/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/ternarySearchTree","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function($){for(var e=[],T=0,O=$.length;T<O;T++)e[T]=Y[$[T]];return e};define(Y[49],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(N){return(I,h,c)=>{let m=null,w=null;if(typeof c.value=="function"?(m="value",w=c.value):typeof c.get=="function"&&(m="get",w=c.get),!w)throw new Error("not supported");c[m]=N(w,h)}}function O(N,I,h){let c=null,m=null;if(typeof h.value=="function"?(c="value",m=h.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",m=h.get),!m)throw new Error("not supported");const w=`$memoize$${I}`;h[c]=function(...p){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[w]}}e.memoize=O;function k(N,I,h){return T((c,m)=>{const w=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...P){this[p]||(this[p]=h?h():void 0),clearTimeout(this[w]),I&&(this[p]=I(this[p],...P),P=[this[p]]),this[w]=setTimeout(()=>{c.apply(this,P),this[p]=h?h():void 0},N)}})}e.debounce=k;function L(N,I,h){return T((c,m)=>{const w=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,P=`$throttle$lastRun$${m}`,y=`$throttle$pending$${m}`;return function(...S){if(this[p]||(this[p]=h?h():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),I&&(this[p]=I(this[p],...S)),this[y])return;const E=this[P]+N;E<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[p]]),this[p]=h?h():void 0):(this[y]=!0,this[w]=setTimeout(()=>{this[y]=!1,this[P]=Date.now(),c.apply(this,[this[p]]),this[p]=h?h():void 0},E-Date.now()))}})}e.throttle=L}),define(Y[68],Z([0,1,11]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=O;function k(h,c="Unreachable"){throw new Error(c)}e.assertNever=k;function L(h){if(!h)throw new T.BugIndicatingError("Assertion Failed")}e.assert=L;function N(h){if(!h()){debugger;h(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function I(h,c){let m=0;for(;m<h.length-1;){const w=h[m],p=h[m+1];if(!c(w,p))return!1;m++}return!0}e.checkAdjacentItems=I}),define(Y[50],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function N(i,n=!1){let t=0;const r=i.length;let o="",u=0,l=16,g=0;function R(Q){let he=0,ce=0;for(;he<Q;){const se=i.charCodeAt(t);if(se>=48&&se<=57)ce=ce*16+se-48;else if(se>=65&&se<=70)ce=ce*16+se-65+10;else if(se>=97&&se<=102)ce=ce*16+se-97+10;else break;t++,he++}return he<Q&&(ce=-1),ce}function C(Q){t=Q,o="",u=0,l=16,g=0}function q(){const Q=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&c(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&c(i.charCodeAt(t)))for(t++;t<i.length&&c(i.charCodeAt(t));)t++;else return g=3,i.substring(Q,t);let he=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&c(i.charCodeAt(t))){for(t++;t<i.length&&c(i.charCodeAt(t));)t++;he=t}else g=3;return i.substring(Q,he)}function X(){let Q="",he=t;for(;;){if(t>=r){Q+=i.substring(he,t),g=2;break}const ce=i.charCodeAt(t);if(ce===34){Q+=i.substring(he,t),t++;break}if(ce===92){if(Q+=i.substring(he,t),t++,t>=r){g=2;break}switch(i.charCodeAt(t++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const ge=R(4);ge>=0?Q+=String.fromCharCode(ge):g=4;break}default:g=5}he=t;continue}if(ce>=0&&ce<=31)if(h(ce)){Q+=i.substring(he,t),g=2;break}else g=6;t++}return Q}function J(){if(o="",g=0,u=t,t>=r)return u=r,l=17;let Q=i.charCodeAt(t);if(I(Q)){do t++,o+=String.fromCharCode(Q),Q=i.charCodeAt(t);while(I(Q));return l=15}if(h(Q))return t++,o+=String.fromCharCode(Q),Q===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),l=14;switch(Q){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,o=X(),l=10;case 47:{const he=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<r&&!h(i.charCodeAt(t));)t++;return o=i.substring(he,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const ce=r-1;let se=!1;for(;t<ce;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,se=!0;break}t++}return se||(t++,g=1),o=i.substring(he,t),l=13}return o+=String.fromCharCode(Q),t++,l=16}case 45:if(o+=String.fromCharCode(Q),t++,t===r||!c(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=q(),l=11;default:for(;t<r&&ie(Q);)t++,Q=i.charCodeAt(t);if(u!==t){switch(o=i.substring(u,t),o){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return o+=String.fromCharCode(Q),t++,l=16}}function ie(Q){if(I(Q)||h(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let Q;do Q=J();while(Q>=12&&Q<=15);return Q}return{setPosition:C,getPosition:()=>t,scan:n?re:J,getToken:()=>l,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>t-u,getTokenError:()=>g}}e.createScanner=N;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function h(i){return i===10||i===13||i===8232||i===8233}function c(i){return i>=48&&i<=57}var m;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(m||(m={}));function w(i,n){const t=[],r=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function g(R,C,q,X){u.value=R,u.offset=C,u.length=q,u.type=X,u.colonOffset=void 0,o=u}try{v(i,{onObjectBegin:(R,C)=>{if(n<=R)throw r;o=void 0,l=n>R,t.push("")},onObjectProperty:(R,C,q)=>{if(n<C||(g(R,C,q,"property"),t[t.length-1]=R,n<=C+q))throw r},onObjectEnd:(R,C)=>{if(n<=R)throw r;o=void 0,t.pop()},onArrayBegin:(R,C)=>{if(n<=R)throw r;o=void 0,t.push(0)},onArrayEnd:(R,C)=>{if(n<=R)throw r;o=void 0,t.pop()},onLiteralValue:(R,C,q)=>{if(n<C||(g(R,C,q,s(R)),n<=C+q))throw r},onSeparator:(R,C,q)=>{if(n<=C)throw r;if(R===":"&&o&&o.type==="property")o.colonOffset=C,l=!1,o=void 0;else if(R===","){const X=t[t.length-1];typeof X=="number"?t[t.length-1]=X+1:(l=!0,t[t.length-1]=""),o=void 0}}})}catch(R){if(R!==r)throw R}return{path:t,previousNode:o,isAtPropertyKey:l,matches:R=>{let C=0;for(let q=0;C<R.length&&q<t.length;q++)if(R[C]===t[q]||R[C]==="*")C++;else if(R[C]!=="**")return!1;return C===R.length}}}e.getLocation=w;function p(i,n=[],t=L.DEFAULT){let r=null,o=[];const u=[];function l(R){Array.isArray(o)?o.push(R):r!==null&&(o[r]=R)}return v(i,{onObjectBegin:()=>{const R={};l(R),u.push(o),o=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const R=[];l(R),u.push(o),o=R,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:l,onError:(R,C,q)=>{n.push({error:R,offset:C,length:q})}},t),o[0]}e.parse=p;function P(i,n=[],t=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function u(R){return r.children.push(R),R}v(i,{onObjectBegin:R=>{r=u({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,C,q)=>{r=u({type:"property",offset:C,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:C,length:q,parent:r})},onObjectEnd:(R,C)=>{r.length=R+C-r.offset,r=r.parent,o(R+C)},onArrayBegin:(R,C)=>{r=u({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,C)=>{r.length=R+C-r.offset,r=r.parent,o(R+C)},onLiteralValue:(R,C,q)=>{u({type:s(R),offset:C,length:q,parent:r,value:R}),o(C+q)},onSeparator:(R,C,q)=>{r.type==="property"&&(R===":"?r.colonOffset=C:R===","&&o(C))},onError:(R,C,q)=>{n.push({error:R,offset:C,length:q})}},t);const g=r.children[0];return g&&delete g.parent,g}e.parseTree=P;function y(i,n){if(!i)return;let t=i;for(const r of n)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const u of t.children)if(Array.isArray(u.children)&&u.children[0].value===r){t=u.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=y;function S(i){if(!i.parent||!i.parent.children)return[];const n=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;n.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&n.push(t)}return n}e.getNodePath=S;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const n=Object.create(null);for(const t of i.children){const r=t.children[1];r&&(n[t.children[0].value]=E(r))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=E;function a(i,n,t=!1){return n>=i.offset&&n<i.offset+i.length||t&&n===i.offset+i.length}e.contains=a;function d(i,n,t=!1){if(a(i,n,t)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const u=d(r[o],n,t);if(u)return u}return i}}e.findNodeAtOffset=d;function v(i,n,t=L.DEFAULT){const r=N(i,!1);function o(x){return x?()=>x(r.getTokenOffset(),r.getTokenLength()):()=>!0}function u(x){return x?ee=>x(ee,r.getTokenOffset(),r.getTokenLength()):()=>!0}const l=o(n.onObjectBegin),g=u(n.onObjectProperty),R=o(n.onObjectEnd),C=o(n.onArrayBegin),q=o(n.onArrayEnd),X=u(n.onLiteralValue),J=u(n.onSeparator),ie=o(n.onComment),re=u(n.onError),Q=t&&t.disallowComments,he=t&&t.allowTrailingComma;function ce(){for(;;){const x=r.scan();switch(r.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:Q||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(x){case 12:case 13:Q?se(10):ie();break;case 16:se(1);break;case 15:case 14:break;default:return x}}}function se(x,ee=[],b=[]){if(re(x),ee.length+b.length>0){let D=r.getToken();for(;D!==17;){if(ee.indexOf(D)!==-1){ce();break}else if(b.indexOf(D)!==-1)break;D=ce()}}}function ge(x){const ee=r.getTokenValue();return x?X(ee):g(ee),ce(),!0}function M(){switch(r.getToken()){case 11:{let x=0;try{x=JSON.parse(r.getTokenValue()),typeof x!="number"&&(se(2),x=0)}catch{se(2)}X(x);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return ce(),!0}function A(){return r.getToken()!==10?(se(3,[],[2,5]),!1):(ge(!1),r.getToken()===6?(J(":"),ce(),G()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function U(){l(),ce();let x=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(x||se(4,[],[]),J(","),ce(),r.getToken()===2&&he)break}else x&&se(6,[],[]);A()||se(4,[],[2,5]),x=!0}return R(),r.getToken()!==2?se(7,[2],[]):ce(),!0}function V(){C(),ce();let x=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(x||se(4,[],[]),J(","),ce(),r.getToken()===4&&he)break}else x&&se(6,[],[]);G()||se(4,[],[4,5]),x=!0}return q(),r.getToken()!==4?se(8,[4],[]):ce(),!0}function G(){switch(r.getToken()){case 3:return V();case 1:return U();case 10:return ge(!0);default:return M()}}return ce(),r.getToken()===17?t.allowEmptyContent?!0:(se(4,[],[]),!1):G()?(r.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=v;function f(i,n){const t=N(i),r=[];let o,u=0,l;do switch(l=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:u!==l&&r.push(i.substring(u,l)),n!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,n)),u=t.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function s(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function $(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function N(h){L.push(h,Date.now())}function I(){const h=[];for(let c=0;c<L.length;c+=2)h.push({name:L[c],startTime:L[c+1]});return h}return{mark:N,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const N of performance.getEntriesByType("mark"))L.push({name:N.name,startTime:Math.round(k+N.startTime)});return L}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function T(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=T(O))}(),function($,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var O in T)(typeof exports=="object"?exports:$)[O]=T[O]}}(typeof self<"u"?self:this,function(){return function($){var e={};function T(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return $[O].call(k.exports,k,k.exports,T),k.l=!0,k.exports}return T.m=$,T.c=e,T.d=function(O,k,L){T.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:L})},T.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},T.t=function(O,k){if(1&k&&(O=T(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var L=Object.create(null);if(T.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var N in O)T.d(L,N,function(I){return O[I]}.bind(null,N));return L},T.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return T.d(k,"a",k),k},T.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},T.p="",T(T.s=0)}([function($,e,T){(function(O){var k;e=$.exports=b,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],h=e.src=[],c=0,m=c++;h[m]="0|[1-9]\\d*";var w=c++;h[w]="[0-9]+";var p=c++;h[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;h[P]="("+h[m]+")\\.("+h[m]+")\\.("+h[m]+")";var y=c++;h[y]="("+h[w]+")\\.("+h[w]+")\\.("+h[w]+")";var S=c++;h[S]="(?:"+h[m]+"|"+h[p]+")";var E=c++;h[E]="(?:"+h[w]+"|"+h[p]+")";var a=c++;h[a]="(?:-("+h[S]+"(?:\\."+h[S]+")*))";var d=c++;h[d]="(?:-?("+h[E]+"(?:\\."+h[E]+")*))";var v=c++;h[v]="[0-9A-Za-z-]+";var f=c++;h[f]="(?:\\+("+h[v]+"(?:\\."+h[v]+")*))";var s=c++,i="v?"+h[P]+h[a]+"?"+h[f]+"?";h[s]="^"+i+"$";var n="[v=\\s]*"+h[y]+h[d]+"?"+h[f]+"?",t=c++;h[t]="^"+n+"$";var r=c++;h[r]="((?:<|>)?=?)";var o=c++;h[o]=h[w]+"|x|X|\\*";var u=c++;h[u]=h[m]+"|x|X|\\*";var l=c++;h[l]="[v=\\s]*("+h[u]+")(?:\\.("+h[u]+")(?:\\.("+h[u]+")(?:"+h[a]+")?"+h[f]+"?)?)?";var g=c++;h[g]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[d]+")?"+h[f]+"?)?)?";var R=c++;h[R]="^"+h[r]+"\\s*"+h[l]+"$";var C=c++;h[C]="^"+h[r]+"\\s*"+h[g]+"$";var q=c++;h[q]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=c++;h[X]="(?:~>?)";var J=c++;h[J]="(\\s*)"+h[X]+"\\s+",I[J]=new RegExp(h[J],"g");var ie=c++;h[ie]="^"+h[X]+h[l]+"$";var re=c++;h[re]="^"+h[X]+h[g]+"$";var Q=c++;h[Q]="(?:\\^)";var he=c++;h[he]="(\\s*)"+h[Q]+"\\s+",I[he]=new RegExp(h[he],"g");var ce=c++;h[ce]="^"+h[Q]+h[l]+"$";var se=c++;h[se]="^"+h[Q]+h[g]+"$";var ge=c++;h[ge]="^"+h[r]+"\\s*("+n+")$|^$";var M=c++;h[M]="^"+h[r]+"\\s*("+i+")$|^$";var A=c++;h[A]="(\\s*)"+h[r]+"\\s*("+n+"|"+h[l]+")",I[A]=new RegExp(h[A],"g");var U=c++;h[U]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var V=c++;h[V]="^\\s*("+h[g]+")\\s+-\\s+("+h[g]+")\\s*$";var G=c++;h[G]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)k(x,h[x]),I[x]||(I[x]=new RegExp(h[x]));function ee(z,H){if(z instanceof b)return z;if(typeof z!="string"||z.length>L||!(H?I[t]:I[s]).test(z))return null;try{return new b(z,H)}catch{return null}}function b(z,H){if(z instanceof b){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof b))return new b(z,H);k("SemVer",z,H),this.loose=H;var K=z.trim().match(H?I[t]:I[s]);if(!K)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var pe=+ue;if(pe>=0&&pe<N)return pe}return ue}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=ee,e.valid=function(z,H){var K=ee(z,H);return K?K.version:null},e.clean=function(z,H){var K=ee(z.trim().replace(/^[=v]+/,""),H);return K?K.version:null},e.SemVer=b,b.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},b.prototype.toString=function(){return this.version},b.prototype.compare=function(z){return k("SemVer.compare",this.version,this.loose,z),z instanceof b||(z=new b(z,this.loose)),this.compareMain(z)||this.comparePre(z)},b.prototype.compareMain=function(z){return z instanceof b||(z=new b(z,this.loose)),j(this.major,z.major)||j(this.minor,z.minor)||j(this.patch,z.patch)},b.prototype.comparePre=function(z){if(z instanceof b||(z=new b(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],ue=z.prerelease[H];if(k("prerelease compare",H,K,ue),K===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(K===void 0)return-1;if(K!==ue)return j(K,ue)}while(++H)},b.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,K,ue){typeof K=="string"&&(ue=K,K=void 0);try{return new b(z,K).inc(H,ue).version}catch{return null}},e.diff=function(z,H){if(te(z,H))return null;var K=ee(z),ue=ee(H);if(K.prerelease.length||ue.prerelease.length){for(var pe in K)if((pe==="major"||pe==="minor"||pe==="patch")&&K[pe]!==ue[pe])return"pre"+pe;return"prerelease"}for(var pe in K)if((pe==="major"||pe==="minor"||pe==="patch")&&K[pe]!==ue[pe])return pe},e.compareIdentifiers=j;var D=/^[0-9]+$/;function j(z,H){var K=D.test(z),ue=D.test(H);return K&&ue&&(z=+z,H=+H),K&&!ue?-1:ue&&!K?1:z<H?-1:z>H?1:0}function F(z,H,K){return new b(z,K).compare(new b(H,K))}function B(z,H,K){return F(z,H,K)>0}function W(z,H,K){return F(z,H,K)<0}function te(z,H,K){return F(z,H,K)===0}function oe(z,H,K){return F(z,H,K)!==0}function me(z,H,K){return F(z,H,K)>=0}function ye(z,H,K){return F(z,H,K)<=0}function ae(z,H,K,ue){var pe;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),pe=z===K;break;case"!==":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),pe=z!==K;break;case"":case"=":case"==":pe=te(z,K,ue);break;case"!=":pe=oe(z,K,ue);break;case">":pe=B(z,K,ue);break;case">=":pe=me(z,K,ue);break;case"<":pe=W(z,K,ue);break;case"<=":pe=ye(z,K,ue);break;default:throw new TypeError("Invalid operator: "+H)}return pe}function ne(z,H){if(z instanceof ne){if(z.loose===H)return z;z=z.value}if(!(this instanceof ne))return new ne(z,H);k("comparator",z,H),this.loose=H,this.parse(z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(z,H){return j(H,z)},e.major=function(z,H){return new b(z,H).major},e.minor=function(z,H){return new b(z,H).minor},e.patch=function(z,H){return new b(z,H).patch},e.compare=F,e.compareLoose=function(z,H){return F(z,H,!0)},e.rcompare=function(z,H,K){return F(H,z,K)},e.sort=function(z,H){return z.sort(function(K,ue){return e.compare(K,ue,H)})},e.rsort=function(z,H){return z.sort(function(K,ue){return e.rcompare(K,ue,H)})},e.gt=B,e.lt=W,e.eq=te,e.neq=oe,e.gte=me,e.lte=ye,e.cmp=ae,e.Comparator=ne;var de={};function le(z,H){if(z instanceof le)return z.loose===H?z:new le(z.raw,H);if(z instanceof ne)return new le(z.value,H);if(!(this instanceof le))return new le(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function ve(z){return!z||z.toLowerCase()==="x"||z==="*"}function Me(z,H,K,ue,pe,ke,Se,Re,Ie,Oe,je,De,Le){return((H=ve(K)?"":ve(ue)?">="+K+".0.0":ve(pe)?">="+K+"."+ue+".0":">="+H)+" "+(Re=ve(Ie)?"":ve(Oe)?"<"+(+Ie+1)+".0.0":ve(je)?"<"+Ie+"."+(+Oe+1)+".0":De?"<="+Ie+"."+Oe+"."+je+"-"+De:"<="+Re)).trim()}function Te(z,H){for(var K=0;K<z.length;K++)if(!z[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<z.length;K++)if(k(z[K].semver),z[K].semver!==de&&z[K].semver.prerelease.length>0){var ue=z[K].semver;if(ue.major===H.major&&ue.minor===H.minor&&ue.patch===H.patch)return!0}return!1}return!0}function Ae(z,H,K){try{H=new le(H,K)}catch{return!1}return H.test(z)}function Ue(z,H,K,ue){var pe,ke,Se,Re,Ie;switch(z=new b(z,ue),H=new le(H,ue),K){case">":pe=B,ke=ye,Se=W,Re=">",Ie=">=";break;case"<":pe=W,ke=me,Se=B,Re="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(z,H,ue))return!1;for(var Oe=0;Oe<H.set.length;++Oe){var je=H.set[Oe],De=null,Le=null;if(je.forEach(function(Ce){Ce.semver===de&&(Ce=new ne(">=0.0.0")),De=De||Ce,Le=Le||Ce,pe(Ce.semver,De.semver,ue)?De=Ce:Se(Ce.semver,Le.semver,ue)&&(Le=Ce)}),De.operator===Re||De.operator===Ie||(!Le.operator||Le.operator===Re)&&ke(z,Le.semver)||Le.operator===Ie&&Se(z,Le.semver))return!1}return!0}ne.prototype.parse=function(z){var H=this.loose?I[ge]:I[M],K=z.match(H);if(!K)throw new TypeError("Invalid comparator: "+z);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new b(K[2],this.loose):this.semver=de},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(z){return k("Comparator.test",z,this.loose),this.semver===de||(typeof z=="string"&&(z=new b(z,this.loose)),ae(z,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(z,H){if(!(z instanceof ne))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new le(z.value,H),Ae(this.value,K,H);if(z.operator==="")return K=new le(this.value,H),Ae(z.semver,K,H);var ue=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),ke=this.semver.version===z.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Re=ae(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ie=ae(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ue||pe||ke&&Se||Re||Ie},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),k("range",z,H);var K=H?I[V]:I[U];z=z.replace(K,Me),k("hyphen replace",z),z=z.replace(I[A],"$1$2$3"),k("comparator trim",z,I[A]),z=(z=(z=z.replace(I[J],"$1~")).replace(I[he],"$1^")).split(/\s+/).join(" ");var ue=H?I[ge]:I[M],pe=z.split(" ").map(function(ke){return function(Se,Re){return k("comp",Se),Se=function(Ie,Oe){return Ie.trim().split(/\s+/).map(function(je){return function(De,Le){k("caret",De,Le);var Ce=Le?I[se]:I[ce];return De.replace(Ce,function(Fe,we,Ee,be,Pe){var Ne;return k("caret",De,Fe,we,Ee,be,Pe),ve(we)?Ne="":ve(Ee)?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":ve(be)?Ne=we==="0"?">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+".0 <"+(+we+1)+".0.0":Pe?(k("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ne=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+Pe+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+Pe+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+Pe+" <"+(+we+1)+".0.0"):(k("no pr"),Ne=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+" <"+(+we+1)+".0.0"),k("caret return",Ne),Ne})}(je,Oe)}).join(" ")}(Se,Re),k("caret",Se),Se=function(Ie,Oe){return Ie.trim().split(/\s+/).map(function(je){return function(De,Le){var Ce=Le?I[re]:I[ie];return De.replace(Ce,function(Fe,we,Ee,be,Pe){var Ne;return k("tilde",De,Fe,we,Ee,be,Pe),ve(we)?Ne="":ve(Ee)?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":ve(be)?Ne=">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":Pe?(k("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ne=">="+we+"."+Ee+"."+be+Pe+" <"+we+"."+(+Ee+1)+".0"):Ne=">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0",k("tilde return",Ne),Ne})}(je,Oe)}).join(" ")}(Se,Re),k("tildes",Se),Se=function(Ie,Oe){return k("replaceXRanges",Ie,Oe),Ie.split(/\s+/).map(function(je){return function(De,Le){De=De.trim();var Ce=Le?I[C]:I[R];return De.replace(Ce,function(Fe,we,Ee,be,Pe,Ne){k("xRange",De,Fe,we,Ee,be,Pe,Ne);var We=ve(Ee),ze=We||ve(be),Be=ze||ve(Pe);return we==="="&&Be&&(we=""),We?Fe=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(ze&&(be=0),Be&&(Pe=0),we===">"?(we=">=",ze?(Ee=+Ee+1,be=0,Pe=0):Be&&(be=+be+1,Pe=0)):we==="<="&&(we="<",ze?Ee=+Ee+1:be=+be+1),Fe=we+Ee+"."+be+"."+Pe):ze?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Be&&(Fe=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0"),k("xRange return",Fe),Fe})}(je,Oe)}).join(" ")}(Se,Re),k("xrange",Se),Se=function(Ie,Oe){return k("replaceStars",Ie,Oe),Ie.trim().replace(I[G],"")}(Se,Re),k("stars",Se),Se}(ke,H)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(ke){return!!ke.match(ue)})),pe=pe.map(function(ke){return new ne(ke,H)})},le.prototype.intersects=function(z,H){if(!(z instanceof le))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(ue){return z.set.some(function(pe){return pe.every(function(ke){return ue.intersects(ke,H)})})})})},e.toComparators=function(z,H){return new le(z,H).set.map(function(K){return K.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},le.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new b(z,this.loose));for(var H=0;H<this.set.length;H++)if(Te(this.set[H],z))return!0;return!1},e.satisfies=Ae,e.maxSatisfying=function(z,H,K){var ue=null,pe=null;try{var ke=new le(H,K)}catch{return null}return z.forEach(function(Se){ke.test(Se)&&(ue&&pe.compare(Se)!==-1||(pe=new b(ue=Se,K)))}),ue},e.minSatisfying=function(z,H,K){var ue=null,pe=null;try{var ke=new le(H,K)}catch{return null}return z.forEach(function(Se){ke.test(Se)&&(ue&&pe.compare(Se)!==1||(pe=new b(ue=Se,K)))}),ue},e.validRange=function(z,H){try{return new le(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,K){return Ue(z,H,"<",K)},e.gtr=function(z,H,K){return Ue(z,H,">",K)},e.outside=Ue,e.prerelease=function(z,H){var K=ee(z,H);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(z,H,K){return z=new le(z,K),H=new le(H,K),z.intersects(H)},e.coerce=function(z){if(z instanceof b)return z;if(typeof z!="string")return null;var H=z.match(I[q]);return H==null?null:ee((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,T(1))},function($,e){var T,O,k=$.exports={};function L(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function I(E){if(T===setTimeout)return setTimeout(E,0);if((T===L||!T)&&setTimeout)return T=setTimeout,setTimeout(E,0);try{return T(E,0)}catch{try{return T.call(null,E,0)}catch{return T.call(this,E,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:L}catch{T=L}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var h,c=[],m=!1,w=-1;function p(){m&&h&&(m=!1,h.length?c=h.concat(c):w=-1,c.length&&P())}function P(){if(!m){var E=I(p);m=!0;for(var a=c.length;a;){for(h=c,c=[];++w<a;)h&&h[w].run();w=-1,a=c.length}h=null,m=!1,function(d){if(O===clearTimeout)return clearTimeout(d);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(d);try{O(d)}catch{try{return O.call(null,d)}catch{return O.call(this,d)}}}(E)}}function y(E,a){this.fun=E,this.array=a}function S(){}k.nextTick=function(E){var a=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)a[d-1]=arguments[d];c.push(new y(E,a)),c.length!==1||m||I(P)},y.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(E){return[]},k.binding=function(E){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(E){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Y[69],Z([0,1]),function($,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(I,h,c){this.level=I,this.key=h,this.value=c,this.forward=[]}}const k=void 0;class L{constructor(I,h=2**16){this.comparator=I,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new O(this.c,k,k)}get size(){return this.f}clear(){this.e=new O(this.c,k,k)}has(I){return Boolean(L.g(this,I,this.comparator))}get(I){return L.g(this,I,this.comparator)?.value}set(I,h){return L.h(this,I,h,this.comparator)&&(this.f+=1),this}delete(I){const h=L.k(this,I,this.comparator);return h&&(this.f-=1),h}forEach(I,h){let c=this.e.forward[0];for(;c;)I.call(h,c.value,c.key,this),c=c.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",h=this.e.forward[0];for(;h;)I+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return I}static g(I,h,c){let m=I.e;for(let w=I.d-1;w>=0;w--)for(;m.forward[w]&&c(m.forward[w].key,h)<0;)m=m.forward[w];if(m=m.forward[0],m&&c(m.key,h)===0)return m}static h(I,h,c,m){const w=[];let p=I.e;for(let P=I.d-1;P>=0;P--){for(;p.forward[P]&&m(p.forward[P].key,h)<0;)p=p.forward[P];w[P]=p}if(p=p.forward[0],p&&m(p.key,h)===0)return p.value=c,!1;{const P=L.j(I);if(P>I.d){for(let y=I.d;y<P;y++)w[y]=I.e;I.d=P}p=new O(P,h,c);for(let y=0;y<P;y++)p.forward[y]=w[y].forward[y],w[y].forward[y]=p;return!0}}static j(I,h=.5){let c=1;for(;Math.random()<h&&c<I.c;)c+=1;return c}static k(I,h,c){const m=[];let w=I.e;for(let p=I.d-1;p>=0;p--){for(;w.forward[p]&&c(w.forward[p].key,h)<0;)w=w.forward[p];m[p]=w}if(w=w.forward[0],!w||c(w.key,h)!==0)return!1;for(let p=0;p<I.d&&m[p].forward[p]===w;p++)m[p].forward[p]=w.forward[p];for(;I.d>0&&I.e.forward[I.d-1]===k;)I.d-=1;return!0}}e.SkipList=L}),define(Y[43],Z([0,1,11,2]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const s=f;return s?typeof s.read=="function":!1}e.isReadable=k;function L(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=L;function N(f){const s=f;return s?L(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=N;function I(f,s){return new h(f,s)}e.newWriteableStream=I;class h{constructor(s,i){this.e=s,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(i=>i(s))}h(s){this.c.error.length===0?(0,T.onUnexpectedError)(s):this.c.error.slice(0).forEach(i=>i(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,i){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(s,i){if(this.a.destroyed)return;let n;switch(s){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const t=n.indexOf(i);t>=0&&n.splice(t,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(f,s){const i=[];let n;for(;(n=f.read())!==null;)i.push(n);return s(i)}e.consumeReadable=c;function m(f,s,i){const n=[];let t;for(;(t=f.read())!==null&&n.length<i;)n.push(t);return t===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return f.read()}}}e.peekReadable=m;function w(f,s){return new Promise((i,n)=>{const t=[];p(f,{onData:r=>{s&&t.push(r)},onError:r=>{s?n(r):i(void 0)},onEnd:()=>{i(s?s(t):void 0)}})})}e.consumeStream=w;function p(f,s){let i=!1;return f.on("error",n=>{i||s.onError(n)}),f.on("end",()=>{i||s.onEnd()}),f.on("data",n=>{i||s.onData(n)}),(0,O.toDisposable)(()=>i=!0)}e.listenStream=p;function P(f,s){return new Promise((i,n)=>{const t=new O.DisposableStore,r=[],o=g=>{if(r.push(g),r.length>s)return t.dispose(),f.pause(),i({stream:f,buffer:r,ended:!1})},u=g=>n(g),l=()=>i({stream:f,buffer:r,ended:!0});t.add((0,O.toDisposable)(()=>f.removeListener("error",u))),f.on("error",u),t.add((0,O.toDisposable)(()=>f.removeListener("end",l))),f.on("end",l),t.add((0,O.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=P;function y(f,s){const i=I(s);return i.end(f),i}e.toStream=y;function S(){const f=I(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function E(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=E;function a(f,s,i){const n=I(i);return p(f,{onData:t=>n.write(s.data(t)),onError:t=>n.error(s.error?s.error(t):t),onEnd:()=>n.end()}),n}e.transform=a;function d(f,s,i){let n=!1;return{read:()=>{const t=s.read();return n?t:(n=!0,t!==null?i([f,t]):f)}}}e.prefixedReadable=d;function v(f,s,i){let n=!1;const t=I(i);return p(s,{onData:r=>n?t.write(r):(n=!0,t.write(i([f,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(f)),t.end()}}),t}e.prefixedStream=v}),define(Y[15],Z([0,1,43]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let k,L;class N{static alloc(g){return O?new N(Buffer.allocUnsafe(g)):new N(new Uint8Array(g))}static wrap(g){return O&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new N(g)}static fromString(g,R){return!(R?.dontUseNodeBuffer||!1)&&O?new N(Buffer.from(g)):(k||(k=new TextEncoder),new N(k.encode(g)))}static fromByteArray(g){const R=N.alloc(g.length);for(let C=0,q=g.length;C<q;C++)R.buffer[C]=g[C];return R}static concat(g,R){if(typeof R>"u"){R=0;for(let X=0,J=g.length;X<J;X++)R+=g[X].byteLength}const C=N.alloc(R);let q=0;for(let X=0,J=g.length;X<J;X++){const ie=g[X];C.set(ie,q),q+=ie.byteLength}return C}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=N.alloc(this.byteLength);return g.set(this),g}toString(){return O?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(g,R){return new N(this.buffer.subarray(g,R))}set(g,R){if(g instanceof N)this.buffer.set(g.buffer,R);else if(g instanceof Uint8Array)this.buffer.set(g,R);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),R);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return c(this.buffer,g)}writeUInt32BE(g,R){m(this.buffer,g,R)}readUInt32LE(g){return w(this.buffer,g)}writeUInt32LE(g,R){p(this.buffer,g,R)}readUInt8(g){return P(this.buffer,g)}writeUInt8(g,R){y(this.buffer,g,R)}}e.VSBuffer=N;function I(l,g){return l[g+0]<<0>>>0|l[g+1]<<8>>>0}e.readUInt16LE=I;function h(l,g,R){l[R+0]=g&255,g=g>>>8,l[R+1]=g&255}e.writeUInt16LE=h;function c(l,g){return l[g]*2**24+l[g+1]*2**16+l[g+2]*2**8+l[g+3]}e.readUInt32BE=c;function m(l,g,R){l[R+3]=g,g=g>>>8,l[R+2]=g,g=g>>>8,l[R+1]=g,g=g>>>8,l[R]=g}e.writeUInt32BE=m;function w(l,g){return l[g+0]<<0>>>0|l[g+1]<<8>>>0|l[g+2]<<16>>>0|l[g+3]<<24>>>0}e.readUInt32LE=w;function p(l,g,R){l[R+0]=g&255,g=g>>>8,l[R+1]=g&255,g=g>>>8,l[R+2]=g&255,g=g>>>8,l[R+3]=g&255}e.writeUInt32LE=p;function P(l,g){return l[g]}e.readUInt8=P;function y(l,g,R){l[R]=g}e.writeUInt8=y;function S(l){return T.consumeReadable(l,g=>N.concat(g))}e.readableToBuffer=S;function E(l){return T.toReadable(l)}e.bufferToReadable=E;function a(l){return T.consumeStream(l,g=>N.concat(g))}e.streamToBuffer=a;async function d(l){return l.ended?N.concat(l.buffer):N.concat([...l.buffer,await a(l.stream)])}e.bufferedStreamToBuffer=d;function v(l){return T.toStream(l,g=>N.concat(g))}e.bufferToStream=v;function f(l){return T.transform(l,{data:g=>typeof g=="string"?N.fromString(g):N.wrap(g)},g=>N.concat(g))}e.streamToBufferReadableStream=f;function s(l){return T.newWriteableStream(g=>N.concat(g),l)}e.newWriteableBufferStream=s;function i(l,g){return T.prefixedReadable(l,g,R=>N.concat(R))}e.prefixedBufferReadable=i;function n(l,g){return T.prefixedStream(l,g,R=>N.concat(R))}e.prefixedBufferStream=n;function t(l){let g=0,R=0,C=0;const q=new Uint8Array(Math.floor(l.length/4*3)),X=ie=>{switch(R){case 3:q[C++]=g|ie,R=0;break;case 2:q[C++]=g|ie>>>2,g=ie<<6,R=3;break;case 1:q[C++]=g|ie>>>4,g=ie<<4,R=2;break;default:g=ie<<2,R=1}};for(let ie=0;ie<l.length;ie++){const re=l.charCodeAt(ie);if(re>=65&&re<=90)X(re-65);else if(re>=97&&re<=122)X(re-97+26);else if(re>=48&&re<=57)X(re-48+52);else if(re===43||re===45)X(62);else if(re===47||re===95)X(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${l[ie]}`)}}const J=C;for(;R>0;)X(0);return N.wrap(q).slice(0,J)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:l},g=!0,R=!1){const C=R?o:r;let q="";const X=l.byteLength%3;let J=0;for(;J<l.byteLength-X;J+=3){const ie=l[J+0],re=l[J+1],Q=l[J+2];q+=C[ie>>>2],q+=C[(ie<<4|re>>>4)&63],q+=C[(re<<2|Q>>>6)&63],q+=C[Q&63]}if(X===1){const ie=l[J+0];q+=C[ie>>>2],q+=C[ie<<4&63],g&&(q+="==")}else if(X===2){const ie=l[J+0],re=l[J+1];q+=C[ie>>>2],q+=C[(ie<<4|re>>>4)&63],q+=C[re<<2&63],g&&(q+="=")}return q}e.encodeBase64=u}),define(Y[28],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const d=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([v,f])=>{d[v]=f&&typeof f=="object"?O(f):f}),d}e.deepClone=O;function k(a){if(!a||typeof a!="object")return a;const d=[a];for(;d.length>0;){const v=d.shift();Object.freeze(v);for(const f in v)if(L.call(v,f)){const s=v[f];typeof s=="object"&&!Object.isFrozen(s)&&!(0,T.isTypedArray)(s)&&d.push(s)}}return a}e.deepFreeze=k;const L=Object.prototype.hasOwnProperty;function N(a,d){return I(a,d,new Set)}e.cloneAndChange=N;function I(a,d,v){if((0,T.isUndefinedOrNull)(a))return a;const f=d(a);if(typeof f<"u")return f;if(Array.isArray(a)){const s=[];for(const i of a)s.push(I(i,d,v));return s}if((0,T.isObject)(a)){if(v.has(a))throw new Error("Cannot clone recursive data-structure");v.add(a);const s={};for(const i in a)L.call(a,i)&&(s[i]=I(a[i],d,v));return v.delete(a),s}return a}function h(a,d,v=!0){return(0,T.isObject)(a)?((0,T.isObject)(d)&&Object.keys(d).forEach(f=>{f in a?v&&((0,T.isObject)(a[f])&&(0,T.isObject)(d[f])?h(a[f],d[f],v):a[f]=d[f]):a[f]=d[f]}),a):d}e.mixin=h;function c(a,d){if(a===d)return!0;if(a==null||d===null||d===void 0||typeof a!=typeof d||typeof a!="object"||Array.isArray(a)!==Array.isArray(d))return!1;let v,f;if(Array.isArray(a)){if(a.length!==d.length)return!1;for(v=0;v<a.length;v++)if(!c(a[v],d[v]))return!1}else{const s=[];for(f in a)s.push(f);s.sort();const i=[];for(f in d)i.push(f);if(i.sort(),!c(s,i))return!1;for(v=0;v<s.length;v++)if(!c(a[s[v]],d[s[v]]))return!1}return!0}e.equals=c;function m(a){const d=new Set;return JSON.stringify(a,(v,f)=>{if((0,T.isObject)(f)||Array.isArray(f)){if(d.has(f))return"[Circular]";d.add(f)}return f})}e.safeStringify=m;function w(a,d){const v=Object.create(null);return!a||!d||Object.keys(d).forEach(s=>{const i=a[s],n=d[s];c(i,n)||(v[s]=n)}),v}e.distinct=w;function p(a,d){const v=d.toLowerCase(),f=Object.keys(a).find(s=>s.toLowerCase()===v);return f?a[f]:a[d]}e.getCaseInsensitive=p;function P(a,d){const v=Object.create(null);for(const[f,s]of Object.entries(a))d(f,s)&&(v[f]=s);return v}e.filter=P;function y(a){let d=[],v=Object.getPrototypeOf(a);for(;Object.prototype!==v;)d=d.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return d}e.getAllPropertyNames=y;function S(a){const d=[];for(const v of y(a))typeof a[v]=="function"&&d.push(v);return d}e.getAllMethodNames=S;function E(a,d){const v=s=>function(){const i=Array.prototype.slice.call(arguments,0);return d(s,i)},f={};for(const s of a)f[s]=v(s);return f}e.createProxyObject=E}),define(Y[31],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return T.test(k)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(I){for(let h=0;h<I.length;h++)I[h]=Math.floor(Math.random()*256);return I};const L=new Uint8Array(16),N=[];for(let I=0;I<256;I++)N.push(I.toString(16).padStart(2,"0"));return function(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let h=0,c="";return c+=N[L[h++]],c+=N[L[h++]],c+=N[L[h++]],c+=N[L[h++]],c+="-",c+=N[L[h++]],c+=N[L[h++]],c+="-",c+=N[L[h++]],c+=N[L[h++]],c+="-",c+=N[L[h++]],c+=N[L[h++]],c+="-",c+=N[L[h++]],c+=N[L[h++]],c+=N[L[h++]],c+=N[L[h++]],c+=N[L[h++]],c+=N[L[h++]],c}}()}),define(Y[70],Z([5,6]),function($,e){return $.create("vs/base/common/date",e)}),define(Y[71],Z([0,1,70]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,k=O*60,L=k*24,N=L*7,I=L*30,h=L*365;function c(w,p,P){typeof w!="number"&&(w=w.getTime());const y=Math.round((new Date().getTime()-w)/1e3);if(y<-30)return(0,T.localize)(0,null,c(new Date().getTime()+y*1e3,!1));if(y<30)return(0,T.localize)(1,null);let S;return y<O?(S=y,p?S===1?P?(0,T.localize)(2,null,S):(0,T.localize)(3,null,S):P?(0,T.localize)(4,null,S):(0,T.localize)(5,null,S):S===1?P?(0,T.localize)(6,null,S):(0,T.localize)(7,null,S):P?(0,T.localize)(8,null,S):(0,T.localize)(9,null,S)):y<k?(S=Math.floor(y/O),p?S===1?P?(0,T.localize)(10,null,S):(0,T.localize)(11,null,S):P?(0,T.localize)(12,null,S):(0,T.localize)(13,null,S):S===1?P?(0,T.localize)(14,null,S):(0,T.localize)(15,null,S):P?(0,T.localize)(16,null,S):(0,T.localize)(17,null,S)):y<L?(S=Math.floor(y/k),p?S===1?P?(0,T.localize)(18,null,S):(0,T.localize)(19,null,S):P?(0,T.localize)(20,null,S):(0,T.localize)(21,null,S):S===1?P?(0,T.localize)(22,null,S):(0,T.localize)(23,null,S):P?(0,T.localize)(24,null,S):(0,T.localize)(25,null,S)):y<N?(S=Math.floor(y/L),p?S===1?(0,T.localize)(26,null,S):(0,T.localize)(27,null,S):S===1?(0,T.localize)(28,null,S):(0,T.localize)(29,null,S)):y<I?(S=Math.floor(y/N),p?S===1?P?(0,T.localize)(30,null,S):(0,T.localize)(31,null,S):P?(0,T.localize)(32,null,S):(0,T.localize)(33,null,S):S===1?P?(0,T.localize)(34,null,S):(0,T.localize)(35,null,S):P?(0,T.localize)(36,null,S):(0,T.localize)(37,null,S)):y<h?(S=Math.floor(y/I),p?S===1?P?(0,T.localize)(38,null,S):(0,T.localize)(39,null,S):P?(0,T.localize)(40,null,S):(0,T.localize)(41,null,S):S===1?P?(0,T.localize)(42,null,S):(0,T.localize)(43,null,S):P?(0,T.localize)(44,null,S):(0,T.localize)(45,null,S)):(S=Math.floor(y/h),p?S===1?P?(0,T.localize)(46,null,S):(0,T.localize)(47,null,S):P?(0,T.localize)(48,null,S):(0,T.localize)(49,null,S):S===1?P?(0,T.localize)(50,null,S):(0,T.localize)(51,null,S):P?(0,T.localize)(52,null,S):(0,T.localize)(53,null,S))}e.fromNow=c;function m(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=m}),define(Y[72],Z([5,6]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Y[32],Z([0,1,19,8,72]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(w,p){return p&&(w.stack||w.stacktrace)?k.localize(0,null,I(w),N(w.stack)||N(w.stacktrace)):I(w)}function N(w){return Array.isArray(w)?w.join(`
`):w}function I(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function h(w=null,p=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const P=T.coalesce(w),y=h(P[0],p);return P.length>1?k.localize(4,null,y,P.length):y}if(O.isString(w))return w;if(w.detail){const P=w.detail;if(P.error)return L(P.error,p);if(P.exception)return L(P.exception,p)}return w.stack?L(w,p):w.message?w.message:k.localize(5,null)}e.toErrorMessage=h;function c(w){const p=w;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=c;function m(w,p){let P;return typeof w=="string"?P=new Error(w):P=w,P.actions=p,P}e.createErrorWithActions=m}),define(Y[73],Z([5,6]),function($,e){return $.create("vs/base/common/jsonErrorMessages",e)}),define(Y[74],Z([0,1,73]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(k){switch(k){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(Y[51],Z([0,1,12]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(O=e.Source||(e.Source={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(I,...h){const c=h.reduce((p,P)=>(p[P]=!0,p),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(p=>!c[p]).forEach(p=>{for(let P=0;P<m.length;P++)if(p.search(m[P])!==-1){delete I[p];break}})}e.sanitizeProcessEnvironment=L;function N(I){!I||(delete I.DEBUG,T.isMacintosh&&delete I.DYLD_LIBRARY_PATH,T.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(Y[52],Z([0,1,29]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(a){return k(a,0)}e.hash=O;function k(a,d){switch(typeof a){case"object":return a===null?L(349,d):Array.isArray(a)?h(a,d):c(a,d);case"string":return I(a,d);case"boolean":return N(a,d);case"number":return L(a,d);case"undefined":return L(937,d);default:return L(617,d)}}e.doHash=k;function L(a,d){return(d<<5)-d+a|0}e.numberHash=L;function N(a,d){return L(a?433:863,d)}function I(a,d){d=L(149417,d);for(let v=0,f=a.length;v<f;v++)d=L(a.charCodeAt(v),d);return d}e.stringHash=I;function h(a,d){return d=L(104579,d),a.reduce((v,f)=>k(f,v),d)}function c(a,d){return d=L(181387,d),Object.keys(a).sort().reduce((v,f)=>(v=I(f,v),k(a[f],v)),d)}class m{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=k(d,this.g),this.g}}e.Hasher=m;var w;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function p(a,d,v=32){const f=v-d,s=~((1<<f)-1);return(a<<d|(s&a)>>>f)>>>0}function P(a,d=0,v=a.byteLength,f=0){for(let s=0;s<v;s++)a[d+s]=f}function y(a,d,v="0"){for(;a.length<d;)a=v+a;return a}function S(a,d=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(v=>v.toString(16).padStart(2,"0")).join(""):y((a>>>0).toString(16),d/4)}e.toHexString=S;class E{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const v=d.length;if(v===0)return;const f=this.p;let s=this.r,i=this.u,n,t;for(i!==0?(n=i,t=-1,i=0):(n=d.charCodeAt(0),t=0);;){let r=n;if(T.isHighSurrogate(n))if(t+1<v){const o=d.charCodeAt(t+1);T.isLowSurrogate(o)?(t++,r=T.computeCodePoint(n,o)):r=65533}else{i=n;break}else T.isLowSurrogate(n)&&(r=65533);if(s=this.w(f,s,r),t++,t<v)n=d.charCodeAt(t);else break}this.r=s,this.u=i}w(d,v,f){return f<128?d[v++]=f:f<2048?(d[v++]=192|(f&1984)>>>6,d[v++]=128|(f&63)>>>0):f<65536?(d[v++]=224|(f&61440)>>>12,d[v++]=128|(f&4032)>>>6,d[v++]=128|(f&63)>>>0):(d[v++]=240|(f&1835008)>>>18,d[v++]=128|(f&258048)>>>12,d[v++]=128|(f&4032)>>>6,d[v++]=128|(f&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=E.g,v=this.q;for(let l=0;l<64;l+=4)d.setUint32(l,v.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)d.setUint32(l,p(d.getUint32(l-12,!1)^d.getUint32(l-32,!1)^d.getUint32(l-56,!1)^d.getUint32(l-64,!1),1),!1);let f=this.h,s=this.l,i=this.m,n=this.n,t=this.o,r,o,u;for(let l=0;l<80;l++)l<20?(r=s&i|~s&n,o=1518500249):l<40?(r=s^i^n,o=1859775393):l<60?(r=s&i|s&n|i&n,o=2400959708):(r=s^i^n,o=3395469782),u=p(f,5)+r+t+o+d.getUint32(l*4,!1)&4294967295,t=n,n=i,i=p(s,30),s=f,f=u;this.h=this.h+f&4294967295,this.l=this.l+s&4294967295,this.m=this.m+i&4294967295,this.n=this.n+n&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=E,E.g=new DataView(new ArrayBuffer(320))}),define(Y[53],Z([0,1,29]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const L="error",N="warning",I="warn",h="info",c="ignore";function m(p){return p?T.equalsIgnoreCase(L,p)?k.Error:T.equalsIgnoreCase(N,p)||T.equalsIgnoreCase(I,p)?k.Warning:T.equalsIgnoreCase(h,p)?k.Info:k.Ignore:k.Ignore}k.fromValue=m;function w(p){switch(p){case k.Error:return L;case k.Warning:return N;case k.Info:return h;default:return c}}k.toString=w}(O||(O={})),e.default=O}),define(Y[75],Z([0,1,10]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.isRemoteConsoleLog=O;function k(c){const m=[];let w;try{const p=JSON.parse(c.arguments),P=p[p.length-1];P&&P.__$stack&&(p.pop(),w=P.__$stack),m.push(...p)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:w}}e.parse=k;function L(c){if(typeof c!="string")return L(k(c).stack);const m=c;if(m){const w=N(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(p&&p.length===4)return{uri:T.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function N(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function I(c,m){const{args:w,stack:p}=k(c),P=typeof w[0]=="string"&&w.length===1;let y=N(p);y&&(y=`(${y.trim()})`);let S=[];if(typeof w[0]=="string"?y&&P?S=[`%c[${m}] %c${w[0]} %c${y}`,h("blue"),h(""),h("grey")]:S=[`%c[${m}] %c${w[0]}`,h("blue"),h(""),...w.slice(1)]:S=[`%c[${m}]%`,h("blue"),...w],y&&!P&&S.push(y),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,S)}e.log=I;function h(c){return`color: ${c}`}}),define(Y[44],Z([0,1,15,29,10]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(c){return JSON.stringify(c,I)}e.stringify=L;function N(c){let m=JSON.parse(c);return m=h(m),m}e.parse=N;function I(c,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,O.regExpFlags)(m)}:m}function h(c,m=0){if(!c||m>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return k.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof T.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let w=0;w<c.length;++w)c[w]=h(c[w],m+1);else for(const w in c)Object.hasOwnProperty.call(c,w)&&(c[w]=h(c[w],m+1))}return c}e.revive=h}),define(Y[76],Z([0,1,38,14,20]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,N=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var h;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class w{constructor(s,i,n){this.exePath=s,this.displayName=i,this.a=n}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:f=!1}={}){return f?c===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function P({useAlternateBitness:f=!1,findPreview:s=!1}={}){const i=p({useAlternateBitness:f});if(!i)return null;const n=O.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(n))return null;let t=-1,r=null;for(const l of await k.Promises.readdir(n)){let g=-1;if(s){const C=l.indexOf("-");if(C<0)continue;const q=l.substring(0,C);if(!L.test(q)||l.substring(C+1)!=="preview")continue;g=parseInt(q,10)}else{if(!L.test(l))continue;g=parseInt(l,10)}if(g<=t)continue;const R=O.join(n,l,"pwsh.exe");!await k.SymlinkSupport.existsFile(R)||(r=R,t=g)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",u=s?" Preview":"";return new w(r,`PowerShell${u}${o}`,!0)}async function y({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const s=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=f?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(s))if(i.test(t)){const r=O.join(s,t,"pwsh.exe");return new w(r,n)}return null}function S(){const f=O.join(T.homedir(),".dotnet","tools","pwsh.exe");return new w(f,".NET Core PowerShell Global Tool")}function E(){const f=O.join(process.env.windir,c===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(f,"Windows PowerShell",!0)}async function*a(){let f=await P();f&&(yield f),f=await P({useAlternateBitness:!0}),f&&(yield f),f=await y(),f&&(yield f),f=S(),f&&(yield f),f=await P({findPreview:!0}),f&&(yield f),f=await y({findPreview:!0}),f&&(yield f),f=await P({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=E(),f&&(yield f)}async function*d(){for await(const f of a())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=d;async function v(){for await(const f of d())return f;return null}e.getFirstAvailablePowerShellInstallation=v}),define(Y[54],Z([0,1,14,12,33,51,8,20]),function($,e,T,O,k,L,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function h(w=k.env){return w.comspec||"cmd.exe"}e.getWindowsShell=h;function c(w){let p=[],P=!1;const y=function(S){if(P){p.push(S);return}(!w.send(S,a=>{if(a&&console.error(a),P=!1,p.length>0){const d=p.slice(0);p=[],d.forEach(v=>y(v))}})||O.isWindows)&&(P=!0)};return{send:y}}e.createQueuedSender=c;var m;(function(w){async function p(P,y,S){if(T.isAbsolute(P))return P;if(y===void 0&&(y=k.cwd()),T.dirname(P)!=="."||(S===void 0&&N.isString(k.env.PATH)&&(S=k.env.PATH.split(T.delimiter)),S===void 0||S.length===0))return T.join(y,P);async function a(d){if(await I.Promises.exists(d)){let v;try{v=await I.Promises.stat(d)}catch(f){f.message.startsWith("EACCES")&&(v=await I.Promises.lstat(d))}return v?!v.isDirectory():!1}return!1}for(const d of S){let v;if(T.isAbsolute(d)?v=T.join(d,P):v=T.join(y,d,P),await a(v))return v;let f=v+".com";if(await a(f)||(f=v+".exe",await a(f)))return f}return T.join(y,P)}w.findExecutable=p})(m=e.win32||(e.win32={}))}),define(Y[77],Z([0,1,38,12,76,54]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function N(P,y){return P===1?O.isWindows?w():L.getWindowsShell(y):c(P,y)}e.getSystemShell=N;function I(P,y){return P===1?O.isWindows?p(y):L.getWindowsShell(y):c(P,y)}e.getSystemShellSync=I;let h=null;function c(P,y){if(O.isLinux&&P===2||O.isMacintosh&&P===3)return"/bin/bash";if(!h){let S;if(O.isWindows)S="/bin/bash";else{if(S=y.SHELL,!S)try{S=(0,T.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}h=S}return h}let m=null;async function w(){return m||(m=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),m}function p(P){if(m)return m;const y=O.isWindows&&parseFloat((0,T.release)())>=10,S=P.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${P.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return y?E:L.getWindowsShell(P)}});var fe=this&&this.__decorate||function($,e,T,O){var k=arguments.length,L=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,T):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($,e,T,O);else for(var I=$.length-1;I>=0;I--)(N=$[I])&&(L=(k<3?N(L):k>3?N(e,T,L):N(e,T))||L);return k>3&&L&&Object.defineProperty(e,T,L),L};define(Y[55],Z([0,1,19,3,15,22,49,11,4,2,44,29,8]),function($,e,T,O,k,L,N,I,h,c,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var P;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(P||(P={}));function y(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(S||(S={}));function E(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(a||(a={}));class d{constructor(A){this.b=A,this.a=0}read(A){const U=this.b.slice(this.a,this.a+A);return this.a+=U.byteLength,U}}class v{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(A){this.a.push(A)}}var f;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(f||(f={}));function s(M){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function i(M){return M.read(4).readUInt32BE(0)}function n(M){const A=k.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const t={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},r=typeof Buffer<"u";function o(M,A){if(typeof A>"u")M.write(t.Undefined);else if(typeof A=="string"){const U=k.VSBuffer.fromString(A);M.write(t.String),M.write(s(U.byteLength)),M.write(U)}else if(r&&Buffer.isBuffer(A)){const U=k.VSBuffer.wrap(A);M.write(t.Buffer),M.write(s(U.byteLength)),M.write(U)}else if(A instanceof k.VSBuffer)M.write(t.VSBuffer),M.write(s(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(t.Array),M.write(s(A.length));for(const U of A)o(M,U)}else{const U=k.VSBuffer.fromString(JSON.stringify(A));M.write(t.Object),M.write(s(U.byteLength)),M.write(U)}}function u(M){switch(M.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return M.read(i(M)).toString();case f.Buffer:return M.read(i(M)).buffer;case f.VSBuffer:return M.read(i(M));case f.Array:{const U=i(M),V=[];for(let G=0;G<U;G++)V.push(u(M));return V}case f.Object:return JSON.parse(M.read(i(M)).toString())}}class l{constructor(A,U,V=null,G=1e3){this.h=A,this.j=U,this.k=V,this.l=G,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.p(x)),this.m({type:200})}registerChannel(A,U){this.b.set(A,U),setTimeout(()=>this.v(A),0)}m(A){switch(A.type){case 200:{const U=this.n([A.type]);this.k?.logOutgoing(U,0,1,E(A.type));return}case 201:case 202:case 204:case 203:{const U=this.n([A.type,A.id],A.data);this.k?.logOutgoing(U,A.id,1,E(A.type),A.data);return}}}n(A,U=void 0){const V=new v;return o(V,A),o(V,U),this.o(V.buffer)}o(A){try{return this.h.send(A),A.byteLength}catch{return 0}}p(A){const U=new d(A),V=u(U),G=u(U),x=V[0];switch(x){case 100:return this.k?.logIncoming(A.byteLength,V[1],1,`${y(x)}: ${V[2]}.${V[3]}`,G),this.q({type:x,id:V[1],channelName:V[2],name:V[3],arg:G});case 102:return this.k?.logIncoming(A.byteLength,V[1],1,`${y(x)}: ${V[2]}.${V[3]}`,G),this.s({type:x,id:V[1],channelName:V[2],name:V[3],arg:G});case 101:return this.k?.logIncoming(A.byteLength,V[1],1,`${y(x)}`),this.t({type:x,id:V[1]});case 103:return this.k?.logIncoming(A.byteLength,V[1],1,`${y(x)}`),this.t({type:x,id:V[1]})}}q(A){const U=this.b.get(A.channelName);if(!U){this.u(A);return}const V=new L.CancellationTokenSource;let G;try{G=U.call(this.j,A.name,A.arg,V.token)}catch(b){G=Promise.reject(b)}const x=A.id;G.then(b=>{this.m({id:x,data:b,type:201}),this.d.delete(A.id)},b=>{b instanceof Error?this.m({id:x,data:{message:b.message,name:b.name,stack:b.stack?b.stack.split?b.stack.split(`
`):b.stack:void 0},type:202}):this.m({id:x,data:b,type:203}),this.d.delete(A.id)});const ee=(0,c.toDisposable)(()=>V.cancel());this.d.set(A.id,ee)}s(A){const U=this.b.get(A.channelName);if(!U){this.u(A);return}const V=A.id,x=U.listen(this.j,A.name,A.arg)(ee=>this.m({id:V,data:ee,type:204}));this.d.set(A.id,x)}t(A){const U=this.d.get(A.id);U&&(U.dispose(),this.d.delete(A.id))}u(A){let U=this.g.get(A.channelName);U||(U=[],this.g.set(A.channelName,U));const V=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.m({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);U.push({request:A,timeoutTimer:V})}v(A){const U=this.g.get(A);if(U){for(const V of U)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.q(V.request);break;case 102:this.s(V.request);break}this.g.delete(A)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=l;var g;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(A,U=null){this.l=A,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.r(V)),this.j=U}getChannel(A){const U=this;return{call(V,G,x){return U.a?Promise.reject(new I.CancellationError):U.m(A,V,G,x)},listen(V,G){return U.a?h.Event.None:U.n(A,V,G)}}}m(A,U,V,G=L.CancellationToken.None){const x=this.g++,b={id:x,type:100,channelName:A,name:U,arg:V};if(G.isCancellationRequested)return Promise.reject(new I.CancellationError);let D;return new Promise((F,B)=>{if(G.isCancellationRequested)return B(new I.CancellationError);const W=()=>{const ye=ae=>{switch(ae.type){case 201:this.f.delete(x),F(ae.data);break;case 202:{this.f.delete(x);const ne=new Error(ae.data.message);ne.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,ne.name=ae.data.name,B(ne);break}case 203:this.f.delete(x),B(ae.data);break}};this.f.set(x,ye),this.o(b)};let te=null;this.b===a.Idle?W():(te=(0,O.createCancelablePromise)(ye=>this.t()),te.then(()=>{te=null,W()}));const oe=()=>{te?(te.cancel(),te=null):this.o({id:x,type:101}),B(new I.CancellationError)},me=G.onCancellationRequested(oe);D=(0,c.combinedDisposable)((0,c.toDisposable)(oe),me),this.d.add(D)}).finally(()=>{this.d.delete(D)})}n(A,U,V){const G=this.g++,ee={id:G,type:102,channelName:A,name:U,arg:V};let b=null;const D=new h.Emitter({onWillAddFirstListener:()=>{b=(0,O.createCancelablePromise)(F=>this.t()),b.then(()=>{b=null,this.d.add(D),this.o(ee)})},onDidRemoveLastListener:()=>{b?(b.cancel(),b=null):(this.d.delete(D),this.o({id:G,type:103}))}}),j=F=>D.fire(F.data);return this.f.set(G,j),D.event}o(A){switch(A.type){case 100:case 102:{const U=this.p([A.type,A.id,A.channelName,A.name],A.arg);this.j?.logOutgoing(U,A.id,0,`${y(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const U=this.p([A.type,A.id]);this.j?.logOutgoing(U,A.id,0,y(A.type));return}}}p(A,U=void 0){const V=new v;return o(V,A),o(V,U),this.q(V.buffer)}q(A){try{return this.l.send(A),A.byteLength}catch{return 0}}r(A){const U=new d(A),V=u(U),G=u(U),x=V[0];switch(x){case 200:return this.j?.logIncoming(A.byteLength,0,0,E(x)),this.s({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(A.byteLength,V[1],0,E(x),G),this.s({type:V[0],id:V[1],data:G})}}s(A){if(A.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(A.id)?.(A)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}t(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}fe([N.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class C{get connections(){const A=[];return this.f.forEach(U=>A.push(U)),A}constructor(A){this.a=new Map,this.f=new Set,this.g=new h.Emitter,this.onDidAddConnection=this.g.event,this.h=new h.Emitter,this.onDidRemoveConnection=this.h.event,A(({protocol:U,onDidClientDisconnect:V})=>{h.Event.once(U.onMessage)(x=>{const ee=new d(x),b=u(ee),D=new l(U,b),j=new R(U);this.a.forEach((B,W)=>D.registerChannel(W,B));const F={channelServer:D,channelClient:j,ctx:b};this.f.add(F),this.g.fire(F),V(()=>{D.dispose(),j.dispose(),this.f.delete(F),this.h.fire(F)})})})}getChannel(A,U){const V=this;return{call(G,x,ee){let b;if((0,p.isFunction)(U)){const j=(0,T.getRandomElement)(V.connections.filter(U));b=j?Promise.resolve(j):h.Event.toPromise(h.Event.filter(V.onDidAddConnection,U))}else b=U.routeCall(V,G,x);const D=b.then(j=>j.channelClient.getChannel(A));return X(D).call(G,x,ee)},listen(G,x){if((0,p.isFunction)(U))return V.j(A,U,G,x);const ee=U.routeEvent(V,G,x).then(b=>b.channelClient.getChannel(A));return X(ee).listen(G,x)}}}j(A,U,V,G){const x=this;let ee=new c.DisposableStore;const b=new h.Emitter({onWillAddFirstListener:()=>{ee=new c.DisposableStore;const D=new h.EventMultiplexer,j=new Map,F=W=>{const oe=W.channelClient.getChannel(A).listen(V,G),me=D.add(oe);j.set(W,me)},B=W=>{const te=j.get(W);!te||(te.dispose(),j.delete(W))};x.connections.filter(U).forEach(F),h.Event.filter(x.onDidAddConnection,U)(F,void 0,ee),x.onDidRemoveConnection(B,void 0,ee),D.event(b.fire,b,ee),ee.add(D)},onDidRemoveLastListener:()=>{ee.dispose()}});return b.event}registerChannel(A,U){this.a.set(A,U),this.f.forEach(V=>{V.channelServer.registerChannel(A,U)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=C;class q{constructor(A,U,V=null){const G=new v;o(G,U),A.send(G.buffer),this.a=new R(A,V),this.d=new l(A,U,V)}getChannel(A){return this.a.getChannel(A)}registerChannel(A,U){this.d.registerChannel(A,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=q;function X(M){return{call(A,U,V){return M.then(G=>G.call(A,U,V))},listen(A,U){const V=new h.Relay;return M.then(G=>V.input=G.listen(A,U)),V.event}}}e.getDelayedChannel=X;function J(M){let A=!1;return{call(U,V,G){return A?M.call(U,V,G):(0,O.timeout)(0).then(()=>A=!0).then(()=>M.call(U,V,G))},listen(U,V){if(A)return M.listen(U,V);const G=new h.Relay;return(0,O.timeout)(0).then(()=>A=!0).then(()=>G.input=M.listen(U,V)),G.event}}}e.getNextTickChannel=J;class ie{constructor(A){this.a=A}routeCall(A){return this.b(A)}routeEvent(A){return this.b(A)}async b(A){for(const U of A.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await h.Event.toPromise(A.onDidAddConnection),await this.b(A)}}e.StaticRouter=ie;var re;(function(M){function A(x,ee){const b=x,D=ee&&ee.disableMarshalling,j=new Map;for(const F in b)V(F)&&j.set(F,h.Event.buffer(b[F],!0));return new class{listen(F,B,W){const te=j.get(B);if(te)return te;if(G(B)){const oe=b[B];if(typeof oe=="function")return oe.call(b,W)}throw new Error(`Event not found: ${B}`)}call(F,B,W){const te=b[B];if(typeof te=="function"){if(!D&&Array.isArray(W))for(let oe=0;oe<W.length;oe++)W[oe]=(0,m.revive)(W[oe]);return te.apply(b,W)}throw new Error(`Method not found: ${B}`)}}}M.fromService=A;function U(x,ee){const b=ee&&ee.disableMarshalling;return new Proxy({},{get(D,j){if(typeof j=="string")return ee?.properties?.has(j)?ee.properties.get(j):G(j)?function(F){return x.listen(j,F)}:V(j)?x.listen(j):async function(...F){let B;ee&&!(0,p.isUndefinedOrNull)(ee.context)?B=[ee.context,...F]:B=F;const W=await x.call(j,B);return b?W:(0,m.revive)(W)};throw new Error(`Property not found: ${String(j)}`)}})}M.toService=U;function V(x){return x[0]==="o"&&x[1]==="n"&&w.isUpperAsciiLetter(x.charCodeAt(2))}function G(x){return/^onDynamic/.test(x)&&w.isUpperAsciiLetter(x.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const A=M.toString();if(A!=="[object Object]")return A}return M}function ce(M){return Array.isArray(M)?M.map(he):he(M)}function se(M,A,U,V,G,x,ee){ee=ce(ee);const b=Q[G],D=b[V%b.length];let j=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${D}`];/\($/.test(x)?(j=j.concat(ee),j.push(")")):j.push(ee),console.log.apply(console,j)}class ge{constructor(A,U){this.d=A,this.f=U,this.a=0,this.b=0}logOutgoing(A,U,V,G,x){this.b+=A,se(this.d,this.b,A,U,V,G,x)}logIncoming(A,U,V,G,x){this.a+=A,se(this.f,this.a,A,U,V,G,x)}}e.IPCLogger=ge}),define(Y[78],Z([0,1,56,3,15,22,75,11,4,2,28,54,51,55]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends P.ChannelServer{constructor(a){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",d=>k.VSBuffer.wrap(Buffer.from(d,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.Server=y;class S{constructor(a,d){this.i=a,this.j=d,this.c=new Set,this.g=new Map,this.h=new h.Emitter,this.onDidProcessExit=this.h.event;const v=d&&d.timeout?d.timeout:6e4;this.b=new O.Delayer(v),this.d=null,this.f=null}getChannel(a){const d=this;return{call(v,f,s){return d.k(a,v,f,s)},listen(v,f){return d.l(a,v,f)}}}k(a,d,v,f=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(I.canceled());this.b.cancel();const s=this.n(a),i=(0,O.createCancelablePromise)(r=>s.call(d,v,r)),n=f.onCancellationRequested(()=>i.cancel()),t=(0,c.toDisposable)(()=>i.cancel());return this.c.add(t),i.finally(()=>{n.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(a,d,v){if(!this.b)return h.Event.None;this.b.cancel();let f;const s=new h.Emitter({onWillAddFirstListener:()=>{f=this.n(a).listen(d,v)(s.fire,s),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,p.removeDangerousEnvVariables)(d.env),this.d=(0,T.fork)(this.i,a,d);const v=new h.Emitter;h.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,N.isRemoteConsoleLog)(o)){(0,N.log)(o,`IPC Library: ${this.j.serverName}`);return}v.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.j.useQueue?(0,w.createQueuedSender)(this.d):this.d,i=o=>this.d&&this.d.connected&&s.send(o.buffer.toString("base64")),n=v.event,t={send:i,onMessage:n};this.f=new P.ChannelClient(t);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",r),this.c.forEach(l=>(0,c.dispose)(l)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(a){let d=this.g.get(a);return d||(d=this.m.getChannel(a),this.g.set(a,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=S}),define(Y[79],Z([0,1,3,4,2,8]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(N=e.StorageHint||(e.StorageHint={}));function I(w){const p=w;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var h;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class c extends k.Disposable{constructor(p,P=Object.create(null)){super(),this.m=p,this.n=P,this.b=this.B(new O.Emitter),this.onDidChangeStorage=this.b.event,this.c=h.None,this.f=new Map,this.g=new T.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(p=>this.r(p)))}r(p){p.changed?.forEach((P,y)=>this.s(y,P)),p.deleted?.forEach(P=>this.s(P,void 0))}s(p,P){if(this.c===h.Closed)return;let y=!1;(0,L.isUndefinedOrNull)(P)?y=this.f.delete(p):this.f.get(p)!==P&&(this.f.set(p,P),y=!0),y&&this.b.fire(p)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===h.None&&(this.c=h.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(p,P){const y=this.f.get(p);return(0,L.isUndefinedOrNull)(y)?P:y}getBoolean(p,P){const y=this.get(p);return(0,L.isUndefinedOrNull)(y)?P:y==="true"}getNumber(p,P){const y=this.get(p);return(0,L.isUndefinedOrNull)(y)?P:parseInt(y,10)}async set(p,P){if(this.c===h.Closed)return;if((0,L.isUndefinedOrNull)(P))return this.delete(p);const y=String(P);if(this.f.get(p)!==y)return this.f.set(p,y),this.j.set(p,y),this.h.delete(p),this.b.fire(p),this.w()}async delete(p){if(!(this.c===h.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire(p),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=h.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(p).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(p){if(!!this.u)return this.w(p)}async w(p){return this.g.trigger(()=>this.v(),p)}async whenFlushed(){if(!!this.u)return new Promise(p=>this.l.push(p))}dispose(){this.g.dispose(),super.dispose()}}e.Storage=c,c.a=100;class m{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((P,y)=>this.a.set(y,P)),p.delete?.forEach(P=>this.a.delete(P))}async close(){}}e.InMemoryStorageDatabase=m}),define(Y[80],Z([5,6]),function($,e){return $.create("vs/base/node/zip",e)}),define(Y[81],Z([5,6]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Y[82],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Y[83],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Y[84],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Y[85],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Y[86],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Y[87],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Y[88],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Y[89],Z([5,6]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Y[90],Z([5,6]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Y[91],Z([5,6]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Y[92],Z([5,6]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Y[93],Z([5,6]),function($,e){return $.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Y[94],Z([5,6]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Y[95],Z([5,6]),function($,e){return $.create("vs/platform/shell/node/shellEnv",e)}),define(Y[96],Z([5,6]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Y[97],Z([5,6]),function($,e){return $.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Y[98],Z([5,6]),function($,e){return $.create("vs/platform/workspace/common/workspace",e)}),define(Y[99],Z([0,1,71,49,16,14,33,17,10]),function($,e,T,O,k,L,N,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,L.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return h.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(h.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=N.env.VSCODE_PORTABLE;return S?h.URI.file((0,L.join)(S,"argv.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const S=this.args["extensions-download-dir"];return S?h.URI.file((0,L.resolve)(S)):h.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const E=N.env.VSCODE_EXTENSIONS;if(E)return E;const a=N.env.VSCODE_PORTABLE;return a?(0,L.join)(a,"extensions"):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(E=>/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,L.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?h.URI.parse(S):h.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(S=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(S))}get extensionLogLevel(){const S=[];for(const E of this.args.log||[]){const a=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(E);a&&a[1]&&a[2]&&S.push([a[1],a[2]])}return S.length?S:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return h.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=N.env.VSCODE_PORTABLE;return S?h.URI.file((0,L.join)(S,"policy.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(S){this.args.continueOn=S}get args(){return this.a}constructor(S,E,a){this.a=S,this.b=E,this.c=a,this.editSessionId=this.args.editSessionId}}fe([O.memoize],c.prototype,"appRoot",null),fe([O.memoize],c.prototype,"userHome",null),fe([O.memoize],c.prototype,"userDataPath",null),fe([O.memoize],c.prototype,"appSettingsHome",null),fe([O.memoize],c.prototype,"tmpDir",null),fe([O.memoize],c.prototype,"cacheHome",null),fe([O.memoize],c.prototype,"stateResource",null),fe([O.memoize],c.prototype,"userRoamingDataHome",null),fe([O.memoize],c.prototype,"userDataSyncHome",null),fe([O.memoize],c.prototype,"userDataSyncLogResource",null),fe([O.memoize],c.prototype,"editSessionsLogResource",null),fe([O.memoize],c.prototype,"sync",null),fe([O.memoize],c.prototype,"machineSettingsResource",null),fe([O.memoize],c.prototype,"workspaceStorageHome",null),fe([O.memoize],c.prototype,"localHistoryHome",null),fe([O.memoize],c.prototype,"keyboardLayoutResource",null),fe([O.memoize],c.prototype,"argvResource",null),fe([O.memoize],c.prototype,"isExtensionDevelopment",null),fe([O.memoize],c.prototype,"untitledWorkspacesHome",null),fe([O.memoize],c.prototype,"installSourcePath",null),fe([O.memoize],c.prototype,"builtinExtensionsPath",null),fe([O.memoize],c.prototype,"extensionsPath",null),fe([O.memoize],c.prototype,"extensionDevelopmentLocationURI",null),fe([O.memoize],c.prototype,"extensionDevelopmentKind",null),fe([O.memoize],c.prototype,"extensionTestsLocationURI",null),fe([O.memoize],c.prototype,"debugExtensionHost",null),fe([O.memoize],c.prototype,"logLevel",null),fe([O.memoize],c.prototype,"extensionLogLevel",null),fe([O.memoize],c.prototype,"serviceMachineIdResource",null),fe([O.memoize],c.prototype,"telemetryLogResource",null),fe([O.memoize],c.prototype,"disableWorkspaceTrust",null),fe([O.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function m(y,S){return P(y["inspect-extensions"],y["inspect-brk-extensions"],5870,S,y.debugId,y.extensionEnvironment)}e.parseExtensionHostPort=m;function w(y,S){return P(y["inspect-search"],y["inspect-brk-search"],5876,S,y.extensionEnvironment)}e.parseSearchPort=w;function p(y,S){return P(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,S,y.extensionEnvironment)}e.parsePtyHostPort=p;function P(y,S,E,a,d,v){const s=Number(S||y)||(a?null:E),i=s?Boolean(!!S):!1;let n;if(v)try{n=JSON.parse(v)}catch{}return{port:s,break:i,debugId:d,env:n}}}),function(){"use strict";function $(e,T,O){function k(N,I){const h=L(N,I),c=[h];return e.isAbsolute(h)||c.unshift(O),e.resolve(...c)}function L(N,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const m=N["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(w,"AppData","Roaming")}break;case"darwin":c=e.join(T.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:k}}if(typeof define=="function")define(Y[100],Z([151,38,33]),function(e,T,O){return $(e,T,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=$(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[101],Z([0,1,38,99,100]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends O.AbstractNativeEnvironmentService{constructor(I,h){super(I,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,k.getUserDataPath)(I,h.nameShort)},h)}}e.NativeEnvironmentService=L}),define(Y[102],Z([0,1,8,85]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(N,I,h){try{L(N,I,h)}catch(c){console.error(c?.message??c)}return N}e.localizeManifest=k;function L(N,I,h){const c=(m,w,p)=>{const P=m[w];if((0,T.isString)(P)){const y=P,S=y.length;if(S>1&&y[0]==="%"&&y[S-1]==="%"){const E=y.substr(1,S-2);let a=I[E];a===void 0&&h&&(a=h[E]);const d=typeof a=="string"?a:a?.message,v=h?.[E],f=typeof v=="string"?v:v?.message;if(!d){f||console.warn(`[${N.name}]: ${(0,O.localize)(0,null,E)}`);return}if(p&&(w==="title"||w==="category")&&f&&f!==d){const s={value:d,original:f};m[w]=s}else m[w]=d}}else if((0,T.isObject)(P))for(const y in P)P.hasOwnProperty(y)&&(y==="commands"?c(P,y,!0):c(P,y,p));else if(Array.isArray(P))for(let y=0;y<P.length;y++)c(P,y,p)};for(const m in N)N.hasOwnProperty(m)&&c(N,m)}}),define(Y[103],Z([0,1,11]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class O{constructor(){this.a=new Map}register(L,N){this.a.set(L,N)}updateManifest(L){if(!(!Array.isArray(L.activationEvents)||!L.contributes)&&!(typeof L.main>"u"&&typeof L.browser>"u"))for(const N in L.contributes){const I=this.a.get(N);if(!I)continue;const h=L.contributes[N],c=Array.isArray(h)?h:[h];try{I(c,L.activationEvents)}catch(m){(0,T.onUnexpectedError)(m)}}}}e.ImplicitActivationEventsImpl=O,e.ImplicitActivationEvents=new O}),define(Y[45],Z([0,1,17,53,89,39]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function h(a){return a=a.trim(),a==="*"||N.test(a)}e.isValidVersionStr=h;function c(a){if(!h(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=a.match(N);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=c;function m(a){if(!a)return null;const d=a.majorBase,v=a.majorMustEqual,f=a.minorBase;let s=a.minorMustEqual;const i=a.patchBase;let n=a.patchMustEqual;a.hasCaret&&(d===0||(s=!1),n=!1);let t=0;if(a.preRelease){const r=I.exec(a.preRelease);if(r){const[,o,u,l]=r;t=Date.UTC(Number(o),Number(u)-1,Number(l))}}return{majorBase:d,majorMustEqual:v,minorBase:f,minorMustEqual:s,patchBase:i,patchMustEqual:n,isMinimum:a.hasGreaterEquals,notBefore:t}}e.normalizeVersion=m;function w(a,d,v){let f;typeof a=="string"?f=m(c(a)):f=a;let s;d instanceof Date?s=d.getTime():typeof d=="string"&&(s=new Date(d).getTime());let i;if(typeof v=="string"?i=m(c(v)):i=v,!f||!i)return!1;const n=f.majorBase,t=f.minorBase,r=f.patchBase;let o=i.majorBase,u=i.minorBase,l=i.patchBase;const g=i.notBefore;let R=i.majorMustEqual,C=i.minorMustEqual,q=i.patchMustEqual;return i.isMinimum?n>o?!0:n<o?!1:t>u?!0:t<u||s&&s<g?!1:r>=l:(n===1&&o===0&&(!R||!C||!q)&&(o=1,u=0,l=0,R=!0,C=!1,q=!1),n<o?!1:n>o?!R:t<u?!1:t>u?!C:r<l?!1:r>l?!q:!(s&&s<g))}e.isValidVersion=w;function p(a,d,v,f,s){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([O.default.Error,k.localize(0,null)]),i;if(typeof f.name!="string")return i.push([O.default.Error,k.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([O.default.Error,k.localize(2,null,"version")]),i;if(!f.engines)return i.push([O.default.Error,k.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([O.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!E(f.extensionDependencies))return i.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!E(f.activationEvents))return i.push([O.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([O.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([O.default.Error,k.localize(9,null,"main")]),i;{const r=(0,T.joinPath)(v,f.main);(0,T.isEqualOrParent)(r,v)||i.push([O.default.Warning,k.localize(10,null,r.path,v.path)])}if(typeof f.activationEvents>"u")return i.push([O.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([O.default.Error,k.localize(12,null,"browser")]),i;{const r=(0,T.joinPath)(v,f.browser);(0,T.isEqualOrParent)(r,v)||i.push([O.default.Warning,k.localize(13,null,r.path,v.path)])}if(typeof f.activationEvents>"u")return i.push([O.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!L.valid(f.version))return i.push([O.default.Error,k.localize(15,null)]),i;const n=[];if(!P(a,d,f,s,n))for(const r of n)i.push([O.default.Error,r]);return i}e.validateExtensionManifest=p;function P(a,d,v,f,s){return f||typeof v.main>"u"&&typeof v.browser>"u"?!0:S(a,d,v.engines.vscode,s)}e.isValidExtensionVersion=P;function y(a,d,v){return a==="*"||S(d,v,a)}e.isEngineValid=y;function S(a,d,v,f=[]){const s=m(c(v));if(!s)return f.push(k.localize(16,null,v)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return f.push(k.localize(17,null,v)),!1}else if(!s.majorMustEqual)return f.push(k.localize(18,null,v)),!1;return w(a,d,s)?!0:(f.push(k.localize(19,null,a,v)),!1)}function E(a){if(!Array.isArray(a))return!1;for(let d=0,v=a.length;d<v;d++)if(typeof a[d]!="string")return!1;return!0}}),define(Y[104],Z([0,1,15,31]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(L,N,I){let h=I&&I.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const m=(await N.readFile(L.serviceMachineIdResource)).value.toString();h=(0,O.isUUID)(m)?m:null}catch{h=null}if(!h){h=(0,O.generateUuid)();try{await N.writeFile(L.serviceMachineIdResource,T.VSBuffer.fromString(h))}catch{}}return I?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=k}),define(Y[46],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(k,L=[],N=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=T}),define(Y[105],Z([0,1,46]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var k;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function L(I,h,c){h instanceof T.SyncDescriptor||(h=new T.SyncDescriptor(h,[],Boolean(c))),O.push([I,h])}e.registerSingleton=L;function N(){return O}e.getSingletonServiceDescriptors=N}),define(Y[106],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(L,N){this.key=L,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class O{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const N of this.a.values())N.outgoing.size===0&&L.push(N);return L}insertEdge(L,N){const I=this.lookupOrInsertNode(L),h=this.lookupOrInsertNode(N);I.outgoing.set(h.key,h),h.incoming.set(I.key,I)}removeNode(L){const N=this.b(L);this.a.delete(N);for(const I of this.a.values())I.outgoing.delete(N),I.incoming.delete(N)}lookupOrInsertNode(L){const N=this.b(L);let I=this.a.get(N);return I||(I=new T(N,L),this.a.set(N,I)),I}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[N,I]of this.a)L.push(`${N}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,N]of this.a){const I=new Set([L]),h=this.c(N,I);if(h)return h}}c(L,N){for(const[I,h]of L.outgoing){if(N.has(I))return[...N,I].join(" -> ");N.add(I);const c=this.c(h,N);if(c)return c;N.delete(I)}}}e.Graph=O}),define(Y[21],Z([0,1,8,10,7]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof O.URI)}e.isConfigurationOverrides=L;function N(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=N;var I;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function c(a,d){const v=Object.create(null);for(const f in a)m(v,f,a[f],d);return v}e.toValuesTree=c;function m(a,d,v,f){const s=d.split("."),i=s.pop();let n=a;for(let t=0;t<s.length;t++){const r=s[t];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${d} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[i]=v}catch{f(`Ignoring ${d} as ${s.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${d} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=m;function w(a,d){const v=d.split(".");p(a,v)}e.removeFromValueTree=w;function p(a,d){const v=d.shift();if(d.length===0){delete a[v];return}if(Object.keys(a).indexOf(v)!==-1){const f=a[v];typeof f=="object"&&!Array.isArray(f)&&(p(f,d),Object.keys(f).length===0&&delete a[v])}}function P(a,d,v){function f(n,t){let r=n;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=d.split("."),i=f(a,s);return typeof i>"u"?v:i}e.getConfigurationValue=P;function y(a,d,v){Object.keys(d).forEach(f=>{f!=="__proto__"&&(f in a?T.isObject(a[f])&&T.isObject(d[f])?y(a[f],d[f],v):v&&(a[f]=d[f]):a[f]=d[f])})}e.merge=y;function S(a,d,v){const f=a.inspect(d),s=a.inspect(v);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:f.defaultValue}e.getMigratedSettingValue=S;function E(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Y[57],Z([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Y[18],Z([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(Y[23],Z([0,1,83,7]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function L(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function N(a,d){switch(a){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function I(a,d){return d==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function h(a,d,v){return I(d,v)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===v?!0:c(v).includes(a)}e.isTargetPlatformCompatible=h;function c(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function m(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=m;var w;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var P;(function(a){a.Install="install",a.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var y;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var S;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal",a.Signature="Signature"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(d,v){super(d),this.code=v,this.name=v}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Y[58],Z([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((L,N)=>$(["node-vsce-sign"],async I=>L(I),N))),this.a}async verify(L,N){let I;try{I=await this.b()}catch{return!1}return I.verify(L,N)}}e.ExtensionSignatureVerificationService=O}),define(Y[59],Z([0,1,15,11,91,13]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(m,w,p,P,y,S){let E;try{await I(m,w,p,P,y,S)}catch(a){E=a}finally{E&&y.errorTransformer&&(E=y.errorTransformer(E)),typeof E<"u"&&p.error(E),p.end()}}e.readFileIntoStream=N;async function I(m,w,p,P,y,S){h(S);const E=await m.open(w,{create:!1});try{h(S);let a=0,d=0,v=y&&typeof y.length=="number"?y.length:void 0,f=T.VSBuffer.alloc(Math.min(y.bufferSize,typeof v=="number"?v:y.bufferSize)),s=y&&typeof y.position=="number"?y.position:0,i=0;do d=await m.read(E,s,f.buffer,i,f.byteLength-i),s+=d,i+=d,a+=d,typeof v=="number"&&(v-=d),i===f.byteLength&&(await p.write(P(f)),f=T.VSBuffer.alloc(Math.min(y.bufferSize,typeof v=="number"?v:y.bufferSize)),i=0);while(d>0&&(typeof v!="number"||v>0)&&h(S)&&c(a,y));if(i>0){let n=i;typeof v=="number"&&(n=Math.min(i,v)),p.write(P(f.slice(0,n)))}}catch(a){throw(0,L.ensureFileSystemProviderError)(a)}finally{await m.close(E)}}function h(m){if(m.isCancellationRequested)throw(0,O.canceled)();return!0}function c(m,w){if(w?.limits){if(typeof w.limits.memory=="number"&&m>w.limits.memory)throw(0,L.createFileSystemProviderError)((0,k.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&m>w.limits.size)throw(0,L.createFileSystemProviderError)((0,k.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[107],Z([0,1,4,152,2,12,153]),function($,e,T,O,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(c){const m=this.i(c),w=m.filter(P=>{const y=this.c.get(P.path);return y?!(0,O.patternsEquals)(y.request.excludes,P.excludes)||!(0,O.patternsEquals)(y.request.includes,P.includes):!0}),p=Array.from(this.c.values()).filter(({request:P})=>!m.find(y=>y.path===P.path&&(0,O.patternsEquals)(y.excludes,P.excludes)&&(0,O.patternsEquals)(y.includes,P.includes))).map(({request:P})=>P.path);w.length&&this.j(`Request to start watching: ${w.map(P=>`${P.path} (excludes: ${P.excludes.length>0?P.excludes:"<none>"}, includes: ${P.includes&&P.includes.length>0?JSON.stringify(P.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const P of p)this.h(P);for(const P of w)this.g(P)}g(c){const m=new N.NodeJSFileWatcherLibrary(c,p=>this.a.fire(p),p=>this.b.fire(p),this.f),w={request:c,instance:m};this.c.set(c.path,w)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const m=this.c.get(c);m&&(this.c.delete(c),m.instance.dispose())}i(c){const m=new Map;for(const w of c){const p=L.isLinux?w.path:w.path.toLowerCase();m.set(p,w)}return Array.from(m.values())}async setVerboseLogging(c){this.f=c;for(const[,m]of this.c)m.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,m){return m?`[File Watcher (node.js)] ${c} (path: ${m.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=I}),define(Y[108],Z([0,1,60,107]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends T.AbstractNonRecursiveWatcherClient{constructor(N,I,h){super(N,I,h),this.m()}l(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Y[109],Z([0,1,16,55,78,60]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends L.AbstractUniversalWatcherClient{constructor(h,c,m){super(h,c,m),this.m()}l(h){const c=h.add(new k.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:m,signal:w})=>this.n(`terminated by itself with code ${m}, signal: ${w}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(Y[61],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...k){this.a=new Map;for(const[L,N]of k)this.set(L,N)}set(k,L){const N=this.a.get(k);return this.a.set(k,L),N}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=T}),define(Y[110],Z([0,1,3,11,2,46,106,7,61,154]),function($,e,T,O,k,L,N,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class w extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class p{constructor(E=new h.ServiceCollection,a=!1,d,v=m){this.f=E,this.g=a,this.h=d,this.i=v,this.o=new Set,this.f.set(I.IInstantiationService,this),this._globalGraph=v?d?._globalGraph??new N.Graph(f=>f):void 0}createChild(E){return new p(E,this.g,this,this.i)}invokeFunction(E,...a){const d=y.traceInvocation(this.i,E);let v=!1;try{return E({get:s=>{if(v)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(s,d);if(!i)throw new Error(`[invokeFunction] unknown service '${s}'`);return i}},...a)}finally{v=!0,d.stop()}}createInstance(E,...a){let d,v;return E instanceof L.SyncDescriptor?(d=y.traceCreation(this.i,E.ctor),v=this.j(E.ctor,E.staticArguments.concat(a),d)):(d=y.traceCreation(this.i,E),v=this.j(E,a,d)),d.stop(),v}j(E,a=[],d){const v=I._util.getServiceDependencies(E).sort((i,n)=>i.index-n.index),f=[];for(const i of v){const n=this.m(i.id,d);n||this.u(`[createInstance] ${E.name} depends on UNKNOWN service ${i.id}.`,!1),f.push(n)}const s=v.length>0?v[0].index:a.length;if(a.length!==s){console.trace(`[createInstance] First service dependency of ${E.name} at position ${s+1} conflicts with ${a.length} static arguments`);const i=s-a.length;i>0?a=a.concat(new Array(i)):a=a.slice(0,s)}return Reflect.construct(E,a.concat(f))}k(E,a){if(this.f.get(E)instanceof L.SyncDescriptor)this.f.set(E,a);else if(this.h)this.h.k(E,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(E){const a=this.f.get(E);return!a&&this.h?this.h.l(E):a}m(E,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const d=this.l(E);return d instanceof L.SyncDescriptor?this.q(E,d,a.branch(E,!0)):(a.branch(E,!1),d)}q(E,a,d){if(this.o.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.o.add(E);try{return this.r(E,a,d)}finally{this.o.delete(E)}}r(E,a,d){const v=new N.Graph(i=>i.id.toString());let f=0;const s=[{id:E,desc:a,_trace:d}];for(;s.length;){const i=s.pop();if(v.lookupOrInsertNode(i),f++>1e3)throw new w(v);for(const n of I._util.getServiceDependencies(i.desc.ctor)){const t=this.l(n.id);if(t||this.u(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof L.SyncDescriptor){const r={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};v.insertEdge(i,r),s.push(r)}}}for(;;){const i=v.roots();if(i.length===0){if(!v.isEmpty())throw new w(v);break}for(const{data:n}of i){if(this.l(n.id)instanceof L.SyncDescriptor){const r=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,r)}v.removeNode(n)}}return this.l(E)}s(E,a,d=[],v,f){if(this.f.get(E)instanceof L.SyncDescriptor)return this.t(E,a,d,v,f);if(this.h)return this.h.s(E,a,d,v,f);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(E,a,d=[],v,f){if(v){const s=new p(void 0,this.g,this,this.i);s.c=String(E);const i=new Map,n=new T.IdleValue(()=>{const t=s.j(a,d,f);for(const[r,o]of i){const u=t[r];if(typeof u=="function")for(const l of o)u.apply(t,l)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let l=i.get(r);return l||(l=new c.LinkedList,i.set(r,l)),(R,C,q)=>{const X=l.push([R,C,q]);return(0,k.toDisposable)(X)}}if(r in t)return t[r];const o=n.value;let u=o[r];return typeof u!="function"||(u=u.bind(o),t[r]=u),u},set(t,r,o){return n.value[r]=o,!0}})}else return this.j(a,d,f)}u(E,a){if(a&&console.warn(E),this.g)throw new Error(E)}}e.InstantiationService=p;var P;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(P||(P={}));class y{static traceInvocation(E,a){return E?new y(1,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(E,a){return E?new y(0,a.name):y.c}constructor(E,a){this.type=E,this.name=a,this.g=Date.now(),this.h=[]}branch(E,a){const d=new y(2,E.toString());return this.h.push([E,a,d]),d}stop(){const E=Date.now()-this.g;y.f+=E;let a=!1;function d(f,s){const i=[],n=new Array(f+1).join("	");for(const[t,r,o]of s.h)if(r&&o){a=!0,i.push(`${n}CREATES -> ${t}`);const u=d(f+1,o);u&&i.push(u)}else i.push(`${n}uses -> ${t}`);return i.join(`
`)}const v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(E>2||a)&&y.all.add(v.join(`
`))}}e.Trace=y,y.all=new Set,y.c=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y.f=0});var _=this&&this.__param||function($,e){return function(T,O){e(T,O,$)}};define(Y[62],Z([0,1,22,2,12,93,23,7]),function($,e,T,O,k,L,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let h=class extends O.Disposable{constructor(m){super(),this.c=m}async getAvailableLanguages(){const m=new T.CancellationTokenSource;setTimeout(()=>m.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},m.token)}catch{return[]}const P=w.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(S=>S.startsWith("lp-"))).map(y=>{const S=y.properties.localizedLanguages?.[0],E=this.getLocale(y);return{...this.f(E,S,y),extensionId:y.identifier.id,galleryExtension:y}});return P.push({...this.f("en","English"),extensionId:"default"}),P}getLocale(m){return m.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}f(m,w,p){const P=w??m;let y;if(P!==m&&(y=`(${m})`),m.toLowerCase()===k.language.toLowerCase()&&(y??="",y+=(0,L.localize)(0,null)),p?.installCount){y??="";const S=p.installCount;let E;S>1e6?E=`${Math.floor(S/1e5)/10}M`:S>1e3?E=`${Math.floor(S/1e3)}K`:E=String(S),y+=` $(cloud-download) ${E}`}return{id:m,label:P,description:y}}};h=fe([_(0,N.IExtensionGalleryService)],h),e.LanguagePackBaseService=h}),define(Y[9],Z([0,1,32,4,2,34,12,10,7]),function($,e,T,O,k,L,N,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function c(){return new Date().toISOString()}var m;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function w(u,l,g){switch(l){case m.Trace:u.trace(g);break;case m.Debug:u.debug(g);break;case m.Info:u.info(g);break;case m.Warning:u.warn(g);break;case m.Error:u.error(g);break;default:throw new Error(`Invalid log level ${l}`)}}e.log=w;function p(u){let l="";for(let g=0;g<u.length;g++){let R=u[g];if(typeof R=="object")try{R=JSON.stringify(R)}catch{}l+=(g>0?" ":"")+R}return l}e.format=p;class P extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new O.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}}e.AbstractLogger=P;class y extends P{constructor(l){super(),this.g=l}h(l){return this.g||this.getLevel()<=l}trace(l,...g){this.h(m.Trace)&&this.f(m.Trace,p([l,...g]))}debug(l,...g){this.h(m.Debug)&&this.f(m.Debug,p([l,...g]))}info(l,...g){this.h(m.Info)&&this.f(m.Info,p([l,...g]))}warn(l,...g){this.h(m.Warning)&&this.f(m.Warning,p([l,...g]))}error(l,...g){if(this.h(m.Error))if(l instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=l.stack,this.f(m.Error,p(R))}else this.f(m.Error,p([l,...g]))}flush(){}}e.AbstractMessageLogger=y;class S extends P{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.f=!N.isWindows}trace(l,...g){this.getLevel()<=m.Trace&&(this.f?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...g):console.log(`[main ${c()}]`,l,...g))}debug(l,...g){this.getLevel()<=m.Debug&&(this.f?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...g):console.log(`[main ${c()}]`,l,...g))}info(l,...g){this.getLevel()<=m.Info&&(this.f?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...g):console.log(`[main ${c()}]`,l,...g))}warn(l,...g){this.getLevel()<=m.Warning&&(this.f?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,l,...g):console.warn(`[main ${c()}]`,l,...g))}error(l,...g){this.getLevel()<=m.Error&&(this.f?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,l,...g):console.error(`[main ${c()}]`,l,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class E extends P{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...g){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",l,...g)}debug(l,...g){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",l,...g)}info(l,...g){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",l,...g)}warn(l,...g){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",l,...g)}error(l,...g){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",l,...g)}dispose(){}flush(){}}e.ConsoleLogger=E;class a extends P{constructor(l,g=e.DEFAULT_LOG_LEVEL){super(),this.f=l,this.setLevel(g)}trace(l,...g){this.getLevel()<=m.Trace&&this.f.log(m.Trace,[this.g(l),...g])}debug(l,...g){this.getLevel()<=m.Debug&&this.f.log(m.Debug,[this.g(l),...g])}info(l,...g){this.getLevel()<=m.Info&&this.f.log(m.Info,[this.g(l),...g])}warn(l,...g){this.getLevel()<=m.Warning&&this.f.log(m.Warning,[this.g(l),...g])}error(l,...g){this.getLevel()<=m.Error&&this.f.log(m.Error,[this.g(l),...g])}g(l){return typeof l=="string"?l:(0,T.toErrorMessage)(l,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=a;class d extends P{constructor(l){super(),this.f=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const g of this.f)g.setLevel(l);super.setLevel(l)}trace(l,...g){for(const R of this.f)R.trace(l,...g)}debug(l,...g){for(const R of this.f)R.debug(l,...g)}info(l,...g){for(const R of this.f)R.info(l,...g)}warn(l,...g){for(const R of this.f)R.warn(l,...g)}error(l,...g){for(const R of this.f)R.error(l,...g)}flush(){for(const l of this.f)l.flush()}dispose(){for(const l of this.f)l.dispose()}}e.MultiplexLogService=d;class v extends k.Disposable{constructor(l){super(),this.b=l,this.B(l)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(l){this.b.setLevel(l)}getLevel(){return this.b.getLevel()}trace(l,...g){this.b.trace(l,...g)}debug(l,...g){this.b.debug(l,...g)}info(l,...g){this.b.info(l,...g)}warn(l,...g){this.b.warn(l,...g)}error(l,...g){this.b.error(l,...g)}flush(){this.b.flush()}}e.LogService=v;class f extends k.Disposable{constructor(l,g){super(),this.c=l,this.b=new L.ResourceMap,this.B(g(R=>this.setLevel(R)))}getLoggers(){return[...this.b.values()].map(({logger:l})=>l)}getLogger(l){return this.b.get(l)?.logger}createLogger(l,g,R){let C=this.b.get(l)?.logger;return C||(R=g?.always?m.Trace:R,C=this.f(l,R??this.c,g),this.b.set(l,{logger:C,logLevel:R})),C}setLevel(l,g){const R=I.URI.isUri(l)?l:void 0,C=R?g:l;if(R){const q=this.b.get(R);q&&q.logLevel!==C&&(q.logLevel=C,q.logger.setLevel(C))}else this.c=C,this.b.forEach(({logLevel:q,logger:X})=>{q===void 0&&X.setLevel(this.c)})}getLogLevel(l){return this.b.get(l)?.logLevel}dispose(){this.b.forEach(({logger:l})=>l.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=f;class s{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(l){}getLevel(){return m.Info}trace(l,...g){}debug(l,...g){}info(l,...g){}warn(l,...g){}error(l,...g){}critical(l,...g){}dispose(){}flush(){}}e.NullLogger=s;class i extends s{}e.NullLogService=i;class n extends f{constructor(){super(m.Info,O.Event.None)}f(l,g,R){return new s}}e.NullLoggerService=n;function t(u){if(u.verbose)return m.Trace;if(typeof u.logLevel=="string"){const l=o(u.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function r(u){switch(u){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=r;function o(u){switch(u){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=o}),define(Y[111],Z([0,1,19,3,11,4,2,14,60,9]),function($,e,T,O,k,L,N,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends N.Disposable{constructor(p,P){super(),this.a=p,this.b=P,this.c=this.B(new L.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new L.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.ThrottledDelayer(0)),this.s=[],this.t=this.B(new O.ThrottledDelayer(0))}watch(p,P){return P.recursive||this.b?.watcher?.forceUniversal?this.l(p,P):this.u(p,P)}l(p,P){const y={path:this.D(p),excludes:P.excludes,includes:P.includes,recursive:P.recursive},S=(0,T.insert)(this.j,y);return this.m(),(0,N.toDisposable)(()=>{S(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,k.onUnexpectedError)(p))}n(){this.h||(this.h=this.B(this.p(P=>this.c.fire((0,h.toFileChanges)(P)),P=>this.C(P),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const P of this.j)(0,h.isRecursiveWatchRequest)(P)&&(P.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const P of this.j)(0,h.isRecursiveWatchRequest)(P)&&p.includes(P.path)&&(P.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,P){const y={path:this.D(p),excludes:P.excludes,includes:P.includes,recursive:!1},S=(0,T.insert)(this.s,y);return this.v(),(0,N.toDisposable)(()=>{S(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,k.onUnexpectedError)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,h.toFileChanges)(p)),p=>this.C(p),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}C(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}D(p){return(0,I.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=m}),define(Y[112],Z([0,1,19,3,15,22,4,52,63,2,113,16,114,17,43,90,13,59,9]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y,S,E,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends c.Disposable{constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new N.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new N.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new O.ResourceQueue)}registerProvider(s,i){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${s}`);const n=new c.DisposableStore;return this.h.set(s,i),this.c.fire({added:!0,scheme:s,provider:i}),n.add(i.onDidChangeFile(t=>this.R.fire(new E.FileChangesEvent(t,!this.O(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(t=>this.S.fire(new Error(t)))),n.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:s}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:s,provider:i}),this.h.delete(s),(0,c.dispose)(n)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const i=[];this.f.fire({scheme:s,join(n){i.push(n)}}),!this.h.has(s)&&await O.Promises.settled(i)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,i){const n=this.h.get(s.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return h.Iterable.map(this.h,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async j(s){if(!(0,P.isAbsolutePath)(s))throw new E.FileOperationError((0,S.localize)(0,null,this.ob(s)),8);await this.activateProvider(s.scheme);const i=this.h.get(s.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,S.localize)(1,null,s.toString()),n}return i}async k(s){const i=await this.j(s);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)||(0,E.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(s){const i=await this.j(s);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.n(s,i)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,S.localize)(2,null,this.ob(s)),1):(0,E.ensureFileSystemProviderError)(n)}}async n(s,i){const n=await this.j(s),t=this.O(n),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,u=i?.resolveMetadata,l=await n.stat(s);let g;return this.p(n,s,l,void 0,!!u,(R,C)=>(g||(g=m.TernarySearchTree.forUris(()=>!t),g.set(s,!0),r&&g.fill(!0,r)),g.get(R.resource)||g.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&o?C===1:!1))}async p(s,i,n,t,r,o){const{providerExtUri:u}=this.N(s),l={resource:i,name:u.basename(i),isFile:(n.type&E.FileType.File)!==0,isDirectory:(n.type&E.FileType.Directory)!==0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&E.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,E.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(l.isDirectory&&o(l,t)){try{const g=await s.readdir(i),R=await O.Promises.settled(g.map(async([C,q])=>{try{const X=u.joinPath(i,C),J=r?await s.stat(X):{type:q};return await this.p(s,X,J,g.length,r,o)}catch(X){return this.b.trace(X),null}}));l.children=(0,T.coalesce)(R)}catch(g){this.b.trace(g),l.children=[]}return l}return l}async resolveAll(s){return O.Promises.settled(s.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const i=await this.j(s),n=await i.stat(s);return this.p(i,s,n,void 0,!0,()=>!1)}async exists(s){const i=await this.j(s);try{return!!await i.stat(s)}catch{return!1}}async canCreateFile(s,i){try{await this.r(s,i)}catch(n){return n}return!0}async r(s,i){if(!i?.overwrite&&await this.exists(s))throw new E.FileOperationError((0,S.localize)(3,null,this.ob(s)),3,i)}async createFile(s,i=k.VSBuffer.fromString(""),n){await this.r(s,n);const t=await this.writeFile(s,i);return this.m.fire(new E.FileOperationEvent(s,0,t)),t}async writeFile(s,i,n){const t=this.mb(await this.l(s),s),{providerExtUri:r}=this.N(t);try{await this.s(t,s,n)||await this.P(t,r.dirname(s));let u;if((0,E.hasReadWriteCapability)(t)&&!(i instanceof k.VSBuffer))if((0,y.isReadableStream)(i)){const l=await(0,y.peekStream)(i,3);l.ended?u=k.VSBuffer.concat(l.buffer):u=l}else u=(0,y.peekReadable)(i,l=>k.VSBuffer.concat(l),3);else u=i;!(0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t)&&u instanceof k.VSBuffer?await this.db(t,s,n,u):await this.Y(t,s,n,u instanceof k.VSBuffer?(0,k.bufferToReadable)(u):u),this.m.fire(new E.FileOperationEvent(s,4))}catch(o){throw new E.FileOperationError((0,S.localize)(4,null,this.ob(s),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async s(s,i,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,S.localize)(5,null,this.ob(i)));let r;try{r=await s.stat(i)}catch{return}if((r.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,S.localize)(6,null,this.ob(i)),0,n);if(this.nb(i,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:r.size}))throw new E.FileOperationError((0,S.localize)(7,null),3,n);return r}async readFile(s,i,n){const t=await this.k(s);return i?.atomic?this.t(t,s,i,n):this.u(t,s,i,n)}async t(s,i,n,t){return new Promise((r,o)=>{this.X.queueFor(i,this.N(s).providerExtUri).queue(async()=>{try{const u=await this.u(s,i,n,t);r(u)}catch(u){o(u)}})})}async u(s,i,n,t){const r=await this.v(s,i,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(s,i,n){const t=await this.k(s);return this.v(t,s,i,n)}async v(s,i,n,t){const r=new L.CancellationTokenSource(t),o=this.F(i,n).then(l=>l,l=>{throw r.cancel(),l});let u;try{return typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&await o,n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)||!((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasFileReadStreamCapability)(s))||(0,E.hasReadWriteCapability)(s)&&n?.preferUnbuffered?u=this.D(s,i,n):(0,E.hasFileReadStreamCapability)(s)?u=this.w(s,i,r.token,n):u=this.C(s,i,r.token,n),{...await o,value:u}}catch(l){u&&await(0,y.consumeStream)(u);const g=(0,S.localize)(8,null,this.ob(i),(0,E.ensureFileSystemProviderError)(l).toString());throw l instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(g,l.stat,n):new E.FileOperationError(g,(0,E.toFileOperationResult)(l),n)}}w(s,i,n,t=Object.create(null)){const r=s.readFileStream(i,t,n);return(0,y.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new E.FileOperationError((0,S.localize)(9,null,this.ob(i),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),t)},o=>k.VSBuffer.concat(o))}C(s,i,n,t=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,a.readFileIntoStream)(s,i,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>new E.FileOperationError((0,S.localize)(10,null,this.ob(i),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),t)},n),r}D(s,i,n){const t=(0,y.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)?r=await s.readFile(i,{atomic:!0}):r=await s.readFile(i),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.G(i,r.byteLength,n),t.end(k.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async F(s,i){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,S.localize)(11,null,this.ob(s)),0,i);if(typeof i?.etag=="string"&&i.etag!==E.ETAG_DISABLED&&i.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,S.localize)(12,null),n,i);return this.G(s,n.size,i),n}G(s,i,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&i>n.limits.size&&(t=7),typeof t=="number")throw new E.FileOperationError((0,S.localize)(13,null,this.ob(s)),t)}}async canMove(s,i,n){return this.H(s,i,"move",n)}async canCopy(s,i,n){return this.H(s,i,"copy",n)}async H(s,i,n,t){if(s.toString()!==i.toString())try{const r=n==="move"?this.mb(await this.l(s),s):await this.k(s),o=this.mb(await this.l(i),i);await this.M(r,s,o,i,n,t)}catch(r){return r}return!0}async move(s,i,n){const t=this.mb(await this.l(s),s),r=this.mb(await this.l(i),i),o=await this.I(t,s,r,i,"move",!!n),u=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,o==="move"?2:3,u)),u}async copy(s,i,n){const t=await this.k(s),r=this.mb(await this.l(i),i),o=await this.I(t,s,r,i,"copy",!!n),u=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,o==="copy"?3:2,u)),u}async I(s,i,n,t,r,o){if(i.toString()===t.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:l}=await this.M(s,i,n,t,r,o);if(u&&!l&&o&&await this.del(t,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(t)),r==="copy"){if(s===n&&(0,E.hasFileFolderCopyCapability)(s))await s.copy(i,t,{overwrite:o});else{const g=await this.resolve(i);g.isDirectory?await this.L(s,g,n,t):await this.J(s,i,n,t)}return r}else return s===n?(await s.rename(i,t,{overwrite:o}),r):(await this.I(s,i,n,t,"copy",o),await this.del(i,{recursive:!0}),"copy")}async J(s,i,n,t){if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.fb(s,i,n,t);if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.lb(s,i,n,t);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.jb(s,i,n,t);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.hb(s,i,n,t)}async L(s,i,n,t){await n.mkdir(t),Array.isArray(i.children)&&await O.Promises.settled(i.children.map(async r=>{const o=this.N(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.L(s,await this.resolve(r.resource),n,o):this.J(s,r.resource,n,o)}))}async M(s,i,n,t,r,o){let u=!1;if(s===n){const{providerExtUri:g,isPathCaseSensitive:R}=this.N(s);if(R||(u=g.isEqual(i,t)),u&&r==="copy")throw new Error((0,S.localize)(14,null,this.ob(i),this.ob(t)));if(!u&&g.isEqualOrParent(t,i))throw new Error((0,S.localize)(15,null,this.ob(i),this.ob(t)))}const l=await this.exists(t);if(l&&!u){if(!o)throw new E.FileOperationError((0,S.localize)(16,null,this.ob(i),this.ob(t)),4);if(s===n){const{providerExtUri:g}=this.N(s);if(g.isEqualOrParent(i,t))throw new Error((0,S.localize)(17,null,this.ob(i),this.ob(t)))}}return{exists:l,isSameResourceWithDifferentPathCase:u}}N(s){const i=this.O(s);return{providerExtUri:i?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:i}}O(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.mb(await this.j(s),s);await this.P(i,s);const n=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,0,n)),n}async P(s,i){const n=[],{providerExtUri:t}=this.N(s);for(;!t.isEqual(i,t.dirname(i));)try{if(((await s.stat(i)).type&E.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.ob(i)));break}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(i)),i=t.dirname(i)}for(let r=n.length-1;r>=0;r--){i=t.joinPath(i,n[r]);try{await s.mkdir(i)}catch(o){if((0,E.toFileSystemProviderErrorCode)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,i){try{await this.Q(s,i)}catch(n){return n}return!0}async Q(s,i){const n=this.mb(await this.j(s),s);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,S.localize)(19,null,this.ob(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.nb(s,r);else throw new E.FileOperationError((0,S.localize)(20,null,this.ob(s)),1);if(!!!i?.recursive){const u=await this.resolve(s);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,S.localize)(21,null,this.ob(s)))}return n}async del(s,i){const n=await this.Q(s,i),t=!!i?.useTrash,r=!!i?.recursive;await n.delete(s,{recursive:r,useTrash:t}),this.m.fire(new E.FileOperationEvent(s,1))}async cloneFile(s,i){const n=await this.j(s),t=this.mb(await this.l(i),i);if(n===t&&this.N(n).providerExtUri.isEqual(s,i))return;if(n===t&&(0,E.hasFileCloneCapability)(n))return n.cloneFile(s,i);await this.P(t,this.N(t).providerExtUri.dirname(i));const r=this.X.queueFor(s,this.N(n).providerExtUri);return n===t&&(0,E.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,i,{overwrite:!0})):r.queue(()=>this.J(n,s,t,i))}watch(s,i={recursive:!1,excludes:[]}){const n=new c.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,c.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(s,i);t?(0,c.dispose)(o):r=()=>(0,c.dispose)(o)}catch(o){this.b.error(o)}})(),n}async W(s,i){const n=await this.j(s),t=(0,I.hash)([this.N(n).providerExtUri.getComparisonKey(s),i]);let r=this.U.get(t);return r||(r={count:0,disposable:n.watch(s,i)},this.U.set(t,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.U.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.U)(0,c.dispose)(s.disposable);this.U.clear()}async Y(s,i,n,t){return this.X.queueFor(i,this.N(s).providerExtUri).queue(async()=>{const r=await s.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,y.isReadableStream)(t)||(0,y.isReadableBufferedStream)(t)?await this.ab(s,r,t):await this.bb(s,r,t)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async ab(s,i,n){let t=0,r;if((0,y.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=k.VSBuffer.concat(n.buffer);await this.cb(s,i,o,o.byteLength,t,0),t+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,u)=>{(0,y.listenStream)(r,{onData:async l=>{r.pause();try{await this.cb(s,i,l,l.byteLength,t,0)}catch(g){return u(g)}t+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>u(l),onEnd:()=>o()})})}async bb(s,i,n){let t=0,r;for(;(r=n.read())!==null;)await this.cb(s,i,r,r.byteLength,t,0),t+=r.byteLength}async cb(s,i,n,t,r,o){let u=0;for(;u<t;)u+=await s.write(i,r+u,n.buffer,o+u,t-u)}async db(s,i,n,t){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.eb(s,i,n,t))}async eb(s,i,n,t){let r;t instanceof k.VSBuffer?r=t:(0,y.isReadableStream)(t)?r=await(0,k.streamToBuffer)(t):(0,y.isReadableBufferedStream)(t)?r=await(0,k.bufferedStreamToBuffer)(t):r=(0,k.readableToBuffer)(t),await s.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async fb(s,i,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.gb(s,i,n,t))}async gb(s,i,n,t){let r,o;try{r=await s.open(i,{create:!1}),o=await n.open(t,{create:!0,unlock:!1});const u=k.VSBuffer.alloc(this.a);let l=0,g=0,R=0;do R=await s.read(r,l,u.buffer,g,u.byteLength-g),await this.cb(n,o,u,R,l,g),l+=R,g+=R,g===u.byteLength&&(g=0);while(R>0)}catch(u){throw(0,E.ensureFileSystemProviderError)(u)}finally{await O.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async hb(s,i,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.ib(s,i,n,t))}async ib(s,i,n,t){return n.writeFile(t,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async jb(s,i,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.kb(s,i,n,t))}async kb(s,i,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(i);await this.cb(n,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async lb(s,i,n,t){const r=await(0,k.streamToBuffer)(this.C(s,i,L.CancellationToken.None));await this.db(n,t,void 0,r)}mb(s,i){if(s.capabilities&2048)throw new E.FileOperationError((0,S.localize)(22,null,this.ob(i)),6);return s}nb(s,i){if((i.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,S.localize)(23,null,this.ob(s)),6)}ob(s){return s.scheme===w.Schemas.file?s.fsPath:s.toString(!0)}};v=fe([_(0,d.ILogService)],v),e.FileService=v}),define(Y[115],Z([0,1,116,155,3,34,15,4,156,2,14,12,17,43,20,92,13,59,111,32,109,108]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y,S,E,a,d,v,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(T)}catch(n){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(n)}`)}})();class i extends d.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=I.Event.None,this.I=new L.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.M=new Map,this.N=new Map,this.O=new Map}get capabilities(){return this.G||(this.G=57374,w.isLinux&&(this.G|=1024)),this.G}async stat(t){try{const{stat:r,symbolicLink:o}=await y.SymlinkSupport.stat(this.D(t));return{type:this.H(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.ab(r)}}async readdir(t){try{const r=await y.Promises.readdir(this.D(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async u=>{try{let l;u.isSymbolicLink()?l=(await this.stat((0,p.joinPath)(t,u.name))).type:l=this.H(u),o.push([u.name,l])}catch(l){this.a.trace(l)}})),o}catch(r){throw this.ab(r)}}H(t,r){let o;return r?.dangling?o=E.FileType.Unknown:t.isFile()?o=E.FileType.File:t.isDirectory()?o=E.FileType.Directory:o=E.FileType.Unknown,r&&(o|=E.FileType.SymbolicLink),o}async J(t){const r=this.D(t);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.I.get(t);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const u=new k.Barrier;return this.I.set(t,u),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,c.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.I.get(t)===u&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.I.delete(t)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),u.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.D(t)})`),o=await this.J(t));const u=this.D(t);return await y.Promises.readFile(u)}catch(u){throw this.ab(u)}finally{o?.dispose()}}L(t){i.F&&this.a.trace(t)}readFileStream(t,r,o){const u=(0,P.newWriteableStream)(l=>N.VSBuffer.concat(l.map(g=>N.VSBuffer.wrap(g))).buffer);return(0,a.readFileIntoStream)(this,t,u,l=>l.buffer,{...r,bufferSize:256*1024},o),u}async writeFile(t,r,o){let u;try{const l=this.D(t);if(!o.create||!o.overwrite){if(await y.Promises.exists(l)){if(!o.overwrite)throw(0,E.createFileSystemProviderError)((0,S.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,E.createFileSystemProviderError)((0,S.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(u,0,r,0,r.byteLength)}catch(l){throw await this.bb(t,l)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(t){i.P=t}async open(t,r){const o=this.D(t);let u;(0,E.isFileOpenForWriteOptions)(r)&&(u=await this.J(t));let l;try{if((0,E.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:R}=await y.SymlinkSupport.stat(o);R.mode&128||await y.Promises.chmod(o,R.mode|128)}catch(R){this.a.trace(R)}let g;if((0,E.isFileOpenForWriteOptions)(r)){if(w.isWindows)try{await y.Promises.truncate(o,0),g="r+"}catch(R){R.code!=="ENOENT"&&this.a.trace(R)}g||(g="w")}else g="r";l=await y.Promises.open(o,g)}catch(g){throw u?.dispose(),(0,E.isFileOpenForWriteOptions)(r)?await this.bb(t,g):this.ab(g)}if(this.M.set(l,0),(0,E.isFileOpenForWriteOptions)(r)&&this.O.set(l,t),u){const g=this.N.get(l);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${o})`),this.N.set(l,u),g&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${o})`),g.dispose())}return l}async close(t){const r=this.N.get(t);try{if(this.M.delete(t),this.O.delete(t)&&i.P)try{await y.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.a.error(o)}return await y.Promises.close(t)}catch(o){throw this.ab(o)}finally{r&&(this.N.get(t)===r&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.N.delete(t)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,u,l){const g=this.Q(t,r);let R=null;try{R=(await y.Promises.read(t,o,u,l,g)).bytesRead}catch(C){throw this.ab(C)}finally{this.R(t,g,R)}return R}Q(t,r){return r===this.M.get(t)?null:r}R(t,r,o){const u=this.M.get(t);typeof u=="number"&&(typeof r=="number"||(typeof o=="number"?this.M.set(t,u+o):this.M.delete(t)))}async write(t,r,o,u,l){return(0,k.retry)(()=>this.S(t,r,o,u,l),100,3)}async S(t,r,o,u,l){const g=this.Q(t,r);let R=null;try{R=(await y.Promises.write(t,o,u,l,g)).bytesWritten}catch(C){throw await this.bb(this.O.get(t),C)}finally{this.R(t,g,R)}return R}async mkdir(t){try{await y.Promises.mkdir(this.D(t))}catch(r){throw this.ab(r)}}async delete(t,r){try{const o=this.D(t);r.recursive?await y.Promises.rm(o,y.RimRafMode.MOVE):await y.Promises.unlink(o)}catch(o){throw this.ab(o)}}async rename(t,r,o){const u=this.D(t),l=this.D(r);if(u!==l)try{await this.U(t,r,"move",o.overwrite),await y.Promises.move(u,l)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,S.localize)(2,null,(0,m.basename)(u),(0,m.basename)((0,m.dirname)(l)),g.toString()))),this.ab(g)}}async copy(t,r,o){const u=this.D(t),l=this.D(r);if(u!==l)try{await this.U(t,r,"copy",o.overwrite),await y.Promises.copy(u,l,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,S.localize)(3,null,(0,m.basename)(u),(0,m.basename)((0,m.dirname)(l)),g.toString()))),this.ab(g)}}async U(t,r,o,u){const l=this.D(t),g=this.D(r);let R=!1;if(!!(this.capabilities&1024)||(R=(0,h.isEqual)(l,g,!0)),R&&o==="copy")throw(0,E.createFileSystemProviderError)((0,S.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!R&&await y.Promises.exists(g)){if(!u)throw(0,E.createFileSystemProviderError)((0,S.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.W(t,r,!1)}async W(t,r,o){const u=this.D(t),l=this.D(r),g=!!(this.capabilities&1024);if((0,h.isEqual)(u,l,!g))return;const R=new c.DisposableStore;try{const[C,q]=await Promise.all([this.J(t),this.J(r)]);R.add(C),R.add(q),o&&await y.Promises.mkdir((0,m.dirname)(l),{recursive:!0}),await y.Promises.copyFile(u,l)}catch(C){if(C.code==="ENOENT"&&!o)return this.W(t,r,!0);throw this.ab(C)}finally{R.dispose()}}p(t,r,o){return new f.UniversalWatcherClient(u=>t(u),u=>r(u),o)}y(t,r,o){return new s.NodeJSWatcherClient(u=>t(u),u=>r(u),o)}ab(t){if(t instanceof E.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=E.FileSystemProviderErrorCode.NoPermissions;break;default:r=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(t,r)}async bb(t,r){let o=this.ab(r);if(t&&o.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await y.SymlinkSupport.stat(this.D(t));u.mode&128||(o=(0,E.createFileSystemProviderError)(r,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return o}}e.DiskFileSystemProvider=i,i.F=!1,i.P=!0}),define(Y[117],Z([0,1,13,9]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(k||(k={}));async function L(c,m,w,p,P){try{const y=await new Promise((E,a)=>{$(["spdlog"],E,a)});y.setFlushOn(O.LogLevel.Trace);const S=await y.createAsyncRotatingLogger(c,m,w,p);return P?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(y){console.error(y)}return null}function N(c,m,w){switch(m){case O.LogLevel.Trace:c.trace(w);break;case O.LogLevel.Debug:c.debug(w);break;case O.LogLevel.Info:c.info(w);break;case O.LogLevel.Warning:c.warn(w);break;case O.LogLevel.Error:c.error(w);break;default:throw new Error(`Invalid log level ${m}`)}}function I(c,m){switch(m){case O.LogLevel.Trace:c.setLevel(k.Trace);break;case O.LogLevel.Debug:c.setLevel(k.Debug);break;case O.LogLevel.Info:c.setLevel(k.Info);break;case O.LogLevel.Warning:c.setLevel(k.Warning);break;case O.LogLevel.Error:c.setLevel(k.Error);break;case O.LogLevel.Off:c.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class h extends O.AbstractMessageLogger{constructor(m,w,p,P,y){super(),this.j=[],this.setLevel(y),this.k=this.m(m,w,p,P),this.B(this.onDidChangeLogLevel(S=>{this.l&&I(this.l,S)}))}async m(m,w,p,P){const y=p?6:1,S=30/y*T.ByteSize.MB,E=await L(m,w,S,y,P);if(E){this.l=E,I(this.l,this.getLevel());for(const{level:a,message:d}of this.j)N(this.l,a,d);this.j=[]}}f(m,w){this.l?N(this.l,m,w):this.getLevel()<=m&&this.j.push({level:m,message:w})}flush(){this.l?this.l.flush():this.k.then(()=>this.flush())}dispose(){this.l?this.p():this.k.then(()=>this.p())}p(){this.l&&(this.l.drop(),this.l=void 0)}}e.SpdLogLogger=h}),define(Y[37],Z([0,1,4,63,2,7]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class N extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const m=Object.keys(this.f).length;return this.f={...c,...this.f},m!==Object.keys(this.f).length&&await this.i(c),O.Iterable.reduce(this.g.entries(),(w,[p,P])=>({...w,[p]:P}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(c,[m,w])=>({...c,[m]:{definition:w,value:this.g.get(m)}}),{})}}e.AbstractPolicyService=N;class I{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(Y[118],Z([0,1,3,4,63,8,13,9,37]),function($,e,T,O,k,L,N,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(w,p){const P=[];for(const y of k.Iterable.concat(w.keys(),p.keys()))w.get(y)!==p.get(y)&&P.push(y);return P}let m=class extends h.AbstractPolicyService{constructor(p,P,y){super(),this.j=p,this.k=P,this.l=y,this.c=this.B(new T.ThrottledDelayer(500));const S=O.Event.filter(P.onDidFilesChange,E=>E.affects(p));this.B(P.watch(p)),this.B(S(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const p=new Map;try{const P=await this.k.readFile(this.j),y=JSON.parse(P.value.toString());if(!(0,L.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(y))this.f[S]&&p.set(S,y[S])}catch(P){P.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",P)}return p}async p(){const p=await this.n(),P=c(this.g,p);this.g=p,P.length>0&&this.h.fire(P)}};m=fe([_(1,N.IFileService),_(2,I.ILogService)],m),e.FilePolicyService=m}),define(Y[30],Z([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Y[35],Z([0,1,68,8]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(N,I){T.ok(O.isString(N)),T.ok(O.isObject(I)),T.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,I)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new k}),define(Y[119],Z([0,1,4,35]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[k(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const N=new L;O.Registry.add(e.Extensions.JSONContribution,N)}),define(Y[40],Z([0,1,19,4,8,81,21,119,35]),function($,e,T,O,k,L,N,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=h.Registry.as(I.Extensions.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.Emitter,this.onDidSchemaChange=this.i.event,this.j=new O.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const t=this.k(i,n);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const n=this.l(i);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:i,remove:n}){const t=[];t.push(...this.l(n)),t.push(...this.k(i,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,T.distinct)(t)})}registerDefaultConfigurations(i){const n=[],t=[];for(const{overrides:r,source:o}of i)for(const u in r)if(n.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const l=this.a.get(u),g=l?.valuesSources??new Map;if(o)for(const X of Object.keys(r[u]))g.set(X,o);const R={...l?.value||{},...r[u]};this.a.set(u,{source:o,value:R,valuesSources:g});const C=(0,N.getLanguageTagSettingPlainKey)(u),q={type:"object",default:R,description:L.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:k.isString(o)?void 0:o,defaultValueSource:o};t.push(...S(u)),this.d[u]=q,this.b.properties[u]=q}else{this.a.set(u,{value:r[u],source:o});const l=this.d[u];l&&(this.s(u,l),this.o(u,l))}this.registerOverrideIdentifiers(t),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:t,source:r}of i)for(const o in t){const u=this.a.get(o),l=k.isString(r)?r:r?.id,g=k.isString(u?.source)?u?.source:u?.source?.id;if(l===g)if(n.push(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const R=this.d[o];R&&(this.s(o,R),this.o(o,R))}}this.q(),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const n of i)this.h.add(n);this.q()}k(i,n){const t=[];return i.forEach(r=>{t.push(...this.m(r,n,r.extensionInfo,r.restrictedProperties)),this.c.push(r),this.n(r)}),t}l(i){const n=[],t=r=>{if(r.properties)for(const o in r.properties){n.push(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.p(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of i){t(r);const o=this.c.indexOf(r);o!==-1&&this.c.splice(o,1)}return n}m(i,n=!0,t,r,o=3){o=k.isUndefinedOrNull(i.scope)?o:i.scope;const u=[],l=i.properties;if(l)for(const R in l){const C=l[R];if(n&&v(R,C)){delete l[R];continue}if(C.source=t,C.defaultDefaultValue=l[R].default,this.s(R,C),e.OVERRIDE_PROPERTY_REGEX.test(R)?C.scope=void 0:(C.scope=k.isUndefinedOrNull(C.scope)?o:C.scope,C.restricted=k.isUndefinedOrNull(C.restricted)?!!r?.includes(R):C.restricted),l[R].hasOwnProperty("included")&&!l[R].included){this.f[R]=l[R],delete l[R];continue}else this.d[R]=l[R],l[R].policy?.name&&this.e.set(l[R].policy.name,R);!l[R].deprecationMessage&&l[R].markdownDeprecationMessage&&(l[R].deprecationMessage=l[R].markdownDeprecationMessage),u.push(R)}const g=i.allOf;if(g)for(const R of g)u.push(...this.m(R,n,t,r,o));return u}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const n=t=>{const r=t.properties;if(r)for(const u in r)this.o(u,r[u]);t.allOf?.forEach(n)};n(i)}o(i,n){switch(e.allSettings.properties[i]=n,n.scope){case 1:e.applicationSettings.properties[i]=n;break;case 2:e.machineSettings.properties[i]=n;break;case 6:e.machineOverridableSettings.properties[i]=n;break;case 3:e.windowSettings.properties[i]=n;break;case 4:e.resourceSettings.properties[i]=n;break;case 5:e.resourceSettings.properties[i]=n,this.g.properties[i]=n;break}}p(i,n){switch(delete e.allSettings.properties[i],n.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const n=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(n,t),e.allSettings.properties[n]=t,e.applicationSettings.properties[n]=t,e.machineSettings.properties[n]=t,e.machineOverridableSettings.properties[n]=t,e.windowSettings.properties[n]=t,e.resourceSettings.properties[n]=t}this.i.fire()}r(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,n){const t=this.a.get(i);let r=t?.value,o=t?.source;k.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),k.isUndefined(r)&&(r=a(n.type)),n.default=r,n.defaultValueSource=o}}const P="\\[([^\\]]+)\\]",y=new RegExp(P,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${P})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(s){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=y.exec(s);for(;n?.length;){const t=n[1].trim();t&&i.push(t),n=y.exec(s)}}return(0,T.distinct)(i)}e.overrideIdentifiersFromKey=S;function E(s){return s.reduce((i,n)=>`${i}[${n}]`,"")}e.keyFromOverrideIdentifiers=E;function a(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const d=new p;h.Registry.add(e.Extensions.Configuration,d);function v(s,i){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?L.localize(7,null,s):d.getConfigurationProperties()[s]!==void 0?L.localize(8,null,s):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,s,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.validateProperty=v;function f(){const s=[],i=d.getConfigurationProperties();for(const n of Object.keys(i))s.push([n,i[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=f}),define(Y[64],Z([0,1,19,4,50,2,34,28,8,10,21,40,35]),function($,e,T,O,k,L,N,I,h,c,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class P{constructor(n={},t=[],r=[],o){this.c=n,this.d=t,this.f=r,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof P)return t;const r=new y("");return r.parseRaw(t),r.configurationModel});this.g=n.reduce((t,r)=>r===t?r:t.merge(r),n[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(n){return n?(0,m.getConfigurationValue)(this.contents,n):this.contents}inspect(n,t){const r=this.rawConfiguration.getValue(n),o=t?this.rawConfiguration.getOverrideValue(n,t):void 0,u=t?this.rawConfiguration.override(t).getValue(n):r;return{value:r,override:o,merged:u}}getOverrideValue(n,t){const r=this.l(t);return r?n?(0,m.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return T.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return T.distinct(n)}override(n){let t=this.b.get(n);return t||(t=this.h(n),this.b.set(n,t)),t}merge(...n){const t=I.deepClone(this.contents),r=I.deepClone(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const l of n)if(u.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.j(t,l.contents);for(const g of l.overrides){const[R]=r.filter(C=>T.equals(C.identifiers,g.identifiers));R?(this.j(R.contents,g.contents),R.keys.push(...g.keys),R.keys=T.distinct(R.keys)):r.push(I.deepClone(g))}for(const g of l.keys)o.indexOf(g)===-1&&o.push(g)}return new P(t,o,r,u.every(l=>l instanceof P)?void 0:u)}freeze(){return this.a=!0,this}clone(){return new P(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}h(n){const t=this.l(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[o];const l=t[o];l&&(typeof u=="object"&&typeof l=="object"?(u=I.deepClone(u),this.j(u,l)):u=l),r[o]=u}return new P(r,this.keys,this.overrides)}j(n,t){for(const r of Object.keys(t)){if(r in n&&h.isObject(n[r])&&h.isObject(t[r])){this.j(n[r],t[r]);continue}n[r]=I.deepClone(t[r])}}k(n){return this.a&&!Object.isFrozen(n)?I.deepFreeze(n):n}l(n){let t=null,r=null;const o=u=>{u&&(r?this.j(r,u):r=I.deepClone(u))};for(const u of this.overrides)T.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&o(u.contents);return o(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.m(n),(0,m.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.n(n)&&(0,m.removeFromValueTree)(this.contents,n)}m(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}n(n){const t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=P;class y{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new P}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,t){if(!h.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,t)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,t){this.a=n;const{contents:r,keys:o,overrides:u,restricted:l,hasExcludedProperties:g}=this.h(n,t);this.b=new P(r,o,u,g?[n]:void 0),this.c=l||[]}g(n){let t={},r=null,o=[];const u=[],l=[];function g(C){Array.isArray(o)?o.push(C):r!==null&&(o[r]=C)}const R={onObjectBegin:()=>{const C={};g(C),u.push(o),o=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const C=[];g(C),u.push(o),o=C,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:g,onError:(C,q,X)=>{l.push({error:C,offset:q,length:X})}};if(n)try{k.visit(n,R),t=o[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return t}h(n,t){const r=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.j(n,r,!0,t);n=o.raw;const u=(0,m.toValuesTree)(n,R=>console.error(`Conflict in settings file ${this.f}: ${R}`)),l=Object.keys(n),g=this.l(n,R=>console.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:u,keys:l,overrides:g,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,t,r,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:u};const l={},g=[];for(const R in n)if(w.OVERRIDE_PROPERTY_REGEX.test(R)&&r){const C=this.j(n[R],t,!1,o);l[R]=C.raw,u=u||C.hasExcludedProperties,g.push(...C.restricted)}else{const C=t[R],q=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&g.push(R),(q===void 0||o.scopes===void 0||o.scopes.includes(q))&&!(o.skipRestricted&&C?.restricted)?l[R]=n[R]:u=!0}return{raw:l,restricted:g,hasExcludedProperties:u}}l(n,t){const r=[];for(const o of Object.keys(n))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const l in n[o])u[l]=n[o][l];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,m.toValuesTree)(u,t)})}return r}}e.ConfigurationModelParser=y;class S extends L.Disposable{constructor(n,t,r,o){super(),this.f=n,this.g=t,this.h=o,this.c=this.B(new O.Emitter),this.onDidChange=this.c.event,this.a=new y(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(O.Event.any(O.Event.filter(this.h.onDidFilesChange,u=>u.contains(this.f)),O.Event.filter(this.h.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&r.isEqual(u.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new P}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=S;class E{constructor(n,t,r,o,u,l,g,R,C,q,X,J,ie){this.a=n,this.b=t,this.value=r,this.overrideIdentifiers=o,this.c=u,this.d=l,this.f=g,this.g=R,this.h=C,this.j=q,this.k=X,this.l=J,this.m=ie}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get A(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class a{constructor(n,t,r,o,u=new P,l=new P,g=new N.ResourceMap,R=new P,C=new N.ResourceMap,q=!0){this.c=n,this.d=t,this.f=r,this.g=o,this.h=u,this.j=l,this.l=g,this.m=R,this.n=C,this.p=q,this.a=null,this.b=new N.ResourceMap,this.q=null}getValue(n,t,r){return this.s(n,t,r).getValue(n)}updateValue(n,t,r={}){let o;r.resource?(o=this.n.get(r.resource),o||(o=new P,this.n.set(r.resource,o))):o=this.m,t===void 0?o.removeValue(n):o.setValue(n,t),r.resource||(this.a=null)}inspect(n,t,r){const o=this.s(n,t,r),u=T.distinct(o.overrides.map(R=>R.identifiers).flat()).filter(R=>o.getOverrideValue(n,R)!==void 0),l=this.w(t.resource,r),g=t.resource?this.n.get(t.resource)||this.m:this.m;return new E(n,t,o.getValue(n),u.length?u:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this.j.freeze():void 0,l?l.freeze():void 0,g.inspect(n,t.overrideIdentifier))}keys(n){const t=this.w(void 0,n);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.j=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,t){this.l.set(n,t),this.b.delete(n)}deleteFolderConfiguration(n){this.r.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:o,updated:u,removed:l}=f(this.c,n);t=[...o,...u,...l]}for(const o of t)for(const u of(0,w.overrideIdentifiersFromKey)(o)){const l=this.c.getKeysForOverrideIdentifier(u),g=n.getKeysForOverrideIdentifier(u),R=[...g.filter(C=>l.indexOf(C)===-1),...l.filter(C=>g.indexOf(C)===-1),...l.filter(C=>!I.equals(this.c.override(u).getValue(C),n.override(u).getValue(C)))];r.push([u,R])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:r,removed:o}=f(this.d,n),u=[...t,...r,...o];return u.length&&this.updatePolicyConfiguration(n),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.applicationConfiguration,n),l=[...t,...r,...o];return l.length&&this.updateApplicationConfiguration(n),{keys:l,overrides:u}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.localUserConfiguration,n),l=[...t,...r,...o];return l.length&&this.updateLocalUserConfiguration(n),{keys:l,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.remoteUserConfiguration,n),l=[...t,...r,...o];return l.length&&this.updateRemoteUserConfiguration(n),{keys:l,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.workspaceConfiguration,n),l=[...t,...r,...o];return l.length&&this.updateWorkspaceConfiguration(n),{keys:l,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const r=this.r.get(n),{added:o,updated:u,removed:l,overrides:g}=f(r,t),R=[...o,...u,...l];return(R.length||!r)&&this.updateFolderConfiguration(n,t),{keys:R,overrides:g}}compareAndDeleteFolderConfiguration(n){const t=this.r.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:u,overrides:l}=f(t,void 0);return{keys:[...r,...o,...u],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(n,t,r){let o=this.t(t,r);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(o=o.merge(this.d)),o}t({resource:n},t){let r=this.u();if(t&&n){const o=t.getFolder(n);o&&(r=this.v(o.uri)||r);const u=this.n.get(n);u&&(r=r.merge(u))}return r}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(n){let t=this.b.get(n);if(!t){const r=this.u(),o=this.l.get(n);o?(t=r.merge(o),this.p&&(t=t.freeze()),this.b.set(n,t)):t=r}return t}w(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this.l.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((n,t)=>{const{contents:r,overrides:o,keys:u}=this.l.get(t);return n.push([t,{contents:r,overrides:o,keys:u}]),n},[])}}allKeys(){const n=new Set;return this.c.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this.j.freeze().keys.forEach(t=>n.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}x(){const n=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}y(n){const t=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.j.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.l.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.A(n.defaults),r=this.A(n.policy),o=this.A(n.application),u=this.A(n.user),l=this.A(n.workspace),g=n.folders.reduce((R,C)=>(R.set(c.URI.revive(C[0]),this.A(C[1])),R),new N.ResourceMap);return new a(t,r,o,u,new P,l,g,new P,new N.ResourceMap,!1)}static A(n){return new P(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=a;function d(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,t=new Map;for(const o of i)o.keys.forEach(u=>n.add(u)),o.overrides.forEach(([u,l])=>{const g=(0,N.getOrSet)(t,u,new Set);l.forEach(R=>g.add(R))});const r=[];return t.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=d;class v{constructor(n,t,r,o){this.change=n,this.b=t,this.c=r,this.d=o,this.f=void 0;const u=new Set;n.keys.forEach(g=>u.add(g)),n.overrides.forEach(([,g])=>g.forEach(R=>u.add(R))),this.affectedKeys=[...u.values()];const l=new P;this.affectedKeys.forEach(g=>l.setValue(g,{})),this.a=l.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=a.parse(this.b.data)),this.f}affectsConfiguration(n,t){if(this.g(this.a,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.b?.workspace):void 0,o=this.c.getValue(n,t,this.d);return!I.equals(r,o)}return!0}return!1}g(n,t){let r=(0,m.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=v;function f(i,n){const{added:t,removed:r,updated:o}=s(n?.rawConfiguration,i?.rawConfiguration),u=[],l=i?.getAllOverrideIdentifiers()||[],g=n?.getAllOverrideIdentifiers()||[];if(n){const R=g.filter(C=>!l.includes(C));for(const C of R)u.push([C,n.getKeysForOverrideIdentifier(C)])}if(i){const R=l.filter(C=>!g.includes(C));for(const C of R)u.push([C,i.getKeysForOverrideIdentifier(C)])}if(n&&i){for(const R of l)if(g.includes(R)){const C=s({contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)},{contents:n.getOverrideValue(void 0,R)||{},keys:n.getKeysForOverrideIdentifier(R)});u.push([R,[...C.added,...C.removed,...C.updated]])}}return{added:t,removed:r,updated:o,overrides:u}}function s(i,n){const t=i?n?i.keys.filter(u=>n.keys.indexOf(u)===-1):[...i.keys]:[],r=n?i?n.keys.filter(u=>i.keys.indexOf(u)===-1):[...n.keys]:[],o=[];if(i&&n){for(const u of n.keys)if(i.keys.indexOf(u)!==-1){const l=(0,m.getConfigurationValue)(n.contents,u),g=(0,m.getConfigurationValue)(i.contents,u);I.equals(l,g)||o.push(u)}}return{added:t,removed:r,updated:o}}}),define(Y[120],Z([0,1,19,4,2,28,8,21,64,40,9,37,35]),function($,e,T,O,k,L,N,I,h,c,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class P extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new y(this.f())),this.b}async initialize(){return this.b=void 0,this.B(p.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:v})=>this.c(d,v))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(d,v){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}}e.DefaultConfiguration=P;class y extends h.ConfigurationModel{constructor(d={}){const v=p.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(v),s=Object.create(null),i=[];for(const n in v){const t=d[n],r=t!==void 0?t:v[n].default;(0,I.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))c.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,c.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,I.toValuesTree)(s[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,f,i)}}e.DefaultConfigurationModel=y;class S{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new h.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let E=class extends k.Disposable{get configurationModel(){return this.b}constructor(d,v,f){super(),this.c=d,this.f=v,this.g=f,this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new h.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.i(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.j(await this.h(d),!0))),this.b}async h(d){const v={},f=[],s=p.Registry.as(c.Extensions.Configuration).getConfigurationProperties();for(const i of d){const n=s[i];if(!n){f.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.g.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(i),v[n.policy.name]={type:n.type}}}return(0,N.isEmptyObject)(v)||await this.f.updatePolicyDefinitions(v),f}i(d){const v=p.Registry.as(c.Extensions.Configuration).getPolicyConfigurations(),f=(0,T.coalesce)(d.map(s=>v.get(s)));this.j(f,!0)}j(d,v){const f=p.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),s=[],i=this.b.isEmpty();for(const n of d){const t=f[n]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(i?r!==void 0:!(0,L.equals)(this.b.getValue(n),r))&&s.push([n,r])}else this.b.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this.b;this.b=new h.ConfigurationModel;for(const t of n.keys)this.b.setValue(t,n.getValue(t));for(const[t,r]of s)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);v&&this.a.fire(this.b)}}};E=fe([_(1,w.IPolicyService),_(2,m.ILogService)],E),e.PolicyConfiguration=E}),define(Y[121],Z([0,1,3,4,2,17,21,64,120,37]),function($,e,T,O,k,L,N,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class m extends k.Disposable{constructor(p,P,y,S){super(),this.i=p,this.h=this.B(new O.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.DefaultConfiguration),this.c=y instanceof c.NullPolicyService?new h.NullPolicyConfiguration:this.B(new h.PolicyConfiguration(this.b,y,S)),this.f=this.B(new I.UserSettings(this.i,void 0,L.extUriBiasedIgnorePathCase,P)),this.a=new I.Configuration(this.b.configurationModel,this.c.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:E,properties:a})=>this.k(E,a))),this.B(this.c.onDidChangeConfiguration(E=>this.l(E))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,P,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.Configuration(p,P,new I.ConfigurationModel,y)}getConfigurationData(){return this.a.toData()}getValue(p,P){const y=typeof p=="string"?p:void 0,S=(0,N.isConfigurationOverrides)(p)?p:(0,N.isConfigurationOverrides)(P)?P:{};return this.a.getValue(y,S,void 0)}updateValue(p,P,y,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const P=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(y,P,2)}k(p,P){const y=this.a.toData(),S=this.a.compareAndUpdateDefaultConfiguration(p,P);this.m(S,y,7)}l(p){const P=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(p);this.m(y,P,7)}m(p,P,y){const S=new I.ConfigurationChangeEvent(p,{data:P},this.a);S.source=y,S.sourceConfig=this.n(y),this.h.fire(S)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=m}),define(Y[122],Z([0,1,16]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(c){return c.scheme===T.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=O;function k(c){if(!c)return;const m=c.indexOf("+");return m<0?c:c.substr(0,m)}e.getRemoteName=k;function L(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=L;function N(c){const{host:m,port:w}=h(c);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:w}}e.parseAuthorityWithPort=N;function I(c,m){let{host:w,port:p}=h(c);return typeof p>"u"&&(p=m),{host:w,port:p}}e.parseAuthorityWithOptionalPort=I;function h(c){const m=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const w=c.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const p=c.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:c,port:void 0}}}),define(Y[26],Z([0,1,29,7,122]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=L;function N(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var h;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(h=e.TargetPlatform||(e.TargetPlatform={}));class c{constructor(S){this.value=S,this.c=S.toLowerCase()}static equals(S,E){if(typeof S>"u"||S===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof S=="string"||typeof E=="string"){const a=typeof S=="string"?S:S.value,d=typeof E=="string"?E:E.value;return T.equalsIgnoreCase(a,d)}return S.c===E.c}static toKey(S){return typeof S=="string"?S.toLowerCase():S.c}}e.ExtensionIdentifier=c;function m(y){return w(y)}e.isApplicationScopedExtension=m;function w(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function p(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function P(y,S){if(S){const E=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return y.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[24],Z([0,1,29,23,26,12,10,11,33]),function($,e,T,O,k,L,N,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function c(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,T.compareIgnoreCase)(n.id,t.id)===0}e.areSameExtensions=c;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,r,o)}static parse(t){const r=m.exec(t);return r&&r[1]&&r[2]?new w({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?c(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=w;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function P(n){const t=p.exec(n);return t&&t[1]?[S(t[1]),t[2]]:[S(n),void 0]}e.getIdAndVersion=P;function y(n,t){return`${n}.${t}`}e.getExtensionId=y;function S(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function E(n,t){return S(y(n,t))}e.getGalleryExtensionId=E;function a(n,t){const r=[],o=u=>{for(const l of r)if(l.some(g=>c(t(g),t(u))))return l;return null};for(const u of n){const l=o(u);l?l.push(u):r.push([u])}return r}e.groupByExtension=a;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function v(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(n,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&r.every(l=>!c(l.identifier,{id:u}))){const l=n.filter(g=>c(g.identifier,{id:u}));l.length===1&&(r.push(l[0]),o.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function s(n,t){if(!L.isLinux)return!1;let r;try{r=(await n.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(u))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function i(n,t){const r=await s(n,t),o=(0,O.getTargetPlatform)(r?"alpine":L.platform,h.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(Y[123],Z([0,1,22,11,16,17,39,10,84,23,24,26]),function($,e,T,O,k,L,N,I,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const p=E=>(0,h.localize)(0,null,E),P=(0,h.localize)(1,null,"ms-dotnettools.csharp");function y(E,a){return a?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let S=class{constructor(a,d){this.a=a,this.b=d}get d(){}async listExtensions(a,d,v,f=console){let s=await this.a.getInstalled(1,v);const i=w.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(d&&d!==""){if(i.indexOf(d.toLowerCase())<0){f.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){f.log("Possible Categories: "),i.forEach(t=>{f.log(t)});return}this.d&&f.log((0,h.localize)(2,null,this.d)),s=s.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let n;for(const t of s)n!==t.identifier.id&&(n=t.identifier.id,f.log(y(t.manifest,a)))}async installExtensions(a,d,v,f,s=console){const i=[],n=[];a.length&&s.log(this.d?(0,h.localize)(3,null,this.d):(0,h.localize)(4,null));const t=await this.a.getInstalled(1,v.profileLocation),r=(g,R)=>{const C=t.find(q=>(0,m.areSameExtensions)(q.identifier,{id:g}));if(C){if(!f&&(!R||R==="prerelease"&&C.preRelease))return s.log((0,h.localize)(5,null,g,C.manifest.version,g)),!1;if(R&&C.manifest.version===R)return s.log((0,h.localize)(6,null,`${g}@${R}`)),!1}return!0},o=(g,R,C)=>{l.push({id:g,version:R!=="prerelease"?R:void 0,installOptions:{...v,isBuiltin:C,installPreReleaseVersion:R==="prerelease"||v.installPreReleaseVersion}})},u=[],l=[];for(const g of a)if(g instanceof I.URI)u.push(g);else{const[R,C]=(0,m.getIdAndVersion)(g);r(R,C)&&o(R,C,!1)}for(const g of d){const[R,C]=(0,m.getIdAndVersion)(g);r(R,C)&&o(R,C,!0)}if(u.length&&await Promise.all(u.map(async g=>{try{const R=await this.f(g,{...v,isBuiltin:!1},f,s);R&&n.push(R)}catch(R){s.error(R.message||R.stack||R),i.push(g.toString())}})),l.length){const g=await this.g(l);await Promise.all(l.map(async R=>{const C=g.get(R.id.toLowerCase());if(C)try{const q=await this.h(R,C,t,f,s);q&&n.push(q)}catch(q){s.error(q.message||q.stack||q),i.push(R.id)}else s.error(`${p(R.version?`${R.id}@${R.version}`:R.id)}
${P}`),i.push(R.id)}))}if(i.length)throw new Error((0,h.localize)(7,null,i.join(", ")))}async f(a,d,v,f){const s=await this.a.getManifest(a);if(!s)throw new Error("Invalid vsix");if(await this.k(s,v,d.profileLocation,f))try{return await this.a.install(a,d),f.log((0,h.localize)(8,null,(0,L.basename)(a))),s}catch(n){if((0,O.isCancellationError)(n))return f.log((0,h.localize)(9,null,(0,L.basename)(a))),null;throw n}return null}async g(a){const d=new Map,v=a.some(s=>s.installOptions.installPreReleaseVersion),f=await this.b.getExtensions(a.map(s=>({...s,preRelease:v})),T.CancellationToken.None);for(const s of f)d.set(s.identifier.id.toLowerCase(),s);return d}async h({id:a,version:d,installOptions:v},f,s,i,n){const t=await this.b.getManifest(f,T.CancellationToken.None);if(t&&!this.j(t,n))return null;const r=s.find(o=>(0,m.areSameExtensions)(o.identifier,f.identifier));if(r){if(f.version===r.manifest.version)return n.log((0,h.localize)(10,null,d?`${a}@${d}`:a)),null;n.log((0,h.localize)(11,null,a,f.version))}try{v.isBuiltin?n.log(d?(0,h.localize)(12,null,a,d):(0,h.localize)(13,null,a)):n.log(d?(0,h.localize)(14,null,a,d):(0,h.localize)(15,null,a));const o=await this.a.installFromGallery(f,{...v,installGivenVersion:!!d});return n.log((0,h.localize)(16,null,a,o.manifest.version)),t}catch(o){if((0,O.isCancellationError)(o))return n.log((0,h.localize)(17,null,a)),null;throw o}}j(a,d){return!0}async k(a,d,v,f){const s={id:(0,m.getGalleryExtensionId)(a.publisher,a.name)},n=(await this.a.getInstalled(1,v)).find(t=>(0,m.areSameExtensions)(s,t.identifier)&&(0,N.gt)(t.manifest.version,a.version));return n&&!d?(f.log((0,h.localize)(18,null,n.identifier.id,n.manifest.version,a.version)),!1):this.j(a,f)}async uninstallExtensions(a,d,v,f=console){const s=async n=>{if(n instanceof I.URI){const t=await this.a.getManifest(n);return y(t)}return n},i=[];for(const n of a){const t=await s(n),o=(await this.a.getInstalled(void 0,v)).filter(u=>(0,m.areSameExtensions)(u.identifier,{id:t}));if(!o.length)throw new Error(`${this.l(t)}
${P}`);if(o.some(u=>u.type===0)){f.log((0,h.localize)(19,null,t));return}if(!d&&o.some(u=>u.isBuiltin)){f.log((0,h.localize)(20,null,t));return}f.log((0,h.localize)(21,null,t));for(const u of o)await this.a.uninstall(u,{profileLocation:v}),i.push(u);this.d?f.log((0,h.localize)(22,null,t,this.d)):f.log((0,h.localize)(23,null,t))}}async locateExtension(a,d=console){const v=await this.a.getInstalled();a.forEach(f=>{v.forEach(s=>{if(s.identifier.id===f&&s.location.scheme===k.Schemas.file){d.log(s.location.fsPath);return}})})}l(a){return this.d?(0,h.localize)(24,null,a,this.d):(0,h.localize)(25,null,a)}};S=fe([_(0,c.IExtensionManagementService),_(1,c.IExtensionGalleryService)],S),e.ExtensionManagementCLI=S}),define(Y[124],Z([0,1,3,11,2,16,12,17,39,31,20,21,18,23,24,58,13,9]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y,S,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let d=class Ve extends k.Disposable{constructor(f,s,i,n,t,r){super(),this.h=s,this.i=i,this.j=n,this.k=t,this.l=r,this.extensionsDownloadDir=f.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(f,s){await this.g;const i=(0,I.joinPath)(this.extensionsDownloadDir,this.u(f));try{await this.n(f,i,t=>this.i.download(f,t,s))}catch(t){throw new P.ExtensionManagementError(t.message,P.ExtensionManagementErrorCode.Download)}let n=!1;if(f.isSigned&&this.j.getValue("extensions.verifySignature")===!0){const t=await this.m(f);try{n=await this.k.verify(i.fsPath,t.fsPath),this.l.info(`Verified extension: ${f.identifier.id}`,n)}catch(r){throw await this.delete(t),await this.delete(i),new P.ExtensionManagementError(r.code,P.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:n}}async m(f){await this.g;const s=(0,I.joinPath)(this.extensionsDownloadDir,`${this.u(f)}${Ve.c}`);return await this.n(f,s,i=>this.i.downloadSignatureArchive(f,i)),s}async n(f,s,i){if(await this.h.exists(s))return;if(s.scheme!==L.Schemas.file){await i(s);return}const n=(0,I.joinPath)(this.extensionsDownloadDir,`.${(0,c.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.r(n,s,Date.now()+2*60*1e3)}catch(t){try{await this.h.del(n)}catch{}if(t.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",f.identifier.id,s.path);else throw this.l.info(`Rename failed because of ${(0,O.getErrorMessage)(t)}. Deleted the file from downloaded location`,n.path),t}}async delete(f){await this.g,await this.h.del(f)}async r(f,s,i){try{await m.Promises.rename(f.fsPath,s.fsPath)}catch(n){if(N.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.l.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.r(f,s,i);throw n}}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const f=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],i=[],n=[];for(const o of f.children)if(o.name.endsWith(Ve.c))n.push(o.resource);else{const u=y.ExtensionKey.parse(o.name);u&&i.push([u,o])}const t=(0,y.groupByExtension)(i,([o])=>o),r=[];for(const o of t)o.sort((u,l)=>h.rcompare(u[0].version,l[0].version)),s.push(...o.slice(1).map(u=>u[1].resource)),r.push(o[0][1]);r.sort((o,u)=>o.mtime-u.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),s.push(...n),await T.Promises.settled(s.map(o=>(this.l.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(f){this.l.error(f)}}u(f){return this.f?y.ExtensionKey.create(f).toString().toLowerCase():(0,c.generateUuid)()}};d.c=".sigzip",d=fe([_(0,p.INativeEnvironmentService),_(1,E.IFileService),_(2,P.IExtensionGalleryService),_(3,w.IConfigurationService),_(4,S.IExtensionSignatureVerificationService),_(5,a.ILogService)],d),e.ExtensionsDownloader=d}),define(Y[125],Z([0,1,2,14,20,26]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends T.Disposable{constructor(h,c){super(),this.b=h,this.a=(0,O.join)(this.b.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this.B(c.onDidInstallExtensions(m=>this.c(m))),this.B(c.onDidUninstallExtension(m=>this.f(m)))}c(h){h.some(c=>!!c.local)&&this.invalidate()}f(h){h.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(Y[126],Z([0,1,4,2,34,24,26]),function($,e,T,O,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class I extends O.Disposable{constructor(c,m,w,p,P,y,S){super(),this.f=c,this.g=m,this.h=w,this.i=p,this.j=P,this.k=y,this.l=S,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.DisposableMap),this.m().then(null,E=>S.error(E))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.D()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c,m){try{await Promise.all(m.map(w=>(this.c.deleteAndDispose(w.id),this.C(w.extensionsResource))))}catch(w){this.l.error(w)}try{c.length&&await Promise.all(c.map(w=>(this.c.set(w.id,(0,O.combinedDisposable)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){this.l.error(w)}}async r(c){for(const m of c.extensions)this.F(this.H(m.identifier,m.version),c.profileLocation)}async s(c){for(const m of c.extensions){const w=this.H(m.identifier,m.version);c.error?this.G(w,c.profileLocation):this.F(w,c.profileLocation)}}async t(c){for(const m of c.extensions)this.G(this.H(m.identifier,m.version),c.profileLocation)}async u(c){let m=!1;for(const w of c.extensions){const p=this.H(w.identifier,w.version);c.error?this.F(p,c.profileLocation):(this.G(p,c.profileLocation),m=m||!this.b.has(p))}m&&await this.D()}v(c){for(const m of this.h.profiles)c.contains(m.extensionsResource,0,1)&&this.w(m.extensionsResource)}async w(c){const m=[],w=[],p=await this.i.scanProfileExtensions(c),P=new Set,y=new Set;for(const[S,E]of this.b)E.has(c)&&y.add(S);for(const S of p){const E=this.H(S.identifier,S.version);P.add(E),y.has(E)||(m.push(S.identifier),this.F(E,c))}for(const S of y)if(!P.has(S)){const E=this.I(S);E&&(w.push(E.identifier),this.G(S,c))}(m.length||w.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:c}:void 0,removed:w.length?{extensions:w,profileLocation:c}:void 0})}async y(c){const m=await this.i.scanProfileExtensions(c);for(const w of m)this.F(this.H(w.identifier,w.version),c)}async C(c){for(const m of[...this.b.keys()])this.G(m,c);await this.D()}async D(){const m=(await this.f.getAllUserInstalled()).filter(w=>!this.b.has(this.H(w.identifier,w.manifest.version)));m.length&&await this.f.markAsUninstalled(...m)}F(c,m){let w=this.b.get(c);w||this.b.set(c,w=new k.ResourceSet(p=>this.j.extUri.getComparisonKey(p))),w.add(m)}G(c,m){const w=this.b.get(c);w&&w.delete(m),w?.size||this.b.delete(c)}H(c,m){return`${N.ExtensionIdentifier.toKey(c.id)}@${m}`}I(c){const[m,w]=(0,L.getIdAndVersion)(c);return w?{identifier:{id:m},version:w}:void 0}}e.ExtensionsWatcher=I}),define(Y[127],Z([0,1,157,19,3,2,16,14,20,18,23,24,9,62,12,10]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends P.LanguagePackBaseService{constructor(f,s,i,n){super(i),this.h=f,this.i=n,this.g=this.B(new a(s,n)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(f){const i=(await this.g.getLanguagePacks())[y.Language.value()];if(!i){this.i.warn(`No language pack found for ${y.Language.value()}`);return}const n=i.translations[f];return n?S.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),s=Object.keys(f).map(i=>{const n=f[i];return{...this.f(i,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return s.push({...this.f("en","English"),extensionId:"default"}),s.sort((i,n)=>i.label.localeCompare(n.label)),s}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const s=await this.g.getLanguagePacks();Object.keys(s).some(i=>s[i]&&s[i].extensions.some(n=>(0,w.areSameExtensions)(n.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,s]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),i=await this.g.update(s);return!(0,O.equals)(Object.keys(f),Object.keys(i))}};E=fe([_(0,m.IExtensionManagementService),_(1,c.INativeEnvironmentService),_(2,m.IExtensionGalleryService),_(3,p.ILogService)],E),e.NativeLanguagePackService=E;let a=class extends L.Disposable{constructor(f,s){super(),this.i=s,this.c={},this.f=(0,I.join)(f.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(s=>{Object.keys(s).forEach(i=>delete s[i]),this.j(s,...f)}).then(()=>this.c)}j(f,...s){for(const i of s)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.k(f,i);Object.keys(f).forEach(i=>this.l(f[i]))}k(f,s){const i=s.identifier,n=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const t of n)if(s.location.scheme===N.Schemas.file&&d(t)){let r=f[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},f[t.languageId]=r);const o=r.extensions.filter(u=>(0,w.areSameExtensions)(u.extensionIdentifier,i))[0];o?o.version=s.manifest.version:r.extensions.push({extensionIdentifier:i,version:s.manifest.version});for(const u of t.translations)r.translations[u.id]=(0,I.join)(s.location.fsPath,u.path)}}l(f){if(f){const s=(0,T.createHash)("md5");for(const i of f.extensions)s.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);f.hash=s.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let s=null;return h.Promises.readFile(this.f,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(s=f(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.c=i,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),h.Promises.writeFile(this.f,n)}).then(()=>s,i=>this.i.error(i))})}};a=fe([_(0,c.INativeEnvironmentService),_(1,p.ILogService)],a);function d(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const f of v.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(Y[47],Z([0,1,15,94,40,7,35]),function($,e,T,O,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function I(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=I;function h(S){return S.res.statusCode===204}async function c(S){return h(S)?null:(await(0,T.streamToBuffer)(S.stream)).toString()}e.asText=c;async function m(S){if(!I(S))throw new Error("Server returned "+S.res.statusCode);return c(S)}e.asTextOrError=m;async function w(S){if(!I(S))throw new Error("Server returned "+S.res.statusCode);if(h(S))return null;const a=(await(0,T.streamToBuffer)(S.stream)).toString();try{return JSON.parse(a)}catch(d){throw d.message+=`:
`+a,d}}e.asJson=w;function p(S){y(S)}e.updateProxyConfigurationsScope=p;let P;function y(S){const E=N.Registry.as(k.Extensions.Configuration),a=P;P={id:"http",order:15,title:(0,O.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(4,null),(0,O.localize)(5,null),(0,O.localize)(6,null),(0,O.localize)(7,null)],default:"override",description:(0,O.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[P],remove:a?[a]:[]})}y(2)}),define(Y[128],Z([0,1,22,16,13,47]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(h,c){this.a=h,this.b=c}async download(h,c,m=T.CancellationToken.None){if(h.scheme===O.Schemas.file||h.scheme===O.Schemas.vscodeRemote){await this.b.copy(h,c);return}const w={type:"GET",url:h.toString(!0)},p=await this.a.request(w,m);if(p.res.statusCode===200)await this.b.writeFile(c,p.stream);else{const P=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${P}`)}}};N=fe([_(0,L.IRequestService),_(1,k.IFileService)],N),e.DownloadService=N}),define(Y[129],Z([0,1,130,8]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(N,I){return N.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:N.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function L(N,I,h={}){const c=(0,T.parse)(N),m=h.proxyUrl||k(c,I);if(!m)return null;const w=(0,T.parse)(m);if(!/^https?:$/.test(w.protocol||""))return null;const p={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,O.isBoolean)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((P,y)=>{$(["http-proxy-agent"],P,y)}))(p):new(await new Promise((P,y)=>{$(["https-proxy-agent"],P,y)}))(p)}e.getProxyAgent=L}),define(Y[131],Z([0,1,56,14,95,22,32,11,12,31,77,158,3]),function($,e,T,O,k,L,N,I,h,c,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const P=1e4;let y;async function S(a,d,v){return d["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(v)&&!d["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(v)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=p.Promises.withAsyncBody(async(f,s)=>{const i=new L.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),s(new Error((0,k.localize)(0,null)))},P);try{f(await E(a,i.token))}catch(t){!(0,I.isCancellationError)(t)&&!i.token.isCancellationRequested?s(new Error((0,k.localize)(1,null,(0,N.toErrorMessage)(t)))):f({})}finally{clearTimeout(n),i.dispose()}})),y)}e.getResolvedShellEnv=S;async function E(a,d){const v=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",v);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",f);const s=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",n);const t=await(0,m.getSystemShell)(h.OS,n);return a.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(d.isCancellationRequested)return o((0,I.canceled)());const u=(0,O.basename)(t);let l,g;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(l=`& '${process.execPath}' ${R} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,g=["-Login","-Command"]):(l=`'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,u==="tcsh"?g=["-ic"]:g=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),l);const C=(0,T.spawn)(t,[...g,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});d.onCancellationRequested(()=>(C.kill(),o((0,I.canceled)()))),C.on("error",J=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(J)),o(J)});const q=[];C.stdout.on("data",J=>q.push(J));const X=[];C.stderr.on("data",J=>X.push(J)),C.on("close",(J,ie)=>{const re=Buffer.concat(q).toString("utf8");a.trace("getUnixShellEnvironment#raw",re);const Q=Buffer.concat(X).toString("utf8");if(Q.trim()&&a.trace("getUnixShellEnvironment#stderr",Q),J||ie)return o(new Error((0,k.localize)(2,null,J,ie)));const he=i.exec(re),ce=he?he[1]:"{}";try{const se=JSON.parse(ce);v?se.ELECTRON_RUN_AS_NODE=v:delete se.ELECTRON_RUN_AS_NODE,f?se.ELECTRON_NO_ATTACH_CONSOLE=f:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",se),r(se)}catch(se){a.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(se)),o(se)}})})}}),define(Y[65],Z([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,T.createDecorator)("stateService")}),define(Y[132],Z([0,1,3,15,8,18,13,9]),function($,e,T,O,k,L,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(w,p,P){this.f=w,this.g=p,this.h=P,this.a=Object.create(null),this.b="",this.c=new T.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==1&&this.g.error(w)}}getItem(w,p){const P=this.a[w];return(0,k.isUndefinedOrNull)(P)?p:P}setItem(w,p){this.setItems([{key:w,data:p}])}setItems(w){let p=!1;for(const{key:P,data:y}of w)this.a[P]!==y&&((0,k.isUndefinedOrNull)(y)?(0,k.isUndefined)(this.a[P])||(this.a[P]=void 0,p=!0):(this.a[P]=y,p=!0));p&&this.j()}removeItem(w){(0,k.isUndefined)(this.a[w])||(this.a[w]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.h.writeFile(this.f,O.VSBuffer.fromString(w)),this.b=w}catch(p){this.g.error(p)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=h;let c=class{constructor(w,p,P){this.a=new h(w.stateResource,p,P)}async init(){await this.a.init()}getItem(w,p){return this.a.getItem(w,p)}};c=fe([_(0,L.IEnvironmentService),_(1,I.ILogService),_(2,N.IFileService)],c),e.StateService=c}),define(Y[66],Z([0,1,12,33,10,31]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(c){if(T.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function I(c,m,w,p,P,y,S,E,a,d){const v=Object.create(null);v["common.machineId"]=S,v.sessionID=(0,L.generateUuid)()+Date.now(),v.commitHash=P,v.version=y,v["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,T.PlatformToString)(T.platform),v["common.nodePlatform"]=O.platform,v["common.nodeArch"]=p,v["common.product"]=d||"desktop",E&&(v["common.msftInternal"]=E);let f=0;const s=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),T.isLinuxSnap&&(v["common.snap"]="true");const i=N(w);i&&(v["common.platformDetail"]=i);try{const n=await c.readFile(k.URI.file(a));v["common.source"]=n.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=I;function h(c){const m=O.env.USERDNSDOMAIN;if(!m)return!1;const w=m.toLowerCase();return c.some(p=>w===p)}e.verifyMicrosoftInternalDomain=h}),define(Y[36],Z([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(O=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Y[41],Z([0,1,28,8,21,66,36]),function($,e,T,O,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class I{constructor(o){this.value=o}}e.TrustedTelemetryValue=I;class h{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,u){return Promise.resolve(void 0)}publicLog2(o,u){return this.publicLog(o,u)}publicLogError(o,u){return Promise.resolve(void 0)}publicLogError2(o,u){return this.publicLogError(o,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class c{async publicLog(o,u,l){}async publicLogError(o,u,l){}}e.NullEndpointTelemetryService=c,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(r,o){return o.onDidChangeConfiguration(u=>{u.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(u.source),configurationKeys:d(u.sourceConfig)})})}e.configurationTelemetry=m;function w(r,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!r.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=w;function p(r,o){return!(o.isBuilt||o.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.isLoggingOnly=p;function P(r){const o=r.getValue(N.TELEMETRY_SETTING_ID),u=r.getValue("telemetry.enableCrashReporter");if(r.getValue(N.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function y(r){const o={},u={},l={};a(r,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const R=l[g];typeof R=="number"?u[g]=R:typeof R=="boolean"?u[g]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${R.length}`),o[g]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(o[g]=R)}return{properties:o,measurements:u}}e.validateTelemetryData=y;const S=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function E(r){if(!r)return"none";for(const o of S)if(r.startsWith(`${o}+`))return o;return"other"}e.cleanRemoteAuthority=E;function a(r,o,u=0,l){if(!!r)for(const g of Object.getOwnPropertyNames(r)){const R=r[g],C=l?l+g:g;Array.isArray(R)?o[C]=(0,T.safeStringify)(R):R instanceof Date?o[C]=R.toISOString():(0,O.isObject)(R)?u<2?a(R,o,u+1,C+"."):o[C]=(0,T.safeStringify)(R):o[C]=R}}function d(r){if(!r)return[];const o=[];return v(o,"",r),o}function v(r,o,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(l=>v(r,o?`${o}.${l}`:l,u[l])):r.push(o)}function f(r,o){const u=r.msftInternalDomains||[],l=o.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(u)||l}e.isInternalTelemetry=f;function s(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(r,o){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let u=r;const l=[];for(const q of o)for(;;){const X=q.exec(r);if(!X)break;l.push([X.index,q.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(u="";;){const q=R.exec(r);if(!q)break;const X=l.some(([J,ie])=>q.index<ie&&J<R.lastIndex);!g.test(q[0])&&!X&&(u+=r.substring(C,q.index)+"<REDACTED: user-file-path>",C=R.lastIndex)}return C<r.length&&(u+=r.substr(C)),u}function n(r){if(!r)return r;const o=r.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of u)if(l.regex.test(o))return`<REDACTED: ${l.label}>`;return r}function t(r,o){return(0,T.cloneAndChange)(r,u=>{if(u instanceof I)return u.value;if(typeof u=="string"){let l=u.replaceAll("%20"," ");l=i(l,o);for(const g of o)l=l.replace(g,"");return l=n(l),l}})}e.cleanData=t}),define(Y[133],Z([0,1,104,41]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(L,N,I,h,c,m,w){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${N.nameShort})`};if((0,O.supportsTelemetry)(N,I)&&(0,O.getTelemetryLevel)(h)===3){const P=await(0,T.getServiceMachineId)(I,c,m),{machineId:y}=await w.getTelemetryInfo();p["X-Market-User-Id"]=P,p["VSCode-SessionId"]=y||P}return p}e.resolveMarketplaceHeaders=k}),define(Y[134],Z([0,1,11,28,41]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function N(h,c,m){const w=await new Promise((E,a)=>{$(["@microsoft/1ds-core-js"],E,a)}),p=await new Promise((E,a)=>{$(["@microsoft/1ds-post-js"],E,a)}),P=new w.AppInsightsCore,y=new p.PostChannel,S={instrumentationKey:h,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(m){S.extensionConfig={};const E={alwaysUseXhrOverride:!0,httpXHROverride:m};S.extensionConfig[y.identifier]=E}return P.initialize(S,[]),P.addTelemetryInitializer(E=>{c&&(E.ext=E.ext??{},E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),P}class I{constructor(c,m,w,p,P){this.d=c,this.e=m,this.f=w,this.g=P,this.c=L,this.f||(this.f={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}h(c){if(!!this.a){if(typeof this.a!="string"){c(this.a);return}this.b||(this.b=N(this.a,this.d,this.g)),this.b.then(m=>{c(m)},m=>{(0,T.onUnexpectedError)(m),console.error(m)})}}log(c,m){if(!this.a)return;m=(0,O.mixin)(m,this.f),m=(0,k.validateTelemetryData)(m);const w=this.e+"/"+c;try{this.h(p=>{p.pluginVersionString=m?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(c=>{this.h(m=>{m.unload(!0,()=>{this.a=void 0,c(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(Y[135],Z([0,1,2,28,12,29,96,21,40,136,30,35,36,41]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(a,d,v){this.k=d,this.l=v,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=a.appenders,this.c=a.commonProperties||Promise.resolve({}),this.f=a.piiPaths||[],this.g=3,this.h=!!a.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this.f)this.j.push(new RegExp((0,L.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(a,d){this.d[a]=d}m(){let a=(0,P.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const v=d.usage?3:d.error?2:0;a=Math.min(a,v)}this.g=a}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const a=await this.c,d=a.sessionID,v=a["common.machineId"],f=a["common.firstSessionDate"],s=a["common.msftInternal"];return{sessionId:d,machineId:v,firstSessionDate:f,msftInternal:s}}dispose(){this.i.dispose()}n(a,d,v){return this.g<d?Promise.resolve(void 0):this.c.then(f=>{v=(0,O.mixin)(v,this.d),v=(0,P.cleanData)(v,this.j),v=(0,O.mixin)(v,f),this.b.forEach(s=>s.log(a,v))},f=>{console.error(f)})}publicLog(a,d){return this.n(a,3,d)}publicLog2(a,d){return this.publicLog(a,d)}publicLogError(a,d){return this.h?this.n(a,2,d):Promise.resolve(void 0)}publicLogError2(a,d){return this.publicLogError(a,d)}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=fe([_(1,I.IConfigurationService),_(2,m.IProductService)],y),e.TelemetryService=y;function S(){const E=(0,N.localize)(0,null,c.default.nameLong),a=c.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=k.isWeb?"":(0,N.localize)(3,null),v=(0,N.localize)(4,null),f=(0,N.localize)(5,null),s=(0,N.localize)(6,null),i=(0,N.localize)(7,null),n=`
|       | ${v} | ${f} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,N.localize)(8,null);return`
${E} ${a} ${d}

&nbsp;

${i}
${n}

&nbsp;

${t}
`}w.Registry.as(h.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(9,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(h.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,N.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,N.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[137],Z([0,1,159,134]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends O.AbstractOneDataSystemAppender{constructor(N,I,h,c){const m={sendPOST:(w,p)=>{const P={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const y=T.request(w.urlString,P,S=>{S.on("data",function(E){p(S.statusCode??200,S.headers,E.toString())}),S.on("error",function(E){p(0,{})})});y.write(w.data),y.end()}catch{p(0,{})}}};super(N,I,h,c,m)}}e.OneDataSystemAppender=k}),define(Y[138],Z([0,1,14,20]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(L,N){const I=Object.create(null),h=(m,w)=>{const p=JSON.parse(m);I[w]=p};if(N){const m=[],w=await O.Promises.readdir(N);for(const P of w)try{(await O.Promises.stat((0,T.join)(N,P))).isDirectory()&&m.push(P)}catch{}const p=[];for(const P of m)(await O.Promises.readdir((0,T.join)(N,P))).filter(S=>S==="telemetry.json").length===1&&p.push(P);for(const P of p){const y=(await O.Promises.readFile((0,T.join)(N,P,"telemetry.json"))).toString();h(y,P)}}let c=(await O.Promises.readFile((0,T.join)(L,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await O.Promises.readFile((0,T.join)(L,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(I,null,4)}e.buildTelemetryMessage=k}),define(Y[27],Z([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Y[139],Z([0,1,27,105,13,17,69,4,2]),function($,e,T,O,k,L,N,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(p){this.uri=p,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let m=class{constructor(p){this.g=p,this.c=new h.DisposableStore,this.f=2**16;const P=new Map,y=S=>{let E=P.get(S.scheme);return E===void 0&&(E=p.hasProvider(S)&&!this.g.hasCapability(S,1024),P.set(S.scheme,E)),E};this.c.add(I.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{P.delete(S.scheme)})),this.extUri=new L.ExtUri(y),this.d=new N.SkipList((S,E)=>this.extUri.compare(S,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,L.normalizePath)(p));const P=this.d.get(p);return P?P.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new c(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((y,S)=>y[1].touch<S[1].touch?1:y[1].touch>S[1].touch?-1:0);c._clock=0,this.d.clear();const P=this.f*.5;for(let y=0;y<P;y++)this.d.set(p[y][0],p[y][1].touch())}};m=fe([_(0,k.IFileService)],m),e.UriIdentityService=m,(0,O.registerSingleton)(T.IUriIdentityService,m,1)}),define(Y[140],Z([0,1,98,14,113,17,10,7,16]),function($,e,T,O,k,L,N,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function c(n){const t=n;return typeof t?.id=="string"&&N.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=c,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function m(n,t){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.basename)(n)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=m;function w(n){const t=n;return typeof t?.id=="string"&&N.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=w;function p(n){const t=n;if(t?.uri)return{id:t.id,uri:N.URI.revive(t.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=p;var P;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function y(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=y;function S(n){const t=n;return!!(t&&typeof t=="object"&&N.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=S;class E{constructor(t,r,o,u,l){this.h=t,this.j=o,this.k=u,this.l=l,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class a{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function d(n){return new a({uri:n,index:0,name:(0,L.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(n,t){return L.extUriBiasedIgnorePathCase.isEqualOrParent(n,t.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function f(n){let t;return N.URI.isUri(n)?t=n:t=n.configuration,t?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=f;function s(n,t){return!v(n,t)&&!f(n)}e.isSavedWorkspace=s;function i(n){return(typeof n=="string"?(0,O.extname)(n):(0,L.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(Y[25],Z([0,1,52,4,2,17,10,97,18,13,7,9,140,34,27,3,31,29]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y,S,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function d(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&N.URI.isUri(t.location)&&N.URI.isUri(t.globalStorageHome)&&N.URI.isUri(t.settingsResource)&&N.URI.isUri(t.keybindingsResource)&&N.URI.isUri(t.tasksResource)&&N.URI.isUri(t.snippetsHome)&&N.URI.isUri(t.extensionsResource))}e.isUserDataProfile=d,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function v(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:N.URI.revive(n.location).with({scheme:t}),globalStorageHome:N.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:N.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:N.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:N.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:N.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:N.URI.revive(n.extensionsResource)?.with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=v;function f(n,t,r,o){return{id:n,name:t,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,L.joinPath)(r,"globalStorage"),settingsResource:(0,L.joinPath)(r,"settings.json"),keybindingsResource:(0,L.joinPath)(r,"keybindings.json"),tasksResource:(0,L.joinPath)(r,"tasks.json"),snippetsHome:(0,L.joinPath)(r,"snippets"),extensionsResource:(0,L.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=f;let s=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(t,r,o,u){super(),this.m=t,this.n=r,this.r=o,this.s=u,this.f=!1,this.g=this.B(new O.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new O.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new O.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new O.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new P.ResourceMap},this.profilesHome=(0,L.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(t){this.f!==t&&(this.t=void 0,this.f=t)}isEnabled(){return this.f}get u(){if(!this.t){const t=this.f?this.I().map(l=>f((0,L.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags})):[];let r;const o=new P.ResourceMap,u=f((0,T.hash)(this.m.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.m.userRoamingDataHome);if(t.unshift({...u,extensionsResource:this.N()??u.extensionsResource,isDefault:!0}),t.length){const l=this.L();if(l.workspaces)for(const[g,R]of Object.entries(l.workspaces)){const C=N.URI.parse(g),q=N.URI.parse(R),X=t.find(J=>this.r.extUri.isEqual(J.location,q));X&&o.set(C,X)}if(l.emptyWindow){const g=N.URI.parse(l.emptyWindow);r=t.find(R=>this.r.extUri.isEqual(R.location,g))}}this.t={profiles:t,workspaces:o,emptyWindow:r}}return this.t}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,a.escapeRegExpCharacters)(r)}\\s(\\d+)`);let u=0;for(const g of this.profiles){const R=o.exec(g.name),C=R?parseInt(R[1]):0;u=C>u?C:u}const l=`${r} ${u+1}`;return this.createProfile((0,T.hash)((0,E.generateUuid)()).toString(16),l,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,T.hash)((0,E.generateUuid)()).toString(16),t,r,o)}async createProfile(t,r,o,u){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=await this.v(t,r,o);return u&&await this.setProfileForWorkspace(u,l),l}async v(t,r,o){let u=this.k.get(r);return u||(u=(async()=>{try{const l=this.profiles.find(C=>C.name===r||C.id===t);if(l)return l;const g=f(t,r,(0,L.joinPath)(this.profilesHome,t),o);await this.n.createFolder(g.location);const R=[];return this.h.fire({profile:g,join(C){R.push(C)}}),await S.Promises.settled(R),this.D([g],[],[]),g}finally{this.k.delete(r)}})(),this.k.set(r,u)),u}async updateProfile(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(u=>u.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=f(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.D([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(u=>u.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.i.fire({profile:r,join(u){o.push(u)}});try{await Promise.allSettled(o)}catch(u){this.s.error(u)}r.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const u of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(u)?.id&&this.u.workspaces.delete(u);this.H(),this.D([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(u){this.s.error(u)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.f)return this.defaultProfile;let o=this.w(t);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(u=>u.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.G(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.G(t,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.H(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const t=await this.n.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.l.profiles.filter(r=>!this.C(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}w(t){const r=this.y(t);return N.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindow??this.u.emptyWindow}y(t){return(0,p.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,p.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}C(t){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,t.location)||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,t.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,t.location)||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,t.location)))}D(t,r,o){const u=[...this.profiles,...t],l=[];this.l.profiles=[];for(let g of u)g.isDefault||r.some(R=>g.id===R.id)||(g=o.find(R=>g.id===R.id)??g,g.isTransient?this.l.profiles.push(g):l.push({location:g.location,name:g.name,shortName:g.shortName,useDefaultFlags:g.useDefaultFlags}));this.J(l),this.t=void 0,this.F(t,r,o)}F(t,r,o){this.g.fire({added:t,removed:r,updated:o,all:this.profiles})}G(t,r,o){o=r?.isTransient?!0:o,o||this.G(t,void 0,!0);const u=this.y(t),l=o?this.l:this.u;N.URI.isUri(u)?(l.workspaces.delete(u),r&&l.workspaces.set(u,r)):l.emptyWindow=r,o||this.H()}H(){const t={};for(const[o,u]of this.u.workspaces.entries())t[o.toString()]=u.location.toString();const r=this.u.emptyWindow?.location.toString();this.M({workspaces:t,emptyWindow:r}),this.t=void 0}I(){return[]}J(t){throw new Error("not implemented")}L(){return{}}M(t){throw new Error("not implemented")}N(){}};s.b="userDataProfiles",s.c="profileAssociations",s=fe([_(0,h.IEnvironmentService),_(1,c.IFileService),_(2,y.IUriIdentityService),_(3,w.ILogService)],s),e.UserDataProfilesService=s;class i extends s{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(t){this.a=t}L(){return this.Q}M(t){this.Q=t}}e.InMemoryUserDataProfilesService=i}),define(Y[141],Z([0,1,19,3,22,11,4,2,12,10,82,23,24,26,9,30,36,25]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y,S,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=class extends I.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,r,o,u,l){super(),this.t=t,this.u=r,this.v=o,this.w=u,this.y=l,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,I.toDisposable)(()=>{this.j.forEach(({task:g})=>g.cancel()),this.k.forEach(g=>g.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.t.isEnabled())throw new w.ExtensionManagementError(m.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.H(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.C(o.manifest,o.extension,r)}catch(o){throw s(this.u,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:o}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(o),f(o)}}async uninstall(t,r={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.J(t,r)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.P(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async C(t,r,o){const u={...o,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,P.isApplicationScopedExtension)(t)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.Q()},l=J=>`${p.ExtensionKey.create(J).toString()}${u.profileLocation?`-${u.profileLocation.toString()}`:""}`;if(!c.URI.isUri(r)){const J=this.j.get(l(r));if(J){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await J.task.waitUntilTaskIsFinished();return ie}}const g=[],R=[],C=[],q=this.R(t,r,u);c.URI.isUri(r)||this.j.set(l(r),{task:q,waitingTasks:[]}),this.l.fire({identifier:q.identifier,source:r,profileLocation:u.profileLocation}),this.v.info("Installing extension:",q.identifier.id),g.push({task:q,manifest:t});let X=!1;try{if(u.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",q.identifier.id);else try{const ie=await this.G(q.identifier,t,!!u.installOnlyNewlyAddedFromExtensionPack,!!u.installPreReleaseVersion,u.profileLocation),re=await this.getInstalled(void 0,u.profileLocation);for(const{gallery:Q,manifest:he}of ie){X=X||!!he.extensionDependencies?.some(ge=>(0,p.areSameExtensions)({id:ge},q.identifier));const ce=l(Q),se=this.j.get(ce);if(se){if(this.D(q,se.task)){this.v.info("Waiting for already requested installing extension",Q.identifier.id,q.identifier.id),se.waitingTasks.push(q);const ge=se.task.identifier;R.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,M=>M.some(A=>(0,p.areSameExtensions)(A.identifier,ge)))).then(M=>{if(!M.find(U=>(0,p.areSameExtensions)(U.identifier,ge))?.local)throw new Error(`Extension ${ge.id} is not installed`)}))}}else if(!re.some(({identifier:ge})=>(0,p.areSameExtensions)(ge,Q.identifier))){const ge=this.R(he,Q,{...u,donotIncludePackAndDependencies:!0});this.j.set(ce,{task:ge,waitingTasks:[q]}),this.l.fire({identifier:ge.identifier,source:Q,profileLocation:u.profileLocation}),this.v.info("Installing extension:",ge.identifier.id,q.identifier.id),g.push({task:ge,manifest:he})}}}catch(ie){if(c.URI.isUri(q.source))(0,T.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",q.identifier.id,ie.message),(0,T.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",q.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",q.identifier.id),ie}const J=g.reduce((ie,{task:re,manifest:Q})=>(ie.set(re.identifier.id.toLowerCase(),{task:re,manifest:Q}),ie),new Map);for(;J.size;){let ie;const re=[...J.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(he=>J.has(he.toLowerCase())));re.length?ie=J.size===1?re:re.filter(({task:Q})=>!(Q===q&&!X)):(this.v.info("Found extensions with circular dependencies",re.map(({task:Q})=>Q.identifier.id)),ie=[...J.values()]),await this.F(ie.map(async({task:Q})=>{const he=new Date().getTime();try{const{local:ce}=await Q.run();if(await this.F(this.s.map(se=>se.postInstall(ce,Q.source,u,k.CancellationToken.None))),!c.URI.isUri(Q.source)){const se=Q.operation===3,ge=se?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(s(this.u,se?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Q.source),wasVerified:Q.wasVerified,duration:new Date().getTime()-he,durationSinceUpdate:ge}),h.isWeb&&Q.operation!==3)try{await this.t.reportStatistic(ce.manifest.publisher,ce.manifest.name,ce.manifest.version,"install")}catch{}}C.push({local:ce,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:u.context,profileLocation:u.profileLocation,applicationScoped:ce.isApplicationScoped})}catch(ce){throw c.URI.isUri(Q.source)||s(this.u,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Q.source),wasVerified:Q.wasVerified,duration:new Date().getTime()-he,error:ce}),this.v.error("Error while installing the extension:",Q.identifier.id),ce}finally{J.delete(Q.identifier.id.toLowerCase())}}))}return R.length&&await this.F(R),C.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(C),C.filter(({identifier:ie})=>(0,p.areSameExtensions)(ie,q.identifier))[0].local}catch(J){if(g.forEach(({task:ie})=>ie.cancel()),C.length)try{const ie=await Promise.allSettled(C.map(({local:re})=>this.S(re,{versionOnly:!0,profileLocation:u.profileLocation}).run()));for(let re=0;re<ie.length;re++){const Q=ie[re],{identifier:he}=C[re];Q.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",he.id):this.v.warn("Rollback: Error while uninstalling extension",he.id,(0,L.getErrorMessage)(Q.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,L.getErrorMessage)(ie),C.map(({identifier:re})=>re.id))}throw this.m.fire(g.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:u.context,profileLocation:u.profileLocation}))),J}finally{for(const[J,{task:ie,waitingTasks:re}]of this.j.entries()){const Q=re.indexOf(q);Q!==-1&&re.splice(Q,1),re.length===0&&(ie===q||Q!==-1)&&this.j.delete(J)}}}D(t,r){for(const[,{task:o,waitingTasks:u}]of this.j.entries())if(o===t&&(u.includes(r)||u.some(l=>this.D(l,r)))||o===r&&u[0]&&!this.D(t,u[0]))return!1;return!0}async F(t){const r=[],o=[],u=await Promise.allSettled(t);for(const l of u)l.status==="fulfilled"?r.push(l.value):o.push(l.reason);if(o.length)throw v(o);return r}async G(t,r,o,u,l){if(!this.t.isEnabled())return[];const g=await this.getInstalled(void 0,l),R=[t],C=[],q=async(X,J)=>{const ie=J.extensionDependencies||[],re=[...ie];if(J.extensionPack){const Q=o?g.find(he=>(0,p.areSameExtensions)(he.identifier,X)):void 0;for(const he of J.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(ce=>(0,p.areSameExtensions)({id:ce},{id:he}))||re.every(ce=>!(0,p.areSameExtensions)({id:ce},{id:he}))&&re.push(he)}if(re.length){const Q=[...R,...C.map(ce=>ce.gallery.identifier)],he=re.filter(ce=>Q.every(se=>!(0,p.areSameExtensions)(se,{id:ce})));if(he.length){const ce=await this.t.getExtensions(he.map(se=>({id:se,preRelease:u})),k.CancellationToken.None);for(const se of ce){if(Q.find(A=>(0,p.areSameExtensions)(A,se.identifier)))continue;const ge=ie.some(A=>(0,p.areSameExtensions)({id:A},se.identifier));let M;try{M=await this.H(se,!1,u)}catch(A){if(A instanceof w.ExtensionManagementError&&A.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ge){this.v.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw A}C.push({gallery:M.extension,manifest:M.manifest}),await q(M.extension.identifier,M.manifest)}}}};return await q(t,r),C}async H(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(R=>(0,p.areSameExtensions)(t.identifier,R)))throw new w.ExtensionManagementError(m.localize(1,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const R=await this.getTargetPlatform();throw new w.ExtensionManagementError(m.localize(2,null,t.identifier.id,this.w.nameLong,(0,w.TargetPlatformToString)(R)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.I(t,r,o);if(l){if(o&&!r&&t.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(m.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],k.CancellationToken.None))[0]?new w.ExtensionManagementError(m.localize(4,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(m.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",l.identifier.id);const g=await this.t.getManifest(l,k.CancellationToken.None);if(g===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(g.version!==l.version)throw new w.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:g}}async I(t,r,o){const u=await this.getTargetPlatform();let l=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(l=(await this.t.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:u,compatible:!0},k.CancellationToken.None))[0]||null),!l&&await this.t.isExtensionCompatible(t,o,u)&&(l=t),l||(r?l=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:u,compatible:!0},k.CancellationToken.None))[0]||null:l=await this.t.getCompatibleExtension(t,o,u)),l}async J(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.Q()},u=X=>`${X.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,l=this.k.get(u(t.identifier));if(l)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),l.waitUntilTaskIsFinished();const g=X=>{const J=this.S(X,o);return this.k.set(u(J.extension.identifier),J),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this.n.fire({identifier:X.identifier,profileLocation:o.profileLocation,applicationScoped:X.isApplicationScoped}),J},R=(X,J)=>{J?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,o.profileLocation.toString(),J.message):this.v.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,J.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),s(this.u,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(X),error:J}),this.p.fire({identifier:X.identifier,error:J?.code,profileLocation:o.profileLocation,applicationScoped:X.isApplicationScoped})},C=[],q=[];try{C.push(g(t));const X=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const J=this.N(t,X);for(const ie of J)this.k.has(u(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):C.push(g(ie))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.L(C.map(J=>J.extension),X,t),await this.F(C.map(async J=>{try{if(await J.run(),await this.F(this.s.map(ie=>ie.postUninstall(J.extension,o,k.CancellationToken.None))),J.extension.identifier.uuid)try{await this.t.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}R(J.extension)}catch(ie){const re=ie instanceof w.ExtensionManagementError?ie:new w.ExtensionManagementError((0,L.getErrorMessage)(ie),w.ExtensionManagementErrorCode.Internal);throw R(J.extension,re),re}finally{q.push(J)}}))}catch(X){const J=X instanceof w.ExtensionManagementError?X:new w.ExtensionManagementError((0,L.getErrorMessage)(X),w.ExtensionManagementErrorCode.Internal);for(const ie of C){try{ie.cancel()}catch{}q.includes(ie)||R(ie.extension,J)}throw J}finally{for(const X of C)this.k.delete(u(X.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}L(t,r,o){for(const u of t){const l=this.O(u,r);if(l.length){const g=l.filter(R=>!t.some(C=>(0,p.areSameExtensions)(C.identifier,R.identifier)));if(g.length)throw new Error(this.M(u,g,o))}}}M(t,r,o){return o===t?r.length===1?m.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?m.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}N(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const u=t.manifest.extensionPack?t.manifest.extensionPack:[];if(u.length){const l=r.filter(R=>!R.isBuiltin&&u.some(C=>(0,p.areSameExtensions)({id:C},R.identifier))),g=[];for(const R of l)g.push(...this.N(R,r,o));return[...l,...g]}return[]}O(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(u=>(0,p.areSameExtensions)({id:u},t.identifier)))}async P(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};d=fe([_(0,w.IExtensionGalleryService),_(1,E.ITelemetryService),_(2,y.ILogService),_(3,S.IProductService),_(4,a.IUserDataProfilesService)],d),e.AbstractExtensionManagementService=d;function v(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=v;function f(n){if(n instanceof w.ExtensionManagementError)return n;const t=new w.ExtensionManagementError(n.message,w.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function s(n,t,{extensionData:r,wasVerified:o,duration:u,error:l,durationSinceUpdate:g}){let R,C;l&&(l instanceof w.ExtensionManagementError?(R=l.code,l.code===w.ExtensionManagementErrorCode.Signature&&(C=l.message)):R=w.ExtensionManagementErrorCode.Internal),n.publicLog(t,{...r,wasVerified:o,success:!l,duration:u,errorcode:R,errorcodeDetail:C,durationSinceUpdate:g})}e.reportTelemetry=s;class i{constructor(){this.d=new O.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.createCancelablePromise)(t=>new Promise((r,o)=>{const u=t.onCancellationRequested(()=>{u.dispose(),o(new L.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=i}),define(Y[42],Z([0,1,3,15,2,4,34,10,24,26,13,7,9,25,27]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let S=class extends k.Disposable{constructor(d,v,f,s){super(),this.h=d,this.i=v,this.j=f,this.k=s,this.a=this.B(new L.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new L.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new L.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new L.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(d){return this.l(d)}async addExtensionsToProfile(d,v){const f=[],s=[];try{return await this.l(v,i=>{const n=[];for(const t of i)d.some(([r])=>(0,h.areSameExtensions)(r.identifier,t.identifier)&&r.manifest.version!==t.version)?f.push(t):n.push(t);for(const[t,r]of d)if(!n.some(o=>(0,h.areSameExtensions)(o.identifier,t.identifier)&&o.version===t.manifest.version)){const o={identifier:t.identifier,version:t.manifest.version,location:t.location,metadata:r};s.push(o),n.push(o)}return s.length&&this.a.fire({extensions:s,profileLocation:v}),f.length&&this.c.fire({extensions:f,profileLocation:v}),n}),s.length&&this.b.fire({extensions:s,profileLocation:v}),f.length&&this.f.fire({extensions:f,profileLocation:v}),s}catch(i){throw s.length&&this.b.fire({extensions:s,error:i,profileLocation:v}),f.length&&this.f.fire({extensions:f,error:i,profileLocation:v}),i}}async removeExtensionFromProfile(d,v){const f=[];this.c.fire({extensions:f,profileLocation:v});try{await this.l(v,s=>{const i=[];for(const n of s)(0,h.areSameExtensions)(n.identifier,d.identifier)?f.push(n):i.push(n);return f.length&&this.c.fire({extensions:f,profileLocation:v}),i}),f.length&&this.f.fire({extensions:f,profileLocation:v})}catch(s){throw f.length&&this.f.fire({extensions:f,error:s,profileLocation:v}),s}}async l(d,v){return this.p(d).queue(async()=>{let f=[],s;try{const i=await this.h.readFile(d);s=JSON.parse(i.value.toString())}catch(i){if((0,m.toFileOperationResult)(i)!==1)throw i;this.j.extUri.isEqual(d,this.i.defaultProfile.extensionsResource)&&(s=await this.n())}if(s)for(const i of s){if(!i.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",i);continue}if(!i.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",i);continue}if(!i.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",i);continue}f.push({identifier:i.identifier,location:I.URI.revive(i.location),version:i.version,metadata:i.metadata})}if(v){f=v(f);const i=f.map(n=>({identifier:n.identifier,version:n.version,location:n.location.toJSON(),metadata:n.metadata}));await this.h.writeFile(d,O.VSBuffer.fromString(JSON.stringify(i)))}return f})}async n(){return this.m||(this.m=(async()=>{const d=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let v;try{v=(await this.h.readFile(d)).value.toString()}catch(s){if((0,m.toFileOperationResult)(s)===1)return;throw s}this.k.info("Migrating extensions from old default profile location",d.toString());let f;try{const s=JSON.parse(v);Array.isArray(s)&&s.every(i=>!!(i&&typeof i=="object"&&(0,c.isIExtensionIdentifier)(i.identifier)&&E(i.location)&&i.version&&typeof i.version=="string"))?f=s:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.k.error(s)}if(f)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(f)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",d.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(s){if((0,m.toFileOperationResult)(s)===3)this.k.info("Migration from old default profile location to new location is done by another window",d.toString(),this.i.defaultProfile.extensionsResource.toString());else throw s}try{await this.h.del(d)}catch(s){(0,m.toFileOperationResult)(s)!==1&&this.k.error(s)}return f})()),this.m}p(d){let v=this.g.get(d);return v||(v=new T.Queue,this.g.set(d,v)),v}};S=fe([_(0,m.IFileService),_(1,P.IUserDataProfilesService),_(2,y.IUriIdentityService),_(3,p.ILogService)],S),e.ExtensionsProfileScannerService=S;function E(a){return a?typeof a.path=="string"&&typeof a.scheme=="string":!1}}),define(Y[48],Z([0,1,19,3,28,15,11,50,74,2,16,14,12,17,39,53,8,10,86,18,24,26,45,13,7,9,30,4,44,42,25,27,102,103]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y,S,E,a,d,v,f,s,i,n,t,r,o,u,l,g,R,C,q,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var J;(function(ge){function M(A,U){if(A===U)return!0;const V=Object.keys(A),G=new Set;for(const x of Object.keys(U))G.add(x);if(V.length!==G.size)return!1;for(const x of V){if(A[x]!==U[x])return!1;G.delete(x)}return G.size===0}ge.equals=M})(J=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let ie=class extends c.Disposable{constructor(M,A,U,V,G,x,ee,b,D,j,F,B){super(),this.systemExtensionsLocation=M,this.userExtensionsLocation=A,this.l=U,this.m=V,this.n=G,this.p=x,this.r=ee,this.s=b,this.t=D,this.u=j,this.v=F,this.w=B,this.g=this.B(new u.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,P.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(he,(0,P.joinPath)(this.m,s.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(he,(0,P.joinPath)(this.m,s.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(Q,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,f.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(M,A,U){const[V,G]=await Promise.all([this.scanSystemExtensions(M),this.scanUserExtensions(A)]),x=U?await this.scanExtensionsUnderDevelopment(M,[...V,...G]):[];return this.F(V,G,x,await this.getTargetPlatform(),!0)}async scanSystemExtensions(M){const A=[];A.push(this.G(!!M.useCache,M.language)),A.push(this.H(M.language,!!M.checkControlFile));const[U,V]=await Promise.all(A);return this.D([...U,...V],0,M,!1)}async scanUserExtensions(M){const A=M.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",A);const U=await this.J(A,!!M.profileLocation,1,!M.includeUninstalled,M.language);let G=await(M.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k).scanExtensions(U);return G=await this.D(G,1,M,!0),this.s.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(M,A){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(V=>V.scheme===m.Schemas.file).map(async V=>{const G=await this.J(V,!1,1,!0,M.language,!1);return(await this.k.scanOneOrMultipleExtensions(G)).map(ee=>(ee.type=A.find(b=>(0,f.areSameExtensions)(b.identifier,ee.identifier))?.type??ee.type,this.k.validate(ee,G)))}))).flat();return this.D(U,"development",M,!0)}return[]}async scanExistingExtension(M,A,U){const V=await this.J(M,!1,A,!0,U.language),G=await this.k.scanExtension(V);return!G||!U.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(M,A,U){const V=await this.J(M,!1,A,!0,U.language),G=await this.k.scanOneOrMultipleExtensions(V);return this.D(G,A,U,!0)}async scanMetadata(M){const A=(0,P.joinPath)(M,"package.json"),U=(await this.r.readFile(A)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(M,A){const U=(0,P.joinPath)(M,"package.json"),V=(await this.r.readFile(U)).value.toString(),G=JSON.parse(V);A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0,G.__metadata={...G.__metadata,...A},await this.r.writeFile((0,P.joinPath)(M,"package.json"),L.VSBuffer.fromString(JSON.stringify(G,null,"	")))}initializeDefaultProfileExtensions(){return this.C||(this.C=(async()=>{try{const M=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(M))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const A=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(A.map(U=>[U,U.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(M,L.VSBuffer.fromString(""))}catch(A){(0,n.toFileOperationResult)(A)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(A))}}catch(M){throw this.s.error(M),M}})()),this.C}async D(M,A,U,V){return U.includeAllVersions||(M=this.F(A===0?M:void 0,A===1?M:void 0,A==="development"?M:void 0,await this.getTargetPlatform(),V)),U.includeInvalid||(M=M.filter(G=>G.isValid)),M.sort((G,x)=>{const ee=w.basename(G.location.fsPath),b=w.basename(x.location.fsPath);return ee<b?-1:ee>b?1:0})}F(M,A,U,V,G){const x=(b,D,j)=>{if(b.isValid&&!D.isValid)return!1;if(b.isValid===D.isValid){if(G&&y.gt(b.manifest.version,D.manifest.version))return this.s.debug(`Skipping extension ${D.location.path} with lower version ${D.manifest.version} in favour of ${b.location.path} with version ${b.manifest.version}`),!1;if(y.eq(b.manifest.version,D.manifest.version)){if(b.type===0)return this.s.debug(`Skipping extension ${D.location.path} in favour of system extension ${b.location.path} with same version`),!1;if(b.targetPlatform===V)return this.s.debug(`Skipping extension ${D.location.path} from different target platform ${D.targetPlatform}`),!1}}return j?this.s.warn(`Overwriting user extension ${b.location.path} with ${D.location.path}.`):this.s.debug(`Overwriting user extension ${b.location.path} with ${D.location.path}.`),!0},ee=new Map;return M?.forEach(b=>{const D=s.ExtensionIdentifier.toKey(b.identifier.id),j=ee.get(D);(!j||x(j,b,!1))&&ee.set(D,b)}),A?.forEach(b=>{const D=s.ExtensionIdentifier.toKey(b.identifier.id),j=ee.get(D);if(!j&&M&&b.type===0){this.s.debug(`Skipping obsolete system extension ${b.location.path}.`);return}(!j||x(j,b,!1))&&ee.set(D,b)}),U?.forEach(b=>{const D=s.ExtensionIdentifier.toKey(b.identifier.id),j=ee.get(D);(!j||x(j,b,!0))&&ee.set(D,b),ee.set(D,b)}),[...ee.values()]}async G(M,A){this.s.trace("Started scanning system extensions");const U=await this.J(this.systemExtensionsLocation,!1,0,!0,A),G=await(M&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",G.length),G}async H(M,A){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const V=A?await this.I():{},G=[],x=a.URI.file(w.normalize(w.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const b of U){const D=V[b.name]||"marketplace";switch(D){case"disabled":break;case"marketplace":G.push((0,P.joinPath)(x,b.name));break;default:G.push(a.URI.file(D));break}}const ee=await Promise.all(G.map(async b=>this.k.scanExtension(await this.J(b,!1,0,!0,M))));return this.s.trace("Scanned dev system extensions:",ee.length),(0,T.coalesce)(ee)}async I(){try{const M=await this.r.readFile(this.l);return JSON.parse(M.value.toString())}catch{return{}}}async J(M,A,U,V,G,x=!0){const ee=await this.f(G??p.language),b=await this.L(M),D=A&&!this.v.extUri.isEqual(M,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,j=D?await this.L(D):void 0;return new re(M,b,D,j,A,U,V,x,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,G,ee)}async L(M){try{const A=await this.r.stat(M);if(typeof A.mtime=="number")return A.mtime}catch{}}};ie=fe([_(4,R.IUserDataProfilesService),_(5,g.IExtensionsProfileScannerService),_(6,n.IFileService),_(7,r.ILogService),_(8,v.IEnvironmentService),_(9,o.IProductService),_(10,C.IUriIdentityService),_(11,t.IInstantiationService)],ie),e.AbstractExtensionsScannerService=ie;class re{constructor(M,A,U,V,G,x,ee,b,D,j,F,B,W,te){this.location=M,this.mtime=A,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=V,this.profile=G,this.type=x,this.excludeObsolete=ee,this.validate=b,this.productVersion=D,this.productDate=j,this.productCommit=F,this.devMode=B,this.language=W,this.translations=te}static createNlsConfiguration(M){return{language:M.language,pseudo:M.language==="pseudo",devMode:M.devMode,translations:M.translations}}static equals(M,A){return(0,P.isEqual)(M.location,A.location)&&M.mtime===A.mtime&&(0,P.isEqual)(M.applicationExtensionslocation,A.applicationExtensionslocation)&&M.applicationExtensionslocationMtime===A.applicationExtensionslocationMtime&&M.profile===A.profile&&M.type===A.type&&M.excludeObsolete===A.excludeObsolete&&M.validate===A.validate&&M.productVersion===A.productVersion&&M.productDate===A.productDate&&M.productCommit===A.productCommit&&M.devMode===A.devMode&&M.language===A.language&&J.equals(M.translations,A.translations)}}let Q=class extends c.Disposable{constructor(M,A,U,V,G){super(),this.f=M,this.g=A,this.h=U,this.i=V,this.j=G}async scanExtensions(M){const A=M.profile?await this.l(M):await this.k(M);let U={};if(M.excludeObsolete&&M.type===1)try{const V=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(V)}catch{}return(0,E.isEmptyObject)(U)?A:A.filter(V=>!U[f.ExtensionKey.create(V).toString()])}async k(M){const A=await this.i.resolve(M.location);if(!A.children?.length)return[];const U=await Promise.all(A.children.map(async V=>{if(!V.isDirectory||M.type===1&&(0,P.basename)(V.resource).indexOf(".")===0)return null;const G=new re(V.resource,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(G)}));return(0,T.coalesce)(U).sort((V,G)=>V.location.path<G.location.path?-1:1)}async l(M){let A=await this.m(M.location,()=>!0,M);if(M.applicationExtensionslocation&&!this.h.extUri.isEqual(M.location,M.applicationExtensionslocation)){A=A.filter(V=>!V.metadata?.isApplicationScoped);const U=await this.m(M.applicationExtensionslocation,V=>!!V.metadata?.isApplicationScoped,M);A.push(...U)}return A}async m(M,A,U){const V=await this.g.scanProfileExtensions(M);if(!V.length)return[];const G=await Promise.all(V.map(async x=>{if(A(x)){const ee=new re(x.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(ee,x.metadata)}return null}));return(0,T.coalesce)(G)}async scanOneOrMultipleExtensions(M){try{if(await this.i.exists((0,P.joinPath)(M.location,"package.json"))){const A=await this.scanExtension(M);return A?[A]:[]}else return await this.scanExtensions(M)}catch(A){return this.j.error(`Error scanning extensions at ${M.location.path}:`,(0,N.getErrorMessage)(A)),[]}}async scanExtension(M,A){try{let U=await this.scanExtensionManifest(M.location);if(U){U.publisher||(U.publisher=s.UNDEFINED_PUBLISHER),A=A??U.__metadata,delete U.__metadata;const V=(0,f.getGalleryExtensionId)(U.publisher,U.name),G=A?.id?{id:V,uuid:A.id}:{id:V},x=A?.isSystem?0:M.type,ee=x===0||!!A?.isBuiltin;X.ImplicitActivationEvents.updateManifest(U),U=await this.n(M.location,U,re.createNlsConfiguration(M));const b={type:x,identifier:G,manifest:U,location:M.location,isBuiltin:ee,targetPlatform:A?.targetPlatform??"undefined",metadata:A,isValid:!0,validations:[]};return M.validate?this.validate(b,M):b}}catch(U){M.type!==0&&this.j.error(U)}return null}validate(M,A){let U=!0;const V=(0,i.validateExtensionManifest)(A.productVersion,A.productDate,A.location,M.manifest,M.isBuiltin);for(const[G,x]of V)G===S.default.Error&&(U=!1,this.j.error(this.t(A.location,x)));return M.isValid=U,M.validations=V,M}async scanExtensionManifest(M){const A=(0,P.joinPath)(M,"package.json");let U;try{U=(await this.i.readFile(A)).value.toString()}catch(G){return(0,n.toFileOperationResult)(G)!==1&&this.j.error(this.t(M,(0,d.localize)(0,null,A.path,G.message))),null}let V;try{V=JSON.parse(U)}catch{const x=[];(0,I.parse)(U,x);for(const ee of x)this.j.error(this.t(M,(0,d.localize)(1,null,A.path,ee.offset,ee.length,(0,h.getParseErrorMessage)(ee.error))));return null}return(0,I.getNodeType)(V)!=="object"?(this.j.error(this.t(M,(0,d.localize)(2,null,A.path))),null):V}async n(M,A,U){const V=await this.p(M,A,U);if(V)try{const G=[],x=await this.r(V.default,G);if(G.length>0)return G.forEach(b=>{this.j.error(this.t(M,(0,d.localize)(3,null,V.default?.path,(0,h.getParseErrorMessage)(b.error))))}),A;if((0,I.getNodeType)(V)!=="object")return this.j.error(this.t(M,(0,d.localize)(4,null,V.default?.path))),A;const ee=V.values||Object.create(null);return(0,q.localizeManifest)(A,ee,x)}catch{}return A}async p(M,A,U){const V=(0,P.joinPath)(M,"package.nls.json"),G=(D,j)=>{j.forEach(F=>{this.j.error(this.t(M,(0,d.localize)(5,null,D?.path,(0,h.getParseErrorMessage)(F.error))))})},x=D=>{this.j.error(this.t(M,(0,d.localize)(6,null,D?.path)))},ee=`${A.publisher}.${A.name}`,b=U.translations[ee];if(b)try{const D=a.URI.file(b),j=(await this.i.readFile(D)).value.toString(),F=[],B=(0,I.parse)(j,F);return F.length>0?(G(D,F),{values:void 0,default:V}):(0,I.getNodeType)(B)!=="object"?(x(D),{values:void 0,default:V}):{values:B.contents?B.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.i.exists(V))return;let j;try{j=await this.s(M,U)}catch{return}if(!j.localized)return{values:void 0,default:j.original};try{const F=(await this.i.readFile(j.localized)).value.toString(),B=[],W=(0,I.parse)(F,B);return B.length>0?(G(j.localized,B),{values:void 0,default:j.original}):(0,I.getNodeType)(W)!=="object"?(x(j.localized),{values:void 0,default:j.original}):{values:W,default:j.original}}catch{return{values:void 0,default:j.original}}}}async r(M,A){if(M)try{const U=(await this.i.readFile(M)).value.toString();return(0,I.parse)(U,A)}catch{}}s(M,A){return new Promise((U,V)=>{const G=x=>{const ee=(0,P.joinPath)(M,`package.nls.${x}.json`);this.i.exists(ee).then(b=>{b&&U({localized:ee,original:(0,P.joinPath)(M,"package.nls.json")});const D=x.lastIndexOf("-");D===-1?U({localized:(0,P.joinPath)(M,"package.nls.json"),original:null}):(x=x.substring(0,D),G(x))})};if(A.devMode||A.pseudo||!A.language)return U({localized:(0,P.joinPath)(M,"package.nls.json"),original:null});G(A.language)})}t(M,A){return`[${M.path}]: ${A}`}};Q=fe([_(1,g.IExtensionsProfileScannerService),_(2,C.IUriIdentityService),_(3,n.IFileService),_(4,r.ILogService)],Q);let he=class extends Q{constructor(M,A,U,V,G,x){super(A,U,V,G,x),this.y=M,this.v=this.B(new O.ThrottledDelayer(3e3)),this.w=this.B(new u.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(M){const A=await this.C();if(this.u=M,A&&A.input&&re.equals(A.input,this.u))return this.v.trigger(()=>this.F()),A.result.map(V=>(V.location=a.URI.revive(V.location),V));const U=await super.scanExtensions(M);return await this.D({input:M,result:U}),U}async C(){try{const M=await this.i.readFile(this.y),A=JSON.parse(M.value.toString());return{result:A.result,input:(0,l.revive)(A.input)}}catch(M){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(M))}return null}async D(M){try{await this.i.writeFile(this.y,L.VSBuffer.fromString(JSON.stringify(M)))}catch(A){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(A))}}async F(){if(!this.u)return;const M=await this.C();if(!M)return;const A=M.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(U,A))try{await this.i.del(this.y),this.w.fire()}catch(V){this.j.error(V)}}};he=fe([_(2,g.IExtensionsProfileScannerService),_(3,C.IUriIdentityService),_(4,n.IFileService),_(5,r.ILogService)],he);function ce(ge,M){const A=(0,f.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:A,identifier:new s.ExtensionIdentifier(A),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:M,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=ce;class se extends ie{constructor(M,A,U,V,G,x,ee,b,D,j,F,B){super(M,A,(0,P.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,P.joinPath)(V,s.MANIFEST_CACHE_FOLDER),G,x,ee,b,D,j,F,B),this.M=(async()=>{if(p.translationsConfigFile)try{const W=await this.r.readFile(a.URI.file(p.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}f(M){return this.M}}e.NativeExtensionsScannerService=se}),define(Y[142],Z([0,1,56,3,32,4,2,16,14,20,9,25]),function($,e,T,O,k,L,N,I,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends N.Disposable{constructor(y,S){super(),this.b=y,this.f=S,this.a=new O.Limiter(5)}async postUninstall(y){const S=this.g(y,"uninstall");return S&&(this.f.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(S.script,"uninstall",S.args,!0,y).then(()=>this.f.info(y.identifier.id,y.manifest.version,"Finished running post uninstall script"),E=>this.f.error(y.identifier.id,y.manifest.version,`Failed to run post uninstall script: ${E}`)))),c.Promises.rm(this.j(y)).then(void 0,E=>this.f.error("Error while removing extension storage path",E))}g(y,S){const E=`vscode:${S}`;if(y.location.scheme===I.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[E]=="string"){const a=y.manifest.scripts[E].split(" ");return a.length<2||a[0]!=="node"||!a[1]?(this.f.warn(y.identifier.id,y.manifest.version,`${E} should be a node script`),null):{script:(0,h.join)(y.location.fsPath,a[1]),args:a.slice(2)||[]}}return null}h(y,S,E,a,d){return new Promise((v,f)=>{const s=this.i(y,S,E,d);let i;const n=t=>{i&&(clearTimeout(i),i=null),t?f(t):v(void 0)};s.on("error",t=>{n((0,k.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,r)=>{n(t?`post-${S} process exited with code ${t}`:void 0)}),a&&(i=setTimeout(()=>{i=null,s.kill(),f("timed out")},5e3))})}i(y,S,E,a){const d={silent:!0,execArgv:void 0},v=(0,T.fork)(y,[`--type=extension-post-${S}`,...E],d);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(v.stdout,"data"),s=L.Event.fromNodeEventEmitter(v.stderr,"data");f(t=>this.f.info(a.identifier.id,a.manifest.version,`post-${S}`,t)),s(t=>this.f.error(a.identifier.id,a.manifest.version,`post-${S}`,t));const i=L.Event.any(L.Event.map(f,t=>({data:`%c${t}`,format:[""]})),L.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(a.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}j(y){return(0,h.join)(this.b.defaultProfile.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};p=fe([_(0,w.IUserDataProfilesService),_(1,m.ILogService)],p),e.ExtensionsLifecycle=p}),define(Y[143],Z([0,1,10,18,42,48,13,7,9,30,27,25]),function($,e,T,O,k,L,N,I,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends L.NativeExtensionsScannerService{constructor(y,S,E,a,d,v,f,s){super(T.URI.file(d.builtinExtensionsPath),T.URI.file(d.extensionsPath),d.userHome,T.URI.file(d.userDataPath),y,S,E,a,d,v,f,s)}};p=fe([_(0,w.IUserDataProfilesService),_(1,k.IExtensionsProfileScannerService),_(2,N.IFileService),_(3,h.ILogService),_(4,O.INativeEnvironmentService),_(5,c.IProductService),_(6,m.IUriIdentityService),_(7,I.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(Y[144],Z([0,1,3,4,2,114,8,79,7,25]),function($,e,T,O,k,L,N,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var m;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var p;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function P(d){const v=d.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=P;class y extends k.Disposable{constructor(v={flushInterval:y.a}){super(),this.j=v,this.b=this.B(new O.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new O.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.D=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.L()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(v,f){if(f===e.TARGET_KEY){switch(v){case-1:this.D=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:f,target:this.G(v)[f]})}r(v){this.f.fire({reason:v})}get(v,f,s){return this.M(f)?.get(v,s)}getBoolean(v,f,s){return this.M(f)?.getBoolean(v,s)}getNumber(v,f,s){return this.M(f)?.getNumber(v,s)}store(v,f,s,i){if((0,N.isUndefinedOrNull)(f)){this.remove(v,s);return}this.t(()=>{this.u(v,s,i),this.M(s)?.set(v,f)})}remove(v,f){this.t(()=>{this.u(v,f,void 0),this.M(f)?.delete(v)})}t(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,f){const s=[],i=this.G(v);for(const n of Object.keys(i))i[n]===f&&s.push(n);return s}u(v,f,s){const i=this.G(f);typeof s=="number"?i[v]!==s&&(i[v]=s,this.M(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[v]=="number"&&(delete i[v],this.M(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.H(1)),this.v}get C(){return this.y||(this.y=this.H(0)),this.y}get F(){return this.D||(this.D=this.H(-1)),this.D}G(v){switch(v){case-1:return this.F;case 0:return this.C;default:return this.w}}H(v){const f=this.M(v);return f?P(f):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=m.NONE){this.f.fire({reason:v});const f=this.M(-1),s=this.M(0),i=this.M(1);switch(v){case m.NONE:await T.Promises.settled([f?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await T.Promises.settled([f?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.M(-1)?.items??new Map,f=this.M(0)?.items??new Map,s=this.M(1)?.items??new Map;return a(v,f,s,this.N(-1)??"",this.N(0)??"",this.N(1)??"")}async switch(v,f){return this.r(m.NONE),(0,c.isUserDataProfile)(v)?this.O(v,f):this.P(v,f)}I(v,f){return!(v.id===f.id||S(f)&&S(v))}J(v,f,s,i){this.t(()=>{if(i)for(const[n,t]of v)f.set(n,t);else{const n=new Set;for(const[t,r]of v)n.add(t),f.get(t)!==r&&this.n(s,t);for(const[t]of f.items)n.has(t)||this.n(s,t)}})}}e.AbstractStorageService=y,y.a=60*1e3;function S(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class E extends y{constructor(){super(),this.p=this.B(new I.Storage(new I.InMemoryStorageDatabase)),this.Q=this.B(new I.Storage(new I.InMemoryStorageDatabase)),this.R=this.B(new I.Storage(new I.InMemoryStorageDatabase)),this.B(this.R.onDidChangeStorage(v=>this.n(1,v))),this.B(this.Q.onDidChangeStorage(v=>this.n(0,v))),this.B(this.p.onDidChangeStorage(v=>this.n(-1,v)))}M(v){switch(v){case-1:return this.p;case 0:return this.Q;default:return this.R}}N(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async L(){}async O(){}async P(){}hasScope(v){return!1}}e.InMemoryStorageService=E;async function a(d,v,f,s,i,n){const t=X=>{try{return JSON.parse(X)}catch{return X}},r=new Map,o=new Map;d.forEach((X,J)=>{r.set(J,X),o.set(J,t(X))});const u=new Map,l=new Map;v.forEach((X,J)=>{u.set(J,X),l.set(J,t(X))});const g=new Map,R=new Map;f.forEach((X,J)=>{g.set(J,X),R.set(J,t(X))}),console.group(s!==i?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const C=[];if(r.forEach((X,J)=>{C.push({key:J,value:X})}),console.table(C),console.groupEnd(),console.log(o),s!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const X=[];u.forEach((J,ie)=>{X.push({key:ie,value:J})}),console.table(X),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${n})`);const q=[];g.forEach((X,J)=>{q.push({key:J,value:X})}),console.table(q),console.groupEnd(),console.log(R)}e.logStorage=a}),define(Y[145],Z([0,1,19,22,11,12,33,8,10,21,18,23,24,45,13,9,30,47,133,144,36]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y,S,E,a,d,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=L.isWeb?"web":(0,w.getTargetPlatform)(L.platform,N.arch);var i;(function(b){b[b.None=0]="None",b[b.IncludeVersions=1]="IncludeVersions",b[b.IncludeFiles=2]="IncludeFiles",b[b.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",b[b.IncludeSharedAccounts=8]="IncludeSharedAccounts",b[b.IncludeVersionProperties=16]="IncludeVersionProperties",b[b.ExcludeNonValidated=32]="ExcludeNonValidated",b[b.IncludeInstallationTargets=64]="IncludeInstallationTargets",b[b.IncludeAssetUri=128]="IncludeAssetUri",b[b.IncludeStatistics=256]="IncludeStatistics",b[b.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",b[b.Unpublished=4096]="Unpublished",b[b.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...b){return String(b.reduce((D,j)=>D|j,0))}var t;(function(b){b[b.Tag=1]="Tag",b[b.ExtensionId=4]="ExtensionId",b[b.Category=5]="Category",b[b.ExtensionName=7]="ExtensionName",b[b.Target=8]="Target",b[b.Featured=9]="Featured",b[b.SearchText=10]="SearchText",b[b.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class g{constructor(D=l){this.d=D}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(D,j=this.d.pageSize){return new g({...this.d,pageNumber:D,pageSize:j})}withFilter(D,...j){const F=[...this.d.criteria,...j.length?j.map(B=>({filterType:D,value:B})):[{filterType:D}]];return new g({...this.d,criteria:F})}withSortBy(D){return new g({...this.d,sortBy:D})}withSortOrder(D){return new g({...this.d,sortOrder:D})}withFlags(...D){return new g({...this.d,flags:D.reduce((j,F)=>j|F,0)})}withAssetTypes(...D){return new g({...this.d,assetTypes:D})}withSource(D){return new g({...this.d,source:D})}get raw(){const{criteria:D,pageNumber:j,pageSize:F,sortBy:B,sortOrder:W,flags:te,assetTypes:oe}=this.d;return{filters:[{criteria:D,pageNumber:j,pageSize:F,sortBy:B,sortOrder:W}],assetTypes:oe,flags:te}}get searchText(){const D=this.d.criteria.filter(j=>j.filterType===t.SearchText)[0];return D&&D.value?D.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(D=>String(D.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(b,D){const j=(b||[]).filter(F=>F.statisticName===D)[0];return j?j.value:0}function C(b){const D="Microsoft.VisualStudio.Code.Translation.";return b.files.filter(F=>F.assetType.indexOf(D)===0).reduce((F,B)=>{const W=J(b,B.assetType);return W&&F.push([B.assetType.substring(D.length),W]),F},[])}function q(b){if(b.properties){const D=b.properties.filter(B=>B.key===r.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=D.filter(B=>j.test(B.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return J(b,r.Repository)}function X(b){return{uri:`${b.fallbackAssetUri}/${r.VSIX}?redirect=true${b.targetPlatform?`&targetPlatform=${b.targetPlatform}`:""}`,fallbackUri:`${b.fallbackAssetUri}/${r.VSIX}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`}}function J(b,D){return b.files.filter(F=>F.assetType===D)[0]?{uri:`${b.assetUri}/${D}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`,fallbackUri:`${b.fallbackAssetUri}/${D}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`}:null}function ie(b,D){const j=b.properties?b.properties.filter(B=>B.key===D):[],F=j.length>0&&j[0].value;return F?F.split(",").map(B=>(0,p.adoptToGalleryExtensionId)(B)):[]}function re(b){const D=b.properties?b.properties.filter(j=>j.key===o.Engine):[];return D.length>0&&D[0].value||""}function Q(b){const D=b.properties?b.properties.filter(j=>j.key===o.PreRelease):[];return D.length>0&&D[0].value==="true"}function he(b){const D=b.properties?b.properties.filter(F=>F.key===o.LocalizedLanguages):[],j=D.length>0&&D[0].value||"";return j?j.split(","):[]}function ce(b){return b.properties?.find(D=>D.key===o.SponsorLink)?.value}function se(b){return b.indexOf("preview")!==-1}function ge(b){return b.targetPlatform?(0,w.toTargetPlatform)(b.targetPlatform):"undefined"}function M(b){const D=(0,T.distinct)(b.versions.map(ge)),j=!!b.tags?.includes(w.WEB_EXTENSION_TAG),F=D.indexOf("web");return j?F===-1&&D.push("web"):F!==-1&&D.splice(F,1),D}function A(b,D){const j=(0,w.getFallbackTargetPlarforms)(D);for(let F=0;F<b.length;F++){const B=b[F];if(B.version===b[F-1]?.version){let W=F;const te=ge(B);if(te===D)for(;W>0&&b[W-1].version===B.version;)W--;else if(j.includes(te))for(;W>0&&b[W-1].version===B.version&&ge(b[W-1])!==D;)W--;W!==F&&(b.splice(F,1),b.splice(W,0,B))}}return b}e.sortExtensionVersions=A;function U(b,D,j){b.telemetryData={index:D,querySource:j}}function V(b,D,j){const F=b.versions[0],B={manifest:J(D,r.Manifest),readme:J(D,r.Details),changelog:J(D,r.Changelog),license:J(D,r.License),repository:q(D),download:X(D),icon:J(D,r.Icon),signature:J(D,r.Signature),coreTranslations:C(D)};return{identifier:{id:(0,p.getGalleryExtensionId)(b.publisher.publisherName,b.extensionName),uuid:b.extensionId},name:b.extensionName,version:D.version,displayName:b.displayName,publisherId:b.publisher.publisherId,publisher:b.publisher.publisherName,publisherDisplayName:b.publisher.displayName,publisherDomain:b.publisher.domain?{link:b.publisher.domain,verified:!!b.publisher.isDomainVerified}:void 0,publisherSponsorLink:ce(F),description:b.shortDescription||"",installCount:R(b.statistics,"install"),rating:R(b.statistics,"averagerating"),ratingCount:R(b.statistics,"ratingcount"),categories:b.categories||[],tags:b.tags||[],releaseDate:Date.parse(b.releaseDate),lastUpdated:Date.parse(b.lastUpdated),allTargetPlatforms:j,assets:B,properties:{dependencies:ie(D,o.Dependency),extensionPack:ie(D,o.ExtensionPack),engine:re(D),localizedLanguages:he(D),targetPlatform:ge(D),isPreReleaseVersion:Q(D)},hasPreReleaseVersion:Q(F),hasReleaseVersion:!0,preview:se(b.flags),isSigned:!!B.signature}}let G=class{constructor(D,j,F,B,W,te,oe,me){this.k=j,this.l=F,this.n=B,this.o=W,this.q=te,this.u=oe,this.w=me;const ye=oe.extensionsGallery,ae=ye?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ae?ye.servicePPEUrl:ye?.serviceUrl,this.g=ae?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(oe.version,oe,this.n,this.w,this.q,D,this.o)}x(D=""){return`${this.d}${D}`}isEnabled(){return!!this.d}async getExtensions(D,j,F){const B=O.CancellationToken.isCancellationToken(j)?{}:j,W=O.CancellationToken.isCancellationToken(j)?j:F,te=[],oe=[],me=[],ye=[];let ae=!0;for(const le of D){le.uuid?oe.push(le.uuid):te.push(le.id);const ve=!!(le.version||le.preRelease);me.push({id:le.id,uuid:le.uuid,includePreRelease:ve}),le.version&&ye.push({id:le.id,uuid:le.uuid,version:le.version}),ae=ae&&!!le.hasPreRelease&&!ve}if(!oe.length&&!te.length)return[];let ne=new g().withPage(1,D.length);oe.length&&(ne=ne.withFilter(t.ExtensionId,...oe)),te.length&&(ne=ne.withFilter(t.ExtensionName,...te)),(B.queryAllVersions||ae)&&(ne=ne.withFlags(ne.flags,i.IncludeVersions)),B.source&&(ne=ne.withSource(B.source));const{extensions:de}=await this.A(ne,{targetPlatform:B.targetPlatform??s,includePreRelease:me,versions:ye,compatible:!!B.compatible},W);return B.source&&de.forEach((le,ve)=>U(le,ve,B.source)),de}async getCompatibleExtension(D,j,F){if((0,w.isNotWebExtensionInWebTargetPlatform)(D.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(D,j,F))return D;const B=new g().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,D.identifier.uuid),{extensions:W}=await this.A(B,{targetPlatform:F,compatible:!0,includePreRelease:j},O.CancellationToken.None);return W[0]||null}async isExtensionCompatible(D,j,F){if(!(0,w.isTargetPlatformCompatible)(D.properties.targetPlatform,D.allTargetPlatforms,F)||!j&&D.properties.isPreReleaseVersion)return!1;let B=D.properties.engine;if(!B){const W=await this.getManifest(D,O.CancellationToken.None);if(!W)throw new Error("Manifest was not found");B=W.engines.vscode}return(0,P.isEngineValid)(B,this.u.version,this.u.date)}async y(D,j,F,B,W){if(!(0,w.isTargetPlatformCompatible)(ge(D),B,W)||j!=="any"&&Q(D)!==(j==="prerelease"))return!1;if(F)try{const te=await this.F(D);if(!(0,P.isEngineValid)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${D.version}.`,(0,k.getErrorMessage)(te)),!1}return!0}async query(D,j){let F=D.text||"";const B=D.pageSize??50;let W=new g().withPage(1,B);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,ne,de)=>(W=W.withFilter(t.Category,de||ne),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,ne,de)=>(W=W.withFilter(t.Tag,de||ne),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(t.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),W=W.withFilter(t.SearchText,F)),W=W.withSortBy(0)):D.ids?W=W.withFilter(t.ExtensionId,...D.ids):D.names?W=W.withFilter(t.ExtensionName,...D.names):W=W.withSortBy(4),typeof D.sortBy=="number"&&(W=W.withSortBy(D.sortBy)),typeof D.sortOrder=="number"&&(W=W.withSortOrder(D.sortOrder)),D.source&&(W=W.withSource(D.source));const te=async(ae,ne)=>{const{extensions:de,total:le}=await this.A(ae,{targetPlatform:s,compatible:!1,includePreRelease:!!D.includePreRelease},ne);return de.forEach((ve,Me)=>U(ve,(ae.pageNumber-1)*ae.pageSize+Me,D.source)),{extensions:de,total:le}},{extensions:oe,total:me}=await te(W,j),ye=async(ae,ne)=>{if(ne.isCancellationRequested)throw new k.CancellationError;const{extensions:de}=await te(W.withPage(ae+1),ne);return de};return{firstPage:oe,total:me,pageSize:W.pageSize,getPage:ye}}async A(D,j,F){const B=D.flags;!!(D.flags&i.IncludeLatestVersionOnly)&&!!(D.flags&i.IncludeVersions)&&(D=D.withFlags(D.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(D.flags&i.IncludeLatestVersionOnly)&&!(D.flags&i.IncludeVersions)&&(D=D.withFlags(D.flags,i.IncludeLatestVersionOnly)),j.versions?.length&&(D=D.withFlags(D.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),D=D.withFlags(D.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:W,total:te}=await this.C(D,F);if(!(D.flags&i.IncludeLatestVersionOnly)){const ae=[];for(const ne of W){const de=await this.B(ne,j);de&&ae.push(de)}return{extensions:ae,total:te}}const me=[],ye=new Map;for(let ae=0;ae<W.length;ae++){const ne=W[ae],de={id:(0,p.getGalleryExtensionId)(ne.publisher.publisherName,ne.extensionName),uuid:ne.extensionId},le=(0,I.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(Me=>(0,p.areSameExtensions)(Me,de))?.includePreRelease;if(j.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(M(ne),j.targetPlatform))continue;const ve=await this.B(ne,j);!ve||ve.properties.isPreReleaseVersion&&(!le||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==j.targetPlatform&&ve.hasPreReleaseVersion?ye.set(ne.extensionId,ae):me.push([ae,ve])}if(ye.size){const ae=new Date().getTime(),ne=new g().withFlags(B&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ye.size).withFilter(t.ExtensionId,...ye.keys()),{extensions:de}=await this.A(ne,j,F);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ae,count:ye.size});for(const le of de){const ve=ye.get(le.identifier.uuid);me.push([ve,le])}}return{extensions:me.sort((ae,ne)=>ae[0]-ne[0]).map(([,ae])=>ae),total:te}}async B(D,j){const F={id:(0,p.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},B=j.versions?.find(me=>(0,p.areSameExtensions)(me,F))?.version,W=(0,I.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(me=>(0,p.areSameExtensions)(me,F))?.includePreRelease,te=M(D),oe=A(D.versions,j.targetPlatform);if(j.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(te,j.targetPlatform))return null;for(let me=0;me<oe.length;me++){const ye=oe[me];if(!(B&&ye.version!==B)){if(await this.y(ye,W?"any":"release",j.compatible,te,j.targetPlatform))return V(D,ye,te);if(B&&ye.version===B)return null}}return B||j.compatible?null:V(D,D.versions[0],te)}async C(D,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");D=D.withFlags(D.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(i.Unpublished));const F=await this.j,B=JSON.stringify(D.raw),W={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},te=new Date().getTime();let oe,me,ye=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&D.criteria.some(ne=>ne.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:B,headers:W},j),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:ye};const ae=await(0,a.asJson)(oe);if(ae){const ne=ae.results[0],de=ne.extensions,le=ne.resultMetadata&&ne.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return ye=le&&le.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye}}return{galleryExtensions:[],total:ye}}catch(ae){throw me=ae,ae}finally{this.o.publicLog2("galleryService:query",{...D.telemetryData,requestBodySize:String(B.length),duration:new Date().getTime()-te,success:!!oe&&(0,a.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:me?(0,k.isCancellationError)(me)?"canceled":(0,k.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(D,j,F,B){if(!this.isEnabled())return;const W=L.isWeb?this.x(`/itemName/${D}.${j}/version/${F}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${D}/extensions/${j}/${F}/stats?statType=${B}`),te=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:W,headers:me},O.CancellationToken.None)}catch{}}async download(D,j,F){this.l.trace("ExtensionGalleryService#download",D.identifier.id);const B=(0,p.getGalleryExtensionTelemetryData)(D),W=new Date().getTime(),te=ae=>this.o.publicLog("galleryService:downloadVSIX",{...B,duration:ae}),oe=F===2?"install":F===3?"update":"",me=oe?{uri:`${D.assets.download.uri}${h.URI.parse(D.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${D.assets.download.fallbackUri}${h.URI.parse(D.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:D.assets.download,ye=await this.E(me);await this.q.writeFile(j,ye.stream),te(new Date().getTime()-W)}async downloadSignatureArchive(D,j){if(!D.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",D.identifier.id);const F=await this.E(D.assets.signature);await this.q.writeFile(j,F.stream)}async getReadme(D,j){if(D.assets.readme){const F=await this.E(D.assets.readme,{},j);return await(0,a.asTextOrError)(F)||""}return""}async getManifest(D,j){if(D.assets.manifest){const F=await this.E(D.assets.manifest,{},j),B=await(0,a.asTextOrError)(F);return B?JSON.parse(B):null}return null}async D(D,j){const F=J(D,r.Manifest);if(!F)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},W=await this.E(F,{headers:B});return await(0,a.asJson)(W)}async getCoreTranslation(D,j){const F=D.assets.coreTranslations.filter(B=>B[0]===j.toUpperCase())[0];if(F){const B=await this.E(F[1]),W=await(0,a.asTextOrError)(B);return W?JSON.parse(W):null}return null}async getChangelog(D,j){if(D.assets.changelog){const F=await this.E(D.assets.changelog,{},j);return await(0,a.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(D,j,F){let B=new g().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);D.identifier.uuid?B=B.withFilter(t.ExtensionId,D.identifier.uuid):B=B.withFilter(t.ExtensionName,D.identifier.id);const{galleryExtensions:W}=await this.C(B,O.CancellationToken.None);if(!W.length)return[];const te=M(W[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(te,F))return[];const oe=[];await Promise.all(W[0].versions.map(async ae=>{try{await this.y(ae,j?"any":"release",!0,te,F)&&oe.push(ae)}catch{}}));const me=[],ye=new Set;for(const ae of A(oe,F))ye.has(ae.version)||(ye.add(ae.version),me.push({version:ae.version,date:ae.lastUpdated,isPreReleaseVersion:Q(ae)}));return me}async E(D,j={},F=O.CancellationToken.None){const B=await this.j,W={type:"GET"},te={...B,...j.headers||{}};j={...j,...W,headers:te};const oe=D.uri,me=D.fallbackUri,ye={...j,url:oe};try{const ae=await this.k.request(ye,F);if(ae.res.statusCode===200)return ae;const ne=await(0,a.asTextOrError)(ae);throw new Error(`Expected 200, got back ${ae.res.statusCode} instead.

${ne}`)}catch(ae){if((0,k.isCancellationError)(ae))throw ae;const ne=(0,k.getErrorMessage)(ae);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:ne});const de={...j,url:me};return this.k.request(de,F)}}async F(D){let j=re(D);if(!j){const F=await this.D(D,O.CancellationToken.None);if(!F)throw new Error("Manifest was not found");j=F.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const D=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(D.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,a.asJson)(D),F=[],B={};if(j){for(const W of j.malicious)F.push({id:W});if(j.migrateToPreRelease)for(const[W,te]of Object.entries(j.migrateToPreRelease))(!te.engine||(0,P.isEngineValid)(te.engine,this.u.version,this.u.date))&&(B[W.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(j.deprecated)for(const[W,te]of Object.entries(j.deprecated))te&&(B[W.toLowerCase()]=(0,I.isBoolean)(te)?{}:te)}return{malicious:F,deprecated:B}}};G=fe([_(1,a.IRequestService),_(2,S.ILogService),_(3,m.IEnvironmentService),_(4,f.ITelemetryService),_(5,y.IFileService),_(6,E.IProductService),_(7,c.IConfigurationService)],G);let x=class extends G{constructor(D,j,F,B,W,te,oe,me){super(D,j,F,B,W,te,oe,me)}};x=fe([_(0,v.IStorageService),_(1,a.IRequestService),_(2,S.ILogService),_(3,m.IEnvironmentService),_(4,f.ITelemetryService),_(5,y.IFileService),_(6,E.IProductService),_(7,c.IConfigurationService)],x),e.ExtensionGalleryService=x;let ee=class extends G{constructor(D,j,F,B,W,te,oe){super(void 0,D,j,F,B,W,te,oe)}};ee=fe([_(0,a.IRequestService),_(1,S.ILogService),_(2,m.IEnvironmentService),_(3,f.ITelemetryService),_(4,y.IFileService),_(5,E.IProductService),_(6,c.IConfigurationService)],ee),e.ExtensionGalleryServiceWithNoStorageService=ee}),define(Y[146],Z([0,1,44,10,18,13,9,65,27,25]),function($,e,T,O,k,L,N,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class $e extends c.UserDataProfilesService{constructor(p,P,y,S,E){super(y,S,P,E),this.a=p,this.O=y}I(){return(0,T.revive)(this.a.getItem($e.b,[]))}L(){return(0,T.revive)(this.a.getItem($e.c,{}))}N(){return this.r.extUri.joinPath(O.URI.file(this.O.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};m=fe([_(0,I.IStateService),_(1,h.IUriIdentityService),_(2,k.INativeEnvironmentService),_(3,L.IFileService),_(4,N.ILogService)],m),e.UserDataProfilesService=m}),define(Y[147],Z([0,1,37,3,160,2,9]),function($,e,T,O,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=class extends T.AbstractPolicyService{constructor(c,m){super(),this.j=c,this.k=m,this.a=new O.Throttler,this.b=this.B(new L.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((m,w)=>{try{this.b.value=(0,k.createWatcher)(this.k,c,p=>{this.m(p),m()})}catch(p){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),w(p)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const m in c){const w=c[m];w===void 0?this.g.delete(m):this.g.set(m,w)}this.h.fire(Object.keys(c))}};I=fe([_(0,N.ILogService)],I),e.NativePolicyService=I}),define(Y[67],Z([0,1,116,3,14,8,20,80,161,162]),function($,e,T,O,k,L,N,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class m extends Error{constructor(i,n){let t=n.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=n}}e.ExtractError=m;function w(s){const i=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,t)=>n+t,i&61440)}function p(s){if(s instanceof m)return s;let i;return/end of central directory record signature not found/.test(s.message)&&(i="CorruptZip"),new m(i,s)}function P(s,i,n,t,r,o){const u=k.dirname(i),l=k.join(t,u);if(!l.startsWith(t))return Promise.reject(new Error(I.localize(0,null,i)));const g=k.join(t,i);let R;return o.onCancellationRequested(()=>{R?.destroy()}),Promise.resolve(N.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((C,q)=>{if(!o.isCancellationRequested)try{R=(0,T.createWriteStream)(g,{mode:n}),R.once("close",()=>C()),R.once("error",q),s.once("error",q),s.pipe(R)}catch(X){q(X)}}))}function y(s,i,n,t){let r=(0,O.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((u,l)=>{const g=new O.Sequencer,R=C=>{C.isCancellationRequested||(o++,s.readEntry())};s.once("error",l),s.once("close",()=>r.then(()=>{t.isCancellationRequested||s.entryCount===o?u():l(new m("Incomplete",new Error(I.localize(1,null,o,s.entryCount))))},l)),s.readEntry(),s.on("entry",C=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(C.fileName)){R(t);return}const q=C.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(q)){const ie=k.join(i,q);r=(0,O.createCancelablePromise)(re=>N.Promises.mkdir(ie,{recursive:!0}).then(()=>R(re)).then(void 0,l));return}const X=E(s,C),J=w(C);r=(0,O.createCancelablePromise)(ie=>g.queue(()=>X.then(re=>P(re,q,J,i,n,ie).then(()=>R(ie)))).then(null,l))})})}function S(s,i=!1){return new Promise((n,t)=>{(0,h.open)(s,i?{lazyEntries:!0}:void 0,(r,o)=>{r?t(p(r)):n((0,L.assertIsDefined)(o))})})}function E(s,i){return new Promise((n,t)=>{s.openReadStream(i,(r,o)=>{r?t(p(r)):n((0,L.assertIsDefined)(o))})})}function a(s,i){return new Promise((n,t)=>{const r=new c.ZipFile;i.forEach(u=>{u.contents?r.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&r.addFile(u.localPath,u.path)}),r.end();const o=(0,T.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>n(s))})}e.zip=a;function d(s,i,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=S(s,!0);return n.overwrite&&(o=o.then(u=>N.Promises.rm(i).then(()=>u))),o.then(u=>y(u,i,{sourcePathRegex:r},t))}e.extract=d;function v(s,i){return S(s).then(n=>new Promise((t,r)=>{n.on("entry",o=>{o.fileName===i&&E(n,o).then(u=>t(u),u=>r(u))}),n.once("close",()=>r(new Error(I.localize(2,null,i))))}))}function f(s,i){return v(s,i).then(n=>new Promise((t,r)=>{const o=[];n.once("error",r),n.on("data",u=>o.push(u)),n.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(Y[148],Z([0,1,67,88]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(L){return(0,T.buffer)(L,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=k}),define(Y[149],Z([0,1,3,22,32,11,4,2,34,16,14,12,17,39,8,10,31,20,67,87,57,18,141,23,24,42,48,124,142,148,125,126,26,45,13,7,9,30,36,27,25]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y,S,E,a,d,v,f,s,i,n,t,r,o,u,l,g,R,C,q,X,J,ie,re,Q,he,ce,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(n.IExtensionManagementService);let ge=class extends i.AbstractExtensionManagementService{constructor(b,D,j,F,B,W,te,oe,me,ye,ae,ne){super(b,D,j,ye,ne),this.ab=B,this.bb=W,this.cb=te,this.db=me,this.eb=ae,this.Y=new Map,this.mb=new h.ResourceSet;const de=this.B(oe.createInstance(l.ExtensionsLifecycle));this.U=this.B(oe.createInstance(M,ve=>de.postUninstall(ve))),this.W=this.B(new R.ExtensionsManifestCache(F,this)),this.X=this.B(oe.createInstance(u.ExtensionsDownloader));const le=this.B(new C.ExtensionsWatcher(this,this.ab,ne,W,ae,me,j));this.B(le.onDidChangeExtensionsByAnotherSource(ve=>this.lb(ve))),this.nb()}getTargetPlatform(){return this.fb||(this.fb=(0,t.computeTargetPlatform)(this.db,this.v)),this.fb}async zip(b){this.v.trace("ExtensionManagementService#zip",b.identifier.id);const D=await this.kb(b),j=await(0,d.zip)((0,p.joinPath)(this.X.extensionsDownloadDir,(0,E.generateUuid)()).fsPath,D);return S.URI.file(j)}async unzip(b){return this.v.trace("ExtensionManagementService#unzip",b.toString()),(await this.install(b)).identifier}async getManifest(b){const{location:D,cleanup:j}=await this.gb(b),F=m.resolve(D.fsPath);try{return await(0,g.getManifest)(F)}finally{await j()}}getInstalled(b,D){return this.U.scanExtensions(b??null,D)}getAllUserInstalled(){return this.U.scanAllUserExtensions(!1)}async install(b,D={}){this.v.trace("ExtensionManagementService#install",b.toString());const{location:j,cleanup:F}=await this.gb(b);try{const B=await(0,g.getManifest)(m.resolve(j.fsPath));if(B.engines&&B.engines.vscode&&!(0,X.isEngineValid)(B.engines.vscode,this.w.version,this.w.date))throw new Error(v.localize(0,null,(0,t.getGalleryExtensionId)(B.publisher,B.name),this.w.version));return await this.C(B,j,D)}finally{await F()}}async installFromLocation(b,D){this.v.trace("ExtensionManagementService#installFromLocation",b.toString());const j=await this.U.scanUserExtensionAtLocation(b);if(!j)throw new Error(`Cannot find a valid extension from the location ${b.toString()}`);return await this.pb([j],D),this.v.info("Successfully installed extension",j.identifier.id,D.toString()),j}getMetadata(b){return this.ab.scanMetadata(b.location)}async updateMetadata(b,D){this.v.trace("ExtensionManagementService#updateMetadata",b.identifier.id);const j={...D};return D.isPreReleaseVersion&&(j.preRelease=!0),b=await this.U.updateMetadata(b,j),this.W.invalidate(),b}async updateExtensionScope(b,D){return this.v.trace("ExtensionManagementService#updateExtensionScope",b.identifier.id),b=await this.U.updateMetadata(b,{isMachineScoped:D}),this.W.invalidate(),b}async reinstallFromGallery(b){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",b.identifier.id),!this.t.isEnabled())throw new Error(v.localize(1,null));const D=await this.getTargetPlatform(),[j]=await this.t.getExtensions([{...b.identifier,preRelease:b.preRelease}],{targetPlatform:D,compatible:!0},O.CancellationToken.None);if(!j)throw new Error(v.localize(2,null));await this.U.setUninstalled(b);try{await this.U.removeUninstalledExtension(b)}catch(F){throw new Error(v.localize(3,null,(0,k.toErrorMessage)(F)))}await this.installFromGallery(j)}markAsUninstalled(...b){return this.U.setUninstalled(...b)}removeUninstalledExtensions(){return this.U.cleanUp()}async download(b,D){const{location:j}=await this.X.download(b,D);return j}async gb(b){if(b.scheme===c.Schemas.file)return{location:b,async cleanup(){}};this.v.trace("Downloading extension from",b.toString());const D=(0,p.joinPath)(this.X.extensionsDownloadDir,(0,E.generateUuid)());return await this.cb.download(b,D),this.v.info("Downloaded extension to",D.toString()),{location:D,cleanup:async()=>{try{await this.db.del(D)}catch(F){this.v.error(F)}}}}Q(){return this.y.defaultProfile.extensionsResource}R(b,D,j){let F;if(S.URI.isUri(D))F=new V(b,D,j,this.t,this.U,this.v);else{const B=t.ExtensionKey.create(D).toString();F=this.Y.get(B),F||(this.Y.set(B,F=new U(b,D,j,this.X,this.U,this.v)),F.waitUntilTaskIsFinished().then(()=>this.Y.delete(B)))}return new G(F,j.profileLocation,this.bb)}S(b,D){return new x(b,D.profileLocation,this.bb)}async kb(b){const D=async F=>{let B=await a.Promises.readdir(F);B=B.map(oe=>m.join(F,oe));const W=await Promise.all(B.map(oe=>a.Promises.stat(oe)));let te=Promise.resolve([]);return W.forEach((oe,me)=>{const ye=B[me];oe.isFile()&&(te=te.then(ae=>[...ae,ye])),oe.isDirectory()&&(te=te.then(ae=>D(ye).then(ne=>[...ae,...ne])))}),te};return(await D(b.location.fsPath)).map(F=>({path:`extension/${m.relative(b.location.fsPath,F)}`,localPath:F}))}async lb({added:b,removed:D}){if(D)for(const j of D.extensions)this.v.info("Extensions removed from another source",j.id,D.profileLocation.toString()),this.p.fire({identifier:j,profileLocation:D.profileLocation});if(b){const F=(await this.U.scanExtensions(1,b.profileLocation)).filter(B=>b.extensions.some(W=>(0,t.areSameExtensions)(W,B.identifier)));this.m.fire(F.map(B=>(this.v.info("Extensions added from another source",B.identifier.id,b.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:b.profileLocation,operation:1})))}}async nb(){this.B(this.U.onExtract(D=>this.mb.add(D)));const b=await this.db.resolve(this.ab.userExtensionsLocation);for(const D of b.children??[])D.isDirectory&&this.mb.add(D.resource);this.B(this.db.watch(this.ab.userExtensionsLocation)),this.B(this.db.onDidFilesChange(D=>this.ob(D)))}async ob(b){const D=[];for(const j of b.rawAdded){if(this.mb.has(j)||!this.eb.extUri.isEqual(this.eb.extUri.dirname(j),this.ab.userExtensionsLocation)||this.eb.extUri.isEqual(j,this.eb.extUri.joinPath(this.ab.userExtensionsLocation,".obsolete"))||this.eb.extUri.basename(j).startsWith(".")||!(await this.db.stat(j)).isDirectory)continue;const F=await this.U.scanUserExtensionAtLocation(j);F&&F.installedTimestamp===void 0&&(this.mb.add(j),D.push(F))}D.length&&(await this.pb(D,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",D.map(j=>j.identifier.id)))}async pb(b,D){await this.bb.addExtensionsToProfile(b.map(j=>[j,void 0]),D),this.m.fire(b.map(j=>({local:j,identifier:j.identifier,operation:1,profileLocation:D})))}};ge=fe([_(0,n.IExtensionGalleryService),_(1,he.ITelemetryService),_(2,re.ILogService),_(3,s.INativeEnvironmentService),_(4,o.IExtensionsScannerService),_(5,r.IExtensionsProfileScannerService),_(6,f.IDownloadService),_(7,ie.IInstantiationService),_(8,J.IFileService),_(9,Q.IProductService),_(10,ce.IUriIdentityService),_(11,se.IUserDataProfilesService)],ge),e.ExtensionManagementService=ge;let M=class extends I.Disposable{constructor(b,D,j,F){super(),this.j=b,this.k=D,this.l=j,this.m=F,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,p.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new T.Queue}async cleanUp(){await this.v()}async scanExtensions(b,D){await this.l.initializeDefaultProfileExtensions();const j={includeInvalid:!0,profileLocation:D};let F=[];return b===null||b===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},j,!1)):b===1&&F.push(...await this.l.scanUserExtensions(j)),F=b!==null?F.filter(B=>B.type===b):F,Promise.all(F.map(B=>this.u(B)))}async scanAllUserExtensions(b){const D=await this.l.scanUserExtensions({includeAllVersions:!b,includeInvalid:!0});return Promise.all(D.map(j=>this.u(j)))}async scanUserExtensionAtLocation(b){try{const D=await this.l.scanExistingExtension(b,1,{includeInvalid:!0});if(D)return await this.u(D)}catch(D){this.m.error(D)}return null}async extractUserExtension(b,D,j,F){await this.l.initializeDefaultProfileExtensions();const B=b.toString(),W=m.join(this.l.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),te=m.join(this.l.userExtensionsLocation.fsPath,B);try{await a.Promises.rm(te)}catch{throw new n.ExtensionManagementError(v.localize(4,null,te,b.id),n.ExtensionManagementErrorCode.Delete)}await this.p(b,D,W,F),await this.l.updateMetadata(S.URI.file(W),j);try{this.h.fire(S.URI.file(te)),await this.s(b,W,te,Date.now()+2*60*1e3),this.m.info("Renamed to",te)}catch(oe){try{await a.Promises.rm(W)}catch{}if(oe.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",b.id);else throw this.m.info(`Rename failed because of ${(0,L.getErrorMessage)(oe)}. Deleted from extracted location`,W),oe}return this.t(S.URI.file(te),1)}async updateMetadata(b,D){return await this.l.updateMetadata(b.location,D),this.t(b.location,b.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...b){const D=b.map(j=>t.ExtensionKey.create(j));await this.n(j=>D.forEach(F=>{j[F.toString()]=!0,this.m.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(b){await this.n(F=>delete F[b.toString()]);const j=(await this.scanAllUserExtensions(!0)).find(F=>t.ExtensionKey.create(F).equals(b))||null;return j?this.updateMetadata(j,{installedTimestamp:Date.now()}):null}async removeExtension(b,D){this.m.trace(`Deleting ${D} extension from disk`,b.identifier.id,b.location.fsPath),await a.Promises.rm(b.location.fsPath),this.m.info("Deleted from disk",b.identifier.id,b.location.fsPath)}async removeUninstalledExtension(b){await this.removeExtension(b,"uninstalled"),await this.n(D=>delete D[t.ExtensionKey.create(b).toString()])}async n(b){return this.g.queue(async()=>{let D;try{D=await a.Promises.readFile(this.c,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let j={};if(D)try{j=JSON.parse(D)}catch{}return b&&(b(j),Object.keys(j).length?await a.Promises.writeFile(this.c,JSON.stringify(j)):await a.Promises.rm(this.c)),j})}async p(b,D,j,F){this.m.trace(`Started extracting the extension from ${D} to ${j}`);try{await a.Promises.rm(j)}catch(B){throw new n.ExtensionManagementError(this.w(B).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(D,j,{sourcePath:"extension",overwrite:!0},F),this.m.info(`Extracted extension to ${j}:`,b.id)}catch(B){try{await a.Promises.rm(j)}catch{}let W=n.ExtensionManagementErrorCode.Extract;throw B instanceof d.ExtractError&&(B.type==="CorruptZip"?W=n.ExtensionManagementErrorCode.CorruptZip:B.type==="Incomplete"&&(W=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(B.message,W)}}async s(b,D,j,F){try{await a.Promises.rename(D,j)}catch(B){if(w.isWindows&&B&&B.code==="EPERM"&&Date.now()<F)return this.m.info(`Failed renaming ${D} to ${j} with 'EPERM' error. Trying again...`,b.id),this.s(b,D,j,F);throw new n.ExtensionManagementError(B.message||v.localize(5,null,D,j),B.code||n.ExtensionManagementErrorCode.Rename)}}async t(b,D){const j=await this.l.scanExistingExtension(b,D,{includeInvalid:!0});if(j)return this.u(j);throw new Error(v.localize(6,null,b.path))}async u(b){const D=await this.k.resolve(b.location);let j,F;return D.children&&(j=D.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,F=D.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:b.identifier,type:b.type,isBuiltin:b.isBuiltin||!!b.metadata?.isBuiltin,location:b.location,manifest:b.manifest,targetPlatform:b.targetPlatform,validations:b.validations,isValid:b.isValid,readmeUrl:j,changelogUrl:F,publisherDisplayName:b.metadata?.publisherDisplayName||null,publisherId:b.metadata?.publisherId||null,isApplicationScoped:!!b.metadata?.isApplicationScoped,isMachineScoped:!!b.metadata?.isMachineScoped,isPreReleaseVersion:!!b.metadata?.isPreReleaseVersion,preRelease:!!b.metadata?.preRelease,installedTimestamp:b.metadata?.installedTimestamp,updated:!!b.metadata?.updated}}async v(){const b=await this.getUninstalledExtensions(),D=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const W of D)b[t.ExtensionKey.create(W).toString()]||j.add(W.identifier.id.toLowerCase());const F=(0,t.groupByExtension)(D,W=>W.identifier);await T.Promises.settled(F.map(async W=>{const te=W.sort((oe,me)=>P.rcompare(oe.manifest.version,me.manifest.version))[0];j.has(te.identifier.id.toLowerCase())||await this.j(await this.u(te))}));const B=D.filter(W=>b[t.ExtensionKey.create(W).toString()]);await T.Promises.settled(B.map(W=>this.removeUninstalledExtension(W)))}w(b){const D=Array.isArray(b)?b:[b];return D.length===1?D[0]instanceof Error?D[0]:new Error(D[0]):D.reduce((j,F)=>new Error(`${j.message}${j.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};M=fe([_(1,J.IFileService),_(2,o.IExtensionsScannerService),_(3,re.ILogService)],M),e.ExtensionsScanner=M;class A extends i.AbstractExtensionTask{get operation(){return(0,y.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(b,D,j,F,B){super(),this.identifier=b,this.source=D,this.k=j,this.l=F,this.m=B,this.wasVerified=!1,this.j=2}async n(b,D){try{const j=await this.o(b.key);if(j)return this.l.updateMetadata(j,b.metadata)}catch{throw w.isMacintosh?new n.ExtensionManagementError(v.localize(7,null),n.ExtensionManagementErrorCode.Internal):new n.ExtensionManagementError(v.localize(8,null),n.ExtensionManagementErrorCode.Internal)}return this.q(b,D)}async o(b){if(!await this.p(b))return null;this.m.trace("Removing the extension from uninstalled list:",b.id);const j=await this.l.setInstalled(b);return this.m.info("Removed the extension from uninstalled list:",b.id),j}async p(b){return!!(await this.l.getUninstalledExtensions())[b.toString()]}async q({zipPath:b,key:D,metadata:j},F){const B=await this.l.extractUserExtension(D,b,j,F);return this.m.info("Extracting completed.",D.id),B}}class U extends A{constructor(b,D,j,F,B,W){super(D.identifier,D,j,B,W),this.s=b,this.t=D,this.u=F}async h(b){const j=(await this.l.scanExtensions(null,void 0)).find(te=>(0,t.areSameExtensions)(te.identifier,this.t.identifier));j&&(this.j=3);const F={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,q.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||j?.isMachineScoped,isBuiltin:this.k.isBuiltin||j?.isBuiltin,isSystem:j?.type===0?!0:void 0,updated:!!j,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,y.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:j?.preRelease)};if(j?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(j,F),metadata:F};const{location:B,verified:W}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!W,this.w(B.fsPath),{local:await this.n({zipPath:B.fsPath,key:t.ExtensionKey.create(this.t),metadata:F},b),metadata:F}}catch(te){try{await this.u.delete(B)}catch(oe){this.m.warn("Error while deleting the downloaded file",B.toString(),(0,L.getErrorMessage)(oe))}throw te}}async w(b){try{await(0,g.getManifest)(b)}catch(D){throw new n.ExtensionManagementError((0,i.joinErrors)(D).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=U;class V extends A{constructor(b,D,j,F,B,W){super({id:(0,t.getGalleryExtensionId)(b.publisher,b.name)},D,j,B,W),this.s=b,this.t=D,this.u=F}async h(b){const D=new t.ExtensionKey(this.identifier,this.s.version),F=(await this.l.scanExtensions(1,void 0)).find(te=>(0,t.areSameExtensions)(this.identifier,te.identifier)),B=await this.w(this.identifier.id,this.s.version,b);if(B.isApplicationScoped=(0,q.isApplicationScopedExtension)(this.s),B.isMachineScoped=this.k.isMachineScoped||F?.isMachineScoped,B.isBuiltin=this.k.isBuiltin||F?.isBuiltin,B.installedTimestamp=Date.now(),F)if(this.j=3,D.equals(new t.ExtensionKey(F.identifier,F.manifest.version)))try{await this.l.removeExtension(F,"existing")}catch{throw new Error(v.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&P.gt(F.manifest.version,this.s.version)&&await this.l.setUninstalled(F);else{const te=await this.o(D);if(te)try{await this.l.removeExtension(te,"existing")}catch{throw new Error(v.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:m.resolve(this.t.fsPath),key:D,metadata:B},b),metadata:B}}async w(b,D,j){try{let[F]=await this.u.getExtensions([{id:b,version:D}],j);if(F||([F]=await this.u.getExtensions([{id:b}],j)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class G{constructor(b,D,j){this.d=b,this.g=D,this.h=j,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const b=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[b.local,b.metadata]],this.g),b}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class x extends i.AbstractExtensionTask{constructor(b,D,j){super(),this.extension=b,this.j=D,this.k=j}async h(b){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Y[150],Z([0,1,130,3,15,11,2,8,21,18,131,9,129,163]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends N.Disposable{constructor(E,a,d){super(),this.h=a,this.i=d,this.j(E.getValue()),this.B(E.onDidChangeConfiguration(()=>this.j(E.getValue()),this))}j(E){this.a=E.http&&E.http.proxy,this.b=!!(E.http&&E.http.proxyStrictSSL),this.f=E.http&&E.http.proxyAuthorization}async request(E,a){this.i.trace("RequestService#request (node) - begin",E.url);const{a:d,b:v}=this;let f;try{f=await(0,m.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(n){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...f},i=E.agent?E.agent:await(0,p.getProxyAgent)(E.url||"",s,{proxyUrl:d,strictSSL:v});E.agent=i,E.strictSSL=v,this.f&&(E.headers={...E.headers||{},"Proxy-Authorization":this.f});try{const n=await this.l(E,a);return this.i.trace("RequestService#request (node) - success",E.url),n}catch(n){throw this.i.trace("RequestService#request (node) - error",E.url,n),n}}async k(E){return((0,T.parse)(E.url).protocol==="https:"?await new Promise((v,f)=>{$(["https"],v,f)}):await new Promise((v,f)=>{$(["http"],v,f)})).request}l(E,a){return O.Promises.withAsyncBody(async(d,v)=>{const f=(0,T.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.k(E),i={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,I.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(i.auth=E.user+":"+E.password);const n=s(i,t=>{const r=(0,I.isNumber)(E.followRedirects)?E.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)this.l({...E,url:t.headers.location,followRedirects:r-1},a).then(d,v);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,P.createGunzip)())),d({res:t,stream:(0,k.streamToBufferReadableStream)(o)})}});n.on("error",v),E.timeout&&n.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&n.write(E.data),n.end(),a.onCancellationRequested(()=>{n.abort(),v(new L.CancellationError)})})}async resolveProxy(E){}};y=fe([_(0,h.IConfigurationService),_(1,c.INativeEnvironmentService),_(2,w.ILogService)],y),e.RequestService=y}),define(Y[164],Z([0,1,38,3,15,32,11,2,16,14,12,33,10,20,21,121,57,128,18,101,145,23,58,123,42,48,149,143,13,112,115,46,110,61,62,127,9,117,118,37,147,136,30,47,150,65,132,66,36,135,41,137,138,27,139,25,146]),function($,e,T,O,k,L,N,I,h,c,m,w,p,P,y,S,E,a,d,v,f,s,i,n,t,r,o,u,l,g,R,C,q,X,J,ie,re,Q,he,ce,se,ge,M,A,U,V,G,x,ee,b,D,j,F,B,W,te,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class me extends I.Disposable{constructor(ne){super(),this.b=ne,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[ne,de]=await this.f();return ne.invokeFunction(async le=>{const ve=le.get(re.ILogService),Me=le.get(l.IFileService),Te=le.get(d.INativeEnvironmentService),Ae=le.get(te.IUserDataProfilesService);ve.info("CLI main",this.b),this.g(ve),await this.h(Te,Me,Ae,ne),await Promise.all(de.map(Ue=>{(0,O.raceTimeout)(Ue.flush(),1e3)}))})}async f(){const ne=new X.ServiceCollection,de={_serviceBrand:void 0,...ge.default};ne.set(M.IProductService,de);const le=new v.NativeEnvironmentService(this.b,de);ne.set(d.INativeEnvironmentService,le),await Promise.all([le.appSettingsHome.fsPath,le.extensionsPath].map(Re=>Re?P.Promises.mkdir(Re,{recursive:!0}):void 0));const ve=(0,re.getLogLevel)(le),Me=[];Me.push(new Q.SpdLogLogger("cli",(0,c.join)(le.logsPath,"cli.log"),!0,!1,ve)),ve===re.LogLevel.Trace&&Me.push(new re.ConsoleLogger(ve));const Te=this.B(new re.MultiplexLogService(Me));ne.set(re.ILogService,Te);const Ae=this.B(new g.FileService(Te));ne.set(l.IFileService,Ae);const Ue=this.B(new R.DiskFileSystemProvider(Te));Ae.registerProvider(h.Schemas.file,Ue);const z=new G.StateService(le,Te,Ae);ne.set(V.IStateService,z);const H=new W.UriIdentityService(Ae);ne.set(B.IUriIdentityService,H);const K=new oe.UserDataProfilesService(z,H,le,Ae,Te);ne.set(te.IUserDataProfilesService,K);const ue=m.isWindows&&de.win32RegValueName?this.B(new se.NativePolicyService(Te,de.win32RegValueName)):le.policyFile?this.B(new he.FilePolicyService(le.policyFile,Ae,Te)):new ce.NullPolicyService;ne.set(ce.IPolicyService,ue);const pe=this.B(new S.ConfigurationService(K.defaultProfile.settingsResource,Ae,ue,Te));ne.set(y.IConfigurationService,pe),await Promise.all([z.init(),pe.initialize()]),K.setEnablement(de.quality!=="stable"||pe.getValue(te.PROFILES_ENABLEMENT_CONFIG)),ne.set(B.IUriIdentityService,new W.UriIdentityService(Ae)),ne.set(A.IRequestService,new C.SyncDescriptor(U.RequestService,void 0,!0)),ne.set(E.IDownloadService,new C.SyncDescriptor(a.DownloadService,void 0,!0)),ne.set(t.IExtensionsProfileScannerService,new C.SyncDescriptor(t.ExtensionsProfileScannerService,void 0,!0)),ne.set(r.IExtensionsScannerService,new C.SyncDescriptor(u.ExtensionsScannerService,void 0,!0)),ne.set(i.IExtensionSignatureVerificationService,new C.SyncDescriptor(i.ExtensionSignatureVerificationService,void 0,!0)),ne.set(o.INativeServerExtensionManagementService,new C.SyncDescriptor(o.ExtensionManagementService,void 0,!0)),ne.set(s.IExtensionGalleryService,new C.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),ne.set(J.ILanguagePackService,new C.SyncDescriptor(ie.NativeLanguagePackService,void 0,!1));const ke=[],Se=(0,D.isInternalTelemetry)(de,pe);if((0,D.supportsTelemetry)(de,le)){de.aiConfig&&de.aiConfig.ariaKey&&ke.push(new j.OneDataSystemAppender(Se,"monacoworkbench",null,de.aiConfig.ariaKey));const{installSourcePath:Re}=le,Ie={appenders:ke,sendErrorTelemetry:!1,commonProperties:(async()=>{let Oe;try{const je=await P.Promises.readFile(le.stateResource.fsPath);Oe=JSON.parse(je.toString())[ee.machineIdKey]}catch(je){je.code!=="ENOENT"&&Te.error(je)}return(0,x.resolveCommonProperties)(Ae,(0,T.release)(),(0,T.hostname)(),process.arch,de.commit,de.version,Oe,Se,Re)})(),piiPaths:(0,D.getPiiPathsFromEnvironment)(le)};ne.set(ee.ITelemetryService,new C.SyncDescriptor(b.TelemetryService,[Ie],!1))}else ne.set(ee.ITelemetryService,D.NullTelemetryService);return[new q.InstantiationService(ne),ke]}g(ne){(0,N.setUnexpectedErrorHandler)(de=>{const le=(0,L.toErrorMessage)(de,!0);!le||ne.error(`[uncaught exception in CLI]: ${le}`)}),process.on("uncaughtException",de=>(0,N.onUnexpectedError)(de)),process.on("unhandledRejection",de=>(0,N.onUnexpectedError)(de))}async h(ne,de,le,ve){const Me=(ne.args.profile?le.profiles.find(Te=>Te.name===ne.args.profile)??le.defaultProfile:le.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(ne,de,this.b["install-source"]);if(this.b["list-extensions"])return ve.createInstance(n.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Me);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Me};return ve.createInstance(n.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],Te,!!this.b.force)}else{if(this.b["uninstall-extension"])return ve.createInstance(n.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Me);if(this.b["locate-extension"])return ve.createInstance(n.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.buildTelemetryMessage)(ne.appRoot,ne.extensionsPath))}}i(ne){return ne.map(de=>/\.vsix$/i.test(de)?p.URI.file((0,c.isAbsolute)(de)?de:(0,c.join)((0,w.cwd)(),de)):de)}async j(ne,de,le){await de.writeFile(p.URI.file(ne.installSourcePath),k.VSBuffer.fromString(le.slice(0,30)))}}async function ye(ae){const ne=new me(ae);try{await ne.run()}finally{ne.dispose()}}e.main=ye})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2eca6d38dede985bf6180cca64d43c16a02e9a13/core/vs/code/node/cliProcessMain.js.map
