/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(te){for(var e=[],a=0,t=te.length;a<t;a++)e[a]=Se[te[a]];return e};define(Se[78],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function a(A){return A?A.replace(/\$\((.*?)\)/g,(D,T)=>` ${T} `).trim():""}e.getCodiconAriaLabel=a;class t{constructor(D,T,S){this.id=D,this.definition=T,this.description=S,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var I;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function T(R){if(R instanceof t)return["codicon","codicon-"+R.id];const P=D.exec(R.id);if(!P)return T(t.error);const[,E,y]=P,v=["codicon","codicon-"+E];return y&&v.push("codicon-modifier-"+y.substring(1)),v}A.asClassNameArray=T;function S(R){return T(R).join(" ")}A.asClassName=S;function C(R){return"."+T(R).join(".")}A.asCSSSelector=C})(I=e.CSSIcon||(e.CSSIcon={}))}),define(Se[79],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(D,T){const S=Object.create(null);for(const C of D){const R=T(C);let P=S[R];P||(P=S[R]=[]),P.push(C)}return S}e.groupBy=a;function t(D,T){const S=[],C=[];for(const R of D)T.has(R)||S.push(R);for(const R of T)D.has(R)||C.push(R);return{removed:S,added:C}}e.diffSets=t;function I(D,T){const S=[],C=[];for(const[R,P]of D)T.has(R)||S.push(P);for(const[R,P]of T)D.has(R)||C.push(P);return{removed:S,added:C}}e.diffMaps=I;class A{constructor(){this.a=new Map}add(T,S){let C=this.a.get(T);C||(C=new Set,this.a.set(T,C)),C.add(S)}delete(T,S){const C=this.a.get(T);!C||(C.delete(S),C.size===0&&this.a.delete(T))}forEach(T,S){const C=this.a.get(T);!C||C.forEach(S)}}e.SetMap=A}),define(Se[60],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(D){return(T,S,C)=>{let R=null,P=null;if(typeof C.value=="function"?(R="value",P=C.value):typeof C.get=="function"&&(R="get",P=C.get),!P)throw new Error("not supported");C[R]=D(P,S)}}function t(D,T,S){let C=null,R=null;if(typeof S.value=="function"?(C="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",R=S.get),!R)throw new Error("not supported");const P=`$memoize$${T}`;S[C]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,E)}),this[P]}}e.memoize=t;function I(D,T,S){return a((C,R)=>{const P=`$debounce$${R}`,E=`$debounce$result$${R}`;return function(...y){this[E]||(this[E]=S?S():void 0),clearTimeout(this[P]),T&&(this[E]=T(this[E],...y),y=[this[E]]),this[P]=setTimeout(()=>{C.apply(this,y),this[E]=S?S():void 0},D)}})}e.debounce=I;function A(D,T,S){return a((C,R)=>{const P=`$throttle$timer$${R}`,E=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...d){if(this[E]||(this[E]=S?S():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),T&&(this[E]=T(this[E],...d)),this[v])return;const g=this[y]+D;g<=Date.now()?(this[y]=Date.now(),C.apply(this,[this[E]]),this[E]=S?S():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[y]=Date.now(),C.apply(this,[this[E]]),this[E]=S?S():void 0},g-Date.now()))}})}e.throttle=A}),define(Se[10],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?m.isErrorNoTelemetry(s)?new m(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(i=>{i(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.ErrorHandler=a,e.errorHandler=new a;function t(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=t;function I(b){S(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=I;function A(b){S(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=A;function D(b){if(b instanceof Error){const{name:s,message:i}=b,c=b.stacktrace||b.stack;return{$isError:!0,name:s,message:i,stack:c,noTelemetry:m.isErrorNoTelemetry(b)}}return b}e.transformErrorForSerialization=D;const T="Canceled";function S(b){return b instanceof C?!0:b instanceof Error&&b.name===T&&b.message===T}e.isCancellationError=S;class C extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=C;function R(){const b=new Error(T);return b.name=b.message,b}e.canceled=R;function P(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=P;function E(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=E;function y(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function v(b){const s=new Error(`${b} has been disposed`);return s.name="DISPOSED",s}e.disposed=v;function d(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=d;class g extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=g;class f extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=f;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class m extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof m)return s;const i=new m;return i.message=s.message,i.stack=s.stack,i}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class h extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(Se[17],ye([1,0,10]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(se,ue=0){return se[se.length-(1+ue)]}e.tail=t;function I(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=I;function A(se,ue,de=(ee,oe)=>ee===oe){if(se===ue)return!0;if(!se||!ue||se.length!==ue.length)return!1;for(let ee=0,oe=se.length;ee<oe;ee++)if(!de(se[ee],ue[ee]))return!1;return!0}e.equals=A;function D(se,ue){const de=se.length-1;ue<de&&(se[ue]=se[de]),se.pop()}e.removeFastWithoutKeepingOrder=D;function T(se,ue,de){return S(se.length,ee=>de(se[ee],ue))}e.binarySearch=T;function S(se,ue){let de=0,ee=se-1;for(;de<=ee;){const oe=(de+ee)/2|0,ie=ue(oe);if(ie<0)de=oe+1;else if(ie>0)ee=oe-1;else return oe}return-(de+1)}e.binarySearch2=S;function C(se,ue){let de=0,ee=se.length;if(ee===0)return 0;for(;de<ee;){const oe=Math.floor((de+ee)/2);ue(se[oe])?ee=oe:de=oe+1}return de}e.findFirstInSorted=C;function R(se,ue,de){if(se=se|0,se>=ue.length)throw new TypeError("invalid index");const ee=ue[Math.floor(ue.length*Math.random())],oe=[],ie=[],N=[];for(const z of ue){const X=de(z,ee);X<0?oe.push(z):X>0?ie.push(z):N.push(z)}return se<oe.length?R(se,oe,de):se<oe.length+N.length?N[0]:R(se-(oe.length+N.length),ie,de)}e.quickSelect=R;function P(se,ue){const de=[];let ee;for(const oe of se.slice(0).sort(ue))!ee||ue(ee[0],oe)!==0?(ee=[oe],de.push(ee)):ee.push(oe);return de}e.groupBy=P;function E(se,ue,de){const ee=[];function oe(z,X,Q){if(X===0&&Q.length===0)return;const le=ee[ee.length-1];le&&le.start+le.deleteCount===z?(le.deleteCount+=X,le.toInsert.push(...Q)):ee.push({start:z,deleteCount:X,toInsert:Q})}let ie=0,N=0;for(;;){if(ie===se.length){oe(ie,0,ue.slice(N));break}if(N===ue.length){oe(ie,se.length-ie,[]);break}const z=se[ie],X=ue[N],Q=de(z,X);Q===0?(ie+=1,N+=1):Q<0?(oe(ie,1,[]),ie+=1):Q>0&&(oe(ie,0,[X]),N+=1)}return ee}e.sortedDiff=E;function y(se,ue,de){const ee=E(se,ue,de),oe=[],ie=[];for(const N of ee)oe.push(...se.slice(N.start,N.start+N.deleteCount)),ie.push(...N.toInsert);return{removed:oe,added:ie}}e.delta=y;function v(se,ue,de){if(de===0)return[];const ee=se.slice(0,de).sort(ue);return g(se,ue,ee,de,se.length),ee}e.top=v;function d(se,ue,de,ee,oe){return de===0?Promise.resolve([]):new Promise((ie,N)=>{(async()=>{const z=se.length,X=se.slice(0,de).sort(ue);for(let Q=de,le=Math.min(de+ee,z);Q<z;Q=le,le=Math.min(le+ee,z)){if(Q>de&&await new Promise(be=>setTimeout(be)),oe&&oe.isCancellationRequested)throw new a.CancellationError;g(se,ue,X,Q,le)}return X})().then(ie,N)})}e.topAsync=d;function g(se,ue,de,ee,oe){for(const ie=de.length;ee<oe;ee++){const N=se[ee];if(ue(N,de[ie-1])<0){de.pop();const z=C(de,X=>ue(N,X)<0);de.splice(z,0,N)}}}function f(se){return se.filter(ue=>!!ue)}e.coalesce=f;function w(se){let ue=0;for(let de=0;de<se.length;de++)se[de]&&(se[ue]=se[de],ue+=1);se.length=ue}e.coalesceInPlace=w;function m(se,ue,de){se.splice(de,0,se.splice(ue,1)[0])}e.move=m;function h(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=h;function b(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=b;function s(se,ue=de=>de){const de=new Set;return se.filter(ee=>{const oe=ue(ee);return de.has(oe)?!1:(de.add(oe),!0)})}e.distinct=s;function i(se){const ue=new Set;return de=>{const ee=se(de);return ue.has(ee)?!1:(ue.add(ee),!0)}}e.uniqueFilter=i;function c(se,ue){const de=u(se,ue);if(de!==-1)return se[de]}e.findLast=c;function u(se,ue){for(let de=se.length-1;de>=0;de--){const ee=se[de];if(ue(ee))return de}return-1}e.lastIndex=u;function r(se,ue){return se.length>0?se[0]:ue}e.firstOrDefault=r;function o(se,ue){return se.length>0?se[se.length-1]:ue}e.lastOrDefault=o;function n(se,ue,de=(ee,oe)=>ee===oe){let ee=0;for(let oe=0,ie=Math.min(se.length,ue.length);oe<ie&&de(se[oe],ue[oe]);oe++)ee++;return ee}e.commonPrefixLength=n;function l(se){return[].concat(...se)}e.flatten=l;function p(se,ue){let de=typeof ue=="number"?se:0;typeof ue=="number"?de=se:(de=0,ue=se);const ee=[];if(de<=ue)for(let oe=de;oe<ue;oe++)ee.push(oe);else for(let oe=de;oe>ue;oe--)ee.push(oe);return ee}e.range=p;function k(se,ue,de){return se.reduce((ee,oe)=>(ee[ue(oe)]=de?de(oe):oe,ee),Object.create(null))}e.index=k;function L(se,ue){return se.push(ue),()=>U(se,ue)}e.insert=L;function U(se,ue){const de=se.indexOf(ue);if(de>-1)return se.splice(de,1),ue}e.remove=U;function K(se,ue,de){const ee=se.slice(0,ue),oe=se.slice(ue);return ee.concat(de,oe)}e.arrayInsert=K;function G(se,ue){let de;if(typeof ue=="number"){let ee=ue;de=()=>{const oe=Math.sin(ee++)*179426549;return oe-Math.floor(oe)}}else de=Math.random;for(let ee=se.length-1;ee>0;ee-=1){const oe=Math.floor(de()*(ee+1)),ie=se[ee];se[ee]=se[oe],se[oe]=ie}}e.shuffle=G;function O(se,ue){const de=se.indexOf(ue);de>-1&&(se.splice(de,1),se.unshift(ue))}e.pushToStart=O;function B(se,ue){const de=se.indexOf(ue);de>-1&&(se.splice(de,1),se.push(ue))}e.pushToEnd=B;function F(se,ue){for(const de of ue)se.push(de)}e.pushMany=F;function $(se,ue){return Array.isArray(se)?se.map(ue):ue(se)}e.mapArrayOrNot=$;function M(se){return Array.isArray(se)?se:[se]}e.asArray=M;function V(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=V;function q(se,ue){for(const de of se){const ee=ue(de);if(ee!==void 0)return ee}}e.mapFind=q;function H(se,ue,de){const ee=Y(se,ue),oe=se.length,ie=de.length;se.length=oe+ie;for(let N=oe-1;N>=ee;N--)se[N+ie]=se[N];for(let N=0;N<ie;N++)se[N+ee]=de[N]}e.insertInto=H;function J(se,ue,de,ee){const oe=Y(se,ue),ie=se.splice(oe,de);return H(se,oe,ee),ie}e.splice=J;function Y(se,ue){return ue<0?Math.max(ue+se.length,0):Math.min(ue,se.length)}var ae;(function(se){function ue(oe){return oe<0}se.isLessThan=ue;function de(oe){return oe>0}se.isGreaterThan=de;function ee(oe){return oe===0}se.isNeitherLessOrGreaterThan=ee,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ae=e.CompareResult||(e.CompareResult={}));function re(se,ue){return(de,ee)=>ue(se(de),se(ee))}e.compareBy=re;function fe(...se){return(ue,de)=>{for(const ee of se){const oe=ee(ue,de);if(!ae.isNeitherLessOrGreaterThan(oe))return oe}return ae.neitherLessOrGreaterThan}}e.tieBreakComparators=fe;const Z=(se,ue)=>se-ue;e.numberComparator=Z;function pe(se,ue){if(se.length===0)return;let de=se[0];for(let ee=1;ee<se.length;ee++){const oe=se[ee];ue(oe,de)>0&&(de=oe)}return de}e.findMaxBy=pe;function we(se,ue){if(se.length===0)return;let de=se[0];for(let ee=1;ee<se.length;ee++){const oe=se[ee];ue(oe,de)>=0&&(de=oe)}return de}e.findLastMaxBy=we;function De(se,ue){return pe(se,(de,ee)=>-ue(de,ee))}e.findMinBy=De;class Re{constructor(ue){this.f=ue,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ue){let de=this.c;for(;de<this.f.length&&ue(this.f[de]);)de++;const ee=de===this.c?null:this.f.slice(this.c,de);return this.c=de,ee}takeFromEndWhile(ue){let de=this.d;for(;de>=0&&ue(this.f[de]);)de--;const ee=de===this.d?null:this.f.slice(de+1,this.d+1);return this.d=de,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ue=this.f[this.c];return this.c++,ue}removeLast(){const ue=this.f[this.d];return this.d--,ue}takeCount(ue){const de=this.f.slice(this.c,this.c+ue);return this.c+=ue,de}}e.ArrayQueue=Re;class Be{constructor(ue){this.iterate=ue}forEach(ue){this.iterate(de=>(ue(de),!0))}toArray(){const ue=[];return this.iterate(de=>(ue.push(de),!0)),ue}filter(ue){return new Be(de=>this.iterate(ee=>ue(ee)?de(ee):!0))}map(ue){return new Be(de=>this.iterate(ee=>de(ue(ee))))}some(ue){let de=!1;return this.iterate(ee=>(de=ue(ee),!de)),de}findFirst(ue){let de;return this.iterate(ee=>ue(ee)?(de=ee,!1):!0),de}findLast(ue){let de;return this.iterate(ee=>(ue(ee)&&(de=ee),!0)),de}findLastMaxBy(ue){let de,ee=!0;return this.iterate(oe=>((ee||ae.isGreaterThan(ue(oe,de)))&&(ee=!1,de=oe),!0)),de}}e.CallbackIterable=Be,Be.empty=new Be(se=>{})}),define(Se[48],ye([1,0,10]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,C){if(!S)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=t;function I(S,C="Unreachable"){throw new Error(C)}e.assertNever=I;function A(S){if(!S)throw new a.BugIndicatingError("Assertion Failed")}e.assert=A;function D(S){if(!S()){debugger;S(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function T(S,C){let R=0;for(;R<S.length-1;){const P=S[R],E=S[R+1];if(!C(P,E))return!1;R++}return!0}e.checkAdjacentItems=T}),define(Se[61],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(t){const I=this;let A=!1,D;return function(){return A||(A=!0,D=t.apply(I,arguments)),D}}e.once=a}),define(Se[99],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Se[62],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function I(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}t.is=I;const A=Object.freeze([]);function D(){return A}t.empty=D;function*T(h){yield h}t.single=T;function S(h){return I(h)?h:T(h)}t.wrap=S;function C(h){return h||A}t.from=C;function R(h){return!h||h[Symbol.iterator]().next().done===!0}t.isEmpty=R;function P(h){return h[Symbol.iterator]().next().value}t.first=P;function E(h,b){for(const s of h)if(b(s))return!0;return!1}t.some=E;function y(h,b){for(const s of h)if(b(s))return s}t.find=y;function*v(h,b){for(const s of h)b(s)&&(yield s)}t.filter=v;function*d(h,b){let s=0;for(const i of h)yield b(i,s++)}t.map=d;function*g(...h){for(const b of h)for(const s of b)yield s}t.concat=g;function f(h,b,s){let i=s;for(const c of h)i=b(i,c);return i}t.reduce=f;function*w(h,b,s=h.length){for(b<0&&(b+=h.length),s<0?s+=h.length:s>h.length&&(s=h.length);b<s;b++)yield h[b]}t.slice=w;function m(h,b=Number.POSITIVE_INFINITY){const s=[];if(b===0)return[s,h];const i=h[Symbol.iterator]();for(let c=0;c<b;c++){const u=i.next();if(u.done)return[s,t.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return i}}]}t.consume=m})(a=e.Iterable||(e.Iterable={}))}),define(Se[145],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function D(s,i=!1){let c=0;const u=s.length;let r="",o=0,n=16,l=0;function p(B){let F=0,$=0;for(;F<B;){const M=s.charCodeAt(c);if(M>=48&&M<=57)$=$*16+M-48;else if(M>=65&&M<=70)$=$*16+M-65+10;else if(M>=97&&M<=102)$=$*16+M-97+10;else break;c++,F++}return F<B&&($=-1),$}function k(B){c=B,r="",o=0,n=16,l=0}function L(){const B=c;if(s.charCodeAt(c)===48)c++;else for(c++;c<s.length&&C(s.charCodeAt(c));)c++;if(c<s.length&&s.charCodeAt(c)===46)if(c++,c<s.length&&C(s.charCodeAt(c)))for(c++;c<s.length&&C(s.charCodeAt(c));)c++;else return l=3,s.substring(B,c);let F=c;if(c<s.length&&(s.charCodeAt(c)===69||s.charCodeAt(c)===101))if(c++,(c<s.length&&s.charCodeAt(c)===43||s.charCodeAt(c)===45)&&c++,c<s.length&&C(s.charCodeAt(c))){for(c++;c<s.length&&C(s.charCodeAt(c));)c++;F=c}else l=3;return s.substring(B,F)}function U(){let B="",F=c;for(;;){if(c>=u){B+=s.substring(F,c),l=2;break}const $=s.charCodeAt(c);if($===34){B+=s.substring(F,c),c++;break}if($===92){if(B+=s.substring(F,c),c++,c>=u){l=2;break}switch(s.charCodeAt(c++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const V=p(4);V>=0?B+=String.fromCharCode(V):l=4;break}default:l=5}F=c;continue}if($>=0&&$<=31)if(S($)){B+=s.substring(F,c),l=2;break}else l=6;c++}return B}function K(){if(r="",l=0,o=c,c>=u)return o=u,n=17;let B=s.charCodeAt(c);if(T(B)){do c++,r+=String.fromCharCode(B),B=s.charCodeAt(c);while(T(B));return n=15}if(S(B))return c++,r+=String.fromCharCode(B),B===13&&s.charCodeAt(c)===10&&(c++,r+=`
`),n=14;switch(B){case 123:return c++,n=1;case 125:return c++,n=2;case 91:return c++,n=3;case 93:return c++,n=4;case 58:return c++,n=6;case 44:return c++,n=5;case 34:return c++,r=U(),n=10;case 47:{const F=c-1;if(s.charCodeAt(c+1)===47){for(c+=2;c<u&&!S(s.charCodeAt(c));)c++;return r=s.substring(F,c),n=12}if(s.charCodeAt(c+1)===42){c+=2;const $=u-1;let M=!1;for(;c<$;){if(s.charCodeAt(c)===42&&s.charCodeAt(c+1)===47){c+=2,M=!0;break}c++}return M||(c++,l=1),r=s.substring(F,c),n=13}return r+=String.fromCharCode(B),c++,n=16}case 45:if(r+=String.fromCharCode(B),c++,c===u||!C(s.charCodeAt(c)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=L(),n=11;default:for(;c<u&&G(B);)c++,B=s.charCodeAt(c);if(o!==c){switch(r=s.substring(o,c),r){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return r+=String.fromCharCode(B),c++,n=16}}function G(B){if(T(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let B;do B=K();while(B>=12&&B<=15);return B}return{setPosition:k,getPosition:()=>c,scan:i?O:K,getToken:()=>n,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>c-o,getTokenError:()=>l}}e.createScanner=D;function T(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function C(s){return s>=48&&s<=57}var R;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(R||(R={}));function P(s,i){const c=[],u=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function l(p,k,L,U){o.value=p,o.offset=k,o.length=L,o.type=U,o.colonOffset=void 0,r=o}try{m(s,{onObjectBegin:(p,k)=>{if(i<=p)throw u;r=void 0,n=i>p,c.push("")},onObjectProperty:(p,k,L)=>{if(i<k||(l(p,k,L,"property"),c[c.length-1]=p,i<=k+L))throw u},onObjectEnd:(p,k)=>{if(i<=p)throw u;r=void 0,c.pop()},onArrayBegin:(p,k)=>{if(i<=p)throw u;r=void 0,c.push(0)},onArrayEnd:(p,k)=>{if(i<=p)throw u;r=void 0,c.pop()},onLiteralValue:(p,k,L)=>{if(i<k||(l(p,k,L,b(p)),i<=k+L))throw u},onSeparator:(p,k,L)=>{if(i<=k)throw u;if(p===":"&&r&&r.type==="property")r.colonOffset=k,n=!1,r=void 0;else if(p===","){const U=c[c.length-1];typeof U=="number"?c[c.length-1]=U+1:(n=!0,c[c.length-1]=""),r=void 0}}})}catch(p){if(p!==u)throw p}return{path:c,previousNode:r,isAtPropertyKey:n,matches:p=>{let k=0;for(let L=0;k<p.length&&L<c.length;L++)if(p[k]===c[L]||p[k]==="*")k++;else if(p[k]!=="**")return!1;return k===p.length}}}e.getLocation=P;function E(s,i=[],c=A.DEFAULT){let u=null,r=[];const o=[];function n(p){Array.isArray(r)?r.push(p):u!==null&&(r[u]=p)}return m(s,{onObjectBegin:()=>{const p={};n(p),o.push(r),r=p,u=null},onObjectProperty:p=>{u=p},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const p=[];n(p),o.push(r),r=p,u=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:n,onError:(p,k,L)=>{i.push({error:p,offset:k,length:L})}},c),r[0]}e.parse=E;function y(s,i=[],c=A.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(p){u.type==="property"&&(u.length=p-u.offset,u=u.parent)}function o(p){return u.children.push(p),p}m(s,{onObjectBegin:p=>{u=o({type:"object",offset:p,length:-1,parent:u,children:[]})},onObjectProperty:(p,k,L)=>{u=o({type:"property",offset:k,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:p,offset:k,length:L,parent:u})},onObjectEnd:(p,k)=>{u.length=p+k-u.offset,u=u.parent,r(p+k)},onArrayBegin:(p,k)=>{u=o({type:"array",offset:p,length:-1,parent:u,children:[]})},onArrayEnd:(p,k)=>{u.length=p+k-u.offset,u=u.parent,r(p+k)},onLiteralValue:(p,k,L)=>{o({type:b(p),offset:k,length:L,parent:u,value:p}),r(k+L)},onSeparator:(p,k,L)=>{u.type==="property"&&(p===":"?u.colonOffset=k:p===","&&r(k))},onError:(p,k,L)=>{i.push({error:p,offset:k,length:L})}},c);const l=u.children[0];return l&&delete l.parent,l}e.parseTree=y;function v(s,i){if(!s)return;let c=s;for(const u of i)if(typeof u=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let r=!1;for(const o of c.children)if(Array.isArray(o.children)&&o.children[0].value===u){c=o.children[1],r=!0;break}if(!r)return}else{const r=u;if(c.type!=="array"||r<0||!Array.isArray(c.children)||r>=c.children.length)return;c=c.children[r]}return c}e.findNodeAtLocation=v;function d(s){if(!s.parent||!s.parent.children)return[];const i=d(s.parent);if(s.parent.type==="property"){const c=s.parent.children[0].value;i.push(c)}else if(s.parent.type==="array"){const c=s.parent.children.indexOf(s);c!==-1&&i.push(c)}return i}e.getNodePath=d;function g(s){switch(s.type){case"array":return s.children.map(g);case"object":{const i=Object.create(null);for(const c of s.children){const u=c.children[1];u&&(i[c.children[0].value]=g(u))}return i}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=g;function f(s,i,c=!1){return i>=s.offset&&i<s.offset+s.length||c&&i===s.offset+s.length}e.contains=f;function w(s,i,c=!1){if(f(s,i,c)){const u=s.children;if(Array.isArray(u))for(let r=0;r<u.length&&u[r].offset<=i;r++){const o=w(u[r],i,c);if(o)return o}return s}}e.findNodeAtOffset=w;function m(s,i,c=A.DEFAULT){const u=D(s,!1);function r(re){return re?()=>re(u.getTokenOffset(),u.getTokenLength()):()=>!0}function o(re){return re?fe=>re(fe,u.getTokenOffset(),u.getTokenLength()):()=>!0}const n=r(i.onObjectBegin),l=o(i.onObjectProperty),p=r(i.onObjectEnd),k=r(i.onArrayBegin),L=r(i.onArrayEnd),U=o(i.onLiteralValue),K=o(i.onSeparator),G=r(i.onComment),O=o(i.onError),B=c&&c.disallowComments,F=c&&c.allowTrailingComma;function $(){for(;;){const re=u.scan();switch(u.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:B||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(re){case 12:case 13:B?M(10):G();break;case 16:M(1);break;case 15:case 14:break;default:return re}}}function M(re,fe=[],Z=[]){if(O(re),fe.length+Z.length>0){let pe=u.getToken();for(;pe!==17;){if(fe.indexOf(pe)!==-1){$();break}else if(Z.indexOf(pe)!==-1)break;pe=$()}}}function V(re){const fe=u.getTokenValue();return re?U(fe):l(fe),$(),!0}function q(){switch(u.getToken()){case 11:{let re=0;try{re=JSON.parse(u.getTokenValue()),typeof re!="number"&&(M(2),re=0)}catch{M(2)}U(re);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return $(),!0}function H(){return u.getToken()!==10?(M(3,[],[2,5]),!1):(V(!1),u.getToken()===6?(K(":"),$(),ae()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function J(){n(),$();let re=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(re||M(4,[],[]),K(","),$(),u.getToken()===2&&F)break}else re&&M(6,[],[]);H()||M(4,[],[2,5]),re=!0}return p(),u.getToken()!==2?M(7,[2],[]):$(),!0}function Y(){k(),$();let re=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(re||M(4,[],[]),K(","),$(),u.getToken()===4&&F)break}else re&&M(6,[],[]);ae()||M(4,[],[4,5]),re=!0}return L(),u.getToken()!==4?M(8,[4],[]):$(),!0}function ae(){switch(u.getToken()){case 3:return Y();case 1:return J();case 10:return V(!0);default:return q()}}return $(),u.getToken()===17?c.allowEmptyContent?!0:(M(4,[],[]),!1):ae()?(u.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=m;function h(s,i){const c=D(s),u=[];let r,o=0,n;do switch(n=c.getPosition(),r=c.scan(),r){case 12:case 13:case 17:o!==n&&u.push(s.substring(o,n)),i!==void 0&&u.push(c.getTokenValue().replace(/[^\r\n]/g,i)),o=c.getPosition();break}while(r!==17);return u.join("")}e.stripComments=h;function b(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(Se[80],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(I){this.d=I,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(I){this.c=I}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(I){return new a(()=>I(this.getValue()))}}e.Lazy=a}),define(Se[6],ye([1,0,61,62]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let A=null;function D(o){A=o}if(e.setDisposableTracker=D,I){const o="__is_disposable_tracked__";D(new class{trackDisposable(n){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[o]||console.log(l)},3e3)}setParent(n,l){if(n&&n!==w.None)try{n[o]=!0}catch{}}markAsDisposed(n){if(n&&n!==w.None)try{n[o]=!0}catch{}}markAsSingleton(n){}})}function T(o){return A?.trackDisposable(o),o}function S(o){A?.markAsDisposed(o)}function C(o,n){A?.setParent(o,n)}function R(o,n){if(!!A)for(const l of o)A.setParent(l,n)}function P(o){return A?.markAsSingleton(o),o}e.markAsSingleton=P;function E(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=E;function y(o){if(t.Iterable.is(o)){const n=[];for(const l of o)if(l)try{l.dispose()}catch(p){n.push(p)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=y;function v(o){for(const n of o)E(n)&&n.dispose();return[]}e.disposeIfDisposable=v;function d(...o){const n=g(()=>y(o));return R(o,n),n}e.combinedDisposable=d;function g(o){const n=T({dispose:(0,a.once)(()=>{S(n),o()})});return n}e.toDisposable=g;class f{constructor(){this.c=new Set,this.f=!1,T(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{y(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return C(n,this),this.f?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this.q=new f,T(this),C(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class m{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&C(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&C(n,null),n}}e.MutableDisposable=m;class h{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=h;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(n){let l=n;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,S(this))},this}}e.SafeDisposable=b;class s{constructor(){this.a=new Map}acquire(n,...l){let p=this.a.get(n);p||(p={counter:0,object:this.b(n,...l)},this.a.set(n,p));const{object:k}=p,L=(0,a.once)(()=>{--p.counter===0&&(this.c(n,p.object),this.a.delete(n))});return p.counter++,{object:k,dispose:L}}}e.ReferenceCollection=s;class i{constructor(n){this.a=n}async acquire(n,...l){const p=this.a.acquire(n,...l);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(k){throw p.dispose(),k}}}e.AsyncReferenceCollection=i;class c{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=c;function u(o){const n=new f;try{o(n)}finally{n.dispose()}}e.disposeOnReturn=u;class r{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{y(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,l,p=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||this.a.get(n)?.dispose(),this.a.set(n,l)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(Se[63],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(A){this.element=A,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class t{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let A=this.a;for(;A!==a.Undefined;){const D=A.next;A.prev=a.Undefined,A.next=a.Undefined,A=D}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,D){const T=new a(A);if(this.a===a.Undefined)this.a=T,this.b=T;else if(D){const C=this.b;this.b=T,T.prev=C,C.next=T}else{const C=this.a;this.a=T,T.next=C,C.prev=T}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(T))}}shift(){if(this.a!==a.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==a.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==a.Undefined&&A.next!==a.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===a.Undefined&&A.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):A.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):A.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==a.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),define(Se[28],ye([1,0]),function(te,e){"use strict";var a,t,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(v,d,g){let f=v.get(d);return f===void 0&&(f=g,v.set(d,f)),f}e.getOrSet=A;function D(v){const d=[];return v.forEach((g,f)=>{d.push(`${f} => ${g}`)}),`Map(${v.size}) {${d.join(", ")}}`}e.mapToString=D;function T(v){const d=[];return v.forEach(g=>{d.push(g)}),`Set(${v.size}) {${d.join(", ")}}`}e.setToString=T;class S{constructor(d,g){this.uri=d,this.value=g}}class C{constructor(d,g){this[a]="ResourceMap",d instanceof C?(this.b=new Map(d.b),this.c=g??C.a):(this.b=new Map,this.c=d??C.a)}set(d,g){return this.b.set(this.c(d),new S(d,g)),this}get(d){return this.b.get(this.c(d))?.value}has(d){return this.b.has(this.c(d))}get size(){return this.b.size}clear(){this.b.clear()}delete(d){return this.b.delete(this.c(d))}forEach(d,g){typeof g<"u"&&(d=d.bind(g));for(const[f,w]of this.b)d(w.value,w.uri,this)}*values(){for(const d of this.b.values())yield d.value}*keys(){for(const d of this.b.values())yield d.uri}*entries(){for(const d of this.b.values())yield[d.uri,d.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.b)yield[d.uri,d.value]}}e.ResourceMap=C,C.a=v=>v.toString();class R{constructor(d,g){this[t]="ResourceSet",!d||typeof d=="function"?this.a=new C(d):(this.a=new C(g),d.forEach(this.add,this))}get size(){return this.a.size}add(d){return this.a.set(d,d),this}clear(){this.a.clear()}delete(d){return this.a.delete(d)}forEach(d,g){this.a.forEach((f,w)=>d.call(g,w,w,this))}has(d){return this.a.has(d)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var P;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class E{constructor(){this[I]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(d){return this.a.has(d)}get(d,g=0){const f=this.a.get(d);if(!!f)return g!==0&&this.j(f,g),f.value}set(d,g,f=0){let w=this.a.get(d);if(w)w.value=g,f!==0&&this.j(w,f);else{switch(w={key:d,value:g,next:void 0,previous:void 0},f){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(d,w),this.d++}return this}delete(d){return!!this.remove(d)}remove(d){const g=this.a.get(d);if(!!g)return this.a.delete(d),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const d=this.b;return this.a.delete(d.key),this.i(d),this.d--,d.value}forEach(d,g){const f=this.e;let w=this.b;for(;w;){if(g?d.bind(g)(w.value,w.key,this):d(w.value,w.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const d=this,g=this.e;let f=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:f.key,done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return w}values(){const d=this,g=this.e;let f=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:f.value,done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return w}entries(){const d=this,g=this.e;let f=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:[f.key,f.value],done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return w}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(d){if(d>=this.size)return;if(d===0){this.clear();return}let g=this.b,f=this.size;for(;g&&f>d;)this.a.delete(g.key),g=g.next,f--;this.b=g,this.d=f,g&&(g.previous=void 0),this.e++}g(d){if(!this.b&&!this.c)this.c=d;else if(this.b)d.next=this.b,this.b.previous=d;else throw new Error("Invalid list");this.b=d,this.e++}h(d){if(!this.b&&!this.c)this.b=d;else if(this.c)d.previous=this.c,this.c.next=d;else throw new Error("Invalid list");this.c=d,this.e++}i(d){if(d===this.b&&d===this.c)this.b=void 0,this.c=void 0;else if(d===this.b){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.b=d.next}else if(d===this.c){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.c=d.previous}else{const g=d.next,f=d.previous;if(!g||!f)throw new Error("Invalid list");g.previous=f,f.next=g}d.next=void 0,d.previous=void 0,this.e++}j(d,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(d===this.b)return;const f=d.next,w=d.previous;d===this.c?(w.next=void 0,this.c=w):(f.previous=w,w.next=f),d.previous=void 0,d.next=this.b,this.b.previous=d,this.b=d,this.e++}else if(g===2){if(d===this.c)return;const f=d.next,w=d.previous;d===this.b?(f.previous=void 0,this.b=f):(f.previous=w,w.next=f),d.next=void 0,d.previous=this.c,this.c.next=d,this.c=d,this.e++}}}toJSON(){const d=[];return this.forEach((g,f)=>{d.push([f,g])}),d}fromJSON(d){this.clear();for(const[g,f]of d)this.set(g,f)}}e.LinkedMap=E;class y extends E{constructor(d,g=1){super(),this.k=d,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(d){this.k=d,this.m()}get ratio(){return this.l}set ratio(d){this.l=Math.min(Math.max(0,d),1),this.m()}get(d,g=2){return super.get(d,g)}peek(d){return super.get(d,0)}set(d,g){return super.set(d,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=y}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Se[146],ye([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(se,ue){for(var de=0;de<ue.length;de++){var ee=ue[de];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(se,ee.key,ee)}}function a(se,ue,de){return ue&&e(se.prototype,ue),de&&e(se,de),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,ue){if(!!se){if(typeof se=="string")return I(se,ue);var de=Object.prototype.toString.call(se).slice(8,-1);if(de==="Object"&&se.constructor&&(de=se.constructor.name),de==="Map"||de==="Set")return Array.from(se);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return I(se,ue)}}function I(se,ue){(ue==null||ue>se.length)&&(ue=se.length);for(var de=0,ee=new Array(ue);de<ue;de++)ee[de]=se[de];return ee}function A(se,ue){var de=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(de)return(de=de.call(se)).next.bind(de);if(Array.isArray(se)||(de=t(se))||ue&&se&&typeof se.length=="number"){de&&(se=de);var ee=0;return function(){return ee>=se.length?{done:!0}:{done:!1,value:se[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=D();function T(se){te.defaults=se}var S=/[&<>"']/,C=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(ue){return E[ue]};function v(se,ue){if(ue){if(S.test(se))return se.replace(C,y)}else if(R.test(se))return se.replace(P,y);return se}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(se){return se.replace(d,function(ue,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var f=/(^|[^\[])\^/g;function w(se,ue){se=typeof se=="string"?se:se.source,ue=ue||"";var de={replace:function(oe,ie){return ie=ie.source||ie,ie=ie.replace(f,"$1"),se=se.replace(oe,ie),de},getRegex:function(){return new RegExp(se,ue)}};return de}var m=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(se,ue,de){if(se){var ee;try{ee=decodeURIComponent(g(de)).replace(m,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ue&&!h.test(de)&&(de=r(ue,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var s={},i=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(se,ue){s[" "+se]||(i.test(se)?s[" "+se]=se+"/":s[" "+se]=p(se,"/",!0)),se=s[" "+se];var de=se.indexOf(":")===-1;return ue.substring(0,2)==="//"?de?ue:se.replace(c,"$1")+ue:ue.charAt(0)==="/"?de?ue:se.replace(u,"$1")+ue:se+ue}var o={exec:function(){}};function n(se){for(var ue=1,de,ee;ue<arguments.length;ue++){de=arguments[ue];for(ee in de)Object.prototype.hasOwnProperty.call(de,ee)&&(se[ee]=de[ee])}return se}function l(se,ue){var de=se.replace(/\|/g,function(ie,N,z){for(var X=!1,Q=N;--Q>=0&&z[Q]==="\\";)X=!X;return X?"|":" |"}),ee=de.split(/ \|/),oe=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ue)ee.splice(ue);else for(;ee.length<ue;)ee.push("");for(;oe<ee.length;oe++)ee[oe]=ee[oe].trim().replace(/\\\|/g,"|");return ee}function p(se,ue,de){var ee=se.length;if(ee===0)return"";for(var oe=0;oe<ee;){var ie=se.charAt(ee-oe-1);if(ie===ue&&!de)oe++;else if(ie!==ue&&de)oe++;else break}return se.slice(0,ee-oe)}function k(se,ue){if(se.indexOf(ue[1])===-1)return-1;for(var de=se.length,ee=0,oe=0;oe<de;oe++)if(se[oe]==="\\")oe++;else if(se[oe]===ue[0])ee++;else if(se[oe]===ue[1]&&(ee--,ee<0))return oe;return-1}function L(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function U(se,ue){if(ue<1)return"";for(var de="";ue>1;)ue&1&&(de+=se),ue>>=1,se+=se;return de+se}function K(se,ue,de,ee){var oe=ue.href,ie=ue.title?v(ue.title):null,N=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){ee.state.inLink=!0;var z={type:"link",raw:de,href:oe,title:ie,text:N,tokens:ee.inlineTokens(N)};return ee.state.inLink=!1,z}return{type:"image",raw:de,href:oe,title:ie,text:v(N)}}function G(se,ue){var de=se.match(/^(\s+)(?:```)/);if(de===null)return ue;var ee=de[1];return ue.split(`
`).map(function(oe){var ie=oe.match(/^\s+/);if(ie===null)return oe;var N=ie[0];return N.length>=ee.length?oe.slice(ee.length):oe}).join(`
`)}var O=function(){function se(de){this.options=de||te.defaults}var ue=se.prototype;return ue.space=function(ee){var oe=this.rules.block.newline.exec(ee);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},ue.code=function(ee){var oe=this.rules.block.code.exec(ee);if(oe){var ie=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:p(ie,`
`)}}},ue.fences=function(ee){var oe=this.rules.block.fences.exec(ee);if(oe){var ie=oe[0],N=G(ie,oe[3]||"");return{type:"code",raw:ie,lang:oe[2]?oe[2].trim():oe[2],text:N}}},ue.heading=function(ee){var oe=this.rules.block.heading.exec(ee);if(oe){var ie=oe[2].trim();if(/#$/.test(ie)){var N=p(ie,"#");(this.options.pedantic||!N||/ $/.test(N))&&(ie=N.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:ie,tokens:this.lexer.inline(ie)}}},ue.hr=function(ee){var oe=this.rules.block.hr.exec(ee);if(oe)return{type:"hr",raw:oe[0]}},ue.blockquote=function(ee){var oe=this.rules.block.blockquote.exec(ee);if(oe){var ie=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},ue.list=function(ee){var oe=this.rules.block.list.exec(ee);if(oe){var ie,N,z,X,Q,le,be,Te,ge,Ce,Ie,He,qe=oe[1].trim(),Ze=qe.length>1,xe={type:"list",raw:"",ordered:Ze,start:Ze?+qe.slice(0,-1):"",loose:!1,items:[]};qe=Ze?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=Ze?qe:"[*+-]");for(var tt=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(He=!1,!(!(oe=tt.exec(ee))||this.rules.block.hr.test(ee)));){if(ie=oe[0],ee=ee.substring(ie.length),Te=oe[2].split(`
`,1)[0],ge=ee.split(`
`,1)[0],this.options.pedantic?(X=2,Ie=Te.trimLeft()):(X=oe[2].search(/[^ ]/),X=X>4?1:X,Ie=Te.slice(X),X+=oe[1].length),le=!1,!Te&&/^ *$/.test(ge)&&(ie+=ge+`
`,ee=ee.substring(ge.length+1),He=!0),!He)for(var nt=new RegExp("^ {0,"+Math.min(3,X-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ft=new RegExp("^ {0,"+Math.min(3,X-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,X-1)+"}(?:```|~~~)"),Fe=new RegExp("^ {0,"+Math.min(3,X-1)+"}#");ee&&(Ce=ee.split(`
`,1)[0],Te=Ce,this.options.pedantic&&(Te=Te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Te)||Fe.test(Te)||nt.test(Te)||ft.test(ee)));){if(Te.search(/[^ ]/)>=X||!Te.trim())Ie+=`
`+Te.slice(X);else if(!le)Ie+=`
`+Te;else break;!le&&!Te.trim()&&(le=!0),ie+=Ce+`
`,ee=ee.substring(Ce.length+1)}xe.loose||(be?xe.loose=!0:/\n *\n *$/.test(ie)&&(be=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(Ie),N&&(z=N[0]!=="[ ] ",Ie=Ie.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:ie,task:!!N,checked:z,loose:!1,text:Ie}),xe.raw+=ie}xe.items[xe.items.length-1].raw=ie.trimRight(),xe.items[xe.items.length-1].text=Ie.trimRight(),xe.raw=xe.raw.trimRight();var lt=xe.items.length;for(Q=0;Q<lt;Q++){this.lexer.state.top=!1,xe.items[Q].tokens=this.lexer.blockTokens(xe.items[Q].text,[]);var W=xe.items[Q].tokens.filter(function(ce){return ce.type==="space"}),_=W.every(function(ce){for(var Pe=ce.raw.split(""),Le=0,Ge=A(Pe),Qe;!(Qe=Ge()).done;){var ut=Qe.value;if(ut===`
`&&(Le+=1),Le>1)return!0}return!1});!xe.loose&&W.length&&_&&(xe.loose=!0,xe.items[Q].loose=!0)}return xe}},ue.html=function(ee){var oe=this.rules.block.html.exec(ee);if(oe){var ie={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(oe[0]):v(oe[0]);ie.type="paragraph",ie.text=N,ie.tokens=this.lexer.inline(N)}return ie}},ue.def=function(ee){var oe=this.rules.block.def.exec(ee);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var ie=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:oe[0],href:oe[2],title:oe[3]}}},ue.table=function(ee){var oe=this.rules.block.table.exec(ee);if(oe){var ie={type:"table",header:l(oe[1]).map(function(be){return{text:be}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=oe[0];var N=ie.align.length,z,X,Q,le;for(z=0;z<N;z++)/^ *-+: *$/.test(ie.align[z])?ie.align[z]="right":/^ *:-+: *$/.test(ie.align[z])?ie.align[z]="center":/^ *:-+ *$/.test(ie.align[z])?ie.align[z]="left":ie.align[z]=null;for(N=ie.rows.length,z=0;z<N;z++)ie.rows[z]=l(ie.rows[z],ie.header.length).map(function(be){return{text:be}});for(N=ie.header.length,X=0;X<N;X++)ie.header[X].tokens=this.lexer.inline(ie.header[X].text);for(N=ie.rows.length,X=0;X<N;X++)for(le=ie.rows[X],Q=0;Q<le.length;Q++)le[Q].tokens=this.lexer.inline(le[Q].text);return ie}}},ue.lheading=function(ee){var oe=this.rules.block.lheading.exec(ee);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},ue.paragraph=function(ee){var oe=this.rules.block.paragraph.exec(ee);if(oe){var ie=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:ie,tokens:this.lexer.inline(ie)}}},ue.text=function(ee){var oe=this.rules.block.text.exec(ee);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},ue.escape=function(ee){var oe=this.rules.inline.escape.exec(ee);if(oe)return{type:"escape",raw:oe[0],text:v(oe[1])}},ue.tag=function(ee){var oe=this.rules.inline.tag.exec(ee);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):v(oe[0]):oe[0]}},ue.link=function(ee){var oe=this.rules.inline.link.exec(ee);if(oe){var ie=oe[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var N=p(ie.slice(0,-1),"\\");if((ie.length-N.length)%2===0)return}else{var z=k(oe[2],"()");if(z>-1){var X=oe[0].indexOf("!")===0?5:4,Q=X+oe[1].length+z;oe[2]=oe[2].substring(0,z),oe[0]=oe[0].substring(0,Q).trim(),oe[3]=""}}var le=oe[2],be="";if(this.options.pedantic){var Te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(le);Te&&(le=Te[1],be=Te[3])}else be=oe[3]?oe[3].slice(1,-1):"";return le=le.trim(),/^</.test(le)&&(this.options.pedantic&&!/>$/.test(ie)?le=le.slice(1):le=le.slice(1,-1)),K(oe,{href:le&&le.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ue.reflink=function(ee,oe){var ie;if((ie=this.rules.inline.reflink.exec(ee))||(ie=this.rules.inline.nolink.exec(ee))){var N=(ie[2]||ie[1]).replace(/\s+/g," ");if(N=oe[N.toLowerCase()],!N||!N.href){var z=ie[0].charAt(0);return{type:"text",raw:z,text:z}}return K(ie,N,ie[0],this.lexer)}},ue.emStrong=function(ee,oe,ie){ie===void 0&&(ie="");var N=this.rules.inline.emStrong.lDelim.exec(ee);if(!!N&&!(N[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=N[1]||N[2]||"";if(!z||z&&(ie===""||this.rules.inline.punctuation.exec(ie))){var X=N[0].length-1,Q,le,be=X,Te=0,ge=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,oe=oe.slice(-1*ee.length+X);(N=ge.exec(oe))!=null;)if(Q=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!Q){if(le=Q.length,N[3]||N[4]){be+=le;continue}else if((N[5]||N[6])&&X%3&&!((X+le)%3)){Te+=le;continue}if(be-=le,!(be>0)){if(le=Math.min(le,le+be+Te),Math.min(X,le)%2){var Ce=ee.slice(1,X+N.index+le);return{type:"em",raw:ee.slice(0,X+N.index+le+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var Ie=ee.slice(2,X+N.index+le-1);return{type:"strong",raw:ee.slice(0,X+N.index+le+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}}}}},ue.codespan=function(ee){var oe=this.rules.inline.code.exec(ee);if(oe){var ie=oe[2].replace(/\n/g," "),N=/[^ ]/.test(ie),z=/^ /.test(ie)&&/ $/.test(ie);return N&&z&&(ie=ie.substring(1,ie.length-1)),ie=v(ie,!0),{type:"codespan",raw:oe[0],text:ie}}},ue.br=function(ee){var oe=this.rules.inline.br.exec(ee);if(oe)return{type:"br",raw:oe[0]}},ue.del=function(ee){var oe=this.rules.inline.del.exec(ee);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},ue.autolink=function(ee,oe){var ie=this.rules.inline.autolink.exec(ee);if(ie){var N,z;return ie[2]==="@"?(N=v(this.options.mangle?oe(ie[1]):ie[1]),z="mailto:"+N):(N=v(ie[1]),z=N),{type:"link",raw:ie[0],text:N,href:z,tokens:[{type:"text",raw:N,text:N}]}}},ue.url=function(ee,oe){var ie;if(ie=this.rules.inline.url.exec(ee)){var N,z;if(ie[2]==="@")N=v(this.options.mangle?oe(ie[0]):ie[0]),z="mailto:"+N;else{var X;do X=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(X!==ie[0]);N=v(ie[0]),ie[1]==="www."?z="http://"+N:z=N}return{type:"link",raw:ie[0],text:N,href:z,tokens:[{type:"text",raw:N,text:N}]}}},ue.inlineText=function(ee,oe){var ie=this.rules.inline.text.exec(ee);if(ie){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]:N=v(this.options.smartypants?oe(ie[0]):ie[0]),{type:"text",raw:ie[0],text:N}}},se}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=w(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=w(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=w(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=w(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=w(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=w(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=n({},B),B.gfm=n({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=w(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=w(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=n({},B.normal,{html:w(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:w(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=w(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=w(B._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=w(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=w(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=w(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=w(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=w(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=w(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=w(F.reflink).replace("label",F._label).replace("ref",B._label).getRegex(),F.nolink=w(F.nolink).replace("ref",B._label).getRegex(),F.reflinkSearch=w(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:w(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:w(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:w(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=w(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:w(F.br).replace("{2,}","*").getRegex(),text:w(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function M(se){var ue="",de,ee,oe=se.length;for(de=0;de<oe;de++)ee=se.charCodeAt(de),Math.random()>.5&&(ee="x"+ee.toString(16)),ue+="&#"+ee+";";return ue}var V=function(){function se(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||te.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:B.normal,inline:F.normal};this.options.pedantic?(ee.block=B.pedantic,ee.inline=F.pedantic):this.options.gfm&&(ee.block=B.gfm,this.options.breaks?ee.inline=F.breaks:ee.inline=F.gfm),this.tokenizer.rules=ee}se.lex=function(ee,oe){var ie=new se(oe);return ie.lex(ee)},se.lexInline=function(ee,oe){var ie=new se(oe);return ie.inlineTokens(ee)};var ue=se.prototype;return ue.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ue.blockTokens=function(ee,oe){var ie=this;oe===void 0&&(oe=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(be,Te,ge){return Te+"    ".repeat(ge.length)});for(var N,z,X,Q;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(N=be.call({lexer:ie},ee,oe))?(ee=ee.substring(N.raw.length),oe.push(N),!0):!1}))){if(N=this.tokenizer.space(ee)){ee=ee.substring(N.raw.length),N.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(N);continue}if(N=this.tokenizer.code(ee)){ee=ee.substring(N.raw.length),z=oe[oe.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):oe.push(N);continue}if(N=this.tokenizer.fences(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.heading(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.hr(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.blockquote(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.list(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.html(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.def(ee)){ee=ee.substring(N.raw.length),z=oe[oe.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+N.raw,z.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.lheading(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(X=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,Te=ee.slice(1),ge=void 0;ie.options.extensions.startBlock.forEach(function(Ce){ge=Ce.call({lexer:this},Te),typeof ge=="number"&&ge>=0&&(be=Math.min(be,ge))}),be<1/0&&be>=0&&(X=ee.substring(0,be+1))}(),this.state.top&&(N=this.tokenizer.paragraph(X))){z=oe[oe.length-1],Q&&z.type==="paragraph"?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):oe.push(N),Q=X.length!==ee.length,ee=ee.substring(N.raw.length);continue}if(N=this.tokenizer.text(ee)){ee=ee.substring(N.raw.length),z=oe[oe.length-1],z&&z.type==="text"?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):oe.push(N);continue}if(ee){var le="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(le);break}else throw new Error(le)}}return this.state.top=!0,oe},ue.inline=function(ee,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:ee,tokens:oe}),oe},ue.inlineTokens=function(ee,oe){var ie=this;oe===void 0&&(oe=[]);var N,z,X,Q=ee,le,be,Te;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(le=this.tokenizer.rules.inline.reflinkSearch.exec(Q))!=null;)ge.includes(le[0].slice(le[0].lastIndexOf("[")+1,-1))&&(Q=Q.slice(0,le.index)+"["+U("a",le[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(le=this.tokenizer.rules.inline.blockSkip.exec(Q))!=null;)Q=Q.slice(0,le.index)+"["+U("a",le[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(le=this.tokenizer.rules.inline.escapedEmSt.exec(Q))!=null;)Q=Q.slice(0,le.index)+"++"+Q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(be||(Te=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ie){return(N=Ie.call({lexer:ie},ee,oe))?(ee=ee.substring(N.raw.length),oe.push(N),!0):!1}))){if(N=this.tokenizer.escape(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.tag(ee)){ee=ee.substring(N.raw.length),z=oe[oe.length-1],z&&N.type==="text"&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):oe.push(N);continue}if(N=this.tokenizer.link(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(N.raw.length),z=oe[oe.length-1],z&&N.type==="text"&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):oe.push(N);continue}if(N=this.tokenizer.emStrong(ee,Q,Te)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.codespan(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.br(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.del(ee)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(N=this.tokenizer.autolink(ee,M)){ee=ee.substring(N.raw.length),oe.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(ee,M))){ee=ee.substring(N.raw.length),oe.push(N);continue}if(X=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var Ie=1/0,He=ee.slice(1),qe=void 0;ie.options.extensions.startInline.forEach(function(Ze){qe=Ze.call({lexer:this},He),typeof qe=="number"&&qe>=0&&(Ie=Math.min(Ie,qe))}),Ie<1/0&&Ie>=0&&(X=ee.substring(0,Ie+1))}(),N=this.tokenizer.inlineText(X,$)){ee=ee.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Te=N.raw.slice(-1)),be=!0,z=oe[oe.length-1],z&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):oe.push(N);continue}if(ee){var Ce="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return oe},a(se,null,[{key:"rules",get:function(){return{block:B,inline:F}}}]),se}(),q=function(){function se(de){this.options=de||te.defaults}var ue=se.prototype;return ue.code=function(ee,oe,ie){var N=(oe||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(ee,N);z!=null&&z!==ee&&(ie=!0,ee=z)}return ee=ee.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+v(N,!0)+'">'+(ie?ee:v(ee,!0))+`</code></pre>
`:"<pre><code>"+(ie?ee:v(ee,!0))+`</code></pre>
`},ue.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ue.html=function(ee){return ee},ue.heading=function(ee,oe,ie,N){if(this.options.headerIds){var z=this.options.headerPrefix+N.slug(ie);return"<h"+oe+' id="'+z+'">'+ee+"</h"+oe+`>
`}return"<h"+oe+">"+ee+"</h"+oe+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(ee,oe,ie){var N=oe?"ol":"ul",z=oe&&ie!==1?' start="'+ie+'"':"";return"<"+N+z+`>
`+ee+"</"+N+`>
`},ue.listitem=function(ee){return"<li>"+ee+`</li>
`},ue.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(ee){return"<p>"+ee+`</p>
`},ue.table=function(ee,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+oe+`</table>
`},ue.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ue.tablecell=function(ee,oe){var ie=oe.header?"th":"td",N=oe.align?"<"+ie+' align="'+oe.align+'">':"<"+ie+">";return N+ee+("</"+ie+`>
`)},ue.strong=function(ee){return"<strong>"+ee+"</strong>"},ue.em=function(ee){return"<em>"+ee+"</em>"},ue.codespan=function(ee){return"<code>"+ee+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(ee){return"<del>"+ee+"</del>"},ue.link=function(ee,oe,ie){if(ee=b(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var N='<a href="'+v(ee)+'"';return oe&&(N+=' title="'+oe+'"'),N+=">"+ie+"</a>",N},ue.image=function(ee,oe,ie){if(ee=b(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var N='<img src="'+ee+'" alt="'+ie+'"';return oe&&(N+=' title="'+oe+'"'),N+=this.options.xhtml?"/>":">",N},ue.text=function(ee){return ee},se}(),H=function(){function se(){}var ue=se.prototype;return ue.strong=function(ee){return ee},ue.em=function(ee){return ee},ue.codespan=function(ee){return ee},ue.del=function(ee){return ee},ue.html=function(ee){return ee},ue.text=function(ee){return ee},ue.link=function(ee,oe,ie){return""+ie},ue.image=function(ee,oe,ie){return""+ie},ue.br=function(){return""},se}(),J=function(){function se(){this.seen={}}var ue=se.prototype;return ue.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(ee,oe){var ie=ee,N=0;if(this.seen.hasOwnProperty(ie)){N=this.seen[ee];do N++,ie=ee+"-"+N;while(this.seen.hasOwnProperty(ie))}return oe||(this.seen[ee]=N,this.seen[ie]=0),ie},ue.slug=function(ee,oe){oe===void 0&&(oe={});var ie=this.serialize(ee);return this.getNextSafeSlug(ie,oe.dryrun)},se}(),Y=function(){function se(de){this.options=de||te.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new J}se.parse=function(ee,oe){var ie=new se(oe);return ie.parse(ee)},se.parseInline=function(ee,oe){var ie=new se(oe);return ie.parseInline(ee)};var ue=se.prototype;return ue.parse=function(ee,oe){oe===void 0&&(oe=!0);var ie="",N,z,X,Q,le,be,Te,ge,Ce,Ie,He,qe,Ze,xe,tt,nt,ft,it,Fe,lt=ee.length;for(N=0;N<lt;N++){if(Ie=ee[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Fe=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Fe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ie.type))){ie+=Fe||"";continue}switch(Ie.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(Ie.tokens),Ie.depth,g(this.parseInline(Ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(Ie.text,Ie.lang,Ie.escaped);continue}case"table":{for(ge="",Te="",Q=Ie.header.length,z=0;z<Q;z++)Te+=this.renderer.tablecell(this.parseInline(Ie.header[z].tokens),{header:!0,align:Ie.align[z]});for(ge+=this.renderer.tablerow(Te),Ce="",Q=Ie.rows.length,z=0;z<Q;z++){for(be=Ie.rows[z],Te="",le=be.length,X=0;X<le;X++)Te+=this.renderer.tablecell(this.parseInline(be[X].tokens),{header:!1,align:Ie.align[X]});Ce+=this.renderer.tablerow(Te)}ie+=this.renderer.table(ge,Ce);continue}case"blockquote":{Ce=this.parse(Ie.tokens),ie+=this.renderer.blockquote(Ce);continue}case"list":{for(He=Ie.ordered,qe=Ie.start,Ze=Ie.loose,Q=Ie.items.length,Ce="",z=0;z<Q;z++)tt=Ie.items[z],nt=tt.checked,ft=tt.task,xe="",tt.task&&(it=this.renderer.checkbox(nt),Ze?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=it+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=it+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:it}):xe+=it),xe+=this.parse(tt.tokens,Ze),Ce+=this.renderer.listitem(xe,ft,nt);ie+=this.renderer.list(Ce,He,qe);continue}case"html":{ie+=this.renderer.html(Ie.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(Ie.tokens));continue}case"text":{for(Ce=Ie.tokens?this.parseInline(Ie.tokens):Ie.text;N+1<lt&&ee[N+1].type==="text";)Ie=ee[++N],Ce+=`
`+(Ie.tokens?this.parseInline(Ie.tokens):Ie.text);ie+=oe?this.renderer.paragraph(Ce):Ce;continue}default:{var W='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return ie},ue.parseInline=function(ee,oe){oe=oe||this.renderer;var ie="",N,z,X,Q=ee.length;for(N=0;N<Q;N++){if(z=ee[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(X=this.options.extensions.renderers[z.type].call({parser:this},z),X!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){ie+=X||"";continue}switch(z.type){case"escape":{ie+=oe.text(z.text);break}case"html":{ie+=oe.html(z.text);break}case"link":{ie+=oe.link(z.href,z.title,this.parseInline(z.tokens,oe));break}case"image":{ie+=oe.image(z.href,z.title,z.text);break}case"strong":{ie+=oe.strong(this.parseInline(z.tokens,oe));break}case"em":{ie+=oe.em(this.parseInline(z.tokens,oe));break}case"codespan":{ie+=oe.codespan(z.text);break}case"br":{ie+=oe.br();break}case"del":{ie+=oe.del(this.parseInline(z.tokens,oe));break}case"text":{ie+=oe.text(z.text);break}default:{var le='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(le);return}else throw new Error(le)}}}return ie},se}();function ae(se,ue,de){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof ue=="function"&&(de=ue,ue=null),ue=n({},ae.defaults,ue||{}),L(ue),de){var ee=ue.highlight,oe;try{oe=V.lex(se,ue)}catch(Q){return de(Q)}var ie=function(le){var be;if(!le)try{ue.walkTokens&&ae.walkTokens(oe,ue.walkTokens),be=Y.parse(oe,ue)}catch(Te){le=Te}return ue.highlight=ee,le?de(le):de(null,be)};if(!ee||ee.length<3||(delete ue.highlight,!oe.length))return ie();var N=0;ae.walkTokens(oe,function(Q){Q.type==="code"&&(N++,setTimeout(function(){ee(Q.text,Q.lang,function(le,be){if(le)return ie(le);be!=null&&be!==Q.text&&(Q.text=be,Q.escaped=!0),N--,N===0&&ie()})},0))}),N===0&&ie();return}function z(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(Q.message+"",!0)+"</pre>";throw Q}try{var X=V.lex(se,ue);if(ue.walkTokens){if(ue.async)return Promise.all(ae.walkTokens(X,ue.walkTokens)).then(function(){return Y.parse(X,ue)}).catch(z);ae.walkTokens(X,ue.walkTokens)}return Y.parse(X,ue)}catch(Q){z(Q)}}ae.options=ae.setOptions=function(se){return n(ae.defaults,se),T(ae.defaults),ae},ae.getDefaults=D,ae.defaults=te.defaults,ae.use=function(){for(var se=arguments.length,ue=new Array(se),de=0;de<se;de++)ue[de]=arguments[de];var ee=n.apply(void 0,[{}].concat(ue)),oe=ae.defaults.extensions||{renderers:{},childTokens:{}},ie;ue.forEach(function(N){if(N.extensions&&(ie=!0,N.extensions.forEach(function(X){if(!X.name)throw new Error("extension name required");if(X.renderer){var Q=oe.renderers?oe.renderers[X.name]:null;Q?oe.renderers[X.name]=function(){for(var le=arguments.length,be=new Array(le),Te=0;Te<le;Te++)be[Te]=arguments[Te];var ge=X.renderer.apply(this,be);return ge===!1&&(ge=Q.apply(this,be)),ge}:oe.renderers[X.name]=X.renderer}if(X.tokenizer){if(!X.level||X.level!=="block"&&X.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[X.level]?oe[X.level].unshift(X.tokenizer):oe[X.level]=[X.tokenizer],X.start&&(X.level==="block"?oe.startBlock?oe.startBlock.push(X.start):oe.startBlock=[X.start]:X.level==="inline"&&(oe.startInline?oe.startInline.push(X.start):oe.startInline=[X.start]))}X.childTokens&&(oe.childTokens[X.name]=X.childTokens)})),N.renderer&&function(){var X=ae.defaults.renderer||new q,Q=function(Te){var ge=X[Te];X[Te]=function(){for(var Ce=arguments.length,Ie=new Array(Ce),He=0;He<Ce;He++)Ie[He]=arguments[He];var qe=N.renderer[Te].apply(X,Ie);return qe===!1&&(qe=ge.apply(X,Ie)),qe}};for(var le in N.renderer)Q(le);ee.renderer=X}(),N.tokenizer&&function(){var X=ae.defaults.tokenizer||new O,Q=function(Te){var ge=X[Te];X[Te]=function(){for(var Ce=arguments.length,Ie=new Array(Ce),He=0;He<Ce;He++)Ie[He]=arguments[He];var qe=N.tokenizer[Te].apply(X,Ie);return qe===!1&&(qe=ge.apply(X,Ie)),qe}};for(var le in N.tokenizer)Q(le);ee.tokenizer=X}(),N.walkTokens){var z=ae.defaults.walkTokens;ee.walkTokens=function(X){var Q=[];return Q.push(N.walkTokens.call(this,X)),z&&(Q=Q.concat(z.call(this,X))),Q}}ie&&(ee.extensions=oe),ae.setOptions(ee)})},ae.walkTokens=function(se,ue){for(var de=[],ee=function(){var z=ie.value;switch(de=de.concat(ue.call(ae,z)),z.type){case"table":{for(var X=A(z.header),Q;!(Q=X()).done;){var le=Q.value;de=de.concat(ae.walkTokens(le.tokens,ue))}for(var be=A(z.rows),Te;!(Te=be()).done;)for(var ge=Te.value,Ce=A(ge),Ie;!(Ie=Ce()).done;){var He=Ie.value;de=de.concat(ae.walkTokens(He.tokens,ue))}break}case"list":{de=de.concat(ae.walkTokens(z.items,ue));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[z.type]?ae.defaults.extensions.childTokens[z.type].forEach(function(qe){de=de.concat(ae.walkTokens(z[qe],ue))}):z.tokens&&(de=de.concat(ae.walkTokens(z.tokens,ue)))}},oe=A(se),ie;!(ie=oe()).done;)ee();return de},ae.parseInline=function(se,ue){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");ue=n({},ae.defaults,ue||{}),L(ue);try{var de=V.lexInline(se,ue);return ue.walkTokens&&ae.walkTokens(de,ue.walkTokens),Y.parseInline(de,ue)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(ee.message+"",!0)+"</pre>";throw ee}},ae.Parser=Y,ae.parser=Y.parse,ae.Renderer=q,ae.TextRenderer=H,ae.Lexer=V,ae.lexer=V.lex,ae.Tokenizer=O,ae.Slugger=J,ae.parse=ae;var re=ae.options,fe=ae.setOptions,Z=ae.use,pe=ae.walkTokens,we=ae.parseInline,De=ae,Re=Y.parse,Be=V.lex;te.Lexer=V,te.Parser=Y,te.Renderer=q,te.Slugger=J,te.TextRenderer=H,te.Tokenizer=O,te.getDefaults=D,te.lexer=Be,te.marked=ae,te.options=re,te.parse=De,te.parseInline=we,te.parser=Re,te.setOptions=fe,te.use=Z,te.walkTokens=pe,Object.defineProperty(te,"__esModule",{value:!0})}),define(Se[81],ye([1,0,28]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new a.LRUCache(1e4);function I(C){return S(C,"NFC",t)}e.normalizeNFC=I;const A=new a.LRUCache(1e4);function D(C){return S(C,"NFD",A)}e.normalizeNFD=D;const T=/[^\u0000-\u0080]/;function S(C,R,P){if(!C)return C;const E=P.get(C);if(E)return E;let y;return T.test(C)?y=C.normalize(R):y=C,P.set(C,y),y}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(R){return D(R).replace(C,"")}}()}),define(Se[100],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(T,S,C){return Math.min(Math.max(T,S),C)}e.clamp=a;function t(T,S){return(S+T%S)%S}e.rot=t;class I{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=I;class A{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class D{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const C=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=C,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function te(I){const A=[];typeof I=="number"&&A.push("code/timeOrigin",I);function D(S){A.push(S,Date.now())}function T(){const S=[];for(let C=0;C<A.length;C+=2)S.push({name:A[C],startTime:A[C+1]});return S}return{mark:D,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(I+D.startTime)});return A}};if(typeof process=="object"){const I=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function a(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var t in a)(typeof exports=="object"?exports:te)[t]=a[t]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function a(t){if(e[t])return e[t].exports;var I=e[t]={i:t,l:!1,exports:{}};return te[t].call(I.exports,I,I.exports,a),I.l=!0,I.exports}return a.m=te,a.c=e,a.d=function(t,I,A){a.o(t,I)||Object.defineProperty(t,I,{enumerable:!0,get:A})},a.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},a.t=function(t,I){if(1&I&&(t=a(t)),8&I||4&I&&typeof t=="object"&&t&&t.__esModule)return t;var A=Object.create(null);if(a.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:t}),2&I&&typeof t!="string")for(var D in t)a.d(A,D,function(T){return t[T]}.bind(null,D));return A},a.n=function(t){var I=t&&t.__esModule?function(){return t.default}:function(){return t};return a.d(I,"a",I),I},a.o=function(t,I){return Object.prototype.hasOwnProperty.call(t,I)},a.p="",a(a.s=0)}([function(te,e,a){(function(t){var I;e=te.exports=Z,I=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],C=0,R=C++;S[R]="0|[1-9]\\d*";var P=C++;S[P]="[0-9]+";var E=C++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=C++;S[y]="("+S[R]+")\\.("+S[R]+")\\.("+S[R]+")";var v=C++;S[v]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var d=C++;S[d]="(?:"+S[R]+"|"+S[E]+")";var g=C++;S[g]="(?:"+S[P]+"|"+S[E]+")";var f=C++;S[f]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var w=C++;S[w]="(?:-?("+S[g]+"(?:\\."+S[g]+")*))";var m=C++;S[m]="[0-9A-Za-z-]+";var h=C++;S[h]="(?:\\+("+S[m]+"(?:\\."+S[m]+")*))";var b=C++,s="v?"+S[y]+S[f]+"?"+S[h]+"?";S[b]="^"+s+"$";var i="[v=\\s]*"+S[v]+S[w]+"?"+S[h]+"?",c=C++;S[c]="^"+i+"$";var u=C++;S[u]="((?:<|>)?=?)";var r=C++;S[r]=S[P]+"|x|X|\\*";var o=C++;S[o]=S[R]+"|x|X|\\*";var n=C++;S[n]="[v=\\s]*("+S[o]+")(?:\\.("+S[o]+")(?:\\.("+S[o]+")(?:"+S[f]+")?"+S[h]+"?)?)?";var l=C++;S[l]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[w]+")?"+S[h]+"?)?)?";var p=C++;S[p]="^"+S[u]+"\\s*"+S[n]+"$";var k=C++;S[k]="^"+S[u]+"\\s*"+S[l]+"$";var L=C++;S[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=C++;S[U]="(?:~>?)";var K=C++;S[K]="(\\s*)"+S[U]+"\\s+",T[K]=new RegExp(S[K],"g");var G=C++;S[G]="^"+S[U]+S[n]+"$";var O=C++;S[O]="^"+S[U]+S[l]+"$";var B=C++;S[B]="(?:\\^)";var F=C++;S[F]="(\\s*)"+S[B]+"\\s+",T[F]=new RegExp(S[F],"g");var $=C++;S[$]="^"+S[B]+S[n]+"$";var M=C++;S[M]="^"+S[B]+S[l]+"$";var V=C++;S[V]="^"+S[u]+"\\s*("+i+")$|^$";var q=C++;S[q]="^"+S[u]+"\\s*("+s+")$|^$";var H=C++;S[H]="(\\s*)"+S[u]+"\\s*("+i+"|"+S[n]+")",T[H]=new RegExp(S[H],"g");var J=C++;S[J]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var Y=C++;S[Y]="^\\s*("+S[l]+")\\s+-\\s+("+S[l]+")\\s*$";var ae=C++;S[ae]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)I(re,S[re]),T[re]||(T[re]=new RegExp(S[re]));function fe(ge,Ce){if(ge instanceof Z)return ge;if(typeof ge!="string"||ge.length>A||!(Ce?T[c]:T[b]).test(ge))return null;try{return new Z(ge,Ce)}catch{return null}}function Z(ge,Ce){if(ge instanceof Z){if(ge.loose===Ce)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Z))return new Z(ge,Ce);I("SemVer",ge,Ce),this.loose=Ce;var Ie=ge.trim().match(Ce?T[c]:T[b]);if(!Ie)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+Ie[1],this.minor=+Ie[2],this.patch=+Ie[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");Ie[4]?this.prerelease=Ie[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var qe=+He;if(qe>=0&&qe<D)return qe}return He}):this.prerelease=[],this.build=Ie[5]?Ie[5].split("."):[],this.format()}e.parse=fe,e.valid=function(ge,Ce){var Ie=fe(ge,Ce);return Ie?Ie.version:null},e.clean=function(ge,Ce){var Ie=fe(ge.trim().replace(/^[=v]+/,""),Ce);return Ie?Ie.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ge){return I("SemVer.compare",this.version,this.loose,ge),ge instanceof Z||(ge=new Z(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},Z.prototype.compareMain=function(ge){return ge instanceof Z||(ge=new Z(ge,this.loose)),we(this.major,ge.major)||we(this.minor,ge.minor)||we(this.patch,ge.patch)},Z.prototype.comparePre=function(ge){if(ge instanceof Z||(ge=new Z(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Ce=0;do{var Ie=this.prerelease[Ce],He=ge.prerelease[Ce];if(I("prerelease compare",Ce,Ie,He),Ie===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(Ie===void 0)return-1;if(Ie!==He)return we(Ie,He)}while(++Ce)},Z.prototype.inc=function(ge,Ce){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ie=this.prerelease.length;--Ie>=0;)typeof this.prerelease[Ie]=="number"&&(this.prerelease[Ie]++,Ie=-2);Ie===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Ce,Ie,He){typeof Ie=="string"&&(He=Ie,Ie=void 0);try{return new Z(ge,Ie).inc(Ce,He).version}catch{return null}},e.diff=function(ge,Ce){if(se(ge,Ce))return null;var Ie=fe(ge),He=fe(Ce);if(Ie.prerelease.length||He.prerelease.length){for(var qe in Ie)if((qe==="major"||qe==="minor"||qe==="patch")&&Ie[qe]!==He[qe])return"pre"+qe;return"prerelease"}for(var qe in Ie)if((qe==="major"||qe==="minor"||qe==="patch")&&Ie[qe]!==He[qe])return qe},e.compareIdentifiers=we;var pe=/^[0-9]+$/;function we(ge,Ce){var Ie=pe.test(ge),He=pe.test(Ce);return Ie&&He&&(ge=+ge,Ce=+Ce),Ie&&!He?-1:He&&!Ie?1:ge<Ce?-1:ge>Ce?1:0}function De(ge,Ce,Ie){return new Z(ge,Ie).compare(new Z(Ce,Ie))}function Re(ge,Ce,Ie){return De(ge,Ce,Ie)>0}function Be(ge,Ce,Ie){return De(ge,Ce,Ie)<0}function se(ge,Ce,Ie){return De(ge,Ce,Ie)===0}function ue(ge,Ce,Ie){return De(ge,Ce,Ie)!==0}function de(ge,Ce,Ie){return De(ge,Ce,Ie)>=0}function ee(ge,Ce,Ie){return De(ge,Ce,Ie)<=0}function oe(ge,Ce,Ie,He){var qe;switch(Ce){case"===":typeof ge=="object"&&(ge=ge.version),typeof Ie=="object"&&(Ie=Ie.version),qe=ge===Ie;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof Ie=="object"&&(Ie=Ie.version),qe=ge!==Ie;break;case"":case"=":case"==":qe=se(ge,Ie,He);break;case"!=":qe=ue(ge,Ie,He);break;case">":qe=Re(ge,Ie,He);break;case">=":qe=de(ge,Ie,He);break;case"<":qe=Be(ge,Ie,He);break;case"<=":qe=ee(ge,Ie,He);break;default:throw new TypeError("Invalid operator: "+Ce)}return qe}function ie(ge,Ce){if(ge instanceof ie){if(ge.loose===Ce)return ge;ge=ge.value}if(!(this instanceof ie))return new ie(ge,Ce);I("comparator",ge,Ce),this.loose=Ce,this.parse(ge),this.semver===N?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(ge,Ce){return we(Ce,ge)},e.major=function(ge,Ce){return new Z(ge,Ce).major},e.minor=function(ge,Ce){return new Z(ge,Ce).minor},e.patch=function(ge,Ce){return new Z(ge,Ce).patch},e.compare=De,e.compareLoose=function(ge,Ce){return De(ge,Ce,!0)},e.rcompare=function(ge,Ce,Ie){return De(Ce,ge,Ie)},e.sort=function(ge,Ce){return ge.sort(function(Ie,He){return e.compare(Ie,He,Ce)})},e.rsort=function(ge,Ce){return ge.sort(function(Ie,He){return e.rcompare(Ie,He,Ce)})},e.gt=Re,e.lt=Be,e.eq=se,e.neq=ue,e.gte=de,e.lte=ee,e.cmp=oe,e.Comparator=ie;var N={};function z(ge,Ce){if(ge instanceof z)return ge.loose===Ce?ge:new z(ge.raw,Ce);if(ge instanceof ie)return new z(ge.value,Ce);if(!(this instanceof z))return new z(ge,Ce);if(this.loose=Ce,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(Ie){return this.parseRange(Ie.trim())},this).filter(function(Ie){return Ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function X(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function Q(ge,Ce,Ie,He,qe,Ze,xe,tt,nt,ft,it,Fe,lt){return((Ce=X(Ie)?"":X(He)?">="+Ie+".0.0":X(qe)?">="+Ie+"."+He+".0":">="+Ce)+" "+(tt=X(nt)?"":X(ft)?"<"+(+nt+1)+".0.0":X(it)?"<"+nt+"."+(+ft+1)+".0":Fe?"<="+nt+"."+ft+"."+it+"-"+Fe:"<="+tt)).trim()}function le(ge,Ce){for(var Ie=0;Ie<ge.length;Ie++)if(!ge[Ie].test(Ce))return!1;if(Ce.prerelease.length){for(Ie=0;Ie<ge.length;Ie++)if(I(ge[Ie].semver),ge[Ie].semver!==N&&ge[Ie].semver.prerelease.length>0){var He=ge[Ie].semver;if(He.major===Ce.major&&He.minor===Ce.minor&&He.patch===Ce.patch)return!0}return!1}return!0}function be(ge,Ce,Ie){try{Ce=new z(Ce,Ie)}catch{return!1}return Ce.test(ge)}function Te(ge,Ce,Ie,He){var qe,Ze,xe,tt,nt;switch(ge=new Z(ge,He),Ce=new z(Ce,He),Ie){case">":qe=Re,Ze=ee,xe=Be,tt=">",nt=">=";break;case"<":qe=Be,Ze=de,xe=Re,tt="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(ge,Ce,He))return!1;for(var ft=0;ft<Ce.set.length;++ft){var it=Ce.set[ft],Fe=null,lt=null;if(it.forEach(function(W){W.semver===N&&(W=new ie(">=0.0.0")),Fe=Fe||W,lt=lt||W,qe(W.semver,Fe.semver,He)?Fe=W:xe(W.semver,lt.semver,He)&&(lt=W)}),Fe.operator===tt||Fe.operator===nt||(!lt.operator||lt.operator===tt)&&Ze(ge,lt.semver)||lt.operator===nt&&xe(ge,lt.semver))return!1}return!0}ie.prototype.parse=function(ge){var Ce=this.loose?T[V]:T[q],Ie=ge.match(Ce);if(!Ie)throw new TypeError("Invalid comparator: "+ge);this.operator=Ie[1],this.operator==="="&&(this.operator=""),Ie[2]?this.semver=new Z(Ie[2],this.loose):this.semver=N},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(ge){return I("Comparator.test",ge,this.loose),this.semver===N||(typeof ge=="string"&&(ge=new Z(ge,this.loose)),oe(ge,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(ge,Ce){if(!(ge instanceof ie))throw new TypeError("a Comparator is required");var Ie;if(this.operator==="")return Ie=new z(ge.value,Ce),be(this.value,Ie,Ce);if(ge.operator==="")return Ie=new z(this.value,Ce),be(ge.semver,Ie,Ce);var He=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),Ze=this.semver.version===ge.semver.version,xe=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),tt=oe(this.semver,"<",ge.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),nt=oe(this.semver,">",ge.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return He||qe||Ze&&xe||tt||nt},e.Range=z,z.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},z.prototype.toString=function(){return this.range},z.prototype.parseRange=function(ge){var Ce=this.loose;ge=ge.trim(),I("range",ge,Ce);var Ie=Ce?T[Y]:T[J];ge=ge.replace(Ie,Q),I("hyphen replace",ge),ge=ge.replace(T[H],"$1$2$3"),I("comparator trim",ge,T[H]),ge=(ge=(ge=ge.replace(T[K],"$1~")).replace(T[F],"$1^")).split(/\s+/).join(" ");var He=Ce?T[V]:T[q],qe=ge.split(" ").map(function(Ze){return function(xe,tt){return I("comp",xe),xe=function(nt,ft){return nt.trim().split(/\s+/).map(function(it){return function(Fe,lt){I("caret",Fe,lt);var W=lt?T[M]:T[$];return Fe.replace(W,function(_,ce,Pe,Le,Ge){var Qe;return I("caret",Fe,_,ce,Pe,Le,Ge),X(ce)?Qe="":X(Pe)?Qe=">="+ce+".0.0 <"+(+ce+1)+".0.0":X(Le)?Qe=ce==="0"?">="+ce+"."+Pe+".0 <"+ce+"."+(+Pe+1)+".0":">="+ce+"."+Pe+".0 <"+(+ce+1)+".0.0":Ge?(I("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Qe=ce==="0"?Pe==="0"?">="+ce+"."+Pe+"."+Le+Ge+" <"+ce+"."+Pe+"."+(+Le+1):">="+ce+"."+Pe+"."+Le+Ge+" <"+ce+"."+(+Pe+1)+".0":">="+ce+"."+Pe+"."+Le+Ge+" <"+(+ce+1)+".0.0"):(I("no pr"),Qe=ce==="0"?Pe==="0"?">="+ce+"."+Pe+"."+Le+" <"+ce+"."+Pe+"."+(+Le+1):">="+ce+"."+Pe+"."+Le+" <"+ce+"."+(+Pe+1)+".0":">="+ce+"."+Pe+"."+Le+" <"+(+ce+1)+".0.0"),I("caret return",Qe),Qe})}(it,ft)}).join(" ")}(xe,tt),I("caret",xe),xe=function(nt,ft){return nt.trim().split(/\s+/).map(function(it){return function(Fe,lt){var W=lt?T[O]:T[G];return Fe.replace(W,function(_,ce,Pe,Le,Ge){var Qe;return I("tilde",Fe,_,ce,Pe,Le,Ge),X(ce)?Qe="":X(Pe)?Qe=">="+ce+".0.0 <"+(+ce+1)+".0.0":X(Le)?Qe=">="+ce+"."+Pe+".0 <"+ce+"."+(+Pe+1)+".0":Ge?(I("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Qe=">="+ce+"."+Pe+"."+Le+Ge+" <"+ce+"."+(+Pe+1)+".0"):Qe=">="+ce+"."+Pe+"."+Le+" <"+ce+"."+(+Pe+1)+".0",I("tilde return",Qe),Qe})}(it,ft)}).join(" ")}(xe,tt),I("tildes",xe),xe=function(nt,ft){return I("replaceXRanges",nt,ft),nt.split(/\s+/).map(function(it){return function(Fe,lt){Fe=Fe.trim();var W=lt?T[k]:T[p];return Fe.replace(W,function(_,ce,Pe,Le,Ge,Qe){I("xRange",Fe,_,ce,Pe,Le,Ge,Qe);var ut=X(Pe),mt=ut||X(Le),st=mt||X(Ge);return ce==="="&&st&&(ce=""),ut?_=ce===">"||ce==="<"?"<0.0.0":"*":ce&&st?(mt&&(Le=0),st&&(Ge=0),ce===">"?(ce=">=",mt?(Pe=+Pe+1,Le=0,Ge=0):st&&(Le=+Le+1,Ge=0)):ce==="<="&&(ce="<",mt?Pe=+Pe+1:Le=+Le+1),_=ce+Pe+"."+Le+"."+Ge):mt?_=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":st&&(_=">="+Pe+"."+Le+".0 <"+Pe+"."+(+Le+1)+".0"),I("xRange return",_),_})}(it,ft)}).join(" ")}(xe,tt),I("xrange",xe),xe=function(nt,ft){return I("replaceStars",nt,ft),nt.trim().replace(T[ae],"")}(xe,tt),I("stars",xe),xe}(Ze,Ce)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(Ze){return!!Ze.match(He)})),qe=qe.map(function(Ze){return new ie(Ze,Ce)})},z.prototype.intersects=function(ge,Ce){if(!(ge instanceof z))throw new TypeError("a Range is required");return this.set.some(function(Ie){return Ie.every(function(He){return ge.set.some(function(qe){return qe.every(function(Ze){return He.intersects(Ze,Ce)})})})})},e.toComparators=function(ge,Ce){return new z(ge,Ce).set.map(function(Ie){return Ie.map(function(He){return He.value}).join(" ").trim().split(" ")})},z.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new Z(ge,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(le(this.set[Ce],ge))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(ge,Ce,Ie){var He=null,qe=null;try{var Ze=new z(Ce,Ie)}catch{return null}return ge.forEach(function(xe){Ze.test(xe)&&(He&&qe.compare(xe)!==-1||(qe=new Z(He=xe,Ie)))}),He},e.minSatisfying=function(ge,Ce,Ie){var He=null,qe=null;try{var Ze=new z(Ce,Ie)}catch{return null}return ge.forEach(function(xe){Ze.test(xe)&&(He&&qe.compare(xe)!==1||(qe=new Z(He=xe,Ie)))}),He},e.validRange=function(ge,Ce){try{return new z(ge,Ce).range||"*"}catch{return null}},e.ltr=function(ge,Ce,Ie){return Te(ge,Ce,"<",Ie)},e.gtr=function(ge,Ce,Ie){return Te(ge,Ce,">",Ie)},e.outside=Te,e.prerelease=function(ge,Ce){var Ie=fe(ge,Ce);return Ie&&Ie.prerelease.length?Ie.prerelease:null},e.intersects=function(ge,Ce,Ie){return ge=new z(ge,Ie),Ce=new z(Ce,Ie),ge.intersects(Ce)},e.coerce=function(ge){if(ge instanceof Z)return ge;if(typeof ge!="string")return null;var Ce=ge.match(T[L]);return Ce==null?null:fe((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,a(1))},function(te,e){var a,t,I=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function T(g){if(a===setTimeout)return setTimeout(g,0);if((a===A||!a)&&setTimeout)return a=setTimeout,setTimeout(g,0);try{return a(g,0)}catch{try{return a.call(null,g,0)}catch{return a.call(this,g,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:A}catch{a=A}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var S,C=[],R=!1,P=-1;function E(){R&&S&&(R=!1,S.length?C=S.concat(C):P=-1,C.length&&y())}function y(){if(!R){var g=T(E);R=!0;for(var f=C.length;f;){for(S=C,C=[];++P<f;)S&&S[P].run();P=-1,f=C.length}S=null,R=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(g)}}function v(g,f){this.fun=g,this.array=f}function d(){}I.nextTick=function(g){var f=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)f[w-1]=arguments[w];C.push(new v(g,f)),C.length!==1||R||T(y)},v.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=d,I.addListener=d,I.once=d,I.off=d,I.removeListener=d,I.removeAllListeners=d,I.emit=d,I.prependListener=d,I.prependOnceListener=d,I.listeners=function(g){return[]},I.binding=function(g){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(g){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Se[101],ye([1,0,10,6]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(h){const b=h;return b?typeof b.read=="function":!1}e.isReadable=I;function A(h){const b=h;return b?[b.on,b.pause,b.resume,b.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=A;function D(h){const b=h;return b?A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=D;function T(h,b){return new S(h,b)}e.newWriteableStream=T;class S{constructor(b,s){this.e=b,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(s=>s(b))}h(b){this.c.error.length===0?(0,a.onUnexpectedError)(b):this.c.error.slice(0).forEach(s=>s(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,s){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(b,s){if(this.a.destroyed)return;let i;switch(b){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const c=i.indexOf(s);c>=0&&i.splice(c,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function C(h,b){const s=[];let i;for(;(i=h.read())!==null;)s.push(i);return b(s)}e.consumeReadable=C;function R(h,b,s){const i=[];let c;for(;(c=h.read())!==null&&i.length<s;)i.push(c);return c===null&&i.length>0?b(i):{read:()=>{if(i.length>0)return i.shift();if(typeof c<"u"){const u=c;return c=void 0,u}return h.read()}}}e.peekReadable=R;function P(h,b){return new Promise((s,i)=>{const c=[];E(h,{onData:u=>{b&&c.push(u)},onError:u=>{b?i(u):s(void 0)},onEnd:()=>{s(b?b(c):void 0)}})})}e.consumeStream=P;function E(h,b){let s=!1;return h.on("error",i=>{s||b.onError(i)}),h.on("end",()=>{s||b.onEnd()}),h.on("data",i=>{s||b.onData(i)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=E;function y(h,b){return new Promise((s,i)=>{const c=new t.DisposableStore,u=[],r=l=>{if(u.push(l),u.length>b)return c.dispose(),h.pause(),s({stream:h,buffer:u,ended:!1})},o=l=>i(l),n=()=>s({stream:h,buffer:u,ended:!0});c.add((0,t.toDisposable)(()=>h.removeListener("error",o))),h.on("error",o),c.add((0,t.toDisposable)(()=>h.removeListener("end",n))),h.on("end",n),c.add((0,t.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}e.peekStream=y;function v(h,b){const s=T(b);return s.end(h),s}e.toStream=v;function d(){const h=T(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function g(h){let b=!1;return{read:()=>b?null:(b=!0,h)}}e.toReadable=g;function f(h,b,s){const i=T(s);return E(h,{onData:c=>i.write(b.data(c)),onError:c=>i.error(b.error?b.error(c):c),onEnd:()=>i.end()}),i}e.transform=f;function w(h,b,s){let i=!1;return{read:()=>{const c=b.read();return i?c:(i=!0,c!==null?s([h,c]):h)}}}e.prefixedReadable=w;function m(h,b,s){let i=!1;const c=T(s);return E(b,{onData:u=>i?c.write(u):(i=!0,c.write(s([h,u]))),onError:u=>c.error(u),onEnd:()=>{i||(i=!0,c.write(h)),c.end()}}),c}e.prefixedStream=m}),define(Se[22],ye([1,0,101]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let I,A;class D{static alloc(l){return t?new D(Buffer.allocUnsafe(l)):new D(new Uint8Array(l))}static wrap(l){return t&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new D(l)}static fromString(l,p){return!(p?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(l)):(I||(I=new TextEncoder),new D(I.encode(l)))}static fromByteArray(l){const p=D.alloc(l.length);for(let k=0,L=l.length;k<L;k++)p.buffer[k]=l[k];return p}static concat(l,p){if(typeof p>"u"){p=0;for(let U=0,K=l.length;U<K;U++)p+=l[U].byteLength}const k=D.alloc(p);let L=0;for(let U=0,K=l.length;U<K;U++){const G=l[U];k.set(G,L),L+=G.byteLength}return k}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=D.alloc(this.byteLength);return l.set(this),l}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(l,p){return new D(this.buffer.subarray(l,p))}set(l,p){if(l instanceof D)this.buffer.set(l.buffer,p);else if(l instanceof Uint8Array)this.buffer.set(l,p);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),p);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return C(this.buffer,l)}writeUInt32BE(l,p){R(this.buffer,l,p)}readUInt32LE(l){return P(this.buffer,l)}writeUInt32LE(l,p){E(this.buffer,l,p)}readUInt8(l){return y(this.buffer,l)}writeUInt8(l,p){v(this.buffer,l,p)}}e.VSBuffer=D;function T(n,l){return n[l+0]<<0>>>0|n[l+1]<<8>>>0}e.readUInt16LE=T;function S(n,l,p){n[p+0]=l&255,l=l>>>8,n[p+1]=l&255}e.writeUInt16LE=S;function C(n,l){return n[l]*2**24+n[l+1]*2**16+n[l+2]*2**8+n[l+3]}e.readUInt32BE=C;function R(n,l,p){n[p+3]=l,l=l>>>8,n[p+2]=l,l=l>>>8,n[p+1]=l,l=l>>>8,n[p]=l}e.writeUInt32BE=R;function P(n,l){return n[l+0]<<0>>>0|n[l+1]<<8>>>0|n[l+2]<<16>>>0|n[l+3]<<24>>>0}e.readUInt32LE=P;function E(n,l,p){n[p+0]=l&255,l=l>>>8,n[p+1]=l&255,l=l>>>8,n[p+2]=l&255,l=l>>>8,n[p+3]=l&255}e.writeUInt32LE=E;function y(n,l){return n[l]}e.readUInt8=y;function v(n,l,p){n[p]=l}e.writeUInt8=v;function d(n){return a.consumeReadable(n,l=>D.concat(l))}e.readableToBuffer=d;function g(n){return a.toReadable(n)}e.bufferToReadable=g;function f(n){return a.consumeStream(n,l=>D.concat(l))}e.streamToBuffer=f;async function w(n){return n.ended?D.concat(n.buffer):D.concat([...n.buffer,await f(n.stream)])}e.bufferedStreamToBuffer=w;function m(n){return a.toStream(n,l=>D.concat(l))}e.bufferToStream=m;function h(n){return a.transform(n,{data:l=>typeof l=="string"?D.fromString(l):D.wrap(l)},l=>D.concat(l))}e.streamToBufferReadableStream=h;function b(n){return a.newWriteableStream(l=>D.concat(l),n)}e.newWriteableBufferStream=b;function s(n,l){return a.prefixedReadable(n,l,p=>D.concat(p))}e.prefixedBufferReadable=s;function i(n,l){return a.prefixedStream(n,l,p=>D.concat(p))}e.prefixedBufferStream=i;function c(n){let l=0,p=0,k=0;const L=new Uint8Array(Math.floor(n.length/4*3)),U=G=>{switch(p){case 3:L[k++]=l|G,p=0;break;case 2:L[k++]=l|G>>>2,l=G<<6,p=3;break;case 1:L[k++]=l|G>>>4,l=G<<4,p=2;break;default:l=G<<2,p=1}};for(let G=0;G<n.length;G++){const O=n.charCodeAt(G);if(O>=65&&O<=90)U(O-65);else if(O>=97&&O<=122)U(O-97+26);else if(O>=48&&O<=57)U(O-48+52);else if(O===43||O===45)U(62);else if(O===47||O===95)U(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${n[G]}`)}}const K=k;for(;p>0;)U(0);return D.wrap(L).slice(0,K)}e.decodeBase64=c;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:n},l=!0,p=!1){const k=p?r:u;let L="";const U=n.byteLength%3;let K=0;for(;K<n.byteLength-U;K+=3){const G=n[K+0],O=n[K+1],B=n[K+2];L+=k[G>>>2],L+=k[(G<<4|O>>>4)&63],L+=k[(O<<2|B>>>6)&63],L+=k[B&63]}if(U===1){const G=n[K+0];L+=k[G>>>2],L+=k[G<<4&63],l&&(L+="==")}else if(U===2){const G=n[K+0],O=n[K+1];L+=k[G>>>2],L+=k[(G<<4|O>>>4)&63],L+=k[O<<2&63],l&&(L+="=")}return L}e.encodeBase64=o}),define(Se[11],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(i){return typeof i=="string"}e.isString=a;function t(i){return Array.isArray(i)&&i.every(c=>a(c))}e.isStringArray=t;function I(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.isObject=I;function A(i){const c=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof c}e.isTypedArray=A;function D(i){return typeof i=="number"&&!isNaN(i)}e.isNumber=D;function T(i){return!!i&&typeof i[Symbol.iterator]=="function"}e.isIterable=T;function S(i){return i===!0||i===!1}e.isBoolean=S;function C(i){return typeof i>"u"}e.isUndefined=C;function R(i){return!P(i)}e.isDefined=R;function P(i){return C(i)||i===null}e.isUndefinedOrNull=P;function E(i,c){if(!i)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=E;function y(i){if(P(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.assertIsDefined=y;function v(...i){const c=[];for(let u=0;u<i.length;u++){const r=i[u];if(P(r))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);c.push(r)}return c}e.assertAllDefined=v;const d=Object.prototype.hasOwnProperty;function g(i){if(!I(i))return!1;for(const c in i)if(d.call(i,c))return!1;return!0}e.isEmptyObject=g;function f(i){return typeof i=="function"}e.isFunction=f;function w(...i){return i.length>0&&i.every(f)}e.areFunctions=w;function m(i,c){const u=Math.min(i.length,c.length);for(let r=0;r<u;r++)h(i[r],c[r])}e.validateConstraints=m;function h(i,c){if(a(c)){if(typeof i!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(f(c)){try{if(i instanceof c)return}catch{}if(!P(i)&&i.constructor===c||c.length===1&&c.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function b(i){return i===null?void 0:i}e.withNullAsUndefined=b;function s(i){return typeof i>"u"?null:i}e.withUndefinedAsNull=s}),define(Se[23],ye([1,0,11]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const w=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([m,h])=>{w[m]=h&&typeof h=="object"?t(h):h}),w}e.deepClone=t;function I(f){if(!f||typeof f!="object")return f;const w=[f];for(;w.length>0;){const m=w.shift();Object.freeze(m);for(const h in m)if(A.call(m,h)){const b=m[h];typeof b=="object"&&!Object.isFrozen(b)&&!(0,a.isTypedArray)(b)&&w.push(b)}}return f}e.deepFreeze=I;const A=Object.prototype.hasOwnProperty;function D(f,w){return T(f,w,new Set)}e.cloneAndChange=D;function T(f,w,m){if((0,a.isUndefinedOrNull)(f))return f;const h=w(f);if(typeof h<"u")return h;if(Array.isArray(f)){const b=[];for(const s of f)b.push(T(s,w,m));return b}if((0,a.isObject)(f)){if(m.has(f))throw new Error("Cannot clone recursive data-structure");m.add(f);const b={};for(const s in f)A.call(f,s)&&(b[s]=T(f[s],w,m));return m.delete(f),b}return f}function S(f,w,m=!0){return(0,a.isObject)(f)?((0,a.isObject)(w)&&Object.keys(w).forEach(h=>{h in f?m&&((0,a.isObject)(f[h])&&(0,a.isObject)(w[h])?S(f[h],w[h],m):f[h]=w[h]):f[h]=w[h]}),f):w}e.mixin=S;function C(f,w){if(f===w)return!0;if(f==null||w===null||w===void 0||typeof f!=typeof w||typeof f!="object"||Array.isArray(f)!==Array.isArray(w))return!1;let m,h;if(Array.isArray(f)){if(f.length!==w.length)return!1;for(m=0;m<f.length;m++)if(!C(f[m],w[m]))return!1}else{const b=[];for(h in f)b.push(h);b.sort();const s=[];for(h in w)s.push(h);if(s.sort(),!C(b,s))return!1;for(m=0;m<b.length;m++)if(!C(f[b[m]],w[b[m]]))return!1}return!0}e.equals=C;function R(f){const w=new Set;return JSON.stringify(f,(m,h)=>{if((0,a.isObject)(h)||Array.isArray(h)){if(w.has(h))return"[Circular]";w.add(h)}return h})}e.safeStringify=R;function P(f,w){const m=Object.create(null);return!f||!w||Object.keys(w).forEach(b=>{const s=f[b],i=w[b];C(s,i)||(m[b]=i)}),m}e.distinct=P;function E(f,w){const m=w.toLowerCase(),h=Object.keys(f).find(b=>b.toLowerCase()===m);return h?f[h]:f[w]}e.getCaseInsensitive=E;function y(f,w){const m=Object.create(null);for(const[h,b]of Object.entries(f))w(h,b)&&(m[h]=b);return m}e.filter=y;function v(f){let w=[],m=Object.getPrototypeOf(f);for(;Object.prototype!==m;)w=w.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return w}e.getAllPropertyNames=v;function d(f){const w=[];for(const m of v(f))typeof f[m]=="function"&&w.push(m);return w}e.getAllMethodNames=d;function g(f,w){const m=b=>function(){const s=Array.prototype.slice.call(arguments,0);return w(b,s)},h={};for(const b of f)h[b]=m(b);return h}e.createProxyObject=g}),define(Se[102],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function t(A){return A<0?0:A>255?255:A|0}e.toUint8=t;function I(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=I}),define(Se[30],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(I){return a.test(I)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const A=new Uint8Array(16),D=[];for(let T=0;T<256;T++)D.push(T.toString(16).padStart(2,"0"));return function(){I(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,C="";return C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C}}()}),define(Se[147],ye([1,0,17,30]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function I(T){return{id:(0,t.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=I;function A(T,S,C){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:S,data:C}),value:void 0}}e.createFileDataTransferItem=A;class D{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,C){const R=this.a.get(S);R?R.push(C):this.a.set(this.b(S),[C])}replace(S,C){this.a.set(this.b(S),[C])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,C]of this.a.entries())for(const R of C)yield[S,R]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[C,R]of this.entries())S(R,C)}b(S){return S.toLowerCase()}}e.VSDataTransfer=D,e.UriList=Object.freeze({create:T=>(0,a.distinct)(T.map(S=>S.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(S=>!S.startsWith("#"))})}),define(Se[103],ye([1,0,102]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(T){const S=(0,a.toUint8)(T);this.c=S,this.a=t.d(S),this.b=new Map}static d(T){const S=new Uint8Array(256);return S.fill(T),S}set(T,S){const C=(0,a.toUint8)(S);T>=0&&T<256?this.a[T]=C:this.b.set(T,C)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var I;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(I||(I={}));class A{constructor(){this.a=new t(0)}add(T){this.a.set(T,1)}has(T){return this.a.get(T)===1}clear(){return this.a.clear()}}e.CharacterSet=A}),define(Se[49],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(I,A){this.lineNumber=I,this.column=A}with(I=this.lineNumber,A=this.column){return I===this.lineNumber&&A===this.column?this:new a(I,A)}delta(I=0,A=0){return this.with(this.lineNumber+I,this.column+A)}equals(I){return a.equals(this,I)}static equals(I,A){return!I&&!A?!0:!!I&&!!A&&I.lineNumber===A.lineNumber&&I.column===A.column}isBefore(I){return a.isBefore(this,I)}static isBefore(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<A.column}isBeforeOrEqual(I){return a.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<=A.column}static compare(I,A){const D=I.lineNumber|0,T=A.lineNumber|0;if(D===T){const S=I.column|0,C=A.column|0;return S-C}return D-T}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new a(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=a}),define(Se[35],ye([1,0,49]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(A,D,T,S){A>T||A===T&&D>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=A,this.endColumn=D):(this.startLineNumber=A,this.startColumn=D,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return t.containsPosition(this,A)}static containsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<A.startColumn||D.lineNumber===A.endLineNumber&&D.column>A.endColumn)}static strictContainsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<=A.startColumn||D.lineNumber===A.endLineNumber&&D.column>=A.endColumn)}containsRange(A){return t.containsRange(this,A)}static containsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>A.endColumn)}strictContainsRange(A){return t.strictContainsRange(this,A)}static strictContainsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<=A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>=A.endColumn)}plusRange(A){return t.plusRange(this,A)}static plusRange(A,D){let T,S,C,R;return D.startLineNumber<A.startLineNumber?(T=D.startLineNumber,S=D.startColumn):D.startLineNumber===A.startLineNumber?(T=D.startLineNumber,S=Math.min(D.startColumn,A.startColumn)):(T=A.startLineNumber,S=A.startColumn),D.endLineNumber>A.endLineNumber?(C=D.endLineNumber,R=D.endColumn):D.endLineNumber===A.endLineNumber?(C=D.endLineNumber,R=Math.max(D.endColumn,A.endColumn)):(C=A.endLineNumber,R=A.endColumn),new t(T,S,C,R)}intersectRanges(A){return t.intersectRanges(this,A)}static intersectRanges(A,D){let T=A.startLineNumber,S=A.startColumn,C=A.endLineNumber,R=A.endColumn;const P=D.startLineNumber,E=D.startColumn,y=D.endLineNumber,v=D.endColumn;return T<P?(T=P,S=E):T===P&&(S=Math.max(S,E)),C>y?(C=y,R=v):C===y&&(R=Math.min(R,v)),T>C||T===C&&S>R?null:new t(T,S,C,R)}equalsRange(A){return t.equalsRange(this,A)}static equalsRange(A,D){return!A&&!D?!0:!!A&&!!D&&A.startLineNumber===D.startLineNumber&&A.startColumn===D.startColumn&&A.endLineNumber===D.endLineNumber&&A.endColumn===D.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(A){return new a.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(A){return new a.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,D){return new t(this.startLineNumber,this.startColumn,A,D)}setStartPosition(A,D){return new t(A,D,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(A){return new t(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static collapseToStart(A){return new t(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,D=A){return new t(A.lineNumber,A.column,D.lineNumber,D.column)}static lift(A){return A?new t(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn)}static areIntersecting(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,D){if(A&&D){const C=A.startLineNumber|0,R=D.startLineNumber|0;if(C===R){const P=A.startColumn|0,E=D.startColumn|0;if(P===E){const y=A.endLineNumber|0,v=D.endLineNumber|0;if(y===v){const d=A.endColumn|0,g=D.endColumn|0;return d-g}return y-v}return P-E}return C-R}return(A?1:0)-(D?1:0)}static compareRangesUsingEnds(A,D){return A.endLineNumber===D.endLineNumber?A.endColumn===D.endColumn?A.startLineNumber===D.startLineNumber?A.startColumn-D.startColumn:A.startLineNumber-D.startLineNumber:A.endColumn-D.endColumn:A.endLineNumber-D.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=t}),define(Se[148],ye([1,0,49,35]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class A extends t.Range{constructor(T,S,C,R){super(T,S,C,R),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return A.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,T,S):new A(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new A(T,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new A(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new A(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new A(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new A(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let C=0,R=T.length;C<R;C++)if(!this.selectionsEqual(T[C],S[C]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,C,R,P){return P===0?new A(T,S,C,R):new A(C,R,T,S)}}e.Selection=A}),define(Se[149],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[150],ye([1,0,103]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends a.CharacterClassifier{constructor(T){super(0);for(let S=0,C=T.length;S<C;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function A(D){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=D(S)),T[S])}e.getMapForWordSeparators=A(D=>new I(D))}),define(Se[104],ye([1,0,62,6,63]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.USUAL_WORD_SEPARATORS)P.indexOf(y)>=0||(E+="\\"+y);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=A();function D(P){let E=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)E=P;else{let y="g";P.ignoreCase&&(y+="i"),P.multiline&&(y+="m"),P.unicode&&(y+="u"),E=new RegExp(P.source,y)}return E.lastIndex=0,E}e.ensureValidWordDefinition=D;const T=new I.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(P){const E=T.unshift(P);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function C(P,E,y,v,d){if(d||(d=a.Iterable.first(T)),y.length>d.maxLen){let h=P-d.maxLen/2;return h<0?h=0:v+=h,y=y.substring(h,P+d.maxLen/2),C(P,E,y,v,d)}const g=Date.now(),f=P-1-v;let w=-1,m=null;for(let h=1;!(Date.now()-g>=d.timeBudget);h++){const b=f-d.windowSize*h;E.lastIndex=Math.max(0,b);const s=R(E,y,f,w);if(!s&&m||(m=s,b<=0))break;w=b}if(m){const h={word:m[0],startColumn:v+1+m.index,endColumn:v+1+m.index+m[0].length};return E.lastIndex=0,h}return null}e.getWordAtText=C;function R(P,E,y,v){let d;for(;d=P.exec(E);){const g=d.index||0;if(g<=y&&P.lastIndex>=y)return d;if(v>0&&g>v)return null}return null}}),define(Se[151],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class t{constructor(T){if(this.e=null,this.f=!1,this.open=T.open,this.close=T.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(T.notIn))for(let S=0,C=T.notIn.length;S<C;S++)switch(T.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const C=T.findTokenIndexAtOffset(S-2),R=T.getStandardTokenType(C);return this.isOK(R)}g(T,S){for(let C=T;C<=S;C++){const R=String.fromCharCode(C);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class I{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function A(D,T,S){D.has(T)?D.get(T).push(S):D.set(T,[S])}}),define(Se[152],ye([1,0,103]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(v,d,g){const f=new Uint8Array(v*d);for(let w=0,m=v*d;w<m;w++)f[w]=g;this.a=f,this.rows=v,this.cols=d}get(v,d){return this.a[v*this.cols+d]}set(v,d,g){this.a[v*this.cols+d]=g}}class A{constructor(v){let d=0,g=0;for(let w=0,m=v.length;w<m;w++){const[h,b,s]=v[w];b>d&&(d=b),h>g&&(g=h),s>g&&(g=s)}d++,g++;const f=new I(g,d,0);for(let w=0,m=v.length;w<m;w++){const[h,b,s]=v[w];f.set(h,b,s)}this.a=f,this.b=d}nextState(v,d){return d<0||d>=this.b?0:this.a.get(v,d)}}e.StateMachine=A;let D=null;function T(){return D===null&&(D=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var S;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function R(){if(C===null){C=new a.CharacterClassifier(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<y.length;d++)C.set(y.charCodeAt(d),1);const v=".,;:";for(let d=0;d<v.length;d++)C.set(v.charCodeAt(d),2)}return C}class P{static a(v,d,g,f,w){let m=w-1;do{const h=d.charCodeAt(m);if(v.get(h)!==2)break;m--}while(m>f);if(f>0){const h=d.charCodeAt(f-1),b=d.charCodeAt(m);(h===40&&b===41||h===91&&b===93||h===123&&b===125)&&m--}return{range:{startLineNumber:g,startColumn:f+1,endLineNumber:g,endColumn:m+2},url:d.substring(f,m+1)}}static computeLinks(v,d=T()){const g=R(),f=[];for(let w=1,m=v.getLineCount();w<=m;w++){const h=v.getLineContent(w),b=h.length;let s=0,i=0,c=0,u=1,r=!1,o=!1,n=!1,l=!1;for(;s<b;){let p=!1;const k=h.charCodeAt(s);if(u===13){let L;switch(k){case 40:r=!0,L=0;break;case 41:L=r?0:1;break;case 91:n=!0,o=!0,L=0;break;case 93:n=!1,L=o?0:1;break;case 123:l=!0,L=0;break;case 125:L=l?0:1;break;case 39:case 34:case 96:c===k?L=1:c===39||c===34||c===96?L=0:L=1;break;case 42:L=c===42?1:0;break;case 124:L=c===124?1:0;break;case 32:L=n?0:1;break;default:L=g.get(k)}L===1&&(f.push(P.a(g,h,w,i,s)),p=!0)}else if(u===12){let L;k===91?(o=!0,L=0):L=g.get(k),L===1?p=!0:u=13}else u=d.nextState(u,k),u===0&&(p=!0);p&&(u=1,r=!1,o=!1,l=!1,i=s+1,c=k),s++}u===13&&f.push(P.a(g,h,w,i,b))}return f}}e.LinkComputer=P;function E(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:P.computeLinks(y)}e.computeLinks=E}),define(Se[105],ye([1,0,23]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=Math.max(1,h.indentSize|0),this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace),this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class R{constructor(h,b){this._findMatchBrand=void 0,this.range=h,this.matches=b}}e.FindMatch=R;var P;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(m){return m&&typeof m.read=="function"}e.isITextSnapshot=E;var y;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(y=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class d{constructor(h,b,s,i,c,u){this.identifier=h,this.range=b,this.text=s,this.forceMoveMarkers=i,this.isAutoWhitespaceEdit=c,this._isTracked=u}}e.ValidAnnotatedEditOperation=d;class g{constructor(h,b,s){this.regex=h,this.wordSeparators=b,this.simpleSearch=s}}e.SearchData=g;class f{constructor(h,b,s){this.reverseEdits=h,this.changes=b,this.trimAutoWhitespaceLineNumbers=s}}e.ApplyEditsResult=f;function w(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.shouldSynchronizeModel=w}),define(Se[153],ye([1,0,17,102]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,C){S=(0,t.toUint32)(S);const R=this.a,P=this.b,E=C.length;return E===0?!1:(this.a=new Uint32Array(R.length+E),this.a.set(R.subarray(0,S),0),this.a.set(R.subarray(S),S+E),this.a.set(C,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(S,C){return S=(0,t.toUint32)(S),C=(0,t.toUint32)(C),this.a[S]===C?!1:(this.a[S]=C,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,C){S=(0,t.toUint32)(S),C=(0,t.toUint32)(C);const R=this.a,P=this.b;if(S>=R.length)return!1;const E=R.length-S;return C>=E&&(C=E),C===0?!1:(this.a=new Uint32Array(R.length-C),this.a.set(R.subarray(0,S),0),this.a.set(R.subarray(S+C),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let C=this.c[0]+1;C===0&&(this.b[0]=this.a[0],C++),S>=this.a.length&&(S=this.a.length-1);for(let R=C;R<=S;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let C=0,R=this.a.length-1,P=0,E=0,y=0;for(;C<=R;)if(P=C+(R-C)/2|0,E=this.b[P],y=E-this.a[P],S<y)R=P-1;else if(S>=E)C=P+1;else break;return new D(P,S-y)}}e.PrefixSumComputer=I;class A{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const C=this.e[S],R=C>0?this.d[C-1]:0;return new D(C,S-R)}removeValues(S,C){this.a.splice(S,C),this.f(S)}insertValues(S,C){this.a=(0,a.arrayInsert)(this.a,S,C),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,C=this.a.length;S<C;S++){const R=this.a[S],P=S>0?this.d[S-1]:0;this.d[S]=P+R;for(let E=0;E<R;E++)this.e[P+E]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,C){this.a[S]!==C&&(this.a[S]=C,this.f(S))}}e.ConstantTimePrefixSumComputer=A;class D{constructor(S,C){this.index=S,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=C}}e.PrefixSumIndexOfResult=D}),define(Se[154],ye([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(Se[155],ye([1,0,154]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,A=I*24,D=A*7,T=A*30,S=A*365;function C(P,E,y){typeof P!="number"&&(P=P.getTime());const v=Math.round((new Date().getTime()-P)/1e3);if(v<-30)return(0,a.localize)(0,null,C(new Date().getTime()+v*1e3,!1));if(v<30)return(0,a.localize)(1,null);let d;return v<t?(d=v,E?d===1?y?(0,a.localize)(2,null,d):(0,a.localize)(3,null,d):y?(0,a.localize)(4,null,d):(0,a.localize)(5,null,d):d===1?y?(0,a.localize)(6,null,d):(0,a.localize)(7,null,d):y?(0,a.localize)(8,null,d):(0,a.localize)(9,null,d)):v<I?(d=Math.floor(v/t),E?d===1?y?(0,a.localize)(10,null,d):(0,a.localize)(11,null,d):y?(0,a.localize)(12,null,d):(0,a.localize)(13,null,d):d===1?y?(0,a.localize)(14,null,d):(0,a.localize)(15,null,d):y?(0,a.localize)(16,null,d):(0,a.localize)(17,null,d)):v<A?(d=Math.floor(v/I),E?d===1?y?(0,a.localize)(18,null,d):(0,a.localize)(19,null,d):y?(0,a.localize)(20,null,d):(0,a.localize)(21,null,d):d===1?y?(0,a.localize)(22,null,d):(0,a.localize)(23,null,d):y?(0,a.localize)(24,null,d):(0,a.localize)(25,null,d)):v<D?(d=Math.floor(v/A),E?d===1?(0,a.localize)(26,null,d):(0,a.localize)(27,null,d):d===1?(0,a.localize)(28,null,d):(0,a.localize)(29,null,d)):v<T?(d=Math.floor(v/D),E?d===1?y?(0,a.localize)(30,null,d):(0,a.localize)(31,null,d):y?(0,a.localize)(32,null,d):(0,a.localize)(33,null,d):d===1?y?(0,a.localize)(34,null,d):(0,a.localize)(35,null,d):y?(0,a.localize)(36,null,d):(0,a.localize)(37,null,d)):v<S?(d=Math.floor(v/T),E?d===1?y?(0,a.localize)(38,null,d):(0,a.localize)(39,null,d):y?(0,a.localize)(40,null,d):(0,a.localize)(41,null,d):d===1?y?(0,a.localize)(42,null,d):(0,a.localize)(43,null,d):y?(0,a.localize)(44,null,d):(0,a.localize)(45,null,d)):(d=Math.floor(v/S),E?d===1?y?(0,a.localize)(46,null,d):(0,a.localize)(47,null,d):y?(0,a.localize)(48,null,d):(0,a.localize)(49,null,d):d===1?y?(0,a.localize)(50,null,d):(0,a.localize)(51,null,d):y?(0,a.localize)(52,null,d):(0,a.localize)(53,null,d))}e.fromNow=C;function R(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Se[156],ye([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Se[50],ye([1,0,17,11,156]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(P,E){return E&&(P.stack||P.stacktrace)?I.localize(0,null,T(P),D(P.stack)||D(P.stacktrace)):T(P)}function D(P){return Array.isArray(P)?P.join(`
`):P}function T(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function S(P=null,E=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const y=a.coalesce(P),v=S(y[0],E);return y.length>1?I.localize(4,null,v,y.length):v}if(t.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return A(y.error,E);if(y.exception)return A(y.exception,E)}return P.stack?A(P,E):P.message?P.message:I.localize(5,null)}e.toErrorMessage=S;function C(P){const E=P;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=C;function R(P,E){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=E,y}e.createErrorWithActions=R}),define(Se[157],ye([19,20]),function(te,e){return te.create("vs/base/common/platform",e)}),define(Se[12],ye([1,0,157]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,I=!1,A=!1,D=!1,T=!1,S=!1,C=!1,R=!1,P=!1,E=!1,y,v=e.LANGUAGE_DEFAULT,d,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const w=typeof f?.versions?.electron=="string",m=w&&f?.type==="renderer";if(typeof navigator=="object"&&!m)g=navigator.userAgent,t=g.indexOf("Windows")>=0,I=g.indexOf("Macintosh")>=0,R=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,E=g?.indexOf("Mobi")>=0,S=!0,y=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,v=y;else if(typeof f=="object"){t=f.platform==="win32",I=f.platform==="darwin",A=f.platform==="linux",D=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,C=w,P=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT;const n=f.env.VSCODE_NLS_CONFIG;if(n)try{const l=JSON.parse(n),p=l.availableLanguages["*"];y=l.locale,v=p||e.LANGUAGE_DEFAULT,d=l._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var h;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let s=0;I?s=1:t?s=3:A&&(s=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=A,e.isLinuxSnap=D,e.isNative=T,e.isElectron=C,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isMobile=E,e.isCI=P,e.platform=s,e.userAgent=g,e.language=v;var i;(function(n){function l(){return e.language}n.value=l;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=p;function k(){return e.language==="en"}n.isDefault=k})(i=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let k=0,L=n.length;k<L;k++){const U=n[k];if(U.id===p.data.vscodeScheduleAsyncWork){n.splice(k,1),U.callback();return}}});let l=0;return p=>{const k=++l;n.push({id:k,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:k},"*")}}return n=>setTimeout(n)})();var c;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||R?2:t?1:3;let u=!0,r=!1;function o(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,u=new Uint16Array(n.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Se[36],ye([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const I=a.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Se[9],ye([1,0,36]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,A=90,D=122,T=46,S=47,C=92,R=58,P=63;class E extends Error{constructor(h,b,s){let i;typeof b=="string"&&b.indexOf("not ")===0?(i="must not be",b=b.replace(/^not /,"")):i="must be";const c=h.indexOf(".")!==-1?"property":"argument";let u=`The "${h}" ${c} ${i} of type ${b}`;u+=`. Received type ${typeof s}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function y(m,h){if(typeof m!="string")throw new E(h,"string",m)}function v(m){return m===S||m===C}function d(m){return m===S}function g(m){return m>=t&&m<=A||m>=I&&m<=D}function f(m,h,b,s){let i="",c=0,u=-1,r=0,o=0;for(let n=0;n<=m.length;++n){if(n<m.length)o=m.charCodeAt(n);else{if(s(o))break;o=S}if(s(o)){if(!(u===n-1||r===1))if(r===2){if(i.length<2||c!==2||i.charCodeAt(i.length-1)!==T||i.charCodeAt(i.length-2)!==T){if(i.length>2){const l=i.lastIndexOf(b);l===-1?(i="",c=0):(i=i.slice(0,l),c=i.length-1-i.lastIndexOf(b)),u=n,r=0;continue}else if(i.length!==0){i="",c=0,u=n,r=0;continue}}h&&(i+=i.length>0?`${b}..`:"..",c=2)}else i.length>0?i+=`${b}${m.slice(u+1,n)}`:i=m.slice(u+1,n),c=n-u-1;u=n,r=0}else o===T&&r!==-1?++r:r=-1}return i}function w(m,h){if(h===null||typeof h!="object")throw new E("pathObject","Object",h);const b=h.dir||h.root,s=h.base||`${h.name||""}${h.ext||""}`;return b?b===h.root?`${b}${s}`:`${b}${m}${s}`:s}e.win32={resolve(...m){let h="",b="",s=!1;for(let i=m.length-1;i>=-1;i--){let c;if(i>=0){if(c=m[i],y(c,"path"),c.length===0)continue}else h.length===0?c=a.cwd():(c=a.env[`=${h}`]||a.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==h.toLowerCase()&&c.charCodeAt(2)===C)&&(c=`${h}\\`));const u=c.length;let r=0,o="",n=!1;const l=c.charCodeAt(0);if(u===1)v(l)&&(r=1,n=!0);else if(v(l))if(n=!0,v(c.charCodeAt(1))){let p=2,k=p;for(;p<u&&!v(c.charCodeAt(p));)p++;if(p<u&&p!==k){const L=c.slice(k,p);for(k=p;p<u&&v(c.charCodeAt(p));)p++;if(p<u&&p!==k){for(k=p;p<u&&!v(c.charCodeAt(p));)p++;(p===u||p!==k)&&(o=`\\\\${L}\\${c.slice(k,p)}`,r=p)}}}else r=1;else g(l)&&c.charCodeAt(1)===R&&(o=c.slice(0,2),r=2,u>2&&v(c.charCodeAt(2))&&(n=!0,r=3));if(o.length>0)if(h.length>0){if(o.toLowerCase()!==h.toLowerCase())continue}else h=o;if(s){if(h.length>0)break}else if(b=`${c.slice(r)}\\${b}`,s=n,n&&h.length>0)break}return b=f(b,!s,"\\",v),s?`${h}\\${b}`:`${h}${b}`||"."},normalize(m){y(m,"path");const h=m.length;if(h===0)return".";let b=0,s,i=!1;const c=m.charCodeAt(0);if(h===1)return d(c)?"\\":m;if(v(c))if(i=!0,v(m.charCodeAt(1))){let r=2,o=r;for(;r<h&&!v(m.charCodeAt(r));)r++;if(r<h&&r!==o){const n=m.slice(o,r);for(o=r;r<h&&v(m.charCodeAt(r));)r++;if(r<h&&r!==o){for(o=r;r<h&&!v(m.charCodeAt(r));)r++;if(r===h)return`\\\\${n}\\${m.slice(o)}\\`;r!==o&&(s=`\\\\${n}\\${m.slice(o,r)}`,b=r)}}}else b=1;else g(c)&&m.charCodeAt(1)===R&&(s=m.slice(0,2),b=2,h>2&&v(m.charCodeAt(2))&&(i=!0,b=3));let u=b<h?f(m.slice(b),!i,"\\",v):"";return u.length===0&&!i&&(u="."),u.length>0&&v(m.charCodeAt(h-1))&&(u+="\\"),s===void 0?i?`\\${u}`:u:i?`${s}\\${u}`:`${s}${u}`},isAbsolute(m){y(m,"path");const h=m.length;if(h===0)return!1;const b=m.charCodeAt(0);return v(b)||h>2&&g(b)&&m.charCodeAt(1)===R&&v(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let h,b;for(let c=0;c<m.length;++c){const u=m[c];y(u,"path"),u.length>0&&(h===void 0?h=b=u:h+=`\\${u}`)}if(h===void 0)return".";let s=!0,i=0;if(typeof b=="string"&&v(b.charCodeAt(0))){++i;const c=b.length;c>1&&v(b.charCodeAt(1))&&(++i,c>2&&(v(b.charCodeAt(2))?++i:s=!1))}if(s){for(;i<h.length&&v(h.charCodeAt(i));)i++;i>=2&&(h=`\\${h.slice(i)}`)}return e.win32.normalize(h)},relative(m,h){if(y(m,"from"),y(h,"to"),m===h)return"";const b=e.win32.resolve(m),s=e.win32.resolve(h);if(b===s||(m=b.toLowerCase(),h=s.toLowerCase(),m===h))return"";let i=0;for(;i<m.length&&m.charCodeAt(i)===C;)i++;let c=m.length;for(;c-1>i&&m.charCodeAt(c-1)===C;)c--;const u=c-i;let r=0;for(;r<h.length&&h.charCodeAt(r)===C;)r++;let o=h.length;for(;o-1>r&&h.charCodeAt(o-1)===C;)o--;const n=o-r,l=u<n?u:n;let p=-1,k=0;for(;k<l;k++){const U=m.charCodeAt(i+k);if(U!==h.charCodeAt(r+k))break;U===C&&(p=k)}if(k!==l){if(p===-1)return s}else{if(n>l){if(h.charCodeAt(r+k)===C)return s.slice(r+k+1);if(k===2)return s.slice(r+k)}u>l&&(m.charCodeAt(i+k)===C?p=k:k===2&&(p=3)),p===-1&&(p=0)}let L="";for(k=i+p+1;k<=c;++k)(k===c||m.charCodeAt(k)===C)&&(L+=L.length===0?"..":"\\..");return r+=p,L.length>0?`${L}${s.slice(r,o)}`:(s.charCodeAt(r)===C&&++r,s.slice(r,o))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const h=e.win32.resolve(m);if(h.length<=2)return m;if(h.charCodeAt(0)===C){if(h.charCodeAt(1)===C){const b=h.charCodeAt(2);if(b!==P&&b!==T)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(g(h.charCodeAt(0))&&h.charCodeAt(1)===R&&h.charCodeAt(2)===C)return`\\\\?\\${h}`;return m},dirname(m){y(m,"path");const h=m.length;if(h===0)return".";let b=-1,s=0;const i=m.charCodeAt(0);if(h===1)return v(i)?m:".";if(v(i)){if(b=s=1,v(m.charCodeAt(1))){let r=2,o=r;for(;r<h&&!v(m.charCodeAt(r));)r++;if(r<h&&r!==o){for(o=r;r<h&&v(m.charCodeAt(r));)r++;if(r<h&&r!==o){for(o=r;r<h&&!v(m.charCodeAt(r));)r++;if(r===h)return m;r!==o&&(b=s=r+1)}}}}else g(i)&&m.charCodeAt(1)===R&&(b=h>2&&v(m.charCodeAt(2))?3:2,s=b);let c=-1,u=!0;for(let r=h-1;r>=s;--r)if(v(m.charCodeAt(r))){if(!u){c=r;break}}else u=!1;if(c===-1){if(b===-1)return".";c=b}return m.slice(0,c)},basename(m,h){h!==void 0&&y(h,"ext"),y(m,"path");let b=0,s=-1,i=!0,c;if(m.length>=2&&g(m.charCodeAt(0))&&m.charCodeAt(1)===R&&(b=2),h!==void 0&&h.length>0&&h.length<=m.length){if(h===m)return"";let u=h.length-1,r=-1;for(c=m.length-1;c>=b;--c){const o=m.charCodeAt(c);if(v(o)){if(!i){b=c+1;break}}else r===-1&&(i=!1,r=c+1),u>=0&&(o===h.charCodeAt(u)?--u===-1&&(s=c):(u=-1,s=r))}return b===s?s=r:s===-1&&(s=m.length),m.slice(b,s)}for(c=m.length-1;c>=b;--c)if(v(m.charCodeAt(c))){if(!i){b=c+1;break}}else s===-1&&(i=!1,s=c+1);return s===-1?"":m.slice(b,s)},extname(m){y(m,"path");let h=0,b=-1,s=0,i=-1,c=!0,u=0;m.length>=2&&m.charCodeAt(1)===R&&g(m.charCodeAt(0))&&(h=s=2);for(let r=m.length-1;r>=h;--r){const o=m.charCodeAt(r);if(v(o)){if(!c){s=r+1;break}continue}i===-1&&(c=!1,i=r+1),o===T?b===-1?b=r:u!==1&&(u=1):b!==-1&&(u=-1)}return b===-1||i===-1||u===0||u===1&&b===i-1&&b===s+1?"":m.slice(b,i)},format:w.bind(null,"\\"),parse(m){y(m,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return h;const b=m.length;let s=0,i=m.charCodeAt(0);if(b===1)return v(i)?(h.root=h.dir=m,h):(h.base=h.name=m,h);if(v(i)){if(s=1,v(m.charCodeAt(1))){let p=2,k=p;for(;p<b&&!v(m.charCodeAt(p));)p++;if(p<b&&p!==k){for(k=p;p<b&&v(m.charCodeAt(p));)p++;if(p<b&&p!==k){for(k=p;p<b&&!v(m.charCodeAt(p));)p++;p===b?s=p:p!==k&&(s=p+1)}}}}else if(g(i)&&m.charCodeAt(1)===R){if(b<=2)return h.root=h.dir=m,h;if(s=2,v(m.charCodeAt(2))){if(b===3)return h.root=h.dir=m,h;s=3}}s>0&&(h.root=m.slice(0,s));let c=-1,u=s,r=-1,o=!0,n=m.length-1,l=0;for(;n>=s;--n){if(i=m.charCodeAt(n),v(i)){if(!o){u=n+1;break}continue}r===-1&&(o=!1,r=n+1),i===T?c===-1?c=n:l!==1&&(l=1):c!==-1&&(l=-1)}return r!==-1&&(c===-1||l===0||l===1&&c===r-1&&c===u+1?h.base=h.name=m.slice(u,r):(h.name=m.slice(u,c),h.base=m.slice(u,r),h.ext=m.slice(c,r))),u>0&&u!==s?h.dir=m.slice(0,u-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let h="",b=!1;for(let s=m.length-1;s>=-1&&!b;s--){const i=s>=0?m[s]:a.cwd();y(i,"path"),i.length!==0&&(h=`${i}/${h}`,b=i.charCodeAt(0)===S)}return h=f(h,!b,"/",d),b?`/${h}`:h.length>0?h:"."},normalize(m){if(y(m,"path"),m.length===0)return".";const h=m.charCodeAt(0)===S,b=m.charCodeAt(m.length-1)===S;return m=f(m,!h,"/",d),m.length===0?h?"/":b?"./":".":(b&&(m+="/"),h?`/${m}`:m)},isAbsolute(m){return y(m,"path"),m.length>0&&m.charCodeAt(0)===S},join(...m){if(m.length===0)return".";let h;for(let b=0;b<m.length;++b){const s=m[b];y(s,"path"),s.length>0&&(h===void 0?h=s:h+=`/${s}`)}return h===void 0?".":e.posix.normalize(h)},relative(m,h){if(y(m,"from"),y(h,"to"),m===h||(m=e.posix.resolve(m),h=e.posix.resolve(h),m===h))return"";const b=1,s=m.length,i=s-b,c=1,u=h.length-c,r=i<u?i:u;let o=-1,n=0;for(;n<r;n++){const p=m.charCodeAt(b+n);if(p!==h.charCodeAt(c+n))break;p===S&&(o=n)}if(n===r)if(u>r){if(h.charCodeAt(c+n)===S)return h.slice(c+n+1);if(n===0)return h.slice(c+n)}else i>r&&(m.charCodeAt(b+n)===S?o=n:n===0&&(o=0));let l="";for(n=b+o+1;n<=s;++n)(n===s||m.charCodeAt(n)===S)&&(l+=l.length===0?"..":"/..");return`${l}${h.slice(c+o)}`},toNamespacedPath(m){return m},dirname(m){if(y(m,"path"),m.length===0)return".";const h=m.charCodeAt(0)===S;let b=-1,s=!0;for(let i=m.length-1;i>=1;--i)if(m.charCodeAt(i)===S){if(!s){b=i;break}}else s=!1;return b===-1?h?"/":".":h&&b===1?"//":m.slice(0,b)},basename(m,h){h!==void 0&&y(h,"ext"),y(m,"path");let b=0,s=-1,i=!0,c;if(h!==void 0&&h.length>0&&h.length<=m.length){if(h===m)return"";let u=h.length-1,r=-1;for(c=m.length-1;c>=0;--c){const o=m.charCodeAt(c);if(o===S){if(!i){b=c+1;break}}else r===-1&&(i=!1,r=c+1),u>=0&&(o===h.charCodeAt(u)?--u===-1&&(s=c):(u=-1,s=r))}return b===s?s=r:s===-1&&(s=m.length),m.slice(b,s)}for(c=m.length-1;c>=0;--c)if(m.charCodeAt(c)===S){if(!i){b=c+1;break}}else s===-1&&(i=!1,s=c+1);return s===-1?"":m.slice(b,s)},extname(m){y(m,"path");let h=-1,b=0,s=-1,i=!0,c=0;for(let u=m.length-1;u>=0;--u){const r=m.charCodeAt(u);if(r===S){if(!i){b=u+1;break}continue}s===-1&&(i=!1,s=u+1),r===T?h===-1?h=u:c!==1&&(c=1):h!==-1&&(c=-1)}return h===-1||s===-1||c===0||c===1&&h===s-1&&h===b+1?"":m.slice(h,s)},format:w.bind(null,"/"),parse(m){y(m,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return h;const b=m.charCodeAt(0)===S;let s;b?(h.root="/",s=1):s=0;let i=-1,c=0,u=-1,r=!0,o=m.length-1,n=0;for(;o>=s;--o){const l=m.charCodeAt(o);if(l===S){if(!r){c=o+1;break}continue}u===-1&&(r=!1,u=o+1),l===T?i===-1?i=o:n!==1&&(n=1):i!==-1&&(n=-1)}if(u!==-1){const l=c===0&&b?1:c;i===-1||n===0||n===1&&i===u-1&&i===c+1?h.base=h.name=m.slice(l,u):(h.name=m.slice(l,i),h.base=m.slice(l,u),h.ext=m.slice(i,u))}return c>0?h.dir=m.slice(0,c-1):b&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=a.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=a.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=a.platform==="win32"?e.win32.join:e.posix.join,e.resolve=a.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=a.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=a.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=a.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=a.platform==="win32"?e.win32.extname:e.posix.extname,e.format=a.platform==="win32"?e.win32.format:e.posix.format,e.parse=a.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=a.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=a.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=a.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Se[82],ye([1,0,9]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const P=(0,a.extname)(R),E=t[P.toLowerCase()];return E!==void 0?E:D(R)}e.getMediaOrTextMime=A;function D(R){const P=(0,a.extname)(R);return I[P.toLowerCase()]}e.getMediaMime=D;function T(R){for(const P in I)if(I[P]===R)return P}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function C(R,P){const E=S.exec(R);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:P?void 0:R}e.normalizeMimeType=C}),define(Se[106],ye([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var I;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(T,...S){const C=S.reduce((E,y)=>(E[y]=!0,E),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(E=>!C[E]).forEach(E=>{for(let y=0;y<R.length;y++)if(E.search(R[y])!==-1){delete T[E];break}})}e.sanitizeProcessEnvironment=A;function D(T){!T||(delete T.DEBUG,a.isMacintosh&&delete T.DYLD_LIBRARY_PATH,a.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Se[51],ye([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=a.globals.performance&&typeof a.globals.performance.now=="function";class I{static create(D=!0){return new I(D)}constructor(D){this.a=t&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=I}),define(Se[4],ye([1,0,10,61,6,63,51]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var C;(function(o){o.None=()=>I.Disposable.None;function n(De){if(S){const{onDidAddListener:Re}=De,Be=v.create();let se=0;De.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Be.print()),Re?.()}}}function l(De,Re){return F(De,()=>{},0,void 0,void 0,Re)}o.defer=l;function p(De){return(Re,Be=null,se)=>{let ue=!1,de;return de=De(ee=>{if(!ue)return de?de.dispose():ue=!0,Re.call(Be,ee)},null,se),ue&&de.dispose(),de}}o.once=p;function k(De,Re,Be){return B((se,ue=null,de)=>De(ee=>se.call(ue,Re(ee)),null,de),Be)}o.map=k;function L(De,Re,Be){return B((se,ue=null,de)=>De(ee=>{Re(ee),se.call(ue,ee)},null,de),Be)}o.forEach=L;function U(De,Re,Be){return B((se,ue=null,de)=>De(ee=>Re(ee)&&se.call(ue,ee),null,de),Be)}o.filter=U;function K(De){return De}o.signal=K;function G(...De){return(Re,Be=null,se)=>(0,I.combinedDisposable)(...De.map(ue=>ue(de=>Re.call(Be,de),null,se)))}o.any=G;function O(De,Re,Be,se){let ue=Be;return k(De,de=>(ue=Re(ue,de),ue),se)}o.reduce=O;function B(De,Re){let Be;const se={onWillAddFirstListener(){Be=De(ue.fire,ue)},onDidRemoveLastListener(){Be?.dispose()}};Re||n(se);const ue=new g(se);return Re?.add(ue),ue.event}function F(De,Re,Be=100,se=!1,ue,de){let ee,oe,ie,N=0;const z={leakWarningThreshold:ue,onWillAddFirstListener(){ee=De(Q=>{N++,oe=Re(oe,Q),se&&!ie&&(X.fire(oe),oe=void 0),clearTimeout(ie),ie=setTimeout(()=>{const le=oe;oe=void 0,ie=void 0,(!se||N>1)&&X.fire(le),N=0},Be)})},onDidRemoveLastListener(){ee.dispose()}};de||n(z);const X=new g(z);return de?.add(X),X.event}o.debounce=F;function $(De,Re=0,Be){return o.debounce(De,(se,ue)=>se?(se.push(ue),se):[ue],Re,void 0,void 0,Be)}o.accumulate=$;function M(De,Re=(se,ue)=>se===ue,Be){let se=!0,ue;return U(De,de=>{const ee=se||!Re(de,ue);return se=!1,ue=de,ee},Be)}o.latch=M;function V(De,Re,Be){return[o.filter(De,Re,Be),o.filter(De,se=>!Re(se),Be)]}o.split=V;function q(De,Re=!1,Be=[]){let se=Be.slice(),ue=De(oe=>{se?se.push(oe):ee.fire(oe)});const de=()=>{se?.forEach(oe=>ee.fire(oe)),se=null},ee=new g({onWillAddFirstListener(){ue||(ue=De(oe=>ee.fire(oe)))},onDidAddFirstListener(){se&&(Re?setTimeout(de):de())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return ee.event}o.buffer=q;class H{constructor(Re){this.event=Re,this.c=new I.DisposableStore}map(Re){return new H(k(this.event,Re,this.c))}forEach(Re){return new H(L(this.event,Re,this.c))}filter(Re){return new H(U(this.event,Re,this.c))}reduce(Re,Be){return new H(O(this.event,Re,Be,this.c))}latch(){return new H(M(this.event,void 0,this.c))}debounce(Re,Be=100,se=!1,ue){return new H(F(this.event,Re,Be,se,ue,this.c))}on(Re,Be,se){return this.event(Re,Be,se)}once(Re,Be,se){return p(this.event)(Re,Be,se)}dispose(){this.c.dispose()}}function J(De){return new H(De)}o.chain=J;function Y(De,Re,Be=se=>se){const se=(...oe)=>ee.fire(Be(...oe)),ue=()=>De.on(Re,se),de=()=>De.removeListener(Re,se),ee=new g({onWillAddFirstListener:ue,onDidRemoveLastListener:de});return ee.event}o.fromNodeEventEmitter=Y;function ae(De,Re,Be=se=>se){const se=(...oe)=>ee.fire(Be(...oe)),ue=()=>De.addEventListener(Re,se),de=()=>De.removeEventListener(Re,se),ee=new g({onWillAddFirstListener:ue,onDidRemoveLastListener:de});return ee.event}o.fromDOMEventEmitter=ae;function re(De){return new Promise(Re=>p(De)(Re))}o.toPromise=re;function fe(De,Re){return Re(void 0),De(Be=>Re(Be))}o.runAndSubscribe=fe;function Z(De,Re){let Be=null;function se(de){Be?.dispose(),Be=new I.DisposableStore,Re(de,Be)}se(void 0);const ue=De(de=>se(de));return(0,I.toDisposable)(()=>{ue.dispose(),Be?.dispose()})}o.runAndSubscribeWithStore=Z;class pe{constructor(Re,Be){this.obs=Re,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Re.addObserver(this)},onDidRemoveLastListener:()=>{Re.removeObserver(this)}};Be||n(se),this.emitter=new g(se),Be&&Be.add(this.emitter)}beginUpdate(Re){this.c++}handleChange(Re,Be){this.d=!0}endUpdate(Re){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function we(De,Re){return new pe(De,Re).emitter.event}o.fromObservable=we})(C=e.Event||(e.Event={}));class R{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${R.c++}`,R.all.add(this)}start(n){this.d=new D.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=R,R.all=new Set,R.c=0;let P=-1;function E(o){const n=P;return P=o,{dispose(){P=n}}}e.setGlobalLeakWarningThreshold=E;class y{constructor(n,l=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=l,this.d=0}dispose(){this.c?.clear()}check(n,l){const p=this.threshold;if(p<=0||l<p)return;this.c||(this.c=new Map);const k=this.c.get(n.value)||0;if(this.c.set(n.value,k+1),this.d-=1,this.d<=0){this.d=p*.5;let L,U=0;for(const[K,G]of this.c)(!L||U<G)&&(L=K,U=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${U}):`),console.warn(L)}return()=>{const L=this.c.get(n.value)||0;this.c.set(n.value,L-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(n,l,p){this.callback=n,this.callbackThis=l,this.stack=p,this.subscription=new I.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class g{constructor(n){this.j=!1,this.d=n,this.f=P>0||this.d?.leakWarningThreshold?new y(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new R(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const n=Array.from(this.q);queueMicrotask(()=>{for(const l of n)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,l,p)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),I.Disposable.None;const k=this.q.isEmpty();k&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let L,U;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(U=v.create(),L=this.f.check(U,this.q.size+1)),T&&(U=U??v.create());const K=new d(n,l,U),G=this.q.push(K);k&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,l);const O=K.subscription.set(()=>{L?.(),this.j||(G(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return p instanceof I.DisposableStore?p.add(O):Array.isArray(p)&&p.push(O),O}),this.l}fire(n){if(this.q){this.m||(this.m=new w);for(const l of this.q)this.m.push(this,l,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=g;class f{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(n,l,p){this.c.push(new m(n,l,p))}clear(n){const l=new A.LinkedList;for(const p of this.c)p.emitter!==n&&l.push(p);this.c=l}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(l){(0,a.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=f;class w extends f{clear(n){this.c.clear()}}class m{constructor(n,l,p){this.emitter=n,this.listener=l,this.event=p}}class h extends g{async fireAsync(n,l,p){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const k of this.q)this.c.push([k,n]);for(;this.c.size>0&&!l.isCancellationRequested;){const[k,L]=this.c.shift(),U=[],K={...L,token:l,waitUntil:G=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");p&&(G=p(G,k.callback)),U.push(G)}};try{k.invoke(K)}catch(G){(0,a.onUnexpectedError)(G);continue}Object.freeze(U),await Promise.allSettled(U).then(G=>{for(const O of G)O.status==="rejected"&&(0,a.onUnexpectedError)(O.reason)})}}}}e.AsyncEmitter=h;class b extends g{constructor(n){super(n),this.h=0,this.s=new A.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=b;class s extends b{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=s;class i extends g{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(l=>super.fire(l)),this.c=[]}))}}e.MicrotaskEmitter=i;class c{constructor(){this.d=!1,this.f=[],this.c=new g({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const l={event:n,listener:null};this.f.push(l),this.d&&this.j(l);const p=()=>{this.d&&this.k(l);const k=this.f.indexOf(l);this.f.splice(k,1)};return(0,I.toDisposable)((0,t.once)(p))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(l=>this.c.fire(l))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=c;class u{constructor(){this.c=[]}wrapEvent(n){return(l,p,k)=>n(L=>{const U=this.c[this.c.length-1];U?U.push(()=>l.call(p,L)):l.call(p,L)},void 0,k)}bufferEvents(n){const l=[];this.c.push(l);const p=n();return this.c.pop(),l.forEach(k=>k()),p}}e.EventBufferer=u;class r{constructor(){this.c=!1,this.d=C.None,this.f=I.Disposable.None,this.g=new g({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(Se[21],ye([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(T,S){const C=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(C)}}});var I;(function(T){function S(C){return C===T.None||C===T.Cancelled||C instanceof A?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=I.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=I.None}}e.CancellationTokenSource=D}),define(Se[158],ye([1,0,21]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new a.CancellationTokenSource,S=this.b(T.token);return this.a={promise:S,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=t;class I{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const S=JSON.stringify(T);return this.b!==S&&(this.b=S,this.a=this.c(T)),this.a}}e.LRUCachedFunction=I;class A{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const S=this.b(T);return this.a.set(T,S),S}}e.CachedFunction=A}),define(Se[8],ye([1,0,158,80]),function(te,e,a,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=A;const D=/{(\d+)}/g;function T(W,..._){return _.length===0?W:W.replace(D,function(ce,Pe){const Le=parseInt(Pe,10);return isNaN(Le)||Le<0||Le>=_.length?ce:_[Le]})}e.format=T;const S=/{([^}]+)}/g;function C(W,_){return W.replace(S,(ce,Pe)=>_[Pe]??ce)}e.format2=C;function R(W){return W.replace(/[<>&]/g,function(_){switch(_){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return _}})}e.escape=R;function P(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function E(W,_){let ce=0;const Pe=_.charCodeAt(0);for(let Le=W.length-1;Le>=0;Le--)W.charCodeAt(Le)===Pe&&ce++;return ce}e.count=E;function y(W,_,ce="\u2026"){return W.length<=_?W:`${W.substr(0,_)}${ce}`}e.truncate=y;function v(W,_=" "){const ce=d(W,_);return g(ce,_)}e.trim=v;function d(W,_){if(!W||!_)return W;const ce=_.length;if(ce===0||W.length===0)return W;let Pe=0;for(;W.indexOf(_,Pe)===Pe;)Pe=Pe+ce;return W.substring(Pe)}e.ltrim=d;function g(W,_){if(!W||!_)return W;const ce=_.length,Pe=W.length;if(ce===0||Pe===0)return W;let Le=Pe,Ge=-1;for(;Ge=W.lastIndexOf(_,Le-1),!(Ge===-1||Ge+ce!==Le);){if(Ge===0)return"";Le=Ge}return W.substring(0,Le)}e.rtrim=g;function f(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function w(W){return W.replace(/\*/g,"")}e.stripWildcards=w;function m(W,_,ce={}){if(!W)throw new Error("Cannot create regex from empty string");_||(W=P(W)),ce.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let Pe="";return ce.global&&(Pe+="g"),ce.matchCase||(Pe+="i"),ce.multiline&&(Pe+="m"),ce.unicode&&(Pe+="u"),new RegExp(W,Pe)}e.createRegExp=m;function h(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function b(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function s(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=s;function i(W){return W.split(/\r\n|\r|\n/)}e.splitLines=i;function c(W){for(let _=0,ce=W.length;_<ce;_++){const Pe=W.charCodeAt(_);if(Pe!==32&&Pe!==9)return _}return-1}e.firstNonWhitespaceIndex=c;function u(W,_=0,ce=W.length){for(let Pe=_;Pe<ce;Pe++){const Le=W.charCodeAt(Pe);if(Le!==32&&Le!==9)return W.substring(_,Pe)}return W.substring(_,ce)}e.getLeadingWhitespace=u;function r(W,_=W.length-1){for(let ce=_;ce>=0;ce--){const Pe=W.charCodeAt(ce);if(Pe!==32&&Pe!==9)return ce}return-1}e.lastNonWhitespaceIndex=r;function o(W,_,ce){const Pe=[];let Le=0;for(const Ge of W.matchAll(_)){if(Pe.push(W.slice(Le,Ge.index)),Ge.index===void 0)throw new Error("match.index should be defined");Le=Ge.index+Ge[0].length,Pe.push(ce(Ge[0],...Ge.slice(1),Ge.index,W,Ge.groups))}return Pe.push(W.slice(Le)),Promise.all(Pe).then(Ge=>Ge.join(""))}e.replaceAsync=o;function n(W,_){return W<_?-1:W>_?1:0}e.compare=n;function l(W,_,ce=0,Pe=W.length,Le=0,Ge=_.length){for(;ce<Pe&&Le<Ge;ce++,Le++){const mt=W.charCodeAt(ce),st=_.charCodeAt(Le);if(mt<st)return-1;if(mt>st)return 1}const Qe=Pe-ce,ut=Ge-Le;return Qe<ut?-1:Qe>ut?1:0}e.compareSubstring=l;function p(W,_){return k(W,_,0,W.length,0,_.length)}e.compareIgnoreCase=p;function k(W,_,ce=0,Pe=W.length,Le=0,Ge=_.length){for(;ce<Pe&&Le<Ge;ce++,Le++){let mt=W.charCodeAt(ce),st=_.charCodeAt(Le);if(mt===st)continue;if(mt>=128||st>=128)return l(W.toLowerCase(),_.toLowerCase(),ce,Pe,Le,Ge);U(mt)&&(mt-=32),U(st)&&(st-=32);const rt=mt-st;if(rt!==0)return rt}const Qe=Pe-ce,ut=Ge-Le;return Qe<ut?-1:Qe>ut?1:0}e.compareSubstringIgnoreCase=k;function L(W){return W>=48&&W<=57}e.isAsciiDigit=L;function U(W){return W>=97&&W<=122}e.isLowerAsciiLetter=U;function K(W){return W>=65&&W<=90}e.isUpperAsciiLetter=K;function G(W,_){return W.length===_.length&&k(W,_)===0}e.equalsIgnoreCase=G;function O(W,_){const ce=_.length;return _.length>W.length?!1:k(W,_,0,ce)===0}e.startsWithIgnoreCase=O;function B(W,_){const ce=Math.min(W.length,_.length);let Pe;for(Pe=0;Pe<ce;Pe++)if(W.charCodeAt(Pe)!==_.charCodeAt(Pe))return Pe;return ce}e.commonPrefixLength=B;function F(W,_){const ce=Math.min(W.length,_.length);let Pe;const Le=W.length-1,Ge=_.length-1;for(Pe=0;Pe<ce;Pe++)if(W.charCodeAt(Le-Pe)!==_.charCodeAt(Ge-Pe))return Pe;return ce}e.commonSuffixLength=F;function $(W){return 55296<=W&&W<=56319}e.isHighSurrogate=$;function M(W){return 56320<=W&&W<=57343}e.isLowSurrogate=M;function V(W,_){return(W-55296<<10)+(_-56320)+65536}e.computeCodePoint=V;function q(W,_,ce){const Pe=W.charCodeAt(ce);if($(Pe)&&ce+1<_){const Le=W.charCodeAt(ce+1);if(M(Le))return V(Pe,Le)}return Pe}e.getNextCodePoint=q;function H(W,_){const ce=W.charCodeAt(_-1);if(M(ce)&&_>1){const Pe=W.charCodeAt(_-2);if($(Pe))return V(Pe,ce)}return ce}class J{get offset(){return this.e}constructor(_,ce=0){this.c=_,this.d=_.length,this.e=ce}setOffset(_){this.e=_}prevCodePoint(){const _=H(this.c,this.e);return this.e-=_>=65536?2:1,_}nextCodePoint(){const _=q(this.c,this.d,this.e);return this.e+=_>=65536?2:1,_}eol(){return this.e>=this.d}}e.CodePointIterator=J;class Y{get offset(){return this.c.offset}constructor(_,ce=0){this.c=new J(_,ce)}nextGraphemeLength(){const _=Ze.getInstance(),ce=this.c,Pe=ce.offset;let Le=_.getGraphemeBreakType(ce.nextCodePoint());for(;!ce.eol();){const Ge=ce.offset,Qe=_.getGraphemeBreakType(ce.nextCodePoint());if(He(Le,Qe)){ce.setOffset(Ge);break}Le=Qe}return ce.offset-Pe}prevGraphemeLength(){const _=Ze.getInstance(),ce=this.c,Pe=ce.offset;let Le=_.getGraphemeBreakType(ce.prevCodePoint());for(;ce.offset>0;){const Ge=ce.offset,Qe=_.getGraphemeBreakType(ce.prevCodePoint());if(He(Qe,Le)){ce.setOffset(Ge);break}Le=Qe}return Pe-ce.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Y;function ae(W,_){return new Y(W,_).nextGraphemeLength()}e.nextCharLength=ae;function re(W,_){return new Y(W,_).prevGraphemeLength()}e.prevCharLength=re;function fe(W,_){_>0&&M(W.charCodeAt(_))&&_--;const ce=_+ae(W,_);return[ce-re(W,ce),ce]}e.getCharContainingOffset=fe;function Z(W){const _=new Y(W);let ce=0;for(;!_.eol();)ce++,_.nextGraphemeLength();return ce}e.charCount=Z;let pe;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De(W){return pe||(pe=we()),pe.test(W)}e.containsRTL=De;const Re=/^[\t\n\r\x20-\x7E]*$/;function Be(W){return Re.test(W)}e.isBasicASCII=Be,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=se;function ue(W){return W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=ue;function de(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129008||W>=129280&&W<=129535||W>=129648&&W<=129782}e.isEmojiImprecise=de;function ee(W,_){if(W.length<_)return W;const ce=/\b/g;let Pe=0;for(;ce.test(W)&&!(W.length-ce.lastIndex<_);)Pe=ce.lastIndex,ce.lastIndex+=1;return W.substring(Pe).replace(/^\s/,"")}e.lcut=ee;const oe=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,N=/\x1b\[0?m/g;function z(W){return W&&(W=W.replace(oe,""),W=W.replace(ie,""),W=W.replace(N,"")),W}e.removeAnsiEscapeCodes=z,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function X(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=X;function Q(W){return X(W)?W.substr(1):W}e.stripUTF8BOM=Q;function le(W,_){if(!W||!_||W.length<_.length)return!1;const ce=_.length,Pe=W.toLowerCase();let Le=0,Ge=-1;for(;Le<ce;){const Qe=Pe.indexOf(_[Le],Ge+1);if(Qe<0)return!1;Ge=Qe,Le++}return!0}e.fuzzyContains=le;function be(W,_=!1){return W?(_&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=be;function Te(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=Te;function ge(W,_=1){if(_===0)return"";let ce=-1;do ce=W.indexOf(`
`,ce+1),_--;while(_>0&&ce>=0);return ce===-1?W:(W[ce-1]==="\r"&&ce--,W.substr(0,ce))}e.getNLines=ge;function Ce(W){return W=W%(2*26),W<26?String.fromCharCode(97+W):String.fromCharCode(65+W-26)}e.singleLetterHash=Ce;function Ie(W){return Ze.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=Ie;function He(W,_){return W===0?_!==5&&_!==7:W===2&&_===3?!1:W===4||W===2||W===3||_===4||_===2||_===3?!0:!(W===8&&(_===8||_===9||_===11||_===12)||(W===11||W===9)&&(_===9||_===10)||(W===12||W===10)&&_===10||_===5||_===13||_===7||W===1||W===13&&_===14||W===6&&_===6)}var qe;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ze{static getInstance(){return Ze.c||(Ze.c=new Ze),Ze.c}constructor(){this.d=xe()}getGraphemeBreakType(_){if(_<32)return _===10?3:_===13?2:4;if(_<127)return 0;const ce=this.d,Pe=ce.length/3;let Le=1;for(;Le<=Pe;)if(_<ce[3*Le])Le=2*Le;else if(_>ce[3*Le+1])Le=2*Le+1;else return ce[3*Le+2];return 0}}Ze.c=null;function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(W,_){if(W===0)return 0;const ce=nt(W,_);if(ce!==void 0)return ce;const Pe=new J(_,W);return Pe.prevCodePoint(),Pe.offset}e.getLeftDeleteOffset=tt;function nt(W,_){const ce=new J(_,W);let Pe=ce.prevCodePoint();for(;ft(Pe)||Pe===65039||Pe===8419;){if(ce.offset===0)return;Pe=ce.prevCodePoint()}if(!de(Pe))return;let Le=ce.offset;return Le>0&&ce.prevCodePoint()===8205&&(Le=ce.offset),Le}function ft(W){return 127995<=W&&W<=127999}var it;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.noBreakWhitespace="\xA0";class Fe{static getInstance(_){return Fe.d.get(Array.from(_))}static getLocales(){return Fe.e.getValue()}constructor(_){this.f=_}isAmbiguous(_){return this.f.has(_)}getPrimaryConfusable(_){return this.f.get(_)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Fe,I=Fe,Fe.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Fe.d=new a.LRUCachedFunction(W=>{function _(st){const rt=new Map;for(let ct=0;ct<st.length;ct+=2)rt.set(st[ct],st[ct+1]);return rt}function ce(st,rt){const ct=new Map(st);for(const[Et,Rt]of rt)ct.set(Et,Rt);return ct}function Pe(st,rt){if(!st)return rt;const ct=new Map;for(const[Et,Rt]of st)rt.has(Et)&&ct.set(Et,Rt);return ct}const Le=I.c.getValue();let Ge=W.filter(st=>!st.startsWith("_")&&st in Le);Ge.length===0&&(Ge=["_default"]);let Qe;for(const st of Ge){const rt=_(Le[st]);Qe=Pe(Qe,rt)}const ut=_(Le._common),mt=ce(ut,Qe);return new Fe(mt)}),Fe.e=new t.Lazy(()=>Object.keys(Fe.c.getValue()).filter(W=>!W.startsWith("_")));class lt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(lt.c())),this.d}static isInvisibleCharacter(_){return lt.e().has(_)}static get codePoints(){return lt.e()}}e.InvisibleCharacters=lt,lt.d=void 0}),define(Se[32],ye([1,0,9,12,8,11]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function T(r){return r.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=T;function S(r){return r.indexOf("/")===-1&&(r=T(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function C(r,o=a.posix.sep){if(!r)return"";const n=r.length,l=r.charCodeAt(0);if(D(l)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let k=3;const L=k;for(;k<n&&!D(r.charCodeAt(k));k++);if(L!==k&&!D(r.charCodeAt(k+1))){for(k+=1;k<n;k++)if(D(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,o)}}return o}else if(f(l)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<n;p++)if(D(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=C;function R(r){if(!t.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let n=2;const l=n;for(;n<r.length&&(o=r.charCodeAt(n),o!==92);n++);return!(l===n||(o=r.charCodeAt(n+1),isNaN(o)||o===92))}e.isUNC=R;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(r,o=t.isWindows){const n=o?P:E;return!(!r||r.length===0||/^\s+$/.test(r)||(n.lastIndex=0,n.test(r))||o&&y.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=v;function d(r,o,n){const l=r===o;return!n||l?l:!r||!o?!1:(0,I.equalsIgnoreCase)(r,o)}e.isEqual=d;function g(r,o,n,l=a.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(n){if(!(0,I.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let k=o.length;return o.charAt(o.length-1)===l&&k--,r.charAt(k)===l}return o.charAt(o.length-1)!==l&&(o+=l),r.indexOf(o)===0}e.isEqualOrParent=g;function f(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=f;function w(r,o){return t.isWindows&&r.endsWith(":")&&(r+=a.sep),(0,a.isAbsolute)(r)||(r=(0,a.join)(o,r)),r=(0,a.normalize)(r),t.isWindows?(r=(0,I.rtrim)(r,a.sep),r.endsWith(":")&&(r+=a.sep)):(r=(0,I.rtrim)(r,a.sep),r||(r=a.sep)),r}e.sanitizeFilePath=w;function m(r){const o=(0,a.normalize)(r);return t.isWindows?r.length>3?!1:h(o)&&(r.length===2||o.charCodeAt(2)===92):o===a.posix.sep}e.isRootOrDriveLetter=m;function h(r,o=t.isWindows){return o?f(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function b(r){return h(r)?r[0]:void 0}e.getDriveLetter=b;function s(r,o,n){return o.length>r.length?-1:r===o?0:(n&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=s;function i(r){const o=r.split(":");let n,l,p;for(const k of o){const L=Number(k);(0,A.isNumber)(L)?l===void 0?l=L:p===void 0&&(p=L):n=n?[n,k].join(":"):k}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:l!==void 0?l:void 0,column:p!==void 0?p:l!==void 0?1:void 0}}e.parseLineAndColumnAware=i;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(r,o,n=8){let l="";for(let k=0;k<n;k++)l+=c.charAt(Math.floor(Math.random()*c.length));let p;return o?p=`${o}-${l}`:p=l,r?(0,a.join)(r,p):p}e.randomPath=u}),define(Se[107],ye([1,0,28,8]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ie){return function(N,z){for(let X=0,Q=ie.length;X<Q;X++){const le=ie[X](N,z);if(le)return le}return null}}e.or=I,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ie,N,z){if(!z||z.length<N.length)return null;let X;return ie?X=t.startsWithIgnoreCase(z,N):X=z.indexOf(N)===0,X?N.length>0?[{start:0,end:N.length}]:[]:null}function D(ie,N){const z=N.toLowerCase().indexOf(ie.toLowerCase());return z===-1?null:[{start:z,end:z+ie.length}]}e.matchesContiguousSubString=D;function T(ie,N){return S(ie.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=T;function S(ie,N,z,X){if(z===ie.length)return[];if(X===N.length)return null;if(ie[z]===N[X]){let Q=null;return(Q=S(ie,N,z+1,X+1))?f({start:X,end:X+1},Q):null}return S(ie,N,z,X+1)}function C(ie){return 97<=ie&&ie<=122}function R(ie){return 65<=ie&&ie<=90}e.isUpper=R;function P(ie){return 48<=ie&&ie<=57}function E(ie){return ie===32||ie===9||ie===10||ie===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>y.add(ie.charCodeAt(0)));function v(ie){return E(ie)||y.has(ie)}function d(ie,N){return ie===N||v(ie)&&v(N)}function g(ie){return C(ie)||R(ie)||P(ie)}function f(ie,N){return N.length===0?N=[ie]:ie.end===N[0].start?N[0].start=ie.start:N.unshift(ie),N}function w(ie,N){for(let z=N;z<ie.length;z++){const X=ie.charCodeAt(z);if(R(X)||P(X)||z>0&&!g(ie.charCodeAt(z-1)))return z}return ie.length}function m(ie,N,z,X){if(z===ie.length)return[];if(X===N.length)return null;if(ie[z]!==N[X].toLowerCase())return null;{let Q=null,le=X+1;for(Q=m(ie,N,z+1,X+1);!Q&&(le=w(N,le))<N.length;)Q=m(ie,N,z+1,le),le++;return Q===null?null:f({start:X,end:X+1},Q)}}function h(ie){let N=0,z=0,X=0,Q=0,le=0;for(let Ie=0;Ie<ie.length;Ie++)le=ie.charCodeAt(Ie),R(le)&&N++,C(le)&&z++,g(le)&&X++,P(le)&&Q++;const be=N/ie.length,Te=z/ie.length,ge=X/ie.length,Ce=Q/ie.length;return{upperPercent:be,lowerPercent:Te,alphaPercent:ge,numericPercent:Ce}}function b(ie){const{upperPercent:N,lowerPercent:z}=ie;return z===0&&N>.6}function s(ie){const{upperPercent:N,lowerPercent:z,alphaPercent:X,numericPercent:Q}=ie;return z>.2&&N<.8&&X>.6&&Q<.2}function i(ie){let N=0,z=0,X=0,Q=0;for(let le=0;le<ie.length;le++)X=ie.charCodeAt(le),R(X)&&N++,C(X)&&z++,E(X)&&Q++;return(N===0||z===0)&&Q===0?ie.length<=30:N<=5}function c(ie,N){if(!N||(N=N.trim(),N.length===0)||!i(ie)||N.length>60)return null;const z=h(N);if(!s(z)){if(!b(z))return null;N=N.toLowerCase()}let X=null,Q=0;for(ie=ie.toLowerCase();Q<N.length&&(X=m(ie,N,0,Q))===null;)Q=w(N,Q+1);return X}e.matchesCamelCase=c;function u(ie,N,z=!1){if(!N||N.length===0)return null;let X=null,Q=0;for(ie=ie.toLowerCase(),N=N.toLowerCase();Q<N.length&&(X=r(ie,N,0,Q,z))===null;)Q=o(N,Q+1);return X}e.matchesWords=u;function r(ie,N,z,X,Q){if(z===ie.length)return[];if(X===N.length)return null;if(d(ie.charCodeAt(z),N.charCodeAt(X))){let le=null,be=X+1;if(le=r(ie,N,z+1,X+1,Q),!Q)for(;!le&&(be=o(N,be))<N.length;)le=r(ie,N,z+1,be,Q),be++;return le?ie.charCodeAt(z)!==N.charCodeAt(X)?le:f({start:X,end:X+1},le):null}else return null}function o(ie,N){for(let z=N;z<ie.length;z++)if(v(ie.charCodeAt(z))||z>0&&v(ie.charCodeAt(z-1)))return z;return ie.length}const n=I(e.matchesPrefix,c,D),l=I(e.matchesPrefix,c,T),p=new a.LRUCache(1e4);function k(ie,N,z=!1){if(typeof ie!="string"||typeof N!="string")return null;let X=p.get(ie);X||(X=new RegExp(t.convertSimple2RegExpPattern(ie),"i"),p.set(ie,X));const Q=X.exec(N);return Q?[{start:Q.index,end:Q.index+Q[0].length}]:z?l(ie,N):n(ie,N)}e.matchesFuzzy=k;function L(ie,N){const z=Re(ie,ie.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?K(z):null}e.matchesFuzzy2=L;function U(ie,N,z,X,Q,le){const be=Math.min(13,ie.length);for(;z<be;z++){const Te=Re(ie,N,z,X,Q,le,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Te)return Te}return[0,le]}e.anyScore=U;function K(ie){if(typeof ie>"u")return[];const N=[],z=ie[1];for(let X=ie.length-1;X>1;X--){const Q=ie[X]+z,le=N[N.length-1];le&&le.end===Q?le.end=Q+1:N.push({start:Q,end:Q+1})}return N}e.createMatches=K;const G=128;function O(){const ie=[],N=[];for(let z=0;z<=G;z++)N[z]=0;for(let z=0;z<=G;z++)ie.push(N.slice(0));return ie}function B(ie){const N=[];for(let z=0;z<=ie;z++)N[z]=0;return N}const F=B(2*G),$=B(2*G),M=O(),V=O(),q=O(),H=!1;function J(ie,N,z,X,Q){function le(Te,ge,Ce=" "){for(;Te.length<ge;)Te=Ce+Te;return Te}let be=` |   |${X.split("").map(Te=>le(Te,3)).join("|")}
`;for(let Te=0;Te<=z;Te++)Te===0?be+=" |":be+=`${N[Te-1]}|`,be+=ie[Te].slice(0,Q+1).map(ge=>le(ge.toString(),3)).join("|")+`
`;return be}function Y(ie,N,z,X){ie=ie.substr(N),z=z.substr(X),console.log(J(V,ie,ie.length,z,z.length)),console.log(J(q,ie,ie.length,z,z.length)),console.log(J(M,ie,ie.length,z,z.length))}function ae(ie,N){if(N<0||N>=ie.length)return!1;const z=ie.codePointAt(N);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(z)}}function re(ie,N){if(N<0||N>=ie.length)return!1;switch(ie.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function fe(ie,N,z){return N[ie]!==z[ie]}function Z(ie,N,z,X,Q,le,be=!1){for(;N<z&&Q<le;)ie[N]===X[Q]&&(be&&(F[N]=Q),N+=1),Q+=1;return N===z}e.isPatternInWord=Z;var pe;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var we;(function(ie){ie.Default=[-100,0];function N(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}ie.isDefault=N})(we=e.FuzzyScore||(e.FuzzyScore={}));class De{constructor(N,z){this.firstMatchCanBeWeak=N,this.boostFullMatch=z}}e.FuzzyScoreOptions=De,De.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ie,N,z,X,Q,le,be=De.default){const Te=ie.length>G?G:ie.length,ge=X.length>G?G:X.length;if(z>=Te||le>=ge||Te-z>ge-le||!Z(N,z,Te,Q,le,ge,!0))return;Be(Te,ge,z,le,N,Q);let Ce=1,Ie=1,He=z,qe=le;const Ze=[!1];for(Ce=1,He=z;He<Te;Ce++,He++){const it=F[He],Fe=$[He],lt=He+1<Te?$[He+1]:ge;for(Ie=it-le+1,qe=it;qe<lt;Ie++,qe++){let W=Number.MIN_SAFE_INTEGER,_=!1;qe<=Fe&&(W=se(ie,N,He,z,X,Q,qe,ge,le,M[Ce-1][Ie-1]===0,Ze));let ce=0;W!==Number.MAX_SAFE_INTEGER&&(_=!0,ce=W+V[Ce-1][Ie-1]);const Pe=qe>it,Le=Pe?V[Ce][Ie-1]+(M[Ce][Ie-1]>0?-5:0):0,Ge=qe>it+1&&M[Ce][Ie-1]>0,Qe=Ge?V[Ce][Ie-2]+(M[Ce][Ie-2]>0?-5:0):0;if(Ge&&(!Pe||Qe>=Le)&&(!_||Qe>=ce))V[Ce][Ie]=Qe,q[Ce][Ie]=3,M[Ce][Ie]=0;else if(Pe&&(!_||Le>=ce))V[Ce][Ie]=Le,q[Ce][Ie]=2,M[Ce][Ie]=0;else if(_)V[Ce][Ie]=ce,q[Ce][Ie]=1,M[Ce][Ie]=M[Ce-1][Ie-1]+1;else throw new Error("not possible")}}if(H&&Y(ie,z,X,le),!Ze[0]&&!be.firstMatchCanBeWeak)return;Ce--,Ie--;const xe=[V[Ce][Ie],le];let tt=0,nt=0;for(;Ce>=1;){let it=Ie;do{const Fe=q[Ce][it];if(Fe===3)it=it-2;else if(Fe===2)it=it-1;else break}while(it>=1);tt>1&&N[z+Ce-1]===Q[le+Ie-1]&&!fe(it+le-1,X,Q)&&tt+1>M[Ce][it]&&(it=Ie),it===Ie?tt++:tt=1,nt||(nt=it),Ce--,Ie=it-1,xe.push(Ie)}ge===Te&&be.boostFullMatch&&(xe[0]+=2);const ft=nt-Te;return xe[0]-=ft,xe}e.fuzzyScore=Re;function Be(ie,N,z,X,Q,le){let be=ie-1,Te=N-1;for(;be>=z&&Te>=X;)Q[be]===le[Te]&&($[be]=Te,be--),Te--}function se(ie,N,z,X,Q,le,be,Te,ge,Ce,Ie){if(N[z]!==le[be])return Number.MIN_SAFE_INTEGER;let He=1,qe=!1;return be===z-X?He=ie[z]===Q[be]?7:5:fe(be,Q,le)&&(be===0||!fe(be-1,Q,le))?(He=ie[z]===Q[be]?7:5,qe=!0):ae(le,be)&&(be===0||!ae(le,be-1))?He=5:(ae(le,be-1)||re(le,be-1))&&(He=5,qe=!0),He>1&&z===X&&(Ie[0]=!0),qe||(qe=fe(be,Q,le)||ae(le,be-1)||re(le,be-1)),z===X?be>ge&&(He-=qe?3:5):Ce?He+=qe?2:0:He+=qe?0:1,be+1===Te&&(He-=qe?3:5),He}function ue(ie,N,z,X,Q,le,be){return ee(ie,N,z,X,Q,le,!0,be)}e.fuzzyScoreGracefulAggressive=ue;function de(ie,N,z,X,Q,le,be){return ee(ie,N,z,X,Q,le,!1,be)}e.fuzzyScoreGraceful=de;function ee(ie,N,z,X,Q,le,be,Te){let ge=Re(ie,N,z,X,Q,le,Te);if(ge&&!be)return ge;if(ie.length>=3){const Ce=Math.min(7,ie.length-1);for(let Ie=z+1;Ie<Ce;Ie++){const He=oe(ie,Ie);if(He){const qe=Re(He,He.toLowerCase(),z,X,Q,le,Te);qe&&(qe[0]-=3,(!ge||qe[0]>ge[0])&&(ge=qe))}}}return ge}function oe(ie,N){if(N+1>=ie.length)return;const z=ie[N],X=ie[N+1];if(z!==X)return ie.slice(0,N)+X+z+ie.slice(N+2)}}),define(Se[83],ye([1,0,8]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return I(f,0)}e.hash=t;function I(f,w){switch(typeof f){case"object":return f===null?A(349,w):Array.isArray(f)?S(f,w):C(f,w);case"string":return T(f,w);case"boolean":return D(f,w);case"number":return A(f,w);case"undefined":return A(937,w);default:return A(617,w)}}e.doHash=I;function A(f,w){return(w<<5)-w+f|0}e.numberHash=A;function D(f,w){return A(f?433:863,w)}function T(f,w){w=A(149417,w);for(let m=0,h=f.length;m<h;m++)w=A(f.charCodeAt(m),w);return w}e.stringHash=T;function S(f,w){return w=A(104579,w),f.reduce((m,h)=>I(h,m),w)}function C(f,w){return w=A(181387,w),Object.keys(f).sort().reduce((m,h)=>(m=T(h,m),I(f[h],m)),w)}class R{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=I(w,this.g),this.g}}e.Hasher=R;var P;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(f,w,m=32){const h=m-w,b=~((1<<h)-1);return(f<<w|(b&f)>>>h)>>>0}function y(f,w=0,m=f.byteLength,h=0){for(let b=0;b<m;b++)f[w+b]=h}function v(f,w,m="0"){for(;f.length<w;)f=m+f;return f}function d(f,w=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(m=>m.toString(16).padStart(2,"0")).join(""):v((f>>>0).toString(16),w/4)}e.toHexString=d;class g{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const m=w.length;if(m===0)return;const h=this.p;let b=this.r,s=this.u,i,c;for(s!==0?(i=s,c=-1,s=0):(i=w.charCodeAt(0),c=0);;){let u=i;if(a.isHighSurrogate(i))if(c+1<m){const r=w.charCodeAt(c+1);a.isLowSurrogate(r)?(c++,u=a.computeCodePoint(i,r)):u=65533}else{s=i;break}else a.isLowSurrogate(i)&&(u=65533);if(b=this.w(h,b,u),c++,c<m)i=w.charCodeAt(c);else break}this.r=b,this.u=s}w(w,m,h){return h<128?w[m++]=h:h<2048?(w[m++]=192|(h&1984)>>>6,w[m++]=128|(h&63)>>>0):h<65536?(w[m++]=224|(h&61440)>>>12,w[m++]=128|(h&4032)>>>6,w[m++]=128|(h&63)>>>0):(w[m++]=240|(h&1835008)>>>18,w[m++]=128|(h&258048)>>>12,w[m++]=128|(h&4032)>>>6,w[m++]=128|(h&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=g.g,m=this.q;for(let n=0;n<64;n+=4)w.setUint32(n,m.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)w.setUint32(n,E(w.getUint32(n-12,!1)^w.getUint32(n-32,!1)^w.getUint32(n-56,!1)^w.getUint32(n-64,!1),1),!1);let h=this.h,b=this.l,s=this.m,i=this.n,c=this.o,u,r,o;for(let n=0;n<80;n++)n<20?(u=b&s|~b&i,r=1518500249):n<40?(u=b^s^i,r=1859775393):n<60?(u=b&s|b&i|s&i,r=2400959708):(u=b^s^i,r=3395469782),o=E(h,5)+u+c+r+w.getUint32(n*4,!1)&4294967295,c=i,i=s,s=E(b,30),b=h,h=o;this.h=this.h+h&4294967295,this.l=this.l+b&4294967295,this.m=this.m+s&4294967295,this.n=this.n+i&4294967295,this.o=this.o+c&4294967295}}e.StringSHA1=g,g.g=new DataView(new ArrayBuffer(320))}),define(Se[159],ye([1,0,78,107,8]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",D=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(a.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${D.source}`,"g");function C(f){return f.replace(S,(w,m)=>m?w:`\\${w}`)}e.escapeIcons=C;const R=new RegExp(`\\\\${D.source}`,"g");function P(f){return f.replace(R,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=P;const E=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function y(f){return f.indexOf(A)===-1?f:f.replace(E,(w,m,h,b)=>h?w:m||b||"")}e.stripIcons=y;function v(f){const w=f.indexOf(A);return w===-1?{text:f}:d(f,w)}e.parseLabelWithIcons=v;function d(f,w){const m=[];let h="";function b(l){if(l){h+=l;for(const p of l)m.push(c)}}let s=-1,i="",c=0,u,r,o=w;const n=f.length;for(b(f.substr(0,w));o<n;)u=f[o],r=f[o+1],u===A[0]&&r===A[1]?(s=o,b(i),i=A,o++):u===")"&&s!==-1?(c+=o-s+1,s=-1,i=""):s!==-1?T.test(u)?i+=u:(b(i),s=-1,i=""):b(u),o++;return b(i),{text:h,iconOffsets:m}}function g(f,w,m=!1){const{text:h,iconOffsets:b}=w;if(!b||b.length===0)return(0,t.matchesFuzzy)(f,h,m);const s=(0,I.ltrim)(h," "),i=h.length-s.length,c=(0,t.matchesFuzzy)(f,s,m);if(c)for(const u of c){const r=b[u.start+i]+i;u.start+=r,u.end+=r}return c}e.matchesFuzzyIconAware=g}),define(Se[42],ye([1,0,8]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const A="error",D="warning",T="warn",S="info",C="ignore";function R(E){return E?a.equalsIgnoreCase(A,E)?I.Error:a.equalsIgnoreCase(D,E)||a.equalsIgnoreCase(T,E)?I.Warning:a.equalsIgnoreCase(S,E)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function P(E){switch(E){case I.Error:return A;case I.Warning:return D;case I.Info:return S;default:return C}}I.toString=P}(t||(t={})),e.default=t}),define(Se[64],ye([1,0,17,8]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const v=y.charCodeAt(0),d=this.b.charCodeAt(this.c);return v-d}value(){return this.b[this.c]}}e.StringIterator=I;class A{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,t.compareSubstring)(y,this.b,0,y.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class D{constructor(y=!0,v=!0){this.f=y,this.g=v}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let v=y.length-1;v>=0;v--,this.c--){const d=this.b.charCodeAt(v);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,t.compareSubstring)(y,this.b,0,y.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var T;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(y,v){this.f=y,this.g=v,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(y,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,t.compare)(y,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(R||(R={}));class P{static forUris(y=()=>!1,v=()=>!1){return new P(new S(y,v))}static forPaths(y=!1){return new P(new D(void 0,!y))}static forStrings(){return new P(new I)}static forConfigKeys(){return new P(new A)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,v){if(v){const d=v.slice(0);(0,a.shuffle)(d);for(const g of d)this.set(g,y)}else{const d=y.slice(0);(0,a.shuffle)(d);for(const g of d)this.set(g[0],g[1])}}set(y,v){const d=this.b.reset(y);let g;this.c||(this.c=new C,this.c.segment=d.value());const f=[];for(g=this.c;;){const m=d.cmp(g.segment);if(m>0)g.left||(g.left=new C,g.left.segment=d.value()),f.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new C,g.right.segment=d.value()),f.push([1,g]),g=g.right;else if(d.hasNext())d.next(),g.mid||(g.mid=new C,g.mid.segment=d.value()),f.push([0,g]),g=g.mid;else break}const w=g.value;g.value=v,g.key=y;for(let m=f.length-1;m>=0;m--){const h=f[m][1];h.updateHeight();const b=h.balanceFactor();if(b<-1||b>1){const s=f[m][0],i=f[m+1][0];if(s===1&&i===1)f[m][1]=h.rotateLeft();else if(s===-1&&i===-1)f[m][1]=h.rotateRight();else if(s===1&&i===-1)h.right=f[m+1][1]=f[m+1][1].rotateRight(),f[m][1]=h.rotateLeft();else if(s===-1&&i===1)h.left=f[m+1][1]=f[m+1][1].rotateLeft(),f[m][1]=h.rotateRight();else throw new Error;if(m>0)switch(f[m-1][0]){case-1:f[m-1][1].left=f[m][1];break;case 1:f[m-1][1].right=f[m][1];break;case 0:f[m-1][1].mid=f[m][1];break}else this.c=f[0][1]}}return w}get(y){return this.d(y)?.value}d(y){const v=this.b.reset(y);let d=this.c;for(;d;){const g=v.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else break}return d}has(y){const v=this.d(y);return!(v?.value===void 0&&v?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,v){const d=this.b.reset(y),g=[];let f=this.c;for(;f;){const w=d.cmp(f.segment);if(w>0)g.push([-1,f]),f=f.left;else if(w<0)g.push([1,f]),f=f.right;else if(d.hasNext())d.next(),g.push([0,f]),f=f.mid;else break}if(!!f){if(v?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const w=this.f(f.right);if(w.key){const{key:m,value:h,segment:b}=w;this.e(w.key,!1),f.key=m,f.value=h,f.segment=b}}else{const w=f.left??f.right;if(g.length>0){const[m,h]=g[g.length-1];switch(m){case-1:h.left=w;break;case 0:h.mid=w;break;case 1:h.right=w;break}}else this.c=w}for(let w=g.length-1;w>=0;w--){const m=g[w][1];m.updateHeight();const h=m.balanceFactor();if(h>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[w][1]=m.rotateLeft()):h<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[w][1]=m.rotateRight()),w>0)switch(g[w-1][0]){case-1:g[w-1][1].left=g[w][1];break;case 1:g[w-1][1].right=g[w][1];break;case 0:g[w-1][1].mid=g[w][1];break}else this.c=g[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const v=this.b.reset(y);let d=this.c,g;for(;d;){const f=v.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(v.hasNext())v.next(),g=d.value||g,d=d.mid;else break}return d&&d.value||g}findSuperstr(y){const v=this.b.reset(y);let d=this.c;for(;d;){const g=v.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else return d.mid?this.g(d.mid):void 0}}forEach(y){for(const[v,d]of this)y(d,v)}*[Symbol.iterator](){yield*this.g(this.c)}g(y){const v=[];return this.h(y,v),v[Symbol.iterator]()}h(y,v){!y||(y.left&&this.h(y.left,v),y.value&&v.push([y.key,y.value]),y.mid&&this.h(y.mid,v),y.right&&this.h(y.right,v))}_isBalanced(){const y=v=>{if(!v)return!0;const d=v.balanceFactor();return d<-1||d>1?!1:y(v.left)&&y(v.right)};return y(this.c)}}e.TernarySearchTree=P}),define(Se[2],ye([1,0,9,12]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function T(c,u){if(!c.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!I.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!A.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(c,u){return!c&&!u?"file":c}function C(c,u){switch(c){case"https":case"http":case"file":u?u[0]!==P&&(u=P+u):u=P;break}return u}const R="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(u){return u instanceof y?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,r,o,n,l,p=!1){typeof u=="object"?(this.scheme=u.scheme||R,this.authority=u.authority||R,this.path=u.path||R,this.query=u.query||R,this.fragment=u.fragment||R):(this.scheme=S(u,p),this.authority=r||R,this.path=C(this.scheme,o||R),this.query=n||R,this.fragment=l||R,T(this,p))}get fsPath(){return m(this,!1)}with(u){if(!u)return this;let{scheme:r,authority:o,path:n,query:l,fragment:p}=u;return r===void 0?r=this.scheme:r===null&&(r=R),o===void 0?o=this.authority:o===null&&(o=R),n===void 0?n=this.path:n===null&&(n=R),l===void 0?l=this.query:l===null&&(l=R),p===void 0?p=this.fragment:p===null&&(p=R),r===this.scheme&&o===this.authority&&n===this.path&&l===this.query&&p===this.fragment?this:new d(r,o,n,l,p)}static parse(u,r=!1){const o=E.exec(u);return o?new d(o[2]||R,i(o[4]||R),i(o[5]||R),i(o[7]||R),i(o[9]||R),r):new d(R,R,R,R,R)}static file(u){let r=R;if(t.isWindows&&(u=u.replace(/\\/g,P)),u[0]===P&&u[1]===P){const o=u.indexOf(P,2);o===-1?(r=u.substring(2),u=P):(r=u.substring(2,o),u=u.substring(o)||P)}return new d("file",r,u,R,R)}static from(u){const r=new d(u.scheme,u.authority,u.path,u.query,u.fragment);return T(r,!0),r}static joinPath(u,...r){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return t.isWindows&&u.scheme==="file"?o=y.file(a.win32.join(m(u,!0),...r)).path:o=a.posix.join(u.path,...r),u.with({path:o})}toString(u=!1){return h(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof y)return u;{const r=new d(u);return r._formatted=u.external,r._fsPath=u._sep===v?u.fsPath:null,r}}else return u}}e.URI=y;const v=t.isWindows?1:void 0;class d extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(u=!1){return u?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=v),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(c,u){let r,o=-1;for(let n=0;n<c.length;n++){const l=c.charCodeAt(n);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||u&&l===47)o!==-1&&(r+=encodeURIComponent(c.substring(o,n)),o=-1),r!==void 0&&(r+=c.charAt(n));else{r===void 0&&(r=c.substr(0,n));const p=g[l];p!==void 0?(o!==-1&&(r+=encodeURIComponent(c.substring(o,n)),o=-1),r+=p):o===-1&&(o=n)}}return o!==-1&&(r+=encodeURIComponent(c.substring(o))),r!==void 0?r:c}function w(c){let u;for(let r=0;r<c.length;r++){const o=c.charCodeAt(r);o===35||o===63?(u===void 0&&(u=c.substr(0,r)),u+=g[o]):u!==void 0&&(u+=c[r])}return u!==void 0?u:c}function m(c,u){let r;return c.authority&&c.path.length>1&&c.scheme==="file"?r=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?u?r=c.path.substr(1):r=c.path[1].toLowerCase()+c.path.substr(2):r=c.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=m;function h(c,u){const r=u?w:f;let o="",{scheme:n,authority:l,path:p,query:k,fragment:L}=c;if(n&&(o+=n,o+=":"),(l||n==="file")&&(o+=P,o+=P),l){let U=l.indexOf("@");if(U!==-1){const K=l.substr(0,U);l=l.substr(U+1),U=K.indexOf(":"),U===-1?o+=r(K,!1):(o+=r(K.substr(0,U),!1),o+=":",o+=r(K.substr(U+1),!1)),o+="@"}l=l.toLowerCase(),U=l.indexOf(":"),U===-1?o+=r(l,!1):(o+=r(l.substr(0,U),!1),o+=l.substr(U))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const U=p.charCodeAt(1);U>=65&&U<=90&&(p=`/${String.fromCharCode(U+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const U=p.charCodeAt(0);U>=65&&U<=90&&(p=`${String.fromCharCode(U+32)}:${p.substr(2)}`)}o+=r(p,!0)}return k&&(o+="?",o+=r(k,!1)),L&&(o+="#",o+=u?L:f(L,!1)),o}function b(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+b(c.substr(3)):c}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(c){return c.match(s)?c.replace(s,u=>b(u)):c}}),define(Se[84],ye([1,0,22,8,2]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(C){return JSON.stringify(C,T)}e.stringify=A;function D(C){let R=JSON.parse(C);return R=S(R),R}e.parse=D;function T(C,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function S(C,R=0){if(!C||R>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return I.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 16:return new Date(C.source)}if(C instanceof a.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let P=0;P<C.length;++P)C[P]=S(C[P],R+1);else for(const P in C)Object.hasOwnProperty.call(C,P)&&(C[P]=S(C[P],R+1))}return C}e.revive=S}),define(Se[15],ye([1,0,12,2]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${I.vscodeRemoteResource}`}set(C,R,P){this.a[C]=R,this.b[C]=P}setConnectionToken(C,R){this.c[C]=R}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)return this.e(C);const R=C.authority;let P=this.a[R];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const E=this.b[R],y=this.c[R];let v=`path=${encodeURIComponent(C.path)}`;return typeof y=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),t.URI.from({scheme:a.isWeb?this.d:I.vscodeRemoteResource,authority:`${P}:${E}`,path:this.f,query:v})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(C){const R=this.b(C,te);return this.uriToBrowserUri(R)}uriToBrowserUri(C){return C.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===I.file&&(a.isNative||a.isWebWorker&&a.globals.origin===`${I.vscodeFileResource}://${D.a}`)?C.with({scheme:I.vscodeFileResource,authority:C.authority||D.a,query:null,fragment:null}):C}asFileUri(C){const R=this.b(C,te);return this.uriToFileUri(R)}uriToFileUri(C){return C.scheme===I.vscodeFileResource?C.with({scheme:I.file,authority:C.authority!==D.a?C.authority:null,query:null,fragment:null}):C}b(C,R){return t.URI.isUri(C)?C:t.URI.parse(R.toUrl(C))}}D.a="vscode-app",e.FileAccess=new D;var T;(function(S){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(C.get("3"));const R="vscode-coi";function P(y){let v;typeof y=="string"?v=new URL(y).searchParams:y instanceof URL?v=y.searchParams:t.URI.isUri(y)&&(v=new URL(y.toString(!0)).searchParams);const d=v?.get(R);if(!!d)return C.get(d)}S.getHeadersFromQuery=P;function E(y,v,d){if(!globalThis.crossOriginIsolated)return;const g=v&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set(R,g):y[R]=g}S.addSearchParam=E})(T=e.COI||(e.COI={}))}),define(Se[24],ye([1,0,32,15,9,12,8,2]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(y){return(0,T.uriToFsPath)(y,!0)}e.originalFSPath=S;class C{constructor(v){this.a=v}compare(v,d,g=!1){return v===d?0:(0,D.compare)(this.getComparisonKey(v,g),this.getComparisonKey(d,g))}isEqual(v,d,g=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,g)===this.getComparisonKey(d,g)}getComparisonKey(v,d=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,d,g=!1){if(v.scheme===d.scheme){if(v.scheme===t.Schemas.file)return a.isEqualOrParent(S(v),S(d),this.a(v))&&v.query===d.query&&(g||v.fragment===d.fragment);if((0,e.isEqualAuthority)(v.authority,d.authority))return a.isEqualOrParent(v.path,d.path,this.a(v),"/")&&v.query===d.query&&(g||v.fragment===d.fragment)}return!1}joinPath(v,...d){return T.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return I.posix.basename(v.path)}extname(v){return I.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===t.Schemas.file?d=T.URI.file(I.dirname(S(v))).path:(d=I.posix.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===t.Schemas.file?d=T.URI.file(I.normalize(S(v))).path:d=I.posix.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.isEqualAuthority)(v.authority,d.authority))return;if(v.scheme===t.Schemas.file){const w=I.relative(S(v),S(d));return A.isWindows?a.toSlashes(w):w}let g=v.path||"/";const f=d.path||"/";if(this.a(v)){let w=0;for(const m=Math.min(g.length,f.length);w<m&&!(g.charCodeAt(w)!==f.charCodeAt(w)&&g.charAt(w).toLowerCase()!==f.charAt(w).toLowerCase());w++);g=f.substr(0,w)+g.substr(w)}return I.posix.relative(g,f)}resolvePath(v,d){if(v.scheme===t.Schemas.file){const g=T.URI.file(I.resolve(S(v),d));return v.with({authority:g.authority,path:g.path})}return d=a.toPosixPath(d),v.with({path:I.posix.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,D.equalsIgnoreCase)(v,d)}hasTrailingPathSeparator(v,d=I.sep){if(v.scheme===t.Schemas.file){const g=S(v);return g.length>a.getRoot(g).length&&g[g.length-1]===d}else{const g=v.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=I.sep){return(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=I.sep){let g=!1;if(v.scheme===t.Schemas.file){const f=S(v);g=f!==void 0&&f.length===a.getRoot(f).length&&f[f.length-1]===d}else{d="/";const f=v.path;g=f.length===1&&f.charCodeAt(f.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path+"/"}):v}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(y=>y.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new C(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(y,v){const d=[];for(let g=0;g<y.length;g++){const f=v(y[g]);y.some((w,m)=>m===g?!1:(0,e.isEqualOrParent)(f,v(w)))||d.push(y[g])}return d}e.distinctParents=R;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function v(d){const g=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(m=>{const[h,b]=m.split(":");h&&b&&g.set(h,b)});const w=d.path.substring(0,d.path.indexOf(";"));return w&&g.set(y.META_DATA_MIME,w),g}y.parseMetaData=v})(P=e.DataUri||(e.DataUri={}));function E(y,v,d){if(v){let g=y.path;return g&&g[0]!==I.posix.sep&&(g=I.posix.sep+g),y.with({scheme:d,authority:v,path:g})}return y.with({scheme:d})}e.toLocalResource=E}),define(Se[18],ye([1,0,21,10,4,6,24,12]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=S;function C(fe){const Z=new a.CancellationTokenSource,pe=fe(Z.token),we=new Promise((De,Re)=>{const Be=Z.token.onCancellationRequested(()=>{Be.dispose(),Z.dispose(),Re(new t.CancellationError)});Promise.resolve(pe).then(se=>{Be.dispose(),Z.dispose(),De(se)},se=>{Be.dispose(),Z.dispose(),Re(se)})});return new class{cancel(){Z.cancel()}then(De,Re){return we.then(De,Re)}catch(De){return this.then(void 0,De)}finally(De){return we.finally(De)}}}e.createCancelablePromise=C;function R(fe,Z,pe){return new Promise((we,De)=>{const Re=Z.onCancellationRequested(()=>{Re.dispose(),we(pe)});fe.then(we,De).finally(()=>Re.dispose())})}e.raceCancellation=R;function P(fe,Z){return new Promise((pe,we)=>{const De=Z.onCancellationRequested(()=>{De.dispose(),we(new t.CancellationError)});fe.then(pe,we).finally(()=>De.dispose())})}e.raceCancellationError=P;async function E(fe){let Z=-1;const pe=fe.map((De,Re)=>De.then(Be=>(Z=Re,Be))),we=await Promise.race(pe);return fe.forEach((De,Re)=>{Re!==Z&&De.cancel()}),we}e.raceCancellablePromises=E;function y(fe,Z,pe){let we;const De=setTimeout(()=>{we?.(void 0),pe?.()},Z);return Promise.race([fe.finally(()=>clearTimeout(De)),new Promise(Re=>we=Re)])}e.raceTimeout=y;function v(fe){return new Promise((Z,pe)=>{const we=fe();S(we)?we.then(Z,pe):Z(we)})}e.asPromise=v;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(Z){if(this.a){if(this.d=Z,!this.b){const pe=()=>{this.b=null;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(pe,pe).then(we)})}return new Promise((pe,we)=>{this.b.then(pe,we)})}return this.a=Z(),new Promise((pe,we)=>{this.a.then(De=>{this.a=null,pe(De)},De=>{this.a=null,we(De)})})}}e.Throttler=d;class g{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.Sequencer=g;class f{constructor(){this.a=new Map}queue(Z,pe){const De=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.a.get(Z)===De&&this.a.delete(Z)});return this.a.set(Z,De),De}}e.SequencerByKey=f;const w=(fe,Z)=>{let pe=!0;const we=setTimeout(()=>{pe=!1,Z()},fe);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(we),pe=!1}}},m=fe=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,fe())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,pe=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((De,Re)=>{this.d=De,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const De=this.g;return this.g=null,De()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=pe===e.MicrotaskDelay?m(we):w(pe,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=h;class b{constructor(Z){this.a=new h(Z),this.b=new d}trigger(Z,pe){return this.a.trigger(()=>this.b.queue(Z),pe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=b;class s{constructor(){this.a=!1,this.b=new Promise((Z,pe)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class i extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function c(fe,Z){return Z?new Promise((pe,we)=>{const De=setTimeout(()=>{Re.dispose(),pe()},fe),Re=Z.onCancellationRequested(()=>{clearTimeout(De),Re.dispose(),we(new t.CancellationError)})}):C(pe=>c(fe,pe))}e.timeout=c;function u(fe,Z=0){const pe=setTimeout(fe,Z);return(0,A.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=u;function r(fe){const Z=[];let pe=0;const we=fe.length;function De(){return pe<we?fe[pe++]():null}function Re(Be){Be!=null&&Z.push(Be);const se=De();return se?se.then(Re):Promise.resolve(Z)}return Promise.resolve(null).then(Re)}e.sequence=r;function o(fe,Z=we=>!!we,pe=null){let we=0;const De=fe.length,Re=()=>{if(we>=De)return Promise.resolve(pe);const Be=fe[we++];return Promise.resolve(Be()).then(ue=>Z(ue)?Promise.resolve(ue):Re())};return Re()}e.first=o;function n(fe,Z=we=>!!we,pe=null){if(fe.length===0)return Promise.resolve(pe);let we=fe.length;const De=()=>{we=-1;for(const Re of fe)Re.cancel?.()};return new Promise((Re,Be)=>{for(const se of fe)se.then(ue=>{--we>=0&&Z(ue)?(De(),Re(ue)):we===0&&Re(pe)}).catch(ue=>{--we>=0&&(De(),Be(ue))})})}e.firstParallel=n;class l{constructor(Z){this.a=0,this.d=Z,this.f=[],this.b=0,this.g=new I.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Z){return this.a++,new Promise((pe,we)=>{this.f.push({factory:Z,c:pe,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Z=this.f.shift();this.b++;const pe=Z.factory();pe.then(Z.c,Z.e),pe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=l;class p extends l{constructor(){super(1)}}e.Queue=p;class k{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Z=new q;return this.b.add(Z),Z.p}d(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueFor(Z,pe=D.extUri){const we=pe.getComparisonKey(Z);let De=this.a.get(we);return De||(De=new p,I.Event.once(De.onDrained)(()=>{De?.dispose(),this.a.delete(we),this.f()}),this.a.set(we,De)),De}f(){!this.d()||this.g()}g(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.g()}}e.ResourceQueue=k;class L{constructor(Z,pe){this.a=-1,typeof Z=="function"&&typeof pe=="number"&&this.setIfNotSet(Z,pe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,pe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},pe)}setIfNotSet(Z,pe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},pe))}}e.TimeoutTimer=L;class U{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Z,pe){this.cancel(),this.a=setInterval(()=>{Z()},pe)}}e.IntervalTimer=U;class K{constructor(Z,pe){this.b=-1,this.a=Z,this.d=pe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class G{constructor(Z,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.a=Z,this.b=pe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class O extends K{constructor(Z,pe){super(Z,pe),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=O;class B extends A.Disposable{constructor(Z,pe){super(),this.g=Z,this.h=pe,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...Z),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,T.setTimeout0)(()=>{if(Z)return;const pe=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(fe,Z)=>{const pe=requestIdleCallback(fe,typeof Z=="number"?{timeout:Z}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(pe))}}}}();class F{constructor(Z){this.d=!1,this.a=()=>{try{this.f=Z()}catch(pe){this.g=pe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function $(fe,Z,pe){let we;for(let De=0;De<pe;De++)try{return await fe()}catch(Re){we=Re,await c(Z)}throw we}e.retry=$;class M{hasPending(Z){return this.a?typeof Z=="number"?this.a.taskId===Z:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Z,pe,we){return this.a={taskId:Z,cancel:()=>we?.(),promise:pe},pe.then(()=>this.d(Z),()=>this.d(Z)),pe}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this.b)this.b.run=Z;else{let pe,we;const De=new Promise((Re,Be)=>{pe=Re,we=Be});this.b={run:Z,promise:De,promiseResolve:pe,promiseReject:we}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=M;class V{constructor(Z,pe=()=>Date.now()){this.d=Z,this.f=pe,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.IntervalCounter=V;class q{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Z,pe)=>{this.a=Z,this.b=pe})}complete(Z){return new Promise(pe=>{this.a(Z),this.f=!0,pe()})}error(Z){return new Promise(pe=>{this.b(Z),this.d=!0,pe()})}cancel(){new Promise(Z=>{this.b(new t.CancellationError),this.d=!0,Z()})}}e.DeferredPromise=q;var H;(function(fe){async function Z(we){let De;const Re=await Promise.all(we.map(Be=>Be.then(se=>se,se=>{De||(De=se)})));if(typeof De<"u")throw De;return Re}fe.settled=Z;function pe(we){return new Promise(async(De,Re)=>{try{await we(De,Re)}catch(Be){Re(Be)}})}fe.withAsyncBody=pe})(H=e.Promises||(e.Promises={}));var J;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(J||(J={}));class Y{static fromArray(Z){return new Y(pe=>{pe.emitMany(Z)})}static fromPromise(Z){return new Y(async pe=>{pe.emitMany(await Z)})}static fromPromises(Z){return new Y(async pe=>{await Promise.all(Z.map(async we=>pe.emitOne(await we)))})}static merge(Z){return new Y(async pe=>{await Promise.all(Z.map(async we=>{for await(const De of we)pe.emitOne(De)}))})}constructor(Z){this.a=0,this.b=[],this.d=null,this.f=new I.Emitter,queueMicrotask(async()=>{const pe={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(Z(pe)),this.j()}catch(we){this.k(we)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(Z,pe){return new Y(async we=>{for await(const De of Z)we.emitOne(pe(De))})}map(Z){return Y.map(this,Z)}static filter(Z,pe){return new Y(async we=>{for await(const De of Z)pe(De)&&we.emitOne(De)})}filter(Z){return Y.filter(this,Z)}static coalesce(Z){return Y.filter(Z,pe=>!!pe)}coalesce(){return Y.coalesce(this)}static async toPromise(Z){const pe=[];for await(const we of Z)pe.push(we);return pe}toPromise(){return Y.toPromise(this)}g(Z){this.a===0&&(this.b.push(Z),this.f.fire())}h(Z){this.a===0&&(this.b=this.b.concat(Z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Z){this.a===0&&(this.a=2,this.d=Z,this.f.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class ae extends Y{constructor(Z,pe){super(pe),this.l=Z}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ae;function re(fe){const Z=new a.CancellationTokenSource,pe=fe(Z.token);return new ae(Z,async we=>{const De=Z.token.onCancellationRequested(()=>{De.dispose(),Z.dispose(),we.reject(new t.CancellationError)});try{for await(const Re of pe){if(Z.token.isCancellationRequested)return;we.emitOne(Re)}De.dispose(),Z.dispose()}catch(Re){De.dispose(),Z.dispose(),we.reject(Re)}})}e.createCancelableAsyncIterable=re}),define(Se[108],ye([1,0,18,9]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new a.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),A=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(p,k,L=!1){const U=p||"",K=k||"",G=I.value.collator.compare(U,K);return I.value.collatorIsNumeric&&G===0&&U!==K?U<K?-1:1:G}e.compareFileNames=T;function S(p,k){const L=A.value.collator;return p=p||"",k=k||"",b(L,p,k)}e.compareFileNamesDefault=S;function C(p,k){const L=A.value.collator;return p=p||"",k=k||"",u(p,k)||b(L,p,k)}e.compareFileNamesUpper=C;function R(p,k){const L=A.value.collator;return p=p||"",k=k||"",c(p,k)||b(L,p,k)}e.compareFileNamesLower=R;function P(p,k){return p=p||"",k=k||"",p===k?0:p<k?-1:1}e.compareFileNamesUnicode=P;function E(p,k,L=!1){L||(p=p&&p.toLowerCase(),k=k&&k.toLowerCase());const[U,K]=m(p),[G,O]=m(k);return U!==G?U<G?-1:1:K===O?0:K<O?-1:1}e.noIntlCompareFileNames=E;function y(p,k){const[L,U]=m(p),[K,G]=m(k);let O=I.value.collator.compare(U,G);if(O===0){if(I.value.collatorIsNumeric&&U!==G)return U<G?-1:1;if(O=I.value.collator.compare(L,K),I.value.collatorIsNumeric&&O===0&&L!==K)return L<K?-1:1}return O}e.compareFileExtensions=y;function v(p,k){p=p||"",k=k||"";const L=h(p),U=h(k),K=A.value.collator,G=D.value.collator;return b(G,L,U)||b(K,p,k)}e.compareFileExtensionsDefault=v;function d(p,k){p=p||"",k=k||"";const L=h(p),U=h(k),K=A.value.collator,G=D.value.collator;return b(G,L,U)||u(p,k)||b(K,p,k)}e.compareFileExtensionsUpper=d;function g(p,k){p=p||"",k=k||"";const L=h(p),U=h(k),K=A.value.collator,G=D.value.collator;return b(G,L,U)||c(p,k)||b(K,p,k)}e.compareFileExtensionsLower=g;function f(p,k){p=p||"",k=k||"";const L=h(p).toLowerCase(),U=h(k).toLowerCase();return L!==U?L<U?-1:1:p!==k?p<k?-1:1:0}e.compareFileExtensionsUnicode=f;const w=/^(.*?)(\.([^.]*))?$/;function m(p,k=!1){const L=p?w.exec(p):[];let U=[L&&L[1]||"",L&&L[3]||""];return k&&(!U[0]&&U[1]||U[0]&&U[0].charAt(0)===".")&&(U=[U[0]+"."+U[1],""]),U}function h(p){const k=p?w.exec(p):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function b(p,k,L){const U=p.compare(k,L);return U!==0?U:k.length!==L.length?k.length<L.length?-1:1:0}function s(p){const k=p.charAt(0);return k.toLocaleUpperCase()!==k}function i(p){const k=p.charAt(0);return k.toLocaleLowerCase()!==k}function c(p,k){return s(p)&&i(k)?-1:i(p)&&s(k)?1:0}function u(p,k){return i(p)&&s(k)?-1:s(p)&&i(k)?1:0}function r(p,k,L=!1){return L||(p=p&&p.toLowerCase(),k=k&&k.toLowerCase()),p===k?0:p<k?-1:1}function o(p,k,L=!1){const U=p.split(t.sep),K=k.split(t.sep),G=U.length-1,O=K.length-1;let B,F;for(let $=0;;$++){if(B=G===$,F=O===$,B&&F)return T(U[$],K[$],L);if(B)return-1;if(F)return 1;const M=r(U[$],K[$],L);if(M!==0)return M}}e.comparePaths=o;function n(p,k,L){const U=p.toLowerCase(),K=k.toLowerCase(),G=l(p,k,L);if(G)return G;const O=U.endsWith(L),B=K.endsWith(L);if(O!==B)return O?-1:1;const F=T(U,K);return F!==0?F:U.localeCompare(K)}e.compareAnything=n;function l(p,k,L){const U=p.toLowerCase(),K=k.toLowerCase(),G=U.startsWith(L),O=K.startsWith(L);if(G!==O)return G?-1:1;if(G&&O){if(U.length<K.length)return-1;if(U.length>K.length)return 1}return 0}e.compareByPrefix=l}),define(Se[109],ye([1,0,108,107,83,9,12,8]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,C=[S,[]];function R(M,V,q,H){if(!M||!V)return C;const J=M.length,Y=V.length;if(J<Y)return C;const ae=M.toLowerCase();return P(V,q,Y,M,ae,J,H)}e.scoreFuzzy=R;function P(M,V,q,H,J,Y,ae){const re=[],fe=[];for(let De=0;De<q;De++){const Re=De*Y,Be=Re-Y,se=De>0,ue=M[De],de=V[De];for(let ee=0;ee<Y;ee++){const oe=ee>0,ie=Re+ee,N=ie-1,z=Be+ee-1,X=oe?re[N]:0,Q=se&&oe?re[z]:0,le=se&&oe?fe[z]:0;let be;!Q&&se?be=0:be=E(ue,de,H,J,ee,le),be&&Q+be>=X&&(ae||se||J.startsWith(V,ee))?(fe[ie]=le+1,re[ie]=Q+be):(fe[ie]=S,re[ie]=X)}}const Z=[];let pe=q-1,we=Y-1;for(;pe>=0&&we>=0;){const De=pe*Y+we;fe[De]===S||(Z.push(we),pe--),we--}return[re[q*Y-1],Z.reverse()]}function E(M,V,q,H,J,Y){let ae=0;if(!y(V,H[J]))return ae;if(ae+=1,Y>0&&(ae+=Y*5),M===q[J]&&(ae+=1),J===0)ae+=8;else{const re=v(q.charCodeAt(J-1));re?ae+=re:(0,t.isUpper)(q.charCodeAt(J))&&Y===0&&(ae+=2)}return ae}function y(M,V){return M===V?!0:M==="/"||M==="\\"?V==="/"||V==="\\":!1}function v(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function g(M,V,q=0,H=0){const J=V;return J.values&&J.values.length>1?f(M,J.values,q,H):w(M,V,q,H)}e.scoreFuzzy2=g;function f(M,V,q,H){let J=0;const Y=[];for(const ae of V){const[re,fe]=w(M,ae,q,H);if(typeof re!="number")return d;J+=re,Y.push(...fe)}return[J,l(Y)]}function w(M,V,q,H){const J=(0,t.fuzzyScore)(V.original,V.originalLowercase,q,M,M.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,t.createMatches)(J)]:d}const m=Object.freeze({score:0}),h=1<<18,b=1<<17,s=1<<16;function i(M,V,q,H){const J=H.values?H.values:[H];return(0,I.hash)({[H.normalized]:{values:J.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:M,description:V,allowNonContiguousMatches:q}})}function c(M,V,q,H,J){if(!M||!V.normalized)return m;const Y=H.getItemLabel(M);if(!Y)return m;const ae=H.getItemDescription(M),re=i(Y,ae,q,V),fe=J[re];if(fe)return fe;const Z=u(Y,ae,H.getItemPath(M),V,q);return J[re]=Z,Z}e.scoreItemFuzzy=c;function u(M,V,q,H,J){const Y=!q||!H.containsPathSeparator;return q&&(D.isLinux?H.pathNormalized===q:(0,T.equalsIgnoreCase)(H.pathNormalized,q))?{score:h,labelMatch:[{start:0,end:M.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:H.values&&H.values.length>1?r(M,V,q,H.values,Y,J):o(M,V,q,H,Y,J)}function r(M,V,q,H,J,Y){let ae=0;const re=[],fe=[];for(const Z of H){const{score:pe,labelMatch:we,descriptionMatch:De}=o(M,V,q,Z,J,Y);if(pe===S)return m;ae+=pe,we&&re.push(...we),De&&fe.push(...De)}return{score:ae,labelMatch:l(re),descriptionMatch:l(fe)}}function o(M,V,q,H,J,Y){if(J||!V){const[ae,re]=R(M,H.normalized,H.normalizedLowercase,Y&&!H.expectContiguousMatch);if(ae){const fe=(0,t.matchesPrefix)(H.normalized,M);let Z;return fe?(Z=b,Z+=Math.round(H.normalized.length/M.length*100)):Z=s,{score:Z+ae,labelMatch:fe||n(re)}}}if(V){let ae=V;q&&(ae=`${V}${A.sep}`);const re=ae.length,fe=`${ae}${M}`,[Z,pe]=R(fe,H.normalized,H.normalizedLowercase,Y&&!H.expectContiguousMatch);if(Z){const we=n(pe),De=[],Re=[];return we.forEach(Be=>{Be.start<re&&Be.end>re?(De.push({start:0,end:Be.end-re}),Re.push({start:Be.start,end:re})):Be.start>=re?De.push({start:Be.start-re,end:Be.end-re}):Re.push(Be)}),{score:Z,labelMatch:De,descriptionMatch:Re}}}return m}function n(M){const V=[];if(!M)return V;let q;for(const H of M)q&&q.end===H?q.end+=1:(q={start:H,end:H+1},V.push(q));return V}function l(M){const V=M.sort((J,Y)=>J.start-Y.start),q=[];let H;for(const J of V)!H||!p(H,J)?(H=J,q.push(J)):(H.start=Math.min(H.start,J.start),H.end=Math.max(H.end,J.end));return q}function p(M,V){return!(M.end<V.start||V.end<M.start)}function k(M,V,q,H,J,Y){const ae=c(M,q,H,J,Y),re=c(V,q,H,J,Y),fe=ae.score,Z=re.score;if((fe===h||Z===h)&&fe!==Z)return fe===h?-1:1;if(fe>s||Z>s){if(fe!==Z)return fe>Z?-1:1;if(fe<b&&Z<b){const ue=U(ae.labelMatch,re.labelMatch);if(ue!==0)return ue}const Be=J.getItemLabel(M)||"",se=J.getItemLabel(V)||"";if(Be.length!==se.length)return Be.length-se.length}if(fe!==Z)return fe>Z?-1:1;const pe=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,we=Array.isArray(re.labelMatch)&&re.labelMatch.length>0;if(pe&&!we)return-1;if(we&&!pe)return 1;const De=L(M,ae,J),Re=L(V,re,J);return De&&Re&&De!==Re?Re>De?-1:1:K(M,V,q,J)}e.compareItemsByFuzzyScore=k;function L(M,V,q){let H=-1,J=-1;if(V.descriptionMatch&&V.descriptionMatch.length?H=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(H=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(J=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const Y=q.getItemDescription(M);Y&&(J+=Y.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(J=V.descriptionMatch[V.descriptionMatch.length-1].end);return J-H}function U(M,V){if(!M&&!V||(!M||!M.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!M||!M.length)return 1;const q=M[0].start,J=M[M.length-1].end-q,Y=V[0].start,re=V[V.length-1].end-Y;return J===re?0:re<J?1:-1}function K(M,V,q,H){const J=H.getItemLabel(M)||"",Y=H.getItemLabel(V)||"",ae=H.getItemDescription(M),re=H.getItemDescription(V),fe=J.length+(ae?ae.length:0),Z=Y.length+(re?re.length:0);if(fe!==Z)return fe-Z;const pe=H.getItemPath(M),we=H.getItemPath(V);return pe&&we&&pe.length!==we.length?pe.length-we.length:J!==Y?(0,a.compareAnything)(J,Y,q.normalized):ae&&re&&ae!==re?(0,a.compareAnything)(ae,re,q.normalized):pe&&we&&pe!==we?(0,a.compareAnything)(pe,we,q.normalized):0}function G(M){return M.startsWith('"')&&M.endsWith('"')}const O=" ";function B(M){typeof M!="string"&&(M="");const V=M.toLowerCase(),{pathNormalized:q,normalized:H,normalizedLowercase:J}=F(M),Y=q.indexOf(A.sep)>=0,ae=G(M);let re;const fe=M.split(O);if(fe.length>1)for(const Z of fe){const pe=G(Z),{pathNormalized:we,normalized:De,normalizedLowercase:Re}=F(Z);De&&(re||(re=[]),re.push({original:Z,originalLowercase:Z.toLowerCase(),pathNormalized:we,normalized:De,normalizedLowercase:Re,expectContiguousMatch:pe}))}return{original:M,originalLowercase:V,pathNormalized:q,normalized:H,normalizedLowercase:J,values:re,containsPathSeparator:Y,expectContiguousMatch:ae}}e.prepareQuery=B;function F(M){let V;D.isWindows?V=M.replace(/\//g,A.sep):V=M.replace(/\\/g,A.sep);const q=(0,T.stripWildcards)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:q,normalizedLowercase:q.toLowerCase()}}function $(M){return Array.isArray(M)?B(M.map(V=>V.original).join(O)):B(M.original)}e.pieceToQuery=$}),define(Se[37],ye([1,0,17,18,32,28,9,12,8]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",P="[^/\\\\]",E=/\//g;function y(q,H){switch(q){case 0:return"";case 1:return`${P}*?`;default:return`(?:${R}|${P}+${R}${H?`|${R}${P}+`:""})*?`}}function v(q,H){if(!q)return[];const J=[];let Y=!1,ae=!1,re="";for(const fe of q){switch(fe){case H:if(!Y&&!ae){J.push(re),re="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}re+=fe}return re&&J.push(re),J}e.splitGlobAware=v;function d(q){if(!q)return"";let H="";const J=v(q,e.GLOB_SPLIT);if(J.every(Y=>Y===e.GLOBSTAR))H=".*";else{let Y=!1;J.forEach((ae,re)=>{if(ae===e.GLOBSTAR){if(Y)return;H+=y(2,re===J.length-1)}else{let fe=!1,Z="",pe=!1,we="";for(const De of ae){if(De!=="}"&&fe){Z+=De;continue}if(pe&&(De!=="]"||!we)){let Re;De==="-"?Re=De:(De==="^"||De==="!")&&!we?Re="^":De===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(De),we+=Re;continue}switch(De){case"{":fe=!0;continue;case"[":pe=!0;continue;case"}":{H+=`(?:${v(Z,",").map(se=>d(se)).join("|")})`,fe=!1,Z="";break}case"]":{H+="["+we+"]",pe=!1,we="";break}case"?":H+=P;continue;case"*":H+=y(1);continue;default:H+=(0,S.escapeRegExpCharacters)(De)}}re<J.length-1&&(J[re+1]!==e.GLOBSTAR||re+2<J.length)&&(H+=R)}Y=ae===e.GLOBSTAR})}return H}const g=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new A.LRUCache(1e4),i=function(){return!1},c=function(){return null};function u(q,H){if(!q)return c;let J;typeof q!="string"?J=q.pattern:J=q,J=J.trim();const Y=`${J}_${!!H.trimForExclusions}`;let ae=s.get(Y);if(ae)return r(ae,q);let re;return g.test(J)?ae=n(J.substr(4),J):(re=f.exec(o(J,H)))?ae=l(re[1],J):(H.trimForExclusions?m:w).test(J)?ae=p(J,H):(re=h.exec(o(J,H)))?ae=k(re[1].substr(1),J,!0):(re=b.exec(o(J,H)))?ae=k(re[1],J,!1):ae=L(J),s.set(Y,ae),r(ae,q)}function r(q,H){if(typeof H=="string")return q;const J=function(Y,ae){return(0,I.isEqualOrParent)(Y,H.base,!T.isLinux)?q((0,S.ltrim)(Y.substr(H.base.length),D.sep),ae):null};return J.allBasenames=q.allBasenames,J.allPaths=q.allPaths,J.basenames=q.basenames,J.patterns=q.patterns,J}function o(q,H){return H.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function n(q,H){return function(J,Y){return typeof J=="string"&&J.endsWith(q)?H:null}}function l(q,H){const J=`/${q}`,Y=`\\${q}`,ae=function(fe,Z){return typeof fe!="string"?null:Z?Z===q?H:null:fe===q||fe.endsWith(J)||fe.endsWith(Y)?H:null},re=[q];return ae.basenames=re,ae.patterns=[H],ae.allBasenames=re,ae}function p(q,H){const J=M(q.slice(1,-1).split(",").map(Z=>u(Z,H)).filter(Z=>Z!==c),q),Y=J.length;if(!Y)return c;if(Y===1)return J[0];const ae=function(Z,pe){for(let we=0,De=J.length;we<De;we++)if(J[we](Z,pe))return q;return null},re=J.find(Z=>!!Z.allBasenames);re&&(ae.allBasenames=re.allBasenames);const fe=J.reduce((Z,pe)=>pe.allPaths?Z.concat(pe.allPaths):Z,[]);return fe.length&&(ae.allPaths=fe),ae}function k(q,H,J){const Y=D.sep===D.posix.sep,ae=Y?q:q.replace(E,D.sep),re=D.sep+ae,fe=D.posix.sep+q;let Z;return J?Z=function(pe,we){return typeof pe=="string"&&(pe===ae||pe.endsWith(re)||!Y&&(pe===q||pe.endsWith(fe)))?H:null}:Z=function(pe,we){return typeof pe=="string"&&(pe===ae||!Y&&pe===q)?H:null},Z.allPaths=[(J?"*/":"./")+q],Z}function L(q){try{const H=new RegExp(`^${d(q)}$`);return function(J){return H.lastIndex=0,typeof J=="string"&&H.test(J)?q:null}}catch{return c}}function U(q,H,J){return!q||typeof H!="string"?!1:K(q)(H,void 0,J)}e.match=U;function K(q,H={}){if(!q)return i;if(typeof q=="string"||G(q)){const J=u(q,H);if(J===c)return i;const Y=function(ae,re){return!!J(ae,re)};return J.allBasenames&&(Y.allBasenames=J.allBasenames),J.allPaths&&(Y.allPaths=J.allPaths),Y}return F(q,H)}e.parse=K;function G(q){const H=q;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=G;function O(q){return q.allBasenames||[]}e.getBasenameTerms=O;function B(q){return q.allPaths||[]}e.getPathTerms=B;function F(q,H){const J=M(Object.getOwnPropertyNames(q).map(Z=>$(Z,q[Z],H)).filter(Z=>Z!==c)),Y=J.length;if(!Y)return c;if(!J.some(Z=>!!Z.requiresSiblings)){if(Y===1)return J[0];const Z=function(De,Re){let Be;for(let se=0,ue=J.length;se<ue;se++){const de=J[se](De,Re);if(typeof de=="string")return de;(0,t.isThenable)(de)&&(Be||(Be=[]),Be.push(de))}return Be?(async()=>{for(const se of Be){const ue=await se;if(typeof ue=="string")return ue}return null})():null},pe=J.find(De=>!!De.allBasenames);pe&&(Z.allBasenames=pe.allBasenames);const we=J.reduce((De,Re)=>Re.allPaths?De.concat(Re.allPaths):De,[]);return we.length&&(Z.allPaths=we),Z}const ae=function(Z,pe,we){let De,Re;for(let Be=0,se=J.length;Be<se;Be++){const ue=J[Be];ue.requiresSiblings&&we&&(pe||(pe=(0,D.basename)(Z)),De||(De=pe.substr(0,pe.length-(0,D.extname)(Z).length)));const de=ue(Z,pe,De,we);if(typeof de=="string")return de;(0,t.isThenable)(de)&&(Re||(Re=[]),Re.push(de))}return Re?(async()=>{for(const Be of Re){const se=await Be;if(typeof se=="string")return se}return null})():null},re=J.find(Z=>!!Z.allBasenames);re&&(ae.allBasenames=re.allBasenames);const fe=J.reduce((Z,pe)=>pe.allPaths?Z.concat(pe.allPaths):Z,[]);return fe.length&&(ae.allPaths=fe),ae}function $(q,H,J){if(H===!1)return c;const Y=u(q,J);if(Y===c)return c;if(typeof H=="boolean")return Y;if(H){const ae=H.when;if(typeof ae=="string"){const re=(fe,Z,pe,we)=>{if(!we||!Y(fe,Z))return null;const De=ae.replace("$(basename)",pe),Re=we(De);return(0,t.isThenable)(Re)?Re.then(Be=>Be?q:null):Re?q:null};return re.requiresSiblings=!0,re}}return Y}function M(q,H){const J=q.filter(Z=>!!Z.basenames);if(J.length<2)return q;const Y=J.reduce((Z,pe)=>{const we=pe.basenames;return we?Z.concat(we):Z},[]);let ae;if(H){ae=[];for(let Z=0,pe=Y.length;Z<pe;Z++)ae.push(H)}else ae=J.reduce((Z,pe)=>{const we=pe.patterns;return we?Z.concat(we):Z},[]);const re=function(Z,pe){if(typeof Z!="string")return null;if(!pe){let De;for(De=Z.length;De>0;De--){const Re=Z.charCodeAt(De-1);if(Re===47||Re===92)break}pe=Z.substr(De)}const we=Y.indexOf(pe);return we!==-1?ae[we]:null};re.basenames=Y,re.patterns=ae,re.allBasenames=Y;const fe=q.filter(Z=>!Z.basenames);return fe.push(re),fe}function V(q,H){return(0,a.equals)(q,H,(J,Y)=>typeof J=="string"&&typeof Y=="string"?J===Y:typeof J!="string"&&typeof Y!="string"?J.base===Y.base&&J.pattern===Y.pattern:!1)}e.patternsEquals=V}),define(Se[110],ye([1,0,10,159,24,8,2]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(f="",w=!1){if(this.value=f,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(f,w=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(m,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,w){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}appendLink(f,w,m){return this.value+="[",this.value+=this.c(w,"]"),this.value+="](",this.value+=this.c(String(f),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(f,w){const m=new RegExp((0,A.escapeRegExpCharacters)(w),"g");return f.replace(m,(h,b)=>f.charAt(b-1)!=="\\"?`\\${h}`:h)}}e.MarkdownString=S;function C(g){return R(g)?!g.value:Array.isArray(g)?g.every(C):!0}e.isEmptyMarkdownString=C;function R(g){return g instanceof S?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function P(g,f){return g===f?!0:!g||!f?!1:g.value===f.value&&g.isTrusted===f.isTrusted&&g.supportThemeIcons===f.supportThemeIcons&&g.supportHtml===f.supportHtml&&(g.baseUri===f.baseUri||!!g.baseUri&&!!f.baseUri&&(0,I.isEqual)(D.URI.from(g.baseUri),D.URI.from(f.baseUri)))}e.markdownStringEqual=P;function E(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function y(g){return g.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=y;function v(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=v;function d(g){const f=[],w=g.split("|").map(h=>h.trim());g=w[0];const m=w[1];if(m){const h=/height=(\d+)/.exec(m),b=/width=(\d+)/.exec(m),s=h?h[1]:"",i=b?b[1]:"",c=isFinite(parseInt(i)),u=isFinite(parseInt(s));c&&f.push(`width="${i}"`),u&&f.push(`height="${s}"`)}return{href:g,dimensions:f}}e.parseHrefAndDimensions=d}),define(Se[111],ye([1,0,17,32,9,12,24,8]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(c,u){const{os:r,tildify:o,relative:n}=u;if(n){const k=C(c,n,r);if(typeof k=="string")return k}let l=c.fsPath;if(r===1&&!A.isWindows?l=l.replace(/\//g,"\\"):r!==1&&A.isWindows&&(l=l.replace(/\\/g,"/")),r!==1&&o?.userHome){const k=o.userHome.fsPath;let L;c.scheme!==o.userHome.scheme&&c.path.startsWith(I.posix.sep)?L=o.userHome.with({path:c.path}).fsPath:L=c.fsPath,l=E(L,k,r)}return(r===1?I.win32:I.posix).normalize(R(l,r===1))}e.getPathLabel=S;function C(c,u,r){const o=r===1?I.win32:I.posix,n=r===3?D.extUri:D.extUriIgnorePathCase,l=u.getWorkspace(),p=(0,a.firstOrDefault)(l.folders);if(!p)return;c.scheme!==p.uri.scheme&&c.path.startsWith(I.posix.sep)&&(c=p.uri.with({path:c.path}));const k=u.getWorkspaceFolder(c);if(!k)return;let L;if(n.isEqual(k.uri,c)?L="":L=n.relativePath(k.uri,c)??"",L&&(L=o.normalize(L)),l.folders.length>1&&!u.noPrefix){const U=k.name?k.name:n.basenameOrAuthority(k.uri);L=L?`${U} \u2022 ${L}`:U}return L}function R(c,u=A.isWindows){return(0,t.hasDriveLetter)(c,u)?c.charAt(0).toUpperCase()+c.slice(1):c}e.normalizeDriveLetter=R;let P=Object.create(null);function E(c,u,r=A.OS){if(r===1||!c||!u)return c;let o=P.original===u?P.normalized:void 0;o||(o=u,A.isWindows&&(o=(0,t.toSlashes)(o)),o=`${(0,T.rtrim)(o,I.posix.sep)}${I.posix.sep}`,P={original:u,normalized:o});let n=c;return A.isWindows&&(n=(0,t.toSlashes)(n)),(r===3?n.startsWith(o):(0,T.startsWithIgnoreCase)(n,o))?`~/${n.substr(o.length)}`:c}e.tildify=E;function y(c,u){return c.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=y;const v="\u2026",d="\\\\",g="~";function f(c,u=I.sep){const r=new Array(c.length);let o=!1;for(let n=0;n<c.length;n++){const l=c[n];if(l===""){r[n]=`.${u}`;continue}if(!l){r[n]=l;continue}o=!0;let p="",k=l;k.indexOf(d)===0?(p=k.substr(0,k.indexOf(d)+d.length),k=k.substr(k.indexOf(d)+d.length)):k.indexOf(u)===0?(p=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length)):k.indexOf(g)===0&&(p=k.substr(0,k.indexOf(g)+g.length),k=k.substr(k.indexOf(g)+g.length));const L=k.split(u);for(let U=1;o&&U<=L.length;U++)for(let K=L.length-U;o&&K>=0;K--){o=!1;let G=L.slice(K,K+U).join(u);for(let O=0;!o&&O<c.length;O++)if(O!==n&&c[O]&&c[O].indexOf(G)>-1){const B=K+U===L.length,F=K>0&&c[O].indexOf(u)>-1?u+G:G,$=c[O].endsWith(F);o=!B||$}if(!o){let O="";(L[0].endsWith(":")||p!=="")&&(K===1&&(K=0,U++,G=L[0]+u+G),K>0&&(O=L[0]+u),O=p+O),K>0&&(O=O+v+u),O=O+G,K+U<L.length&&(O=O+u+v),r[n]=O}}o&&(r[n]=l)}return r}e.shorten=f;var w;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function m(c,u=Object.create(null)){const r=[];let o=!1,n="";for(const l of c)if(l==="$"||o&&l==="{")n&&r.push({value:n,type:w.TEXT}),n="",o=!0;else if(l==="}"&&o){const p=u[n];if(typeof p=="string")p.length&&r.push({value:p,type:w.VARIABLE});else if(p){const k=r[r.length-1];(!k||k.type!==w.SEPARATOR)&&r.push({value:p.label,type:w.SEPARATOR})}n="",o=!1}else n+=l;return n&&!o&&r.push({value:n,type:w.TEXT}),r.filter((l,p)=>{if(l.type===w.SEPARATOR){const k=r[p-1],L=r[p+1];return[k,L].every(U=>U&&(U.type===w.VARIABLE||U.type===w.TEXT)&&U.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=m;function h(c,u){return A.isMacintosh||u?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):c.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function b(c,u){return A.isMacintosh||u?c.replace(/\(&&\w\)|&&/g,""):A.isWindows?c.replace(/&&|&/g,r=>r==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function s(c){return c.replace(/&/g,"&&")}e.unmnemonicLabel=s;function i(c){const u=c.indexOf("/")!==-1?I.posix:I.win32,r=u.basename(c),o=u.dirname(c);return r.length?{name:r,parentPath:o}:{name:o,parentPath:""}}e.splitName=i}),define(Se[112],ye([1,0,2]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class I{constructor(P){this.a=P}transformIncoming(P){const E=this.a.transformIncoming(P);return E===P?P:t(a.URI.from(E))}transformOutgoing(P){const E=this.a.transformOutgoing(P);return E===P?P:t(a.URI.from(E))}transformOutgoingURI(P){const E=this.a.transformOutgoing(P);return E===P?P:a.URI.from(E)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function A(R,P,E){if(!R||E>200)return null;if(typeof R=="object"){if(R instanceof a.URI)return P.transformOutgoing(R);for(const y in R)if(Object.hasOwnProperty.call(R,y)){const v=A(R[y],P,E+1);v!==null&&(R[y]=v)}}return null}function D(R,P){const E=A(R,P,0);return E===null?R:E}e.transformOutgoingURIs=D;function T(R,P,E,y){if(!R||y>200)return null;if(typeof R=="object"){if(R.$mid===1)return E?a.URI.revive(P.transformIncoming(R)):P.transformIncoming(R);for(const v in R)if(Object.hasOwnProperty.call(R,v)){const d=T(R[v],P,E,y+1);d!==null&&(R[v]=d)}}return null}function S(R,P){const E=T(R,P,!1,0);return E===null?R:E}e.transformIncomingURIs=S;function C(R,P){const E=T(R,P,!0,0);return E===null?R:E}e.transformAndReviveIncomingURIs=C}),define(Se[29],ye([1,0,65,85,309,18,32,81,9,12,24,2]),function(te,e,a,t,I,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function y(F,$=E.UNLINK){if((0,D.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return $===E.UNLINK?d(F):v(F)}async function v(F){try{const $=(0,D.randomPath)((0,t.tmpdir)());try{await a.promises.rename(F,$)}catch(M){return M.code==="ENOENT"?void 0:d(F)}d($).catch(M=>{})}catch($){if($.code!=="ENOENT")throw $}}async function d(F){return(0,I.promisify)(a.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function g(F){if((0,D.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function f(F,$){return h(await($?w(F):(0,I.promisify)(a.readdir)(F)))}async function w(F){try{return await(0,I.promisify)(a.readdir)(F,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const $=[],M=await f(F);for(const V of M){let q=!1,H=!1,J=!1;try{const Y=await e.Promises.lstat((0,S.join)(F,V));q=Y.isFile(),H=Y.isDirectory(),J=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}$.push({name:V,isFile:()=>q,isDirectory:()=>H,isSymbolicLink:()=>J})}return $}function m(F){return h(a.readdirSync(F))}e.readdirSync=m;function h(F){return F.map($=>typeof $=="string"?C.isMacintosh?(0,T.normalizeNFC)($):$:($.name=C.isMacintosh?(0,T.normalizeNFC)($.name):$.name,$))}async function b(F){const $=await f(F),M=[];for(const V of $)await i.existsDirectory((0,S.join)(F,V))&&M.push(V);return M}function s(F,$=1e3){return new Promise(M=>{let V=!1;const q=setInterval(()=>{V||(V=!0,a.access(F,H=>{V=!1,H&&(clearInterval(q),M(void 0))}))},$)})}e.whenDeleted=s;var i;(function(F){async function $(q){let H;try{if(H=await e.Promises.lstat(q),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(C.isWindows&&J.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw Y}throw J}}F.stat=$;async function M(q){try{const{stat:H,symbolicLink:J}=await F.stat(q);return H.isFile()&&J?.dangling!==!0}catch{}return!1}F.existsFile=M;async function V(q){try{const{stat:H,symbolicLink:J}=await F.stat(q);return H.isDirectory()&&J?.dangling!==!0}catch{}return!1}F.existsDirectory=V})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const c=new A.ResourceQueue;function u(F,$,M){return c.queueFor(P.URI.file(F),R.extUriBiasedIgnorePathCase).queue(()=>{const V=p(M);return new Promise((q,H)=>n(F,$,V,J=>J?H(J):q()))})}let r=!0;function o(F){r=F}e.configureFlushOnWrite=o;function n(F,$,M,V){if(!r)return a.writeFile(F,$,{mode:M.mode,flag:M.flag},V);a.open(F,M.flag,M.mode,(q,H)=>{if(q)return V(q);a.writeFile(H,$,J=>{if(J)return a.close(H,()=>V(J));a.fdatasync(H,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),o(!1)),a.close(H,ae=>V(ae))))})})}function l(F,$,M){const V=p(M);if(!r)return a.writeFileSync(F,$,{mode:V.mode,flag:V.flag});const q=a.openSync(F,V.flag,V.mode);try{a.writeFileSync(q,$);try{a.fdatasyncSync(q)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),o(!1)}}finally{a.closeSync(q)}}e.writeFileSync=l;function p(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function k(F,$){if(F!==$)try{await e.Promises.rename(F,$)}catch(M){if(F.toLowerCase()!==$.toLowerCase()&&M.code==="EXDEV"||F.endsWith("."))await L(F,$,{preserveSymlinks:!1}),await y(F,E.MOVE);else throw M}}async function L(F,$,M){return K(F,$,{root:{source:F,target:$},options:M,handledSourcePaths:new Set})}const U=511;async function K(F,$,M){if(M.handledSourcePaths.has(F))return;M.handledSourcePaths.add(F);const{stat:V,symbolicLink:q}=await i.stat(F);if(q){if(M.options.preserveSymlinks)try{return await B(F,$,M)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(q.dangling)return}return V.isDirectory()?G(F,$,V.mode&U,M):O(F,$,V.mode&U)}async function G(F,$,M,V){await e.Promises.mkdir($,{recursive:!0,mode:M});const q=await f(F);for(const H of q)await K((0,S.join)(F,H),(0,S.join)($,H),V)}async function O(F,$,M){await e.Promises.copyFile(F,$),await e.Promises.chmod($,M)}async function B(F,$,M){let V=await e.Promises.readlink(F);(0,D.isEqualOrParent)(V,M.root.source,!C.isLinux)&&(V=(0,S.join)(M.root.target,V.substr(M.root.source.length+1))),await e.Promises.symlink(V,$)}e.Promises=new class{get access(){return(0,I.promisify)(a.access)}get stat(){return(0,I.promisify)(a.stat)}get lstat(){return(0,I.promisify)(a.lstat)}get utimes(){return(0,I.promisify)(a.utimes)}get read(){return(F,$,M,V,q)=>new Promise((H,J)=>{a.read(F,$,M,V,q,(Y,ae,re)=>Y?J(Y):H({bytesRead:ae,buffer:re}))})}get readFile(){return(0,I.promisify)(a.readFile)}get write(){return(F,$,M,V,q)=>new Promise((H,J)=>{a.write(F,$,M,V,q,(Y,ae,re)=>Y?J(Y):H({bytesWritten:ae,buffer:re}))})}get appendFile(){return(0,I.promisify)(a.appendFile)}get fdatasync(){return(0,I.promisify)(a.fdatasync)}get truncate(){return(0,I.promisify)(a.truncate)}get rename(){return(0,I.promisify)(a.rename)}get copyFile(){return(0,I.promisify)(a.copyFile)}get open(){return(0,I.promisify)(a.open)}get close(){return(0,I.promisify)(a.close)}get symlink(){return(0,I.promisify)(a.symlink)}get readlink(){return(0,I.promisify)(a.readlink)}get chmod(){return(0,I.promisify)(a.chmod)}get mkdir(){return(0,I.promisify)(a.mkdir)}get unlink(){return(0,I.promisify)(a.unlink)}get rmdir(){return(0,I.promisify)(a.rmdir)}get realpath(){return(0,I.promisify)(a.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return b}get writeFile(){return u}get rm(){return y}get move(){return k}get copy(){return L}}}),define(Se[113],ye([1,0,65,9,12,8,29]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(E){if(I.isLinux)return E;const y=(0,t.dirname)(E);if(E===y)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const g=(0,D.readdirSync)(y).filter(f=>f.toLowerCase()===v);if(g.length===1){const f=T(y);if(f)return(0,t.join)(f,g[0])}else if(g.length>1){const f=g.indexOf(v);if(f>=0){const w=T(y);if(w)return(0,t.join)(w,g[f])}}}catch{}return null}e.realcaseSync=T;async function S(E){if(I.isLinux)return E;const y=(0,t.dirname)(E);if(E===y)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const g=(await D.Promises.readdir(y)).filter(f=>f.toLowerCase()===v);if(g.length===1){const f=await S(y);if(f)return(0,t.join)(f,g[0])}else if(g.length>1){const f=g.indexOf(v);if(f>=0){const w=await S(y);if(w)return(0,t.join)(w,g[f])}}}catch{}return null}e.realcase=S;async function C(E){try{return await D.Promises.realpath(E)}catch{const v=P(E);return await D.Promises.access(v,a.constants.R_OK),v}}e.realpath=C;function R(E){try{return a.realpathSync(E)}catch{const v=P(E);return a.accessSync(v,a.constants.R_OK),v}}e.realpathSync=R;function P(E){return(0,A.rtrim)((0,t.normalize)(E),t.sep)}}),define(Se[114],ye([1,0,9,12,36,106,11,29]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(P=I.env){return P.comspec||"cmd.exe"}e.getWindowsShell=S;function C(P){let E=[],y=!1;const v=function(d){if(y){E.push(d);return}(!P.send(d,f=>{if(f&&console.error(f),y=!1,E.length>0){const w=E.slice(0);E=[],w.forEach(m=>v(m))}})||t.isWindows)&&(y=!0)};return{send:v}}e.createQueuedSender=C;var R;(function(P){async function E(y,v,d){if(a.isAbsolute(y))return y;if(v===void 0&&(v=I.cwd()),a.dirname(y)!=="."||(d===void 0&&D.isString(I.env.PATH)&&(d=I.env.PATH.split(a.delimiter)),d===void 0||d.length===0))return a.join(v,y);async function f(w){if(await T.Promises.exists(w)){let m;try{m=await T.Promises.stat(w)}catch(h){h.message.startsWith("EACCES")&&(m=await T.Promises.lstat(w))}return m?!m.isDirectory():!1}return!1}for(const w of d){let m;if(a.isAbsolute(w)?m=a.join(w,y):m=a.join(v,w,y),await f(m))return m;let h=m+".com";if(await f(h)||(h=m+".exe",await f(h)))return h}return a.join(v,y)}P.findExecutable=E})(R=e.win32||(e.win32={}))});var Ve=this&&this.__decorate||function(te,e,a,t){var I=arguments.length,A=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,a,t);else for(var T=te.length-1;T>=0;T--)(D=te[T])&&(A=(I<3?D(A):I>3?D(e,a,A):D(e,a))||A);return I>3&&A&&Object.defineProperty(e,a,A),A};define(Se[115],ye([1,0,17,18,22,21,60,10,4,6,84,8,11]),function(te,e,a,t,I,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y||(y={}));function v(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(d||(d={}));function g(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(f||(f={}));class w{constructor(H){this.b=H,this.a=0}read(H){const J=this.b.slice(this.a,this.a+H);return this.a+=J.byteLength,J}}class m{constructor(){this.a=[]}get buffer(){return I.VSBuffer.concat(this.a)}write(H){this.a.push(H)}}var h;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(h||(h={}));function b(q){const H=I.VSBuffer.alloc(4);return H.writeUInt32BE(q,0),H}function s(q){return q.read(4).readUInt32BE(0)}function i(q){const H=I.VSBuffer.alloc(1);return H.writeUInt8(q,0),H}const c={Undefined:i(h.Undefined),String:i(h.String),Buffer:i(h.Buffer),VSBuffer:i(h.VSBuffer),Array:i(h.Array),Object:i(h.Object)},u=typeof Buffer<"u";function r(q,H){if(typeof H>"u")q.write(c.Undefined);else if(typeof H=="string"){const J=I.VSBuffer.fromString(H);q.write(c.String),q.write(b(J.byteLength)),q.write(J)}else if(u&&Buffer.isBuffer(H)){const J=I.VSBuffer.wrap(H);q.write(c.Buffer),q.write(b(J.byteLength)),q.write(J)}else if(H instanceof I.VSBuffer)q.write(c.VSBuffer),q.write(b(H.byteLength)),q.write(H);else if(Array.isArray(H)){q.write(c.Array),q.write(b(H.length));for(const J of H)r(q,J)}else{const J=I.VSBuffer.fromString(JSON.stringify(H));q.write(c.Object),q.write(b(J.byteLength)),q.write(J)}}function o(q){switch(q.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return q.read(s(q)).toString();case h.Buffer:return q.read(s(q)).buffer;case h.VSBuffer:return q.read(s(q));case h.Array:{const J=s(q),Y=[];for(let ae=0;ae<J;ae++)Y.push(o(q));return Y}case h.Object:return JSON.parse(q.read(s(q)).toString())}}class n{constructor(H,J,Y=null,ae=1e3){this.h=H,this.j=J,this.k=Y,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.p(re)),this.m({type:200})}registerChannel(H,J){this.b.set(H,J),setTimeout(()=>this.v(H),0)}m(H){switch(H.type){case 200:{const J=this.n([H.type]);this.k?.logOutgoing(J,0,1,g(H.type));return}case 201:case 202:case 204:case 203:{const J=this.n([H.type,H.id],H.data);this.k?.logOutgoing(J,H.id,1,g(H.type),H.data);return}}}n(H,J=void 0){const Y=new m;return r(Y,H),r(Y,J),this.o(Y.buffer)}o(H){try{return this.h.send(H),H.byteLength}catch{return 0}}p(H){const J=new w(H),Y=o(J),ae=o(J),re=Y[0];switch(re){case 100:return this.k?.logIncoming(H.byteLength,Y[1],1,`${v(re)}: ${Y[2]}.${Y[3]}`,ae),this.q({type:re,id:Y[1],channelName:Y[2],name:Y[3],arg:ae});case 102:return this.k?.logIncoming(H.byteLength,Y[1],1,`${v(re)}: ${Y[2]}.${Y[3]}`,ae),this.s({type:re,id:Y[1],channelName:Y[2],name:Y[3],arg:ae});case 101:return this.k?.logIncoming(H.byteLength,Y[1],1,`${v(re)}`),this.t({type:re,id:Y[1]});case 103:return this.k?.logIncoming(H.byteLength,Y[1],1,`${v(re)}`),this.t({type:re,id:Y[1]})}}q(H){const J=this.b.get(H.channelName);if(!J){this.u(H);return}const Y=new A.CancellationTokenSource;let ae;try{ae=J.call(this.j,H.name,H.arg,Y.token)}catch(Z){ae=Promise.reject(Z)}const re=H.id;ae.then(Z=>{this.m({id:re,data:Z,type:201}),this.d.delete(H.id)},Z=>{Z instanceof Error?this.m({id:re,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.m({id:re,data:Z,type:203}),this.d.delete(H.id)});const fe=(0,C.toDisposable)(()=>Y.cancel());this.d.set(H.id,fe)}s(H){const J=this.b.get(H.channelName);if(!J){this.u(H);return}const Y=H.id,re=J.listen(this.j,H.name,H.arg)(fe=>this.m({id:Y,data:fe,type:204}));this.d.set(H.id,re)}t(H){const J=this.d.get(H.id);J&&(J.dispose(),this.d.delete(H.id))}u(H){let J=this.g.get(H.channelName);J||(J=[],this.g.set(H.channelName,J));const Y=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:H,timeoutTimer:Y})}v(H){const J=this.g.get(H);if(J){for(const Y of J)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.q(Y.request);break;case 102:this.s(Y.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,C.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=n;var l;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(H,J=null){this.l=H,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.r(Y)),this.j=J}getChannel(H){const J=this;return{call(Y,ae,re){return J.a?Promise.reject(new T.CancellationError):J.m(H,Y,ae,re)},listen(Y,ae){return J.a?S.Event.None:J.n(H,Y,ae)}}}m(H,J,Y,ae=A.CancellationToken.None){const re=this.g++,Z={id:re,type:100,channelName:H,name:J,arg:Y};if(ae.isCancellationRequested)return Promise.reject(new T.CancellationError);let pe;return new Promise((De,Re)=>{if(ae.isCancellationRequested)return Re(new T.CancellationError);const Be=()=>{const ee=oe=>{switch(oe.type){case 201:this.f.delete(re),De(oe.data);break;case 202:{this.f.delete(re);const ie=new Error(oe.data.message);ie.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,ie.name=oe.data.name,Re(ie);break}case 203:this.f.delete(re),Re(oe.data);break}};this.f.set(re,ee),this.o(Z)};let se=null;this.b===f.Idle?Be():(se=(0,t.createCancelablePromise)(ee=>this.t()),se.then(()=>{se=null,Be()}));const ue=()=>{se?(se.cancel(),se=null):this.o({id:re,type:101}),Re(new T.CancellationError)},de=ae.onCancellationRequested(ue);pe=(0,C.combinedDisposable)((0,C.toDisposable)(ue),de),this.d.add(pe)}).finally(()=>{this.d.delete(pe)})}n(H,J,Y){const ae=this.g++,fe={id:ae,type:102,channelName:H,name:J,arg:Y};let Z=null;const pe=new S.Emitter({onWillAddFirstListener:()=>{Z=(0,t.createCancelablePromise)(De=>this.t()),Z.then(()=>{Z=null,this.d.add(pe),this.o(fe)})},onDidRemoveLastListener:()=>{Z?(Z.cancel(),Z=null):(this.d.delete(pe),this.o({id:ae,type:103}))}}),we=De=>pe.fire(De.data);return this.f.set(ae,we),pe.event}o(H){switch(H.type){case 100:case 102:{const J=this.p([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(J,H.id,0,`${v(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const J=this.p([H.type,H.id]);this.j?.logOutgoing(J,H.id,0,v(H.type));return}}}p(H,J=void 0){const Y=new m;return r(Y,H),r(Y,J),this.q(Y.buffer)}q(H){try{return this.l.send(H),H.byteLength}catch{return 0}}r(H){const J=new w(H),Y=o(J),ae=o(J),re=Y[0];switch(re){case 200:return this.j?.logIncoming(H.byteLength,0,0,g(re)),this.s({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(H.byteLength,Y[1],0,g(re),ae),this.s({type:Y[0],id:Y[1],data:ae})}}s(H){if(H.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}t(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,C.dispose)(this.d.values()),this.d.clear()}}Ve([D.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class k{get connections(){const H=[];return this.f.forEach(J=>H.push(J)),H}constructor(H){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,H(({protocol:J,onDidClientDisconnect:Y})=>{S.Event.once(J.onMessage)(re=>{const fe=new w(re),Z=o(fe),pe=new n(J,Z),we=new p(J);this.a.forEach((Re,Be)=>pe.registerChannel(Be,Re));const De={channelServer:pe,channelClient:we,ctx:Z};this.f.add(De),this.g.fire(De),Y(()=>{pe.dispose(),we.dispose(),this.f.delete(De),this.h.fire(De)})})})}getChannel(H,J){const Y=this;return{call(ae,re,fe){let Z;if((0,E.isFunction)(J)){const we=(0,a.getRandomElement)(Y.connections.filter(J));Z=we?Promise.resolve(we):S.Event.toPromise(S.Event.filter(Y.onDidAddConnection,J))}else Z=J.routeCall(Y,ae,re);const pe=Z.then(we=>we.channelClient.getChannel(H));return U(pe).call(ae,re,fe)},listen(ae,re){if((0,E.isFunction)(J))return Y.j(H,J,ae,re);const fe=J.routeEvent(Y,ae,re).then(Z=>Z.channelClient.getChannel(H));return U(fe).listen(ae,re)}}}j(H,J,Y,ae){const re=this;let fe=new C.DisposableStore;const Z=new S.Emitter({onWillAddFirstListener:()=>{fe=new C.DisposableStore;const pe=new S.EventMultiplexer,we=new Map,De=Be=>{const ue=Be.channelClient.getChannel(H).listen(Y,ae),de=pe.add(ue);we.set(Be,de)},Re=Be=>{const se=we.get(Be);!se||(se.dispose(),we.delete(Be))};re.connections.filter(J).forEach(De),S.Event.filter(re.onDidAddConnection,J)(De,void 0,fe),re.onDidRemoveConnection(Re,void 0,fe),pe.event(Z.fire,Z,fe),fe.add(pe)},onDidRemoveLastListener:()=>{fe.dispose()}});return Z.event}registerChannel(H,J){this.a.set(H,J),this.f.forEach(Y=>{Y.channelServer.registerChannel(H,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=k;class L{constructor(H,J,Y=null){const ae=new m;r(ae,J),H.send(ae.buffer),this.a=new p(H,Y),this.d=new n(H,J,Y)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,J){this.d.registerChannel(H,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=L;function U(q){return{call(H,J,Y){return q.then(ae=>ae.call(H,J,Y))},listen(H,J){const Y=new S.Relay;return q.then(ae=>Y.input=ae.listen(H,J)),Y.event}}}e.getDelayedChannel=U;function K(q){let H=!1;return{call(J,Y,ae){return H?q.call(J,Y,ae):(0,t.timeout)(0).then(()=>H=!0).then(()=>q.call(J,Y,ae))},listen(J,Y){if(H)return q.listen(J,Y);const ae=new S.Relay;return(0,t.timeout)(0).then(()=>H=!0).then(()=>ae.input=q.listen(J,Y)),ae.event}}}e.getNextTickChannel=K;class G{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const J of H.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await S.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.StaticRouter=G;var O;(function(q){function H(re,fe){const Z=re,pe=fe&&fe.disableMarshalling,we=new Map;for(const De in Z)Y(De)&&we.set(De,S.Event.buffer(Z[De],!0));return new class{listen(De,Re,Be){const se=we.get(Re);if(se)return se;if(ae(Re)){const ue=Z[Re];if(typeof ue=="function")return ue.call(Z,Be)}throw new Error(`Event not found: ${Re}`)}call(De,Re,Be){const se=Z[Re];if(typeof se=="function"){if(!pe&&Array.isArray(Be))for(let ue=0;ue<Be.length;ue++)Be[ue]=(0,R.revive)(Be[ue]);return se.apply(Z,Be)}throw new Error(`Method not found: ${Re}`)}}}q.fromService=H;function J(re,fe){const Z=fe&&fe.disableMarshalling;return new Proxy({},{get(pe,we){if(typeof we=="string")return fe?.properties?.has(we)?fe.properties.get(we):ae(we)?function(De){return re.listen(we,De)}:Y(we)?re.listen(we):async function(...De){let Re;fe&&!(0,E.isUndefinedOrNull)(fe.context)?Re=[fe.context,...De]:Re=De;const Be=await re.call(we,Re);return Z?Be:(0,R.revive)(Be)};throw new Error(`Property not found: ${String(we)}`)}})}q.toService=J;function Y(re){return re[0]==="o"&&re[1]==="n"&&P.isUpperAsciiLetter(re.charCodeAt(2))}function ae(re){return/^onDynamic/.test(re)&&P.isUpperAsciiLetter(re.charCodeAt(9))}})(O=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const H=q.toString();if(H!=="[object Object]")return H}return q}function $(q){return Array.isArray(q)?q.map(F):F(q)}function M(q,H,J,Y,ae,re,fe){fe=$(fe);const Z=B[ae],pe=Z[Y%Z.length];let we=[`%c[${q}]%c[${String(H).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(re)?(we=we.concat(fe),we.push(")")):we.push(fe),console.log.apply(console,we)}class V{constructor(H,J){this.d=H,this.f=J,this.a=0,this.b=0}logOutgoing(H,J,Y,ae,re){this.b+=H,M(this.d,this.b,H,J,Y,ae,re)}logIncoming(H,J,Y,ae,re){this.a+=H,M(this.f,this.a,H,J,Y,ae,re)}}e.IPCLogger=V}),define(Se[116],ye([1,0,22,4,6,115]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var T;(function(u){u.enableDiagnostics=!1,u.records=[];const r=new WeakMap;let o=0;function n(p,k){if(!r.has(p)){const L=String(++o);r.set(p,L)}return r.get(p)}function l(p,k,L,U){if(!u.enableDiagnostics)return;const K=n(p,k);if(U instanceof a.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const G=a.VSBuffer.alloc(U.byteLength);G.set(U),u.records.push({timestamp:Date.now(),id:K,label:k,type:L,buff:G})}else u.records.push({timestamp:Date.now(),id:K,label:k,type:L,data:U})}u.traceSocketEvent=l})(T=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function R(){return C||(C=a.VSBuffer.alloc(0)),C}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,o){if(r===0)return R();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const k=this.a[0];return o&&(this.a.shift(),this.b-=r),k}if(this.a[0].byteLength>r){const k=this.a[0].slice(0,r);return o&&(this.a[0]=this.a[0].slice(r),this.b-=r),k}const n=a.VSBuffer.alloc(r);let l=0,p=0;for(;r>0;){const k=this.a[p];if(k.byteLength>r){const L=k.slice(0,r);n.set(L,l),l+=r,o&&(this.a[p]=k.slice(r),this.b-=r),r-=r}else n.set(k,l),l+=k.byteLength,o?(this.a.shift(),this.b-=k.byteLength):p++,r-=k.byteLength}return n}}e.ChunkStream=P;var E;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(E||(E={}));function y(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,o,n,l){this.type=r,this.id=o,this.ack=n,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends I.Disposable{constructor(r){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new P,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const n=this.g.messageType,l=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new d(n,l,p,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=a.VSBuffer.alloc(13);o.writeUInt8(r.type,0),o.writeUInt32BE(r.id,1),o.writeUInt32BE(r.ack,5),o.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(o,r.data)}g(r,o){const n=this.f===0;return this.d.push(r,o),this.f+=r.byteLength+o.byteLength,n}h(){const r=a.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,o){this.g(r,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class w extends I.Disposable{constructor(r){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new f(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new d(1,0,0,r))}}e.Protocol=w;class m extends A.IPCClient{static fromSocket(r,o){return new m(new w(r),o)}get onDidDispose(){return this.b.onDidDispose}constructor(r,o,n=null){super(r,o,n),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.Client=m;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.BufferedEmitter=h;class b{constructor(r){this.data=r,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let r=0,o=this.a;for(;o;)o=o.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let o=0,n=this.a;for(;n;)r[o++]=n.data,n=n.next;return r}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const o=new b(r);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const r=Date.now();for(let o=0;o<i.a;o++)this.c[o]=r-1e3*o;setInterval(()=>{for(let o=i.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),o=(1+i.a)*1e3;let n=0;for(let l=0;l<i.a;l++)r-this.c[l]<=o&&n++;return 1-n/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;class c{get unacknowledgedCount(){return this.c-this.d}constructor(r,o=null,n=i.getInstance()){this.t=new h,this.onControlMessage=this.t.event,this.u=new h,this.onMessage=this.u.event,this.v=new h,this.onDidDispose=this.v.event,this.w=new h,this.onSocketClose=this.w.event,this.x=new h,this.onSocketTimeout=this.x.event,this.s=n,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=r,this.p=new f(this.o),this.r.push(this.p),this.q=new g(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(l=>this.y(l))),this.r.push(this.o.onClose(l=>this.w.fire(l))),o&&this.q.acceptChunk(o),this.l=setInterval(()=>{this.D()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,I.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const r=new d(5,0,0,R());this.p.write(r),this.p.flush()}sendPause(){const r=new d(7,0,0,R());this.p.write(r)}sendResume(){const r=new d(8,0,0,R());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,o){this.a=!0,this.r=(0,I.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=new f(this.o),this.r.push(this.p),this.q=new g(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(n=>this.y(n))),this.r.push(this.o.onClose(n=>this.w.fire(n))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new d(3,0,this.h,R());this.p.write(r);const o=this.b.toArray();for(let n=0,l=o.length;n<l;n++)this.p.write(o[n]);this.B()}acceptDisconnect(){this.v.fire()}y(r){if(r.ack>this.d){this.d=r.ack;do{const o=this.b.peek();if(o&&o.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new d(6,0,0,R())))}else this.g=r.id,this.j=Date.now(),this.A(),this.u.fire(r.data);break}case 2:{this.t.fire(r.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const o=this.b.toArray();for(let n=0,l=o.length;n<l;n++)this.p.write(o[n]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const o=++this.c;this.h=this.g;const n=new d(1,o,this.h,r);this.b.push(n),this.a||(this.p.write(n),this.B())}sendControl(r){const o=new d(2,0,0,r);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),o=Date.now()-r.writtenTime,n=Date.now()-this.q.lastReadTime,l=Date.now()-this.n;if(o>=2e4&&n>=2e4&&l>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:n});return}const p=Math.max(2e4-o,2e4-n,2e4-l,500);this.f=setTimeout(()=>{this.f=null,this.B()},p)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new d(3,0,this.h,R());this.p.write(r)}D(){const r=new d(9,0,0,R());this.p.write(r)}}e.PersistentProtocol=c}),define(Se[117],ye([1,0,22,10,4,6,9,12,30,115,116]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class E{traceSocketEvent(n,l){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,l)}constructor(n,l=""){this.f=!0,this.debugLabel=l,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,t.onUnexpectedError)(p)}},this.socket.on("error",this.a),this.b=p=>{this.traceSocketEvent("close",{hadError:p}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const l=p=>{this.traceSocketEvent("read",p),n(a.VSBuffer.wrap(p))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(n){const l=p=>{n({type:0,hadError:p,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(n){const l=()=>{n()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,t.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,t.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=E;var y;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var v;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(v||(v={}));class d extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,l){this.socket.traceSocketEvent(n,l)}constructor(n,l,p,k){super(),this.f=this.B(new I.Emitter),this.g=this.B(new I.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:p?.byteLength||0,recordInflateBytes:k}),this.a=this.B(new g(this,l,p,k,this.f,(L,U)=>this.k(L,U))),this.B(this.a.onError(L=>{console.error(L),(0,t.onUnexpectedError)(L),this.g.fire({type:0,hadError:!0,error:L})})),this.b=new R.ChunkStream,this.B(this.socket.onData(L=>this.l(L))),this.B(this.socket.onClose(L=>this.g.fire(L)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,l){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let p=2;n.byteLength<126?p+=0:n.byteLength<2**16?p+=2:p+=8;const k=a.VSBuffer.alloc(p);if(l?k.writeUInt8(194,0):k.writeUInt8(130,0),n.byteLength<126)k.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){k.writeUInt8(126,1);let L=1;k.writeUInt8(n.byteLength>>>8&255,++L),k.writeUInt8(n.byteLength>>>0&255,++L)}else{k.writeUInt8(127,1);let L=1;k.writeUInt8(0,++L),k.writeUInt8(0,++L),k.writeUInt8(0,++L),k.writeUInt8(0,++L),k.writeUInt8(n.byteLength>>>24&255,++L),k.writeUInt8(n.byteLength>>>16&255,++L),k.writeUInt8(n.byteLength>>>8&255,++L),k.writeUInt8(n.byteLength>>>0&255,++L)}this.socket.write(a.VSBuffer.concat([k,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const l=this.b.peek(this.j.readLen),p=l.readUInt8(0),k=(p&128)>>>7,L=(p&64)>>>6,U=l.readUInt8(1),K=(U&128)>>>7,G=U&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(G===126?2:0)+(G===127?8:0),this.j.fin=k,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(L)),this.j.firstFrameOfMessage=Boolean(k),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const l=this.b.read(this.j.readLen),p=l.readUInt8(1),k=(p&128)>>>7;let L=p&127,U=1;L===126?L=l.readUInt8(++U)*2**8+l.readUInt8(++U):L===127&&(L=l.readUInt8(++U)*0+l.readUInt8(++U)*0+l.readUInt8(++U)*0+l.readUInt8(++U)*0+l.readUInt8(++U)*2**24+l.readUInt8(++U)*2**16+l.readUInt8(++U)*2**8+l.readUInt8(++U));let K=0;k&&(K=l.readUInt8(++U)*2**24+l.readUInt8(++U)*2**16+l.readUInt8(++U)*2**8+l.readUInt8(++U)),this.j.state=3,this.j.readLen=L,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const l=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),m(l,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(l,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await I.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class g extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(n,l,p,k,L,U){super(),this.k=n,this.l=L,this.m=U,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new I.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,l?(this.b=this.B(new f(this.k,k,p,{windowBits:15})),this.f=this.B(new w(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const l=await this.r(this.f,n);this.m(l,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,l){return new Promise((p,k)=>{n.write(l),n.flush(L=>p(L))})}acceptFrame(n,l,p){this.h.push({data:n,isCompressed:l,isLastFrameOfMessage:p}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const l=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(l)}else this.l.fire(n.data)}this.s=!1}}u(n,l,p){return new Promise((k,L)=>{n.write(l),p&&n.write(a.VSBuffer.fromByteArray([0,0,255,255])),n.flush(U=>k(U))})}}class f extends A.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(n,l,p,k){super(),this.h=n,this.j=l,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(k),this.b.on("error",L=>{this.h.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent("zlibInflateData",L),this.g.push(a.VSBuffer.wrap(L))}),p&&(this.h.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this.b.write(p.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const l=a.VSBuffer.concat(this.g);this.g.length=0,n(l)})}}class w extends A.Disposable{constructor(n,l){super(),this.g=n,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",p=>{this.g.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this.a.fire(p)}),this.b.on("data",p=>{this.g.traceSocketEvent("zlibDeflateData",p),this.f.push(a.VSBuffer.wrap(p))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let l=a.VSBuffer.concat(this.f);this.f.length=0,l=l.slice(0,l.byteLength-4),n(l)})}}function m(o,n){if(n===0)return;const l=o.byteLength>>>2;for(let G=0;G<l;G++){const O=o.readUInt32BE(G*4);o.writeUInt32BE(O^n,G*4)}const p=l*4,k=o.byteLength-p,L=n>>>24&255,U=n>>>16&255,K=n>>>8&255;k>=1&&o.writeUInt8(o.readUInt8(p)^L,p),k>=2&&o.writeUInt8(o.readUInt8(p+1)^U,p+1),k>=3&&o.writeUInt8(o.readUInt8(p+2)^K,p+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function b(){const o=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):n=(0,D.join)(P().os.tmpdir(),`vscode-ipc-${o}.sock`),i(n),n}e.createRandomIPCHandle=b;function s(o,n,l){const p=P().crypto.createHash("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${l}-${n}-sock`;let k;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?k=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${l}-${n}.sock`):k=(0,D.join)(o,`${l}-${n}.sock`),i(k),k}e.createStaticIPCHandle=s;function i(o){const n=h[T.platform];typeof n=="number"&&o.length>=n&&console.warn(`WARNING: IPC handle "${o}" is longer than ${n} chars, try a shorter --user-data-dir`)}class c extends C.IPCServer{static b(n){const l=I.Event.fromNodeEventEmitter(n,"connection");return I.Event.map(l,p=>({protocol:new R.Protocol(new E(p,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(p,"close"))}))}constructor(n){super(c.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=c;function u(o){return new Promise((n,l)=>{const p=P().net.createServer();p.on("error",l),p.listen(o,()=>{p.removeListener("error",l),n(new c(p))})})}e.serve=u;function r(o,n){return new Promise((l,p)=>{const k=P().net.createConnection(o,()=>{k.removeListener("error",p),l(R.Client.fromSocket(new E(k,`ipc-client${n}`),n))});k.once("error",p)})}e.connect=r}),define(Se[160],ye([1,0,37,9]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(A,D,T,S,C,R){if(Array.isArray(A)){let P=0;for(const E of A){const y=I(E,D,T,S,C,R);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof A=="string")return S?A==="*"?5:A===T?10:0:0;if(A){const{language:P,pattern:E,scheme:y,hasAccessToAllModels:v,notebookType:d}=A;if(!S&&!v)return 0;d&&C&&(D=C);let g=0;if(y)if(y===D.scheme)g=10;else if(y==="*")g=5;else return 0;if(P)if(P===T)g=10;else if(P==="*")g=Math.max(g,5);else return 0;if(d)if(d===R)g=10;else if(d==="*"&&R!==void 0)g=Math.max(g,5);else return 0;if(E){let f;if(typeof E=="string"?f=E:f={...E,base:(0,t.normalize)(E.base)},f===D.fsPath||(0,a.match)(f,D.fsPath))g=10;else return 0}return g}else return 0}}e.score=I}),define(Se[161],ye([1,0,8,49,153]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(T,S,C,R){this.c=T,this.d=S,this.f=C,this.g=R,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(T){T.eol&&T.eol!==this.f&&(this.f=T.eol,this.h=null);const S=T.changes;for(const C of S)this.n(C.range),this.o(new t.Position(C.range.startLineNumber,C.range.startColumn),C.text);this.g=T.versionId,this.j=null}k(){if(!this.h){const T=this.f.length,S=this.d.length,C=new Uint32Array(S);for(let R=0;R<S;R++)C[R]=this.d[R].length+T;this.h=new I.PrefixSumComputer(C)}}l(T,S){this.d[T]=S,this.h&&this.h.setValue(T,this.d[T].length+this.f.length)}n(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.startLineNumber-1].substring(T.endColumn-1));return}this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.endLineNumber-1].substring(T.endColumn-1)),this.d.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.h&&this.h.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}o(T,S){if(S.length===0)return;const C=(0,a.splitLines)(S);if(C.length===1){this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+C[0]+this.d[T.lineNumber-1].substring(T.column-1));return}C[C.length-1]+=this.d[T.lineNumber-1].substring(T.column-1),this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+C[0]);const R=new Uint32Array(C.length-1);for(let P=1;P<C.length;P++)this.d.splice(T.lineNumber+P-1,0,C[P]),R[P-1]=C[P].length+this.f.length;this.h&&this.h.insertValues(T.lineNumber,R)}}e.MirrorTextModel=A}),define(Se[162],ye([1,0,8,150,49,35,105]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(w,m,h,b){this.searchString=w,this.isRegex=m,this.matchCase=h,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=C(this.searchString):w=this.searchString.indexOf(`
`)>=0;let m=null;try{m=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!m)return null;let h=!this.isRegex&&!w;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new D.SearchData(m,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,h?this.searchString:null)}}e.SearchParams=S;function C(f){if(!f||f.length===0)return!1;for(let w=0,m=f.length;w<m;w++){const h=f.charCodeAt(w);if(h===10)return!0;if(h===92){if(w++,w>=m)break;const b=f.charCodeAt(w);if(b===110||b===114||b===87)return!0}}return!1}e.isMultilineRegexSource=C;function R(f,w,m){if(!m)return new D.FindMatch(f,null);const h=[];for(let b=0,s=w.length;b<s;b++)h[b]=w[b];return new D.FindMatch(f,h)}e.createFindMatch=R;class P{constructor(w){const m=[];let h=0;for(let b=0,s=w.length;b<s;b++)w.charCodeAt(b)===10&&(m[h++]=b);this.a=m}findLineFeedCountBeforeOffset(w){const m=this.a;let h=0,b=m.length-1;if(b===-1||w<=m[0])return 0;for(;h<b;){const s=h+((b-h)/2>>0);m[s]>=w?b=s-1:m[s+1]>=w?(h=s,b=s):h=s+1}return h+1}}class E{static findMatches(w,m,h,b,s){const i=m.parseSearchRequest();return i?i.regex.multiline?this.b(w,h,new g(i.wordSeparators,i.regex),b,s):this.c(w,h,i,b,s):[]}static a(w,m,h,b,s,i){let c,u=0;b?(u=b.findLineFeedCountBeforeOffset(s),c=m+s+u):c=m+s;let r;if(b){const p=b.findLineFeedCountBeforeOffset(s+i.length)-u;r=c+i.length+p}else r=c+i.length;const o=w.getPositionAt(c),n=w.getPositionAt(r);return new A.Range(o.lineNumber,o.column,n.lineNumber,n.column)}static b(w,m,h,b,s){const i=w.getOffsetAt(m.getStartPosition()),c=w.getValueInRange(m,1),u=w.getEOL()===`\r
`?new P(c):null,r=[];let o=0,n;for(h.reset(0);n=h.next(c);)if(r[o++]=R(this.a(w,i,c,u,n.index,n[0]),n,b),o>=s)return r;return r}static c(w,m,h,b,s){const i=[];let c=0;if(m.startLineNumber===m.endLineNumber){const r=w.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return c=this.d(h,r,m.startLineNumber,m.startColumn-1,c,i,b,s),i}const u=w.getLineContent(m.startLineNumber).substring(m.startColumn-1);c=this.d(h,u,m.startLineNumber,m.startColumn-1,c,i,b,s);for(let r=m.startLineNumber+1;r<m.endLineNumber&&c<s;r++)c=this.d(h,w.getLineContent(r),r,0,c,i,b,s);if(c<s){const r=w.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);c=this.d(h,r,m.endLineNumber,0,c,i,b,s)}return i}static d(w,m,h,b,s,i,c,u){const r=w.wordSeparators;if(!c&&w.simpleSearch){const l=w.simpleSearch,p=l.length,k=m.length;let L=-p;for(;(L=m.indexOf(l,L+p))!==-1;)if((!r||d(r,m,k,L,p))&&(i[s++]=new D.FindMatch(new A.Range(h,L+1+b,h,L+1+p+b),null),s>=u))return s;return s}const o=new g(w.wordSeparators,w.regex);let n;o.reset(0);do if(n=o.next(m),n&&(i[s++]=R(new A.Range(h,n.index+1+b,h,n.index+1+n[0].length+b),n,c),s>=u))return s;while(n);return s}static findNextMatch(w,m,h,b){const s=m.parseSearchRequest();if(!s)return null;const i=new g(s.wordSeparators,s.regex);return s.regex.multiline?this.e(w,h,i,b):this.f(w,h,i,b)}static e(w,m,h,b){const s=new I.Position(m.lineNumber,1),i=w.getOffsetAt(s),c=w.getLineCount(),u=w.getValueInRange(new A.Range(s.lineNumber,s.column,c,w.getLineMaxColumn(c)),1),r=w.getEOL()===`\r
`?new P(u):null;h.reset(m.column-1);const o=h.next(u);return o?R(this.a(w,i,u,r,o.index,o[0]),o,b):m.lineNumber!==1||m.column!==1?this.e(w,new I.Position(1,1),h,b):null}static f(w,m,h,b){const s=w.getLineCount(),i=m.lineNumber,c=w.getLineContent(i),u=this.g(h,c,i,m.column,b);if(u)return u;for(let r=1;r<=s;r++){const o=(i+r-1)%s,n=w.getLineContent(o+1),l=this.g(h,n,o+1,1,b);if(l)return l}return null}static g(w,m,h,b,s){w.reset(b-1);const i=w.next(m);return i?R(new A.Range(h,i.index+1,h,i.index+1+i[0].length),i,s):null}static findPreviousMatch(w,m,h,b){const s=m.parseSearchRequest();if(!s)return null;const i=new g(s.wordSeparators,s.regex);return s.regex.multiline?this.h(w,h,i,b):this.j(w,h,i,b)}static h(w,m,h,b){const s=this.b(w,new A.Range(1,1,m.lineNumber,m.column),h,b,10*T);if(s.length>0)return s[s.length-1];const i=w.getLineCount();return m.lineNumber!==i||m.column!==w.getLineMaxColumn(i)?this.h(w,new I.Position(i,w.getLineMaxColumn(i)),h,b):null}static j(w,m,h,b){const s=w.getLineCount(),i=m.lineNumber,c=w.getLineContent(i).substring(0,m.column-1),u=this.k(h,c,i,b);if(u)return u;for(let r=1;r<=s;r++){const o=(s+i-r-1)%s,n=w.getLineContent(o+1),l=this.k(h,n,o+1,b);if(l)return l}return null}static k(w,m,h,b){let s=null,i;for(w.reset(0);i=w.next(m);)s=R(new A.Range(h,i.index+1,h,i.index+1+i[0].length),i,b);return s}}e.TextModelSearch=E;function y(f,w,m,h,b){if(h===0)return!0;const s=w.charCodeAt(h-1);if(f.get(s)!==0||s===13||s===10)return!0;if(b>0){const i=w.charCodeAt(h);if(f.get(i)!==0)return!0}return!1}function v(f,w,m,h,b){if(h+b===m)return!0;const s=w.charCodeAt(h+b);if(f.get(s)!==0||s===13||s===10)return!0;if(b>0){const i=w.charCodeAt(h+b-1);if(f.get(i)!==0)return!0}return!1}function d(f,w,m,h,b){return y(f,w,m,h,b)&&v(f,w,m,h,b)}e.isValidMatch=d;class g{constructor(w,m){this._wordSeparators=w,this.a=m,this.b=-1,this.c=0}reset(w){this.a.lastIndex=w,this.b=-1,this.c=0}next(w){const m=w.length;let h;do{if(this.b+this.c===m||(h=this.a.exec(w),!h))return null;const b=h.index,s=h[0].length;if(b===this.b&&s===this.c){if(s===0){a.getNextCodePoint(w,m,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=b,this.c=s,!this._wordSeparators||d(this._wordSeparators,w,m,b,s))return h}while(h);return null}}e.Searcher=g}),define(Se[118],ye([1,0,22,12]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(I||(I={}));function A(P){for(let E=0,y=P.length;E<y;E+=4){const v=P[E+0],d=P[E+1],g=P[E+2],f=P[E+3];P[E+0]=f,P[E+1]=g,P[E+2]=d,P[E+3]=v}}function D(P){const E=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||A(E),a.VSBuffer.wrap(E)}function T(P){const E=P.buffer;if(t.isLittleEndian()||A(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const y=new Uint8Array(E.byteLength);return y.set(E),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function S(P){const E=new Uint32Array(C(P));let y=0;if(E[y++]=P.id,P.type==="full")E[y++]=1,E[y++]=P.data.length,E.set(P.data,y),y+=P.data.length;else{E[y++]=2,E[y++]=P.deltas.length;for(const v of P.deltas)E[y++]=v.start,E[y++]=v.deleteCount,v.data?(E[y++]=v.data.length,E.set(v.data,y),y+=v.data.length):E[y++]=0}return D(E)}e.encodeSemanticTokensDto=S;function C(P){let E=0;if(E+=1+1,P.type==="full")E+=1+P.data.length;else{E+=1,E+=(1+1+1)*P.deltas.length;for(const y of P.deltas)y.data&&(E+=y.data.length)}return E}function R(P){const E=T(P);let y=0;const v=E[y++];if(E[y++]===1){const w=E[y++],m=E.subarray(y,y+w);return y+=w,{id:v,type:"full",data:m}}const g=E[y++],f=[];for(let w=0;w<g;w++){const m=E[y++],h=E[y++],b=E[y++];let s;b>0&&(s=E.subarray(y,y+b),y+=b),f[w]={start:m,deleteCount:h,data:s}}return{id:v,type:"delta",deltas:f}}e.decodeSemanticTokensDto=R}),define(Se[163],ye([1,0,4,6]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this.a.set(T,S),this.fire([T]),(0,t.toDisposable)(()=>{this.a.get(T)===S&&(this.a.delete(T),this.fire([T]))})}registerFactory(T,S){this.b.get(T)?.dispose();const C=new A(this,T,S);return this.b.set(T,C),(0,t.toDisposable)(()=>{const R=this.b.get(T);!R||R!==C||(this.b.delete(T),R.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const C=this.b.get(T);return!C||C.isResolved?null:(await C.resolve(),this.get(T))}get(T){return this.a.get(T)||null}isResolved(T){if(this.get(T))return!0;const C=this.b.get(T);return!!(!C||C.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=I;class A extends t.Disposable{get isResolved(){return this.c}constructor(T,S,C){super(),this.f=T,this.g=S,this.h=C,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,T&&!this.a&&this.B(this.f.register(this.g,T))}}}),define(Se[66],ye([1,0,78,2,35,163]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class D{constructor(p,k,L){this._tokenBrand=void 0,this.offset=p,this.type=k,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class T{constructor(p,k){this._tokenizationResultBrand=void 0,this.tokens=p,this.endState=k}}e.TokenizationResult=T;class S{constructor(p,k){this._encodedTokenizationResultBrand=void 0,this.tokens=p,this.endState=k}}e.EncodedTokenizationResult=S;var C;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(C=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(l){const p=new Map;p.set(0,a.Codicon.symbolMethod),p.set(1,a.Codicon.symbolFunction),p.set(2,a.Codicon.symbolConstructor),p.set(3,a.Codicon.symbolField),p.set(4,a.Codicon.symbolVariable),p.set(5,a.Codicon.symbolClass),p.set(6,a.Codicon.symbolStruct),p.set(7,a.Codicon.symbolInterface),p.set(8,a.Codicon.symbolModule),p.set(9,a.Codicon.symbolProperty),p.set(10,a.Codicon.symbolEvent),p.set(11,a.Codicon.symbolOperator),p.set(12,a.Codicon.symbolUnit),p.set(13,a.Codicon.symbolValue),p.set(15,a.Codicon.symbolEnum),p.set(14,a.Codicon.symbolConstant),p.set(15,a.Codicon.symbolEnum),p.set(16,a.Codicon.symbolEnumMember),p.set(17,a.Codicon.symbolKeyword),p.set(27,a.Codicon.symbolSnippet),p.set(18,a.Codicon.symbolText),p.set(19,a.Codicon.symbolColor),p.set(20,a.Codicon.symbolFile),p.set(21,a.Codicon.symbolReference),p.set(22,a.Codicon.symbolCustomColor),p.set(23,a.Codicon.symbolFolder),p.set(24,a.Codicon.symbolTypeParameter),p.set(25,a.Codicon.account),p.set(26,a.Codicon.issues);function k(K){let G=p.get(K);return G||(console.info("No codicon found for CompletionItemKind "+K),G=a.Codicon.symbolProperty),G}l.toIcon=k;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function U(K,G){let O=L.get(K);return typeof O>"u"&&!G&&(O=9),O}l.fromString=U})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(l){l[l.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var y;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function w(l){return l&&t.URI.isUri(l.uri)&&I.Range.isIRange(l.range)&&(I.Range.isIRange(l.originSelectionRange)||I.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=w;var m;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(m=e.SymbolKind||(e.SymbolKind={}));var h;(function(l){l[l.Deprecated=1]="Deprecated"})(h=e.SymbolTag||(e.SymbolTag={}));var b;(function(l){const p=new Map;p.set(0,a.Codicon.symbolFile),p.set(1,a.Codicon.symbolModule),p.set(2,a.Codicon.symbolNamespace),p.set(3,a.Codicon.symbolPackage),p.set(4,a.Codicon.symbolClass),p.set(5,a.Codicon.symbolMethod),p.set(6,a.Codicon.symbolProperty),p.set(7,a.Codicon.symbolField),p.set(8,a.Codicon.symbolConstructor),p.set(9,a.Codicon.symbolEnum),p.set(10,a.Codicon.symbolInterface),p.set(11,a.Codicon.symbolFunction),p.set(12,a.Codicon.symbolVariable),p.set(13,a.Codicon.symbolConstant),p.set(14,a.Codicon.symbolString),p.set(15,a.Codicon.symbolNumber),p.set(16,a.Codicon.symbolBoolean),p.set(17,a.Codicon.symbolArray),p.set(18,a.Codicon.symbolObject),p.set(19,a.Codicon.symbolKey),p.set(20,a.Codicon.symbolNull),p.set(21,a.Codicon.symbolEnumMember),p.set(22,a.Codicon.symbolStruct),p.set(23,a.Codicon.symbolEvent),p.set(24,a.Codicon.symbolOperator),p.set(25,a.Codicon.symbolTypeParameter);function k(L){let U=p.get(L);return U||(console.info("No codicon found for SymbolKind "+L),U=a.Codicon.symbolProperty),U}l.toIcon=k})(b=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(p){this.value=p}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var i;(function(l){function p(k){return!k||typeof k!="object"?!1:typeof k.id=="string"&&typeof k.title=="string"}l.is=p})(i=e.Command||(e.Command={}));var c;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(l){l[l.Unresolved=0]="Unresolved",l[l.Resolved=1]="Resolved"})(u=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var o;(function(l){l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(o=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var n;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Se[164],ye([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Se[119],ye([1,0,164,12,104,17,23,149]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontFamily=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(W){W[W.None=0]="None",W[W.Keep=1]="Keep",W[W.Brackets=2]="Brackets",W[W.Advanced=3]="Advanced",W[W.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=C;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class P{constructor(_,ce,Pe,Le){this.id=_,this.name=ce,this.defaultValue=Pe,this.schema=Le}applyUpdate(_,ce){return y(_,ce)}compute(_,ce,Pe){return Pe}}class E{constructor(_,ce){this.newValue=_,this.didChange=ce}}e.ApplyUpdateResult=E;function y(W,_){if(typeof W!="object"||typeof _!="object"||!W||!_)return new E(_,W!==_);if(Array.isArray(W)||Array.isArray(_)){const Pe=Array.isArray(W)&&Array.isArray(_)&&A.equals(W,_);return new E(_,!Pe)}let ce=!1;for(const Pe in _)if(_.hasOwnProperty(Pe)){const Le=y(W[Pe],_[Pe]);Le.didChange&&(W[Pe]=Le.newValue,ce=!0)}return new E(W,ce)}class v{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,ce){return y(_,ce)}validate(_){return this.defaultValue}}class d{constructor(_,ce,Pe,Le){this.id=_,this.name=ce,this.defaultValue=Pe,this.schema=Le}applyUpdate(_,ce){return y(_,ce)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,ce,Pe){return Pe}}function g(W,_){return typeof W>"u"?_:W==="false"?!1:Boolean(W)}e.boolean=g;class f extends d{constructor(_,ce,Pe,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Pe),super(_,ce,Pe,Le)}validate(_){return g(_,this.defaultValue)}}function w(W,_,ce,Pe){if(typeof W>"u")return _;let Le=parseInt(W,10);return isNaN(Le)?_:(Le=Math.max(ce,Le),Le=Math.min(Pe,Le),Le|0)}e.clampedInt=w;class m extends d{static clampedInt(_,ce,Pe,Le){return w(_,ce,Pe,Le)}constructor(_,ce,Pe,Le,Ge,Qe=void 0){typeof Qe<"u"&&(Qe.type="integer",Qe.default=Pe,Qe.minimum=Le,Qe.maximum=Ge),super(_,ce,Pe,Qe),this.minimum=Le,this.maximum=Ge}validate(_){return m.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}class h extends d{static clamp(_,ce,Pe){return _<ce?ce:_>Pe?Pe:_}static float(_,ce){if(typeof _=="number")return _;if(typeof _>"u")return ce;const Pe=parseFloat(_);return isNaN(Pe)?ce:Pe}constructor(_,ce,Pe,Le,Ge){typeof Ge<"u"&&(Ge.type="number",Ge.default=Pe),super(_,ce,Pe,Ge),this.validationFn=Le}validate(_){return this.validationFn(h.float(_,this.defaultValue))}}class b extends d{static string(_,ce){return typeof _!="string"?ce:_}constructor(_,ce,Pe,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Pe),super(_,ce,Pe,Le)}validate(_){return b.string(_,this.defaultValue)}}function s(W,_,ce){return typeof W!="string"||ce.indexOf(W)===-1?_:W}e.stringSet=s;class i extends d{constructor(_,ce,Pe,Le,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.enum=Le,Ge.default=Pe),super(_,ce,Pe,Ge),this.c=Le}validate(_){return s(_,this.defaultValue,this.c)}}class c extends P{constructor(_,ce,Pe,Le,Ge,Qe,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=Ge,ut.default=Le),super(_,ce,Pe,ut),this.c=Ge,this.d=Qe}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function u(W){switch(W){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,ce,Pe){return Pe===0?_.accessibilitySupport:Pe}}class o extends P{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:a.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{insertSpace:g(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(W){W[W.Hidden=0]="Hidden",W[W.Blink=1]="Blink",W[W.Smooth=2]="Smooth",W[W.Phase=3]="Phase",W[W.Expand=4]="Expand",W[W.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(W){switch(W){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(W){W[W.Line=1]="Line",W[W.Block=2]="Block",W[W.Underline=3]="Underline",W[W.LineThin=4]="LineThin",W[W.BlockOutline=5]="BlockOutline",W[W.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function k(W){switch(W){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function L(W){switch(W){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class U extends v{constructor(){super(133)}compute(_,ce,Pe){const Le=["monaco-editor"];return ce.get(34)&&Le.push(ce.get(34)),_.extraEditorClassName&&Le.push(_.extraEditorClassName),ce.get(68)==="default"?Le.push("mouse-default"):ce.get(68)==="copy"&&Le.push("mouse-copy"),ce.get(103)&&Le.push("showUnused"),ce.get(131)&&Le.push("showDeprecated"),Le.join(" ")}}class K extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(_,ce,Pe){return Pe&&_.emptySelectionClipboard}}class G extends P{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:a.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:a.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{cursorMoveOnType:g(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":s(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":s(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(ce.loop,this.defaultValue.loop)}}}class O extends P{constructor(){super(46,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?O.OFF:_==="true"?O.ON:_:Boolean(_)?O.ON:O.OFF}}e.EditorFontLigatures=O,O.OFF='"liga" off, "calt" off',O.ON='"liga" on, "calt" on';class B extends P{constructor(){super(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{anyOf:[{type:"string"},{type:"array",items:{type:"string"}}],description:a.localize(22,null),default:e.EDITOR_FONT_DEFAULTS.fontFamily})}validate(_){return typeof _=="string"?_:Array.isArray(_)&&_.length>0?_.map(ce=>JSON.stringify(ce)).join(","):this.defaultValue}}e.EditorFontFamily=B;class F extends P{constructor(){super(49,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:a.localize(23,null)},{type:"string",description:a.localize(24,null)}],description:a.localize(25,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?F.OFF:_==="true"?F.TRANSLATE:_:Boolean(_)?F.TRANSLATE:F.OFF}compute(_,ce,Pe){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=F,F.OFF="normal",F.TRANSLATE="translate";class $ extends v{constructor(){super(45)}compute(_,ce,Pe){return _.fontInfo}}class M extends d{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(26,null)})}validate(_){const ce=h.float(_,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ce,6,100)}compute(_,ce,Pe){return _.fontInfo.fontSize}}class V extends P{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:a.localize(27,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(28,null)})}validate(_){return _==="normal"||_==="bold"?_:String(m.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class q extends P{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[a.localize(29,null),a.localize(30,null),a.localize(31,null)]},Pe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(32,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(33,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(34,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:a.localize(35,null),...ce},"editor.gotoLocation.multipleImplementations":{description:a.localize(36,null),...ce},"editor.gotoLocation.multipleReferences":{description:a.localize(37,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Pe,description:a.localize(38,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Pe,description:a.localize(39,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Pe,description:a.localize(40,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Pe,description:a.localize(41,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Pe,description:a.localize(42,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{multiple:s(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??s(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??s(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??s(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??s(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??s(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends P{constructor(){const _={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:a.localize(43,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:a.localize(44,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:a.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{enabled:g(ce.enabled,this.defaultValue.enabled),delay:m.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:g(ce.sticky,this.defaultValue.sticky),above:g(ce.above,this.defaultValue.above)}}}var J;(function(W){W[W.None=0]="None",W[W.Text=1]="Text",W[W.Blocks=2]="Blocks"})(J=e.RenderMinimap||(e.RenderMinimap={}));class Y extends v{constructor(){super(136)}compute(_,ce,Pe){return Y.computeLayout(ce,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio})}static computeContainedMinimapLineCount(_){const ce=_.height/_.lineHeight,Pe=_.scrollBeyondLastLine?ce-1:0,Le=(_.viewLineCount+Pe)/(_.pixelRatio*_.height),Ge=Math.floor(_.viewLineCount/Le);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Pe,desiredRatio:Le,minimapLineCount:Ge}}static c(_,ce){const Pe=_.outerWidth,Le=_.outerHeight,Ge=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Qe=ce.stableMinimapLayoutInput,ut=Qe&&_.outerHeight===Qe.outerHeight&&_.lineHeight===Qe.lineHeight&&_.typicalHalfwidthCharacterWidth===Qe.typicalHalfwidthCharacterWidth&&_.pixelRatio===Qe.pixelRatio&&_.scrollBeyondLastLine===Qe.scrollBeyondLastLine&&_.minimap.enabled===Qe.minimap.enabled&&_.minimap.side===Qe.minimap.side&&_.minimap.size===Qe.minimap.size&&_.minimap.showSlider===Qe.minimap.showSlider&&_.minimap.renderCharacters===Qe.minimap.renderCharacters&&_.minimap.maxColumn===Qe.minimap.maxColumn&&_.minimap.scale===Qe.minimap.scale&&_.verticalScrollbarWidth===Qe.verticalScrollbarWidth&&_.isViewportWrapping===Qe.isViewportWrapping,mt=_.lineHeight,st=_.typicalHalfwidthCharacterWidth,rt=_.scrollBeyondLastLine,ct=_.minimap.renderCharacters;let Et=Ge>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Rt=_.minimap.maxColumn,At=_.minimap.size,wt=_.minimap.side,kt=_.verticalScrollbarWidth,Bt=_.viewLineCount,Nt=_.remainingWidth,Xe=_.isViewportWrapping,zt=ct?2:3;let Lt=Math.floor(Ge*Le);const Wt=Lt/Ge;let pt=!1,Mt=!1,Ae=zt*Et,Oe=Et/Ge,Ee=1;if(At==="fill"||At==="fit"){const{typicalViewportLineCount:It,extraLinesBeyondLastLine:St,desiredRatio:Ot,minimapLineCount:bt}=Y.computeContainedMinimapLineCount({viewLineCount:Bt,scrollBeyondLastLine:rt,height:Le,lineHeight:mt,pixelRatio:Ge});if(Bt/bt>1)pt=!0,Mt=!0,Et=1,Ae=1,Oe=Et/Ge;else{let vt=!1,Ht=Et+1;if(At==="fit"){const Ut=Math.ceil((Bt+St)*Ae);Xe&&ut&&Nt<=ce.stableFitRemainingWidth?(vt=!0,Ht=ce.stableFitMaxMinimapScale):vt=Ut>Lt}if(At==="fill"||vt){pt=!0;const Ut=Et;Ae=Math.min(mt*Ge,Math.max(1,Math.floor(1/Ot))),Xe&&ut&&Nt<=ce.stableFitRemainingWidth&&(Ht=ce.stableFitMaxMinimapScale),Et=Math.min(Ht,Math.max(1,Math.floor(Ae/zt))),Et>Ut&&(Ee=Math.min(2,Et/Ut)),Oe=Et/Ge/Ee,Lt=Math.ceil(Math.max(It,Bt+St)*Ae),Xe?(ce.stableMinimapLayoutInput=_,ce.stableFitRemainingWidth=Nt,ce.stableFitMaxMinimapScale=Et):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const ne=Math.floor(Rt*Oe),Ne=Math.min(ne,Math.max(0,Math.floor((Nt-kt-2)*Oe/(st+Oe)))+e.MINIMAP_GUTTER_WIDTH);let $e=Math.floor(Ge*Ne);const _e=$e/Ge;$e=Math.floor($e*Ee);const je=ct?1:2,et=wt==="left"?0:Pe-Ne-kt;return{renderMinimap:je,minimapLeft:et,minimapWidth:Ne,minimapHeightIsEditorHeight:pt,minimapIsSampling:Mt,minimapScale:Et,minimapLineHeight:Ae,minimapCanvasInnerWidth:$e,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:_e,minimapCanvasOuterHeight:Wt}}static computeLayout(_,ce){const Pe=ce.outerWidth|0,Le=ce.outerHeight|0,Ge=ce.lineHeight|0,Qe=ce.lineNumbersDigitCount|0,ut=ce.typicalHalfwidthCharacterWidth,mt=ce.maxDigitWidth,st=ce.pixelRatio,rt=ce.viewLineCount,ct=_.get(128),Et=ct==="inherit"?_.get(127):ct,Rt=Et==="inherit"?_.get(123):Et,At=_.get(126),wt=ce.isDominatedByLongLines,kt=_.get(52),Bt=_.get(62).renderType!==0,Nt=_.get(63),Xe=_.get(97),zt=_.get(67),Lt=_.get(95),Wt=Lt.verticalScrollbarSize,pt=Lt.verticalHasArrows,Mt=Lt.arrowSize,Ae=Lt.horizontalScrollbarSize,Oe=_.get(38),Ee=_.get(102)!=="never";let ne=_.get(60);Oe&&Ee&&(ne+=16);let Ne=0;if(Bt){const Zt=Math.max(Qe,Nt);Ne=Math.round(Zt*mt)}let $e=0;kt&&($e=Ge);let _e=0,je=_e+$e,et=je+Ne,It=et+ne;const St=Pe-$e-Ne-ne;let Ot=!1,bt=!1,Tt=-1;Et==="inherit"&&wt?(Ot=!0,bt=!0):Rt==="on"||Rt==="bounded"?bt=!0:Rt==="wordWrapColumn"&&(Tt=At);const vt=Y.c({outerWidth:Pe,outerHeight:Le,lineHeight:Ge,typicalHalfwidthCharacterWidth:ut,pixelRatio:st,scrollBeyondLastLine:Xe,minimap:zt,verticalScrollbarWidth:Wt,viewLineCount:rt,remainingWidth:St,isViewportWrapping:bt},ce.memory||new R);vt.renderMinimap!==0&&vt.minimapLeft===0&&(_e+=vt.minimapWidth,je+=vt.minimapWidth,et+=vt.minimapWidth,It+=vt.minimapWidth);const Ht=St-vt.minimapWidth,Ut=Math.max(1,Math.floor((Ht-Wt-2)/ut)),yt=pt?Mt:0;return bt&&(Tt=Math.max(1,Ut),Rt==="bounded"&&(Tt=Math.min(Tt,At))),{width:Pe,height:Le,glyphMarginLeft:_e,glyphMarginWidth:$e,lineNumbersLeft:je,lineNumbersWidth:Ne,decorationsLeft:et,decorationsWidth:ne,contentLeft:It,contentWidth:Ht,minimap:vt,viewportColumn:Ut,isWordWrapMinified:Ot,isViewportWrapping:bt,wrappingColumn:Tt,verticalScrollbarWidth:Wt,horizontalScrollbarHeight:Ae,overviewRuler:{top:yt,width:Wt,height:Le-2*yt,right:0}}}}e.EditorLayoutInfoComputer=Y;class ae extends P{constructor(){super(130,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(_){return s(_,"simple",["simple","advanced"])}compute(_,ce,Pe){return ce.get(2)===2?"advanced":Pe}}class re extends P{constructor(){const _={enabled:!0};super(59,"lightbulb",_,{"editor.lightbulb.enabled":{type:"boolean",default:_.enabled,description:a.localize(50,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:g(_.enabled,this.defaultValue.enabled)}}}class fe extends P{constructor(){const _={enabled:!1,maxLineCount:5};super(107,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:a.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:a.localize(52,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{enabled:g(ce.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(ce.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Z extends P{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(132,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:a.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(54,null),a.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:a.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:a.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:a.localize(60,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return typeof ce.enabled=="boolean"&&(ce.enabled=ce.enabled?"on":"off"),{enabled:s(ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ce.fontFamily,this.defaultValue.fontFamily),padding:g(ce.padding,this.defaultValue.padding)}}}class pe extends P{constructor(){super(60,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):m.clampedInt(_,this.defaultValue,0,1e3)}compute(_,ce,Pe){return Pe<0?m.clampedInt(-Pe*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Pe}}class we extends h{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>h.clamp(_,0,150),{markdownDescription:a.localize(61,null)})}compute(_,ce,Pe){return _.fontInfo.lineHeight}}class De extends P{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:a.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:a.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(64,null),a.localize(65,null),a.localize(66,null)],default:_.size,description:a.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:a.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:a.localize(69,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:a.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:a.localize(72,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{enabled:g(ce.enabled,this.defaultValue.enabled),autohide:g(ce.autohide,this.defaultValue.autohide),size:s(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ce.side,this.defaultValue.side,["right","left"]),showSlider:s(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(ce.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(ce.scale,1,1,3),maxColumn:m.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Re(W){return W==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Be extends P{constructor(){super(78,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(74,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{top:m.clampedInt(ce.top,0,0,1e3),bottom:m.clampedInt(ce.bottom,0,0,1e3)}}}class se extends P{constructor(){const _={enabled:!0,cycle:!1};super(79,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:a.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:a.localize(76,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{enabled:g(ce.enabled,this.defaultValue.enabled),cycle:g(ce.cycle,this.defaultValue.cycle)}}}class ue extends v{constructor(){super(134)}compute(_,ce,Pe){return _.pixelRatio}}class de extends P{constructor(){const _={other:"on",comments:"off",strings:"off"},ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(77,null),a.localize(78,null),a.localize(79,null)]}];super(82,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ce,default:_.strings,description:a.localize(80,null)},comments:{anyOf:ce,default:_.comments,description:a.localize(81,null)},other:{anyOf:ce,default:_.other,description:a.localize(82,null)}},default:_,markdownDescription:a.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const st=_?"on":"off";return{comments:st,strings:st,other:st}}if(!_||typeof _!="object")return this.defaultValue;const{other:ce,comments:Pe,strings:Le}=_,Ge=["on","inline","off"];let Qe,ut,mt;return typeof ce=="boolean"?Qe=ce?"on":"off":Qe=s(ce,this.defaultValue.other,Ge),typeof Pe=="boolean"?ut=Pe?"on":"off":ut=s(Pe,this.defaultValue.comments,Ge),typeof Le=="boolean"?mt=Le?"on":"off":mt=s(Le,this.defaultValue.strings,Ge),{other:Qe,comments:ut,strings:mt}}}var ee;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative",W[W.Interval=3]="Interval",W[W.Custom=4]="Custom"})(ee=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends P{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(84,null),a.localize(85,null),a.localize(86,null),a.localize(87,null)],default:"on",description:a.localize(88,null)})}validate(_){let ce=this.defaultValue.renderType,Pe=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(ce=4,Pe=_):_==="interval"?ce=3:_==="relative"?ce=2:_==="on"?ce=1:ce=0),{renderType:ce,renderFn:Pe}}}function ie(W){const _=W.get(90);return _==="editable"?W.get(84):_!=="on"}e.filterValidationDecorations=ie;class N extends P{constructor(){const _=[],ce={type:"number",description:a.localize(89,null)};super(94,"rulers",_,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:a.localize(90,null),format:"color-hex"}}}]},default:_,description:a.localize(91,null)})}validate(_){if(Array.isArray(_)){const ce=[];for(const Pe of _)if(typeof Pe=="number")ce.push({column:m.clampedInt(Pe,0,0,1e4),color:null});else if(Pe&&typeof Pe=="object"){const Le=Pe;ce.push({column:m.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ce.sort((Pe,Le)=>Pe.column-Le.column),ce}return this.defaultValue}}function z(W,_){if(typeof W!="string")return _;switch(W){case"hidden":return 2;case"visible":return 3;default:return 1}}class X extends P{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(95,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(92,null),a.localize(93,null),a.localize(94,null)],default:"auto",description:a.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(96,null),a.localize(97,null),a.localize(98,null)],default:"auto",description:a.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:a.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:a.localize(102,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_,Pe=m.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=m.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(ce.vertical,this.defaultValue.vertical),horizontal:z(ce.horizontal,this.defaultValue.horizontal),useShadows:g(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Pe,horizontalSliderSize:m.clampedInt(ce.horizontalSliderSize,Pe,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:m.clampedInt(ce.verticalSliderSize,Le,0,1e3),scrollByPage:g(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends P{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(117,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:a.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:a.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:a.localize(109,null)}})}applyUpdate(_,ce){let Pe=!1;ce.allowedCharacters&&_&&(D.equals(_.allowedCharacters,ce.allowedCharacters)||(_={..._,allowedCharacters:ce.allowedCharacters},Pe=!0)),ce.allowedLocales&&_&&(D.equals(_.allowedLocales,ce.allowedLocales)||(_={..._,allowedLocales:ce.allowedLocales},Pe=!0));const Le=super.applyUpdate(_,ce);return Pe?new E(Le.newValue,!0):Le}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{nonBasicASCII:ge(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,ce){if(typeof _!="object"||!_)return ce;const Pe={};for(const[Le,Ge]of Object.entries(_))Ge===!0&&(Pe[Le]=!0);return Pe}}class le extends P{constructor(){const _={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:a.localize(110,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{enabled:g(ce.enabled,this.defaultValue.enabled),mode:s(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class be extends P{constructor(){const _={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:a.localize(111,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:a.localize(112,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{enabled:g(ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Te extends P{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(113,null),a.localize(114,null),a.localize(115,null)],default:_.bracketPairs,description:a.localize(116,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(117,null),a.localize(118,null),a.localize(119,null)],default:_.bracketPairsHorizontal,description:a.localize(120,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:a.localize(121,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:a.localize(122,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(123,null),a.localize(124,null),a.localize(125,null)],default:_.highlightActiveIndentation,description:a.localize(126,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{bracketPairs:ge(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(W,_,ce){const Pe=ce.indexOf(W);return Pe===-1?_:ce[Pe]}class Ce extends P{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(110,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(127,null),a.localize(128,null)],default:_.insertMode,description:a.localize(129,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:a.localize(130,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:a.localize(131,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:a.localize(132,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:a.localize(133,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:a.localize(134,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:a.localize(135,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:a.localize(136,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:a.localize(137,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(138,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(139,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ce=_;return{insertMode:s(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:g(ce.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:g(ce.showIcons,this.defaultValue.showIcons),showStatusBar:g(ce.showStatusBar,this.defaultValue.showStatusBar),preview:g(ce.preview,this.defaultValue.preview),previewMode:s(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(ce.showMethods,this.defaultValue.showMethods),showFunctions:g(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:g(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(ce.showFields,this.defaultValue.showFields),showVariables:g(ce.showVariables,this.defaultValue.showVariables),showClasses:g(ce.showClasses,this.defaultValue.showClasses),showStructs:g(ce.showStructs,this.defaultValue.showStructs),showInterfaces:g(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:g(ce.showModules,this.defaultValue.showModules),showProperties:g(ce.showProperties,this.defaultValue.showProperties),showEvents:g(ce.showEvents,this.defaultValue.showEvents),showOperators:g(ce.showOperators,this.defaultValue.showOperators),showUnits:g(ce.showUnits,this.defaultValue.showUnits),showValues:g(ce.showValues,this.defaultValue.showValues),showConstants:g(ce.showConstants,this.defaultValue.showConstants),showEnums:g(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:g(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(ce.showKeywords,this.defaultValue.showKeywords),showWords:g(ce.showWords,this.defaultValue.showWords),showColors:g(ce.showColors,this.defaultValue.showColors),showFiles:g(ce.showFiles,this.defaultValue.showFiles),showReferences:g(ce.showReferences,this.defaultValue.showReferences),showFolders:g(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:g(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(ce.showSnippets,this.defaultValue.showSnippets),showUsers:g(ce.showUsers,this.defaultValue.showUsers),showIssues:g(ce.showIssues,this.defaultValue.showIssues)}}}class Ie extends P{constructor(){super(105,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(170,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class He extends v{constructor(){super(135)}compute(_,ce,Pe){return ce.get(84)?!0:_.tabFocusMode}}var qe;(function(W){W[W.None=0]="None",W[W.Same=1]="Same",W[W.Indent=2]="Indent",W[W.DeepIndent=3]="DeepIndent"})(qe=e.WrappingIndent||(e.WrappingIndent={}));class Ze extends P{constructor(){super(129,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(171,null),a.localize(172,null),a.localize(173,null),a.localize(174,null)],description:a.localize(175,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,ce,Pe){return ce.get(2)===2?0:Pe}}class xe extends v{constructor(){super(137)}compute(_,ce,Pe){const Le=ce.get(136);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class tt extends P{constructor(){const _={enabled:!0};super(32,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:a.localize(176,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:g(_.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",ft="Menlo, Monaco, 'Courier New', monospace",it="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?ft:t.isLinux?it:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(W){return e.editorOptionsRegistry[W.id]=W,W}var lt;(function(W){W[W.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",W[W.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",W[W.accessibilitySupport=2]="accessibilitySupport",W[W.accessibilityPageSize=3]="accessibilityPageSize",W[W.ariaLabel=4]="ariaLabel",W[W.autoClosingBrackets=5]="autoClosingBrackets",W[W.autoClosingDelete=6]="autoClosingDelete",W[W.autoClosingOvertype=7]="autoClosingOvertype",W[W.autoClosingQuotes=8]="autoClosingQuotes",W[W.autoIndent=9]="autoIndent",W[W.automaticLayout=10]="automaticLayout",W[W.autoSurround=11]="autoSurround",W[W.bracketPairColorization=12]="bracketPairColorization",W[W.guides=13]="guides",W[W.codeLens=14]="codeLens",W[W.codeLensFontFamily=15]="codeLensFontFamily",W[W.codeLensFontSize=16]="codeLensFontSize",W[W.colorDecorators=17]="colorDecorators",W[W.columnSelection=18]="columnSelection",W[W.comments=19]="comments",W[W.contextmenu=20]="contextmenu",W[W.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",W[W.cursorBlinking=22]="cursorBlinking",W[W.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",W[W.cursorStyle=24]="cursorStyle",W[W.cursorSurroundingLines=25]="cursorSurroundingLines",W[W.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",W[W.cursorWidth=27]="cursorWidth",W[W.disableLayerHinting=28]="disableLayerHinting",W[W.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",W[W.domReadOnly=30]="domReadOnly",W[W.dragAndDrop=31]="dragAndDrop",W[W.dropIntoEditor=32]="dropIntoEditor",W[W.emptySelectionClipboard=33]="emptySelectionClipboard",W[W.extraEditorClassName=34]="extraEditorClassName",W[W.fastScrollSensitivity=35]="fastScrollSensitivity",W[W.find=36]="find",W[W.fixedOverflowWidgets=37]="fixedOverflowWidgets",W[W.folding=38]="folding",W[W.foldingStrategy=39]="foldingStrategy",W[W.foldingHighlight=40]="foldingHighlight",W[W.foldingImportsByDefault=41]="foldingImportsByDefault",W[W.foldingMaximumRegions=42]="foldingMaximumRegions",W[W.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",W[W.fontFamily=44]="fontFamily",W[W.fontInfo=45]="fontInfo",W[W.fontLigatures=46]="fontLigatures",W[W.fontSize=47]="fontSize",W[W.fontWeight=48]="fontWeight",W[W.fontVariations=49]="fontVariations",W[W.formatOnPaste=50]="formatOnPaste",W[W.formatOnType=51]="formatOnType",W[W.glyphMargin=52]="glyphMargin",W[W.gotoLocation=53]="gotoLocation",W[W.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",W[W.hover=55]="hover",W[W.inDiffEditor=56]="inDiffEditor",W[W.inlineSuggest=57]="inlineSuggest",W[W.letterSpacing=58]="letterSpacing",W[W.lightbulb=59]="lightbulb",W[W.lineDecorationsWidth=60]="lineDecorationsWidth",W[W.lineHeight=61]="lineHeight",W[W.lineNumbers=62]="lineNumbers",W[W.lineNumbersMinChars=63]="lineNumbersMinChars",W[W.linkedEditing=64]="linkedEditing",W[W.links=65]="links",W[W.matchBrackets=66]="matchBrackets",W[W.minimap=67]="minimap",W[W.mouseStyle=68]="mouseStyle",W[W.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",W[W.mouseWheelZoom=70]="mouseWheelZoom",W[W.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",W[W.multiCursorModifier=72]="multiCursorModifier",W[W.multiCursorPaste=73]="multiCursorPaste",W[W.multiCursorLimit=74]="multiCursorLimit",W[W.occurrencesHighlight=75]="occurrencesHighlight",W[W.overviewRulerBorder=76]="overviewRulerBorder",W[W.overviewRulerLanes=77]="overviewRulerLanes",W[W.padding=78]="padding",W[W.parameterHints=79]="parameterHints",W[W.peekWidgetDefaultFocus=80]="peekWidgetDefaultFocus",W[W.definitionLinkOpensInPeek=81]="definitionLinkOpensInPeek",W[W.quickSuggestions=82]="quickSuggestions",W[W.quickSuggestionsDelay=83]="quickSuggestionsDelay",W[W.readOnly=84]="readOnly",W[W.renameOnType=85]="renameOnType",W[W.renderControlCharacters=86]="renderControlCharacters",W[W.renderFinalNewline=87]="renderFinalNewline",W[W.renderLineHighlight=88]="renderLineHighlight",W[W.renderLineHighlightOnlyWhenFocus=89]="renderLineHighlightOnlyWhenFocus",W[W.renderValidationDecorations=90]="renderValidationDecorations",W[W.renderWhitespace=91]="renderWhitespace",W[W.revealHorizontalRightPadding=92]="revealHorizontalRightPadding",W[W.roundedSelection=93]="roundedSelection",W[W.rulers=94]="rulers",W[W.scrollbar=95]="scrollbar",W[W.scrollBeyondLastColumn=96]="scrollBeyondLastColumn",W[W.scrollBeyondLastLine=97]="scrollBeyondLastLine",W[W.scrollPredominantAxis=98]="scrollPredominantAxis",W[W.selectionClipboard=99]="selectionClipboard",W[W.selectionHighlight=100]="selectionHighlight",W[W.selectOnLineNumbers=101]="selectOnLineNumbers",W[W.showFoldingControls=102]="showFoldingControls",W[W.showUnused=103]="showUnused",W[W.snippetSuggestions=104]="snippetSuggestions",W[W.smartSelect=105]="smartSelect",W[W.smoothScrolling=106]="smoothScrolling",W[W.stickyScroll=107]="stickyScroll",W[W.stickyTabStops=108]="stickyTabStops",W[W.stopRenderingLineAfter=109]="stopRenderingLineAfter",W[W.suggest=110]="suggest",W[W.suggestFontSize=111]="suggestFontSize",W[W.suggestLineHeight=112]="suggestLineHeight",W[W.suggestOnTriggerCharacters=113]="suggestOnTriggerCharacters",W[W.suggestSelection=114]="suggestSelection",W[W.tabCompletion=115]="tabCompletion",W[W.tabIndex=116]="tabIndex",W[W.unicodeHighlighting=117]="unicodeHighlighting",W[W.unusualLineTerminators=118]="unusualLineTerminators",W[W.useShadowDOM=119]="useShadowDOM",W[W.useTabStops=120]="useTabStops",W[W.wordBreak=121]="wordBreak",W[W.wordSeparators=122]="wordSeparators",W[W.wordWrap=123]="wordWrap",W[W.wordWrapBreakAfterCharacters=124]="wordWrapBreakAfterCharacters",W[W.wordWrapBreakBeforeCharacters=125]="wordWrapBreakBeforeCharacters",W[W.wordWrapColumn=126]="wordWrapColumn",W[W.wordWrapOverride1=127]="wordWrapOverride1",W[W.wordWrapOverride2=128]="wordWrapOverride2",W[W.wrappingIndent=129]="wrappingIndent",W[W.wrappingStrategy=130]="wrappingStrategy",W[W.showDeprecated=131]="showDeprecated",W[W.inlayHints=132]="inlayHints",W[W.editorClassName=133]="editorClassName",W[W.pixelRatio=134]="pixelRatio",W[W.tabFocusMode=135]="tabFocusMode",W[W.layoutInfo=136]="layoutInfo",W[W.wrappingInfo=137]="wrappingInfo"})(lt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(177,null)})),acceptSuggestionOnEnter:Fe(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(178,null),""],markdownDescription:a.localize(179,null)})),accessibilitySupport:Fe(new r),accessibilityPageSize:Fe(new m(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(180,null),tags:["accessibility"]})),ariaLabel:Fe(new b(4,"ariaLabel",a.localize(181,null))),autoClosingBrackets:Fe(new i(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(182,null),a.localize(183,null),""],description:a.localize(184,null)})),autoClosingDelete:Fe(new i(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(185,null),""],description:a.localize(186,null)})),autoClosingOvertype:Fe(new i(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(187,null),""],description:a.localize(188,null)})),autoClosingQuotes:Fe(new i(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(189,null),a.localize(190,null),""],description:a.localize(191,null)})),autoIndent:Fe(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[a.localize(192,null),a.localize(193,null),a.localize(194,null),a.localize(195,null),a.localize(196,null)],description:a.localize(197,null)})),automaticLayout:Fe(new f(10,"automaticLayout",!1)),autoSurround:Fe(new i(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(198,null),a.localize(199,null),a.localize(200,null),""],description:a.localize(201,null)})),bracketPairColorization:Fe(new be),bracketPairGuides:Fe(new Te),stickyTabStops:Fe(new f(108,"stickyTabStops",!1,{description:a.localize(202,null)})),codeLens:Fe(new f(14,"codeLens",!0,{description:a.localize(203,null)})),codeLensFontFamily:Fe(new b(15,"codeLensFontFamily","",{description:a.localize(204,null)})),codeLensFontSize:Fe(new m(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(205,null)})),colorDecorators:Fe(new f(17,"colorDecorators",!0,{description:a.localize(206,null)})),columnSelection:Fe(new f(18,"columnSelection",!1,{description:a.localize(207,null)})),comments:Fe(new o),contextmenu:Fe(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new f(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(208,null)})),cursorBlinking:Fe(new c(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:a.localize(209,null)})),cursorSmoothCaretAnimation:Fe(new f(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(210,null)})),cursorStyle:Fe(new c(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:a.localize(211,null)})),cursorSurroundingLines:Fe(new m(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(212,null)})),cursorSurroundingLinesStyle:Fe(new i(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(213,null),a.localize(214,null)],description:a.localize(215,null)})),cursorWidth:Fe(new m(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(216,null)})),disableLayerHinting:Fe(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new f(30,"domReadOnly",!1)),dragAndDrop:Fe(new f(31,"dragAndDrop",!0,{description:a.localize(217,null)})),emptySelectionClipboard:Fe(new K),dropIntoEditor:Fe(new tt),stickyScroll:Fe(new fe),extraEditorClassName:Fe(new b(34,"extraEditorClassName","")),fastScrollSensitivity:Fe(new h(35,"fastScrollSensitivity",5,W=>W<=0?5:W,{markdownDescription:a.localize(218,null)})),find:Fe(new G),fixedOverflowWidgets:Fe(new f(37,"fixedOverflowWidgets",!1)),folding:Fe(new f(38,"folding",!0,{description:a.localize(219,null)})),foldingStrategy:Fe(new i(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(220,null),a.localize(221,null)],description:a.localize(222,null)})),foldingHighlight:Fe(new f(40,"foldingHighlight",!0,{description:a.localize(223,null)})),foldingImportsByDefault:Fe(new f(41,"foldingImportsByDefault",!1,{description:a.localize(224,null)})),foldingMaximumRegions:Fe(new m(42,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(225,null)})),unfoldOnClickAfterEndOfLine:Fe(new f(43,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(226,null)})),fontFamily:Fe(new B),fontInfo:Fe(new $),fontLigatures2:Fe(new O),fontSize:Fe(new M),fontWeight:Fe(new V),fontVariations:Fe(new F),formatOnPaste:Fe(new f(50,"formatOnPaste",!1,{description:a.localize(227,null)})),formatOnType:Fe(new f(51,"formatOnType",!1,{description:a.localize(228,null)})),glyphMargin:Fe(new f(52,"glyphMargin",!0,{description:a.localize(229,null)})),gotoLocation:Fe(new q),hideCursorInOverviewRuler:Fe(new f(54,"hideCursorInOverviewRuler",!1,{description:a.localize(230,null)})),hover:Fe(new H),inDiffEditor:Fe(new f(56,"inDiffEditor",!1)),letterSpacing:Fe(new h(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,W=>h.clamp(W,-5,20),{description:a.localize(231,null)})),lightbulb:Fe(new re),lineDecorationsWidth:Fe(new pe),lineHeight:Fe(new we),lineNumbers:Fe(new oe),lineNumbersMinChars:Fe(new m(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new f(64,"linkedEditing",!1,{description:a.localize(232,null)})),links:Fe(new f(65,"links",!0,{description:a.localize(233,null)})),matchBrackets:Fe(new i(66,"matchBrackets","always",["always","near","never"],{description:a.localize(234,null)})),minimap:Fe(new De),mouseStyle:Fe(new i(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new h(69,"mouseWheelScrollSensitivity",1,W=>W===0?1:W,{markdownDescription:a.localize(235,null)})),mouseWheelZoom:Fe(new f(70,"mouseWheelZoom",!1,{markdownDescription:a.localize(236,null)})),multiCursorMergeOverlapping:Fe(new f(71,"multiCursorMergeOverlapping",!0,{description:a.localize(237,null)})),multiCursorModifier:Fe(new c(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Re,{markdownEnumDescriptions:[a.localize(238,null),a.localize(239,null)],markdownDescription:a.localize(240,null)})),multiCursorPaste:Fe(new i(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(241,null),a.localize(242,null)],markdownDescription:a.localize(243,null)})),multiCursorLimit:Fe(new m(74,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(244,null)})),occurrencesHighlight:Fe(new f(75,"occurrencesHighlight",!0,{description:a.localize(245,null)})),overviewRulerBorder:Fe(new f(76,"overviewRulerBorder",!0,{description:a.localize(246,null)})),overviewRulerLanes:Fe(new m(77,"overviewRulerLanes",3,0,3)),padding:Fe(new Be),parameterHints:Fe(new se),peekWidgetDefaultFocus:Fe(new i(80,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(247,null),a.localize(248,null)],description:a.localize(249,null)})),definitionLinkOpensInPeek:Fe(new f(81,"definitionLinkOpensInPeek",!1,{description:a.localize(250,null)})),quickSuggestions:Fe(new de),quickSuggestionsDelay:Fe(new m(83,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(251,null)})),readOnly:Fe(new f(84,"readOnly",!1)),renameOnType:Fe(new f(85,"renameOnType",!1,{description:a.localize(252,null),markdownDeprecationMessage:a.localize(253,null)})),renderControlCharacters:Fe(new f(86,"renderControlCharacters",!0,{description:a.localize(254,null),restricted:!0})),renderFinalNewline:Fe(new f(87,"renderFinalNewline",!0,{description:a.localize(255,null)})),renderLineHighlight:Fe(new i(88,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(256,null)],description:a.localize(257,null)})),renderLineHighlightOnlyWhenFocus:Fe(new f(89,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(258,null)})),renderValidationDecorations:Fe(new i(90,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new i(91,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(259,null),a.localize(260,null),a.localize(261,null),""],description:a.localize(262,null)})),revealHorizontalRightPadding:Fe(new m(92,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new f(93,"roundedSelection",!0,{description:a.localize(263,null)})),rulers:Fe(new N),scrollbar:Fe(new X),scrollBeyondLastColumn:Fe(new m(96,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(264,null)})),scrollBeyondLastLine:Fe(new f(97,"scrollBeyondLastLine",!0,{description:a.localize(265,null)})),scrollPredominantAxis:Fe(new f(98,"scrollPredominantAxis",!0,{description:a.localize(266,null)})),selectionClipboard:Fe(new f(99,"selectionClipboard",!0,{description:a.localize(267,null),included:t.isLinux})),selectionHighlight:Fe(new f(100,"selectionHighlight",!0,{description:a.localize(268,null)})),selectOnLineNumbers:Fe(new f(101,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new i(102,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(269,null),a.localize(270,null),a.localize(271,null)],description:a.localize(272,null)})),showUnused:Fe(new f(103,"showUnused",!0,{description:a.localize(273,null)})),showDeprecated:Fe(new f(131,"showDeprecated",!0,{description:a.localize(274,null)})),inlayHints:Fe(new Z),snippetSuggestions:Fe(new i(104,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(275,null),a.localize(276,null),a.localize(277,null),a.localize(278,null)],description:a.localize(279,null)})),smartSelect:Fe(new Ie),smoothScrolling:Fe(new f(106,"smoothScrolling",!1,{description:a.localize(280,null)})),stopRenderingLineAfter:Fe(new m(109,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new Ce),inlineSuggest:Fe(new le),suggestFontSize:Fe(new m(111,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(281,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new m(112,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(282,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new f(113,"suggestOnTriggerCharacters",!0,{description:a.localize(283,null)})),suggestSelection:Fe(new i(114,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(284,null),a.localize(285,null),a.localize(286,null)],description:a.localize(287,null)})),tabCompletion:Fe(new i(115,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(288,null),a.localize(289,null),a.localize(290,null)],description:a.localize(291,null)})),tabIndex:Fe(new m(116,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new Q),unusualLineTerminators:Fe(new i(118,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(292,null),a.localize(293,null),a.localize(294,null)],description:a.localize(295,null)})),useShadowDOM:Fe(new f(119,"useShadowDOM",!0)),useTabStops:Fe(new f(120,"useTabStops",!0,{description:a.localize(296,null)})),wordBreak:Fe(new i(121,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],description:a.localize(299,null)})),wordSeparators:Fe(new b(122,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:a.localize(300,null)})),wordWrap:Fe(new i(123,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null),a.localize(304,null)],description:a.localize(305,null)})),wordWrapBreakAfterCharacters:Fe(new b(124,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new b(125,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new m(126,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(306,null)})),wordWrapOverride1:Fe(new i(127,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new i(128,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new U),pixelRatio:Fe(new ue),tabFocusMode:Fe(new He),layoutInfo:Fe(new Y),wrappingInfo:Fe(new xe),wrappingIndent:Fe(new Ze),wrappingStrategy:Fe(new ae)}}),define(Se[165],ye([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[166],ye([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[167],ye([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[168],ye([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[169],ye([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Se[170],ye([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Se[171],ye([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Se[172],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[173],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[174],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[175],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[176],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[177],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[178],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[179],ye([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[180],ye([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Se[181],ye([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Se[182],ye([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[183],ye([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[184],ye([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[185],ye([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[186],ye([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[187],ye([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[188],ye([19,20]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[189],ye([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[190],ye([1,0,10]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(A,D){this.a.set(A,D)}updateManifest(A){if(!(!Array.isArray(A.activationEvents)||!A.contributes)&&!(typeof A.main>"u"&&typeof A.browser>"u"))for(const D in A.contributes){const T=this.a.get(D);if(!T)continue;const S=A.contributes[D],C=Array.isArray(S)?S:[S];try{T(C,A.activationEvents)}catch(R){(0,a.onUnexpectedError)(R)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(Se[191],ye([1,0,24,42,167,310]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(f){return f=f.trim(),f==="*"||D.test(f)}e.isValidVersionStr=S;function C(f){if(!S(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=f.match(D);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=C;function R(f){if(!f)return null;const w=f.majorBase,m=f.majorMustEqual,h=f.minorBase;let b=f.minorMustEqual;const s=f.patchBase;let i=f.patchMustEqual;f.hasCaret&&(w===0||(b=!1),i=!1);let c=0;if(f.preRelease){const u=T.exec(f.preRelease);if(u){const[,r,o,n]=u;c=Date.UTC(Number(r),Number(o)-1,Number(n))}}return{majorBase:w,majorMustEqual:m,minorBase:h,minorMustEqual:b,patchBase:s,patchMustEqual:i,isMinimum:f.hasGreaterEquals,notBefore:c}}e.normalizeVersion=R;function P(f,w,m){let h;typeof f=="string"?h=R(C(f)):h=f;let b;w instanceof Date?b=w.getTime():typeof w=="string"&&(b=new Date(w).getTime());let s;if(typeof m=="string"?s=R(C(m)):s=m,!h||!s)return!1;const i=h.majorBase,c=h.minorBase,u=h.patchBase;let r=s.majorBase,o=s.minorBase,n=s.patchBase;const l=s.notBefore;let p=s.majorMustEqual,k=s.minorMustEqual,L=s.patchMustEqual;return s.isMinimum?i>r?!0:i<r?!1:c>o?!0:c<o||b&&b<l?!1:u>=n:(i===1&&r===0&&(!p||!k||!L)&&(r=1,o=0,n=0,p=!0,k=!1,L=!1),i<r?!1:i>r?!p:c<o?!1:c>o?!k:u<n?!1:u>n?!L:!(b&&b<l))}e.isValidVersion=P;function E(f,w,m,h,b){const s=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return s.push([t.default.Error,I.localize(0,null)]),s;if(typeof h.name!="string")return s.push([t.default.Error,I.localize(1,null,"name")]),s;if(typeof h.version!="string")return s.push([t.default.Error,I.localize(2,null,"version")]),s;if(!h.engines)return s.push([t.default.Error,I.localize(3,null,"engines")]),s;if(typeof h.engines.vscode!="string")return s.push([t.default.Error,I.localize(4,null,"engines.vscode")]),s;if(typeof h.extensionDependencies<"u"&&!g(h.extensionDependencies))return s.push([t.default.Error,I.localize(5,null,"extensionDependencies")]),s;if(typeof h.activationEvents<"u"){if(!g(h.activationEvents))return s.push([t.default.Error,I.localize(6,null,"activationEvents")]),s;if(typeof h.main>"u"&&typeof h.browser>"u")return s.push([t.default.Error,I.localize(7,null,"activationEvents","main")]),s}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&s.push([t.default.Warning,I.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return s.push([t.default.Error,I.localize(9,null,"main")]),s;{const u=(0,a.joinPath)(m,h.main);(0,a.isEqualOrParent)(u,m)||s.push([t.default.Warning,I.localize(10,null,u.path,m.path)])}if(typeof h.activationEvents>"u")return s.push([t.default.Error,I.localize(11,null,"activationEvents","main")]),s}if(typeof h.browser<"u"){if(typeof h.browser!="string")return s.push([t.default.Error,I.localize(12,null,"browser")]),s;{const u=(0,a.joinPath)(m,h.browser);(0,a.isEqualOrParent)(u,m)||s.push([t.default.Warning,I.localize(13,null,u.path,m.path)])}if(typeof h.activationEvents>"u")return s.push([t.default.Error,I.localize(14,null,"activationEvents","browser")]),s}if(!A.valid(h.version))return s.push([t.default.Error,I.localize(15,null)]),s;const i=[];if(!y(f,w,h,b,i))for(const u of i)s.push([t.default.Error,u]);return s}e.validateExtensionManifest=E;function y(f,w,m,h,b){return h||typeof m.main>"u"&&typeof m.browser>"u"?!0:d(f,w,m.engines.vscode,b)}e.isValidExtensionVersion=y;function v(f,w,m){return f==="*"||d(w,m,f)}e.isEngineValid=v;function d(f,w,m,h=[]){const b=R(C(m));if(!b)return h.push(I.localize(16,null,m)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return h.push(I.localize(17,null,m)),!1}else if(!b.majorMustEqual)return h.push(I.localize(18,null,m)),!1;return P(f,w,b)?!0:(h.push(I.localize(19,null,f,m)),!1)}function g(f){if(!Array.isArray(f))return!1;for(let w=0,m=f.length;w<m;w++)if(typeof f[w]!="string")return!1;return!0}}),define(Se[120],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(I,A=[],D=!1){this.ctor=I,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=a}),define(Se[86],ye([1,0,120]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var I;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function A(T,S,C){S instanceof a.SyncDescriptor||(S=new a.SyncDescriptor(S,[],Boolean(C))),t.push([T,S])}e.registerSingleton=A;function D(){return t}e.getSingletonServiceDescriptors=D}),define(Se[192],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(A,D){this.key=A,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class t{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const D of this.a.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const T=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(D);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(A){const D=this.b(A);this.a.delete(D);for(const T of this.a.values())T.outgoing.delete(D),T.incoming.delete(D)}lookupOrInsertNode(A){const D=this.b(A);let T=this.a.get(D);return T||(T=new a(D,A),this.a.set(D,T)),T}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[D,T]of this.a)A.push(`${D}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this.a){const T=new Set([A]),S=this.c(D,T);if(S)return S}}c(A,D){for(const[T,S]of A.outgoing){if(D.has(T))return[...D,T].join(" -> ");D.add(T);const C=this.c(S,D);if(C)return C;D.delete(T)}}}e.Graph=t}),define(Se[3],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=T})(a=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(D,T,S){T[a.DI_TARGET]===T?T[a.DI_DEPENDENCIES].push({id:D,index:S}):(T[a.DI_DEPENDENCIES]=[{id:D,index:S}],T[a.DI_TARGET]=T)}function I(D){if(a.serviceIds.has(D))return a.serviceIds.get(D);const T=function(S,C,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(T,S,R)};return T.toString=()=>D,a.serviceIds.set(D,T),T}e.createDecorator=I;function A(D){return D}e.refineServiceDecorator=A}),define(Se[52],ye([1,0,11,2,3]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=A;function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var T;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function C(f,w){const m=Object.create(null);for(const h in f)R(m,h,f[h],w);return m}e.toValuesTree=C;function R(f,w,m,h){const b=w.split("."),s=b.pop();let i=f;for(let c=0;c<b.length;c++){const u=b[c];let r=i[u];switch(typeof r){case"undefined":r=i[u]=Object.create(null);break;case"object":break;default:h(`Ignoring ${w} as ${b.slice(0,c+1).join(".")} is ${JSON.stringify(r)}`);return}i=r}if(typeof i=="object"&&i!==null)try{i[s]=m}catch{h(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(i)}`)}else h(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=R;function P(f,w){const m=w.split(".");E(f,m)}e.removeFromValueTree=P;function E(f,w){const m=w.shift();if(w.length===0){delete f[m];return}if(Object.keys(f).indexOf(m)!==-1){const h=f[m];typeof h=="object"&&!Array.isArray(h)&&(E(h,w),Object.keys(h).length===0&&delete f[m])}}function y(f,w,m){function h(i,c){let u=i;for(const r of c){if(typeof u!="object"||u===null)return;u=u[r]}return u}const b=w.split("."),s=h(f,b);return typeof s>"u"?m:s}e.getConfigurationValue=y;function v(f,w,m){Object.keys(w).forEach(h=>{h!=="__proto__"&&(h in f?a.isObject(f[h])&&a.isObject(w[h])?v(f[h],w[h],m):m&&(f[h]=w[h]):f[h]=w[h])})}e.merge=v;function d(f,w,m){const h=f.inspect(w),b=f.inspect(m);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:h.defaultValue}e.getMigratedSettingValue=d;function g(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(Se[53],ye([1,0,12,8,3]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",a.isMacintosh),A.set("isLinux",a.isLinux),A.set("isWindows",a.isWindows),A.set("isWeb",a.isWeb),A.set("isMacNative",a.isMacintosh&&!a.isWeb),A.set("isEdge",a.isEdge),A.set("isFirefox",a.isFirefox),A.set("isChrome",a.isChrome),A.set("isSafari",a.isSafari);const D=Object.prototype.hasOwnProperty;var T;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return P.INSTANCE}static true(){return E.INSTANCE}static has(O){return y.create(O)}static equals(O,B){return v.create(O,B)}static notEquals(O,B){return f.create(O,B)}static regex(O,B){return c.create(O,B)}static in(O,B){return d.create(O,B)}static notIn(O,B){return g.create(O,B)}static not(O){return w.create(O)}static and(...O){return o.create(O,null,!0)}static or(...O){return n.create(O,null,!0)}static greater(O,B){return h.create(O,B)}static greaterEquals(O,B){return b.create(O,B)}static smaller(O,B){return s.create(O,B)}static smallerEquals(O,B){return i.create(O,B)}static deserialize(O,B=!1){if(!!O)return this.c(O,B)}static c(O,B){const F=O.split("||");return n.create(F.map($=>this.d($,B)),null,!0)}static d(O,B){const F=O.split("&&");return o.create(F.map($=>this.f($,B)),null,!0)}static f(O,B){if(O=O.trim(),O.indexOf("!=")>=0){const F=O.split("!=");return f.create(F[0].trim(),this.g(F[1],B))}if(O.indexOf("==")>=0){const F=O.split("==");return v.create(F[0].trim(),this.g(F[1],B))}if(O.indexOf("=~")>=0){const F=O.split("=~");return c.create(F[0].trim(),this.h(F[1],B))}if(O.indexOf(" not in ")>=0){const F=O.split(" not in ");return g.create(F[0].trim(),this.g(F[1],B))}if(O.indexOf(" in ")>=0){const F=O.split(" in ");return d.create(F[0].trim(),this.g(F[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(O)){const F=O.split(">=");return b.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(O)){const F=O.split(">");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(O)){const F=O.split("<=");return i.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(O)){const F=O.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(O)?w.create(O.substr(1).trim()):y.create(O)}static g(O,B){if(O=O.trim(),O==="true")return!0;if(O==="false")return!1;const F=/^'([^']*)'$/.exec(O);return F?F[1].trim():O}static h(O,B){if((0,t.isFalsyOrWhitespace)(O)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=O.indexOf("/"),$=O.lastIndexOf("/");if(F===$||F<0){if(B)throw new Error(`bad regexp-value '${O}', missing /-enclosure`);return console.warn(`bad regexp-value '${O}', missing /-enclosure`),null}const M=O.slice(F+1,$),V=O[$+1]==="i"?"i":"";try{return new RegExp(M,V)}catch(q){if(B)throw new Error(`bad regexp-value '${O}', parse error: ${q}`);return console.warn(`bad regexp-value '${O}', parse error: ${q}`),null}}}e.ContextKeyExpr=S;function C(G,O){const B=G?G.substituteConstants():void 0,F=O?O.substituteConstants():void 0;return!B&&!F?!0:!B||!F?!1:B.equals(F)}e.expressionsAreEqualWithConstantSubstitution=C;function R(G,O){return G.cmp(O)}class P{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class E{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class y{static create(O,B=null){const F=A.get(O);return typeof F=="boolean"?F?E.INSTANCE:P.INSTANCE:new y(O,B)}constructor(O,B){this.key=O,this.c=B,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:p(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=A.get(this.key);return typeof O=="boolean"?O?E.INSTANCE:P.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=w.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=y;class v{static create(O,B,F=null){if(typeof B=="boolean")return B?y.create(O,F):w.create(O,F);const $=A.get(O);return typeof $=="boolean"?B===($?"true":"false")?E.INSTANCE:P.INSTANCE:new v(O,B,F)}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=A.get(this.c);if(typeof O=="boolean"){const B=O?"true":"false";return this.d===B?E.INSTANCE:P.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=v;class d{static create(O,B){return new d(O,B)}constructor(O,B){this.d=O,this.f=B,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:k(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const B=O.getValue(this.f),F=O.getValue(this.d);return Array.isArray(B)?B.includes(F):typeof F=="string"&&typeof B=="object"&&B!==null?D.call(B,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=d;class g{static create(O,B){return new g(O,B)}constructor(O,B){this.d=O,this.f=B,this.type=11,this.c=d.create(O,B)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=g;class f{static create(O,B,F=null){if(typeof B=="boolean")return B?w.create(O,F):y.create(O,F);const $=A.get(O);return typeof $=="boolean"?B===($?"true":"false")?P.INSTANCE:E.INSTANCE:new f(O,B,F)}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=A.get(this.c);if(typeof O=="boolean"){const B=O?"true":"false";return this.d===B?P.INSTANCE:E.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=f;class w{static create(O,B=null){const F=A.get(O);return typeof F=="boolean"?F?P.INSTANCE:E.INSTANCE:new w(O,B)}constructor(O,B){this.c=O,this.d=B,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:p(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=A.get(this.c);return typeof O=="boolean"?O?P.INSTANCE:E.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.ContextKeyNotExpr=w;function m(G,O){if(typeof G=="string"){const B=parseFloat(G);isNaN(B)||(G=B)}return typeof G=="string"||typeof G=="number"?O(G):P.INSTANCE}class h{static create(O,B,F=null){return m(B,$=>new h(O,$,F))}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=h;class b{static create(O,B,F=null){return m(B,$=>new b(O,$,F))}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=b;class s{static create(O,B,F=null){return m(B,$=>new s(O,$,F))}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class i{static create(O,B,F=null){return m(B,$=>new i(O,$,F))}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=i;class c{static create(O,B){return new c(O,B)}constructor(O,B){this.d=O,this.f=B,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const B=this.f?this.f.source:"",F=O.f?O.f.source:"";return B<F?-1:B>F?1:0}equals(O){if(O.type===this.type){const B=this.f?this.f.source:"",F=O.f?O.f.source:"";return this.d===O.d&&B===F}return!1}substituteConstants(){return this}evaluate(O){const B=O.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=c;class u{static create(O){return new u(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(O){return new u(this.c.map(O))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function r(G){let O=null;for(let B=0,F=G.length;B<F;B++){const $=G[B].substituteConstants();if(G[B]!==$&&O===null){O=[];for(let M=0;M<B;M++)O[M]=G[M]}O!==null&&(O[B]=$)}return O===null?G:O}class o{static create(O,B,F){return o.d(O,B,F)}constructor(O,B){this.expr=O,this.c=B,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let B=0,F=this.expr.length;B<F;B++){const $=R(this.expr[B],O.expr[B]);if($!==0)return $}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let B=0,F=this.expr.length;B<F;B++)if(!this.expr[B].equals(O.expr[B]))return!1;return!0}return!1}substituteConstants(){const O=r(this.expr);return O===this.expr?this:o.create(O,this.c,!1)}evaluate(O){for(let B=0,F=this.expr.length;B<F;B++)if(!this.expr[B].evaluate(O))return!1;return!0}static d(O,B,F){const $=[];let M=!1;for(const V of O)if(!!V){if(V.type===1){M=!0;continue}if(V.type===0)return P.INSTANCE;if(V.type===6){$.push(...V.expr);continue}$.push(V)}if($.length===0&&M)return E.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(R);for(let V=1;V<$.length;V++)$[V-1].equals($[V])&&($.splice(V,1),V--);if($.length===1)return $[0];for(;$.length>1;){const V=$[$.length-1];if(V.type!==9)break;$.pop();const q=$.pop(),H=$.length===0,J=n.create(V.expr.map(Y=>o.create([Y,q],null,F)),null,H);J&&($.push(J),$.sort(R))}if($.length===1)return $[0];if(F){for(let V=0;V<$.length;V++)for(let q=V+1;q<$.length;q++)if($[V].negate().equals($[q]))return P.INSTANCE;if($.length===1)return $[0]}return new o($,B)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const B of this.expr)O.push(...B.keys());return O}map(O){return new o(this.expr.map(B=>B.map(O)),null)}negate(){if(!this.c){const O=[];for(const B of this.expr)O.push(B.negate());this.c=n.create(O,this,!0)}return this.c}}class n{static create(O,B,F){return n.d(O,B,F)}constructor(O,B){this.expr=O,this.c=B,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let B=0,F=this.expr.length;B<F;B++){const $=R(this.expr[B],O.expr[B]);if($!==0)return $}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let B=0,F=this.expr.length;B<F;B++)if(!this.expr[B].equals(O.expr[B]))return!1;return!0}return!1}substituteConstants(){const O=r(this.expr);return O===this.expr?this:n.create(O,this.c,!1)}evaluate(O){for(let B=0,F=this.expr.length;B<F;B++)if(this.expr[B].evaluate(O))return!0;return!1}static d(O,B,F){let $=[],M=!1;if(O){for(let V=0,q=O.length;V<q;V++){const H=O[V];if(!!H){if(H.type===0){M=!0;continue}if(H.type===1)return E.INSTANCE;if(H.type===9){$=$.concat(H.expr);continue}$.push(H)}}if($.length===0&&M)return P.INSTANCE;$.sort(R)}if($.length!==0){if($.length===1)return $[0];for(let V=1;V<$.length;V++)$[V-1].equals($[V])&&($.splice(V,1),V--);if($.length===1)return $[0];if(F){for(let V=0;V<$.length;V++)for(let q=V+1;q<$.length;q++)if($[V].negate().equals($[q]))return E.INSTANCE;if($.length===1)return $[0]}return new n($,B)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const B of this.expr)O.push(...B.keys());return O}map(O){return new n(this.expr.map(B=>B.map(O)),null)}negate(){if(!this.c){const O=[];for(const B of this.expr)O.push(B.negate());for(;O.length>1;){const B=O.shift(),F=O.shift(),$=[];for(const M of K(B))for(const V of K(F))$.push(o.create([M,V],null,!1));O.unshift(n.create($,null,!1))}this.c=n.create(O,this,!0)}return this.c}}class l extends y{static all(){return l.d.values()}constructor(O,B,F){super(O,null),this.f=B,typeof F=="object"?l.d.push({...F,key:O}):F!==!0&&l.d.push({key:O,description:F,type:B!=null?typeof B:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return v.create(this.key,O)}notEqualsTo(O){return f.create(this.key,O)}}e.RawContextKey=l,l.d=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(G,O){return G<O?-1:G>O?1:0}function k(G,O,B,F){return G<B?-1:G>B?1:O<F?-1:O>F?1:0}function L(G,O){if(G.type===0||O.type===1)return!0;if(G.type===9)return O.type===9?U(G.expr,O.expr):!1;if(O.type===9){for(const B of O.expr)if(L(G,B))return!0;return!1}if(G.type===6){if(O.type===6)return U(O.expr,G.expr);for(const B of G.expr)if(L(B,O))return!0;return!1}return G.equals(O)}e.implies=L;function U(G,O){let B=0,F=0;for(;B<G.length&&F<O.length;){const $=G[B].cmp(O[F]);if($<0)return!1;$===0&&B++,F++}return B===G.length}function K(G){return G.type===9?G.expr:[G]}}),define(Se[193],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Se[121],ye([1,0,166,3]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function I(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function D(f,w){switch(f){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function T(f,w){return w==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(f,w,m){return T(w,m)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===m?!0:C(m).includes(f)}e.isTargetPlatformCompatible=S;function C(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function R(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=R;var P;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var E;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var y;(function(f){f.Install="install",f.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var d;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(w,m){super(w),this.code=m,this.name=m}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Se[194],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(Se[195],ye([1,0,44,15,9,12,106,29,114,168,194]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=C.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends E{openTerminal(h,b){return this.spawnTerminal(a,h,S.getWindowsShell(),b)}spawnTerminal(h,b,s,i){const c=b.windowsExec||y.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const u=I.basename(c).toLowerCase();if(u==="cmder"||u==="cmder.exe")return h.spawn(c,i?[i]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return c.indexOf(" ")>=0&&r.push('""'),r.push(c),(u==="wt"||u==="wt.exe")&&r.push("-d ."),new Promise((o,n)=>{const l=g(process),p=h.spawn(s,r,{cwd:i,env:l});p.on("error",n),p.on("exit",()=>o())})}runInTerminal(h,b,s,i,c){const u="windowsExec"in c&&c.windowsExec?c.windowsExec:y.getDefaultTerminalWindows();return new Promise((r,o)=>{const n=`"${b} - ${P}"`,l=`""${s.join('" "')}" & pause"`,p=["/c","start",n,"/wait",u,"/c",l],k=Object.assign({},g(process),i);Object.keys(k).filter(K=>k[K]===null).forEach(K=>delete k[K]);const L={cwd:b,env:k,windowsVerbatimArguments:!0};a.spawn(y.b,p,L).on("error",K=>{o(f(K))}),r(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.WindowsExternalTerminalService=y,y.b="cmd.exe";class v extends E{openTerminal(h,b){return this.spawnTerminal(a,h,b)}runInTerminal(h,b,s,i,c){const u=c.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{if(u===R.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const n=u===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",h||P,"-w",b];for(const U of s)p.push("-a"),p.push(U);if(i){const U=Object.assign({},g(process),i);for(const K in U){const G=U[K];G===null?(p.push("-u"),p.push(K)):(p.push("-e"),p.push(`${K}=${G}`))}}let k="";const L=a.spawn(v.b,p);L.on("error",U=>{o(f(U))}),L.stderr.on("data",U=>{k+=U.toString()}),L.on("exit",U=>{if(U===0)r(void 0);else if(k){const K=k.split(`
`,1);o(new Error(K[0]))}else o(new Error(C.localize(1,null,n,U)))})}else o(new Error(C.localize(2,null,u)))})}spawnTerminal(h,b,s){const i=b.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((c,u)=>{const r=["-a",i];s&&r.push(s);const o=g(process),n=h.spawn("/usr/bin/open",r,{cwd:s,env:o});n.on("error",u),n.on("exit",()=>c())})}}e.MacExternalTerminalService=v,v.b="/usr/bin/osascript";class d extends E{openTerminal(h,b){return this.spawnTerminal(a,h,b)}runInTerminal(h,b,s,i,c){const u=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{const n=[];u.then(l=>{l.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const p=`${w(s)}; echo; read -p "${d.b}" -n1;`;n.push(`''${p}''`);const k=Object.assign({},g(process),i);Object.keys(k).filter(G=>k[G]===null).forEach(G=>delete k[G]);const L={cwd:b,env:k};let U="";const K=a.spawn(l,n,L);K.on("error",G=>{o(f(G))}),K.stderr.on("data",G=>{U+=G.toString()}),K.on("exit",G=>{if(G===0)r(void 0);else if(U){const O=U.split(`
`,1);o(new Error(O[0]))}else o(new Error(C.localize(4,null,l,G)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!A.isLinux)d.d=Promise.resolve("xterm");else{const h=await T.Promises.exists("/etc/debian_version");d.d=new Promise(b=>{h?b("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?b("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?b("konsole"):process.env.COLORTERM?b(process.env.COLORTERM):process.env.TERM?b(process.env.TERM):b("xterm")})}return d.d}spawnTerminal(h,b,s){const i=b.linuxExec?Promise.resolve(b.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((c,u)=>{i.then(r=>{const o=g(process),n=h.spawn(r,[],{cwd:s,env:o});n.on("error",u),n.on("exit",()=>c())})})}}e.LinuxExternalTerminalService=d,d.b=C.localize(3,null);function g(m){const h={...m.env};return(0,D.sanitizeProcessEnvironment)(h),h}function f(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(C.localize(5,null,m.path)):m}function w(m){let h="";for(const b of m)b.indexOf(" ")>=0?h+='"'+b+'"':h+=b,h+=" ";return h}}),define(Se[38],ye([1,0,64,9,8,11,2,169,3]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(M){return M.create===!0}e.isFileOpenForWriteOptions=C;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var P;(function(M){M[M.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var E;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function v(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(M){return!!(M.capabilities&32768)}e.hasFileCloneCapability=d;function g(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function f(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=f;function w(M){return y(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var m;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(V,q){super(V),this.code=q}}e.FileSystemProviderError=h;function b(M,V){const q=new h(M.toString(),V);return i(q,V),q}e.createFileSystemProviderError=b;function s(M){return M||b((0,T.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=s;function i(M,V){return M.name=V?`${V} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=i;function c(M){if(!M)return m.Unknown;if(M instanceof h)return M.code;const V=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!V)return m.Unknown;switch(V[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=c;function u(M){if(M instanceof k)return M.fileOperationResult;switch(c(M)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class o{constructor(V,q,H){this.resource=V,this.operation=q,this.target=H}isOperation(V){return this.operation===V}}e.FileOperationEvent=o;var n;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class l{constructor(V,q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=V;const H=new Map;for(const J of V){const Y=H.get(J.type);switch(Y?Y.push([J.resource,J]):H.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,Y]of H)switch(J){case 1:this.a=a.TernarySearchTree.forUris(()=>q),this.a.fill(Y);break;case 0:this.b=a.TernarySearchTree.forUris(()=>q),this.b.fill(Y);break;case 2:this.c=a.TernarySearchTree.forUris(()=>q),this.c.fill(Y);break}}contains(V,...q){return this.d(V,{includeChildren:!1},...q)}affects(V,...q){return this.d(V,{includeChildren:!0},...q)}d(V,q,...H){if(!V)return!1;const J=H.length>0;return!!((!J||H.includes(1))&&(this.a?.get(V)||q.includeChildren&&this.a?.findSuperstr(V))||(!J||H.includes(0))&&(this.b?.get(V)||q.includeChildren&&this.b?.findSuperstr(V))||(!J||H.includes(2))&&(this.c?.findSubstr(V)||q.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=l;function p(M,V,q){return!M||!V||M===V||V.length>M.length?!1:(V.charAt(V.length-1)!==t.sep&&(V+=t.sep),q?(0,I.startsWithIgnoreCase)(M,V):M.indexOf(V)===0)}e.isParent=p;class k extends Error{constructor(V,q,H){super(V),this.fileOperationResult=q,this.options=H}}e.FileOperationError=k;class L extends k{constructor(V,q,H){super(V,2,H),this.stat=q}}e.NotModifiedSinceFileOperationError=L;var U;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var K;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(K=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=G;async function O(M,V){if(!V.hasProvider(D.URI.from({scheme:M.scheme})))return new Promise(q=>{const H=V.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===M.scheme&&J.added&&(H.dispose(),q())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(V){return(0,A.isNumber)(V)||(V=0),V<B.KB?(0,T.localize)(1,null,V.toFixed(0)):V<B.MB?(0,T.localize)(2,null,(V/B.KB).toFixed(2)):V<B.GB?(0,T.localize)(3,null,(V/B.MB).toFixed(2)):V<B.TB?(0,T.localize)(4,null,(V/B.GB).toFixed(2)):(0,T.localize)(5,null,(V/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(M){return{maxFileSize:M===0?300*B.MB:16*B.GB,maxHeapSize:M===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=$}),define(Se[87],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...I){this.a=new Map;for(const[A,D]of I)this.set(A,D)}set(I,A){const D=this.a.get(I);return this.a.set(I,A),D}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.ServiceCollection=a}),define(Se[196],ye([1,0,18,10,6,120,192,3,87,63]),function(te,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class P extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class E{constructor(g=new S.ServiceCollection,f=!1,w,m=R){this.f=g,this.g=f,this.h=w,this.i=m,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=m?w?._globalGraph??new D.Graph(h=>h):void 0}createChild(g){return new E(g,this.g,this,this.i)}invokeFunction(g,...f){const w=v.traceInvocation(this.i,g);let m=!1;try{return g({get:b=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(b,w);if(!s)throw new Error(`[invokeFunction] unknown service '${b}'`);return s}},...f)}finally{m=!0,w.stop()}}createInstance(g,...f){let w,m;return g instanceof A.SyncDescriptor?(w=v.traceCreation(this.i,g.ctor),m=this.j(g.ctor,g.staticArguments.concat(f),w)):(w=v.traceCreation(this.i,g),m=this.j(g,f,w)),w.stop(),m}j(g,f=[],w){const m=T._util.getServiceDependencies(g).sort((s,i)=>s.index-i.index),h=[];for(const s of m){const i=this.m(s.id,w);i||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${s.id}.`,!1),h.push(i)}const b=m.length>0?m[0].index:f.length;if(f.length!==b){console.trace(`[createInstance] First service dependency of ${g.name} at position ${b+1} conflicts with ${f.length} static arguments`);const s=b-f.length;s>0?f=f.concat(new Array(s)):f=f.slice(0,b)}return Reflect.construct(g,f.concat(h))}k(g,f){if(this.f.get(g)instanceof A.SyncDescriptor)this.f.set(g,f);else if(this.h)this.h.k(g,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const f=this.f.get(g);return!f&&this.h?this.h.l(g):f}m(g,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const w=this.l(g);return w instanceof A.SyncDescriptor?this.q(g,w,f.branch(g,!0)):(f.branch(g,!1),w)}q(g,f,w){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,f,w)}finally{this.o.delete(g)}}r(g,f,w){const m=new D.Graph(s=>s.id.toString());let h=0;const b=[{id:g,desc:f,_trace:w}];for(;b.length;){const s=b.pop();if(m.lookupOrInsertNode(s),h++>1e3)throw new P(m);for(const i of T._util.getServiceDependencies(s.desc.ctor)){const c=this.l(i.id);if(c||this.u(`[createInstance] ${g} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(i.id)),c instanceof A.SyncDescriptor){const u={id:i.id,desc:c,_trace:s._trace.branch(i.id,!0)};m.insertEdge(s,u),b.push(u)}}}for(;;){const s=m.roots();if(s.length===0){if(!m.isEmpty())throw new P(m);break}for(const{data:i}of s){if(this.l(i.id)instanceof A.SyncDescriptor){const u=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,u)}m.removeNode(i)}}return this.l(g)}s(g,f,w=[],m,h){if(this.f.get(g)instanceof A.SyncDescriptor)return this.t(g,f,w,m,h);if(this.h)return this.h.s(g,f,w,m,h);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(g,f,w=[],m,h){if(m){const b=new E(void 0,this.g,this,this.i);b.c=String(g);const s=new Map,i=new a.IdleValue(()=>{const c=b.j(f,w,h);for(const[u,r]of s){const o=c[u];if(typeof o=="function")for(const n of r)o.apply(c,n)}return s.clear(),c});return new Proxy(Object.create(null),{get(c,u){if(!i.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let n=s.get(u);return n||(n=new C.LinkedList,s.set(u,n)),(p,k,L)=>{const U=n.push([p,k,L]);return(0,I.toDisposable)(U)}}if(u in c)return c[u];const r=i.value;let o=r[u];return typeof o!="function"||(o=o.bind(r),c[u]=o),o},set(c,u,r){return i.value[u]=r,!0}})}else return this.j(f,w,h)}u(g,f){if(f&&console.warn(g),this.g)throw new Error(g)}}e.InstantiationService=E;var y;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(y||(y={}));class v{static traceInvocation(g,f){return g?new v(1,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(g,f){return g?new v(0,f.name):v.c}constructor(g,f){this.type=g,this.name=f,this.g=Date.now(),this.h=[]}branch(g,f){const w=new v(2,g.toString());return this.h.push([g,f,w]),w}stop(){const g=Date.now()-this.g;v.f+=g;let f=!1;function w(h,b){const s=[],i=new Array(h+1).join("	");for(const[c,u,r]of b.h)if(u&&r){f=!0,s.push(`${i}CREATES -> ${c}`);const o=w(h+1,r);o&&s.push(o)}else s.push(`${i}uses -> ${c}`);return s.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(g>2||f)&&v.all.add(m.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v.f=0}),define(Se[13],ye([1,0,50,4,6,28,12,2,3]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function C(){return new Date().toISOString()}var R;(function(o){o[o.Off=0]="Off",o[o.Trace=1]="Trace",o[o.Debug=2]="Debug",o[o.Info=3]="Info",o[o.Warning=4]="Warning",o[o.Error=5]="Error"})(R=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=R.Info;function P(o,n,l){switch(n){case R.Trace:o.trace(l);break;case R.Debug:o.debug(l);break;case R.Info:o.info(l);break;case R.Warning:o.warn(l);break;case R.Error:o.error(l);break;default:throw new Error(`Invalid log level ${n}`)}}e.log=P;function E(o){let n="";for(let l=0;l<o.length;l++){let p=o[l];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}n+=(l>0?" ":"")+p}return n}e.format=E;class y extends I.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}}e.AbstractLogger=y;class v extends y{constructor(n){super(),this.g=n}h(n){return this.g||this.getLevel()<=n}trace(n,...l){this.h(R.Trace)&&this.f(R.Trace,E([n,...l]))}debug(n,...l){this.h(R.Debug)&&this.f(R.Debug,E([n,...l]))}info(n,...l){this.h(R.Info)&&this.f(R.Info,E([n,...l]))}warn(n,...l){this.h(R.Warning)&&this.f(R.Warning,E([n,...l]))}error(n,...l){if(this.h(R.Error))if(n instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=n.stack,this.f(R.Error,E(p))}else this.f(R.Error,E([n,...l]))}flush(){}}e.AbstractMessageLogger=v;class d extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.f=!D.isWindows}trace(n,...l){this.getLevel()<=R.Trace&&(this.f?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...l):console.log(`[main ${C()}]`,n,...l))}debug(n,...l){this.getLevel()<=R.Debug&&(this.f?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...l):console.log(`[main ${C()}]`,n,...l))}info(n,...l){this.getLevel()<=R.Info&&(this.f?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...l):console.log(`[main ${C()}]`,n,...l))}warn(n,...l){this.getLevel()<=R.Warning&&(this.f?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,n,...l):console.warn(`[main ${C()}]`,n,...l))}error(n,...l){this.getLevel()<=R.Error&&(this.f?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,n,...l):console.error(`[main ${C()}]`,n,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class g extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...l){this.getLevel()<=R.Trace&&console.log("%cTRACE","color: #888",n,...l)}debug(n,...l){this.getLevel()<=R.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...l)}info(n,...l){this.getLevel()<=R.Info&&console.log("%c INFO","color: #33f",n,...l)}warn(n,...l){this.getLevel()<=R.Warning&&console.log("%c WARN","color: #993",n,...l)}error(n,...l){this.getLevel()<=R.Error&&console.log("%c  ERR","color: #f33",n,...l)}dispose(){}flush(){}}e.ConsoleLogger=g;class f extends y{constructor(n,l=e.DEFAULT_LOG_LEVEL){super(),this.f=n,this.setLevel(l)}trace(n,...l){this.getLevel()<=R.Trace&&this.f.log(R.Trace,[this.g(n),...l])}debug(n,...l){this.getLevel()<=R.Debug&&this.f.log(R.Debug,[this.g(n),...l])}info(n,...l){this.getLevel()<=R.Info&&this.f.log(R.Info,[this.g(n),...l])}warn(n,...l){this.getLevel()<=R.Warning&&this.f.log(R.Warning,[this.g(n),...l])}error(n,...l){this.getLevel()<=R.Error&&this.f.log(R.Error,[this.g(n),...l])}g(n){return typeof n=="string"?n:(0,a.toErrorMessage)(n,this.getLevel()<=R.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class w extends y{constructor(n){super(),this.f=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const l of this.f)l.setLevel(n);super.setLevel(n)}trace(n,...l){for(const p of this.f)p.trace(n,...l)}debug(n,...l){for(const p of this.f)p.debug(n,...l)}info(n,...l){for(const p of this.f)p.info(n,...l)}warn(n,...l){for(const p of this.f)p.warn(n,...l)}error(n,...l){for(const p of this.f)p.error(n,...l)}flush(){for(const n of this.f)n.flush()}dispose(){for(const n of this.f)n.dispose()}}e.MultiplexLogService=w;class m extends I.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...l){this.b.trace(n,...l)}debug(n,...l){this.b.debug(n,...l)}info(n,...l){this.b.info(n,...l)}warn(n,...l){this.b.warn(n,...l)}error(n,...l){this.b.error(n,...l)}flush(){this.b.flush()}}e.LogService=m;class h extends I.Disposable{constructor(n,l){super(),this.c=n,this.b=new A.ResourceMap,this.B(l(p=>this.setLevel(p)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,l,p){let k=this.b.get(n)?.logger;return k||(p=l?.always?R.Trace:p,k=this.f(n,p??this.c,l),this.b.set(n,{logger:k,logLevel:p})),k}setLevel(n,l){const p=T.URI.isUri(n)?n:void 0,k=p?l:n;if(p){const L=this.b.get(p);L&&L.logLevel!==k&&(L.logLevel=k,L.logger.setLevel(k))}else this.c=k,this.b.forEach(({logLevel:L,logger:U})=>{L===void 0&&U.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=h;class b{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return R.Info}trace(n,...l){}debug(n,...l){}info(n,...l){}warn(n,...l){}error(n,...l){}critical(n,...l){}dispose(){}flush(){}}e.NullLogger=b;class s extends b{}e.NullLogService=s;class i extends h{constructor(){super(R.Info,t.Event.None)}f(n,l,p){return new b}}e.NullLoggerService=i;function c(o){if(o.verbose)return R.Trace;if(typeof o.logLevel=="string"){const n=r(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(o){switch(o){case R.Trace:return"trace";case R.Debug:return"debug";case R.Info:return"info";case R.Warning:return"warn";case R.Error:return"error";case R.Off:return"off"}}e.LogLevelToString=u;function r(o){switch(o){case"trace":return R.Trace;case"debug":return R.Debug;case"info":return R.Info;case"warn":return R.Warning;case"error":return R.Error;case"critical":return R.Error;case"off":return R.Off}}e.parseLogLevel=r}),define(Se[197],ye([1,0,38,13]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(I||(I={}));async function A(C,R,P,E,y){try{const v=await new Promise((g,f)=>{te(["spdlog"],g,f)});v.setFlushOn(t.LogLevel.Trace);const d=await v.createAsyncRotatingLogger(C,R,P,E);return y?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(v){console.error(v)}return null}function D(C,R,P){switch(R){case t.LogLevel.Trace:C.trace(P);break;case t.LogLevel.Debug:C.debug(P);break;case t.LogLevel.Info:C.info(P);break;case t.LogLevel.Warning:C.warn(P);break;case t.LogLevel.Error:C.error(P);break;default:throw new Error(`Invalid log level ${R}`)}}function T(C,R){switch(R){case t.LogLevel.Trace:C.setLevel(I.Trace);break;case t.LogLevel.Debug:C.setLevel(I.Debug);break;case t.LogLevel.Info:C.setLevel(I.Info);break;case t.LogLevel.Warning:C.setLevel(I.Warning);break;case t.LogLevel.Error:C.setLevel(I.Error);break;case t.LogLevel.Off:C.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class S extends t.AbstractMessageLogger{constructor(R,P,E,y,v){super(),this.j=[],this.setLevel(v),this.k=this.m(R,P,E,y),this.B(this.onDidChangeLogLevel(d=>{this.l&&T(this.l,d)}))}async m(R,P,E,y){const v=E?6:1,d=30/v*a.ByteSize.MB,g=await A(R,P,d,v,y);if(g){this.l=g,T(this.l,this.getLevel());for(const{level:f,message:w}of this.j)D(this.l,f,w);this.j=[]}}f(R,P){this.l?D(this.l,R,P):this.getLevel()<=R&&this.j.push({level:R,message:P})}flush(){this.l?this.l.flush():this.k.then(()=>this.flush())}dispose(){this.l?this.p():this.k.then(()=>this.p())}p(){this.l&&(this.l.drop(),this.l=void 0)}}e.SpdLogLogger=S}),define(Se[122],ye([1,0,42,170,3]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var D;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(v,d){return d-v}S.compare=C;const R=Object.create(null);R[S.Error]=(0,t.localize)(0,null),R[S.Warning]=(0,t.localize)(1,null),R[S.Info]=(0,t.localize)(2,null);function P(v){return R[v]||""}S.toString=P;function E(v){switch(v){case a.default.Error:return S.Error;case a.default.Warning:return S.Warning;case a.default.Info:return S.Info;case a.default.Ignore:return S.Hint}}S.fromSeverity=E;function y(v){switch(v){case S.Error:return a.default.Error;case S.Warning:return a.default.Warning;case S.Info:return a.default.Info;case S.Hint:return a.default.Ignore}}S.toSeverity=y}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const C="";function R(E){return P(E,!0)}S.makeKey=R;function P(E,y){const v=[C];return E.source?v.push(E.source.replace("\xA6","\\\xA6")):v.push(C),E.code?typeof E.code=="string"?v.push(E.code.replace("\xA6","\\\xA6")):v.push(E.code.value.replace("\xA6","\\\xA6")):v.push(C),E.severity!==void 0&&E.severity!==null?v.push(D.toString(E.severity)):v.push(C),E.message&&y?v.push(E.message.replace("\xA6","\\\xA6")):v.push(C),E.startLineNumber!==void 0&&E.startLineNumber!==null?v.push(E.startLineNumber.toString()):v.push(C),E.startColumn!==void 0&&E.startColumn!==null?v.push(E.startColumn.toString()):v.push(C),E.endLineNumber!==void 0&&E.endLineNumber!==null?v.push(E.endLineNumber.toString()):v.push(C),E.endColumn!==void 0&&E.endColumn!==null?v.push(E.endColumn.toString()):v.push(C),v.push(C),v.join("\xA6")}S.makeKeyOptionalMessage=P})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(Se[198],ye([1,0,4,42,3]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=S}),define(Se[123],ye([1,0,8,2,3]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService");function A(C,R){return t.URI.isUri(C)?(0,a.equalsIgnoreCase)(C.scheme,R):(0,a.startsWithIgnoreCase)(C,R+":")}e.matchesScheme=A;function D(C,...R){return R.some(P=>A(C,P))}e.matchesSomeScheme=D;function T(C,R){return C.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=T;function S(C){let R;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(C.fragment);return P&&(R={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},C=C.with({fragment:""})),{selection:R,uri:C}}e.extractSelection=S}),define(Se[199],ye([1,0,12,36]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const A=a.globals.vscode.context.configuration();if(A)I=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(I=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`,serverDataFolderName:I.serverDataFolderName?`${I.serverDataFolderName}-dev`:void 0}),!I.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(I,{version:A.version})}}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=I}),define(Se[200],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__param||function(te,e){return function(a,t){e(a,t,te)}};define(Se[124],ye([1,0,18,21,6,3]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(P,E){super(),this.a=new a.DeferredPromise,E.withProgress(P,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,I.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};S=Ve([ze(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends I.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new I.DisposableStore)}start(P){this.stop();const E=++this.a,y=new t.CancellationTokenSource;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,I.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,I.toDisposable)(()=>y.cancel())),this.b.add((0,I.toDisposable)(()=>this.c?this.c.done():void 0)),{id:E,token:y.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Se[43],ye([1,0,48,11]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.a=new Map}add(D,T){a.ok(t.isString(D)),a.ok(t.isObject(T)),a.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,T)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new I}),define(Se[125],ye([1,0,4,43]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class A{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,C){this.a[I(S)]=C,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const D=new A;t.Registry.add(e.Extensions.JSONContribution,D)}),define(Se[126],ye([1,0,17,4,11,165,52,125,43]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=S.Registry.as(T.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(s,i=!0){this.registerConfigurations([s],i)}registerConfigurations(s,i=!0){const c=this.k(s,i);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(s){const i=this.l(s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:s,remove:i}){const c=[];c.push(...this.l(i)),c.push(...this.k(s,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,a.distinct)(c)})}registerDefaultConfigurations(s){const i=[],c=[];for(const{overrides:u,source:r}of s)for(const o in u)if(i.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const n=this.a.get(o),l=n?.valuesSources??new Map;if(r)for(const U of Object.keys(u[o]))l.set(U,r);const p={...n?.value||{},...u[o]};this.a.set(o,{source:r,value:p,valuesSources:l});const k=(0,D.getLanguageTagSettingPlainKey)(o),L={type:"object",default:p,description:A.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:I.isString(r)?void 0:r,defaultValueSource:r};c.push(...d(o)),this.d[o]=L,this.b.properties[o]=L}else{this.a.set(o,{value:u[o],source:r});const n=this.d[o];n&&(this.s(o,n),this.o(o,n))}this.registerOverrideIdentifiers(c),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const i=[];for(const{overrides:c,source:u}of s)for(const r in c){const o=this.a.get(r),n=I.isString(u)?u:u?.id,l=I.isString(o?.source)?o?.source:o?.source?.id;if(n===l)if(i.push(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const p=this.d[r];p&&(this.s(r,p),this.o(r,p))}}this.q(),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){for(const i of s)this.h.add(i);this.q()}k(s,i){const c=[];return s.forEach(u=>{c.push(...this.m(u,i,u.extensionInfo,u.restrictedProperties)),this.c.push(u),this.n(u)}),c}l(s){const i=[],c=u=>{if(u.properties)for(const r in u.properties){i.push(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.p(r,u.properties[r])}u.allOf?.forEach(r=>c(r))};for(const u of s){c(u);const r=this.c.indexOf(u);r!==-1&&this.c.splice(r,1)}return i}m(s,i=!0,c,u,r=3){r=I.isUndefinedOrNull(s.scope)?r:s.scope;const o=[],n=s.properties;if(n)for(const p in n){const k=n[p];if(i&&m(p,k)){delete n[p];continue}if(k.source=c,k.defaultDefaultValue=n[p].default,this.s(p,k),e.OVERRIDE_PROPERTY_REGEX.test(p)?k.scope=void 0:(k.scope=I.isUndefinedOrNull(k.scope)?r:k.scope,k.restricted=I.isUndefinedOrNull(k.restricted)?!!u?.includes(p):k.restricted),n[p].hasOwnProperty("included")&&!n[p].included){this.f[p]=n[p],delete n[p];continue}else this.d[p]=n[p],n[p].policy?.name&&this.e.set(n[p].policy.name,p);!n[p].deprecationMessage&&n[p].markdownDeprecationMessage&&(n[p].deprecationMessage=n[p].markdownDeprecationMessage),o.push(p)}const l=s.allOf;if(l)for(const p of l)o.push(...this.m(p,i,c,u,r));return o}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(s){const i=c=>{const u=c.properties;if(u)for(const o in u)this.o(o,u[o]);c.allOf?.forEach(i)};i(s)}o(s,i){switch(e.allSettings.properties[s]=i,i.scope){case 1:e.applicationSettings.properties[s]=i;break;case 2:e.machineSettings.properties[s]=i;break;case 6:e.machineOverridableSettings.properties[s]=i;break;case 3:e.windowSettings.properties[s]=i;break;case 4:e.resourceSettings.properties[s]=i;break;case 5:e.resourceSettings.properties[s]=i,this.g.properties[s]=i;break}}p(s,i){switch(delete e.allSettings.properties[s],i.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}q(){for(const s of this.h.values()){const i=`[${s}]`,c={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(i,c),e.allSettings.properties[i]=c,e.applicationSettings.properties[i]=c,e.machineSettings.properties[i]=c,e.machineOverridableSettings.properties[i]=c,e.windowSettings.properties[i]=c,e.resourceSettings.properties[i]=c}this.i.fire()}r(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}s(s,i){const c=this.a.get(s);let u=c?.value,r=c?.source;I.isUndefined(u)&&(u=i.defaultDefaultValue,r=void 0),I.isUndefined(u)&&(u=f(i.type)),i.default=u,i.defaultValueSource=r}}const y="\\[([^\\]]+)\\]",v=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(b){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let i=v.exec(b);for(;i?.length;){const c=i[1].trim();c&&s.push(c),i=v.exec(b)}}return(0,a.distinct)(s)}e.overrideIdentifiersFromKey=d;function g(b){return b.reduce((s,i)=>`${s}[${i}]`,"")}e.keyFromOverrideIdentifiers=g;function f(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const w=new E;S.Registry.add(e.Extensions.Configuration,w);function m(b,s){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?A.localize(7,null,b):w.getConfigurationProperties()[b]!==void 0?A.localize(8,null,b):s.policy?.name&&w.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,b,s.policy?.name,w.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.validateProperty=m;function h(){const b=[],s=w.getConfigurationProperties();for(const i of Object.keys(s))b.push([i,s[i].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=h}),define(Se[201],ye([1,0,17,4,145,6,28,23,11,2,52,126,43]),function(te,e,a,t,I,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(i={},c=[],u=[],r){this.c=i,this.d=c,this.f=u,this.raw=r,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(c=>{if(c instanceof y)return c;const u=new v("");return u.parseRaw(c),u.configurationModel});this.g=i.reduce((c,u)=>u===c?u:c.merge(u),i[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(i){return i?(0,R.getConfigurationValue)(this.contents,i):this.contents}inspect(i,c){const u=this.rawConfiguration.getValue(i),r=c?this.rawConfiguration.getOverrideValue(i,c):void 0,o=c?this.rawConfiguration.override(c).getValue(i):u;return{value:u,override:r,merged:o}}getOverrideValue(i,c){const u=this.l(c);return u?i?(0,R.getConfigurationValue)(u,i):u:void 0}getKeysForOverrideIdentifier(i){const c=[];for(const u of this.overrides)u.identifiers.includes(i)&&c.push(...u.keys);return a.distinct(c)}getAllOverrideIdentifiers(){const i=[];for(const c of this.overrides)i.push(...c.identifiers);return a.distinct(i)}override(i){let c=this.b.get(i);return c||(c=this.h(i),this.b.set(i,c)),c}merge(...i){const c=T.deepClone(this.contents),u=T.deepClone(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const n of i)if(o.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(c,n.contents);for(const l of n.overrides){const[p]=u.filter(k=>a.equals(k.identifiers,l.identifiers));p?(this.j(p.contents,l.contents),p.keys.push(...l.keys),p.keys=a.distinct(p.keys)):u.push(T.deepClone(l))}for(const l of n.keys)r.indexOf(l)===-1&&r.push(l)}return new y(c,r,u,o.every(n=>n instanceof y)?void 0:o)}freeze(){return this.a=!0,this}clone(){return new y(T.deepClone(this.contents),[...this.keys],T.deepClone(this.overrides))}h(i){const c=this.l(i);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const u={};for(const r of a.distinct([...Object.keys(this.contents),...Object.keys(c)])){let o=this.contents[r];const n=c[r];n&&(typeof o=="object"&&typeof n=="object"?(o=T.deepClone(o),this.j(o,n)):o=n),u[r]=o}return new y(u,this.keys,this.overrides)}j(i,c){for(const u of Object.keys(c)){if(u in i&&S.isObject(i[u])&&S.isObject(c[u])){this.j(i[u],c[u]);continue}i[u]=T.deepClone(c[u])}}k(i){return this.a&&!Object.isFrozen(i)?T.deepFreeze(i):i}l(i){let c=null,u=null;const r=o=>{o&&(u?this.j(u,o):u=T.deepClone(o))};for(const o of this.overrides)a.equals(o.identifiers,[i])?c=o.contents:o.identifiers.includes(i)&&r(o.contents);return r(c),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,c){this.m(i),(0,R.addToValueTree)(this.contents,i,c,u=>{throw new Error(u)})}removeValue(i){this.n(i)&&(0,R.removeFromValueTree)(this.contents,i)}m(i){let c=this.keys.length;for(let u=0;u<c;u++)i.indexOf(this.keys[u])===0&&(c=u);this.keys.splice(c,1,i)}n(i){const c=this.keys.indexOf(i);return c!==-1?(this.keys.splice(c,1),!0):!1}}e.ConfigurationModel=y;class v{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,c){if(!S.isUndefinedOrNull(i)){const u=this.g(i);this.parseRaw(u,c)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,c){this.a=i;const{contents:u,keys:r,overrides:o,restricted:n,hasExcludedProperties:l}=this.h(i,c);this.b=new y(u,r,o,l?[i]:void 0),this.c=n||[]}g(i){let c={},u=null,r=[];const o=[],n=[];function l(k){Array.isArray(r)?r.push(k):u!==null&&(r[u]=k)}const p={onObjectBegin:()=>{const k={};l(k),o.push(r),r=k,u=null},onObjectProperty:k=>{u=k},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const k=[];l(k),o.push(r),r=k,u=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:l,onError:(k,L,U)=>{n.push({error:k,offset:L,length:U})}};if(i)try{I.visit(i,p),c=r[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return c}h(i,c){const u=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.j(i,u,!0,c);i=r.raw;const o=(0,R.toValuesTree)(i,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),n=Object.keys(i),l=this.l(i,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:o,keys:n,overrides:l,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}j(i,c,u,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const n={},l=[];for(const p in i)if(P.OVERRIDE_PROPERTY_REGEX.test(p)&&u){const k=this.j(i[p],c,!1,r);n[p]=k.raw,o=o||k.hasExcludedProperties,l.push(...k.restricted)}else{const k=c[p],L=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&l.push(p),(L===void 0||r.scopes===void 0||r.scopes.includes(L))&&!(r.skipRestricted&&k?.restricted)?n[p]=i[p]:o=!0}return{raw:n,restricted:l,hasExcludedProperties:o}}l(i,c){const u=[];for(const r of Object.keys(i))if(P.OVERRIDE_PROPERTY_REGEX.test(r)){const o={};for(const n in i[r])o[n]=i[r][n];u.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(o),contents:(0,R.toValuesTree)(o,c)})}return u}}e.ConfigurationModelParser=v;class d extends A.Disposable{constructor(i,c,u,r){super(),this.f=i,this.g=c,this.h=r,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(u.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&u.isEqual(o.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class g{constructor(i,c,u,r,o,n,l,p,k,L,U,K,G){this.a=i,this.b=c,this.value=u,this.overrideIdentifiers=r,this.c=o,this.d=n,this.f=l,this.g=p,this.h=k,this.j=L,this.k=U,this.l=K,this.m=G}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get A(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class f{constructor(i,c,u,r,o=new y,n=new y,l=new D.ResourceMap,p=new y,k=new D.ResourceMap,L=!0){this.c=i,this.d=c,this.f=u,this.g=r,this.h=o,this.j=n,this.l=l,this.m=p,this.n=k,this.p=L,this.a=null,this.b=new D.ResourceMap,this.q=null}getValue(i,c,u){return this.s(i,c,u).getValue(i)}updateValue(i,c,u={}){let r;u.resource?(r=this.n.get(u.resource),r||(r=new y,this.n.set(u.resource,r))):r=this.m,c===void 0?r.removeValue(i):r.setValue(i,c),u.resource||(this.a=null)}inspect(i,c,u){const r=this.s(i,c,u),o=a.distinct(r.overrides.map(p=>p.identifiers).flat()).filter(p=>r.getOverrideValue(i,p)!==void 0),n=this.w(c.resource,u),l=c.resource?this.n.get(c.resource)||this.m:this.m;return new g(i,c,r.getValue(i),o.length?o:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),u?this.j.freeze():void 0,n?n.freeze():void 0,l.inspect(i,c.overrideIdentifier))}keys(i){const c=this.w(void 0,i);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:c?c.freeze().keys:[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.j=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,c){this.l.set(i,c),this.b.delete(i)}deleteFolderConfiguration(i){this.r.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,c){const u=[];if(!c){const{added:r,updated:o,removed:n}=h(this.c,i);c=[...r,...o,...n]}for(const r of c)for(const o of(0,P.overrideIdentifiersFromKey)(r)){const n=this.c.getKeysForOverrideIdentifier(o),l=i.getKeysForOverrideIdentifier(o),p=[...l.filter(k=>n.indexOf(k)===-1),...n.filter(k=>l.indexOf(k)===-1),...n.filter(k=>!T.equals(this.c.override(o).getValue(k),i.override(o).getValue(k)))];u.push([o,p])}return this.updateDefaultConfiguration(i),{keys:c,overrides:u}}compareAndUpdatePolicyConfiguration(i){const{added:c,updated:u,removed:r}=h(this.d,i),o=[...c,...u,...r];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:c,updated:u,removed:r,overrides:o}=h(this.applicationConfiguration,i),n=[...c,...u,...r];return n.length&&this.updateApplicationConfiguration(i),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:c,updated:u,removed:r,overrides:o}=h(this.localUserConfiguration,i),n=[...c,...u,...r];return n.length&&this.updateLocalUserConfiguration(i),{keys:n,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:c,updated:u,removed:r,overrides:o}=h(this.remoteUserConfiguration,i),n=[...c,...u,...r];return n.length&&this.updateRemoteUserConfiguration(i),{keys:n,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:c,updated:u,removed:r,overrides:o}=h(this.workspaceConfiguration,i),n=[...c,...u,...r];return n.length&&this.updateWorkspaceConfiguration(i),{keys:n,overrides:o}}compareAndUpdateFolderConfiguration(i,c){const u=this.r.get(i),{added:r,updated:o,removed:n,overrides:l}=h(u,c),p=[...r,...o,...n];return(p.length||!u)&&this.updateFolderConfiguration(i,c),{keys:p,overrides:l}}compareAndDeleteFolderConfiguration(i){const c=this.r.get(i);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:u,updated:r,removed:o,overrides:n}=h(c,void 0);return{keys:[...u,...r,...o],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(i,c,u){let r=this.t(c,u);return c.overrideIdentifier&&(r=r.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(r=r.merge(this.d)),r}t({resource:i},c){let u=this.u();if(c&&i){const r=c.getFolder(i);r&&(u=this.v(r.uri)||u);const o=this.n.get(i);o&&(u=u.merge(o))}return u}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(i){let c=this.b.get(i);if(!c){const u=this.u(),r=this.l.get(i);r?(c=u.merge(r),this.p&&(c=c.freeze()),this.b.set(i,c)):c=u}return c}w(i,c){if(c&&i){const u=c.getFolder(i);if(u)return this.l.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((i,c)=>{const{contents:u,overrides:r,keys:o}=this.l.get(c);return i.push([c,{contents:u,overrides:r,keys:o}]),i},[])}}allKeys(){const i=new Set;return this.c.freeze().keys.forEach(c=>i.add(c)),this.userConfiguration.freeze().keys.forEach(c=>i.add(c)),this.j.freeze().keys.forEach(c=>i.add(c)),this.l.forEach(c=>c.freeze().keys.forEach(u=>i.add(u))),[...i.values()]}x(){const i=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.j.freeze().getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.l.forEach(c=>c.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u))),[...i.values()]}y(i){const c=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(u=>c.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>c.add(u)),this.j.getKeysForOverrideIdentifier(i).forEach(u=>c.add(u)),this.l.forEach(u=>u.getKeysForOverrideIdentifier(i).forEach(r=>c.add(r))),[...c.values()]}static parse(i){const c=this.A(i.defaults),u=this.A(i.policy),r=this.A(i.application),o=this.A(i.user),n=this.A(i.workspace),l=i.folders.reduce((p,k)=>(p.set(C.URI.revive(k[0]),this.A(k[1])),p),new D.ResourceMap);return new f(c,u,r,o,new y,n,l,new y,new D.ResourceMap,!1)}static A(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=f;function w(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,c=new Map;for(const r of s)r.keys.forEach(o=>i.add(o)),r.overrides.forEach(([o,n])=>{const l=(0,D.getOrSet)(c,o,new Set);n.forEach(p=>l.add(p))});const u=[];return c.forEach((r,o)=>u.push([o,[...r.values()]])),{keys:[...i.values()],overrides:u}}e.mergeChanges=w;class m{constructor(i,c,u,r){this.change=i,this.b=c,this.c=u,this.d=r,this.f=void 0;const o=new Set;i.keys.forEach(l=>o.add(l)),i.overrides.forEach(([,l])=>l.forEach(p=>o.add(p))),this.affectedKeys=[...o.values()];const n=new y;this.affectedKeys.forEach(l=>n.setValue(l,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=f.parse(this.b.data)),this.f}affectsConfiguration(i,c){if(this.g(this.a,i)){if(c){const u=this.previousConfiguration?this.previousConfiguration.getValue(i,c,this.b?.workspace):void 0,r=this.c.getValue(i,c,this.d);return!T.equals(u,r)}return!0}return!1}g(i,c){let u=(0,R.toValuesTree)({[c]:!0},()=>{}),r;for(;typeof u=="object"&&(r=Object.keys(u)[0]);){if(i=i[r],!i)return!1;u=u[r]}return!0}}e.ConfigurationChangeEvent=m;function h(s,i){const{added:c,removed:u,updated:r}=b(i?.rawConfiguration,s?.rawConfiguration),o=[],n=s?.getAllOverrideIdentifiers()||[],l=i?.getAllOverrideIdentifiers()||[];if(i){const p=l.filter(k=>!n.includes(k));for(const k of p)o.push([k,i.getKeysForOverrideIdentifier(k)])}if(s){const p=n.filter(k=>!l.includes(k));for(const k of p)o.push([k,s.getKeysForOverrideIdentifier(k)])}if(i&&s){for(const p of n)if(l.includes(p)){const k=b({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:i.getOverrideValue(void 0,p)||{},keys:i.getKeysForOverrideIdentifier(p)});o.push([p,[...k.added,...k.removed,...k.updated]])}}return{added:c,removed:u,updated:r,overrides:o}}function b(s,i){const c=s?i?s.keys.filter(o=>i.keys.indexOf(o)===-1):[...s.keys]:[],u=i?s?i.keys.filter(o=>s.keys.indexOf(o)===-1):[...i.keys]:[],r=[];if(s&&i){for(const o of i.keys)if(s.keys.indexOf(o)!==-1){const n=(0,R.getConfigurationValue)(i.contents,o),l=(0,R.getConfigurationValue)(s.contents,o);T.equals(n,l)||r.push(o)}}return{added:c,removed:u,updated:r}}}),define(Se[127],ye([1,0,10,3]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var I;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends a.ErrorNoTelemetry{static isNotAvailable(T){return T instanceof A&&T._code===I.NotAvailable}static isTemporarilyNotAvailable(T){return T instanceof A&&T._code===I.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof A&&T._code===I.NoResolverFound}static isHandled(T){return T instanceof A&&T.isHandled}constructor(T,S=I.Unknown,C){super(T),this._message=T,this._code=S,this._detail=C,this.isHandled=S===I.NotAvailable&&C===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(Se[88],ye([1,0,15]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===a.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function I(C){if(!C)return;const R=C.indexOf("+");return R<0?C:C.substr(0,R)}e.getRemoteName=I;function A(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=A;function D(C){const{host:R,port:P}=S(C);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:P}}e.parseAuthorityWithPort=D;function T(C,R){let{host:P,port:E}=S(C);return typeof E>"u"&&(E=R),{host:P,port:E}}e.parseAuthorityWithOptionalPort=T;function S(C){const R=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const P=C.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const E=C.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:C,port:void 0}}}),define(Se[27],ye([1,0,8,3,88]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=A;function D(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var S;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,g){if(typeof d>"u"||d===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof d=="string"||typeof g=="string"){const f=typeof d=="string"?d:d.value,w=typeof g=="string"?g:g.value;return a.equalsIgnoreCase(f,w)}return d.c===g.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=C;function R(v){return P(v)}e.isApplicationScopedExtension=R;function P(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function E(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function y(v,d){if(d){const g=`onResolveRemoteAuthority:${(0,I.getRemoteName)(d)}`;return v.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Se[202],ye([1,0,8,121,27,12,2,10,36]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(i,c){return i.uuid&&c.uuid?i.uuid===c.uuid:i.id===c.id?!0:(0,a.compareIgnoreCase)(i.id,c.id)===0}e.areSameExtensions=C;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(c){const u=c.manifest?c.manifest.version:c.version,r=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new P(c.identifier,u,r)}static parse(c){const u=R.exec(c);return u&&u[1]&&u[2]?new P({id:u[1]},u[2],u[4]||void 0):null}constructor(c,u,r="undefined"){this.version=u,this.targetPlatform=r,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof P?C(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=P;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const c=E.exec(i);return c&&c[1]?[d(c[1]),c[2]]:[d(i),void 0]}e.getIdAndVersion=y;function v(i,c){return`${i}.${c}`}e.getExtensionId=v;function d(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function g(i,c){return d(v(i,c))}e.getGalleryExtensionId=g;function f(i,c){const u=[],r=o=>{for(const n of u)if(n.some(l=>C(c(l),c(o))))return n;return null};for(const o of i){const n=r(o);n?n.push(o):u.push([o])}return u}e.groupByExtension=f;function w(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function m(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function h(i,c){const u=[],r=c.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&u.every(n=>!C(n.identifier,{id:o}))){const n=i.filter(l=>C(l.identifier,{id:o}));n.length===1&&(u.push(n[0]),r.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=h;async function b(i,c){if(!A.isLinux)return!1;let u;try{u=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){c.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(o))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=b;async function s(i,c){const u=await b(i,c),r=(0,t.getTargetPlatform)(u?"alpine":A.platform,S.arch);return c.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=s}),define(Se[203],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((I,A)=>te(["vsda"],I,A))}async createNewMessage(I){try{const A=await this.c(),D=new A.validator;if(D){const T=String(a.a++);return this.b.set(T,D),{id:T,data:D.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,A){if(!I.id)return!0;const D=this.b.get(I.id);if(!D)return!1;this.b.delete(I.id);try{return D.validate(A)==="ok"}catch{return!1}}async sign(I){try{const A=await this.c(),D=new A.signer;if(D)return D.sign(I)}catch{}return I}}e.SignService=a,a.a=1}),define(Se[204],ye([1,0,12,36,2,30]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(C){if(a.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function T(C,R,P,E,y,v,d,g,f,w){const m=Object.create(null);m["common.machineId"]=d,m.sessionID=(0,A.generateUuid)()+Date.now(),m.commitHash=y,m.version=v,m["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,a.PlatformToString)(a.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=E,m["common.product"]=w||"desktop",g&&(m["common.msftInternal"]=g);let h=0;const b=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),a.isLinuxSnap&&(m["common.snap"]="true");const s=D(P);s&&(m["common.platformDetail"]=s);try{const i=await C.readFile(I.URI.file(f));m["common.source"]=i.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=T;function S(C){const R=t.env.USERDNSDOMAIN;if(!R)return!1;const P=R.toLowerCase();return C.some(E=>P===E)}e.verifyMicrosoftInternalDomain=S}),define(Se[205],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Se[128],ye([1,0,23,11,52,204,205]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class T{constructor(r){this.value=r}}e.TrustedTelemetryValue=T;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class C{async publicLog(r,o,n){}async publicLogError(r,o,n){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(u,r){return r.onDidChangeConfiguration(o=>{o.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,I.ConfigurationTargetToString)(o.source),configurationKeys:w(o.sourceConfig)})})}e.configurationTelemetry=R;function P(u,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!u.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=P;function E(u,r){return!(r.isBuilt||r.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.isLoggingOnly=E;function y(u){const r=u.getValue(D.TELEMETRY_SETTING_ID),o=u.getValue("telemetry.enableCrashReporter");if(u.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function v(u){const r={},o={},n={};f(u,n);for(let l in n){l=l.length>150?l.substr(l.length-149):l;const p=n[l];typeof p=="number"?o[l]=p:typeof p=="boolean"?o[l]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${p.length}`),r[l]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(r[l]=p)}return{properties:r,measurements:o}}e.validateTelemetryData=v;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function g(u){if(!u)return"none";for(const r of d)if(u.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=g;function f(u,r,o=0,n){if(!!u)for(const l of Object.getOwnPropertyNames(u)){const p=u[l],k=n?n+l:l;Array.isArray(p)?r[k]=(0,a.safeStringify)(p):p instanceof Date?r[k]=p.toISOString():(0,t.isObject)(p)?o<2?f(p,r,o+1,k+"."):r[k]=(0,a.safeStringify)(p):r[k]=p}}function w(u){if(!u)return[];const r=[];return m(r,"",u),r}function m(u,r,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(n=>m(u,r?`${r}.${n}`:n,o[n])):u.push(r)}function h(u,r){const o=u.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(o)||n}e.isInternalTelemetry=h;function b(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=b;function s(u,r){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let o=u;const n=[];for(const L of r)for(;;){const U=L.exec(u);if(!U)break;n.push([U.index,L.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(o="";;){const L=p.exec(u);if(!L)break;const U=n.some(([K,G])=>L.index<G&&K<p.lastIndex);!l.test(L[0])&&!U&&(o+=u.substring(k,L.index)+"<REDACTED: user-file-path>",k=p.lastIndex)}return k<u.length&&(o+=u.substr(k)),o}function i(u){if(!u)return u;const r=u.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(r))return`<REDACTED: ${n.label}>`;return u}function c(u,r){return(0,a.cloneAndChange)(u,o=>{if(o instanceof T)return o.value;if(typeof o=="string"){let n=o.replaceAll("%20"," ");n=s(n,r);for(const l of r)n=n.replace(l,"");return n=i(n),n}})}e.cleanData=c}),define(Se[206],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,A,D=5){const T=A(S=>{const C=typeof S=="string"?S:S.data;let R=this.a.get(I);if(R){R.data.push(C);return}const P=setTimeout(()=>this.flushBuffer(I),D);R={data:[C],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(I),T.dispose()}},this.a.set(I,R)});return T}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const A=this.a.get(I);A&&(this.a.delete(I),this.b(I,A.data.join("")))}}e.TerminalDataBufferer=a}),define(Se[207],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var a;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function t(A){return A===a.HIGH_CONTRAST_DARK||A===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function I(A){return A===a.DARK||A===a.HIGH_CONTRAST_DARK}e.isDark=I}),define(Se[89],ye([1,0,78,4,6,3,43,207]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(g){function f(w){return w&&typeof w=="object"&&typeof w.id=="string"}g.isThemeColor=f})(S=e.ThemeColor||(e.ThemeColor={}));function C(g){return{id:g}}e.themeColorFromId=C;var R;(function(g){function f(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||S.isThemeColor(u.color))}g.isThemeIcon=f;const w=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function m(u){const r=w.exec(u);if(!r)return;const[,o]=r;return{id:o}}g.fromString=m;function h(u){return{id:u}}g.fromId=h;function b(u,r){let o=u.id;const n=o.lastIndexOf("~");return n!==-1&&(o=o.substring(0,n)),r&&(o=`${o}~${r}`),{id:o}}g.modify=b;function s(u){const r=u.id.lastIndexOf("~");if(r!==-1)return u.id.substring(r+1)}g.getModifier=s;function i(u,r){return u.id===r.id&&u.color?.id===r.color?.id}g.isEqual=i;function c(u,r){return{id:u.id,color:r?C(r):void 0}}g.asThemeIcon=c,g.asClassNameArray=a.CSSIcon.asClassNameArray,g.asClassName=a.CSSIcon.asClassName,g.asCSSSelector=a.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function P(g){switch(g){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case T.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(f){return this.a.push(f),this.b.fire(f),(0,I.toDisposable)(()=>{const w=this.a.indexOf(f);this.a.splice(w,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const y=new E;D.Registry.add(e.Extensions.ThemingContribution,y);function v(g){return y.onColorThemeChange(g)}e.registerThemingParticipant=v;class d extends I.Disposable{constructor(f){super(),this.k=f,this.h=f.getColorTheme(),this.B(this.k.onDidColorThemeChange(w=>this.n(w)))}n(f){this.h=f,this.updateStyles()}updateStyles(){}w(f,w){let m=this.h.getColor(f);return m&&w&&(m=w(m,this.h)),m?m.toString():null}}e.Themable=d}),define(Se[129],ye([1,0,4,52,3,13]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var D;(function(d){d.Http="http",d.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function E(d,g,f,w){if(f===1)return!1;if(f===2&&P(g)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(m?.length===4&&parseInt(m[1])>=18)return!1}return d<1024}e.isPortPrivileged=E;class y{constructor(g,f,w){this.remoteAddress=g,this.localAddress=f,this.b=w,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=y;let v=class{constructor(g,f){this.i=g,this.j=f,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const g=this.j.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.e=g,g?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.f=g.elevation,this.g=g.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const g=[],f=Array.from(this.d.values());for(const w of f){const m=Array.from(w.values());for(const h of m){const b=await h.value;b&&g.push(b)}}return g}async dispose(){for(const g of this.d.values()){for(const{value:f}of g.values())await f.then(w=>w?.dispose());g.clear()}this.d.clear()}setEnvironmentTunnel(g,f,w,m,h){this.o(g,f,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:f,localAddress:w,privacy:m,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,f){(P(g)||R(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const w=this.q(g,f);if(w)return++w.refcount,w.value}openTunnel(g,f,w,m,h=!1,b,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${w} on local port ${m}.`),!g)return;if(f||(f="localhost"),this.e&&this.h.has(w)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(g,f,w,m,h,b,s);return i?i.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(f,w);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(c);return(c.tunnelRemoteHost!==f||c.tunnelRemotePort!==w)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const f=this.d.get(g.tunnelRemoteHost);if(f){const w=f.get(g.tunnelRemotePort);w&&(w.refcount--,await this.n(g.tunnelRemoteHost,g.tunnelRemotePort,w))}}}}async n(g,f,w){if(w.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${f}.`);const m=w.value.then(async h=>{h&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.d.has(g)&&this.d.get(g).delete(f),m}}async closeTunnel(g,f){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${f} `);const w=this.d.get(g);if(w&&w.has(f)){const m=w.get(f);m.refcount=0,await this.n(g,f,m)}}o(g,f,w){this.d.has(g)||this.d.set(g,new Map),this.d.get(g).set(f,{refcount:1,value:w})}async p(g,f){const w=this.d.get(g);w&&(await w.get(f)||w.delete(f),w.size===0&&this.d.delete(g))}q(g,f){const w=[g];R(g)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):P(g)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const m=w.map(h=>this.d.get(h));for(const h of m){const b=h?.get(f);if(b)return b}}canTunnel(g){return!!C(g)}s(g,f,w,m,h,b,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${w} on local port ${m}.`);const i=w;this.h.add(i);const c=m===void 0?w:m,u={elevationRequired:h?this.isPortPrivileged(c):!1},r={remoteAddress:{host:f,port:w},localAddressPort:m,privacy:b,public:b?b!==T.Private:void 0,protocol:s},o=g.forwardPort(r,u);return o?(this.o(f,w,o),o.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(i)})):this.h.delete(i),o}};v=Ve([ze(0,A.ILogService),ze(1,t.IConfigurationService)],v),e.AbstractTunnelService=v}),define(Se[208],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var t;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Se[209],ye([1,0,15]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==a.Schemas.file&&S.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=t;function I(S){if(S.folders.length)return S.folders.every(C=>t(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=I;function A(S){return I(S)?.scheme}e.getVirtualWorkspaceScheme=A;function D(S){return I(S)?.authority}e.getVirtualWorkspaceAuthority=D;function T(S){return I(S)!==void 0}e.isVirtualWorkspace=T}),define(Se[45],ye([1,0,171,9,64,24,2,3,15]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function C(i){const c=i;return typeof c?.id=="string"&&D.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(i,c){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,t.basename)(i)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const u=i;if(u.configuration)return{id:u.id,configPath:u.configuration};if(u.folders.length===1)return{id:u.id,uri:u.folders[0].uri}}e.toWorkspaceIdentifier=R;function P(i){const c=i;return typeof c?.id=="string"&&D.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=P;function E(i){const c=i;if(c?.uri)return{id:c.id,uri:D.URI.revive(c.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:D.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=E;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function v(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=v;function d(i){const c=i;return!!(c&&typeof c=="object"&&D.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=d;class g{constructor(c,u,r,o,n){this.h=c,this.j=r,this.k=o,this.l=n,this.c=I.TernarySearchTree.forUris(this.l,()=>!0),this.folders=u}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=I.TernarySearchTree.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class f{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,A.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function w(i){return new f({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(i,c){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,c.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function h(i){let c;return D.URI.isUri(i)?c=i:c=i.configuration,c?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=h;function b(i,c){return!m(i,c)&&!h(i)}e.isSavedWorkspace=b;function s(i){return(typeof i=="string"?(0,t.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Se[67],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const A=this.c++;return this.b.set(A,I),this.e(),A}get(I,A){return this.b.has(I)?this.b.get(I)[A]:void 0}delete(I){this.b.delete(I),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=a,a.a=!1}),define(Se[46],ye([1,0,15,24,3]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(T=>{const S=this.b.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this.b.delete(T.scheme):this.b.set(T.scheme,S)}isFreeScheme(T){return!this.b.has(T)&&!this.a.has(T)}getCapabilities(T){return this.b.get(T)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(Se[25],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Se[210],ye([1,0,18]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(D,T,S){this.h=new Map,this.a=D,this.b=T,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(C=>(this.f=C,this)),this.g=this.c.onDidChangeStorage(C=>{C.shared===this.b&&C.key===this.a&&(this.f=C.value)}),this.i=new a.RunOnceScheduler(()=>{const C=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of C.values())R.complete()}catch(R){for(const P of C.values())P.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this.d}get(D,T){let S=this.f[D];return typeof S>"u"&&(S=T),S}update(D,T){this.f[D]=T;const S=this.h.get(D);if(S!==void 0)return S.p;const C=new a.DeferredPromise;return this.h.set(D,C),this.i.isScheduled()||this.i.schedule(),C.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class I extends t{setKeysForSync(D){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},D)}constructor(D,T){super(D.identifier.value,!0,T),this.j=D}}e.ExtensionGlobalMemento=I}),define(Se[211],ye([1,0,4,2]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(D){this.c=D,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(D,T,S,C){const P=this.c.getNotebookDocument(t.URI.revive(D)).acceptModelChanged(T.value,S,C);this.b.fire(P)}$acceptDirtyStateChanged(D,T){this.c.getNotebookDocument(t.URI.revive(D)).acceptDirty(T)}$acceptModelSaved(D){const T=this.c.getNotebookDocument(t.URI.revive(D));this.a.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(Se[16],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a},Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[212],ye([1,0,27,4]),function(te,e,a,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(T,S){I.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(T.identifier),Je(this,I,S,"f"),Me(this,I,"f").onDidChangePassword(C=>{C.extensionId===this.a&&this.b.fire({key:C.key})})}get(T){return Me(this,I,"f").get(this.a,T)}store(T,S){return Me(this,I,"f").store(this.a,T,S)}delete(T){return Me(this,I,"f").delete(this.a,T)}}e.ExtensionSecrets=A,I=new WeakMap}),define(Se[54],ye([1,0,3,129,4,16]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(S){function C(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}S.fromApiTunnel=C;function R(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}S.fromServiceTunnel=R})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let T=class{constructor(C){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,R){}async getTunnels(){return[]}async setTunnelFactory(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,R){return{dispose:()=>{}}}async $providePortAttributes(C,R,P,E,y){return[]}async $forwardPort(C,R){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([ze(0,A.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(Se[55],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=t}),define(Se[213],ye([1,0,22]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function I(T,S){if(S.serializeBuffersForPostMessage){const C=new t,R=(y,v)=>{if(v instanceof ArrayBuffer){const d=C.add(v);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(v)){const d=A(v);if(d){const g=C.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},P=JSON.stringify(T,R),E=C.buffers.map(y=>{const v=new Uint8Array(y);return a.VSBuffer.wrap(v)});return{message:P,buffers:E}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=I;function A(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(T,S){const C=S.map(E=>{const y=new ArrayBuffer(E.byteLength);return new Uint8Array(y).set(E.buffer),y}),R=S.length?(E,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const v=y,{index:d}=v,g=C[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(g,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return y}:void 0;return{message:JSON.parse(T,R),arrayBuffers:C}}e.deserializeWebviewMessage=D}),define(Se[214],ye([1,0,112]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(A){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:A,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function I(A){return new a.URITransformer(t(A))}e.createURITransformer=I}),define(Se[130],ye([1,0,181,11,2,6,3,43,38,15]),function(te,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(q){q[q.PROGRAMMATIC=1]="PROGRAMMATIC",q[q.USER=2]="USER",q[q.EDIT=3]="EDIT",q[q.NAVIGATION=4]="NAVIGATION",q[q.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var P;(function(q){q[q.IDENTICAL=1]="IDENTICAL",q[q.SIMILAR=2]="SIMILAR",q[q.DIFFERENT=3]="DIFFERENT"})(P=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(q){const H=q;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.isEditorPaneWithSelection=E;function y(q,H,J){for(const Y of J.visibleEditorPanes)if(Y.group.id===H&&q.matches(Y.input))return Y.getViewState()}e.findViewStateForEditor=y;function v(q){if(r(q))return!1;const H=q;return I.URI.isUri(H?.resource)}e.isResourceEditorInput=v;function d(q){if(r(q))return!1;const H=q;return H?.original!==void 0&&H.modified!==void 0}e.isResourceDiffEditorInput=d;function g(q){if(r(q)||d(q))return!1;const H=q;return H?.primary!==void 0&&H.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function f(q){if(r(q))return!1;const H=q;return H?H.resource===void 0||H.resource.scheme===C.Schemas.untitled||H.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=f;const w=/Untitled-\d+/;function m(q){return q.scheme===C.Schemas.untitled&&q.path.length>1&&!w.test(q.path)}e.isUntitledWithAssociatedResource=m;function h(q){if(r(q))return!1;const H=q;return I.URI.isUri(H?.base?.resource)&&I.URI.isUri(H?.input1?.resource)&&I.URI.isUri(H?.input2?.resource)&&I.URI.isUri(H?.result?.resource)}e.isResourceMergeEditorInput=h;var b;(function(q){q[q.SHORT=0]="SHORT",q[q.MEDIUM=1]="MEDIUM",q[q.LONG=2]="LONG"})(b=e.Verbosity||(e.Verbosity={}));var s;(function(q){q[q.EXPLICIT=1]="EXPLICIT",q[q.AUTO=2]="AUTO",q[q.FOCUS_CHANGE=3]="FOCUS_CHANGE",q[q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class i{constructor(){this.a=new Map}registerSource(H,J){let Y=this.a.get(H);return Y||(Y={source:H,label:J},this.a.set(H,Y)),Y.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.SaveSourceRegistry=new i;var c;(function(q){q[q.None=0]="None",q[q.Readonly=2]="Readonly",q[q.Untitled=4]="Untitled",q[q.Singleton=8]="Singleton",q[q.RequiresTrust=16]="RequiresTrust",q[q.CanSplitInGroup=32]="CanSplitInGroup",q[q.ForceDescription=64]="ForceDescription",q[q.CanDropIntoEditor=128]="CanDropIntoEditor",q[q.MultipleEditors=256]="MultipleEditors"})(c=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends A.Disposable{}e.AbstractEditorInput=u;function r(q){return q instanceof u}e.isEditorInput=r;function o(q){const H=q;return I.URI.isUri(H?.preferredResource)}function n(q){const H=q;return r(H?.primary)&&r(H?.secondary)}e.isSideBySideEditorInput=n;function l(q){const H=q;return r(H?.modified)&&r(H?.original)}e.isDiffEditorInput=l;function p(q){return r(q?.editor)}e.isEditorInputWithOptions=p;function k(q){const H=q;return p(q)&&H?.group!==void 0}e.isEditorInputWithOptionsAndGroup=k;function L(q){const H=q;return typeof H?.groupId=="number"&&r(H.editor)}e.isEditorIdentifier=L;var U;(function(q){q[q.UNKNOWN=0]="UNKNOWN",q[q.REPLACE=1]="REPLACE",q[q.MOVE=2]="MOVE",q[q.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var K;(function(q){q[q.GROUP_ACTIVE=0]="GROUP_ACTIVE",q[q.GROUP_INDEX=1]="GROUP_INDEX",q[q.GROUP_LOCKED=2]="GROUP_LOCKED",q[q.EDITOR_OPEN=3]="EDITOR_OPEN",q[q.EDITOR_CLOSE=4]="EDITOR_CLOSE",q[q.EDITOR_MOVE=5]="EDITOR_MOVE",q[q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",q[q.EDITOR_LABEL=7]="EDITOR_LABEL",q[q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",q[q.EDITOR_PIN=9]="EDITOR_PIN",q[q.EDITOR_STICKY=10]="EDITOR_STICKY",q[q.EDITOR_DIRTY=11]="EDITOR_DIRTY",q[q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(K=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var G;(function(q){q[q.PRIMARY=1]="PRIMARY",q[q.SECONDARY=2]="SECONDARY",q[q.BOTH=3]="BOTH",q[q.ANY=4]="ANY"})(G=e.SideBySideEditor||(e.SideBySideEditor={}));class O{getOriginalUri(H,J){if(!H)return;if(h(H))return e.EditorResourceAccessor.getOriginalUri(H.result,J);if(J?.supportSideBySide){const{primary:ae,secondary:re}=this.a(H);if(ae&&re){if(J?.supportSideBySide===G.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:J.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===G.ANY)return this.getOriginalUri(ae,{filterByScheme:J.filterByScheme})??this.getOriginalUri(re,{filterByScheme:J.filterByScheme});H=J.supportSideBySide===G.PRIMARY?ae:re}}if(d(H)||g(H)||h(H))return;const Y=o(H)?H.preferredResource:H.resource;return!Y||!J||!J.filterByScheme?Y:this.b(Y,J.filterByScheme)}a(H){return n(H)||g(H)?{primary:H.primary,secondary:H.secondary}:l(H)||d(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,J){if(!H)return;if(h(H))return e.EditorResourceAccessor.getCanonicalUri(H.result,J);if(J?.supportSideBySide){const{primary:ae,secondary:re}=this.a(H);if(ae&&re){if(J?.supportSideBySide===G.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:J.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===G.ANY)return this.getCanonicalUri(ae,{filterByScheme:J.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:J.filterByScheme});H=J.supportSideBySide===G.PRIMARY?ae:re}}if(d(H)||g(H)||h(H))return;const Y=H.resource;return!Y||!J||!J.filterByScheme?Y:this.b(Y,J.filterByScheme)}b(H,J){if(Array.isArray(J)){if(J.some(Y=>H.scheme===Y))return H}else if(J===H.scheme)return H}}e.EditorResourceAccessor=new O;var B;(function(q){q[q.LEFT=0]="LEFT",q[q.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(H){const J=this.a=H.get(D.IInstantiationService);for(const[Y,ae]of this.c)this.e(Y,ae,J);this.c.clear()}e(H,J,Y){const ae=Y.createInstance(J);this.d.set(H,ae)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(H,J){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,J,this.a):this.c.set(H,J),(0,A.toDisposable)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new F);async function $(q,H,J){return!q||!q.length?[]:await Promise.all(q.map(async Y=>{const ae=I.URI.revive(Y.fileUri);if(!ae){J.info("Cannot resolve the path because it is not valid.",Y);return}if(!await H.canHandleResource(ae)){J.info("Cannot resolve the path because it cannot be handled",Y);return}let fe=Y.exists,Z=Y.type;if(typeof fe!="boolean"||typeof Z!="number")try{Z=(await H.stat(ae)).isDirectory?S.FileType.Directory:S.FileType.Unknown,fe=!0}catch(we){J.error(we),fe=!1}if(!fe&&Y.openOnlyIfExists){J.info("Cannot resolve the path because it does not exist",Y);return}if(Z===S.FileType.Directory){J.info("Cannot resolve the path because it is a directory",Y);return}const pe={...Y.options,pinned:!0};return fe?{resource:ae,options:pe}:{resource:ae,options:pe,forceUntitled:!0}}))}e.pathsToEditors=$;var M;(function(q){q[q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",q[q.SEQUENTIAL=1]="SEQUENTIAL"})(M=e.EditorsOrder||(e.EditorsOrder={}));function V(q){const H=q;if(!H)return!1;const J=H;if(J.modified)return V(J.modified);const Y=H;return!!(Y.contributionsState&&Y.viewState&&Array.isArray(Y.cursorState))}e.isTextEditorViewState=V}),define(Se[131],ye([1,0,4,18,182]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(T){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=T}onEvent(T){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=T}onRequest(T){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.s("response",T)}sendRequest(T,S,C,R){const P={command:T};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.s("request",P),typeof R=="number"){const E=setTimeout(()=>{clearTimeout(E);const y=this.f.get(P.seq);if(y){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:T,message:(0,I.localize)(0,null,R,T)};y(v)}},R)}return C&&this.f.set(P.seq,C),P.seq}acceptMessage(T){this.j?this.j(T):(this.k.push(T),this.k.length===1&&this.q())}o(T,S){return T.type!=="event"||S.type!=="event"}async q(){let T;for(;this.k.length;){if((!T||this.o(this.k[0],T))&&await(0,t.timeout)(0),T=this.k.shift(),!T)return;switch(T.type){case"event":this.i?.(T);break;case"request":this.g?.(T);break;case"response":{const S=T,C=this.f.get(S.request_seq);C&&(this.f.delete(S.request_seq),C(S));break}}}}s(T,S){S.type=T,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((S,C)=>T.set(C,S)),await(0,t.timeout)(500),T.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.f.delete(C)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=A}),define(Se[215],ye([1,0,183,53,3]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(49,null)});const A=E=>a.localize(50,null,E);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(51,null)};var D;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(D=e.State||(e.State={}));function T(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var C;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(C=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,I.createDecorator)("debugService");var P;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Se[216],ye([1,0,8,2,9,23,15]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(c,u,r){return c.replace(T,function(o,n){return u&&n.length>0&&n[0]!=="_"?o:r&&r.hasOwnProperty(n)?r[n]:o})}e.formatPII=S;function C(c){const u={};for(const r of Object.keys(c))r.startsWith("!")||(u[r]=c[r]);return u}e.filterExceptionsFromTelemetry=C;function R(c){return c.configuration.request==="attach"&&!P(c)&&(!c.parentSession||R(c.parentSession))}e.isSessionAttach=R;function P(c){let u=c.configuration.type;if(!!u)return u==="vslsShare"&&(u=c.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(u,"extensionhost")||(0,a.equalsIgnoreCase)(u,"pwa-extensionhost")?c:c.parentSession?P(c.parentSession):void 0}e.getExtensionHostDebugSession=P;function E(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=E;function y(c,u,r){let o,n=0;const l=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=l.exec(c);){const k=p.index+1,L=k+p[0].length;if(k<=u&&L>=r){o=p[0],n=k;break}}if(o){const k=/\w+/g;let L=null;for(;(L=k.exec(o))&&!(L.index+1+n+L[0].length>=r););L&&(o=o.substring(0,k.lastIndex))}return o?{start:n,end:n+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=y;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(c){return!!(c&&c.match(v))}e.isUri=d;function g(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(d(c.path))return t.URI.parse(c.path);if((0,I.isAbsolute)(c.path))return t.URI.file(c.path)}return c.path}function f(c){if(typeof c.path=="object"){const u=t.URI.revive(c.path);if(u)return u.scheme===D.Schemas.file?u.fsPath:u.toString()}return c.path}function w(c,u){const r=u?g:f,o=(0,A.deepClone)(c);return h(o,(n,l)=>{n&&l&&(l.path=r(l))}),o}e.convertToDAPaths=w;function m(c,u){const r=u?g:f,o=(0,A.deepClone)(c);return h(o,(n,l)=>{!n&&l&&(l.path=r(l))}),o}e.convertToVSCPaths=m;function h(c,u){switch(c.type){case"event":{const r=c;switch(r.event){case"output":u(!1,r.body.source);break;case"loadedSource":u(!1,r.body.source);break;case"breakpoint":u(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=c;switch(r.command){case"setBreakpoints":u(!0,r.arguments.source);break;case"breakpointLocations":u(!0,r.arguments.source);break;case"source":u(!0,r.arguments.source);break;case"gotoTargets":u(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(o=>u(!1,o));break;default:break}break}case"response":{const r=c;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(o=>u(!1,o.source));break;case"loadedSources":r.body.sources.forEach(o=>u(!1,o));break;case"scopes":r.body.scopes.forEach(o=>u(!1,o.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(o=>u(!1,o.source));break;case"setBreakpoints":r.body.breakpoints.forEach(o=>u(!1,o.source));break;case"disassemble":r.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function b(c){return c.filter(u=>!u.presentation?.hidden).sort((u,r)=>u.presentation?r.presentation?u.presentation.group?r.presentation.group?u.presentation.group!==r.presentation.group?u.presentation.group.localeCompare(r.presentation.group):s(u.presentation.order,r.presentation.order):-1:r.presentation.group?1:s(u.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=b;function s(c,u){return typeof c!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:c-u}async function i(c,u){const r=c.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(r!=="none"&&(await u.saveAll(),r==="allEditorsInActiveGroup")){const o=u.activeEditorPane;o&&o.input.resource?.scheme===D.Schemas.untitled&&await u.save({editor:o.input,groupId:o.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=i}),define(Se[217],ye([1,0,44,218,23,9,12,8,29,184,131]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends R.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(f,w){this.p=w,this.r=Buffer.allocUnsafe(0),this.t=-1,f.on("data",m=>this.w(m))}sendMessage(f){if(this.p){const w=JSON.stringify(f);this.p.write(`Content-Length: ${Buffer.byteLength(w,"utf8")}${P.a}${w}`,"utf8")}}w(f){for(this.r=Buffer.concat([this.r,f]);;){if(this.t>=0){if(this.r.length>=this.t){const w=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,w.length>0)try{this.acceptMessage(JSON.parse(w))}catch(m){this.m.fire(new Error((m.message||m)+`
`+w))}continue}}else{const w=this.r.indexOf(P.a);if(w!==-1){const h=this.r.toString("utf8",0,w).split(P.b);for(const b of h){const s=b.split(P.l);s[0]==="Content-Length"&&(this.t=Number(s[1]))}this.r=this.r.slice(w+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class E extends P{startSession(){return new Promise((f,w)=>{let m=!1;this.x=this.y(()=>{this.v(this.x,this.x),f(),m=!0}),this.x.on("close",()=>{m?this.m.fire(new Error("connection closed")):w(new Error("connection closed"))}),this.x.on("error",h=>{m?this.m.fire(h):w(h)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=E;class y extends E{constructor(f){super(),this.A=f}y(f){return t.createConnection(this.A.port,this.A.host||"127.0.0.1",f)}}e.SocketDebugAdapter=y;class v extends E{constructor(f){super(),this.A=f}y(f){return t.createConnection(this.A.path,f)}}e.NamedPipeDebugAdapter=v;class d extends P{constructor(f,w){super(),this.y=f,this.A=w}async startSession(){const f=this.y.command,w=this.y.args,m=this.y.options||{};try{if(f)if(A.isAbsolute(f)){if(!await S.Promises.exists(f))throw new Error(C.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.A));let h=process.env;if(m.env&&Object.keys(m.env).length>0&&(h=I.mixin(I.deepClone(process.env),m.env)),f==="node")if(Array.isArray(w)&&w.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:h,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};m.cwd&&(s.cwd=m.cwd);const i=a.fork(w[0],w.slice(1),s);if(!i.pid)throw new Error(C.localize(2,null,w[0]));this.x=i}else throw new Error(C.localize(3,null));else{const b={env:h};m.cwd&&(b.cwd=m.cwd),this.x=a.spawn(f,w,b)}this.x.on("error",b=>{this.m.fire(b)}),this.x.on("exit",(b,s)=>{this.n.fire(b)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",b=>{this.m.fire(b)}),this.x.stdin.on("error",b=>{this.m.fire(b)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(h){this.m.fire(h)}}async stopSession(){return this.x?(await this.u(),D.isWindows?new Promise((f,w)=>{const m=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(h,b,s){if(h)return w(h)});m.on("exit",f),m.on("error",w)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static B(f,w){if(!f)return;const m=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?m.runtime=A.join(w,f.runtime):m.runtime=f.runtime),f.runtimeArgs&&(m.runtimeArgs=f.runtimeArgs),f.program&&(A.isAbsolute(f.program)?m.program=f.program:m.program=A.join(w,f.program)),f.args&&(m.args=f.args);const h=f;return h.win&&(m.win=d.B(h.win,w)),h.winx86&&(m.winx86=d.B(h.winx86,w)),h.windows&&(m.windows=d.B(h.windows,w)),h.osx&&(m.osx=d.B(h.osx,w)),h.linux&&(m.linux=d.B(h.linux,w)),m}static platformAdapterExecutable(f,w){let m=Object.create(null);w=w.toLowerCase();for(const u of f)if(u.contributes){const r=u.contributes.debuggers;r&&r.length>0&&r.filter(o=>typeof o.type=="string"&&T.equalsIgnoreCase(o.type,w)).forEach(o=>{const n=d.B(o,u.extensionLocation.fsPath);m=I.mixin(m,n,u.isBuiltin)})}let h;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?h=m.winx86||m.win||m.windows:D.isWindows?h=m.win||m.windows:D.isMacintosh?h=m.osx:D.isLinux&&(h=m.linux),h=h||m;const b=h.program||m.program,s=h.args||m.args,i=h.runtime||m.runtime,c=h.runtimeArgs||m.runtimeArgs;if(i)return{type:"executable",command:i,args:(c||[]).concat(typeof b=="string"?[b]:[]).concat(s||[])};if(b)return{type:"executable",command:b,args:s||[]}}}e.ExecutableDebugAdapter=d}),define(Se[219],ye([1,0,44,32,12]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(C,R){return new Promise((P,E)=>{let y="";const v=a.spawn(C,R);v.pid&&v.stdout.on("data",d=>{y+=d.toString()}),v.on("error",d=>{E(d)}),v.on("close",d=>{P(y)})})}async function D(C){if(C)if(I.isWindows){const R=await new Promise((P,E)=>{te(["windows-process-tree"],P,E)});return new Promise(P=>{R.getProcessTree(C,E=>{P(!!E&&E.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(C)]).then(R=>{const P=R.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var T;(function(C){C[C.cmd=0]="cmd",C[C.powershell=1]="powershell",C[C.bash=2]="bash"})(T||(T={}));function S(C,R,P,E,y){C=C.trim().toLowerCase();let v;C.indexOf("powershell")>=0||C.indexOf("pwsh")>=0?v=1:C.indexOf("cmd.exe")>=0?v=0:C.indexOf("bash")>=0?v=2:I.isWindows?v=0:v=2;let d,g=" ";switch(v){case 1:if(d=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),E){const f=(0,t.getDriveLetter)(E);f&&(g+=`${f}:; `),g+=`cd ${d(E)}; `}if(y)for(const f in y){const w=y[f];w===null?g+=`Remove-Item env:${f}; `:g+=`\${env:${f}}='${w}'; `}if(R.length>0){const f=R.shift(),w=P?f:d(f);g+=w[0]==="'"?`& ${w} `:`${w} `;for(const m of R)g+=m==="<"||m===">"||P?m:d(m),g+=" "}break;case 0:if(d=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(w=>f.includes(w))||f.length===0?`"${f}"`:f),E){const f=(0,t.getDriveLetter)(E);f&&(g+=`${f}: && `),g+=`cd ${d(E)} && `}if(y){g+='cmd /C "';for(const f in y){let w=y[f];w===null?g+=`set "${f}=" && `:(w=w.replace(/[&^|<>]/g,m=>`^${m}`),g+=`set "${f}=${w}" && `)}}for(const f of R)g+=f==="<"||f===">"||P?f:d(f),g+=" ";y&&(g+='"');break;case 2:{d=w=>(w=w.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),w.length===0?'""':w);const f=w=>/[^\w@%\/+=,.:^-]/.test(w)?`'${w.replace(/'/g,"'\\''")}'`:w;if(E&&(g+=`cd ${d(E)} ; `),y){g+="/usr/bin/env";for(const w in y){const m=y[w];m===null?g+=` -u ${f(w)}`:g+=` ${f(`${w}=${m}`)}`}g+=" "}for(const w of R)g+=w==="<"||w===">"||P?w:d(w),g+=" ";break}}return g}e.prepareCommand=S}),define(Se[90],ye([1,0,22,37,62,82,15,9,12,53]),function(te,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json",A.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var E;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var f;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var w;(function($){$.scheme=D.Schemas.vscodeNotebookCell;const M=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${M.join("")}]+`),q=7;function H(Z,pe){const we=pe.toString(q),Re=`${we.length<M.length?M[we.length-1]:"z"}${we}s${(0,a.encodeBase64)(a.VSBuffer.fromString(Z.scheme),!0,!0)}`;return Z.with({scheme:$.scheme,fragment:Re})}$.generate=H;function J(Z){if(Z.scheme!==$.scheme)return;const pe=Z.fragment.indexOf("s");if(pe<0)return;const we=parseInt(Z.fragment.substring(0,pe).replace(V,""),q),De=(0,a.decodeBase64)(Z.fragment.substring(pe+1)).toString();if(!isNaN(we))return{handle:we,notebook:Z.with({scheme:De,fragment:null})}}$.parse=J;function Y(Z,pe){return Z.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${Z.scheme!==D.Schemas.file?Z.scheme:""}`})}$.generateCellOutputUri=Y;function ae(Z){if(Z.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Z.fragment);if(!pe)return;const we=pe[1]&&pe[1]!==""?pe[1]:void 0,De=pe[2];return{outputId:we,notebook:Z.with({scheme:De||D.Schemas.file,fragment:null})}}$.parseCellOutputUri=ae;function re(Z,pe,we){return $.generate(Z,pe).with({scheme:we})}$.generateCellPropertyUri=re;function fe(Z,pe){if(Z.scheme===pe)return $.parse(Z.with({scheme:$.scheme}))}$.parseCellPropertyUri=fe})(w=e.CellUri||(e.CellUri={}));const m=$=>S.isWindows?$.replace(/\//g,"\\"):$;class h{constructor(M=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.e=V,this.d=[...new Set(M)].map(q=>({pattern:q,matches:t.parse(m(q))}))}sort(M){const V=new Map(I.Iterable.map(M,H=>[H,m(H)]));let q=[];for(const{matches:H}of this.d)for(const[J,Y]of V)if(H(Y)){q.push(J),V.delete(J);break}return V.size&&(q=q.concat([...V.keys()].sort((H,J)=>this.e.indexOf(H)-this.e.indexOf(J)))),q}prioritize(M,V){const q=this.f(M);if(q===-1){this.d.unshift({pattern:M,matches:t.parse(m(M))});return}const H=new Set(V.map(Y=>this.f(Y,q)));H.delete(-1);const J=Array.from(H).sort();this.d.splice(q+1,0,...J.map(Y=>this.d[Y]));for(let Y=J.length-1;Y>=0;Y--)this.d.splice(J[Y],1)}toArray(){return this.d.map(M=>M.pattern)}f(M,V=this.d.length){const q=m(M);for(let H=0;H<V;H++)if(this.d[H].matches(q))return H;return-1}}e.MimeTypeDisplayOrder=h;function b($,M,V,q=(H,J)=>H===J){const H=[];function J(re,fe,Z){if(fe===0&&Z.length===0)return;const pe=H[H.length-1];pe&&pe.start+pe.deleteCount===re?(pe.deleteCount+=fe,pe.toInsert.push(...Z)):H.push({start:re,deleteCount:fe,toInsert:Z})}let Y=0,ae=0;for(;;){if(Y===$.length){J(Y,0,M.slice(ae));break}if(ae===M.length){J(Y,$.length-Y,[]);break}const re=$[Y],fe=M[ae];if(q(re,fe)){Y+=1,ae+=1;continue}V(fe)?(J(Y,1,[]),Y+=1):(J(Y,0,[fe]),ae+=1)}return H}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function($){$.default="default",$.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i($){const M=$;return!!((typeof M.include=="string"||t.isRelativePattern(M.include))&&(typeof M.exclude=="string"||t.isRelativePattern(M.exclude)))}e.isDocumentExcludePattern=i;function c($,M,V){if(Array.isArray($.viewType)&&$.viewType.indexOf(M)>=0||$.viewType===M)return!0;if($.filenamePattern){const q=i($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,H=i($.filenamePattern)?$.filenamePattern.exclude:void 0;if(t.match(q,(0,T.basename)(V.fsPath).toLowerCase()))return!(H&&t.match(H,(0,T.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var u;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(M){return`${r.d}${M}`}static parse(M){if(M.startsWith(r.d))return M.substring(r.d.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r.d="notebook/";function o($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=o;const n=new TextDecoder;function l($){const M=[];let V=!1;for(const q of $)(M.length===0||V)&&(M.push(q),V=!0);return U(M),F(a.VSBuffer.concat(M.map(q=>a.VSBuffer.wrap(q))))}e.compressOutputItemStreams=l;const p=`${String.fromCharCode(27)}[A`,k=p.split("").map($=>$.charCodeAt(0)),L=10;function U($){$.forEach((M,V)=>{if(V===0||M.length<p.length)return;const q=$[V-1],H=M.subarray(0,p.length);if(H[0]===k[0]&&H[1]===k[1]&&H[2]===k[2]){const J=q.lastIndexOf(L);if(J===-1)return;$[V-1]=q.subarray(0,J),$[V]=M.subarray(p.length)}})}function K($){let M=$;do $=M,M=$.replace(/[^\n]\x08/gm,"");while(M.length<$.length);return $}function G($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const M=$.match(/^(.*)\r+/m)[1];let V=$.match(/\r+(.*)$/m)[1];V=V+M.slice(V.length,M.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return $}const O="\b".charCodeAt(0),B="\r".charCodeAt(0);function F($){return!$.buffer.includes(O)&&!$.buffer.includes(B)?$:a.VSBuffer.fromString(G(K(n.decode($.buffer))))}}),define(Se[220],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Se[221],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=a;function t(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=t;function I(D){return Array.from(D.entries()).map(T=>[T[0],a(T[1].map)])}e.serializeEnvironmentVariableCollections=I;function A(D){return new Map(D.map(T=>[T[0],{map:t(T[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Se[56],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(A){A.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{static fromExtHostTestItem(D,T,S=D.parent){if(D._isRoot)return new I([T]);const C=[D.id];for(let R=S;R&&R.id!==T;R=R.parent)C.push(R.id);return C.push(T),new I(C.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const T=D.indexOf("\0");return T===-1?D:D.slice(0,T)}static fromString(D){return new I(D.split("\0"))}static join(D,T){return new I([...D.path,T])}static joinToString(D,T){return D.toString()+"\0"+T}static parentId(D){const T=D.lastIndexOf("\0");return T===-1?void 0:D.slice(0,T)}static compare(D,T){return D===T?0:T.startsWith(D+"\0")?2:D.startsWith(T+"\0")?3:1}constructor(D,T=D.length){if(this.path=D,this.d=T,D.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new I(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new I(this.path,D)}compare(D){if(typeof D=="string")return I.compare(this.toString(),D);for(let T=0;T<D.d&&T<this.d;T++)if(D.path[T]!==this.path[T])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.TestId=I}),define(Se[68],ye([1,0,2,35,56]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var A;(function(o){o[o.Unset=0]="Unset",o[o.Queued=1]="Queued",o[o.Running=2]="Running",o[o.Passed=3]="Passed",o[o.Failed=4]="Failed",o[o.Skipped=5]="Skipped",o[o.Errored=6]="Errored"})(A=e.TestResultState||(e.TestResultState={}));var D;(function(o){o[o.Run=2]="Run",o[o.Debug=4]="Debug",o[o.Coverage=8]="Coverage",o[o.HasNonDefaultProfile=16]="HasNonDefaultProfile",o[o.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(o){o.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),o.deserialize=n=>({range:t.Range.lift(n.range),uri:a.URI.revive(n.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var S;(function(o){o[o.Error=0]="Error",o[o.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var C;(function(o){o.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&T.serialize(n.location)}),o.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&T.deserialize(n.location)})})(C=e.ITestErrorMessage||(e.ITestErrorMessage={}));const R=(o,n)=>`${n?"s":"e"}${o}`;e.getMarkId=R;var P;(function(o){o.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&T.serialize(n.location)}),o.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&T.deserialize(n.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(o){o.serialize=n=>n.type===0?C.serialize(n):P.serialize(n),o.deserialize=n=>n.type===0?C.deserialize(n):P.deserialize(n)})(E=e.ITestMessage||(e.ITestMessage={}));var y;(function(o){o.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),o.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(E.serialize)}),o.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(E.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const v="\0",d=(o,n)=>o+v+n;e.namespaceTestTag=d;const g=o=>{const n=o.indexOf(v);return{ctrlId:o.slice(0,n),tagId:o.slice(n+1)}};e.denamespaceTestTag=g;var f;(function(o){o.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),o.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?a.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(f=e.ITestItem||(e.ITestItem={}));var w;(function(o){o[o.NotExpandable=0]="NotExpandable",o[o.Expandable=1]="Expandable",o[o.BusyExpanding=2]="BusyExpanding",o[o.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var m;(function(o){o.serialize=n=>({expand:n.expand,item:f.serialize(n.item)}),o.deserialize=n=>({controllerId:I.TestId.root(n.item.extId),expand:n.expand,item:f.deserialize(n.item)})})(m=e.InternalTestItem||(e.InternalTestItem={}));var h;(function(o){o.serialize=n=>{let l;return n.item&&(l={},n.item.label!==void 0&&(l.label=n.item.label),n.item.tags!==void 0&&(l.tags=n.item.tags),n.item.busy!==void 0&&(l.busy=n.item.busy),n.item.uri!==void 0&&(l.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(l.range=n.item.range?.toJSON()),n.item.description!==void 0&&(l.description=n.item.description),n.item.error!==void 0&&(l.error=n.item.error),n.item.sortText!==void 0&&(l.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:l}},o.deserialize=n=>{let l;return n.item&&(l={},n.item.label!==void 0&&(l.label=n.item.label),n.item.tags!==void 0&&(l.tags=n.item.tags),n.item.busy!==void 0&&(l.busy=n.item.busy),n.item.range!==void 0&&(l.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(l.description=n.item.description),n.item.error!==void 0&&(l.error=n.item.error),n.item.sortText!==void 0&&(l.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:l}}})(h=e.ITestItemUpdate||(e.ITestItemUpdate={}));const b=(o,n)=>{n.expand!==void 0&&(o.expand=n.expand),n.item!==void 0&&(o.item=o.item?Object.assign(o.item,n.item):n.item)};e.applyTestItemUpdate=b;var s;(function(o){o.serializeWithoutMessages=n=>({...m.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(y.serializeWithoutMessages),retired:n.retired}),o.serialize=n=>({...m.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(y.serialize),retired:n.retired}),o.deserialize=n=>({...m.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(y.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var i;(function(o){o[o.Function=0]="Function",o[o.Statement=1]="Statement"})(i=e.DetailType||(e.DetailType={}));var c;(function(o){o[o.Add=0]="Add",o[o.Update=1]="Update",o[o.DocumentSynced=2]="DocumentSynced",o[o.Remove=3]="Remove",o[o.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",o[o.Retire=5]="Retire",o[o.AddTag=6]="AddTag",o[o.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(o){o.deserialize=n=>n.op===0?{op:n.op,item:m.deserialize(n.item)}:n.op===1?{op:n.op,item:h.deserialize(n.item)}:n.op===2?{op:n.op,uri:a.URI.revive(n.uri),docv:n.docv}:n,o.serialize=n=>n.op===0?{op:n.op,item:m.serialize(n.item)}:n.op===1?{op:n.op,item:h.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class r{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const l=this.o();for(const p of n)switch(p.op){case 0:this.j(m.deserialize(p.item),l);break;case 1:this.k(h.deserialize(p.item),l);break;case 3:this.l(p.itemId,l);break;case 5:this.m(p.itemId);break;case 4:this.updatePendingRoots(p.amount);break;case 6:this.c.set(p.tag.id,p.tag);break;case 7:this.c.delete(p.id);break}l.complete?.()}j(n,l){const p=I.TestId.parentId(n.item.extId)?.toString();let k;if(!p)k=this.p(n),this.f.add(k),this.d.set(n.item.extId,k);else if(this.d.has(p)){const L=this.d.get(p);L.children.add(n.item.extId),k=this.p(n,L),this.d.set(n.item.extId,k)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return l.add?.(k),n.expand===2&&this.g++,k}k(n,l){const p=this.d.get(n.extId);if(!!p)return n.expand!==void 0&&(p.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(p,n),l.update?.(p),p}l(n,l){const p=this.d.get(n);if(!p)return;const k=I.TestId.parentId(p.item.extId)?.toString();k?this.d.get(k).children.delete(p.item.extId):this.f.delete(p);const L=[[n]];for(;L.length;)for(const U of L.pop()){const K=this.d.get(U);K&&(L.push(K.children),this.d.delete(U),l.remove?.(K,K!==p),K.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=r}),define(Se[91],ye([1,0,18,4,6,48,68,56]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(w){w[w.Upsert=0]="Upsert",w[w.SetTags=1]="SetTags",w[w.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",w[w.RemoveChild=3]="RemoveChild",w[w.SetProp=4]="SetProp",w[w.Bulk=5]="Bulk",w[w.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(w,m)=>w===m,P=Object.entries({range:(w,m)=>w===m?!0:!w||!m?!1:w.equalsRange(m),busy:C,label:C,description:C,error:C,sortText:C,tags:(w,m)=>!(w.length!==m.length||w.some(h=>!m.includes(h)))}),E=(w,m)=>{let h;for(const[b,s]of P)s(w[b],m[b])||(h?h[b]=m[b]:h={[b]:m[b]});return h};class y extends I.Disposable{get root(){return this.m.root}constructor(m){super(),this.m=m,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(m){this.h=m;for(const h of this.tree.values())this.H(h)}collectDiff(){const m=this.k;return this.k=[],m}pushDiff(m){switch(m.op){case 2:{for(const h of this.k)if(h.op===2&&h.uri===m.uri){h.docv=m.docv;return}break}case 1:{const h=this.k[this.k.length-1];if(h){if(h.op===1&&h.item.extId===m.item.extId){(0,D.applyTestItemUpdate)(h.item,m.item);return}if(h.op===0&&h.item.item.extId===m.item.extId){(0,D.applyTestItemUpdate)(h.item,m.item);return}}break}}this.k.push(m),this.f.isScheduled()||this.f.schedule()}expand(m,h){const b=this.tree.get(m);if(!!b){if((b.expandLevels===void 0||h>b.expandLevels)&&(b.expandLevels=h),b.expand===1){const s=this.J(b);return s.isOpen()?this.I(b,h-1):s.wait().then(()=>this.I(b,h-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.I(b,h-1)):this.I(b,h-1)}}dispose(){for(const m of this.tree.values())this.m.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(m,h){switch(h.op){case 3:this.M(T.TestId.joinToString(m.fullId,h.id));break;case 0:this.u(h.item,m);break;case 5:for(const b of h.ops)this.p(m,b);break;case 1:this.w(h.new,h.old,m.fullId.toString());break;case 2:this.H(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:h.update}});break;case 6:this.s(m.actual.uri);break;default:(0,A.assertNever)(h)}}s(m){m&&this.pushDiff({op:2,uri:m,docv:this.m.getDocumentVersion(m)})}u(m,h){const b=T.TestId.fromExtHostTestItem(m,this.root.id,h?.actual),s=this.m.getApiFor(m);s.parent&&s.parent!==h?.actual&&this.m.getChildren(s.parent).delete(m.id);let i=this.tree.get(b.toString());if(!i){i={fullId:b,actual:m,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},m.tags.forEach(this.y,this),this.tree.set(i.fullId.toString(),i),this.D(m,h),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:i.expand,item:this.m.toITestItem(m)}}),this.G(m,i,h);return}if(i.actual===m){this.F(m,i,h);return}if(i.actual.uri?.toString()!==m.uri?.toString())return this.M(b.toString()),this.u(m,h);const c=this.m.getChildren(i.actual),u=i.actual,r=E(this.m.toITestItem(u),this.m.toITestItem(m));this.m.getApiFor(u).listener=void 0,i.actual=m,i.expand=0,r&&(r.hasOwnProperty("tags")&&(this.w(m.tags,u.tags,b.toString()),delete r.tags),this.p(i,{op:4,update:r})),this.G(m,i,h);for(const[o,n]of c)this.m.getChildren(m).get(n.id)||this.M(T.TestId.joinToString(b,n.id));this.s(i.actual.uri)}w(m,h,b){const s=new Set(h.map(i=>i.id));for(const i of m)s.delete(i.id)||this.y(i);this.pushDiff({op:1,item:{extId:b,item:{tags:m.map(i=>(0,D.namespaceTestTag)(this.m.controllerId,i.id))}}}),s.forEach(this.C,this)}y(m){const h=this.j.get(m.id);h?h.refCount++:(this.j.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.m.controllerId,m.id)}}))}C(m){const h=this.j.get(m);h&&!--h.refCount&&(this.j.delete(m),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.m.controllerId,m)}))}D(m,h){this.m.getApiFor(m).parent=h&&h.actual!==this.root?h.actual:void 0}F(m,h,b){this.D(m,b);const s=this.m.getApiFor(m);s.parent=b?.actual,s.listener=i=>this.p(h,i),this.H(h)}G(m,h,b){this.F(m,h,b);for(const[s,i]of this.m.getChildren(m))this.u(i,h)}H(m){let h;this.h?m.resolveBarrier?h=m.resolveBarrier.isOpen()?3:2:h=m.actual.canResolveChildren?1:0:h=0,h!==m.expand&&(m.expand=h,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:h}}),h===1&&m.expandLevels!==void 0&&this.J(m))}I(m,h){if(h<0)return;const b=[];for(const[s,i]of this.m.getChildren(m.actual)){const c=this.expand(T.TestId.joinToString(m.fullId,i.id),h);(0,a.isThenable)(c)&&b.push(c)}if(b.length)return Promise.all(b).then(()=>{})}J(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this.h){const i=new a.Barrier;return i.open(),i}m.expand=2,this.L(m);const h=m.resolveBarrier=new a.Barrier,b=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,i)};let s;try{s=this.h(m.actual===this.root?void 0:m.actual)}catch(i){b(i)}return(0,a.isThenable)(s)?s.catch(b).then(()=>{h.open(),this.H(m)}):(h.open(),this.H(m)),m.resolveBarrier}L(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}M(m){const h=this.tree.get(m);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const b=[h];for(;b.length;){const s=b.pop();if(!!s){this.m.getApiFor(s.actual).listener=void 0;for(const i of s.actual.tags)this.C(i.id);this.tree.delete(s.fullId.toString());for(const[i,c]of this.m.getChildren(s.actual))b.push(this.tree.get(T.TestId.joinToString(s.fullId,c.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.g.fire(m)}}e.TestItemCollection=y;class v extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=v;class d extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class g extends Error{constructor(m,h,b){super(`TestItem with ID "${m}" is from controller "${h}" and cannot be added as a child of an item from controller "${b}".`)}}e.MixedTestItemController=g;const f=(w,m,h)=>{let b=new Map;return{get size(){return b.size},forEach(s,i){for(const c of b.values())s.call(i,c,this)},[Symbol.iterator](){return b.entries()},replace(s){const i=new Map,c=new Set(b.keys()),u={op:5,ops:[]};for(const r of s){if(!(r instanceof h))throw new d(r.id);const o=m(r).controllerId;if(o!==w.controllerId)throw new g(r.id,o,w.controllerId);if(i.has(r.id))throw new v(r.id);i.set(r.id,r),c.delete(r.id),u.ops.push({op:0,item:r})}for(const r of c.keys())u.ops.push({op:3,id:r});w.listener?.(u),b=i},add(s){if(!(s instanceof h))throw new d(s.id);b.set(s.id,s),w.listener?.({op:0,item:s})},delete(s){b.delete(s)&&w.listener?.({op:3,id:s})},get(s){return b.get(s)},toJSON(){return Array.from(b.values())}}};e.createTestItemChildren=f}),define(Se[132],ye([1,0,91]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,I=(D,T)=>{const S={controllerId:T};return t.set(D,S),S};e.createPrivateApiFor=I;const A=D=>{const T=t.get(D);if(!T)throw new a.InvalidTestItemError(D?.id||"<unknown>");return T};e.getPrivateApiFor=A}),define(Se[92],ye([1,0,15,2]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(T,S){return T.scheme===a.Schemas.http||T.scheme===a.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===a.Schemas.file&&(T=t.URI.from({scheme:a.Schemas.vscodeRemote,authority:S.authority,path:T.path})),t.URI.from({scheme:a.Schemas.https,authority:`${T.scheme}+${A(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=I;function A(T){return T.replace(/./g,S=>{const C=S.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?S:"-"+C.toString(16).padStart(4,"0")})}function D(T){return T.replace(/-([0-9a-f]{4})/g,(S,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=D}),define(Se[222],ye([1,0,4,6,92]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(T,S,C){this.d=T,this.e=S,this.f=C,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const P of this.c.values())R.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,S,C,R,P){let E;for(const m of this.e.getVisibleTextEditors(!0))if(m.value===T){E=m;break}if(!E)throw new Error("not a visible editor");const y=this,v=this.a++,d=new a.Emitter,g=new a.Emitter,f=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(m){return(0,I.asWebviewUri)(m,y.f)}get cspSource(){return I.webviewGenericCspSource}set options(m){this.b=m,y.d.$setOptions(v,m)}get options(){return this.b}set html(m){this.a=m,y.d.$setHtml(v,m)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(m){return y.d.$postMessage(v,m)}},w=new class{constructor(){this.editor=T,this.line=S,this.height=C,this.webview=f,this.onDidDispose=g.event}dispose(){y.c.has(v)&&(y.c.delete(v),y.d.$disposeEditorInset(v),g.fire(),g.dispose(),d.dispose())}};return this.d.$createEditorInset(v,E.id,E.value.document.uri,S+1,C,R||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:T,inset:w,onDidReceiveMessage:d}),w}$onDidDispose(T){const S=this.c.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this.c.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(Se[223],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var t;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class I extends Error{constructor(D,T){super(T),this.variable=D}}e.VariableError=I}),define(Se[224],ye([1,0,9,36,11,23,12,111,187,223,8]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,v,d,g){this.g=new Map,this.a=y,this.b=v,this.d=d,g&&(this.c=g.then(f=>this.h(f)))}h(y){if(D.isWindows){const v=Object.create(null);return Object.keys(y).forEach(d=>{v[d.toLowerCase()]=y[d]}),v}return y}resolveWithEnvironment(y,v,d){return this.j({env:this.h(y),userHome:void 0},v?v.uri:void 0,d)}async resolveAsync(y,v){const d={env:await this.c,userHome:await this.d};return this.j(d,y?y.uri:void 0,v)}async i(y,v,d,g){const f=A.deepClone(v);D.isWindows&&f.windows?Object.keys(f.windows).forEach(m=>f[m]=f.windows[m]):D.isMacintosh&&f.osx?Object.keys(f.osx).forEach(m=>f[m]=f.osx[m]):D.isLinux&&f.linux&&Object.keys(f.linux).forEach(m=>f[m]=f.linux[m]),delete f.windows,delete f.osx,delete f.linux;const w={env:await this.c,userHome:await this.d};return this.j(w,y?y.uri:void 0,f,d,g)}async resolveAnyAsync(y,v,d){return this.i(y,v,d)}async resolveAnyMap(y,v,d){const g=new Map;return{newConfig:await this.i(y,v,d,g),resolvedVariables:g}}resolveWithInteractionReplace(y,v,d,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,v,d,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,v){if(this.g.has(y))throw new Error("Variable "+y+" is contributed twice.");this.g.set(y,v)}async j(y,v,d,g,f){if(I.isString(d))return this.l(y,v,d,g,f);if(Array.isArray(d))return Promise.all(d.map(w=>this.j(y,v,w,g,f)));if(I.isObject(d)){const w=Object.create(null),m=await Promise.all(Object.keys(d).map(async h=>[await this.l(y,v,h,g,f),await this.j(y,v,d[h],g,f)]));for(const[h,b]of m)w[h]=b;return w}return d}l(y,v,d,g,f){return(0,R.replaceAsync)(d,P.VARIABLE_REGEXP,async(w,m)=>{if(m.includes(P.VARIABLE_LHS))return w;let h=await this.n(y,w,m,v,g);return f?.set(m,h),h!==w&&I.isString(h)&&h.match(P.VARIABLE_REGEXP)&&(h=await this.l(y,v,h,g,f)),h})}m(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async n(y,v,d,g,f){let w;const m=d.split(":");m.length>1&&(d=m[0],w=m[1]);const h=i=>{const c=this.a.getFilePath();if(c)return c;throw new C.VariableError(i,(0,S.localize)(0,null,v))},b=i=>{const c=h(i);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return u}throw new C.VariableError(i,(0,S.localize)(1,null,v,a.basename(c)))},s=i=>{if(w){const c=this.a.getFolderUri(w);if(c)return c;throw new C.VariableError(i,(0,S.localize)(2,null,v,w))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new C.VariableError(i,(0,S.localize)(3,null,v)):new C.VariableError(i,(0,S.localize)(4,null,v))};switch(d){case"env":if(w){if(y.env){const i=y.env[D.isWindows?w.toLowerCase():w];if(I.isString(i))return i}return""}throw new C.VariableError(C.VariableKind.Env,(0,S.localize)(5,null,v));case"config":if(w){const i=this.a.getConfigurationValue(g,w);if(I.isUndefinedOrNull(i))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(6,null,v,w));if(I.isObject(i))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(7,null,v,w));return i}throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(8,null,v));case"command":return this.o(C.VariableKind.Command,v,w,f,"command");case"input":return this.o(C.VariableKind.Input,v,w,f,"input");case"extensionInstallFolder":if(w){const i=await this.a.getExtension(w);if(!i)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,v,w));return this.m(i.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,v));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.m(s(C.VariableKind.WorkspaceFolder)));case"cwd":return g||w?(0,T.normalizeDriveLetter)(this.m(s(C.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.m(s(C.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(y.userHome)return y.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,S.localize)(11,null,v))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new C.VariableError(C.VariableKind.LineNumber,(0,S.localize)(12,null,v))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new C.VariableError(C.VariableKind.SelectedText,(0,S.localize)(13,null,v))}case"file":return h(C.VariableKind.File);case"fileWorkspaceFolder":return b(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return g||w?a.relative(this.m(s(C.VariableKind.RelativeFile)),h(C.VariableKind.RelativeFile)):h(C.VariableKind.RelativeFile);case"relativeFileDirname":{const i=a.dirname(h(C.VariableKind.RelativeFileDirname));if(g||w){const c=a.relative(this.m(s(C.VariableKind.RelativeFileDirname)),i);return c.length===0?".":c}return i}case"fileDirname":return a.dirname(h(C.VariableKind.FileDirname));case"fileExtname":return a.extname(h(C.VariableKind.FileExtname));case"fileBasename":return a.basename(h(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=a.basename(h(C.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-a.extname(i).length)}case"fileDirnameBasename":return a.basename(a.dirname(h(C.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||v}case"execInstallFolder":{const i=this.a.getAppRoot();return i||v}case"pathSeparator":return a.sep;default:try{const i=w?`${d}:${w}`:d;return this.o(C.VariableKind.Unknown,v,i,f,void 0)}catch{return v}}}}o(y,v,d,g,f){if(d&&g){const w=f===void 0?g[d]:g[f+":"+d];if(typeof w=="string")return w;throw new C.VariableError(y,(0,S.localize)(14,null,v))}return v}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[133],ye([1,0,3,130]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var T;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function C(v){const d=v;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=C;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function E(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=E;function y(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(Se[225],ye([1,0,3,133]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(A){const D=A;return typeof A=="number"||(0,t.isEditorGroup)(D)}e.isPreferredGroup=I}),define(Se[226],ye([1,0,3,193]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(t.IEnvironmentService)}),define(Se[227],ye([1,0,27,4,9]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=A;class D{constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(a.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(a.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let E of P.activationEvents)E==="onUri"&&(E=`onUri:${a.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(E)||this.g.set(E,[]),this.g.get(E).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,E){this.d=C(this.d,E),this.d=this.d.concat(P);const y=D.j(this.d);return this.d=C(this.d,y.map(v=>v.identifier)),this.h(),this.c.fire(void 0),new A(y)}static j(P){const E=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,w){this.addNode(f),this.addNode(w),this.c.has(f)?this.c.get(f).push(w):this.c.set(f,[w])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,w){const m=E.getArcs(f);for(let h=0;h<m.length;h++)if(!w.has(m[h]))return!1;return!0}getNodes(){return this.e}},y=new Map;for(const f of P){const w=a.ExtensionIdentifier.toKey(f.identifier);if(y.set(w,f),f.extensionDependencies)for(const m of f.extensionDependencies){const h=a.ExtensionIdentifier.toKey(m);E.addArc(w,h)}}const v=new Set;E.getNodes().filter(f=>E.getArcs(f).length===0).forEach(f=>v.add(f));const d=E.getNodes().filter(f=>!v.has(f));let g;do{g=!1;for(let f=0;f<d.length;f++){const w=d[f];E.hasOnlyGoodArcs(w,v)&&(d.splice(f,1),f--,v.add(w),g=!0)}}while(g);return d.map(f=>y.get(f))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(a.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const E=this.g.get(P);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const E=this.e.get(a.ExtensionIdentifier.toKey(P));return E||void 0}getExtensionDescriptionByUUID(P){for(const E of this.f)if(E.uuid===P)return E}getExtensionDescriptionByIdOrUUID(P,E){return this.getExtensionDescription(P)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=D;var T;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(T||(T={}));function S(R,P){const E=R.isBuiltin?0:R.isUnderDevelopment?2:1,y=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(E!==y)return E-y;const v=I.posix.basename(R.extensionLocation.path),d=I.posix.basename(P.extensionLocation.path);return v<d?-1:v>d?1:0}function C(R,P){const E=new Set;return P.forEach(y=>E.add(a.ExtensionIdentifier.toKey(y))),R.filter(y=>!E.has(a.ExtensionIdentifier.toKey(y.identifier)))}}),define(Se[228],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class I{constructor(){this.type=2}serialize(P){P[I.ENV_KEY]="1"}}e.SocketExtHostConnection=I,I.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(P){P[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function D(R){delete R[t.ENV_KEY],delete R[I.ENV_KEY],delete R[A.ENV_KEY]}function T(R,P){D(P),R.serialize(P)}e.writeExtHostConnection=T;function S(R){if(R[t.ENV_KEY])return C(R,new t(R[t.ENV_KEY]));if(R[I.ENV_KEY])return C(R,new I);if(R[A.ENV_KEY])return C(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function C(R,P){return D(R),P}}),define(Se[93],ye([1,0,22]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var I;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function D(C){const R=a.VSBuffer.alloc(1);switch(C){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=D;function T(C,R){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=T;var S;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Se[94],ye([1,0,3,4,13,25,93,88,128,23,2]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(d,g){this.i=d,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=g.createLogger(R.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(d,g){const f=this.getTelemetryDetails(),w=new E(g,d,this.g,this.f,this.getBuiltInCommonProperties(d),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled});return this.h.set(d.identifier.value,w),w.apiTelemetryLogger}$initializeTelemetryLevel(d,g,f){this.d=d,this.f=g,this.c=f??{usage:!0,error:!0}}getBuiltInCommonProperties(d){const g={};switch(g["common.extname"]=d.name,g["common.extversion"]=d.version,g["common.vscodemachineid"]=this.i.telemetryInfo.machineId,g["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,g["common.vscodeversion"]=this.i.version,g["common.isnewappinstall"]=y(this.i.telemetryInfo.firstSessionDate),g["common.product"]=this.i.environment.appHost,this.i.uiKind){case D.UIKind.Web:g["common.uikind"]="web";break;case D.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),g}$onDidChangeTelemetryLevel(d){this.e=this.getTelemetryConfiguration(),this.d=d;const g=this.getTelemetryDetails();this.h.forEach(f=>{f.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(d,g){const f=this.h.get(d.value);return f?(f.logError(g),!0):!1}};P=Ve([ze(0,A.IExtHostInitDataService),ze(1,I.ILoggerService)],P),e.ExtHostTelemetry=P;class E{constructor(d,g,f,w,m,h){this.e=g,this.f=f,this.g=w,this.h=m,this.b=new t.Emitter,this.a=d,this.c={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(d,g){this.d&&(this.c={isUsageEnabled:d,isErrorsEnabled:g},this.b.fire(this.d))}mixInCommonPropsAndCleanData(d){let g=d.properties??d;return g=(0,S.cleanData)(g,[]),this.a.additionalCommonProperties&&(g=(0,C.mixin)(g,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(g=(0,C.mixin)(g,this.h)),d.properties?d.properties=g:d=g,d}i(d,g){this.e.publisher==="vscode"?d=this.e.name+"/"+d:d=this.e.identifier.value+"/"+d,g=this.mixInCommonPropsAndCleanData(g||{}),this.g||this.a.logEvent(d,g),this.f.trace(d,g)}logUsage(d,g){!this.c.isUsageEnabled||this.i(d,g)}logError(d,g){!this.c.isErrorsEnabled||(typeof d=="string"?this.i(d,g):this.a.logException(d,g))}get apiTelemetryLogger(){if(!this.d){const d=this,g={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.c.isUsageEnabled},get isErrorsEnabled(){return d.c.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.b.event.bind(d)};this.d=Object.freeze(g)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=E;function y(v){const d=Date.now()-new Date(v).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=y,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Se[26],ye([1,0,4,2,3,27,202]),function(te,e,a,t,I,A,D){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class S{constructor(o){this.affinity=o,this.kind=1}equals(o){return this.kind===o.kind&&this.affinity===o.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class C{constructor(o){this.affinity=o,this.kind=2}equals(o){return this.kind===o.kind&&this.affinity===o.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=C;class R{constructor(){this.kind=3,this.affinity=0}equals(o){return this.kind===o.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class P{constructor(o){this.dependency=o}}e.MissingExtensionDependency=P;var E;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=y;class v{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(o,n){const l=[],p=[],k=[],L=[],U=f(this.c),K=f(o),G=($,M)=>$.extensionLocation.toString()===M.extensionLocation.toString()||$.isBuiltin===M.isBuiltin||$.isUserBuiltin===M.isUserBuiltin||$.isUnderDevelopment===M.isUnderDevelopment;for(const $ of this.c){const M=K.get(A.ExtensionIdentifier.toKey($.identifier));if(!M){l.push($.identifier),U.delete(A.ExtensionIdentifier.toKey($.identifier));continue}if(!G($,M)){l.push($.identifier),U.delete(A.ExtensionIdentifier.toKey($.identifier));continue}}for(const $ of o){const M=U.get(A.ExtensionIdentifier.toKey($.identifier));if(!M){p.push($);continue}if(!G(M,$)){l.push(M.identifier),U.delete(A.ExtensionIdentifier.toKey(M.identifier));continue}}const O=g(this.d),B=g(n);for(const $ of this.d)B.has(A.ExtensionIdentifier.toKey($))||k.push($);for(const $ of n)O.has(A.ExtensionIdentifier.toKey($))||L.push($);const F={toRemove:l,toAdd:p,myToRemove:k,myToAdd:L};return this.delta(F),F}delta(o){const{toRemove:n,toAdd:l,myToRemove:p,myToAdd:k}=o,L=g(n),U=g(p);for(let K=0;K<this.c.length;K++)L.has(A.ExtensionIdentifier.toKey(this.c[K].identifier))&&(this.c.splice(K,1),K--);for(let K=0;K<this.d.length;K++)U.has(A.ExtensionIdentifier.toKey(this.d[K]))&&(this.d.splice(K,1),K--);for(const K of l)this.c.push(K);for(const K of k)this.d.push(K)}containsExtension(o){for(const n of this.d)if(A.ExtensionIdentifier.equals(n,o))return!0;return!1}}e.ExtensionHostExtensions=v;class d{constructor(o){if(this[T]="ExtensionIdentifierSet",this.c=new Map,this.d=A.ExtensionIdentifier.toKey,o)for(const n of o)this.add(n)}get size(){return this.c.size}add(o){return this.c.set(this.d(o),o),this}clear(){this.c.clear()}delete(o){return this.c.delete(this.d(o))}has(o){return this.c.has(this.d(o))}forEach(o,n){this.c.forEach(l=>o.call(n,l,l,this))}*entries(){for(const[o,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=d;function g(r){const o=new Set;for(const n of r)o.add(A.ExtensionIdentifier.toKey(n));return o}e.extensionIdentifiersArrayToSet=g;function f(r){const o=new Map;for(const n of r)o.set(A.ExtensionIdentifier.toKey(n.identifier),n);return o}function w(r,o){return r.enabledApiProposals?r.enabledApiProposals.includes(o):!1}e.isProposedApiEnabled=w;function m(r,o){if(!w(r,o))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=m;class h{constructor(o,n,l,p){this.codeLoadingTime=o,this.activateCallTime=n,this.activateResolvedTime=l,this.activationReason=p}}e.ActivationTimes=h;class b{constructor(o,n){this.description=o,this.value=n}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function i(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=i;function c(r,o){return{identifier:new A.ExtensionIdentifier((0,D.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!o,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=c;class u{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(o,n){return Promise.resolve(0)}getInspectPorts(o,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(Se[229],ye([1,0,10,27,26,13,18]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class T{constructor(g,f,w,m){this.startup=g,this.codeLoadingTime=f,this.activateCallTime=w,this.activateResolvedTime=m}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class S{constructor(g){this.a=g,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(g,f){return g===-1||f===-1?-1:f-g}build(){return new T(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=S;class C{constructor(g,f,w,m,h,b){this.activationFailed=g,this.activationFailedError=f,this.activationTimes=w,this.module=m,this.exports=h,this.subscriptions=b}}e.ActivatedExtension=C;class R extends C{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class P extends C{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class E extends C{constructor(g){super(!0,g,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(g,f,w,m,h){this.h=h,this.a=g,this.b=new Set,f.forEach(b=>this.b.add(t.ExtensionIdentifier.toKey(b))),this.c=new Map,w.forEach(b=>this.c.set(t.ExtensionIdentifier.toKey(b),b)),this.d=m,this.f=new Map,this.g=Object.create(null)}dispose(){for(const[g,f]of this.f)f.dispose()}isActivated(g){const f=this.f.get(t.ExtensionIdentifier.toKey(g));return Boolean(f&&f.value)}getActivatedExtension(g){const f=this.f.get(t.ExtensionIdentifier.toKey(g));if(!f||!f.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return f.value}async activateByEvent(g,f){if(this.g[g])return;const w=this.a.getExtensionDescriptionsForActivationEvent(g);await this.j(w.map(m=>({id:m.identifier,reason:{startup:f,extensionId:m.identifier,activationEvent:g}}))),this.g[g]=!0}activateById(g,f){const w=this.a.getExtensionDescription(g);if(!w)throw new Error(`Extension '${g}' is not known`);return this.j([{id:w.identifier,reason:f}])}async j(g){const f=g.filter(w=>!this.isActivated(w.id)).map(w=>this.k(w));await Promise.all(f.map(w=>w.wait()))}k(g){if(this.f.has(t.ExtensionIdentifier.toKey(g.id)))return this.f.get(t.ExtensionIdentifier.toKey(g.id));if(this.c.has(t.ExtensionIdentifier.toKey(g.id)))return this.l(g,null,[],null);const f=this.a.getExtensionDescription(g.id);if(!f){const h=new Error(`Cannot activate unknown extension '${g.id.value}'`),b=this.l(g,null,[],new E(h));return this.d.onExtensionActivationError(g.id,h,new I.MissingExtensionDependency(g.id.value)),b}const w=[],m=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const h of m){if(this.b.has(t.ExtensionIdentifier.toKey(h)))continue;const b=this.f.get(t.ExtensionIdentifier.toKey(h));if(b){w.push(b);continue}if(this.c.has(t.ExtensionIdentifier.toKey(h))){w.push(this.k({id:this.c.get(t.ExtensionIdentifier.toKey(h)),reason:g.reason}));continue}const s=this.a.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;w.push(this.k({id:s.identifier,reason:g.reason}));continue}const i=f.displayName||f.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${h}'`),u=this.l(g,f.displayName,[],new E(c));return this.d.onExtensionActivationError(f.identifier,c,new I.MissingExtensionDependency(h)),u}return this.l(g,f.displayName,w,null)}l(g,f,w,m){const h=new v(g.id,f,g.reason,w,m,this.d,this.h);return this.f.set(t.ExtensionIdentifier.toKey(g.id),h),h}};y=Ve([ze(4,A.ILogService)],y),e.ExtensionsActivator=y;let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(g,f,w,m,h,b,s){this.c=g,this.d=f,this.f=w,this.g=m,this.h=h,this.j=b,this.k=s,this.a=new D.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let g=0;g<this.g.length;g++){const f=this.g[g];if(f.value&&!f.value.activationFailed){this.g.splice(g,1),g--;continue}if(f.value&&f.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);w.detail=f.value.activationFailedError,this.h=new E(w),this.j.onExtensionActivationError(this.c,w,null);return}}this.g.length>0&&await Promise.race(this.g.map(g=>g.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(g){const f=new Error;if(g&&g.name&&(f.name=g.name),g&&g.message?f.message=`Activating extension '${this.c.value}' failed: ${g.message}.`:f.message=`Activating extension '${this.c.value}' failed: ${g}.`,g&&g.stack&&(f.stack=g.stack),this.h=new E(f),this.b&&a.isCancellationError(g))return;this.j.onExtensionActivationError(this.c,f,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(g)}}};v=Ve([ze(6,A.ILogService)],v)}),define(Se[230],ye([1,0,13,25,26]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends a.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};A=Ve([ze(0,a.ILoggerService),ze(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a},Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[7],ye([1,0,17,10,110,28,82,8,11,2,30,38,127,90,26]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v){"use strict";var d,g,f,w,m,h,b,s,i,c,u,r,o,n,l,p,k,L,U,K,G,O,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(x){return Object.assign(x,{apply:function(){const he=arguments.length===1?[]:arguments[1];return Reflect.construct(x,he,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[he,...ke]=arguments;return Reflect.construct(x,ke,he.constructor)}}})}var $;(function(x){x.top="top",x.bottom="bottom"})($=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var M;(function(x){x.command="command",x.opener="opener"})(M=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let V=h=class{static from(...j){let he=j;return new h(function(){if(he){for(const ke of he)ke&&typeof ke.dispose=="function"&&ke.dispose();he=void 0}})}constructor(j){d.set(this,void 0),Je(this,d,j,"f")}dispose(){typeof Me(this,d,"f")=="function"&&(Me(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,V=h=Ve([F],V),e.Disposable=V;let q=b=class{static Min(...j){if(j.length===0)throw new TypeError;let he=j[0];for(let ke=1;ke<j.length;ke++){const Ke=j[ke];Ke.isBefore(he)&&(he=Ke)}return he}static Max(...j){if(j.length===0)throw new TypeError;let he=j[0];for(let ke=1;ke<j.length;ke++){const Ke=j[ke];Ke.isAfter(he)&&(he=Ke)}return he}static isPosition(j){if(!j)return!1;if(j instanceof b)return!0;const{line:he,character:ke}=j;return typeof he=="number"&&typeof ke=="number"}static of(j){if(j instanceof b)return j;if(this.isPosition(j))return new b(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,he){if(j<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=j,this.e=he}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,he=0){if(j===null||he===null)throw(0,t.illegalArgument)();let ke;return typeof j>"u"?ke=0:typeof j=="number"?ke=j:(ke=typeof j.lineDelta=="number"?j.lineDelta:0,he=typeof j.characterDelta=="number"?j.characterDelta:0),ke===0&&he===0?this:new b(this.line+ke,this.character+he)}with(j,he=this.character){if(j===null||he===null)throw(0,t.illegalArgument)();let ke;return typeof j>"u"?ke=this.line:typeof j=="number"?ke=j:(ke=typeof j.line=="number"?j.line:this.line,he=typeof j.character=="number"?j.character:this.character),ke===this.line&&he===this.character?this:new b(ke,he)}toJSON(){return{line:this.line,character:this.character}}};q=b=Ve([F],q),e.Position=q;let H=s=class{static isRange(j){return j instanceof s?!0:j?q.isPosition(j.start)&&q.isPosition(j.end):!1}static of(j){if(j instanceof s)return j;if(this.isRange(j))return new s(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,he,ke,Ke){let Ye,at;if(typeof j=="number"&&typeof he=="number"&&typeof ke=="number"&&typeof Ke=="number"?(Ye=new q(j,he),at=new q(ke,Ke)):q.isPosition(j)&&q.isPosition(he)&&(Ye=q.of(j),at=q.of(he)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this.c=Ye,this.e=at):(this.c=at,this.e=Ye)}contains(j){return s.isRange(j)?this.contains(j.start)&&this.contains(j.end):q.isPosition(j)?!(q.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const he=q.Max(j.start,this.c),ke=q.Min(j.end,this.e);if(!he.isAfter(ke))return new s(he,ke)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const he=q.Min(j.start,this.c),ke=q.Max(j.end,this.end);return new s(he,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,he=this.end){if(j===null||he===null)throw(0,t.illegalArgument)();let ke;return j?q.isPosition(j)?ke=j:(ke=j.start||this.start,he=j.end||this.end):ke=this.start,ke.isEqual(this.c)&&he.isEqual(this.end)?this:new s(ke,he)}toJSON(){return[this.start,this.end]}};H=s=Ve([F],H),e.Range=H;let J=i=class extends H{static isSelection(j){return j instanceof i?!0:j?H.isRange(j)&&q.isPosition(j.anchor)&&q.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,he,ke,Ke){let Ye,at;if(typeof j=="number"&&typeof he=="number"&&typeof ke=="number"&&typeof Ke=="number"?(Ye=new q(j,he),at=new q(ke,Ke)):q.isPosition(j)&&q.isPosition(he)&&(Ye=q.of(j),at=q.of(he)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this.f=Ye,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};J=i=Ve([F],J),e.Selection=J;class Y{constructor(j,he,ke){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof ke<"u"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,t.illegalArgument)("connectionToken");this.host=j,this.port=Math.round(he),this.connectionToken=ke}}e.ResolvedAuthority=Y;class ae extends Error{static NotAvailable(j,he){return new ae(j,E.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(j){return new ae(j,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,he=E.RemoteAuthorityResolverErrorCode.Unknown,ke){super(j),this._message=j,this._code=he,this._detail=ke,Object.setPrototypeOf(this,ae.prototype)}}e.RemoteAuthorityResolverError=ae;var re;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var fe;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(fe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Z=c=class{static isTextEdit(j){return j instanceof c?!0:j?H.isRange(j)&&typeof j.newText=="string":!1}static replace(j,he){return new c(j,he)}static insert(j,he){return c.replace(new H(j,j),he)}static delete(j){return c.replace(j,"")}static setEndOfLine(j){const he=new c(new H(new q(0,0),new q(0,0)),"");return he.newEol=j,he}get range(){return this.c}set range(j){if(j&&!H.isRange(j))throw(0,t.illegalArgument)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,t.illegalArgument)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,t.illegalArgument)("newEol");this.f=j}constructor(j,he){this.c=j,this.e=he}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};Z=c=Ve([F],Z),e.TextEdit=Z;let pe=u=class{static isNotebookCellEdit(j){return j instanceof u?!0:j?Xt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,he){return new u(j,he)}static insertCells(j,he){return new u(new Xt(j,j),he)}static deleteCells(j){return new u(j,[])}static updateCellMetadata(j,he){const ke=new u(new Xt(j,j),[]);return ke.newCellMetadata=he,ke}static updateNotebookMetadata(j){const he=new u(new Xt(0,0),[]);return he.newNotebookMetadata=j,he}constructor(j,he){this.range=j,this.newCells=he}};pe=u=Ve([F],pe),e.NotebookEdit=pe;class we{static isSnippetTextEdit(j){return j instanceof we?!0:j?H.isRange(j.range)&&Be.isSnippetString(j.snippet):!1}static replace(j,he){return new we(j,he)}static insert(j,he){return we.replace(new H(j,j),he)}constructor(j,he){this.range=j,this.snippet=he}}e.SnippetTextEdit=we;var De;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(De=e.FileEditType||(e.FileEditType={}));let Re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,he,ke,Ke){this.c.push({_type:1,from:j,to:he,options:ke,metadata:Ke})}createFile(j,he,ke){this.c.push({_type:1,from:void 0,to:j,options:he,metadata:ke})}deleteFile(j,he,ke){this.c.push({_type:1,from:j,to:void 0,options:he,metadata:ke})}e(j,he,ke){this.c.push({_type:3,metadata:ke,uri:j,edit:{editType:5,metadata:he},notebookMetadata:he})}f(j,he,ke,Ke){const Ye=he.start,at=he.end;(Ye!==at||ke.length>0)&&this.c.push({_type:5,uri:j,index:Ye,count:at-Ye,cells:ke,metadata:Ke})}g(j,he,ke,Ke){this.c.push({_type:3,metadata:Ke,uri:j,edit:{editType:8,index:he,metadata:ke}})}replace(j,he,ke,Ke){this.c.push({_type:2,uri:j,edit:new Z(he,ke),metadata:Ke})}insert(j,he,ke,Ke){this.replace(j,new H(he,he),ke,Ke)}delete(j,he,ke){this.replace(j,he,"",ke)}has(j){return this.c.some(he=>he._type===2&&he.uri.toString()===j.toString())}set(j,he){if(he)for(const ke of he){if(!ke)continue;let Ke,Ye;Array.isArray(ke)?(Ke=ke[0],Ye=ke[1]):Ke=ke,pe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(j,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(j,Ke.newNotebookMetadata,Ye):this.f(j,Ke.range,Ke.newCells,Ye):we.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:j,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:j,edit:Ke,metadata:Ye})}else{for(let ke=0;ke<this.c.length;ke++){const Ke=this.c[ke];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===j.toString()&&(this.c[ke]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(j){const he=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===j.toString()&&he.push(ke.edit);return he}entries(){const j=new A.ResourceMap;for(const he of this.c)if(he._type===2){let ke=j.get(he.uri);ke||(ke=[he.uri,[]],j.set(he.uri,ke)),ke[1].push(he.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Re=Ve([F],Re),e.WorkspaceEdit=Re;let Be=r=class{static isSnippetString(j){return j instanceof r?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=r.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,he=this.e++){if(typeof j=="function"){const ke=new r;ke.e=this.e,j(ke),this.e=ke.e,j=ke.value}else j=r.c(j);return this.value+="${",this.value+=he,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,he=this.e++){const ke=j.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(j,he){if(typeof he=="function"){const ke=new r;ke.e=this.e,he(ke),this.e=ke.e,he=ke.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,he&&(this.value+=":",this.value+=he),this.value+="}",this}};Be=r=Ve([F],Be),e.SnippetString=Be;var se;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=o=class{static isLocation(j){return j instanceof o?!0:j?H.isRange(j.range)&&C.URI.isUri(j.uri):!1}constructor(j,he){if(this.uri=j,he)if(H.isRange(he))this.range=H.of(he);else if(q.isPosition(he))this.range=new H(he,he);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};de=o=Ve([F],de),e.Location=de;let ee=class{static is(j){return j?typeof j.message=="string"&&j.location&&H.isRange(j.location.range)&&C.URI.isUri(j.location.uri):!1}constructor(j,he){this.location=j,this.message=he}static isEqual(j,he){return j===he?!0:!j||!he?!1:j.message===he.message&&j.location.range.isEqual(he.location.range)&&j.location.uri.toString()===he.location.uri.toString()}};ee=Ve([F],ee),e.DiagnosticRelatedInformation=ee;let oe=class{constructor(j,he,ke=ue.Error){if(!H.isRange(j))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=j,this.message=he,this.severity=ke}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,he){return j===he?!0:!j||!he?!1:j.message===he.message&&j.severity===he.severity&&j.code===he.code&&j.severity===he.severity&&j.source===he.source&&j.range.isEqual(he.range)&&(0,a.equals)(j.tags,he.tags)&&(0,a.equals)(j.relatedInformation,he.relatedInformation,ee.isEqual)}};oe=Ve([F],oe),e.Diagnostic=oe;let ie=class{constructor(j,he){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=he}};ie=Ve([F],ie),e.Hover=ie;var N;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(N=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let z=class{constructor(j,he=N.Text){this.range=j,this.kind=he}toJSON(){return{range:this.range,kind:N[this.kind]}}};z=Ve([F],z),e.DocumentHighlight=z;var X;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(X=e.SymbolKind||(e.SymbolKind={}));var Q;(function(x){x[x.Deprecated=1]="Deprecated"})(Q=e.SymbolTag||(e.SymbolTag={}));let le=n=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,he,ke,Ke,Ye){this.name=j,this.kind=he,this.containerName=Ye,typeof ke=="string"&&(this.containerName=ke),Ke instanceof de?this.location=Ke:ke instanceof H&&(this.location=new de(Ke,ke)),n.validate(this)}toJSON(){return{name:this.name,kind:X[this.kind],location:this.location,containerName:this.containerName}}};le=n=Ve([F],le),e.SymbolInformation=le;let be=l=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(l.validate)}constructor(j,he,ke,Ke,Ye){this.name=j,this.detail=he,this.kind=ke,this.range=Ke,this.selectionRange=Ye,this.children=[],l.validate(this)}};be=l=Ve([F],be),e.DocumentSymbol=be;var Te;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(Te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ge=class{constructor(j,he){this.title=j,this.kind=he}};ge=Ve([F],ge),e.CodeAction=ge;let Ce=p=class{constructor(j){this.value=j}append(j){return new p(this.value?this.value+p.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+p.c)}};Ce.c=".",Ce=p=Ve([F],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let Ie=class{constructor(j,he){if(this.range=j,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ie=Ve([F],Ie),e.SelectionRange=Ie;class He{constructor(j,he,ke,Ke,Ye,at){this.kind=j,this.name=he,this.detail=ke,this.uri=Ke,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=He;class qe{constructor(j,he){this.fromRanges=he,this.from=j}}e.CallHierarchyIncomingCall=qe;class Ze{constructor(j,he){this.fromRanges=he,this.to=j}}e.CallHierarchyOutgoingCall=Ze;var xe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(j,he){this.range=j,this.command=he}get isResolved(){return!!this.command}};tt=Ve([F],tt),e.CodeLens=tt;let nt=k=class{static isMarkdownString(j){return j instanceof k?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,he=!1){g.set(this,void 0),Je(this,g,new I.MarkdownString(j,{supportThemeIcons:he}),"f")}get value(){return Me(this,g,"f").value}set value(j){Me(this,g,"f").value=j}get isTrusted(){return Me(this,g,"f").isTrusted}set isTrusted(j){Me(this,g,"f").isTrusted=j}get supportThemeIcons(){return Me(this,g,"f").supportThemeIcons}set supportThemeIcons(j){Me(this,g,"f").supportThemeIcons=j}get supportHtml(){return Me(this,g,"f").supportHtml}set supportHtml(j){Me(this,g,"f").supportHtml=j}get baseUri(){return Me(this,g,"f").baseUri}set baseUri(j){Me(this,g,"f").baseUri=j}appendText(j){return Me(this,g,"f").appendText(j),this}appendMarkdown(j){return Me(this,g,"f").appendMarkdown(j),this}appendCodeblock(j,he){return Me(this,g,"f").appendCodeblock(he??"",j),this}};g=new WeakMap,nt=k=Ve([F],nt),e.MarkdownString=nt;let ft=class{constructor(j,he){this.label=j,this.documentation=he}};ft=Ve([F],ft),e.ParameterInformation=ft;let it=class{constructor(j,he){this.label=j,this.documentation=he,this.parameters=[]}};it=Ve([F],it),e.SignatureInformation=it;let Fe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Fe=Ve([F],Fe),e.SignatureHelp=Fe;var lt;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(lt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var W;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(W=e.InlayHintKind||(e.InlayHintKind={}));let _=class{constructor(j){this.value=j}};_=Ve([F],_),e.InlayHintLabelPart=_;let ce=class{constructor(j,he,ke){this.position=j,this.label=he,this.kind=ke}};ce=Ve([F],ce),e.InlayHint=ce;var Pe;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Le=e.CompletionItemKind||(e.CompletionItemKind={}));var Ge;(function(x){x[x.Deprecated=1]="Deprecated"})(Ge=e.CompletionItemTag||(e.CompletionItemTag={}));let Qe=class{constructor(j,he){this.label=j,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&Le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Qe=Ve([F],Qe),e.CompletionItem=Qe;let ut=class{constructor(j=[],he=!1){this.items=j,this.isIncomplete=he}};ut=Ve([F],ut),e.CompletionList=ut;let mt=class{constructor(j,he,ke){this.insertText=j,this.range=he,this.command=ke}};mt=Ve([F],mt),e.InlineSuggestion=mt;let st=class{constructor(j){this.commands=void 0,this.items=j}};st=Ve([F],st),e.InlineSuggestionList=st;var rt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(rt=e.ViewColumn||(e.ViewColumn={}));var ct;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ct=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Et;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Rt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var At;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(At=e.TextEditorRevealType||(e.TextEditorRevealType={}));var wt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(wt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var kt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(kt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function j(he){switch(he){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=j}(wt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(j,he){if(he&&!C.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!H.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.target=he}};Nt=Ve([F],Nt),e.DocumentLink=Nt;let Xe=class{constructor(j,he,ke,Ke){this.red=j,this.green=he,this.blue=ke,this.alpha=Ke}};Xe=Ve([F],Xe),e.Color=Xe;let zt=class{constructor(j,he){if(he&&!(he instanceof Xe))throw(0,t.illegalArgument)("color");if(!H.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.color=he}};zt=Ve([F],zt),e.ColorInformation=zt;let Lt=class{constructor(j){if(!j||typeof j!="string")throw(0,t.illegalArgument)("label");this.label=j}};Lt=Ve([F],Lt),e.ColorPresentation=Lt;var Wt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Wt=e.ColorFormat||(e.ColorFormat={}));var pt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Mt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(Mt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ae{constructor(j,he,ke){if(this.startIndex=j,this.length=he,this.tooltip=ke,typeof j!="number"||j<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ae;var Oe;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Oe=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(j){if(this.options=j,typeof j!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ee;var ne;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var Ne;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Ne=e.TaskPanelKind||(e.TaskPanelKind={}));let $e=L=class{static from(j){switch(j){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(j,he){if(this.label=he,typeof j!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this.c=j}get id(){return this.c}};$e.Clean=new L("clean","Clean"),$e.Build=new L("build","Build"),$e.Rebuild=new L("rebuild","Rebuild"),$e.Test=new L("test","Test"),$e=L=Ve([F],$e),e.TaskGroup=$e;function _e(x){let j="";for(let he=0;he<x.length;he++)j+=x[he].replace(/,/g,",,")+",";return j}let je=class{constructor(j,he,ke){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=j,he!==void 0&&(Array.isArray(he)?(this.e=he,this.f=ke):this.f=he)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const he of this.e)j.push(he);return _e(j)}};je=Ve([F],je),e.ProcessExecution=je;let et=class{constructor(j,he,ke){if(this.f=[],Array.isArray(he)){if(!j)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j,this.f=he,this.g=ke}else{if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j,this.g=he}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const he of this.f)j.push(typeof he=="string"?he:he.value);return _e(j)}};et=Ve([F],et),e.ShellExecution=et;var It;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var St;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class Ot{constructor(j){this.c=j}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(j){this.c=j}get callback(){return this.c}}e.CustomExecution=Ot;let bt=U=class{constructor(j,he,ke,Ke,Ye,at){this.j=!1,this.k=this.definition=j;let ht;typeof he=="string"?(this.m=this.name=he,this.t=this.source=ke,this.execution=Ke,ht=Ye,this.j=!0):he===St.Global||he===St.Workspace?(this.target=he,this.m=this.name=ke,this.t=this.source=Ke,this.execution=Ye,ht=at):(this.target=he,this.m=this.name=ke,this.t=this.source=Ke,this.execution=Ye,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof je?this.k={type:U.e,id:this.n.computeId()}:this.n instanceof et?this.k={type:U.f,id:this.n.computeId()}:this.n instanceof Ot?this.k={type:U.c,id:this.n.computeId()}:this.k={type:U.g,id:(0,R.generateUuid)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=j}get scope(){return this.l}set target(j){this.y(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.y(),this.n=j;const he=this.k.type;(U.g===he||U.e===he||U.f===he||U.c===he)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.y(),this.o=j,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.y(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.y(),this.u=j}get detail(){return this.x}set detail(j){j===null&&(j=void 0),this.x=j}get presentationOptions(){return this.v}set presentationOptions(j){j==null&&(j=Object.create(null)),this.y(),this.v=j}get runOptions(){return this.w}set runOptions(j){j==null&&(j=Object.create(null)),this.y(),this.w=j}};bt.c="customExecution",bt.e="process",bt.f="shell",bt.g="$empty",bt=U=Ve([F],bt),e.Task=bt;var Tt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Tt=e.ProgressLocation||(e.ProgressLocation={}));var vt;(function(x){function j(he){const ke=he;return(0,S.isNumber)(ke.value)?ke.tooltip&&!(0,S.isString)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}x.isViewBadge=j})(vt=e.ViewBadge||(e.ViewBadge={}));let Ht=K=class{static isTreeItem(j,he){if(j instanceof K)return!0;const ke=j;if(ke.label!==void 0&&!(0,S.isString)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,S.isString)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,S.isString)(ke.iconPath)&&!C.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,S.isString)(ke.iconPath.id))){const Ke=ke.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!C.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!C.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}if(ke.description!==void 0&&!(0,S.isString)(ke.description)&&typeof ke.description!="boolean")return console.log("INVALID tree item, invalid description",ke.description),!1;if(ke.resourceUri!==void 0&&!C.URI.isUri(ke.resourceUri))return console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1;if(ke.tooltip!==void 0&&!(0,S.isString)(ke.tooltip)&&!(ke.tooltip instanceof nt))return console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1;if(ke.command!==void 0&&!ke.command.command)return console.log("INVALID tree item, invalid command",ke.command),!1;if(ke.collapsibleState!==void 0&&ke.collapsibleState<Ut.None&&ke.collapsibleState>Ut.Expanded)return console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1;if(ke.contextValue!==void 0&&!(0,S.isString)(ke.contextValue))return console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1;if(ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1;if(ke.checkboxState!==void 0){(0,v.checkProposedApiEnabled)(he,"treeItemCheckbox");const Ke=(0,S.isNumber)(ke.checkboxState)?ke.checkboxState:(0,S.isObject)(ke.checkboxState)&&(0,S.isNumber)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ye=!(0,S.isNumber)(ke.checkboxState)&&(0,S.isObject)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==yt.Checked&&Ke!==yt.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}return!0}constructor(j,he=Ut.None){this.collapsibleState=he,C.URI.isUri(j)?this.resourceUri=j:this.label=j}};Ht=K=Ve([F],Ht),e.TreeItem=Ht;var Ut;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var yt;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(yt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Zt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j,he){this.value=j,this.id=he??(0,R.generateUuid)()}};Zt=Ve([F],Zt),e.DataTransferItem=Zt;let an=class{constructor(j){f.set(this,new Map);for(const[he,ke]of j??[]){const Ke=Me(this,f,"f").get(he);Ke?Ke.push(ke):Me(this,f,"f").set(he,[ke])}}get(j){return Me(this,f,"f").get(j)?.[0]}set(j,he){Me(this,f,"f").set(j,[he])}forEach(j,he){for(const[ke,Ke]of Me(this,f,"f"))for(const Ye of Ke)j.call(he,Ye,ke,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[j,he]of Me(this,f,"f"))for(const ke of he)yield[j,ke]}};an=Ve([F],an),e.DataTransfer=an;let en=class{constructor(j){this.insertText=j}};en=Ve([F],en),e.DocumentDropEdit=en;let bn=class{constructor(j){this.insertText=j}};bn=Ve([F],bn),e.DocumentPasteEdit=bn;let Ct=class{constructor(j,he){this.id=j,this.color=he}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};Ct=Ve([F],Ct),e.ThemeIcon=Ct,Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let cn=class{constructor(j){this.id=j}};cn=Ve([F],cn),e.ThemeColor=cn;var On;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(On=e.ConfigurationTarget||(e.ConfigurationTarget={}));let tn=class{get base(){return this.c}set base(j){this.c=j,this.e=C.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,he){if(typeof j!="string"&&(!j||!C.URI.isUri(j)&&!C.URI.isUri(j.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof j=="string"?this.baseUri=C.URI.file(j):C.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=he}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};tn=Ve([F],tn),e.RelativePattern=tn;let Vt=class{constructor(j,he,ke,Ke){this.enabled=typeof j=="boolean"?j:!0,typeof he=="string"&&(this.condition=he),typeof ke=="string"&&(this.hitCondition=ke),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,R.generateUuid)()),this.c}};Vt=Ve([F],Vt),e.Breakpoint=Vt;let dt=class extends Vt{constructor(j,he,ke,Ke,Ye){if(super(he,ke,Ke,Ye),j===null)throw(0,t.illegalArgument)("location");this.location=j}};dt=Ve([F],dt),e.SourceBreakpoint=dt;let wn=class extends Vt{constructor(j,he,ke,Ke,Ye){super(he,ke,Ke,Ye),this.functionName=j}};wn=Ve([F],wn),e.FunctionBreakpoint=wn;let qt=class extends Vt{constructor(j,he,ke,Ke,Ye,at,ht){if(super(Ke,Ye,at,ht),!he)throw(0,t.illegalArgument)("dataId");this.label=j,this.dataId=he,this.canPersist=ke}};qt=Ve([F],qt),e.DataBreakpoint=qt;let _t=class{constructor(j,he,ke){this.command=j,this.args=he||[],this.options=ke}};_t=Ve([F],_t),e.DebugAdapterExecutable=_t;let ln=class{constructor(j,he){this.port=j,this.host=he}};ln=Ve([F],ln),e.DebugAdapterServer=ln;let vn=class{constructor(j){this.path=j}};vn=Ve([F],vn),e.DebugAdapterNamedPipeServer=vn;let un=class{constructor(j){this.implementation=j}};un=Ve([F],un),e.DebugAdapterInlineImplementation=un;let En=class{constructor(j,he){this.range=j,this.expression=he}};En=Ve([F],En),e.EvaluatableExpression=En;var kn;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let nn=class{constructor(j,he){this.range=j,this.text=he}};nn=Ve([F],nn),e.InlineValueText=nn;let Sn=class{constructor(j,he,ke=!0){this.range=j,this.variableName=he,this.caseSensitiveLookup=ke}};Sn=Ve([F],Sn),e.InlineValueVariableLookup=Sn;let sn=class{constructor(j,he){this.range=j,this.expression=he}};sn=Ve([F],sn),e.InlineValueEvaluatableExpression=sn;let on=class{constructor(j,he){this.frameId=j,this.stoppedLocation=he}};on=Ve([F],on),e.InlineValueContext=on;var Nn;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Nn=e.FileChangeType||(e.FileChangeType={}));let yn=G=class extends Error{static FileExists(j){return new G(j,P.FileSystemProviderErrorCode.FileExists,G.FileExists)}static FileNotFound(j){return new G(j,P.FileSystemProviderErrorCode.FileNotFound,G.FileNotFound)}static FileNotADirectory(j){return new G(j,P.FileSystemProviderErrorCode.FileNotADirectory,G.FileNotADirectory)}static FileIsADirectory(j){return new G(j,P.FileSystemProviderErrorCode.FileIsADirectory,G.FileIsADirectory)}static NoPermissions(j){return new G(j,P.FileSystemProviderErrorCode.NoPermissions,G.NoPermissions)}static Unavailable(j){return new G(j,P.FileSystemProviderErrorCode.Unavailable,G.Unavailable)}constructor(j,he=P.FileSystemProviderErrorCode.Unknown,ke){super(C.URI.isUri(j)?j.toString(!0):j),this.code=ke?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,he),Object.setPrototypeOf(this,G.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};yn=G=Ve([F],yn),e.FileSystemError=yn;let Qt=class{constructor(j,he,ke){this.start=j,this.end=he,this.kind=ke}};Qt=Ve([F],Qt),e.FoldingRange=Qt;var Fn;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Fn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mn;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Mn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Un;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Un=e.CommentMode||(e.CommentMode={}));var Bn;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Bn=e.CommentThreadState||(e.CommentThreadState={}));class $n{constructor(j,he=[]){this.tokenTypes=j,this.tokenModifiers=he}}e.SemanticTokensLegend=$n;function Cn(x){return typeof x>"u"||(0,S.isStringArray)(x)}class dn{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let he=0,ke=j.tokenTypes.length;he<ke;he++)this.j.set(j.tokenTypes[he],he);for(let he=0,ke=j.tokenModifiers.length;he<ke;he++)this.k.set(j.tokenModifiers[he],he)}}push(j,he,ke,Ke,Ye){if(typeof j=="number"&&typeof he=="number"&&typeof ke=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(j,he,ke,Ke,Ye);if(H.isRange(j)&&typeof he=="string"&&Cn(ke))return this.m(j,he,ke);throw(0,t.illegalArgument)()}m(j,he,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(he))throw new Error("`tokenType` is not in the provided legend");const Ke=j.start.line,Ye=j.start.character,at=j.end.character-j.start.character,ht=this.j.get(he);let Ft=0;if(ke)for(const jt of ke){if(!this.k.has(jt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(jt);Ft|=1<<Gt>>>0}this.n(Ke,Ye,at,ht,Ft)}n(j,he,ke,Ke,Ye){if(this.f&&(j<this.c||j===this.c&&he<this.e)){this.f=!1;const Ft=this.g.length/5|0;let jt=0,Gt=0;for(let xt=0;xt<Ft;xt++){let Yt=this.g[5*xt],Dn=this.g[5*xt+1];Yt===0?(Yt=jt,Dn+=Gt):Yt+=jt,this.g[5*xt]=Yt,this.g[5*xt+1]=Dn,jt=Yt,Gt=Dn}}let at=j,ht=he;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=ke,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=j,this.e=he}static o(j){const he=[],ke=j.length/5|0;for(let ht=0;ht<ke;ht++)he[ht]=ht;he.sort((ht,Ft)=>{const jt=j[5*ht],Gt=j[5*Ft];if(jt===Gt){const xt=j[5*ht+1],Yt=j[5*Ft+1];return xt-Yt}return jt-Gt});const Ke=new Uint32Array(j.length);let Ye=0,at=0;for(let ht=0;ht<ke;ht++){const Ft=5*he[ht],jt=j[Ft+0],Gt=j[Ft+1],xt=j[Ft+2],Yt=j[Ft+3],Dn=j[Ft+4],ti=jt-Ye,Ii=ti===0?Gt-at:Gt,In=5*ht;Ke[In+0]=ti,Ke[In+1]=Ii,Ke[In+2]=xt,Ke[In+3]=Yt,Ke[In+4]=Dn,Ye=jt,at=Gt}return Ke}build(j){return this.f?new hn(new Uint32Array(this.g),j):new hn(dn.o(this.g),j)}}e.SemanticTokensBuilder=dn;class hn{constructor(j,he){this.resultId=he,this.data=j}}e.SemanticTokens=hn;class We{constructor(j,he,ke){this.start=j,this.deleteCount=he,this.data=ke}}e.SemanticTokensEdit=We;class Kt{constructor(j,he){this.resultId=he,this.edits=j}}e.SemanticTokensEdits=Kt;var Tn;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Tn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let gt=class{constructor(){}};gt.Back={iconPath:new Ct("arrow-left")},gt=Ve([F],gt),e.QuickInputButtons=gt;var zn;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(zn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Wn;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Wn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Pn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Pn=e.ExtensionKind||(e.ExtensionKind={}));class Hn{static validate(j){if(typeof j.badge=="string"){let he=(0,T.nextCharLength)(j.badge,0);if(he<j.badge.length&&(he+=(0,T.nextCharLength)(j.badge,he)),j.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Ct.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,he,ke){this.badge=j,this.tooltip=he,this.color=ke}}e.FileDecoration=Hn;let rn=class{constructor(j){this.kind=j}};rn=Ve([F],rn),e.ColorTheme=rn;var jn;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(jn=e.ColorThemeKind||(e.ColorThemeKind={}));class Xt{static isNotebookRange(j){return j instanceof Xt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,he){if(j<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");j<=he?(this.c=j,this.e=he):(this.c=he,this.e=j)}with(j){let he=this.c,ke=this.e;return j.start!==void 0&&(he=j.start),j.end!==void 0&&(ke=j.end),he===this.c&&ke===this.e?this:new Xt(he,ke)}}e.NotebookRange=Xt;class fn{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(he=>fn.isNotebookCellData(he))}static isNotebookCellData(j){return!0}constructor(j,he,ke,Ke,Ye,at,ht){this.kind=j,this.value=he,this.languageId=ke,this.mime=Ke,this.outputs=Ye??[],this.metadata=at,this.executionSummary=ht,fn.validate(this)}}e.NotebookCellData=fn;class An{constructor(j){this.cells=j}}e.NotebookData=An;class $t{static isNotebookCellOutputItem(j){return j instanceof $t?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const he={name:j.name,message:j.message,stack:j.stack};return $t.json(he,"application/vnd.code.notebook.error")}static stdout(j){return $t.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return $t.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,he="application/octet-stream"){return new $t(j,he)}static text(j,he=D.Mimes.text){const ke=Me($t,w,"f",m).encode(String(j));return new $t(ke,he)}static json(j,he="text/x-json"){const ke=JSON.stringify(j,void 0,"	");return $t.text(ke,he)}constructor(j,he){this.data=j,this.mime=he;const ke=(0,D.normalizeMimeType)(he,!0);if(!ke)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.NotebookCellOutputItem=$t,w=$t,m={value:new TextEncoder};class mn{static isNotebookCellOutput(j){return j instanceof mn?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,he=!1){const ke=new Set,Ke=new Set;for(let Ye=0;Ye<j.length;Ye++){const at=j[Ye],ht=(0,D.normalizeMimeType)(at.mime);if(!ke.has(ht)||(0,y.isTextStreamMime)(ht)){ke.add(ht);continue}Ke.add(Ye),he&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?j:j.filter((Ye,at)=>!Ke.has(at))}constructor(j,he,ke){this.items=mn.ensureUniqueMimeTypes(j,!0),typeof he=="string"?(this.id=he,this.metadata=ke):(this.id=(0,R.generateUuid)(),this.metadata=he??ke)}}e.NotebookCellOutput=mn;var Vn;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Vn=e.NotebookCellKind||(e.NotebookCellKind={}));var qn;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(qn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Gn;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Kn;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Kn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class me{constructor(j,he){this.text=j,this.alignment=he}}e.NotebookCellStatusBarItem=me;var ve;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(ve=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Ue;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(Ue=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ot{constructor(j,he=[]){this.uri=j,this.provides=(0,a.asArray)(he)}}e.NotebookRendererScript=ot;class Dt{constructor(j){this.label=j}}e.NotebookKernelSourceAction=Dt;let Pt=class{constructor(j,he){this.label=j,this.timestamp=he}};Pt=Ve([F],Pt),e.TimelineItem=Pt;var si;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class ci{constructor(j,he){this.ranges=j,this.wordPattern=he}}e.LinkedEditingRanges=ci;class li{constructor(j,he){this.c=j,this.e=he}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=li;var ui;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var di;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(di=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Xn=class{constructor(j=void 0,he=void 0,ke=void 0){this.include=j,this.exclude=he,this.profile=ke}};Xn=Ve([F],Xn),e.TestRunRequest=Xn;let xn=O=class{static diff(j,he,ke){const Ke=new O(j);return Ke.expectedOutput=he,Ke.actualOutput=ke,Ke}constructor(j){this.message=j}};xn=O=Ve([F],xn),e.TestMessage=xn;let _n=class{constructor(j){this.id=j}};_n=Ve([F],_n),e.TestTag=_n;let gn=class{constructor(j,he){this.covered=j,this.total=he}};gn=Ve([F],gn),e.CoveredCount=gn;let Qn=B=class{static fromDetails(j,he){const ke=new gn(0,0),Ke=new gn(0,0),Ye=new gn(0,0);for(const ht of he)if("branches"in ht){ke.total+=1,ke.covered+=ht.executionCount>0?1:0;for(const Ft of ht.branches)Ke.total+=1,Ke.covered+=Ft.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ht.executionCount>0?1:0;const at=new B(j,ke,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=he,at}constructor(j,he,ke,Ke){this.uri=j,this.statementCoverage=he,this.branchCoverage=ke,this.functionCoverage=Ke}};Qn=B=Ve([F],Qn),e.FileCoverage=Qn;let Yn=class{constructor(j,he,ke=[]){this.executionCount=j,this.location=he,this.branches=ke}};Yn=Ve([F],Yn),e.StatementCoverage=Yn;let Jn=class{constructor(j,he){this.executionCount=j,this.location=he}};Jn=Ve([F],Jn),e.BranchCoverage=Jn;let Zn=class{constructor(j,he){this.executionCount=j,this.location=he}};Zn=Ve([F],Zn),e.FunctionCoverage=Zn;var hi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fi;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(fi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(j,he,ke,Ke,Ye,at){this.kind=j,this.name=he,this.detail=ke,this.uri=Ke,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=gi;class pi{constructor(j){this.uri=j}}e.TextTabInput=pi;class bi{constructor(j,he){this.original=j,this.modified=he}}e.TextDiffTabInput=bi;class wi{constructor(j,he,ke,Ke){this.base=j,this.input1=he,this.input2=ke,this.result=Ke}}e.TextMergeTabInput=wi;class vi{constructor(j,he){this.uri=j,this.viewType=he}}e.CustomEditorTabInput=vi;class Ei{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=Ei;class Si{constructor(j,he){this.uri=j,this.notebookType=he}}e.NotebookEditorTabInput=Si;class yi{constructor(j,he,ke){this.original=j,this.modified=he,this.notebookType=ke}}e.NotebookDiffEditorTabInput=yi;class Ci{constructor(){}}e.TerminalEditorTabInput=Ci;class Di{constructor(j,he){this.uri=j,this.inputBoxUri=he}}e.InteractiveWindowInput=Di}),define(Se[134],ye([1,0,48,15,8,161,104,7,17]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const C=new Map;function R(v,d){d?C.set(v,d):C.delete(v)}e.setWordDefinitionFor=R;function P(v){return C.get(v)}class E extends A.MirrorTextModel{constructor(d,g,f,w,m,h,b,s){super(g,f,w,m),this.m=d,this.p=h,this.q=b,this.notebook=s,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===t.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(g){return g?d.s(g):d.getText()},get eol(){return d.f===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(g){return d.t(g)},offsetAt(g){return d.u(g)},positionAt(g){return d.v(g)},validateRange(g){return d.w(g)},validatePosition(g){return d.x(g)},getWordRangeAtPosition(g,f){return d.y(g,f)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,a.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,a.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const g=this.w(d);if(g.isEmpty)return"";if(g.isSingleLine)return this.d[g.start.line].substring(g.start.character,g.end.character);const f=this.f,w=g.start.line,m=g.end.line,h=[];h.push(this.d[w].substring(g.start.character));for(let b=w+1;b<m;b++)h.push(this.d[b]);return h.push(this.d[m].substring(0,g.end.character)),h.join(f)}t(d){let g;if(d instanceof T.Position?g=d.line:typeof d=="number"&&(g=d),typeof g!="number"||g<0||g>=this.d.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new y(g,this.d[g],g===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const g=this.h.getIndexOf(d),f=this.d[g.index].length;return new T.Position(g.index,Math.min(g.remainder,f))}w(d){if(!(d instanceof T.Range))throw new Error("Invalid argument");const g=this.x(d.start),f=this.x(d.end);return g===d.start&&f===d.end?d:new T.Range(g.line,g.character,f.line,f.character)}x(d){if(!(d instanceof T.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:g,character:f}=d,w=!1;if(g<0)g=0,f=0,w=!0;else if(g>=this.d.length)g=this.d.length-1,f=this.d[g].length,w=!0;else{const m=this.d[g].length;f<0?(f=0,w=!0):f>m&&(f=m,w=!0)}return w?new T.Position(g,f):d}y(d,g){const f=this.x(d);if(!g)g=P(this.p);else if((0,I.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const w=(0,D.getWordAtText)(f.character+1,(0,D.ensureValidWordDefinition)(g),this.d[f.line],0);if(w)return new T.Range(f.line,w.startColumn-1,f.line,w.endColumn-1)}}e.ExtHostDocumentData=E;class y{constructor(d,g,f){this.a=d,this.b=g,this.c=f}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=y}),define(Se[231],ye([1,0,7,16,4]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(T){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new I.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(T){let S;switch(T){case"light":S=a.ColorThemeKind.Light;break;case"hcDark":S=a.ColorThemeKind.HighContrast;break;case"hcLight":S=a.ColorThemeKind.HighContrastLight;break;default:S=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};A=Ve([ze(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Se[14],ye([1,0,17,22,147,61,110,28,146,84,82,23,11,2,35,66,122,132,130,90,56,68,225,7]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m,h,b,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(Ae){function Oe(ne){const{selectionStartLineNumber:Ne,selectionStartColumn:$e,positionLineNumber:_e,positionColumn:je}=ne,et=new i.Position(Ne-1,$e-1),It=new i.Position(_e-1,je-1);return new i.Selection(et,It)}Ae.to=Oe;function Ee(ne){const{anchor:Ne,active:$e}=ne;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Ae.from=Ee})(c=e.Selection||(e.Selection={}));var u;(function(Ae){function Oe(ne){if(!ne)return;const{start:Ne,end:$e}=ne;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Ae.from=Oe;function Ee(ne){if(!ne)return;const{startLineNumber:Ne,startColumn:$e,endLineNumber:_e,endColumn:je}=ne;return new i.Range(Ne-1,$e-1,_e-1,je-1)}Ae.to=Ee})(u=e.Range||(e.Range={}));var r;(function(Ae){function Oe(Ee){switch(Ee){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}Ae.to=Oe})(r=e.TokenType||(e.TokenType={}));var o;(function(Ae){function Oe(ne){return new i.Position(ne.lineNumber-1,ne.column-1)}Ae.to=Oe;function Ee(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Ae.from=Ee})(o=e.Position||(e.Position={}));var n;(function(Ae){function Oe(Ne,$e){return(0,a.coalesce)((0,a.asArray)(Ne).map(_e=>Ee(_e,$e)))}Ae.from=Oe;function Ee(Ne,$e){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:ne(Ne.scheme,$e),pattern:W.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function ne(Ne,$e){return $e&&typeof Ne=="string"?$e.transformOutgoingScheme(Ne):Ne}})(n=e.DocumentSelector||(e.DocumentSelector={}));var l;(function(Ae){function Oe(ne){switch(ne){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Ee(ne){switch(ne){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}Ae.to=Ee})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(Ae){function Oe(ne){let Ne;return ne.code&&((0,E.isString)(ne.code)||(0,E.isNumber)(ne.code)?Ne=String(ne.code):Ne={value:String(ne.code.value),target:ne.code.target}),{...u.from(ne.range),message:ne.message,source:ne.source,code:Ne,severity:L.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(k.from),tags:Array.isArray(ne.tags)?(0,a.coalesce)(ne.tags.map(l.from)):void 0}}Ae.from=Oe;function Ee(ne){const Ne=new i.Diagnostic(u.to(ne),ne.message,L.to(ne.severity));return Ne.source=ne.source,Ne.code=(0,E.isString)(ne.code)?ne.code:ne.code?.value,Ne.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(k.to),Ne.tags=ne.tags&&(0,a.coalesce)(ne.tags.map(l.to)),Ne}Ae.to=Ee})(p=e.Diagnostic||(e.Diagnostic={}));var k;(function(Ae){function Oe(ne){return{...u.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Ae.from=Oe;function Ee(ne){return new i.DiagnosticRelatedInformation(new i.Location(ne.resource,u.to(ne)),ne.message)}Ae.to=Ee})(k=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var L;(function(Ae){function Oe(ne){switch(ne){case i.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Ae.from=Oe;function Ee(ne){switch(ne){case g.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}Ae.to=Ee})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var U;(function(Ae){function Oe(ne){return typeof ne=="number"&&ne>=i.ViewColumn.One?ne-1:ne===i.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}Ae.from=Oe;function Ee(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Ee})(U=e.ViewColumn||(e.ViewColumn={}));function K(Ae){return typeof Ae.range<"u"}function G(Ae){return Ae.length===0?!0:!!K(Ae[0])}e.isDecorationOptionsArr=G;var O;(function(Ae){function Oe(je){return je.map(Ae.from)}Ae.fromMany=Oe;function Ee(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function ne(je){let et;if(Ee(je)){const{language:bt,value:Tt}=je;et={value:"```"+bt+`
`+Tt+"\n```\n"}}else i.MarkdownString.isMarkdownString(je)?et={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?et={value:je}:et={value:""};const It=Object.create(null);et.uris=It;const St=bt=>{try{let Tt=y.URI.parse(bt,!0);Tt=Tt.with({query:Ne(Tt.query,It)}),It[bt]=Tt}catch{}return""},Ot=new S.marked.Renderer;return Ot.link=St,Ot.image=bt=>typeof bt=="string"?St(D.parseHrefAndDimensions(bt).href):"",(0,S.marked)(et.value,{renderer:Ot}),et}Ae.from=ne;function Ne(je,et){if(!je)return je;let It;try{It=(0,C.parse)(je)}catch{}if(!It)return je;let St=!1;return It=(0,P.cloneAndChange)(It,Ot=>{if(y.URI.isUri(Ot)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[bt]=Ot,St=!0,bt}else return}),St?JSON.stringify(It):je}function $e(je){const et=new i.MarkdownString(je.value,je.supportThemeIcons);return et.isTrusted=je.isTrusted,et.supportHtml=je.supportHtml,et.baseUri=je.baseUri?y.URI.from(je.baseUri):void 0,et}Ae.to=$e;function _e(je){if(!!je)return typeof je=="string"?je:Ae.from(je)}Ae.fromStrict=_e})(O=e.MarkdownString||(e.MarkdownString={}));function B(Ae){return G(Ae)?Ae.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?O.fromMany(Oe.hoverMessage):Oe.hoverMessage?O.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=B;function F(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?y.URI.file(Ae):Ae}e.pathOrURIToURI=F;var $;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?F(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Ae.from=Oe})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var M;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?$.from(Ee.before):void 0,after:Ee.after?$.from(Ee.after):void 0}}Ae.from=Oe})(M=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(Ae){function Oe(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(Ae){function Oe(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?V.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?M.from(Ee.light):void 0,dark:Ee.dark?M.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?$.from(Ee.before):void 0,after:Ee.after?$.from(Ee.after):void 0}}Ae.from=Oe})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(Ae){function Oe(ne){return{text:ne.newText,eol:ne.newEol&&nt.from(ne.newEol),range:u.from(ne.range)}}Ae.from=Oe;function Ee(ne){const Ne=new i.TextEdit(u.to(ne.range),ne.text);return Ne.newEol=typeof ne.eol>"u"?void 0:nt.to(ne.eol),Ne}Ae.to=Ee})(H=e.TextEdit||(e.TextEdit={}));var J;(function(Ae){function Oe(ne,Ne){const $e={edits:[]};if(ne instanceof i.WorkspaceEdit){const _e=new T.ResourceSet;for(const je of ne._allEntries())je._type===1&&y.URI.isUri(je.to)&&je.from===void 0&&_e.add(je.to);for(const je of ne._allEntries())je._type===1?$e.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contentsBase64:je.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(je.options.contents))},metadata:je.metadata}):je._type===2?$e.edits.push({resource:je.uri,textEdit:H.from(je.edit),versionId:_e.has(je.uri)?void 0:Ne?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?$e.edits.push({resource:je.uri,textEdit:{range:u.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:_e.has(je.uri)?void 0:Ne?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?$e.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(je.uri)}):je._type===5&&$e.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(ut.from)}})}return $e}Ae.from=Oe;function Ee(ne){const Ne=new i.WorkspaceEdit;for(const $e of ne.edits)$e.textEdit?Ne.replace(y.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Ne.renameFile(y.URI.revive($e.oldResource),y.URI.revive($e.newResource),$e.options);return Ne}Ae.to=Ee})(J=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Y;(function(Ae){const Oe=Object.create(null);Oe[i.SymbolKind.File]=0,Oe[i.SymbolKind.Module]=1,Oe[i.SymbolKind.Namespace]=2,Oe[i.SymbolKind.Package]=3,Oe[i.SymbolKind.Class]=4,Oe[i.SymbolKind.Method]=5,Oe[i.SymbolKind.Property]=6,Oe[i.SymbolKind.Field]=7,Oe[i.SymbolKind.Constructor]=8,Oe[i.SymbolKind.Enum]=9,Oe[i.SymbolKind.Interface]=10,Oe[i.SymbolKind.Function]=11,Oe[i.SymbolKind.Variable]=12,Oe[i.SymbolKind.Constant]=13,Oe[i.SymbolKind.String]=14,Oe[i.SymbolKind.Number]=15,Oe[i.SymbolKind.Boolean]=16,Oe[i.SymbolKind.Array]=17,Oe[i.SymbolKind.Object]=18,Oe[i.SymbolKind.Key]=19,Oe[i.SymbolKind.Null]=20,Oe[i.SymbolKind.EnumMember]=21,Oe[i.SymbolKind.Struct]=22,Oe[i.SymbolKind.Event]=23,Oe[i.SymbolKind.Operator]=24,Oe[i.SymbolKind.TypeParameter]=25;function Ee(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Ae.from=Ee;function ne(Ne){for(const $e in Oe)if(Oe[$e]===Ne)return Number($e);return i.SymbolKind.Property}Ae.to=ne})(Y=e.SymbolKind||(e.SymbolKind={}));var ae;(function(Ae){function Oe(ne){switch(ne){case i.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Ee(ne){switch(ne){case 1:return i.SymbolTag.Deprecated}}Ae.to=Ee})(ae=e.SymbolTag||(e.SymbolTag={}));var re;(function(Ae){function Oe(ne){return{name:ne.name,kind:Y.from(ne.kind),tags:ne.tags&&ne.tags.map(ae.from),containerName:ne.containerName,location:De.from(ne.location)}}Ae.from=Oe;function Ee(ne){const Ne=new i.SymbolInformation(ne.name,Y.to(ne.kind),ne.containerName,De.to(ne.location));return Ne.tags=ne.tags&&ne.tags.map(ae.to),Ne}Ae.to=Ee})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var fe;(function(Ae){function Oe(ne){const Ne={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:u.from(ne.range),selectionRange:u.from(ne.selectionRange),kind:Y.from(ne.kind),tags:ne.tags?.map(ae.from)??[]};return ne.children&&(Ne.children=ne.children.map(Oe)),Ne}Ae.from=Oe;function Ee(ne){const Ne=new i.DocumentSymbol(ne.name,ne.detail,Y.to(ne.kind),u.to(ne.range),u.to(ne.selectionRange));return(0,a.isNonEmptyArray)(ne.tags)&&(Ne.tags=ne.tags.map(ae.to)),ne.children&&(Ne.children=ne.children.map(Ee)),Ne}Ae.to=Ee})(fe=e.DocumentSymbol||(e.DocumentSymbol={}));var Z;(function(Ae){function Oe(ne){const Ne=new i.CallHierarchyItem(Y.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),u.to(ne.range),u.to(ne.selectionRange));return Ne._sessionId=ne._sessionId,Ne._itemId=ne._itemId,Ne}Ae.to=Oe;function Ee(ne,Ne,$e){if(Ne=Ne??ne._sessionId,$e=$e??ne._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,name:ne.name,detail:ne.detail,kind:Y.from(ne.kind),uri:ne.uri,range:u.from(ne.range),selectionRange:u.from(ne.selectionRange),tags:ne.tags?.map(ae.from)}}Ae.from=Ee})(Z=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(Ae){function Oe(Ee){return new i.CallHierarchyIncomingCall(Z.to(Ee.from),Ee.fromRanges.map(ne=>u.to(ne)))}Ae.to=Oe})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var we;(function(Ae){function Oe(Ee){return new i.CallHierarchyOutgoingCall(Z.to(Ee.to),Ee.fromRanges.map(ne=>u.to(ne)))}Ae.to=Oe})(we=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var De;(function(Ae){function Oe(ne){return{range:ne.range&&u.from(ne.range),uri:ne.uri}}Ae.from=Oe;function Ee(ne){return new i.Location(y.URI.revive(ne.uri),u.to(ne.range))}Ae.to=Ee})(De=e.location||(e.location={}));var Re;(function(Ae){function Oe(ne){const Ne=ne,$e=ne;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:$e.uri,range:u.from(Ne.targetRange?Ne.targetRange:$e.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Ae.from=Oe;function Ee(ne){return{targetUri:y.URI.revive(ne.uri),targetRange:u.to(ne.range),targetSelectionRange:ne.targetSelectionRange?u.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?u.to(ne.originSelectionRange):void 0}}Ae.to=Ee})(Re=e.DefinitionLink||(e.DefinitionLink={}));var Be;(function(Ae){function Oe(ne){return{range:u.from(ne.range),contents:O.fromMany(ne.contents)}}Ae.from=Oe;function Ee(ne){return new i.Hover(ne.contents.map(O.to),u.to(ne.range))}Ae.to=Ee})(Be=e.Hover||(e.Hover={}));var se;(function(Ae){function Oe(ne){return{range:u.from(ne.range),expression:ne.expression}}Ae.from=Oe;function Ee(ne){return new i.EvaluatableExpression(u.to(ne.range),ne.expression)}Ae.to=Ee})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ue;(function(Ae){function Oe(ne){if(ne instanceof i.InlineValueText)return{type:"text",range:u.from(ne.range),text:ne.text};if(ne instanceof i.InlineValueVariableLookup)return{type:"variable",range:u.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof i.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Ee(ne){switch(ne.type){case"text":return{range:u.to(ne.range),text:ne.text};case"variable":return{range:u.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:u.to(ne.range),expression:ne.expression}}}Ae.to=Ee})(ue=e.InlineValue||(e.InlineValue={}));var de;(function(Ae){function Oe(ne){return{frameId:ne.frameId,stoppedLocation:u.from(ne.stoppedLocation)}}Ae.from=Oe;function Ee(ne){return new i.InlineValueContext(ne.frameId,u.to(ne.stoppedLocation))}Ae.to=Ee})(de=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Ae){function Oe(ne){return{range:u.from(ne.range),kind:ne.kind}}Ae.from=Oe;function Ee(ne){return new i.DocumentHighlight(u.to(ne.range),ne.kind)}Ae.to=Ee})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var oe;(function(Ae){function Oe(Ee){switch(Ee){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}Ae.to=Oe})(oe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ie;(function(Ae){function Oe(Ee){return{triggerKind:oe.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Ae.to=Oe})(ie=e.CompletionContext||(e.CompletionContext={}));var N;(function(Ae){function Oe(ne){switch(ne){case i.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Ee(ne){switch(ne){case 1:return i.CompletionItemTag.Deprecated}}Ae.to=Ee})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var z;(function(Ae){const Oe=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function Ee($e){return Oe.get($e)??9}Ae.from=Ee;const ne=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Ne($e){return ne.get($e)??i.CompletionItemKind.Property}Ae.to=Ne})(z=e.CompletionItemKind||(e.CompletionItemKind={}));var X;(function(Ae){function Oe(Ee,ne){const Ne=new i.CompletionItem(Ee.label);return Ne.insertText=Ee.insertText,Ne.kind=z.to(Ee.kind),Ne.tags=Ee.tags?.map(N.to),Ne.detail=Ee.detail,Ne.documentation=D.isMarkdownString(Ee.documentation)?O.to(Ee.documentation):Ee.documentation,Ne.sortText=Ee.sortText,Ne.filterText=Ee.filterText,Ne.preselect=Ee.preselect,Ne.commitCharacters=Ee.commitCharacters,v.Range.isIRange(Ee.range)?Ne.range=u.to(Ee.range):typeof Ee.range=="object"&&(Ne.range={inserting:u.to(Ee.range.insert),replacing:u.to(Ee.range.replace)}),Ne.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:Boolean(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Ne.insertText=new i.SnippetString(Ee.insertText):(Ne.insertText=Ee.insertText,Ne.textEdit=Ne.range instanceof i.Range?new i.TextEdit(Ne.range,Ne.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ee.additionalTextEdits.map($e=>H.to($e))),Ne.command=ne&&Ee.command?ne.fromInternal(Ee.command):void 0,Ne}Ae.to=Oe})(X=e.CompletionItem||(e.CompletionItem={}));var Q;(function(Ae){function Oe(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:O.fromStrict(ne.documentation)}}Ae.from=Oe;function Ee(ne){return{label:ne.label,documentation:D.isMarkdownString(ne.documentation)?O.to(ne.documentation):ne.documentation}}Ae.to=Ee})(Q=e.ParameterInformation||(e.ParameterInformation={}));var le;(function(Ae){function Oe(ne){return{label:ne.label,documentation:O.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(Q.from):[],activeParameter:ne.activeParameter}}Ae.from=Oe;function Ee(ne){return{label:ne.label,documentation:D.isMarkdownString(ne.documentation)?O.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(Q.to):[],activeParameter:ne.activeParameter}}Ae.to=Ee})(le=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(Ae){function Oe(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(le.from):[]}}Ae.from=Oe;function Ee(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(le.to):[]}}Ae.to=Ee})(be=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(Ae){function Oe(Ee,ne){const Ne=new i.InlayHint(o.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(ge.to.bind(void 0,Ee)),ne.kind&&Ce.to(ne.kind));return Ne.textEdits=ne.textEdits&&ne.textEdits.map(H.to),Ne.tooltip=D.isMarkdownString(ne.tooltip)?O.to(ne.tooltip):ne.tooltip,Ne.paddingLeft=ne.paddingLeft,Ne.paddingRight=ne.paddingRight,Ne}Ae.to=Oe})(Te=e.InlayHint||(e.InlayHint={}));var ge;(function(Ae){function Oe(Ee,ne){const Ne=new i.InlayHintLabelPart(ne.label);return Ne.tooltip=D.isMarkdownString(ne.tooltip)?O.to(ne.tooltip):ne.tooltip,d.Command.is(ne.command)&&(Ne.command=Ee.fromInternal(ne.command)),ne.location&&(Ne.location=De.to(ne.location)),Ne}Ae.to=Oe})(ge=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Ae){function Oe(ne){return ne}Ae.from=Oe;function Ee(ne){return ne}Ae.to=Ee})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var Ie;(function(Ae){function Oe(ne){return{range:u.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Ae.from=Oe;function Ee(ne){let Ne;if(ne.url)try{Ne=typeof ne.url=="string"?y.URI.parse(ne.url,!0):y.URI.revive(ne.url)}catch{}return new i.DocumentLink(u.to(ne.range),Ne)}Ae.to=Ee})(Ie=e.DocumentLink||(e.DocumentLink={}));var He;(function(Ae){function Oe(ne){const Ne=new i.ColorPresentation(ne.label);return ne.textEdit&&(Ne.textEdit=H.to(ne.textEdit)),ne.additionalTextEdits&&(Ne.additionalTextEdits=ne.additionalTextEdits.map($e=>H.to($e))),Ne}Ae.to=Oe;function Ee(ne){return{label:ne.label,textEdit:ne.textEdit?H.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Ne=>H.from(Ne)):void 0}}Ae.from=Ee})(He=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(Ae){function Oe(ne){return new i.Color(ne[0],ne[1],ne[2],ne[3])}Ae.to=Oe;function Ee(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Ae.from=Ee})(qe=e.Color||(e.Color={}));var Ze;(function(Ae){function Oe(ne){return{range:u.from(ne.range)}}Ae.from=Oe;function Ee(ne){return new i.SelectionRange(u.to(ne.range))}Ae.to=Ee})(Ze=e.SelectionRange||(e.SelectionRange={}));var xe;(function(Ae){function Oe(Ee){switch(Ee){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(Ae){function Oe(ne){switch(ne){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Ee(ne){switch(ne){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}Ae.to=Ee})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var nt;(function(Ae){function Oe(ne){if(ne===i.EndOfLine.CRLF)return 1;if(ne===i.EndOfLine.LF)return 0}Ae.from=Oe;function Ee(ne){if(ne===1)return i.EndOfLine.CRLF;if(ne===0)return i.EndOfLine.LF}Ae.to=Ee})(nt=e.EndOfLine||(e.EndOfLine={}));var ft;(function(Ae){function Oe(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(ft=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Ae){function Oe(Ee){const ne={start:Ee.start+1,end:Ee.end+1};return Ee.kind&&(ne.kind=Fe.from(Ee.kind)),ne}Ae.from=Oe})(it=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(Ae){function Oe(Ee){if(Ee)switch(Ee){case i.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case i.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case i.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Ae.from=Oe})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var lt;(function(Ae){function Oe(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?u.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?w.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(lt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var W;(function(Ae){function Oe($e){return $e instanceof i.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Ee($e)||ne($e)?new i.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Ae.from=Oe;function Ee($e){const _e=$e;return _e?y.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ne($e){const _e=$e;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ne($e){return typeof $e=="string"?$e:new i.RelativePattern(y.URI.revive($e.baseUri),$e.pattern)}Ae.to=Ne})(W=e.GlobPattern||(e.GlobPattern={}));var _;(function(Ae){function Oe(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Oe);if(typeof Ee=="string")return Ee;{const ne=Ee;return{language:ne.language,scheme:ne.scheme,pattern:W.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Ae.from=Oe})(_=e.LanguageSelector||(e.LanguageSelector={}));var ce;(function(Ae){function Oe(ne){return{start:ne.start,end:ne.end}}Ae.from=Oe;function Ee(ne){return new i.NotebookRange(ne.start,ne.end)}Ae.to=Ee})(ce=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(Ae){function Oe(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Ae.to=Oe;function Ee(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Ae.from=Ee})(Pe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Le;(function(Ae){function Oe(Ee){if(Ee===m.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(Ee===m.NotebookCellExecutionState.Pending)return;if(Ee===m.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Ae.to=Oe})(Le=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ge;(function(Ae){function Oe(ne){switch(ne){case i.NotebookCellKind.Markup:return m.CellKind.Markup;case i.NotebookCellKind.Code:default:return m.CellKind.Code}}Ae.from=Oe;function Ee(ne){switch(ne){case m.CellKind.Markup:return i.NotebookCellKind.Markup;case m.CellKind.Code:default:return i.NotebookCellKind.Code}}Ae.to=Ee})(Ge=e.NotebookCellKind||(e.NotebookCellKind={}));var Qe;(function(Ae){function Oe(ne){const Ne={metadata:ne.metadata??Object.create(null),cells:[]};for(const $e of ne.cells)i.NotebookCellData.validate($e),Ne.cells.push(ut.from($e));return Ne}Ae.from=Oe;function Ee(ne){const Ne=new i.NotebookData(ne.cells.map(ut.to));return(0,E.isEmptyObject)(ne.metadata)||(Ne.metadata=ne.metadata),Ne}Ae.to=Ee})(Qe=e.NotebookData||(e.NotebookData={}));var ut;(function(Ae){function Oe(ne){return{cellKind:Ge.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Pe.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(st.from):[]}}Ae.from=Oe;function Ee(ne){return new i.NotebookCellData(Ge.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(st.to):void 0,ne.metadata,ne.internalMetadata?Pe.to(ne.internalMetadata):void 0)}Ae.to=Ee})(ut=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Ae){function Oe(ne){return{mime:ne.mime,valueBytes:t.VSBuffer.wrap(ne.data)}}Ae.from=Oe;function Ee(ne){return new i.NotebookCellOutputItem(ne.valueBytes.buffer,ne.mime)}Ae.to=Ee})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var st;(function(Ae){function Oe(ne){return{outputId:ne.id,items:ne.items.map(mt.from),metadata:ne.metadata}}Ae.from=Oe;function Ee(ne){const Ne=ne.items.map(mt.to);return new i.NotebookCellOutput(Ne,ne.outputId,ne.metadata)}Ae.to=Ee})(st=e.NotebookCellOutput||(e.NotebookCellOutput={}));var rt;(function(Ae){function Oe(Ne){return ne(Ne)?{include:(0,E.withNullAsUndefined)(W.from(Ne.include)),exclude:(0,E.withNullAsUndefined)(W.from(Ne.exclude))}:(0,E.withNullAsUndefined)(W.from(Ne))}Ae.from=Oe;function Ee(Ne){return ne(Ne)?{include:W.to(Ne.include),exclude:W.to(Ne.exclude)}:W.to(Ne)}Ae.to=Ee;function ne(Ne){const $e=Ne;return $e?!(0,E.isUndefinedOrNull)($e.include)&&!(0,E.isUndefinedOrNull)($e.exclude):!1}})(rt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ct;(function(Ae){function Oe(Ee,ne,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal($e,Ne),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Ae.from=Oe})(ct=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Et;(function(Ae){function Oe(Ee,ne,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:ne.toInternal($e,Ne),label:Ee.label,description:Ee.description,detail:Ee.detail}}Ae.from=Oe})(Et=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Rt;(function(Ae){function Oe(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Ae.from=Oe})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var At;(function(Ae){function Oe(ne){return{uri:ne.uri,provides:ne.provides}}Ae.from=Oe;function Ee(ne){return new i.NotebookRendererScript(y.URI.revive(ne.uri),ne.provides)}Ae.to=Ee})(At=e.NotebookRendererScript||(e.NotebookRendererScript={}));var wt;(function(Ae){function Oe(ne){return{message:O.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,location:ne.location&&{range:u.from(ne.location.range),uri:ne.location.uri}}}Ae.from=Oe;function Ee(ne){const Ne=new i.TestMessage(typeof ne.message=="string"?ne.message:O.to(ne.message));return Ne.actualOutput=ne.actual,Ne.expectedOutput=ne.expected,Ne.location=ne.location?De.to(ne.location):void 0,Ne}Ae.to=Ee})(wt=e.TestMessage||(e.TestMessage={}));var kt;(function(Ae){Ae.namespace=b.namespaceTestTag,Ae.denamespace=b.denamespaceTestTag})(kt=e.TestTag||(e.TestTag={}));var Bt;(function(Ae){function Oe(ne){const Ne=(0,f.getPrivateApiFor)(ne).controllerId;return{extId:h.TestId.fromExtHostTestItem(ne,Ne).toString(),label:ne.label,uri:y.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map($e=>kt.namespace(Ne,$e.id)),range:v.Range.lift(u.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&O.fromStrict(ne.error)||null}}Ae.from=Oe;function Ee(ne){return{parent:void 0,error:void 0,id:h.TestId.fromString(ne.extId).localId,label:ne.label,uri:y.URI.revive(ne.uri),tags:(ne.tags||[]).map(Ne=>{const{tagId:$e}=kt.denamespace(Ne);return new i.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Ae.toPlain=Ee})(Bt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(ne){return{id:ne.id}}Ae.from=Oe;function Ee(ne){return new i.TestTag(ne.id)}Ae.to=Ee}(kt=e.TestTag||(e.TestTag={}));var Nt;(function(Ae){const Oe=(ne,Ne)=>{const $e=[];for(const[je,et]of Ne)h.TestId.compare(et.item.extId,je)===2&&(Ne.delete(je),$e.push(et));const _e={...Bt.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(et=>et.type===0).map(wt.to)})),children:$e.map(je=>Oe(je,Ne))};for(const je of _e.children)je.parent=_e;return _e};function Ee(ne){const Ne=[],$e=new Map;for(const _e of ne.items){$e.set(_e.item.extId,_e);const je=h.TestId.root(_e.item.extId);ne.request.targets.some(et=>et.controllerId===je&&et.testIds.includes(_e.item.extId))&&Ne.push(_e)}return{completedAt:ne.completedAt,results:Ne.map(_e=>Oe(_e,$e))}}Ae.to=Ee})(Nt=e.TestResults||(e.TestResults={}));var Xe;(function(Ae){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Ee($e){return"line"in $e?o.from($e):u.from($e)}function ne($e){return"branches"in $e?{count:$e.executionCount,location:Ee($e.location),type:1,branches:$e.branches.length?$e.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Ee(_e.location)})):void 0}:{type:0,count:$e.executionCount,location:Ee($e.location)}}Ae.fromDetailed=ne;function Ne($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(ne)}}Ae.fromFile=Ne})(Xe=e.TestCoverage||(e.TestCoverage={}));var zt;(function(Ae){function Oe(Ee){switch(Ee){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(zt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(Ae){function Oe(ne){const Ne=new i.TypeHierarchyItem(Y.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),u.to(ne.range),u.to(ne.selectionRange));return Ne._sessionId=ne._sessionId,Ne._itemId=ne._itemId,Ne}Ae.to=Oe;function Ee(ne,Ne,$e){if(Ne=Ne??ne._sessionId,$e=$e??ne._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,kind:Y.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:u.from(ne.range),selectionRange:u.from(ne.selectionRange),tags:ne.tags?.map(ae.from)}}Ae.from=Ee})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Wt;(function(Ae){function Oe(Ee){if(!!Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Ae.from=Oe})(Wt=e.ViewBadge||(e.ViewBadge={}));var pt;(function(Ae){function Oe($e,_e,je){const et=_e.fileData;return et?new class extends i.DataTransferItem{asFile(){return{name:et.name,uri:y.URI.revive(et.uri),data:(0,A.once)(()=>je())}}}("",_e.id):$e===R.Mimes.uriList&&_e.uriListData?new i.DataTransferItem(Ne(_e.uriListData)):new i.DataTransferItem(_e.asString)}Ae.to=Oe;async function Ee($e,_e){const je=await _e.asString();if($e===R.Mimes.uriList)return{id:_e.id,asString:"",fileData:void 0,uriListData:ne(je)};const et=_e.asFile();return{id:_e.id,asString:je,fileData:et?{name:et.name,uri:et.uri}:void 0}}Ae.from=Ee;function ne($e){return I.UriList.split($e).map(_e=>{if(_e.startsWith("#"))return _e;try{return y.URI.parse(_e)}catch{}return _e})}function Ne($e){return I.UriList.create($e.map(_e=>typeof _e=="string"?_e:y.URI.revive(_e)))}})(pt=e.DataTransferItem||(e.DataTransferItem={}));var Mt;(function(Ae){function Oe(ne,Ne){const $e=ne.items.map(([_e,je])=>[_e,pt.to(_e,je,()=>Ne(je.id))]);return new i.DataTransfer($e)}Ae.toDataTransfer=Oe;async function Ee(ne){const Ne={items:[]},$e=[];return ne.forEach((_e,je)=>{$e.push((async()=>{Ne.items.push([je,await pt.from(je,_e)])})())}),await Promise.all($e),Ne}Ae.toDataTransferDTO=Ee})(Mt=e.DataTransfer||(e.DataTransfer={}))}),define(Se[232],ye([1,0,2,10,7,14,63]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(C,R,P,E={timeout:1500,errors:3}){this.c=C,this.d=R,this.f=P,this.g=E,this.a=new D.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(R,P,E)=>{const v={dispose:this.a.push([R,P,C])};return Array.isArray(E)&&E.push(v),v}}async $participateInSave(C,R){const P=a.URI.revive(C);let E=!1;const y=setTimeout(()=>E=!0,this.g.timeout),v=[];try{for(const d of[...this.a]){if(E)break;const g=this.d.getDocument(P),f=await this.h(d,{document:g,reason:A.TextDocumentSaveReason.to(R)});v.push(f)}}finally{clearTimeout(y)}return v}h([C,R,P],E){const y=this.b.get(C);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(P,C,R,E).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const d=this.b.get(C);this.b.set(C,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,R,P,E){const y=[],v=Date.now(),{document:d,reason:g}=E,{version:f}=d,w=Object.freeze({document:d,reason:g,waitUntil(m){if(Object.isFrozen(y))throw(0,t.illegalState)("waitUntil can not be called async");y.push(Promise.resolve(m))}});try{R.apply(P,[w])}catch(m){return Promise.reject(m)}return Object.freeze(y),new Promise((m,h)=>{const b=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(y).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(b),m(s)}).catch(s=>{clearTimeout(b),h(s)})}).then(m=>{const h={edits:[]};for(const b of m)if(Array.isArray(b)&&b.every(s=>s instanceof I.TextEdit))for(const{newText:s,newEol:i,range:c}of b)h.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:c&&A.Range.from(c),text:s,eol:i&&A.EndOfLine.from(i)}});if(h.edits.length!==0)return f===d.version?this.f.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(Se[233],ye([1,0,15,2,14,7,90]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(P,E,y,v){this.start=P,this.deletedCount=E,this.deletedItems=y,this.items=v}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(P,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,E,y){this.notebook=P,this.h=E,this.j=y,this.handle=y.handle,this.uri=t.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(I.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,E=this.h.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:E.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(y)}return this.f}setOutputs(P){this.a=P.map(I.NotebookCellOutput.to)}setOutputItems(P,E,y){const v=y.map(I.NotebookCellOutputItem.to),d=this.a.find(g=>g.id===P);if(d&&(E||(d.items.length=0),d.items.push(...v),d.items.length>1&&d.items.every(g=>D.isTextStreamMime(g.mime)))){const g=new Map,f=[];d.items.forEach(w=>{let m;g.has(w.mime)?m=g.get(w.mime):(m=[],g.set(w.mime,m),f.push(w.mime)),m.push(w.data)}),d.items.length=0,f.forEach(w=>{const m=D.compressOutputItemStreams(g.get(w));d.items.push({mime:w,data:m.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=S;class C{constructor(P,E,y,v,d){this.k=P,this.l=E,this.m=y,this.uri=v,this.handle=C.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,E={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===a.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(y){return y=P.n(y),P.b[y].apiCell},getCells(y){return(y?P.p(y):P.b).map(d=>d.apiCell)},save(){return P.q()}};this.e=Object.freeze(E)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,E,y){this.g=P.versionId,this.h=E,this.acceptDocumentPropertiesChanged({metadata:y});const v={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},d=[];for(const f of P.rawEvents)f.kind===D.NotebookCellsChangeType.ModelChange?this.r(f.changes,!1,v.contentChanges):f.kind===D.NotebookCellsChangeType.Move?this.s(f.index,f.length,f.newIdx,v.contentChanges):f.kind===D.NotebookCellsChangeType.Output?(this.t(f.index,f.outputs),d.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===D.NotebookCellsChangeType.OutputItem?(this.u(f.index,f.outputId,f.append,f.outputItems),d.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this.v(f.index,f.language),d.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document})):f.kind===D.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document}):f.kind===D.NotebookCellsChangeType.ChangeCellMime?this.w(f.index,f.mime):f.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this.x(f.index,f.metadata),d.push({cell:this.b[f.index].apiCell,metadata:this.b[f.index].apiCell.metadata})):f.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(f.index,f.internalMetadata),d.push({cell:this.b[f.index].apiCell,executionSummary:this.b[f.index].apiCell.executionSummary}));const g=new Map;for(let f=0;f<d.length;f++){const w=d[f],m=g.get(w.cell);if(m===void 0){const h=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...w});g.set(w.cell,h-1)}else v.cellChanges[m]={...v.cellChanges[m],...w}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let E=P.start|0,y=P.end|0;return E<0&&(E=0),y>this.b.length&&(y=this.b.length),P.with({start:E,end:y})}p(P){P=this.o(P);const E=[];for(let y=P.start;y<P.end;y++)E.push(this.b[y]);return E}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,E,y){if(this.j)return;const v=[],d=[],g=[];if(P.reverse().forEach(f=>{const m=f[2].map(s=>{const i=new S(this,this.l,s);return E||d.push(S.asModelAddData(this.apiNotebook,s)),i}),h=new T(f[0],f[1],[],m),b=this.b.splice(f[0],f[1],...m);for(const s of b)g.push(s.uri),h.deletedItems.push(s.apiCell);v.push(h)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:g}),y)for(const f of v)y.push(f.asApiEvent())}s(P,E,y,v){const d=this.b.splice(P,E);this.b.splice(y,0,...d);const g=[new T(P,E,d.map(f=>f.apiCell),[]),new T(y,0,[],d)];for(const f of g)v.push(f.asApiEvent())}t(P,E){this.b[P].setOutputs(E)}u(P,E,y,v){this.b[P].setOutputItems(E,y,v)}v(P,E){const y=this.b[P];y.apiCell.document.languageId!==E&&this.m.$acceptModelLanguageChanged(y.uri,E)}w(P,E){const y=this.b[P];y.apiCell.mime=E}x(P,E){this.b[P].setMetadata(E)}y(P,E){this.b[P].setInternalMetadata(E)}getCellFromApiCell(P){return this.b.find(E=>E.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(E=>E.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=C,C.a=0}),define(Se[135],ye([1,0,10,14,7]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(T,S,C,R,P,E){this.id=T,this.f=S,this.notebookData=C,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=R,this.c=E}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(S){this.selections=[S]},get selections(){return T.a},set selections(S){if(!Array.isArray(S)||!S.every(I.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");T.a=S,T.g(S)},get visibleRanges(){return T.b},revealRange(S,C){T.f.$tryRevealRange(T.id,t.NotebookRange.from(S),C??I.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(t.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(Se[234],ye([1,0,4,13,14]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(T,S){this.c=T,this.d=S,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const C=this.d.getEditorById(T);S.visibleRanges&&C._acceptVisibleRanges(S.visibleRanges.ranges.map(I.NotebookRange.to)),S.selections&&C._acceptSelections(S.selections.selections.map(I.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this.d.getEditorById(S)._acceptViewColumn(I.ViewColumn.to(T[S]))}};A=Ve([ze(0,t.ILogService)],A),e.ExtHostNotebookEditors=A}),define(Se[235],ye([1,0,14,124,174,21,60,10]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,y,v){const d=this.b++,{title:g,location:f,cancellable:w}=y,m={label:(0,I.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this.a.$startProgress(d,{location:a.ProgressLocation.from(f),title:g,source:m,cancellable:w},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.onUnexpectedExternalError),this.d(d,v,!!w)}d(E,y,v){let d;v&&(d=new A.CancellationTokenSource,this.c.set(E,d));const g=w=>{this.a.$progressEnd(w),this.c.delete(w),d?.dispose()};let f;try{f=y(new R(this.a,E),v&&d?d.token:A.CancellationToken.None)}catch(w){throw g(E),w}return f.then(w=>g(E),w=>g(E)),f}$acceptProgressCanceled(E){const y=this.c.get(E);y&&(y.cancel(),this.c.delete(E))}}e.ExtHostProgress=S;function C(P,E){return P.message=E.message,typeof E.increment=="number"&&(typeof P.increment=="number"?P.increment+=E.increment:P.increment=E.increment),P}class R extends t.Progress{constructor(E,y){super(v=>this.throttledReport(v)),this.c=E,this.d=y}throttledReport(E){this.c.$progressReport(this.d,E)}}Ve([(0,D.throttle)(100,(P,E)=>C(P,E),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Se[136],ye([1,0,35,132,56,91,68,14,2]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(m,h,b,s)=>{let i=h;return{enumerable:!0,configurable:!1,get(){return i},set(c){if(!b(i,c)){const u=i;i=c,m.listener?.(s(c,u))}}}},R=(m,h)=>m===h,P={range:(m,h)=>m===h?!0:!m||!h?!1:m.isEqual(h),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(m,h)=>!(m.length!==h.length||m.some(b=>!h.find(s=>b.id===s.id)))},E=m=>h=>({op:4,update:m(h)}),y=(m,h)=>({range:(()=>{let b;const s=E(i=>({range:a.Range.lift(T.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return b},set(i){m.listener?.({op:6}),P.range(b,i)||(b=i,m.listener?.(s(i)))}}})(),label:C(m,h,P.label,E(b=>({label:b}))),description:C(m,void 0,P.description,E(b=>({description:b}))),sortText:C(m,void 0,P.sortText,E(b=>({sortText:b}))),canResolveChildren:C(m,!1,P.canResolveChildren,b=>({op:2,state:b})),busy:C(m,!1,P.busy,E(b=>({busy:b}))),error:C(m,void 0,P.error,E(b=>({error:T.MarkdownString.fromStrict(b)||null}))),tags:C(m,[],P.tags,(b,s)=>({op:1,new:b.map(T.TestTag.from),old:s.map(T.TestTag.from)}))}),v=m=>{const h=I.TestId.fromString(m.extId),b=new g(h.controllerId,h.localId,m.label,S.URI.revive(m.uri)||void 0);return b.range=T.Range.to(m.range||void 0),b.description=m.description||void 0,b.sortText=m.sortText||void 0,b.tags=m.tags.map(s=>T.TestTag.to({id:(0,D.denamespaceTestTag)(s).tagId})),b},d=m=>{let h;for(const b of m.tests){const s=v(b.item);(0,t.getPrivateApiFor)(s).parent=h,h=s}return h};e.toItemFromContext=d;class g{constructor(h,b,s,i){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const c=(0,t.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof f?void 0:c.parent}},children:{value:(0,A.createTestItemChildren)(c,t.getPrivateApiFor,g),enumerable:!0,writable:!1},...y(c,s)})}}e.TestItemImpl=g;class f extends g{constructor(h,b){super(h,h,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class w extends A.TestItemCollection{constructor(h,b,s){super({controllerId:h,getDocumentVersion:i=>i&&s.getDocument(i)?.version,getApiFor:t.getPrivateApiFor,getChildren:i=>i.children,root:new f(h,b),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=w}),define(Se[137],ye([1,0,48,10,99,14,7]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(E,y,v){const d=T.c.nextId();E.$registerTextEditorDecorationType(y.identifier,d,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){E.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=T,T.c=new I.IdGenerator("TextEditorDecorationType");class S{constructor(E,y){this.g=[],this.h=void 0,this.j=!1,this.c=E,this.d=E.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(E,y){this.k();let v=null;if(E instanceof D.Position)v=new D.Range(E,E);else if(E instanceof D.Range)v=E;else throw new Error("Unrecognized location");this.l(v,y,!1)}insert(E,y){this.k(),this.l(new D.Range(E,E),y,!0)}delete(E){this.k();let y=null;if(E instanceof D.Range)y=E;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(E,y,v){const d=this.c.validateRange(E);this.g.push({range:d,text:y,forceMoveMarkers:v})}setEndOfLine(E){if(this.k(),E!==D.EndOfLine.LF&&E!==D.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=E}}e.TextEditorEdit=S;class C{constructor(E,y,v,d){this.c=E,this.d=y,this._accept(v),this.e=d;const g=this;this.value={get tabSize(){return g.f},set tabSize(f){g.m(f)},get indentSize(){return g.g},set indentSize(f){g.o(f)},get insertSpaces(){return g.h},set insertSpaces(f){g.q(f)},get cursorStyle(){return g.j},set cursorStyle(f){g.s(f)},get lineNumbers(){return g.k},set lineNumbers(f){g.t(f)}}}_accept(E){this.f=E.tabSize,this.g=E.indentSize,this.h=E.insertSpaces,this.j=E.cursorStyle,this.k=A.TextEditorLineNumbersStyle.to(E.lineNumbers)}l(E){if(E==="auto")return"auto";if(typeof E=="number"){const y=Math.floor(E);return y>0?y:null}if(typeof E=="string"){const y=parseInt(E,10);return isNaN(y)?null:y>0?y:null}return null}m(E){const y=this.l(E);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(E){if(E==="tabSize")return"tabSize";if(typeof E=="number"){const y=Math.floor(E);return y>0?y:null}if(typeof E=="string"){const y=parseInt(E,10);return isNaN(y)?null:y>0?y:null}return null}o(E){const y=this.n(E);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}q(E){const y=this.p(E);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(E){this.j!==E&&(this.j=E,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:E})))}t(E){this.k!==E&&(this.k=E,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(E)})))}assign(E){const y={};let v=!1;if(typeof E.tabSize<"u"){const d=this.l(E.tabSize);d==="auto"?(v=!0,y.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,v=!0,y.tabSize=d)}if(typeof E.indentSize<"u"){const d=this.n(E.indentSize);d==="tabSize"?(v=!0,y.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,v=!0,y.indentSize=d)}if(typeof E.insertSpaces<"u"){const d=this.p(E.insertSpaces);d==="auto"?(v=!0,y.insertSpaces=d):this.h!==d&&(this.h=d,v=!0,y.insertSpaces=d)}typeof E.cursorStyle<"u"&&this.j!==E.cursorStyle&&(this.j=E.cursorStyle,v=!0,y.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this.k!==E.lineNumbers&&(this.k=E.lineNumbers,v=!0,y.lineNumbers=A.TextEditorLineNumbersStyle.from(E.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(E,y){y.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this.e.warn(v)})}}e.ExtHostTextEditorOptions=C;class R{constructor(E,y,v,d,g,f,w,m){this.id=E,this.j=y,this.k=v,this.g=!1,this.h=new Set,this.c=g,this.d=new C(this.j,this.id,f,v),this.e=w,this.f=m;const h=this;this.value=Object.freeze({get document(){return d.getValue()},set document(b){throw(0,t.readonly)("document")},get selection(){return h.c&&h.c[0]},set selection(b){if(!(b instanceof D.Selection))throw(0,t.illegalArgument)("selection");h.c=[b],h.l()},get selections(){return h.c},set selections(b){if(!Array.isArray(b)||b.some(s=>!(s instanceof D.Selection)))throw(0,t.illegalArgument)("selections");h.c=b,h.l()},get visibleRanges(){return h.e},set visibleRanges(b){throw(0,t.readonly)("visibleRanges")},get options(){return h.d.value},set options(b){h.g||h.d.assign(b)},get viewColumn(){return h.f},set viewColumn(b){throw(0,t.readonly)("viewColumn")},edit(b,s={undoStopBefore:!0,undoStopAfter:!0}){if(h.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new S(d.getValue(),s);return b(i),h.m(i)},insertSnippet(b,s,i={undoStopBefore:!0,undoStopAfter:!0}){if(h.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!s||Array.isArray(s)&&s.length===0)c=h.c.map(u=>A.Range.from(u));else if(s instanceof D.Position){const{lineNumber:u,column:r}=A.Position.from(s);c=[{startLineNumber:u,startColumn:r,endLineNumber:u,endColumn:r}]}else if(s instanceof D.Range)c=[A.Range.from(s)];else{c=[];for(const u of s)if(u instanceof D.Range)c.push(A.Range.from(u));else{const{lineNumber:r,column:o}=A.Position.from(u);c.push({startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o})}}return y.$tryInsertSnippet(E,d.getValue().version,b.value,c,i)},setDecorations(b,s){const i=s.length===0;i&&!h.h.has(b.key)||(i?h.h.delete(b.key):h.h.add(b.key),h.n(()=>{if(A.isDecorationOptionsArr(s))return y.$trySetDecorations(E,b.key,A.fromRangeOrRangeWithMessage(s));{const c=new Array(4*s.length);for(let u=0,r=s.length;u<r;u++){const o=s[u];c[4*u]=o.start.line+1,c[4*u+1]=o.start.character+1,c[4*u+2]=o.end.line+1,c[4*u+3]=o.end.character+1}return y.$trySetDecorationsFast(E,b.key,c)}}))},revealRange(b,s){h.n(()=>y.$tryRevealRange(E,A.Range.from(b),s||D.TextEditorRevealType.Default))},show(b){y.$tryShowEditor(E,A.ViewColumn.from(b))},hide(){y.$tryHideEditor(E)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(E){(0,a.ok)(!this.g),this.d._accept(E)}_acceptVisibleRanges(E){(0,a.ok)(!this.g),this.e=E}_acceptViewColumn(E){(0,a.ok)(!this.g),this.f=E}_acceptSelections(E){(0,a.ok)(!this.g),this.c=E}async l(){const E=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,E)),this.value}m(E){const y=E.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const v=y.edits.map(g=>g.range);v.sort((g,f)=>g.end.line===f.end.line?g.end.character===f.end.character?g.start.line===f.start.line?g.start.character-f.start.character:g.start.line-f.start.line:g.end.character-f.end.character:g.end.line-f.end.line);for(let g=0,f=v.length-1;g<f;g++){const w=v[g].end;if(v[g+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=y.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,d,{setEndOfLine:typeof y.setEndOfLine=="number"?A.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(E){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.ExtHostTextEditor=R}),define(Se[236],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[237],ye([1,0,188,10,42,121,125,43,27,236,200,190]),function(te,e,a,t,I,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=T.Registry.as(D.Extensions.JSONContribution);class y{constructor(b,s,i){this.a=b,this.b=s,this.c=i}d(b,s){this.a({type:b,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(I.default.Error,b)}warn(b){this.d(I.default.Warning,b)}info(b){this.d(I.default.Info,b)}}e.ExtensionMessageCollector=y;class v{static a(b){const s=new Set;for(let i=0,c=b.length;i<c;i++)s.add(S.ExtensionIdentifier.toKey(b[i].description.identifier));return s}static compute(b,s){if(!b||!b.length)return new v(s,[]);if(!s||!s.length)return new v([],b);const i=this.a(b),c=this.a(s),u=s.filter(o=>!i.has(S.ExtensionIdentifier.toKey(o.description.identifier))),r=b.filter(o=>!c.has(S.ExtensionIdentifier.toKey(o.description.identifier)));return new v(u,r)}constructor(b,s){this.added=b,this.removed=s}}e.ExtensionPointUserDelta=v;class d{constructor(b,s){this.name=b,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=v.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,t.onUnexpectedError)(b)}}}e.ExtensionPoint=d;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},f="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},activationEvents:{description:a.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(30,null)},{label:"onUri",body:"onUri",description:a.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(35,null)},{label:"onRenderer",description:a.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(37,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(39,null)},{label:"*",description:a.localize(40,null),body:"*"}]}},badges:{type:"array",description:a.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(42,null)},href:{type:"string",description:a.localize(43,null)},description:{type:"string",description:a.localize(44,null)}}}},markdown:{type:"string",description:a.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(49,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(50,null)},{body:["workspace"],description:a.localize(51,null)},{body:["ui","workspace"],description:a.localize(52,null)},{body:["workspace","ui"],description:a.localize(53,null)},{body:[],description:a.localize(54,null)}]},capabilities:{description:a.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(58,null),a.localize(59,null),a.localize(60,null)]},description:{type:"string",markdownDescription:a.localize(61,null)}}},untrustedWorkspaces:{description:a.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(64,null),a.localize(65,null),a.localize(66,null)]},restrictedConfigurations:{description:a.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(68,null)}}}}},sponsor:{description:a.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(71,null),type:"string"},"vscode:uninstall":{description:a.localize(72,null),type:"string"}}},icon:{type:"string",description:a.localize(73,null)},l10n:{type:"string",description:a.localize(74,null)}}};class w{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const s=new d(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,s),b.activationEventsGenerator&&P.ImplicitActivationEvents.register(b.extensionPoint,b.activationEventsGenerator),e.schema.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,E.registerSchema(f,e.schema),s}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=w;const m={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(m.ExtensionsRegistry,new w),e.ExtensionsRegistry=T.Registry.as(m.ExtensionsRegistry),E.registerSchema(f,e.schema),E.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(Se[238],ye([1,0,185,11,23,237,53,4]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var C;(function(E){function y(v,d,g){if(!v)return;const f=t.isString(v.type)?v.type:void 0;if(!f||f.length===0){g.error(a.localize(3,null));return}const w=[];if(Array.isArray(v.required))for(const m of v.required)t.isString(m)&&w.push(m);return{extensionId:d.value,taskType:f,required:w,properties:v.properties?I.deepClone(v.properties):{},when:v.when?D.ContextKeyExpr.deserialize(v.when):void 0}}E.from=y})(C||(C={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:S}});class P{constructor(){this.d=new T.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,v)=>{R.setHandler((d,g)=>{this.c=void 0;try{for(const f of g.removed){const w=f.value;for(const m of w)this.a&&m.type&&this.a[m.type]&&delete this.a[m.type]}for(const f of g.added){const w=f.value;for(const m of w){const h=C.from(m,f.description.identifier,f.collector);h&&(this.a[h.taskType]=h)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const v of this.all()){const d={type:"object",additionalProperties:!1};v.required.length>0&&(d.required=v.required.slice(0)),v.properties!==void 0?d.properties=I.deepClone(v.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[v.taskType]},y.push(d)}this.c={oneOf:y}}return this.c}}e.TaskDefinitionRegistry=new P}),define(Se[239],ye([1,0,186,11,24,23,53,238]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function $(M){if(!M)return F.Strong;switch(M.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=$}(S=e.ShellQuoting||(e.ShellQuoting={}));var C;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(C=e.CommandOptions||(e.CommandOptions={}));var R;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(F){function $(M){switch(M.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=$}(R=e.RevealKind||(e.RevealKind={}));var P;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function $(M){switch(M.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=$}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(F){function $(M){switch(M.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=$}(E=e.PanelKind||(e.PanelKind={}));var y;(function(F){F.defaults={echo:!0,reveal:R.Always,revealProblems:P.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(y=e.PresentationOptions||(e.PresentationOptions={}));var v;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(v=e.RuntimeType||(e.RuntimeType={})),function(F){function $(V){switch(V.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=$;function M(V){switch(V){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=M}(v=e.RuntimeType||(e.RuntimeType={}));var d;(function(F){function $(M){return t.isString(M)?M:M.value}F.value=$})(d=e.CommandString||(e.CommandString={}));var g;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function $(V){return V===F.Clean._id||V===F.Build._id||V===F.Rebuild._id||V===F.Test._id}F.is=$;function M(V){if(V!==void 0)return t.isString(V)?$(V)?{_id:V,isDefault:!1}:void 0:V}F.from=M})(g=e.TaskGroup||(e.TaskGroup={}));var f;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var w;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function $(M){switch(M){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=$})(w=e.TaskSourceKind||(e.TaskSourceKind={}));var m;(function(F){F.parallel="parallel",F.sequence="sequence"})(m=e.DependsOrder||(e.DependsOrder={}));var h;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(h=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:h.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class s{constructor($,M,V,q,H,J){this._label="",this._id=$,M&&(this._label=M),V&&(this.type=V),this.runOptions=q,this.configurationProperties=H,this._source=J}getDefinition($){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const $={folder:this.d(),id:this._id};return JSON.stringify($)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches($,M=!1){if($===void 0)return!1;if(t.isString($))return $===this._label||$===this.configurationProperties.identifier||M&&$===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===$._key}getQualifiedLabel(){const $=this.getWorkspaceFolder();return $?`${this._label} (${$.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages($){this.c===void 0&&(this.c=[]),$&&(this.c=this.c.concat($))}get taskLoadMessages(){return this.c}}e.CommonTask=s;class i extends s{constructor($,M,V,q,H,J,Y,ae){super($,V,void 0,Y,ae,M),this.command={},this._source=M,this.hasDefinedMatchers=J,H&&(this.command=H)}clone(){return new i(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition($=!1){if($&&this._source.customizes!==void 0)return this._source.customizes;{let M;switch(this.command?this.command.runtime:void 0){case v.Shell:M="shell";break;case v.Process:M="process";break;case v.CustomExecution:M="customExecution";break;case void 0:M="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:M,_key:this._id,id:this._id}}}static is($){return $ instanceof i}getMapKey(){const $=this._source.config.workspaceFolder;return $?`${$.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let M=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(M+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:M};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f($){return new i($._id,$._source,$._label,$.type,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.CustomTask=i;class c extends s{constructor($,M,V,q,H,J,Y){super($,V,q,J,Y,M),this._source=M,this.configures=H}static is($){return $ instanceof c}f($){return $}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let M=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(M+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:M};return JSON.stringify(V)}}e.ConfiguringTask=c;class u extends s{constructor($,M,V,q,H,J,Y,ae,re){super($,V,q,ae,re,M),this.defines=H,this.hasDefinedMatchers=Y,this.command=J,this.icon=re.icon,this.hide=re.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is($){return $ instanceof u}getMapKey(){const $=this._source.workspaceFolder;return $?`${this._source.scope.toString()}|${$.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const $={type:"contributed",scope:this._source.scope,id:this._id};return $.folder=this.d(),JSON.stringify($)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f($){return new u($._id,$._source,$._label,$.type,$.defines,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.ContributedTask=u;class r extends s{constructor($,M,V,q,H,J){super($,V,q,H,J,M),this._source=M}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is($){return $ instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f($){return new r($._id,$._source,$._label,$.type,$.runOptions,$.configurationProperties)}}e.InMemoryTask=r;var o;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(o=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(o=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class l{constructor($){this.c=new Map;for(let M=0;M<$.length;M++)this.c.set($[M].uri.toString(),M)}compare($,M){const V=$.getWorkspaceFolder(),q=M.getWorkspaceFolder();if(V&&q){let H=this.c.get(V.uri.toString());H=H===void 0?0:H+1;let J=this.c.get(q.uri.toString());return J=J===void 0?0:J+1,H===J?$._label.localeCompare(M._label):H-J}else return!V&&q?-1:V&&!q?1:0}}e.TaskSorter=l;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var k;(function(F){F.SingleRun="singleRun",F.Background="background"})(k=e.TaskRunType||(e.TaskRunType={}));var L;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var U;(function(F){function $(M,V,q,H){if(V){const J={kind:M,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:q,__task:V};return M==="start"?J.resolvedVariables=H:M==="processStarted"?J.processId=H:M==="processEnded"&&(J.exitCode=H),Object.freeze(J)}else return Object.freeze({kind:"changed"})}F.create=$})(U=e.TaskEvent||(e.TaskEvent={}));var K;(function(F){function $(V){const q=Object.keys(V).sort();let H="";for(const J of q){let Y=V[J];Y instanceof Object?Y=$(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),H+=J+","+Y+","}return H}function M(V){const H={_key:$(V),type:V.taskType};return Object.assign(H,V),H}F.create=M})(K=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var G;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(G=e.TaskSettingId||(e.TaskSettingId={}));var O;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(O=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(F){function $(M,V){const q=T.TaskDefinitionRegistry.get(M.type);if(q===void 0){const ae=A.deepClone(M);return delete ae._key,K.create(ae)}const H=Object.create(null);H.type=q.taskType;const J=new Set;q.required.forEach(ae=>J.add(ae));const Y=q.properties;for(const ae of Object.keys(Y)){const re=M[ae];if(re!=null)H[ae]=re;else if(J.has(ae)){const fe=Y[ae];if(fe.default!==void 0)H[ae]=A.deepClone(fe.default);else switch(fe.type){case"boolean":H[ae]=!1;break;case"number":case"integer":H[ae]=0;break;case"string":H[ae]="";break;default:V.error(a.localize(2,null,JSON.stringify(M,void 0,0),ae));return}}}return K.create(H)}F.createTaskIdentifier=$})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(Se[240],ye([1,0,10]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((D,T)=>{this.b=D,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(D){this.f||this.h||(this.f=!0,this.g=D,this.a&&this.b(D))}resolveErr(D){this.f||this.h||(this.h=!0,this.i=D,this.a?this.d(D):(0,a.onUnexpectedError)(D))}then(D,T){return this.j().then(D,T)}catch(D){return this.j().then(void 0,D)}finally(D){return this.j().finally(D)}}e.LazyPromise=t;class I extends t{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=I}),define(Se[57],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const t=[];function I(T){const S=new a(T);return t[S.nid]=S,S}e.createProxyIdentifier=I;function A(T){return t[T].sid}e.getStringIdentifierForProxy=A;class D{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=D}),define(Se[5],ye([1,0,57]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A=e.TabModelOperationKind||(e.TabModelOperationKind={}));var D;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(g){return g._id=P.a++,g}}e.IdObject=P,P.a=0;var E;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var y;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(y=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(Se[69],ye([1,0,3,13,5,16]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(S,C){this.c=C,this.a=new Set,this.b=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,C,R){const P=this.d(S,C);this.a.has(P)||(this.a.add(P),C.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}d(S,C){return`${S}-${C.identifier.value}`}};D=Ve([ze(0,A.IExtHostRpcService),ze(1,t.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,C){}})}),define(Se[241],ye([1,0,4,5,7,27]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(S){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,C,R,P={}){const E=A.ExtensionIdentifier.toKey(S.identifier),y=this.f.get(E)||[],v=[...R].sort().join(" ");let d=y.find(g=>g.providerId===C&&g.scopes===v);if(d)return d.result;{const g=this.g(S,E,C,R,P);d={providerId:C,scopes:v,result:g},y.push(d),this.f.set(E,y);try{await g}finally{const f=y.findIndex(w=>w.providerId===C&&w.scopes===v);f>-1&&(y.splice(f),this.f.set(E,y))}return g}}async g(S,C,R,P,E={}){await this.a.$ensureProvider(R);const y=S.displayName||S.name;return this.a.$getSession(R,P,C,y,E)}async removeSession(S,C){const R=this.b.get(S);return R?R.provider.removeSession(C):this.a.$removeSession(S,C)}registerAuthenticationProvider(S,C,R,P){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:C,provider:R,options:P??{supportsMultipleAccounts:!1}}),this.c.find(y=>y.id===S)||this.c.push({id:S,label:C});const E=R.onDidChangeSessions(y=>{this.a.$sendDidChangeSessions(S,{added:y.added??[],changed:y.changed??[],removed:y.removed??[]})});return this.a.$registerAuthenticationProvider(S,C,P?.supportsMultipleAccounts??!1),new I.Disposable(()=>{E.dispose(),this.b.delete(S);const y=this.c.findIndex(v=>v.id===S);y>-1&&this.c.splice(y),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this.d.fire({provider:{id:S,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(Se[242],ye([1,0,5,16,14]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(T,S){this.a=T.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>S.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,C){const R=I.WorkspaceEdit.from(T,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,C?.isRefactoring??!1)}};A=Ve([ze(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(Se[243],ye([1,0,5]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const D=A.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(T){return D.$writeText(T)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a},Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[39],ye([1,0,11,7,14,23,5,17,13,84,35,49,2,6,3,16,136,22,57,50]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m){"use strict";var h,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(n,l){h.set(this,void 0),this.b=new Map,this.c=new Map,b.set(this,void 0),Je(this,h,n.getProxy(D.MainContext.MainThreadCommands),"f"),this.d=l,Je(this,b,n.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new i(this,p=>{const k=this.c.get(p);return k?.result===u.Void?k:void 0},l),this.f=[{processArgument(p){return(0,C.revive)(p)}},{processArgument(p){return(0,A.cloneAndChange)(p,function(k){if(R.Range.isIRange(k))return I.Range.to(k);if(P.Position.isIPosition(k))return I.Position.to(k);if(R.Range.isIRange(k.range)&&E.URI.isUri(k.uri))return I.location.to(k);if(k instanceof f.VSBuffer)return k.buffer.buffer;if(!Array.isArray(k))return k})}}]}registerArgumentProcessor(n){this.f.push(n)}registerApiCommand(n){const l=this.registerCommand(!1,n.id,async(...p)=>{const k=n.args.map((U,K)=>{if(!U.validate(p[K]))throw new Error(`Invalid argument '${U.name}' when running '${n.id}', received: ${p[K]}`);return U.convert(p[K])}),L=await this.executeCommand(n.internalId,...k);return n.result.convert(L,p,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this.c.set(n.id,n),new t.Disposable(()=>{l.dispose(),this.c.delete(n.id)})}registerCommand(n,l,p,k,L,U){if(this.d.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this.b.has(l))throw new Error(`command '${l}' already exists`);return this.b.set(l,{callback:p,thisArg:k,description:L,extension:U}),n&&Me(this,h,"f").$registerCommand(l),new t.Disposable(()=>{this.b.delete(l)&&n&&Me(this,h,"f").$unregisterCommand(l)})}executeCommand(n,...l){return this.d.trace("ExtHostCommands#executeCommand",n),this.g(n,l,!0)}async g(n,l,p){if(this.b.has(n))return Me(this,h,"f").$fireCommandActivationEvent(n),this.h(n,l,!1);{let k=!1;const L=(0,A.cloneAndChange)(l,function(U){if(U instanceof t.Position)return I.Position.from(U);if(U instanceof t.Range)return I.Range.from(U);if(U instanceof t.Location)return I.location.from(U);if(t.NotebookRange.isNotebookRange(U))return I.NotebookRange.from(U);if(U instanceof ArrayBuffer)return k=!0,f.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return k=!0,f.VSBuffer.wrap(U);if(U instanceof f.VSBuffer)return k=!0,U;if(!Array.isArray(U))return U});try{const U=await Me(this,h,"f").$executeCommand(n,k?new w.SerializableObjectWithBuffers(L):L,p);return(0,C.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(n,l,!1);throw U}}}async h(n,l,p){const k=this.b.get(n);if(!k)throw new Error("Unknown command");const{callback:L,thisArg:U,description:K}=k;if(K)for(let O=0;O<K.args.length;O++)try{(0,a.validateConstraint)(l[O],K.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${K.args[O].name}' - ${K.args[O].description}`)}const G=Date.now();try{return await L.apply(U,l)}catch(O){if(n===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...l);B&&(n=B.command)}throw this.d.error(O,n,k.extension?.identifier),p?new class extends Error{constructor(){super((0,m.toErrorMessage)(O)),this.id=n,this.source=k.extension?.displayName??k.extension?.name}}:O}finally{this.j(k,n,Date.now()-G)}}j(n,l,p){!n.extension||n.extension.isBuiltin||Me(this,b,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:l,duration:p})}$executeContributedCommand(n,...l){return this.d.trace("ExtHostCommands#$executeContributedCommand",n),this.b.has(n)?(l=l.map(p=>this.f.reduce((k,L)=>L.processArgument(k),p)),this.h(n,l,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this.d.trace("ExtHostCommands#getCommands",n),Me(this,h,"f").$getCommands().then(l=>(n&&(l=l.filter(p=>p[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[l,p]of this.b){const{description:k}=p;k&&(n[l]=k)}return Promise.resolve(n)}};h=new WeakMap,b=new WeakMap,s=Ve([ze(0,d.IExtHostRpcService),ze(1,S.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class i{constructor(n,l,p){this.d=n,this.f=l,this.g=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(n,l){if(!n)return;const p={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return p;const k=this.f(n.command);if(k)p.id=k.internalId,p.arguments=k.args.map((L,U)=>L.convert(n.arguments&&n.arguments[U]));else if((0,T.isNonEmptyArray)(n.arguments)){const L=`${n.command}/${++this.c}`;this.b.set(L,n),l.add((0,y.toDisposable)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),p.$ident=L,p.id=this.delegatingCommandId,p.arguments=[L],this.g.trace("CommandsConverter#CREATE",n.command,L)}return p}fromInternal(n){return typeof n.$ident=="string"?this.b.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this.b.get(n[0])}h(...n){const l=this.getActualCommand(...n);return this.g.trace("CommandsConverter#EXECUTE",n[0],l?l.command:"MISSING"),l?this.d.executeCommand(l.command,...l.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${n[0]}`)}}e.CommandsConverter=i;class c{constructor(n,l,p,k){this.name=n,this.description=l,this.validate=p,this.convert=k}optional(){return new c(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,l){return new c(n??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",o=>E.URI.isUri(o),o=>o),c.Position=new c("position","A position in a text document",o=>t.Position.isPosition(o),I.Position.from),c.Range=new c("range","A range in a text document",o=>t.Range.isRange(o),I.Range.from),c.Selection=new c("selection","A selection in a text document",o=>t.Selection.isSelection(o),I.Selection.from),c.Number=new c("number","",o=>typeof o=="number",o=>o),c.String=new c("string","",o=>typeof o=="string",o=>o),c.CallHierarchyItem=new c("item","A call hierarchy item",o=>o instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",o=>o instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",o=>o instanceof g.TestItemImpl,I.TestItem.from);class u{constructor(n,l){this.description=n,this.convert=l}}e.ApiCommandResult=u,u.Void=new u("no result",o=>o);class r{constructor(n,l,p,k,L){this.id=n,this.internalId=l,this.description=p,this.args=k,this.result=L}}e.ApiCommand=r}),define(Se[244],ye([1,0,2,14,7,66,39,17,118,123,15]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",y(t.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,g)=>{if((0,T.isFalsyOrEmpty)(d))return;class f extends I.SymbolInformation{static to(m){const h=new f(m.name,t.SymbolKind.to(m.kind),m.containerName||"",new I.Location(g[0],t.Range.to(m.range)));return h.detail=m.detail,h.range=h.location.range,h.selectionRange=t.Range.to(m.selectionRange),h.children=m.children?m.children.map(f.to):[],h}}return d.map(f.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",y(t.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",y(t.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(g=>I.Position.isPosition(g)),d=>d.map(t.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(g=>{let f;for(const w of g.reverse())f=new I.SelectionRange(t.Range.to(w),f);return f}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(t.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:t.Range.to(d.range),placeholder:d.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return t.WorkspaceEdit.to(d)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(t.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const g=(0,S.decodeSemanticTokensDto)(d);if(g.type==="full")return new I.SemanticTokens(g.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const g=(0,S.decodeSemanticTokensDto)(d);if(g.type==="full")return new I.SemanticTokens(g.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,g,f)=>{if(!d)return new I.CompletionList([]);const w=d.suggestions.map(m=>t.CompletionItem.to(m,f));return new I.CompletionList(w,d.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return t.SignatureHelp.to(d)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,g,f)=>y(w=>new I.CodeLens(t.Range.to(w.range),w.command&&f.fromInternal(w.command)))(d))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>I.Range.isRange(d),d=>I.Selection.isSelection(d)?t.Selection.from(d):t.Range.from(d)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,g,f)=>y(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(w.command)}else{const m=new I.CodeAction(w.title,w.kind?new I.CodeActionKind(w.kind):void 0);return w.edit&&(m.edit=t.WorkspaceEdit.to(w.edit)),w.command&&(m.command=f.fromInternal(w.command)),m.isPreferred=w.isPreferred,m}})(d))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(g=>new I.ColorInformation(t.Range.to(g.range),t.Color.to(g.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",d=>d instanceof I.Color,t.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:t.Range.from(d.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(t.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,g,f)=>d.map(t.InlayHint.to.bind(void 0,f)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",y(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(g=>t.NotebookExclusiveDocumentPattern.to(g))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(t.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>a.URI.isUri(d)||typeof d=="string"&&(0,C.matchesSomeScheme)(d,R.Schemas.http,R.Schemas.https),d=>d),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void)];class E{static register(g){P.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=E;function y(d){return g=>{if(Array.isArray(g))return g.map(d)}}function v(d){if(!Array.isArray(d))return;const g=[];for(const f of d)A.isLocationLink(f)?g.push(t.DefinitionLink.to(f)):g.push(t.location.to(f));return g}}),define(Se[245],ye([1,0,18,60,4,6,2,66,27,14,7,26,5]),function(te,e,a,t,I,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function y(v,d,g){const f=v.getProxy(E.MainContext.MainThreadComments);class w{constructor(){this.b=new Map,this.c=new Map,d.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const n=this.b.get(o.handle);return n?n.value:o}else if(o&&o.$mid===7){const n=this.b.get(o.commentControlHandle);if(!n)return o;const l=n.getCommentThread(o.commentThreadHandle);return l?l.value:o}else if(o&&(o.$mid===9||o.$mid===8)){const n=this.b.get(o.thread.commentControlHandle);if(!n)return o;const l=n.getCommentThread(o.thread.commentThreadHandle);return l?o.$mid===8?l.value:{thread:l.value,text:o.text}:o}else if(o&&o.$mid===10){const n=this.b.get(o.thread.commentControlHandle);if(!n)return o;const l=n.getCommentThread(o.thread.commentThreadHandle);if(!l)return o;const p=o.commentUniqueId,k=l.getCommentByUniqueId(p);return k||o}else if(o&&o.$mid===11){const n=this.b.get(o.thread.commentControlHandle);if(!n)return o;const l=n.getCommentThread(o.thread.commentThreadHandle);if(!l)return o;const p=o.text,k=o.commentUniqueId,L=l.getCommentByUniqueId(k);return L?(typeof L.body=="string"?L.body=p:L.body.value=p,L):o}return o}})}createCommentController(o,n,l){const p=w.a++,k=new h(o,p,n,l);this.b.set(k.handle,k);const L=this.c.get(S.ExtensionIdentifier.toKey(o.identifier))||[];return L.push(k),this.c.set(S.ExtensionIdentifier.toKey(o.identifier),L),k.value}$createCommentThreadTemplate(o,n,l){const p=this.b.get(o);!p||p.$createCommentThreadTemplate(n,l)}async $updateCommentThreadTemplate(o,n,l){const p=this.b.get(o);!p||p.$updateCommentThreadTemplate(n,l)}$deleteCommentThread(o,n){this.b.get(o)?.$deleteCommentThread(n)}$provideCommentingRanges(o,n,l){const p=this.b.get(o);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const k=g.getDocument(D.URI.revive(n));return(0,a.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(k,l)).then(L=>L?L.map(U=>C.Range.from(U)):void 0)}$toggleReaction(o,n,l,p,k){const L=this.b.get(o);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const U=L.getCommentThread(n);if(U){const K=U.getCommentByUniqueId(p.uniqueIdInThread);if(L!==void 0&&K&&L.reactionHandler)return L.reactionHandler(K,i(k))}return Promise.resolve(void 0)})}dispose(){}}w.a=0;class m{set threadId(o){this.n=o}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(o){o.isEqual(this.p)||(this.p=o,this.b.range=o,this.c.fire())}get range(){return this.p}set canReply(o){this.d!==o&&(this.d=o,this.b.canReply=o,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(o){this.e=o,this.b.label=o,this.c.fire()}get contextValue(){return this.f}set contextValue(o){this.f=o,this.b.contextValue=o,this.c.fire()}get comments(){return this.q}set comments(o){this.q=o,this.b.comments=o,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(o){this.g=o,this.b.collapsibleState=o,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(o){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=o,this.b.state=o,this.c.fire()}get isDisposed(){return this.j}constructor(o,n,l,p,k,L,U,K){this.m=n,this.n=l,this.o=p,this.p=k,this.q=L,this.extensionDescription=U,this.r=K,this.handle=m.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.MutableDisposable,this.l.value=new A.DisposableStore,this.n===void 0&&(this.n=`${o}.${this.handle}`),f.$createCommentThread(n,this.handle,this.n,this.o,C.Range.from(this.p),U.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{f.$deleteCommentThread(n,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(O){G.range=O},get comments(){return G.comments},set comments(O){G.comments=O},get collapsibleState(){return G.collapsibleState},set collapsibleState(O){G.collapsibleState=O},get canReply(){return G.canReply},set canReply(O){G.canReply=O},get contextValue(){return G.contextValue},set contextValue(O){G.contextValue=O},get label(){return G.label},set label(O){G.label=O},get state(){return G.state},set state(O){G.state=O},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.DisposableStore);const o=l=>Object.prototype.hasOwnProperty.call(this.b,l),n={};o("range")&&(n.range=C.Range.from(this.p)),o("label")&&(n.label=this.label),o("contextValue")&&(n.contextValue=this.contextValue??null),o("comments")&&(n.comments=this.q.map(l=>b(this,l,this.k))),o("collapsibleState")&&(n.collapseState=c(this.g)),o("canReply")&&(n.canReply=this.canReply),o("state")&&(n.state=u(this.h)),o("isTemplate")&&(n.isTemplate=this.r),this.b={},f.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(o){for(const n of this.k){const l=n[0],p=n[1];if(o===p)return l}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(o=>o.dispose())}}m.a=0,Ve([(0,t.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class h{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(o){this.b=o,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(o){this.c=o,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this.d}set options(o){this.d=o,f.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(o,n,l,p){this.f=o,this.g=n,this.h=l,this.i=p,this.a=new Map,f.$registerCommentController(this.handle,l,p);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(L){k.options=L},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(L){k.commentingRangeProvider=L},get reactionHandler(){return k.reactionHandler},set reactionHandler(L){k.reactionHandler=L},createCommentThread(L,U,K){return k.createCommentThread(L,U,K).value},dispose:()=>{k.dispose()}}),this.e=[],this.e.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(o,n,l,p){if(typeof o=="string"){const k=new m(this.id,this.handle,o,n,l,p,this.f,!1);return this.a.set(k.handle,k),k}else{const k=new m(this.id,this.handle,void 0,o,n,l,this.f,!1);return this.a.set(k.handle,k),k}}$createCommentThreadTemplate(o,n){const l=new m(this.id,this.handle,void 0,D.URI.revive(o),C.Range.to(n),[],this.f,!0);return l.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this.a.set(l.handle,l),l}$updateCommentThreadTemplate(o,n){const l=this.a.get(o);l&&(l.range=C.Range.to(n))}$deleteCommentThread(o){this.a.get(o)?.dispose(),this.a.delete(o)}getCommentThread(o){return this.a.get(o)}dispose(){this.a.forEach(o=>{o.dispose()}),this.e.forEach(o=>o.dispose())}}function b(r,o,n){let l=n.get(o);l||(l=++r.commentHandle,n.set(o,l));const p=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:l,body:typeof o.body=="string"?o.body:C.MarkdownString.from(o.body),userName:o.author.name,userIconPath:p,label:o.label,commentReactions:o.reactions?o.reactions.map(k=>s(k)):void 0,timestamp:o.timestamp?.toJSON()}}function s(r){return{label:r.label,iconPath:r.iconPath?C.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?D.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function c(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function u(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new w}e.createExtHostComments=y}),define(Se[246],ye([1,0,23,5,25,16]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(R,P){this.a=R.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,P){const E=this,y=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){E.e(R,P,y,arguments)}})}e(R,P,E,y){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:S(y,this.b)}),this.c&&this.f(R,E,y)}};D=Ve([ze(0,A.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const T=1e5;function S(C,R){const P=[];if(C.length)for(let E=0;E<C.length;E++){let y=C[E];if(typeof y>"u")y="undefined";else if(y instanceof Error){const v=y;v.stack?y=v.stack:y=v.toString()}P.push(y)}if(R){const E=new Error().stack;E&&P.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,a.safeStringify)(P);return E.length>T?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(Se[138],ye([1,0,2,5,7,3,16,13,17,8,9,26]),function(te,e,a,t,I,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class Rn{constructor(v,d){this.h=d,this.f=new Map,this.g=v.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,d){const g=Rn.c++;this.f.set(g,{provider:v,extensionDescription:d}),this.g.$registerDecorationProvider(g,d.identifier.value);const f=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(w=>{if(!w){this.g.$onDidChange(g,null);return}const m=(0,S.asArray)(w);if(m.length<=Rn.d){this.g.$onDidChange(g,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,m.length);const h=m.map(i=>({uri:i,rank:(0,C.count)(i.path,"/")})),b=(0,S.groupBy)(h,(i,c)=>i.rank-c.rank||(0,C.compare)(i.uri.path,c.uri.path)),s=[];e:for(const i of b){let c;for(const u of i){const r=(0,R.dirname)(u.uri.path);if(c!==r&&(c=r,s.push(u.uri)>=Rn.d))break e}}this.g.$onDidChange(g,s)});return new I.Disposable(()=>{f?.dispose(),this.g.$unregisterDecorationProvider(g),this.f.delete(g)})}async $provideDecorations(v,d,g){if(!this.f.has(v))return Object.create(null);const f=Object.create(null),{provider:w,extensionDescription:m}=this.f.get(v);return await Promise.all(d.map(async h=>{try{const{uri:b,id:s}=h,i=await Promise.resolve(w.provideFileDecoration(a.URI.revive(b),g));if(!i)return;try{I.FileDecoration.validate(i),i.badge&&typeof i.badge!="string"&&(0,P.checkProposedApiEnabled)(m,"codiconDecoration"),f[s]=[i.propagate,i.tooltip,i.badge,i.color]}catch(c){this.h.warn(`INVALID decoration from extension '${m}': ${c}`)}}catch(b){this.h.error(b)}})),f}};E.c=0,E.d=250,E=Ve([ze(0,D.IExtHostRpcService),ze(1,T.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a},Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[247],ye([1,0,172,122,2,5,7,14,4,13,28,46]),function(te,e,a,t,I,A,D,T,S,C,R,P){"use strict";var E,y,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(w,m,h,b,s,i,c){this.d=w,this.e=m,this.f=h,this.g=b,E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),this.c=!1,Je(this,v,new R.ResourceMap(u=>s.getComparisonKey(u)),"f"),Je(this,E,i,"f"),Je(this,y,c,"f")}dispose(){this.c||(Me(this,y,"f").fire([...Me(this,v,"f").keys()]),Me(this,E,"f")?.$clear(this.e),Me(this,v,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(w,m){if(!w){this.clear();return}this.h();let h=[];if(I.URI.isUri(w)){if(!m){this.delete(w);return}Me(this,v,"f").set(w,m.slice()),h=[w]}else if(Array.isArray(w)){h=[];let s;w=[...w].sort(d.j);for(const i of w){const[c,u]=i;if((!s||c.toString()!==s.toString())&&(s&&Me(this,v,"f").get(s).length===0&&Me(this,v,"f").delete(s),s=c,h.push(c),Me(this,v,"f").set(c,[])),u)Me(this,v,"f").get(c)?.push(...u);else{const r=Me(this,v,"f").get(c);r&&(r.length=0)}}}if(Me(this,y,"f").fire(h),!Me(this,E,"f"))return;const b=[];for(const s of h){let i=[];const c=Me(this,v,"f").get(s);if(c)if(c.length>this.f){i=[];const u=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const o of c)if(o.severity===u[r]&&i.push({...T.Diagnostic.from(o),modelVersionId:this.g(s)})===this.f)break e;i.push({severity:t.MarkerSeverity.Info,message:(0,a.localize)(0,null,c.length-this.f),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=c.map(u=>({...T.Diagnostic.from(u),modelVersionId:this.g(s)}));b.push([s,i])}Me(this,E,"f").$changeMany(this.e,b)}delete(w){this.h(),Me(this,y,"f").fire([w]),Me(this,v,"f").delete(w),Me(this,E,"f")?.$changeMany(this.e,[[w,void 0]])}clear(){this.h(),Me(this,y,"f").fire([...Me(this,v,"f").keys()]),Me(this,v,"f").clear(),Me(this,E,"f")?.$clear(this.e)}forEach(w,m){this.h();for(const[h,b]of this)w.call(m,h,b,this)}*[(E=new WeakMap,y=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.h();for(const w of Me(this,v,"f").keys())yield[w,this.get(w)]}get(w){this.h();const m=Me(this,v,"f").get(w);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(w){return this.h(),Array.isArray(Me(this,v,"f").get(w))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(w,m){return w[0].toString()<m[0].toString()?-1:w[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=d;let g=class pn{static _mapper(w){const m=new R.ResourceMap;for(const h of w)m.set(h,h);return{uris:Object.freeze(Array.from(m.values()))}}constructor(w,m,h,b){this.h=m,this.j=h,this.k=b,this.f=new Map,this.g=new S.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pn._mapper),this.e=w.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(w,m){const{f:h,e:b,g:s,h:i,j:c,k:u}=this,r=new class{$changeMany(l,p){b.$changeMany(l,p),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,l,p.length===0?"CLEARING":p)}$clear(l){b.$clear(l),i.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,l)}dispose(){b.dispose()}};let o;if(!m)m="_generated_diagnostic_collection_name_#"+pn.c++,o=m;else if(!h.has(m))o=m;else{this.h.warn(`DiagnosticCollection with name '${m}' does already exist.`);do o=m+pn.c++;while(h.has(o))}return new class extends d{constructor(){super(m,o,pn.d,l=>u.getDocument(l)?.version,c.extUri,r,s),h.set(o,this)}dispose(){super.dispose(),h.delete(o)}}}getDiagnostics(w){if(w)return this.l(w);{const m=new Map,h=[];for(const b of this.f.values())b.forEach((s,i)=>{let c=m.get(s.toString());typeof c>"u"&&(c=h.length,m.set(s.toString(),c),h.push([s,[]])),h[c][1]=h[c][1].concat(...i)});return h}}l(w){let m=[];for(const h of this.f.values())h.has(w)&&(m=m.concat(h.get(w)));return m}$acceptMarkersChange(w){if(!this.m){const m="_generated_mirror",h=new d(m,m,pn.d,b=>{},this.j.extUri,void 0,this.g);this.f.set(m,h),this.m=h}for(const[m,h]of w)this.m.set(I.URI.revive(m),h.map(T.Diagnostic.to))}};g.c=0,g.d=1e3,g=Ve([ze(1,C.ILogService),ze(2,P.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(Se[248],ye([1,0,2,5]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(D){this.a=D.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(D){return this.a.$showOpenDialog(D).then(T=>T?T.map(S=>a.URI.revive(S)):void 0)}showSaveDialog(D){return this.a.$showSaveDialog(D).then(T=>T?a.URI.revive(T):void 0)}}e.ExtHostDialogs=I}),define(Se[249],ye([1,0,10,2,7,5,15,21,8]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(P,E,y){this.d=E,this.e=y,this.b=new Map,this.c=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,E){if(Object.keys(D.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const y=C.a++;this.b.set(y,E),this.c.$registerTextContentProvider(y,P);let v;return typeof E.onDidChange=="function"&&(v=E.onDidChange(d=>{if(d.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(y,d).then(g=>{if(!g&&typeof g!="string")return;const f=this.d.getDocument(d);if(!f)return;const w=(0,S.splitLines)(g);if(!f.equalLines(w))return this.c.$onVirtualDocumentChange(d,g)},a.onUnexpectedError)})),new I.Disposable(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,E){const y=this.b.get(P);return y?Promise.resolve(y.provideTextDocumentContent(t.URI.revive(E),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=C,C.a=0}),define(Se[250],ye([1,0,4,6,2,5,134,14,11,23,7]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(y,v){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=y.getProxy(A.MainContext.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(d=>{for(const g of d)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const g of d)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const v=this.g.getDocument(y);if(v)return v}getDocument(y){const v=this.getDocumentData(y);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return v.document}ensureDocumentData(y){const v=this.g.getDocument(y);if(v)return Promise.resolve(v);let d=this.h.get(y.toString());return d||(d=this.f.$tryOpenDocument(y).then(g=>{this.h.delete(y.toString());const f=I.URI.revive(g);return(0,S.assertIsDefined)(this.g.getDocument(f))},g=>(this.h.delete(y.toString()),Promise.reject(g))),this.h.set(y.toString(),d)),d}createDocumentData(y){return this.f.$tryCreateDocument(y).then(v=>I.URI.revive(v))}$acceptModelLanguageChanged(y,v){const d=I.URI.revive(y),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(v),this.a.fire(g.document)}$acceptModelSaved(y){const v=I.URI.revive(y),d=this.g.getDocument(v);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(y,v){const d=I.URI.revive(y),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");g._acceptIsDirty(v),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,v,d){const g=I.URI.revive(y),f=this.g.getDocument(g);if(!f)throw new Error("unknown document");f._acceptIsDirty(d),f.onEvents(v);let w;v.isUndoing?w=R.TextDocumentChangeReason.Undo:v.isRedoing&&(w=R.TextDocumentChangeReason.Redo),this.c.fire((0,C.deepFreeze)({document:f.document,contentChanges:v.changes.map(m=>({range:T.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:w}))}setWordDefinitionFor(y,v){(0,D.setWordDefinitionFor)(y,v)}}e.ExtHostDocuments=P}),define(Se[58],ye([1,0,48,4,6,2,3,5,134,16,137,14,13,28,15,62,80]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(h){this.value=h,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let w=class{constructor(h,b){this.h=h,this.i=b,this.a=null,this.b=new Map,this.c=new y.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const b=[],s=[],i=[];if(h.removedDocuments)for(const c of h.removedDocuments){const u=A.URI.revive(c),r=this.c.get(u);r?.unref()&&(this.c.delete(u),b.push(r.value))}if(h.addedDocuments)for(const c of h.addedDocuments){const u=A.URI.revive(c.uri);let r=this.c.get(u);if(r&&u.scheme!==v.Schemas.vscodeNotebookCell&&u.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);r||(r=new f(new S.ExtHostDocumentData(this.h.getProxy(T.MainContext.MainThreadDocuments),u,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(u,r),s.push(r.value)),r.ref()}if(h.removedEditors)for(const c of h.removedEditors){const u=this.b.get(c);this.b.delete(c),u&&i.push(u)}if(h.addedEditors)for(const c of h.addedEditors){const u=A.URI.revive(c.documentUri);a.ok(this.c.has(u),`document '${u}' does not exist`),a.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const r=this.c.get(u).value,o=new R.ExtHostTextEditor(c.id,this.h.getProxy(T.MainContext.MainThreadTextEditors),this.i,new g.Lazy(()=>r.document),c.selections.map(P.Selection.to),c.options,c.visibleRanges.map(n=>P.Range.to(n)),typeof c.editorPosition=="number"?P.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,o)}h.newActiveEditor!==void 0&&(a.ok(h.newActiveEditor===null||this.b.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this.a=h.newActiveEditor),(0,I.dispose)(b),(0,I.dispose)(i),h.removedDocuments&&this.e.fire(b),h.addedDocuments&&this.d.fire(s),(h.removedEditors||h.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),h.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(h){return this.c.get(h)?.value}allDocuments(){return d.Iterable.map(this.c.values(),h=>h.value)}getEditor(h){return this.b.get(h)}activeEditor(h){if(!this.a)return;const b=this.b.get(this.a);return h?b:b?.value}allEditors(){return[...this.b.values()]}};w=Ve([ze(0,C.IExtHostRpcService),ze(1,E.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(Se[59],ye([1,0,14,5,2,4,3,7,16,11,79]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class P{constructor(g,f,w){this.e=w,this.d=f,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,f={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(f)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.TextTabInput(I.URI.revive(this.b.input.uri));case 2:return new T.TextDiffTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new T.TextMergeTabInput(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new T.CustomEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.WebviewEditorTabInput(this.b.input.viewType);case 4:return new T.NotebookEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));default:return}}}class E{constructor(g,f){this.c=[],this.d="",this.b=g,this.e=f;for(const w of g.tabs)w.isActive&&(this.d=w.id),this.c.push(new P(w,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,f={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return a.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(w=>w.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(w=>w.apiObject))}};this.a=Object.freeze(f)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const w=new P(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,w),g.tabDto.isActive&&(this.d=w.tabId),w}else if(g.kind===1){const w=this.c.splice(g.index,1)[0];if(!w)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return w.tabId===this.d&&(this.d=""),w}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const w=this.c.splice(g.oldIndex,1)[0];if(!w)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,w),w}const f=this.c.find(w=>w.tabId===g.tabDto.id);if(!f)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),f.acceptDtoUpdate(g.tabDto),f}activeTabId(){return this.d}}let y=class{constructor(g){this.b=new A.Emitter,this.c=new A.Emitter,this.e=[],this.a=g.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,f={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(w=>w.apiObject))},get activeTabGroup(){const w=g.d;return(0,C.assertIsDefined)(g.e.find(h=>h.groupId===w)?.apiObject)},close:async(w,m)=>{const h=Array.isArray(w)?w:[w];return h.length?v(h[0])?this.j(h,m):this.i(h,m):!0}};this.f=Object.freeze(f)}return this.f}$acceptEditorTabModel(g){const f=new Set(this.e.map(c=>c.groupId)),w=new Set(g.map(c=>c.groupId)),m=(0,R.diffSets)(f,w),h=this.e.filter(c=>m.removed.includes(c.groupId)).map(c=>c.apiObject),b=[],s=[];this.e=g.map(c=>{const u=new E(c,()=>this.d);return m.added.includes(u.groupId)?b.push(u.apiObject):s.push(u.apiObject),u});const i=(0,C.assertIsDefined)(g.find(c=>c.isActive===!0)?.groupId);i!==void 0&&this.d!==i&&(this.d=i),this.c.fire(Object.freeze({opened:b,closed:h,changed:s}))}$acceptTabGroupUpdate(g){const f=this.e.find(w=>w.groupId===g.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const f=this.e.find(m=>m.groupId===g.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const w=f.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[w.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[w.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[w.apiObject]}));return}}g(g){for(const f of this.e)for(const w of f.tabs)if(w.apiObject===g)return w}h(g){return this.e.find(f=>f.apiObject===g)}async i(g,f){const w=[];for(const m of g){const h=this.g(m);if(!h)throw new Error("Tab close: Invalid tab not found!");w.push(h.tabId)}return this.a.$closeTab(w,f)}async j(g,f){const w=[];for(const m of g){const h=this.h(m);if(!h)throw new Error("Group close: Invalid group not found!");w.push(h.groupId)}return this.a.$closeGroup(w,f)}};y=Ve([ze(0,S.IExtHostRpcService)],y),e.ExtHostEditorTabs=y;function v(d){return d.tabs!==void 0}}),define(Se[251],ye([1,0,2,5,6,7,14,152,8,22,26]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const d=this.a.indexOf(v);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),d=[];let g,f,w=14,m=14;for(const h of v){let b=g?(0,S.commonPrefixLength)(g,h):0;for(b===0?f=1:f=m;b<h.length;b++)b+1===h.length?(w=m,m=9):m+=1,d.push([f,h.toUpperCase().charCodeAt(b),m]),d.push([f,h.toLowerCase().charCodeAt(b),m]),f=m;g=h,m=w}d.push([9,58,10]),d.push([10,47,12]),this.b=new T.StateMachine(d)}}provideDocumentLinks(v){this.c();const d=[],g=T.LinkComputer.computeLinks({getLineContent(f){return v.lineAt(f-1).text},getLineCount(){return v.lineCount}},this.b);for(const f of g){const w=D.DocumentLink.to(f);w.target&&d.push(w)}return d}}class E{constructor(v,d){this.i=d,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,d,g,f={}){if(this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const w=this.h++;this.b.add(d),this.d.add(d),this.c.set(w,g);let m=2;f.isCaseSensitive&&(m+=1024),f.isReadonly&&(m+=2048),typeof g.copy=="function"&&(m+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,R.checkProposedApiEnabled)(v,"fsChunks"),m+=4),this.a.$registerFileSystemProvider(w,d,m).catch(b=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${d}`),console.error(b)});const h=g.onDidChangeFile(b=>{const s=[];for(const i of b){const{uri:c,type:u}=i;if(c.scheme!==d)continue;let r;switch(u){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:c,type:r})}this.a.$onFileSystemChange(w,s)});return(0,I.toDisposable)(()=>{h.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(w),this.a.$unregisterProvider(w)})}static j(v){const{type:d,ctime:g,mtime:f,size:w,permissions:m}=v;return{type:d,ctime:g,mtime:f,size:w,permissions:m}}$stat(v,d){return Promise.resolve(this.k(v).stat(a.URI.revive(d))).then(g=>E.j(g))}$readdir(v,d){return Promise.resolve(this.k(v).readDirectory(a.URI.revive(d)))}$readFile(v,d){return Promise.resolve(this.k(v).readFile(a.URI.revive(d))).then(g=>C.VSBuffer.wrap(g))}$writeFile(v,d,g,f){return Promise.resolve(this.k(v).writeFile(a.URI.revive(d),g.buffer,f))}$delete(v,d,g){return Promise.resolve(this.k(v).delete(a.URI.revive(d),g))}$rename(v,d,g,f){return Promise.resolve(this.k(v).rename(a.URI.revive(d),a.URI.revive(g),f))}$copy(v,d,g,f){const w=this.k(v);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(a.URI.revive(d),a.URI.revive(g),f))}$mkdir(v,d){return Promise.resolve(this.k(v).createDirectory(a.URI.revive(d)))}$watch(v,d,g,f){const w=this.k(v).watch(a.URI.revive(g),f);this.f.set(d,w)}$unwatch(v,d){const g=this.f.get(d);g&&(g.dispose(),this.f.delete(d))}$open(v,d,g){const f=this.k(v);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(a.URI.revive(d),g))}$close(v,d){const g=this.k(v);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(d))}$read(v,d,g,f){const w=this.k(v);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const m=C.VSBuffer.alloc(f);return Promise.resolve(w.read(d,g,m.buffer,0,f)).then(h=>m.slice(0,h))}$write(v,d,g,f){const w=this.k(v);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(d,g,f.buffer,0,f.byteLength))}k(v){const d=this.c.get(v);if(!d){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return d}}e.ExtHostFileSystem=E}),define(Se[70],ye([1,0,5,38,7,22,3,16,46,6]),function(te,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Jt{constructor(E,y){this.b=new Map,this.a=E.getProxy(a.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(d){try{const g=v.b.get(d.scheme);if(!g)return await v.a.$stat(d);await v.a.$ensureActivation(d.scheme);const f=await g.stat(d);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(g){Jt.c(g)}},async readDirectory(d){try{const g=v.b.get(d.scheme);return g?(await v.a.$ensureActivation(d.scheme),(await g.readDirectory(d)).slice()):await v.a.$readdir(d)}catch(g){return Jt.c(g)}},async createDirectory(d){try{return await v.a.$mkdir(d)}catch(g){return Jt.c(g)}},async readFile(d){try{const g=v.b.get(d.scheme);return g?(await v.a.$ensureActivation(d.scheme),(await g.readFile(d)).slice()):(await v.a.$readFile(d)).buffer}catch(g){return Jt.c(g)}},async writeFile(d,g){try{return await v.a.$writeFile(d,A.VSBuffer.wrap(g))}catch(f){return Jt.c(f)}},async delete(d,g){try{const f=v.b.get(d.scheme);return f?(await v.a.$ensureActivation(d.scheme),await f.delete(d,{recursive:!1,...g})):await v.a.$delete(d,{recursive:!1,useTrash:!1,...g})}catch(f){return Jt.c(f)}},async rename(d,g,f){try{return await v.a.$rename(d,g,{overwrite:!1,...f})}catch(w){return Jt.c(w)}},async copy(d,g,f){try{return await v.a.$copy(d,g,{overwrite:!1,...f})}catch(w){return Jt.c(w)}},isWritableFileSystem(d){const g=y.getCapabilities(d);if(typeof g=="number")return!(g&2048)}})}static c(E){if(E instanceof I.FileSystemError)throw E;if(!(E instanceof Error))throw new I.FileSystemError(String(E));if(E.name==="ENOPRO")throw I.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(E.message);default:throw new I.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,y){return this.b.set(E,y),(0,C.toDisposable)(()=>this.b.delete(E))}};R=Ve([ze(0,T.IExtHostRpcService),ze(1,S.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(Se[252],ye([1,0,4,37,2,5,14,7]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,E,y,v,d,g,f,w){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const m=this.h(P,y,d);this.g=0,g&&(this.g+=1),f&&(this.g+=2),w&&(this.g+=4);const h=(0,t.parse)(d),b=typeof d=="string",s=v(i=>{if(!g)for(const c of i.created){const u=I.URI.revive(c);h(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.a.fire(u)}if(!f)for(const c of i.changed){const u=I.URI.revive(c);h(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.b.fire(u)}if(!w)for(const c of i.deleted){const u=I.URI.revive(c);h(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=T.Disposable.from(m,this.a,this.b,this.c,s)}h(P,E,y){const v=T.Disposable.from();if(typeof y=="string")return v;const d=P.getProxy(A.MainContext.MainThreadFileSystem);let g=!1;(y.pattern.includes(t.GLOBSTAR)||y.pattern.includes(t.GLOB_SPLIT))&&(g=!0);const f=Math.random();return d.$watch(E.identifier.value,f,y.baseUri,{recursive:g,excludes:[]}),T.Disposable.from({dispose:()=>d.$unwatch(f)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class C{constructor(P,E,y){this.j=P,this.k=E,this.l=y,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,E,y,v,d,g){return new S(this.j,P,E,this.a.event,D.GlobPattern.from(y),v,d,g)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,E){switch(P){case 2:this.b.fire(Object.freeze({files:E.map(y=>({oldUri:I.URI.revive(y.source),newUri:I.URI.revive(y.target)}))}));break;case 1:this.d.fire(Object.freeze({files:E.map(y=>I.URI.revive(y.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:E.map(y=>I.URI.revive(y.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,E){return(y,v,d)=>{const g=function(w){y.call(v,w)};return g.extension=P,E.event(g,void 0,d)}}async $onWillRunFileOperation(P,E,y,v){switch(P){case 2:return await this.n(this.g,{files:E.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},y,v);case 1:return await this.n(this.i,{files:E.map(d=>I.URI.revive(d.target))},y,v);case 0:case 3:return await this.n(this.h,{files:E.map(d=>I.URI.revive(d.target))},y,v)}}async n(P,E,y,v){const d=new Set,g=[];if(await P.fireAsync(E,v,async(w,m)=>{const h=Date.now(),b=await Promise.resolve(w);b instanceof T.WorkspaceEdit&&(g.push([m.extension,b]),d.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-h>y&&this.k.warn("SLOW file-participant",m.extension.identifier)}),v.isCancellationRequested||g.length===0)return;const f={edits:[]};for(const[,w]of g){const{edits:m}=D.WorkspaceEdit.from(w,{getTextDocumentVersion:h=>this.l.getDocument(h)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(m)}return{edit:f,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=C}),define(Se[253],ye([1,0,2,39]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(D,T,S,C,R){this.a=T,this.b=S,this.c=C;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const y=this.a.getEditorById(E.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:a.URI.revive(E.notebookUri),inputUri:a.URI.revive(E.inputUri),notebookEditor:y.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:a.URI.revive(E.notebookUri),inputUri:a.URI.revive(E.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(D,T,S,C){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:D,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=I}),define(Se[254],ye([1,0,6,5]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(D){this.b=0,this.a=D.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,D),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=I}),define(Se[255],ye([1,0,2,23,14,7,66,5,8,35,17,11,148,21,6,118,99,67,51,10,18,26]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(N,z){this.d=N,this.e=z}async provideDocumentSymbols(N,z){const X=this.d.getDocument(N),Q=await this.e.provideDocumentSymbols(X,z);if(!(0,R.isFalsyOrEmpty)(Q))return Q[0]instanceof A.DocumentSymbol?Q.map(I.DocumentSymbol.from):s.f(Q)}static f(N){N=N.slice(0).sort((Q,le)=>{let be=Q.location.range.start.compareTo(le.location.range.start);return be===0&&(be=le.location.range.end.compareTo(Q.location.range.end)),be});const z=[],X=[];for(const Q of N){const le={name:Q.name||"!!MISSING: name!!",kind:I.SymbolKind.from(Q.kind),tags:Q.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:I.Range.from(Q.location.range),selectionRange:I.Range.from(Q.location.range),children:[]};for(;;){if(X.length===0){X.push(le),z.push(le);break}const be=X[X.length-1];if(C.Range.containsRange(be.range,le.range)&&!C.Range.equalsRange(be.range,le.range)){be.children?.push(le),X.push(le);break}X.pop()}}return z}}class i{constructor(N,z,X){this.g=N,this.h=z,this.j=X,this.e=new f.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,z){const X=this.g.getDocument(N),Q=await this.j.provideCodeLenses(X,z);if(!Q||z.isCancellationRequested)return;const le=this.e.add(Q),be=new v.DisposableStore;this.f.set(le,be);const Te={cacheId:le,lenses:[]};for(let ge=0;ge<Q.length;ge++)Te.lenses.push({cacheId:[le,ge],range:I.Range.from(Q[ge].range),command:this.h.toInternal(Q[ge].command,be)});return Te}async resolveCodeLens(N,z){const X=N.cacheId&&this.e.get(...N.cacheId);if(!X)return;let Q;if(typeof this.j.resolveCodeLens!="function"||X.isResolved?Q=X:Q=await this.j.resolveCodeLens(X,z),Q||(Q=X),z.isCancellationRequested)return;const le=N.cacheId&&this.f.get(N.cacheId[0]);if(!!le)return N.command=this.h.toInternal(Q.command??i.d,le),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}i.d={command:"missing",title:"!!MISSING: command!!"};function c(ie){return Array.isArray(ie)?ie.map(I.DefinitionLink.from):ie?[I.DefinitionLink.from(ie)]:[]}class u{constructor(N,z){this.d=N,this.e=z}async provideDefinition(N,z,X){const Q=this.d.getDocument(N),le=I.Position.to(z),be=await this.e.provideDefinition(Q,le,X);return c(be)}}class r{constructor(N,z){this.d=N,this.e=z}async provideDeclaration(N,z,X){const Q=this.d.getDocument(N),le=I.Position.to(z),be=await this.e.provideDeclaration(Q,le,X);return c(be)}}class o{constructor(N,z){this.d=N,this.e=z}async provideImplementation(N,z,X){const Q=this.d.getDocument(N),le=I.Position.to(z),be=await this.e.provideImplementation(Q,le,X);return c(be)}}class n{constructor(N,z){this.d=N,this.e=z}async provideTypeDefinition(N,z,X){const Q=this.d.getDocument(N),le=I.Position.to(z),be=await this.e.provideTypeDefinition(Q,le,X);return c(be)}}class l{constructor(N,z){this.d=N,this.e=z}async provideHover(N,z,X){const Q=this.d.getDocument(N),le=I.Position.to(z),be=await this.e.provideHover(Q,le,X);if(!(!be||(0,R.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=Q.getWordRangeAtPosition(le)),be.range||(be.range=new A.Range(le,le)),I.Hover.from(be)}}class p{constructor(N,z){this.d=N,this.e=z}async provideEvaluatableExpression(N,z,X){const Q=this.d.getDocument(N),le=I.Position.to(z),be=await this.e.provideEvaluatableExpression(Q,le,X);if(be)return I.EvaluatableExpression.from(be)}}class k{constructor(N,z){this.d=N,this.e=z}async provideInlineValues(N,z,X,Q){const le=this.d.getDocument(N),be=await this.e.provideInlineValues(le,I.Range.to(z),I.InlineValueContext.to(X),Q);if(Array.isArray(be))return be.map(Te=>I.InlineValue.from(Te))}}class L{constructor(N,z){this.d=N,this.e=z}async provideDocumentHighlights(N,z,X){const Q=this.d.getDocument(N),le=I.Position.to(z),be=await this.e.provideDocumentHighlights(Q,le,X);if(Array.isArray(be))return be.map(I.DocumentHighlight.from)}}class U{constructor(N,z){this.d=N,this.e=z}async provideLinkedEditingRanges(N,z,X){const Q=this.d.getDocument(N),le=I.Position.to(z),be=await this.e.provideLinkedEditingRanges(Q,le,X);if(be&&Array.isArray(be.ranges))return{ranges:(0,R.coalesce)(be.ranges.map(I.Range.from)),wordPattern:be.wordPattern}}}class K{constructor(N,z){this.d=N,this.e=z}async provideReferences(N,z,X,Q){const le=this.d.getDocument(N),be=I.Position.to(z),Te=await this.e.provideReferences(le,be,X,Q);if(Array.isArray(Te))return Te.map(I.location.from)}}class G{constructor(N,z,X,Q,le,be,Te){this.g=N,this.h=z,this.j=X,this.k=Q,this.l=le,this.m=be,this.n=Te,this.e=new f.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,z,X,Q){const le=this.g.getDocument(N),be=E.Selection.isISelection(z)?I.Selection.to(z):I.Range.to(z),Te=[];for(const Ze of this.j.getDiagnostics(N))if(be.intersection(Ze.range)&&Te.push(Ze)>G.d)break;const ge={diagnostics:Te,only:X.only?new A.CodeActionKind(X.only):void 0,triggerKind:I.CodeActionTriggerKind.to(X.trigger)},Ce=await this.k.provideCodeActions(le,be,ge,Q);if(!(0,R.isNonEmptyArray)(Ce)||Q.isCancellationRequested)return;const Ie=this.e.add(Ce),He=new v.DisposableStore;this.f.set(Ie,He);const qe=[];for(let Ze=0;Ze<Ce.length;Ze++){const xe=Ce[Ze];!xe||(G.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,He)})):(ge.only&&(xe.kind?ge.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Ie,Ze],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,He),diagnostics:xe.diagnostics&&xe.diagnostics.map(I.Diagnostic.from),edit:xe.edit&&I.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,disabled:xe.disabled?.reason})))}return{cacheId:Ie,actions:qe}}async resolveCodeAction(N,z){const[X,Q]=N,le=this.e.get(X,Q);if(!le||G.o(le)||!this.k.resolveCodeAction)return;const be=await this.k.resolveCodeAction(le,z)??le;return be?.edit?I.WorkspaceEdit.from(be.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}G.d=1e3;class O{constructor(N,z,X,Q){this.d=N,this.e=z,this.f=X,this.g=Q}async prepareDocumentPaste(N,z,X,Q){if(!this.f.prepareDocumentPaste)return;const le=this.e.getDocument(N),be=z.map(ge=>I.Range.to(ge)),Te=I.DataTransfer.toDataTransfer(X,()=>{throw new m.NotImplementedError});return await this.f.prepareDocumentPaste(le,be,Te,Q),I.DataTransfer.toDataTransferDTO(Te)}async providePasteEdits(N,z,X,Q,le){const be=this.e.getDocument(z),Te=X.map(Ie=>I.Range.to(Ie)),ge=I.DataTransfer.toDataTransfer(Q,async Ie=>(await this.d.$resolvePasteFileData(this.g,N,Ie)).buffer),Ce=await this.f.provideDocumentPasteEdits(be,Te,ge,le);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?I.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class B{constructor(N,z){this.d=N,this.e=z}async provideDocumentFormattingEdits(N,z,X){const Q=this.d.getDocument(N),le=await this.e.provideDocumentFormattingEdits(Q,z,X);if(Array.isArray(le))return le.map(I.TextEdit.from)}}class F{constructor(N,z){this.d=N,this.e=z}async provideDocumentRangeFormattingEdits(N,z,X,Q){const le=this.d.getDocument(N),be=I.Range.to(z),Te=await this.e.provideDocumentRangeFormattingEdits(le,be,X,Q);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class ${constructor(N,z){this.d=N,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,z,X,Q,le){const be=this.d.getDocument(N),Te=I.Position.to(z),ge=await this.e.provideOnTypeFormattingEdits(be,Te,X,Q,le);if(Array.isArray(ge))return ge.map(I.TextEdit.from)}}class M{constructor(N,z){this.e=N,this.f=z,this.d=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,z){const X=await this.e.provideWorkspaceSymbols(N,z);if(!(0,R.isNonEmptyArray)(X))return{symbols:[]};const Q=this.d.add(X),le={cacheId:Q,symbols:[]};for(let be=0;be<X.length;be++){const Te=X[be];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}le.symbols.push({...I.WorkspaceSymbol.from(Te),cacheId:[Q,be]})}return le}async resolveWorkspaceSymbol(N,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const X=this.d.get(...N.cacheId);if(X){const Q=await this.e.resolveWorkspaceSymbol(X,z);return Q&&(0,t.mixin)(N,I.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class V{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,z,X){this.d=N,this.e=z,this.f=X}async provideRenameEdits(N,z,X,Q){const le=this.d.getDocument(N),be=I.Position.to(z);try{const Te=await this.e.provideRenameEdits(le,be,X,Q);return Te?I.WorkspaceEdit.from(Te):void 0}catch(Te){const ge=V.g(Te);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(N,z,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(N),le=I.Position.to(z);try{const be=await this.e.prepareRename(Q,le,X);let Te,ge;if(A.Range.isRange(be)?(Te=be,ge=Q.getText(be)):(0,P.isObject)(be)&&(Te=be.range,ge=be.placeholder),!Te||!ge)return;if(Te.start.line>le.line||Te.end.line<le.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Te),text:ge}}catch(be){const Te=V.g(be);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(be)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class q{constructor(N,z){this.resultId=N,this.tokens=z}}class H{constructor(N,z){this.f=N,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,z,X){const Q=this.f.getDocument(N),le=z!==0?this.d.get(z):null;let be=typeof le?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,le.resultId,X):await this.g.provideDocumentSemanticTokens(Q,X);return le&&this.d.delete(z),be?(be=H.h(be),this.o(H.n(le,be),be)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return H.j(N)?H.k(N)?N:new A.SemanticTokens(new Uint32Array(N.data),N.resultId):H.l(N)?H.m(N)?N:new A.SemanticTokensEdits(N.edits.map(z=>new A.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const z of N.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(N,z){if(!H.j(z)||!N||!N.tokens)return z;const X=N.tokens,Q=X.length,le=z.data,be=le.length;let Te=0;const ge=Math.min(Q,be);for(;Te<ge&&X[Te]===le[Te];)Te++;if(Te===Q&&Te===be)return new A.SemanticTokensEdits([],z.resultId);let Ce=0;const Ie=ge-Te;for(;Ce<Ie&&X[Q-Ce-1]===le[be-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Te,deleteCount:Q-Te-Ce,data:le.subarray(Te,be-Ce)}],z.resultId)}o(N,z){if(H.j(N)){const X=this.e++;return this.d.set(X,new q(N.resultId,N.data)),(0,d.encodeSemanticTokensDto)({id:X,type:"full",data:N.data})}if(H.l(N)){const X=this.e++;return H.j(z)?this.d.set(X,new q(z.resultId,z.data)):this.d.set(X,new q(N.resultId)),(0,d.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(N.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class J{constructor(N,z){this.d=N,this.e=z}async provideDocumentRangeSemanticTokens(N,z,X){const Q=this.d.getDocument(N),le=await this.e.provideDocumentRangeSemanticTokens(Q,I.Range.to(z),X);return le?this.f(le):null}f(N){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class Y{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,z,X,Q,le){this.f=N,this.g=z,this.h=X,this.j=Q,this.k=le,this.d=new f.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,z,X,Q){const le=this.f.getDocument(N),be=I.Position.to(z),Te=le.getWordRangeAtPosition(be)||new A.Range(be,be),ge=Te.with({end:be}),Ce=new w.StopWatch(!0),Ie=await this.h.provideCompletionItems(le,be,Q,I.CompletionContext.to(X));if(!Ie||Q.isCancellationRequested)return;const He=Array.isArray(Ie)?new A.CompletionList(Ie):Ie,qe=Y.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Ze=new v.DisposableStore;this.e.set(qe,Ze);const xe=[],tt={x:qe,b:xe,a:{replace:I.Range.from(Te),insert:I.Range.from(ge)},c:He.isIncomplete||void 0,d:Ce.elapsed()};for(let nt=0;nt<He.items.length;nt++){const ft=He.items[nt],it=this.l(ft,[qe,nt],ge,Te);xe.push(it)}return tt}async resolveCompletionItem(N,z){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...N);if(!X)return;const Q=await this.h.resolveCompletionItem(X,z);if(!!Q)return this.l(Q,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,z,X,Q){const le=this.e.get(z[0]);if(!le)throw Error("DisposableStore is missing...");const be=this.g.toInternal(N.command,le),Te={x:z,a:N.label,b:N.kind!==void 0?I.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(I.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:I.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(I.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=N.textEdit.newText):typeof N.insertText=="string"?Te.h=N.insertText:N.insertText instanceof A.SnippetString&&(Te.h=N.insertText.value,Te.i|=4);let ge;return N.textEdit?ge=N.textEdit.range:N.range&&(ge=N.range),A.Range.isRange(ge)?Te.j=I.Range.from(ge):ge&&(!X?.isEqual(ge.inserting)||!Q?.isEqual(ge.replacing))&&(Te.j={insert:I.Range.from(ge.inserting),replace:I.Range.from(ge.replacing)}),Te}}class ae{async provideInlineCompletions(N,z,X,Q){}disposeCompletions(N){}handleDidShowCompletionItem(N,z){}}class re extends ae{constructor(N,z,X,Q){super(),this.f=N,this.g=z,this.h=X,this.j=Q,this.d=new fe,this.e=(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[D.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(N,z,X,Q){const le=this.g.getDocument(N),be=I.Position.to(z),Te=await this.h.provideInlineCompletionItems(le,be,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:I.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Q);if(!Te||Q.isCancellationRequested)return;const ge=Array.isArray(Te)?Te:Te.items,Ce=this.e?Array.isArray(Te)?[]:Te.commands||[]:[];let Ie;return{pid:this.d.createReferenceId({dispose(){Ie?.dispose()},items:ge}),items:ge.map((qe,Ze)=>{let xe;qe.command&&(Ie||(Ie=new v.DisposableStore),xe=this.j.toInternal(qe.command,Ie));const tt=qe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:qe.filterText,range:qe.range?I.Range.from(qe.range):void 0,command:xe,idx:Ze,completeBracketPairs:this.e?qe.completeBracketPairs:!1}}),commands:Ce.map(qe=>(Ie||(Ie=new v.DisposableStore),this.j.toInternal(qe,Ie)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,z){const X=this.d.get(N)?.items[z];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X)}}class fe{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const z=this.e++;return this.d.set(z,N),z}disposeReferenceId(N){const z=this.d.get(N);return this.d.delete(N),z}get(N){return this.d.get(N)}}class Z{constructor(N,z){this.e=N,this.f=z,this.d=new f.Cache("SignatureHelp")}async provideSignatureHelp(N,z,X,Q){const le=this.e.getDocument(N),be=I.Position.to(z),Te=this.g(X),ge=await this.f.provideSignatureHelp(le,be,Q,Te);if(ge){const Ce=this.d.add([ge]);return{...I.SignatureHelp.from(ge),id:Ce}}}g(N){let z;if(N.activeSignatureHelp){const X=I.SignatureHelp.to(N.activeSignatureHelp),Q=this.d.get(N.activeSignatureHelp.id,0);Q?(z=Q,z.activeSignature=X.activeSignature,z.activeParameter=X.activeParameter):z=X}return{...N,activeSignatureHelp:z}}releaseSignatureHelp(N){this.d.delete(N)}}class pe{constructor(N,z,X,Q,le){this.f=N,this.g=z,this.h=X,this.j=Q,this.k=le,this.d=new f.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,z,X){const Q=this.f.getDocument(N),le=I.Range.to(z),be=await this.h.provideInlayHints(Q,le,X);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${z}`);return}if(X.isCancellationRequested)return;const Te=this.d.add(be);this.e.set(Te,new v.DisposableStore);const ge={hints:[],cacheId:Te};for(let Ce=0;Ce<be.length;Ce++)this.l(be[Ce],le)&&ge.hints.push(this.m(be[Ce],[Te,Ce]));return this.j.trace(`[InlayHints] ${ge.hints.length} inlay hints from '${this.k.identifier.value}' for ${z}`),ge}async resolveInlayHint(N,z){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...N);if(!X)return;const Q=await this.h.resolveInlayHint(X,z);if(!!Q&&!!this.l(Q))return this.m(Q,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,z){return N.label.length===0||Array.isArray(N.label)&&N.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(z&&!z.contains(N.position))}m(N,z){const X=this.e.get(z[0]);if(!X)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:z,tooltip:I.MarkdownString.fromStrict(N.tooltip),position:I.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(I.TextEdit.from),kind:N.kind&&I.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?Q.label=N.label:Q.label=N.label.map(le=>{const be={label:le.value};return be.tooltip=I.MarkdownString.fromStrict(le.tooltip),A.Location.isLocation(le.location)&&(be.location=I.location.from(le.location)),le.command&&(be.command=this.g.toInternal(le.command,X)),be}),Q}}class we{constructor(N,z){this.e=N,this.f=z,this.d=new f.Cache("DocumentLink")}async provideLinks(N,z){const X=this.e.getDocument(N),Q=await this.f.provideDocumentLinks(X,z);if(!(!Array.isArray(Q)||Q.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(we.g).map(I.DocumentLink.from)};{const le=this.d.add(Q),be={links:[],cacheId:le};for(let Te=0;Te<Q.length;Te++){if(!we.g(Q[Te]))continue;const ge=I.DocumentLink.from(Q[Te]);ge.cacheId=[le,Te],be.links.push(ge)}return be}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,z){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...N);if(!X)return;const Q=await this.f.resolveDocumentLink(X,z);if(!(!Q||!we.g(Q)))return I.DocumentLink.from(Q)}releaseLinks(N){this.d.delete(N)}}class De{constructor(N,z){this.d=N,this.e=z}async provideColors(N,z){const X=this.d.getDocument(N),Q=await this.e.provideDocumentColors(X,z);return Array.isArray(Q)?Q.map(be=>({color:I.Color.from(be.color),range:I.Range.from(be.range)})):[]}async provideColorPresentations(N,z,X){const Q=this.d.getDocument(N),le=I.Range.to(z.range),be=I.Color.to(z.color),Te=await this.e.provideColorPresentations(be,{document:Q,range:le},X);if(!!Array.isArray(Te))return Te.map(I.ColorPresentation.from)}}class Re{constructor(N,z){this.d=N,this.e=z}async provideFoldingRanges(N,z,X){const Q=this.d.getDocument(N),le=await this.e.provideFoldingRanges(Q,z,X);if(!!Array.isArray(le))return le.map(I.FoldingRange.from)}}class Be{constructor(N,z,X){this.d=N,this.e=z,this.f=X}async provideSelectionRanges(N,z,X){const Q=this.d.getDocument(N),le=z.map(I.Position.to),be=await this.e.provideSelectionRanges(Q,le,X);if(!(0,R.isNonEmptyArray)(be))return[];if(be.length!==le.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let ge=0;ge<le.length;ge++){const Ce=[];Te.push(Ce);let Ie=le[ge],He=be[ge];for(;;){if(!He.range.contains(Ie))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(I.SelectionRange.from(He)),!He.parent)break;Ie=He.range,He=He.parent}}return Te}}class se{constructor(N,z){this.f=N,this.g=z,this.d=new g.IdGenerator(""),this.e=new Map}async prepareSession(N,z,X){const Q=this.f.getDocument(N),le=I.Position.to(z),be=await this.g.prepareCallHierarchy(Q,le,X);if(!be)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(be)?be.map(ge=>this.h(Te,ge)):[this.h(Te,be)]}async provideCallsTo(N,z,X){const Q=this.j(N,z);if(!Q)throw new Error("missing call hierarchy item");const le=await this.g.provideCallHierarchyIncomingCalls(Q,X);if(!!le)return le.map(be=>({from:this.h(N,be.from),fromRanges:be.fromRanges.map(Te=>I.Range.from(Te))}))}async provideCallsFrom(N,z,X){const Q=this.j(N,z);if(!Q)throw new Error("missing call hierarchy item");const le=await this.g.provideCallHierarchyOutgoingCalls(Q,X);if(!!le)return le.map(be=>({to:this.h(N,be.to),fromRanges:be.fromRanges.map(Te=>I.Range.from(Te))}))}releaseSession(N){this.e.delete(N)}h(N,z){const X=this.e.get(N),Q=I.CallHierarchyItem.from(z,N,X.size.toString(36));return X.set(Q._itemId,z),Q}j(N,z){return this.e.get(N)?.get(z)}}class ue{constructor(N,z){this.f=N,this.g=z,this.d=new g.IdGenerator(""),this.e=new Map}async prepareSession(N,z,X){const Q=this.f.getDocument(N),le=I.Position.to(z),be=await this.g.prepareTypeHierarchy(Q,le,X);if(!be)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(be)?be.map(ge=>this.h(Te,ge)):[this.h(Te,be)]}async provideSupertypes(N,z,X){const Q=this.j(N,z);if(!Q)throw new Error("missing type hierarchy item");const le=await this.g.provideTypeHierarchySupertypes(Q,X);if(!!le)return le.map(be=>this.h(N,be))}async provideSubtypes(N,z,X){const Q=this.j(N,z);if(!Q)throw new Error("missing type hierarchy item");const le=await this.g.provideTypeHierarchySubtypes(Q,X);if(!!le)return le.map(be=>this.h(N,be))}releaseSession(N){this.e.delete(N)}h(N,z){const X=this.e.get(N),Q=I.TypeHierarchyItem.from(z,N,X.size.toString(36));return X.set(Q._itemId,z),Q}j(N,z){return this.e.get(N)?.get(z)}}class de{constructor(N,z,X,Q){this.d=N,this.e=z,this.f=X,this.g=Q}async provideDocumentOnDropEdits(N,z,X,Q,le){const be=this.e.getDocument(z),Te=I.Position.to(X),ge=I.DataTransfer.toDataTransfer(Q,async Ie=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,Ie)).buffer),Ce=await this.f.provideDocumentDropEdits(be,Te,ge,le);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?I.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ee{constructor(N,z){this.adapter=N,this.extension=z}}class oe{constructor(N,z,X,Q,le,be,Te,ge){this.g=z,this.h=X,this.j=Q,this.k=le,this.l=be,this.m=Te,this.n=ge,this.f=new Map,this.e=N.getProxy(T.MainContext.MainThreadLanguageFeatures)}o(N){return I.DocumentSelector.from(N,this.g)}p(N){return new A.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return oe.d++}async s(N,z,X,Q,le,be=!1){const Te=this.f.get(N);if(!Te||!(Te.adapter instanceof z))return Q;const ge=Date.now();be||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Ce=X(Te.adapter,Te.extension);return Promise.resolve(Ce).catch(Ie=>{(0,m.isCancellationError)(Ie)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(Ie),this.n.onExtensionError(Te.extension.identifier,Ie))}).finally(()=>{be||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-ge}ms`)}),y.CancellationToken.isCancellationToken(le)?(0,h.raceCancellationError)(Ce,le):Ce}t(N,z){const X=this.q();return this.f.set(X,new ee(N,z)),X}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,z,X,Q){const le=this.t(new s(this.h,X),N),be=Q&&Q.label||oe.u(N);return this.e.$registerDocumentSymbolProvider(le,this.o(z),be),this.p(le)}$provideDocumentSymbols(N,z,X){return this.s(N,s,Q=>Q.provideDocumentSymbols(a.URI.revive(z),X),void 0,X)}registerCodeLensProvider(N,z,X){const Q=this.q(),le=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new ee(new i(this.h,this.j.converter,X),N)),this.e.$registerCodeLensSupport(Q,this.o(z),le);let be=this.p(Q);if(le!==void 0){const Te=X.onDidChangeCodeLenses(ge=>this.e.$emitCodeLensEvent(le));be=A.Disposable.from(be,Te)}return be}$provideCodeLenses(N,z,X){return this.s(N,i,Q=>Q.provideCodeLenses(a.URI.revive(z),X),void 0,X)}$resolveCodeLens(N,z,X){return this.s(N,i,Q=>Q.resolveCodeLens(z,X),void 0,void 0)}$releaseCodeLenses(N,z){this.s(N,i,X=>Promise.resolve(X.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(N,z,X){const Q=this.t(new u(this.h,X),N);return this.e.$registerDefinitionSupport(Q,this.o(z)),this.p(Q)}$provideDefinition(N,z,X,Q){return this.s(N,u,le=>le.provideDefinition(a.URI.revive(z),X,Q),[],Q)}registerDeclarationProvider(N,z,X){const Q=this.t(new r(this.h,X),N);return this.e.$registerDeclarationSupport(Q,this.o(z)),this.p(Q)}$provideDeclaration(N,z,X,Q){return this.s(N,r,le=>le.provideDeclaration(a.URI.revive(z),X,Q),[],Q)}registerImplementationProvider(N,z,X){const Q=this.t(new o(this.h,X),N);return this.e.$registerImplementationSupport(Q,this.o(z)),this.p(Q)}$provideImplementation(N,z,X,Q){return this.s(N,o,le=>le.provideImplementation(a.URI.revive(z),X,Q),[],Q)}registerTypeDefinitionProvider(N,z,X){const Q=this.t(new n(this.h,X),N);return this.e.$registerTypeDefinitionSupport(Q,this.o(z)),this.p(Q)}$provideTypeDefinition(N,z,X,Q){return this.s(N,n,le=>le.provideTypeDefinition(a.URI.revive(z),X,Q),[],Q)}registerHoverProvider(N,z,X,Q){const le=this.t(new l(this.h,X),N);return this.e.$registerHoverProvider(le,this.o(z)),this.p(le)}$provideHover(N,z,X,Q){return this.s(N,l,le=>le.provideHover(a.URI.revive(z),X,Q),void 0,Q)}registerEvaluatableExpressionProvider(N,z,X,Q){const le=this.t(new p(this.h,X),N);return this.e.$registerEvaluatableExpressionProvider(le,this.o(z)),this.p(le)}$provideEvaluatableExpression(N,z,X,Q){return this.s(N,p,le=>le.provideEvaluatableExpression(a.URI.revive(z),X,Q),void 0,Q)}registerInlineValuesProvider(N,z,X,Q){const le=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new k(this.h,X),N);this.e.$registerInlineValuesProvider(be,this.o(z),le);let Te=this.p(be);if(le!==void 0){const ge=X.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(le));Te=A.Disposable.from(Te,ge)}return Te}$provideInlineValues(N,z,X,Q,le){return this.s(N,k,be=>be.provideInlineValues(a.URI.revive(z),X,Q,le),void 0,le)}registerDocumentHighlightProvider(N,z,X){const Q=this.t(new L(this.h,X),N);return this.e.$registerDocumentHighlightProvider(Q,this.o(z)),this.p(Q)}$provideDocumentHighlights(N,z,X,Q){return this.s(N,L,le=>le.provideDocumentHighlights(a.URI.revive(z),X,Q),void 0,Q)}registerLinkedEditingRangeProvider(N,z,X){const Q=this.t(new U(this.h,X),N);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(z)),this.p(Q)}$provideLinkedEditingRanges(N,z,X,Q){return this.s(N,U,async le=>{const be=await le.provideLinkedEditingRanges(a.URI.revive(z),X,Q);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?oe.w(be.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(N,z,X){const Q=this.t(new K(this.h,X),N);return this.e.$registerReferenceSupport(Q,this.o(z)),this.p(Q)}$provideReferences(N,z,X,Q,le){return this.s(N,K,be=>be.provideReferences(a.URI.revive(z),X,Q,le),void 0,le)}registerCodeActionProvider(N,z,X,Q){const le=new v.DisposableStore,be=this.t(new G(this.h,this.j.converter,this.k,X,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(be,this.o(z),{providedKinds:Q?.providedCodeActionKinds?.map(Te=>Te.value),documentation:Q?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,le)}))},oe.u(N),Boolean(X.resolveCodeAction)),le.add(this.p(be)),le}$provideCodeActions(N,z,X,Q,le){return this.s(N,G,be=>be.provideCodeActions(a.URI.revive(z),X,Q,le),void 0,le)}$resolveCodeAction(N,z,X){return this.s(N,G,Q=>Q.resolveCodeAction(z,X),void 0,void 0)}$releaseCodeActions(N,z){this.s(N,G,X=>Promise.resolve(X.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(N,z,X){const Q=this.t(new B(this.h,X),N);return this.e.$registerDocumentFormattingSupport(Q,this.o(z),N.identifier,N.displayName||N.name),this.p(Q)}$provideDocumentFormattingEdits(N,z,X,Q){return this.s(N,B,le=>le.provideDocumentFormattingEdits(a.URI.revive(z),X,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(N,z,X){const Q=this.t(new F(this.h,X),N);return this.e.$registerRangeFormattingSupport(Q,this.o(z),N.identifier,N.displayName||N.name),this.p(Q)}$provideDocumentRangeFormattingEdits(N,z,X,Q,le){return this.s(N,F,be=>be.provideDocumentRangeFormattingEdits(a.URI.revive(z),X,Q,le),void 0,le)}registerOnTypeFormattingEditProvider(N,z,X,Q){const le=this.t(new $(this.h,X),N);return this.e.$registerOnTypeFormattingSupport(le,this.o(z),Q,N.identifier),this.p(le)}$provideOnTypeFormattingEdits(N,z,X,Q,le,be){return this.s(N,$,Te=>Te.provideOnTypeFormattingEdits(a.URI.revive(z),X,Q,le,be),void 0,be)}registerWorkspaceSymbolProvider(N,z){const X=this.t(new M(z,this.l),N);return this.e.$registerNavigateTypeSupport(X,typeof z.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(N,z,X){return this.s(N,M,Q=>Q.provideWorkspaceSymbols(z,X),{symbols:[]},X)}$resolveWorkspaceSymbol(N,z,X){return this.s(N,M,Q=>Q.resolveWorkspaceSymbol(z,X),void 0,void 0)}$releaseWorkspaceSymbols(N,z){this.s(N,M,X=>X.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(N,z,X){const Q=this.t(new V(this.h,X,this.l),N);return this.e.$registerRenameSupport(Q,this.o(z),V.supportsResolving(X)),this.p(Q)}$provideRenameEdits(N,z,X,Q,le){return this.s(N,V,be=>be.provideRenameEdits(a.URI.revive(z),X,Q,le),void 0,le)}$resolveRenameLocation(N,z,X,Q){return this.s(N,V,le=>le.resolveRenameLocation(a.URI.revive(z),X,Q),void 0,Q)}registerDocumentSemanticTokensProvider(N,z,X,Q){const le=this.t(new H(this.h,X),N),be=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(le,this.o(z),Q,be);let Te=this.p(le);if(be){const ge=X.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(be));Te=A.Disposable.from(Te,ge)}return Te}$provideDocumentSemanticTokens(N,z,X,Q){return this.s(N,H,le=>le.provideDocumentSemanticTokens(a.URI.revive(z),X,Q),null,Q)}$releaseDocumentSemanticTokens(N,z){this.s(N,H,X=>X.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,z,X,Q){const le=this.t(new J(this.h,X),N);return this.e.$registerDocumentRangeSemanticTokensProvider(le,this.o(z),Q),this.p(le)}$provideDocumentRangeSemanticTokens(N,z,X,Q){return this.s(N,J,le=>le.provideDocumentRangeSemanticTokens(a.URI.revive(z),X,Q),null,Q)}registerCompletionItemProvider(N,z,X,Q){const le=this.t(new Y(this.h,this.j.converter,X,this.m,N),N);return this.e.$registerCompletionsProvider(le,this.o(z),Q,Y.supportsResolving(X),`${N.identifier.value}(${Q.join("")})`),this.p(le)}$provideCompletionItems(N,z,X,Q,le){return this.s(N,Y,be=>be.provideCompletionItems(a.URI.revive(z),X,Q,le),void 0,le)}$resolveCompletionItem(N,z,X){return this.s(N,Y,Q=>Q.resolveCompletionItem(z,X),void 0,X)}$releaseCompletionItems(N,z){this.s(N,Y,X=>X.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(N,z,X){const Q=new re(N,this.h,X,this.j.converter),le=this.t(Q,N);return this.e.$registerInlineCompletionsSupport(le,this.o(z),Q.supportsHandleDidShowCompletionItem),this.p(le)}$provideInlineCompletions(N,z,X,Q,le){return this.s(N,ae,be=>be.provideInlineCompletions(a.URI.revive(z),X,Q,le),void 0,le)}$handleInlineCompletionDidShow(N,z,X){this.s(N,ae,async Q=>{Q.handleDidShowCompletionItem(z,X)},void 0,void 0)}$freeInlineCompletionsList(N,z){this.s(N,ae,async X=>{X.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(N,z,X,Q){const le=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,be=this.t(new Z(this.h,X),N);return this.e.$registerSignatureHelpProvider(be,this.o(z),le),this.p(be)}$provideSignatureHelp(N,z,X,Q,le){return this.s(N,Z,be=>be.provideSignatureHelp(a.URI.revive(z),X,Q,le),void 0,le)}$releaseSignatureHelp(N,z){this.s(N,Z,X=>X.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(N,z,X){const Q=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,le=this.t(new pe(this.h,this.j.converter,X,this.l,N),N);this.e.$registerInlayHintsProvider(le,this.o(z),typeof X.resolveInlayHint=="function",Q,oe.u(N));let be=this.p(le);if(Q!==void 0){const Te=X.onDidChangeInlayHints(ge=>this.e.$emitInlayHintsEvent(Q));be=A.Disposable.from(be,Te)}return be}$provideInlayHints(N,z,X,Q){return this.s(N,pe,le=>le.provideInlayHints(a.URI.revive(z),X,Q),void 0,Q)}$resolveInlayHint(N,z,X){return this.s(N,pe,Q=>Q.resolveInlayHint(z,X),void 0,X)}$releaseInlayHints(N,z){this.s(N,pe,X=>X.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(N,z,X){const Q=this.t(new we(this.h,X),N);return this.e.$registerDocumentLinkProvider(Q,this.o(z),typeof X.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(N,z,X){return this.s(N,we,Q=>Q.provideLinks(a.URI.revive(z),X),void 0,X,z.scheme==="output")}$resolveDocumentLink(N,z,X){return this.s(N,we,Q=>Q.resolveLink(z,X),void 0,void 0,!0)}$releaseDocumentLinks(N,z){this.s(N,we,X=>X.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(N,z,X){const Q=this.t(new De(this.h,X),N);return this.e.$registerDocumentColorProvider(Q,this.o(z)),this.p(Q)}$provideDocumentColors(N,z,X){return this.s(N,De,Q=>Q.provideColors(a.URI.revive(z),X),[],X)}$provideColorPresentations(N,z,X,Q){return this.s(N,De,le=>le.provideColorPresentations(a.URI.revive(z),X,Q),void 0,Q)}registerFoldingRangeProvider(N,z,X){const Q=this.q(),le=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new ee(new Re(this.h,X),N)),this.e.$registerFoldingRangeProvider(Q,this.o(z),N.identifier,le);let be=this.p(Q);if(le!==void 0){const Te=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(le));be=A.Disposable.from(be,Te)}return be}$provideFoldingRanges(N,z,X,Q){return this.s(N,Re,le=>le.provideFoldingRanges(a.URI.revive(z),X,Q),void 0,Q)}registerSelectionRangeProvider(N,z,X){const Q=this.t(new Be(this.h,X,this.l),N);return this.e.$registerSelectionRangeProvider(Q,this.o(z)),this.p(Q)}$provideSelectionRanges(N,z,X,Q){return this.s(N,Be,le=>le.provideSelectionRanges(a.URI.revive(z),X,Q),[],Q)}registerCallHierarchyProvider(N,z,X){const Q=this.t(new se(this.h,X),N);return this.e.$registerCallHierarchyProvider(Q,this.o(z)),this.p(Q)}$prepareCallHierarchy(N,z,X,Q){return this.s(N,se,le=>Promise.resolve(le.prepareSession(a.URI.revive(z),X,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(N,z,X,Q){return this.s(N,se,le=>le.provideCallsTo(z,X,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(N,z,X,Q){return this.s(N,se,le=>le.provideCallsFrom(z,X,Q),void 0,Q)}$releaseCallHierarchy(N,z){this.s(N,se,X=>Promise.resolve(X.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(N,z,X){const Q=this.t(new ue(this.h,X),N);return this.e.$registerTypeHierarchyProvider(Q,this.o(z)),this.p(Q)}$prepareTypeHierarchy(N,z,X,Q){return this.s(N,ue,le=>Promise.resolve(le.prepareSession(a.URI.revive(z),X,Q)),void 0,Q)}$provideTypeHierarchySupertypes(N,z,X,Q){return this.s(N,ue,le=>le.provideSupertypes(z,X,Q),void 0,Q)}$provideTypeHierarchySubtypes(N,z,X,Q){return this.s(N,ue,le=>le.provideSubtypes(z,X,Q),void 0,Q)}$releaseTypeHierarchy(N,z){this.s(N,ue,X=>Promise.resolve(X.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(N,z,X){const Q=this.q();return this.f.set(Q,new ee(new de(this.e,this.h,X,Q),N)),this.e.$registerDocumentOnDropEditProvider(Q,this.o(z)),this.p(Q)}$provideDocumentOnDropEdits(N,z,X,Q,le,be){return this.s(N,de,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(z,a.URI.revive(X),Q,le,be)),void 0,void 0)}registerDocumentPasteEditProvider(N,z,X,Q){const le=this.q();return this.f.set(le,new ee(new O(this.e,this.h,X,le),N)),this.e.$registerPasteEditProvider(le,this.o(z),!!X.prepareDocumentPaste,Q.pasteMimeTypes),this.p(le)}$prepareDocumentPaste(N,z,X,Q,le){return this.s(N,O,be=>be.prepareDocumentPaste(a.URI.revive(z),X,Q,le),void 0,le)}$providePasteEdits(N,z,X,Q,le,be){return this.s(N,O,Te=>Te.providePasteEdits(z,a.URI.revive(X),Q,le,be),void 0,be)}static w(N){return{pattern:N.source,flags:(0,S.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:oe.w(N.decreaseIndentPattern),increaseIndentPattern:oe.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?oe.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?oe.w(N.unIndentedLinePattern):void 0}}static B(N){return{beforeText:oe.w(N.beforeText),afterText:N.afterText?oe.w(N.afterText):void 0,previousLineText:N.previousLineText?oe.w(N.previousLineText):void 0,action:N.action}}static C(N){return N.map(oe.B)}setLanguageConfiguration(N,z,X){const{wordPattern:Q}=X;if(Q&&(0,S.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(z,Q):this.h.setWordDefinitionFor(z,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const le=this.q(),be={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?oe.w(X.wordPattern):void 0,indentationRules:X.indentationRules?oe.y(X.indentationRules):void 0,onEnterRules:X.onEnterRules?oe.C(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this.e.$setLanguageConfiguration(le,z,be),this.p(le)}$setWordDefinitions(N){for(const z of N)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.ExtHostLanguageFeatures=oe,oe.d=0}),define(Se[256],ye([1,0,5,14,7,42,18,6]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,P,E,y){this.c=P,this.d=E,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=R.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this.b=R}async getLanguages(){return this.b.slice(0)}async changeLanguage(R,P){await this.a.$changeLanguage(R,P);const E=this.c.getDocumentData(R);if(!E)throw new Error(`document '${R.toString()}' NOT found`);return E.document}async tokenAtPosition(R,P){const E=R.version,y=t.Position.from(P),v=await this.a.$tokensAtPosition(R.uri,y),d={type:I.StandardTokenType.Other,range:R.getWordRangeAtPosition(P)??new I.Range(P.line,P.character,P.line,P.character)};if(!v)return d;const g={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!g.range.contains(P)||E!==R.version?d:g}createLanguageStatusItem(R,P,E){const y=this.f++,v=this.a,d=this.g,g=`${R.identifier.value}/${P}`;if(d.has(g))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);d.add(g);const f={selector:E,id:P,name:R.displayName??R.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let w;const m=new T.DisposableStore,h=()=>{w?.dispose(),w=(0,D.disposableTimeout)(()=>{m.clear(),this.a.$setLanguageStatus(y,{id:g,name:f.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===I.LanguageStatusSeverity.Error?A.default.Error:f.severity===I.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:f.command&&this.d.toInternal(f.command,m),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},b={dispose(){m.dispose(),w?.dispose(),v.$removeLanguageStatus(y),d.delete(g)},get id(){return f.id},get name(){return f.name},set name(s){f.name=s,h()},get selector(){return f.selector},set selector(s){f.selector=s,h()},get text(){return f.text},set text(s){f.text=s,h()},get detail(){return f.detail},set detail(s){f.detail=s,h()},get severity(){return f.severity},set severity(s){f.severity=s,h()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(s){f.accessibilityInformation=s,h()},get command(){return f.command},set command(s){f.command=s,h()},get busy(){return f.busy},set busy(s){f.busy=s,h()}};return h(),b}}e.ExtHostLanguages=S}),define(Se[95],ye([1,0,12,8,2,3,13,5,25,16]),function(te,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(E,y,v){this.f=v,this.d=new Map,this.a=y.getProxy(T.MainContext.MainThreadLocalization),this.b=E.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(E,y){const{message:v,args:d,comment:g}=y;if(this.c)return(0,t.format2)(v,d??{});let f=v;g&&g.length>0&&(f+=`/${Array.isArray(g)?g.join():g}`);const w=this.d.get(E)?.contents[f];return w||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,t.format2)(w??v,d??{})}getBundle(E){return this.d.get(E)?.contents}getBundleUri(E){return this.d.get(E)?.uri}async initializeLocalizedMessages(E){if(this.c||!E.l10n&&!E.isBuiltin||this.d.has(E.identifier.value))return;let y;const v=await this.g(E);if(!v){this.f.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(v),g=JSON.parse(d);y=E.isBuiltin?g.contents?.bundle:g}catch(d){this.f.error(`Failed to load translations for ${E.identifier.value} from ${v}: ${d.message}`);return}y&&this.d.set(E.identifier.value,{contents:y,uri:v})}async g(E){if(E.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(E.identifier.value);return I.URI.revive(y)}return E.l10n?I.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.b}.json`):void 0}};R=Ve([ze(0,S.IExtHostInitDataService),ze(1,C.IExtHostRpcService),ze(2,D.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Se[139],ye([1,0,13,5,25,16,2,4,11]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends a.AbstractLoggerService{constructor(E,y){super(y.logLevel,T.Event.None),this.g=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,y){y?this.setLevel(D.URI.revive(y),E):(0,S.isUndefined)(E)||this.setLevel(E)}f(E,y,v){return new R(this.g,E,y,v)}};C=Ve([ze(0,A.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class R extends a.AbstractMessageLogger{constructor(E,y,v,d){super(d?.always),this.l=E,this.m=y,this.j=!1,this.k=[],this.setLevel(v),this.l.$createLogger(y,d).then(()=>{this.p(this.k),this.j=!0})}f(E,y){const v=[[E,y]];this.j?this.p(v):this.k.push(...v)}p(E){this.l.$log(this.m,E)}}}),define(Se[257],ye([1,0,5,13,26]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(T){return T&&T.title}let D=class{constructor(S,C){this.b=C,this.a=S.getProxy(a.MainContext.MainThreadMessageService)}showMessage(S,C,R,P,E){const y={source:{identifier:S.identifier,label:S.displayName||S.name}};let v;typeof P=="string"||A(P)?v=[P,...E]:(y.modal=P?.modal,y.useCustom=P?.useCustom,y.detail=P?.detail,v=E),y.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let g=0;g<v.length;g++){const f=v[g];if(typeof f=="string")d.push({title:f,handle:g,isCloseAffordance:!1});else if(typeof f=="object"){const{title:w,isCloseAffordance:m}=f;d.push({title:w,isCloseAffordance:!!m,handle:g})}else this.b.warn("Invalid message item:",f)}return this.a.$showMessage(C,R,y,d).then(g=>{if(typeof g=="number")return v[g]})}};D=Ve([ze(1,t.ILogService)],D),e.ExtHostMessageService=D}),define(Se[258],ye([1,0,22,4,6,28,8,11,2,67,5,39,14,7,57,233,135]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,h,b,s){this.q=b,this.r=s,this.f=new Map,this.g=new A.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=m.getProxy(R.MainContext.MainThreadNotebook),this.c=m.getProxy(R.MainContext.MainThreadNotebookDocuments),this.d=m.getProxy(R.MainContext.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===13){const c=i.notebookEditor?.notebookUri,u=i.cell.handle,o=this.g.get(c)?.getCell(u);if(o)return o.apiCell}if(i&&i.$mid===14){const c=i.uri,u=this.g.get(c);if(u)return u.apiNotebook}return i}}),f.x(h)}getEditorById(m){const h=this.h.get(m);if(!h)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(m){for(const[h,b]of this.h)if(b.apiEditor===m)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,h){const b=this.g.get(m);if(!b&&!h)throw new Error(`NO notebook document for '${m}'`);return b}static s(m,h){if(!h)return;const b=h.filenamePattern.map(s=>E.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(h.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:h.displayName,filenamePattern:b,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,h,b){const s=f.a++,i=typeof b.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(s,b),this.b.$registerNotebookCellStatusBarItemProvider(s,i,h);let c;return i!==void 0&&(c=b.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(i))),new y.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,i),c?.dispose()})}async createNotebookDocument(m){const h=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&E.NotebookData.from(m.content)});return S.URI.revive(h)}async openNotebookDocument(m){const h=this.g.get(m);if(h)return h.apiNotebook;const b=await this.c.$tryOpenNotebook(m),s=this.g.get(S.URI.revive(b));return(0,T.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(m,h){S.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let b;typeof h=="object"?b={position:E.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(E.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:b={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,b),i=s&&this.h.get(s)?.apiEditor;if(i)return i;throw s?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,h,b,s){const i=this.f.get(m),c=S.URI.revive(h),u=this.g.get(c);if(!u||!i)return;const r=u.getCellFromIndex(b);if(!r)return;const o=await i.provideCellStatusBarItems(r.apiCell,s);if(!o)return;const n=new I.DisposableStore,l=this.p.add([n]),k=(Array.isArray(o)?o:[o]).map(L=>E.NotebookStatusBarItem.from(L,this.i,n));return{cacheId:l,items:k}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,h,b,s,i){if((0,D.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const c=this.t++;return this.u.set(c,b),this.b.$registerNotebookSerializer(c,{id:m.identifier,location:m.extensionLocation},h,E.NotebookDocumentContentOptions.from(s),f.s(m,i)),(0,I.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(c)})}async $dataToNotebook(m,h,b){const s=this.u.get(m);if(!s)throw new Error("NO serializer found");const i=await s.deserializeNotebook(h.buffer,b);return new v.SerializableObjectWithBuffers(E.NotebookData.from(i))}async $notebookToData(m,h,b){const s=this.u.get(m);if(!s)throw new Error("NO serializer found");const i=await s.serializeNotebook(E.NotebookData.to(h.value),b);return a.VSBuffer.wrap(i)}w(m,h,b){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const s=new g.ExtHostNotebookEditor(h,this.d,m,b.visibleRanges.map(E.NotebookRange.to),b.selections.map(E.NotebookRange.to),typeof b.viewColumn=="number"?E.ViewColumn.to(b.viewColumn):void 0);this.h.set(h,s)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const b of m.value.removedDocuments){const s=S.URI.revive(b),i=this.g.get(s);i&&(i.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(c=>c.document.uri)}),this.n.fire(i.apiNotebook));for(const c of this.h.values())c.notebookData.uri.toString()===s.toString()&&this.h.delete(c.id)}if(m.value.addedDocuments){const b=[];for(const s of m.value.addedDocuments){const i=S.URI.revive(s.uri);if(this.g.has(i))throw new Error(`adding EXISTING notebook ${i} `);const c=new d.ExtHostNotebookDocument(this.c,this.q,this.r,i,s);b.push(...s.cells.map(u=>d.ExtHostCell.asModelAddData(c.apiNotebook,u))),this.g.get(i)?.dispose(),this.g.set(i,c),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(c.apiNotebook)}}if(m.value.addedEditors)for(const b of m.value.addedEditors){if(this.h.has(b.id))return;const s=S.URI.revive(b.documentUri),i=this.g.get(s);i&&this.w(i,b.id,b)}const h=[];if(m.value.removedEditors)for(const b of m.value.removedEditors){const s=this.h.get(b);s&&(this.h.delete(b),this.k?.id===s.id&&(this.k=void 0),h.push(s))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const b=new Set;this.l.forEach(s=>b.add(s.id));for(const s of this.h.values()){const i=b.has(s.id);s._acceptVisibility(i)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(m){const h=P.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new P.ApiCommandArgument("data","Bytes to convert to data",i=>i instanceof Uint8Array,i=>a.VSBuffer.wrap(i))],new P.ApiCommandResult("Notebook Data",i=>E.NotebookData.to(i.value))),s=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",i=>!0,i=>new v.SerializableObjectWithBuffers(E.NotebookData.from(i)))],new P.ApiCommandResult("Bytes",i=>i.buffer));m.registerApiCommand(b),m.registerApiCommand(s)}}e.ExtHostNotebookController=f,f.a=0}),define(Se[259],ye([1,0,17,18,21,4,6,28,2,27,13,67,5,39,14,7,92,220,26,57]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let h=class{constructor(r,o,n,l,p){this.k=o,this.l=n,this.m=l,this.n=p,this.b=new T.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=r.getProxy(E.MainContext.MainThreadNotebookKernels);const k=new y.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new y.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const U=this.l.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:U}}else if(L&&"notebookEditor"in L){const U=this.l.getIdByEditor(L.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return L})],y.ApiCommandResult.Void);this.m.registerApiCommand(k)}createNotebookController(r,o,n,l,p,k){for(const ae of this.h.values())if(ae.controller.id===o&&C.ExtensionIdentifier.equals(r.identifier,ae.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const L=this.i++,U=this;this.n.trace(`NotebookController[${L}], CREATED by ${r.identifier.value}, ${o}`);const K=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${r.identifier}'`);let G=!1;const O=new D.DisposableStore,B=new A.Emitter,F=new A.Emitter,$={id:c(r.identifier,o),notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:l||r.identifier.value,preloads:k?k.map(v.NotebookRendererScript.from):[]};let M=p??K,V;this.a.$addKernel(L,$).catch(ae=>{console.log(ae),G=!0});let q=0;const H=()=>{if(G)return;const ae=++q;Promise.resolve().then(()=>{ae===q&&this.a.$updateKernel(L,$)})},J=new T.ResourceMap,Y={get id(){return o},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return $.label},set label(ae){$.label=ae??r.displayName??r.name,H()},get detail(){return $.detail??""},set detail(ae){$.detail=ae,H()},get description(){return $.description??""},set description(ae){$.description=ae,H()},get kind(){return(0,w.checkProposedApiEnabled)(r,"notebookControllerKind"),$.kind??""},set kind(ae){(0,w.checkProposedApiEnabled)(r,"notebookControllerKind"),$.kind=ae,H()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(ae){$.supportedLanguages=ae,H()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){$.supportsExecutionOrder=ae,H()},get rendererScripts(){return $.preloads?$.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(ae){M=ae??K},get interruptHandler(){return V},set interruptHandler(ae){V=ae,$.supportsInterrupt=Boolean(ae),H()},createNotebookCellExecution(ae){if(G)throw new Error("notebook controller is DISPOSED");if(!J.has(ae.notebook.uri))throw U.n.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(J.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return U._createNotebookCellExecution(ae,c(r.identifier,this.id))},dispose:()=>{G||(this.n.trace(`NotebookController[${L}], DISPOSED`),G=!0,this.h.delete(L),O.dispose(),B.dispose(),F.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(ae,re){re===d.NotebookControllerAffinity2.Hidden&&(0,w.checkProposedApiEnabled)(r,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(L,ae.uri,re)},onDidReceiveMessage:F.event,postMessage(ae,re){return(0,w.checkProposedApiEnabled)(r,"notebookMessaging"),U.a.$postMessage(L,re&&U.l.getIdByEditor(re),ae)},asWebviewUri(ae){return(0,w.checkProposedApiEnabled)(r,"notebookMessaging"),(0,g.asWebviewUri)(ae,U.k.remote)}};return this.h.set(L,{extensionId:r.identifier,controller:Y,onDidReceiveMessage:F,onDidChangeSelection:B,associatedNotebooks:J}),Y}getIdByController(r){for(const[o,n]of this.h)if(n.controller===r)return c(n.extensionId,r.id);return null}createNotebookControllerDetectionTask(r,o){const n=this.d++,l=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${r.identifier.value}`),this.a.$addKernelDetectionTask(n,o);const p={dispose:()=>{this.c.delete(n),l.a.$removeKernelDetectionTask(n)}};return this.c.set(n,p),p}registerKernelSourceActionProvider(r,o,n){const l=this.f++,p=this;return this.e.set(l,n),this.n.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${r.identifier.value}`),this.a.$addKernelSourceActionProvider(l,o),{dispose:()=>{this.e.delete(l),p.a.$removeKernelSourceActionProvider(l)}}}async $provideKernelSourceActions(r,o){const n=this.e.get(r);if(n){const l=new D.DisposableStore;return this.g.add([l]),(await n.provideNotebookKernelSourceActions(o)??[]).map(k=>v.NotebookKernelSourceAction.from(k,this.m.converter,l))}return[]}$acceptNotebookAssociation(r,o,n){const l=this.h.get(r);if(l){const p=this.l.getNotebookDocument(S.URI.revive(o));n?l.associatedNotebooks.set(p.uri,!0):l.associatedNotebooks.delete(p.uri),this.n.trace(`NotebookController[${r}] ASSOCIATE notebook`,p.uri.toString(),n),l.onDidChangeSelection.fire({selected:n,notebook:p.apiNotebook})}}async $executeCells(r,o,n){const l=this.h.get(r);if(!l)return;const p=this.l.getNotebookDocument(S.URI.revive(o)),k=[];for(const L of n){const U=p.getCell(L);U&&k.push(U.apiCell)}try{this.n.trace(`NotebookController[${r}] EXECUTE cells`,p.uri.toString(),k.length),await l.controller.executeHandler.call(l.controller,k,p.apiNotebook,l.controller)}catch(L){this.n.error(`NotebookController[${r}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(r,o,n){const l=this.h.get(r);if(!l)return;const p=this.l.getNotebookDocument(S.URI.revive(o));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,p.apiNotebook);else for(const k of n){const L=p.getCell(k);L&&this.b.get(L.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,o,n){const l=this.h.get(r);if(!l)return;const p=this.l.getEditorById(o);l.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:n}))}$cellExecutionChanged(r,o,n){const p=this.l.getNotebookDocument(S.URI.revive(r)).getCell(o);if(p){const k=n?v.NotebookCellExecutionState.to(n):d.NotebookCellExecutionState.Idle;k!==void 0&&this.j.fire({cell:p.apiCell,state:k})}}_createNotebookCellExecution(r,o){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.l.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const p=new s(o,l,this.a);this.b.set(l.uri,p);const k=p.onDidChangeState(()=>{p.state===b.Resolved&&(p.dispose(),k.dispose(),this.b.delete(l.uri))});return p.asApiObject()}};h=Ve([ze(4,R.ILogService)],h),e.ExtHostNotebookKernels=h;var b;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(b||(b={}));class s extends D.Disposable{get state(){return this.f}constructor(r,o,n){super(),this.j=o,this.k=n,this.b=s.a++,this.c=new A.Emitter,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new I.CancellationTokenSource),this.h=new i(10,l=>this.m(l)),this.i=o.internalMetadata.executionOrder,this.k.$createExecution(this.b,r,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(r){await this.h.addItem(r)}async m(r){const o=Array.isArray(r)?r:[r];return this.k.$updateExecution(this.b,new m.SerializableObjectWithBuffers(o))}n(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(r){let o=this.j;if(r&&(o=this.j.notebook.getCellFromApiCell(r)),!o)throw new Error("INVALID cell");return o.handle}s(r){return r.map(o=>{const n=d.NotebookCellOutput.ensureUniqueMimeTypes(o.items,!0);return n===o.items?v.NotebookCellOutput.from(o):v.NotebookCellOutput.from({items:n,id:o.id,metadata:o.metadata})})}async t(r,o,n){const l=this.r(o),p=this.s((0,a.asArray)(r));return this.l({editType:f.CellExecutionUpdateType.Output,cellHandle:l,append:n,outputs:p})}async w(r,o,n){return r=d.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(r),!0),this.l({editType:f.CellExecutionUpdateType.OutputItems,items:r.map(v.NotebookCellOutputItem.from),outputId:o.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r.g.token},get cell(){return r.j.apiCell},get executionOrder(){return r.i},set executionOrder(n){r.i=n,r.m([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:r.i}])},start(n){if(r.f===b.Resolved||r.f===b.Started)throw new Error("Cannot call start again");r.f=b.Started,r.c.fire(),r.m({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,l){if(r.f===b.Resolved)throw new Error("Cannot call resolve twice");r.f=b.Resolved,r.c.fire(),r.h.flush(),r.k.$completeExecution(r.b,new m.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:n}))},clearOutput(n){return r.n(),r.t([],n,!1)},appendOutput(n,l){return r.n(),r.t(n,l,!0)},replaceOutput(n,l){return r.n(),r.t(n,l,!1)},appendOutputItems(n,l){return r.n(),r.w(n,l,!0)},replaceOutputItems(n,l){return r.n(),r.w(n,l,!1)}})}}s.a=0;class i{constructor(r,o){this.d=r,this.e=o,this.a=[],this.b=Date.now()}addItem(r){return this.a.push(r),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const r=this.c;this.c=void 0;const o=this.a;return this.a=[],this.e(o).finally(()=>r.complete())}}function c(u,r){return`${u.value}/${r}`}e.createKernelId=c}),define(Se[260],ye([1,0,4,5,135]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(T,S){this.c=S,this.a=new Map,this.b=T.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,C){const R=this.c.getEditorById(T);this.a.get(S)?.fire({editor:R.apiEditor,message:C})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(R=>R.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(R,P,E)=>this.d(S).event(R,P,E),postMessage:(R,P)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,P]=[P,R]);const E=P&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(E?.id,S,R)}}}d(T){let S=this.a.get(T);return S||(S=new a.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(T)}}),this.a.set(T,S),S)}}e.ExtHostNotebookRenderers=A}),define(Se[261],ye([1,0,6,2,26,5]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class D{constructor(S){this.b=new Map,this.a=S.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,C,R){if((0,I.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,R),this.a.$registerProfileContentHandler(C,R.name,S.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(S,C,R,P){const E=this.b.get(S);if(!E)throw new Error(`Unknown handler with id: ${S}`);return E.saveProfile(C,R,P)}async $readProfile(S,C,R){const P=this.b.get(S);if(!P)throw new Error(`Unknown handler with id: ${S}`);return P.readProfile(t.URI.revive(C),R)}}e.ExtHostProfileContentHandlers=D}),define(Se[262],ye([1,0,21,4,6,5,2,7,10,17,42,89]),function(te,e,a,t,I,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(y,v,d){const g=y.getProxy(A.MainContext.MainThreadQuickOpen);class f{constructor(r,o){this.e=new Map,this.f=0,this.a=r,this.b=o}showQuickPick(r,o,n=a.CancellationToken.None){this.c=void 0;const l=Promise.resolve(r),p=++this.f,k=g.$show(p,{title:o?.title,placeHolder:o?.placeHolder,matchOnDescription:o?.matchOnDescription,matchOnDetail:o?.matchOnDetail,ignoreFocusLost:o?.ignoreFocusOut,canPickMany:o?.canPickMany},n),L={},U=k.then(()=>L);return Promise.race([U,l]).then(K=>{if(K!==L)return l.then(G=>{const O=[];for(let B=0;B<G.length;B++){const F=G[B];typeof F=="string"?O.push({label:F,handle:B}):F.kind===T.QuickPickItemKind.Separator?O.push({type:"separator",label:F.label}):O.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:B})}return o&&typeof o.onDidSelectItem=="function"&&(this.c=B=>{o.onDidSelectItem(G[B])}),g.$setItems(p,O),k.then(B=>{if(typeof B=="number")return G[B];if(Array.isArray(B))return B.map(F=>G[F])})})}).then(void 0,K=>{if(!(0,S.isCancellationError)(K))return g.$setError(p,K),Promise.reject(K)})}$onItemSelected(r){this.c?.(r)}showInput(r,o=a.CancellationToken.None){return this.d=r?.validateInput,g.$input(r,typeof this.d=="function",o).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(r){if(!this.d)return;const o=await this.d(r);if(!o||typeof o=="string")return o;let n;switch(o.severity){case T.InputBoxValidationSeverity.Info:n=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:n=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:n=R.default.Error;break;default:n=o.message?R.default.Error:R.default.Ignore;break}return{content:o.message,severity:n}}async showWorkspaceFolderPick(r,o=a.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!n)return;const l=await this.a.getWorkspaceFolders2();if(!!l)return l.find(p=>p.uri.toString()===n.uri.toString())}createQuickPick(r){const o=new i(r,()=>this.e.delete(o._id));return this.e.set(o._id,o),o}createInputBox(r){const o=new c(r,()=>this.e.delete(o._id));return this.e.set(o._id,o),o}$onDidChangeValue(r,o){this.e.get(r)?._fireDidChangeValue(o)}$onDidAccept(r){this.e.get(r)?._fireDidAccept()}$onDidChangeActive(r,o){const n=this.e.get(r);n instanceof i&&n._fireDidChangeActive(o)}$onDidChangeSelection(r,o){const n=this.e.get(r);n instanceof i&&n._fireDidChangeSelection(o)}$onDidTriggerButton(r,o){this.e.get(r)?._fireDidTriggerButton(o)}$onDidTriggerItemButton(r,o,n){const l=this.e.get(r);l instanceof i&&l._fireDidTriggerItemButton(o,n)}$onDidHide(r){this.e.get(r)?._fireDidHide()}}class w{constructor(r,o){this.x=r,this.y=o,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(r){this.b=r,this.A({title:r})}get step(){return this.c}set step(r){this.c=r,this.A({step:r})}get totalSteps(){return this.d}set totalSteps(r){this.d=r,this.A({totalSteps:r})}get enabled(){return this.g}set enabled(r){this.g=r,this.A({enabled:r})}get busy(){return this.j}set busy(r){this.j=r,this.A({busy:r})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(r){this.k=r,this.A({ignoreFocusOut:r})}get value(){return this.l}set value(r){this.l=r,this.A({value:r})}get placeholder(){return this.m}set placeholder(r){this.m=r,this.A({placeholder:r})}get buttons(){return this.n}set buttons(r){this.n=r.slice(),this.o.clear(),r.forEach((o,n)=>{const l=o===T.QuickInputButtons.Back?-1:n;this.o.set(l,o)}),this.A({buttons:r.map((o,n)=>({...s(o),tooltip:o.tooltip,handle:o===T.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.A({visible:!0})}hide(){this.e=!1,this.A({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(r){this.l=r,this.q.fire(r)}_fireDidTriggerButton(r){const o=this.o.get(r);o&&this.r.fire(o)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),g.$dispose(this._id))}A(r){if(!this.v){for(const o of Object.keys(r)){const n=r[o];this.u[o]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.B()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.B()},0))}}B(){g.$createOrUpdate(this.u),this.u={id:this._id}}}w.a=1;function m(u){if(u instanceof T.ThemeIcon)return{id:u.id};const r=b(u),o=h(u);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof o=="string"?D.URI.file(o):o}}function h(u){return typeof u=="object"&&"light"in u?u.light:u}function b(u){return typeof u=="object"&&"dark"in u?u.dark:u}function s(u){const r=m(u.iconPath);let o,n;return"id"in r?n=P.ThemeIcon.asClassName(r):o=r,{iconPath:o,iconClass:n}}class i extends w{constructor(r,o){super(r.identifier,o),this.C=[],this.D=new Map,this.E=new Map,this.F=!1,this.G=!0,this.H=!0,this.I=!0,this.J=!1,this.K=[],this.L=new t.Emitter,this.M=[],this.N=new t.Emitter,this.O=new t.Emitter,this.onDidChangeActive=this.L.event,this.onDidChangeSelection=this.N.event,this.onDidTriggerItemButton=this.O.event,this.w.push(this.L,this.N,this.O),this.A({type:"quickPick"})}get items(){return this.C}set items(r){this.C=r.slice(),this.D.clear(),this.E.clear(),r.forEach((n,l)=>{this.D.set(l,n),this.E.set(n,l)});const o=[];for(let n=0;n<r.length;n++){const l=r[n];l.kind===T.QuickPickItemKind.Separator?o.push({type:"separator",label:l.label}):o.push({handle:n,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((p,k)=>({...s(p),tooltip:p.tooltip,handle:k}))})}this.A({items:o})}get canSelectMany(){return this.F}set canSelectMany(r){this.F=r,this.A({canSelectMany:r})}get matchOnDescription(){return this.G}set matchOnDescription(r){this.G=r,this.A({matchOnDescription:r})}get matchOnDetail(){return this.H}set matchOnDetail(r){this.H=r,this.A({matchOnDetail:r})}get sortByLabel(){return this.I}set sortByLabel(r){this.I=r,this.A({sortByLabel:r})}get keepScrollPosition(){return this.J}set keepScrollPosition(r){this.J=r,this.A({keepScrollPosition:r})}get activeItems(){return this.K}set activeItems(r){this.K=r.filter(o=>this.E.has(o)),this.A({activeItems:this.K.map(o=>this.E.get(o))})}get selectedItems(){return this.M}set selectedItems(r){this.M=r.filter(o=>this.E.has(o)),this.A({selectedItems:this.M.map(o=>this.E.get(o))})}_fireDidChangeActive(r){const o=(0,C.coalesce)(r.map(n=>this.D.get(n)));this.K=o,this.L.fire(o)}_fireDidChangeSelection(r){const o=(0,C.coalesce)(r.map(n=>this.D.get(n)));this.M=o,this.N.fire(o)}_fireDidTriggerItemButton(r,o){const n=this.D.get(r);if(!n||!n.buttons||!n.buttons.length)return;const l=n.buttons[o];l&&this.O.fire({button:l,item:n})}}class c extends w{constructor(r,o){super(r.identifier,o),this.C=!1,this.A({type:"inputBox"})}get password(){return this.C}set password(r){this.C=r,this.A({password:r})}get prompt(){return this.D}set prompt(r){this.D=r,this.A({prompt:r})}get valueSelection(){return this.E}set valueSelection(r){this.E=r,this.A({valueSelection:r})}get validationMessage(){return this.F}set validationMessage(r){this.F=r,r?typeof r=="string"?this.A({validationMessage:r,severity:R.default.Error}):this.A({validationMessage:r.message,severity:r.severity??R.default.Error}):this.A({validationMessage:void 0,severity:R.default.Ignore})}}return new f(v,d)}e.createExtHostQuickOpen=E});var Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a};define(Se[263],ye([1,0,2,4,60,6,18,5,17,108,13,27,89,14,26]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v){"use strict";var d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(l){if(l)return typeof l.iconPath=="string"?a.URI.file(l.iconPath):a.URI.isUri(l.iconPath)||E.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function w(l,p){if(!l.iconPath&&!p.iconPath)return 0;if(l.iconPath){if(!p.iconPath)return 1}else return-1;const k=typeof l.iconPath=="string"?l.iconPath:a.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,L=typeof p.iconPath=="string"?p.iconPath:a.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,C.comparePaths)(k,L)}function m(l,p){let k=0;if(l.strikeThrough!==p.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==p.faded)return l.faded?1:-1;if(l.tooltip!==p.tooltip)return(l.tooltip||"").localeCompare(p.tooltip||"");if(k=w(l,p),k!==0)return k;if(l.light&&p.light)k=w(l.light,p.light);else{if(l.light)return 1;if(p.light)return-1}if(k!==0)return k;if(l.dark&&p.dark)k=w(l.dark,p.dark);else{if(l.dark)return 1;if(p.dark)return-1}return k}function h(l,p){if(l.command!==p.command)return l.command<p.command?-1:1;if(l.title!==p.title)return l.title<p.title?-1:1;if(l.tooltip!==p.tooltip){if(l.tooltip!==void 0&&p.tooltip!==void 0)return l.tooltip<p.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(l.arguments===p.arguments)return 0;if(l.arguments)if(p.arguments){if(l.arguments.length!==p.arguments.length)return l.arguments.length-p.arguments.length}else return 1;else return-1;for(let k=0;k<l.arguments.length;k++){const L=l.arguments[k],U=p.arguments[k];if(L!==U)return L<U?-1:1}return 0}function b(l,p){let k=(0,C.comparePaths)(l.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(k!==0)return k;if(l.command&&p.command)k=h(l.command,p.command);else{if(l.command)return 1;if(p.command)return-1}if(k!==0)return k;if(l.decorations&&p.decorations)k=m(l.decorations,p.decorations);else{if(l.decorations)return 1;if(p.decorations)return-1}return k}function s(l,p){for(let k=0;k<l.length;k++)if(l[k]!==p[k])return!1;return!0}function i(l,p){return l.command===p.command&&l.title===p.title&&l.tooltip===p.tooltip&&(l.arguments&&p.arguments?s(l.arguments,p.arguments):l.arguments===p.arguments)}function c(l,p){return(0,S.equals)(l,p,i)}class u{get value(){return this.d}set value(p){p=p??"",Me(this,d,"f").$setInputBoxValue(this.l,p),this.m(p)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(p){Me(this,d,"f").$setInputBoxPlaceholder(this.l,p),this.f=p}get validateInput(){return(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(p){if((0,v.checkProposedApiEnabled)(this.k,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=p,Me(this,d,"f").$setValidationProviderIsEnabled(this.l,!!p)}get enabled(){return this.h}set enabled(p){p=!!p,this.h!==p&&(this.h=p,Me(this,d,"f").$setInputBoxEnablement(this.l,p))}get visible(){return this.j}set visible(p){p=!!p,this.j!==p&&(this.j=p,Me(this,d,"f").$setInputBoxVisibility(this.l,p))}constructor(p,k,L){this.k=p,this.l=L,d.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,k,"f")}showValidationMessage(p,k){(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),Me(this,d,"f").$showValidationMessage(this.l,p,k)}$onInputBoxValueChange(p){this.m(p)}m(p){this.d=p,this.e.fire(p)}}e.ExtHostSCMInputBox=u,d=new WeakMap;class r{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(p){this.v=p,this.q.$updateGroupLabel(this.t,this.handle,p)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(p){this.p=p,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(p){this.f=[...p],this.k.fire()}constructor(p,k,L,U,K){this.q=p,this.s=k,this.t=L,this.u=U,this.v=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=r.d++}getResourceState(p){return this.g.get(p)}$executeResourceCommand(p,k){const L=this.h.get(p);return L?(0,D.asPromise)(()=>this.s.executeCommand(L.command,...L.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this.f].sort(b),L=(0,S.sortedDiff)(this.o,p,b).map(G=>{const O=G.toInsert.map(B=>{const F=this.e++;this.g.set(F,B);const $=B.resourceUri;let M;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const pe=new A.DisposableStore;M=this.s.converter.toInternal(B.command,pe),this.j.set(F,pe)}else this.h.set(F,B.command);const V=f(B.decorations),q=B.decorations&&f(B.decorations.light)||V,H=B.decorations&&f(B.decorations.dark)||V,J=[q,H],Y=B.decorations&&B.decorations.tooltip||"",ae=B.decorations&&!!B.decorations.strikeThrough,re=B.decorations&&!!B.decorations.faded,fe=B.contextValue||"";return{rawResource:[F,$,J,Y,ae,re,fe,M],handle:F}});return{start:G.start,deleteCount:G.deleteCount,toInsert:O}}),U=L.map(({start:G,deleteCount:O,toInsert:B})=>[G,O,B.map(F=>F.rawResource)]),K=L.reverse();for(const{start:G,deleteCount:O,toInsert:B}of K){const F=B.map(M=>M.handle),$=this.n.splice(G,O,...F);for(const M of $)this.g.delete(M),this.h.delete(M),this.j.get(M)?.dispose(),this.j.delete(M)}return this.o=p,U}dispose(){this.l=!0,this.m.fire()}}r.d=0;class o{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(p){this.g!==p&&(this.g=p,Me(this,g,"f").$updateSourceControl(this.t,{count:p}))}get quickDiffProvider(){return this.h}set quickDiffProvider(p){this.h=p,Me(this,g,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this.j}set commitTemplate(p){p!==this.j&&(this.j=p,Me(this,g,"f").$updateSourceControl(this.t,{commitTemplate:p}))}get acceptInputCommand(){return this.l}set acceptInputCommand(p){this.k.value=new A.DisposableStore,this.l=p;const k=this.v.converter.toInternal(p,this.k.value);Me(this,g,"f").$updateSourceControl(this.t,{acceptInputCommand:k})}get actionButton(){return(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(p){(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new A.DisposableStore,this.n=p;const k=p!==void 0?{command:this.v.converter.toInternal(p.command,this.m.value),secondaryCommands:p.secondaryCommands?.map(L=>L.map(U=>this.v.converter.toInternal(U,this.m.value))),description:p.description,enabled:p.enabled}:void 0;Me(this,g,"f").$updateSourceControl(this.t,{actionButton:k??null})}get statusBarCommands(){return this.p}set statusBarCommands(p){if(this.p&&p&&c(this.p,p))return;this.o.value=new A.DisposableStore,this.p=p;const k=(p||[]).map(L=>this.v.converter.toInternal(L,this.o.value));Me(this,g,"f").$updateSourceControl(this.t,{statusBarCommands:k})}get selected(){return this.q}constructor(p,k,L,U,K,G){this.u=p,this.v=L,this.w=U,this.x=K,this.y=G,g.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new A.MutableDisposable,this.l=void 0,this.m=new A.MutableDisposable,this.o=new A.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=o.d++,this.A=new Map,this.B=new Set,Je(this,g,k,"f"),this.f=new u(p,Me(this,g,"f"),this.t),Me(this,g,"f").$registerSourceControl(this.t,U,K,G)}createResourceGroup(p,k){const L=new r(Me(this,g,"f"),this.v,this.t,p,k),U=t.Event.once(L.onDidDispose)(()=>this.A.delete(L));return this.A.set(L,U),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const p=[],k=[];for(const[L,U]of this.A){U.dispose();const K=L.onDidUpdateResourceStates(()=>{this.B.add(L),this.eventuallyUpdateResourceStates()});t.Event.once(L.onDidDispose)(()=>{this.B.delete(L),K.dispose(),this.e.delete(L.handle),Me(this,g,"f").$unregisterGroup(this.t,L.handle)}),p.push([L.handle,L.id,L.label,L.features]);const G=L._takeResourceStateSnapshot();G.length>0&&k.push([L.handle,G]),this.e.set(L.handle,L)}Me(this,g,"f").$registerGroups(this.t,p,k),this.A.clear()}eventuallyUpdateResourceStates(){const p=[];this.B.forEach(k=>{const L=k._takeResourceStateSnapshot();L.length!==0&&p.push([k.handle,L])}),p.length>0&&Me(this,g,"f").$spliceResourceStates(this.t,p),this.B.clear()}getResourceGroup(p){return this.e.get(p)}setSelectionState(p){this.q=p,this.s.fire(p)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(p=>p.dispose()),Me(this,g,"f").$unregisterSourceControl(this.t)}}g=new WeakMap,o.d=0,Ve([(0,I.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Ve([(0,I.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let n=class ni{get onDidChangeActiveProvider(){return this.j.event}constructor(p,k,L){this.l=k,this.m=L,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=p.getProxy(T.MainContext.MainThreadSCM),this.f=p.getProxy(T.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const K=this.g.get(U.sourceControlHandle);if(!K)return U;const G=K.getResourceGroup(U.groupHandle);return G?G.getResourceState(U.handle):U}else if(U&&U.$mid===4){const K=this.g.get(U.sourceControlHandle);return K?K.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const K=this.g.get(U.handle);return K||U}return U}})}createSourceControl(p,k,L,U){this.m.trace("ExtHostSCM#createSourceControl",p.identifier.value,k,L,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const K=ni.d++,G=new o(p,this.e,this.l,k,L,U);this.g.set(K,G);const O=this.h.get(P.ExtensionIdentifier.toKey(p.identifier))||[];return O.push(G),this.h.set(P.ExtensionIdentifier.toKey(p.identifier),O),G}getLastInputBox(p){this.m.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const k=this.h.get(P.ExtensionIdentifier.toKey(p.identifier)),L=k&&k[k.length-1];return L&&L.inputBox}$provideOriginalResource(p,k,L){const U=a.URI.revive(k);this.m.trace("ExtHostSCM#$provideOriginalResource",p,U.toString());const K=this.g.get(p);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>K.quickDiffProvider.provideOriginalResource(U,L)).then(G=>G||null)}$onInputBoxValueChange(p,k){this.m.trace("ExtHostSCM#$onInputBoxValueChange",p);const L=this.g.get(p);return L&&L.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(p,k,L,U){this.m.trace("ExtHostSCM#$executeResourceCommand",p,k,L);const K=this.g.get(p);if(!K)return Promise.resolve(void 0);const G=K.getResourceGroup(k);return G?G.$executeResourceCommand(L,U):Promise.resolve(void 0)}$validateInput(p,k,L){this.m.trace("ExtHostSCM#$validateInput",p);const U=this.g.get(p);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>U.inputBox.validateInput(k,L)).then(K=>{if(!K)return Promise.resolve(void 0);const G=y.MarkdownString.fromStrict(K.message);return G?Promise.resolve([G,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this.g.get(p)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=p,Promise.resolve(void 0)}};n.d=0,n=Ve([ze(2,R.ILogService)],n),e.ExtHostSCM=n}),define(Se[96],ye([1,0,5,4,3]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(T){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,S){return this.a.$getPassword(T,S)}store(T,S,C){return this.a.$setPassword(T,S,C)}delete(T,S){return this.a.$deletePassword(T,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a},Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[264],ye([1,0,7,5,175,6,14,11]),function(te,e,a,t,I,A,D,T){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(v,d,g,f,w=a.StatusBarAlignment.Left,m){S.set(this,void 0),C.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new A.DisposableStore,Je(this,S,v,"f"),Je(this,C,d,"f"),this.c=R.a++,this.e=g,this.f=f,this.g=w,this.h=this.t(m)}t(v){if(!!(0,T.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(v){this.k=v,this.u()}set name(v){this.m=v,this.u()}set tooltip(v){this.l=v,this.u()}set color(v){this.n=v,this.u()}set backgroundColor(v){v&&!R.b.has(v.id)&&(v=void 0),this.o=v,this.u()}set command(v){this.q?.fromApi!==v&&(this.p.clear(),typeof v=="string"?this.q={fromApi:v,internal:Me(this,C,"f").toInternal({title:"",command:v},this.p)}:v?this.q={fromApi:v,internal:Me(this,C,"f").toInternal(v,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(v){this.s=v,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Me(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let d;this.m?d=this.m:d=(0,I.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=R.b.get(this.o.id));const f=D.MarkdownString.fromStrict(this.l);Me(this,S,"f").$setEntry(this.c,v,d,this.k,f,this.q?.internal,g,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=R,S=new WeakMap,C=new WeakMap,R.a=0,R.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const d={message:v};return this.b.unshift(d),this.c(),new a.Disposable(()=>{const g=this.b.indexOf(d);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class E{constructor(v,d){this.a=v.getProxy(t.MainContext.MainThreadStatusBar),this.b=d,this.c=new P(this)}createStatusBarEntry(v,d,g,f){return new R(this.a,this.b,v,d,g,f)}setStatusBarMessage(v,d){const g=this.c.setMessage(v);let f;return typeof d=="number"?f=setTimeout(()=>g.dispose(),d):typeof d<"u"&&d.then(()=>g.dispose(),()=>g.dispose()),new a.Disposable(()=>{g.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=E}),define(Se[97],ye([1,0,5,4,3]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(T,S){this.c=S,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this.a.$registerExtensionStorageKeysToSync(T,S)}async initializeExtensionStorage(T,S,C){const R=await this.a.$initializeExtensionStorage(T,S);let P;return R&&(P=this.d(T,S,R)),P||C}setValue(T,S,C){return this.a.$setValue(T,S,C)}$acceptValue(T,S,C){const R=this.d(T,S,C);R&&this.b.fire({shared:T,key:S,value:R})}d(T,S,C){try{return JSON.parse(C)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${T}): ${R}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(Se[71],ye([1,0,3,25,13,70,2]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let T=class{constructor(C,R,P){this.d=R,this.f=P,this.a=C.workspace??void 0,this.b=C.environment,this.whenReady=this.h().then(E=>this.c=E)}async g(C){return D.URI.joinPath(this.b.workspaceStorageHome,C)}async h(){if(!this.a)return Promise.resolve(void 0);const C=this.a.id,R=await this.g(C);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(D.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:D.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(C){if(this.c)return D.URI.joinPath(this.c,C.identifier.value)}globalValue(C){return D.URI.joinPath(this.b.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ve([ze(0,t.IExtHostInitDataService),ze(1,I.ILogService),ze(2,A.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(Se[40],ye([1,0,4,5,3,2,16,6,7,176,10,221,21,30,206,89,11,18,14]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class m{constructor(n,l,p,k){this.k=n,this._id=l,this.l=p,this.m=k,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(U=>this.f=U);const L=this;this.value={get name(){return L.m||""},get processId(){return L.b},get creationOptions(){return L.l},get exitStatus(){return L.h},get state(){return L.j},sendText(U,K=!0){L.o(),L.k.$sendText(L._id,U,K)},show(U){L.o(),L.k.$show(L._id,U)},hide(){L.o(),L.k.$hide(L._id)},dispose(){L.a||(L.a=!0,L.k.$dispose(L._id))},get dimensions(){if(!(L.d===void 0||L.g===void 0))return{columns:L.d,rows:L.g}}}}async create(n,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,g.withNullAsUndefined)(n.shellPath),shellArgs:(0,g.withNullAsUndefined)(n.shellArgs),cwd:(0,g.withNullAsUndefined)(n.cwd),env:(0,g.withNullAsUndefined)(n.env),icon:(0,g.withNullAsUndefined)(u(n.iconPath)),color:d.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,g.withNullAsUndefined)(n.message),strictEnv:(0,g.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this.n(n.location,l?.resolvedExtHostIdentifier),isTransient:(0,g.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,l,p,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:p,color:d.ThemeColor.isThemeColor(k)?k.id:void 0,location:this.n(n,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,l){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in n?{viewColumn:w.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,l){this.h=Object.freeze({code:n,reason:l})}setDimensions(n,l){return n===this.d&&l===this.g||n===0||l===0?!1:(this.d=n,this.g=l,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(l=>{l!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=m;class h{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${l}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,l){this.g.setDimensions?.({columns:n,rows:l})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(l=>this.a.fire(l)),this.g.onDidClose?.((l=void 0)=>{this.f.fire(l===void 0?void 0:l)}),this.g.onDidOverrideDimensions?.(l=>{l&&this.d.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this.g.onDidChangeName?.(l=>{this.d.fire({type:"title",value:l})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=h;let b=1,s=class extends T.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.J.event}constructor(n,l){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.C=new Map,this.D=new a.Emitter,this.onDidCloseTerminal=this.D.event,this.F=new a.Emitter,this.onDidOpenTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeActiveTerminal=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalDimensions=this.H.event,this.I=new a.Emitter,this.onDidChangeTerminalState=this.I.event,this.L=new a.Emitter,this.onDidChangeShell=this.L.event,this.a=l.getProxy(t.MainContext.MainThreadTerminalService),this.s=new v.TerminalDataBufferer(this.a.$sendProcessData),this.J=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[p,k]of this.g)k.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,l){const p=new m(this.a,(0,y.generateUuid)(),n,n.name),k=new h(n.pty);return p.createExtensionTerminal(n.location,this.M(n,l).resolvedExtHostIdentifier,u(n.iconPath),r(n.color)).then(L=>{const U=this.N(L,k);this.h[L]=U}),this.f.push(p),p.value}M(n,l){if(l=l||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const p=n.location.parentTerminal;if(p){const k=this.f.find(L=>L.value===p);k&&(l.resolvedExtHostIdentifier=k._id)}}else n.location&&typeof n.location!="object"?l.location=n.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(n,l){if(!this.P(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const k=new h(l),L=this.N(n,k);this.h[n]=L}async $acceptActiveTerminalChanged(n){const l=this.b;if(n===null){this.b=void 0,l!==this.b&&this.G.fire(this.b);return}const p=this.P(n);p&&(this.b=p,l!==this.b&&this.G.fire(this.b.value))}async $acceptTerminalProcessData(n,l){const p=this.P(n);p&&this.J.fire({terminal:p.value,data:l})}async $acceptTerminalDimensions(n,l,p){const k=this.P(n);k&&k.setDimensions(l,p)&&this.H.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptTerminalMaximumDimensions(n,l,p){this.g.get(n)?.resize(l,p)}async $acceptTerminalTitleChange(n,l){const p=this.P(n);p&&(p.name=l)}async $acceptTerminalClosed(n,l,p){const k=this.R(this.f,n);if(k!==null){const L=this.f.splice(k,1)[0];L.setExitStatus(l,p),this.D.fire(L.value)}}$acceptTerminalOpened(n,l,p,k){if(l){const K=this.R(this.f,l);if(K!==null){this.f[K]._id=n,this.F.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const L={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:A.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},U=new m(this.a,n,L,p);this.f.push(U),this.F.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(n,l){this.P(n)?._setProcessId(l)}async $startExtensionTerminal(n,l){const p=this.P(n);if(!p)return{message:(0,C.localize)(0,null,n)};p.isOpen||await new Promise(L=>{const U=this.onDidOpenTerminal(async K=>{K===p.value&&(U.dispose(),L())})});const k=this.g.get(n);k?k.startSendingEvents(l):this.j[n]={initialDimensions:l}}N(n,l){const p=new T.DisposableStore;p.add(l.onProcessReady(L=>this.a.$sendProcessReady(n,L.pid,L.cwd))),p.add(l.onDidChangeProperty(L=>this.a.$sendProcessProperty(n,L))),this.s.startBuffering(n,l.onProcessData),p.add(l.onProcessExit(L=>this.O(n,L))),this.g.set(n,l);const k=this.j[n];return k&&l instanceof h&&(l.startSendingEvents(k.initialDimensions),delete this.j[n]),p}$acceptProcessAckDataEvent(n,l){this.g.get(n)?.acknowledgeDataEvent(l)}$acceptProcessInput(n,l){this.g.get(n)?.input(l)}$acceptTerminalInteraction(n){const l=this.P(n);l?.setInteractedWith()&&this.I.fire(l.value)}$acceptProcessResize(n,l,p){try{this.g.get(n)?.resize(l,p)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(n,l){this.g.get(n)?.shutdown(l)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(l=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(l=>this.a.$sendProcessProperty(n,{type:"cwd",value:l}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,l,p){if(this.v.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this.v.set(l,p),this.a.$registerProfileProvider(l,n.identifier.value),new S.Disposable(()=>{this.v.delete(l),this.a.$unregisterProfileProvider(l)})}registerTerminalQuickFixProvider(n,l,p){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,p),this.a.$registerQuickFixProvider(n,l),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,l){const p=new E.CancellationTokenSource().token;if(p.isCancellationRequested)return;const k=this.w.get(n);if(!!k)return k.provideTerminalQuickFixes(l,p)}async $createContributedProfileTerminal(n,l){const p=new E.CancellationTokenSource().token;let k=await this.v.get(n)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(k&&!("options"in k)&&(k={options:k}),!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,l);return}this.createTerminalFromOptions(k.options,l)}}async $provideLinks(n,l){const p=this.P(n);if(!p)return[];this.y.delete(n),this.C.get(n)?.dispose(!0);const L=new E.CancellationTokenSource;this.C.set(n,L);const U=[],K={terminal:p.value,line:l},G=[];for(const F of this.u)G.push(f.Promises.withAsyncBody(async $=>{L.token.onCancellationRequested(()=>$({provider:F,links:[]}));const M=await F.provideTerminalLinks(K,L.token)||[];L.token.isCancellationRequested||$({provider:F,links:M})}));const O=await Promise.all(G);if(L.token.isCancellationRequested)return[];const B=new Map;for(const F of O)F&&F.links.length>0&&U.push(...F.links.map($=>{const M={id:b++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return B.set(M.id,{provider:F.provider,link:$}),M}));return this.y.set(n,B),U}$activateLink(n,l){const p=this.y.get(n)?.get(l);!p||p.provider.handleTerminalLink(p.link)}O(n,l){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const p=this.h[n];p&&(p.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,l)}P(n){return this.Q(this.f,n)}Q(n,l){const p=this.R(n,l);return p!==null?n[p]:null}R(n,l){let p=null;return n.some((k,L)=>k._id===l?(p=L,!0):!1),p}getEnvironmentVariableCollection(n){let l=this.l.get(n.identifier.value);return l||(l=new i,this.U(n.identifier.value,l)),l}S(n,l){const p=(0,P.serializeEnvironmentVariableCollection)(l.map);this.a.$setEnvironmentVariableCollection(n,l.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(n){n.forEach(l=>{const p=l[0],k=new i(l[1]);this.U(p,k)})}$acceptDefaultProfile(n,l){const p=this.m;this.m=n,this.n=l,p?.path!==n.path&&this.L.fire(n.path)}U(n,l){this.l.set(n,l),l.onDidChangeCollection(()=>{this.S(n,l)})}};s=Ve([ze(1,D.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class i{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,l){this.d(n,{value:l,type:S.EnvironmentVariableMutatorType.Replace})}append(n,l){this.d(n,{value:l,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,l){this.d(n,{value:l,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,l){const p=this.map.get(n);(!p||p.value!==l.value||p.type!==l.type)&&(this.map.set(n,l),this.b.fire())}get(n){return this.map.get(n)}forEach(n,l){this.map.forEach((p,k)=>n.call(l,k,p,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}e.EnvironmentVariableCollection=i;let c=class extends s{constructor(n){super(!1,n)}createTerminal(n,l,p){throw new R.NotSupportedError}createTerminalFromOptions(n,l){throw new R.NotSupportedError}};c=Ve([ze(0,D.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c;function u(o){if(!(!o||typeof o=="string"))return"id"in o?{id:o.id,color:o.color}:o}function r(o){return d.ThemeColor.isThemeColor(o)?o:void 0}});var Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a};define(Se[265],ye([1,0,17,22,21,4,61,83,6,23,11,30,5,16,136,14,7,56,91,68]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m){"use strict";var h,b;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(K,G,O){this.j=O,this.c=new A.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=K.getProxy(E.MainContext.MainThreadTesting),this.h=new p(this.f),this.g=new c(this.f),G.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==15)return B;const F=B,$=F.tests[F.tests.length-1].item.extId;return this.d.get(f.TestId.root($))?.collection.tree.get($)?.actual??(0,v.toItemFromContext)(B)}})}createTestController(K,G,O){if(this.d.has(K))throw new Error(`Attempt to insert a duplicate controller with ID "${K}"`);const B=new S.DisposableStore,F=B.add(new v.ExtHostTestItemCollection(K,G,this.j));F.root.label=G;const $=new Map,M=this.f,V={items:F.root.children,get label(){return G},set label(H){G=H,F.root.label=H,M.$updateController(K,{label:G})},get refreshHandler(){return O},set refreshHandler(H){O=H,M.$updateController(K,{canRefresh:!!H})},get id(){return K},createRunProfile:(H,J,Y,ae,re)=>{let fe=(0,T.hash)(H);for(;$.has(fe);)fe++;return new k(this.f,$,K,fe,H,J,Y,ae,re)},createTestItem(H,J,Y){return new v.TestItemImpl(K,H,J,Y)},createTestRun:(H,J,Y=!0)=>this.g.createTestRun(K,F,H,J,Y),set resolveHandler(H){F.resolveHandler=H},get resolveHandler(){return F.resolveHandler},dispose:()=>{B.dispose()}};M.$registerTestController(K,G,!!O),B.add((0,S.toDisposable)(()=>M.$unregisterTestController(K)));const q={controller:V,collection:F,profiles:$};return this.d.set(K,q),B.add((0,S.toDisposable)(()=>this.d.delete(K))),B.add(F.onDidGenerateDiff(H=>M.$publishDiff(K,H.map(m.TestsDiffOp.serialize)))),V}createTestObserver(){return this.h.checkout()}async runTests(K,G=I.CancellationToken.None){const O=u(K);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.d.get(O.controllerId);if(!B)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:K.include?.map(F=>f.TestId.fromExtHostTestItem(F,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:L[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:K.exclude?.map(F=>F.id)},G)}$syncTests(){for(const{collection:K}of this.d.values())K.flushDiff();return Promise.resolve()}$provideFileCoverage(K,G,O){return(0,a.mapFind)(this.g.trackers,F=>F.id===K?F.getCoverage(G):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(K,G,O,B){return(0,a.mapFind)(this.g.trackers,$=>$.id===K?$.getCoverage(G):void 0)?.resolveFileCoverage(O,B)??Promise.resolve([])}$configureRunProfile(K,G){this.d.get(K)?.profiles.get(G)?.configureHandler?.()}async $refreshTests(K,G){await this.d.get(K)?.controller.refreshHandler?.(G)}$publishTestResults(K){this.results=Object.freeze(K.map(G=>(0,C.deepFreeze)(d.TestResults.to(G))).concat(this.results).sort((G,O)=>O.completedAt-G.completedAt).slice(0,32)),this.c.fire()}async $expandTest(K,G){const O=this.d.get(f.TestId.fromString(K).controllerId)?.collection;O&&(await O.expand(K,G<0?1/0:G),O.flushDiff())}$acceptDiff(K){this.h.applyDiff(K.map(m.TestsDiffOp.deserialize))}async $runControllerTests(K,G){return Promise.all(K.map(O=>this.runControllerTestRequest(O,G)))}async runControllerTestRequest(K,G){const O=this.d.get(K.controllerId);if(!O)return{};const{collection:B,profiles:F}=O,$=F.get(K.profileId);if(!$)return{};const M=K.testIds.map(J=>B.tree.get(J)).filter(R.isDefined),V=K.excludeExtIds.map(J=>O.collection.tree.get(J)).filter(R.isDefined).filter(J=>M.some(Y=>Y.fullId.compare(J.fullId)===2));if(!M.length)return{};const q=new g.TestRunRequest(M.some(J=>J.actual instanceof v.TestItemRootImpl)?void 0:M.map(J=>J.actual),V.map(J=>J.actual),$),H=this.g.prepareForMainThreadTestRun(q,r.fromInternal(K,O.collection),G);try{return await $.runHandler(q,G),{}}catch(J){return{error:String(J)}}finally{H.isRunning&&!G.isCancellationRequested&&await A.Event.toPromise(H.onEnd),H.dispose()}}$cancelExtensionTestRun(K){K===void 0?this.g.cancelAllRuns():this.g.cancelRunById(K)}};s=Ve([ze(0,y.IExtHostRpcService)],s),e.ExtHostTesting=s;class i extends S.Disposable{get isRunning(){return this.c.size>0}get id(){return this.k.id}constructor(K,G,O){super(),this.k=K,this.l=G,this.c=new Map,this.f=new Set,this.h=this.B(new A.Emitter),this.j=!1,this.onEnd=this.h.event,this.g=this.B(new I.CancellationTokenSource(O)),this.B(this.g.token.onCancellationRequested(()=>{for(const{run:B}of this.c.values())B.end()}))}getCoverage(K){return this.c.get(K)?.coverage}createRun(K){const G=this.k.id,O=this.k.controllerId,B=(0,P.generateUuid)(),F=new o(this.l,G,B),$=H=>(J,...Y)=>{if(V){console.warn(`Setting the state of test "${J.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(J)||(this.m(J),H(J,...Y))},M=(H,J)=>{const Y=J instanceof Array?J.map(d.TestMessage.from):[d.TestMessage.from(J)];if(H.uri&&H.range){const ae={range:d.Range.from(H.range),uri:H.uri};for(const re of Y)re.location=re.location||ae}this.l.$appendTestMessagesInRun(G,B,f.TestId.fromExtHostTestItem(H,O).toString(),Y)};let V=!1;const q={isPersisted:this.k.isPersisted,token:this.g.token,name:K,get coverageProvider(){return F.coverageProvider},set coverageProvider(H){F.coverageProvider=H},enqueued:$(H=>{this.l.$updateTestStateInRun(G,B,f.TestId.fromExtHostTestItem(H,O).toString(),1)}),skipped:$(H=>{this.l.$updateTestStateInRun(G,B,f.TestId.fromExtHostTestItem(H,O).toString(),5)}),started:$(H=>{this.l.$updateTestStateInRun(G,B,f.TestId.fromExtHostTestItem(H,O).toString(),2)}),errored:$((H,J,Y)=>{M(H,J),this.l.$updateTestStateInRun(G,B,f.TestId.fromExtHostTestItem(H,O).toString(),6,Y)}),failed:$((H,J,Y)=>{M(H,J),this.l.$updateTestStateInRun(G,B,f.TestId.fromExtHostTestItem(H,O).toString(),4,Y)}),passed:$((H,J)=>{this.l.$updateTestStateInRun(G,B,f.TestId.fromExtHostTestItem(H,this.k.controllerId).toString(),3,J)}),appendOutput:(H,J,Y)=>{V||(Y&&(this.k.isIncluded(Y)?this.m(Y):Y=void 0),this.l.$appendOutputToRun(G,B,t.VSBuffer.fromString(H),J&&d.location.from(J),Y&&f.TestId.fromExtHostTestItem(Y,O).toString()))},end:()=>{V||(V=!0,this.l.$finishedTestRunTask(G,B),this.c.delete(B),this.isRunning||this.dispose())}};return this.c.set(B,{run:q,coverage:F}),this.l.$startedTestRunTask(G,{id:B,name:K,running:!0}),q}dispose(){this.j||(this.j=!0,this.h.fire(),this.g.cancel(),super.dispose())}m(K){if(!(K instanceof v.TestItemImpl))throw new w.InvalidTestItemError(K.id);if(this.f.has(f.TestId.fromExtHostTestItem(K,this.k.controllerId).toString()))return;const G=[],O=this.k.colllection.root;for(;;){const B=d.TestItem.from(K);if(G.unshift(B),this.f.has(B.extId)||(this.f.add(B.extId),K===O))break;K=K.parent||O}this.l.$addTestsToRun(this.k.controllerId,this.k.id,G)}}class c{get trackers(){return this.c.values()}constructor(K){this.d=K,this.c=new Map}prepareForMainThreadTestRun(K,G,O){return this.f(K,G,O)}cancelRunById(K){for(const G of this.c.values())if(G.id===K){G.dispose();return}}cancelAllRuns(){for(const K of this.c.values())K.dispose()}createTestRun(K,G,O,B,F){const $=this.c.get(O);if($)return $.createRun(B);const M=r.fromPublic(K,G,O,F),V=u(O);this.d.$startedExtensionTestRun({controllerId:K,profile:V&&{group:L[V.kind],id:V.profileId},exclude:O.exclude?.map(H=>f.TestId.fromExtHostTestItem(H,G.root.id).toString())??[],id:M.id,include:O.include?.map(H=>f.TestId.fromExtHostTestItem(H,G.root.id).toString())??[G.root.id],persist:F});const q=this.f(O,M);return q.onEnd(()=>this.d.$finishedExtensionTestRun(M.id)),q.createRun(B)}f(K,G,O){const B=new i(G,this.d,O);return this.c.set(K,B),B.onEnd(()=>this.c.delete(K)),B}}e.TestRunCoordinator=c;const u=U=>{if(!!U.profile){if(!(U.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class r{static fromPublic(K,G,O,B){return new r(K,(0,P.generateUuid)(),O.include?.map(F=>f.TestId.fromExtHostTestItem(F,K).toString())??[K],O.exclude?.map(F=>f.TestId.fromExtHostTestItem(F,K).toString())??[],B,G)}static fromInternal(K,G){return new r(K.controllerId,K.runId,K.testIds,K.excludeExtIds,!0,G)}constructor(K,G,O,B,F,$){this.controllerId=K,this.id=G,this.isPersisted=F,this.colllection=$,this.c=O.map(M=>M+"\0"),this.d=B.map(M=>M+"\0")}isIncluded(K){const G=f.TestId.fromExtHostTestItem(K,this.controllerId).toString()+"\0";for(const O of this.d)if(G===O||G.startsWith(O))return!1;for(const O of this.c)if(G===O||G.startsWith(O))return!0;return!1}}e.TestRunDto=r;class o{set coverageProvider(K){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!K||(this.c=K,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(K,G,O){this.f=K,this.g=G,this.h=O}async provideFileCoverage(K){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(K))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(G){throw this.d=void 0,G}}async resolveFileCoverage(K,G){const O=await this.d;let B=O?.[K];return!this.c||!O||!B?[]:(B.detailedCoverage||(B=O[K]=await this.c.resolveFileCoverage?.(B,G)??B),B.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class n{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(K){this.h=K,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(K){this.c.add(K)}update(K){Object.assign(K.revived,d.TestItem.toPlain(K.item)),this.c.has(K)||this.d.add(K)}remove(K){if(this.c.has(K)){this.c.delete(K);return}this.d.delete(K);const G=f.TestId.parentId(K.item.extId);if(G&&this.g.has(G.toString())){this.g.add(K.item.extId);return}this.f.add(K)}getChangeEvent(){const{c:K,d:G,f:O}=this;return{get added(){return[...K].map(B=>B.revived)},get updated(){return[...G].map(B=>B.revived)},get removed(){return[...O].map(B=>B.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class l extends m.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new A.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(K){return this.d.get(K)}getMirroredTestDataByReference(K){return this.d.get(K.id)}p(K,G){return{...K,revived:d.TestItem.toPlain(K.item),depth:G?G.depth+1:0,children:new Set}}o(){return new n(this.q)}}e.MirroredTestCollection=l;class p{constructor(K){this.d=K}checkout(){this.c||(this.c=this.f());const K=this.c;return K.observers++,{onDidChangeTest:K.tests.onDidChangeTests,get tests(){return[...K.tests.rootTests].map(G=>G.revived)},dispose:(0,D.once)(()=>{--K.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(K){return this.c?.tests.getMirroredTestDataByReference(K)}applyDiff(K){this.c?.tests.apply(K)}f(){const K=new l;return this.d.$subscribeToDiffs(),{observers:0,tests:K}}}class k{get label(){return this.d}set label(K){K!==this.d&&(this.d=K,Me(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:K}))}get isDefault(){return this.f}set isDefault(K){K!==this.f&&(this.f=K,Me(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:K}))}get tag(){return this._tag}set tag(K){K?.id!==this._tag?.id&&(this._tag=K,Me(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:K?d.TestTag.namespace(this.controllerId,K.id):null}))}get configureHandler(){return this.c}set configureHandler(K){K!==this.c&&(this.c=K,Me(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!K}))}constructor(K,G,O,B,F,$,M,V=!1,q=void 0){this.controllerId=O,this.profileId=B,this.d=F,this.kind=$,this.runHandler=M,this.f=V,this._tag=q,h.set(this,void 0),b.set(this,void 0),Je(this,h,K,"f"),Je(this,b,G,"f"),G.set(B,this);const H=L[$];if(typeof H!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Me(this,h,"f").$publishTestRunProfile({profileId:B,controllerId:O,tag:q?d.TestTag.namespace(this.controllerId,q.id):null,label:F,group:H,isDefault:V,hasConfigurationHandler:!1})}dispose(){Me(this,b,"f")?.delete(this.profileId)&&(Je(this,b,void 0,"f"),Me(this,h,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=k,h=new WeakMap,b=new WeakMap;const L={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(Se[266],ye([1,0,17,4,5,137,14,7]),function(te,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(R,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(I.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(E=>this.g.fire(E)),this.i.onDidChangeActiveTextEditor(E=>this.f.fire(E))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const P=this.i.allEditors();return R?P:P.map(E=>E.value)}async showTextDocument(R,P,E){let y;typeof P=="number"?y={position:D.ViewColumn.from(P),preserveFocus:E}:typeof P=="object"?y={position:D.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?D.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:y={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(R.uri,y),d=v&&this.i.getEditor(v);if(d)return d.value;throw v?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,P){return new A.TextEditorDecorationType(this.h,R,P).value}$acceptEditorPropertiesChanged(R,P){const E=this.i.getEditor(R);if(!E)throw new Error("unknown text editor");if(P.options&&E._acceptOptions(P.options),P.selections){const y=P.selections.selections.map(D.Selection.to);E._acceptSelections(y)}if(P.visibleRanges){const y=a.coalesce(P.visibleRanges.map(D.Range.to));E._acceptVisibleRanges(y)}if(P.options&&this.b.fire({textEditor:E.value,options:{...P.options,lineNumbers:D.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const y=T.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(D.Selection.to);this.a.fire({textEditor:E.value,selections:v,kind:y})}if(P.visibleRanges){const y=a.coalesce(P.visibleRanges.map(D.Range.to));this.c.fire({textEditor:E.value,visibleRanges:y})}}$acceptEditorPositionData(R){for(const P in R){const E=this.i.getEditor(P);if(!E)throw new Error("Unknown text editor");const y=D.ViewColumn.to(R[P]);E.value.viewColumn!==y&&(E._acceptViewColumn(y),this.d.fire({textEditor:E.value,viewColumn:y}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.ExtHostEditors=S}),define(Se[267],ye([1,0,2,3,5,6,7,14,11]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class C{constructor(E,y){this.b=new Map,this.c=new Map,this.a=E.getProxy(I.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===12){const d=v.uri===void 0?void 0:a.URI.revive(v.uri);return this.c.get(v.source)?.get(R(d))?.get(v.handle)}return v}})}async $getTimeline(E,y,v,d){return this.b.get(E)?.provideTimeline(a.URI.revive(y),v,d)}registerTimelineProvider(E,y,v,d){const g=new A.DisposableStore,f=this.d(y.id,d,g).bind(this);let w;y.onDidChange&&(w=y.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:y.id}),this));const m=this.c;return this.f({...y,scheme:E,onDidChange:void 0,async provideTimeline(h,b,s){b?.resetCache&&(g.clear(),m.get(y.id)?.clear());const i=await y.provideTimeline(h,b,s);if(i==null)return;const c=f(h,b);return{...i,source:y.id,items:i.items.map(c)}},dispose(){for(const h of m.values())h.get(y.id)?.clear();w?.dispose(),g.dispose()}})}d(E,y,v){return(d,g)=>{let f;if(g?.cacheResults){let w=this.c.get(E);w===void 0&&(w=new Map,this.c.set(E,w));const m=R(d);f=w.get(m),f===void 0&&(f=new Map,w.set(m,f))}return w=>{const{iconPath:m,...h}=w,b=`${E}|${w.id??w.timestamp}`;f?.set(b,w);let s,i,c;w.iconPath&&(m instanceof D.ThemeIcon?c={id:m.id,color:m.color}:a.URI.isUri(m)?(s=m,i=m):{light:s,dark:i}=m);let u;return D.MarkdownString.isMarkdownString(h.tooltip)?u=T.MarkdownString.from(h.tooltip):(0,S.isString)(h.tooltip)?u=h.tooltip:D.MarkdownString.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=T.MarkdownString.from(h.detail)):(0,S.isString)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=h.detail),{...h,id:h.id??void 0,handle:b,source:E,command:w.command?y.toInternal(w.command,v):void 0,icon:s,iconDark:i,themeIcon:c,tooltip:u,accessibilityInformation:w.accessibilityInformation}}}}f(E){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,E),(0,A.toDisposable)(()=>{for(const v of this.c.values())v.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=C;function R(P){return P?.toString()}}),define(Se[268],ye([1,0,6,15,2,5]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(S){this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,R,P){if(this.c.has(C))throw new Error(`Opener with id '${C}' already registered`);const E=P.schemes.find(y=>!D.a.has(y));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this.c.set(C,R),this.b.$registerUriOpener(C,P.schemes,S,P.label),(0,a.toDisposable)(()=>{this.c.delete(C),this.b.$unregisterUriOpener(C)})}async $canOpenUri(S,C,R){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const E=I.URI.revive(C);return P.canOpenExternalUri(E,R)}async $openUri(S,C,R){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(I.URI.revive(C.resolvedUri),{sourceUri:I.URI.revive(C.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.a=new Set([t.Schemas.http,t.Schemas.https])}),define(Se[269],ye([1,0,5,2,6,10,27]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(C){this.c=new Set,this.d=new Map,this.b=C.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(C,R){if(this.c.has(D.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const P=T.a++;return this.c.add(D.ExtensionIdentifier.toKey(C)),this.d.set(P,R),this.b.$registerUriHandler(P,C),(0,I.toDisposable)(()=>{this.c.delete(D.ExtensionIdentifier.toKey(C)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(C,R){const P=this.d.get(C);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(R))}catch(E){(0,A.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(C){return t.URI.revive(await this.b.$createAppUri(C))}}e.ExtHostUrls=T,T.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a},Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[72],ye([1,0,4,15,23,2,191,213,92,5]),function(te,e,a,t,I,A,D,T,S,C){"use strict";var R,P,E,y,v,d,g,f,w,m,h,b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class i{constructor(L,U,K,G,O,B,F){R.set(this,void 0),P.set(this,void 0),E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,""),f.set(this,void 0),w.set(this,!1),m.set(this,!1),h.set(this,void 0),b.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new a.Emitter),this._onDidDispose=Me(this,s,"f").event,Je(this,R,L,"f"),Je(this,P,U,"f"),Je(this,f,K,"f"),Je(this,y,G,"f"),Je(this,v,O,"f"),Je(this,d,B,"f"),Je(this,h,c(B),"f"),Je(this,b,u(B),"f"),Je(this,E,F,"f")}dispose(){Je(this,w,!0,"f"),Me(this,s,"f").fire(),Me(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return Je(this,m,!0,"f"),(0,S.asWebviewUri)(L,Me(this,y,"f"))}get cspSource(){const L=Me(this,d,"f").extensionLocation;if(L.scheme===t.Schemas.https||L.scheme===t.Schemas.http){let U=L.toString();return U.endsWith("/")||(U+="/"),U+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Me(this,g,"f")}set html(L){this.a(),Me(this,g,"f")!==L&&(Je(this,g,L,"f"),Me(this,b,"f")&&!Me(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(Je(this,m,!0,"f"),Me(this,E,"f").report("Webview vscode-resource: uris",Me(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,P,"f").$setHtml(Me(this,R,"f"),this.b(L)))}get options(){return this.a(),Me(this,f,"f")}set options(L){this.a(),I.equals(Me(this,f,"f"),L)||Me(this,P,"f").$setOptions(Me(this,R,"f"),n(Me(this,d,"f"),Me(this,v,"f"),L)),Je(this,f,L,"f")}async postMessage(L){if(Me(this,w,"f"))return!1;const U=(0,T.serializeWebviewMessage)(L,{serializeBuffersForPostMessage:Me(this,h,"f")});return Me(this,P,"f").$postMessage(Me(this,R,"f"),U.message,...U.buffers)}a(){if(Me(this,w,"f"))throw new Error("Webview is disposed")}b(L){if(!Me(this,b,"f"))return L;const U=Me(this,d,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,K=Me(this,d,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Me(this,d,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,O,B,F,$,M)=>{const V=A.URI.from({scheme:F||"file",path:decodeURIComponent($)}),q=(0,S.asWebviewUri)(V,{isRemote:U,authority:K}).toString();return`${O}${q}${M}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,O,B,F,$,M)=>{const V=A.URI.from({scheme:F||"file",path:decodeURIComponent($)}),q=(0,S.asWebviewUri)(V,{isRemote:U,authority:K}).toString();return`${O}${q}${M}`})}}e.ExtHostWebview=i,R=new WeakMap,P=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,f=new WeakMap,w=new WeakMap,m=new WeakMap,h=new WeakMap,b=new WeakMap,s=new WeakMap;function c(k){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(k.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=c;function u(k){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(k.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class r{constructor(L,U,K,G,O){this.c=U,this.d=K,this.e=G,this.f=O,this.b=new Map,this.a=L.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(L,U,K){const G=this.g(L);if(G){const{message:O}=(0,T.deserializeWebviewMessage)(U,K.value);G._onMessageEmitter.fire(O)}}$onMissingCsp(L,U){this.e.warn(`${U} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,U,K){const G=new i(L,this.a,l(U),this.c,this.d,K,this.f);return this.b.set(L,G),G._onDidDispose(()=>{this.b.delete(L)}),G}deleteWebview(L){this.b.delete(L)}g(L){return this.b.get(L)}}e.ExtHostWebviews=r;function o(k){return{id:k.identifier,location:k.extensionLocation}}e.toExtensionData=o;function n(k,L,U){return{enableCommandUris:U.enableCommandUris,enableScripts:U.enableScripts,enableForms:U.enableForms,portMapping:U.portMapping,localResourceRoots:U.localResourceRoots||p(k,L)}}e.serializeWebviewOptions=n;function l(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(L=>A.URI.from(L))}}function p(k,L){return[...(L?.getWorkspaceFolders()||[]).map(U=>U.uri),k.extensionLocation]}}),define(Se[270],ye([1,0,21,83,6,15,24,2,14,72,67,5,7]),function(te,e,a,t,I,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class y{constructor(i,c){this.document=i,this.b=c,this.a=1,this.c=new R.Cache("custom documents")}addEdit(i){return this.c.add([i])}async undo(i,c){await this.f(i).undo(),c||this.disposeBackup()}async redo(i,c){await this.f(i).redo(),c||this.disposeBackup()}disposeEdits(i){for(const c of i)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const i=b(this.document.uri)+this.a++;return(0,D.joinPath)(this.b,i)}updateBackup(i){this.d?.delete(),this.d=i}disposeBackup(){this.d?.delete(),this.d=void 0}f(i){const c=this.c.get(i,0);if(!c)throw new Error("No edit found");return c}}class v{constructor(){this.a=new Map}get(i,c){return this.a.get(this.b(i,c))}add(i,c,u){const r=this.b(i,c.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${i} resource:${c.uri}`);const o=new y(c,u);return this.a.set(r,o),o}delete(i,c){const u=this.b(i,c.uri);this.a.delete(u)}b(i,c){return`${i}@@@${c}`}}var d;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(d||(d={}));class g{constructor(){this.a=new Map}addTextProvider(i,c,u){return this.b(0,i,c,u)}addCustomProvider(i,c,u){return this.b(1,i,c,u)}get(i){return this.a.get(i)}b(i,c,u,r){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:i,extension:u,provider:r}),new E.Disposable(()=>this.a.delete(c))}}class f{constructor(i,c,u,r,o){this.d=c,this.f=u,this.g=r,this.h=o,this.b=new g,this.c=new v,this.a=i.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,c,u,r){const o=new I.DisposableStore;return m(u)?(o.add(this.b.addTextProvider(c,i,u)),this.a.$registerTextEditorProvider((0,C.toExtensionData)(i),c,r.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(i))):(o.add(this.b.addCustomProvider(c,i,u)),w(u)&&o.add(u.onDidChangeCustomDocument(n=>{const l=this.i(c,n.document.uri);if(h(n)){const p=l.addEdit(n);this.a.$onDidEdit(n.document.uri,c,p,n.label)}else this.a.$onContentChange(n.document.uri,c)})),this.a.$registerCustomEditorProvider((0,C.toExtensionData)(i),c,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(i))),E.Disposable.from(o,new E.Disposable(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(i,c,u,r,o){const n=this.b.get(c);if(!n)throw new Error(`No provider found for '${c}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${c}'`);const l=T.URI.revive(i),p=await n.provider.openCustomDocument(l,{backupId:u,untitledDocumentData:r?.buffer},o);let k;return w(n.provider)&&this.f&&(k=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(c,p,k),{editable:w(n.provider)}}async $disposeCustomDocument(i,c){const u=this.b.get(c);if(!u)throw new Error(`No provider found for '${c}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${c}'`);const r=T.URI.revive(i),{document:o}=this.i(c,r);this.c.delete(c,o),o.dispose()}async $resolveWebviewEditor(i,c,u,r,o,n){const l=this.b.get(u);if(!l)throw new Error(`No provider found for '${u}'`);const p=S.ViewColumn.to(o),k=this.g.createNewWebview(c,r.contentOptions,l.extension),L=this.h.createNewWebviewPanel(c,u,r.title,p,r.options,k,!0),U=T.URI.revive(i);switch(l.type){case 1:{const{document:K}=this.i(u,U);return l.provider.resolveCustomEditor(K,L,n)}case 0:{const K=this.d.getDocument(U);return l.provider.resolveCustomTextEditor(K,L,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,c,u){this.i(c,i).disposeEdits(u)}async $onMoveCustomEditor(i,c,u){const r=this.b.get(u);if(!r)throw new Error(`No provider found for '${u}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const o=this.h.getWebviewPanel(i);if(!o)throw new Error("No webview found");const n=T.URI.revive(c),l=this.d.getDocument(n);await r.provider.moveCustomTextEditor(l,o,a.CancellationToken.None)}async $undo(i,c,u,r){return this.i(c,i).undo(u,r)}async $redo(i,c,u,r){return this.i(c,i).redo(u,r)}async $revert(i,c,u){const r=this.i(c,i);await this.j(c).revertCustomDocument(r.document,u),r.disposeBackup()}async $onSave(i,c,u){const r=this.i(c,i);await this.j(c).saveCustomDocument(r.document,u),r.disposeBackup()}async $onSaveAs(i,c,u,r){const o=this.i(c,i);return this.j(c).saveCustomDocumentAs(o.document,T.URI.revive(u),r)}async $backup(i,c,u){const r=this.i(c,i),n=await this.j(c).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},u);return r.updateBackup(n),n.id}i(i,c){const u=this.c.get(i,T.URI.revive(c));if(!u)throw new Error("No custom document found");return u}j(i){const u=this.b.get(i)?.provider;if(!u||!w(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=f;function w(s){return!!s.onDidChangeCustomDocument}function m(s){return typeof s.resolveCustomTextEditor=="function"}function h(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function b(s){const i=s.scheme===A.Schemas.file||s.scheme===A.Schemas.untitled?s.fsPath:s.toString();return(0,t.hash)(i)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a},Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[271],ye([1,0,4,6,2,30,14,72,5,7]),function(te,e,a,t,I,A,D,T,S,C){"use strict";var R,P,E,y,v,d,g,f,w,m,h,b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends t.Disposable{constructor(o,n,l,p){super(),R.set(this,void 0),P.set(this,void 0),E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,void 0),f.set(this,void 0),w.set(this,!0),m.set(this,void 0),h.set(this,!1),b.set(this,this.B(new a.Emitter)),this.onDidDispose=Me(this,b,"f").event,s.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Me(this,s,"f").event,Je(this,R,o,"f"),Je(this,P,n,"f"),Je(this,y,l,"f"),Je(this,E,p.viewType,"f"),Je(this,v,p.panelOptions,"f"),Je(this,f,p.viewColumn,"f"),Je(this,d,p.title,"f"),Je(this,m,p.active,"f")}dispose(){Me(this,h,"f")||(Je(this,h,!0,"f"),Me(this,b,"f").fire(),Me(this,P,"f").$disposeWebview(Me(this,R,"f")),Me(this,y,"f").dispose(),super.dispose())}get webview(){return this.c(),Me(this,y,"f")}get viewType(){return this.c(),Me(this,E,"f")}get title(){return this.c(),Me(this,d,"f")}set title(o){this.c(),Me(this,d,"f")!==o&&(Je(this,d,o,"f"),Me(this,P,"f").$setTitle(Me(this,R,"f"),o))}get iconPath(){return this.c(),Me(this,g,"f")}set iconPath(o){this.c(),Me(this,g,"f")!==o&&(Je(this,g,o,"f"),Me(this,P,"f").$setIconPath(Me(this,R,"f"),I.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return Me(this,v,"f")}get viewColumn(){if(this.c(),!(typeof Me(this,f,"f")=="number"&&Me(this,f,"f")<0))return Me(this,f,"f")}get active(){return this.c(),Me(this,m,"f")}get visible(){return this.c(),Me(this,w,"f")}_updateViewState(o){Me(this,h,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(Je(this,m,o.active,"f"),Je(this,w,o.visible,"f"),Je(this,f,o.viewColumn,"f"),Me(this,s,"f").fire({webviewPanel:this}))}reveal(o,n){this.c(),Me(this,P,"f").$reveal(Me(this,R,"f"),{viewColumn:typeof o>"u"?void 0:D.ViewColumn.from(o),preserveFocus:!!n})}c(){if(Me(this,h,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,P=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,f=new WeakMap,w=new WeakMap,m=new WeakMap,h=new WeakMap,b=new WeakMap,s=new WeakMap;class c{static c(){return(0,A.generateUuid)()}constructor(o,n,l){this.g=n,this.h=l,this.e=new Map,this.f=new Map,this.d=o.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(o,n,l,p,k={}){const L=typeof p=="object"?p.viewColumn:p,U={viewColumn:D.ViewColumn.from(L),preserveFocus:typeof p=="object"&&!!p.preserveFocus},K=(0,T.shouldSerializeBuffersForPostMessage)(o),G=c.c();this.d.$createWebviewPanel((0,T.toExtensionData)(o),G,n,{title:l,panelOptions:u(k),webviewOptions:(0,T.serializeWebviewOptions)(o,this.h,k),serializeBuffersForPostMessage:K},U);const O=this.g.createNewWebview(G,k,o);return this.createNewWebviewPanel(G,n,l,L,k,O,!0)}$onDidChangeWebviewPanelViewStates(o){const n=Object.keys(o);n.sort((l,p)=>{const k=o[l],L=o[p];return k.active?1:L.active?-1:+k.visible-+L.visible});for(const l of n){const p=this.getWebviewPanel(l);if(!p)continue;const k=o[l];p._updateViewState({active:k.active,visible:k.visible,viewColumn:D.ViewColumn.to(k.position)})}}async $onDidDisposeWebviewPanel(o){this.getWebviewPanel(o)?.dispose(),this.e.delete(o),this.g.deleteWebview(o)}registerWebviewPanelSerializer(o,n,l){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:l,extension:o}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(o)}),new C.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(o,n,l,p){const k=this.f.get(n);if(!k)throw new Error(`No serializer found for '${n}'`);const{serializer:L,extension:U}=k,K=this.g.createNewWebview(o,l.webviewOptions,U),G=this.createNewWebviewPanel(o,n,l.title,p,l.panelOptions,K,l.active);await L.deserializeWebviewPanel(G,l.state)}createNewWebviewPanel(o,n,l,p,k,L,U){const K=new i(o,this.d,L,{viewType:n,title:l,viewColumn:p,panelOptions:k,active:U});return this.e.set(o,K),K}getWebviewPanel(o){return this.e.get(o)}}e.ExtHostWebviewPanels=c;function u(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a},Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[272],ye([1,0,4,6,72,14,5,7]),function(te,e,a,t,I,A,D,T){"use strict";var S,C,R,P,E,y,v,d,g,f,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends t.Disposable{constructor(s,i,c,u,r,o){super(),S.set(this,void 0),C.set(this,void 0),R.set(this,void 0),P.set(this,void 0),E.set(this,!1),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,void 0),f.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Me(this,f,"f").event,w.set(this,this.B(new a.Emitter)),this.onDidDispose=Me(this,w,"f").event,Je(this,R,c,"f"),Je(this,v,u,"f"),Je(this,S,s,"f"),Je(this,C,i,"f"),Je(this,P,r,"f"),Je(this,y,o,"f")}dispose(){Me(this,E,"f")||(Je(this,E,!0,"f"),Me(this,w,"f").fire(),Me(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Me(this,v,"f")}set title(s){this.a(),Me(this,v,"f")!==s&&(Je(this,v,s,"f"),Me(this,C,"f").$setWebviewViewTitle(Me(this,S,"f"),s))}get description(){return this.a(),Me(this,d,"f")}set description(s){this.a(),Me(this,d,"f")!==s&&(Je(this,d,s,"f"),Me(this,C,"f").$setWebviewViewDescription(Me(this,S,"f"),s))}get visible(){return Me(this,y,"f")}get webview(){return Me(this,P,"f")}get viewType(){return Me(this,R,"f")}_setVisible(s){s===Me(this,y,"f")||Me(this,E,"f")||(Je(this,y,s,"f"),Me(this,f,"f").fire())}get badge(){return this.a(),Me(this,g,"f")}set badge(s){this.a(),!(s?.value===Me(this,g,"f")?.value&&s?.tooltip===Me(this,g,"f")?.tooltip)&&(Je(this,g,A.ViewBadge.from(s),"f"),Me(this,C,"f").$setWebviewViewBadge(Me(this,S,"f"),s))}show(s){this.a(),Me(this,C,"f").$show(Me(this,S,"f"),!!s)}a(){if(Me(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,C=new WeakMap,R=new WeakMap,P=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,f=new WeakMap,w=new WeakMap;class h{constructor(s,i){this.d=i,this.b=new Map,this.c=new Map,this.a=s.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,i,c,u){if(this.b.has(i))throw new Error(`View provider for '${i}' already registered`);return this.b.set(i,{provider:c,extension:s}),this.a.$registerWebviewViewProvider((0,I.toExtensionData)(s),i,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(s)}),new T.Disposable(()=>{this.b.delete(i),this.a.$unregisterWebviewViewProvider(i)})}async $resolveWebviewView(s,i,c,u,r){const o=this.b.get(i);if(!o)throw new Error(`No view provider found for '${i}'`);const{provider:n,extension:l}=o,p=this.d.createNewWebview(s,{},l),k=new m(s,this.a,i,c,p,!0);this.c.set(s,k),await n.resolveWebviewView(k,{state:u},r)}async $onDidChangeWebviewViewVisibility(s,i){this.e(s)._setVisible(i)}async $disposeWebviewView(s){const i=this.e(s);this.c.delete(s),i.dispose(),this.d.deleteWebview(s)}e(s){const i=this.c.get(s);if(!i)throw new Error("No webview found");return i}}e.ExtHostWebviewViews=h}),define(Se[140],ye([1,0,4,5,2,15,8,3,16]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class ii{get state(){return this.d}constructor(P){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=ii.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,E){let y;if(typeof P=="string"){y=P;try{P=I.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,D.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,y,E)}async asExternalUri(P,E){if((0,D.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const y=await this.b.$asExternalUri(P,E);return I.URI.from(y)}};C.a={focused:!0},C=Ve([ze(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(Se[273],ye([1,0,117,274,65,39,2,13,45]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(E,y,v){this.b=E,this.c=y,this.f=v,this.a=t.createServer((d,g)=>this.h(d,g)),this.g().catch(d=>(y.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",E=>this.c.error(E))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(E,y){const v=(g,f)=>{y.writeHead(g,{"content-type":"application/json"}),y.end(JSON.stringify(f||null),w=>w&&this.c.error(w))},d=[];E.setEncoding("utf8"),E.on("data",g=>d.push(g)),E.on("end",async()=>{try{const g=JSON.parse(d.join(""));let f;switch(g.type){case"open":f=await this.i(g);break;case"openExternal":f=await this.j(g);break;case"status":f=await this.l(g);break;case"extensionManagement":f=await this.k(g);break;default:v(404,`Unknown message type: ${g.type}`);break}v(200,f)}catch(g){const f=g instanceof Error?g.message:JSON.stringify(g);v(500,f),this.c.error("Error while processing pipe request",g)}})}async i(E){const{fileURIs:y,folderURIs:v,forceNewWindow:d,diffMode:g,mergeMode:f,addMode:w,forceReuseWindow:m,gotoLineMode:h,waitMarkerFilePath:b,remoteAuthority:s}=E,i=[];if(Array.isArray(v))for(const o of v)try{i.push({folderUri:D.URI.parse(o)})}catch{}if(Array.isArray(y))for(const o of y)try{(0,S.hasWorkspaceFileExtension)(o)?i.push({workspaceUri:D.URI.parse(o)}):i.push({fileUri:D.URI.parse(o)})}catch{}const c=b?D.URI.file(b):void 0,r={forceNewWindow:d,diffMode:g,mergeMode:f,addMode:w,gotoLineMode:h,forceReuseWindow:m,preferNewWindow:!m&&!c&&!w,waitMarkerFileURI:c,remoteAuthority:s};return this.b.executeCommand("_remoteCLI.windowOpen",i,r),""}async j(E){for(const y of E.uris){const v=D.URI.parse(y),d=v.scheme==="file"?v:y;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(E){const y=d=>d?.map(g=>/\.vsix$/i.test(g)?D.URI.parse(g):g),v={list:E.list,install:y(E.install),uninstall:y(E.uninstall),force:E.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(E){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&I.existsSync(this.f)&&I.unlinkSync(this.f)}}e.CLIServerBase=C;let R=class extends C{constructor(E,y){super(E,y,(0,a.createRandomIPCHandle)())}};R=Ve([ze(0,A.IExtHostCommands),ze(1,T.ILogService)],R),e.CLIServer=R}),define(Se[275],ye([1,0,246,25,16]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let D=class extends a.AbstractExtHostConsoleForwarder{constructor(S,C){super(S,C),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,C,R){const P=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),C.apply(console,R),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,C){const R=process[S],P=R.write;let E="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(y,v,d)=>{if(!this.g){E+=y.toString(v);const g=E.length>A?E.length:E.lastIndexOf(`
`);g!==-1&&(console[C](E.slice(0,g)),E=E.slice(g+1))}P.call(R,y,v,d)}})}};D=Ve([ze(0,I.IExtHostRpcService),ze(1,t.IExtHostInitDataService)],D),e.ExtHostConsoleForwarder=D}),define(Se[276],ye([1,0,9,85,30,39,6,5,2,16]),function(te,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends D.Disposable{constructor(E,y){super();const v=E.getProxy(T.MainContext.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async d=>{const g=S.URI.file((0,a.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await v.$download(d,g),g})}};R=Ve([ze(0,C.IExtHostRpcService),ze(1,A.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(Se[277],ye([1,0,139,15,197,30]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class D extends a.ExtHostLoggerService{f(S,C,R){return S.scheme===t.Schemas.file?new I.SpdLogLogger(R?.name||(0,A.generateUuid)(),S.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,C):super.f(S,C,R)}}e.ExtHostLoggerService=D}),define(Se[278],ye([1,0,65,9,2,71,6,15,18,29]),function(te,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends A.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(s){const i=await super.g(s);if(i.scheme!==T.Schemas.file)return i;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${i.fsPath}.`),i;const c=i.fsPath;let u=0;do{let r;u===0?r=c:r=/[/\\]$/.test(c)?`${c.substr(0,c.length-1)}-${u}`:`${c}-${u}`,await P(r);const o=t.join(r,"vscode.lock"),n=await d(this.d,o,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),I.URI.file(r);u++}while(u<10);return i}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function P(b){try{await C.Promises.stat(b);return}catch{}try{await C.Promises.mkdir(b,{recursive:!0})}catch{}}const E=1e3,y=10*60*1e3;class v extends D.Disposable{constructor(s,i){super(),this.b=s,this.c=i,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const c=await g(s,i);(!c||c.pid!==process.pid)&&(s.info(`Lock '${i}': The lock was lost unexpectedly.`),this.a.cancel());try{await C.Promises.utimes(i,new Date,new Date)}catch(u){s.error(u),s.info(`Lock '${i}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(s){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const i={pid:process.pid,willReleaseAt:Date.now()+s};await C.Promises.writeFile(this.c,JSON.stringify(i),{flag:"w"})}catch(i){this.b.error(i)}}}async function d(b,s,i){try{const u={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(s,JSON.stringify(u),{flag:"wx"})}catch(u){b.error(u)}const c=await g(b,s);return!c||c.pid!==process.pid?i?(b.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(b.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),m(b,s)):(b.info(`Lock '${s}': Lock acquired.`),new v(b,s))}async function g(b,s){let i;try{i=await C.Promises.readFile(s)}catch(c){return b.error(c),null}try{return JSON.parse(String(i))}catch(c){return b.error(c),null}}async function f(b,s){let i;try{i=await C.Promises.stat(s)}catch(c){return b.error(c),0}return i.mtime.getTime()}function w(b){try{return process.kill(b,0),!0}catch{return!1}}async function m(b,s){const i=await g(b,s);if(!i)return b.info(`Lock '${s}': Could not read pid of lock holder.`),h(b,s);if(i.willReleaseAt){let n=i.willReleaseAt-Date.now();if(n<5e3){for(n>0?b.info(`Lock '${s}': The lockfile is scheduled to be released in ${n} ms.`):b.info(`Lock '${s}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await f(b,s)===0)return h(b,s);n=i.willReleaseAt-Date.now()}return h(b,s)}}if(!w(i.pid))return b.info(`Lock '${s}': The pid ${i.pid} appears to be gone.`),h(b,s);const c=await f(b,s),u=Date.now()-c;if(u<=y)return b.info(`Lock '${s}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;b.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const r=await f(b,s),o=Date.now()-r;return o<=y?(b.info(`Lock '${s}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null):(b.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),h(b,s))}async function h(b,s){b.info(`Lock '${s}': Deleting a stale lock.`);try{await C.Promises.unlink(s)}catch{}return d(b,s,!0)}}),define(Se[279],ye([1,0,30,16,40]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends I.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,C){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:C})}createTerminalFromOptions(T,S){const C=new I.ExtHostTerminal(this.a,(0,a.generateUuid)(),T,T.name);return this.f.push(C),C.create(T,this.M(T,S)),C.value}};A=Ve([ze(0,t.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Se[280],ye([1,0,5,16,180,6,25,2,44,24,29,7,12,54,4,129,100,13]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class w extends d.DisposableTunnel{}function m(n){const l=n.trim().split(`
`),p=[];return l.forEach(L=>{const U=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);U&&U.length>=3&&p.push({pid:parseInt(U[1],10),socket:parseInt(U[2],10)})}),p.reduce((L,U)=>(L[U.socket]=U,L),{})}e.getSockets=m;function h(...n){const l=[].concat(...n.map(s));return[...new Map(l.filter(p=>p.st==="0A").map(p=>{const k=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:b(k[0]),port:parseInt(k[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=h;function b(n){let l="";if(n.length===8)for(let p=n.length-2;p>=0;p-=2)l+=parseInt(n.substr(p,2),16),p!==0&&(l+=".");else for(let p=n.length-4;p>=0;p-=4)l+=parseInt(n.substr(p,4),16).toString(16),p!==0&&(l+=":");return l}function s(n){const l=n.trim().split(`
`),p=l.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return l.map(L=>L.trim().split(/\s+/).reduce((U,K,G)=>(U[p[G]||G]=K,U),{}))}e.loadConnectionTable=s;function i(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function c(n){const l=n.trim().split(`
`),p=[];return l.forEach(k=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(k);L&&L.length>=4&&p.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),p}e.getRootProcesses=c;async function u(n,l,p){const k=p.reduce((U,K)=>(U[K.pid]=K,U),{}),L=[];return n.forEach(({socket:U,ip:K,port:G})=>{const O=l[U]?l[U].pid:void 0,B=O?k[O]?.cmd:void 0;O&&B&&!i(B)&&L.push({host:K,port:G,detail:B,pid:O})}),L}e.findPorts=u;function r(n,l,p){const k=new Map,L=c(l);for(const U of n){const K=p.get(U.port);if(K){k.set(U.port,K);continue}const G=L.find(O=>O.cmd.includes(`${U.port}`));if(G){let O=G,B;do B=L.find(F=>F.ppid===O.pid),B&&(O=B);while(B);k.set(U.port,{host:U.ip,port:U.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else k.set(U.port,{host:U.ip,port:U.port,ppid:Number.MAX_VALUE})}return k}e.tryFindRootPorts=r;let o=class extends A.Disposable{constructor(l,p,k){super(),this.n=k,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new v.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=l.getProxy(a.MainContext.MainThreadTunnelService),E.isLinux&&p.remote.isRemote&&p.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(l,p){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${p.remoteAddress.host}:${p.remoteAddress.port}.`);const k=await this.a.$openTunnel(p,l.displayName);if(k){const L=new w(k.remoteAddress,k.localAddress,()=>this.a.$closeTunnel(k.remoteAddress));return this.B(L),L}}async getTunnels(){return this.a.$getTunnels()}p(l){return Math.max(l*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(l,p){const k=this.r();return this.l.set(k,{selector:l,provider:p}),this.a.$registerPortsAttributesProvider(l,k),new P.Disposable(()=>{this.l.delete(k),this.a.$unregisterPortsAttributesProvider(k)})}async $providePortAttributes(l,p,k,L,U){const K=[];for(const O of l){const B=this.l.get(O);if(!B)return[];K.push(...await Promise.all(p.map(async F=>B.provider.providePortAttributes(F,k,L,U))))}const G=K.filter(O=>!!O);return G.length>0?G.map(O=>({autoForwardAction:O.autoForwardAction,port:O.port})):[]}async $registerCandidateFinder(l){if(l&&this.h)return;this.h=l;const p=new g.MovingAverage;let k;for(;this.h;){const L=new Date().getTime(),U=(await this.findCandidatePorts()).filter(G=>(0,d.isLocalhost)(G.host)||(0,d.isAllInterfaces)(G.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(G=>G.port).join(", ")}`);const K=new Date().getTime()-L;p.update(K),(!k||JSON.stringify(k)!==JSON.stringify(U))&&(k=U,await this.a.$onFoundNewCandidates(k)),await new Promise(G=>setTimeout(()=>G(),this.p(p.value)))}}async setTunnelFactory(l){if(l){if(l.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this.c=l.showCandidatePort,this.a.$setCandidateFilter()),l.tunnelFactory){this.b=l.tunnelFactory;let p=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&p.length===0&&(p=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const k=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:p}:void 0;this.a.$setTunnelProvider(k)}}else this.b=void 0;return(0,A.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(l,p){if(this.f.has(l.host)){const k=this.f.get(l.host);k.has(l.port)&&(p&&k.get(l.port).disposeListener.dispose(),await k.get(l.port).tunnel.dispose(),k.delete(l.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(l,p){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const k=this.b(l,p);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),k!==void 0){const L=await k;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(l.remoteAddress.host)||this.f.set(l.remoteAddress.host,new Map);const U=this.B(L.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(L.remoteAddress))));return this.f.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:L,disposeListener:U}),y.TunnelDtoConverter.fromApiTunnel(L)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(l){const p=await Promise.all(l.map(L=>this.c(L.host,L.port,L.detail??""))),k=l.filter((L,U)=>p[U]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(L=>L.port).join(", ")} to ${k.map(L=>L.port).join(", ")}`),k}async findCandidatePorts(){let l="",p="";try{l=await R.Promises.readFile("/proc/net/tcp","utf8"),p=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const k=h(l,p),L=await new Promise(M=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(V,q,H)=>{M(q)})}),U=m(L),K=await R.Promises.readdir("/proc"),G=[];for(const M of K)try{const V=Number(M),q=C.joinPath(T.URI.file("/proc"),M);if((await R.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(V)){const J=await R.Promises.readlink(C.joinPath(q,"cwd").fsPath),Y=await R.Promises.readFile(C.joinPath(q,"cmdline").fsPath,"utf8");G.push({pid:V,cwd:J,cmd:Y})}}catch{}const O=[],B=k.filter(M=>{const V=U[M.socket];return V||O.push(M),V}),F=u(B,U,G);let $;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const M=await new Promise(V=>{(0,S.exec)("ps -F -A -l | grep root",(q,H,J)=>{V(H)})});this.j=r(O,M,this.j),$=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return F.then(M=>$?M.concat($):M)}};o=Ve([ze(0,t.IExtHostRpcService),ze(1,D.IExtHostInitDataService),ze(2,f.ILogService)],o),e.ExtHostTunnelService=o}),define(Se[281],ye([1,0,18,22,21,10,4,6,112,240,57]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(k,L){try{return JSON.stringify(k,L)}catch{return"null"}}const y="$$ref$$",v={[y]:-1};class d{constructor(L,U){this.jsonString=L,this.referencedBuffers=U}}function g(k,L=null,U=!1){const K=[];return{jsonString:(U?E:JSON.stringify)(k,(O,B)=>{if(typeof B>"u")return v;if(typeof B=="object"){if(B instanceof t.VSBuffer){const F=K.push(B)-1;return{[y]:F}}if(L)return L(O,B)}return B}),referencedBuffers:K}}e.stringifyJsonWithBufferRefs=g;function f(k,L,U){return JSON.parse(k,(K,G)=>{if(G){const O=G[y];if(typeof O=="number")return L[O];if(U&&G.$mid===1)return U.transformIncoming(G)}return G})}e.parseJsonAndRestoreBufferRefs=f;function w(k,L){return JSON.stringify(k,L)}function m(k){return k?(L,U)=>U&&U.$mid===1?k.transformOutgoing(U):U:null}var h;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},i=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class u extends T.Disposable{constructor(L,U=null,K=null){super(),this[P]=!0,this.b=this.B(new D.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=U,this.g=K,this.h=m(this.g),this.j=!1,this.k=[],this.l=[];for(let G=0,O=R.ProxyIdentifier.count;G<O;G++)this.k[G]=null,this.l[G]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.D(),1e3)),this.c.onMessage(G=>this.H(G))}dispose(){this.j=!0,Object.keys(this.s).forEach(L=>{this.s[L].resolveErr(A.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(L){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}C(L){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.F(0)}D(){this.u!==0&&(Date.now()>this.v?this.F(1):this.w.schedule())}F(L){this.t!==L&&(this.t=L,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(L){return this.g?(0,S.transformIncomingURIs)(L,this.g):L}getProxy(L){const{nid:U,sid:K}=L;return this.l[U]||(this.l[U]=this.G(U,K)),this.l[U]}G(L,U){const K={get:(G,O)=>(typeof O=="string"&&!G[O]&&O.charCodeAt(0)===36&&(G[O]=(...B)=>this.P(L,O,B)),O===c?U:G[O])};return new Proxy(Object.create(null),K)}set(L,U){return this.k[L.nid]=U,U}assertRegistered(L){for(let U=0,K=L.length;U<K;U++){const G=L[U];if(!this.k[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}H(L){if(this.j)return;const U=L.byteLength,K=r.read(L,0),G=K.readUInt8(),O=K.readUInt32();switch(G){case 1:case 2:{let{rpcId:B,method:F,args:$}=n.deserializeRequestJSONArgs(K);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.I(U,O,B,F,$,G===2);break}case 3:case 4:{let{rpcId:B,method:F,args:$}=n.deserializeRequestMixedArgs(K);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.I(U,O,B,F,$,G===4);break}case 5:{this.f?.logIncoming(U,O,0,"ack"),this.C(O);break}case 6:{this.J(U,O);break}case 7:{this.L(U,O,void 0);break}case 9:{let B=n.deserializeReplyOKJSON(K);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.L(U,O,B);break}case 10:{const B=n.deserializeReplyOKJSONWithBuffers(K,this.g);this.L(U,O,B);break}case 8:{const B=n.deserializeReplyOKVSBuffer(K);this.L(U,O,B);break}case 11:{let B=n.deserializeReplyErrError(K);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.M(U,O,B);break}case 12:{this.M(U,O,void 0);break}default:console.error("received unexpected message"),console.error(L)}}I(L,U,K,G,O,B){this.f?.logIncoming(L,U,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(K)}.${G}(`,O);const F=String(U);let $,M;if(B){const q=new I.CancellationTokenSource;O.push(q.token),$=this.N(K,G,O),M=()=>q.cancel()}else $=this.N(K,G,O),M=s;this.p[F]=M;const V=n.serializeAcknowledged(U);this.f?.logOutgoing(V.byteLength,U,1,"ack"),this.c.send(V),$.then(q=>{delete this.p[F];const H=n.serializeReplyOK(U,q,this.h);this.f?.logOutgoing(H.byteLength,U,1,"reply:",q),this.c.send(H)},q=>{delete this.p[F];const H=n.serializeReplyErr(U,q);this.f?.logOutgoing(H.byteLength,U,1,"replyErr:",q),this.c.send(H)})}J(L,U){this.f?.logIncoming(L,U,1,"receiveCancel");const K=String(U);this.p[K]?.()}L(L,U,K){this.f?.logIncoming(L,U,0,"receiveReply:",K);const G=String(U);if(!this.s.hasOwnProperty(G))return;const O=this.s[G];delete this.s[G],O.resolveOk(K)}M(L,U,K){this.f?.logIncoming(L,U,0,"receiveReplyErr:",K);const G=String(U);if(!this.s.hasOwnProperty(G))return;const O=this.s[G];delete this.s[G];let B;K&&(K.$isError?(B=new Error,B.name=K.name,B.message=K.message,B.stack=K.stack):B=K),O.resolveErr(B)}N(L,U,K){try{return Promise.resolve(this.O(L,U,K))}catch(G){return Promise.reject(G)}}O(L,U,K){const G=this.k[L];if(!G)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const O=G[U];if(typeof O!="function")throw new Error("Unknown method "+U+" on actor "+(0,R.getStringIdentifierForProxy)(L));return O.apply(G,K)}P(L,U,K){if(this.j)return new C.CanceledLazyPromise;let G=null;if(K.length>0&&I.CancellationToken.isCancellationToken(K[K.length-1])&&(G=K.pop()),G&&G.isCancellationRequested)return Promise.reject(A.canceled());const O=n.serializeRequestArguments(K,this.h),B=++this.m,F=String(B),$=new C.LazyPromise;G&&G.onCancellationRequested(()=>{const V=n.serializeCancel(B);this.f?.logOutgoing(V.byteLength,B,0,"cancel"),this.c.send(n.serializeCancel(B))}),this.s[F]=$,this.y(B);const M=n.serializeRequest(B,L,U,O,!!G);return this.f?.logOutgoing(M.byteLength,B,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${U}(`,K),this.c.send(M),$}}e.RPCProtocol=u,P=i,u.a=3*1e3;class r{static alloc(L,U,K){const G=new r(t.VSBuffer.alloc(K+1+4),0);return G.writeUInt8(L),G.writeUInt32(U),G}static read(L,U){return new r(L,U)}get buffer(){return this.a}constructor(L,U){this.a=L,this.b=U}static sizeUInt8(){return 1}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+L).toString();return this.b+=L,K}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+L).toString();return this.b+=L,K}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+L);return this.b+=L,U}static sizeMixedArray(L){let U=0;U+=1;for(let K=0,G=L.length;K<G;K++){const O=L[K];switch(U+=1,O.type){case 1:U+=this.sizeLongString(O.value);break;case 2:U+=this.sizeVSBuffer(O.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString(O.value);for(let B=0;B<O.buffers.length;++B)U+=this.sizeVSBuffer(O.buffers[B]);break;case 4:break}}return U}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let U=0,K=L.length;U<K;U++){const G=L[U];switch(G.type){case 1:this.writeUInt8(1),this.writeLongString(G.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(G.value);break;case 3:this.writeUInt8(3),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let O=0;O<G.buffers.length;++O)this.writeBuffer(G.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const U=new Array(L);for(let K=0;K<L;K++)switch(this.readUInt8()){case 1:U[K]=this.readLongString();break;case 2:U[K]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),B=this.readLongString(),F=[];for(let $=0;$<O;++$)F.push(this.readVSBuffer());U[K]=new R.SerializableObjectWithBuffers(f(B,F,null));break}case 4:U[K]=void 0;break}return U}}r.sizeUInt32=4;var o;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(o||(o={}));class n{static a(L){for(let U=0,K=L.length;U<K;U++)if(L[U]instanceof t.VSBuffer||L[U]instanceof R.SerializableObjectWithBuffers||typeof L[U]>"u")return!0;return!1}static serializeRequestArguments(L,U){if(this.a(L)){const K=[];for(let G=0,O=L.length;G<O;G++){const B=L[G];if(B instanceof t.VSBuffer)K[G]={type:2,value:B};else if(typeof B>"u")K[G]={type:4};else if(B instanceof R.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:$}=g(B.value,U);K[G]={type:3,value:t.VSBuffer.fromString(F),buffers:$}}else K[G]={type:1,value:t.VSBuffer.fromString(w(B,U))}}return{type:1,args:K}}return{type:0,args:w(L,U)}}static serializeRequest(L,U,K,G,O){switch(G.type){case 0:return this.b(L,U,K,G.args,O);case 1:return this.c(L,U,K,G.args,O)}}static b(L,U,K,G,O){const B=t.VSBuffer.fromString(K),F=t.VSBuffer.fromString(G);let $=0;$+=r.sizeUInt8(),$+=r.sizeShortString(B),$+=r.sizeLongString(F);const M=r.alloc(O?2:1,L,$);return M.writeUInt8(U),M.writeShortString(B),M.writeLongString(F),M.buffer}static deserializeRequestJSONArgs(L){const U=L.readUInt8(),K=L.readShortString(),G=L.readLongString();return{rpcId:U,method:K,args:JSON.parse(G)}}static c(L,U,K,G,O){const B=t.VSBuffer.fromString(K);let F=0;F+=r.sizeUInt8(),F+=r.sizeShortString(B),F+=r.sizeMixedArray(G);const $=r.alloc(O?4:3,L,F);return $.writeUInt8(U),$.writeShortString(B),$.writeMixedArray(G),$.buffer}static deserializeRequestMixedArgs(L){const U=L.readUInt8(),K=L.readShortString(),G=L.readMixedArray(),O=new Array(G.length);for(let B=0,F=G.length;B<F;B++){const $=G[B];typeof $=="string"?O[B]=JSON.parse($):O[B]=$}return{rpcId:U,method:K,args:O}}static serializeAcknowledged(L){return r.alloc(5,L,0).buffer}static serializeCancel(L){return r.alloc(6,L,0).buffer}static serializeReplyOK(L,U,K){if(typeof U>"u")return this.d(L);if(U instanceof t.VSBuffer)return this.e(L,U);if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:G,referencedBuffers:O}=g(U.value,K,!0);return this.g(L,G,O)}else return this.f(L,E(U,K))}static d(L){return r.alloc(7,L,0).buffer}static e(L,U){let K=0;K+=r.sizeVSBuffer(U);const G=r.alloc(8,L,K);return G.writeVSBuffer(U),G.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,U){const K=t.VSBuffer.fromString(U);let G=0;G+=r.sizeLongString(K);const O=r.alloc(9,L,G);return O.writeLongString(K),O.buffer}static g(L,U,K){const G=t.VSBuffer.fromString(U);let O=0;O+=r.sizeUInt32,O+=r.sizeLongString(G);for(const F of K)O+=r.sizeVSBuffer(F);const B=r.alloc(10,L,O);B.writeUInt32(K.length),B.writeLongString(G);for(const F of K)B.writeBuffer(F);return B.buffer}static deserializeReplyOKJSON(L){const U=L.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(L,U){const K=L.readUInt32(),G=L.readLongString(),O=[];for(let B=0;B<K;++B)O.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(f(G,O,U))}static serializeReplyErr(L,U){const K=U?E(A.transformErrorForSerialization(U),null):void 0;if(typeof K!="string")return this.h(L);const G=t.VSBuffer.fromString(K);let O=0;O+=r.sizeLongString(G);const B=r.alloc(11,L,O);return B.writeLongString(G),B.buffer}static deserializeReplyErrError(L){const U=L.readLongString();return JSON.parse(U)}static h(L){return r.alloc(12,L,0).buffer}}var l;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var p;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(p||(p={}))}),define(Se[282],ye([1,0,4,43,53,3,38,10,18]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(d=>v.push(d)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}t.Registry.add(e.Extensions.OutputChannels,new R);function P(y,v,d,g,f){return(0,S.createCancelablePromise)(async w=>{await(0,D.whenProviderRegistered)(d,g);const m=t.Registry.as(e.Extensions.OutputChannels);try{await E(d,1,g,f,w),m.registerChannel({id:y,label:v,file:d,log:!0})}catch(h){(0,T.isCancellationError)(h)||f.error("Error while registering log channel",d.toString(),(0,T.getErrorMessage)(h))}})}e.registerLogChannel=P;async function E(y,v,d,g,f){if(!await d.exists(y)){if(f.isCancellationRequested)throw new T.CancellationError;if(v>10)throw new Error("Timed out while waiting for file to be created");g.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",y.toString()),await(0,S.timeout)(1e3,f),await E(y,v+1,d,g,f)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(Se[141],ye([1,0,5,3,16,27,13,282,70,25,46,155,22,11,38,4,6]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class f extends D.AbstractMessageLogger{get disposed(){return this.k}constructor(b,s,i,c,u){super(),this.id=b,this.name=s,this.l=i,this.m=c,this.extension=u,this.j=0,this.k=!1,this.visible=!1,this.setLevel(i.getLevel()),this.B(i.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.j;this.l.flush(),this.m.$update(this.id,T.OutputChannelUpdateMode.Clear,b)}replace(b){const s=this.j;this.info(b),this.m.$update(this.id,T.OutputChannelUpdateMode.Replace,s),this.visible&&this.l.flush()}show(b,s){this.l.flush(),this.m.$reveal(this.id,!!(typeof b=="boolean"?b:s))}hide(){this.m.$close(this.id)}f(b,s){this.j+=E.VSBuffer.fromString(s).byteLength,(0,D.log)(this.l,b,s),this.visible&&(this.l.flush(),this.m.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.k||(this.m.$dispose(this.id),this.k=!0)}}class w extends f{appendLine(b){this.append(b)}}let m=class{constructor(b,s,i,c,u,r){this.i=s,this.j=i,this.k=c,this.l=u,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[s,i]of this.g)i.visible=s===this.h}createOutputChannel(b,s,i){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const c=typeof s=="object"&&s.log,u=(0,y.isString)(s)?s:void 0;if((0,y.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const o=this.i.environment.extensionLogLevel?.find(([l])=>A.ExtensionIdentifier.equals(i.identifier,l))?.[1];o&&(r=(0,D.parseLogLevel)(o));const n=c?this.o(b,r,i):this.n(b,u,i);return n.then(l=>{this.g.set(l.id,l),l.visible=l.id===this.h}),c?this.r(b,r??this.m.getLevel(),n):this.q(b,n)}async n(b,s,i){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,u=this.k.extUri.joinPath(c,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),o=await this.a.$register(b,u,!1,s,i.identifier.value);return new f(o,b,r,this.a,i)}async o(b,s,i){const c=await this.p(i),u=this.k.extUri.joinPath(c,`${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(u,{name:b},s),o=await this.a.$register(b,u,!0,void 0,i.identifier.value);return new w(o,b,r,this.a,i)}p(b){let s=this.d.get(b.identifier.value);if(!s){const i=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(i)}catch(c){if((0,v.toFileSystemProviderErrorCode)(c)!==v.FileSystemProviderErrorCode.FileExists)throw c}return i})())}return s}q(b,s){let i=!1;const c=()=>{if(i)throw new Error("Channel has been closed")};return{get name(){return b},append(u){c(),s.then(r=>r.append(u))},appendLine(u){c(),s.then(r=>r.appendLine(u))},clear(){c(),s.then(u=>u.clear())},replace(u){c(),s.then(r=>r.replace(u))},show(u,r){c(),s.then(o=>o.show(u,r))},hide(){c(),s.then(u=>u.hide())},dispose(){i=!0,s.then(u=>u.dispose())}}}r(b,s,i){const c=new g.DisposableStore,u=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},r=c.add(new d.Emitter);return i.then(o=>{c.add(o),c.add(o.onDidChangeLogLevel(n=>{s=n,r.fire(n)}))}),{...this.q(b,i),get logLevel(){return s},onDidChangeLogLevel:r.event,trace(o,...n){u(),i.then(l=>l.trace(o,...n))},debug(o,...n){u(),i.then(l=>l.debug(o,...n))},info(o,...n){u(),i.then(l=>l.info(o,...n))},warn(o,...n){u(),i.then(l=>l.warn(o,...n))},error(o,...n){u(),i.then(l=>l.error(o,...n))},dispose(){c.dispose()}}}};m=Ve([ze(0,I.IExtHostRpcService),ze(1,C.IExtHostInitDataService),ze(2,S.IExtHostConsumerFileSystem),ze(3,R.IExtHostFileSystemInfo),ze(4,D.ILoggerService),ze(5,D.ILogService)],m),e.ExtHostOutputService=m,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(Se[283],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Se[284],ye([1,0,32,15,9,12,24,2,3,209,45,226,283]),function(te,e,a,t,I,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class ri{constructor(d,g,f,w){this.d=d,this.e=g,this.f=f,this.g=w,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??d})()}hasValidBasename(d,g,f){return typeof g=="string"||typeof g>"u"?this.a.then(w=>this.h(d,w,g)):this.h(d,g,f)}h(d,g,f){return d.scheme===t.Schemas.file||d.scheme===t.Schemas.vscodeRemote?(0,a.isValidBasename)(f??(0,D.basename)(d),g===1):!0}get defaultUriScheme(){return ri.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,g){if(d.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,C.getVirtualWorkspaceScheme)(g.getWorkspace());if(f)return f;const w=g.getWorkspace().folders[0];if(w)return w.uri.scheme;const m=g.getWorkspace().configuration;return m?m.scheme:t.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?I.win32:I.posix)}async fileURI(d){let g="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const w=d.indexOf("/",2);w===-1?(g=d.substring(2),d="/"):(g=d.substring(2,w),d=d.substring(w)||"/")}return T.URI.from({scheme:t.Schemas.file,authority:g,path:d,query:"",fragment:""})}};y=Ve([ze(1,E.IRemoteAgentService),ze(2,P.IWorkbenchEnvironmentService),ze(3,R.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(Se[73],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(D,T){this.line=D,this.character=T}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,T){return new a(0,0)}with(D){return new a(0,0)}}e.Position=a;class t{constructor(D,T,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(D,T),this.end=new a(S,C)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new t(0,0,0,0)}with(D){return new t(0,0,0,0)}}e.Range=t;var I;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Se[31],ye([1,0,17,37,23,32,8,3,9,10,73,18]),function(te,e,a,t,I,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",y=" characters skipped \u27EB",v=(E.length+y.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var d;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function f(Y){return!!Y.preview}e.resultIsMatch=f;function w(Y){return!!Y.resource}e.isFileMatch=w;function m(Y){return!!Y.message}e.isProgressMessage=m;var h;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(ae){this.resource=ae,this.results=[]}}e.FileMatch=b;class s{constructor(ae,re,fe){this.ranges=re;const Z=Array.isArray(re)?re:[re];if(fe&&fe.matchLines===1&&i(Z)){ae=(0,D.getNLines)(ae,fe.matchLines);let pe="",we=0,De=0;const Re=Math.floor(fe.charsPerLine/5),Be=[];for(const se of Z){const ue=Math.max(se.startColumn-Re,0),de=se.startColumn+fe.charsPerLine;if(ue>De+Re+v){const ee=E+(ue-De)+y;pe+=ee+ae.slice(ue,de),we+=ue-(De+ee.length)}else pe+=ae.slice(De,de);Be.push(new u(0,se.startColumn-we,se.endColumn-we)),De=de}this.preview={text:pe,matches:Array.isArray(this.ranges)?Be:Be[0]}}else{const pe=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:ae,matches:(0,a.mapArrayOrNot)(re,we=>new c(we.startLineNumber-pe,we.startColumn,we.endLineNumber-pe,we.endColumn))}}}}e.TextSearchMatch=s;function i(Y){const ae=Y[0].startLineNumber;for(const re of Y)if(re.startLineNumber!==ae||re.endLineNumber!==ae)return!1;return!0}class c{constructor(ae,re,fe,Z){this.startLineNumber=ae,this.startColumn=re,this.endLineNumber=fe,this.endColumn=Z}}e.SearchRange=c;class u extends c{constructor(ae,re,fe){super(ae,re,ae,fe)}}e.OneLineRange=u;var r;(function(Y){Y.List="list",Y.Tree="tree"})(r=e.ViewMode||(e.ViewMode={}));var o;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Y,ae=!0){const re=Y&&Y.files&&Y.files.exclude,fe=ae&&Y&&Y.search&&Y.search.exclude;if(!re&&!fe)return;if(!re||!fe)return re||fe;let Z=Object.create(null);return Z=I.mixin(Z,I.deepClone(re)),Z=I.mixin(Z,I.deepClone(fe),!0),Z}e.getExcludes=n;function l(Y,ae){return Y.excludePattern&&t.match(Y.excludePattern,ae)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&t.match(Y.includePattern,ae)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(re=>{const fe=re.folder.fsPath;if(A.isEqualOrParent(ae,fe)){const Z=S.relative(fe,ae);return!re.includePattern||!!t.match(re.includePattern,Z)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var p;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class k extends Error{constructor(ae,re){super(ae),this.code=re}}e.SearchError=k;function L(Y){const ae=Y.message;if((0,C.isCancellationError)(Y))return new k(ae,p.canceled);try{const re=JSON.parse(ae);return new k(re.message,re.code)}catch{return new k(ae,p.other)}}e.deserializeSearchError=L;function U(Y){const ae={message:Y.message,code:Y.code};return new Error(JSON.stringify(ae))}e.serializeSearchError=U;function K(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=K;function G(Y){return Y.type==="success"}e.isSerializedSearchSuccess=G;function O(Y){return!!Y.path}e.isSerializedFileMatch=O;function B(Y,ae){const re=Y.searchPath?Y.searchPath:Y.relativePath;return(0,D.fuzzyContains)(re,ae)}e.isFilePatternMatch=B;class F{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function $(Y,ae){const re={...Y||{},...ae||{}};return Object.keys(re).filter(fe=>{const Z=re[fe];return typeof Z=="boolean"&&Z})}e.resolvePatternsForProvider=$;class M{constructor(ae,re){this.c=null,this.a={...ae.excludePattern||{},...re.excludePattern||{}},this.b=t.parse(this.a);let fe=ae.includePattern;re.includePattern&&(fe?fe={...fe,...re.includePattern}:fe=re.includePattern),fe&&(this.c=t.parse(fe))}matchesExcludesSync(ae,re,fe){return!!(this.b&&this.b(ae,re,fe))}includedInQuerySync(ae,re,fe){return!(this.b&&this.b(ae,re,fe)||this.c&&!this.c(ae,re,fe))}includedInQuery(ae,re,fe){const Z=this.b(ae,re,fe),pe=()=>this.c?!!this.c(ae,re,fe):!0;return(0,P.isThenable)(Z)?Z.then(we=>we?!1:pe()):pe()}hasSiblingExcludeClauses(){return V(this.a)}}e.QueryGlobTester=M;function V(Y){for(const ae in Y)if(typeof Y[ae]!="boolean")return!0;return!1}function q(Y){if(!Y)return;let ae;return re=>(ae||(ae=(Y()||Promise.resolve([])).then(fe=>fe?J(fe):{})),ae.then(fe=>!!fe[re]))}e.hasSiblingPromiseFn=q;function H(Y){if(!Y)return;let ae;return re=>{if(!ae){const fe=Y();ae=fe?J(fe):{}}return!!ae[re]}}e.hasSiblingFn=H;function J(Y){const ae={};for(const re of Y)ae[re]=!0;return ae}}),define(Se[33],ye([1,0,17,18,21,4,6,64,15,100,24,8,11,2,178,3,13,198,45,46,25,16,14,7,55,31,5]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m,h,b,s,i,c,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(G,O,B){return new R.ExtUri(F=>k(F,B)).isEqual(G,O)}function n(G,O,B){return o(G.uri,O.uri,B)?0:(0,P.compare)(G.uri.toString(),O.uri.toString())}function l(G,O,B){return G.index!==O.index?G.index<O.index?-1:1:o(G.uri,O.uri,B)?(0,P.compare)(G.name,O.name):(0,P.compare)(G.uri.toString(),O.uri.toString())}function p(G,O,B,F){const $=G.slice(0).sort((V,q)=>B(V,q,F)),M=O.slice(0).sort((V,q)=>B(V,q,F));return(0,a.delta)($,M,(V,q)=>B(V,q,F))}function k(G,O){const B=O.getCapabilities(G.scheme);return!(B&&B&1024)}class L extends w.Workspace{static toExtHostWorkspace(O,B,F,$){if(!O)return{workspace:null,added:[],removed:[]};const{id:M,name:V,folders:q,configuration:H,transient:J,isUntitled:Y}=O,ae=[],re=B;B?q.forEach((we,De)=>{const Re=y.URI.revive(we.uri),Be=L.e(F||B,Re,$);Be?(Be.name=we.name,Be.index=we.index,ae.push(Be)):ae.push({uri:Re,name:we.name,index:De})}):ae.push(...q.map(({uri:we,name:De,index:Re})=>({uri:y.URI.revive(we),name:De,index:Re}))),ae.sort((we,De)=>we.index<De.index?-1:1);const fe=new L(M,V,ae,!!J,H?y.URI.revive(H):null,!!Y,we=>k(we,$)),{added:Z,removed:pe}=p(re?re.workspaceFolders:[],fe.workspaceFolders,n,$);return{workspace:fe,added:Z,removed:pe}}static e(O,B,F){for(let $=0;$<O.folders.length;$++){const M=O.workspaceFolders[$];if(o(M.uri,B,F))return M}}constructor(O,B,F,$,M,V,q){super(O,F.map(H=>new w.WorkspaceFolder(H)),$,M,q),this.s=B,this.t=V,this.o=[],this.q=T.TernarySearchTree.forUris(q),F.forEach(H=>{this.o.push(H),this.q.set(H.uri,H)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(O,B){return B&&this.q.get(O)&&(O=(0,R.dirname)(O)),this.q.findSubstr(O)}resolveWorkspaceFolder(O){return this.q.get(O)}}let U=class{constructor(O,B,F,$,M){this.c=new A.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new A.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=$,this.q=F,this.s=M,this.h=new C.Counter,this.j=new t.Barrier,this.n=O.getProxy(r.MainContext.MainThreadWorkspace),this.o=O.getProxy(r.MainContext.MainThreadMessageService);const V=B.workspace;this.k=V?new L(V.id,V.name,[],!!V.transient,V.configuration?y.URI.revive(V.configuration):null,!!V.isUntitled,q=>k(q,F)):void 0}$initializeWorkspace(O,B){this.u=B,this.$acceptWorkspaceData(O),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?y.URI.from({scheme:S.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(O,B,F,...$){const M=[];if(Array.isArray($)&&$.forEach(Y=>{y.URI.isUri(Y.uri)&&!M.some(ae=>o(ae.uri,Y.uri,this.q))&&M.push({uri:Y.uri,name:Y.name||(0,R.basenameOrAuthority)(Y.uri)})}),this.l||[B,F].some(Y=>typeof Y!="number"||Y<0)||F===0&&M.length===0)return!1;const V=this.w?this.w.workspaceFolders:[];if(B+F>V.length)return!1;const q=V.slice(0);q.splice(B,F,...M.map(Y=>({uri:Y.uri,name:Y.name||(0,R.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<q.length;Y++){const ae=q[Y];if(q.some((re,fe)=>fe!==Y&&o(ae.uri,re.uri,this.q)))return!1}q.forEach((Y,ae)=>Y.index=ae);const{added:H,removed:J}=p(V,q,l,this.q);if(H.length===0&&J.length===0)return!1;if(this.n){const Y=O.displayName||O.name;this.n.$updateWorkspaceFolders(Y,B,F,M).then(void 0,ae=>{this.l=void 0;const re={source:{identifier:O.identifier,label:O.displayName||O.name}};this.o.$showMessage(f.Severity.Error,(0,v.localize)(0,null,Y,ae.toString()),re,[])})}return this.x(q),!0}getWorkspaceFolder(O,B){if(!!this.w)return this.w.getWorkspaceFolder(O,B)}async getWorkspaceFolder2(O,B){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(O,B)}async resolveWorkspaceFolder(O){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(O)}getPath(){if(!this.w)return;const{folders:O}=this.w;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,B){let F,$="";if(typeof O=="string"?(F=y.URI.file(O),$=O):typeof O<"u"&&(F=O,$=O.fsPath),!F)return $;const M=this.getWorkspaceFolder(F,!0);if(!M)return $;typeof B>"u"&&this.w&&(B=this.w.folders.length>1);let V=(0,R.relativePath)(M.uri,F);return B&&M.name&&(V=`${M.name}/${V}`),V}x(O){this.w&&(this.l=L.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:O,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:B,added:F,removed:$}=L.toExtHostWorkspace(O,this.k,this.l,this.q);this.k=B||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:$}))}findFiles(O,B,F,$,M=I.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let V;if(B===null?V=!1:B&&(typeof B=="string"?V=B:V=B.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:q,folder:H}=K(s.GlobPattern.from(O));return this.n.$startFileSearch((0,E.withUndefinedAsNull)(q),(0,E.withUndefinedAsNull)(H),(0,E.withUndefinedAsNull)(V),(0,E.withUndefinedAsNull)(F),M).then(J=>Array.isArray(J)?J.map(Y=>y.URI.revive(Y)):[])}async findTextInFiles(O,B,F,$,M=I.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const V=this.h.getNext(),q=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:H,folder:J}=K(s.GlobPattern.from(B.include)),Y=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ae={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:q,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:H,excludePattern:Y},re=!1;if(this.t[V]=fe=>{if(re)return;const Z=y.URI.revive(fe.resource);fe.results.forEach(pe=>{(0,u.resultIsMatch)(pe)?F({uri:Z,preview:{text:pe.preview.text,matches:(0,a.mapArrayOrNot)(pe.preview.matches,we=>new i.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,a.mapArrayOrNot)(pe.ranges,we=>new i.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):F({uri:Z,text:pe.text,lineNumber:pe.lineNumber})})},M.isCancellationRequested)return{};try{const fe=await this.n.$startTextSearch(O,(0,E.withUndefinedAsNull)(J),ae,V,M);return delete this.t[V],fe||{}}catch(fe){throw delete this.t[V],fe}}$handleTextSearchResult(O,B){this.t[B]?.(O)}saveAll(O){return this.n.$saveAll(O)}resolveProxy(O){return this.n.$resolveProxy(O)}get trusted(){return this.u}requestWorkspaceTrust(O){return this.n.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(O,B){if(this.v.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.v.set(O,B);const F=this.s.transformOutgoingScheme(O),$=this.y++;return this.n.$registerEditSessionIdentityProvider($,F),(0,D.toDisposable)(()=>{this.v.delete(O),this.n.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(O,B){this.g.info("Getting edit session identifier for workspaceFolder",O);const F=await this.resolveWorkspaceFolder(y.URI.revive(O));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const $=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!$),!$)return;const M=await $.provideEditSessionIdentity(F,B);if(this.g.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(O,B,F,$){this.g.info("Getting edit session identifier for workspaceFolder",O);const M=await this.resolveWorkspaceFolder(y.URI.revive(O));if(!M){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const V=this.v.get(M.uri.scheme);if(this.g.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!V),!V)return;const q=await V.provideEditSessionIdentityMatch?.(B,F,$);if(this.g.info("Provider returned edit session identifier match result: ",q),!!q)return q}};U=Ve([ze(0,b.IExtHostRpcService),ze(1,h.IExtHostInitDataService),ze(2,m.IExtHostFileSystemInfo),ze(3,g.ILogService),ze(4,c.IURITransformerService)],U),e.ExtHostWorkspace=U,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function K(G){let O,B;return G&&(typeof G=="string"?O=G:(O=G.pattern,B=y.URI.revive(G.baseUri))),{includePattern:O,folder:B}}}),define(Se[34],ye([1,0,23,4,33,5,7,201,126,11,18,3,16,13,2]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(i,c){if(c){const u=c.split(".");let r=i;for(let o=0;r&&o<u.length;o++)r=r[u[o]];return r}}function g(i){return i instanceof v.URI}function f(i){return i&&i.uri instanceof v.URI&&i.languageId&&typeof i.languageId=="string"}function w(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function m(i){return i&&i.uri instanceof v.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function h(i){if(g(i))return{resource:i};if(f(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(w(i))return{overrideIdentifier:i.languageId};if(m(i))return{resource:i.uri};if(i===null)return{resource:null}}let b=class{constructor(c,u,r){this.a=c.getProxy(A.MainContext.MainThreadConfiguration),this.c=u,this.b=r,this.d=new R.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new s(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,u){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(c,u))}};b=Ve([ze(0,E.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,y.ILogService)],b),e.ExtHostConfiguration=b;class s{constructor(c,u,r,o){this.a=new t.Emitter,this.b=c,this.f=o,this.c=u,this.e=T.Configuration.parse(r),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,u){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=T.Configuration.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(u,r))}getConfiguration(c,u,r){const o=h(u)||{},n=this.g(c?d(this.e.getValue(void 0,o,this.c.workspace),c):this.e.getValue(void 0,o,this.c.workspace));c&&this.h(c,o,r?.identifier);function l(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(k){return typeof d(n,k)<"u"},get:(k,L)=>{this.h(c?`${c}.${k}`:k,o,r?.identifier);let U=d(n,k);if(typeof U>"u")U=L;else{let K;const G=(O,B)=>{let F;const $=()=>{K=K||(0,a.deepClone)(n),F=F||d(K,B)};return(0,C.isObject)(O)?new Proxy(O,{get:(M,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return $(),()=>F;if(K)return F=F||d(K,B),F[V];const q=M[V];return typeof V=="string"?G(q,`${B}.${V}`):q},set:(M,V,q)=>($(),F&&(F[V]=q),!0),deleteProperty:(M,V)=>($(),F&&delete F[V],!0),defineProperty:(M,V,q)=>($(),F&&Object.defineProperty(F,V,q),!0)}):O};U=G(U,k)}return U},update:(k,L,U,K)=>{k=c?`${c}.${k}`:k;const G=l(U);return L!==void 0?this.b.$updateConfigurationOption(G,k,L,o,K):this.b.$removeConfigurationOption(G,k,o,K)},inspect:k=>{k=c?`${c}.${k}`:k;const L=this.e.inspect(k,o,this.c.workspace);if(L)return{key:k,defaultValue:(0,a.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,a.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,a.deepClone)(L.workspace?.value),workspaceFolderValue:(0,a.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(L.default?.override),globalLanguageValue:(0,a.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,a.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(L.workspaceFolder?.override),languageIds:(0,a.deepClone)(L.overrideIdentifiers)}}};return typeof n=="object"&&(0,a.mixin)(p,n,!1),Object.freeze(p)}g(c){const u=r=>(0,C.isObject)(r)?new Proxy(r,{get:(o,n)=>u(o[n]),set:(o,n,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(o,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(o,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return u(c)}h(c,u,r){const o=S.OVERRIDE_PROPERTY_REGEX.test(c)?4:this.d.get(c),n=r?`[${r.value}] `:"";if(o===4){typeof u?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){u?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,u){const r=new T.ConfigurationChangeEvent(c,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(o,n)=>r.affectsConfiguration(o,h(n))})}k(c){return c.reduce((u,r)=>(u.set(r[0],r[1]),u),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a},Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[74],ye([1,0,2,18,4,5,7,33,58,34,21,40,16,25,3,15,12,13,69,239,10]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m,h){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(O){function B($){if($!=null)return $}O.from=B;function F($){if($!=null)return $}O.to=F})(s||(s={}));var i;(function(O){function B($){if($!=null)return $}O.from=B;function F($){if($!=null)return $}O.to=F})(i||(i={}));var c;(function(O){function B($){if($!=null)return $}O.from=B;function F($){if($!=null)return $}O.to=F})(c||(c={}));var u;(function(O){function B(M){if(M){const V=M;return V&&!!V.process}else return!1}O.is=B;function F(M){if(M==null)return;const V={process:M.process,args:M.args};return M.options&&(V.options=c.from(M.options)),V}O.from=F;function $(M){if(M!=null)return new D.ProcessExecution(M.process,M.args,M.options)}O.to=$})(u||(u={}));var r;(function(O){function B($){if($!=null)return $}O.from=B;function F($){if($!=null)return $}O.to=F})(r||(r={}));var o;(function(O){function B(M){if(M){const V=M;return V&&(!!V.commandLine||!!V.command)}else return!1}O.is=B;function F(M){if(M==null)return;const V={};return M.commandLine!==void 0?V.commandLine=M.commandLine:(V.command=M.command,V.args=M.args),M.options&&(V.options=r.from(M.options)),V}O.from=F;function $(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new D.ShellExecution(M.commandLine,M.options):new D.ShellExecution(M.command,M.args?M.args:[],M.options)}O.to=$})(o||(o={}));var n;(function(O){function B(M){if(M){const V=M;return V&&V.customExecution==="customExecution"}else return!1}O.is=B;function F(M){return{customExecution:"customExecution"}}O.from=F;function $(M,V){return V.get(M)}O.to=$})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var l;(function(O){function B(F,$){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===D.TaskScope.Workspace&&$&&$.workspaceFile?M=$.workspaceFile:M=m.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}O.from=B})(l=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(O){function B(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}O.from=B})(p||(p={}));var k;(function(O){function B(M,V){if(M==null)return[];const q=[];for(const H of M){const J=F(H,V);J&&q.push(J)}return q}O.fromMany=B;function F(M,V){if(M==null)return;let q;M.execution instanceof D.ProcessExecution?q=u.from(M.execution):M.execution instanceof D.ShellExecution?q=o.from(M.execution):M.execution&&M.execution instanceof D.CustomExecution&&(q=n.from(M.execution));const H=s.from(M.definition);let J;return M.scope?typeof M.scope=="number"?J=M.scope:J=M.scope.uri:J=D.TaskScope.Workspace,!H||!J?void 0:{_id:M._id,definition:H,name:M.name,source:{extensionId:V.identifier.value,label:M.source,scope:J},execution:q,isBackground:M.isBackground,group:p.from(M.group),presentationOptions:i.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}O.from=F;async function $(M,V,q){if(M==null)return;let H;u.is(M.execution)?H=u.to(M.execution):o.is(M.execution)?H=o.to(M.execution):n.is(M.execution)&&(H=n.to(M._id,q));const J=s.to(M.definition);let Y;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?Y=M.source.scope:Y=await V.resolveWorkspaceFolder(a.URI.revive(M.source.scope)):Y=D.TaskScope.Workspace),!J||!Y)return;const ae=new D.Task(J,Y,M.name,M.source.label,H,M.problemMatchers);return M.isBackground!==void 0&&(ae.isBackground=M.isBackground),M.group!==void 0&&(ae.group=D.TaskGroup.from(M.group._id),ae.group&&M.group.isDefault&&(ae.group=new D.TaskGroup(ae.group.id,ae.group.label),M.group.isDefault===!0&&(ae.group.isDefault=M.group.isDefault))),M.presentationOptions&&(ae.presentationOptions=i.to(M.presentationOptions)),M._id&&(ae._id=M._id),M.detail&&(ae.detail=M.detail),ae}O.to=$})(k=e.TaskDTO||(e.TaskDTO={}));var L;(function(O){function B($){return $}O.from=B;function F($){if(!!$)return Object.assign(Object.create(null),$)}O.to=F})(L||(L={}));class U{constructor(B,F,$){this._id=F,this.a=$,b.set(this,void 0),Je(this,b,B,"f")}get task(){return this.a}terminate(){Me(this,b,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}b=new WeakMap;let K=class{constructor(B,F,$,M,V,q,H,J){this.q=new I.Emitter,this.r=new I.Emitter,this.s=new I.Emitter,this.t=new I.Emitter,this.a=B.getProxy(A.MainContext.MainThreadTask),this.b=$,this.c=M,this.d=V,this.e=q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=H,this.g=J,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,F,$){if(!$)return new D.Disposable(()=>{});const M=this.w();return this.j.set(M,{type:F,provider:$,extension:B}),this.a.$registerTaskProvider(M,F),new D.Disposable(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(B,F){this.a.$registerTaskSystem(B,F)}fetchTasks(B){return this.a.$fetchTasks(L.from(B)).then(async F=>{const $=[];for(const M of F){const V=await k.to(M,this.b,this.m);V&&$.push(V)}return $})}get taskExecutions(){const B=[];return this.k.forEach(F=>B.push(F)),B}terminateTask(B){if(!(B instanceof U))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,F,$){const M=this.m.get(B.id);M&&(this.o.set(B.id,M),this.e.attachPtyToTerminal(F,await M.callback($))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const F=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.B(B),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const F=await this.y(B.id);this.s.fire({execution:F,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const F=await this.y(B.id);this.t.fire({execution:F,exitCode:B.exitCode})}$provideTasks(B,F){const $=this.j.get(B);if(!$)return Promise.reject(new Error("no handler found"));const M=[],V=(0,t.asPromise)(()=>$.provider.provideTasks(R.CancellationToken.None)).then(q=>this.u(F,M,$,q));return new Promise(q=>{V.then(H=>{Promise.all(M).then(()=>{q(H)})})})}async $resolveTask(B,F){const $=this.j.get(B);if(!$)return Promise.reject(new Error("no handler found"));if(F.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${$.type}].`);const M=await k.to(F,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const V=await $.provider.resolveTask(M,R.CancellationToken.None);if(!V)return;this.A(V,$);const q=k.from(V,$.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(q.execution)&&await this.x(q,V,!0),await this.v(q)}w(){return this.h++}async x(B,F,$){const M=await this.a.$createTaskId(B);!$&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,F.execution)),this.m.set(M,F.execution)}async y(B,F){if(typeof B=="string"){const V=this.l.get(B);if(!V)throw new h.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const $=this.l.get(B.id);if($)return $;const M=new Promise((V,q)=>{function H(J,Y,ae){ae?V(new U(J,Y.id,ae)):q("Unexpected: Task does not exist.")}F?H(this,B,F):k.to(B.task,this.b,this.m).then(J=>H(this,B,J))});return this.l.set(B.id,M),M.then(V=>(this.k.set(B.id,V),V),V=>Promise.reject(V))}A(B,F){B._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const $=this.n.values();let M=$.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=$.next()}};K=Ve([ze(0,E.IExtHostRpcService),ze(1,y.IExtHostInitDataService),ze(2,T.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,P.IExtHostTerminalService),ze(6,f.ILogService),ze(7,w.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let G=class extends K{constructor(B,F,$,M,V,q,H,J){super(B,F,$,M,V,q,H,J),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(B,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const $=k.from(F,B);if($===void 0)throw new Error("Task is not valid");if(n.is($.execution))await this.x($,F,!1);else throw new h.NotSupportedError;const M=await this.y(await this.a.$getTaskExecution($),F);return this.a.$executeTask($).catch(V=>{throw new Error(V)}),M}u(B,F,$,M){const V=[];if(M)for(const q of M){this.A(q,$),(!q.definition||!B[q.definition.type])&&this.f.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const H=k.from(q,$.extension);H&&n.is(H.execution)?(V.push(H),F.push(this.x(H,q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:$.extension}}async v(B){if(n.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,F,$){}};G=Ve([ze(0,E.IExtHostRpcService),ze(1,y.IExtHostInitDataService),ze(2,T.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,P.IExtHostTerminalService),ze(6,f.ILogService),ze(7,w.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(Se[285],ye([1,0,9,21,50,37,24,51,31]),function(te,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(E,y,v){this.k=E,this.l=y,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=E.filePattern,this.b=E.includePattern&&A.parse(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.h=new Set,this.j=E.excludePattern&&A.parse(E.excludePattern)}cancel(){this.g=!0,this.h.forEach(E=>E.cancel()),this.h=new Set}search(E){const y=this.k.folderQueries||[];return new Promise((v,d)=>{const g=f=>{this.f++,E(f)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(f=>{const w=f.toString(),m=a.basename(w);this.j&&this.j(w,m)||this.v(g,{base:f,basename:m})}),Promise.all(y.map(f=>this.p(f,g))).then(f=>{v({limitHit:this.e,stats:f[0]||void 0})},f=>{d(new Error((0,I.toErrorMessage)(f)))})})}async p(E,y){const v=new t.CancellationTokenSource,d=this.q(E),g=this.r(),f=new S.QueryGlobTester(this.k,E),w=!f.hasSiblingExcludeClauses();let m;try{this.h.add(v),m=T.StopWatch.create();const h=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,v.token),b=m.elapsed(),s=T.StopWatch.create();return this.g&&!this.e||(h&&h.forEach(i=>{const c=a.posix.relative(E.folder.path,i.path);if(w){const u=a.basename(i.path);this.v(y,{base:E.folder,relativePath:c,basename:u});return}this.s(g,E.folder,c,y)}),this.g&&!this.e)?null:(this.u(g,f,y),{providerTime:b,postProcessTime:s.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(E){const y=(0,S.resolvePatternsForProvider)(this.k.includePattern,E.includePattern),v=(0,S.resolvePatternsForProvider)(this.k.excludePattern,E.excludePattern);return{folder:E.folder,excludes:v,includes:y,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}s({pathToEntries:E},y,v,d){if(v===this.a){const f=a.basename(this.a);this.v(d,{base:y,relativePath:this.a,basename:f})}function g(f){const w=a.basename(f),m=a.dirname(f);let h=E[m];h||(h=E[m]=[],g(m)),h.push({base:y,relativePath:f,basename:w})}g(v)}u({rootEntries:E,pathToEntries:y},v,d){const g=this,f=this.a;function w(m){const h=(0,S.hasSiblingFn)(()=>m.map(b=>b.basename));for(let b=0,s=m.length;b<s;b++){const i=m[b],{relativePath:c,basename:u}=i;if(v.matchesExcludesSync(c,u,f!==u?h:void 0))continue;const r=y[c];if(r)w(r);else{if(c===f)continue;g.v(d,i)}if(g.e)break}}w(E)}v(E,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||E(y))}}class R{constructor(){this.b=new Map}fileSearch(E,y,v,d){const g=this.c(E.cacheKey),f=new C(E,y,g&&g.token);let w=0;const m=h=>{w+=h.length,v(h.map(b=>this.d(b)))};return this.e(f,R.a,m,d).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:h.stats}}))}clearCache(E){this.c(E)?.cancel()}c(E){if(!!E)return this.b.has(E)||this.b.set(E,new t.CancellationTokenSource),this.b.get(E)}d(E){return E.relativePath?{resource:D.joinPath(E.base,E.relativePath)}:{resource:E.base}}e(E,y,v,d){d.onCancellationRequested(()=>{E.cancel()});const g=w=>{w&&(f.push(w),y>0&&f.length>=y&&(v(f),f=[]))};let f=[];return E.search(g).then(w=>(f.length&&v(f),w),w=>(f.length&&v(f),Promise.reject(w)))}}e.FileSearchManager=R,R.a=512}),define(Se[286],ye([1,0,17,79,37,111,28,15,9,24,8,11,2,162,189,52,13,45,133,284,31]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(p,k,L,U,K){this.a=p,this.b=k,this.c=L,this.d=U,this.e=K}text(p,k,L={}){p=this.f(p,L);const U=this.a.getValue(),K=k&&k.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(k?.map(f.toWorkspaceFolder),L),type:2,contentPattern:p,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:U.search.usePCRE2||K||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(p,k){const L=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const U={...p,wordSeparators:L.editor.wordSeparators};return this.j(p,k)&&(U.isCaseSensitive=!0),this.k(p)&&(U.isMultiline=!0),U}file(p,k={}){return{...this.h(p,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(p,k){return p?(p=Array.isArray(p)?p.map(r):r(p),k?this.parseSearchPaths(p):{pattern:i(...Array.isArray(p)?p:[p])}):{}}h(p=[],k={}){const L=this.g(k.includePattern,k.expandPatterns),U=this.g(k.excludePattern,k.expandPatterns),K=p.length>1,G=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(F=>this.q(F,k,U)):p.map(F=>this.r(F,k,U,K))).filter(F=>!!F),O={_reason:k._reason,folderQueries:G,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:U.pattern,includePattern:L.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const F=a.coalesce(a.flatten(this.c.groups.map(V=>V.editors.map(q=>q.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const $=F.filter(V=>(0,h.pathIncludedInQuery)(O,V.fsPath)),M=this.i($);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(M)),{...O,...M}}const B=k.extraFileResources&&k.extraFileResources.filter(F=>(0,h.pathIncludedInQuery)(O,F.fsPath));return O.extraFileResources=B&&B.length?B:void 0,O}i(p){const k=[],L=new D.ResourceMap,U={};let K=!1;return p.forEach(G=>{if(G.scheme===T.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(G)){const B=this.b.getWorkspaceFolder(G)?.uri??G.with({path:S.dirname(G.fsPath)});let F=L.get(B);F||(K=!0,F={folder:B,includePattern:{}},k.push(F),L.set(B,F));const $=S.relative(B.fsPath,G.fsPath);(0,P.assertIsDefined)(F.includePattern)[$.replace(/\\/g,"/")]=!0}else G.fsPath&&(K=!0,U[G.fsPath]=!0)}),{folderQueries:k,includePattern:U,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(p,k){if(k.isSmartCase){if(p.isRegExp){if(R.containsUppercaseCharacter(p.pattern,!0))return!0}else if(R.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,y.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const k=M=>S.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),U=(Array.isArray(p)?p:c(p)).map(M=>{const V=this.e.resolvedUserHome;return V?(0,A.untildify)(M,V.scheme===T.Schemas.file?V.fsPath:V.path):M}),K=t.groupBy(U,M=>k(M)?"searchPaths":"exprSegments"),G=(K.exprSegments||[]).map(M=>R.rtrim(M,"/")).map(M=>R.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),u(M))),O={},B=this.m(K.searchPaths||[]);B&&B.length&&(O.searchPaths=B);const F=a.flatten(G),$=i(...F);return $&&(O.pattern=$),O}l(p,k){return k.disregardExcludeSettings?void 0:(0,h.getExcludes)(p,!k.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const k=a.flatten(p.map(U=>{let{pathPortion:K,globPortion:G}=s(U);G&&(G=o(G));const O=this.n(K);return a.flatten(O.map(B=>this.o(B,G)))})),L=new Map;return k.forEach(U=>{const K=U.searchPath.toString(),G=L.get(K);G?U.pattern&&(G.pattern=G.pattern||{},G.pattern[U.pattern]=!0):L.set(K,{searchPath:U.searchPath,pattern:U.pattern?i(U.pattern):void 0})}),Array.from(L.values())}n(p){if(S.isAbsolute(p)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==T.Schemas.file?[{searchPath:k[0].uri.with({path:p})}]:[{searchPath:E.URI.file(S.normalize(p))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(p=r(p),p.startsWith("../")||p===".."){const U=S.posix.resolve(k.path,p);return[{searchPath:k.with({path:U})}]}const L=o(p);return[{searchPath:k,pattern:L}]}else{if(p==="./"||p===".\\")return[];{const k=p.replace(/^\.[\/\\]/,""),U=this.b.getWorkspace().folders.map(K=>{const G=k.match(new RegExp(`^${R.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return G?{match:G,folder:K}:null}).filter(P.isDefined);if(U.length)return U.map(K=>{const G=K.match[1];return{searchPath:K.folder.uri,pattern:G&&o(G)}});{const K=p.match(/\.[\/\\](.+)[\/\\]?/),G=K?K[1]:p,O=v.localize(0,null,G);throw new Error(O)}}}}o(p,k){const L=p.pattern&&k?`${p.pattern}/${k}`:p.pattern||k,U=[{searchPath:p.searchPath,pattern:L}];return L&&!L.endsWith("**")&&U.push({searchPath:p.searchPath,pattern:L+"/**"}),U}q(p,k,L){const U=this.r((0,f.toWorkspaceFolder)(p.searchPath),k,L,!1);return U?{...U,includePattern:p.pattern}:null}r(p,k,L,U){let K;const G=E.URI.isUri(p)?p:p.uri;if(L.searchPaths){const M=L.searchPaths.filter(V=>(0,C.isEqual)(V.searchPath,G))[0];if(M&&!M.pattern)return null;M&&(K=M.pattern)}const O=this.a.getValue({resource:G}),F={...this.l(O,k)||{},...K||{}},$=E.URI.isUri(p)?(0,C.basename)(p):p.name;return{folder:G,folderName:U?$:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!O.search.followSymlinks}}};b=Ve([ze(0,d.IConfigurationService),ze(1,f.IWorkspaceContextService),ze(2,w.IEditorGroupsService),ze(3,g.ILogService),ze(4,m.IPathService)],b),e.QueryBuilder=b;function s(l){const p=l.match(/[\*\{\}\(\)\[\]\?]/);if(p){const k=p.index,L=l.substr(0,k).match(/[/|\\][^/\\]*$/);if(L){let U=l.substr(0,L.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:l.substr((L.index||0)+1)}}}return{pathPortion:l}}function i(...l){return l.length?l.reduce((p,k)=>(p[k]=!0,p),Object.create(null)):void 0}function c(l){return I.splitGlobAware(l,",").map(p=>p.trim()).filter(p=>!!p.length)}function u(l){return[`**/${l}/**`,`**/${l}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function r(l){return l.replace(/\\/g,"/")}function o(l){return r(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(l,p){l=a.distinct(l,U=>U.toString());const k=[],L=p.getWorkspace();return l&&l.forEach(U=>{let K;if(p.getWorkbenchState()===2)K=(0,C.relativePath)(L.folders[0].uri,U),K&&K!=="."&&(K="./"+K);else{const G=p.getWorkspaceFolder(U);if(G){const O=G.name;if(L.folders.filter(F=>F.name===O).length===1){const F=(0,C.relativePath)(G.uri,U);F===""?K=`./${G.name}`:K=`./${G.name}/${F}`}else K=U.fsPath}}K&&k.push(K)}),k}e.resolveResourcesForSearchIncludes=n}),define(Se[287],ye([1,0,24,2,21,10,3,286,31,45]),function(te,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function P(d,g){const f=g.activationEvents;if(!f)return Promise.resolve(void 0);const w=[],m=[];for(const u of f)if(/^workspaceContains:/.test(u)){const r=u.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||d.forceUsingSearch?m.push(r):w.push(r)}if(w.length===0&&m.length===0)return Promise.resolve(void 0);let h;const b=new Promise((u,r)=>{h=u}),s=u=>h({activationEvent:u}),i=Promise.all(w.map(u=>E(d,u,s))).then(()=>{}),c=y(d,g.identifier,m,s);return Promise.all([i,c]).then(()=>{h(void 0)}),b}e.checkActivateWorkspaceContainsExtension=P;async function E(d,g,f){for(const w of d.folders)if(await d.exists(a.joinPath(t.URI.revive(w),g))){f(`workspaceContains:${g}`);return}}async function y(d,g,f,w){if(f.length===0)return Promise.resolve(void 0);const m=new I.CancellationTokenSource,h=d.checkExists(d.folders,f,m.token),b=setTimeout(async()=>{m.cancel(),d.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},R);let s=!1;try{s=await h}catch(i){A.isCancellationError(i)||A.onUnexpectedError(i)}m.dispose(),clearTimeout(b),s&&w(`workspaceContains:${f.join(",")}`)}function v(d,g,f,w){const m=d.get(D.IInstantiationService),h=d.get(S.ISearchService),s=m.createInstance(T.QueryBuilder).file(g.map(i=>(0,C.toWorkspaceFolder)(t.URI.revive(i))),{_reason:"checkExists",includePattern:f,exists:!0});return h.fileSearch(s,w).then(i=>!!i.limitHit,i=>A.isCancellationError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=v});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(te,a):I?I.value=a:e.set(te,a),a},Me=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[41],ye([1,0,173,9,75,24,18,6,64,2,13,5,34,229,97,33,26,227,10,27,22,210,7,127,3,25,71,16,87,54,40,4,287,96,212,15,95]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m,h,b,s,i,c,u,r,o,n,l,p,k,L,U,K,G,O){"use strict";var B,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,c.createDecorator)("IHostUtils");let M=class Ln extends T.Disposable{constructor(re,fe,Z,pe,we,De,Re,Be,se,ue,de){super(),this.a=this.B(new k.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=fe,this.g=Z,this.f=Re,this.j=pe,this.k=we,this.l=De,this.m=se,this.p=ue,this.s=de,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new D.Barrier,this.y=new D.Barrier,this.C=new D.Barrier,this.D=new D.Barrier,this.G=new f.ExtensionDescriptionRegistry(this.f.allExtensions);const ee=(0,g.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.F=new f.ExtensionDescriptionRegistry(H(this.G,ee)),this.H=new v.ExtHostStorage(this.g,this.l),this.I=new U.ExtHostSecretState(this.g),this.J=Be,this.h=re.createChild(new n.ServiceCollection([v.IExtHostStorage,this.H],[U.IExtHostSecretState,this.I]));let oe=[],ie=[];this.f.remote.isRemote&&(oe=this.f.allExtensions.filter(z=>!z.main&&!z.browser).map(z=>z.identifier),ie=this.f.allExtensions.filter(z=>!ee.has(m.ExtensionIdentifier.toKey(z.identifier.value))).filter(z=>(z.main||z.browser)&&z.api==="none").map(z=>z.identifier));const N=(0,g.extensionIdentifiersArrayToSet)(ie);this.L=this.B(new y.ExtensionsActivator(this.F,oe,ie,{onExtensionActivationError:(z,X,Q)=>{this.v.$onExtensionActivationError(z,w.transformErrorForSerialization(X),Q)},actualActivateExtension:async(z,X)=>{if(N.has(m.ExtensionIdentifier.toKey(z)))return await this.v.$activateExtension(z,X),new y.HostExtension;const Q=this.F.getExtensionDescription(z);return this.ab(Q,X)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.mb()}catch(re){w.onUnexpectedError(re)}}async R(){this.J.onWillDeactivateAll();let re=[];try{re=this.F.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.Y(we))}catch{}await Promise.all(re)}terminate(re,fe=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${re}`),this.l.flush(),this.p.dispose(),this.L.dispose(),w.setUnexpectedErrorHandler(pe=>{this.l.error(pe)}),this.g.dispose();const Z=this.R();Promise.race([(0,D.timeout)(5e3),Z]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${fe}`):this.l.info(`Extension host exiting with code ${fe}`),this.l.flush(),this.l.dispose(),this.c.exit(fe)})}isActivated(re){return this.C.isOpen()?this.L.isActivated(re):!1}async getExtension(re){const fe=await this.v.$getExtension(re);let Z;if(fe?.browserNlsBundleUris){Z={};for(const pe of Object.keys(fe.browserNlsBundleUris))Z[pe]=C.URI.revive(fe.browserNlsBundleUris[pe])}return fe&&{...fe,identifier:new m.ExtensionIdentifier(fe.identifier.value),extensionLocation:C.URI.revive(fe.extensionLocation),browserNlsBundleUris:Z}}S(re,fe){return this.L.activateByEvent(re,fe)}U(re,fe){return this.L.activateById(re,fe)}activateByIdWithErrors(re,fe){return this.U(re,fe).then(()=>{const Z=this.L.getActivatedExtension(re);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.C.wait().then(re=>this.F)}getExtensionExports(re){return this.C.isOpen()?this.L.getActivatedExtension(re).exports:null}async W(re){if(re.scheme!==G.Schemas.file)return re;const fe=await this.c.realpath(re.fsPath);return C.URI.file(fe)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(re=>new Y(re))),this.M}async X(re){const fe=S.TernarySearchTree.forUris(Z=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Z));return await Promise.all(re.map(async Z=>{if(this.qb(Z)){const pe=await this.W(Z.extensionLocation);fe.set(pe,Z)}})),fe}Y(re){let fe=Promise.resolve(void 0);if(!this.C.isOpen()||!this.L.isActivated(re))return fe;const Z=this.L.getActivatedExtension(re);if(!Z)return fe;try{typeof Z.module.deactivate=="function"&&(fe=Promise.resolve(Z.module.deactivate()).then(void 0,pe=>(this.l.error(pe),Promise.resolve(void 0))))}catch(pe){this.l.error(`An error occurred when deactivating the extension '${re.value}':`),this.l.error(pe)}try{(0,T.dispose)(Z.subscriptions)}catch(pe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this.l.error(pe)}return fe}async ab(re,fe){return this.f.remote.isRemote?this.v.$onWillActivateExtension(re.identifier):await this.v.$onWillActivateExtension(re.identifier),this.cb(re,fe).then(Z=>{const pe=Z.activationTimes;return this.v.$onDidActivateExtension(re.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,fe),this.bb(re,fe,"success",pe),Z},Z=>{throw this.bb(re,fe,"failure"),Z})}bb(re,fe,Z,pe){const we=V(re,fe);this.u.$publicLog2("extensionActivationTimes",{...we,...pe||{},outcome:Z})}cb(re,fe){const Z=V(re,fe);this.u.$publicLog2("activatePlugin",Z);const pe=this.qb(re);if(!pe)return Promise.resolve(new y.EmptyExtension(y.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${fe.startup}, activationEvent: '${fe.activationEvent}'${re.identifier.value!==fe.extensionId.value?`, root cause: ${fe.extensionId.value}`:""}`),this.l.flush();const we=new y.ExtensionActivationTimesBuilder(fe.startup);return Promise.all([this.rb(re,(0,A.joinPath)(re.extensionLocation,pe),we),this.db(re)]).then(De=>(I.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Ln.eb(this.l,re.identifier,De[0],De[1],we))).then(De=>(I.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),De))}db(re){const fe=new b.ExtensionGlobalMemento(re,this.H),Z=new b.ExtensionMemento(re.identifier.value,!1,this.H),pe=new K.ExtensionSecrets(re,this.I),we=re.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,De=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([fe.whenReady,Z.whenReady,this.J.whenReady]).then(()=>{const Re=this;let Be,se;const ue=(0,g.isProposedApiEnabled)(re,"ipc")?this.f.messagePorts?.get(m.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:fe,workspaceState:Z,secrets:pe,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(de){return t.join(re.extensionLocation.fsPath,de)},get storagePath(){return Re.J.workspaceValue(re)?.fsPath},get globalStoragePath(){return Re.J.globalValue(re).fsPath},get logPath(){return t.join(Re.f.logsLocation.fsPath,re.identifier.value)},get logUri(){return C.URI.joinPath(Re.f.logsLocation,re.identifier.value)},get storageUri(){return Re.J.workspaceValue(re)},get globalStorageUri(){return Re.J.globalValue(re)},get extensionMode(){return we},get extension(){return Be===void 0&&(Be=new q(Re,re.identifier,re,De,!1)),Be},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(re,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!se){if(!ue)return;const de=k.Event.buffer(k.Event.fromDOMEventEmitter(ue,"message",ee=>ee.data));ue.start(),se={onDidReceiveMessage:de,postMessage:ue.postMessage.bind(ue)}}return se}})})}static eb(re,fe,Z,pe,we){return Z=Z||{activate:void 0,deactivate:void 0},this.fb(re,fe,Z,pe,we).then(De=>new y.ActivatedExtension(!1,null,we.build(),Z,De,pe.subscriptions))}static fb(re,fe,Z,pe,we){if(typeof Z.activate=="function")try{we.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${fe.value}`);const De=typeof global=="object"?global:self,Re=Z.activate.apply(De,[pe]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(Re).then(Be=>(we.activateResolveStop(),Be))}catch(De){return Promise.reject(De)}else return Promise.resolve(Z)}gb(re,fe){this.U(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:fe}).then(void 0,Z=>{this.l.error(Z)})}hb(){this.v.$setPerformanceMarks(I.getMarks());for(const re of this.F.getAllExtensionDescriptions())if(re.activationEvents)for(const fe of re.activationEvents)fe==="onStartupFinished"&&this.gb(re,fe)}ib(){const re=this.S("*",!0).then(void 0,we=>{this.l.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.jb(we.added)));const fe=this.j.workspace?this.j.workspace.folders:[],Z=this.jb(fe),pe=Promise.all([re,Z]).then(()=>{});return Promise.race([pe,(0,D.timeout)(1e4)]).then(()=>{this.hb()}),pe}jb(re){return re.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(fe=>this.kb(re,fe))).then(()=>{})}async kb(re,fe){if(this.isActivated(fe.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.l,folders:re.map(De=>De.uri),forceUsingSearch:Z,exists:De=>this.c.exists(De.fsPath),checkExists:(De,Re,Be)=>this.t.$checkExists(De,Re,Be)},we=await(0,L.checkActivateWorkspaceContainsExtension)(pe,fe);if(!!we)return this.U(fe.identifier,{startup:!0,extensionId:fe.identifier,activationEvent:we.activationEvent}).then(void 0,De=>this.l.error(De))}async $extensionTestsExecute(){await this.D.wait();try{return await this.lb()}catch(re){throw console.error(re),re}}async lb(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:fe}=this.f.environment;if(!re||!fe)throw new Error(a.localize(0,null));const Z=await this.rb(null,fe,new y.ExtensionActivationTimesBuilder(!1));if(!Z||typeof Z.run!="function")throw new Error(a.localize(1,null,fe.toString()));return new Promise((pe,we)=>{const De=(se,ue)=>{se?we(se):pe(typeof ue=="number"&&ue>0?1:0)},Re=(0,A.originalFSPath)(fe),Be=Z.run(Re,De);Be&&Be.then&&Be.then(()=>{pe(0)}).catch(se=>{we(se instanceof Error&&se.stack?se.stack:String(se))})})}mb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.C.open()).then(()=>this.ib()).then(()=>{this.D.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,fe){return this.N[re]=fe,(0,T.toDisposable)(()=>{delete this.N[re]})}async nb(re){const fe=re.indexOf("+");if(fe===-1)throw new Error("Not an authority that can be resolved!");const Z=re.substr(0,fe);return await this.w.wait(),await this.S(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.N[Z]}}async $resolveAuthority(re,fe){this.l.info(`$resolveAuthority invoked for authority (${J(re)})`);const{authorityPrefix:Z,resolver:pe}=await this.nb(re);if(!pe)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Z}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(pe)),I.mark(`code/extHost/willResolveAuthority/${Z}`);const we=await pe.resolve(re,{resolveAttempt:fe});I.mark(`code/extHost/didResolveAuthorityOK/${Z}`);const De={authority:re,host:we.host,port:we.port,connectionToken:we.connectionToken},Re={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:De,options:Re,tunnelInformation:{environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures}}}}catch(we){if(I.mark(`code/extHost/didResolveAuthorityError/${Z}`),we instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}async $getCanonicalURI(re,fe){this.l.info(`$getCanonicalURI invoked for authority (${J(re)})`);const{resolver:Z}=await this.nb(re);if(!Z)return null;const pe=C.URI.revive(fe);if(typeof Z.getCanonicalURI>"u")return pe;const we=await(0,D.asPromise)(()=>Z.getCanonicalURI(pe));return we||pe}static ob(re,fe,Z){const pe=new f.ExtensionDescriptionRegistry(re.getAllExtensionDescriptions());pe.deltaExtensions(Z.toAdd,Z.toRemove);const we=(0,g.extensionIdentifiersArrayToSet)(fe.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Z.myToRemove)we.delete(m.ExtensionIdentifier.toKey(Re));for(const Re of Z.myToAdd)we.add(m.ExtensionIdentifier.toKey(Re));const De=H(pe,we);return{globalRegistry:pe,myExtensions:De}}$startExtensionHost(re){re.toAdd.forEach(pe=>pe.extensionLocation=C.URI.revive(pe.extensionLocation));const{globalRegistry:fe,myExtensions:Z}=Ln.ob(this.G,this.F,re);return this.G.set(fe.getAllExtensionDescriptions()),this.F.set(Z),this.mb()}$activateByEvent(re,fe){return fe===1?this.S(re,!1):this.C.wait().then(Z=>this.S(re,!1))}async $activate(re,fe){return await this.C.wait(),this.F.getExtensionDescription(re)?(await this.U(re,fe),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(De=>De.extensionLocation=C.URI.revive(De.extensionLocation));const{globalRegistry:fe,myExtensions:Z}=Ln.ob(this.G,this.F,re),pe=await this.X(Z);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.G.set(fe.getAllExtensionDescriptions()),this.F.set(Z),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const fe=h.VSBuffer.alloc(re),Z=Math.random()%256;for(let pe=0;pe<re;pe++)fe.writeUInt8(Z,pe);return fe}async $updateRemoteConnectionData(re){this.Q=re,this.a.fire()}};M=Ve([ze(0,c.IInstantiationService),ze(1,e.IHostUtils),ze(2,o.IExtHostRpcService),ze(3,d.IExtHostWorkspace),ze(4,E.IExtHostConfiguration),ze(5,R.ILogService),ze(6,u.IExtHostInitDataService),ze(7,r.IExtensionStoragePaths),ze(8,l.IExtHostTunnelService),ze(9,p.IExtHostTerminalService),ze(10,O.IExtHostLocalizationService)],M),e.AbstractExtHostExtensionService=M;function V(ae,re){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,c.createDecorator)("IExtHostExtensionService");class q{constructor(re,fe,Z,pe,we){B.set(this,void 0),F.set(this,void 0),$.set(this,void 0),Je(this,B,re,"f"),Je(this,F,fe,"f"),Je(this,$,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=pe,this.isFromDifferentExtensionHost=we}get isActive(){return Me(this,B,"f").isActivated(Me(this,$,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,B,"f").getExtensionExports(Me(this,$,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,B,"f").activateByIdWithErrors(Me(this,$,"f"),{startup:!1,extensionId:Me(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=q,B=new WeakMap,F=new WeakMap,$=new WeakMap;function H(ae,re){return ae.getAllExtensionDescriptions().filter(fe=>re.has(m.ExtensionIdentifier.toKey(fe.identifier)))}function J(ae){const re=ae.indexOf("+");return re===-1?ae:ae.substring(0,re)}class Y{constructor(re){this.a=re}setSearchTree(re){this.a=re}findSubstr(re){return this.a.findSubstr(re)}forEach(re){return this.a.forEach(re)}}e.ExtensionPaths=Y}),define(Se[288],ye([1,0,75,2,5,34,26,27,16,25,3,41,36,13,8]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(b,s,i,c,u,r,o){this.c=b,this.d=s,this.e=i,this.f=c,this.g=u,this.h=r,this.i=o,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const b=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new f(this.c,s,this.d,b,this.i)),this.register(this.e.createInstance(w,s)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(m,s,this.h.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const s of b.nodeModuleName)this.a.set(s,b);else this.a.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this.b.push(s=>b.alternativeModuleName(s))}};d=Ve([ze(2,R.IInstantiationService),ze(3,A.IExtHostConfiguration),ze(4,P.IExtHostExtensionService),ze(5,C.IExtHostInitDataService),ze(6,y.ILogService)],d),e.RequireInterceptor=d;let g=class ei{constructor(b){if(b.environment.appRoot&&ei.a.size){const s=(0,v.escapeRegExpCharacters)(this.c(b.environment.appRoot.fsPath)),i="[a-z0-9_.-]",c=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${u}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(b){if(!this.b)return;const s=this.b.exec(this.c(b));if(!s)return;const[,i,c,u]=s,r=ei.a.get(c);if(r!==void 0)return console.warn(`${c} as been renamed to ${r}, please update your imports`),i+r+u}c(b){return b.replace(/\\/g,"/")}};g.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=Ve([ze(0,C.IExtHostInitDataService)],g);class f{constructor(b,s,i,c,u){this.c=b,this.d=s,this.e=i,this.f=c,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(b,s){const i=this.d.findSubstr(s);if(i){let c=this.a.get(T.ExtensionIdentifier.toKey(i.identifier));return c||(c=this.c(i,this.e,this.f),this.a.set(T.ExtensionIdentifier.toKey(i.identifier),c)),c}if(!this.b){let c="";this.d.forEach((u,r)=>c+=`	${r} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${c}`),this.b=this.c(D.nullExtensionDescription,this.e,this.f)}return this.b}}let w=class{constructor(b,s,i){this.d=b,this.nodeModuleName="keytar",this.a=s.getProxy(I.MainContext.MainThreadTelemetry);const{environment:c}=i,u=s.getProxy(I.MainContext.MainThreadKeytar);if(c.appRoot){let r=c.appRoot.fsPath;E.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.b=new Set,this.b.add(`${r}/node_modules.asar/keytar`),this.b.add(`${r}/node_modules/keytar`)}this.c={getPassword:(r,o)=>u.$getPassword(r,o),setPassword:(r,o,n)=>u.$setPassword(r,o,n),deletePassword:(r,o)=>u.$deletePassword(r,o),findPassword:r=>u.$findPassword(r),findCredentials(r){return u.$findCredentials(r)}}}load(b,s){const i=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:i?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(b){const s=b.length;if(s<=7||!this.b)return;const i=s-7;if((b.charAt(i)==="/"||b.charAt(i)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.b.has(b)))return"keytar"}};w=Ve([ze(1,S.IExtHostRpcService),ze(2,C.IExtHostInitDataService)],w);let m=class{constructor(b,s,i){this.e=b,this.f=s,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.MainContext.MainThreadTelemetry);const c=i.getProxy(I.MainContext.MainThreadWindow);this.c=(u,r)=>{const o=t.URI.parse(u);return r?this.g(u,r):o.scheme==="http"||o.scheme==="https"?c.$openUri(o,u,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this.f?c.$openUri(o,u,{}):this.g(u,r)}}load(b,s,i){const c=this.e.findSubstr(s);return c&&(this.a=c.identifier.value,this.h()),this.b=i(b),this.c}g(b,s){return this.i(),this.b(b,s)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};m=Ve([ze(2,S.IExtHostRpcService)],m)}),define(Se[47],ye([1,0,80,6,9,36,3,58,59,41,7,33,224,34]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class v extends E.AbstractVariableResolverService{constructor(f,w,m,h,b,s,i){function c(){if(m){const u=m.activeEditor();if(u)return u.document.uri;const r=h.tabGroups.all.find(o=>o.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.TextDiffTabInput||r.input instanceof R.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof R.TextTabInput||r.input instanceof R.NotebookEditorTabInput||r.input instanceof R.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:u=>{const r=s.folders.filter(o=>o.name===u);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(u,r)=>b.getConfiguration(void 0,u).get(r),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=c();if(u)return I.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(w){const u=c();if(u){const r=w.getWorkspaceFolder(u);if(r)return I.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(m){const u=m.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(m){const u=m.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>f.getExtension(u)},void 0,i?Promise.resolve(i):void 0,Promise.resolve(A.env))}}let d=class extends t.Disposable{constructor(f,w,m,h,b){super(),this.b=f,this.c=w,this.g=m,this.h=h,this.i=b,this.a=new a.Lazy(async()=>{const s=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.i,s,c,this.j())})}getResolver(){return this.a.getValue()}j(){}};d=Ve([ze(0,C.IExtHostExtensionService),ze(1,P.IExtHostWorkspace),ze(2,T.IExtHostDocumentsAndEditors),ze(3,y.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(Se[76],ye([1,0,18,4,11,2,3,5,59,41,16,7,33,131,216,34,47]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(c,u,r,o,n,l){this.E=u,this.F=r,this.G=o,this.H=n,this.I=l,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=c.getProxy(T.MainContext.MainThreadDebugService),this.A=new t.Emitter({onWillAddFirstListener:()=>{this.U()}}),this.v=new m(this.k),this.w=new Map,this.y=!1,this.F.getExtensionRegistry().then(p=>{p.onDidChange(k=>{this.J(p)}),this.J(p)})}asDebugSourceUri(c,u){const r=c;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let o=`debug:${encodeURIComponent(r.path||"")}`,n="?";return u&&(o+=`${n}session=${encodeURIComponent(u.id)}`,n="&"),o+=`${n}ref=${r.sourceReference}`,A.URI.parse(o)}else{if(r.path)return A.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(c){const u=[];for(const r of c.getAllExtensionDescriptions())if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0)for(const n of o)(0,v.isDebuggerMainContribution)(n)&&u.push(n.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){this.U();const c=[];return this.w.forEach(u=>c.push(u)),c}addBreakpoints(c){this.U();const u=c.filter(n=>{const l=n.id;return this.w.has(l)?!1:(this.w.set(l,n),!0)});this.V(u,[],[]);const r=[],o=new Map;for(const n of u)if(n instanceof P.SourceBreakpoint){let l=o.get(n.location.uri.toString());l||(l={type:"sourceMulti",uri:n.location.uri,lines:[]},o.set(n.location.uri.toString(),l),r.push(l)),l.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof P.FunctionBreakpoint&&r.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(r)}removeBreakpoints(c){this.U();const u=c.filter(l=>this.w.delete(l.id));this.V([],u,[]);const r=u.filter(l=>l instanceof P.SourceBreakpoint).map(l=>l.id),o=u.filter(l=>l instanceof P.FunctionBreakpoint).map(l=>l.id),n=u.filter(l=>l instanceof P.DataBreakpoint).map(l=>l.id);return this.k.$unregisterBreakpoints(r,o,n)}startDebugging(c,u,r){return this.k.$startDebugging(c?c.uri:void 0,u,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,suppressSaveBeforeStart:r.suppressSaveBeforeStart,suppressDebugStatusbar:r.suppressDebugStatusbar??r.debugUI?.simple,suppressDebugToolbar:r.suppressDebugToolbar??r.debugUI?.simple,suppressDebugView:r.suppressDebugView??r.debugUI?.simple})}stopDebugging(c){return this.k.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,u,r){if(!u)return new P.Disposable(()=>{});const o=this.d++;return this.f.push({type:c,handle:o,provider:u}),this.k.$registerDebugConfigurationProvider(c,r,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,o),new P.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==u),this.k.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(c,u,r){if(!r)return new P.Disposable(()=>{});if(!this.Q(c,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this.g++;return this.h.push({type:u,handle:o,factory:r}),this.k.$registerDebugAdapterDescriptorFactory(u,o),new P.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==r),this.k.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(c,u){if(!u)return new P.Disposable(()=>{});const r=this.i++;return this.j.push({type:c,handle:r,factory:u}),new P.Disposable(()=>{this.j=this.j.filter(o=>o.factory!==u)})}async $runInTerminal(c,u){return Promise.resolve(void 0)}async $substituteVariables(c,u){let r;const o=await this.X(c);return o&&(r={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(r,u)}K(c,u){if(c.type==="implementation")return new b(c.implementation)}L(){}async $startDASession(c,u){const r=this,o=await this.W(u);return this.S(this.N(o.type),o).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const l=this.M(n),p=this.K(l,o);if(!p)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const k=p;return this.B.set(c,k),this.R(o).then(L=>(L&&this.C.set(c,L),k.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const K=U,G={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(K.arguments.value);G.body={signature:O},k.sendResponse(G)}else throw new Error("no signer")}catch(O){G.success=!1,G.message=O.message,k.sendResponse(G)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(U),U=(0,v.convertToVSCPaths)(U,!0),r.k.$acceptDAMessage(c,U)}),k.onError(U=>{L&&L.onError&&L.onError(U),this.k.$acceptDAError(c,U.name,U.message,U.stack)}),k.onExit(U=>{L&&L.onExit&&L.onExit((0,I.withNullAsUndefined)(U),void 0),this.k.$acceptDAExit(c,(0,I.withNullAsUndefined)(U),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),k.startSession()))})}$sendDAMessage(c,u){u=(0,v.convertToDAPaths)(u,!1);const r=this.C.get(c);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(u),this.B.get(c)?.sendMessage(u)}$stopDASession(c){const u=this.C.get(c);this.C.delete(c),u&&u.onWillStopSession&&u.onWillStopSession();const r=this.B.get(c);return this.B.delete(c),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const u=[],r=[],o=[];if(c.added)for(const n of c.added){const l=n.id;if(l&&!this.w.has(l)){let p;if(n.type==="function")p=new P.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")p=new P.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const k=A.URI.revive(n.uri);p=new P.SourceBreakpoint(new P.Location(k,new P.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}p._id=l,this.w.set(l,p),u.push(p)}}if(c.removed)for(const n of c.removed){const l=this.w.get(n);l&&(this.w.delete(n),r.push(l))}if(c.changed){for(const n of c.changed)if(n.id){const l=this.w.get(n.id);if(l){if(l instanceof P.FunctionBreakpoint&&n.type==="function"){const p=l;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.functionName=n.functionName}else if(l instanceof P.SourceBreakpoint&&n.type==="source"){const p=l;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.location=new P.Location(A.URI.revive(n.uri),new P.Position(n.line,n.character))}o.push(l)}}}this.V(u,r,o)}$provideDebugConfigurations(c,u,r){return(0,a.asPromise)(async()=>{const o=this.P(c);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.X(u);return o.provideDebugConfigurations(n,r)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(c,u,r,o){return(0,a.asPromise)(async()=>{const n=this.P(c);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.X(u);return n.resolveDebugConfiguration(l,r,o)})}$resolveDebugConfigurationWithSubstitutedVariables(c,u,r,o){return(0,a.asPromise)(async()=>{const n=this.P(c);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.X(u);return n.resolveDebugConfigurationWithSubstitutedVariables(l,r,o)})}async $provideDebugAdapter(c,u){const r=this.O(c);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.W(u);return this.S(r,o).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.M(n)})}async $acceptDebugSessionStarted(c){const u=await this.W(c);this.m.fire(u)}async $acceptDebugSessionTerminated(c){const u=await this.W(c);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(c){this.q=c?await this.W(c):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(c,u){(await this.W(c))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(c,u){const o={session:await this.W(c),event:u.event,body:u.body};this.u.fire(o)}M(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}N(c){const u=this.h.filter(r=>r.type===c);if(u.length>0)return u[0].factory}O(c){const u=this.h.filter(r=>r.handle===c);if(u.length>0)return u[0].factory}P(c){const u=this.f.filter(r=>r.handle===c);if(u.length>0)return u[0].provider}Q(c,u){if(c.contributes){const r=c.contributes.debuggers;if(r&&r.length>0){for(const o of r)if(o.label&&o.type&&o.type===u)return!0}}return!1}R(c){const r=c.configuration.type,o=this.j.filter(n=>n.type===r||n.type==="*").map(n=>(0,a.asPromise)(()=>n.factory.createDebugAdapterTracker(c)).then(l=>l,l=>null));return Promise.race([Promise.all(o).then(n=>{const l=n.filter(p=>!!p);if(l.length>0)return new h(l)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async S(c,u){const r=u.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new P.DebugAdapterServer(r));if(c){const n=await this.F.getExtensionRegistry();return(0,a.asPromise)(()=>c.createDebugAdapterDescriptor(u,this.T(u,n))).then(l=>{if(l)return l})}const o=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,o))}T(c,u){}U(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}V(c,u,r){(c.length>0||u.length>0||r.length>0)&&this.A.fire(Object.freeze({added:c,removed:u,changed:r}))}async W(c){if(c)if(typeof c=="string"){const u=this.l.get(c);if(u)return u}else{let u=this.l.get(c.id);if(!u){const r=await this.X(c.folderUri),o=c.parent?this.l.get(c.parent):void 0;u=new w(this.k,c.id,c.type,c.name,r,c.configuration,o),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}X(c){if(c){const u=A.URI.revive(c);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};f=Ve([ze(0,R.IExtHostRpcService),ze(1,E.IExtHostWorkspace),ze(2,C.IExtHostExtensionService),ze(3,d.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs),ze(5,g.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class w{constructor(c,u,r,o,n,l,p){this.d=c,this.f=u,this.g=r,this.h=o,this.i=n,this.j=l,this.k=p}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(c){this.h=c,this.d.$setDebugSessionName(this.f,c)}get parentSession(){return this.k}_acceptNameChanged(c){this.h=c}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(c,u){return this.d.$customDebugAdapterRequest(this.f,c,u)}getDebugProtocolBreakpoint(c){return this.d.$getDebugProtocolBreakpoint(this.f,c.id)}}e.ExtHostDebugSession=w;class m{constructor(c){this.value=Object.freeze({append(u){c.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=m;class h{constructor(c){this.d=c}onWillStartSession(){this.d.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(c):void 0)}onWillStopSession(){this.d.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.d.forEach(u=>u.onError?u.onError(c):void 0)}onExit(c,u){this.d.forEach(r=>r.onExit?r.onExit(c,u):void 0)}}class b extends y.AbstractDebugAdapter{constructor(c){super(),this.h=c,c.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.h.handleMessage(c)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends f{constructor(c,u,r,o,n,l){super(c,u,r,o,n,l)}};s=Ve([ze(0,R.IExtHostRpcService),ze(1,E.IExtHostWorkspace),ze(2,C.IExtHostExtensionService),ze(3,d.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs),ze(5,g.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(Se[289],ye([1,0,10,75,2,5,281,13,86,87,25,196,16,55,41,94]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class g{static async installEarlyHandler(m){const h=m.get(T.ILogService),s=m.get(E.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(i=>{h.error(i);const c=a.transformErrorForSerialization(i);s.$onUnexpectedError(c)})}static async installFullHandler(m){const h=m.get(T.ILogService),b=m.get(E.IExtHostRpcService),s=m.get(v.IExtHostExtensionService),i=m.get(d.IExtHostTelemetry),c=b.getProxy(A.MainContext.MainThreadExtensionService),u=b.getProxy(A.MainContext.MainThreadErrors),r=await s.getExtensionPathIndex(),o=new WeakMap;Error.prepareStackTrace=(n,l)=>{let p="",k,L;for(const U of l)p+=`
	at ${U.toString()}`,L=U.getFileName(),!k&&L&&(k=r.findSubstr(I.URI.file(L)));return o.set(n,k?.identifier),`${n.name||"Error"}: ${n.message||""}${p}`},a.setUnexpectedErrorHandler(n=>{h.error(n);const l=a.transformErrorForSerialization(n),p=o.get(n);if(!p){u.$onUnexpectedError(l);return}c.$onExtensionRuntimeError(p,l);const k=i.onExtensionError(p,n);h.trace("forwarded error to extension?",k,p)})}}Error.stackTraceLimit=100;class f{constructor(m,h,b,s,i){this.a=b,this.b=new D.RPCProtocol(m,null,s),h=f.e(h,this.b);const c=new C.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());c.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...h,messagePorts:i}),c.set(E.IExtHostRpcService,new E.ExtHostRpcService(this.b)),c.set(y.IURITransformerService,new y.URITransformerService(s)),c.set(v.IHostUtils,b);const u=new P.InstantiationService(c,!0);u.invokeFunction(g.installEarlyHandler),this.d=u.invokeFunction(r=>r.get(T.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",h),this.c=u.invokeFunction(r=>r.get(v.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(g.installFullHandler)}async asBrowserUri(m){const h=this.b.getProxy(A.MainContext.MainThreadExtensionService);return I.URI.revive(await h.$asBrowserUri(m))}terminate(m){this.c.terminate(m)}static e(m,h){m.allExtensions.forEach(s=>{s.extensionLocation=I.URI.revive(h.transformIncomingURIs(s.extensionLocation));const i={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(c=>i[c]=I.URI.revive(h.transformIncomingURIs(s.browserNlsBundleUris[c]))),s.browserNlsBundleUris=i)}),m.environment.appRoot=I.URI.revive(h.transformIncomingURIs(m.environment.appRoot));const b=m.environment.extensionDevelopmentLocationURI;return b&&(m.environment.extensionDevelopmentLocationURI=b.map(s=>I.URI.revive(h.transformIncomingURIs(s)))),m.environment.extensionTestsLocationURI=I.URI.revive(h.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=I.URI.revive(h.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=I.URI.revive(h.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=I.URI.revive(h.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=I.URI.revive(h.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=I.URI.revive(h.transformIncomingURIs(m.logsLocation)),m.logFile=I.URI.revive(h.transformIncomingURIs(m.logFile)),m.workspace=h.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=f}),define(Se[290],ye([1,0,18,12,179,195,203,76,59,41,16,40,7,47,33,217,219,34]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends T.ExtHostDebugServiceBase{constructor(i,c,u,r,o,n,l){super(i,c,u,r,n,l),this.bb=o,this.Y=new b}K(i,c){switch(i.type){case"server":return new d.SocketDebugAdapter(i);case"pipeServer":return new d.NamedPipeDebugAdapter(i);case"executable":return new d.ExecutableDebugAdapter(i,c.type)}return super.K(i,c)}T(i,c){const u=d.ExecutableDebugAdapter.platformAdapterExecutable(c.getAllExtensionDescriptions(),i.type);if(u)return new E.DebugAdapterExecutable(u.command,u.args,u.options)}L(){return new D.SignService}async $runInTerminal(i,c){if(i.kind==="integrated"){this.ab||(this.ab=this.bb.onDidCloseTerminal(O=>{this.Y.onTerminalClosed(O)}));const u=await this.G.getConfigProvider(),r=this.bb.getDefaultShell(!0),o=this.bb.getDefaultShellArgs(!0),n=i.title||I.localize(0,null),l=JSON.stringify({shell:r,shellArgs:o});let p=await this.Y.checkout(l,n),k,L=!1;if(p)k=i.cwd;else{const O={shellPath:r,shellArgs:o,cwd:i.cwd,name:n,iconPath:new E.ThemeIcon("debug")};L=!0,p=this.bb.createTerminalFromOptions(O,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.Y.insert(p,l)}p.show(!0);const U=await p.processId;L?await new Promise(O=>setTimeout(O,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?p.sendText("cls"):r.indexOf("bash")>=0?p.sendText("clear"):t.isWindows?p.sendText("cls"):p.sendText("clear"));const K=(0,g.prepareCommand)(r,i.args,!!i.argsCanBeInterpretedByShell,k,i.env);p.sendText(K);const G=this.onDidTerminateDebugSession(O=>{O.id===c&&(this.Y.free(p),G.dispose())});return U}else if(i.kind==="external")return h(i,await this.G.getConfigProvider());return super.$runInTerminal(i,c)}};w=Ve([ze(0,R.IExtHostRpcService),ze(1,v.IExtHostWorkspace),ze(2,C.IExtHostExtensionService),ze(3,f.IExtHostConfiguration),ze(4,P.IExtHostTerminalService),ze(5,S.IExtHostEditorTabs),ze(6,y.IExtHostVariableResolverProvider)],w),e.ExtHostDebugService=w;let m;function h(s,i){if(!m)if(t.isWindows)m=new A.WindowsExternalTerminalService;else if(t.isMacintosh)m=new A.MacExternalTerminalService;else if(t.isLinux)m=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=i.getConfiguration("terminal");return m.runInTerminal(s.title,s.cwd,s.args,s.env||{},c.external||{})}class b{constructor(){this.b=new Map}async checkout(i,c){const r=[...this.b.entries()].map(([o,n])=>(0,a.createCancelablePromise)(async l=>{if(o.name!==c||n.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await o.processId))return null;const p=Date.now();return n.lastUsedAt+b.a>p||l.isCancellationRequested||n.config!==i?null:(n.lastUsedAt=p,o)}));return await(0,a.firstParallel)(r,o=>!!o)}insert(i,c){this.b.set(i,{lastUsedAt:Date.now(),config:c})}free(i){const c=this.b.get(i);c&&(c.lastUsedAt=-1)}onTerminalClosed(i){this.b.delete(i)}}b.a=1e3}),define(Se[291],ye([1,0,9,2,114,33,58,34,45,40,16,25,74,15,13,69,24,85,47]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let m=class extends E.ExtHostTaskBase{constructor(b,s,i,c,u,r,o,n,l){super(b,s,i,c,u,r,o,n),this.C=i,this.D=l,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,s){const i=s;if(!s.execution&&i._id===void 0)throw new Error("Tasks to execute must include an execution");if(i._id!==void 0){const c=E.TaskHandleDTO.from(i,this.C),u=await this.a.$getTaskExecution(c);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.y(u,s);return this.a.$executeTask(c).catch(()=>{}),r}else{const c=E.TaskDTO.from(s,b);if(c===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(c.execution)&&await this.x(c,s,!1);const u=await this.y(await this.a.$getTaskExecution(c),s);return this.a.$executeTask(c).catch(()=>{}),u}}u(b,s,i,c){const u=[];if(c)for(const r of c){this.A(r,i),(!r.definition||!b[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const o=E.TaskDTO.from(r,i.extension);o&&(u.push(o),E.CustomExecutionDTO.is(o.execution)&&s.push(this.x(o,r,!0)))}return{tasks:u,extension:i.extension}}async v(b){return b}async G(b){let s=b&&b.length>0?b[0]:void 0;if(!s){const i=t.URI.file((0,f.homedir)());s=new S.WorkspaceFolder({uri:i,name:g.basename(i),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(b,s){const i=t.URI.revive(b),c={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(i),r=await this.b.getWorkspaceFolders2()??[],o=await this.D.getResolver(),n=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(r);for(const l of s.variables)c.variables[l]=await o.resolveAsync(n,l);if(s.process!==void 0){let l;if(s.process.path!==void 0){l=s.process.path.split(a.delimiter);for(let p=0;p<l.length;p++)l[p]=await o.resolveAsync(n,l[p])}c.process=await I.win32.findExecutable(await o.resolveAsync(n,s.process.name),s.process.cwd!==void 0?await o.resolveAsync(n,s.process.cwd):void 0,l)}return c}async $jsonTasksSupported(){return!0}async $findExecutable(b,s,i){return I.win32.findExecutable(b,s,i)}};m=Ve([ze(0,R.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,A.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,C.IExtHostTerminalService),ze(6,v.ILogService),ze(7,d.IExtHostApiDeprecationService),ze(8,w.IExtHostVariableResolverProvider)],m),e.ExtHostTask=m}),define(Se[292],ye([1,0,85,47]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class I extends t.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=I}),define(Se[142],ye([1,0,17,18,21,50,15,9,24,2,31]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(w,m,h,b){this.d=w,this.e=m,this.f=h,this.g=b,this.a=null,this.b=!1,this.c=0}search(w,m){const h=this.d.folderQueries||[],b=new I.CancellationTokenSource;return m.onCancellationRequested(()=>b.cancel()),new Promise((s,i)=>{this.a=new y(w);let c=!1;const u=(r,o)=>{if(!c&&!this.b){const n=this.h(r);d(r)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,c=!0,b.cancel(),r=this.j(r,this.d.maxResults-this.c));const l=this.h(r);this.c+=l,(l>0||!d(r))&&this.a.add(r,o)}};Promise.all(h.map((r,o)=>this.k(r,n=>u(n,o),b.token))).then(r=>{b.dispose(),this.a.flush();const o=r.some(n=>!!n&&!!n.limitHit);s({limitHit:this.b||o,messages:(0,a.flatten)(r.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},r=>{b.dispose();const o=(0,A.toErrorMessage)(r);i(new Error(o))})})}h(w){return d(w)?Array.isArray(w.ranges)?w.ranges.length:1:0}j(w,m){const h=Array.isArray(w.ranges)?w.ranges:[w.ranges],b=Array.isArray(w.preview.matches)?w.preview.matches:[w.preview.matches];return{ranges:h.slice(0,m),preview:{matches:b.slice(0,m),text:w.preview.text},uri:w.uri}}async k(w,m,h){const b=new R.QueryGlobTester(this.d,w),s=[],i={report:r=>{if(!this.l(r))return;const o=w.folder.scheme===D.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(r.uri))):void 0,n=S.relativePath(w.folder,r.uri);if(n){const l=b.includedInQuery(n,T.basename(n),o);(0,t.isThenable)(l)?s.push(l.then(p=>{p&&m(r)})):l&&m(r)}}},c=this.n(w),u=await this.e.provideTextSearchResults(E(this.d.contentPattern),c,i,h);return s.length&&await Promise.all(s),u}l(w){if(d(w)){if(Array.isArray(w.ranges)){if(!Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(w.preview.matches.length!==w.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(w){const m=(0,R.resolvePatternsForProvider)(this.d.includePattern,w.includePattern),h=(0,R.resolvePatternsForProvider)(this.d.excludePattern,w.excludePattern),b={folder:C.URI.from(w.folder),excludes:h,includes:m,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,encoding:w.fileEncoding&&this.f.toCanonicalName(w.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.TextSearchManager=P;function E(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class y{constructor(w){this.e=w,this.b=-1,this.d=null,this.a=new g(512,m=>this.g(m))}add(w,m){this.d&&(this.b!==m||!S.isEqual(this.c,w.uri))&&(this.f(),this.d=null),this.d||(this.b=m,this.d={resource:w.uri,results:[]}),this.d.results.push(v(w))}f(){const w=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,w)}flush(){this.f(),this.a.flush()}g(w){this.e(w)}}e.TextSearchResultsCollector=y;function v(f){return d(f)?{preview:{matches:(0,a.mapArrayOrNot)(f.preview.matches,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character})),text:f.preview.text},ranges:(0,a.mapArrayOrNot)(f.ranges,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function d(f){return!!f.preview}e.extensionResultIsMatch=d;class g{constructor(w,m){this.g=w,this.h=m,this.c=0,this.d=[],this.e=0}addItem(w,m){!w||this.j(w,m)}addItems(w,m){!w||this.k(w,m)}j(w,m){this.d.push(w),this.e+=m,this.l()}k(w,m){this.d=this.d.concat(w),this.e+=m,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=g,g.a=4e3,g.b=50}),define(Se[77],ye([1,0,6,5,3,285,16,55,13,2,142]),function(te,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let P=class{constructor(d,g,f){this.k=d,this.l=g,this.n=f,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,g){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const f=this.d++;return this.e.set(f,g),this.c.$registerTextSearchProvider(f,this.o(d)),(0,a.toDisposable)(()=>{this.g.delete(d),this.e.delete(f),this.c.$unregisterProvider(f)})}registerFileSearchProvider(d,g){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const f=this.d++;return this.h.set(f,g),this.c.$registerFileSearchProvider(f,this.o(d)),(0,a.toDisposable)(()=>{this.i.delete(d),this.h.delete(f),this.c.$unregisterProvider(f)})}$provideFileSearchResults(d,g,f,w){const m=E(f),h=this.h.get(d);if(h)return this.j.fileSearch(m,h,b=>{this.c.$handleFileMatch(d,g,b.map(s=>s.resource))},w);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,g,f,w){const m=this.e.get(d);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const h=E(f);return this.q(h,m).search(s=>this.c.$handleTextMatch(d,g,s),w)}$enableExtensionHostSearch(){}q(d,g){return new R.TextSearchManager(d,g,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};P=Ve([ze(0,D.IExtHostRpcService),ze(1,T.IURITransformerService),ze(2,S.ILogService)],P),e.ExtHostSearch=P;function E(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(y),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>C.URI.revive(d))}}e.reviveQuery=E;function y(v){return{...v,folder:C.URI.revive(v.folder)}}}),define(Se[293],ye([1,0,86,141,33,138,34,39,58,40,74,76,77,97,54,69,140,70,46,96,94,59,139,13,230,47,95]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m,h,b,s,i,c,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(r.IExtHostLocalizationService,r.ExtHostLocalizationService,1),(0,a.registerSingleton)(i.ILoggerService,s.ExtHostLoggerService,1),(0,a.registerSingleton)(i.ILogService,c.ExtHostLogService,1),(0,a.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,a.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration,0),(0,a.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,a.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,a.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,a.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,0),(0,a.registerSingleton)(y.IExtHostStorage,y.ExtHostStorage,0),(0,a.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,a.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,0),(0,a.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow,0),(0,a.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,0),(0,a.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState,0),(0,a.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry,0),(0,a.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,0),(0,a.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(Se[98],ye([1,0,17,13,31,73]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=D;function T(P,E,y,v){const d=(0,a.mapArrayOrNot)(y,S),g=new I.TextSearchMatch(E,d,v),f=g.preview.matches;return{ranges:(0,a.mapArrayOrNot)(d,C),uri:P,preview:{text:g.preview.text,matches:(0,a.mapArrayOrNot)(f,C)}}}e.createTextSearchResult=T;function S(P){return new I.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function C(P){return new A.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let R=class{constructor(E,y){this.a=E,this.b=y}appendLine(E){this.b.debug(`${this.a}#search`,E)}};R=Ve([ze(1,t.ILogService)],R),e.OutputChannel=R}),define(Se[294],ye([1,0,44,9,81,32,12,8,98,295]),function(te,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(m,h,b,s){const i=E(m,h,b,s),c=h.folder.fsPath;return{cmd:a.spawn(R,i.args,{cwd:c}),rgDiskPath:R,siblingClauses:i.siblingClauses,rgArgs:i,cwd:c}}e.spawnRipgrepCmd=P;function E(m,h,b,s){const i=["--files","--hidden","--case-sensitive"];v([h],b,!1).forEach(u=>{const r=(0,S.anchorGlob)(u);if(i.push("-g",r),D.isMacintosh){const o=(0,I.normalizeNFD)(r);o!==r&&i.push("-g",o)}});const c=y([h],s,void 0,!1);return c.globArgs.forEach(u=>{const r=`!${(0,S.anchorGlob)(u)}`;if(i.push("-g",r),D.isMacintosh){const o=(0,I.normalizeNFD)(r);o!==r&&i.push("-g",o)}}),h.disregardIgnoreFiles!==!1?i.push("--no-ignore"):h.disregardParentIgnoreFiles!==!1&&i.push("--no-ignore-parent"),h.ignoreSymlinks||i.push("--follow"),m.exists&&i.push("--quiet"),i.push("--no-config"),h.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:c.siblingClauses}}function y(m,h,b,s=!0){const i=[];let c={};return m.forEach(u=>{const r=Object.assign({},u.excludePattern||{},h||{}),o=d(r,s?u.folder.fsPath:void 0,b);i.push(...o.globArgs),o.siblingClauses&&(c=Object.assign(c,o.siblingClauses))}),{globArgs:i,siblingClauses:c}}e.foldersToRgExcludeGlobs=y;function v(m,h,b=!0){const s=[];return m.forEach(i=>{const c=Object.assign({},h||{},i.includePattern||{}),u=d(c,b?i.folder.fsPath:void 0);s.push(...u.globArgs)}),s}e.foldersToIncludeGlobs=v;function d(m,h,b){const s=[],i={};return Object.keys(m).forEach(c=>{if(b&&b.has(c)||!c)return;const u=m[c];c=f(h?g(h,c):c),c.startsWith("\\\\")?c="\\\\"+c.substr(2).replace(/\\/g,"/"):c=c.replace(/\\/g,"/"),typeof u=="boolean"&&u?(c.startsWith("\\\\")&&(c+="**"),s.push(w(c))):u&&u.when&&(i[c]=u)}),{globArgs:s,siblingClauses:i}}function g(m,h){return t.isAbsolute(h)?h:t.join(m,h)}e.getAbsoluteGlob=g;function f(m){return m=T.rtrim(m,"\\"),T.rtrim(m,"/")}function w(m){return A.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=w}),define(Se[296],ye([1,0,44,65,9,297,17,50,37,81,32,12,51,8,11,29,31,294,109]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(c=>c())});class h{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&S.parse(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,w.prepareQuery)(this.b).normalizedLowercase),this.u=u.excludePattern&&S.parse(u.excludePattern),this.t=new Map,u.folderQueries.forEach(r=>{const o=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),n=r.folder.fsPath;u.folderQueries.map(l=>l.folder.fsPath).filter(l=>l!==n).forEach(l=>{(0,R.isEqualOrParent)(l,n)&&(o[I.relative(n,l)]=!0)}),this.t.set(n,new s(o,n))})}cancel(){this.l=!0,m.forEach(u=>u())}walk(u,r,o,n,l){if(this.m=E.StopWatch.create(!1),this.l)return l(null,this.j);r.forEach(p=>{const k=I.basename(p.fsPath);this.u&&this.u(p.fsPath,k)||this.K(o,{relativePath:p.fsPath,searchPath:void 0})}),this.r=E.StopWatch.create(!1),this.w(u,(p,k)=>{this.x(this.y,this,p,o,n,L=>{if(L){const U=(0,T.toErrorMessage)(L);console.error(U),this.q.push(U),k(L,void 0)}else k(null,void 0)})},(p,k)=>{this.m.stop();const L=p?D.coalesce(p)[0]:null;l(L,this.j)})}w(u,r,o){const n=new Array(u.length),l=new Array(u.length);let p=!1,k=0;if(u.length===0)return o(null,[]);u.forEach((L,U)=>{r(L,(K,G)=>{if(K?(p=!0,n[U]=null,l[U]=K):(n[U]=G,l[U]=null),++k===u.length)return o(p?l:null,n)})})}x(u,r,...o){try{u.apply(r,o)}catch(n){o[o.length-1](n)}}y(u,r,o,n){const l=u.folder.fsPath,p=P.isMacintosh,k=()=>O&&O.kill();m.add(k);let L=M=>{m.delete(k),L=()=>{},n(M)},U="";const K=this.G(),G=(0,f.spawnRipgrepCmd)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),O=G.cmd,B=!Object.keys(G.siblingClauses).length,F=G.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let $=`${G.rgDiskPath} ${F}
 - cwd: ${G.cwd}`;G.rgArgs.siblingClauses&&($+=`
 - Sibling clauses: ${JSON.stringify(G.rgArgs.siblingClauses)}`),o({message:$}),this.s=0,this.A(O,"utf8",o,(M,V,q)=>{if(M){L(M);return}if(this.j){L();return}const J=(U+(p?C.normalizeNFC(V||""):V)).split(`
`);if(q){const Y=J.length;J[Y-1]=J[Y-1].trim(),J[Y-1]||J.pop()}else U=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.s+=J.length,B){for(const Y of J)if(this.K(r,{base:l,relativePath:Y,searchPath:this.O(u,Y)}),this.j){k();break}(q||this.j)&&L();return}this.H(u,K,l,J,r),q&&(this.I(K,l,r),L())})}spawnFindCmd(u){const r=this.t.get(u.folder.fsPath),o=r.getBasenameTerms(),n=r.getPathTerms(),l=["-L","."];if(o.length||n.length){l.push("-not","(","(");for(const p of o)l.push("-name",p),l.push("-o");for(const p of n)l.push("-path",p),l.push("-o");l.pop(),l.push(")","-prune",")")}return l.push("-type","f"),a.spawn("find",l,{cwd:u.folder.fsPath})}readStdout(u,r,o){let n="";this.A(u,r,()=>{},(l,p,k)=>{if(l){o(l);return}n+=p,k&&o(null,n)})}A(u,r,o,n){let l=(L,U,K)=>{(L||K)&&(l=()=>{},this.r?.stop()),n(L,U,K)},p=!1;u.stdout?(this.B(u.stdout,r,l),u.stdout.once("data",()=>p=!0)):o({message:"stdout is null"});let k;u.stderr?k=this.C(u.stderr):o({message:"stderr is null"}),u.on("error",L=>{l(L)}),u.on("close",L=>{let U;!p&&(U=this.D(k,r))&&i(U)?l(new Error(`command failed with error code ${L}: ${this.D(k,r)}`)):(this.g&&L===0&&(this.j=!0),l(null,"",!0))})}B(u,r,o){const n=new A.StringDecoder(r);return u.on("data",l=>{o(null,n.write(l))}),n}C(u){const r=[];return u.on("data",o=>{r.push(o)}),r}D(u,r){const o=new A.StringDecoder(r);return u.map(n=>o.write(n)).join("")}G(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}H(u,{pathToEntries:r},o,n,l){n.indexOf(this.b)!==-1&&this.K(l,{base:o,relativePath:this.b,searchPath:this.O(u,this.b)});const p=k=>{const L=I.basename(k),U=I.dirname(k);let K=r[U];K||(K=r[U]=[],p(U)),K.push({base:o,relativePath:k,basename:L,searchPath:this.O(u,k)})};n.forEach(p)}I({rootEntries:u,pathToEntries:r},o,n){const l=this,p=this.t.get(o),k=this.b;function L(U){l.o++;const K=(0,g.hasSiblingFn)(()=>U.map(G=>G.basename));for(let G=0,O=U.length;G<O;G++){const B=U[G],{relativePath:F,basename:$}=B;if(p.test(F,$,k!==$?K:void 0))continue;const M=r[F];if(M)L(M);else{if(l.p++,F===k)continue;l.K(n,B)}if(l.j)break}}L(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}J(u,r,o,n,l){const p=u.folder,k=(0,g.hasSiblingFn)(()=>o);this.w(o,(L,U)=>{if(this.l||this.j)return U(null);const K=r?[r,L].join(I.sep):L;if(this.t.get(u.folder.fsPath).test(K,L,this.a.filePattern!==L?k:void 0))return U(null);const G=[p.fsPath,K].join(I.sep);t.lstat(G,(O,B)=>{if(O||this.l||this.j)return U(null);this.M(G,B,(F,$)=>F||this.l||this.j?U(null):$.isDirectory()?(this.o++,this.N(G,B,(M,V)=>M||this.l||this.j||(V=V||"",this.v[V])?U(null):(this.v[V]=!0,d.Promises.readdir(G).then(q=>{if(this.l||this.j)return U(null);this.J(u,K,q,n,H=>U(H||null))},q=>{U(null)})))):(this.p++,K===this.b||this.h&&v.isNumber($.size)&&$.size>this.h||this.K(n,{base:p.fsPath,relativePath:K,searchPath:this.O(u,K)}),U(null,void 0)))})},L=>{const U=L&&D.coalesce(L);return l(U&&U.length>0?U[0]:void 0)})}K(u,r){this.L(r)&&(!this.d||this.d(r.relativePath,I.basename(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(r))}L(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.isFilePatternMatch)(u,this.c)}return!0}M(u,r,o){return r.isSymbolicLink()?t.stat(u,o):o(null,r)}N(u,r,o){return r.isSymbolicLink()?t.realpath(u,(n,l)=>n?o(n):o(null,l)):o(null,u)}O(u,r){return u.folderName?I.join(u.folderName,r):r}}e.FileWalker=h;class b{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new h(u)}search(u,r,o){this.c.walk(this.a,this.b,u,r,(n,l)=>{o(n,{limitHit:l,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=b;class s{constructor(u,r){this.expression=u,this.c=r,this.d(u)}d(u){let r,o;Object.keys(u).filter(n=>u[n]).forEach(n=>{I.isAbsolute(n)?(r=r||S.getEmptyExpression(),r[n]=u[n]):(o=o||S.getEmptyExpression(),o[n]=u[n])}),this.a=r&&S.parse(r,{trimForExclusions:!0}),this.b=o&&S.parse(o,{trimForExclusions:!0})}test(u,r,o){return this.b&&this.b(u,r,o)||this.a&&this.a(I.join(this.c,u),r,o)}getBasenameTerms(){const u=[];return this.a&&u.push(...S.getBasenameTerms(this.a)),this.b&&u.push(...S.getBasenameTerms(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...S.getPathTerms(this.a)),this.b&&u.push(...S.getPathTerms(this.b)),u}}function i(c){const u=c.trim().split(`
`),r=u[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return y.uppercaseFirstLetter(u[u.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=i}),define(Se[298],ye([1,0,101,22]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(c){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===c)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,D=512,T=512*8,S=512*128;var C;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(u,r){super(u),this.decodeStreamErrorKind=r}}e.DecodeStreamError=R;class P{static async create(u){let r;if(u!==e.UTF8)r=(await new Promise((n,l)=>{te(["@vscode/iconv-lite-umd"],n,l)})).getDecoder(d(u));else{const o=new TextDecoder;r={write(n){return o.decode(n,{stream:!0})},end(){return o.decode()}}}return new P(r)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function E(c,u){const r=u.minBytesRequiredForDetection??u.guessEncoding?T:D;return new Promise((o,n)=>{const l=(0,a.newWriteableStream)(G=>G.join("")),p=[];let k=0,L,U;const K=async()=>{try{const G=await i({buffer:t.VSBuffer.concat(p),bytesRead:k},u.guessEncoding);if(G.seemsBinary&&u.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);G.encoding=await u.overwriteEncoding(G.encoding),L=await P.create(G.encoding);const O=L.write(t.VSBuffer.concat(p).buffer);l.write(O),p.length=0,k=0,o({stream:l,detected:G})}catch(G){U?.dispose(),l.destroy(),n(G)}};U=(0,a.listenStream)(c,{onData:async G=>{L?l.write(L.write(G.buffer)):(p.push(G),k+=G.byteLength,k>=r&&(c.pause(),await K(),setTimeout(()=>c.resume())))},onError:G=>l.error(G),onEnd:async()=>{L||await K(),l.end(L?.end())}})})}e.toDecodeStream=E;async function y(c,u,r){const n=(await new Promise((k,L)=>{te(["@vscode/iconv-lite-umd"],k,L)})).getEncoder(d(u),r);let l=!1,p=!1;return{read(){if(p)return null;const k=c.read();if(typeof k!="string"){if(p=!0,!l&&r?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=n.end();return L&&L.length>0?(l=!0,t.VSBuffer.wrap(L)):null}return l=!0,t.VSBuffer.wrap(n.write(k))}}}e.toEncodeReadable=y;async function v(c){return(await new Promise((r,o)=>{te(["@vscode/iconv-lite-umd"],r,o)})).encodingExists(d(c))}e.encodingExists=v;function d(c){return c===e.UTF8_with_bom||c===null?e.UTF8:c}e.toNodeEncoding=d;function g(c,u){if(!c||u<e.UTF16be_BOM.length)return null;const r=c.readUInt8(0),o=c.readUInt8(1);if(r===e.UTF16be_BOM[0]&&o===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&o===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const n=c.readUInt8(2);return r===e.UTF8_BOM[0]&&o===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=g;const f=["ascii","utf-16","utf-32"];async function w(c){const u=await new Promise((p,k)=>{te(["jschardet"],p,k)}),r=c.slice(0,S),o=b(r.buffer),n=u.detect(o);if(!n||!n.encoding)return null;const l=n.encoding.toLowerCase();return 0<=f.indexOf(l)?null:h(n.encoding)}const m={ibm866:"cp866",big5:"cp950"};function h(c){const u=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return m[u]||u}function b(c){let u="";for(let r=0;r<c.length;r++)u+=String.fromCharCode(c[r]);return u}function s(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=c.match(/windows(\d+)/);return u?"windows-"+u[1]:c}}}e.toCanonicalName=s;function i({buffer:c,bytesRead:u},r){let o=g(c,u),n=!1;if(o!==e.UTF16be&&o!==e.UTF16le&&c){let l=!0,p=!0,k=!1;for(let L=0;L<u&&L<A;L++){const U=L%2===1,K=c.readUInt8(L)===0;if(K&&(k=!0),l&&(U&&!K||!U&&K)&&(l=!1),p&&(U&&K||!U&&!K)&&(p=!1),K&&!l&&!p)break}k&&(l?o=e.UTF16le:p?o=e.UTF16be:n=!0)}return r&&!n&&!o&&c?w(c.slice(0,u)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:n,encoding:o}}e.detectEncodingFromBuffer=i,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[143],ye([1,0,298,29,142]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends I.TextSearchManager{constructor(T,S,C=t,R="searchProcess"){super(T,S,{readdir:P=>C.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,a.toCanonicalName)(P)},R)}}e.NativeTextSearchManager=A}),define(Se[299],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const A=this.a.get(I);return this.a.delete(I),A}}addDragOperationTransfer(I,A){this.a.set(I,A)}getRenderedTreeElement(I){if(this.b.has(I))return this.b.get(I)}addRenderedTreeItemElement(I,A){this.b.set(I,A)}removeRenderedTreeItemElement(I){this.b.has(I)&&this.b.delete(I)}}e.TreeviewsService=a}),define(Se[300],ye([1,0,177,7,24,2,4,6,18,7,11,17,14,21,299,26]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(m,h){if((0,R.isString)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let b;return Array.isArray(m.highlights)&&(b=m.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),b=b.length?b:void 0),{label:m.label,highlights:b}}}class f{constructor(h,b,s){this.d=h,this.e=b,this.f=s,this.a=new Map,this.b=new v.TreeviewsService;function i(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}b.registerArgumentProcessor({processArgument:c=>i(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(u=>i(u)?this.i(u):u):c})}registerTreeDataProvider(h,b,s){const i=this.createTreeView(h,{treeDataProvider:b},s);return{dispose:()=>i.dispose()}}createTreeView(h,b,s){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=b.dragAndDropController?.dropMimeTypes??[],c=b.dragAndDropController?.dragMimeTypes??[],u=!!b.dragAndDropController?.handleDrag,r=!!b.dragAndDropController?.handleDrop,o=this.h(h,b,s),n=this.d.$registerTreeViewDataProvider(h,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,dropMimeTypes:i,dragMimeTypes:c,hasHandleDrag:u,hasHandleDrop:r});return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(s,"treeItemCheckbox"),o.onDidChangeCheckboxState},get message(){return o.message},set message(l){o.message=l},get title(){return o.title},set title(l){o.title=l},get description(){return o.description},set description(l){o.description=l},get badge(){return o.badge},set badge(l){l!==void 0&&C.ViewBadge.isViewBadge(l)?o.badge={value:Math.floor(Math.abs(l.value)),tooltip:l.tooltip}:l===void 0&&(o.badge=void 0)},reveal:(l,p)=>o.reveal(l,p),dispose:async()=>{await n,this.a.delete(h),o.dispose()}}}$getChildren(h,b){const s=this.a.get(h);return s?s.getChildren(b):Promise.reject(new Error((0,a.localize)(0,null,h)))}async $handleDrop(h,b,s,i,c,u,r,o){const n=this.a.get(h);if(!n)return Promise.reject(new Error((0,a.localize)(1,null,h)));const l=E.DataTransfer.toDataTransfer(s,async p=>(await this.d.$resolveDropFileData(h,b,p)).buffer);return r===h&&o&&await this.g(l,n,o,c,u),n.onDrop(l,i,c)}async g(h,b,s,i,c){const u=this.b.removeDragOperationTransfer(c);if(u)(await u)?.forEach((r,o)=>{r&&h.set(o,r)});else if(c&&b.handleDrag){const r=b.handleDrag(s,h,i);this.b.addDragOperationTransfer(c,r),await r}return h}async $handleDrag(h,b,s,i){const c=this.a.get(h);if(!c)return Promise.reject(new Error((0,a.localize)(2,null,h)));const u=await this.g(new t.DataTransfer,c,b,i,s);if(!!u)return E.DataTransfer.toDataTransferDTO(u)}async $hasResolve(h){const b=this.a.get(h);if(!b)throw new Error((0,a.localize)(3,null,h));return b.hasResolve}$resolve(h,b,s){const i=this.a.get(h);if(!i)throw new Error((0,a.localize)(4,null,h));return i.resolveTreeItem(b,s)}$setExpanded(h,b,s){const i=this.a.get(h);if(!i)throw new Error((0,a.localize)(5,null,h));i.setExpanded(b,s)}$setSelection(h,b){const s=this.a.get(h);if(!s)throw new Error((0,a.localize)(6,null,h));s.setSelection(b)}$setFocus(h,b){const s=this.a.get(h);if(!s)throw new Error((0,a.localize)(7,null,h));s.setFocus(b)}$setVisible(h,b){const s=this.a.get(h);if(!s)throw new Error((0,a.localize)(8,null,h));s.setVisible(b)}$changeCheckboxState(h,b){const s=this.a.get(h);if(!s)throw new Error((0,a.localize)(9,null,h));s.setCheckboxState(b)}h(h,b,s){const i=new w(h,b,this.d,this.e.converter,this.f,s);return this.a.set(h,i),i}i(h){const b=this.a.get(h.$treeViewId);return b&&"$treeItemHandle"in h?b.getExtensionElement(h.$treeItemHandle):b&&"$focusedTreeItem"in h&&h.$focusedTreeItem?b.focusedElement:null}}e.ExtHostTreeViews=f;class w extends T.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.isUndefinedOrNull)(h))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(h,b,s,i,c,u){if(super(),this.D=h,this.F=s,this.G=i,this.H=c,this.I=u,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new D.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new D.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new D.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new D.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new D.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new D.Emitter),this.y=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new y.CancellationTokenSource,u.contributes&&u.contributes.views)for(const n in u.contributes.views)for(const l of u.contributes.views[n])l.id===h&&(this.L=l.name);this.f=b.treeDataProvider,this.g=b.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let r,o;this.B(D.Event.debounce(this.w.event,(n,l)=>(n||(n={message:!1,elements:[]}),l.element!==!1&&(r||(r=new Promise(p=>o=p),this.y=this.y.then(()=>r)),Array.isArray(l.element)?n.elements.push(...l.element):n.elements.push(l.element)),l.message&&(n.message=!0),n),200,!0)(({message:n,elements:l})=>{l.length&&(this.C=this.C.then(()=>{const p=o;return r=null,this.W(l).then(()=>p())})),n&&this.F.$setMessage(this.D,this.J)}))}async getChildren(h){const b=h?this.getExtensionElement(h):void 0;if(h&&!b)return this.H.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.R(h);return s||(s=await this.S(b)),s?s.map(i=>i.item):void 0}getExtensionElement(h){return this.i.get(h)}reveal(h,b){b=b||{select:!0,focus:!1};const s=(0,R.isUndefinedOrNull)(b.select)?!0:b.select,i=(0,R.isUndefinedOrNull)(b.focus)?!1:b.focus,c=(0,R.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.y.then(()=>this.O(h)).then(u=>this.Q(h,u[u.length-1]).then(r=>this.F.$reveal(this.D,{item:r.item,parentChain:u.map(o=>o.item)},{select:s,focus:i,expand:c})),u=>this.H.error(u)):this.F.$reveal(this.D,void 0,{select:s,focus:i,expand:c})}get message(){return this.J}set message(h){this.J=h,this.w.fire({message:!0,element:!1})}get title(){return this.L}set title(h){this.L=h,this.F.$setTitle(this.D,h,this.M)}get description(){return this.M}set description(h){this.M=h,this.F.$setTitle(this.D,this.L,h)}get badge(){return this.N}set badge(h){this.N?.value===h?.value&&this.N?.tooltip===h?.tooltip||(this.N=E.ViewBadge.from(h),this.F.$setBadge(this.D,h))}setExpanded(h,b){const s=this.getExtensionElement(h);s&&(b?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(h){(0,P.equals)(this.l,h)||(this.l=h,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(h){this.m=h}setVisible(h){h!==this.k&&(this.k=h,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(h){const b=(await Promise.all(h.map(async s=>{const i=this.getExtensionElement(s.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:s.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);b.forEach(s=>{s.treeItem.checkboxState=s.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}),this.v.fire({items:b.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,b,s){const i=[];for(const c of h){const u=this.getExtensionElement(c);u&&i.push(u)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,b,s),b}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,b,s){const i=b?this.getExtensionElement(b):void 0;if(!(!i&&b||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(i,h,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,b){if(!this.f.resolveTreeItem)return;const s=this.i.get(h);if(s){const i=this.j.get(s);if(i){const c=await this.f.resolveTreeItem(i.extensionItem,s,b)??i.extensionItem;return this.fb(c),i.item.tooltip=this.cb(c.tooltip),i.item.command=this.db(i.disposableStore,c.command),i.item}}}O(h){return this.P(h).then(b=>b?this.O(b).then(s=>this.Q(b,s[s.length-1]).then(i=>(s.push(i),s))):Promise.resolve([]))}P(h){const b=this.j.get(h);return b?Promise.resolve(b.parent?this.i.get(b.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(h))}Q(h,b){const s=this.j.get(h);return s?Promise.resolve(s):(0,S.asPromise)(()=>this.f.getTreeItem(h)).then(i=>this.ib(h,i,b,!0)).then(i=>this.getChildren(b?b.item.handle:void 0).then(()=>{const c=this.getExtensionElement(i);if(c){const u=this.j.get(c);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}R(h){if(h){let b;if(typeof h=="string"){const s=this.getExtensionElement(h);b=s?this.j.get(s):void 0}else b=h;return b&&b.children||void 0}return this.h}async S(h){this.pb(h);const b=new y.CancellationTokenSource(this.U.token);try{const s=h?this.j.get(h):void 0,i=await this.f.getChildren(h);if(b.token.isCancellationRequested)return;const c=await Promise.all((0,P.coalesce)(i||[]).map(async u=>{const r=await this.f.getTreeItem(u);return r&&!b.token.isCancellationRequested?this.bb(u,r,s):null}));return b.token.isCancellationRequested?void 0:(0,P.coalesce)(c)}finally{b.dispose()}}W(h){if(h.some(s=>!s))return this.U.dispose(!0),this.U=new y.CancellationTokenSource,this.rb(),this.F.$refresh(this.D);{const s=this.X(h);if(s.length)return this.Y(s)}return Promise.resolve(void 0)}X(h){const b=new Set,s=h.map(c=>this.j.get(c));for(const c of s)if(c&&!b.has(c.item.handle)){let u=c;for(;u&&u.parent&&s.findIndex(r=>u&&u.parent&&r&&r.item.handle===u.parent.item.handle)===-1;){const r=this.i.get(u.parent.item.handle);u=r?this.j.get(r):void 0}u&&!u.parent&&b.add(c.item.handle)}const i=[];return b.forEach(c=>{const u=this.i.get(c);if(u){const r=this.j.get(u);r&&(!r.parent||!b.has(r.parent.item.handle))&&i.push(c)}}),i}Y(h){const b={};return Promise.all(h.map(s=>this.ab(s).then(i=>{i&&(b[s]=i.item)}))).then(()=>Object.keys(b).length?this.F.$refresh(this.D,b):void 0)}ab(h){const b=this.getExtensionElement(h);if(b){const s=this.j.get(b);if(s)return this.pb(b),(0,S.asPromise)(()=>this.f.getTreeItem(b)).then(i=>{if(i){const c=this.gb(b,i,s.parent);return this.nb(b,c,s,s.parent),s.dispose(),c}return null})}return Promise.resolve(null)}bb(h,b,s){const i=this.gb(h,b,s);if(b.id&&this.i.has(i.item.handle))throw new Error((0,a.localize)(10,null,b.id));return this.mb(h,i),this.ob(i,s),i}cb(h){return C.MarkdownString.isMarkdownString(h)?E.MarkdownString.from(h):h}db(h,b){return b?{...this.G.toInternal(b,h),originalId:b.command}:void 0}eb(h){if(!h.checkboxState)return;let b,s;return typeof h.checkboxState=="number"?b=h.checkboxState:(b=h.checkboxState.state,s=h.checkboxState.tooltip),{isChecked:b===C.TreeItemCheckboxState.Checked,tooltip:s}}fb(h){if(!C.TreeItem.isTreeItem(h,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}gb(h,b,s){this.fb(b);const i=new T.DisposableStore,c=this.ib(h,b,s),u=this.jb(b);return{item:{handle:c,parentHandle:s?s.item.handle:void 0,label:g(b.label,this.I),description:b.description,resourceUri:b.resourceUri,tooltip:this.cb(b.tooltip),command:this.db(i,b.command),contextValue:b.contextValue,icon:u,iconDark:this.kb(b)||u,themeIcon:this.hb(b),collapsibleState:(0,R.isUndefinedOrNull)(b.collapsibleState)?C.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation,checkbox:this.eb(b)},extensionItem:b,parent:s,children:void 0,disposableStore:i,dispose(){i.dispose()}}}hb(h){return h.iconPath instanceof C.ThemeIcon?h.iconPath:void 0}ib(h,{id:b,label:s,resourceUri:i},c,u){if(b)return`${w.b}/${b}`;const r=g(s,this.I),o=c?c.item.handle:w.a;let n=r?r.label:i?(0,I.basename)(i):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const l=this.j.has(h)?this.j.get(h).item.handle:void 0,p=this.R(c)||[];let k,L=0;do{if(k=`${o}/${L}:${n}`,u||!this.i.has(k)||l===k)break;L++}while(L<=p.length);return k}jb(h){if(h.iconPath&&!(h.iconPath instanceof C.ThemeIcon))return typeof h.iconPath=="string"||A.URI.isUri(h.iconPath)?this.lb(h.iconPath):this.lb(h.iconPath.light)}kb(h){if(h.iconPath&&!(h.iconPath instanceof C.ThemeIcon)&&h.iconPath.dark)return this.lb(h.iconPath.dark)}lb(h){return A.URI.isUri(h)?h:A.URI.file(h)}mb(h,b){this.i.set(b.item.handle,h),this.j.set(h,b)}nb(h,b,s,i){this.i.delete(b.item.handle),this.j.delete(h),b.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.mb(h,b);const c=this.R(i)||[],u=c.filter(r=>r.item.handle===s.item.handle)[0];u&&c.splice(c.indexOf(u),1,b)}ob(h,b){b?(b.children||(b.children=[]),b.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}pb(h){if(h){const b=this.j.get(h);if(b){if(b.children)for(const s of b.children){const i=this.i.get(s.item.handle);i&&this.qb(i)}b.children=void 0}}else this.rb()}qb(h){const b=this.j.get(h);if(b){if(b.children)for(const s of b.children){const i=this.i.get(s.item.handle);i&&this.qb(i)}this.j.delete(h),this.i.delete(b.item.handle),b.dispose()}}rb(){this.h=void 0,this.i.clear(),this.j.forEach(h=>h.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.rb(),this.F.$disposeTree(this.D)}}w.a="0",w.b="1"}),define(Se[301],ye([1,0,21,10,4,42,2,119,105,151,160,38,5,93,244,243,39,245,34,247,248,249,232,250,58,41,251,252,255,256,257,141,235,262,263,264,97,40,266,300,14,7,128,269,72,140,33,222,254,88,138,74,76,77,13,55,16,25,258,231,54,69,241,267,71,70,272,270,271,242,46,265,268,96,59,94,259,73,260,15,123,234,211,253,6,26,215,95,208,261]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m,h,b,s,i,c,u,r,o,n,l,p,k,L,U,K,G,O,B,F,$,M,V,q,H,J,Y,ae,re,fe,Z,pe,we,De,Re,Be,se,ue,de,ee,oe,ie,N,z,X,Q,le,be,Te,ge,Ce,Ie,He,qe,Ze,xe,tt,nt,ft,it,Fe,lt,W,_,ce,Pe,Le,Ge,Qe,ut,mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function st(rt){const ct=rt.get(de.IExtHostInitDataService),Et=rt.get(Ie.IExtHostFileSystemInfo),Rt=rt.get(le.IExtHostConsumerFileSystem),At=rt.get(u.IExtHostExtensionService),wt=rt.get(ae.IExtHostWorkspace),kt=rt.get(tt.IExtHostTelemetry),Bt=rt.get(w.IExtHostConfiguration),Nt=rt.get(se.IURITransformerService),Xe=rt.get(ue.IExtHostRpcService),zt=rt.get(O.IExtHostStorage),Lt=rt.get(Q.IExtensionStoragePaths),Wt=rt.get(Be.ILoggerService),pt=rt.get(Be.ILogService),Mt=rt.get(ie.IExtHostTunnelService),Ae=rt.get(N.IExtHostApiDeprecationService),Oe=rt.get(Y.IExtHostWindow),Ee=rt.get(Ze.IExtHostSecretState),ne=rt.get(xe.IExtHostEditorTabs);Xe.set(E.ExtHostContext.ExtHostFileSystemInfo,Et),Xe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Wt),Xe.set(E.ExtHostContext.ExtHostWorkspace,wt),Xe.set(E.ExtHostContext.ExtHostConfiguration,Bt),Xe.set(E.ExtHostContext.ExtHostExtensionService,At),Xe.set(E.ExtHostContext.ExtHostStorage,zt),Xe.set(E.ExtHostContext.ExtHostTunnelService,Mt),Xe.set(E.ExtHostContext.ExtHostWindow,Oe),Xe.set(E.ExtHostContext.ExtHostSecretState,Ee),Xe.set(E.ExtHostContext.ExtHostTelemetry,kt),Xe.set(E.ExtHostContext.ExtHostEditorTabs,ne);const Ne=Xe.set(E.ExtHostContext.ExtHostDecorations,rt.get(pe.IExtHostDecorations)),$e=Xe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(c.IExtHostDocumentsAndEditors)),_e=Xe.set(E.ExtHostContext.ExtHostCommands,rt.get(g.IExtHostCommands)),je=Xe.set(E.ExtHostContext.ExtHostTerminalService,rt.get(B.IExtHostTerminalService)),et=Xe.set(E.ExtHostContext.ExtHostDebugService,rt.get(De.IExtHostDebugService)),It=Xe.set(E.ExtHostContext.ExtHostSearch,rt.get(Re.IExtHostSearch)),St=Xe.set(E.ExtHostContext.ExtHostTask,rt.get(we.IExtHostTask)),Ot=Xe.set(E.ExtHostContext.ExtHostOutputService,rt.get(k.IExtHostOutputService)),bt=Xe.set(E.ExtHostContext.ExtHostLocalization,rt.get(Qe.IExtHostLocalizationService)),Tt=Xe.set(E.ExtHostContext.ExtHostUrls,new H.ExtHostUrls(Xe)),vt=Xe.set(E.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Xe,$e)),Ht=Xe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(Xe,$e,pt)),Ut=Xe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(pt,vt,Xe.getProxy(E.MainContext.MainThreadBulkEdits))),yt=Xe.set(E.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(Xe,_e,$e,vt)),Zt=Xe.set(E.ExtHostContext.ExtHostNotebookDocuments,new _.ExtHostNotebookDocuments(yt)),an=Xe.set(E.ExtHostContext.ExtHostNotebookEditors,new W.ExtHostNotebookEditors(pt,yt)),en=Xe.set(E.ExtHostContext.ExtHostNotebookKernels,new nt.ExtHostNotebookKernels(Xe,ct,yt,_e,pt)),bn=Xe.set(E.ExtHostContext.ExtHostNotebookRenderers,new it.ExtHostNotebookRenderers(Xe,yt)),Ct=Xe.set(E.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Xe,$e)),cn=Xe.set(E.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(Xe.getProxy(E.MainContext.MainThreadTreeViews),_e,pt)),On=Xe.set(E.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Xe.getProxy(E.MainContext.MainThreadEditorInsets),Ct,ct.remote)),tn=Xe.set(E.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(Xe,pt,Et,$e)),Vt=Xe.set(E.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Xe,vt,_e.converter,Nt)),dt=Xe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Nt,vt,_e,tn,pt,Ae,kt)),wn=Xe.set(E.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Xe,dt)),qt=Xe.set(E.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(Xe,pt,$e)),_t=Xe.set(E.ExtHostContext.ExtHostQuickOpen,(0,U.createExtHostQuickOpen)(Xe,wt,_e)),ln=Xe.set(E.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(Xe,_e,pt)),vn=Xe.set(E.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Xe,_e,vt)),un=Xe.set(E.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Xe.getProxy(E.MainContext.MainThreadProgress))),En=Xe.set(E.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(Xe)),kn=Xe.set(E.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Xe)),nn=Xe.set(E.ExtHostContext.ExtHostAuthentication,new z.ExtHostAuthentication(Xe)),Sn=Xe.set(E.ExtHostContext.ExtHostTimeline,new X.ExtHostTimeline(Xe,_e)),sn=Xe.set(E.ExtHostContext.ExtHostWebviews,new J.ExtHostWebviews(Xe,ct.remote,wt,pt,Ae)),on=Xe.set(E.ExtHostContext.ExtHostWebviewPanels,new ge.ExtHostWebviewPanels(Xe,sn,wt)),Nn=Xe.set(E.ExtHostContext.ExtHostCustomEditors,new Te.ExtHostCustomEditors(Xe,vt,Lt,sn,on)),yn=Xe.set(E.ExtHostContext.ExtHostWebviewViews,new be.ExtHostWebviewViews(Xe,sn)),Qt=Xe.set(E.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Xe,_e,$e)),Fn=Xe.set(E.ExtHostContext.ExtHostUriOpeners,new qe.ExtHostUriOpeners(Xe)),Mn=Xe.set(E.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Xe));Xe.set(E.ExtHostContext.ExtHostInteractive,new ce.ExtHostInteractive(Xe,yt,$e,_e,pt));const Un=Object.values(E.ExtHostContext);Xe.assertRegistered(Un);const Bn=new Ce.ExtHostBulkEdits(Xe,$e),$n=new d.ExtHostClipboard(Xe),Cn=new p.ExtHostMessageService(Xe,pt),dn=new h.ExtHostDialogs(Xe),hn=new G.ExtHostStatusBar(Xe,_e.converter);return v.ExtHostApiCommands.register(_e),function(We,Kt,Tn){const gt=function(){let me=!We.isUnderDevelopment;function ve(){me||(pt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Ue(ot){if(Array.isArray(ot))ot.forEach(Ue);else if(typeof ot=="string")ve();else{const Dt=ot;typeof Dt.scheme>"u"&&ve(),typeof Dt.exclusive=="boolean"&&(0,Le.checkProposedApiEnabled)(We,"documentFiltersExclusive")}return ot}}(),zn={getSession(me,ve,Ue){return nn.getSession(We,me,ve,Ue)},async hasSession(me,ve){return(0,Le.checkProposedApiEnabled)(We,"authSession"),!!await nn.getSession(We,me,ve,{silent:!0})},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(me,ve,Ue,ot){return nn.registerAuthenticationProvider(me,ve,Ue,ot)}},Wn={registerCommand(me,ve,Ue){return _e.registerCommand(!0,me,ve,Ue,void 0,We)},registerTextEditorCommand(me,ve,Ue){return _e.registerCommand(!0,me,(...ot)=>{const Dt=Ct.getActiveTextEditor();if(!Dt){pt.warn("Cannot execute "+me+" because there is no active text editor.");return}return Dt.edit(Pt=>{ve.apply(Ue,[Dt,Pt,...ot])}).then(Pt=>{Pt||pt.warn("Edits from command "+me+" were not applied.")},Pt=>{pt.warn("An error occurred while running command "+me,Pt)})},void 0,void 0,We)},registerDiffInformationCommand:(me,ve,Ue)=>((0,Le.checkProposedApiEnabled)(We,"diffCommand"),_e.registerCommand(!0,me,async(...ot)=>{const Dt=$e.activeEditor(!0);if(!Dt){pt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Pt=await Ct.getDiffInformation(Dt.id);ve.apply(Ue,[Pt,...ot])},void 0,void 0,We)),executeCommand(me,...ve){return _e.executeCommand(me,...ve)},getCommands(me=!1){return _e.getCommands(me)}},Pn={get machineId(){return ct.telemetryInfo.machineId},get sessionId(){return ct.telemetryInfo.sessionId},get language(){return ct.environment.appLanguage},get appName(){return ct.environment.appName},get appRoot(){return ct.environment.appRoot?.fsPath??""},get appHost(){return ct.environment.appHost},get uriScheme(){return ct.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return je.getDefaultShell(!1)},get onDidChangeShell(){return(0,Le.checkProposedApiEnabled)(We,"envShellEvent"),je.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Le.checkProposedApiEnabled)(We,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Le.checkProposedApiEnabled)(We,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.isNewAppInstall)(ct.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Le.checkProposedApiEnabled)(We,"telemetryLogger"),kt.instantiateLogger(We,me)},openExternal(me,ve){return Oe.openUri(me,{allowTunneling:!!ct.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===ct.environment.appUriScheme)return Tt.createAppUri(me);try{return await Oe.asExternalUri(me,{allowTunneling:!!ct.remote.authority})}catch(ve){if((0,lt.matchesScheme)(me,Fe.Schemas.http)||(0,lt.matchesScheme)(me,Fe.Schemas.https))return me;throw ve}},get remoteName(){return(0,Z.getRemoteName)(ct.remote.authority)},get remoteAuthority(){return(0,Le.checkProposedApiEnabled)(We,"resolvers"),ct.remote.authority},get uiKind(){return ct.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return pt.onDidChangeLogLevel}};ct.environment.extensionTestsLocationURI||Object.freeze(Pn);const Hn={createTestController(me,ve,Ue){return Qt.createTestController(me,ve,Ue)},createTestObserver(){return(0,Le.checkProposedApiEnabled)(We,"testObserver"),Qt.createTestObserver()},runTests(me){return(0,Le.checkProposedApiEnabled)(We,"testObserver"),Qt.runTests(me)},get onDidChangeTestResults(){return(0,Le.checkProposedApiEnabled)(We,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,Le.checkProposedApiEnabled)(We,"testObserver"),Qt.results}},rn=ct.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,jn={getExtension(me,ve){(0,Le.isProposedApiEnabled)(We,"extensionsAny")||(ve=!1);const Ue=Kt.mine.getExtensionDescription(me);if(Ue)return new u.Extension(At,We.identifier,Ue,rn,!1);if(ve){const ot=Kt.all.getExtensionDescription(me);if(ot)return new u.Extension(At,We.identifier,ot,rn,!0)}},get all(){const me=[];for(const ve of Kt.mine.getAllExtensionDescriptions())me.push(new u.Extension(At,We.identifier,ve,rn,!1));return me},get allAcrossExtensionHosts(){(0,Le.checkProposedApiEnabled)(We,"extensionsAny");const me=new Le.ExtensionIdentifierSet(Kt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ve=[];for(const Ue of Kt.all.getAllExtensionDescriptions()){const ot=!me.has(Ue.identifier);ve.push(new u.Extension(At,We.identifier,Ue,rn,ot))}return ve},get onDidChange(){return(0,Le.isProposedApiEnabled)(We,"extensionsAny")?I.Event.any(Kt.mine.onDidChange,Kt.all.onDidChange):Kt.mine.onDidChange}},Xt={createDiagnosticCollection(me){return tn.createDiagnosticCollection(We.identifier,me)},get onDidChangeDiagnostics(){return tn.onDidChangeDiagnostics},getDiagnostics:me=>tn.getDiagnostics(me),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(me,ve){return Vt.changeLanguage(me.uri,ve)},match(me,ve){const Ue=vt.getDocumentData(ve.uri)?.notebook;return(0,R.score)(M.LanguageSelector.from(me),ve.uri,ve.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(me,ve,Ue){return dt.registerCodeActionProvider(We,gt(me),ve,Ue)},registerDocumentPasteEditProvider(me,ve,Ue){return(0,Le.checkProposedApiEnabled)(We,"documentPaste"),dt.registerDocumentPasteEditProvider(We,gt(me),ve,Ue)},registerCodeLensProvider(me,ve){return dt.registerCodeLensProvider(We,gt(me),ve)},registerDefinitionProvider(me,ve){return dt.registerDefinitionProvider(We,gt(me),ve)},registerDeclarationProvider(me,ve){return dt.registerDeclarationProvider(We,gt(me),ve)},registerImplementationProvider(me,ve){return dt.registerImplementationProvider(We,gt(me),ve)},registerTypeDefinitionProvider(me,ve){return dt.registerTypeDefinitionProvider(We,gt(me),ve)},registerHoverProvider(me,ve){return dt.registerHoverProvider(We,gt(me),ve,We.identifier)},registerEvaluatableExpressionProvider(me,ve){return dt.registerEvaluatableExpressionProvider(We,gt(me),ve,We.identifier)},registerInlineValuesProvider(me,ve){return dt.registerInlineValuesProvider(We,gt(me),ve,We.identifier)},registerDocumentHighlightProvider(me,ve){return dt.registerDocumentHighlightProvider(We,gt(me),ve)},registerLinkedEditingRangeProvider(me,ve){return dt.registerLinkedEditingRangeProvider(We,gt(me),ve)},registerReferenceProvider(me,ve){return dt.registerReferenceProvider(We,gt(me),ve)},registerRenameProvider(me,ve){return dt.registerRenameProvider(We,gt(me),ve)},registerDocumentSymbolProvider(me,ve,Ue){return dt.registerDocumentSymbolProvider(We,gt(me),ve,Ue)},registerWorkspaceSymbolProvider(me){return dt.registerWorkspaceSymbolProvider(We,me)},registerDocumentFormattingEditProvider(me,ve){return dt.registerDocumentFormattingEditProvider(We,gt(me),ve)},registerDocumentRangeFormattingEditProvider(me,ve){return dt.registerDocumentRangeFormattingEditProvider(We,gt(me),ve)},registerOnTypeFormattingEditProvider(me,ve,Ue,...ot){return dt.registerOnTypeFormattingEditProvider(We,gt(me),ve,[Ue].concat(ot))},registerDocumentSemanticTokensProvider(me,ve,Ue){return dt.registerDocumentSemanticTokensProvider(We,gt(me),ve,Ue)},registerDocumentRangeSemanticTokensProvider(me,ve,Ue){return dt.registerDocumentRangeSemanticTokensProvider(We,gt(me),ve,Ue)},registerSignatureHelpProvider(me,ve,Ue,...ot){return typeof Ue=="object"?dt.registerSignatureHelpProvider(We,gt(me),ve,Ue):dt.registerSignatureHelpProvider(We,gt(me),ve,typeof Ue>"u"?[]:[Ue,...ot])},registerCompletionItemProvider(me,ve,...Ue){return dt.registerCompletionItemProvider(We,gt(me),ve,Ue)},registerInlineCompletionItemProvider(me,ve){return ve.handleDidShowCompletionItem&&(0,Le.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(We,gt(me),ve)},registerDocumentLinkProvider(me,ve){return dt.registerDocumentLinkProvider(We,gt(me),ve)},registerColorProvider(me,ve){return dt.registerColorProvider(We,gt(me),ve)},registerFoldingRangeProvider(me,ve){return dt.registerFoldingRangeProvider(We,gt(me),ve)},registerSelectionRangeProvider(me,ve){return dt.registerSelectionRangeProvider(We,me,ve)},registerCallHierarchyProvider(me,ve){return dt.registerCallHierarchyProvider(We,me,ve)},registerTypeHierarchyProvider(me,ve){return dt.registerTypeHierarchyProvider(We,me,ve)},setLanguageConfiguration:(me,ve)=>dt.setLanguageConfiguration(We,me,ve),getTokenInformationAtPosition(me,ve){return(0,Le.checkProposedApiEnabled)(We,"tokenInformation"),Vt.tokenAtPosition(me,ve)},registerInlayHintsProvider(me,ve){return dt.registerInlayHintsProvider(We,me,ve)},createLanguageStatusItem(me,ve){return Vt.createLanguageStatusItem(We,me,ve)},registerDocumentDropEditProvider(me,ve){return dt.registerDocumentOnDropEditProvider(We,me,ve)}},fn={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return je.activeTerminal},get terminals(){return je.terminals},async showTextDocument(me,ve,Ue){const ot=await(D.URI.isUri(me)?Promise.resolve(An.openTextDocument(me)):Promise.resolve(me));return Ct.showTextDocument(ot,ve,Ue)},createTextEditorDecorationType(me){return Ct.createTextEditorDecorationType(We,me)},onDidChangeActiveTextEditor(me,ve,Ue){return Ct.onDidChangeActiveTextEditor(me,ve,Ue)},onDidChangeVisibleTextEditors(me,ve,Ue){return Ct.onDidChangeVisibleTextEditors(me,ve,Ue)},onDidChangeTextEditorSelection(me,ve,Ue){return Ct.onDidChangeTextEditorSelection(me,ve,Ue)},onDidChangeTextEditorOptions(me,ve,Ue){return Ct.onDidChangeTextEditorOptions(me,ve,Ue)},onDidChangeTextEditorVisibleRanges(me,ve,Ue){return Ct.onDidChangeTextEditorVisibleRanges(me,ve,Ue)},onDidChangeTextEditorViewColumn(me,ve,Ue){return Ct.onDidChangeTextEditorViewColumn(me,ve,Ue)},onDidCloseTerminal(me,ve,Ue){return je.onDidCloseTerminal(me,ve,Ue)},onDidOpenTerminal(me,ve,Ue){return je.onDidOpenTerminal(me,ve,Ue)},onDidChangeActiveTerminal(me,ve,Ue){return je.onDidChangeActiveTerminal(me,ve,Ue)},onDidChangeTerminalDimensions(me,ve,Ue){return(0,Le.checkProposedApiEnabled)(We,"terminalDimensions"),je.onDidChangeTerminalDimensions(me,ve,Ue)},onDidChangeTerminalState(me,ve,Ue){return je.onDidChangeTerminalState(me,ve,Ue)},onDidWriteTerminalData(me,ve,Ue){return(0,Le.checkProposedApiEnabled)(We,"terminalDataWriteEvent"),je.onDidWriteTerminalData(me,ve,Ue)},get state(){return Oe.state},onDidChangeWindowState(me,ve,Ue){return Oe.onDidChangeWindowState(me,ve,Ue)},showInformationMessage(me,...ve){return Cn.showMessage(We,A.default.Info,me,ve[0],ve.slice(1))},showWarningMessage(me,...ve){return Cn.showMessage(We,A.default.Warning,me,ve[0],ve.slice(1))},showErrorMessage(me,...ve){return Cn.showMessage(We,A.default.Error,me,ve[0],ve.slice(1))},showQuickPick(me,ve,Ue){return _t.showQuickPick(me,ve,Ue)},showWorkspaceFolderPick(me){return _t.showWorkspaceFolderPick(me)},showInputBox(me,ve){return _t.showInput(me,ve)},showOpenDialog(me){return dn.showOpenDialog(me)},showSaveDialog(me){return dn.showSaveDialog(me)},createStatusBarItem(me,ve,Ue){let ot,Dt,Pt;return typeof me=="string"?(ot=me,Dt=ve,Pt=Ue):(Dt=me,Pt=ve),hn.createStatusBarEntry(We,ot,Dt,Pt)},setStatusBarMessage(me,ve){return hn.setStatusBarMessage(me,ve)},withScmProgress(me){return Ae.report("window.withScmProgress",We,"Use 'withProgress' instead."),un.withProgress(We,{location:V.ProgressLocation.SourceControl},(ve,Ue)=>me({report(ot){}}))},withProgress(me,ve){return un.withProgress(We,me,ve)},createOutputChannel(me,ve){return Ot.createOutputChannel(me,ve,We)},createWebviewPanel(me,ve,Ue,ot){return on.createWebviewPanel(We,me,ve,Ue,ot)},createWebviewTextEditorInset(me,ve,Ue,ot){return(0,Le.checkProposedApiEnabled)(We,"editorInsets"),On.createWebviewEditorInset(me,ve,Ue,ot,We)},createTerminal(me,ve,Ue){return typeof me=="object"?"pty"in me?je.createExtensionTerminal(me):je.createTerminalFromOptions(me):je.createTerminal(me,ve,Ue)},registerTerminalLinkProvider(me){return je.registerLinkProvider(me)},registerTerminalProfileProvider(me,ve){return je.registerProfileProvider(We,me,ve)},registerTerminalQuickFixProvider(me,ve){return(0,Le.checkProposedApiEnabled)(We,"terminalQuickFixProvider"),je.registerTerminalQuickFixProvider(me,We.identifier.value,ve)},registerTreeDataProvider(me,ve){return cn.registerTreeDataProvider(me,ve,We)},createTreeView(me,ve){return cn.createTreeView(me,ve,We)},registerWebviewPanelSerializer:(me,ve)=>on.registerWebviewPanelSerializer(We,me,ve),registerCustomEditorProvider:(me,ve,Ue={})=>Nn.registerCustomEditorProvider(We,me,ve,Ue),registerFileDecorationProvider(me){return Ne.registerFileDecorationProvider(me,We)},registerUriHandler(me){return Tt.registerUriHandler(We.identifier,me)},createQuickPick(){return _t.createQuickPick(We)},createInputBox(){return _t.createInputBox(We)},get activeColorTheme(){return kn.activeColorTheme},onDidChangeActiveColorTheme(me,ve,Ue){return kn.onDidChangeActiveColorTheme(me,ve,Ue)},registerWebviewViewProvider(me,ve,Ue){return yn.registerWebviewViewProvider(We,me,ve,Ue?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,ve,Ue){return yt.onDidChangeActiveNotebookEditor(me,ve,Ue)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,ve,Ue){return an.onDidChangeNotebookEditorSelection(me,ve,Ue)},onDidChangeNotebookEditorVisibleRanges(me,ve,Ue){return an.onDidChangeNotebookEditorVisibleRanges(me,ve,Ue)},showNotebookDocument(me,ve){return yt.showNotebookDocument(me,ve)},registerExternalUriOpener(me,ve,Ue){return(0,Le.checkProposedApiEnabled)(We,"externalUriOpener"),Fn.registerExternalUriOpener(We.identifier,me,ve,Ue)},registerProfileContentHandler(me,ve){return(0,Le.checkProposedApiEnabled)(We,"profileContentHandlers"),Mn.registrProfileContentHandler(We,me,ve)},get tabGroups(){return ne.tabGroups}},An={get rootPath(){return Ae.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return wt.getWorkspaceFolder(me)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(me){throw t.readonly()},get workspaceFile(){return wt.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,ve,...Ue)=>wt.updateWorkspaceFolders(We,me,ve||0,...Ue),onDidChangeWorkspaceFolders:function(me,ve,Ue){return wt.onDidChangeWorkspace(me,ve,Ue)},asRelativePath:(me,ve)=>wt.getRelativePath(me,ve),findFiles:(me,ve,Ue,ot)=>wt.findFiles(me,ve,Ue,We.identifier,ot),findTextInFiles:(me,ve,Ue,ot)=>{(0,Le.checkProposedApiEnabled)(We,"findTextInFiles");let Dt,Pt;return typeof ve=="object"?(Dt=ve,Pt=Ue):(Dt={},Pt=ve,ot=Ue),wt.findTextInFiles(me,Dt||{},Pt,We.identifier,ot)},saveAll:me=>wt.saveAll(me),applyEdit(me,ve){return Bn.applyWorkspaceEdit(me,We,ve)},createFileSystemWatcher:(me,ve,Ue,ot)=>qt.createFileSystemWatcher(wt,We,me,ve,Ue,ot),get textDocuments(){return vt.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let ve;const Ue=me;if(typeof me=="string")ve=Promise.resolve(D.URI.file(me));else if(D.URI.isUri(me))ve=Promise.resolve(me);else if(!Ue||typeof Ue=="object")ve=vt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(ot=>vt.ensureDocumentData(ot).then(Dt=>Dt.document))},onDidOpenTextDocument:(me,ve,Ue)=>vt.onDidAddDocument(me,ve,Ue),onDidCloseTextDocument:(me,ve,Ue)=>vt.onDidRemoveDocument(me,ve,Ue),onDidChangeTextDocument:(me,ve,Ue)=>vt.onDidChangeDocument(me,ve,Ue),onDidSaveTextDocument:(me,ve,Ue)=>vt.onDidSaveDocument(me,ve,Ue),onWillSaveTextDocument:(me,ve,Ue)=>Ut.getOnWillSaveTextDocumentEvent(We)(me,ve,Ue),get notebookDocuments(){return yt.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,ve){let Ue;if(D.URI.isUri(me))Ue=me,await yt.openNotebookDocument(me);else if(typeof me=="string")Ue=D.URI.revive(await yt.createNotebookDocument({viewType:me,content:ve}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(me,ve,Ue){return Zt.onDidSaveNotebookDocument(me,ve,Ue)},onDidChangeNotebookDocument(me,ve,Ue){return Zt.onDidChangeNotebookDocument(me,ve,Ue)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(me,ve,Ue,ot){return yt.registerNotebookSerializer(We,me,ve,Ue,(0,Le.isProposedApiEnabled)(We,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(me,ve,Ue)=>Tn.onDidChangeConfiguration(me,ve,Ue),getConfiguration(me,ve){return ve=arguments.length===1?void 0:ve,Tn.getConfiguration(me,ve,We)},registerTextDocumentContentProvider(me,ve){return Ht.registerTextDocumentContentProvider(me,ve)},registerTaskProvider:(me,ve)=>(Ae.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(We,me,ve)),registerFileSystemProvider(me,ve,Ue){return(0,Pe.combinedDisposable)(wn.registerFileSystemProvider(We,me,ve,Ue),Rt.addFileSystemProvider(me,ve))},get fs(){return Rt.value},registerFileSearchProvider:(me,ve)=>((0,Le.checkProposedApiEnabled)(We,"fileSearchProvider"),It.registerFileSearchProvider(me,ve)),registerTextSearchProvider:(me,ve)=>((0,Le.checkProposedApiEnabled)(We,"textSearchProvider"),It.registerTextSearchProvider(me,ve)),registerRemoteAuthorityResolver:(me,ve)=>((0,Le.checkProposedApiEnabled)(We,"resolvers"),At.registerRemoteAuthorityResolver(me,ve)),registerResourceLabelFormatter:me=>((0,Le.checkProposedApiEnabled)(We,"resolvers"),En.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,ve,Ue)=>qt.onDidCreateFile(me,ve,Ue),onDidDeleteFiles:(me,ve,Ue)=>qt.onDidDeleteFile(me,ve,Ue),onDidRenameFiles:(me,ve,Ue)=>qt.onDidRenameFile(me,ve,Ue),onWillCreateFiles:(me,ve,Ue)=>qt.getOnWillCreateFileEvent(We)(me,ve,Ue),onWillDeleteFiles:(me,ve,Ue)=>qt.getOnWillDeleteFileEvent(We)(me,ve,Ue),onWillRenameFiles:(me,ve,Ue)=>qt.getOnWillRenameFileEvent(We)(me,ve,Ue),openTunnel:me=>((0,Le.checkProposedApiEnabled)(We,"tunnels"),Mt.openTunnel(We,me).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,Le.checkProposedApiEnabled)(We,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(me,ve,Ue)=>((0,Le.checkProposedApiEnabled)(We,"tunnels"),Mt.onDidChangeTunnels(me,ve,Ue)),registerPortAttributesProvider:(me,ve)=>((0,Le.checkProposedApiEnabled)(We,"portsAttributes"),Mt.registerPortsAttributesProvider(me,ve)),registerTimelineProvider:(me,ve)=>((0,Le.checkProposedApiEnabled)(We,"timeline"),Sn.registerTimelineProvider(me,ve,We.identifier,_e.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:me=>((0,Le.checkProposedApiEnabled)(We,"workspaceTrust"),wt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,ve,Ue)=>wt.onDidGrantWorkspaceTrust(me,ve,Ue),registerEditSessionIdentityProvider:(me,ve)=>((0,Le.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(me,ve))},$t={get inputBox(){return Ae.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),ln.getLastInputBox(We)},createSourceControl(me,ve,Ue){return ln.createSourceControl(We,me,ve,Ue)}},mn={createCommentController(me,ve){return vn.createCommentController(We,me,ve)}},Vn={get activeDebugSession(){return et.activeDebugSession},get activeDebugConsole(){return et.activeDebugConsole},get breakpoints(){return et.breakpoints},onDidStartDebugSession(me,ve,Ue){return et.onDidStartDebugSession(me,ve,Ue)},onDidTerminateDebugSession(me,ve,Ue){return et.onDidTerminateDebugSession(me,ve,Ue)},onDidChangeActiveDebugSession(me,ve,Ue){return et.onDidChangeActiveDebugSession(me,ve,Ue)},onDidReceiveDebugSessionCustomEvent(me,ve,Ue){return et.onDidReceiveDebugSessionCustomEvent(me,ve,Ue)},onDidChangeBreakpoints(me,ve,Ue){return et.onDidChangeBreakpoints(me,ve,Ue)},registerDebugConfigurationProvider(me,ve,Ue){return et.registerDebugConfigurationProvider(me,ve,Ue||Ge.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,ve){return et.registerDebugAdapterDescriptorFactory(We,me,ve)},registerDebugAdapterTrackerFactory(me,ve){return et.registerDebugAdapterTrackerFactory(me,ve)},startDebugging(me,ve,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?et.startDebugging(me,ve,{parentSession:Ue}):et.startDebugging(me,ve,Ue||{})},stopDebugging(me){return et.stopDebugging(me)},addBreakpoints(me){return et.addBreakpoints(me)},removeBreakpoints(me){return et.removeBreakpoints(me)},asDebugSourceUri(me,ve){return et.asDebugSourceUri(me,ve)}},qn={registerTaskProvider:(me,ve)=>St.registerTaskProvider(We,me,ve),fetchTasks:me=>St.fetchTasks(me),executeTask:me=>St.executeTask(We,me),get taskExecutions(){return St.taskExecutions},onDidStartTask:(me,ve,Ue)=>St.onDidStartTask(me,ve,Ue),onDidEndTask:(me,ve,Ue)=>St.onDidEndTask(me,ve,Ue),onDidStartTaskProcess:(me,ve,Ue)=>St.onDidStartTaskProcess(me,ve,Ue),onDidEndTaskProcess:(me,ve,Ue)=>St.onDidEndTaskProcess(me,ve,Ue)},Gn={createNotebookController(me,ve,Ue,ot,Dt){return en.createNotebookController(We,me,ve,Ue,ot,(0,Le.isProposedApiEnabled)(We,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(me,ve)=>yt.registerNotebookCellStatusBarItemProvider(We,me,ve),createRendererMessaging(me){return bn.createRendererMessaging(We,me)},createNotebookControllerDetectionTask(me){return(0,Le.checkProposedApiEnabled)(We,"notebookKernelSource"),en.createNotebookControllerDetectionTask(We,me)},registerKernelSourceActionProvider(me,ve){return(0,Le.checkProposedApiEnabled)(We,"notebookKernelSource"),en.registerKernelSourceActionProvider(We,me,ve)},onDidChangeNotebookCellExecutionState(me,ve,Ue){return(0,Le.checkProposedApiEnabled)(We,"notebookCellExecutionState"),en.onDidChangeNotebookCellExecutionState(me,ve,Ue)}},Kn={t(...me){if(typeof me[0]=="string"){const ve=me.shift(),Ue=!me||typeof me[0]!="object"?me:me[0];return bt.getMessage(We.identifier.value,{message:ve,args:Ue})}return bt.getMessage(We.identifier.value,me[0])},get bundle(){return bt.getBundle(We.identifier.value)},get uri(){return bt.getBundleUri(We.identifier.value)}};return{version:ct.version,authentication:zn,commands:Wn,comments:mn,debug:Vn,env:Pn,extensions:jn,l10n:Kn,languages:Xt,notebooks:Gn,scm:$t,tasks:qn,tests:Hn,window:fn,workspace:An,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ge.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:C.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:y.UIKind,Uri:D.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:ft.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TrustedTelemetryValue:q.TrustedTelemetryValue,LogLevel:Be.LogLevel,EditSessionIdentityMatch:ut.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=st}),define(Se[302],ye([1,0,274,311,312,2,313]),function(te,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(P,E,y,v,d,g){const f=g.environment.useHostProxy,w=typeof f=="boolean"?f:!g.remote.isRemote,m=(0,D.createProxyResolver)({resolveProxy:b=>P.resolveProxy(b),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(b,s,...i)=>{switch(b){case D.LogLevel.Trace:v.trace(s,...i);break;case D.LogLevel.Debug:v.debug(s,...i);break;case D.LogLevel.Info:v.info(s,...i);break;case D.LogLevel.Warning:v.warn(s,...i);break;case D.LogLevel.Error:v.error(s,...i);break;case D.LogLevel.Critical:v.error(s,...i);break;case D.LogLevel.Off:break;default:c(b,s,i);break}function c(u,r,...o){v.error("Unknown log level",u),v.error(r,...o)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:w,env:process.env}),h=S(E,m);return R(y,h)}e.connectProxyResolver=T;function S(P,E){const y={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(d=>{y.config=P.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(d=>{v.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"off"},v,!0)),on:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"on"},v,!0)),override:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"override"},v,!0)),onRequest:Object.assign({},a,(0,D.createHttpPatch)(a,E,y,v,!0)),default:Object.assign(a,(0,D.createHttpPatch)(a,E,y,v,!1))},https:{off:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"off"},v,!0)),on:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"on"},v,!0)),override:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,D.createHttpPatch)(t,E,y,v,!0)),default:Object.assign(t,(0,D.createHttpPatch)(t,E,y,v,!1))},tls:Object.assign(I,(0,D.createTlsPatch)(I))}}const C=new Map;function R(P,E){return P.getExtensionPathIndex().then(y=>{const v=globalThis._VSCODE_NODE_MODULES.module,d=v._load;v._load=function(f,w,m){if(f==="tls")return E.tls;if(f!=="http"&&f!=="https")return d.apply(this,arguments);const h=E[f],b=y.findSubstr(A.URI.file(w.filename));let s=C.get(b);if(s||C.set(b,s={}),!s[f]){const i=h.default;s[f]={...i}}return s[f]}})}}),define(Se[303],ye([1,0,75,301,288,302,41,276,2,15,7,273,113,275]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends I.RequireInterceptor{j(){const f=this,w=globalThis._VSCODE_NODE_MODULES.module,m=w._load;w._load=function(i,c,u){return i=b(i),f.a.has(i)?f.a.get(i).load(i,S.URI.file((0,E.realpathSync)(c.filename)),r=>m.apply(this,[r,c,u])):m.apply(this,arguments)};const h=w._resolveLookupPaths;w._resolveLookupPaths=(s,i)=>h.call(this,b(s),i);const b=s=>{for(const i of f.b){const c=i(s);if(c){s=c;break}}return s}}}class d extends D.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async pb(){this.h.createInstance(y.ExtHostConsoleForwarder);const f=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(T.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const h=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=h.ipcHandlePath}await this.h.createInstance(v,f,{mine:this.F,all:this.G}).install(),a.mark("code/extHost/didInitAPI");const m=await this.k.getConfigProvider();await(0,A.connectProxyResolver)(this.j,m,this,this.l,this.u,this.f),a.mark("code/extHost/didInitProxyResolver")}qb(f){return f.main}async rb(f,w,m){if(w.scheme!==C.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let h=null;m.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this.l.flush();const b=f?.identifier.value;f&&await this.s.initializeLocalizedMessages(f);try{b&&a.mark(`code/extHost/willLoadExtensionCode/${b}`),h=te.__$__nodeRequire(w.fsPath)}finally{b&&a.mark(`code/extHost/didLoadExtensionCode/${b}`),m.codeLoadingStop()}return h}async $setRemoteEnvironment(f){if(!!this.f.remote.isRemote)for(const w in f){const m=f[w];m===null?delete process.env[w]:process.env[w]=m}}}e.ExtHostExtensionService=d}),define(Se[144],ye([1,0,44,314,297,17,79,37,9,8,2,31,73,315,295,98]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const g=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(p){this.a=p}provideTextSearchResults(p,k,L,U){return this.a.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((K,G)=>{U.onCancellationRequested(()=>H());const O=i(p,k),B=k.folder.fsPath,F=O.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.a.appendLine(`${g} ${F}
 - cwd: ${B}`);let $=a.spawn(g,O,{cwd:B});$.on("error",fe=>{console.error(fe),this.a.appendLine("Error: "+(fe&&fe.message)),G((0,P.serializeSearchError)(new P.SearchError(fe&&fe.message,P.SearchErrorCode.rgProcessError)))});let M=!1;const V=new h(k.maxResults,B,k.previewOptions);V.on("result",fe=>{M=!0,Y="",L.report(fe)});let q=!1;const H=()=>{q=!0,$?.kill(),V?.cancel()};let J=!1;V.on("hitLimit",()=>{J=!0,H()});let Y="";$.stdout.on("data",fe=>{V.handleData(fe),M||(Y+=fe)});let ae=!1;$.stdout.once("data",()=>ae=!0);let re="";$.stderr.on("data",fe=>{const Z=fe.toString();this.a.appendLine(Z),re.length+Z.length<1e6&&(re+=Z)}),$.on("close",()=>{if(this.a.appendLine(ae?"Got data from stdout":"No data from stdout"),this.a.appendLine(M?"Got result from parser":"No result from parser"),Y&&this.a.appendLine(`Got data without result: ${Y}`),this.a.appendLine(""),q)K({limitHit:J});else{V.flush(),$=null;let fe;re&&!ae&&(fe=w(re))?G((0,P.serializeSearchError)(new P.SearchError(fe.message,fe.code))):K({limitHit:J})}})})}}e.RipgrepTextSearchEngine=f;function w(l){const p=l.split(`
`),k=p[0].trim();if(p.some(U=>U.startsWith("regex parse error")))return new P.SearchError(m(p),P.SearchErrorCode.regexParseError);const L=k.match(/grep config error: unknown encoding: (.*)/);if(L)return new P.SearchError(`Unknown encoding: ${L[1]}`,P.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new P.SearchError(k.charAt(0).toUpperCase()+k.substr(1),P.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new P.SearchError(k.charAt(0).toUpperCase()+k.substr(1),P.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(k,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function m(l){const p=["Regex parse error"],k=l.filter(L=>L.startsWith("PCRE2:"));if(k.length>=1){const L=k[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const U=L.split(":")[1];p.push(":"+U)}}return p.join("")}e.buildRegexParseError=m;class h extends t.EventEmitter{constructor(p,k,L){super(),this.g=p,this.h=k,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new I.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(p,k){return super.on(p,k),this}handleData(p){if(this.b)return;const k=typeof p=="string"?p:this.d.write(p);this.k(k)}k(p){let k=p.indexOf(`
`);const L=this.a+p;if(k>=0)k+=this.a.length;else{this.a=L;return}let U=0;for(;k>=0;)this.m(L.substring(U,k).trim()),U=k+1,k=L.indexOf(`
`,U);this.a=L.substring(U)}m(p){if(this.b||!p)return;let k;try{k=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(k.type==="match"){const L=b(k.data.path),U=R.URI.file(S.join(this.h,L)),K=this.n(k.data,U);this.p(K),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const L=b(k.data.path),U=R.URI.file(S.join(this.h,L));this.o(k.data,U).forEach(G=>this.p(G))}}n(p,k){const L=p.line_number-1,U=b(p.lines),K=Buffer.from(U);let G=0,O=0,B=L;p.submatches.length===0&&p.submatches.push(U.length?{start:0,end:1,match:{text:U[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.coalesce)(p.submatches.map(($,M)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const V=b($.match),q=K.slice(G,$.start).toString(),H=s(q),J=H.numLines>0?H.lastLineLength:H.lastLineLength+O,Y=s(V),ae=H.numLines+B,re=Y.numLines+ae,fe=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+J;return G=$.end,O=fe,B=re,new E.Range(ae,J,re,fe)}));return(0,d.createTextSearchResult)(k,U,F,this.j)}o(p,k){const L=b(p.lines),U=p.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((K,G)=>({text:K,uri:k,lineNumber:U+G}))}p(p){this.emit("result",p)}}e.RipgrepParser=h;function b(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function s(l){const p=/\n/g;let k=0,L=-1,U;for(;U=p.exec(l);)k++,L=U.index;const K=L>=0?l.length-L-1:l.length;return{numLines:k,lastLineLength:K}}function i(l,p){const k=["--hidden"];k.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:U}=(0,D.groupBy)(p.includes,G=>G.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(U&&U.length){const G=new Set;U.forEach(O=>{G.add(O)}),k.push("-g","!*"),G.forEach(O=>{c(O).map(d.anchorGlob).forEach(B=>{k.push("-g",B)})})}L&&L.length&&L.forEach(G=>{k.push("-g",G)}),p.excludes.map(d.anchorGlob).forEach(G=>k.push("-g",`!${G}`)),p.maxFileSize&&k.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),p.followSymlinks&&k.push("--follow"),p.encoding&&p.encoding!=="utf8"&&k.push("--encoding",p.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,C.escapeRegExpCharacters)(l.pattern),l.isRegExp=!0),p.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),l.isRegExp&&(l.pattern=u(l.pattern),k.push("--engine","auto"));let K;if(l.isWordMatch){const O=(0,C.createRegExp)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",O)}else if(l.isRegExp){let G=o(l.pattern);G=n(G),k.push("--regexp",G)}else K=l.pattern,k.push("--fixed-strings");return k.push("--no-config"),p.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),l.isMultiline&&k.push("--multiline"),p.beforeContext&&k.push("--before-context",p.beforeContext+""),p.afterContext&&k.push("--after-context",p.afterContext+""),k.push("--"),K&&k.push(K),k.push("."),k}function c(l){const p=(0,T.splitGlobAware)(l,"/");return p.map((k,L)=>p.slice(0,L+1).join("/"))}e.spreadGlobComponents=c;function u(l){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(p);)l=l.replace(p,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(k);)l=l.replace(k,"$1\\x{$2}");return l}e.unicodeEscapesToPCRE2=u;const r=l=>l.type==="Assertion"&&l.kind==="lookbehind";function o(l){let p;try{p=new y.RegExpParser().parsePattern(l)}catch{return l}let k="",L=0;const U=(O,B,F)=>{k+=l.slice(L,O)+F,L=B},K=[];return new y.RegExpVisitor({onCharacterEnter(O){if(O.raw!=="\\n")return;const B=K[0];if(!B)U(O.start,O.end,"\\r?\\n");else if(!K.some(r))if(B.type==="CharacterClass")if(B.negate){const F=l.slice(B.start+2,O.start)+l.slice(O.end,B.end-1);B.parent?.type==="Quantifier"?U(B.start,B.end,F?`[^${F}]`:"."):U(B.start,B.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=l.slice(B.start+1,O.start)+l.slice(O.end,B.end-1);U(B.start,B.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else B.type==="Quantifier"&&U(O.start,O.end,"(?:\\r?\\n)")},onQuantifierEnter(O){K.unshift(O)},onQuantifierLeave(){K.shift()},onCharacterClassRangeEnter(O){K.unshift(O)},onCharacterClassRangeLeave(){K.shift()},onCharacterClassEnter(O){K.unshift(O)},onCharacterClassLeave(){K.shift()},onAssertionEnter(O){r(O)&&K.push(O)},onAssertionLeave(O){K[0]===O&&K.shift()}}).visit(p),k+=l.slice(L),k}e.fixRegexNewline=o;function n(l){return l.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(Se[304],ye([1,0,21,144,124,15]),function(te,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(C){this.b=C,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(C,R,P,E){const y=new t.RipgrepTextSearchEngine(this.b);if(R.folder.scheme===A.Schemas.vscodeUserData){const v={...R,folder:R.folder.with({scheme:A.Schemas.file})},d=new I.Progress(g=>P.report({...g,uri:g.uri.with({scheme:R.folder.scheme})}));return this.c(E,g=>y.provideTextSearchResults(C,v,d,g))}else return this.c(E,v=>y.provideTextSearchResults(C,R,P,v))}async c(C,R){const P=T(C);this.a.add(P);const E=await R(P.token);return this.a.delete(P),E}d(){this.a.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=D;function T(S){const C=new a.CancellationTokenSource;return S.onCancellationRequested(()=>C.cancel()),C}}),define(Se[305],ye([1,0,29,144,143]),function(te,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.a=S}search(S,C,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(y){R({message:y})}},E=new I.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),a);return new Promise((y,v)=>E.search(d=>{C(d.map(D))},S).then(d=>y({limitHit:d.limitHit,type:"success",stats:d.stats}),v))}}e.TextSearchEngineAdapter=A;function D(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,C)=>{if(C.ranges){const R=C;return S+(Array.isArray(R.ranges)?R.ranges.length:1)}else return S+1},0)}}}),define(Se[306],ye([1,0,17,18,10,4,109,9,51,2,38,31,296,305]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(h="searchProcess"){this.d=h,this.b=Object.create(null)}fileSearch(h){let b;const s=f(h),i=new A.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(c=>this.doFileSearchWithEngine(E.Engine,s,u=>i.fire(u),c)),b.then(c=>i.fire(c),c=>i.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return i.event}textSearch(h){let b;const s=f(h),i=new A.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(c=>this.f(s,u=>i.fire(u),c)),b.then(c=>i.fire(c),c=>i.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return i.event}f(h,b,s){return h.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new y.TextSearchEngineAdapter(h).search(s,b,b)}doFileSearch(h,b,s){return this.doFileSearchWithEngine(E.Engine,h,b,s)}doFileSearchWithEngine(h,b,s,i,c=v.a){let u=0;const r=n=>{Array.isArray(n)?(u+=n.length,s(n.map(l=>this.g(l)))):n.relativePath?(u++,s(this.g(n))):s(n)};if(b.sortByScore){let n=this.k(b,r,i);if(!n){const l=b.maxResults?Object.assign({},b,{maxResults:null}):b,p=new h(l);n=this.h(p,b,s,r,i)}return new Promise((l,p)=>{n.then(([k,L])=>{const U=L.map(K=>this.g(K));this.n(U,s,c),l(k)},p)})}const o=new h(b);return this.q(o,r,c,i).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}g(h){return{path:h.base?(0,T.join)(h.base,h.relativePath):h.relativePath}}h(h,b,s,i,c){const u=new A.Emitter;let r=(0,t.createCancelablePromise)(n=>{let l=[];const p=k=>{Array.isArray(k)?l=k:(i(k),u.fire(k))};return this.q(h,p,-1,n).then(k=>[k,l])}),o;if(b.cacheKey){o=this.j(b.cacheKey);const n={promise:r,event:u.event,resolved:!1};o.resultsToSearchCache[b.filePattern||""]=n,r.then(()=>{n.resolved=!0},l=>{delete o.resultsToSearchCache[b.filePattern||""]}),r=this.r(r)}return r.then(([n,l])=>{const p=o?o.scorerCache:Object.create(null),k=(typeof b.maxResults!="number"||b.maxResults>0)&&S.StopWatch.create(!1);return this.l(b,l,p,c).then(L=>{const U=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:U,fromCache:!1,type:this.d,workspaceFolderCount:b.folderQueries.length,resultCount:L.length},messages:n.messages,limitHit:n.limitHit||typeof b.maxResults=="number"&&l.length>b.maxResults},L]})})}j(h){const b=this.b[h];return b||(this.b[h]=new d)}k(h,b,s){const i=h.cacheKey&&this.b[h.cacheKey];if(!i)return;const c=this.o(i,h.filePattern||"",b,s);if(c)return c.then(([u,r,o])=>{const n=S.StopWatch.create(!1);return this.l(h,r,i.scorerCache,s).then(l=>{const p=n.elapsed(),k={fromCache:!0,detailStats:o,type:this.d,resultCount:r.length,sortingTime:p};return[{type:"success",limitHit:u.limitHit||typeof h.maxResults=="number"&&r.length>h.maxResults,stats:k},l]})})}l(h,b,s,i){const c=(0,D.prepareQuery)(h.filePattern||""),u=(o,n)=>(0,D.compareItemsByFuzzyScore)(o,n,c,!0,g,s),r=typeof h.maxResults=="number"?h.maxResults:Number.MAX_VALUE;return a.topAsync(b,u,r,1e4,i)}n(h,b,s){if(s&&s>0)for(let i=0;i<h.length;i+=s)b(h.slice(i,i+s));else b(h)}o(h,b,s,i){const c=S.StopWatch.create(!1),u=b.indexOf(T.sep)>=0;let r;for(const p in h.resultsToSearchCache)if(b.startsWith(p)){if(u&&p.indexOf(T.sep)<0&&p!=="")continue;const k=h.resultsToSearchCache[p];r={promise:this.r(k.promise),event:k.event,resolved:k.resolved};break}if(!r)return null;const o=c.elapsed(),n=S.StopWatch.create(!1),l=r.event(s);return i&&i.onCancellationRequested(()=>{l.dispose()}),r.promise.then(([p,k])=>{if(i&&i.isCancellationRequested)throw(0,I.canceled)();const L=[],U=(0,D.prepareQuery)(b).normalizedLowercase;for(const K of k)!(0,P.isFilePatternMatch)(K,U)||L.push(K);return[p,L,{cacheWasResolved:r.resolved,cacheLookupTime:o,cacheFilterTime:n.elapsed(),cacheEntryCount:k.length}]})}q(h,b,s,i){return new Promise((c,u)=>{let r=[];i?.onCancellationRequested(()=>h.cancel()),h.search(o=>{o&&(s?(r.push(o),s>0&&r.length>=s&&(b(r),r=[])):b(o))},o=>{b(o)},(o,n)=>{r.length&&b(r),o?u(o):c(n)})})}clearCache(h){return delete this.b[h],Promise.resolve(void 0)}r(h){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(b,s){return h.then(b,s)}catch(b){return this.then(void 0,b)}finally(b){return h.finally(b)}}}}e.SearchService=v,v.a=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(m){return(0,T.basename)(m.relativePath)}getItemDescription(m){return(0,T.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function f(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(w),extraFileResources:m.extraFileResources&&m.extraFileResources.map(h=>C.URI.revive(h))}}function w(m){return{...m,folder:C.URI.revive(m.folder)}}}),define(Se[307],ye([1,0,6,15,2,29,13,25,16,77,55,31,306,304,98,143]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let g=class extends C.ExtHostSearch{constructor(w,m,h,b){super(w,h,b),this.s=A,this.t=-1,this.v=null,this.w=!1;const s=new v.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new y.RipgrepSearchProvider(s)),m.remote.isRemote&&m.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const w=new v.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new y.RipgrepSearchProvider(w)),this.y(t.Schemas.file,new E.SearchService("fileSearchProvider"))}y(w,m){const h=this.d++;return this.v=m,this.t=h,this.c.$registerFileSearchProvider(h,this.o(w)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(h)})}$provideFileSearchResults(w,m,h,b){const s=(0,C.reviveQuery)(h);return w===this.t?this.A(w,m,s,b):super.$provideFileSearchResults(w,m,h,b)}A(w,m,h,b){const s=i=>{if((0,P.isSerializedFileMatch)(i)&&(i=[i]),Array.isArray(i)){this.c.$handleFileMatch(w,m,i.map(c=>I.URI.file(c.path)));return}i.message&&this.n.debug("ExtHostSearch",i.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(h,s,b)}$clearCache(w){return this.v?.clearCache(w),super.$clearCache(w)}q(w,m){return new d.NativeTextSearchManager(w,m,void 0,"textSearchProvider")}};g=Ve([ze(0,S.IExtHostRpcService),ze(1,T.IExtHostInitDataService),ze(2,R.IURITransformerService),ze(3,D.ILogService)],g),e.NativeExtHostSearch=g}),define(Se[308],ye([1,0,86,279,291,290,307,303,280,76,41,77,74,40,54,71,278,277,13,292,47]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(R.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,a.registerSingleton)(w.ILoggerService,f.ExtHostLoggerService,1),(0,a.registerSingleton)(d.IExtensionStoragePaths,g.ExtensionStoragePaths,0),(0,a.registerSingleton)(C.IExtHostDebugService,A.ExtHostDebugService,0),(0,a.registerSingleton)(P.IExtHostSearch,D.NativeExtHostSearch,0),(0,a.registerSingleton)(E.IExtHostTask,I.ExtHostTask,0),(0,a.registerSingleton)(y.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,a.registerSingleton)(v.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,a.registerSingleton)(h.IExtHostVariableResolverProvider,m.NodeExtHostVariableResolverProviderService,0)}),define(Se[316],ye([1,0,218,317,75,10,116,117,199,93,289,22,29,113,18,119,214,228,293,308]),function(te,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let o=0;o<process.execArgv.length;o++)process.execArgv[o]==="--inspect-port=0"&&(process.execArgv.splice(o,1),o--)}();const w=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=globalThis._VSCODE_NODE_MODULES.module,o=r._load;r._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return o.apply(this,arguments)}})();const m=process.exit.bind(process);function h(r){process.exit=function(o){if(r)m(o);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const o=new Error("An extension called process.crash() and this was prevented.");console.warn(o.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let b=function(r){m()};function s(){const r=(0,f.readExtHostConnection)(process.env);if(r.type===3)return new Promise((o,n)=>{const l=p=>{const k=p[0],L=new D.BufferedEmitter;k.on("message",U=>L.fire(P.VSBuffer.wrap(U.data))),k.on("close",()=>{b("renderer closed the MessagePort")}),k.start(),o({onMessage:L.event,send:U=>k.postMessage(U.buffer)})};process?.parentPort.on("message",p=>l(p.ports))});if(r.type===2)return new Promise((o,n)=>{let l=null;const p=setTimeout(()=>{b("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),k=108e5,L=3e5,U=new v.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (1)"),k),K=new v.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (2)"),L);process.on("message",(O,B)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const F=P.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let $;if(O.skipWebSocketFrames)$=new T.NodeSocket(B,"extHost-socket");else{const M=P.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));$=new T.WebSocketNodeSocket(new T.NodeSocket(B,"extHost-socket"),O.permessageDeflate,M,!1)}l?(U.cancel(),K.cancel(),l.beginAcceptReconnection($,F),l.endAcceptReconnection(),l.sendResume()):(clearTimeout(p),l=new D.PersistentProtocol($,F),l.sendResume(),l.onDidDispose(()=>b("renderer disconnected")),o(l),l.onSocketClose(()=>{U.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(K.isScheduled())return;U.isScheduled()&&K.schedule()}});const G={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(G)});{const o=r.pipeName;return new Promise((n,l)=>{const p=a.createConnection(o,()=>{p.removeListener("error",l);const k=new D.PersistentProtocol(new T.NodeSocket(p,"extHost-renderer"));k.sendResume(),n(k)});p.once("error",l),p.on("close",()=>{b("renderer closed the socket")})})}}async function i(){const r=await s();return new class{constructor(){this.a=new D.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,r.onMessage(o=>{(0,C.isMessageOfType)(o,2)?(this.b=!0,b("received terminate message from renderer")):this.a.fire(o)})}send(o){this.b||r.send(o)}async drain(){if(r.drain)return r.drain()}}}function c(r){return new Promise(o=>{const n=r.onMessage(l=>{n.dispose();const p=JSON.parse(l.toString()),k=p.commit,L=S.default.commit;if(k&&L&&k!==L&&m(55),p.parentPid){let U=0;setInterval(function(){try{process.kill(p.parentPid,0),U=0}catch(G){G&&G.code==="EPERM"?(U++,U>=3&&b(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${G.message} (code: ${G.code}) (errno: ${G.errno})`)):b(`parent process ${p.parentPid} does not exist anymore: ${G.message} (code: ${G.code}) (errno: ${G.errno})`)}},1e3);let K;try{K=globalThis._VSCODE_NODE_MODULES["native-watchdog"],K.start(p.parentPid)}catch(G){(0,A.onUnexpectedError)(G)}}r.send((0,C.createMessageOfType)(0)),o({protocol:r,initData:p})});r.send((0,C.createMessageOfType)(1))})}async function u(){const r=[];process.on("unhandledRejection",(U,K)=>{r.push(K),setTimeout(()=>{const G=r.indexOf(K);G>=0&&K.catch(O=>{r.splice(G,1),(0,A.isCancellationError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),U&&(0,A.onUnexpectedError)(U))})},1e3)}),process.on("rejectionHandled",U=>{const K=r.indexOf(U);K>=0&&r.splice(K,1)}),process.on("uncaughtException",function(U){(0,A.onUnexpectedError)(U)}),I.mark("code/extHost/willConnectToRenderer");const o=await i();I.mark("code/extHost/didConnectToRenderer");const n=await c(o);I.mark("code/extHost/didWaitForInitData");const{initData:l}=n;h(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=w.useHostProxy!==void 0?w.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,d.boolean)(w.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(K){m(K)}exists(K){return E.Promises.exists(K)}realpath(K){return(0,y.realpath)(K)}};let k=null;l.remote.authority&&w.transformURIs&&(k=(0,g.createURITransformer)(l.remote.authority));const L=new R.ExtensionHostMain(n.protocol,l,p,k);b=U=>L.terminate(U)}u().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2eca6d38dede985bf6180cca64d43c16a02e9a13/core/vs/workbench/api/node/extensionHostProcess.js.map
