/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(te){for(var e=[],n=0,T=te.length;n<T;n++)e[n]=De[te[n]];return e};define(De[78],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(C,R){const S=Object.create(null);for(const k of C){const O=R(k);let I=S[O];I||(I=S[O]=[]),I.push(k)}return S}e.groupBy=n;function T(C,R){const S=[],k=[];for(const O of C)R.has(O)||S.push(O);for(const O of R)C.has(O)||k.push(O);return{removed:S,added:k}}e.diffSets=T;function y(C,R){const S=[],k=[];for(const[O,I]of C)R.has(O)||S.push(I);for(const[O,I]of R)C.has(O)||k.push(I);return{removed:S,added:k}}e.diffMaps=y;class N{constructor(){this.a=new Map}add(R,S){let k=this.a.get(R);k||(k=new Set,this.a.set(R,k)),k.add(S)}delete(R,S){const k=this.a.get(R);!k||(k.delete(S),k.size===0&&this.a.delete(R))}forEach(R,S){const k=this.a.get(R);!k||k.forEach(S)}}e.SetMap=N}),define(De[59],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(C){return(R,S,k)=>{let O=null,I=null;if(typeof k.value=="function"?(O="value",I=k.value):typeof k.get=="function"&&(O="get",I=k.get),!I)throw new Error("not supported");k[O]=C(I,S)}}function T(C,R,S){let k=null,O=null;if(typeof S.value=="function"?(k="value",O=S.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",O=S.get),!O)throw new Error("not supported");const I=`$memoize$${R}`;S[k]=function(...f){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,f)}),this[I]}}e.memoize=T;function y(C,R,S){return n((k,O)=>{const I=`$debounce$${O}`,f=`$debounce$result$${O}`;return function(...v){this[f]||(this[f]=S?S():void 0),clearTimeout(this[I]),R&&(this[f]=R(this[f],...v),v=[this[f]]),this[I]=setTimeout(()=>{k.apply(this,v),this[f]=S?S():void 0},C)}})}e.debounce=y;function N(C,R,S){return n((k,O)=>{const I=`$throttle$timer$${O}`,f=`$throttle$result$${O}`,v=`$throttle$lastRun$${O}`,h=`$throttle$pending$${O}`;return function(...i){if(this[f]||(this[f]=S?S():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...i)),this[h])return;const o=this[v]+C;o<=Date.now()?(this[v]=Date.now(),k.apply(this,[this[f]]),this[f]=S?S():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),k.apply(this,[this[f]]),this[f]=S?S():void 0},o-Date.now()))}})}e.throttle=N}),define(De[79],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(y){this.a=y,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(De[107],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var T;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var N;(function(s){s.DEFAULT={allowTrailingComma:!0}})(N=e.ParseOptions||(e.ParseOptions={}));function C(s,r=!1){let a=0;const d=s.length;let c="",u=0,t=16,m=0;function g(M){let F=0,$=0;for(;F<M;){const z=s.charCodeAt(a);if(z>=48&&z<=57)$=$*16+z-48;else if(z>=65&&z<=70)$=$*16+z-65+10;else if(z>=97&&z<=102)$=$*16+z-97+10;else break;a++,F++}return F<M&&($=-1),$}function A(M){a=M,c="",u=0,t=16,m=0}function L(){const M=a;if(s.charCodeAt(a)===48)a++;else for(a++;a<s.length&&k(s.charCodeAt(a));)a++;if(a<s.length&&s.charCodeAt(a)===46)if(a++,a<s.length&&k(s.charCodeAt(a)))for(a++;a<s.length&&k(s.charCodeAt(a));)a++;else return m=3,s.substring(M,a);let F=a;if(a<s.length&&(s.charCodeAt(a)===69||s.charCodeAt(a)===101))if(a++,(a<s.length&&s.charCodeAt(a)===43||s.charCodeAt(a)===45)&&a++,a<s.length&&k(s.charCodeAt(a))){for(a++;a<s.length&&k(s.charCodeAt(a));)a++;F=a}else m=3;return s.substring(M,F)}function K(){let M="",F=a;for(;;){if(a>=d){M+=s.substring(F,a),m=2;break}const $=s.charCodeAt(a);if($===34){M+=s.substring(F,a),a++;break}if($===92){if(M+=s.substring(F,a),a++,a>=d){m=2;break}switch(s.charCodeAt(a++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const V=g(4);V>=0?M+=String.fromCharCode(V):m=4;break}default:m=5}F=a;continue}if($>=0&&$<=31)if(S($)){M+=s.substring(F,a),m=2;break}else m=6;a++}return M}function q(){if(c="",m=0,u=a,a>=d)return u=d,t=17;let M=s.charCodeAt(a);if(R(M)){do a++,c+=String.fromCharCode(M),M=s.charCodeAt(a);while(R(M));return t=15}if(S(M))return a++,c+=String.fromCharCode(M),M===13&&s.charCodeAt(a)===10&&(a++,c+=`
`),t=14;switch(M){case 123:return a++,t=1;case 125:return a++,t=2;case 91:return a++,t=3;case 93:return a++,t=4;case 58:return a++,t=6;case 44:return a++,t=5;case 34:return a++,c=K(),t=10;case 47:{const F=a-1;if(s.charCodeAt(a+1)===47){for(a+=2;a<d&&!S(s.charCodeAt(a));)a++;return c=s.substring(F,a),t=12}if(s.charCodeAt(a+1)===42){a+=2;const $=d-1;let z=!1;for(;a<$;){if(s.charCodeAt(a)===42&&s.charCodeAt(a+1)===47){a+=2,z=!0;break}a++}return z||(a++,m=1),c=s.substring(F,a),t=13}return c+=String.fromCharCode(M),a++,t=16}case 45:if(c+=String.fromCharCode(M),a++,a===d||!k(s.charCodeAt(a)))return t=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=L(),t=11;default:for(;a<d&&j(M);)a++,M=s.charCodeAt(a);if(u!==a){switch(c=s.substring(u,a),c){case"true":return t=8;case"false":return t=9;case"null":return t=7}return t=16}return c+=String.fromCharCode(M),a++,t=16}}function j(M){if(R(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function P(){let M;do M=q();while(M>=12&&M<=15);return M}return{setPosition:A,getPosition:()=>a,scan:r?P:q,getToken:()=>t,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>a-u,getTokenError:()=>m}}e.createScanner=C;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function k(s){return s>=48&&s<=57}var O;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(O||(O={}));function I(s,r){const a=[],d=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let t=!1;function m(g,A,L,K){u.value=g,u.offset=A,u.length=L,u.type=K,u.colonOffset=void 0,c=u}try{b(s,{onObjectBegin:(g,A)=>{if(r<=g)throw d;c=void 0,t=r>g,a.push("")},onObjectProperty:(g,A,L)=>{if(r<A||(m(g,A,L,"property"),a[a.length-1]=g,r<=A+L))throw d},onObjectEnd:(g,A)=>{if(r<=g)throw d;c=void 0,a.pop()},onArrayBegin:(g,A)=>{if(r<=g)throw d;c=void 0,a.push(0)},onArrayEnd:(g,A)=>{if(r<=g)throw d;c=void 0,a.pop()},onLiteralValue:(g,A,L)=>{if(r<A||(m(g,A,L,w(g)),r<=A+L))throw d},onSeparator:(g,A,L)=>{if(r<=A)throw d;if(g===":"&&c&&c.type==="property")c.colonOffset=A,t=!1,c=void 0;else if(g===","){const K=a[a.length-1];typeof K=="number"?a[a.length-1]=K+1:(t=!0,a[a.length-1]=""),c=void 0}}})}catch(g){if(g!==d)throw g}return{path:a,previousNode:c,isAtPropertyKey:t,matches:g=>{let A=0;for(let L=0;A<g.length&&L<a.length;L++)if(g[A]===a[L]||g[A]==="*")A++;else if(g[A]!=="**")return!1;return A===g.length}}}e.getLocation=I;function f(s,r=[],a=N.DEFAULT){let d=null,c=[];const u=[];function t(g){Array.isArray(c)?c.push(g):d!==null&&(c[d]=g)}return b(s,{onObjectBegin:()=>{const g={};t(g),u.push(c),c=g,d=null},onObjectProperty:g=>{d=g},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const g=[];t(g),u.push(c),c=g,d=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:t,onError:(g,A,L)=>{r.push({error:g,offset:A,length:L})}},a),c[0]}e.parse=f;function v(s,r=[],a=N.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(g){d.type==="property"&&(d.length=g-d.offset,d=d.parent)}function u(g){return d.children.push(g),g}b(s,{onObjectBegin:g=>{d=u({type:"object",offset:g,length:-1,parent:d,children:[]})},onObjectProperty:(g,A,L)=>{d=u({type:"property",offset:A,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:g,offset:A,length:L,parent:d})},onObjectEnd:(g,A)=>{d.length=g+A-d.offset,d=d.parent,c(g+A)},onArrayBegin:(g,A)=>{d=u({type:"array",offset:g,length:-1,parent:d,children:[]})},onArrayEnd:(g,A)=>{d.length=g+A-d.offset,d=d.parent,c(g+A)},onLiteralValue:(g,A,L)=>{u({type:w(g),offset:A,length:L,parent:d,value:g}),c(A+L)},onSeparator:(g,A,L)=>{d.type==="property"&&(g===":"?d.colonOffset=A:g===","&&c(A))},onError:(g,A,L)=>{r.push({error:g,offset:A,length:L})}},a);const m=d.children[0];return m&&delete m.parent,m}e.parseTree=v;function h(s,r){if(!s)return;let a=s;for(const d of r)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const u of a.children)if(Array.isArray(u.children)&&u.children[0].value===d){a=u.children[1],c=!0;break}if(!c)return}else{const c=d;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.findNodeAtLocation=h;function i(s){if(!s.parent||!s.parent.children)return[];const r=i(s.parent);if(s.parent.type==="property"){const a=s.parent.children[0].value;r.push(a)}else if(s.parent.type==="array"){const a=s.parent.children.indexOf(s);a!==-1&&r.push(a)}return r}e.getNodePath=i;function o(s){switch(s.type){case"array":return s.children.map(o);case"object":{const r=Object.create(null);for(const a of s.children){const d=a.children[1];d&&(r[a.children[0].value]=o(d))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=o;function l(s,r,a=!1){return r>=s.offset&&r<s.offset+s.length||a&&r===s.offset+s.length}e.contains=l;function E(s,r,a=!1){if(l(s,r,a)){const d=s.children;if(Array.isArray(d))for(let c=0;c<d.length&&d[c].offset<=r;c++){const u=E(d[c],r,a);if(u)return u}return s}}e.findNodeAtOffset=E;function b(s,r,a=N.DEFAULT){const d=C(s,!1);function c(ce){return ce?()=>ce(d.getTokenOffset(),d.getTokenLength()):()=>!0}function u(ce){return ce?me=>ce(me,d.getTokenOffset(),d.getTokenLength()):()=>!0}const t=c(r.onObjectBegin),m=u(r.onObjectProperty),g=c(r.onObjectEnd),A=c(r.onArrayBegin),L=c(r.onArrayEnd),K=u(r.onLiteralValue),q=u(r.onSeparator),j=c(r.onComment),P=u(r.onError),M=a&&a.disallowComments,F=a&&a.allowTrailingComma;function $(){for(;;){const ce=d.scan();switch(d.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:M||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ce){case 12:case 13:M?z(10):j();break;case 16:z(1);break;case 15:case 14:break;default:return ce}}}function z(ce,me=[],Y=[]){if(P(ce),me.length+Y.length>0){let pe=d.getToken();for(;pe!==17;){if(me.indexOf(pe)!==-1){$();break}else if(Y.indexOf(pe)!==-1)break;pe=$()}}}function V(ce){const me=d.getTokenValue();return ce?K(me):m(me),$(),!0}function X(){switch(d.getToken()){case 11:{let ce=0;try{ce=JSON.parse(d.getTokenValue()),typeof ce!="number"&&(z(2),ce=0)}catch{z(2)}K(ce);break}case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return $(),!0}function Z(){return d.getToken()!==10?(z(3,[],[2,5]),!1):(V(!1),d.getToken()===6?(q(":"),$(),le()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function fe(){t(),$();let ce=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(ce||z(4,[],[]),q(","),$(),d.getToken()===2&&F)break}else ce&&z(6,[],[]);Z()||z(4,[],[2,5]),ce=!0}return g(),d.getToken()!==2?z(7,[2],[]):$(),!0}function oe(){A(),$();let ce=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(ce||z(4,[],[]),q(","),$(),d.getToken()===4&&F)break}else ce&&z(6,[],[]);le()||z(4,[],[4,5]),ce=!0}return L(),d.getToken()!==4?z(8,[4],[]):$(),!0}function le(){switch(d.getToken()){case 3:return oe();case 1:return fe();case 10:return V(!0);default:return X()}}return $(),d.getToken()===17?a.allowEmptyContent?!0:(z(4,[],[]),!1):le()?(d.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=b;function p(s,r){const a=C(s),d=[];let c,u=0,t;do switch(t=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:u!==t&&d.push(s.substring(u,t)),r!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,r)),u=a.getPosition();break}while(c!==17);return d.join("")}e.stripComments=p;function w(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(De[28],Ce([1,0]),function(te,e){"use strict";var n,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function N(h,i,o){let l=h.get(i);return l===void 0&&(l=o,h.set(i,l)),l}e.getOrSet=N;function C(h){const i=[];return h.forEach((o,l)=>{i.push(`${l} => ${o}`)}),`Map(${h.size}) {${i.join(", ")}}`}e.mapToString=C;function R(h){const i=[];return h.forEach(o=>{i.push(o)}),`Set(${h.size}) {${i.join(", ")}}`}e.setToString=R;class S{constructor(i,o){this.uri=i,this.value=o}}class k{constructor(i,o){this[n]="ResourceMap",i instanceof k?(this.b=new Map(i.b),this.c=o??k.a):(this.b=new Map,this.c=i??k.a)}set(i,o){return this.b.set(this.c(i),new S(i,o)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,o){typeof o<"u"&&(i=i.bind(o));for(const[l,E]of this.b)i(E.value,E.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.ResourceMap=k,k.a=h=>h.toString();class O{constructor(i,o){this[T]="ResourceSet",!i||typeof i=="function"?this.a=new k(i):(this.a=new k(o),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,o){this.a.forEach((l,E)=>i.call(o,E,E,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var I;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class f{constructor(){this[y]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,o=0){const l=this.a.get(i);if(!!l)return o!==0&&this.j(l,o),l.value}set(i,o,l=0){let E=this.a.get(i);if(E)E.value=o,l!==0&&this.j(E,l);else{switch(E={key:i,value:o,next:void 0,previous:void 0},l){case 0:this.h(E);break;case 1:this.g(E);break;case 2:this.h(E);break;default:this.h(E);break}this.a.set(i,E),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this.a.get(i);if(!!o)return this.a.delete(i),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,o){const l=this.e;let E=this.b;for(;E;){if(o?i.bind(o)(E.value,E.key,this):i(E.value,E.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const i=this,o=this.e;let l=this.b;const E={[Symbol.iterator](){return E},next(){if(i.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return E}values(){const i=this,o=this.e;let l=this.b;const E={[Symbol.iterator](){return E},next(){if(i.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return E}entries(){const i=this,o=this.e;let l=this.b;const E={[Symbol.iterator](){return E},next(){if(i.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return E}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this.b,l=this.size;for(;o&&l>i;)this.a.delete(o.key),o=o.next,l--;this.b=o,this.d=l,o&&(o.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const o=i.next,l=i.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}i.next=void 0,i.previous=void 0,this.e++}j(i,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this.b)return;const l=i.next,E=i.previous;i===this.c?(E.next=void 0,this.c=E):(l.previous=E,E.next=l),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(o===2){if(i===this.c)return;const l=i.next,E=i.previous;i===this.b?(l.previous=void 0,this.b=l):(l.previous=E,E.next=l),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((o,l)=>{i.push([l,o])}),i}fromJSON(i){this.clear();for(const[o,l]of i)this.set(o,l)}}e.LinkedMap=f;class v extends f{constructor(i,o=1){super(),this.k=i,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=v}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[108],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Pe,Ie){for(var ke=0;ke<Ie.length;ke++){var re=Ie[ke];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Pe,re.key,re)}}function n(Pe,Ie,ke){return Ie&&e(Pe.prototype,Ie),ke&&e(Pe,ke),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function T(Pe,Ie){if(!!Pe){if(typeof Pe=="string")return y(Pe,Ie);var ke=Object.prototype.toString.call(Pe).slice(8,-1);if(ke==="Object"&&Pe.constructor&&(ke=Pe.constructor.name),ke==="Map"||ke==="Set")return Array.from(Pe);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return y(Pe,Ie)}}function y(Pe,Ie){(Ie==null||Ie>Pe.length)&&(Ie=Pe.length);for(var ke=0,re=new Array(Ie);ke<Ie;ke++)re[ke]=Pe[ke];return re}function N(Pe,Ie){var ke=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(ke)return(ke=ke.call(Pe)).next.bind(ke);if(Array.isArray(Pe)||(ke=T(Pe))||Ie&&Pe&&typeof Pe.length=="number"){ke&&(Pe=ke);var re=0;return function(){return re>=Pe.length?{done:!0}:{done:!1,value:Pe[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=C();function R(Pe){te.defaults=Pe}var S=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(Ie){return f[Ie]};function h(Pe,Ie){if(Ie){if(S.test(Pe))return Pe.replace(k,v)}else if(O.test(Pe))return Pe.replace(I,v);return Pe}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Pe){return Pe.replace(i,function(Ie,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var l=/(^|[^\[])\^/g;function E(Pe,Ie){Pe=typeof Pe=="string"?Pe:Pe.source,Ie=Ie||"";var ke={replace:function(ae,J){return J=J.source||J,J=J.replace(l,"$1"),Pe=Pe.replace(ae,J),ke},getRegex:function(){return new RegExp(Pe,Ie)}};return ke}var b=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Pe,Ie,ke){if(Pe){var re;try{re=decodeURIComponent(o(ke)).replace(b,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Ie&&!p.test(ke)&&(ke=c(Ie,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var s={},r=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Pe,Ie){s[" "+Pe]||(r.test(Pe)?s[" "+Pe]=Pe+"/":s[" "+Pe]=g(Pe,"/",!0)),Pe=s[" "+Pe];var ke=Pe.indexOf(":")===-1;return Ie.substring(0,2)==="//"?ke?Ie:Pe.replace(a,"$1")+Ie:Ie.charAt(0)==="/"?ke?Ie:Pe.replace(d,"$1")+Ie:Pe+Ie}var u={exec:function(){}};function t(Pe){for(var Ie=1,ke,re;Ie<arguments.length;Ie++){ke=arguments[Ie];for(re in ke)Object.prototype.hasOwnProperty.call(ke,re)&&(Pe[re]=ke[re])}return Pe}function m(Pe,Ie){var ke=Pe.replace(/\|/g,function(J,D,U){for(var H=!1,G=D;--G>=0&&U[G]==="\\";)H=!H;return H?"|":" |"}),re=ke.split(/ \|/),ae=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>Ie)re.splice(Ie);else for(;re.length<Ie;)re.push("");for(;ae<re.length;ae++)re[ae]=re[ae].trim().replace(/\\\|/g,"|");return re}function g(Pe,Ie,ke){var re=Pe.length;if(re===0)return"";for(var ae=0;ae<re;){var J=Pe.charAt(re-ae-1);if(J===Ie&&!ke)ae++;else if(J!==Ie&&ke)ae++;else break}return Pe.slice(0,re-ae)}function A(Pe,Ie){if(Pe.indexOf(Ie[1])===-1)return-1;for(var ke=Pe.length,re=0,ae=0;ae<ke;ae++)if(Pe[ae]==="\\")ae++;else if(Pe[ae]===Ie[0])re++;else if(Pe[ae]===Ie[1]&&(re--,re<0))return ae;return-1}function L(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function K(Pe,Ie){if(Ie<1)return"";for(var ke="";Ie>1;)Ie&1&&(ke+=Pe),Ie>>=1,Pe+=Pe;return ke+Pe}function q(Pe,Ie,ke,re){var ae=Ie.href,J=Ie.title?h(Ie.title):null,D=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){re.state.inLink=!0;var U={type:"link",raw:ke,href:ae,title:J,text:D,tokens:re.inlineTokens(D)};return re.state.inLink=!1,U}return{type:"image",raw:ke,href:ae,title:J,text:h(D)}}function j(Pe,Ie){var ke=Pe.match(/^(\s+)(?:```)/);if(ke===null)return Ie;var re=ke[1];return Ie.split(`
`).map(function(ae){var J=ae.match(/^\s+/);if(J===null)return ae;var D=J[0];return D.length>=re.length?ae.slice(re.length):ae}).join(`
`)}var P=function(){function Pe(ke){this.options=ke||te.defaults}var Ie=Pe.prototype;return Ie.space=function(re){var ae=this.rules.block.newline.exec(re);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},Ie.code=function(re){var ae=this.rules.block.code.exec(re);if(ae){var J=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?J:g(J,`
`)}}},Ie.fences=function(re){var ae=this.rules.block.fences.exec(re);if(ae){var J=ae[0],D=j(J,ae[3]||"");return{type:"code",raw:J,lang:ae[2]?ae[2].trim():ae[2],text:D}}},Ie.heading=function(re){var ae=this.rules.block.heading.exec(re);if(ae){var J=ae[2].trim();if(/#$/.test(J)){var D=g(J,"#");(this.options.pedantic||!D||/ $/.test(D))&&(J=D.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:J,tokens:this.lexer.inline(J)}}},Ie.hr=function(re){var ae=this.rules.block.hr.exec(re);if(ae)return{type:"hr",raw:ae[0]}},Ie.blockquote=function(re){var ae=this.rules.block.blockquote.exec(re);if(ae){var J=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},Ie.list=function(re){var ae=this.rules.block.list.exec(re);if(ae){var J,D,U,H,G,ee,de,ye,se,ve,be,$e,He=ae[1].trim(),tt=He.length>1,Ge={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&($e=!1,!(!(ae=et.exec(re))||this.rules.block.hr.test(re)));){if(J=ae[0],re=re.substring(J.length),ye=ae[2].split(`
`,1)[0],se=re.split(`
`,1)[0],this.options.pedantic?(H=2,be=ye.trimLeft()):(H=ae[2].search(/[^ ]/),H=H>4?1:H,be=ye.slice(H),H+=ae[1].length),ee=!1,!ye&&/^ *$/.test(se)&&(J+=se+`
`,re=re.substring(se.length+1),$e=!0),!$e)for(var it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),Le=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");re&&(ve=re.split(`
`,1)[0],ye=ve,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(ye)||Le.test(ye)||it.test(ye)||ct.test(re)));){if(ye.search(/[^ ]/)>=H||!ye.trim())be+=`
`+ye.slice(H);else if(!ee)be+=`
`+ye;else break;!ee&&!ye.trim()&&(ee=!0),J+=ve+`
`,re=re.substring(ve.length+1)}Ge.loose||(de?Ge.loose=!0:/\n *\n *$/.test(J)&&(de=!0)),this.options.gfm&&(D=/^\[[ xX]\] /.exec(be),D&&(U=D[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:J,task:!!D,checked:U,loose:!1,text:be}),Ge.raw+=J}Ge.items[Ge.items.length-1].raw=J.trimRight(),Ge.items[Ge.items.length-1].text=be.trimRight(),Ge.raw=Ge.raw.trimRight();var lt=Ge.items.length;for(G=0;G<lt;G++){this.lexer.state.top=!1,Ge.items[G].tokens=this.lexer.blockTokens(Ge.items[G].text,[]);var _=Ge.items[G].tokens.filter(function(ue){return ue.type==="space"}),Q=_.every(function(ue){for(var Ue=ue.raw.split(""),Ne=0,_e=N(Ue),Je;!(Je=_e()).done;){var ht=Je.value;if(ht===`
`&&(Ne+=1),Ne>1)return!0}return!1});!Ge.loose&&_.length&&Q&&(Ge.loose=!0,Ge.items[G].loose=!0)}return Ge}},Ie.html=function(re){var ae=this.rules.block.html.exec(re);if(ae){var J={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var D=this.options.sanitizer?this.options.sanitizer(ae[0]):h(ae[0]);J.type="paragraph",J.text=D,J.tokens=this.lexer.inline(D)}return J}},Ie.def=function(re){var ae=this.rules.block.def.exec(re);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var J=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ae[0],href:ae[2],title:ae[3]}}},Ie.table=function(re){var ae=this.rules.block.table.exec(re);if(ae){var J={type:"table",header:m(ae[1]).map(function(de){return{text:de}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ae[0];var D=J.align.length,U,H,G,ee;for(U=0;U<D;U++)/^ *-+: *$/.test(J.align[U])?J.align[U]="right":/^ *:-+: *$/.test(J.align[U])?J.align[U]="center":/^ *:-+ *$/.test(J.align[U])?J.align[U]="left":J.align[U]=null;for(D=J.rows.length,U=0;U<D;U++)J.rows[U]=m(J.rows[U],J.header.length).map(function(de){return{text:de}});for(D=J.header.length,H=0;H<D;H++)J.header[H].tokens=this.lexer.inline(J.header[H].text);for(D=J.rows.length,H=0;H<D;H++)for(ee=J.rows[H],G=0;G<ee.length;G++)ee[G].tokens=this.lexer.inline(ee[G].text);return J}}},Ie.lheading=function(re){var ae=this.rules.block.lheading.exec(re);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},Ie.paragraph=function(re){var ae=this.rules.block.paragraph.exec(re);if(ae){var J=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:J,tokens:this.lexer.inline(J)}}},Ie.text=function(re){var ae=this.rules.block.text.exec(re);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},Ie.escape=function(re){var ae=this.rules.inline.escape.exec(re);if(ae)return{type:"escape",raw:ae[0],text:h(ae[1])}},Ie.tag=function(re){var ae=this.rules.inline.tag.exec(re);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):h(ae[0]):ae[0]}},Ie.link=function(re){var ae=this.rules.inline.link.exec(re);if(ae){var J=ae[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var D=g(J.slice(0,-1),"\\");if((J.length-D.length)%2===0)return}else{var U=A(ae[2],"()");if(U>-1){var H=ae[0].indexOf("!")===0?5:4,G=H+ae[1].length+U;ae[2]=ae[2].substring(0,U),ae[0]=ae[0].substring(0,G).trim(),ae[3]=""}}var ee=ae[2],de="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);ye&&(ee=ye[1],de=ye[3])}else de=ae[3]?ae[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(J)?ee=ee.slice(1):ee=ee.slice(1,-1)),q(ae,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},Ie.reflink=function(re,ae){var J;if((J=this.rules.inline.reflink.exec(re))||(J=this.rules.inline.nolink.exec(re))){var D=(J[2]||J[1]).replace(/\s+/g," ");if(D=ae[D.toLowerCase()],!D||!D.href){var U=J[0].charAt(0);return{type:"text",raw:U,text:U}}return q(J,D,J[0],this.lexer)}},Ie.emStrong=function(re,ae,J){J===void 0&&(J="");var D=this.rules.inline.emStrong.lDelim.exec(re);if(!!D&&!(D[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=D[1]||D[2]||"";if(!U||U&&(J===""||this.rules.inline.punctuation.exec(J))){var H=D[0].length-1,G,ee,de=H,ye=0,se=D[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,ae=ae.slice(-1*re.length+H);(D=se.exec(ae))!=null;)if(G=D[1]||D[2]||D[3]||D[4]||D[5]||D[6],!!G){if(ee=G.length,D[3]||D[4]){de+=ee;continue}else if((D[5]||D[6])&&H%3&&!((H+ee)%3)){ye+=ee;continue}if(de-=ee,!(de>0)){if(ee=Math.min(ee,ee+de+ye),Math.min(H,ee)%2){var ve=re.slice(1,H+D.index+ee);return{type:"em",raw:re.slice(0,H+D.index+ee+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var be=re.slice(2,H+D.index+ee-1);return{type:"strong",raw:re.slice(0,H+D.index+ee+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},Ie.codespan=function(re){var ae=this.rules.inline.code.exec(re);if(ae){var J=ae[2].replace(/\n/g," "),D=/[^ ]/.test(J),U=/^ /.test(J)&&/ $/.test(J);return D&&U&&(J=J.substring(1,J.length-1)),J=h(J,!0),{type:"codespan",raw:ae[0],text:J}}},Ie.br=function(re){var ae=this.rules.inline.br.exec(re);if(ae)return{type:"br",raw:ae[0]}},Ie.del=function(re){var ae=this.rules.inline.del.exec(re);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},Ie.autolink=function(re,ae){var J=this.rules.inline.autolink.exec(re);if(J){var D,U;return J[2]==="@"?(D=h(this.options.mangle?ae(J[1]):J[1]),U="mailto:"+D):(D=h(J[1]),U=D),{type:"link",raw:J[0],text:D,href:U,tokens:[{type:"text",raw:D,text:D}]}}},Ie.url=function(re,ae){var J;if(J=this.rules.inline.url.exec(re)){var D,U;if(J[2]==="@")D=h(this.options.mangle?ae(J[0]):J[0]),U="mailto:"+D;else{var H;do H=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(H!==J[0]);D=h(J[0]),J[1]==="www."?U="http://"+D:U=D}return{type:"link",raw:J[0],text:D,href:U,tokens:[{type:"text",raw:D,text:D}]}}},Ie.inlineText=function(re,ae){var J=this.rules.inline.text.exec(re);if(J){var D;return this.lexer.state.inRawBlock?D=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):h(J[0]):J[0]:D=h(this.options.smartypants?ae(J[0]):J[0]),{type:"text",raw:J[0],text:D}}},Pe}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=E(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=E(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=E(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=E(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=E(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=E(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=t({},M),M.gfm=t({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=E(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=E(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=t({},M.normal,{html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:E(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=E(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=E(M._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=E(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=E(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=E(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=E(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=E(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=E(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=E(F.reflink).replace("label",F._label).replace("ref",M._label).getRegex(),F.nolink=E(F.nolink).replace("ref",M._label).getRegex(),F.reflinkSearch=E(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=t({},F),F.pedantic=t({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=t({},F.normal,{escape:E(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=E(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=t({},F.gfm,{br:E(F.br).replace("{2,}","*").getRegex(),text:E(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Pe){var Ie="",ke,re,ae=Pe.length;for(ke=0;ke<ae;ke++)re=Pe.charCodeAt(ke),Math.random()>.5&&(re="x"+re.toString(16)),Ie+="&#"+re+";";return Ie}var V=function(){function Pe(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||te.defaults,this.options.tokenizer=this.options.tokenizer||new P,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:M.normal,inline:F.normal};this.options.pedantic?(re.block=M.pedantic,re.inline=F.pedantic):this.options.gfm&&(re.block=M.gfm,this.options.breaks?re.inline=F.breaks:re.inline=F.gfm),this.tokenizer.rules=re}Pe.lex=function(re,ae){var J=new Pe(ae);return J.lex(re)},Pe.lexInline=function(re,ae){var J=new Pe(ae);return J.inlineTokens(re)};var Ie=Pe.prototype;return Ie.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},Ie.blockTokens=function(re,ae){var J=this;ae===void 0&&(ae=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(de,ye,se){return ye+"    ".repeat(se.length)});for(var D,U,H,G;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(D=de.call({lexer:J},re,ae))?(re=re.substring(D.raw.length),ae.push(D),!0):!1}))){if(D=this.tokenizer.space(re)){re=re.substring(D.raw.length),D.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(D);continue}if(D=this.tokenizer.code(re)){re=re.substring(D.raw.length),U=ae[ae.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+D.raw,U.text+=`
`+D.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):ae.push(D);continue}if(D=this.tokenizer.fences(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.heading(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.hr(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.blockquote(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.list(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.html(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.def(re)){re=re.substring(D.raw.length),U=ae[ae.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+D.raw,U.text+=`
`+D.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[D.tag]||(this.tokens.links[D.tag]={href:D.href,title:D.title});continue}if(D=this.tokenizer.table(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.lheading(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(H=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=1/0,ye=re.slice(1),se=void 0;J.options.extensions.startBlock.forEach(function(ve){se=ve.call({lexer:this},ye),typeof se=="number"&&se>=0&&(de=Math.min(de,se))}),de<1/0&&de>=0&&(H=re.substring(0,de+1))}(),this.state.top&&(D=this.tokenizer.paragraph(H))){U=ae[ae.length-1],G&&U.type==="paragraph"?(U.raw+=`
`+D.raw,U.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):ae.push(D),G=H.length!==re.length,re=re.substring(D.raw.length);continue}if(D=this.tokenizer.text(re)){re=re.substring(D.raw.length),U=ae[ae.length-1],U&&U.type==="text"?(U.raw+=`
`+D.raw,U.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):ae.push(D);continue}if(re){var ee="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,ae},Ie.inline=function(re,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:re,tokens:ae}),ae},Ie.inlineTokens=function(re,ae){var J=this;ae===void 0&&(ae=[]);var D,U,H,G=re,ee,de,ye;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)se.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,ee.index)+"["+K("a",ee[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,ee.index)+"["+K("a",ee[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,ee.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(de||(ye=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(D=be.call({lexer:J},re,ae))?(re=re.substring(D.raw.length),ae.push(D),!0):!1}))){if(D=this.tokenizer.escape(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.tag(re)){re=re.substring(D.raw.length),U=ae[ae.length-1],U&&D.type==="text"&&U.type==="text"?(U.raw+=D.raw,U.text+=D.text):ae.push(D);continue}if(D=this.tokenizer.link(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(D.raw.length),U=ae[ae.length-1],U&&D.type==="text"&&U.type==="text"?(U.raw+=D.raw,U.text+=D.text):ae.push(D);continue}if(D=this.tokenizer.emStrong(re,G,ye)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.codespan(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.br(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.del(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.autolink(re,z)){re=re.substring(D.raw.length),ae.push(D);continue}if(!this.state.inLink&&(D=this.tokenizer.url(re,z))){re=re.substring(D.raw.length),ae.push(D);continue}if(H=re,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,$e=re.slice(1),He=void 0;J.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},$e),typeof He=="number"&&He>=0&&(be=Math.min(be,He))}),be<1/0&&be>=0&&(H=re.substring(0,be+1))}(),D=this.tokenizer.inlineText(H,$)){re=re.substring(D.raw.length),D.raw.slice(-1)!=="_"&&(ye=D.raw.slice(-1)),de=!0,U=ae[ae.length-1],U&&U.type==="text"?(U.raw+=D.raw,U.text+=D.text):ae.push(D);continue}if(re){var ve="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ae},n(Pe,null,[{key:"rules",get:function(){return{block:M,inline:F}}}]),Pe}(),X=function(){function Pe(ke){this.options=ke||te.defaults}var Ie=Pe.prototype;return Ie.code=function(re,ae,J){var D=(ae||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(re,D);U!=null&&U!==re&&(J=!0,re=U)}return re=re.replace(/\n$/,"")+`
`,D?'<pre><code class="'+this.options.langPrefix+h(D,!0)+'">'+(J?re:h(re,!0))+`</code></pre>
`:"<pre><code>"+(J?re:h(re,!0))+`</code></pre>
`},Ie.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Ie.html=function(re){return re},Ie.heading=function(re,ae,J,D){if(this.options.headerIds){var U=this.options.headerPrefix+D.slug(J);return"<h"+ae+' id="'+U+'">'+re+"</h"+ae+`>
`}return"<h"+ae+">"+re+"</h"+ae+`>
`},Ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ie.list=function(re,ae,J){var D=ae?"ol":"ul",U=ae&&J!==1?' start="'+J+'"':"";return"<"+D+U+`>
`+re+"</"+D+`>
`},Ie.listitem=function(re){return"<li>"+re+`</li>
`},Ie.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ie.paragraph=function(re){return"<p>"+re+`</p>
`},Ie.table=function(re,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ae+`</table>
`},Ie.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Ie.tablecell=function(re,ae){var J=ae.header?"th":"td",D=ae.align?"<"+J+' align="'+ae.align+'">':"<"+J+">";return D+re+("</"+J+`>
`)},Ie.strong=function(re){return"<strong>"+re+"</strong>"},Ie.em=function(re){return"<em>"+re+"</em>"},Ie.codespan=function(re){return"<code>"+re+"</code>"},Ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ie.del=function(re){return"<del>"+re+"</del>"},Ie.link=function(re,ae,J){if(re=w(this.options.sanitize,this.options.baseUrl,re),re===null)return J;var D='<a href="'+h(re)+'"';return ae&&(D+=' title="'+ae+'"'),D+=">"+J+"</a>",D},Ie.image=function(re,ae,J){if(re=w(this.options.sanitize,this.options.baseUrl,re),re===null)return J;var D='<img src="'+re+'" alt="'+J+'"';return ae&&(D+=' title="'+ae+'"'),D+=this.options.xhtml?"/>":">",D},Ie.text=function(re){return re},Pe}(),Z=function(){function Pe(){}var Ie=Pe.prototype;return Ie.strong=function(re){return re},Ie.em=function(re){return re},Ie.codespan=function(re){return re},Ie.del=function(re){return re},Ie.html=function(re){return re},Ie.text=function(re){return re},Ie.link=function(re,ae,J){return""+J},Ie.image=function(re,ae,J){return""+J},Ie.br=function(){return""},Pe}(),fe=function(){function Pe(){this.seen={}}var Ie=Pe.prototype;return Ie.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ie.getNextSafeSlug=function(re,ae){var J=re,D=0;if(this.seen.hasOwnProperty(J)){D=this.seen[re];do D++,J=re+"-"+D;while(this.seen.hasOwnProperty(J))}return ae||(this.seen[re]=D,this.seen[J]=0),J},Ie.slug=function(re,ae){ae===void 0&&(ae={});var J=this.serialize(re);return this.getNextSafeSlug(J,ae.dryrun)},Pe}(),oe=function(){function Pe(ke){this.options=ke||te.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new fe}Pe.parse=function(re,ae){var J=new Pe(ae);return J.parse(re)},Pe.parseInline=function(re,ae){var J=new Pe(ae);return J.parseInline(re)};var Ie=Pe.prototype;return Ie.parse=function(re,ae){ae===void 0&&(ae=!0);var J="",D,U,H,G,ee,de,ye,se,ve,be,$e,He,tt,Ge,et,it,ct,nt,Le,lt=re.length;for(D=0;D<lt;D++){if(be=re[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Le=this.options.extensions.renderers[be.type].call({parser:this},be),Le!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){J+=Le||"";continue}switch(be.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(be.tokens),be.depth,o(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(se="",ye="",G=be.header.length,U=0;U<G;U++)ye+=this.renderer.tablecell(this.parseInline(be.header[U].tokens),{header:!0,align:be.align[U]});for(se+=this.renderer.tablerow(ye),ve="",G=be.rows.length,U=0;U<G;U++){for(de=be.rows[U],ye="",ee=de.length,H=0;H<ee;H++)ye+=this.renderer.tablecell(this.parseInline(de[H].tokens),{header:!1,align:be.align[H]});ve+=this.renderer.tablerow(ye)}J+=this.renderer.table(se,ve);continue}case"blockquote":{ve=this.parse(be.tokens),J+=this.renderer.blockquote(ve);continue}case"list":{for($e=be.ordered,He=be.start,tt=be.loose,G=be.items.length,ve="",U=0;U<G;U++)et=be.items[U],it=et.checked,ct=et.task,Ge="",et.task&&(nt=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=nt+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=nt+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:nt}):Ge+=nt),Ge+=this.parse(et.tokens,tt),ve+=this.renderer.listitem(Ge,ct,it);J+=this.renderer.list(ve,$e,He);continue}case"html":{J+=this.renderer.html(be.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(ve=be.tokens?this.parseInline(be.tokens):be.text;D+1<lt&&re[D+1].type==="text";)be=re[++D],ve+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);J+=ae?this.renderer.paragraph(ve):ve;continue}default:{var _='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(_);return}else throw new Error(_)}}}return J},Ie.parseInline=function(re,ae){ae=ae||this.renderer;var J="",D,U,H,G=re.length;for(D=0;D<G;D++){if(U=re[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(H=this.options.extensions.renderers[U.type].call({parser:this},U),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){J+=H||"";continue}switch(U.type){case"escape":{J+=ae.text(U.text);break}case"html":{J+=ae.html(U.text);break}case"link":{J+=ae.link(U.href,U.title,this.parseInline(U.tokens,ae));break}case"image":{J+=ae.image(U.href,U.title,U.text);break}case"strong":{J+=ae.strong(this.parseInline(U.tokens,ae));break}case"em":{J+=ae.em(this.parseInline(U.tokens,ae));break}case"codespan":{J+=ae.codespan(U.text);break}case"br":{J+=ae.br();break}case"del":{J+=ae.del(this.parseInline(U.tokens,ae));break}case"text":{J+=ae.text(U.text);break}default:{var ee='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return J},Pe}();function le(Pe,Ie,ke){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Ie=="function"&&(ke=Ie,Ie=null),Ie=t({},le.defaults,Ie||{}),L(Ie),ke){var re=Ie.highlight,ae;try{ae=V.lex(Pe,Ie)}catch(G){return ke(G)}var J=function(ee){var de;if(!ee)try{Ie.walkTokens&&le.walkTokens(ae,Ie.walkTokens),de=oe.parse(ae,Ie)}catch(ye){ee=ye}return Ie.highlight=re,ee?ke(ee):ke(null,de)};if(!re||re.length<3||(delete Ie.highlight,!ae.length))return J();var D=0;le.walkTokens(ae,function(G){G.type==="code"&&(D++,setTimeout(function(){re(G.text,G.lang,function(ee,de){if(ee)return J(ee);de!=null&&de!==G.text&&(G.text=de,G.escaped=!0),D--,D===0&&J()})},0))}),D===0&&J();return}function U(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+h(G.message+"",!0)+"</pre>";throw G}try{var H=V.lex(Pe,Ie);if(Ie.walkTokens){if(Ie.async)return Promise.all(le.walkTokens(H,Ie.walkTokens)).then(function(){return oe.parse(H,Ie)}).catch(U);le.walkTokens(H,Ie.walkTokens)}return oe.parse(H,Ie)}catch(G){U(G)}}le.options=le.setOptions=function(Pe){return t(le.defaults,Pe),R(le.defaults),le},le.getDefaults=C,le.defaults=te.defaults,le.use=function(){for(var Pe=arguments.length,Ie=new Array(Pe),ke=0;ke<Pe;ke++)Ie[ke]=arguments[ke];var re=t.apply(void 0,[{}].concat(Ie)),ae=le.defaults.extensions||{renderers:{},childTokens:{}},J;Ie.forEach(function(D){if(D.extensions&&(J=!0,D.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var G=ae.renderers?ae.renderers[H.name]:null;G?ae.renderers[H.name]=function(){for(var ee=arguments.length,de=new Array(ee),ye=0;ye<ee;ye++)de[ye]=arguments[ye];var se=H.renderer.apply(this,de);return se===!1&&(se=G.apply(this,de)),se}:ae.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[H.level]?ae[H.level].unshift(H.tokenizer):ae[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ae.startBlock?ae.startBlock.push(H.start):ae.startBlock=[H.start]:H.level==="inline"&&(ae.startInline?ae.startInline.push(H.start):ae.startInline=[H.start]))}H.childTokens&&(ae.childTokens[H.name]=H.childTokens)})),D.renderer&&function(){var H=le.defaults.renderer||new X,G=function(ye){var se=H[ye];H[ye]=function(){for(var ve=arguments.length,be=new Array(ve),$e=0;$e<ve;$e++)be[$e]=arguments[$e];var He=D.renderer[ye].apply(H,be);return He===!1&&(He=se.apply(H,be)),He}};for(var ee in D.renderer)G(ee);re.renderer=H}(),D.tokenizer&&function(){var H=le.defaults.tokenizer||new P,G=function(ye){var se=H[ye];H[ye]=function(){for(var ve=arguments.length,be=new Array(ve),$e=0;$e<ve;$e++)be[$e]=arguments[$e];var He=D.tokenizer[ye].apply(H,be);return He===!1&&(He=se.apply(H,be)),He}};for(var ee in D.tokenizer)G(ee);re.tokenizer=H}(),D.walkTokens){var U=le.defaults.walkTokens;re.walkTokens=function(H){var G=[];return G.push(D.walkTokens.call(this,H)),U&&(G=G.concat(U.call(this,H))),G}}J&&(re.extensions=ae),le.setOptions(re)})},le.walkTokens=function(Pe,Ie){for(var ke=[],re=function(){var U=J.value;switch(ke=ke.concat(Ie.call(le,U)),U.type){case"table":{for(var H=N(U.header),G;!(G=H()).done;){var ee=G.value;ke=ke.concat(le.walkTokens(ee.tokens,Ie))}for(var de=N(U.rows),ye;!(ye=de()).done;)for(var se=ye.value,ve=N(se),be;!(be=ve()).done;){var $e=be.value;ke=ke.concat(le.walkTokens($e.tokens,Ie))}break}case"list":{ke=ke.concat(le.walkTokens(U.items,Ie));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[U.type]?le.defaults.extensions.childTokens[U.type].forEach(function(He){ke=ke.concat(le.walkTokens(U[He],Ie))}):U.tokens&&(ke=ke.concat(le.walkTokens(U.tokens,Ie)))}},ae=N(Pe),J;!(J=ae()).done;)re();return ke},le.parseInline=function(Pe,Ie){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Ie=t({},le.defaults,Ie||{}),L(Ie);try{var ke=V.lexInline(Pe,Ie);return Ie.walkTokens&&le.walkTokens(ke,Ie.walkTokens),oe.parseInline(ke,Ie)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+h(re.message+"",!0)+"</pre>";throw re}},le.Parser=oe,le.parser=oe.parse,le.Renderer=X,le.TextRenderer=Z,le.Lexer=V,le.lexer=V.lex,le.Tokenizer=P,le.Slugger=fe,le.parse=le;var ce=le.options,me=le.setOptions,Y=le.use,pe=le.walkTokens,we=le.parseInline,Fe=le,We=oe.parse,Xe=V.lex;te.Lexer=V,te.Parser=oe,te.Renderer=X,te.Slugger=fe,te.TextRenderer=Z,te.Tokenizer=P,te.getDefaults=C,te.lexer=Xe,te.marked=le,te.options=ce,te.parse=Fe,te.parseInline=we,te.parser=We,te.setOptions=me,te.use=Y,te.walkTokens=pe,Object.defineProperty(te,"__esModule",{value:!0})}),define(De[109],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(R,S,k){return Math.min(Math.max(R,S),k)}e.clamp=n;function T(R,S){return(S+R%S)%S}e.rot=T;class y{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=y;class N{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=N;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const k=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function te(y){const N=[];typeof y=="number"&&N.push("code/timeOrigin",y);function C(S){N.push(S,Date.now())}function R(){const S=[];for(let k=0;k<N.length;k+=2)S.push({name:N[k],startTime:N[k+1]});return S}return{mark:C,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))N.push({name:C.name,startTime:Math.round(y+C.startTime)});return N}};if(typeof process=="object"){const y=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=n(T))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var T in n)(typeof exports=="object"?exports:te)[T]=n[T]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(T){if(e[T])return e[T].exports;var y=e[T]={i:T,l:!1,exports:{}};return te[T].call(y.exports,y,y.exports,n),y.l=!0,y.exports}return n.m=te,n.c=e,n.d=function(T,y,N){n.o(T,y)||Object.defineProperty(T,y,{enumerable:!0,get:N})},n.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},n.t=function(T,y){if(1&y&&(T=n(T)),8&y||4&y&&typeof T=="object"&&T&&T.__esModule)return T;var N=Object.create(null);if(n.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:T}),2&y&&typeof T!="string")for(var C in T)n.d(N,C,function(R){return T[R]}.bind(null,C));return N},n.n=function(T){var y=T&&T.__esModule?function(){return T.default}:function(){return T};return n.d(y,"a",y),y},n.o=function(T,y){return Object.prototype.hasOwnProperty.call(T,y)},n.p="",n(n.s=0)}([function(te,e,n){(function(T){var y;e=te.exports=Y,y=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],k=0,O=k++;S[O]="0|[1-9]\\d*";var I=k++;S[I]="[0-9]+";var f=k++;S[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=k++;S[v]="("+S[O]+")\\.("+S[O]+")\\.("+S[O]+")";var h=k++;S[h]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var i=k++;S[i]="(?:"+S[O]+"|"+S[f]+")";var o=k++;S[o]="(?:"+S[I]+"|"+S[f]+")";var l=k++;S[l]="(?:-("+S[i]+"(?:\\."+S[i]+")*))";var E=k++;S[E]="(?:-?("+S[o]+"(?:\\."+S[o]+")*))";var b=k++;S[b]="[0-9A-Za-z-]+";var p=k++;S[p]="(?:\\+("+S[b]+"(?:\\."+S[b]+")*))";var w=k++,s="v?"+S[v]+S[l]+"?"+S[p]+"?";S[w]="^"+s+"$";var r="[v=\\s]*"+S[h]+S[E]+"?"+S[p]+"?",a=k++;S[a]="^"+r+"$";var d=k++;S[d]="((?:<|>)?=?)";var c=k++;S[c]=S[I]+"|x|X|\\*";var u=k++;S[u]=S[O]+"|x|X|\\*";var t=k++;S[t]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[l]+")?"+S[p]+"?)?)?";var m=k++;S[m]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[E]+")?"+S[p]+"?)?)?";var g=k++;S[g]="^"+S[d]+"\\s*"+S[t]+"$";var A=k++;S[A]="^"+S[d]+"\\s*"+S[m]+"$";var L=k++;S[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=k++;S[K]="(?:~>?)";var q=k++;S[q]="(\\s*)"+S[K]+"\\s+",R[q]=new RegExp(S[q],"g");var j=k++;S[j]="^"+S[K]+S[t]+"$";var P=k++;S[P]="^"+S[K]+S[m]+"$";var M=k++;S[M]="(?:\\^)";var F=k++;S[F]="(\\s*)"+S[M]+"\\s+",R[F]=new RegExp(S[F],"g");var $=k++;S[$]="^"+S[M]+S[t]+"$";var z=k++;S[z]="^"+S[M]+S[m]+"$";var V=k++;S[V]="^"+S[d]+"\\s*("+r+")$|^$";var X=k++;S[X]="^"+S[d]+"\\s*("+s+")$|^$";var Z=k++;S[Z]="(\\s*)"+S[d]+"\\s*("+r+"|"+S[t]+")",R[Z]=new RegExp(S[Z],"g");var fe=k++;S[fe]="^\\s*("+S[t]+")\\s+-\\s+("+S[t]+")\\s*$";var oe=k++;S[oe]="^\\s*("+S[m]+")\\s+-\\s+("+S[m]+")\\s*$";var le=k++;S[le]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)y(ce,S[ce]),R[ce]||(R[ce]=new RegExp(S[ce]));function me(se,ve){if(se instanceof Y)return se;if(typeof se!="string"||se.length>N||!(ve?R[a]:R[w]).test(se))return null;try{return new Y(se,ve)}catch{return null}}function Y(se,ve){if(se instanceof Y){if(se.loose===ve)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Y))return new Y(se,ve);y("SemVer",se,ve),this.loose=ve;var be=se.trim().match(ve?R[a]:R[w]);if(!be)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var He=+$e;if(He>=0&&He<C)return He}return $e}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=me,e.valid=function(se,ve){var be=me(se,ve);return be?be.version:null},e.clean=function(se,ve){var be=me(se.trim().replace(/^[=v]+/,""),ve);return be?be.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(se){return y("SemVer.compare",this.version,this.loose,se),se instanceof Y||(se=new Y(se,this.loose)),this.compareMain(se)||this.comparePre(se)},Y.prototype.compareMain=function(se){return se instanceof Y||(se=new Y(se,this.loose)),we(this.major,se.major)||we(this.minor,se.minor)||we(this.patch,se.patch)},Y.prototype.comparePre=function(se){if(se instanceof Y||(se=new Y(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var ve=0;do{var be=this.prerelease[ve],$e=se.prerelease[ve];if(y("prerelease compare",ve,be,$e),be===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(be===void 0)return-1;if(be!==$e)return we(be,$e)}while(++ve)},Y.prototype.inc=function(se,ve){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,ve,be,$e){typeof be=="string"&&($e=be,be=void 0);try{return new Y(se,be).inc(ve,$e).version}catch{return null}},e.diff=function(se,ve){if(Pe(se,ve))return null;var be=me(se),$e=me(ve);if(be.prerelease.length||$e.prerelease.length){for(var He in be)if((He==="major"||He==="minor"||He==="patch")&&be[He]!==$e[He])return"pre"+He;return"prerelease"}for(var He in be)if((He==="major"||He==="minor"||He==="patch")&&be[He]!==$e[He])return He},e.compareIdentifiers=we;var pe=/^[0-9]+$/;function we(se,ve){var be=pe.test(se),$e=pe.test(ve);return be&&$e&&(se=+se,ve=+ve),be&&!$e?-1:$e&&!be?1:se<ve?-1:se>ve?1:0}function Fe(se,ve,be){return new Y(se,be).compare(new Y(ve,be))}function We(se,ve,be){return Fe(se,ve,be)>0}function Xe(se,ve,be){return Fe(se,ve,be)<0}function Pe(se,ve,be){return Fe(se,ve,be)===0}function Ie(se,ve,be){return Fe(se,ve,be)!==0}function ke(se,ve,be){return Fe(se,ve,be)>=0}function re(se,ve,be){return Fe(se,ve,be)<=0}function ae(se,ve,be,$e){var He;switch(ve){case"===":typeof se=="object"&&(se=se.version),typeof be=="object"&&(be=be.version),He=se===be;break;case"!==":typeof se=="object"&&(se=se.version),typeof be=="object"&&(be=be.version),He=se!==be;break;case"":case"=":case"==":He=Pe(se,be,$e);break;case"!=":He=Ie(se,be,$e);break;case">":He=We(se,be,$e);break;case">=":He=ke(se,be,$e);break;case"<":He=Xe(se,be,$e);break;case"<=":He=re(se,be,$e);break;default:throw new TypeError("Invalid operator: "+ve)}return He}function J(se,ve){if(se instanceof J){if(se.loose===ve)return se;se=se.value}if(!(this instanceof J))return new J(se,ve);y("comparator",se,ve),this.loose=ve,this.parse(se),this.semver===D?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(se,ve){return we(ve,se)},e.major=function(se,ve){return new Y(se,ve).major},e.minor=function(se,ve){return new Y(se,ve).minor},e.patch=function(se,ve){return new Y(se,ve).patch},e.compare=Fe,e.compareLoose=function(se,ve){return Fe(se,ve,!0)},e.rcompare=function(se,ve,be){return Fe(ve,se,be)},e.sort=function(se,ve){return se.sort(function(be,$e){return e.compare(be,$e,ve)})},e.rsort=function(se,ve){return se.sort(function(be,$e){return e.rcompare(be,$e,ve)})},e.gt=We,e.lt=Xe,e.eq=Pe,e.neq=Ie,e.gte=ke,e.lte=re,e.cmp=ae,e.Comparator=J;var D={};function U(se,ve){if(se instanceof U)return se.loose===ve?se:new U(se.raw,ve);if(se instanceof J)return new U(se.value,ve);if(!(this instanceof U))return new U(se,ve);if(this.loose=ve,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function H(se){return!se||se.toLowerCase()==="x"||se==="*"}function G(se,ve,be,$e,He,tt,Ge,et,it,ct,nt,Le,lt){return((ve=H(be)?"":H($e)?">="+be+".0.0":H(He)?">="+be+"."+$e+".0":">="+ve)+" "+(et=H(it)?"":H(ct)?"<"+(+it+1)+".0.0":H(nt)?"<"+it+"."+(+ct+1)+".0":Le?"<="+it+"."+ct+"."+nt+"-"+Le:"<="+et)).trim()}function ee(se,ve){for(var be=0;be<se.length;be++)if(!se[be].test(ve))return!1;if(ve.prerelease.length){for(be=0;be<se.length;be++)if(y(se[be].semver),se[be].semver!==D&&se[be].semver.prerelease.length>0){var $e=se[be].semver;if($e.major===ve.major&&$e.minor===ve.minor&&$e.patch===ve.patch)return!0}return!1}return!0}function de(se,ve,be){try{ve=new U(ve,be)}catch{return!1}return ve.test(se)}function ye(se,ve,be,$e){var He,tt,Ge,et,it;switch(se=new Y(se,$e),ve=new U(ve,$e),be){case">":He=We,tt=re,Ge=Xe,et=">",it=">=";break;case"<":He=Xe,tt=ke,Ge=We,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(de(se,ve,$e))return!1;for(var ct=0;ct<ve.set.length;++ct){var nt=ve.set[ct],Le=null,lt=null;if(nt.forEach(function(_){_.semver===D&&(_=new J(">=0.0.0")),Le=Le||_,lt=lt||_,He(_.semver,Le.semver,$e)?Le=_:Ge(_.semver,lt.semver,$e)&&(lt=_)}),Le.operator===et||Le.operator===it||(!lt.operator||lt.operator===et)&&tt(se,lt.semver)||lt.operator===it&&Ge(se,lt.semver))return!1}return!0}J.prototype.parse=function(se){var ve=this.loose?R[V]:R[X],be=se.match(ve);if(!be)throw new TypeError("Invalid comparator: "+se);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Y(be[2],this.loose):this.semver=D},J.prototype.toString=function(){return this.value},J.prototype.test=function(se){return y("Comparator.test",se,this.loose),this.semver===D||(typeof se=="string"&&(se=new Y(se,this.loose)),ae(se,this.operator,this.semver,this.loose))},J.prototype.intersects=function(se,ve){if(!(se instanceof J))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new U(se.value,ve),de(this.value,be,ve);if(se.operator==="")return be=new U(this.value,ve),de(se.semver,be,ve);var $e=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),tt=this.semver.version===se.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),et=ae(this.semver,"<",se.semver,ve)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),it=ae(this.semver,">",se.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return $e||He||tt&&Ge||et||it},e.Range=U,U.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},U.prototype.toString=function(){return this.range},U.prototype.parseRange=function(se){var ve=this.loose;se=se.trim(),y("range",se,ve);var be=ve?R[oe]:R[fe];se=se.replace(be,G),y("hyphen replace",se),se=se.replace(R[Z],"$1$2$3"),y("comparator trim",se,R[Z]),se=(se=(se=se.replace(R[q],"$1~")).replace(R[F],"$1^")).split(/\s+/).join(" ");var $e=ve?R[V]:R[X],He=se.split(" ").map(function(tt){return function(Ge,et){return y("comp",Ge),Ge=function(it,ct){return it.trim().split(/\s+/).map(function(nt){return function(Le,lt){y("caret",Le,lt);var _=lt?R[z]:R[$];return Le.replace(_,function(Q,ue,Ue,Ne,_e){var Je;return y("caret",Le,Q,ue,Ue,Ne,_e),H(ue)?Je="":H(Ue)?Je=">="+ue+".0.0 <"+(+ue+1)+".0.0":H(Ne)?Je=ue==="0"?">="+ue+"."+Ue+".0 <"+ue+"."+(+Ue+1)+".0":">="+ue+"."+Ue+".0 <"+(+ue+1)+".0.0":_e?(y("replaceCaret pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),Je=ue==="0"?Ue==="0"?">="+ue+"."+Ue+"."+Ne+_e+" <"+ue+"."+Ue+"."+(+Ne+1):">="+ue+"."+Ue+"."+Ne+_e+" <"+ue+"."+(+Ue+1)+".0":">="+ue+"."+Ue+"."+Ne+_e+" <"+(+ue+1)+".0.0"):(y("no pr"),Je=ue==="0"?Ue==="0"?">="+ue+"."+Ue+"."+Ne+" <"+ue+"."+Ue+"."+(+Ne+1):">="+ue+"."+Ue+"."+Ne+" <"+ue+"."+(+Ue+1)+".0":">="+ue+"."+Ue+"."+Ne+" <"+(+ue+1)+".0.0"),y("caret return",Je),Je})}(nt,ct)}).join(" ")}(Ge,et),y("caret",Ge),Ge=function(it,ct){return it.trim().split(/\s+/).map(function(nt){return function(Le,lt){var _=lt?R[P]:R[j];return Le.replace(_,function(Q,ue,Ue,Ne,_e){var Je;return y("tilde",Le,Q,ue,Ue,Ne,_e),H(ue)?Je="":H(Ue)?Je=">="+ue+".0.0 <"+(+ue+1)+".0.0":H(Ne)?Je=">="+ue+"."+Ue+".0 <"+ue+"."+(+Ue+1)+".0":_e?(y("replaceTilde pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),Je=">="+ue+"."+Ue+"."+Ne+_e+" <"+ue+"."+(+Ue+1)+".0"):Je=">="+ue+"."+Ue+"."+Ne+" <"+ue+"."+(+Ue+1)+".0",y("tilde return",Je),Je})}(nt,ct)}).join(" ")}(Ge,et),y("tildes",Ge),Ge=function(it,ct){return y("replaceXRanges",it,ct),it.split(/\s+/).map(function(nt){return function(Le,lt){Le=Le.trim();var _=lt?R[A]:R[g];return Le.replace(_,function(Q,ue,Ue,Ne,_e,Je){y("xRange",Le,Q,ue,Ue,Ne,_e,Je);var ht=H(Ue),wt=ht||H(Ne),St=wt||H(_e);return ue==="="&&St&&(ue=""),ht?Q=ue===">"||ue==="<"?"<0.0.0":"*":ue&&St?(wt&&(Ne=0),St&&(_e=0),ue===">"?(ue=">=",wt?(Ue=+Ue+1,Ne=0,_e=0):St&&(Ne=+Ne+1,_e=0)):ue==="<="&&(ue="<",wt?Ue=+Ue+1:Ne=+Ne+1),Q=ue+Ue+"."+Ne+"."+_e):wt?Q=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":St&&(Q=">="+Ue+"."+Ne+".0 <"+Ue+"."+(+Ne+1)+".0"),y("xRange return",Q),Q})}(nt,ct)}).join(" ")}(Ge,et),y("xrange",Ge),Ge=function(it,ct){return y("replaceStars",it,ct),it.trim().replace(R[le],"")}(Ge,et),y("stars",Ge),Ge}(tt,ve)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match($e)})),He=He.map(function(tt){return new J(tt,ve)})},U.prototype.intersects=function(se,ve){if(!(se instanceof U))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function($e){return se.set.some(function(He){return He.every(function(tt){return $e.intersects(tt,ve)})})})})},e.toComparators=function(se,ve){return new U(se,ve).set.map(function(be){return be.map(function($e){return $e.value}).join(" ").trim().split(" ")})},U.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new Y(se,this.loose));for(var ve=0;ve<this.set.length;ve++)if(ee(this.set[ve],se))return!0;return!1},e.satisfies=de,e.maxSatisfying=function(se,ve,be){var $e=null,He=null;try{var tt=new U(ve,be)}catch{return null}return se.forEach(function(Ge){tt.test(Ge)&&($e&&He.compare(Ge)!==-1||(He=new Y($e=Ge,be)))}),$e},e.minSatisfying=function(se,ve,be){var $e=null,He=null;try{var tt=new U(ve,be)}catch{return null}return se.forEach(function(Ge){tt.test(Ge)&&($e&&He.compare(Ge)!==1||(He=new Y($e=Ge,be)))}),$e},e.validRange=function(se,ve){try{return new U(se,ve).range||"*"}catch{return null}},e.ltr=function(se,ve,be){return ye(se,ve,"<",be)},e.gtr=function(se,ve,be){return ye(se,ve,">",be)},e.outside=ye,e.prerelease=function(se,ve){var be=me(se,ve);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(se,ve,be){return se=new U(se,be),ve=new U(ve,be),se.intersects(ve)},e.coerce=function(se){if(se instanceof Y)return se;if(typeof se!="string")return null;var ve=se.match(R[L]);return ve==null?null:me((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,n(1))},function(te,e){var n,T,y=te.exports={};function N(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function R(o){if(n===setTimeout)return setTimeout(o,0);if((n===N||!n)&&setTimeout)return n=setTimeout,setTimeout(o,0);try{return n(o,0)}catch{try{return n.call(null,o,0)}catch{return n.call(this,o,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:N}catch{n=N}try{T=typeof clearTimeout=="function"?clearTimeout:C}catch{T=C}})();var S,k=[],O=!1,I=-1;function f(){O&&S&&(O=!1,S.length?k=S.concat(k):I=-1,k.length&&v())}function v(){if(!O){var o=R(f);O=!0;for(var l=k.length;l;){for(S=k,k=[];++I<l;)S&&S[I].run();I=-1,l=k.length}S=null,O=!1,function(E){if(T===clearTimeout)return clearTimeout(E);if((T===C||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(E);try{T(E)}catch{try{return T.call(null,E)}catch{return T.call(this,E)}}}(o)}}function h(o,l){this.fun=o,this.array=l}function i(){}y.nextTick=function(o){var l=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)l[E-1]=arguments[E];k.push(new h(o,l)),k.length!==1||O||R(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=i,y.addListener=i,y.once=i,y.off=i,y.removeListener=i,y.removeAllListeners=i,y.emit=i,y.prependListener=i,y.prependOnceListener=i,y.listeners=function(o){return[]},y.binding=function(o){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(o){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(De[110],Ce([1,0,11,7]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(p){const w=p;return w?typeof w.read=="function":!1}e.isReadable=y;function N(p){const w=p;return w?[w.on,w.pause,w.resume,w.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=N;function C(p){const w=p;return w?N(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=C;function R(p,w){return new S(p,w)}e.newWriteableStream=R;class S{constructor(w,s){this.e=w,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(s=>s(w))}h(w){this.c.error.length===0?(0,n.onUnexpectedError)(w):this.c.error.slice(0).forEach(s=>s(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,s){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(w,s){if(this.a.destroyed)return;let r;switch(w){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const a=r.indexOf(s);a>=0&&r.splice(a,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(p,w){const s=[];let r;for(;(r=p.read())!==null;)s.push(r);return w(s)}e.consumeReadable=k;function O(p,w,s){const r=[];let a;for(;(a=p.read())!==null&&r.length<s;)r.push(a);return a===null&&r.length>0?w(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return p.read()}}}e.peekReadable=O;function I(p,w){return new Promise((s,r)=>{const a=[];f(p,{onData:d=>{w&&a.push(d)},onError:d=>{w?r(d):s(void 0)},onEnd:()=>{s(w?w(a):void 0)}})})}e.consumeStream=I;function f(p,w){let s=!1;return p.on("error",r=>{s||w.onError(r)}),p.on("end",()=>{s||w.onEnd()}),p.on("data",r=>{s||w.onData(r)}),(0,T.toDisposable)(()=>s=!0)}e.listenStream=f;function v(p,w){return new Promise((s,r)=>{const a=new T.DisposableStore,d=[],c=m=>{if(d.push(m),d.length>w)return a.dispose(),p.pause(),s({stream:p,buffer:d,ended:!1})},u=m=>r(m),t=()=>s({stream:p,buffer:d,ended:!0});a.add((0,T.toDisposable)(()=>p.removeListener("error",u))),p.on("error",u),a.add((0,T.toDisposable)(()=>p.removeListener("end",t))),p.on("end",t),a.add((0,T.toDisposable)(()=>p.removeListener("data",c))),p.on("data",c)})}e.peekStream=v;function h(p,w){const s=R(w);return s.end(p),s}e.toStream=h;function i(){const p=R(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=i;function o(p){let w=!1;return{read:()=>w?null:(w=!0,p)}}e.toReadable=o;function l(p,w,s){const r=R(s);return f(p,{onData:a=>r.write(w.data(a)),onError:a=>r.error(w.error?w.error(a):a),onEnd:()=>r.end()}),r}e.transform=l;function E(p,w,s){let r=!1;return{read:()=>{const a=w.read();return r?a:(r=!0,a!==null?s([p,a]):p)}}}e.prefixedReadable=E;function b(p,w,s){let r=!1;const a=R(s);return f(w,{onData:d=>r?a.write(d):(r=!0,a.write(s([p,d]))),onError:d=>a.error(d),onEnd:()=>{r||(r=!0,a.write(p)),a.end()}}),a}e.prefixedStream=b}),define(De[24],Ce([1,0,110]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let y,N;class C{static alloc(m){return T?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return T&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,g){return!(g?.dontUseNodeBuffer||!1)&&T?new C(Buffer.from(m)):(y||(y=new TextEncoder),new C(y.encode(m)))}static fromByteArray(m){const g=C.alloc(m.length);for(let A=0,L=m.length;A<L;A++)g.buffer[A]=m[A];return g}static concat(m,g){if(typeof g>"u"){g=0;for(let K=0,q=m.length;K<q;K++)g+=m[K].byteLength}const A=C.alloc(g);let L=0;for(let K=0,q=m.length;K<q;K++){const j=m[K];A.set(j,L),L+=j.byteLength}return A}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=C.alloc(this.byteLength);return m.set(this),m}toString(){return T?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(m,g){return new C(this.buffer.subarray(m,g))}set(m,g){if(m instanceof C)this.buffer.set(m.buffer,g);else if(m instanceof Uint8Array)this.buffer.set(m,g);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),g);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return k(this.buffer,m)}writeUInt32BE(m,g){O(this.buffer,m,g)}readUInt32LE(m){return I(this.buffer,m)}writeUInt32LE(m,g){f(this.buffer,m,g)}readUInt8(m){return v(this.buffer,m)}writeUInt8(m,g){h(this.buffer,m,g)}}e.VSBuffer=C;function R(t,m){return t[m+0]<<0>>>0|t[m+1]<<8>>>0}e.readUInt16LE=R;function S(t,m,g){t[g+0]=m&255,m=m>>>8,t[g+1]=m&255}e.writeUInt16LE=S;function k(t,m){return t[m]*2**24+t[m+1]*2**16+t[m+2]*2**8+t[m+3]}e.readUInt32BE=k;function O(t,m,g){t[g+3]=m,m=m>>>8,t[g+2]=m,m=m>>>8,t[g+1]=m,m=m>>>8,t[g]=m}e.writeUInt32BE=O;function I(t,m){return t[m+0]<<0>>>0|t[m+1]<<8>>>0|t[m+2]<<16>>>0|t[m+3]<<24>>>0}e.readUInt32LE=I;function f(t,m,g){t[g+0]=m&255,m=m>>>8,t[g+1]=m&255,m=m>>>8,t[g+2]=m&255,m=m>>>8,t[g+3]=m&255}e.writeUInt32LE=f;function v(t,m){return t[m]}e.readUInt8=v;function h(t,m,g){t[g]=m}e.writeUInt8=h;function i(t){return n.consumeReadable(t,m=>C.concat(m))}e.readableToBuffer=i;function o(t){return n.toReadable(t)}e.bufferToReadable=o;function l(t){return n.consumeStream(t,m=>C.concat(m))}e.streamToBuffer=l;async function E(t){return t.ended?C.concat(t.buffer):C.concat([...t.buffer,await l(t.stream)])}e.bufferedStreamToBuffer=E;function b(t){return n.toStream(t,m=>C.concat(m))}e.bufferToStream=b;function p(t){return n.transform(t,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}e.streamToBufferReadableStream=p;function w(t){return n.newWriteableStream(m=>C.concat(m),t)}e.newWriteableBufferStream=w;function s(t,m){return n.prefixedReadable(t,m,g=>C.concat(g))}e.prefixedBufferReadable=s;function r(t,m){return n.prefixedStream(t,m,g=>C.concat(g))}e.prefixedBufferStream=r;function a(t){let m=0,g=0,A=0;const L=new Uint8Array(Math.floor(t.length/4*3)),K=j=>{switch(g){case 3:L[A++]=m|j,g=0;break;case 2:L[A++]=m|j>>>2,m=j<<6,g=3;break;case 1:L[A++]=m|j>>>4,m=j<<4,g=2;break;default:m=j<<2,g=1}};for(let j=0;j<t.length;j++){const P=t.charCodeAt(j);if(P>=65&&P<=90)K(P-65);else if(P>=97&&P<=122)K(P-97+26);else if(P>=48&&P<=57)K(P-48+52);else if(P===43||P===45)K(62);else if(P===47||P===95)K(63);else{if(P===61)break;throw new SyntaxError(`Unexpected base64 character ${t[j]}`)}}const q=A;for(;g>0;)K(0);return C.wrap(L).slice(0,q)}e.decodeBase64=a;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:t},m=!0,g=!1){const A=g?c:d;let L="";const K=t.byteLength%3;let q=0;for(;q<t.byteLength-K;q+=3){const j=t[q+0],P=t[q+1],M=t[q+2];L+=A[j>>>2],L+=A[(j<<4|P>>>4)&63],L+=A[(P<<2|M>>>6)&63],L+=A[M&63]}if(K===1){const j=t[q+0];L+=A[j>>>2],L+=A[j<<4&63],m&&(L+="==")}else if(K===2){const j=t[q+0],P=t[q+1];L+=A[j>>>2],L+=A[(j<<4|P>>>4)&63],L+=A[P<<2&63],m&&(L+="=")}return L}e.encodeBase64=u}),define(De[34],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(y){return n.test(y)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const N=new Uint8Array(16),C=[];for(let R=0;R<256;R++)C.push(R.toString(16).padStart(2,"0"));return function(){y(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let S=0,k="";return k+=C[N[S++]],k+=C[N[S++]],k+=C[N[S++]],k+=C[N[S++]],k+="-",k+=C[N[S++]],k+=C[N[S++]],k+="-",k+=C[N[S++]],k+=C[N[S++]],k+="-",k+=C[N[S++]],k+=C[N[S++]],k+="-",k+=C[N[S++]],k+=C[N[S++]],k+=C[N[S++]],k+=C[N[S++]],k+=C[N[S++]],k+=C[N[S++]],k}}()}),define(De[111],Ce([1,0,16,34]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function y(R){return{id:(0,T.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=y;function N(R,S,k){return{id:(0,T.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:S,data:k}),value:void 0}}e.createFileDataTransferItem=N;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,k){const O=this.a.get(S);O?O.push(k):this.a.set(this.b(S),[k])}replace(S,k){this.a.set(this.b(S),[k])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,k]of this.a.entries())for(const O of k)yield[S,O]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[k,O]of this.entries())S(O,k)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:R=>(0,n.distinct)(R.map(S=>S.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(S=>!S.startsWith("#"))})}),define(De[112],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[113],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class T{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let S=0,k=R.notIn.length;S<k;S++)switch(R.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,S){if(R.getTokenCount()===0)return!0;const k=R.findTokenIndexAtOffset(S-2),O=R.getStandardTokenType(k);return this.isOK(O)}g(R,S){for(let k=R;k<=S;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=T;class y{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of R)N(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),N(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),N(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),N(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&N(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=y;function N(C,R,S){C.has(R)?C.get(R).push(S):C.set(R,[S])}}),define(De[114],Ce([17,18]),function(te,e){return te.create("vs/base/common/date",e)}),define(De[115],Ce([1,0,114]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,y=T*60,N=y*24,C=N*7,R=N*30,S=N*365;function k(I,f,v){typeof I!="number"&&(I=I.getTime());const h=Math.round((new Date().getTime()-I)/1e3);if(h<-30)return(0,n.localize)(0,null,k(new Date().getTime()+h*1e3,!1));if(h<30)return(0,n.localize)(1,null);let i;return h<T?(i=h,f?i===1?v?(0,n.localize)(2,null,i):(0,n.localize)(3,null,i):v?(0,n.localize)(4,null,i):(0,n.localize)(5,null,i):i===1?v?(0,n.localize)(6,null,i):(0,n.localize)(7,null,i):v?(0,n.localize)(8,null,i):(0,n.localize)(9,null,i)):h<y?(i=Math.floor(h/T),f?i===1?v?(0,n.localize)(10,null,i):(0,n.localize)(11,null,i):v?(0,n.localize)(12,null,i):(0,n.localize)(13,null,i):i===1?v?(0,n.localize)(14,null,i):(0,n.localize)(15,null,i):v?(0,n.localize)(16,null,i):(0,n.localize)(17,null,i)):h<N?(i=Math.floor(h/y),f?i===1?v?(0,n.localize)(18,null,i):(0,n.localize)(19,null,i):v?(0,n.localize)(20,null,i):(0,n.localize)(21,null,i):i===1?v?(0,n.localize)(22,null,i):(0,n.localize)(23,null,i):v?(0,n.localize)(24,null,i):(0,n.localize)(25,null,i)):h<C?(i=Math.floor(h/N),f?i===1?(0,n.localize)(26,null,i):(0,n.localize)(27,null,i):i===1?(0,n.localize)(28,null,i):(0,n.localize)(29,null,i)):h<R?(i=Math.floor(h/C),f?i===1?v?(0,n.localize)(30,null,i):(0,n.localize)(31,null,i):v?(0,n.localize)(32,null,i):(0,n.localize)(33,null,i):i===1?v?(0,n.localize)(34,null,i):(0,n.localize)(35,null,i):v?(0,n.localize)(36,null,i):(0,n.localize)(37,null,i)):h<S?(i=Math.floor(h/R),f?i===1?v?(0,n.localize)(38,null,i):(0,n.localize)(39,null,i):v?(0,n.localize)(40,null,i):(0,n.localize)(41,null,i):i===1?v?(0,n.localize)(42,null,i):(0,n.localize)(43,null,i):v?(0,n.localize)(44,null,i):(0,n.localize)(45,null,i)):(i=Math.floor(h/S),f?i===1?v?(0,n.localize)(46,null,i):(0,n.localize)(47,null,i):v?(0,n.localize)(48,null,i):(0,n.localize)(49,null,i):i===1?v?(0,n.localize)(50,null,i):(0,n.localize)(51,null,i):v?(0,n.localize)(52,null,i):(0,n.localize)(53,null,i))}e.fromNow=k;function O(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(De[116],Ce([17,18]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(De[45],Ce([1,0,16,9,116]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(I,f){return f&&(I.stack||I.stacktrace)?y.localize(0,null,R(I),C(I.stack)||C(I.stacktrace)):R(I)}function C(I){return Array.isArray(I)?I.join(`
`):I}function R(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?y.localize(1,null,I.message):I.message||y.localize(2,null)}function S(I=null,f=!1){if(!I)return y.localize(3,null);if(Array.isArray(I)){const v=n.coalesce(I),h=S(v[0],f);return v.length>1?y.localize(4,null,h,v.length):h}if(T.isString(I))return I;if(I.detail){const v=I.detail;if(v.error)return N(v.error,f);if(v.exception)return N(v.exception,f)}return I.stack?N(I,f):I.message?I.message:y.localize(5,null)}e.toErrorMessage=S;function k(I){const f=I;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=k;function O(I,f){let v;return typeof I=="string"?v=new Error(I):v=I,v.actions=f,v}e.createErrorWithActions=O}),define(De[60],Ce([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(O){const I=(0,n.extname)(O),f=T[I.toLowerCase()];return f!==void 0?f:C(O)}e.getMediaOrTextMime=N;function C(O){const I=(0,n.extname)(O);return y[I.toLowerCase()]}e.getMediaMime=C;function R(O){for(const I in y)if(y[I]===O)return I}e.getExtensionForMimeType=R;const S=/^(.+)\/(.+?)(;.+)?$/;function k(O,I){const f=S.exec(O);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:I?void 0:O}e.normalizeMimeType=k}),define(De[39],Ce([1,0,19,21,10,9]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(c){return c===47||c===92}e.isPathSeparator=C;function R(c){return c.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=R;function S(c){return c.indexOf("/")===-1&&(c=R(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=S;function k(c,u=n.posix.sep){if(!c)return"";const t=c.length,m=c.charCodeAt(0);if(C(m)){if(C(c.charCodeAt(1))&&!C(c.charCodeAt(2))){let A=3;const L=A;for(;A<t&&!C(c.charCodeAt(A));A++);if(L!==A&&!C(c.charCodeAt(A+1))){for(A+=1;A<t;A++)if(C(c.charCodeAt(A)))return c.slice(0,A+1).replace(/[\\/]/g,u)}}return u}else if(l(m)&&c.charCodeAt(1)===58)return C(c.charCodeAt(2))?c.slice(0,2)+u:c.slice(0,2);let g=c.indexOf("://");if(g!==-1){for(g+=3;g<t;g++)if(C(c.charCodeAt(g)))return c.slice(0,g+1)}return""}e.getRoot=k;function O(c){if(!T.isWindows||!c||c.length<5)return!1;let u=c.charCodeAt(0);if(u!==92||(u=c.charCodeAt(1),u!==92))return!1;let t=2;const m=t;for(;t<c.length&&(u=c.charCodeAt(t),u!==92);t++);return!(m===t||(u=c.charCodeAt(t+1),isNaN(u)||u===92))}e.isUNC=O;const I=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(c,u=T.isWindows){const t=u?I:f;return!(!c||c.length===0||/^\s+$/.test(c)||(t.lastIndex=0,t.test(c))||u&&v.test(c)||c==="."||c===".."||u&&c[c.length-1]==="."||u&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=h;function i(c,u,t){const m=c===u;return!t||m?m:!c||!u?!1:(0,y.equalsIgnoreCase)(c,u)}e.isEqual=i;function o(c,u,t,m=n.sep){if(c===u)return!0;if(!c||!u||u.length>c.length)return!1;if(t){if(!(0,y.startsWithIgnoreCase)(c,u))return!1;if(u.length===c.length)return!0;let A=u.length;return u.charAt(u.length-1)===m&&A--,c.charAt(A)===m}return u.charAt(u.length-1)!==m&&(u+=m),c.indexOf(u)===0}e.isEqualOrParent=o;function l(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=l;function E(c,u){return T.isWindows&&c.endsWith(":")&&(c+=n.sep),(0,n.isAbsolute)(c)||(c=(0,n.join)(u,c)),c=(0,n.normalize)(c),T.isWindows?(c=(0,y.rtrim)(c,n.sep),c.endsWith(":")&&(c+=n.sep)):(c=(0,y.rtrim)(c,n.sep),c||(c=n.sep)),c}e.sanitizeFilePath=E;function b(c){const u=(0,n.normalize)(c);return T.isWindows?c.length>3?!1:p(u)&&(c.length===2||u.charCodeAt(2)===92):u===n.posix.sep}e.isRootOrDriveLetter=b;function p(c,u=T.isWindows){return u?l(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function w(c){return p(c)?c[0]:void 0}e.getDriveLetter=w;function s(c,u,t){return u.length>c.length?-1:c===u?0:(t&&(c=c.toLowerCase(),u=u.toLowerCase()),c.indexOf(u))}e.indexOfPath=s;function r(c){const u=c.split(":");let t,m,g;for(const A of u){const L=Number(A);(0,N.isNumber)(L)?m===void 0?m=L:g===void 0&&(g=L):t=t?[t,A].join(":"):A}if(!t)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:t,line:m!==void 0?m:void 0,column:g!==void 0?g:m!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function d(c,u,t=8){let m="";for(let A=0;A<t;A++)m+=a.charAt(Math.floor(Math.random()*a.length));let g;return u?g=`${u}-${m}`:g=m,c?(0,n.join)(c,g):g}e.randomPath=d}),define(De[117],Ce([1,0,28,10]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...J){return function(D,U){for(let H=0,G=J.length;H<G;H++){const ee=J[H](D,U);if(ee)return ee}return null}}e.or=y,e.matchesStrictPrefix=N.bind(void 0,!1),e.matchesPrefix=N.bind(void 0,!0);function N(J,D,U){if(!U||U.length<D.length)return null;let H;return J?H=T.startsWithIgnoreCase(U,D):H=U.indexOf(D)===0,H?D.length>0?[{start:0,end:D.length}]:[]:null}function C(J,D){const U=D.toLowerCase().indexOf(J.toLowerCase());return U===-1?null:[{start:U,end:U+J.length}]}e.matchesContiguousSubString=C;function R(J,D){return S(J.toLowerCase(),D.toLowerCase(),0,0)}e.matchesSubString=R;function S(J,D,U,H){if(U===J.length)return[];if(H===D.length)return null;if(J[U]===D[H]){let G=null;return(G=S(J,D,U+1,H+1))?l({start:H,end:H+1},G):null}return S(J,D,U,H+1)}function k(J){return 97<=J&&J<=122}function O(J){return 65<=J&&J<=90}e.isUpper=O;function I(J){return 48<=J&&J<=57}function f(J){return J===32||J===9||J===10||J===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>v.add(J.charCodeAt(0)));function h(J){return f(J)||v.has(J)}function i(J,D){return J===D||h(J)&&h(D)}function o(J){return k(J)||O(J)||I(J)}function l(J,D){return D.length===0?D=[J]:J.end===D[0].start?D[0].start=J.start:D.unshift(J),D}function E(J,D){for(let U=D;U<J.length;U++){const H=J.charCodeAt(U);if(O(H)||I(H)||U>0&&!o(J.charCodeAt(U-1)))return U}return J.length}function b(J,D,U,H){if(U===J.length)return[];if(H===D.length)return null;if(J[U]!==D[H].toLowerCase())return null;{let G=null,ee=H+1;for(G=b(J,D,U+1,H+1);!G&&(ee=E(D,ee))<D.length;)G=b(J,D,U+1,ee),ee++;return G===null?null:l({start:H,end:H+1},G)}}function p(J){let D=0,U=0,H=0,G=0,ee=0;for(let be=0;be<J.length;be++)ee=J.charCodeAt(be),O(ee)&&D++,k(ee)&&U++,o(ee)&&H++,I(ee)&&G++;const de=D/J.length,ye=U/J.length,se=H/J.length,ve=G/J.length;return{upperPercent:de,lowerPercent:ye,alphaPercent:se,numericPercent:ve}}function w(J){const{upperPercent:D,lowerPercent:U}=J;return U===0&&D>.6}function s(J){const{upperPercent:D,lowerPercent:U,alphaPercent:H,numericPercent:G}=J;return U>.2&&D<.8&&H>.6&&G<.2}function r(J){let D=0,U=0,H=0,G=0;for(let ee=0;ee<J.length;ee++)H=J.charCodeAt(ee),O(H)&&D++,k(H)&&U++,f(H)&&G++;return(D===0||U===0)&&G===0?J.length<=30:D<=5}function a(J,D){if(!D||(D=D.trim(),D.length===0)||!r(J)||D.length>60)return null;const U=p(D);if(!s(U)){if(!w(U))return null;D=D.toLowerCase()}let H=null,G=0;for(J=J.toLowerCase();G<D.length&&(H=b(J,D,0,G))===null;)G=E(D,G+1);return H}e.matchesCamelCase=a;function d(J,D,U=!1){if(!D||D.length===0)return null;let H=null,G=0;for(J=J.toLowerCase(),D=D.toLowerCase();G<D.length&&(H=c(J,D,0,G,U))===null;)G=u(D,G+1);return H}e.matchesWords=d;function c(J,D,U,H,G){if(U===J.length)return[];if(H===D.length)return null;if(i(J.charCodeAt(U),D.charCodeAt(H))){let ee=null,de=H+1;if(ee=c(J,D,U+1,H+1,G),!G)for(;!ee&&(de=u(D,de))<D.length;)ee=c(J,D,U+1,de,G),de++;return ee?J.charCodeAt(U)!==D.charCodeAt(H)?ee:l({start:H,end:H+1},ee):null}else return null}function u(J,D){for(let U=D;U<J.length;U++)if(h(J.charCodeAt(U))||U>0&&h(J.charCodeAt(U-1)))return U;return J.length}const t=y(e.matchesPrefix,a,C),m=y(e.matchesPrefix,a,R),g=new n.LRUCache(1e4);function A(J,D,U=!1){if(typeof J!="string"||typeof D!="string")return null;let H=g.get(J);H||(H=new RegExp(T.convertSimple2RegExpPattern(J),"i"),g.set(J,H));const G=H.exec(D);return G?[{start:G.index,end:G.index+G[0].length}]:U?m(J,D):t(J,D)}e.matchesFuzzy=A;function L(J,D){const U=We(J,J.toLowerCase(),0,D,D.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?q(U):null}e.matchesFuzzy2=L;function K(J,D,U,H,G,ee){const de=Math.min(13,J.length);for(;U<de;U++){const ye=We(J,D,U,H,G,ee,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ye)return ye}return[0,ee]}e.anyScore=K;function q(J){if(typeof J>"u")return[];const D=[],U=J[1];for(let H=J.length-1;H>1;H--){const G=J[H]+U,ee=D[D.length-1];ee&&ee.end===G?ee.end=G+1:D.push({start:G,end:G+1})}return D}e.createMatches=q;const j=128;function P(){const J=[],D=[];for(let U=0;U<=j;U++)D[U]=0;for(let U=0;U<=j;U++)J.push(D.slice(0));return J}function M(J){const D=[];for(let U=0;U<=J;U++)D[U]=0;return D}const F=M(2*j),$=M(2*j),z=P(),V=P(),X=P(),Z=!1;function fe(J,D,U,H,G){function ee(ye,se,ve=" "){for(;ye.length<se;)ye=ve+ye;return ye}let de=` |   |${H.split("").map(ye=>ee(ye,3)).join("|")}
`;for(let ye=0;ye<=U;ye++)ye===0?de+=" |":de+=`${D[ye-1]}|`,de+=J[ye].slice(0,G+1).map(se=>ee(se.toString(),3)).join("|")+`
`;return de}function oe(J,D,U,H){J=J.substr(D),U=U.substr(H),console.log(fe(V,J,J.length,U,U.length)),console.log(fe(X,J,J.length,U,U.length)),console.log(fe(z,J,J.length,U,U.length))}function le(J,D){if(D<0||D>=J.length)return!1;const U=J.codePointAt(D);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(U)}}function ce(J,D){if(D<0||D>=J.length)return!1;switch(J.charCodeAt(D)){case 32:case 9:return!0;default:return!1}}function me(J,D,U){return D[J]!==U[J]}function Y(J,D,U,H,G,ee,de=!1){for(;D<U&&G<ee;)J[D]===H[G]&&(de&&(F[D]=G),D+=1),G+=1;return D===U}e.isPatternInWord=Y;var pe;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var we;(function(J){J.Default=[-100,0];function D(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}J.isDefault=D})(we=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(D,U){this.firstMatchCanBeWeak=D,this.boostFullMatch=U}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function We(J,D,U,H,G,ee,de=Fe.default){const ye=J.length>j?j:J.length,se=H.length>j?j:H.length;if(U>=ye||ee>=se||ye-U>se-ee||!Y(D,U,ye,G,ee,se,!0))return;Xe(ye,se,U,ee,D,G);let ve=1,be=1,$e=U,He=ee;const tt=[!1];for(ve=1,$e=U;$e<ye;ve++,$e++){const nt=F[$e],Le=$[$e],lt=$e+1<ye?$[$e+1]:se;for(be=nt-ee+1,He=nt;He<lt;be++,He++){let _=Number.MIN_SAFE_INTEGER,Q=!1;He<=Le&&(_=Pe(J,D,$e,U,H,G,He,se,ee,z[ve-1][be-1]===0,tt));let ue=0;_!==Number.MAX_SAFE_INTEGER&&(Q=!0,ue=_+V[ve-1][be-1]);const Ue=He>nt,Ne=Ue?V[ve][be-1]+(z[ve][be-1]>0?-5:0):0,_e=He>nt+1&&z[ve][be-1]>0,Je=_e?V[ve][be-2]+(z[ve][be-2]>0?-5:0):0;if(_e&&(!Ue||Je>=Ne)&&(!Q||Je>=ue))V[ve][be]=Je,X[ve][be]=3,z[ve][be]=0;else if(Ue&&(!Q||Ne>=ue))V[ve][be]=Ne,X[ve][be]=2,z[ve][be]=0;else if(Q)V[ve][be]=ue,X[ve][be]=1,z[ve][be]=z[ve-1][be-1]+1;else throw new Error("not possible")}}if(Z&&oe(J,U,H,ee),!tt[0]&&!de.firstMatchCanBeWeak)return;ve--,be--;const Ge=[V[ve][be],ee];let et=0,it=0;for(;ve>=1;){let nt=be;do{const Le=X[ve][nt];if(Le===3)nt=nt-2;else if(Le===2)nt=nt-1;else break}while(nt>=1);et>1&&D[U+ve-1]===G[ee+be-1]&&!me(nt+ee-1,H,G)&&et+1>z[ve][nt]&&(nt=be),nt===be?et++:et=1,it||(it=nt),ve--,be=nt-1,Ge.push(be)}se===ye&&de.boostFullMatch&&(Ge[0]+=2);const ct=it-ye;return Ge[0]-=ct,Ge}e.fuzzyScore=We;function Xe(J,D,U,H,G,ee){let de=J-1,ye=D-1;for(;de>=U&&ye>=H;)G[de]===ee[ye]&&($[de]=ye,de--),ye--}function Pe(J,D,U,H,G,ee,de,ye,se,ve,be){if(D[U]!==ee[de])return Number.MIN_SAFE_INTEGER;let $e=1,He=!1;return de===U-H?$e=J[U]===G[de]?7:5:me(de,G,ee)&&(de===0||!me(de-1,G,ee))?($e=J[U]===G[de]?7:5,He=!0):le(ee,de)&&(de===0||!le(ee,de-1))?$e=5:(le(ee,de-1)||ce(ee,de-1))&&($e=5,He=!0),$e>1&&U===H&&(be[0]=!0),He||(He=me(de,G,ee)||le(ee,de-1)||ce(ee,de-1)),U===H?de>se&&($e-=He?3:5):ve?$e+=He?2:0:$e+=He?0:1,de+1===ye&&($e-=He?3:5),$e}function Ie(J,D,U,H,G,ee,de){return re(J,D,U,H,G,ee,!0,de)}e.fuzzyScoreGracefulAggressive=Ie;function ke(J,D,U,H,G,ee,de){return re(J,D,U,H,G,ee,!1,de)}e.fuzzyScoreGraceful=ke;function re(J,D,U,H,G,ee,de,ye){let se=We(J,D,U,H,G,ee,ye);if(se&&!de)return se;if(J.length>=3){const ve=Math.min(7,J.length-1);for(let be=U+1;be<ve;be++){const $e=ae(J,be);if($e){const He=We($e,$e.toLowerCase(),U,H,G,ee,ye);He&&(He[0]-=3,(!se||He[0]>se[0])&&(se=He))}}}return se}function ae(J,D){if(D+1>=J.length)return;const U=J[D],H=J[D+1];if(U!==H)return J.slice(0,D)+H+U+J.slice(D+2)}}),define(De[118],Ce([1,0,119,117,10]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const N="$(",C=new RegExp(`\\$\\(${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(n.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${C.source}`,"g");function k(l){return l.replace(S,(E,b)=>b?E:`\\${E}`)}e.escapeIcons=k;const O=new RegExp(`\\\\${C.source}`,"g");function I(l){return l.replace(O,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=I;const f=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function v(l){return l.indexOf(N)===-1?l:l.replace(f,(E,b,p,w)=>p?E:b||w||"")}e.stripIcons=v;function h(l){const E=l.indexOf(N);return E===-1?{text:l}:i(l,E)}e.parseLabelWithIcons=h;function i(l,E){const b=[];let p="";function w(m){if(m){p+=m;for(const g of m)b.push(a)}}let s=-1,r="",a=0,d,c,u=E;const t=l.length;for(w(l.substr(0,E));u<t;)d=l[u],c=l[u+1],d===N[0]&&c===N[1]?(s=u,w(r),r=N,u++):d===")"&&s!==-1?(a+=u-s+1,s=-1,r=""):s!==-1?R.test(d)?r+=d:(w(r),s=-1,r=""):w(d),u++;return w(r),{text:p,iconOffsets:b}}function o(l,E,b=!1){const{text:p,iconOffsets:w}=E;if(!w||w.length===0)return(0,T.matchesFuzzy)(l,p,b);const s=(0,y.ltrim)(p," "),r=p.length-s.length,a=(0,T.matchesFuzzy)(l,s,b);if(a)for(const d of a){const c=w[d.start+r]+r;d.start+=c,d.end+=c}return a}e.matchesFuzzyIconAware=o}),define(De[29],Ce([1,0,10]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(T||(T={})),function(y){const N="error",C="warning",R="warn",S="info",k="ignore";function O(f){return f?n.equalsIgnoreCase(N,f)?y.Error:n.equalsIgnoreCase(C,f)||n.equalsIgnoreCase(R,f)?y.Warning:n.equalsIgnoreCase(S,f)?y.Info:y.Ignore:y.Ignore}y.fromValue=O;function I(f){switch(f){case y.Error:return N;case y.Warning:return C;case y.Info:return S;default:return k}}y.toString=I}(T||(T={})),e.default=T}),define(De[46],Ce([1,0,16,10]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const h=v.charCodeAt(0),i=this.b.charCodeAt(this.c);return h-i}value(){return this.b[this.c]}}e.StringIterator=y;class N{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,T.compareSubstring)(v,this.b,0,v.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=N;class C{constructor(v=!0,h=!0){this.f=v,this.g=h}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let h=v.length-1;h>=0;h--,this.c--){const i=this.b.charCodeAt(h);if(!(i===47||this.f&&i===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,T.compareSubstring)(v,this.b,0,v.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var R;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(v,h){this.f=v,this.g=h,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(v,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,T.compare)(v,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(O||(O={}));class I{static forUris(v=()=>!1,h=()=>!1){return new I(new S(v,h))}static forPaths(v=!1){return new I(new C(void 0,!v))}static forStrings(){return new I(new y)}static forConfigKeys(){return new I(new N)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,h){if(h){const i=h.slice(0);(0,n.shuffle)(i);for(const o of i)this.set(o,v)}else{const i=v.slice(0);(0,n.shuffle)(i);for(const o of i)this.set(o[0],o[1])}}set(v,h){const i=this.b.reset(v);let o;this.c||(this.c=new k,this.c.segment=i.value());const l=[];for(o=this.c;;){const b=i.cmp(o.segment);if(b>0)o.left||(o.left=new k,o.left.segment=i.value()),l.push([-1,o]),o=o.left;else if(b<0)o.right||(o.right=new k,o.right.segment=i.value()),l.push([1,o]),o=o.right;else if(i.hasNext())i.next(),o.mid||(o.mid=new k,o.mid.segment=i.value()),l.push([0,o]),o=o.mid;else break}const E=o.value;o.value=h,o.key=v;for(let b=l.length-1;b>=0;b--){const p=l[b][1];p.updateHeight();const w=p.balanceFactor();if(w<-1||w>1){const s=l[b][0],r=l[b+1][0];if(s===1&&r===1)l[b][1]=p.rotateLeft();else if(s===-1&&r===-1)l[b][1]=p.rotateRight();else if(s===1&&r===-1)p.right=l[b+1][1]=l[b+1][1].rotateRight(),l[b][1]=p.rotateLeft();else if(s===-1&&r===1)p.left=l[b+1][1]=l[b+1][1].rotateLeft(),l[b][1]=p.rotateRight();else throw new Error;if(b>0)switch(l[b-1][0]){case-1:l[b-1][1].left=l[b][1];break;case 1:l[b-1][1].right=l[b][1];break;case 0:l[b-1][1].mid=l[b][1];break}else this.c=l[0][1]}}return E}get(v){return this.d(v)?.value}d(v){const h=this.b.reset(v);let i=this.c;for(;i;){const o=h.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(h.hasNext())h.next(),i=i.mid;else break}return i}has(v){const h=this.d(v);return!(h?.value===void 0&&h?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,h){const i=this.b.reset(v),o=[];let l=this.c;for(;l;){const E=i.cmp(l.segment);if(E>0)o.push([-1,l]),l=l.left;else if(E<0)o.push([1,l]),l=l.right;else if(i.hasNext())i.next(),o.push([0,l]),l=l.mid;else break}if(!!l){if(h?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const E=this.f(l.right);if(E.key){const{key:b,value:p,segment:w}=E;this.e(E.key,!1),l.key=b,l.value=p,l.segment=w}}else{const E=l.left??l.right;if(o.length>0){const[b,p]=o[o.length-1];switch(b){case-1:p.left=E;break;case 0:p.mid=E;break;case 1:p.right=E;break}}else this.c=E}for(let E=o.length-1;E>=0;E--){const b=o[E][1];b.updateHeight();const p=b.balanceFactor();if(p>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),o[E][1]=b.rotateLeft()):p<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),o[E][1]=b.rotateRight()),E>0)switch(o[E-1][0]){case-1:o[E-1][1].left=o[E][1];break;case 1:o[E-1][1].right=o[E][1];break;case 0:o[E-1][1].mid=o[E][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const h=this.b.reset(v);let i=this.c,o;for(;i;){const l=h.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(h.hasNext())h.next(),o=i.value||o,i=i.mid;else break}return i&&i.value||o}findSuperstr(v){const h=this.b.reset(v);let i=this.c;for(;i;){const o=h.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(h.hasNext())h.next(),i=i.mid;else return i.mid?this.g(i.mid):void 0}}forEach(v){for(const[h,i]of this)v(i,h)}*[Symbol.iterator](){yield*this.g(this.c)}g(v){const h=[];return this.h(v,h),h[Symbol.iterator]()}h(v,h){!v||(v.left&&this.h(v.left,h),v.value&&h.push([v.key,v.value]),v.mid&&this.h(v.mid,h),v.right&&this.h(v.right,h))}_isBalanced(){const v=h=>{if(!h)return!0;const i=h.balanceFactor();return i<-1||i>1?!1:v(h.left)&&v(h.right)};return v(this.c)}}e.TernarySearchTree=I}),define(De[80],Ce([1,0,24,10,2]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(k){return JSON.stringify(k,R)}e.stringify=N;function C(k){let O=JSON.parse(k);return O=S(O),O}e.parse=C;function R(k,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,T.regExpFlags)(O)}:O}function S(k,O=0){if(!k||O>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return y.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof n.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let I=0;I<k.length;++I)k[I]=S(k[I],O+1);else for(const I in k)Object.hasOwnProperty.call(k,I)&&(k[I]=S(k[I],O+1))}return k}e.revive=S}),define(De[13],Ce([1,0,21,2]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(k){this.d=k}setDelegate(k){this.e=k}setServerRootPath(k){this.f=`${k}/${y.vscodeRemoteResource}`}set(k,O,I){this.a[k]=O,this.b[k]=I}setConnectionToken(k,O){this.c[k]=O}getPreferredWebSchema(){return this.d}rewrite(k){if(this.e)return this.e(k);const O=k.authority;let I=this.a[O];I&&I.indexOf(":")!==-1&&I.indexOf("[")===-1&&(I=`[${I}]`);const f=this.b[O],v=this.c[O];let h=`path=${encodeURIComponent(k.path)}`;return typeof v=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),T.URI.from({scheme:n.isWeb?this.d:y.vscodeRemoteResource,authority:`${I}:${f}`,path:this.f,query:h})}}e.RemoteAuthorities=new N,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(k){const O=this.b(k,te);return this.uriToBrowserUri(O)}uriToBrowserUri(k){return k.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===y.file&&(n.isNative||n.isWebWorker&&n.globals.origin===`${y.vscodeFileResource}://${C.a}`)?k.with({scheme:y.vscodeFileResource,authority:k.authority||C.a,query:null,fragment:null}):k}asFileUri(k){const O=this.b(k,te);return this.uriToFileUri(O)}uriToFileUri(k){return k.scheme===y.vscodeFileResource?k.with({scheme:y.file,authority:k.authority!==C.a?k.authority:null,query:null,fragment:null}):k}b(k,O){return T.URI.isUri(k)?k:T.URI.parse(O.toUrl(k))}}C.a="vscode-app",e.FileAccess=new C;var R;(function(S){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(k.get("3"));const O="vscode-coi";function I(v){let h;typeof v=="string"?h=new URL(v).searchParams:v instanceof URL?h=v.searchParams:T.URI.isUri(v)&&(h=new URL(v.toString(!0)).searchParams);const i=h?.get(O);if(!!i)return k.get(i)}S.getHeadersFromQuery=I;function f(v,h,i){if(!globalThis.crossOriginIsolated)return;const o=h&&i?"3":i?"2":"1";v instanceof URLSearchParams?v.set(O,o):v[O]=o}S.addSearchParam=f})(R=e.COI||(e.COI={}))}),define(De[22],Ce([1,0,39,13,19,21,10,2]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(v){return(0,R.uriToFsPath)(v,!0)}e.originalFSPath=S;class k{constructor(h){this.a=h}compare(h,i,o=!1){return h===i?0:(0,C.compare)(this.getComparisonKey(h,o),this.getComparisonKey(i,o))}isEqual(h,i,o=!1){return h===i?!0:!h||!i?!1:this.getComparisonKey(h,o)===this.getComparisonKey(i,o)}getComparisonKey(h,i=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,i,o=!1){if(h.scheme===i.scheme){if(h.scheme===T.Schemas.file)return n.isEqualOrParent(S(h),S(i),this.a(h))&&h.query===i.query&&(o||h.fragment===i.fragment);if((0,e.isEqualAuthority)(h.authority,i.authority))return n.isEqualOrParent(h.path,i.path,this.a(h),"/")&&h.query===i.query&&(o||h.fragment===i.fragment)}return!1}joinPath(h,...i){return R.URI.joinPath(h,...i)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let i;return h.scheme===T.Schemas.file?i=R.URI.file(y.dirname(S(h))).path:(i=y.posix.dirname(h.path),h.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),i="/")),h.with({path:i})}normalizePath(h){if(!h.path.length)return h;let i;return h.scheme===T.Schemas.file?i=R.URI.file(y.normalize(S(h))).path:i=y.posix.normalize(h.path),h.with({path:i})}relativePath(h,i){if(h.scheme!==i.scheme||!(0,e.isEqualAuthority)(h.authority,i.authority))return;if(h.scheme===T.Schemas.file){const E=y.relative(S(h),S(i));return N.isWindows?n.toSlashes(E):E}let o=h.path||"/";const l=i.path||"/";if(this.a(h)){let E=0;for(const b=Math.min(o.length,l.length);E<b&&!(o.charCodeAt(E)!==l.charCodeAt(E)&&o.charAt(E).toLowerCase()!==l.charAt(E).toLowerCase());E++);o=l.substr(0,E)+o.substr(E)}return y.posix.relative(o,l)}resolvePath(h,i){if(h.scheme===T.Schemas.file){const o=R.URI.file(y.resolve(S(h),i));return h.with({authority:o.authority,path:o.path})}return i=n.toPosixPath(i),h.with({path:y.posix.resolve(h.path,i)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,i){return h===i||h!==void 0&&i!==void 0&&(0,C.equalsIgnoreCase)(h,i)}hasTrailingPathSeparator(h,i=y.sep){if(h.scheme===T.Schemas.file){const o=S(h);return o.length>n.getRoot(o).length&&o[o.length-1]===i}else{const o=h.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,i=y.sep){return(0,e.hasTrailingPathSeparator)(h,i)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,i=y.sep){let o=!1;if(h.scheme===T.Schemas.file){const l=S(h);o=l!==void 0&&l.length===n.getRoot(l).length&&l[l.length-1]===i}else{i="/";const l=h.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(h,i)?h.with({path:h.path+"/"}):h}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(v=>v.scheme===T.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new k(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(v,h){const i=[];for(let o=0;o<v.length;o++){const l=h(v[o]);v.some((E,b)=>b===o?!1:(0,e.isEqualOrParent)(l,h(E)))||i.push(v[o])}return i}e.distinctParents=O;var I;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(i){const o=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(b=>{const[p,w]=b.split(":");p&&w&&o.set(p,w)});const E=i.path.substring(0,i.path.indexOf(";"));return E&&o.set(v.META_DATA_MIME,E),o}v.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function f(v,h,i){if(h){let o=v.path;return o&&o[0]!==y.posix.sep&&(o=y.posix.sep+o),v.with({scheme:i,authority:h,path:o})}return v.with({scheme:i})}e.toLocalResource=f}),define(De[15],Ce([1,0,20,11,5,7,22,21]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(me){return!!me&&typeof me.then=="function"}e.isThenable=S;function k(me){const Y=new n.CancellationTokenSource,pe=me(Y.token),we=new Promise((Fe,We)=>{const Xe=Y.token.onCancellationRequested(()=>{Xe.dispose(),Y.dispose(),We(new T.CancellationError)});Promise.resolve(pe).then(Pe=>{Xe.dispose(),Y.dispose(),Fe(Pe)},Pe=>{Xe.dispose(),Y.dispose(),We(Pe)})});return new class{cancel(){Y.cancel()}then(Fe,We){return we.then(Fe,We)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return we.finally(Fe)}}}e.createCancelablePromise=k;function O(me,Y,pe){return new Promise((we,Fe)=>{const We=Y.onCancellationRequested(()=>{We.dispose(),we(pe)});me.then(we,Fe).finally(()=>We.dispose())})}e.raceCancellation=O;function I(me,Y){return new Promise((pe,we)=>{const Fe=Y.onCancellationRequested(()=>{Fe.dispose(),we(new T.CancellationError)});me.then(pe,we).finally(()=>Fe.dispose())})}e.raceCancellationError=I;async function f(me){let Y=-1;const pe=me.map((Fe,We)=>Fe.then(Xe=>(Y=We,Xe))),we=await Promise.race(pe);return me.forEach((Fe,We)=>{We!==Y&&Fe.cancel()}),we}e.raceCancellablePromises=f;function v(me,Y,pe){let we;const Fe=setTimeout(()=>{we?.(void 0),pe?.()},Y);return Promise.race([me.finally(()=>clearTimeout(Fe)),new Promise(We=>we=We)])}e.raceTimeout=v;function h(me){return new Promise((Y,pe)=>{const we=me();S(we)?we.then(Y,pe):Y(we)})}e.asPromise=h;class i{constructor(){this.a=null,this.b=null,this.d=null}queue(Y){if(this.a){if(this.d=Y,!this.b){const pe=()=>{this.b=null;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(pe,pe).then(we)})}return new Promise((pe,we)=>{this.b.then(pe,we)})}return this.a=Y(),new Promise((pe,we)=>{this.a.then(Fe=>{this.a=null,pe(Fe)},Fe=>{this.a=null,we(Fe)})})}}e.Throttler=i;class o{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.Sequencer=o;class l{constructor(){this.a=new Map}queue(Y,pe){const Fe=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.a.get(Y)===Fe&&this.a.delete(Y)});return this.a.set(Y,Fe),Fe}}e.SequencerByKey=l;const E=(me,Y)=>{let pe=!0;const we=setTimeout(()=>{pe=!1,Y()},me);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(we),pe=!1}}},b=me=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,me())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,pe=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((Fe,We)=>{this.d=Fe,this.f=We}).then(()=>{if(this.b=null,this.d=null,this.g){const Fe=this.g;return this.g=null,Fe()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=pe===e.MicrotaskDelay?b(we):E(pe,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class w{constructor(Y){this.a=new p(Y),this.b=new i}trigger(Y,pe){return this.a.trigger(()=>this.b.queue(Y),pe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class s{constructor(){this.a=!1,this.b=new Promise((Y,pe)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function a(me,Y){return Y?new Promise((pe,we)=>{const Fe=setTimeout(()=>{We.dispose(),pe()},me),We=Y.onCancellationRequested(()=>{clearTimeout(Fe),We.dispose(),we(new T.CancellationError)})}):k(pe=>a(me,pe))}e.timeout=a;function d(me,Y=0){const pe=setTimeout(me,Y);return(0,N.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=d;function c(me){const Y=[];let pe=0;const we=me.length;function Fe(){return pe<we?me[pe++]():null}function We(Xe){Xe!=null&&Y.push(Xe);const Pe=Fe();return Pe?Pe.then(We):Promise.resolve(Y)}return Promise.resolve(null).then(We)}e.sequence=c;function u(me,Y=we=>!!we,pe=null){let we=0;const Fe=me.length,We=()=>{if(we>=Fe)return Promise.resolve(pe);const Xe=me[we++];return Promise.resolve(Xe()).then(Ie=>Y(Ie)?Promise.resolve(Ie):We())};return We()}e.first=u;function t(me,Y=we=>!!we,pe=null){if(me.length===0)return Promise.resolve(pe);let we=me.length;const Fe=()=>{we=-1;for(const We of me)We.cancel?.()};return new Promise((We,Xe)=>{for(const Pe of me)Pe.then(Ie=>{--we>=0&&Y(Ie)?(Fe(),We(Ie)):we===0&&We(pe)}).catch(Ie=>{--we>=0&&(Fe(),Xe(Ie))})})}e.firstParallel=t;class m{constructor(Y){this.a=0,this.d=Y,this.f=[],this.b=0,this.g=new y.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Y){return this.a++,new Promise((pe,we)=>{this.f.push({factory:Y,c:pe,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Y=this.f.shift();this.b++;const pe=Y.factory();pe.then(Y.c,Y.e),pe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=m;class g extends m{constructor(){super(1)}}e.Queue=g;class A{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Y=new X;return this.b.add(Y),Y.p}d(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueFor(Y,pe=C.extUri){const we=pe.getComparisonKey(Y);let Fe=this.a.get(we);return Fe||(Fe=new g,y.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(we),this.f()}),this.a.set(we,Fe)),Fe}f(){!this.d()||this.g()}g(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.g()}}e.ResourceQueue=A;class L{constructor(Y,pe){this.a=-1,typeof Y=="function"&&typeof pe=="number"&&this.setIfNotSet(Y,pe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,pe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},pe)}setIfNotSet(Y,pe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},pe))}}e.TimeoutTimer=L;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Y,pe){this.cancel(),this.a=setInterval(()=>{Y()},pe)}}e.IntervalTimer=K;class q{constructor(Y,pe){this.b=-1,this.a=Y,this.d=pe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=q;class j{constructor(Y,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.a=Y,this.b=pe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=j;class P extends q{constructor(Y,pe){super(Y,pe),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=P;class M extends N.Disposable{constructor(Y,pe){super(),this.g=Y,this.h=pe,this.a=[],this.b=this.B(new N.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...Y),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=me=>{(0,R.setTimeout0)(()=>{if(Y)return;const pe=Date.now()+15;me(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(me,Y)=>{const pe=requestIdleCallback(me,typeof Y=="number"?{timeout:Y}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(pe))}}}}();class F{constructor(Y){this.d=!1,this.a=()=>{try{this.f=Y()}catch(pe){this.g=pe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function $(me,Y,pe){let we;for(let Fe=0;Fe<pe;Fe++)try{return await me()}catch(We){we=We,await a(Y)}throw we}e.retry=$;class z{hasPending(Y){return this.a?typeof Y=="number"?this.a.taskId===Y:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Y,pe,we){return this.a={taskId:Y,cancel:()=>we?.(),promise:pe},pe.then(()=>this.d(Y),()=>this.d(Y)),pe}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this.b)this.b.run=Y;else{let pe,we;const Fe=new Promise((We,Xe)=>{pe=We,we=Xe});this.b={run:Y,promise:Fe,promiseResolve:pe,promiseReject:we}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class V{constructor(Y,pe=()=>Date.now()){this.d=Y,this.f=pe,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.IntervalCounter=V;class X{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Y,pe)=>{this.a=Y,this.b=pe})}complete(Y){return new Promise(pe=>{this.a(Y),this.f=!0,pe()})}error(Y){return new Promise(pe=>{this.b(Y),this.d=!0,pe()})}cancel(){new Promise(Y=>{this.b(new T.CancellationError),this.d=!0,Y()})}}e.DeferredPromise=X;var Z;(function(me){async function Y(we){let Fe;const We=await Promise.all(we.map(Xe=>Xe.then(Pe=>Pe,Pe=>{Fe||(Fe=Pe)})));if(typeof Fe<"u")throw Fe;return We}me.settled=Y;function pe(we){return new Promise(async(Fe,We)=>{try{await we(Fe,We)}catch(Xe){We(Xe)}})}me.withAsyncBody=pe})(Z=e.Promises||(e.Promises={}));var fe;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(fe||(fe={}));class oe{static fromArray(Y){return new oe(pe=>{pe.emitMany(Y)})}static fromPromise(Y){return new oe(async pe=>{pe.emitMany(await Y)})}static fromPromises(Y){return new oe(async pe=>{await Promise.all(Y.map(async we=>pe.emitOne(await we)))})}static merge(Y){return new oe(async pe=>{await Promise.all(Y.map(async we=>{for await(const Fe of we)pe.emitOne(Fe)}))})}constructor(Y){this.a=0,this.b=[],this.d=null,this.f=new y.Emitter,queueMicrotask(async()=>{const pe={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(Y(pe)),this.j()}catch(we){this.k(we)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(Y,pe){return new oe(async we=>{for await(const Fe of Y)we.emitOne(pe(Fe))})}map(Y){return oe.map(this,Y)}static filter(Y,pe){return new oe(async we=>{for await(const Fe of Y)pe(Fe)&&we.emitOne(Fe)})}filter(Y){return oe.filter(this,Y)}static coalesce(Y){return oe.filter(Y,pe=>!!pe)}coalesce(){return oe.coalesce(this)}static async toPromise(Y){const pe=[];for await(const we of Y)pe.push(we);return pe}toPromise(){return oe.toPromise(this)}g(Y){this.a===0&&(this.b.push(Y),this.f.fire())}h(Y){this.a===0&&(this.b=this.b.concat(Y),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Y){this.a===0&&(this.a=2,this.d=Y,this.f.fire())}}e.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class le extends oe{constructor(Y,pe){super(pe),this.l=Y}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=le;function ce(me){const Y=new n.CancellationTokenSource,pe=me(Y.token);return new le(Y,async we=>{const Fe=Y.token.onCancellationRequested(()=>{Fe.dispose(),Y.dispose(),we.reject(new T.CancellationError)});try{for await(const We of pe){if(Y.token.isCancellationRequested)return;we.emitOne(We)}Fe.dispose(),Y.dispose()}catch(We){Fe.dispose(),Y.dispose(),we.reject(We)}})}e.createCancelableAsyncIterable=ce}),define(De[120],Ce([1,0,15,19]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new n.IdleValue(()=>{const g=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:g,collatorIsNumeric:g.resolvedOptions().numeric}}),N=new n.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new n.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(g,A,L=!1){const K=g||"",q=A||"",j=y.value.collator.compare(K,q);return y.value.collatorIsNumeric&&j===0&&K!==q?K<q?-1:1:j}e.compareFileNames=R;function S(g,A){const L=N.value.collator;return g=g||"",A=A||"",w(L,g,A)}e.compareFileNamesDefault=S;function k(g,A){const L=N.value.collator;return g=g||"",A=A||"",d(g,A)||w(L,g,A)}e.compareFileNamesUpper=k;function O(g,A){const L=N.value.collator;return g=g||"",A=A||"",a(g,A)||w(L,g,A)}e.compareFileNamesLower=O;function I(g,A){return g=g||"",A=A||"",g===A?0:g<A?-1:1}e.compareFileNamesUnicode=I;function f(g,A,L=!1){L||(g=g&&g.toLowerCase(),A=A&&A.toLowerCase());const[K,q]=b(g),[j,P]=b(A);return K!==j?K<j?-1:1:q===P?0:q<P?-1:1}e.noIntlCompareFileNames=f;function v(g,A){const[L,K]=b(g),[q,j]=b(A);let P=y.value.collator.compare(K,j);if(P===0){if(y.value.collatorIsNumeric&&K!==j)return K<j?-1:1;if(P=y.value.collator.compare(L,q),y.value.collatorIsNumeric&&P===0&&L!==q)return L<q?-1:1}return P}e.compareFileExtensions=v;function h(g,A){g=g||"",A=A||"";const L=p(g),K=p(A),q=N.value.collator,j=C.value.collator;return w(j,L,K)||w(q,g,A)}e.compareFileExtensionsDefault=h;function i(g,A){g=g||"",A=A||"";const L=p(g),K=p(A),q=N.value.collator,j=C.value.collator;return w(j,L,K)||d(g,A)||w(q,g,A)}e.compareFileExtensionsUpper=i;function o(g,A){g=g||"",A=A||"";const L=p(g),K=p(A),q=N.value.collator,j=C.value.collator;return w(j,L,K)||a(g,A)||w(q,g,A)}e.compareFileExtensionsLower=o;function l(g,A){g=g||"",A=A||"";const L=p(g).toLowerCase(),K=p(A).toLowerCase();return L!==K?L<K?-1:1:g!==A?g<A?-1:1:0}e.compareFileExtensionsUnicode=l;const E=/^(.*?)(\.([^.]*))?$/;function b(g,A=!1){const L=g?E.exec(g):[];let K=[L&&L[1]||"",L&&L[3]||""];return A&&(!K[0]&&K[1]||K[0]&&K[0].charAt(0)===".")&&(K=[K[0]+"."+K[1],""]),K}function p(g){const A=g?E.exec(g):[];return A&&A[1]&&A[1].charAt(0)!=="."&&A[3]||""}function w(g,A,L){const K=g.compare(A,L);return K!==0?K:A.length!==L.length?A.length<L.length?-1:1:0}function s(g){const A=g.charAt(0);return A.toLocaleUpperCase()!==A}function r(g){const A=g.charAt(0);return A.toLocaleLowerCase()!==A}function a(g,A){return s(g)&&r(A)?-1:r(g)&&s(A)?1:0}function d(g,A){return r(g)&&s(A)?-1:s(g)&&r(A)?1:0}function c(g,A,L=!1){return L||(g=g&&g.toLowerCase(),A=A&&A.toLowerCase()),g===A?0:g<A?-1:1}function u(g,A,L=!1){const K=g.split(T.sep),q=A.split(T.sep),j=K.length-1,P=q.length-1;let M,F;for(let $=0;;$++){if(M=j===$,F=P===$,M&&F)return R(K[$],q[$],L);if(M)return-1;if(F)return 1;const z=c(K[$],q[$],L);if(z!==0)return z}}e.comparePaths=u;function t(g,A,L){const K=g.toLowerCase(),q=A.toLowerCase(),j=m(g,A,L);if(j)return j;const P=K.endsWith(L),M=q.endsWith(L);if(P!==M)return P?-1:1;const F=R(K,q);return F!==0?F:K.localeCompare(q)}e.compareAnything=t;function m(g,A,L){const K=g.toLowerCase(),q=A.toLowerCase(),j=K.startsWith(L),P=q.startsWith(L);if(j!==P)return j?-1:1;if(j&&P){if(K.length<q.length)return-1;if(K.length>q.length)return 1}return 0}e.compareByPrefix=m}),define(De[35],Ce([1,0,16,15,39,28,19,21,10]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",I="[^/\\\\]",f=/\//g;function v(X,Z){switch(X){case 0:return"";case 1:return`${I}*?`;default:return`(?:${O}|${I}+${O}${Z?`|${O}${I}+`:""})*?`}}function h(X,Z){if(!X)return[];const fe=[];let oe=!1,le=!1,ce="";for(const me of X){switch(me){case Z:if(!oe&&!le){fe.push(ce),ce="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":le=!0;break;case"]":le=!1;break}ce+=me}return ce&&fe.push(ce),fe}e.splitGlobAware=h;function i(X){if(!X)return"";let Z="";const fe=h(X,e.GLOB_SPLIT);if(fe.every(oe=>oe===e.GLOBSTAR))Z=".*";else{let oe=!1;fe.forEach((le,ce)=>{if(le===e.GLOBSTAR){if(oe)return;Z+=v(2,ce===fe.length-1)}else{let me=!1,Y="",pe=!1,we="";for(const Fe of le){if(Fe!=="}"&&me){Y+=Fe;continue}if(pe&&(Fe!=="]"||!we)){let We;Fe==="-"?We=Fe:(Fe==="^"||Fe==="!")&&!we?We="^":Fe===e.GLOB_SPLIT?We="":We=(0,S.escapeRegExpCharacters)(Fe),we+=We;continue}switch(Fe){case"{":me=!0;continue;case"[":pe=!0;continue;case"}":{Z+=`(?:${h(Y,",").map(Pe=>i(Pe)).join("|")})`,me=!1,Y="";break}case"]":{Z+="["+we+"]",pe=!1,we="";break}case"?":Z+=I;continue;case"*":Z+=v(1);continue;default:Z+=(0,S.escapeRegExpCharacters)(Fe)}}ce<fe.length-1&&(fe[ce+1]!==e.GLOBSTAR||ce+2<fe.length)&&(Z+=O)}oe=le===e.GLOBSTAR})}return Z}const o=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new N.LRUCache(1e4),r=function(){return!1},a=function(){return null};function d(X,Z){if(!X)return a;let fe;typeof X!="string"?fe=X.pattern:fe=X,fe=fe.trim();const oe=`${fe}_${!!Z.trimForExclusions}`;let le=s.get(oe);if(le)return c(le,X);let ce;return o.test(fe)?le=t(fe.substr(4),fe):(ce=l.exec(u(fe,Z)))?le=m(ce[1],fe):(Z.trimForExclusions?b:E).test(fe)?le=g(fe,Z):(ce=p.exec(u(fe,Z)))?le=A(ce[1].substr(1),fe,!0):(ce=w.exec(u(fe,Z)))?le=A(ce[1],fe,!1):le=L(fe),s.set(oe,le),c(le,X)}function c(X,Z){if(typeof Z=="string")return X;const fe=function(oe,le){return(0,y.isEqualOrParent)(oe,Z.base,!R.isLinux)?X((0,S.ltrim)(oe.substr(Z.base.length),C.sep),le):null};return fe.allBasenames=X.allBasenames,fe.allPaths=X.allPaths,fe.basenames=X.basenames,fe.patterns=X.patterns,fe}function u(X,Z){return Z.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function t(X,Z){return function(fe,oe){return typeof fe=="string"&&fe.endsWith(X)?Z:null}}function m(X,Z){const fe=`/${X}`,oe=`\\${X}`,le=function(me,Y){return typeof me!="string"?null:Y?Y===X?Z:null:me===X||me.endsWith(fe)||me.endsWith(oe)?Z:null},ce=[X];return le.basenames=ce,le.patterns=[Z],le.allBasenames=ce,le}function g(X,Z){const fe=z(X.slice(1,-1).split(",").map(Y=>d(Y,Z)).filter(Y=>Y!==a),X),oe=fe.length;if(!oe)return a;if(oe===1)return fe[0];const le=function(Y,pe){for(let we=0,Fe=fe.length;we<Fe;we++)if(fe[we](Y,pe))return X;return null},ce=fe.find(Y=>!!Y.allBasenames);ce&&(le.allBasenames=ce.allBasenames);const me=fe.reduce((Y,pe)=>pe.allPaths?Y.concat(pe.allPaths):Y,[]);return me.length&&(le.allPaths=me),le}function A(X,Z,fe){const oe=C.sep===C.posix.sep,le=oe?X:X.replace(f,C.sep),ce=C.sep+le,me=C.posix.sep+X;let Y;return fe?Y=function(pe,we){return typeof pe=="string"&&(pe===le||pe.endsWith(ce)||!oe&&(pe===X||pe.endsWith(me)))?Z:null}:Y=function(pe,we){return typeof pe=="string"&&(pe===le||!oe&&pe===X)?Z:null},Y.allPaths=[(fe?"*/":"./")+X],Y}function L(X){try{const Z=new RegExp(`^${i(X)}$`);return function(fe){return Z.lastIndex=0,typeof fe=="string"&&Z.test(fe)?X:null}}catch{return a}}function K(X,Z,fe){return!X||typeof Z!="string"?!1:q(X)(Z,void 0,fe)}e.match=K;function q(X,Z={}){if(!X)return r;if(typeof X=="string"||j(X)){const fe=d(X,Z);if(fe===a)return r;const oe=function(le,ce){return!!fe(le,ce)};return fe.allBasenames&&(oe.allBasenames=fe.allBasenames),fe.allPaths&&(oe.allPaths=fe.allPaths),oe}return F(X,Z)}e.parse=q;function j(X){const Z=X;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.isRelativePattern=j;function P(X){return X.allBasenames||[]}e.getBasenameTerms=P;function M(X){return X.allPaths||[]}e.getPathTerms=M;function F(X,Z){const fe=z(Object.getOwnPropertyNames(X).map(Y=>$(Y,X[Y],Z)).filter(Y=>Y!==a)),oe=fe.length;if(!oe)return a;if(!fe.some(Y=>!!Y.requiresSiblings)){if(oe===1)return fe[0];const Y=function(Fe,We){let Xe;for(let Pe=0,Ie=fe.length;Pe<Ie;Pe++){const ke=fe[Pe](Fe,We);if(typeof ke=="string")return ke;(0,T.isThenable)(ke)&&(Xe||(Xe=[]),Xe.push(ke))}return Xe?(async()=>{for(const Pe of Xe){const Ie=await Pe;if(typeof Ie=="string")return Ie}return null})():null},pe=fe.find(Fe=>!!Fe.allBasenames);pe&&(Y.allBasenames=pe.allBasenames);const we=fe.reduce((Fe,We)=>We.allPaths?Fe.concat(We.allPaths):Fe,[]);return we.length&&(Y.allPaths=we),Y}const le=function(Y,pe,we){let Fe,We;for(let Xe=0,Pe=fe.length;Xe<Pe;Xe++){const Ie=fe[Xe];Ie.requiresSiblings&&we&&(pe||(pe=(0,C.basename)(Y)),Fe||(Fe=pe.substr(0,pe.length-(0,C.extname)(Y).length)));const ke=Ie(Y,pe,Fe,we);if(typeof ke=="string")return ke;(0,T.isThenable)(ke)&&(We||(We=[]),We.push(ke))}return We?(async()=>{for(const Xe of We){const Pe=await Xe;if(typeof Pe=="string")return Pe}return null})():null},ce=fe.find(Y=>!!Y.allBasenames);ce&&(le.allBasenames=ce.allBasenames);const me=fe.reduce((Y,pe)=>pe.allPaths?Y.concat(pe.allPaths):Y,[]);return me.length&&(le.allPaths=me),le}function $(X,Z,fe){if(Z===!1)return a;const oe=d(X,fe);if(oe===a)return a;if(typeof Z=="boolean")return oe;if(Z){const le=Z.when;if(typeof le=="string"){const ce=(me,Y,pe,we)=>{if(!we||!oe(me,Y))return null;const Fe=le.replace("$(basename)",pe),We=we(Fe);return(0,T.isThenable)(We)?We.then(Xe=>Xe?X:null):We?X:null};return ce.requiresSiblings=!0,ce}}return oe}function z(X,Z){const fe=X.filter(Y=>!!Y.basenames);if(fe.length<2)return X;const oe=fe.reduce((Y,pe)=>{const we=pe.basenames;return we?Y.concat(we):Y},[]);let le;if(Z){le=[];for(let Y=0,pe=oe.length;Y<pe;Y++)le.push(Z)}else le=fe.reduce((Y,pe)=>{const we=pe.patterns;return we?Y.concat(we):Y},[]);const ce=function(Y,pe){if(typeof Y!="string")return null;if(!pe){let Fe;for(Fe=Y.length;Fe>0;Fe--){const We=Y.charCodeAt(Fe-1);if(We===47||We===92)break}pe=Y.substr(Fe)}const we=oe.indexOf(pe);return we!==-1?le[we]:null};ce.basenames=oe,ce.patterns=le,ce.allBasenames=oe;const me=X.filter(Y=>!Y.basenames);return me.push(ce),me}function V(X,Z){return(0,n.equals)(X,Z,(fe,oe)=>typeof fe=="string"&&typeof oe=="string"?fe===oe:typeof fe!="string"&&typeof oe!="string"?fe.base===oe.base&&fe.pattern===oe.pattern:!1)}e.patternsEquals=V}),define(De[81],Ce([1,0,11,118,22,10,2]),function(te,e,n,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(l="",E=!1){if(this.value=l,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=E.isTrusted??void 0,this.supportThemeIcons=E.supportThemeIcons??!1,this.supportHtml=E.supportHtml??!1)}appendText(l,E=0){return this.value+=f(this.supportThemeIcons?(0,T.escapeIcons)(l):l).replace(/([ \t]+)/g,(b,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,E){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}appendLink(l,E,b){return this.value+="[",this.value+=this.c(E,"]"),this.value+="](",this.value+=this.c(String(l),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(l,E){const b=new RegExp((0,N.escapeRegExpCharacters)(E),"g");return l.replace(b,(p,w)=>l.charAt(w-1)!=="\\"?`\\${p}`:p)}}e.MarkdownString=S;function k(o){return O(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function O(o){return o instanceof S?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function I(o,l){return o===l?!0:!o||!l?!1:o.value===l.value&&o.isTrusted===l.isTrusted&&o.supportThemeIcons===l.supportThemeIcons&&o.supportHtml===l.supportHtml&&(o.baseUri===l.baseUri||!!o.baseUri&&!!l.baseUri&&(0,y.isEqual)(C.URI.from(o.baseUri),C.URI.from(l.baseUri)))}e.markdownStringEqual=I;function f(o){return o.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function v(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=v;function h(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function i(o){const l=[],E=o.split("|").map(p=>p.trim());o=E[0];const b=E[1];if(b){const p=/height=(\d+)/.exec(b),w=/width=(\d+)/.exec(b),s=p?p[1]:"",r=w?w[1]:"",a=isFinite(parseInt(r)),d=isFinite(parseInt(s));a&&l.push(`width="${r}"`),d&&l.push(`height="${s}"`)}return{href:o,dimensions:l}}e.parseHrefAndDimensions=i}),define(De[82],Ce([1,0,16,39,19,21,22,10]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(a,d){const{os:c,tildify:u,relative:t}=d;if(t){const A=k(a,t,c);if(typeof A=="string")return A}let m=a.fsPath;if(c===1&&!N.isWindows?m=m.replace(/\//g,"\\"):c!==1&&N.isWindows&&(m=m.replace(/\\/g,"/")),c!==1&&u?.userHome){const A=u.userHome.fsPath;let L;a.scheme!==u.userHome.scheme&&a.path.startsWith(y.posix.sep)?L=u.userHome.with({path:a.path}).fsPath:L=a.fsPath,m=f(L,A,c)}return(c===1?y.win32:y.posix).normalize(O(m,c===1))}e.getPathLabel=S;function k(a,d,c){const u=c===1?y.win32:y.posix,t=c===3?C.extUri:C.extUriIgnorePathCase,m=d.getWorkspace(),g=(0,n.firstOrDefault)(m.folders);if(!g)return;a.scheme!==g.uri.scheme&&a.path.startsWith(y.posix.sep)&&(a=g.uri.with({path:a.path}));const A=d.getWorkspaceFolder(a);if(!A)return;let L;if(t.isEqual(A.uri,a)?L="":L=t.relativePath(A.uri,a)??"",L&&(L=u.normalize(L)),m.folders.length>1&&!d.noPrefix){const K=A.name?A.name:t.basenameOrAuthority(A.uri);L=L?`${K} \u2022 ${L}`:K}return L}function O(a,d=N.isWindows){return(0,T.hasDriveLetter)(a,d)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=O;let I=Object.create(null);function f(a,d,c=N.OS){if(c===1||!a||!d)return a;let u=I.original===d?I.normalized:void 0;u||(u=d,N.isWindows&&(u=(0,T.toSlashes)(u)),u=`${(0,R.rtrim)(u,y.posix.sep)}${y.posix.sep}`,I={original:d,normalized:u});let t=a;return N.isWindows&&(t=(0,T.toSlashes)(t)),(c===3?t.startsWith(u):(0,R.startsWithIgnoreCase)(t,u))?`~/${t.substr(u.length)}`:a}e.tildify=f;function v(a,d){return a.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=v;const h="\u2026",i="\\\\",o="~";function l(a,d=y.sep){const c=new Array(a.length);let u=!1;for(let t=0;t<a.length;t++){const m=a[t];if(m===""){c[t]=`.${d}`;continue}if(!m){c[t]=m;continue}u=!0;let g="",A=m;A.indexOf(i)===0?(g=A.substr(0,A.indexOf(i)+i.length),A=A.substr(A.indexOf(i)+i.length)):A.indexOf(d)===0?(g=A.substr(0,A.indexOf(d)+d.length),A=A.substr(A.indexOf(d)+d.length)):A.indexOf(o)===0&&(g=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length));const L=A.split(d);for(let K=1;u&&K<=L.length;K++)for(let q=L.length-K;u&&q>=0;q--){u=!1;let j=L.slice(q,q+K).join(d);for(let P=0;!u&&P<a.length;P++)if(P!==t&&a[P]&&a[P].indexOf(j)>-1){const M=q+K===L.length,F=q>0&&a[P].indexOf(d)>-1?d+j:j,$=a[P].endsWith(F);u=!M||$}if(!u){let P="";(L[0].endsWith(":")||g!=="")&&(q===1&&(q=0,K++,j=L[0]+d+j),q>0&&(P=L[0]+d),P=g+P),q>0&&(P=P+h+d),P=P+j,q+K<L.length&&(P=P+d+h),c[t]=P}}u&&(c[t]=m)}return c}e.shorten=l;var E;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(E||(E={}));function b(a,d=Object.create(null)){const c=[];let u=!1,t="";for(const m of a)if(m==="$"||u&&m==="{")t&&c.push({value:t,type:E.TEXT}),t="",u=!0;else if(m==="}"&&u){const g=d[t];if(typeof g=="string")g.length&&c.push({value:g,type:E.VARIABLE});else if(g){const A=c[c.length-1];(!A||A.type!==E.SEPARATOR)&&c.push({value:g.label,type:E.SEPARATOR})}t="",u=!1}else t+=m;return t&&!u&&c.push({value:t,type:E.TEXT}),c.filter((m,g)=>{if(m.type===E.SEPARATOR){const A=c[g-1],L=c[g+1];return[A,L].every(K=>K&&(K.type===E.VARIABLE||K.type===E.TEXT)&&K.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=b;function p(a,d){return N.isMacintosh||d?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function w(a,d){return N.isMacintosh||d?a.replace(/\(&&\w\)|&&/g,""):N.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function s(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(a){const d=a.indexOf("/")!==-1?y.posix:y.win32,c=d.basename(a),u=d.dirname(a);return c.length?{name:c,parentPath:u}:{name:u,parentPath:""}}e.splitName=r}),define(De[121],Ce([1,0,2]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(O){return O.toJSON()}class y{constructor(I){this.a=I}transformIncoming(I){const f=this.a.transformIncoming(I);return f===I?I:T(n.URI.from(f))}transformOutgoing(I){const f=this.a.transformOutgoing(I);return f===I?I:T(n.URI.from(f))}transformOutgoingURI(I){const f=this.a.transformOutgoing(I);return f===I?I:n.URI.from(f)}transformOutgoingScheme(I){return this.a.transformOutgoingScheme(I)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function N(O,I,f){if(!O||f>200)return null;if(typeof O=="object"){if(O instanceof n.URI)return I.transformOutgoing(O);for(const v in O)if(Object.hasOwnProperty.call(O,v)){const h=N(O[v],I,f+1);h!==null&&(O[v]=h)}}return null}function C(O,I){const f=N(O,I,0);return f===null?O:f}e.transformOutgoingURIs=C;function R(O,I,f,v){if(!O||v>200)return null;if(typeof O=="object"){if(O.$mid===1)return f?n.URI.revive(I.transformIncoming(O)):I.transformIncoming(O);for(const h in O)if(Object.hasOwnProperty.call(O,h)){const i=R(O[h],I,f,v+1);i!==null&&(O[h]=i)}}return null}function S(O,I){const f=R(O,I,!1,0);return f===null?O:f}e.transformIncomingURIs=S;function k(O,I){const f=R(O,I,!0,0);return f===null?O:f}e.transformAndReviveIncomingURIs=k}),define(De[122],Ce([1,0,35,19]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(N,C,R,S,k,O){if(Array.isArray(N)){let I=0;for(const f of N){const v=y(f,C,R,S,k,O);if(v===10)return v;v>I&&(I=v)}return I}else{if(typeof N=="string")return S?N==="*"?5:N===R?10:0:0;if(N){const{language:I,pattern:f,scheme:v,hasAccessToAllModels:h,notebookType:i}=N;if(!S&&!h)return 0;i&&k&&(C=k);let o=0;if(v)if(v===C.scheme)o=10;else if(v==="*")o=5;else return 0;if(I)if(I===R)o=10;else if(I==="*")o=Math.max(o,5);else return 0;if(i)if(i===O)o=10;else if(i==="*"&&O!==void 0)o=Math.max(o,5);else return 0;if(f){let l;if(typeof f=="string"?l=f:l={...f,base:(0,T.normalize)(f.base)},l===C.fsPath||(0,n.match)(l,C.fsPath))o=10;else return 0}return o}else return 0}}e.score=y}),define(De[83],Ce([1,0,24,21]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(y||(y={}));function N(I){for(let f=0,v=I.length;f<v;f+=4){const h=I[f+0],i=I[f+1],o=I[f+2],l=I[f+3];I[f+0]=l,I[f+1]=o,I[f+2]=i,I[f+3]=h}}function C(I){const f=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.isLittleEndian()||N(f),n.VSBuffer.wrap(f)}function R(I){const f=I.buffer;if(T.isLittleEndian()||N(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const v=new Uint8Array(f.byteLength);return v.set(f),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function S(I){const f=new Uint32Array(k(I));let v=0;if(f[v++]=I.id,I.type==="full")f[v++]=1,f[v++]=I.data.length,f.set(I.data,v),v+=I.data.length;else{f[v++]=2,f[v++]=I.deltas.length;for(const h of I.deltas)f[v++]=h.start,f[v++]=h.deleteCount,h.data?(f[v++]=h.data.length,f.set(h.data,v),v+=h.data.length):f[v++]=0}return C(f)}e.encodeSemanticTokensDto=S;function k(I){let f=0;if(f+=1+1,I.type==="full")f+=1+I.data.length;else{f+=1,f+=(1+1+1)*I.deltas.length;for(const v of I.deltas)v.data&&(f+=v.data.length)}return f}function O(I){const f=R(I);let v=0;const h=f[v++];if(f[v++]===1){const E=f[v++],b=f.subarray(v,v+E);return v+=E,{id:h,type:"full",data:b}}const o=f[v++],l=[];for(let E=0;E<o;E++){const b=f[v++],p=f[v++],w=f[v++];let s;w>0&&(s=f.subarray(v,v+w),v+=w),l[E]={start:b,deleteCount:p,data:s}}return{id:h,type:"delta",deltas:l}}e.decodeSemanticTokensDto=O}),define(De[123],Ce([17,18]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(De[124],Ce([1,0,123,21,125,16,23,112]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontFamily=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class I{constructor(Q,ue,Ue,Ne){this.id=Q,this.name=ue,this.defaultValue=Ue,this.schema=Ne}applyUpdate(Q,ue){return v(Q,ue)}compute(Q,ue,Ue){return Ue}}class f{constructor(Q,ue){this.newValue=Q,this.didChange=ue}}e.ApplyUpdateResult=f;function v(_,Q){if(typeof _!="object"||typeof Q!="object"||!_||!Q)return new f(Q,_!==Q);if(Array.isArray(_)||Array.isArray(Q)){const Ue=Array.isArray(_)&&Array.isArray(Q)&&N.equals(_,Q);return new f(Q,!Ue)}let ue=!1;for(const Ue in Q)if(Q.hasOwnProperty(Ue)){const Ne=v(_[Ue],Q[Ue]);Ne.didChange&&(_[Ue]=Ne.newValue,ue=!0)}return new f(_,ue)}class h{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ue){return v(Q,ue)}validate(Q){return this.defaultValue}}class i{constructor(Q,ue,Ue,Ne){this.id=Q,this.name=ue,this.defaultValue=Ue,this.schema=Ne}applyUpdate(Q,ue){return v(Q,ue)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ue,Ue){return Ue}}function o(_,Q){return typeof _>"u"?Q:_==="false"?!1:Boolean(_)}e.boolean=o;class l extends i{constructor(Q,ue,Ue,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Ue),super(Q,ue,Ue,Ne)}validate(Q){return o(Q,this.defaultValue)}}function E(_,Q,ue,Ue){if(typeof _>"u")return Q;let Ne=parseInt(_,10);return isNaN(Ne)?Q:(Ne=Math.max(ue,Ne),Ne=Math.min(Ue,Ne),Ne|0)}e.clampedInt=E;class b extends i{static clampedInt(Q,ue,Ue,Ne){return E(Q,ue,Ue,Ne)}constructor(Q,ue,Ue,Ne,_e,Je=void 0){typeof Je<"u"&&(Je.type="integer",Je.default=Ue,Je.minimum=Ne,Je.maximum=_e),super(Q,ue,Ue,Je),this.minimum=Ne,this.maximum=_e}validate(Q){return b.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class p extends i{static clamp(Q,ue,Ue){return Q<ue?ue:Q>Ue?Ue:Q}static float(Q,ue){if(typeof Q=="number")return Q;if(typeof Q>"u")return ue;const Ue=parseFloat(Q);return isNaN(Ue)?ue:Ue}constructor(Q,ue,Ue,Ne,_e){typeof _e<"u"&&(_e.type="number",_e.default=Ue),super(Q,ue,Ue,_e),this.validationFn=Ne}validate(Q){return this.validationFn(p.float(Q,this.defaultValue))}}class w extends i{static string(Q,ue){return typeof Q!="string"?ue:Q}constructor(Q,ue,Ue,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Ue),super(Q,ue,Ue,Ne)}validate(Q){return w.string(Q,this.defaultValue)}}function s(_,Q,ue){return typeof _!="string"||ue.indexOf(_)===-1?Q:_}e.stringSet=s;class r extends i{constructor(Q,ue,Ue,Ne,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.enum=Ne,_e.default=Ue),super(Q,ue,Ue,_e),this.c=Ne}validate(Q){return s(Q,this.defaultValue,this.c)}}class a extends I{constructor(Q,ue,Ue,Ne,_e,Je,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=_e,ht.default=Ne),super(Q,ue,Ue,ht),this.c=_e,this.d=Je}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function d(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ue,Ue){return Ue===0?Q.accessibilitySupport:Ue}}class u extends I{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:n.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{insertSpace:o(ue.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ue.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var t;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(t=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function A(_){switch(_){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=A;function L(_){switch(_){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class K extends h{constructor(){super(133)}compute(Q,ue,Ue){const Ne=["monaco-editor"];return ue.get(34)&&Ne.push(ue.get(34)),Q.extraEditorClassName&&Ne.push(Q.extraEditorClassName),ue.get(68)==="default"?Ne.push("mouse-default"):ue.get(68)==="copy"&&Ne.push("mouse-copy"),ue.get(103)&&Ne.push("showUnused"),ue.get(131)&&Ne.push("showDeprecated"),Ne.join(" ")}}class q extends l{constructor(){super(33,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(Q,ue,Ue){return Ue&&Q.emptySelectionClipboard}}class j extends I{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:n.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:n.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{cursorMoveOnType:o(ue.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":s(ue.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":s(ue.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ue.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ue.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ue.loop,this.defaultValue.loop)}}}class P extends I{constructor(){super(46,"fontLigatures",P.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?P.OFF:Q==="true"?P.ON:Q:Boolean(Q)?P.ON:P.OFF}}e.EditorFontLigatures=P,P.OFF='"liga" off, "calt" off',P.ON='"liga" on, "calt" on';class M extends I{constructor(){super(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{anyOf:[{type:"string"},{type:"array",items:{type:"string"}}],description:n.localize(22,null),default:e.EDITOR_FONT_DEFAULTS.fontFamily})}validate(Q){return typeof Q=="string"?Q:Array.isArray(Q)&&Q.length>0?Q.map(ue=>JSON.stringify(ue)).join(","):this.defaultValue}}e.EditorFontFamily=M;class F extends I{constructor(){super(49,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:n.localize(23,null)},{type:"string",description:n.localize(24,null)}],description:n.localize(25,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?F.OFF:Q==="true"?F.TRANSLATE:Q:Boolean(Q)?F.TRANSLATE:F.OFF}compute(Q,ue,Ue){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=F,F.OFF="normal",F.TRANSLATE="translate";class $ extends h{constructor(){super(45)}compute(Q,ue,Ue){return Q.fontInfo}}class z extends i{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(26,null)})}validate(Q){const ue=p.float(Q,this.defaultValue);return ue===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ue,6,100)}compute(Q,ue,Ue){return Q.fontInfo.fontSize}}class V extends I{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:n.localize(27,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(28,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(b.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class X extends I{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ue={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[n.localize(29,null),n.localize(30,null),n.localize(31,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(32,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(33,null),...ue},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(34,null),...ue},"editor.gotoLocation.multipleDeclarations":{description:n.localize(35,null),...ue},"editor.gotoLocation.multipleImplementations":{description:n.localize(36,null),...ue},"editor.gotoLocation.multipleReferences":{description:n.localize(37,null),...ue},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ue,description:n.localize(38,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ue,description:n.localize(39,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ue,description:n.localize(40,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ue,description:n.localize(41,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ue,description:n.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{multiple:s(ue.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ue.multipleDefinitions??s(ue.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ue.multipleTypeDefinitions??s(ue.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ue.multipleDeclarations??s(ue.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ue.multipleImplementations??s(ue.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ue.multipleReferences??s(ue.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ue.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ue.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ue.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ue.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ue.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends I{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:n.localize(43,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:n.localize(44,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:n.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:n.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{enabled:o(ue.enabled,this.defaultValue.enabled),delay:b.clampedInt(ue.delay,this.defaultValue.delay,0,1e4),sticky:o(ue.sticky,this.defaultValue.sticky),above:o(ue.above,this.defaultValue.above)}}}var fe;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(fe=e.RenderMinimap||(e.RenderMinimap={}));class oe extends h{constructor(){super(136)}compute(Q,ue,Ue){return oe.computeLayout(ue,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ue=Q.height/Q.lineHeight,Ue=Q.scrollBeyondLastLine?ue-1:0,Ne=(Q.viewLineCount+Ue)/(Q.pixelRatio*Q.height),_e=Math.floor(Q.viewLineCount/Ne);return{typicalViewportLineCount:ue,extraLinesBeyondLastLine:Ue,desiredRatio:Ne,minimapLineCount:_e}}static c(Q,ue){const Ue=Q.outerWidth,Ne=Q.outerHeight,_e=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(_e*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const Je=ue.stableMinimapLayoutInput,ht=Je&&Q.outerHeight===Je.outerHeight&&Q.lineHeight===Je.lineHeight&&Q.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Je.pixelRatio&&Q.scrollBeyondLastLine===Je.scrollBeyondLastLine&&Q.minimap.enabled===Je.minimap.enabled&&Q.minimap.side===Je.minimap.side&&Q.minimap.size===Je.minimap.size&&Q.minimap.showSlider===Je.minimap.showSlider&&Q.minimap.renderCharacters===Je.minimap.renderCharacters&&Q.minimap.maxColumn===Je.minimap.maxColumn&&Q.minimap.scale===Je.minimap.scale&&Q.verticalScrollbarWidth===Je.verticalScrollbarWidth&&Q.isViewportWrapping===Je.isViewportWrapping,wt=Q.lineHeight,St=Q.typicalHalfwidthCharacterWidth,ut=Q.scrollBeyondLastLine,gt=Q.minimap.renderCharacters;let yt=_e>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Ut=Q.minimap.maxColumn,At=Q.minimap.size,pt=Q.minimap.side,kt=Q.verticalScrollbarWidth,Bt=Q.viewLineCount,Ft=Q.remainingWidth,Ke=Q.isViewportWrapping,zt=gt?2:3;let Rt=Math.floor(_e*Ne);const Wt=Rt/_e;let ft=!1,Mt=!1,Se=zt*yt,Te=yt/_e,ge=1;if(At==="fill"||At==="fit"){const{typicalViewportLineCount:Ct,extraLinesBeyondLastLine:bt,desiredRatio:Ot,minimapLineCount:mt}=oe.computeContainedMinimapLineCount({viewLineCount:Bt,scrollBeyondLastLine:ut,height:Ne,lineHeight:wt,pixelRatio:_e});if(Bt/mt>1)ft=!0,Mt=!0,yt=1,Se=1,Te=yt/_e;else{let vt=!1,Ht=yt+1;if(At==="fit"){const Nt=Math.ceil((Bt+bt)*Se);Ke&&ht&&Ft<=ue.stableFitRemainingWidth?(vt=!0,Ht=ue.stableFitMaxMinimapScale):vt=Nt>Rt}if(At==="fill"||vt){ft=!0;const Nt=yt;Se=Math.min(wt*_e,Math.max(1,Math.floor(1/Ot))),Ke&&ht&&Ft<=ue.stableFitRemainingWidth&&(Ht=ue.stableFitMaxMinimapScale),yt=Math.min(Ht,Math.max(1,Math.floor(Se/zt))),yt>Nt&&(ge=Math.min(2,yt/Nt)),Te=yt/_e/ge,Rt=Math.ceil(Math.max(Ct,Bt+bt)*Se),Ke?(ue.stableMinimapLayoutInput=Q,ue.stableFitRemainingWidth=Ft,ue.stableFitMaxMinimapScale=yt):(ue.stableMinimapLayoutInput=null,ue.stableFitRemainingWidth=0)}}}const x=Math.floor(Ut*Te),Ae=Math.min(x,Math.max(0,Math.floor((Ft-kt-2)*Te/(St+Te)))+e.MINIMAP_GUTTER_WIDTH);let Me=Math.floor(_e*Ae);const xe=Me/_e;Me=Math.floor(Me*ge);const ze=gt?1:2,Ze=pt==="left"?0:Ue-Ae-kt;return{renderMinimap:ze,minimapLeft:Ze,minimapWidth:Ae,minimapHeightIsEditorHeight:ft,minimapIsSampling:Mt,minimapScale:yt,minimapLineHeight:Se,minimapCanvasInnerWidth:Me,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:xe,minimapCanvasOuterHeight:Wt}}static computeLayout(Q,ue){const Ue=ue.outerWidth|0,Ne=ue.outerHeight|0,_e=ue.lineHeight|0,Je=ue.lineNumbersDigitCount|0,ht=ue.typicalHalfwidthCharacterWidth,wt=ue.maxDigitWidth,St=ue.pixelRatio,ut=ue.viewLineCount,gt=Q.get(128),yt=gt==="inherit"?Q.get(127):gt,Ut=yt==="inherit"?Q.get(123):yt,At=Q.get(126),pt=ue.isDominatedByLongLines,kt=Q.get(52),Bt=Q.get(62).renderType!==0,Ft=Q.get(63),Ke=Q.get(97),zt=Q.get(67),Rt=Q.get(95),Wt=Rt.verticalScrollbarSize,ft=Rt.verticalHasArrows,Mt=Rt.arrowSize,Se=Rt.horizontalScrollbarSize,Te=Q.get(38),ge=Q.get(102)!=="never";let x=Q.get(60);Te&&ge&&(x+=16);let Ae=0;if(Bt){const Zt=Math.max(Je,Ft);Ae=Math.round(Zt*wt)}let Me=0;kt&&(Me=_e);let xe=0,ze=xe+Me,Ze=ze+Ae,Ct=Ze+x;const bt=Ue-Me-Ae-x;let Ot=!1,mt=!1,Tt=-1;yt==="inherit"&&pt?(Ot=!0,mt=!0):Ut==="on"||Ut==="bounded"?mt=!0:Ut==="wordWrapColumn"&&(Tt=At);const vt=oe.c({outerWidth:Ue,outerHeight:Ne,lineHeight:_e,typicalHalfwidthCharacterWidth:ht,pixelRatio:St,scrollBeyondLastLine:Ke,minimap:zt,verticalScrollbarWidth:Wt,viewLineCount:ut,remainingWidth:bt,isViewportWrapping:mt},ue.memory||new O);vt.renderMinimap!==0&&vt.minimapLeft===0&&(xe+=vt.minimapWidth,ze+=vt.minimapWidth,Ze+=vt.minimapWidth,Ct+=vt.minimapWidth);const Ht=bt-vt.minimapWidth,Nt=Math.max(1,Math.floor((Ht-Wt-2)/ht)),Et=ft?Mt:0;return mt&&(Tt=Math.max(1,Nt),Ut==="bounded"&&(Tt=Math.min(Tt,At))),{width:Ue,height:Ne,glyphMarginLeft:xe,glyphMarginWidth:Me,lineNumbersLeft:ze,lineNumbersWidth:Ae,decorationsLeft:Ze,decorationsWidth:x,contentLeft:Ct,contentWidth:Ht,minimap:vt,viewportColumn:Nt,isWordWrapMinified:Ot,isViewportWrapping:mt,wrappingColumn:Tt,verticalScrollbarWidth:Wt,horizontalScrollbarHeight:Se,overviewRuler:{top:Et,width:Wt,height:Ne-2*Et,right:0}}}}e.EditorLayoutInfoComputer=oe;class le extends I{constructor(){super(130,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(47,null),n.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(49,null)}})}validate(Q){return s(Q,"simple",["simple","advanced"])}compute(Q,ue,Ue){return ue.get(2)===2?"advanced":Ue}}class ce extends I{constructor(){const Q={enabled:!0};super(59,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:n.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class me extends I{constructor(){const Q={enabled:!1,maxLineCount:5};super(107,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:n.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:n.localize(52,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{enabled:o(ue.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(ue.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Y extends I{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(132,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:n.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(54,null),n.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:n.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:n.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:n.localize(60,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return typeof ue.enabled=="boolean"&&(ue.enabled=ue.enabled?"on":"off"),{enabled:s(ue.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(ue.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ue.fontFamily,this.defaultValue.fontFamily),padding:o(ue.padding,this.defaultValue.padding)}}}class pe extends I{constructor(){super(60,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):b.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ue,Ue){return Ue<0?b.clampedInt(-Ue*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class we extends p{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>p.clamp(Q,0,150),{markdownDescription:n.localize(61,null)})}compute(Q,ue,Ue){return Q.fontInfo.lineHeight}}class Fe extends I{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:n.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:n.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(64,null),n.localize(65,null),n.localize(66,null)],default:Q.size,description:n.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:n.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:n.localize(69,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:n.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:n.localize(72,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{enabled:o(ue.enabled,this.defaultValue.enabled),autohide:o(ue.autohide,this.defaultValue.autohide),size:s(ue.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ue.side,this.defaultValue.side,["right","left"]),showSlider:s(ue.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ue.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(ue.scale,1,1,3),maxColumn:b.clampedInt(ue.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function We(_){return _==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Xe extends I{constructor(){super(78,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{top:b.clampedInt(ue.top,0,0,1e3),bottom:b.clampedInt(ue.bottom,0,0,1e3)}}}class Pe extends I{constructor(){const Q={enabled:!0,cycle:!1};super(79,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:n.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:n.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{enabled:o(ue.enabled,this.defaultValue.enabled),cycle:o(ue.cycle,this.defaultValue.cycle)}}}class Ie extends h{constructor(){super(134)}compute(Q,ue,Ue){return Q.pixelRatio}}class ke extends I{constructor(){const Q={other:"on",comments:"off",strings:"off"},ue=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(77,null),n.localize(78,null),n.localize(79,null)]}];super(82,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ue,default:Q.strings,description:n.localize(80,null)},comments:{anyOf:ue,default:Q.comments,description:n.localize(81,null)},other:{anyOf:ue,default:Q.other,description:n.localize(82,null)}},default:Q,markdownDescription:n.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const St=Q?"on":"off";return{comments:St,strings:St,other:St}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ue,comments:Ue,strings:Ne}=Q,_e=["on","inline","off"];let Je,ht,wt;return typeof ue=="boolean"?Je=ue?"on":"off":Je=s(ue,this.defaultValue.other,_e),typeof Ue=="boolean"?ht=Ue?"on":"off":ht=s(Ue,this.defaultValue.comments,_e),typeof Ne=="boolean"?wt=Ne?"on":"off":wt=s(Ne,this.defaultValue.strings,_e),{other:Je,comments:ht,strings:wt}}}var re;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(re=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ae extends I{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(84,null),n.localize(85,null),n.localize(86,null),n.localize(87,null)],default:"on",description:n.localize(88,null)})}validate(Q){let ue=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ue=4,Ue=Q):Q==="interval"?ue=3:Q==="relative"?ue=2:Q==="on"?ue=1:ue=0),{renderType:ue,renderFn:Ue}}}function J(_){const Q=_.get(90);return Q==="editable"?_.get(84):Q!=="on"}e.filterValidationDecorations=J;class D extends I{constructor(){const Q=[],ue={type:"number",description:n.localize(89,null)};super(94,"rulers",Q,{type:"array",items:{anyOf:[ue,{type:["object"],properties:{column:ue,color:{type:"string",description:n.localize(90,null),format:"color-hex"}}}]},default:Q,description:n.localize(91,null)})}validate(Q){if(Array.isArray(Q)){const ue=[];for(const Ue of Q)if(typeof Ue=="number")ue.push({column:b.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ne=Ue;ue.push({column:b.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ue.sort((Ue,Ne)=>Ue.column-Ne.column),ue}return this.defaultValue}}function U(_,Q){if(typeof _!="string")return Q;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends I{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(95,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(92,null),n.localize(93,null),n.localize(94,null)],default:"auto",description:n.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(96,null),n.localize(97,null),n.localize(98,null)],default:"auto",description:n.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:n.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:n.localize(102,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q,Ue=b.clampedInt(ue.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=b.clampedInt(ue.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(ue.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(ue.vertical,this.defaultValue.vertical),horizontal:U(ue.horizontal,this.defaultValue.horizontal),useShadows:o(ue.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ue.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ue.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ue.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ue.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:b.clampedInt(ue.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:b.clampedInt(ue.verticalSliderSize,Ne,0,1e3),scrollByPage:o(ue.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends I{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(117,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:n.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:n.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:n.localize(109,null)}})}applyUpdate(Q,ue){let Ue=!1;ue.allowedCharacters&&Q&&(C.equals(Q.allowedCharacters,ue.allowedCharacters)||(Q={...Q,allowedCharacters:ue.allowedCharacters},Ue=!0)),ue.allowedLocales&&Q&&(C.equals(Q.allowedLocales,ue.allowedLocales)||(Q={...Q,allowedLocales:ue.allowedLocales},Ue=!0));const Ne=super.applyUpdate(Q,ue);return Ue?new f(Ne.newValue,!0):Ne}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{nonBasicASCII:se(ue.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ue.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ue.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:se(ue.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:se(ue.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ue){if(typeof Q!="object"||!Q)return ue;const Ue={};for(const[Ne,_e]of Object.entries(Q))_e===!0&&(Ue[Ne]=!0);return Ue}}class ee extends I{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:n.localize(110,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{enabled:o(ue.enabled,this.defaultValue.enabled),mode:s(ue.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class de extends I{constructor(){const Q={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:n.localize(111,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:n.localize(112,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{enabled:o(ue.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ue.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ye extends I{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(113,null),n.localize(114,null),n.localize(115,null)],default:Q.bracketPairs,description:n.localize(116,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(117,null),n.localize(118,null),n.localize(119,null)],default:Q.bracketPairsHorizontal,description:n.localize(120,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:n.localize(121,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:n.localize(122,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(123,null),n.localize(124,null),n.localize(125,null)],default:Q.highlightActiveIndentation,description:n.localize(126,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{bracketPairs:se(ue.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:se(ue.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ue.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ue.indentation,this.defaultValue.indentation),highlightActiveIndentation:se(ue.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function se(_,Q,ue){const Ue=ue.indexOf(_);return Ue===-1?Q:ue[Ue]}class ve extends I{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(110,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(127,null),n.localize(128,null)],default:Q.insertMode,description:n.localize(129,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:n.localize(130,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:n.localize(131,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:n.localize(132,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:n.localize(133,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:n.localize(134,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:n.localize(135,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:n.localize(136,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:n.localize(137,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(138,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(139,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(140,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(141,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(142,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(143,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(144,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(145,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(146,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ue=Q;return{insertMode:s(ue.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ue.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ue.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ue.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ue.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:o(ue.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:o(ue.showIcons,this.defaultValue.showIcons),showStatusBar:o(ue.showStatusBar,this.defaultValue.showStatusBar),preview:o(ue.preview,this.defaultValue.preview),previewMode:s(ue.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ue.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ue.showMethods,this.defaultValue.showMethods),showFunctions:o(ue.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ue.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ue.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ue.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ue.showFields,this.defaultValue.showFields),showVariables:o(ue.showVariables,this.defaultValue.showVariables),showClasses:o(ue.showClasses,this.defaultValue.showClasses),showStructs:o(ue.showStructs,this.defaultValue.showStructs),showInterfaces:o(ue.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ue.showModules,this.defaultValue.showModules),showProperties:o(ue.showProperties,this.defaultValue.showProperties),showEvents:o(ue.showEvents,this.defaultValue.showEvents),showOperators:o(ue.showOperators,this.defaultValue.showOperators),showUnits:o(ue.showUnits,this.defaultValue.showUnits),showValues:o(ue.showValues,this.defaultValue.showValues),showConstants:o(ue.showConstants,this.defaultValue.showConstants),showEnums:o(ue.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ue.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ue.showKeywords,this.defaultValue.showKeywords),showWords:o(ue.showWords,this.defaultValue.showWords),showColors:o(ue.showColors,this.defaultValue.showColors),showFiles:o(ue.showFiles,this.defaultValue.showFiles),showReferences:o(ue.showReferences,this.defaultValue.showReferences),showFolders:o(ue.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ue.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ue.showSnippets,this.defaultValue.showSnippets),showUsers:o(ue.showUsers,this.defaultValue.showUsers),showIssues:o(ue.showIssues,this.defaultValue.showIssues)}}}class be extends I{constructor(){super(105,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(170,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class $e extends h{constructor(){super(135)}compute(Q,ue,Ue){return ue.get(84)?!0:Q.tabFocusMode}}var He;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(He=e.WrappingIndent||(e.WrappingIndent={}));class tt extends I{constructor(){super(129,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(171,null),n.localize(172,null),n.localize(173,null),n.localize(174,null)],description:n.localize(175,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ue,Ue){return ue.get(2)===2?0:Ue}}class Ge extends h{constructor(){super(137)}compute(Q,ue,Ue){const Ne=ue.get(136);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class et extends I{constructor(){const Q={enabled:!0};super(32,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:n.localize(176,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}const it="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?ct:T.isLinux?nt:it,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(_){return e.editorOptionsRegistry[_.id]=_,_}var lt;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.autoClosingBrackets=5]="autoClosingBrackets",_[_.autoClosingDelete=6]="autoClosingDelete",_[_.autoClosingOvertype=7]="autoClosingOvertype",_[_.autoClosingQuotes=8]="autoClosingQuotes",_[_.autoIndent=9]="autoIndent",_[_.automaticLayout=10]="automaticLayout",_[_.autoSurround=11]="autoSurround",_[_.bracketPairColorization=12]="bracketPairColorization",_[_.guides=13]="guides",_[_.codeLens=14]="codeLens",_[_.codeLensFontFamily=15]="codeLensFontFamily",_[_.codeLensFontSize=16]="codeLensFontSize",_[_.colorDecorators=17]="colorDecorators",_[_.columnSelection=18]="columnSelection",_[_.comments=19]="comments",_[_.contextmenu=20]="contextmenu",_[_.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",_[_.cursorBlinking=22]="cursorBlinking",_[_.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",_[_.cursorStyle=24]="cursorStyle",_[_.cursorSurroundingLines=25]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",_[_.cursorWidth=27]="cursorWidth",_[_.disableLayerHinting=28]="disableLayerHinting",_[_.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",_[_.domReadOnly=30]="domReadOnly",_[_.dragAndDrop=31]="dragAndDrop",_[_.dropIntoEditor=32]="dropIntoEditor",_[_.emptySelectionClipboard=33]="emptySelectionClipboard",_[_.extraEditorClassName=34]="extraEditorClassName",_[_.fastScrollSensitivity=35]="fastScrollSensitivity",_[_.find=36]="find",_[_.fixedOverflowWidgets=37]="fixedOverflowWidgets",_[_.folding=38]="folding",_[_.foldingStrategy=39]="foldingStrategy",_[_.foldingHighlight=40]="foldingHighlight",_[_.foldingImportsByDefault=41]="foldingImportsByDefault",_[_.foldingMaximumRegions=42]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=44]="fontFamily",_[_.fontInfo=45]="fontInfo",_[_.fontLigatures=46]="fontLigatures",_[_.fontSize=47]="fontSize",_[_.fontWeight=48]="fontWeight",_[_.fontVariations=49]="fontVariations",_[_.formatOnPaste=50]="formatOnPaste",_[_.formatOnType=51]="formatOnType",_[_.glyphMargin=52]="glyphMargin",_[_.gotoLocation=53]="gotoLocation",_[_.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",_[_.hover=55]="hover",_[_.inDiffEditor=56]="inDiffEditor",_[_.inlineSuggest=57]="inlineSuggest",_[_.letterSpacing=58]="letterSpacing",_[_.lightbulb=59]="lightbulb",_[_.lineDecorationsWidth=60]="lineDecorationsWidth",_[_.lineHeight=61]="lineHeight",_[_.lineNumbers=62]="lineNumbers",_[_.lineNumbersMinChars=63]="lineNumbersMinChars",_[_.linkedEditing=64]="linkedEditing",_[_.links=65]="links",_[_.matchBrackets=66]="matchBrackets",_[_.minimap=67]="minimap",_[_.mouseStyle=68]="mouseStyle",_[_.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=70]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",_[_.multiCursorModifier=72]="multiCursorModifier",_[_.multiCursorPaste=73]="multiCursorPaste",_[_.multiCursorLimit=74]="multiCursorLimit",_[_.occurrencesHighlight=75]="occurrencesHighlight",_[_.overviewRulerBorder=76]="overviewRulerBorder",_[_.overviewRulerLanes=77]="overviewRulerLanes",_[_.padding=78]="padding",_[_.parameterHints=79]="parameterHints",_[_.peekWidgetDefaultFocus=80]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=81]="definitionLinkOpensInPeek",_[_.quickSuggestions=82]="quickSuggestions",_[_.quickSuggestionsDelay=83]="quickSuggestionsDelay",_[_.readOnly=84]="readOnly",_[_.renameOnType=85]="renameOnType",_[_.renderControlCharacters=86]="renderControlCharacters",_[_.renderFinalNewline=87]="renderFinalNewline",_[_.renderLineHighlight=88]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=89]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=90]="renderValidationDecorations",_[_.renderWhitespace=91]="renderWhitespace",_[_.revealHorizontalRightPadding=92]="revealHorizontalRightPadding",_[_.roundedSelection=93]="roundedSelection",_[_.rulers=94]="rulers",_[_.scrollbar=95]="scrollbar",_[_.scrollBeyondLastColumn=96]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=97]="scrollBeyondLastLine",_[_.scrollPredominantAxis=98]="scrollPredominantAxis",_[_.selectionClipboard=99]="selectionClipboard",_[_.selectionHighlight=100]="selectionHighlight",_[_.selectOnLineNumbers=101]="selectOnLineNumbers",_[_.showFoldingControls=102]="showFoldingControls",_[_.showUnused=103]="showUnused",_[_.snippetSuggestions=104]="snippetSuggestions",_[_.smartSelect=105]="smartSelect",_[_.smoothScrolling=106]="smoothScrolling",_[_.stickyScroll=107]="stickyScroll",_[_.stickyTabStops=108]="stickyTabStops",_[_.stopRenderingLineAfter=109]="stopRenderingLineAfter",_[_.suggest=110]="suggest",_[_.suggestFontSize=111]="suggestFontSize",_[_.suggestLineHeight=112]="suggestLineHeight",_[_.suggestOnTriggerCharacters=113]="suggestOnTriggerCharacters",_[_.suggestSelection=114]="suggestSelection",_[_.tabCompletion=115]="tabCompletion",_[_.tabIndex=116]="tabIndex",_[_.unicodeHighlighting=117]="unicodeHighlighting",_[_.unusualLineTerminators=118]="unusualLineTerminators",_[_.useShadowDOM=119]="useShadowDOM",_[_.useTabStops=120]="useTabStops",_[_.wordBreak=121]="wordBreak",_[_.wordSeparators=122]="wordSeparators",_[_.wordWrap=123]="wordWrap",_[_.wordWrapBreakAfterCharacters=124]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=125]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=126]="wordWrapColumn",_[_.wordWrapOverride1=127]="wordWrapOverride1",_[_.wordWrapOverride2=128]="wordWrapOverride2",_[_.wrappingIndent=129]="wrappingIndent",_[_.wrappingStrategy=130]="wrappingStrategy",_[_.showDeprecated=131]="showDeprecated",_[_.inlayHints=132]="inlayHints",_[_.editorClassName=133]="editorClassName",_[_.pixelRatio=134]="pixelRatio",_[_.tabFocusMode=135]="tabFocusMode",_[_.layoutInfo=136]="layoutInfo",_[_.wrappingInfo=137]="wrappingInfo"})(lt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(177,null)})),acceptSuggestionOnEnter:Le(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(178,null),""],markdownDescription:n.localize(179,null)})),accessibilitySupport:Le(new c),accessibilityPageSize:Le(new b(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(180,null),tags:["accessibility"]})),ariaLabel:Le(new w(4,"ariaLabel",n.localize(181,null))),autoClosingBrackets:Le(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(182,null),n.localize(183,null),""],description:n.localize(184,null)})),autoClosingDelete:Le(new r(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(185,null),""],description:n.localize(186,null)})),autoClosingOvertype:Le(new r(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(187,null),""],description:n.localize(188,null)})),autoClosingQuotes:Le(new r(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(189,null),n.localize(190,null),""],description:n.localize(191,null)})),autoIndent:Le(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[n.localize(192,null),n.localize(193,null),n.localize(194,null),n.localize(195,null),n.localize(196,null)],description:n.localize(197,null)})),automaticLayout:Le(new l(10,"automaticLayout",!1)),autoSurround:Le(new r(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(198,null),n.localize(199,null),n.localize(200,null),""],description:n.localize(201,null)})),bracketPairColorization:Le(new de),bracketPairGuides:Le(new ye),stickyTabStops:Le(new l(108,"stickyTabStops",!1,{description:n.localize(202,null)})),codeLens:Le(new l(14,"codeLens",!0,{description:n.localize(203,null)})),codeLensFontFamily:Le(new w(15,"codeLensFontFamily","",{description:n.localize(204,null)})),codeLensFontSize:Le(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(205,null)})),colorDecorators:Le(new l(17,"colorDecorators",!0,{description:n.localize(206,null)})),columnSelection:Le(new l(18,"columnSelection",!1,{description:n.localize(207,null)})),comments:Le(new u),contextmenu:Le(new l(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new l(21,"copyWithSyntaxHighlighting",!0,{description:n.localize(208,null)})),cursorBlinking:Le(new a(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:n.localize(209,null)})),cursorSmoothCaretAnimation:Le(new l(23,"cursorSmoothCaretAnimation",!1,{description:n.localize(210,null)})),cursorStyle:Le(new a(24,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:n.localize(211,null)})),cursorSurroundingLines:Le(new b(25,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(212,null)})),cursorSurroundingLinesStyle:Le(new r(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(213,null),n.localize(214,null)],description:n.localize(215,null)})),cursorWidth:Le(new b(27,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(216,null)})),disableLayerHinting:Le(new l(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new l(29,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new l(30,"domReadOnly",!1)),dragAndDrop:Le(new l(31,"dragAndDrop",!0,{description:n.localize(217,null)})),emptySelectionClipboard:Le(new q),dropIntoEditor:Le(new et),stickyScroll:Le(new me),extraEditorClassName:Le(new w(34,"extraEditorClassName","")),fastScrollSensitivity:Le(new p(35,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:n.localize(218,null)})),find:Le(new j),fixedOverflowWidgets:Le(new l(37,"fixedOverflowWidgets",!1)),folding:Le(new l(38,"folding",!0,{description:n.localize(219,null)})),foldingStrategy:Le(new r(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(220,null),n.localize(221,null)],description:n.localize(222,null)})),foldingHighlight:Le(new l(40,"foldingHighlight",!0,{description:n.localize(223,null)})),foldingImportsByDefault:Le(new l(41,"foldingImportsByDefault",!1,{description:n.localize(224,null)})),foldingMaximumRegions:Le(new b(42,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(225,null)})),unfoldOnClickAfterEndOfLine:Le(new l(43,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(226,null)})),fontFamily:Le(new M),fontInfo:Le(new $),fontLigatures2:Le(new P),fontSize:Le(new z),fontWeight:Le(new V),fontVariations:Le(new F),formatOnPaste:Le(new l(50,"formatOnPaste",!1,{description:n.localize(227,null)})),formatOnType:Le(new l(51,"formatOnType",!1,{description:n.localize(228,null)})),glyphMargin:Le(new l(52,"glyphMargin",!0,{description:n.localize(229,null)})),gotoLocation:Le(new X),hideCursorInOverviewRuler:Le(new l(54,"hideCursorInOverviewRuler",!1,{description:n.localize(230,null)})),hover:Le(new Z),inDiffEditor:Le(new l(56,"inDiffEditor",!1)),letterSpacing:Le(new p(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>p.clamp(_,-5,20),{description:n.localize(231,null)})),lightbulb:Le(new ce),lineDecorationsWidth:Le(new pe),lineHeight:Le(new we),lineNumbers:Le(new ae),lineNumbersMinChars:Le(new b(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new l(64,"linkedEditing",!1,{description:n.localize(232,null)})),links:Le(new l(65,"links",!0,{description:n.localize(233,null)})),matchBrackets:Le(new r(66,"matchBrackets","always",["always","near","never"],{description:n.localize(234,null)})),minimap:Le(new Fe),mouseStyle:Le(new r(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new p(69,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:n.localize(235,null)})),mouseWheelZoom:Le(new l(70,"mouseWheelZoom",!1,{markdownDescription:n.localize(236,null)})),multiCursorMergeOverlapping:Le(new l(71,"multiCursorMergeOverlapping",!0,{description:n.localize(237,null)})),multiCursorModifier:Le(new a(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],We,{markdownEnumDescriptions:[n.localize(238,null),n.localize(239,null)],markdownDescription:n.localize(240,null)})),multiCursorPaste:Le(new r(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(241,null),n.localize(242,null)],markdownDescription:n.localize(243,null)})),multiCursorLimit:Le(new b(74,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(244,null)})),occurrencesHighlight:Le(new l(75,"occurrencesHighlight",!0,{description:n.localize(245,null)})),overviewRulerBorder:Le(new l(76,"overviewRulerBorder",!0,{description:n.localize(246,null)})),overviewRulerLanes:Le(new b(77,"overviewRulerLanes",3,0,3)),padding:Le(new Xe),parameterHints:Le(new Pe),peekWidgetDefaultFocus:Le(new r(80,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(247,null),n.localize(248,null)],description:n.localize(249,null)})),definitionLinkOpensInPeek:Le(new l(81,"definitionLinkOpensInPeek",!1,{description:n.localize(250,null)})),quickSuggestions:Le(new ke),quickSuggestionsDelay:Le(new b(83,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(251,null)})),readOnly:Le(new l(84,"readOnly",!1)),renameOnType:Le(new l(85,"renameOnType",!1,{description:n.localize(252,null),markdownDeprecationMessage:n.localize(253,null)})),renderControlCharacters:Le(new l(86,"renderControlCharacters",!0,{description:n.localize(254,null),restricted:!0})),renderFinalNewline:Le(new l(87,"renderFinalNewline",!0,{description:n.localize(255,null)})),renderLineHighlight:Le(new r(88,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(256,null)],description:n.localize(257,null)})),renderLineHighlightOnlyWhenFocus:Le(new l(89,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(258,null)})),renderValidationDecorations:Le(new r(90,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new r(91,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(259,null),n.localize(260,null),n.localize(261,null),""],description:n.localize(262,null)})),revealHorizontalRightPadding:Le(new b(92,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new l(93,"roundedSelection",!0,{description:n.localize(263,null)})),rulers:Le(new D),scrollbar:Le(new H),scrollBeyondLastColumn:Le(new b(96,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(264,null)})),scrollBeyondLastLine:Le(new l(97,"scrollBeyondLastLine",!0,{description:n.localize(265,null)})),scrollPredominantAxis:Le(new l(98,"scrollPredominantAxis",!0,{description:n.localize(266,null)})),selectionClipboard:Le(new l(99,"selectionClipboard",!0,{description:n.localize(267,null),included:T.isLinux})),selectionHighlight:Le(new l(100,"selectionHighlight",!0,{description:n.localize(268,null)})),selectOnLineNumbers:Le(new l(101,"selectOnLineNumbers",!0)),showFoldingControls:Le(new r(102,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(269,null),n.localize(270,null),n.localize(271,null)],description:n.localize(272,null)})),showUnused:Le(new l(103,"showUnused",!0,{description:n.localize(273,null)})),showDeprecated:Le(new l(131,"showDeprecated",!0,{description:n.localize(274,null)})),inlayHints:Le(new Y),snippetSuggestions:Le(new r(104,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(275,null),n.localize(276,null),n.localize(277,null),n.localize(278,null)],description:n.localize(279,null)})),smartSelect:Le(new be),smoothScrolling:Le(new l(106,"smoothScrolling",!1,{description:n.localize(280,null)})),stopRenderingLineAfter:Le(new b(109,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ve),inlineSuggest:Le(new ee),suggestFontSize:Le(new b(111,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(281,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new b(112,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(282,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new l(113,"suggestOnTriggerCharacters",!0,{description:n.localize(283,null)})),suggestSelection:Le(new r(114,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(284,null),n.localize(285,null),n.localize(286,null)],description:n.localize(287,null)})),tabCompletion:Le(new r(115,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(288,null),n.localize(289,null),n.localize(290,null)],description:n.localize(291,null)})),tabIndex:Le(new b(116,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new G),unusualLineTerminators:Le(new r(118,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(292,null),n.localize(293,null),n.localize(294,null)],description:n.localize(295,null)})),useShadowDOM:Le(new l(119,"useShadowDOM",!0)),useTabStops:Le(new l(120,"useTabStops",!0,{description:n.localize(296,null)})),wordBreak:Le(new r(121,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(297,null),n.localize(298,null)],description:n.localize(299,null)})),wordSeparators:Le(new w(122,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:n.localize(300,null)})),wordWrap:Le(new r(123,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(301,null),n.localize(302,null),n.localize(303,null),n.localize(304,null)],description:n.localize(305,null)})),wordWrapBreakAfterCharacters:Le(new w(124,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new w(125,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new b(126,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(306,null)})),wordWrapOverride1:Le(new r(127,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new r(128,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new K),pixelRatio:Le(new Ie),tabFocusMode:Le(new $e),layoutInfo:Le(new oe),wrappingInfo:Le(new Ge),wrappingIndent:Le(new tt),wrappingStrategy:Le(new le)}}),define(De[126],Ce([17,18]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[127],Ce([17,18]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[128],Ce([17,18]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[129],Ce([17,18]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(De[130],Ce([17,18]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(De[131],Ce([17,18]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(De[132],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[133],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[134],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(De[135],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[136],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[137],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[138],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[139],Ce([17,18]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(De[140],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[141],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[142],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[143],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[144],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[145],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[146],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[147],Ce([1,0,11]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this.a=new Map}register(N,C){this.a.set(N,C)}updateManifest(N){if(!(!Array.isArray(N.activationEvents)||!N.contributes)&&!(typeof N.main>"u"&&typeof N.browser>"u"))for(const C in N.contributes){const R=this.a.get(C);if(!R)continue;const S=N.contributes[C],k=Array.isArray(S)?S:[S];try{R(k,N.activationEvents)}catch(O){(0,n.onUnexpectedError)(O)}}}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(De[148],Ce([1,0,22,29,128,248]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||C.test(l)}e.isValidVersionStr=S;function k(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const E=l.match(C);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=k;function O(l){if(!l)return null;const E=l.majorBase,b=l.majorMustEqual,p=l.minorBase;let w=l.minorMustEqual;const s=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(E===0||(w=!1),r=!1);let a=0;if(l.preRelease){const d=R.exec(l.preRelease);if(d){const[,c,u,t]=d;a=Date.UTC(Number(c),Number(u)-1,Number(t))}}return{majorBase:E,majorMustEqual:b,minorBase:p,minorMustEqual:w,patchBase:s,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=O;function I(l,E,b){let p;typeof l=="string"?p=O(k(l)):p=l;let w;E instanceof Date?w=E.getTime():typeof E=="string"&&(w=new Date(E).getTime());let s;if(typeof b=="string"?s=O(k(b)):s=b,!p||!s)return!1;const r=p.majorBase,a=p.minorBase,d=p.patchBase;let c=s.majorBase,u=s.minorBase,t=s.patchBase;const m=s.notBefore;let g=s.majorMustEqual,A=s.minorMustEqual,L=s.patchMustEqual;return s.isMinimum?r>c?!0:r<c?!1:a>u?!0:a<u||w&&w<m?!1:d>=t:(r===1&&c===0&&(!g||!A||!L)&&(c=1,u=0,t=0,g=!0,A=!1,L=!1),r<c?!1:r>c?!g:a<u?!1:a>u?!A:d<t?!1:d>t?!L:!(w&&w<m))}e.isValidVersion=I;function f(l,E,b,p,w){const s=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return s.push([T.default.Error,y.localize(0,null)]),s;if(typeof p.name!="string")return s.push([T.default.Error,y.localize(1,null,"name")]),s;if(typeof p.version!="string")return s.push([T.default.Error,y.localize(2,null,"version")]),s;if(!p.engines)return s.push([T.default.Error,y.localize(3,null,"engines")]),s;if(typeof p.engines.vscode!="string")return s.push([T.default.Error,y.localize(4,null,"engines.vscode")]),s;if(typeof p.extensionDependencies<"u"&&!o(p.extensionDependencies))return s.push([T.default.Error,y.localize(5,null,"extensionDependencies")]),s;if(typeof p.activationEvents<"u"){if(!o(p.activationEvents))return s.push([T.default.Error,y.localize(6,null,"activationEvents")]),s;if(typeof p.main>"u"&&typeof p.browser>"u")return s.push([T.default.Error,y.localize(7,null,"activationEvents","main")]),s}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&s.push([T.default.Warning,y.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return s.push([T.default.Error,y.localize(9,null,"main")]),s;{const d=(0,n.joinPath)(b,p.main);(0,n.isEqualOrParent)(d,b)||s.push([T.default.Warning,y.localize(10,null,d.path,b.path)])}if(typeof p.activationEvents>"u")return s.push([T.default.Error,y.localize(11,null,"activationEvents","main")]),s}if(typeof p.browser<"u"){if(typeof p.browser!="string")return s.push([T.default.Error,y.localize(12,null,"browser")]),s;{const d=(0,n.joinPath)(b,p.browser);(0,n.isEqualOrParent)(d,b)||s.push([T.default.Warning,y.localize(13,null,d.path,b.path)])}if(typeof p.activationEvents>"u")return s.push([T.default.Error,y.localize(14,null,"activationEvents","browser")]),s}if(!N.valid(p.version))return s.push([T.default.Error,y.localize(15,null)]),s;const r=[];if(!v(l,E,p,w,r))for(const d of r)s.push([T.default.Error,d]);return s}e.validateExtensionManifest=f;function v(l,E,b,p,w){return p||typeof b.main>"u"&&typeof b.browser>"u"?!0:i(l,E,b.engines.vscode,w)}e.isValidExtensionVersion=v;function h(l,E,b){return l==="*"||i(E,b,l)}e.isEngineValid=h;function i(l,E,b,p=[]){const w=O(k(b));if(!w)return p.push(y.localize(16,null,b)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return p.push(y.localize(17,null,b)),!1}else if(!w.majorMustEqual)return p.push(y.localize(18,null,b)),!1;return I(l,E,w)?!0:(p.push(y.localize(19,null,l,b)),!1)}function o(l){if(!Array.isArray(l))return!1;for(let E=0,b=l.length;E<b;E++)if(typeof l[E]!="string")return!1;return!0}}),define(De[84],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(y,N=[],C=!1){this.ctor=y,this.staticArguments=N,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=n}),define(De[61],Ce([1,0,84]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var y;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(y=e.InstantiationType||(e.InstantiationType={}));function N(R,S,k){S instanceof n.SyncDescriptor||(S=new n.SyncDescriptor(S,[],Boolean(k))),T.push([R,S])}e.registerSingleton=N;function C(){return T}e.getSingletonServiceDescriptors=C}),define(De[149],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(N,C){this.key=N,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class T{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const C of this.a.values())C.outgoing.size===0&&N.push(C);return N}insertEdge(N,C){const R=this.lookupOrInsertNode(N),S=this.lookupOrInsertNode(C);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(N){const C=this.b(N);this.a.delete(C);for(const R of this.a.values())R.outgoing.delete(C),R.incoming.delete(C)}lookupOrInsertNode(N){const C=this.b(N);let R=this.a.get(C);return R||(R=new n(C,N),this.a.set(C,R)),R}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[C,R]of this.a)N.push(`${C}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,C]of this.a){const R=new Set([N]),S=this.c(C,R);if(S)return S}}c(N,C){for(const[R,S]of N.outgoing){if(C.has(R))return[...C,R].join(" -> ");C.add(R);const k=this.c(S,C);if(k)return k;C.delete(R)}}}e.Graph=T}),define(De[3],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=R})(n=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function T(C,R,S){R[n.DI_TARGET]===R?R[n.DI_DEPENDENCIES].push({id:C,index:S}):(R[n.DI_DEPENDENCIES]=[{id:C,index:S}],R[n.DI_TARGET]=R)}function y(C){if(n.serviceIds.has(C))return n.serviceIds.get(C);const R=function(S,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(R,S,O)};return R.toString=()=>C,n.serviceIds.set(C,R),R}e.createDecorator=y;function N(C){return C}e.refineServiceDecorator=N}),define(De[40],Ce([1,0,9,2,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationOverrides=N;function C(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=C;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function k(l,E){const b=Object.create(null);for(const p in l)O(b,p,l[p],E);return b}e.toValuesTree=k;function O(l,E,b,p){const w=E.split("."),s=w.pop();let r=l;for(let a=0;a<w.length;a++){const d=w[a];let c=r[d];switch(typeof c){case"undefined":c=r[d]=Object.create(null);break;case"object":break;default:p(`Ignoring ${E} as ${w.slice(0,a+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[s]=b}catch{p(`Ignoring ${E} as ${w.join(".")} is ${JSON.stringify(r)}`)}else p(`Ignoring ${E} as ${w.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=O;function I(l,E){const b=E.split(".");f(l,b)}e.removeFromValueTree=I;function f(l,E){const b=E.shift();if(E.length===0){delete l[b];return}if(Object.keys(l).indexOf(b)!==-1){const p=l[b];typeof p=="object"&&!Array.isArray(p)&&(f(p,E),Object.keys(p).length===0&&delete l[b])}}function v(l,E,b){function p(r,a){let d=r;for(const c of a){if(typeof d!="object"||d===null)return;d=d[c]}return d}const w=E.split("."),s=p(l,w);return typeof s>"u"?b:s}e.getConfigurationValue=v;function h(l,E,b){Object.keys(E).forEach(p=>{p!=="__proto__"&&(p in l?n.isObject(l[p])&&n.isObject(E[p])?h(l[p],E[p],b):b&&(l[p]=E[p]):l[p]=E[p])})}e.merge=h;function i(l,E,b){const p=l.inspect(E),w=l.inspect(b);return typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:p.defaultValue}e.getMigratedSettingValue=i;function o(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(De[41],Ce([1,0,21,10,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const N=new Map;N.set("false",!1),N.set("true",!0),N.set("isMac",n.isMacintosh),N.set("isLinux",n.isLinux),N.set("isWindows",n.isWindows),N.set("isWeb",n.isWeb),N.set("isMacNative",n.isMacintosh&&!n.isWeb),N.set("isEdge",n.isEdge),N.set("isFirefox",n.isFirefox),N.set("isChrome",n.isChrome),N.set("isSafari",n.isSafari);const C=Object.prototype.hasOwnProperty;var R;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return I.INSTANCE}static true(){return f.INSTANCE}static has(P){return v.create(P)}static equals(P,M){return h.create(P,M)}static notEquals(P,M){return l.create(P,M)}static regex(P,M){return a.create(P,M)}static in(P,M){return i.create(P,M)}static notIn(P,M){return o.create(P,M)}static not(P){return E.create(P)}static and(...P){return u.create(P,null,!0)}static or(...P){return t.create(P,null,!0)}static greater(P,M){return p.create(P,M)}static greaterEquals(P,M){return w.create(P,M)}static smaller(P,M){return s.create(P,M)}static smallerEquals(P,M){return r.create(P,M)}static deserialize(P,M=!1){if(!!P)return this.c(P,M)}static c(P,M){const F=P.split("||");return t.create(F.map($=>this.d($,M)),null,!0)}static d(P,M){const F=P.split("&&");return u.create(F.map($=>this.f($,M)),null,!0)}static f(P,M){if(P=P.trim(),P.indexOf("!=")>=0){const F=P.split("!=");return l.create(F[0].trim(),this.g(F[1],M))}if(P.indexOf("==")>=0){const F=P.split("==");return h.create(F[0].trim(),this.g(F[1],M))}if(P.indexOf("=~")>=0){const F=P.split("=~");return a.create(F[0].trim(),this.h(F[1],M))}if(P.indexOf(" not in ")>=0){const F=P.split(" not in ");return o.create(F[0].trim(),this.g(F[1],M))}if(P.indexOf(" in ")>=0){const F=P.split(" in ");return i.create(F[0].trim(),this.g(F[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(P)){const F=P.split(">=");return w.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(P)){const F=P.split(">");return p.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(P)){const F=P.split("<=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(P)){const F=P.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(P)?E.create(P.substr(1).trim()):v.create(P)}static g(P,M){if(P=P.trim(),P==="true")return!0;if(P==="false")return!1;const F=/^'([^']*)'$/.exec(P);return F?F[1].trim():P}static h(P,M){if((0,T.isFalsyOrWhitespace)(P)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=P.indexOf("/"),$=P.lastIndexOf("/");if(F===$||F<0){if(M)throw new Error(`bad regexp-value '${P}', missing /-enclosure`);return console.warn(`bad regexp-value '${P}', missing /-enclosure`),null}const z=P.slice(F+1,$),V=P[$+1]==="i"?"i":"";try{return new RegExp(z,V)}catch(X){if(M)throw new Error(`bad regexp-value '${P}', parse error: ${X}`);return console.warn(`bad regexp-value '${P}', parse error: ${X}`),null}}}e.ContextKeyExpr=S;function k(j,P){const M=j?j.substituteConstants():void 0,F=P?P.substituteConstants():void 0;return!M&&!F?!0:!M||!F?!1:M.equals(F)}e.expressionsAreEqualWithConstantSubstitution=k;function O(j,P){return j.cmp(P)}class I{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class f{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class v{static create(P,M=null){const F=N.get(P);return typeof F=="boolean"?F?f.INSTANCE:I.INSTANCE:new v(P,M)}constructor(P,M){this.key=P,this.c=M,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:g(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=N.get(this.key);return typeof P=="boolean"?P?f.INSTANCE:I.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=E.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=v;class h{static create(P,M,F=null){if(typeof M=="boolean")return M?v.create(P,F):E.create(P,F);const $=N.get(P);return typeof $=="boolean"?M===($?"true":"false")?f.INSTANCE:I.INSTANCE:new h(P,M,F)}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=N.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?f.INSTANCE:I.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class i{static create(P,M){return new i(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:A(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.f),F=P.getValue(this.d);return Array.isArray(M)?M.includes(F):typeof F=="string"&&typeof M=="object"&&M!==null?C.call(M,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=i;class o{static create(P,M){return new o(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=11,this.c=i.create(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class l{static create(P,M,F=null){if(typeof M=="boolean")return M?E.create(P,F):v.create(P,F);const $=N.get(P);return typeof $=="boolean"?M===($?"true":"false")?I.INSTANCE:f.INSTANCE:new l(P,M,F)}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=N.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?I.INSTANCE:f.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class E{static create(P,M=null){const F=N.get(P);return typeof F=="boolean"?F?I.INSTANCE:f.INSTANCE:new E(P,M)}constructor(P,M){this.c=P,this.d=M,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:g(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=N.get(this.c);return typeof P=="boolean"?P?I.INSTANCE:f.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.ContextKeyNotExpr=E;function b(j,P){if(typeof j=="string"){const M=parseFloat(j);isNaN(M)||(j=M)}return typeof j=="string"||typeof j=="number"?P(j):I.INSTANCE}class p{static create(P,M,F=null){return b(M,$=>new p(P,$,F))}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=p;class w{static create(P,M,F=null){return b(M,$=>new w(P,$,F))}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class s{static create(P,M,F=null){return b(M,$=>new s(P,$,F))}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class r{static create(P,M,F=null){return b(M,$=>new r(P,$,F))}constructor(P,M,F){this.c=P,this.d=M,this.f=F,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class a{static create(P,M){return new a(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const M=this.f?this.f.source:"",F=P.f?P.f.source:"";return M<F?-1:M>F?1:0}equals(P){if(P.type===this.type){const M=this.f?this.f.source:"",F=P.f?P.f.source:"";return this.d===P.d&&M===F}return!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=d.create(this)),this.c}}e.ContextKeyRegexExpr=a;class d{static create(P){return new d(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(P){return new d(this.c.map(P))}negate(){return this.c}}e.ContextKeyNotRegexExpr=d;function c(j){let P=null;for(let M=0,F=j.length;M<F;M++){const $=j[M].substituteConstants();if(j[M]!==$&&P===null){P=[];for(let z=0;z<M;z++)P[z]=j[z]}P!==null&&(P[M]=$)}return P===null?j:P}class u{static create(P,M,F){return u.d(P,M,F)}constructor(P,M){this.expr=P,this.c=M,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const $=O(this.expr[M],P.expr[M]);if($!==0)return $}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=c(this.expr);return P===this.expr?this:u.create(P,this.c,!1)}evaluate(P){for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static d(P,M,F){const $=[];let z=!1;for(const V of P)if(!!V){if(V.type===1){z=!0;continue}if(V.type===0)return I.INSTANCE;if(V.type===6){$.push(...V.expr);continue}$.push(V)}if($.length===0&&z)return f.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(O);for(let V=1;V<$.length;V++)$[V-1].equals($[V])&&($.splice(V,1),V--);if($.length===1)return $[0];for(;$.length>1;){const V=$[$.length-1];if(V.type!==9)break;$.pop();const X=$.pop(),Z=$.length===0,fe=t.create(V.expr.map(oe=>u.create([oe,X],null,F)),null,Z);fe&&($.push(fe),$.sort(O))}if($.length===1)return $[0];if(F){for(let V=0;V<$.length;V++)for(let X=V+1;X<$.length;X++)if($[V].negate().equals($[X]))return I.INSTANCE;if($.length===1)return $[0]}return new u($,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new u(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());this.c=t.create(P,this,!0)}return this.c}}class t{static create(P,M,F){return t.d(P,M,F)}constructor(P,M){this.expr=P,this.c=M,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const $=O(this.expr[M],P.expr[M]);if($!==0)return $}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=c(this.expr);return P===this.expr?this:t.create(P,this.c,!1)}evaluate(P){for(let M=0,F=this.expr.length;M<F;M++)if(this.expr[M].evaluate(P))return!0;return!1}static d(P,M,F){let $=[],z=!1;if(P){for(let V=0,X=P.length;V<X;V++){const Z=P[V];if(!!Z){if(Z.type===0){z=!0;continue}if(Z.type===1)return f.INSTANCE;if(Z.type===9){$=$.concat(Z.expr);continue}$.push(Z)}}if($.length===0&&z)return I.INSTANCE;$.sort(O)}if($.length!==0){if($.length===1)return $[0];for(let V=1;V<$.length;V++)$[V-1].equals($[V])&&($.splice(V,1),V--);if($.length===1)return $[0];if(F){for(let V=0;V<$.length;V++)for(let X=V+1;X<$.length;X++)if($[V].negate().equals($[X]))return f.INSTANCE;if($.length===1)return $[0]}return new t($,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new t(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),F=P.shift(),$=[];for(const z of q(M))for(const V of q(F))$.push(u.create([z,V],null,!1));P.unshift(t.create($,null,!1))}this.c=t.create(P,this,!0)}return this.c}}class m extends v{static all(){return m.d.values()}constructor(P,M,F){super(P,null),this.f=M,typeof F=="object"?m.d.push({...F,key:P}):F!==!0&&m.d.push({key:P,description:F,type:M!=null?typeof M:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return h.create(this.key,P)}notEqualsTo(P){return l.create(this.key,P)}}e.RawContextKey=m,m.d=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(j,P){return j<P?-1:j>P?1:0}function A(j,P,M,F){return j<M?-1:j>M?1:P<F?-1:P>F?1:0}function L(j,P){if(j.type===0||P.type===1)return!0;if(j.type===9)return P.type===9?K(j.expr,P.expr):!1;if(P.type===9){for(const M of P.expr)if(L(j,M))return!0;return!1}if(j.type===6){if(P.type===6)return K(P.expr,j.expr);for(const M of j.expr)if(L(M,P))return!0;return!1}return j.equals(P)}e.implies=L;function K(j,P){let M=0,F=0;for(;M<j.length&&F<P.length;){const $=j[M].cmp(P[F]);if($<0)return!1;$===0&&M++,F++}return M===j.length}function q(j){return j.type===9?j.expr:[j]}}),define(De[150],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(De[85],Ce([1,0,127,3]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function N(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function C(l,E){switch(l){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function R(l,E){return E==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function S(l,E,b){return R(E,b)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===b?!0:k(b).includes(l)}e.isTargetPlatformCompatible=S;function k(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function O(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=O;var I;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var f;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var i;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(i=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(E,b){super(E),this.code=b,this.name=b}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[36],Ce([1,0,46,19,10,9,2,129,3]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var O;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var I;(function(z){z[z.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var f;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=v;function h(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=h;function i(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=i;function o(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function l(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=l;function E(z){return v(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var b;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(V,X){super(V),this.code=X}}e.FileSystemProviderError=p;function w(z,V){const X=new p(z.toString(),V);return r(X,V),X}e.createFileSystemProviderError=w;function s(z){return z||w((0,R.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function r(z,V){return z.name=V?`${V} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=r;function a(z){if(!z)return b.Unknown;if(z instanceof p)return z.code;const V=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!V)return b.Unknown;switch(V[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=a;function d(z){if(z instanceof A)return z.fileOperationResult;switch(a(z)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=d;var c;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class u{constructor(V,X,Z){this.resource=V,this.operation=X,this.target=Z}isOperation(V){return this.operation===V}}e.FileOperationEvent=u;var t;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(t=e.FileChangeType||(e.FileChangeType={}));class m{constructor(V,X){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=V;const Z=new Map;for(const fe of V){const oe=Z.get(fe.type);switch(oe?oe.push([fe.resource,fe]):Z.set(fe.type,[[fe.resource,fe]]),fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}}for(const[fe,oe]of Z)switch(fe){case 1:this.a=n.TernarySearchTree.forUris(()=>X),this.a.fill(oe);break;case 0:this.b=n.TernarySearchTree.forUris(()=>X),this.b.fill(oe);break;case 2:this.c=n.TernarySearchTree.forUris(()=>X),this.c.fill(oe);break}}contains(V,...X){return this.d(V,{includeChildren:!1},...X)}affects(V,...X){return this.d(V,{includeChildren:!0},...X)}d(V,X,...Z){if(!V)return!1;const fe=Z.length>0;return!!((!fe||Z.includes(1))&&(this.a?.get(V)||X.includeChildren&&this.a?.findSuperstr(V))||(!fe||Z.includes(0))&&(this.b?.get(V)||X.includeChildren&&this.b?.findSuperstr(V))||(!fe||Z.includes(2))&&(this.c?.findSubstr(V)||X.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=m;function g(z,V,X){return!z||!V||z===V||V.length>z.length?!1:(V.charAt(V.length-1)!==T.sep&&(V+=T.sep),X?(0,y.startsWithIgnoreCase)(z,V):z.indexOf(V)===0)}e.isParent=g;class A extends Error{constructor(V,X,Z){super(V),this.fileOperationResult=X,this.options=Z}}e.FileOperationError=A;class L extends A{constructor(V,X,Z){super(V,2,Z),this.stat=X}}e.NotModifiedSinceFileOperationError=L;var K;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(K=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var q;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function j(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=j;async function P(z,V){if(!V.hasProvider(C.URI.from({scheme:z.scheme})))return new Promise(X=>{const Z=V.onDidChangeFileSystemProviderRegistrations(fe=>{fe.scheme===z.scheme&&fe.added&&(Z.dispose(),X())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(V){return(0,N.isNumber)(V)||(V=0),V<M.KB?(0,R.localize)(1,null,V.toFixed(0)):V<M.MB?(0,R.localize)(2,null,(V/M.KB).toFixed(2)):V<M.GB?(0,R.localize)(3,null,(V/M.MB).toFixed(2)):V<M.TB?(0,R.localize)(4,null,(V/M.GB).toFixed(2)):(0,R.localize)(5,null,(V/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var F;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(z){return{maxFileSize:z===0?300*M.MB:16*M.GB,maxHeapSize:z===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=$}),define(De[62],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...y){this.a=new Map;for(const[N,C]of y)this.set(N,C)}set(y,N){const C=this.a.get(y);return this.a.set(y,N),C}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.ServiceCollection=n}),define(De[151],Ce([1,0,15,11,7,84,149,3,62,152]),function(te,e,n,T,y,N,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class I extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class f{constructor(o=new S.ServiceCollection,l=!1,E,b=O){this.f=o,this.g=l,this.h=E,this.i=b,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=b?E?._globalGraph??new C.Graph(p=>p):void 0}createChild(o){return new f(o,this.g,this,this.i)}invokeFunction(o,...l){const E=h.traceInvocation(this.i,o);let b=!1;try{return o({get:w=>{if(b)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(w,E);if(!s)throw new Error(`[invokeFunction] unknown service '${w}'`);return s}},...l)}finally{b=!0,E.stop()}}createInstance(o,...l){let E,b;return o instanceof N.SyncDescriptor?(E=h.traceCreation(this.i,o.ctor),b=this.j(o.ctor,o.staticArguments.concat(l),E)):(E=h.traceCreation(this.i,o),b=this.j(o,l,E)),E.stop(),b}j(o,l=[],E){const b=R._util.getServiceDependencies(o).sort((s,r)=>s.index-r.index),p=[];for(const s of b){const r=this.m(s.id,E);r||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${s.id}.`,!1),p.push(r)}const w=b.length>0?b[0].index:l.length;if(l.length!==w){console.trace(`[createInstance] First service dependency of ${o.name} at position ${w+1} conflicts with ${l.length} static arguments`);const s=w-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,w)}return Reflect.construct(o,l.concat(p))}k(o,l){if(this.f.get(o)instanceof N.SyncDescriptor)this.f.set(o,l);else if(this.h)this.h.k(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const l=this.f.get(o);return!l&&this.h?this.h.l(o):l}m(o,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const E=this.l(o);return E instanceof N.SyncDescriptor?this.q(o,E,l.branch(o,!0)):(l.branch(o,!1),E)}q(o,l,E){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,l,E)}finally{this.o.delete(o)}}r(o,l,E){const b=new C.Graph(s=>s.id.toString());let p=0;const w=[{id:o,desc:l,_trace:E}];for(;w.length;){const s=w.pop();if(b.lookupOrInsertNode(s),p++>1e3)throw new I(b);for(const r of R._util.getServiceDependencies(s.desc.ctor)){const a=this.l(r.id);if(a||this.u(`[createInstance] ${o} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(r.id)),a instanceof N.SyncDescriptor){const d={id:r.id,desc:a,_trace:s._trace.branch(r.id,!0)};b.insertEdge(s,d),w.push(d)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new I(b);break}for(const{data:r}of s){if(this.l(r.id)instanceof N.SyncDescriptor){const d=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,d)}b.removeNode(r)}}return this.l(o)}s(o,l,E=[],b,p){if(this.f.get(o)instanceof N.SyncDescriptor)return this.t(o,l,E,b,p);if(this.h)return this.h.s(o,l,E,b,p);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(o,l,E=[],b,p){if(b){const w=new f(void 0,this.g,this,this.i);w.c=String(o);const s=new Map,r=new n.IdleValue(()=>{const a=w.j(l,E,p);for(const[d,c]of s){const u=a[d];if(typeof u=="function")for(const t of c)u.apply(a,t)}return s.clear(),a});return new Proxy(Object.create(null),{get(a,d){if(!r.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let t=s.get(d);return t||(t=new k.LinkedList,s.set(d,t)),(g,A,L)=>{const K=t.push([g,A,L]);return(0,y.toDisposable)(K)}}if(d in a)return a[d];const c=r.value;let u=c[d];return typeof u!="function"||(u=u.bind(c),a[d]=u),u},set(a,d,c){return r.value[d]=c,!0}})}else return this.j(l,E,p)}u(o,l){if(l&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=f;var v;(function(i){i[i.Creation=0]="Creation",i[i.Invocation=1]="Invocation",i[i.Branch=2]="Branch"})(v||(v={}));class h{static traceInvocation(o,l){return o?new h(1,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(o,l){return o?new h(0,l.name):h.c}constructor(o,l){this.type=o,this.name=l,this.g=Date.now(),this.h=[]}branch(o,l){const E=new h(2,o.toString());return this.h.push([o,l,E]),E}stop(){const o=Date.now()-this.g;h.f+=o;let l=!1;function E(p,w){const s=[],r=new Array(p+1).join("	");for(const[a,d,c]of w.h)if(d&&c){l=!0,s.push(`${r}CREATES -> ${a}`);const u=E(p+1,c);u&&s.push(u)}else s.push(`${r}uses -> ${a}`);return s.join(`
`)}const b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(o>2||l)&&h.all.add(b.join(`
`))}}e.Trace=h,h.all=new Set,h.c=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h.f=0}),define(De[12],Ce([1,0,45,5,7,28,21,2,3]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function k(){return new Date().toISOString()}var O;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(O=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=O.Info;function I(u,t,m){switch(t){case O.Trace:u.trace(m);break;case O.Debug:u.debug(m);break;case O.Info:u.info(m);break;case O.Warning:u.warn(m);break;case O.Error:u.error(m);break;default:throw new Error(`Invalid log level ${t}`)}}e.log=I;function f(u){let t="";for(let m=0;m<u.length;m++){let g=u[m];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}t+=(m>0?" ":"")+g}return t}e.format=f;class v extends y.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(t){this.b!==t&&(this.b=t,this.c.fire(this.b))}getLevel(){return this.b}}e.AbstractLogger=v;class h extends v{constructor(t){super(),this.g=t}h(t){return this.g||this.getLevel()<=t}trace(t,...m){this.h(O.Trace)&&this.f(O.Trace,f([t,...m]))}debug(t,...m){this.h(O.Debug)&&this.f(O.Debug,f([t,...m]))}info(t,...m){this.h(O.Info)&&this.f(O.Info,f([t,...m]))}warn(t,...m){this.h(O.Warning)&&this.f(O.Warning,f([t,...m]))}error(t,...m){if(this.h(O.Error))if(t instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=t.stack,this.f(O.Error,f(g))}else this.f(O.Error,f([t,...m]))}flush(){}}e.AbstractMessageLogger=h;class i extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.f=!C.isWindows}trace(t,...m){this.getLevel()<=O.Trace&&(this.f?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,t,...m):console.log(`[main ${k()}]`,t,...m))}debug(t,...m){this.getLevel()<=O.Debug&&(this.f?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,t,...m):console.log(`[main ${k()}]`,t,...m))}info(t,...m){this.getLevel()<=O.Info&&(this.f?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,t,...m):console.log(`[main ${k()}]`,t,...m))}warn(t,...m){this.getLevel()<=O.Warning&&(this.f?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,t,...m):console.warn(`[main ${k()}]`,t,...m))}error(t,...m){this.getLevel()<=O.Error&&(this.f?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,t,...m):console.error(`[main ${k()}]`,t,...m))}dispose(){}flush(){}}e.ConsoleMainLogger=i;class o extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...m){this.getLevel()<=O.Trace&&console.log("%cTRACE","color: #888",t,...m)}debug(t,...m){this.getLevel()<=O.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...m)}info(t,...m){this.getLevel()<=O.Info&&console.log("%c INFO","color: #33f",t,...m)}warn(t,...m){this.getLevel()<=O.Warning&&console.log("%c WARN","color: #993",t,...m)}error(t,...m){this.getLevel()<=O.Error&&console.log("%c  ERR","color: #f33",t,...m)}dispose(){}flush(){}}e.ConsoleLogger=o;class l extends v{constructor(t,m=e.DEFAULT_LOG_LEVEL){super(),this.f=t,this.setLevel(m)}trace(t,...m){this.getLevel()<=O.Trace&&this.f.log(O.Trace,[this.g(t),...m])}debug(t,...m){this.getLevel()<=O.Debug&&this.f.log(O.Debug,[this.g(t),...m])}info(t,...m){this.getLevel()<=O.Info&&this.f.log(O.Info,[this.g(t),...m])}warn(t,...m){this.getLevel()<=O.Warning&&this.f.log(O.Warning,[this.g(t),...m])}error(t,...m){this.getLevel()<=O.Error&&this.f.log(O.Error,[this.g(t),...m])}g(t){return typeof t=="string"?t:(0,n.toErrorMessage)(t,this.getLevel()<=O.Trace)}dispose(){}flush(){}}e.AdapterLogger=l;class E extends v{constructor(t){super(),this.f=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const m of this.f)m.setLevel(t);super.setLevel(t)}trace(t,...m){for(const g of this.f)g.trace(t,...m)}debug(t,...m){for(const g of this.f)g.debug(t,...m)}info(t,...m){for(const g of this.f)g.info(t,...m)}warn(t,...m){for(const g of this.f)g.warn(t,...m)}error(t,...m){for(const g of this.f)g.error(t,...m)}flush(){for(const t of this.f)t.flush()}dispose(){for(const t of this.f)t.dispose()}}e.MultiplexLogService=E;class b extends y.Disposable{constructor(t){super(),this.b=t,this.B(t)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(t){this.b.setLevel(t)}getLevel(){return this.b.getLevel()}trace(t,...m){this.b.trace(t,...m)}debug(t,...m){this.b.debug(t,...m)}info(t,...m){this.b.info(t,...m)}warn(t,...m){this.b.warn(t,...m)}error(t,...m){this.b.error(t,...m)}flush(){this.b.flush()}}e.LogService=b;class p extends y.Disposable{constructor(t,m){super(),this.c=t,this.b=new N.ResourceMap,this.B(m(g=>this.setLevel(g)))}getLoggers(){return[...this.b.values()].map(({logger:t})=>t)}getLogger(t){return this.b.get(t)?.logger}createLogger(t,m,g){let A=this.b.get(t)?.logger;return A||(g=m?.always?O.Trace:g,A=this.f(t,g??this.c,m),this.b.set(t,{logger:A,logLevel:g})),A}setLevel(t,m){const g=R.URI.isUri(t)?t:void 0,A=g?m:t;if(g){const L=this.b.get(g);L&&L.logLevel!==A&&(L.logLevel=A,L.logger.setLevel(A))}else this.c=A,this.b.forEach(({logLevel:L,logger:K})=>{L===void 0&&K.setLevel(this.c)})}getLogLevel(t){return this.b.get(t)?.logLevel}dispose(){this.b.forEach(({logger:t})=>t.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=p;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return O.Info}trace(t,...m){}debug(t,...m){}info(t,...m){}warn(t,...m){}error(t,...m){}critical(t,...m){}dispose(){}flush(){}}e.NullLogger=w;class s extends w{}e.NullLogService=s;class r extends p{constructor(){super(O.Info,T.Event.None)}f(t,m,g){return new w}}e.NullLoggerService=r;function a(u){if(u.verbose)return O.Trace;if(typeof u.logLevel=="string"){const t=c(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function d(u){switch(u){case O.Trace:return"trace";case O.Debug:return"debug";case O.Info:return"info";case O.Warning:return"warn";case O.Error:return"error";case O.Off:return"off"}}e.LogLevelToString=d;function c(u){switch(u){case"trace":return O.Trace;case"debug":return O.Debug;case"info":return O.Info;case"warn":return O.Warning;case"error":return O.Error;case"critical":return O.Error;case"off":return O.Off}}e.parseLogLevel=c}),define(De[86],Ce([1,0,29,130,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(N=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(h,i){return i-h}S.compare=k;const O=Object.create(null);O[S.Error]=(0,T.localize)(0,null),O[S.Warning]=(0,T.localize)(1,null),O[S.Info]=(0,T.localize)(2,null);function I(h){return O[h]||""}S.toString=I;function f(h){switch(h){case n.default.Error:return S.Error;case n.default.Warning:return S.Warning;case n.default.Info:return S.Info;case n.default.Ignore:return S.Hint}}S.fromSeverity=f;function v(h){switch(h){case S.Error:return n.default.Error;case S.Warning:return n.default.Warning;case S.Info:return n.default.Info;case S.Hint:return n.default.Ignore}}S.toSeverity=v}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(S){const k="";function O(f){return I(f,!0)}S.makeKey=O;function I(f,v){const h=[k];return f.source?h.push(f.source.replace("\xA6","\\\xA6")):h.push(k),f.code?typeof f.code=="string"?h.push(f.code.replace("\xA6","\\\xA6")):h.push(f.code.value.replace("\xA6","\\\xA6")):h.push(k),f.severity!==void 0&&f.severity!==null?h.push(C.toString(f.severity)):h.push(k),f.message&&v?h.push(f.message.replace("\xA6","\\\xA6")):h.push(k),f.startLineNumber!==void 0&&f.startLineNumber!==null?h.push(f.startLineNumber.toString()):h.push(k),f.startColumn!==void 0&&f.startColumn!==null?h.push(f.startColumn.toString()):h.push(k),f.endLineNumber!==void 0&&f.endLineNumber!==null?h.push(f.endLineNumber.toString()):h.push(k),f.endColumn!==void 0&&f.endColumn!==null?h.push(f.endColumn.toString()):h.push(k),h.push(k),h.join("\xA6")}S.makeKeyOptionalMessage=I})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(De[153],Ce([1,0,5,29,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,y.createDecorator)("notificationService");var N;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(N=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new S,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=R;class S{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=S}),define(De[87],Ce([1,0,10,2,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function N(k,O){return T.URI.isUri(k)?(0,n.equalsIgnoreCase)(k.scheme,O):(0,n.startsWithIgnoreCase)(k,O+":")}e.matchesScheme=N;function C(k,...O){return O.some(I=>N(k,I))}e.matchesSomeScheme=C;function R(k,O){return k.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=R;function S(k){let O;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return I&&(O={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},k=k.with({fragment:""})),{selection:O,uri:k}}e.extractSelection=S}),define(De[154],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__decorate||function(te,e,n,T){var y=arguments.length,N=y<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,n):T,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(te,e,n,T);else for(var R=te.length-1;R>=0;R--)(C=te[R])&&(N=(y<3?C(N):y>3?C(e,n,N):C(e,n))||N);return y>3&&N&&Object.defineProperty(e,n,N),N},je=this&&this.__param||function(te,e){return function(n,T){e(n,T,te)}};define(De[155],Ce([1,0,15,20,7,3]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var C;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(I){this.b=I}report(I){this.a=I,this.b(this.a)}}e.Progress=R,R.None=Object.freeze({report(){}});let S=class extends y.Disposable{constructor(I,f){super(),this.a=new n.DeferredPromise,f.withProgress(I,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,y.toDisposable)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};S=Ve([je(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends y.Disposable{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new y.DisposableStore)}start(I){this.stop();const f=++this.a,v=new T.CancellationTokenSource;return this.f=setTimeout(()=>{f===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,y.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,y.toDisposable)(()=>v.cancel())),this.b.add((0,y.toDisposable)(()=>this.c?this.c.done():void 0)),{id:f,token:v.token,stop:()=>this.h(f),isCurrent:()=>this.a===f}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(De[30],Ce([1,0,47,9]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.a=new Map}add(C,R){n.ok(T.isString(C)),n.ok(T.isObject(R)),n.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,R)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new y}),define(De[88],Ce([1,0,5,30]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class N{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,k){this.a[y(S)]=k,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new N;T.Registry.add(e.Extensions.JSONContribution,C)}),define(De[89],Ce([1,0,16,5,9,126,40,88,30]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=S.Registry.as(R.Extensions.JSONContribution);class f{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const a=this.k(s,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(s){const r=this.l(s);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:s,remove:r}){const a=[];a.push(...this.l(r)),a.push(...this.k(s,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,n.distinct)(a)})}registerDefaultConfigurations(s){const r=[],a=[];for(const{overrides:d,source:c}of s)for(const u in d)if(r.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const t=this.a.get(u),m=t?.valuesSources??new Map;if(c)for(const K of Object.keys(d[u]))m.set(K,c);const g={...t?.value||{},...d[u]};this.a.set(u,{source:c,value:g,valuesSources:m});const A=(0,C.getLanguageTagSettingPlainKey)(u),L={type:"object",default:g,description:N.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:y.isString(c)?void 0:c,defaultValueSource:c};a.push(...i(u)),this.d[u]=L,this.b.properties[u]=L}else{this.a.set(u,{value:d[u],source:c});const t=this.d[u];t&&(this.s(u,t),this.o(u,t))}this.registerOverrideIdentifiers(a),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:a,source:d}of s)for(const c in a){const u=this.a.get(c),t=y.isString(d)?d:d?.id,m=y.isString(u?.source)?u?.source:u?.source?.id;if(t===m)if(r.push(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const g=this.d[c];g&&(this.s(c,g),this.o(c,g))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){for(const r of s)this.h.add(r);this.q()}k(s,r){const a=[];return s.forEach(d=>{a.push(...this.m(d,r,d.extensionInfo,d.restrictedProperties)),this.c.push(d),this.n(d)}),a}l(s){const r=[],a=d=>{if(d.properties)for(const c in d.properties){r.push(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.p(c,d.properties[c])}d.allOf?.forEach(c=>a(c))};for(const d of s){a(d);const c=this.c.indexOf(d);c!==-1&&this.c.splice(c,1)}return r}m(s,r=!0,a,d,c=3){c=y.isUndefinedOrNull(s.scope)?c:s.scope;const u=[],t=s.properties;if(t)for(const g in t){const A=t[g];if(r&&b(g,A)){delete t[g];continue}if(A.source=a,A.defaultDefaultValue=t[g].default,this.s(g,A),e.OVERRIDE_PROPERTY_REGEX.test(g)?A.scope=void 0:(A.scope=y.isUndefinedOrNull(A.scope)?c:A.scope,A.restricted=y.isUndefinedOrNull(A.restricted)?!!d?.includes(g):A.restricted),t[g].hasOwnProperty("included")&&!t[g].included){this.f[g]=t[g],delete t[g];continue}else this.d[g]=t[g],t[g].policy?.name&&this.e.set(t[g].policy.name,g);!t[g].deprecationMessage&&t[g].markdownDeprecationMessage&&(t[g].deprecationMessage=t[g].markdownDeprecationMessage),u.push(g)}const m=s.allOf;if(m)for(const g of m)u.push(...this.m(g,r,a,d,c));return u}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(s){const r=a=>{const d=a.properties;if(d)for(const u in d)this.o(u,d[u]);a.allOf?.forEach(r)};r(s)}o(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.g.properties[s]=r;break}}p(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}q(){for(const s of this.h.values()){const r=`[${s}]`,a={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this.i.fire()}r(){const s={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}s(s,r){const a=this.a.get(s);let d=a?.value,c=a?.source;y.isUndefined(d)&&(d=r.defaultDefaultValue,c=void 0),y.isUndefined(d)&&(d=l(r.type)),r.default=d,r.defaultValueSource=c}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function i(w){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let r=h.exec(w);for(;r?.length;){const a=r[1].trim();a&&s.push(a),r=h.exec(w)}}return(0,n.distinct)(s)}e.overrideIdentifiersFromKey=i;function o(w){return w.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=o;function l(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const E=new f;S.Registry.add(e.Extensions.Configuration,E);function b(w,s){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?N.localize(7,null,w):E.getConfigurationProperties()[w]!==void 0?N.localize(8,null,w):s.policy?.name&&E.getPolicyConfigurations().get(s.policy?.name)!==void 0?N.localize(9,null,w,s.policy?.name,E.getPolicyConfigurations().get(s.policy?.name)):null:N.localize(6,null)}e.validateProperty=b;function p(){const w=[],s=E.getConfigurationProperties();for(const r of Object.keys(s))w.push([r,s[r].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=p}),define(De[156],Ce([1,0,16,5,107,7,28,23,9,2,40,89,30]),function(te,e,n,T,y,N,C,R,S,k,O,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(r={},a=[],d=[],c){this.c=r,this.d=a,this.f=d,this.raw=c,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof v)return a;const d=new h("");return d.parseRaw(a),d.configurationModel});this.g=r.reduce((a,d)=>d===a?d:a.merge(d),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const d=this.rawConfiguration.getValue(r),c=a?this.rawConfiguration.getOverrideValue(r,a):void 0,u=a?this.rawConfiguration.override(a).getValue(r):d;return{value:d,override:c,merged:u}}getOverrideValue(r,a){const d=this.l(a);return d?r?(0,O.getConfigurationValue)(d,r):d:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const d of this.overrides)d.identifiers.includes(r)&&a.push(...d.keys);return n.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return n.distinct(r)}override(r){let a=this.b.get(r);return a||(a=this.h(r),this.b.set(r,a)),a}merge(...r){const a=R.deepClone(this.contents),d=R.deepClone(this.overrides),c=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const t of r)if(u.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.j(a,t.contents);for(const m of t.overrides){const[g]=d.filter(A=>n.equals(A.identifiers,m.identifiers));g?(this.j(g.contents,m.contents),g.keys.push(...m.keys),g.keys=n.distinct(g.keys)):d.push(R.deepClone(m))}for(const m of t.keys)c.indexOf(m)===-1&&c.push(m)}return new v(a,c,d,u.every(t=>t instanceof v)?void 0:u)}freeze(){return this.a=!0,this}clone(){return new v(R.deepClone(this.contents),[...this.keys],R.deepClone(this.overrides))}h(r){const a=this.l(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const d={};for(const c of n.distinct([...Object.keys(this.contents),...Object.keys(a)])){let u=this.contents[c];const t=a[c];t&&(typeof u=="object"&&typeof t=="object"?(u=R.deepClone(u),this.j(u,t)):u=t),d[c]=u}return new v(d,this.keys,this.overrides)}j(r,a){for(const d of Object.keys(a)){if(d in r&&S.isObject(r[d])&&S.isObject(a[d])){this.j(r[d],a[d]);continue}r[d]=R.deepClone(a[d])}}k(r){return this.a&&!Object.isFrozen(r)?R.deepFreeze(r):r}l(r){let a=null,d=null;const c=u=>{u&&(d?this.j(d,u):d=R.deepClone(u))};for(const u of this.overrides)n.equals(u.identifiers,[r])?a=u.contents:u.identifiers.includes(r)&&c(u.contents);return c(a),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,a){this.m(r),(0,O.addToValueTree)(this.contents,r,a,d=>{throw new Error(d)})}removeValue(r){this.n(r)&&(0,O.removeFromValueTree)(this.contents,r)}m(r){let a=this.keys.length;for(let d=0;d<a;d++)r.indexOf(this.keys[d])===0&&(a=d);this.keys.splice(a,1,r)}n(r){const a=this.keys.indexOf(r);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,a){if(!S.isUndefinedOrNull(r)){const d=this.g(r);this.parseRaw(d,a)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,a){this.a=r;const{contents:d,keys:c,overrides:u,restricted:t,hasExcludedProperties:m}=this.h(r,a);this.b=new v(d,c,u,m?[r]:void 0),this.c=t||[]}g(r){let a={},d=null,c=[];const u=[],t=[];function m(A){Array.isArray(c)?c.push(A):d!==null&&(c[d]=A)}const g={onObjectBegin:()=>{const A={};m(A),u.push(c),c=A,d=null},onObjectProperty:A=>{d=A},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const A=[];m(A),u.push(c),c=A,d=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:m,onError:(A,L,K)=>{t.push({error:A,offset:L,length:K})}};if(r)try{y.visit(r,g),a=c[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return a}h(r,a){const d=f.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),c=this.j(r,d,!0,a);r=c.raw;const u=(0,O.toValuesTree)(r,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),t=Object.keys(r),m=this.l(r,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:u,keys:t,overrides:m,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(r,a,d,c){let u=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:u};const t={},m=[];for(const g in r)if(I.OVERRIDE_PROPERTY_REGEX.test(g)&&d){const A=this.j(r[g],a,!1,c);t[g]=A.raw,u=u||A.hasExcludedProperties,m.push(...A.restricted)}else{const A=a[g],L=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&m.push(g),(L===void 0||c.scopes===void 0||c.scopes.includes(L))&&!(c.skipRestricted&&A?.restricted)?t[g]=r[g]:u=!0}return{raw:t,restricted:m,hasExcludedProperties:u}}l(r,a){const d=[];for(const c of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(c)){const u={};for(const t in r[c])u[t]=r[c][t];d.push({identifiers:(0,I.overrideIdentifiersFromKey)(c),keys:Object.keys(u),contents:(0,O.toValuesTree)(u,a)})}return d}}e.ConfigurationModelParser=h;class i extends N.Disposable{constructor(r,a,d,c){super(),this.f=r,this.g=a,this.h=c,this.c=this.B(new T.Emitter),this.onDidChange=this.c.event,this.a=new h(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(d.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(T.Event.any(T.Event.filter(this.h.onDidFilesChange,u=>u.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&d.isEqual(u.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new v}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=i;class o{constructor(r,a,d,c,u,t,m,g,A,L,K,q,j){this.a=r,this.b=a,this.value=d,this.overrideIdentifiers=c,this.c=u,this.d=t,this.f=m,this.g=g,this.h=A,this.j=L,this.k=K,this.l=q,this.m=j}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get A(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(r,a,d,c,u=new v,t=new v,m=new C.ResourceMap,g=new v,A=new C.ResourceMap,L=!0){this.c=r,this.d=a,this.f=d,this.g=c,this.h=u,this.j=t,this.l=m,this.m=g,this.n=A,this.p=L,this.a=null,this.b=new C.ResourceMap,this.q=null}getValue(r,a,d){return this.s(r,a,d).getValue(r)}updateValue(r,a,d={}){let c;d.resource?(c=this.n.get(d.resource),c||(c=new v,this.n.set(d.resource,c))):c=this.m,a===void 0?c.removeValue(r):c.setValue(r,a),d.resource||(this.a=null)}inspect(r,a,d){const c=this.s(r,a,d),u=n.distinct(c.overrides.map(g=>g.identifiers).flat()).filter(g=>c.getOverrideValue(r,g)!==void 0),t=this.w(a.resource,d),m=a.resource?this.n.get(a.resource)||this.m:this.m;return new o(r,a,c.getValue(r),u.length?u:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),d?this.j.freeze():void 0,t?t.freeze():void 0,m.inspect(r,a.overrideIdentifier))}keys(r){const a=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,a){this.l.set(r,a),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const d=[];if(!a){const{added:c,updated:u,removed:t}=p(this.c,r);a=[...c,...u,...t]}for(const c of a)for(const u of(0,I.overrideIdentifiersFromKey)(c)){const t=this.c.getKeysForOverrideIdentifier(u),m=r.getKeysForOverrideIdentifier(u),g=[...m.filter(A=>t.indexOf(A)===-1),...t.filter(A=>m.indexOf(A)===-1),...t.filter(A=>!R.equals(this.c.override(u).getValue(A),r.override(u).getValue(A)))];d.push([u,g])}return this.updateDefaultConfiguration(r),{keys:a,overrides:d}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:d,removed:c}=p(this.d,r),u=[...a,...d,...c];return u.length&&this.updatePolicyConfiguration(r),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=p(this.applicationConfiguration,r),t=[...a,...d,...c];return t.length&&this.updateApplicationConfiguration(r),{keys:t,overrides:u}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=p(this.localUserConfiguration,r),t=[...a,...d,...c];return t.length&&this.updateLocalUserConfiguration(r),{keys:t,overrides:u}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=p(this.remoteUserConfiguration,r),t=[...a,...d,...c];return t.length&&this.updateRemoteUserConfiguration(r),{keys:t,overrides:u}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:d,removed:c,overrides:u}=p(this.workspaceConfiguration,r),t=[...a,...d,...c];return t.length&&this.updateWorkspaceConfiguration(r),{keys:t,overrides:u}}compareAndUpdateFolderConfiguration(r,a){const d=this.r.get(r),{added:c,updated:u,removed:t,overrides:m}=p(d,a),g=[...c,...u,...t];return(g.length||!d)&&this.updateFolderConfiguration(r,a),{keys:g,overrides:m}}compareAndDeleteFolderConfiguration(r){const a=this.r.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:d,updated:c,removed:u,overrides:t}=p(a,void 0);return{keys:[...d,...c,...u],overrides:t}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,a,d){let c=this.t(a,d);return a.overrideIdentifier&&(c=c.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}t({resource:r},a){let d=this.u();if(a&&r){const c=a.getFolder(r);c&&(d=this.v(c.uri)||d);const u=this.n.get(r);u&&(d=d.merge(u))}return d}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let a=this.b.get(r);if(!a){const d=this.u(),c=this.l.get(r);c?(a=d.merge(c),this.p&&(a=a.freeze()),this.b.set(r,a)):a=d}return a}w(r,a){if(a&&r){const d=a.getFolder(r);if(d)return this.l.get(d.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,a)=>{const{contents:d,overrides:c,keys:u}=this.l.get(a);return r.push([a,{contents:d,overrides:c,keys:u}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(a=>r.add(a)),this.userConfiguration.freeze().keys.forEach(a=>r.add(a)),this.j.freeze().keys.forEach(a=>r.add(a)),this.l.forEach(a=>a.freeze().keys.forEach(d=>r.add(d))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.j.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.l.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(d=>r.add(d))),[...r.values()]}y(r){const a=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(d=>a.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(d=>a.add(d)),this.j.getKeysForOverrideIdentifier(r).forEach(d=>a.add(d)),this.l.forEach(d=>d.getKeysForOverrideIdentifier(r).forEach(c=>a.add(c))),[...a.values()]}static parse(r){const a=this.A(r.defaults),d=this.A(r.policy),c=this.A(r.application),u=this.A(r.user),t=this.A(r.workspace),m=r.folders.reduce((g,A)=>(g.set(k.URI.revive(A[0]),this.A(A[1])),g),new C.ResourceMap);return new l(a,d,c,u,new v,t,m,new v,new C.ResourceMap,!1)}static A(r){return new v(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function E(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,a=new Map;for(const c of s)c.keys.forEach(u=>r.add(u)),c.overrides.forEach(([u,t])=>{const m=(0,C.getOrSet)(a,u,new Set);t.forEach(g=>m.add(g))});const d=[];return a.forEach((c,u)=>d.push([u,[...c.values()]])),{keys:[...r.values()],overrides:d}}e.mergeChanges=E;class b{constructor(r,a,d,c){this.change=r,this.b=a,this.c=d,this.d=c,this.f=void 0;const u=new Set;r.keys.forEach(m=>u.add(m)),r.overrides.forEach(([,m])=>m.forEach(g=>u.add(g))),this.affectedKeys=[...u.values()];const t=new v;this.affectedKeys.forEach(m=>t.setValue(m,{})),this.a=t.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(r,a){if(this.g(this.a,r)){if(a){const d=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.b?.workspace):void 0,c=this.c.getValue(r,a,this.d);return!R.equals(d,c)}return!0}return!1}g(r,a){let d=(0,O.toValuesTree)({[a]:!0},()=>{}),c;for(;typeof d=="object"&&(c=Object.keys(d)[0]);){if(r=r[c],!r)return!1;d=d[c]}return!0}}e.ConfigurationChangeEvent=b;function p(s,r){const{added:a,removed:d,updated:c}=w(r?.rawConfiguration,s?.rawConfiguration),u=[],t=s?.getAllOverrideIdentifiers()||[],m=r?.getAllOverrideIdentifiers()||[];if(r){const g=m.filter(A=>!t.includes(A));for(const A of g)u.push([A,r.getKeysForOverrideIdentifier(A)])}if(s){const g=t.filter(A=>!m.includes(A));for(const A of g)u.push([A,s.getKeysForOverrideIdentifier(A)])}if(r&&s){for(const g of t)if(m.includes(g)){const A=w({contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)},{contents:r.getOverrideValue(void 0,g)||{},keys:r.getKeysForOverrideIdentifier(g)});u.push([g,[...A.added,...A.removed,...A.updated]])}}return{added:a,removed:d,updated:c,overrides:u}}function w(s,r){const a=s?r?s.keys.filter(u=>r.keys.indexOf(u)===-1):[...s.keys]:[],d=r?s?r.keys.filter(u=>s.keys.indexOf(u)===-1):[...r.keys]:[],c=[];if(s&&r){for(const u of r.keys)if(s.keys.indexOf(u)!==-1){const t=(0,O.getConfigurationValue)(r.contents,u),m=(0,O.getConfigurationValue)(s.contents,u);R.equals(t,m)||c.push(u)}}return{added:a,removed:d,updated:c}}}),define(De[90],Ce([1,0,11,3]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var y;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class N extends n.ErrorNoTelemetry{static isNotAvailable(R){return R instanceof N&&R._code===y.NotAvailable}static isTemporarilyNotAvailable(R){return R instanceof N&&R._code===y.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof N&&R._code===y.NoResolverFound}static isHandled(R){return R instanceof N&&R.isHandled}constructor(R,S=y.Unknown,k){super(R),this._message=R,this._code=S,this._detail=k,this.isHandled=S===y.NotAvailable&&k===!0,Object.setPrototypeOf(this,N.prototype)}}e.RemoteAuthorityResolverError=N}),define(De[63],Ce([1,0,13]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(k){return k.scheme===n.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=T;function y(k){if(!k)return;const O=k.indexOf("+");return O<0?k:k.substr(0,O)}e.getRemoteName=y;function N(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=N;function C(k){const{host:O,port:I}=S(k);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:I}}e.parseAuthorityWithPort=C;function R(k,O){let{host:I,port:f}=S(k);return typeof f>"u"&&(f=O),{host:I,port:f}}e.parseAuthorityWithOptionalPort=R;function S(k){const O=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const I=k.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const f=k.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:k,port:void 0}}}),define(De[26],Ce([1,0,10,3,63]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=N;function C(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var S;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(i){this.value=i,this.c=i.toLowerCase()}static equals(i,o){if(typeof i>"u"||i===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof i=="string"||typeof o=="string"){const l=typeof i=="string"?i:i.value,E=typeof o=="string"?o:o.value;return n.equalsIgnoreCase(l,E)}return i.c===o.c}static toKey(i){return typeof i=="string"?i.toLowerCase():i.c}}e.ExtensionIdentifier=k;function O(h){return I(h)}e.isApplicationScopedExtension=O;function I(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function f(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function v(h,i){if(i){const o=`onResolveRemoteAuthority:${(0,y.getRemoteName)(i)}`;return h.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[157],Ce([1,0,10,85,26,21,2,11,48]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,n.compareIgnoreCase)(r.id,a.id)===0}e.areSameExtensions=k;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{static create(a){const d=a.manifest?a.manifest.version:a.version,c=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new I(a.identifier,d,c)}static parse(a){const d=O.exec(a);return d&&d[1]&&d[2]?new I({id:d[1]},d[2],d[4]||void 0):null}constructor(a,d,c="undefined"){this.version=d,this.targetPlatform=c,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof I?k(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=I;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const a=f.exec(r);return a&&a[1]?[i(a[1]),a[2]]:[i(r),void 0]}e.getIdAndVersion=v;function h(r,a){return`${r}.${a}`}e.getExtensionId=h;function i(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=i;function o(r,a){return i(h(r,a))}e.getGalleryExtensionId=o;function l(r,a){const d=[],c=u=>{for(const t of d)if(t.some(m=>k(a(m),a(u))))return t;return null};for(const u of r){const t=c(u);t?t.push(u):d.push([u])}return d}e.groupByExtension=l;function E(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function b(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function p(r,a){const d=[],c=a.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const u=c.shift();if(u&&d.every(t=>!k(t.identifier,{id:u}))){const t=r.filter(m=>k(m.identifier,{id:u}));t.length===1&&(d.push(t[0]),c.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=p;async function w(r,a){if(!N.isLinux)return!1;let d;try{d=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){a.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(u))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=w;async function s(r,a){const d=await w(r,a),c=(0,T.getTargetPlatform)(d?"alpine":N.platform,S.arch);return a.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=s}),define(De[158],Ce([1,0,21,48,2,34]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(k){if(n.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function R(k,O,I,f,v,h,i,o,l,E){const b=Object.create(null);b["common.machineId"]=i,b.sessionID=(0,N.generateUuid)()+Date.now(),b.commitHash=v,b.version=h,b["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,n.PlatformToString)(n.platform),b["common.nodePlatform"]=T.platform,b["common.nodeArch"]=f,b["common.product"]=E||"desktop",o&&(b["common.msftInternal"]=o);let p=0;const w=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),n.isLinuxSnap&&(b["common.snap"]="true");const s=C(I);s&&(b["common.platformDetail"]=s);try{const r=await k.readFile(y.URI.file(l));b["common.source"]=r.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=R;function S(k){const O=T.env.USERDNSDOMAIN;if(!O)return!1;const I=O.toLowerCase();return k.some(f=>I===f)}e.verifyMicrosoftInternalDomain=S}),define(De[159],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[91],Ce([1,0,23,9,40,158,159]),function(te,e,n,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class R{constructor(c){this.value=c}}e.TrustedTelemetryValue=R;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,u){return Promise.resolve(void 0)}publicLog2(c,u){return this.publicLog(c,u)}publicLogError(c,u){return Promise.resolve(void 0)}publicLogError2(c,u){return this.publicLogError(c,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class k{async publicLog(c,u,t){}async publicLogError(c,u,t){}}e.NullEndpointTelemetryService=k,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function O(d,c){return c.onDidChangeConfiguration(u=>{u.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,y.ConfigurationTargetToString)(u.source),configurationKeys:E(u.sourceConfig)})})}e.configurationTelemetry=O;function I(d,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!d.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=I;function f(d,c){return!(c.isBuilt||c.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.isLoggingOnly=f;function v(d){const c=d.getValue(C.TELEMETRY_SETTING_ID),u=d.getValue("telemetry.enableCrashReporter");if(d.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function h(d){const c={},u={},t={};l(d,t);for(let m in t){m=m.length>150?m.substr(m.length-149):m;const g=t[m];typeof g=="number"?u[m]=g:typeof g=="boolean"?u[m]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${g.length}`),c[m]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(c[m]=g)}return{properties:c,measurements:u}}e.validateTelemetryData=h;const i=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function o(d){if(!d)return"none";for(const c of i)if(d.startsWith(`${c}+`))return c;return"other"}e.cleanRemoteAuthority=o;function l(d,c,u=0,t){if(!!d)for(const m of Object.getOwnPropertyNames(d)){const g=d[m],A=t?t+m:m;Array.isArray(g)?c[A]=(0,n.safeStringify)(g):g instanceof Date?c[A]=g.toISOString():(0,T.isObject)(g)?u<2?l(g,c,u+1,A+"."):c[A]=(0,n.safeStringify)(g):c[A]=g}}function E(d){if(!d)return[];const c=[];return b(c,"",d),c}function b(d,c,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(t=>b(d,c?`${c}.${t}`:t,u[t])):d.push(c)}function p(d,c){const u=d.msftInternalDomains||[],t=c.getValue("telemetry.internalTesting");return(0,N.verifyMicrosoftInternalDomain)(u)||t}e.isInternalTelemetry=p;function w(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.getPiiPathsFromEnvironment=w;function s(d,c){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let u=d;const t=[];for(const L of c)for(;;){const K=L.exec(d);if(!K)break;t.push([K.index,L.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let A=0;for(u="";;){const L=g.exec(d);if(!L)break;const K=t.some(([q,j])=>L.index<j&&q<g.lastIndex);!m.test(L[0])&&!K&&(u+=d.substring(A,L.index)+"<REDACTED: user-file-path>",A=g.lastIndex)}return A<d.length&&(u+=d.substr(A)),u}function r(d){if(!d)return d;const c=d.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of u)if(t.regex.test(c))return`<REDACTED: ${t.label}>`;return d}function a(d,c){return(0,n.cloneAndChange)(d,u=>{if(u instanceof R)return u.value;if(typeof u=="string"){let t=u.replaceAll("%20"," ");t=s(t,c);for(const m of c)t=t.replace(m,"");return t=r(t),t}})}e.cleanData=a}),define(De[160],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(y){this.b=y,this.a=new Map}dispose(){for(const y of this.a.values())y.dispose()}startBuffering(y,N,C=5){const R=N(S=>{const k=typeof S=="string"?S:S.data;let O=this.a.get(y);if(O){O.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(y),C);O={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(y),R.dispose()}},this.a.set(y,O)});return R}stopBuffering(y){this.a.get(y)?.dispose()}flushBuffer(y){const N=this.a.get(y);N&&(this.a.delete(y),this.b(y,N.data.join("")))}}e.TerminalDataBufferer=n}),define(De[161],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var n;(function(N){N.DARK="dark",N.LIGHT="light",N.HIGH_CONTRAST_DARK="hcDark",N.HIGH_CONTRAST_LIGHT="hcLight"})(n=e.ColorScheme||(e.ColorScheme={}));function T(N){return N===n.HIGH_CONTRAST_DARK||N===n.HIGH_CONTRAST_LIGHT}e.isHighContrast=T;function y(N){return N===n.DARK||N===n.HIGH_CONTRAST_DARK}e.isDark=y}),define(De[64],Ce([1,0,119,5,7,3,30,161]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,N.createDecorator)("themeService");var S;(function(o){function l(E){return E&&typeof E=="object"&&typeof E.id=="string"}o.isThemeColor=l})(S=e.ThemeColor||(e.ThemeColor={}));function k(o){return{id:o}}e.themeColorFromId=k;var O;(function(o){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||S.isThemeColor(d.color))}o.isThemeIcon=l;const E=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function b(d){const c=E.exec(d);if(!c)return;const[,u]=c;return{id:u}}o.fromString=b;function p(d){return{id:d}}o.fromId=p;function w(d,c){let u=d.id;const t=u.lastIndexOf("~");return t!==-1&&(u=u.substring(0,t)),c&&(u=`${u}~${c}`),{id:u}}o.modify=w;function s(d){const c=d.id.lastIndexOf("~");if(c!==-1)return d.id.substring(c+1)}o.getModifier=s;function r(d,c){return d.id===c.id&&d.color?.id===c.color?.id}o.isEqual=r;function a(d,c){return{id:d.id,color:c?k(c):void 0}}o.asThemeIcon=a,o.asClassNameArray=n.CSSIcon.asClassNameArray,o.asClassName=n.CSSIcon.asClassName,o.asCSSSelector=n.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function I(o){switch(o){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.a=[],this.a=[],this.b=new T.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,y.toDisposable)(()=>{const E=this.a.indexOf(l);this.a.splice(E,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const v=new f;C.Registry.add(e.Extensions.ThemingContribution,v);function h(o){return v.onColorThemeChange(o)}e.registerThemingParticipant=h;class i extends y.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(E=>this.n(E)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,E){let b=this.h.getColor(l);return b&&E&&(b=E(b,this.h)),b?b.toString():null}}e.Themable=i}),define(De[162],Ce([1,0,5,40,3,12]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var C;(function(i){i.Http="http",i.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(i){return e.LOCALHOST_ADDRESSES.indexOf(i)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(i){return e.ALL_INTERFACES_ADDRESSES.indexOf(i)>=0}e.isAllInterfaces=I;function f(i,o,l,E){if(l===1)return!1;if(l===2&&I(o)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(E);if(b?.length===4&&parseInt(b[1])>=18)return!1}return i<1024}e.isPortPrivileged=f;class v{constructor(o,l,E){this.remoteAddress=o,this.localAddress=l,this.b=E,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=v;let h=class{constructor(o,l){this.i=o,this.j=l,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],l=Array.from(this.d.values());for(const E of l){const b=Array.from(E.values());for(const p of b){const w=await p.value;w&&o.push(w)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:l}of o.values())await l.then(E=>E?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,l,E,b,p){this.o(o,l,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:l,localAddress:E,privacy:b,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,l){(I(o)||O(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const E=this.q(o,l);if(E)return++E.refcount,E.value}openTunnel(o,l,E,b,p=!1,w,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${E} on local port ${b}.`),!o)return;if(l||(l="localhost"),this.e&&this.h.has(E)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(o,l,E,b,p,w,s);return r?r.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,E);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.m(a);return(a.tunnelRemoteHost!==l||a.tunnelRemotePort!==E)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(d),d}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const l=this.d.get(o.tunnelRemoteHost);if(l){const E=l.get(o.tunnelRemotePort);E&&(E.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,E))}}}}async n(o,l,E){if(E.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${l}.`);const b=E.value.then(async p=>{p&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(l),b}}async closeTunnel(o,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${l} `);const E=this.d.get(o);if(E&&E.has(l)){const b=E.get(l);b.refcount=0,await this.n(o,l,b)}}o(o,l,E){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(l,{refcount:1,value:E})}async p(o,l){const E=this.d.get(o);E&&(await E.get(l)||E.delete(l),E.size===0&&this.d.delete(o))}q(o,l){const E=[o];O(o)?(E.push(...e.LOCALHOST_ADDRESSES),E.push(...e.ALL_INTERFACES_ADDRESSES)):I(o)&&E.push(...e.ALL_INTERFACES_ADDRESSES);const b=E.map(p=>this.d.get(p));for(const p of b){const w=p?.get(l);if(w)return w}}canTunnel(o){return!!k(o)}s(o,l,E,b,p,w,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${E} on local port ${b}.`);const r=E;this.h.add(r);const a=b===void 0?E:b,d={elevationRequired:p?this.isPortPrivileged(a):!1},c={remoteAddress:{host:l,port:E},localAddressPort:b,privacy:w,public:w?w!==R.Private:void 0,protocol:s},u=o.forwardPort(c,d);return u?(this.o(l,E,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),u}};h=Ve([je(0,N.ILogService),je(1,T.IConfigurationService)],h),e.AbstractTunnelService=h}),define(De[163],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var T;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(T=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[164],Ce([1,0,13]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(S){return S.scheme!==n.Schemas.file&&S.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=T;function y(S){if(S.folders.length)return S.folders.every(k=>T(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function N(S){return y(S)?.scheme}e.getVirtualWorkspaceScheme=N;function C(S){return y(S)?.authority}e.getVirtualWorkspaceAuthority=C;function R(S){return y(S)!==void 0}e.isVirtualWorkspace=R}),define(De[49],Ce([1,0,131,19,46,22,2,3,13]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function k(r){const a=r;return typeof a?.id=="string"&&C.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(r,a){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,T.basename)(r)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const d=r;if(d.configuration)return{id:d.id,configPath:d.configuration};if(d.folders.length===1)return{id:d.id,uri:d.folders[0].uri}}e.toWorkspaceIdentifier=O;function I(r){const a=r;return typeof a?.id=="string"&&C.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=I;function f(r){const a=r;if(a?.uri)return{id:a.id,uri:C.URI.revive(a.uri)};const d=r;if(d?.configPath)return{id:d.id,configPath:C.URI.revive(d.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=f;var v;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=h;function i(r){const a=r;return!!(a&&typeof a=="object"&&C.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=i;class o{constructor(a,d,c,u,t){this.h=a,this.j=c,this.k=u,this.l=t,this.c=y.TernarySearchTree.forUris(this.l,()=>!0),this.folders=d}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=y.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class l{constructor(a,d){this.raw=d,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,N.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function E(r){return new l({uri:r,index:0,name:(0,N.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(r,a){return N.extUriBiasedIgnorePathCase.isEqualOrParent(r,a.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function p(r){let a;return C.URI.isUri(r)?a=r:a=r.configuration,a?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=p;function w(r,a){return!b(r,a)&&!p(r)}e.isSavedWorkspace=w;function s(r){return(typeof r=="string"?(0,T.extname)(r):(0,N.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(De[50],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(y){this.d=y,this.b=new Map,this.c=1}add(y){const N=this.c++;return this.b.set(N,y),this.e(),N}get(y,N){return this.b.has(y)?this.b.get(y)[N]:void 0}delete(y){this.b.delete(y),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=n,n.a=!1}),define(De[37],Ce([1,0,13,22,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new T.ExtUri(R=>{const S=this.b.get(R.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(R,S){S===null?this.b.delete(R.scheme):this.b.set(R.scheme,S)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(De[27],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(De[165],Ce([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(C,R,S){this.h=new Map,this.a=C,this.b=R,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new n.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of k.values())O.complete()}catch(O){for(const I of k.values())I.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,R){let S=this.f[C];return typeof S>"u"&&(S=R),S}update(C,R){this.f[C]=R;const S=this.h.get(C);if(S!==void 0)return S.p;const k=new n.DeferredPromise;return this.h.set(C,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=T;class y extends T{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,R){super(C.identifier.value,!0,R),this.j=C}}e.ExtensionGlobalMemento=y}),define(De[166],Ce([1,0,5,2]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(C){this.c=C,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,R,S,k){const I=this.c.getNotebookDocument(T.URI.revive(C)).acceptModelChanged(R.value,S,k);this.b.fire(I)}$acceptDirtyStateChanged(C,R){this.c.getNotebookDocument(T.URI.revive(C)).acceptDirty(R)}$acceptModelSaved(C){const R=this.c.getNotebookDocument(T.URI.revive(C));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(De[14],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class T{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=T});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(De[167],Ce([1,0,26,5]),function(te,e,n,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class N{constructor(R,S){y.set(this,void 0),this.b=new T.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(R.identifier),Ye(this,y,S,"f"),Re(this,y,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(R){return Re(this,y,"f").get(this.a,R)}store(R,S){return Re(this,y,"f").store(this.a,R,S)}delete(R){return Re(this,y,"f").delete(this.a,R)}}e.ExtensionSecrets=N,y=new WeakMap}),define(De[65],Ce([1,0,3,162,5,14]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function k(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:I.protocol}}S.fromApiTunnel=k;function O(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==T.TunnelPrivacyId.ConstantPrivate&&I.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}S.fromServiceTunnel=O})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let R=class{constructor(k){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,O){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,O){return{dispose:()=>{}}}async $providePortAttributes(k,O,I,f,v){return[]}async $forwardPort(k,O){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ve([je(0,N.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(De[51],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class T{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=T}),define(De[168],Ce([1,0,24]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function y(R,S){if(S.serializeBuffersForPostMessage){const k=new T,O=(v,h)=>{if(h instanceof ArrayBuffer){const i=k.add(h);return{$$vscode_array_buffer_reference$$:!0,index:i}}else if(ArrayBuffer.isView(h)){const i=N(h);if(i){const o=k.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:i,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},I=JSON.stringify(R,O),f=k.buffers.map(v=>{const h=new Uint8Array(v);return n.VSBuffer.wrap(h)});return{message:I,buffers:f}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=y;function N(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(R,S){const k=S.map(f=>{const v=new ArrayBuffer(f.byteLength);return new Uint8Array(v).set(f.buffer),v}),O=S.length?(f,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const h=v,{index:i}=h,o=k[i];if(h.view)switch(h.view.type){case 1:return new Int8Array(o,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(R,O),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(De[92],Ce([1,0,139,9,2,7,3,30,36,13]),function(te,e,n,T,y,N,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var O;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(O=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var I;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(I=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(X){const Z=X;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.isEditorPaneWithSelection=f;function v(X,Z,fe){for(const oe of fe.visibleEditorPanes)if(oe.group.id===Z&&X.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=v;function h(X){if(c(X))return!1;const Z=X;return y.URI.isUri(Z?.resource)}e.isResourceEditorInput=h;function i(X){if(c(X))return!1;const Z=X;return Z?.original!==void 0&&Z.modified!==void 0}e.isResourceDiffEditorInput=i;function o(X){if(c(X)||i(X))return!1;const Z=X;return Z?.primary!==void 0&&Z.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function l(X){if(c(X))return!1;const Z=X;return Z?Z.resource===void 0||Z.resource.scheme===k.Schemas.untitled||Z.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;const E=/Untitled-\d+/;function b(X){return X.scheme===k.Schemas.untitled&&X.path.length>1&&!E.test(X.path)}e.isUntitledWithAssociatedResource=b;function p(X){if(c(X))return!1;const Z=X;return y.URI.isUri(Z?.base?.resource)&&y.URI.isUri(Z?.input1?.resource)&&y.URI.isUri(Z?.input2?.resource)&&y.URI.isUri(Z?.result?.resource)}e.isResourceMergeEditorInput=p;var w;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var s;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.a=new Map}registerSource(Z,fe){let oe=this.a.get(Z);return oe||(oe={source:Z,label:fe},this.a.set(Z,oe)),oe.source}getSourceLabel(Z){return this.a.get(Z)?.label??Z}}e.SaveSourceRegistry=new r;var a;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends N.Disposable{}e.AbstractEditorInput=d;function c(X){return X instanceof d}e.isEditorInput=c;function u(X){const Z=X;return y.URI.isUri(Z?.preferredResource)}function t(X){const Z=X;return c(Z?.primary)&&c(Z?.secondary)}e.isSideBySideEditorInput=t;function m(X){const Z=X;return c(Z?.modified)&&c(Z?.original)}e.isDiffEditorInput=m;function g(X){return c(X?.editor)}e.isEditorInputWithOptions=g;function A(X){const Z=X;return g(X)&&Z?.group!==void 0}e.isEditorInputWithOptionsAndGroup=A;function L(X){const Z=X;return typeof Z?.groupId=="number"&&c(Z.editor)}e.isEditorIdentifier=L;var K;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(K=e.EditorCloseContext||(e.EditorCloseContext={}));var q;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(q=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var j;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(j=e.SideBySideEditor||(e.SideBySideEditor={}));class P{getOriginalUri(Z,fe){if(!Z)return;if(p(Z))return e.EditorResourceAccessor.getOriginalUri(Z.result,fe);if(fe?.supportSideBySide){const{primary:le,secondary:ce}=this.a(Z);if(le&&ce){if(fe?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(le,{filterByScheme:fe.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:fe.filterByScheme})};if(fe?.supportSideBySide===j.ANY)return this.getOriginalUri(le,{filterByScheme:fe.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:fe.filterByScheme});Z=fe.supportSideBySide===j.PRIMARY?le:ce}}if(i(Z)||o(Z)||p(Z))return;const oe=u(Z)?Z.preferredResource:Z.resource;return!oe||!fe||!fe.filterByScheme?oe:this.b(oe,fe.filterByScheme)}a(Z){return t(Z)||o(Z)?{primary:Z.primary,secondary:Z.secondary}:m(Z)||i(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,fe){if(!Z)return;if(p(Z))return e.EditorResourceAccessor.getCanonicalUri(Z.result,fe);if(fe?.supportSideBySide){const{primary:le,secondary:ce}=this.a(Z);if(le&&ce){if(fe?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(le,{filterByScheme:fe.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:fe.filterByScheme})};if(fe?.supportSideBySide===j.ANY)return this.getCanonicalUri(le,{filterByScheme:fe.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:fe.filterByScheme});Z=fe.supportSideBySide===j.PRIMARY?le:ce}}if(i(Z)||o(Z)||p(Z))return;const oe=Z.resource;return!oe||!fe||!fe.filterByScheme?oe:this.b(oe,fe.filterByScheme)}b(Z,fe){if(Array.isArray(fe)){if(fe.some(oe=>Z.scheme===oe))return Z}else if(fe===Z.scheme)return Z}}e.EditorResourceAccessor=new P;var M;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(Z){const fe=this.a=Z.get(C.IInstantiationService);for(const[oe,le]of this.c)this.e(oe,le,fe);this.c.clear()}e(Z,fe,oe){const le=oe.createInstance(fe);this.d.set(Z,le)}registerFileEditorFactory(Z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Z}getFileEditorFactory(){return(0,T.assertIsDefined)(this.b)}registerEditorSerializer(Z,fe){if(this.c.has(Z)||this.d.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.a?this.e(Z,fe,this.a):this.c.set(Z,fe),(0,N.toDisposable)(()=>{this.c.delete(Z),this.d.delete(Z)})}getEditorSerializer(Z){return this.d.get(typeof Z=="string"?Z:Z.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new F);async function $(X,Z,fe){return!X||!X.length?[]:await Promise.all(X.map(async oe=>{const le=y.URI.revive(oe.fileUri);if(!le){fe.info("Cannot resolve the path because it is not valid.",oe);return}if(!await Z.canHandleResource(le)){fe.info("Cannot resolve the path because it cannot be handled",oe);return}let me=oe.exists,Y=oe.type;if(typeof me!="boolean"||typeof Y!="number")try{Y=(await Z.stat(le)).isDirectory?S.FileType.Directory:S.FileType.Unknown,me=!0}catch(we){fe.error(we),me=!1}if(!me&&oe.openOnlyIfExists){fe.info("Cannot resolve the path because it does not exist",oe);return}if(Y===S.FileType.Directory){fe.info("Cannot resolve the path because it is a directory",oe);return}const pe={...oe.options,pinned:!0};return me?{resource:le,options:pe}:{resource:le,options:pe,forceUntitled:!0}}))}e.pathsToEditors=$;var z;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function V(X){const Z=X;if(!Z)return!1;const fe=Z;if(fe.modified)return V(fe.modified);const oe=Z;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=V}),define(De[169],Ce([1,0,5,15,140]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,S,k,O){const I={command:R};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.s("request",I),typeof O=="number"){const f=setTimeout(()=>{clearTimeout(f);const v=this.f.get(I.seq);if(v){this.f.delete(I.seq);const h={type:"response",seq:0,request_seq:I.seq,success:!1,command:R,message:(0,y.localize)(0,null,O,R)};v(h)}},O)}return k&&this.f.set(I.seq,k),I.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,S){return R.type!=="event"||S.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,T.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const S=R,k=this.f.get(S.request_seq);k&&(this.f.delete(S.request_seq),k(S));break}}}}s(R,S){S.type=R,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((S,k)=>R.set(k,S)),await(0,T.timeout)(500),R.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=N}),define(De[170],Ce([1,0,141,41,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(49,null)});const N=f=>n.localize(50,null,f);e.debuggerDisabledMessage=N,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(51,null)};var C;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(C=e.State||(e.State={}));function R(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var S;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,y.createDecorator)("debugService");var I;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(I=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[171],Ce([1,0,10,2,19,23,13]),function(te,e,n,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function S(a,d,c){return a.replace(R,function(u,t){return d&&t.length>0&&t[0]!=="_"?u:c&&c.hasOwnProperty(t)?c[t]:u})}e.formatPII=S;function k(a){const d={};for(const c of Object.keys(a))c.startsWith("!")||(d[c]=a[c]);return d}e.filterExceptionsFromTelemetry=k;function O(a){return a.configuration.request==="attach"&&!I(a)&&(!a.parentSession||O(a.parentSession))}e.isSessionAttach=O;function I(a){let d=a.configuration.type;if(!!d)return d==="vslsShare"&&(d=a.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(d,"extensionhost")||(0,n.equalsIgnoreCase)(d,"pwa-extensionhost")?a:a.parentSession?I(a.parentSession):void 0}e.getExtensionHostDebugSession=I;function f(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=f;function v(a,d,c){let u,t=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=m.exec(a);){const A=g.index+1,L=A+g[0].length;if(A<=d&&L>=c){u=g[0],t=A;break}}if(u){const A=/\w+/g;let L=null;for(;(L=A.exec(u))&&!(L.index+1+t+L[0].length>=c););L&&(u=u.substring(0,A.lastIndex))}return u?{start:t,end:t+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=v;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(a){return!!(a&&a.match(h))}e.isUri=i;function o(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(i(a.path))return T.URI.parse(a.path);if((0,y.isAbsolute)(a.path))return T.URI.file(a.path)}return a.path}function l(a){if(typeof a.path=="object"){const d=T.URI.revive(a.path);if(d)return d.scheme===C.Schemas.file?d.fsPath:d.toString()}return a.path}function E(a,d){const c=d?o:l,u=(0,N.deepClone)(a);return p(u,(t,m)=>{t&&m&&(m.path=c(m))}),u}e.convertToDAPaths=E;function b(a,d){const c=d?o:l,u=(0,N.deepClone)(a);return p(u,(t,m)=>{!t&&m&&(m.path=c(m))}),u}e.convertToVSCPaths=b;function p(a,d){switch(a.type){case"event":{const c=a;switch(c.event){case"output":d(!1,c.body.source);break;case"loadedSource":d(!1,c.body.source);break;case"breakpoint":d(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=a;switch(c.command){case"setBreakpoints":d(!0,c.arguments.source);break;case"breakpointLocations":d(!0,c.arguments.source);break;case"source":d(!0,c.arguments.source);break;case"gotoTargets":d(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(u=>d(!1,u));break;default:break}break}case"response":{const c=a;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(u=>d(!1,u.source));break;case"loadedSources":c.body.sources.forEach(u=>d(!1,u));break;case"scopes":c.body.scopes.forEach(u=>d(!1,u.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(u=>d(!1,u.source));break;case"setBreakpoints":c.body.breakpoints.forEach(u=>d(!1,u.source));break;case"disassemble":c.body?.instructions.forEach(t=>d(!1,t.location));break;default:break}break}}}function w(a){return a.filter(d=>!d.presentation?.hidden).sort((d,c)=>d.presentation?c.presentation?d.presentation.group?c.presentation.group?d.presentation.group!==c.presentation.group?d.presentation.group.localeCompare(c.presentation.group):s(d.presentation.order,c.presentation.order):-1:c.presentation.group?1:s(d.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=w;function s(a,d){return typeof a!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:a-d}async function r(a,d){const c=a.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(c!=="none"&&(await d.saveAll(),c==="allEditorsInActiveGroup")){const u=d.activeEditorPane;u&&u.input.resource?.scheme===C.Schemas.untitled&&await d.save({editor:u.input,groupId:u.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(De[66],Ce([1,0,24,35,172,60,13,19,21,41]),function(te,e,n,T,y,N,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",N.Mimes.latex,N.Mimes.markdown,"image/png","image/jpeg",N.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[N.Mimes.latex,N.Mimes.markdown,"application/json",N.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var f;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(f=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var v;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(v=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var h;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(h=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var i;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(i=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var l;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var E;(function($){$.scheme=C.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${z.join("")}]+`),X=7;function Z(Y,pe){const we=pe.toString(X),We=`${we.length<z.length?z[we.length-1]:"z"}${we}s${(0,n.encodeBase64)(n.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:$.scheme,fragment:We})}$.generate=Z;function fe(Y){if(Y.scheme!==$.scheme)return;const pe=Y.fragment.indexOf("s");if(pe<0)return;const we=parseInt(Y.fragment.substring(0,pe).replace(V,""),X),Fe=(0,n.decodeBase64)(Y.fragment.substring(pe+1)).toString();if(!isNaN(we))return{handle:we,notebook:Y.with({scheme:Fe,fragment:null})}}$.parse=fe;function oe(Y,pe){return Y.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${Y.scheme!==C.Schemas.file?Y.scheme:""}`})}$.generateCellOutputUri=oe;function le(Y){if(Y.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!pe)return;const we=pe[1]&&pe[1]!==""?pe[1]:void 0,Fe=pe[2];return{outputId:we,notebook:Y.with({scheme:Fe||C.Schemas.file,fragment:null})}}$.parseCellOutputUri=le;function ce(Y,pe,we){return $.generate(Y,pe).with({scheme:we})}$.generateCellPropertyUri=ce;function me(Y,pe){if(Y.scheme===pe)return $.parse(Y.with({scheme:$.scheme}))}$.parseCellPropertyUri=me})(E=e.CellUri||(e.CellUri={}));const b=$=>S.isWindows?$.replace(/\//g,"\\"):$;class p{constructor(z=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.e=V,this.d=[...new Set(z)].map(X=>({pattern:X,matches:T.parse(b(X))}))}sort(z){const V=new Map(y.Iterable.map(z,Z=>[Z,b(Z)]));let X=[];for(const{matches:Z}of this.d)for(const[fe,oe]of V)if(Z(oe)){X.push(fe),V.delete(fe);break}return V.size&&(X=X.concat([...V.keys()].sort((Z,fe)=>this.e.indexOf(Z)-this.e.indexOf(fe)))),X}prioritize(z,V){const X=this.f(z);if(X===-1){this.d.unshift({pattern:z,matches:T.parse(b(z))});return}const Z=new Set(V.map(oe=>this.f(oe,X)));Z.delete(-1);const fe=Array.from(Z).sort();this.d.splice(X+1,0,...fe.map(oe=>this.d[oe]));for(let oe=fe.length-1;oe>=0;oe--)this.d.splice(fe[oe],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,V=this.d.length){const X=b(z);for(let Z=0;Z<V;Z++)if(this.d[Z].matches(X))return Z;return-1}}e.MimeTypeDisplayOrder=p;function w($,z,V,X=(Z,fe)=>Z===fe){const Z=[];function fe(ce,me,Y){if(me===0&&Y.length===0)return;const pe=Z[Z.length-1];pe&&pe.start+pe.deleteCount===ce?(pe.deleteCount+=me,pe.toInsert.push(...Y)):Z.push({start:ce,deleteCount:me,toInsert:Y})}let oe=0,le=0;for(;;){if(oe===$.length){fe(oe,0,z.slice(le));break}if(le===z.length){fe(oe,$.length-oe,[]);break}const ce=$[oe],me=z[le];if(X(ce,me)){oe+=1,le+=1;continue}V(me)?(fe(oe,1,[]),oe+=1):(fe(oe,0,[me]),le+=1)}return Z}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function($){$.default="default",$.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r($){const z=$;return!!((typeof z.include=="string"||T.isRelativePattern(z.include))&&(typeof z.exclude=="string"||T.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=r;function a($,z,V){if(Array.isArray($.viewType)&&$.viewType.indexOf(z)>=0||$.viewType===z)return!0;if($.filenamePattern){const X=r($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,Z=r($.filenamePattern)?$.filenamePattern.exclude:void 0;if(T.match(X,(0,R.basename)(V.fsPath).toLowerCase()))return!(Z&&T.match(Z,(0,R.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var d;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(z){return`${c.d}${z}`}static parse(z){if(z.startsWith(c.d))return z.substring(c.d.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c.d="notebook/";function u($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=u;const t=new TextDecoder;function m($){const z=[];let V=!1;for(const X of $)(z.length===0||V)&&(z.push(X),V=!0);return K(z),F(n.VSBuffer.concat(z.map(X=>n.VSBuffer.wrap(X))))}e.compressOutputItemStreams=m;const g=`${String.fromCharCode(27)}[A`,A=g.split("").map($=>$.charCodeAt(0)),L=10;function K($){$.forEach((z,V)=>{if(V===0||z.length<g.length)return;const X=$[V-1],Z=z.subarray(0,g.length);if(Z[0]===A[0]&&Z[1]===A[1]&&Z[2]===A[2]){const fe=X.lastIndexOf(L);if(fe===-1)return;$[V-1]=X.subarray(0,fe),$[V]=z.subarray(g.length)}})}function q($){let z=$;do $=z,z=$.replace(/[^\n]\x08/gm,"");while(z.length<$.length);return $}function j($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const z=$.match(/^(.*)\r+/m)[1];let V=$.match(/\r+(.*)$/m)[1];V=V+z.slice(V.length,z.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return $}const P="\b".charCodeAt(0),M="\r".charCodeAt(0);function F($){return!$.buffer.includes(P)&&!$.buffer.includes(M)?$:n.VSBuffer.fromString(j(q(t.decode($.buffer))))}}),define(De[173],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(De[174],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=n;function T(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=T;function y(C){return Array.from(C.entries()).map(R=>[R[0],n(R[1].map)])}e.serializeEnvironmentVariableCollections=y;function N(C){return new Map(C.map(R=>[R[0],{map:T(R[1])}]))}e.deserializeEnvironmentVariableCollections=N}),define(De[42],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(N){N.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class y{static fromExtHostTestItem(C,R,S=C.parent){if(C._isRoot)return new y([R]);const k=[C.id];for(let O=S;O&&O.id!==R;O=O.parent)k.push(O.id);return k.push(R),new y(k.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const R=C.indexOf("\0");return R===-1?C:C.slice(0,R)}static fromString(C){return new y(C.split("\0"))}static join(C,R){return new y([...C.path,R])}static joinToString(C,R){return C.toString()+"\0"+R}static parentId(C){const R=C.lastIndexOf("\0");return R===-1?void 0:C.slice(0,R)}static compare(C,R){return C===R?0:R.startsWith(C+"\0")?2:C.startsWith(R+"\0")?3:1}constructor(C,R=C.length){if(this.path=C,this.d=R,C.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new y(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new y(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new y(this.path,C)}compare(C){if(typeof C=="string")return y.compare(this.toString(),C);for(let R=0;R<C.d&&R<this.d;R++)if(C.path[R]!==this.path[R])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=y}),define(De[52],Ce([1,0,2,53,42]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var N;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(N=e.TestResultState||(e.TestResultState={}));var C;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var R;(function(u){u.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),u.deserialize=t=>({range:T.Range.lift(t.range),uri:n.URI.revive(t.uri)})})(R=e.IRichLocation||(e.IRichLocation={}));var S;(function(u){u[u.Error=0]="Error",u[u.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var k;(function(u){u.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&R.serialize(t.location)}),u.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&R.deserialize(t.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const O=(u,t)=>`${t?"s":"e"}${u}`;e.getMarkId=O;var I;(function(u){u.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&R.serialize(t.location)}),u.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&R.deserialize(t.location)})})(I=e.ITestOutputMessage||(e.ITestOutputMessage={}));var f;(function(u){u.serialize=t=>t.type===0?k.serialize(t):I.serialize(t),u.deserialize=t=>t.type===0?k.deserialize(t):I.deserialize(t)})(f=e.ITestMessage||(e.ITestMessage={}));var v;(function(u){u.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),u.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(f.serialize)}),u.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(f.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const h="\0",i=(u,t)=>u+h+t;e.namespaceTestTag=i;const o=u=>{const t=u.indexOf(h);return{ctrlId:u.slice(0,t),tagId:u.slice(t+1)}};e.denamespaceTestTag=o;var l;(function(u){u.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),u.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?n.URI.revive(t.uri):void 0,range:t.range?T.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(l=e.ITestItem||(e.ITestItem={}));var E;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var b;(function(u){u.serialize=t=>({expand:t.expand,item:l.serialize(t.item)}),u.deserialize=t=>({controllerId:y.TestId.root(t.item.extId),expand:t.expand,item:l.deserialize(t.item)})})(b=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(u){u.serialize=t=>{let m;return t.item&&(m={},t.item.label!==void 0&&(m.label=t.item.label),t.item.tags!==void 0&&(m.tags=t.item.tags),t.item.busy!==void 0&&(m.busy=t.item.busy),t.item.uri!==void 0&&(m.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(m.range=t.item.range?.toJSON()),t.item.description!==void 0&&(m.description=t.item.description),t.item.error!==void 0&&(m.error=t.item.error),t.item.sortText!==void 0&&(m.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:m}},u.deserialize=t=>{let m;return t.item&&(m={},t.item.label!==void 0&&(m.label=t.item.label),t.item.tags!==void 0&&(m.tags=t.item.tags),t.item.busy!==void 0&&(m.busy=t.item.busy),t.item.range!==void 0&&(m.range=t.item.range?T.Range.lift(t.item.range):null),t.item.description!==void 0&&(m.description=t.item.description),t.item.error!==void 0&&(m.error=t.item.error),t.item.sortText!==void 0&&(m.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:m}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(u,t)=>{t.expand!==void 0&&(u.expand=t.expand),t.item!==void 0&&(u.item=u.item?Object.assign(u.item,t.item):t.item)};e.applyTestItemUpdate=w;var s;(function(u){u.serializeWithoutMessages=t=>({...b.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(v.serializeWithoutMessages),retired:t.retired}),u.serialize=t=>({...b.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(v.serialize),retired:t.retired}),u.deserialize=t=>({...b.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(v.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var a;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.DocumentSynced=2]="DocumentSynced",u[u.Remove=3]="Remove",u[u.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",u[u.Retire=5]="Retire",u[u.AddTag=6]="AddTag",u[u.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(u){u.deserialize=t=>t.op===0?{op:t.op,item:b.deserialize(t.item)}:t.op===1?{op:t.op,item:p.deserialize(t.item)}:t.op===2?{op:t.op,uri:n.URI.revive(t.uri),docv:t.docv}:t,u.serialize=t=>t.op===0?{op:t.op,item:b.serialize(t.item)}:t.op===1?{op:t.op,item:p.serialize(t.item)}:t})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(t){const m=this.o();for(const g of t)switch(g.op){case 0:this.j(b.deserialize(g.item),m);break;case 1:this.k(p.deserialize(g.item),m);break;case 3:this.l(g.itemId,m);break;case 5:this.m(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.c.set(g.tag.id,g.tag);break;case 7:this.c.delete(g.id);break}m.complete?.()}j(t,m){const g=y.TestId.parentId(t.item.extId)?.toString();let A;if(!g)A=this.p(t),this.f.add(A),this.d.set(t.item.extId,A);else if(this.d.has(g)){const L=this.d.get(g);L.children.add(t.item.extId),A=this.p(t,L),this.d.set(t.item.extId,A)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return m.add?.(A),t.expand===2&&this.g++,A}k(t,m){const g=this.d.get(t.extId);if(!!g)return t.expand!==void 0&&(g.expand===2&&this.g--,t.expand===2&&this.g++),(0,e.applyTestItemUpdate)(g,t),m.update?.(g),g}l(t,m){const g=this.d.get(t);if(!g)return;const A=y.TestId.parentId(g.item.extId)?.toString();A?this.d.get(A).children.delete(g.item.extId):this.f.delete(g);const L=[[t]];for(;L.length;)for(const K of L.pop()){const q=this.d.get(K);q&&(L.push(q.children),this.d.delete(K),m.remove?.(q,q!==g),q.expand===2&&this.g--)}}m(t){}updatePendingRoots(t){this.h+=t}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(De[67],Ce([1,0,15,5,7,47,52,42]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(E){E[E.Upsert=0]="Upsert",E[E.SetTags=1]="SetTags",E[E.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",E[E.RemoveChild=3]="RemoveChild",E[E.SetProp=4]="SetProp",E[E.Bulk=5]="Bulk",E[E.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(E,b)=>E===b,I=Object.entries({range:(E,b)=>E===b?!0:!E||!b?!1:E.equalsRange(b),busy:k,label:k,description:k,error:k,sortText:k,tags:(E,b)=>!(E.length!==b.length||E.some(p=>!b.includes(p)))}),f=(E,b)=>{let p;for(const[w,s]of I)s(E[w],b[w])||(p?p[w]=b[w]:p={[w]:b[w]});return p};class v extends y.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new T.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const p of this.tree.values())this.H(p)}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const p of this.k)if(p.op===2&&p.uri===b.uri){p.docv=b.docv;return}break}case 1:{const p=this.k[this.k.length-1];if(p){if(p.op===1&&p.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(p.item,b.item);return}if(p.op===0&&p.item.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(p.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,p){const w=this.tree.get(b);if(!!w){if((w.expandLevels===void 0||p>w.expandLevels)&&(w.expandLevels=p),w.expand===1){const s=this.J(w);return s.isOpen()?this.I(w,p-1):s.wait().then(()=>this.I(w,p-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.I(w,p-1)):this.I(w,p-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,p){switch(p.op){case 3:this.M(R.TestId.joinToString(b.fullId,p.id));break;case 0:this.u(p.item,b);break;case 5:for(const w of p.ops)this.p(b,w);break;case 1:this.w(p.new,p.old,b.fullId.toString());break;case 2:this.H(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:p.update}});break;case 6:this.s(b.actual.uri);break;default:(0,N.assertNever)(p)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,p){const w=R.TestId.fromExtHostTestItem(b,this.root.id,p?.actual),s=this.m.getApiFor(b);s.parent&&s.parent!==p?.actual&&this.m.getChildren(s.parent).delete(b.id);let r=this.tree.get(w.toString());if(!r){r={fullId:w,actual:b,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(r.fullId.toString(),r),this.D(b,p),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:r.expand,item:this.m.toITestItem(b)}}),this.G(b,r,p);return}if(r.actual===b){this.F(b,r,p);return}if(r.actual.uri?.toString()!==b.uri?.toString())return this.M(w.toString()),this.u(b,p);const a=this.m.getChildren(r.actual),d=r.actual,c=f(this.m.toITestItem(d),this.m.toITestItem(b));this.m.getApiFor(d).listener=void 0,r.actual=b,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(b.tags,d.tags,w.toString()),delete c.tags),this.p(r,{op:4,update:c})),this.G(b,r,p);for(const[u,t]of a)this.m.getChildren(b).get(t.id)||this.M(R.TestId.joinToString(w,t.id));this.s(r.actual.uri)}w(b,p,w){const s=new Set(p.map(r=>r.id));for(const r of b)s.delete(r.id)||this.y(r);this.pushDiff({op:1,item:{extId:w,item:{tags:b.map(r=>(0,C.namespaceTestTag)(this.m.controllerId,r.id))}}}),s.forEach(this.C,this)}y(b){const p=this.j.get(b.id);p?p.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,b.id)}}))}C(b){const p=this.j.get(b);p&&!--p.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,b)}))}D(b,p){this.m.getApiFor(b).parent=p&&p.actual!==this.root?p.actual:void 0}F(b,p,w){this.D(b,w);const s=this.m.getApiFor(b);s.parent=w?.actual,s.listener=r=>this.p(p,r),this.H(p)}G(b,p,w){this.F(b,p,w);for(const[s,r]of this.m.getChildren(b))this.u(r,p)}H(b){let p;this.h?b.resolveBarrier?p=b.resolveBarrier.isOpen()?3:2:p=b.actual.canResolveChildren?1:0:p=0,p!==b.expand&&(b.expand=p,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:p}}),p===1&&b.expandLevels!==void 0&&this.J(b))}I(b,p){if(p<0)return;const w=[];for(const[s,r]of this.m.getChildren(b.actual)){const a=this.expand(R.TestId.joinToString(b.fullId,r.id),p);(0,n.isThenable)(a)&&w.push(a)}if(w.length)return Promise.all(w).then(()=>{})}J(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const r=new n.Barrier;return r.open(),r}b.expand=2,this.L(b);const p=b.resolveBarrier=new n.Barrier,w=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,r)};let s;try{s=this.h(b.actual===this.root?void 0:b.actual)}catch(r){w(r)}return(0,n.isThenable)(s)?s.catch(w).then(()=>{p.open(),this.H(b)}):(p.open(),this.H(b)),b.resolveBarrier}L(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}M(b){const p=this.tree.get(b);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const w=[p];for(;w.length;){const s=w.pop();if(!!s){this.m.getApiFor(s.actual).listener=void 0;for(const r of s.actual.tags)this.C(r.id);this.tree.delete(s.fullId.toString());for(const[r,a]of this.m.getChildren(s.actual))w.push(this.tree.get(R.TestId.joinToString(s.fullId,a.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=v;class h extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=h;class i extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=i;class o extends Error{constructor(b,p,w){super(`TestItem with ID "${b}" is from controller "${p}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=o;const l=(E,b,p)=>{let w=new Map;return{get size(){return w.size},forEach(s,r){for(const a of w.values())s.call(r,a,this)},[Symbol.iterator](){return w.entries()},replace(s){const r=new Map,a=new Set(w.keys()),d={op:5,ops:[]};for(const c of s){if(!(c instanceof p))throw new i(c.id);const u=b(c).controllerId;if(u!==E.controllerId)throw new o(c.id,u,E.controllerId);if(r.has(c.id))throw new h(c.id);r.set(c.id,c),a.delete(c.id),d.ops.push({op:0,item:c})}for(const c of a.keys())d.ops.push({op:3,id:c});E.listener?.(d),w=r},add(s){if(!(s instanceof p))throw new i(s.id);w.set(s.id,s),E.listener?.({op:0,item:s})},delete(s){w.delete(s)&&E.listener?.({op:3,id:s})},get(s){return w.get(s)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=l}),define(De[93],Ce([1,0,67]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,y=(C,R)=>{const S={controllerId:R};return T.set(C,S),S};e.createPrivateApiFor=y;const N=C=>{const R=T.get(C);if(!R)throw new n.InvalidTestItemError(C?.id||"<unknown>");return R};e.getPrivateApiFor=N}),define(De[68],Ce([1,0,13,2]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(R,S){return R.scheme===n.Schemas.http||R.scheme===n.Schemas.https?R:(S&&S.authority&&S.isRemote&&R.scheme===n.Schemas.file&&(R=T.URI.from({scheme:n.Schemas.vscodeRemote,authority:S.authority,path:R.path})),T.URI.from({scheme:n.Schemas.https,authority:`${R.scheme}+${N(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=y;function N(R){return R.replace(/./g,S=>{const k=S.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?S:"-"+k.toString(16).padStart(4,"0")})}function C(R){return R.replace(/-([0-9a-f]{4})/g,(S,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=C}),define(De[175],Ce([1,0,5,7,68]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(R,S,k){this.d=R,this.e=S,this.f=k,this.a=0,this.b=new T.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const O=S.getVisibleTextEditors();for(const I of this.c.values())O.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,S,k,O,I){let f;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===R){f=b;break}if(!f)throw new Error("not a visible editor");const v=this,h=this.a++,i=new n.Emitter,o=new n.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,y.asWebviewUri)(b,v.f)}get cspSource(){return y.webviewGenericCspSource}set options(b){this.b=b,v.d.$setOptions(h,b)}get options(){return this.b}set html(b){this.a=b,v.d.$setHtml(h,b)}get html(){return this.a}get onDidReceiveMessage(){return i.event}postMessage(b){return v.d.$postMessage(h,b)}},E=new class{constructor(){this.editor=R,this.line=S,this.height=k,this.webview=l,this.onDidDispose=o.event}dispose(){v.c.has(h)&&(v.c.delete(h),v.d.$disposeEditorInset(h),o.fire(),o.dispose(),i.dispose())}};return this.d.$createEditorInset(h,f.id,f.value.document.uri,S+1,k,O||{},I.identifier,I.extensionLocation),this.c.set(h,{editor:R,inset:E,onDidReceiveMessage:i}),E}$onDidDispose(R){const S=this.c.get(R);S&&S.inset.dispose()}$onDidReceiveMessage(R,S){this.c.get(R)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=N}),define(De[176],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var T;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator"})(T=e.VariableKind||(e.VariableKind={}));class y extends Error{constructor(C,R){super(R),this.variable=C}}e.VariableError=y}),define(De[177],Ce([1,0,19,48,9,23,21,82,144,176,10]),function(te,e,n,T,y,N,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(v,h,i,o){this.g=new Map,this.a=v,this.b=h,this.d=i,o&&(this.c=o.then(l=>this.h(l)))}h(v){if(C.isWindows){const h=Object.create(null);return Object.keys(v).forEach(i=>{h[i.toLowerCase()]=v[i]}),h}return v}resolveWithEnvironment(v,h,i){return this.j({env:this.h(v),userHome:void 0},h?h.uri:void 0,i)}async resolveAsync(v,h){const i={env:await this.c,userHome:await this.d};return this.j(i,v?v.uri:void 0,h)}async i(v,h,i,o){const l=N.deepClone(h);C.isWindows&&l.windows?Object.keys(l.windows).forEach(b=>l[b]=l.windows[b]):C.isMacintosh&&l.osx?Object.keys(l.osx).forEach(b=>l[b]=l.osx[b]):C.isLinux&&l.linux&&Object.keys(l.linux).forEach(b=>l[b]=l.linux[b]),delete l.windows,delete l.osx,delete l.linux;const E={env:await this.c,userHome:await this.d};return this.j(E,v?v.uri:void 0,l,i,o)}async resolveAnyAsync(v,h,i){return this.i(v,h,i)}async resolveAnyMap(v,h,i){const o=new Map;return{newConfig:await this.i(v,h,i,o),resolvedVariables:o}}resolveWithInteractionReplace(v,h,i,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,h,i,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,h){if(this.g.has(v))throw new Error("Variable "+v+" is contributed twice.");this.g.set(v,h)}async j(v,h,i,o,l){if(y.isString(i))return this.l(v,h,i,o,l);if(Array.isArray(i))return Promise.all(i.map(E=>this.j(v,h,E,o,l)));if(y.isObject(i)){const E=Object.create(null),b=await Promise.all(Object.keys(i).map(async p=>[await this.l(v,h,p,o,l),await this.j(v,h,i[p],o,l)]));for(const[p,w]of b)E[p]=w;return E}return i}l(v,h,i,o,l){return(0,O.replaceAsync)(i,I.VARIABLE_REGEXP,async(E,b)=>{if(b.includes(I.VARIABLE_LHS))return E;let p=await this.n(v,E,b,h,o);return l?.set(b,p),p!==E&&y.isString(p)&&p.match(I.VARIABLE_REGEXP)&&(p=await this.l(v,h,p,o,l)),p})}m(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async n(v,h,i,o,l){let E;const b=i.split(":");b.length>1&&(i=b[0],E=b[1]);const p=r=>{const a=this.a.getFilePath();if(a)return a;throw new k.VariableError(r,(0,S.localize)(0,null,h))},w=r=>{const a=p(r);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return d}throw new k.VariableError(r,(0,S.localize)(1,null,h,n.basename(a)))},s=r=>{if(E){const a=this.a.getFolderUri(E);if(a)return a;throw new k.VariableError(r,(0,S.localize)(2,null,h,E))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(r,(0,S.localize)(3,null,h)):new k.VariableError(r,(0,S.localize)(4,null,h))};switch(i){case"env":if(E){if(v.env){const r=v.env[C.isWindows?E.toLowerCase():E];if(y.isString(r))return r}return""}throw new k.VariableError(k.VariableKind.Env,(0,S.localize)(5,null,h));case"config":if(E){const r=this.a.getConfigurationValue(o,E);if(y.isUndefinedOrNull(r))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(6,null,h,E));if(y.isObject(r))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(7,null,h,E));return r}throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(8,null,h));case"command":return this.o(k.VariableKind.Command,h,E,l,"command");case"input":return this.o(k.VariableKind.Input,h,E,l,"input");case"extensionInstallFolder":if(E){const r=await this.a.getExtension(E);if(!r)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,h,E));return this.m(r.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,h));default:switch(i){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(s(k.VariableKind.WorkspaceFolder)));case"cwd":return o||E?(0,R.normalizeDriveLetter)(this.m(s(k.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return n.basename(this.m(s(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(v.userHome)return v.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,S.localize)(11,null,h))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new k.VariableError(k.VariableKind.LineNumber,(0,S.localize)(12,null,h))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new k.VariableError(k.VariableKind.SelectedText,(0,S.localize)(13,null,h))}case"file":return p(k.VariableKind.File);case"fileWorkspaceFolder":return w(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||E?n.relative(this.m(s(k.VariableKind.RelativeFile)),p(k.VariableKind.RelativeFile)):p(k.VariableKind.RelativeFile);case"relativeFileDirname":{const r=n.dirname(p(k.VariableKind.RelativeFileDirname));if(o||E){const a=n.relative(this.m(s(k.VariableKind.RelativeFileDirname)),r);return a.length===0?".":a}return r}case"fileDirname":return n.dirname(p(k.VariableKind.FileDirname));case"fileExtname":return n.extname(p(k.VariableKind.FileExtname));case"fileBasename":return n.basename(p(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=n.basename(p(k.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-n.extname(r).length)}case"fileDirnameBasename":return n.basename(n.dirname(p(k.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||h}case"execInstallFolder":{const r=this.a.getAppRoot();return r||h}case"pathSeparator":return n.sep;default:try{const r=E?`${i}:${E}`:i;return this.o(k.VariableKind.Unknown,h,r,l,void 0)}catch{return h}}}}o(v,h,i,o,l){if(i&&o){const E=l===void 0?o[i]:o[l+":"+i];if(typeof E=="string")return E;throw new k.VariableError(v,(0,S.localize)(14,null,h))}return h}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[94],Ce([1,0,3,92]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var y;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var N;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(N=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var R;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function k(h){const i=h;return(0,T.isEditorInput)(i?.editor)&&(0,T.isEditorInput)(i?.replacement)}e.isEditorReplacement=k;var O;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function f(h){const i=h;return!!i&&typeof i.id=="number"&&Array.isArray(i.editors)}e.isEditorGroup=f;function v(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(De[178],Ce([1,0,3,94]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(N){const C=N;return typeof N=="number"||(0,T.isEditorGroup)(C)}e.isPreferredGroup=y}),define(De[179],Ce([1,0,3,150]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(T.IEnvironmentService)}),define(De[180],Ce([1,0,26,5,19]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class N{constructor(I){this.removedDueToLooping=I}}e.DeltaExtensionsResult=N;class C{constructor(I){this.c=new T.Emitter,this.onDidChange=this.c.event,this.d=I,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const I of this.d){if(this.e.has(n.ExtensionIdentifier.toKey(I.identifier))){console.error("Extension `"+I.identifier.value+"` is already registered");continue}if(this.e.set(n.ExtensionIdentifier.toKey(I.identifier),I),this.f.push(I),Array.isArray(I.activationEvents))for(let f of I.activationEvents)f==="onUri"&&(f=`onUri:${n.ExtensionIdentifier.toKey(I.identifier)}`),this.g.has(f)||this.g.set(f,[]),this.g.get(f).push(I)}}set(I){this.d=I,this.h(),this.c.fire(void 0)}deltaExtensions(I,f){this.d=k(this.d,f),this.d=this.d.concat(I);const v=C.j(this.d);return this.d=k(this.d,v.map(h=>h.identifier)),this.h(),this.c.fire(void 0),new N(v)}static j(I){const f=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,E){this.addNode(l),this.addNode(E),this.c.has(l)?this.c.get(l).push(E):this.c.set(l,[E])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,E){const b=f.getArcs(l);for(let p=0;p<b.length;p++)if(!E.has(b[p]))return!1;return!0}getNodes(){return this.e}},v=new Map;for(const l of I){const E=n.ExtensionIdentifier.toKey(l.identifier);if(v.set(E,l),l.extensionDependencies)for(const b of l.extensionDependencies){const p=n.ExtensionIdentifier.toKey(b);f.addArc(E,p)}}const h=new Set;f.getNodes().filter(l=>f.getArcs(l).length===0).forEach(l=>h.add(l));const i=f.getNodes().filter(l=>!h.has(l));let o;do{o=!1;for(let l=0;l<i.length;l++){const E=i[l];f.hasOnlyGoodArcs(E,h)&&(i.splice(l,1),l--,h.add(E),o=!0)}}while(o);return i.map(l=>v.get(l))}containsActivationEvent(I){return this.g.has(I)}containsExtension(I){return this.e.has(n.ExtensionIdentifier.toKey(I))}getExtensionDescriptionsForActivationEvent(I){const f=this.g.get(I);return f?f.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(I){const f=this.e.get(n.ExtensionIdentifier.toKey(I));return f||void 0}getExtensionDescriptionByUUID(I){for(const f of this.f)if(f.uuid===I)return f}getExtensionDescriptionByIdOrUUID(I,f){return this.getExtensionDescription(I)??(f?this.getExtensionDescriptionByUUID(f):void 0)}}e.ExtensionDescriptionRegistry=C;var R;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(R||(R={}));function S(O,I){const f=O.isBuiltin?0:O.isUnderDevelopment?2:1,v=I.isBuiltin?0:I.isUnderDevelopment?2:1;if(f!==v)return f-v;const h=y.posix.basename(O.extensionLocation.path),i=y.posix.basename(I.extensionLocation.path);return h<i?-1:h>i?1:0}function k(O,I){const f=new Set;return I.forEach(v=>f.add(n.ExtensionIdentifier.toKey(v))),O.filter(v=>!f.has(n.ExtensionIdentifier.toKey(v.identifier)))}}),define(De[69],Ce([1,0,24]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var N;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(N=e.MessageType||(e.MessageType={}));function C(k){const O=n.VSBuffer.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=C;function R(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=R;var S;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[70],Ce([1,0,3,5,12,27,69,63,91,23,2]),function(te,e,n,T,y,N,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let I=class{constructor(i,o){this.i=i,this.a=new T.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new T.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=o.createLogger(O.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(i,o){const l=this.getTelemetryDetails(),E=new f(o,i,this.g,this.f,this.getBuiltInCommonProperties(i),{isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled});return this.h.set(i.identifier.value,E),E.apiTelemetryLogger}$initializeTelemetryLevel(i,o,l){this.d=i,this.f=o,this.c=l??{usage:!0,error:!0}}getBuiltInCommonProperties(i){const o={};switch(o["common.extname"]=i.name,o["common.extversion"]=i.version,o["common.vscodemachineid"]=this.i.telemetryInfo.machineId,o["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,o["common.vscodeversion"]=this.i.version,o["common.isnewappinstall"]=v(this.i.telemetryInfo.firstSessionDate),o["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:o["common.uikind"]="web";break;case C.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,R.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),o}$onDidChangeTelemetryLevel(i){this.e=this.getTelemetryConfiguration(),this.d=i;const o=this.getTelemetryDetails();this.h.forEach(l=>{l.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(i,o){const l=this.h.get(i.value);return l?(l.logError(o),!0):!1}};I=Ve([je(0,N.IExtHostInitDataService),je(1,y.ILoggerService)],I),e.ExtHostTelemetry=I;class f{constructor(i,o,l,E,b,p){this.e=o,this.f=l,this.g=E,this.h=b,this.b=new T.Emitter,this.a=i,this.c={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(i,o){this.d&&(this.c={isUsageEnabled:i,isErrorsEnabled:o},this.b.fire(this.d))}mixInCommonPropsAndCleanData(i){let o=i.properties??i;return o=(0,S.cleanData)(o,[]),this.a.additionalCommonProperties&&(o=(0,k.mixin)(o,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(o=(0,k.mixin)(o,this.h)),i.properties?i.properties=o:i=o,i}i(i,o){this.e.publisher==="vscode"?i=this.e.name+"/"+i:i=this.e.identifier.value+"/"+i,o=this.mixInCommonPropsAndCleanData(o||{}),this.g||this.a.logEvent(i,o),this.f.trace(i,o)}logUsage(i,o){!this.c.isUsageEnabled||this.i(i,o)}logError(i,o){!this.c.isErrorsEnabled||(typeof i=="string"?this.i(i,o):this.a.logException(i,o))}get apiTelemetryLogger(){if(!this.d){const i=this,o={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.c.isUsageEnabled},get isErrorsEnabled(){return i.c.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.b.event.bind(i)};this.d=Object.freeze(o)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=f;function v(h){const i=Date.now()-new Date(h).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.isNewAppInstall=v,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(De[25],Ce([1,0,5,2,3,26,157]),function(te,e,n,T,y,N,C){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new N.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class S{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class k{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class O{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class I{constructor(u){this.dependency=u}}e.MissingExtensionDependency=I;var f;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(f=e.ExtensionHostKind||(e.ExtensionHostKind={}));function v(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=v;class h{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,t){const m=[],g=[],A=[],L=[],K=l(this.c),q=l(u),j=($,z)=>$.extensionLocation.toString()===z.extensionLocation.toString()||$.isBuiltin===z.isBuiltin||$.isUserBuiltin===z.isUserBuiltin||$.isUnderDevelopment===z.isUnderDevelopment;for(const $ of this.c){const z=q.get(N.ExtensionIdentifier.toKey($.identifier));if(!z){m.push($.identifier),K.delete(N.ExtensionIdentifier.toKey($.identifier));continue}if(!j($,z)){m.push($.identifier),K.delete(N.ExtensionIdentifier.toKey($.identifier));continue}}for(const $ of u){const z=K.get(N.ExtensionIdentifier.toKey($.identifier));if(!z){g.push($);continue}if(!j(z,$)){m.push(z.identifier),K.delete(N.ExtensionIdentifier.toKey(z.identifier));continue}}const P=o(this.d),M=o(t);for(const $ of this.d)M.has(N.ExtensionIdentifier.toKey($))||A.push($);for(const $ of t)P.has(N.ExtensionIdentifier.toKey($))||L.push($);const F={toRemove:m,toAdd:g,myToRemove:A,myToAdd:L};return this.delta(F),F}delta(u){const{toRemove:t,toAdd:m,myToRemove:g,myToAdd:A}=u,L=o(t),K=o(g);for(let q=0;q<this.c.length;q++)L.has(N.ExtensionIdentifier.toKey(this.c[q].identifier))&&(this.c.splice(q,1),q--);for(let q=0;q<this.d.length;q++)K.has(N.ExtensionIdentifier.toKey(this.d[q]))&&(this.d.splice(q,1),q--);for(const q of m)this.c.push(q);for(const q of A)this.d.push(q)}containsExtension(u){for(const t of this.d)if(N.ExtensionIdentifier.equals(t,u))return!0;return!1}}e.ExtensionHostExtensions=h;class i{constructor(u){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=N.ExtensionIdentifier.toKey,u)for(const t of u)this.add(t)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,t){this.c.forEach(m=>u.call(t,m,m,this))}*entries(){for(const[u,t]of this.c)yield[t,t]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=i;function o(c){const u=new Set;for(const t of c)u.add(N.ExtensionIdentifier.toKey(t));return u}e.extensionIdentifiersArrayToSet=o;function l(c){const u=new Map;for(const t of c)u.set(N.ExtensionIdentifier.toKey(t.identifier),t);return u}function E(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=E;function b(c,u){if(!E(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=b;class p{constructor(u,t,m,g){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=m,this.activationReason=g}}e.ActivationTimes=p;class w{constructor(u,t){this.description=u,this.value=t}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function a(c,u){return{identifier:new N.ExtensionIdentifier((0,C.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=a;class d{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,t){return Promise.resolve(0)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=d}),define(De[181],Ce([1,0,11,26,25,12,15]),function(te,e,n,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class R{constructor(o,l,E,b){this.startup=o,this.codeLoadingTime=l,this.activateCallTime=E,this.activateResolvedTime=b}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class S{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,l){return o===-1||l===-1?-1:l-o}build(){return new R(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=S;class k{constructor(o,l,E,b,p,w){this.activationFailed=o,this.activationFailedError=l,this.activationTimes=E,this.module=b,this.exports=p,this.subscriptions=w}}e.ActivatedExtension=k;class O extends k{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class I extends k{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class f extends k{constructor(o){super(!0,o,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,l,E,b,p){this.h=p,this.a=o,this.b=new Set,l.forEach(w=>this.b.add(T.ExtensionIdentifier.toKey(w))),this.c=new Map,E.forEach(w=>this.c.set(T.ExtensionIdentifier.toKey(w),w)),this.d=b,this.f=new Map,this.g=Object.create(null)}dispose(){for(const[o,l]of this.f)l.dispose()}isActivated(o){const l=this.f.get(T.ExtensionIdentifier.toKey(o));return Boolean(l&&l.value)}getActivatedExtension(o){const l=this.f.get(T.ExtensionIdentifier.toKey(o));if(!l||!l.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return l.value}async activateByEvent(o,l){if(this.g[o])return;const E=this.a.getExtensionDescriptionsForActivationEvent(o);await this.j(E.map(b=>({id:b.identifier,reason:{startup:l,extensionId:b.identifier,activationEvent:o}}))),this.g[o]=!0}activateById(o,l){const E=this.a.getExtensionDescription(o);if(!E)throw new Error(`Extension '${o}' is not known`);return this.j([{id:E.identifier,reason:l}])}async j(o){const l=o.filter(E=>!this.isActivated(E.id)).map(E=>this.k(E));await Promise.all(l.map(E=>E.wait()))}k(o){if(this.f.has(T.ExtensionIdentifier.toKey(o.id)))return this.f.get(T.ExtensionIdentifier.toKey(o.id));if(this.c.has(T.ExtensionIdentifier.toKey(o.id)))return this.l(o,null,[],null);const l=this.a.getExtensionDescription(o.id);if(!l){const p=new Error(`Cannot activate unknown extension '${o.id.value}'`),w=this.l(o,null,[],new f(p));return this.d.onExtensionActivationError(o.id,p,new y.MissingExtensionDependency(o.id.value)),w}const E=[],b=typeof l.extensionDependencies>"u"?[]:l.extensionDependencies;for(const p of b){if(this.b.has(T.ExtensionIdentifier.toKey(p)))continue;const w=this.f.get(T.ExtensionIdentifier.toKey(p));if(w){E.push(w);continue}if(this.c.has(T.ExtensionIdentifier.toKey(p))){E.push(this.k({id:this.c.get(T.ExtensionIdentifier.toKey(p)),reason:o.reason}));continue}const s=this.a.getExtensionDescription(p);if(s){if(!s.main&&!s.browser)continue;E.push(this.k({id:s.identifier,reason:o.reason}));continue}const r=l.displayName||l.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),d=this.l(o,l.displayName,[],new f(a));return this.d.onExtensionActivationError(l.identifier,a,new y.MissingExtensionDependency(p)),d}return this.l(o,l.displayName,E,null)}l(o,l,E,b){const p=new h(o.id,l,o.reason,E,b,this.d,this.h);return this.f.set(T.ExtensionIdentifier.toKey(o.id),p),p}};v=Ve([je(4,N.ILogService)],v),e.ExtensionsActivator=v;let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,l,E,b,p,w,s){this.c=o,this.d=l,this.f=E,this.g=b,this.h=p,this.j=w,this.k=s,this.a=new C.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const l=this.g[o];if(l.value&&!l.value.activationFailed){this.g.splice(o,1),o--;continue}if(l.value&&l.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${l.friendlyName}' failed to activate`);E.detail=l.value.activationFailedError,this.h=new f(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const l=new Error;if(o&&o.name&&(l.name=o.name),o&&o.message?l.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:l.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(l.stack=o.stack),this.h=new f(l),this.b&&n.isCancellationError(o))return;this.j.onExtensionActivationError(this.c,l,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};h=Ve([je(6,N.ILogService)],h)}),define(De[182],Ce([1,0,12,27,25]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let N=class extends n.LogService{constructor(R,S){super(R.createLogger(S.logFile,{name:y.ExtensionHostLogFileName}))}};N=Ve([je(0,n.ILoggerService),je(1,T.IExtHostInitDataService)],N),e.ExtHostLogService=N});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(De[6],Ce([1,0,16,11,81,28,60,10,9,2,34,36,90,66,25]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h){"use strict";var i,o,l,E,b,p,w,s,r,a,d,c,u,t,m,g,A,L,K,q,j,P,M;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(W){return Object.assign(W,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(W,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(W,[]);{const[ie,...Ee]=arguments;return Reflect.construct(W,Ee,ie.constructor)}}})}var $;(function(W){W.top="top",W.bottom="bottom"})($=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(W){W.command="command",W.opener="opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let V=p=class{static from(...B){let ie=B;return new p(function(){if(ie){for(const Ee of ie)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ie=void 0}})}constructor(B){i.set(this,void 0),Ye(this,i,B,"f")}dispose(){typeof Re(this,i,"f")=="function"&&(Re(this,i,"f").call(this),Ye(this,i,void 0,"f"))}};i=new WeakMap,V=p=Ve([F],V),e.Disposable=V;let X=w=class{static Min(...B){if(B.length===0)throw new TypeError;let ie=B[0];for(let Ee=1;Ee<B.length;Ee++){const qe=B[Ee];qe.isBefore(ie)&&(ie=qe)}return ie}static Max(...B){if(B.length===0)throw new TypeError;let ie=B[0];for(let Ee=1;Ee<B.length;Ee++){const qe=B[Ee];qe.isAfter(ie)&&(ie=qe)}return ie}static isPosition(B){if(!B)return!1;if(B instanceof w)return!0;const{line:ie,character:Ee}=B;return typeof ie=="number"&&typeof Ee=="number"}static of(B){if(B instanceof w)return B;if(this.isPosition(B))return new w(B.line,B.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(B,ie){if(B<0)throw(0,T.illegalArgument)("line must be non-negative");if(ie<0)throw(0,T.illegalArgument)("character must be non-negative");this.c=B,this.e=ie}isBefore(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<B.e}isBeforeOrEqual(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<=B.e}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this.c===B.c&&this.e===B.e}compareTo(B){return this.c<B.c?-1:this.c>B.line?1:this.e<B.e?-1:this.e>B.e?1:0}translate(B,ie=0){if(B===null||ie===null)throw(0,T.illegalArgument)();let Ee;return typeof B>"u"?Ee=0:typeof B=="number"?Ee=B:(Ee=typeof B.lineDelta=="number"?B.lineDelta:0,ie=typeof B.characterDelta=="number"?B.characterDelta:0),Ee===0&&ie===0?this:new w(this.line+Ee,this.character+ie)}with(B,ie=this.character){if(B===null||ie===null)throw(0,T.illegalArgument)();let Ee;return typeof B>"u"?Ee=this.line:typeof B=="number"?Ee=B:(Ee=typeof B.line=="number"?B.line:this.line,ie=typeof B.character=="number"?B.character:this.character),Ee===this.line&&ie===this.character?this:new w(Ee,ie)}toJSON(){return{line:this.line,character:this.character}}};X=w=Ve([F],X),e.Position=X;let Z=s=class{static isRange(B){return B instanceof s?!0:B?X.isPosition(B.start)&&X.isPosition(B.end):!1}static of(B){if(B instanceof s)return B;if(this.isRange(B))return new s(B.start,B.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(B,ie,Ee,qe){let Qe,st;if(typeof B=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof qe=="number"?(Qe=new X(B,ie),st=new X(Ee,qe)):X.isPosition(B)&&X.isPosition(ie)&&(Qe=X.of(B),st=X.of(ie)),!Qe||!st)throw new Error("Invalid arguments");Qe.isBefore(st)?(this.c=Qe,this.e=st):(this.c=st,this.e=Qe)}contains(B){return s.isRange(B)?this.contains(B.start)&&this.contains(B.end):X.isPosition(B)?!(X.of(B).isBefore(this.c)||this.e.isBefore(B)):!1}isEqual(B){return this.c.isEqual(B.c)&&this.e.isEqual(B.e)}intersection(B){const ie=X.Max(B.start,this.c),Ee=X.Min(B.end,this.e);if(!ie.isAfter(Ee))return new s(ie,Ee)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const ie=X.Min(B.start,this.c),Ee=X.Max(B.end,this.end);return new s(ie,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(B,ie=this.end){if(B===null||ie===null)throw(0,T.illegalArgument)();let Ee;return B?X.isPosition(B)?Ee=B:(Ee=B.start||this.start,ie=B.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&ie.isEqual(this.end)?this:new s(Ee,ie)}toJSON(){return[this.start,this.end]}};Z=s=Ve([F],Z),e.Range=Z;let fe=r=class extends Z{static isSelection(B){return B instanceof r?!0:B?Z.isRange(B)&&X.isPosition(B.anchor)&&X.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(B,ie,Ee,qe){let Qe,st;if(typeof B=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof qe=="number"?(Qe=new X(B,ie),st=new X(Ee,qe)):X.isPosition(B)&&X.isPosition(ie)&&(Qe=X.of(B),st=X.of(ie)),!Qe||!st)throw new Error("Invalid arguments");super(Qe,st),this.f=Qe,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};fe=r=Ve([F],fe),e.Selection=fe;class oe{constructor(B,ie,Ee){if(typeof B!="string"||B.length===0)throw(0,T.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,T.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,T.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(ie),this.connectionToken=Ee}}e.ResolvedAuthority=oe;class le extends Error{static NotAvailable(B,ie){return new le(B,f.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(B){return new le(B,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(B,ie=f.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(B),this._message=B,this._code=ie,this._detail=Ee,Object.setPrototypeOf(this,le.prototype)}}e.RemoteAuthorityResolverError=le;var ce;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(ce=e.EndOfLine||(e.EndOfLine={}));var me;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(me=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Y=a=class{static isTextEdit(B){return B instanceof a?!0:B?Z.isRange(B)&&typeof B.newText=="string":!1}static replace(B,ie){return new a(B,ie)}static insert(B,ie){return a.replace(new Z(B,B),ie)}static delete(B){return a.replace(B,"")}static setEndOfLine(B){const ie=new a(new Z(new X(0,0),new X(0,0)),"");return ie.newEol=B,ie}get range(){return this.c}set range(B){if(B&&!Z.isRange(B))throw(0,T.illegalArgument)("range");this.c=B}get newText(){return this.e||""}set newText(B){if(B&&typeof B!="string")throw(0,T.illegalArgument)("newText");this.e=B}get newEol(){return this.f}set newEol(B){if(B&&typeof B!="number")throw(0,T.illegalArgument)("newEol");this.f=B}constructor(B,ie){this.c=B,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};Y=a=Ve([F],Y),e.TextEdit=Y;let pe=d=class{static isNotebookCellEdit(B){return B instanceof d?!0:B?xt.isNotebookRange(B)&&Array.isArray(B.newCells):!1}static replaceCells(B,ie){return new d(B,ie)}static insertCells(B,ie){return new d(new xt(B,B),ie)}static deleteCells(B){return new d(B,[])}static updateCellMetadata(B,ie){const Ee=new d(new xt(B,B),[]);return Ee.newCellMetadata=ie,Ee}static updateNotebookMetadata(B){const ie=new d(new xt(0,0),[]);return ie.newNotebookMetadata=B,ie}constructor(B,ie){this.range=B,this.newCells=ie}};pe=d=Ve([F],pe),e.NotebookEdit=pe;class we{static isSnippetTextEdit(B){return B instanceof we?!0:B?Z.isRange(B.range)&&Xe.isSnippetString(B.snippet):!1}static replace(B,ie){return new we(B,ie)}static insert(B,ie){return we.replace(new Z(B,B),ie)}constructor(B,ie){this.range=B,this.snippet=ie}}e.SnippetTextEdit=we;var Fe;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(Fe=e.FileEditType||(e.FileEditType={}));let We=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(B,ie,Ee,qe){this.c.push({_type:1,from:B,to:ie,options:Ee,metadata:qe})}createFile(B,ie,Ee){this.c.push({_type:1,from:void 0,to:B,options:ie,metadata:Ee})}deleteFile(B,ie,Ee){this.c.push({_type:1,from:B,to:void 0,options:ie,metadata:Ee})}e(B,ie,Ee){this.c.push({_type:3,metadata:Ee,uri:B,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(B,ie,Ee,qe){const Qe=ie.start,st=ie.end;(Qe!==st||Ee.length>0)&&this.c.push({_type:5,uri:B,index:Qe,count:st-Qe,cells:Ee,metadata:qe})}g(B,ie,Ee,qe){this.c.push({_type:3,metadata:qe,uri:B,edit:{editType:8,index:ie,metadata:Ee}})}replace(B,ie,Ee,qe){this.c.push({_type:2,uri:B,edit:new Y(ie,Ee),metadata:qe})}insert(B,ie,Ee,qe){this.replace(B,new Z(ie,ie),Ee,qe)}delete(B,ie,Ee){this.replace(B,ie,"",Ee)}has(B){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===B.toString())}set(B,ie){if(ie)for(const Ee of ie){if(!Ee)continue;let qe,Qe;Array.isArray(Ee)?(qe=Ee[0],Qe=Ee[1]):qe=Ee,pe.isNotebookCellEdit(qe)?qe.newCellMetadata?this.g(B,qe.range.start,qe.newCellMetadata,Qe):qe.newNotebookMetadata?this.e(B,qe.newNotebookMetadata,Qe):this.f(B,qe.range,qe.newCells,Qe):we.isSnippetTextEdit(qe)?this.c.push({_type:6,uri:B,range:qe.range,edit:qe.snippet,metadata:Qe}):this.c.push({_type:2,uri:B,edit:qe,metadata:Qe})}else{for(let Ee=0;Ee<this.c.length;Ee++){const qe=this.c[Ee];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===B.toString()&&(this.c[Ee]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(B){const ie=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===B.toString()&&ie.push(Ee.edit);return ie}entries(){const B=new N.ResourceMap;for(const ie of this.c)if(ie._type===2){let Ee=B.get(ie.uri);Ee||(Ee=[ie.uri,[]],B.set(ie.uri,Ee)),Ee[1].push(ie.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};We=Ve([F],We),e.WorkspaceEdit=We;let Xe=c=class{static isSnippetString(B){return B instanceof c?!0:B?typeof B.value=="string":!1}static c(B){return B.replace(/\$|}|\\/g,"\\$&")}constructor(B){this.e=1,this.value=B||""}appendText(B){return this.value+=c.c(B),this}appendTabstop(B=this.e++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,ie=this.e++){if(typeof B=="function"){const Ee=new c;Ee.e=this.e,B(Ee),this.e=Ee.e,B=Ee.value}else B=c.c(B);return this.value+="${",this.value+=ie,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,ie=this.e++){const Ee=B.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(B,ie){if(typeof ie=="function"){const Ee=new c;Ee.e=this.e,ie(Ee),this.e=Ee.e,ie=Ee.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Xe=c=Ve([F],Xe),e.SnippetString=Xe;var Pe;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Pe=e.DiagnosticTag||(e.DiagnosticTag={}));var Ie;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(Ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=u=class{static isLocation(B){return B instanceof u?!0:B?Z.isRange(B.range)&&k.URI.isUri(B.uri):!1}constructor(B,ie){if(this.uri=B,ie)if(Z.isRange(ie))this.range=Z.of(ie);else if(X.isPosition(ie))this.range=new Z(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=u=Ve([F],ke),e.Location=ke;let re=class{static is(B){return B?typeof B.message=="string"&&B.location&&Z.isRange(B.location.range)&&k.URI.isUri(B.location.uri):!1}constructor(B,ie){this.location=B,this.message=ie}static isEqual(B,ie){return B===ie?!0:!B||!ie?!1:B.message===ie.message&&B.location.range.isEqual(ie.location.range)&&B.location.uri.toString()===ie.location.uri.toString()}};re=Ve([F],re),e.DiagnosticRelatedInformation=re;let ae=class{constructor(B,ie,Ee=Ie.Error){if(!Z.isRange(B))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=B,this.message=ie,this.severity=Ee}toJSON(){return{severity:Ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,ie){return B===ie?!0:!B||!ie?!1:B.message===ie.message&&B.severity===ie.severity&&B.code===ie.code&&B.severity===ie.severity&&B.source===ie.source&&B.range.isEqual(ie.range)&&(0,n.equals)(B.tags,ie.tags)&&(0,n.equals)(B.relatedInformation,ie.relatedInformation,re.isEqual)}};ae=Ve([F],ae),e.Diagnostic=ae;let J=class{constructor(B,ie){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=ie}};J=Ve([F],J),e.Hover=J;var D;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(D=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let U=class{constructor(B,ie=D.Text){this.range=B,this.kind=ie}toJSON(){return{range:this.range,kind:D[this.kind]}}};U=Ve([F],U),e.DocumentHighlight=U;var H;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(H=e.SymbolKind||(e.SymbolKind={}));var G;(function(W){W[W.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ee=t=class{static validate(B){if(!B.name)throw new Error("name must not be falsy")}constructor(B,ie,Ee,qe,Qe){this.name=B,this.kind=ie,this.containerName=Qe,typeof Ee=="string"&&(this.containerName=Ee),qe instanceof ke?this.location=qe:Ee instanceof Z&&(this.location=new ke(qe,Ee)),t.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};ee=t=Ve([F],ee),e.SymbolInformation=ee;let de=m=class{static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children?.forEach(m.validate)}constructor(B,ie,Ee,qe,Qe){this.name=B,this.detail=ie,this.kind=Ee,this.range=qe,this.selectionRange=Qe,this.children=[],m.validate(this)}};de=m=Ve([F],de),e.DocumentSymbol=de;var ye;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(B,ie){this.title=B,this.kind=ie}};se=Ve([F],se),e.CodeAction=se;let ve=g=class{constructor(B){this.value=B}append(B){return new g(this.value?this.value+g.c+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+g.c)}};ve.c=".",ve=g=Ve([F],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let be=class{constructor(B,ie){if(this.range=B,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=Ve([F],be),e.SelectionRange=be;class $e{constructor(B,ie,Ee,qe,Qe,st){this.kind=B,this.name=ie,this.detail=Ee,this.uri=qe,this.range=Qe,this.selectionRange=st}}e.CallHierarchyItem=$e;class He{constructor(B,ie){this.fromRanges=ie,this.from=B}}e.CallHierarchyIncomingCall=He;class tt{constructor(B,ie){this.fromRanges=ie,this.to=B}}e.CallHierarchyOutgoingCall=tt;var Ge;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(Ge=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(B,ie){this.range=B,this.command=ie}get isResolved(){return!!this.command}};et=Ve([F],et),e.CodeLens=et;let it=A=class{static isMarkdownString(B){return B instanceof A?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}constructor(B,ie=!1){o.set(this,void 0),Ye(this,o,new y.MarkdownString(B,{supportThemeIcons:ie}),"f")}get value(){return Re(this,o,"f").value}set value(B){Re(this,o,"f").value=B}get isTrusted(){return Re(this,o,"f").isTrusted}set isTrusted(B){Re(this,o,"f").isTrusted=B}get supportThemeIcons(){return Re(this,o,"f").supportThemeIcons}set supportThemeIcons(B){Re(this,o,"f").supportThemeIcons=B}get supportHtml(){return Re(this,o,"f").supportHtml}set supportHtml(B){Re(this,o,"f").supportHtml=B}get baseUri(){return Re(this,o,"f").baseUri}set baseUri(B){Re(this,o,"f").baseUri=B}appendText(B){return Re(this,o,"f").appendText(B),this}appendMarkdown(B){return Re(this,o,"f").appendMarkdown(B),this}appendCodeblock(B,ie){return Re(this,o,"f").appendCodeblock(ie??"",B),this}};o=new WeakMap,it=A=Ve([F],it),e.MarkdownString=it;let ct=class{constructor(B,ie){this.label=B,this.documentation=ie}};ct=Ve([F],ct),e.ParameterInformation=ct;let nt=class{constructor(B,ie){this.label=B,this.documentation=ie,this.parameters=[]}};nt=Ve([F],nt),e.SignatureInformation=nt;let Le=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Le=Ve([F],Le),e.SignatureHelp=Le;var lt;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(lt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(_=e.InlayHintKind||(e.InlayHintKind={}));let Q=class{constructor(B){this.value=B}};Q=Ve([F],Q),e.InlayHintLabelPart=Q;let ue=class{constructor(B,ie,Ee){this.position=B,this.label=ie,this.kind=Ee}};ue=Ve([F],ue),e.InlayHint=ue;var Ue;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(Ne=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(W){W[W.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let Je=class{constructor(B,ie){this.label=B,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Je=Ve([F],Je),e.CompletionItem=Je;let ht=class{constructor(B=[],ie=!1){this.items=B,this.isIncomplete=ie}};ht=Ve([F],ht),e.CompletionList=ht;let wt=class{constructor(B,ie,Ee){this.insertText=B,this.range=ie,this.command=Ee}};wt=Ve([F],wt),e.InlineSuggestion=wt;let St=class{constructor(B){this.commands=void 0,this.items=B}};St=Ve([F],St),e.InlineSuggestionList=St;var ut;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(ut=e.ViewColumn||(e.ViewColumn={}));var gt;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(gt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var yt;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(yt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ut;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Ut=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var At;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(At=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var kt;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(kt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function B(ie){switch(ie){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=B}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(B,ie){if(ie&&!k.URI.isUri(ie))throw(0,T.illegalArgument)("target");if(!Z.isRange(B)||B.isEmpty)throw(0,T.illegalArgument)("range");this.range=B,this.target=ie}};Ft=Ve([F],Ft),e.DocumentLink=Ft;let Ke=class{constructor(B,ie,Ee,qe){this.red=B,this.green=ie,this.blue=Ee,this.alpha=qe}};Ke=Ve([F],Ke),e.Color=Ke;let zt=class{constructor(B,ie){if(ie&&!(ie instanceof Ke))throw(0,T.illegalArgument)("color");if(!Z.isRange(B)||B.isEmpty)throw(0,T.illegalArgument)("range");this.range=B,this.color=ie}};zt=Ve([F],zt),e.ColorInformation=zt;let Rt=class{constructor(B){if(!B||typeof B!="string")throw(0,T.illegalArgument)("label");this.label=B}};Rt=Ve([F],Rt),e.ColorPresentation=Rt;var Wt;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Wt=e.ColorFormat||(e.ColorFormat={}));var ft;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Mt;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(Mt=e.TerminalExitReason||(e.TerminalExitReason={}));class Se{constructor(B,ie,Ee){if(this.startIndex=B,this.length=ie,this.tooltip=Ee,typeof B!="number"||B<0)throw(0,T.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,T.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=Se;var Te;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(Te=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(B){if(this.options=B,typeof B!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=ge;var x;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(x=e.TaskRevealKind||(e.TaskRevealKind={}));var Ae;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(Ae=e.TaskPanelKind||(e.TaskPanelKind={}));let Me=L=class{static from(B){switch(B){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(B,ie){if(this.label=ie,typeof B!="string"||typeof ie!="string")throw(0,T.illegalArgument)("name");this.c=B}get id(){return this.c}};Me.Clean=new L("clean","Clean"),Me.Build=new L("build","Build"),Me.Rebuild=new L("rebuild","Rebuild"),Me.Test=new L("test","Test"),Me=L=Ve([F],Me),e.TaskGroup=Me;function xe(W){let B="";for(let ie=0;ie<W.length;ie++)B+=W[ie].replace(/,/g,",,")+",";return B}let ze=class{constructor(B,ie,Ee){if(typeof B!="string")throw(0,T.illegalArgument)("process");this.e=[],this.c=B,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=Ee):this.f=ie)}get process(){return this.c}set process(B){if(typeof B!="string")throw(0,T.illegalArgument)("process");this.c=B}get args(){return this.e}set args(B){Array.isArray(B)||(B=[]),this.e=B}get options(){return this.f}set options(B){this.f=B}computeId(){const B=[];if(B.push("process"),this.c!==void 0&&B.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)B.push(ie);return xe(B)}};ze=Ve([F],ze),e.ProcessExecution=ze;let Ze=class{constructor(B,ie,Ee){if(this.f=[],Array.isArray(ie)){if(!B)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,T.illegalArgument)("command");this.e=B,this.f=ie,this.g=Ee}else{if(typeof B!="string")throw(0,T.illegalArgument)("commandLine");this.c=B,this.g=ie}}get commandLine(){return this.c}set commandLine(B){if(typeof B!="string")throw(0,T.illegalArgument)("commandLine");this.c=B}get command(){return this.e?this.e:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,T.illegalArgument)("command");this.e=B}get args(){return this.f}set args(B){this.f=B||[]}get options(){return this.g}set options(B){this.g=B}computeId(){const B=[];if(B.push("shell"),this.c!==void 0&&B.push(this.c),this.e!==void 0&&B.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)B.push(typeof ie=="string"?ie:ie.value);return xe(B)}};Ze=Ve([F],Ze),e.ShellExecution=Ze;var Ct;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(Ct=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class Ot{constructor(B){this.c=B}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(B){this.c=B}get callback(){return this.c}}e.CustomExecution=Ot;let mt=K=class{constructor(B,ie,Ee,qe,Qe,st){this.j=!1,this.k=this.definition=B;let at;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=Ee,this.execution=qe,at=Qe,this.j=!0):ie===bt.Global||ie===bt.Workspace?(this.target=ie,this.m=this.name=Ee,this.t=this.source=qe,this.execution=Qe,at=st):(this.target=ie,this.m=this.name=Ee,this.t=this.source=qe,this.execution=Qe,at=st),typeof at=="string"?(this.o=[at],this.q=!0):Array.isArray(at)?(this.o=at,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(B){this.h=B}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof ze?this.k={type:K.e,id:this.n.computeId()}:this.n instanceof Ze?this.k={type:K.f,id:this.n.computeId()}:this.n instanceof Ot?this.k={type:K.c,id:this.n.computeId()}:this.k={type:K.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(B){if(B==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=B}get scope(){return this.l}set target(B){this.y(),this.l=B}get name(){return this.m}set name(B){if(typeof B!="string")throw(0,T.illegalArgument)("name");this.y(),this.m=B}get execution(){return this.n}set execution(B){B===null&&(B=void 0),this.y(),this.n=B;const ie=this.k.type;(K.g===ie||K.e===ie||K.f===ie||K.c===ie)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(B){if(Array.isArray(B))this.y(),this.o=B,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.y(),this.r=B}get source(){return this.t}set source(B){if(typeof B!="string"||B.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.y(),this.t=B}get group(){return this.u}set group(B){B===null&&(B=void 0),this.y(),this.u=B}get detail(){return this.x}set detail(B){B===null&&(B=void 0),this.x=B}get presentationOptions(){return this.v}set presentationOptions(B){B==null&&(B=Object.create(null)),this.y(),this.v=B}get runOptions(){return this.w}set runOptions(B){B==null&&(B=Object.create(null)),this.y(),this.w=B}};mt.c="customExecution",mt.e="process",mt.f="shell",mt.g="$empty",mt=K=Ve([F],mt),e.Task=mt;var Tt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(Tt=e.ProgressLocation||(e.ProgressLocation={}));var vt;(function(W){function B(ie){const Ee=ie;return(0,S.isNumber)(Ee.value)?Ee.tooltip&&!(0,S.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}W.isViewBadge=B})(vt=e.ViewBadge||(e.ViewBadge={}));let Ht=q=class{static isTreeItem(B,ie){if(B instanceof q)return!0;const Ee=B;if(Ee.label!==void 0&&!(0,S.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,S.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,S.isString)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,S.isString)(Ee.iconPath.id))){const qe=Ee.iconPath;if(!qe||!(0,S.isString)(qe.light)&&!k.URI.isUri(qe.light)&&!(0,S.isString)(qe.dark)&&!k.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}if(Ee.description!==void 0&&!(0,S.isString)(Ee.description)&&typeof Ee.description!="boolean")return console.log("INVALID tree item, invalid description",Ee.description),!1;if(Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1;if(Ee.tooltip!==void 0&&!(0,S.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1;if(Ee.command!==void 0&&!Ee.command.command)return console.log("INVALID tree item, invalid command",Ee.command),!1;if(Ee.collapsibleState!==void 0&&Ee.collapsibleState<Nt.None&&Ee.collapsibleState>Nt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1;if(Ee.contextValue!==void 0&&!(0,S.isString)(Ee.contextValue))return console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1;if(Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1;if(Ee.checkboxState!==void 0){(0,h.checkProposedApiEnabled)(ie,"treeItemCheckbox");const qe=(0,S.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,S.isObject)(Ee.checkboxState)&&(0,S.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Qe=!(0,S.isNumber)(Ee.checkboxState)&&(0,S.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(qe===void 0||qe!==Et.Checked&&qe!==Et.Unchecked||Qe!==void 0&&!(0,S.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}return!0}constructor(B,ie=Nt.None){this.collapsibleState=ie,k.URI.isUri(B)?this.resourceUri=B:this.label=B}};Ht=q=Ve([F],Ht),e.TreeItem=Ht;var Nt;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Nt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Et;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(Et=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Zt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(B,ie){this.value=B,this.id=ie??(0,O.generateUuid)()}};Zt=Ve([F],Zt),e.DataTransferItem=Zt;let oi=class{constructor(B){l.set(this,new Map);for(const[ie,Ee]of B??[]){const qe=Re(this,l,"f").get(ie);qe?qe.push(Ee):Re(this,l,"f").set(ie,[Ee])}}get(B){return Re(this,l,"f").get(B)?.[0]}set(B,ie){Re(this,l,"f").set(B,[ie])}forEach(B,ie){for(const[Ee,qe]of Re(this,l,"f"))for(const Qe of qe)B.call(ie,Qe,Ee,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[B,ie]of Re(this,l,"f"))for(const Ee of ie)yield[B,Ee]}};oi=Ve([F],oi),e.DataTransfer=oi;let ei=class{constructor(B){this.insertText=B}};ei=Ve([F],ei),e.DocumentDropEdit=ei;let pi=class{constructor(B){this.insertText=B}};pi=Ve([F],pi),e.DocumentPasteEdit=pi;let It=class{constructor(B,ie){this.id=B,this.color=ie}static isThemeIcon(B){return typeof B.id!="string"?(console.log("INVALID ThemeIcon, invalid id",B.id),!1):!0}};It=Ve([F],It),e.ThemeIcon=It,It.File=new It("file"),It.Folder=new It("folder");let ai=class{constructor(B){this.id=B}};ai=Ve([F],ai),e.ThemeColor=ai;var Oi;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(Oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ti=class{get base(){return this.c}set base(B){this.c=B,this.e=k.URI.file(B)}get baseUri(){return this.e}set baseUri(B){this.e=B,this.c=B.fsPath}constructor(B,ie){if(typeof B!="string"&&(!B||!k.URI.isUri(B)&&!k.URI.isUri(B.uri)))throw(0,T.illegalArgument)("base");if(typeof ie!="string")throw(0,T.illegalArgument)("pattern");typeof B=="string"?this.baseUri=k.URI.file(B):k.URI.isUri(B)?this.baseUri=B:this.baseUri=B.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ti=Ve([F],ti),e.RelativePattern=ti;let Vt=class{constructor(B,ie,Ee,qe){this.enabled=typeof B=="boolean"?B:!0,typeof ie=="string"&&(this.condition=ie),typeof Ee=="string"&&(this.hitCondition=Ee),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this.c||(this.c=(0,O.generateUuid)()),this.c}};Vt=Ve([F],Vt),e.Breakpoint=Vt;let ot=class extends Vt{constructor(B,ie,Ee,qe,Qe){if(super(ie,Ee,qe,Qe),B===null)throw(0,T.illegalArgument)("location");this.location=B}};ot=Ve([F],ot),e.SourceBreakpoint=ot;let vi=class extends Vt{constructor(B,ie,Ee,qe,Qe){super(ie,Ee,qe,Qe),this.functionName=B}};vi=Ve([F],vi),e.FunctionBreakpoint=vi;let qt=class extends Vt{constructor(B,ie,Ee,qe,Qe,st,at){if(super(qe,Qe,st,at),!ie)throw(0,T.illegalArgument)("dataId");this.label=B,this.dataId=ie,this.canPersist=Ee}};qt=Ve([F],qt),e.DataBreakpoint=qt;let _t=class{constructor(B,ie,Ee){this.command=B,this.args=ie||[],this.options=Ee}};_t=Ve([F],_t),e.DebugAdapterExecutable=_t;let ci=class{constructor(B,ie){this.port=B,this.host=ie}};ci=Ve([F],ci),e.DebugAdapterServer=ci;let bi=class{constructor(B){this.path=B}};bi=Ve([F],bi),e.DebugAdapterNamedPipeServer=bi;let ui=class{constructor(B){this.implementation=B}};ui=Ve([F],ui),e.DebugAdapterInlineImplementation=ui;let Ei=class{constructor(B,ie){this.range=B,this.expression=ie}};Ei=Ve([F],Ei),e.EvaluatableExpression=Ei;var Ci;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(Ci=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(B,ie){this.range=B,this.text=ie}};ii=Ve([F],ii),e.InlineValueText=ii;let wi=class{constructor(B,ie,Ee=!0){this.range=B,this.variableName=ie,this.caseSensitiveLookup=Ee}};wi=Ve([F],wi),e.InlineValueVariableLookup=wi;let ri=class{constructor(B,ie){this.range=B,this.expression=ie}};ri=Ve([F],ri),e.InlineValueEvaluatableExpression=ri;let si=class{constructor(B,ie){this.frameId=B,this.stoppedLocation=ie}};si=Ve([F],si),e.InlineValueContext=si;var Fi;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Fi=e.FileChangeType||(e.FileChangeType={}));let Si=j=class extends Error{static FileExists(B){return new j(B,I.FileSystemProviderErrorCode.FileExists,j.FileExists)}static FileNotFound(B){return new j(B,I.FileSystemProviderErrorCode.FileNotFound,j.FileNotFound)}static FileNotADirectory(B){return new j(B,I.FileSystemProviderErrorCode.FileNotADirectory,j.FileNotADirectory)}static FileIsADirectory(B){return new j(B,I.FileSystemProviderErrorCode.FileIsADirectory,j.FileIsADirectory)}static NoPermissions(B){return new j(B,I.FileSystemProviderErrorCode.NoPermissions,j.NoPermissions)}static Unavailable(B){return new j(B,I.FileSystemProviderErrorCode.Unavailable,j.Unavailable)}constructor(B,ie=I.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(B)?B.toString(!0):B),this.code=Ee?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,j.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};Si=j=Ve([F],Si),e.FileSystemError=Si;let Qt=class{constructor(B,ie,Ee){this.start=B,this.end=ie,this.kind=Ee}};Qt=Ve([F],Qt),e.FoldingRange=Qt;var Li;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Li=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mi;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Mi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ni;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(Ni=e.CommentMode||(e.CommentMode={}));var Ui;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(Ui=e.CommentThreadState||(e.CommentThreadState={}));class Bi{constructor(B,ie=[]){this.tokenTypes=B,this.tokenModifiers=ie}}e.SemanticTokensLegend=Bi;function yi(W){return typeof W>"u"||(0,S.isStringArray)(W)}class li{constructor(B){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,B){this.l=!0;for(let ie=0,Ee=B.tokenTypes.length;ie<Ee;ie++)this.j.set(B.tokenTypes[ie],ie);for(let ie=0,Ee=B.tokenModifiers.length;ie<Ee;ie++)this.k.set(B.tokenModifiers[ie],ie)}}push(B,ie,Ee,qe,Qe){if(typeof B=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof qe=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this.n(B,ie,Ee,qe,Qe);if(Z.isRange(B)&&typeof ie=="string"&&yi(Ee))return this.m(B,ie,Ee);throw(0,T.illegalArgument)()}m(B,ie,Ee){if(!this.l)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const qe=B.start.line,Qe=B.start.character,st=B.end.character-B.start.character,at=this.j.get(ie);let Lt=0;if(Ee)for(const jt of Ee){if(!this.k.has(jt))throw new Error("`tokenModifier` is not in the provided legend");const Kt=this.k.get(jt);Lt|=1<<Kt>>>0}this.n(qe,Qe,st,at,Lt)}n(B,ie,Ee,qe,Qe){if(this.f&&(B<this.c||B===this.c&&ie<this.e)){this.f=!1;const Lt=this.g.length/5|0;let jt=0,Kt=0;for(let Xt=0;Xt<Lt;Xt++){let Yt=this.g[5*Xt],Ii=this.g[5*Xt+1];Yt===0?(Yt=jt,Ii+=Kt):Yt+=jt,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Ii,jt=Yt,Kt=Ii}}let st=B,at=ie;this.f&&this.h>0&&(st-=this.c,st===0&&(at-=this.e)),this.g[this.h++]=st,this.g[this.h++]=at,this.g[this.h++]=Ee,this.g[this.h++]=qe,this.g[this.h++]=Qe,this.c=B,this.e=ie}static o(B){const ie=[],Ee=B.length/5|0;for(let at=0;at<Ee;at++)ie[at]=at;ie.sort((at,Lt)=>{const jt=B[5*at],Kt=B[5*Lt];if(jt===Kt){const Xt=B[5*at+1],Yt=B[5*Lt+1];return Xt-Yt}return jt-Kt});const qe=new Uint32Array(B.length);let Qe=0,st=0;for(let at=0;at<Ee;at++){const Lt=5*ie[at],jt=B[Lt+0],Kt=B[Lt+1],Xt=B[Lt+2],Yt=B[Lt+3],Ii=B[Lt+4],en=jt-Qe,Cn=en===0?Kt-st:Kt,Di=5*at;qe[Di+0]=en,qe[Di+1]=Cn,qe[Di+2]=Xt,qe[Di+3]=Yt,qe[Di+4]=Ii,Qe=jt,st=Kt}return qe}build(B){return this.f?new di(new Uint32Array(this.g),B):new di(li.o(this.g),B)}}e.SemanticTokensBuilder=li;class di{constructor(B,ie){this.resultId=ie,this.data=B}}e.SemanticTokens=di;class Be{constructor(B,ie,Ee){this.start=B,this.deleteCount=ie,this.data=Ee}}e.SemanticTokensEdit=Be;class Gt{constructor(B,ie){this.resultId=ie,this.edits=B}}e.SemanticTokensEdits=Gt;var ki;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(ki=e.DebugConsoleMode||(e.DebugConsoleMode={}));let dt=class{constructor(){}};dt.Back={iconPath:new It("arrow-left")},dt=Ve([F],dt),e.QuickInputButtons=dt;var $i;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})($i=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(zi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ti;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(Ti=e.ExtensionKind||(e.ExtensionKind={}));class Wi{static validate(B){if(typeof B.badge=="string"){let ie=(0,R.nextCharLength)(B.badge,0);if(ie<B.badge.length&&(ie+=(0,R.nextCharLength)(B.badge,ie)),B.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(B.badge&&!It.isThemeIcon(B.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty");return!0}constructor(B,ie,Ee){this.badge=B,this.tooltip=ie,this.color=Ee}}e.FileDecoration=Wi;let ni=class{constructor(B){this.kind=B}};ni=Ve([F],ni),e.ColorTheme=ni;var Hi;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(Hi=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(B){return B instanceof xt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(B,ie){if(B<0)throw(0,T.illegalArgument)("start must be positive");if(ie<0)throw(0,T.illegalArgument)("end must be positive");B<=ie?(this.c=B,this.e=ie):(this.c=ie,this.e=B)}with(B){let ie=this.c,Ee=this.e;return B.start!==void 0&&(ie=B.start),B.end!==void 0&&(Ee=B.end),ie===this.c&&Ee===this.e?this:new xt(ie,Ee)}}e.NotebookRange=xt;class hi{static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(ie=>hi.isNotebookCellData(ie))}static isNotebookCellData(B){return!0}constructor(B,ie,Ee,qe,Qe,st,at){this.kind=B,this.value=ie,this.languageId=Ee,this.mime=qe,this.outputs=Qe??[],this.metadata=st,this.executionSummary=at,hi.validate(this)}}e.NotebookCellData=hi;class Pi{constructor(B){this.cells=B}}e.NotebookData=Pi;class $t{static isNotebookCellOutputItem(B){return B instanceof $t?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const ie={name:B.name,message:B.message,stack:B.stack};return $t.json(ie,"application/vnd.code.notebook.error")}static stdout(B){return $t.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return $t.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,ie="application/octet-stream"){return new $t(B,ie)}static text(B,ie=C.Mimes.text){const Ee=Re($t,E,"f",b).encode(String(B));return new $t(Ee,ie)}static json(B,ie="text/x-json"){const Ee=JSON.stringify(B,void 0,"	");return $t.text(Ee,ie)}constructor(B,ie){this.data=B,this.mime=ie;const Ee=(0,C.normalizeMimeType)(ie,!0);if(!Ee)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.NotebookCellOutputItem=$t,E=$t,b={value:new TextEncoder};class fi{static isNotebookCellOutput(B){return B instanceof fi?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&Array.isArray(B.items)}static ensureUniqueMimeTypes(B,ie=!1){const Ee=new Set,qe=new Set;for(let Qe=0;Qe<B.length;Qe++){const st=B[Qe],at=(0,C.normalizeMimeType)(st.mime);if(!Ee.has(at)||(0,v.isTextStreamMime)(at)){Ee.add(at);continue}qe.add(Qe),ie&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return qe.size===0?B:B.filter((Qe,st)=>!qe.has(st))}constructor(B,ie,Ee){this.items=fi.ensureUniqueMimeTypes(B,!0),typeof ie=="string"?(this.id=ie,this.metadata=Ee):(this.id=(0,O.generateUuid)(),this.metadata=ie??Ee)}}e.NotebookCellOutput=fi;var ji;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(ji=e.NotebookCellKind||(e.NotebookCellKind={}));var Vi;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(Vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var qi;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(qi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ki;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ki=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ne{constructor(B,ie){this.text=B,this.alignment=ie}}e.NotebookCellStatusBarItem=ne;var he;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(he=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Oe;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(Oe=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rt{constructor(B,ie=[]){this.uri=B,this.provides=(0,n.asArray)(ie)}}e.NotebookRendererScript=rt;class Dt{constructor(B){this.label=B}}e.NotebookKernelSourceAction=Dt;let Pt=class{constructor(B,ie){this.label=B,this.timestamp=ie}};Pt=Ve([F],Pt),e.TimelineItem=Pt;var sn;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(sn=e.ExtensionMode||(e.ExtensionMode={}));var on;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(on=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class cn{constructor(B,ie){this.ranges=B,this.wordPattern=ie}}e.LinkedEditingRanges=cn;class un{constructor(B,ie){this.c=B,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=un;var ln;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(ln=e.TestResultState||(e.TestResultState={}));var dn;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(dn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Gi=class{constructor(B=void 0,ie=void 0,Ee=void 0){this.include=B,this.exclude=ie,this.profile=Ee}};Gi=Ve([F],Gi),e.TestRunRequest=Gi;let xi=P=class{static diff(B,ie,Ee){const qe=new P(B);return qe.expectedOutput=ie,qe.actualOutput=Ee,qe}constructor(B){this.message=B}};xi=P=Ve([F],xi),e.TestMessage=xi;let Xi=class{constructor(B){this.id=B}};Xi=Ve([F],Xi),e.TestTag=Xi;let mi=class{constructor(B,ie){this.covered=B,this.total=ie}};mi=Ve([F],mi),e.CoveredCount=mi;let _i=M=class{static fromDetails(B,ie){const Ee=new mi(0,0),qe=new mi(0,0),Qe=new mi(0,0);for(const at of ie)if("branches"in at){Ee.total+=1,Ee.covered+=at.executionCount>0?1:0;for(const Lt of at.branches)qe.total+=1,qe.covered+=Lt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=at.executionCount>0?1:0;const st=new M(B,Ee,qe.total>0?qe:void 0,Qe.total>0?Qe:void 0);return st.detailedCoverage=ie,st}constructor(B,ie,Ee,qe){this.uri=B,this.statementCoverage=ie,this.branchCoverage=Ee,this.functionCoverage=qe}};_i=M=Ve([F],_i),e.FileCoverage=_i;let Qi=class{constructor(B,ie,Ee=[]){this.executionCount=B,this.location=ie,this.branches=Ee}};Qi=Ve([F],Qi),e.StatementCoverage=Qi;let Yi=class{constructor(B,ie){this.executionCount=B,this.location=ie}};Yi=Ve([F],Yi),e.BranchCoverage=Yi;let Ji=class{constructor(B,ie){this.executionCount=B,this.location=ie}};Ji=Ve([F],Ji),e.FunctionCoverage=Ji;var hn;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mn;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gn{constructor(B,ie,Ee,qe,Qe,st){this.kind=B,this.name=ie,this.detail=Ee,this.uri=qe,this.range=Qe,this.selectionRange=st}}e.TypeHierarchyItem=gn;class pn{constructor(B){this.uri=B}}e.TextTabInput=pn;class vn{constructor(B,ie){this.original=B,this.modified=ie}}e.TextDiffTabInput=vn;class bn{constructor(B,ie,Ee,qe){this.base=B,this.input1=ie,this.input2=Ee,this.result=qe}}e.TextMergeTabInput=bn;class En{constructor(B,ie){this.uri=B,this.viewType=ie}}e.CustomEditorTabInput=En;class wn{constructor(B){this.viewType=B}}e.WebviewEditorTabInput=wn;class Sn{constructor(B,ie){this.uri=B,this.notebookType=ie}}e.NotebookEditorTabInput=Sn;class yn{constructor(B,ie,Ee){this.original=B,this.modified=ie,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=yn;class In{constructor(){}}e.TerminalEditorTabInput=In;class Dn{constructor(B,ie){this.uri=B,this.inputBoxUri=ie}}e.InteractiveWindowInput=Dn}),define(De[95],Ce([1,0,47,13,10,249,125,6,16]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function O(h,i){i?k.set(h,i):k.delete(h)}e.setWordDefinitionFor=O;function I(h){return k.get(h)}class f extends N.MirrorTextModel{constructor(i,o,l,E,b,p,w,s){super(o,l,E,b),this.m=i,this.p=p,this.q=w,this.notebook=s,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(i){return(0,S.equals)(this.d,i)}get document(){if(!this.a){const i=this;this.a={get uri(){return i.c},get fileName(){return i.c.fsPath},get isUntitled(){return i.c.scheme===T.Schemas.untitled},get languageId(){return i.p},get version(){return i.g},get isClosed(){return i.b},get isDirty(){return i.q},save(){return i.r()},getText(o){return o?i.s(o):i.getText()},get eol(){return i.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return i.d.length},lineAt(o){return i.t(o)},offsetAt(o){return i.u(o)},positionAt(o){return i.v(o)},validateRange(o){return i.w(o)},validatePosition(o){return i.x(o)},getWordRangeAtPosition(o,l){return i.y(o,l)}}}return Object.freeze(this.a)}_acceptLanguageId(i){(0,n.ok)(!this.b),this.p=i}_acceptIsDirty(i){(0,n.ok)(!this.b),this.q=i}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(i){const o=this.w(i);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const l=this.f,E=o.start.line,b=o.end.line,p=[];p.push(this.d[E].substring(o.start.character));for(let w=E+1;w<b;w++)p.push(this.d[w]);return p.push(this.d[b].substring(0,o.end.character)),p.join(l)}t(i){let o;if(i instanceof R.Position?o=i.line:typeof i=="number"&&(o=i),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.d[o],o===this.d.length-1)}u(i){return i=this.x(i),this.k(),this.h.getPrefixSum(i.line-1)+i.character}v(i){i=Math.floor(i),i=Math.max(0,i),this.k();const o=this.h.getIndexOf(i),l=this.d[o.index].length;return new R.Position(o.index,Math.min(o.remainder,l))}w(i){if(!(i instanceof R.Range))throw new Error("Invalid argument");const o=this.x(i.start),l=this.x(i.end);return o===i.start&&l===i.end?i:new R.Range(o.line,o.character,l.line,l.character)}x(i){if(!(i instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return i.with(0,0);let{line:o,character:l}=i,E=!1;if(o<0)o=0,l=0,E=!0;else if(o>=this.d.length)o=this.d.length-1,l=this.d[o].length,E=!0;else{const b=this.d[o].length;l<0?(l=0,E=!0):l>b&&(l=b,E=!0)}return E?new R.Position(o,l):i}y(i,o){const l=this.x(i);if(!o)o=I(this.p);else if((0,y.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const E=(0,C.getWordAtText)(l.character+1,(0,C.ensureValidWordDefinition)(o),this.d[l.line],0);if(E)return new R.Range(l.line,E.startColumn-1,l.line,E.endColumn-1)}}e.ExtHostDocumentData=f;class v{constructor(i,o,l){this.a=i,this.b=o,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=v}),define(De[183],Ce([1,0,6,14,5]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=class{constructor(R){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new y.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let S;switch(R){case"light":S=n.ColorThemeKind.Light;break;case"hcDark":S=n.ColorThemeKind.HighContrast;break;case"hcLight":S=n.ColorThemeKind.HighContrastLight;break;default:S=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};N=Ve([je(0,T.IExtHostRpcService)],N),e.ExtHostTheming=N}),define(De[8],Ce([1,0,16,24,111,184,81,28,108,80,60,23,9,2,53,71,86,93,92,66,42,52,178,6]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b,p,w,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Se){function Te(x){const{selectionStartLineNumber:Ae,selectionStartColumn:Me,positionLineNumber:xe,positionColumn:ze}=x,Ze=new r.Position(Ae-1,Me-1),Ct=new r.Position(xe-1,ze-1);return new r.Selection(Ze,Ct)}Se.to=Te;function ge(x){const{anchor:Ae,active:Me}=x;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}Se.from=ge})(a=e.Selection||(e.Selection={}));var d;(function(Se){function Te(x){if(!x)return;const{start:Ae,end:Me}=x;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}Se.from=Te;function ge(x){if(!x)return;const{startLineNumber:Ae,startColumn:Me,endLineNumber:xe,endColumn:ze}=x;return new r.Range(Ae-1,Me-1,xe-1,ze-1)}Se.to=ge})(d=e.Range||(e.Range={}));var c;(function(Se){function Te(ge){switch(ge){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Se.to=Te})(c=e.TokenType||(e.TokenType={}));var u;(function(Se){function Te(x){return new r.Position(x.lineNumber-1,x.column-1)}Se.to=Te;function ge(x){return{lineNumber:x.line+1,column:x.character+1}}Se.from=ge})(u=e.Position||(e.Position={}));var t;(function(Se){function Te(Ae,Me){return(0,n.coalesce)((0,n.asArray)(Ae).map(xe=>ge(xe,Me)))}Se.from=Te;function ge(Ae,Me){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:x(Ae.scheme,Me),pattern:_.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function x(Ae,Me){return Me&&typeof Ae=="string"?Me.transformOutgoingScheme(Ae):Ae}})(t=e.DocumentSelector||(e.DocumentSelector={}));var m;(function(Se){function Te(x){switch(x){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Se.from=Te;function ge(x){switch(x){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Se.to=ge})(m=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(Se){function Te(x){let Ae;return x.code&&((0,f.isString)(x.code)||(0,f.isNumber)(x.code)?Ae=String(x.code):Ae={value:String(x.code.value),target:x.code.target}),{...d.from(x.range),message:x.message,source:x.source,code:Ae,severity:L.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(A.from),tags:Array.isArray(x.tags)?(0,n.coalesce)(x.tags.map(m.from)):void 0}}Se.from=Te;function ge(x){const Ae=new r.Diagnostic(d.to(x),x.message,L.to(x.severity));return Ae.source=x.source,Ae.code=(0,f.isString)(x.code)?x.code:x.code?.value,Ae.relatedInformation=x.relatedInformation&&x.relatedInformation.map(A.to),Ae.tags=x.tags&&(0,n.coalesce)(x.tags.map(m.to)),Ae}Se.to=ge})(g=e.Diagnostic||(e.Diagnostic={}));var A;(function(Se){function Te(x){return{...d.from(x.location.range),message:x.message,resource:x.location.uri}}Se.from=Te;function ge(x){return new r.DiagnosticRelatedInformation(new r.Location(x.resource,d.to(x)),x.message)}Se.to=ge})(A=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var L;(function(Se){function Te(x){switch(x){case r.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Se.from=Te;function ge(x){switch(x){case o.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Se.to=ge})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var K;(function(Se){function Te(x){return typeof x=="number"&&x>=r.ViewColumn.One?x-1:x===r.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}Se.from=Te;function ge(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=ge})(K=e.ViewColumn||(e.ViewColumn={}));function q(Se){return typeof Se.range<"u"}function j(Se){return Se.length===0?!0:!!q(Se[0])}e.isDecorationOptionsArr=j;var P;(function(Se){function Te(ze){return ze.map(Se.from)}Se.fromMany=Te;function ge(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function x(ze){let Ze;if(ge(ze)){const{language:mt,value:Tt}=ze;Ze={value:"```"+mt+`
`+Tt+"\n```\n"}}else r.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const Ct=Object.create(null);Ze.uris=Ct;const bt=mt=>{try{let Tt=v.URI.parse(mt,!0);Tt=Tt.with({query:Ae(Tt.query,Ct)}),Ct[mt]=Tt}catch{}return""},Ot=new S.marked.Renderer;return Ot.link=bt,Ot.image=mt=>typeof mt=="string"?bt(C.parseHrefAndDimensions(mt).href):"",(0,S.marked)(Ze.value,{renderer:Ot}),Ze}Se.from=x;function Ae(ze,Ze){if(!ze)return ze;let Ct;try{Ct=(0,k.parse)(ze)}catch{}if(!Ct)return ze;let bt=!1;return Ct=(0,I.cloneAndChange)(Ct,Ot=>{if(v.URI.isUri(Ot)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[mt]=Ot,bt=!0,mt}else return}),bt?JSON.stringify(Ct):ze}function Me(ze){const Ze=new r.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?v.URI.from(ze.baseUri):void 0,Ze}Se.to=Me;function xe(ze){if(!!ze)return typeof ze=="string"?ze:Se.from(ze)}Se.fromStrict=xe})(P=e.MarkdownString||(e.MarkdownString={}));function M(Se){return j(Se)?Se.map(Te=>({range:d.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?P.fromMany(Te.hoverMessage):Te.hoverMessage?P.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Se.map(Te=>({range:d.from(Te)}))}e.fromRangeOrRangeWithMessage=M;function F(Se){return typeof Se>"u"?Se:typeof Se=="string"?v.URI.file(Se):Se}e.pathOrURIToURI=F;var $;(function(Se){function Te(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?F(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Se.from=Te})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(Se){function Te(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?F(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?$.from(ge.before):void 0,after:ge.after?$.from(ge.after):void 0}}Se.from=Te})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(Se){function Te(ge){if(typeof ge>"u")return ge;switch(ge){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Te})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var X;(function(Se){function Te(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?V.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?z.from(ge.light):void 0,dark:ge.dark?z.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?F(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?$.from(ge.before):void 0,after:ge.after?$.from(ge.after):void 0}}Se.from=Te})(X=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Z;(function(Se){function Te(x){return{text:x.newText,eol:x.newEol&&it.from(x.newEol),range:d.from(x.range)}}Se.from=Te;function ge(x){const Ae=new r.TextEdit(d.to(x.range),x.text);return Ae.newEol=typeof x.eol>"u"?void 0:it.to(x.eol),Ae}Se.to=ge})(Z=e.TextEdit||(e.TextEdit={}));var fe;(function(Se){function Te(x,Ae){const Me={edits:[]};if(x instanceof r.WorkspaceEdit){const xe=new R.ResourceSet;for(const ze of x._allEntries())ze._type===1&&v.URI.isUri(ze.to)&&ze.from===void 0&&xe.add(ze.to);for(const ze of x._allEntries())ze._type===1?Me.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,T.encodeBase64)(T.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Me.edits.push({resource:ze.uri,textEdit:Z.from(ze.edit),versionId:xe.has(ze.uri)?void 0:Ae?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Me.edits.push({resource:ze.uri,textEdit:{range:d.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:xe.has(ze.uri)?void 0:Ae?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Me.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Me.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(ht.from)}})}return Me}Se.from=Te;function ge(x){const Ae=new r.WorkspaceEdit;for(const Me of x.edits)Me.textEdit?Ae.replace(v.URI.revive(Me.resource),d.to(Me.textEdit.range),Me.textEdit.text):Ae.renameFile(v.URI.revive(Me.oldResource),v.URI.revive(Me.newResource),Me.options);return Ae}Se.to=ge})(fe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var oe;(function(Se){const Te=Object.create(null);Te[r.SymbolKind.File]=0,Te[r.SymbolKind.Module]=1,Te[r.SymbolKind.Namespace]=2,Te[r.SymbolKind.Package]=3,Te[r.SymbolKind.Class]=4,Te[r.SymbolKind.Method]=5,Te[r.SymbolKind.Property]=6,Te[r.SymbolKind.Field]=7,Te[r.SymbolKind.Constructor]=8,Te[r.SymbolKind.Enum]=9,Te[r.SymbolKind.Interface]=10,Te[r.SymbolKind.Function]=11,Te[r.SymbolKind.Variable]=12,Te[r.SymbolKind.Constant]=13,Te[r.SymbolKind.String]=14,Te[r.SymbolKind.Number]=15,Te[r.SymbolKind.Boolean]=16,Te[r.SymbolKind.Array]=17,Te[r.SymbolKind.Object]=18,Te[r.SymbolKind.Key]=19,Te[r.SymbolKind.Null]=20,Te[r.SymbolKind.EnumMember]=21,Te[r.SymbolKind.Struct]=22,Te[r.SymbolKind.Event]=23,Te[r.SymbolKind.Operator]=24,Te[r.SymbolKind.TypeParameter]=25;function ge(Ae){return typeof Te[Ae]=="number"?Te[Ae]:6}Se.from=ge;function x(Ae){for(const Me in Te)if(Te[Me]===Ae)return Number(Me);return r.SymbolKind.Property}Se.to=x})(oe=e.SymbolKind||(e.SymbolKind={}));var le;(function(Se){function Te(x){switch(x){case r.SymbolTag.Deprecated:return 1}}Se.from=Te;function ge(x){switch(x){case 1:return r.SymbolTag.Deprecated}}Se.to=ge})(le=e.SymbolTag||(e.SymbolTag={}));var ce;(function(Se){function Te(x){return{name:x.name,kind:oe.from(x.kind),tags:x.tags&&x.tags.map(le.from),containerName:x.containerName,location:Fe.from(x.location)}}Se.from=Te;function ge(x){const Ae=new r.SymbolInformation(x.name,oe.to(x.kind),x.containerName,Fe.to(x.location));return Ae.tags=x.tags&&x.tags.map(le.to),Ae}Se.to=ge})(ce=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var me;(function(Se){function Te(x){const Ae={name:x.name||"!!MISSING: name!!",detail:x.detail,range:d.from(x.range),selectionRange:d.from(x.selectionRange),kind:oe.from(x.kind),tags:x.tags?.map(le.from)??[]};return x.children&&(Ae.children=x.children.map(Te)),Ae}Se.from=Te;function ge(x){const Ae=new r.DocumentSymbol(x.name,x.detail,oe.to(x.kind),d.to(x.range),d.to(x.selectionRange));return(0,n.isNonEmptyArray)(x.tags)&&(Ae.tags=x.tags.map(le.to)),x.children&&(Ae.children=x.children.map(ge)),Ae}Se.to=ge})(me=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(Se){function Te(x){const Ae=new r.CallHierarchyItem(oe.to(x.kind),x.name,x.detail||"",v.URI.revive(x.uri),d.to(x.range),d.to(x.selectionRange));return Ae._sessionId=x._sessionId,Ae._itemId=x._itemId,Ae}Se.to=Te;function ge(x,Ae,Me){if(Ae=Ae??x._sessionId,Me=Me??x._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,name:x.name,detail:x.detail,kind:oe.from(x.kind),uri:x.uri,range:d.from(x.range),selectionRange:d.from(x.selectionRange),tags:x.tags?.map(le.from)}}Se.from=ge})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(Se){function Te(ge){return new r.CallHierarchyIncomingCall(Y.to(ge.from),ge.fromRanges.map(x=>d.to(x)))}Se.to=Te})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var we;(function(Se){function Te(ge){return new r.CallHierarchyOutgoingCall(Y.to(ge.to),ge.fromRanges.map(x=>d.to(x)))}Se.to=Te})(we=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Fe;(function(Se){function Te(x){return{range:x.range&&d.from(x.range),uri:x.uri}}Se.from=Te;function ge(x){return new r.Location(v.URI.revive(x.uri),d.to(x.range))}Se.to=ge})(Fe=e.location||(e.location={}));var We;(function(Se){function Te(x){const Ae=x,Me=x;return{originSelectionRange:Ae.originSelectionRange?d.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Me.uri,range:d.from(Ae.targetRange?Ae.targetRange:Me.range),targetSelectionRange:Ae.targetSelectionRange?d.from(Ae.targetSelectionRange):void 0}}Se.from=Te;function ge(x){return{targetUri:v.URI.revive(x.uri),targetRange:d.to(x.range),targetSelectionRange:x.targetSelectionRange?d.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?d.to(x.originSelectionRange):void 0}}Se.to=ge})(We=e.DefinitionLink||(e.DefinitionLink={}));var Xe;(function(Se){function Te(x){return{range:d.from(x.range),contents:P.fromMany(x.contents)}}Se.from=Te;function ge(x){return new r.Hover(x.contents.map(P.to),d.to(x.range))}Se.to=ge})(Xe=e.Hover||(e.Hover={}));var Pe;(function(Se){function Te(x){return{range:d.from(x.range),expression:x.expression}}Se.from=Te;function ge(x){return new r.EvaluatableExpression(d.to(x.range),x.expression)}Se.to=ge})(Pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ie;(function(Se){function Te(x){if(x instanceof r.InlineValueText)return{type:"text",range:d.from(x.range),text:x.text};if(x instanceof r.InlineValueVariableLookup)return{type:"variable",range:d.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Te;function ge(x){switch(x.type){case"text":return{range:d.to(x.range),text:x.text};case"variable":return{range:d.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:d.to(x.range),expression:x.expression}}}Se.to=ge})(Ie=e.InlineValue||(e.InlineValue={}));var ke;(function(Se){function Te(x){return{frameId:x.frameId,stoppedLocation:d.from(x.stoppedLocation)}}Se.from=Te;function ge(x){return new r.InlineValueContext(x.frameId,d.to(x.stoppedLocation))}Se.to=ge})(ke=e.InlineValueContext||(e.InlineValueContext={}));var re;(function(Se){function Te(x){return{range:d.from(x.range),kind:x.kind}}Se.from=Te;function ge(x){return new r.DocumentHighlight(d.to(x.range),x.kind)}Se.to=ge})(re=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(Se){function Te(ge){switch(ge){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Se.to=Te})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(Se){function Te(ge){return{triggerKind:ae.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Se.to=Te})(J=e.CompletionContext||(e.CompletionContext={}));var D;(function(Se){function Te(x){switch(x){case r.CompletionItemTag.Deprecated:return 1}}Se.from=Te;function ge(x){switch(x){case 1:return r.CompletionItemTag.Deprecated}}Se.to=ge})(D=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(Se){const Te=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function ge(Me){return Te.get(Me)??9}Se.from=ge;const x=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ae(Me){return x.get(Me)??r.CompletionItemKind.Property}Se.to=Ae})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(Se){function Te(ge,x){const Ae=new r.CompletionItem(ge.label);return Ae.insertText=ge.insertText,Ae.kind=U.to(ge.kind),Ae.tags=ge.tags?.map(D.to),Ae.detail=ge.detail,Ae.documentation=C.isMarkdownString(ge.documentation)?P.to(ge.documentation):ge.documentation,Ae.sortText=ge.sortText,Ae.filterText=ge.filterText,Ae.preselect=ge.preselect,Ae.commitCharacters=ge.commitCharacters,h.Range.isIRange(ge.range)?Ae.range=d.to(ge.range):typeof ge.range=="object"&&(Ae.range={inserting:d.to(ge.range.insert),replacing:d.to(ge.range.replace)}),Ae.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Ae.insertText=new r.SnippetString(ge.insertText):(Ae.insertText=ge.insertText,Ae.textEdit=Ae.range instanceof r.Range?new r.TextEdit(Ae.range,Ae.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ge.additionalTextEdits.map(Me=>Z.to(Me))),Ae.command=x&&ge.command?x.fromInternal(ge.command):void 0,Ae}Se.to=Te})(H=e.CompletionItem||(e.CompletionItem={}));var G;(function(Se){function Te(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:P.fromStrict(x.documentation)}}Se.from=Te;function ge(x){return{label:x.label,documentation:C.isMarkdownString(x.documentation)?P.to(x.documentation):x.documentation}}Se.to=ge})(G=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(Se){function Te(x){return{label:x.label,documentation:P.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(G.from):[],activeParameter:x.activeParameter}}Se.from=Te;function ge(x){return{label:x.label,documentation:C.isMarkdownString(x.documentation)?P.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(G.to):[],activeParameter:x.activeParameter}}Se.to=ge})(ee=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(Se){function Te(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ee.from):[]}}Se.from=Te;function ge(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ee.to):[]}}Se.to=ge})(de=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(Se){function Te(ge,x){const Ae=new r.InlayHint(u.to(x.position),typeof x.label=="string"?x.label:x.label.map(se.to.bind(void 0,ge)),x.kind&&ve.to(x.kind));return Ae.textEdits=x.textEdits&&x.textEdits.map(Z.to),Ae.tooltip=C.isMarkdownString(x.tooltip)?P.to(x.tooltip):x.tooltip,Ae.paddingLeft=x.paddingLeft,Ae.paddingRight=x.paddingRight,Ae}Se.to=Te})(ye=e.InlayHint||(e.InlayHint={}));var se;(function(Se){function Te(ge,x){const Ae=new r.InlayHintLabelPart(x.label);return Ae.tooltip=C.isMarkdownString(x.tooltip)?P.to(x.tooltip):x.tooltip,i.Command.is(x.command)&&(Ae.command=ge.fromInternal(x.command)),x.location&&(Ae.location=Fe.to(x.location)),Ae}Se.to=Te})(se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(Se){function Te(x){return x}Se.from=Te;function ge(x){return x}Se.to=ge})(ve=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(Se){function Te(x){return{range:d.from(x.range),url:x.target,tooltip:x.tooltip}}Se.from=Te;function ge(x){let Ae;if(x.url)try{Ae=typeof x.url=="string"?v.URI.parse(x.url,!0):v.URI.revive(x.url)}catch{}return new r.DocumentLink(d.to(x.range),Ae)}Se.to=ge})(be=e.DocumentLink||(e.DocumentLink={}));var $e;(function(Se){function Te(x){const Ae=new r.ColorPresentation(x.label);return x.textEdit&&(Ae.textEdit=Z.to(x.textEdit)),x.additionalTextEdits&&(Ae.additionalTextEdits=x.additionalTextEdits.map(Me=>Z.to(Me))),Ae}Se.to=Te;function ge(x){return{label:x.label,textEdit:x.textEdit?Z.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Ae=>Z.from(Ae)):void 0}}Se.from=ge})($e=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(Se){function Te(x){return new r.Color(x[0],x[1],x[2],x[3])}Se.to=Te;function ge(x){return[x.red,x.green,x.blue,x.alpha]}Se.from=ge})(He=e.Color||(e.Color={}));var tt;(function(Se){function Te(x){return{range:d.from(x.range)}}Se.from=Te;function ge(x){return new r.SelectionRange(d.to(x.range))}Se.to=ge})(tt=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(Se){function Te(ge){switch(ge){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Se.to=Te})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(Se){function Te(x){switch(x){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Te;function ge(x){switch(x){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Se.to=ge})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(Se){function Te(x){if(x===r.EndOfLine.CRLF)return 1;if(x===r.EndOfLine.LF)return 0}Se.from=Te;function ge(x){if(x===1)return r.EndOfLine.CRLF;if(x===0)return r.EndOfLine.LF}Se.to=ge})(it=e.EndOfLine||(e.EndOfLine={}));var ct;(function(Se){function Te(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Te})(ct=e.ProgressLocation||(e.ProgressLocation={}));var nt;(function(Se){function Te(ge){const x={start:ge.start+1,end:ge.end+1};return ge.kind&&(x.kind=Le.from(ge.kind)),x}Se.from=Te})(nt=e.FoldingRange||(e.FoldingRange={}));var Le;(function(Se){function Te(ge){if(ge)switch(ge){case r.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}Se.from=Te})(Le=e.FoldingRangeKind||(e.FoldingRangeKind={}));var lt;(function(Se){function Te(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?d.from(ge.selection):void 0,override:typeof ge.override=="boolean"?E.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Te})(lt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var _;(function(Se){function Te(Me){return Me instanceof r.RelativePattern?Me.toJSON():typeof Me=="string"?Me:ge(Me)||x(Me)?new r.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}Se.from=Te;function ge(Me){const xe=Me;return xe?v.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function x(Me){const xe=Me;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Ae(Me){return typeof Me=="string"?Me:new r.RelativePattern(v.URI.revive(Me.baseUri),Me.pattern)}Se.to=Ae})(_=e.GlobPattern||(e.GlobPattern={}));var Q;(function(Se){function Te(ge){if(ge){if(Array.isArray(ge))return ge.map(Te);if(typeof ge=="string")return ge;{const x=ge;return{language:x.language,scheme:x.scheme,pattern:_.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}Se.from=Te})(Q=e.LanguageSelector||(e.LanguageSelector={}));var ue;(function(Se){function Te(x){return{start:x.start,end:x.end}}Se.from=Te;function ge(x){return new r.NotebookRange(x.start,x.end)}Se.to=ge})(ue=e.NotebookRange||(e.NotebookRange={}));var Ue;(function(Se){function Te(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}Se.to=Te;function ge(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}Se.from=ge})(Ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ne;(function(Se){function Te(ge){if(ge===b.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(ge===b.NotebookCellExecutionState.Pending)return;if(ge===b.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Se.to=Te})(Ne=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _e;(function(Se){function Te(x){switch(x){case r.NotebookCellKind.Markup:return b.CellKind.Markup;case r.NotebookCellKind.Code:default:return b.CellKind.Code}}Se.from=Te;function ge(x){switch(x){case b.CellKind.Markup:return r.NotebookCellKind.Markup;case b.CellKind.Code:default:return r.NotebookCellKind.Code}}Se.to=ge})(_e=e.NotebookCellKind||(e.NotebookCellKind={}));var Je;(function(Se){function Te(x){const Ae={metadata:x.metadata??Object.create(null),cells:[]};for(const Me of x.cells)r.NotebookCellData.validate(Me),Ae.cells.push(ht.from(Me));return Ae}Se.from=Te;function ge(x){const Ae=new r.NotebookData(x.cells.map(ht.to));return(0,f.isEmptyObject)(x.metadata)||(Ae.metadata=x.metadata),Ae}Se.to=ge})(Je=e.NotebookData||(e.NotebookData={}));var ht;(function(Se){function Te(x){return{cellKind:_e.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:Ue.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(St.from):[]}}Se.from=Te;function ge(x){return new r.NotebookCellData(_e.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(St.to):void 0,x.metadata,x.internalMetadata?Ue.to(x.internalMetadata):void 0)}Se.to=ge})(ht=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(Se){function Te(x){return{mime:x.mime,valueBytes:T.VSBuffer.wrap(x.data)}}Se.from=Te;function ge(x){return new r.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}Se.to=ge})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var St;(function(Se){function Te(x){return{outputId:x.id,items:x.items.map(wt.from),metadata:x.metadata}}Se.from=Te;function ge(x){const Ae=x.items.map(wt.to);return new r.NotebookCellOutput(Ae,x.outputId,x.metadata)}Se.to=ge})(St=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ut;(function(Se){function Te(Ae){return x(Ae)?{include:(0,f.withNullAsUndefined)(_.from(Ae.include)),exclude:(0,f.withNullAsUndefined)(_.from(Ae.exclude))}:(0,f.withNullAsUndefined)(_.from(Ae))}Se.from=Te;function ge(Ae){return x(Ae)?{include:_.to(Ae.include),exclude:_.to(Ae.exclude)}:_.to(Ae)}Se.to=ge;function x(Ae){const Me=Ae;return Me?!(0,f.isUndefinedOrNull)(Me.include)&&!(0,f.isUndefinedOrNull)(Me.exclude):!1}})(ut=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var gt;(function(Se){function Te(ge,x,Ae){const Me=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Me,Ae),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Se.from=Te})(gt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var yt;(function(Se){function Te(ge,x,Ae){const Me=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:x.toInternal(Me,Ae),label:ge.label,description:ge.description,detail:ge.detail}}Se.from=Te})(yt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ut;(function(Se){function Te(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Se.from=Te})(Ut=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var At;(function(Se){function Te(x){return{uri:x.uri,provides:x.provides}}Se.from=Te;function ge(x){return new r.NotebookRendererScript(v.URI.revive(x.uri),x.provides)}Se.to=ge})(At=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Se){function Te(x){return{message:P.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:d.from(x.location.range),uri:x.location.uri}}}Se.from=Te;function ge(x){const Ae=new r.TestMessage(typeof x.message=="string"?x.message:P.to(x.message));return Ae.actualOutput=x.actual,Ae.expectedOutput=x.expected,Ae.location=x.location?Fe.to(x.location):void 0,Ae}Se.to=ge})(pt=e.TestMessage||(e.TestMessage={}));var kt;(function(Se){Se.namespace=w.namespaceTestTag,Se.denamespace=w.denamespaceTestTag})(kt=e.TestTag||(e.TestTag={}));var Bt;(function(Se){function Te(x){const Ae=(0,l.getPrivateApiFor)(x).controllerId;return{extId:p.TestId.fromExtHostTestItem(x,Ae).toString(),label:x.label,uri:v.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(Me=>kt.namespace(Ae,Me.id)),range:h.Range.lift(d.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&P.fromStrict(x.error)||null}}Se.from=Te;function ge(x){return{parent:void 0,error:void 0,id:p.TestId.fromString(x.extId).localId,label:x.label,uri:v.URI.revive(x.uri),tags:(x.tags||[]).map(Ae=>{const{tagId:Me}=kt.denamespace(Ae);return new r.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}Se.toPlain=ge})(Bt=e.TestItem||(e.TestItem={})),function(Se){function Te(x){return{id:x.id}}Se.from=Te;function ge(x){return new r.TestTag(x.id)}Se.to=ge}(kt=e.TestTag||(e.TestTag={}));var Ft;(function(Se){const Te=(x,Ae)=>{const Me=[];for(const[ze,Ze]of Ae)p.TestId.compare(Ze.item.extId,ze)===2&&(Ae.delete(ze),Me.push(Ze));const xe={...Bt.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(pt.to)})),children:Me.map(ze=>Te(ze,Ae))};for(const ze of xe.children)ze.parent=xe;return xe};function ge(x){const Ae=[],Me=new Map;for(const xe of x.items){Me.set(xe.item.extId,xe);const ze=p.TestId.root(xe.item.extId);x.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(xe.item.extId))&&Ae.push(xe)}return{completedAt:x.completedAt,results:Ae.map(xe=>Te(xe,Me))}}Se.to=ge})(Ft=e.TestResults||(e.TestResults={}));var Ke;(function(Se){function Te(Me){return{covered:Me.covered,total:Me.covered}}function ge(Me){return"line"in Me?u.from(Me):d.from(Me)}function x(Me){return"branches"in Me?{count:Me.executionCount,location:ge(Me.location),type:1,branches:Me.branches.length?Me.branches.map(xe=>({count:xe.executionCount,location:xe.location&&ge(xe.location)})):void 0}:{type:0,count:Me.executionCount,location:ge(Me.location)}}Se.fromDetailed=x;function Ae(Me){return{uri:Me.uri,statement:Te(Me.statementCoverage),branch:Me.branchCoverage&&Te(Me.branchCoverage),function:Me.functionCoverage&&Te(Me.functionCoverage),details:Me.detailedCoverage?.map(x)}}Se.fromFile=Ae})(Ke=e.TestCoverage||(e.TestCoverage={}));var zt;(function(Se){function Te(ge){switch(ge){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Se.to=Te})(zt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Rt;(function(Se){function Te(x){const Ae=new r.TypeHierarchyItem(oe.to(x.kind),x.name,x.detail||"",v.URI.revive(x.uri),d.to(x.range),d.to(x.selectionRange));return Ae._sessionId=x._sessionId,Ae._itemId=x._itemId,Ae}Se.to=Te;function ge(x,Ae,Me){if(Ae=Ae??x._sessionId,Me=Me??x._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,kind:oe.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:d.from(x.range),selectionRange:d.from(x.selectionRange),tags:x.tags?.map(le.from)}}Se.from=ge})(Rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Wt;(function(Se){function Te(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}Se.from=Te})(Wt=e.ViewBadge||(e.ViewBadge={}));var ft;(function(Se){function Te(Me,xe,ze){const Ze=xe.fileData;return Ze?new class extends r.DataTransferItem{asFile(){return{name:Ze.name,uri:v.URI.revive(Ze.uri),data:(0,N.once)(()=>ze())}}}("",xe.id):Me===O.Mimes.uriList&&xe.uriListData?new r.DataTransferItem(Ae(xe.uriListData)):new r.DataTransferItem(xe.asString)}Se.to=Te;async function ge(Me,xe){const ze=await xe.asString();if(Me===O.Mimes.uriList)return{id:xe.id,asString:"",fileData:void 0,uriListData:x(ze)};const Ze=xe.asFile();return{id:xe.id,asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}Se.from=ge;function x(Me){return y.UriList.split(Me).map(xe=>{if(xe.startsWith("#"))return xe;try{return v.URI.parse(xe)}catch{}return xe})}function Ae(Me){return y.UriList.create(Me.map(xe=>typeof xe=="string"?xe:v.URI.revive(xe)))}})(ft=e.DataTransferItem||(e.DataTransferItem={}));var Mt;(function(Se){function Te(x,Ae){const Me=x.items.map(([xe,ze])=>[xe,ft.to(xe,ze,()=>Ae(ze.id))]);return new r.DataTransfer(Me)}Se.toDataTransfer=Te;async function ge(x){const Ae={items:[]},Me=[];return x.forEach((xe,ze)=>{Me.push((async()=>{Ae.items.push([ze,await ft.from(ze,xe)])})())}),await Promise.all(Me),Ae}Se.toDataTransferDTO=ge})(Mt=e.DataTransfer||(e.DataTransfer={}))}),define(De[185],Ce([1,0,2,11,6,8,152]),function(te,e,n,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(k,O,I,f={timeout:1500,errors:3}){this.c=k,this.d=O,this.f=I,this.g=f,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(O,I,f)=>{const h={dispose:this.a.push([O,I,k])};return Array.isArray(f)&&f.push(h),h}}async $participateInSave(k,O){const I=n.URI.revive(k);let f=!1;const v=setTimeout(()=>f=!0,this.g.timeout),h=[];try{for(const i of[...this.a]){if(f)break;const o=this.d.getDocument(I),l=await this.h(i,{document:o,reason:N.TextDocumentSaveReason.to(O)});h.push(l)}}finally{clearTimeout(v)}return h}h([k,O,I],f){const v=this.b.get(k);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(I,k,O,f).then(()=>!0,h=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const i=this.b.get(k);this.b.set(k,i?i+1:1),typeof i=="number"&&i>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,O,I,f){const v=[],h=Date.now(),{document:i,reason:o}=f,{version:l}=i,E=Object.freeze({document:i,reason:o,waitUntil(b){if(Object.isFrozen(v))throw(0,T.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(b))}});try{O.apply(I,[E])}catch(b){return Promise.reject(b)}return Object.freeze(v),new Promise((b,p)=>{const w=setTimeout(()=>p(new Error("timeout")),this.g.timeout);return Promise.all(v).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(w),b(s)}).catch(s=>{clearTimeout(w),p(s)})}).then(b=>{const p={edits:[]};for(const w of b)if(Array.isArray(w)&&w.every(s=>s instanceof y.TextEdit))for(const{newText:s,newEol:r,range:a}of w)p.edits.push({resource:i.uri,versionId:void 0,textEdit:{range:a&&N.Range.from(a),text:s,eol:r&&N.EndOfLine.from(r)}});if(p.edits.length!==0)return l===i.version?this.f.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(De[186],Ce([1,0,13,2,8,6,66]),function(te,e,n,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(I,f,v,h){this.start=I,this.deletedCount=f,this.deletedItems=v,this.items=h}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(I,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,f,v){this.notebook=I,this.h=f,this.j=v,this.handle=v.handle,this.uri=T.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(y.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(y.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:y.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return I.g},set mime(h){I.g=h},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(v)}return this.f}setOutputs(I){this.a=I.map(y.NotebookCellOutput.to)}setOutputItems(I,f,v){const h=v.map(y.NotebookCellOutputItem.to),i=this.a.find(o=>o.id===I);if(i&&(f||(i.items.length=0),i.items.push(...h),i.items.length>1&&i.items.every(o=>C.isTextStreamMime(o.mime)))){const o=new Map,l=[];i.items.forEach(E=>{let b;o.has(E.mime)?b=o.get(E.mime):(b=[],o.set(E.mime,b),l.push(E.mime)),b.push(E.data)}),i.items.length=0,l.forEach(E=>{const b=C.compressOutputItemStreams(o.get(E));i.items.push({mime:E,data:b.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(y.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=S;class k{constructor(I,f,v,h,i){this.k=I,this.l=f,this.m=v,this.uri=h,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=i.viewType,this.f=Object.freeze(i.metadata??Object.create(null)),this.r([[0,0,i.cells]],!0,void 0),this.g=i.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const I=this,f={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===n.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(v){return v=I.n(v),I.b[v].apiCell},getCells(v){return(v?I.p(v):I.b).map(i=>i.apiCell)},save(){return I.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,f,v){this.g=I.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:v});const h={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},i=[];for(const l of I.rawEvents)l.kind===C.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,h.contentChanges):l.kind===C.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,h.contentChanges):l.kind===C.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),i.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),i.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),i.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===C.NotebookCellsChangeType.ChangeCellContent?i.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),i.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),i.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const o=new Map;for(let l=0;l<i.length;l++){const E=i[l],b=o.get(E.cell);if(b===void 0){const p=h.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...E});o.set(E.cell,p-1)}else h.cellChanges[b]={...h.cellChanges[b],...E}}return Object.freeze(h),Object.freeze(h.cellChanges),Object.freeze(h.contentChanges),h}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let f=I.start|0,v=I.end|0;return f<0&&(f=0),v>this.b.length&&(v=this.b.length),I.with({start:f,end:v})}p(I){I=this.o(I);const f=[];for(let v=I.start;v<I.end;v++)f.push(this.b[v]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,f,v){if(this.j)return;const h=[],i=[],o=[];if(I.reverse().forEach(l=>{const b=l[2].map(s=>{const r=new S(this,this.l,s);return f||i.push(S.asModelAddData(this.apiNotebook,s)),r}),p=new R(l[0],l[1],[],b),w=this.b.splice(l[0],l[1],...b);for(const s of w)o.push(s.uri),p.deletedItems.push(s.apiCell);h.push(p)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:i,removedDocuments:o}),v)for(const l of h)v.push(l.asApiEvent())}s(I,f,v,h){const i=this.b.splice(I,f);this.b.splice(v,0,...i);const o=[new R(I,f,i.map(l=>l.apiCell),[]),new R(v,0,[],i)];for(const l of o)h.push(l.asApiEvent())}t(I,f){this.b[I].setOutputs(f)}u(I,f,v,h){this.b[I].setOutputItems(f,v,h)}v(I,f){const v=this.b[I];v.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(v.uri,f)}w(I,f){const v=this.b[I];v.apiCell.mime=f}x(I,f){this.b[I].setMetadata(f)}y(I,f){this.b[I].setInternalMetadata(f)}getCellFromApiCell(I){return this.b.find(f=>f.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(f=>f.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.ExtHostNotebookDocument=k,k.a=0}),define(De[96],Ce([1,0,11,8,6]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{constructor(R,S,k,O,I,f){this.id=R,this.f=S,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=O,this.c=f}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(S){this.selections=[S]},get selections(){return R.a},set selections(S){if(!Array.isArray(S)||!S.every(y.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");R.a=S,R.g(S)},get visibleRanges(){return R.b},revealRange(S,k){R.f.$tryRevealRange(R.id,T.NotebookRange.from(S),k??y.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(T.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.ExtHostNotebookEditor=N,N.apiEditorsToExtHost=new WeakMap}),define(De[187],Ce([1,0,5,12,8]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let N=class{constructor(R,S){this.c=R,this.d=S,this.a=new n.Emitter,this.b=new n.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,S);const k=this.d.getEditorById(R);S.visibleRanges&&k._acceptVisibleRanges(S.visibleRanges.ranges.map(y.NotebookRange.to)),S.selections&&k._acceptSelections(S.selections.selections.map(y.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const S in R)this.d.getEditorById(S)._acceptViewColumn(y.ViewColumn.to(R[S]))}};N=Ve([je(0,T.ILogService)],N),e.ExtHostNotebookEditors=N}),define(De[188],Ce([1,0,8,155,134,20,59,11]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,v,h){const i=this.b++,{title:o,location:l,cancellable:E}=v,b={label:(0,y.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(i,{location:n.ProgressLocation.from(l),title:o,source:b,cancellable:E},f.isUnderDevelopment?void 0:f.identifier.value).catch(R.onUnexpectedExternalError),this.d(i,h,!!E)}d(f,v,h){let i;h&&(i=new N.CancellationTokenSource,this.c.set(f,i));const o=E=>{this.a.$progressEnd(E),this.c.delete(E),i?.dispose()};let l;try{l=v(new O(this.a,f),h&&i?i.token:N.CancellationToken.None)}catch(E){throw o(f),E}return l.then(E=>o(f),E=>o(f)),l}$acceptProgressCanceled(f){const v=this.c.get(f);v&&(v.cancel(),this.c.delete(f))}}e.ExtHostProgress=S;function k(I,f){return I.message=f.message,typeof f.increment=="number"&&(typeof I.increment=="number"?I.increment+=f.increment:I.increment=f.increment),I}class O extends T.Progress{constructor(f,v){super(h=>this.throttledReport(h)),this.c=f,this.d=v}throttledReport(f){this.c.$progressReport(this.d,f)}}Ve([(0,C.throttle)(100,(I,f)=>k(I,f),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(De[97],Ce([1,0,53,93,42,67,52,8,2]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(b,p,w,s)=>{let r=p;return{enumerable:!0,configurable:!1,get(){return r},set(a){if(!w(r,a)){const d=r;r=a,b.listener?.(s(a,d))}}}},O=(b,p)=>b===p,I={range:(b,p)=>b===p?!0:!b||!p?!1:b.isEqual(p),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(b,p)=>!(b.length!==p.length||b.some(w=>!p.find(s=>w.id===s.id)))},f=b=>p=>({op:4,update:b(p)}),v=(b,p)=>({range:(()=>{let w;const s=f(r=>({range:n.Range.lift(R.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return w},set(r){b.listener?.({op:6}),I.range(w,r)||(w=r,b.listener?.(s(r)))}}})(),label:k(b,p,I.label,f(w=>({label:w}))),description:k(b,void 0,I.description,f(w=>({description:w}))),sortText:k(b,void 0,I.sortText,f(w=>({sortText:w}))),canResolveChildren:k(b,!1,I.canResolveChildren,w=>({op:2,state:w})),busy:k(b,!1,I.busy,f(w=>({busy:w}))),error:k(b,void 0,I.error,f(w=>({error:R.MarkdownString.fromStrict(w)||null}))),tags:k(b,[],I.tags,(w,s)=>({op:1,new:w.map(R.TestTag.from),old:s.map(R.TestTag.from)}))}),h=b=>{const p=y.TestId.fromString(b.extId),w=new o(p.controllerId,p.localId,b.label,S.URI.revive(b.uri)||void 0);return w.range=R.Range.to(b.range||void 0),w.description=b.description||void 0,w.sortText=b.sortText||void 0,w.tags=b.tags.map(s=>R.TestTag.to({id:(0,C.denamespaceTestTag)(s).tagId})),w},i=b=>{let p;for(const w of b.tests){const s=h(w.item);(0,T.getPrivateApiFor)(s).parent=p,p=s}return p};e.toItemFromContext=i;class o{constructor(p,w,s,r){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const a=(0,T.createPrivateApiFor)(this,p);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof l?void 0:a.parent}},children:{value:(0,N.createTestItemChildren)(a,T.getPrivateApiFor,o),enumerable:!0,writable:!1},...v(a,s)})}}e.TestItemImpl=o;class l extends o{constructor(p,w){super(p,p,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class E extends N.TestItemCollection{constructor(p,w,s){super({controllerId:p,getDocumentVersion:r=>r&&s.getDocument(r)?.version,getApiFor:T.getPrivateApiFor,getChildren:r=>r.children,root:new l(p,w),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=E}),define(De[98],Ce([1,0,47,11,79,8,6]),function(te,e,n,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class R{constructor(f,v,h){const i=R.c.nextId();f.$registerTextEditorDecorationType(v.identifier,i,N.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:i,dispose(){f.$removeTextEditorDecorationType(i)}})}}e.TextEditorDecorationType=R,R.c=new y.IdGenerator("TextEditorDecorationType");class S{constructor(f,v){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,v){this.k();let h=null;if(f instanceof C.Position)h=new C.Range(f,f);else if(f instanceof C.Range)h=f;else throw new Error("Unrecognized location");this.l(h,v,!1)}insert(f,v){this.k(),this.l(new C.Range(f,f),v,!0)}delete(f){this.k();let v=null;if(f instanceof C.Range)v=f;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(f,v,h){const i=this.c.validateRange(f);this.g.push({range:i,text:v,forceMoveMarkers:h})}setEndOfLine(f){if(this.k(),f!==C.EndOfLine.LF&&f!==C.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this.h=f}}e.TextEditorEdit=S;class k{constructor(f,v,h,i){this.c=f,this.d=v,this._accept(h),this.e=i;const o=this;this.value={get tabSize(){return o.f},set tabSize(l){o.m(l)},get indentSize(){return o.g},set indentSize(l){o.o(l)},get insertSpaces(){return o.h},set insertSpaces(l){o.q(l)},get cursorStyle(){return o.j},set cursorStyle(l){o.s(l)},get lineNumbers(){return o.k},set lineNumbers(l){o.t(l)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=N.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const v=Math.floor(f);return v>0?v:null}if(typeof f=="string"){const v=parseInt(f,10);return isNaN(v)?null:v>0?v:null}return null}m(f){const v=this.l(f);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const v=Math.floor(f);return v>0?v:null}if(typeof f=="string"){const v=parseInt(f,10);return isNaN(v)?null:v>0?v:null}return null}o(f){const v=this.n(f);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}q(f){const v=this.p(f);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(f)})))}assign(f){const v={};let h=!1;if(typeof f.tabSize<"u"){const i=this.l(f.tabSize);i==="auto"?(h=!0,v.tabSize=i):typeof i=="number"&&this.f!==i&&(this.f=i,h=!0,v.tabSize=i)}if(typeof f.indentSize<"u"){const i=this.n(f.indentSize);i==="tabSize"?(h=!0,v.indentSize=i):typeof i=="number"&&this.g!==i&&(this.g=i,h=!0,v.indentSize=i)}if(typeof f.insertSpaces<"u"){const i=this.p(f.insertSpaces);i==="auto"?(h=!0,v.insertSpaces=i):this.h!==i&&(this.h=i,h=!0,v.insertSpaces=i)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,h=!0,v.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,h=!0,v.lineNumbers=N.TextEditorLineNumbersStyle.from(f.lineNumbers)),h&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(f,v){v.catch(h=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(h)})}}e.ExtHostTextEditorOptions=k;class O{constructor(f,v,h,i,o,l,E,b){this.id=f,this.j=v,this.k=h,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,l,h),this.e=E,this.f=b;const p=this;this.value=Object.freeze({get document(){return i.getValue()},set document(w){throw(0,T.readonly)("document")},get selection(){return p.c&&p.c[0]},set selection(w){if(!(w instanceof C.Selection))throw(0,T.illegalArgument)("selection");p.c=[w],p.l()},get selections(){return p.c},set selections(w){if(!Array.isArray(w)||w.some(s=>!(s instanceof C.Selection)))throw(0,T.illegalArgument)("selections");p.c=w,p.l()},get visibleRanges(){return p.e},set visibleRanges(w){throw(0,T.readonly)("visibleRanges")},get options(){return p.d.value},set options(w){p.g||p.d.assign(w)},get viewColumn(){return p.f},set viewColumn(w){throw(0,T.readonly)("viewColumn")},edit(w,s={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new S(i.getValue(),s);return w(r),p.m(r)},insertSnippet(w,s,r={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!s||Array.isArray(s)&&s.length===0)a=p.c.map(d=>N.Range.from(d));else if(s instanceof C.Position){const{lineNumber:d,column:c}=N.Position.from(s);a=[{startLineNumber:d,startColumn:c,endLineNumber:d,endColumn:c}]}else if(s instanceof C.Range)a=[N.Range.from(s)];else{a=[];for(const d of s)if(d instanceof C.Range)a.push(N.Range.from(d));else{const{lineNumber:c,column:u}=N.Position.from(d);a.push({startLineNumber:c,startColumn:u,endLineNumber:c,endColumn:u})}}return v.$tryInsertSnippet(f,i.getValue().version,w.value,a,r)},setDecorations(w,s){const r=s.length===0;r&&!p.h.has(w.key)||(r?p.h.delete(w.key):p.h.add(w.key),p.n(()=>{if(N.isDecorationOptionsArr(s))return v.$trySetDecorations(f,w.key,N.fromRangeOrRangeWithMessage(s));{const a=new Array(4*s.length);for(let d=0,c=s.length;d<c;d++){const u=s[d];a[4*d]=u.start.line+1,a[4*d+1]=u.start.character+1,a[4*d+2]=u.end.line+1,a[4*d+3]=u.end.character+1}return v.$trySetDecorationsFast(f,w.key,a)}}))},revealRange(w,s){p.n(()=>v.$tryRevealRange(f,N.Range.from(w),s||C.TextEditorRevealType.Default))},show(w){v.$tryShowEditor(f,N.ViewColumn.from(w))},hide(){v.$tryHideEditor(f)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,n.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,n.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,n.ok)(!this.g),this.f=f}_acceptSelections(f){(0,n.ok)(!this.g),this.c=f}async l(){const f=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const v=f.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const h=v.edits.map(o=>o.range);h.sort((o,l)=>o.end.line===l.end.line?o.end.character===l.end.character?o.start.line===l.start.line?o.start.character-l.start.character:o.start.line-l.start.line:o.end.character-l.end.character:o.end.line-l.end.line);for(let o=0,l=h.length-1;o<l;o++){const E=h[o].end;if(h[o+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const i=v.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,i,{setEndOfLine:typeof v.setEndOfLine=="number"?N.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.ExtHostTextEditor=O}),define(De[189],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[190],Ce([1,0,145,11,29,85,88,30,26,189,154,147]),function(te,e,n,T,y,N,C,R,S,k,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const f=R.Registry.as(C.Extensions.JSONContribution);class v{constructor(w,s,r){this.a=w,this.b=s,this.c=r}d(w,s){this.a({type:w,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(y.default.Error,w)}warn(w){this.d(y.default.Warning,w)}info(w){this.d(y.default.Info,w)}}e.ExtensionMessageCollector=v;class h{static a(w){const s=new Set;for(let r=0,a=w.length;r<a;r++)s.add(S.ExtensionIdentifier.toKey(w[r].description.identifier));return s}static compute(w,s){if(!w||!w.length)return new h(s,[]);if(!s||!s.length)return new h([],w);const r=this.a(w),a=this.a(s),d=s.filter(u=>!r.has(S.ExtensionIdentifier.toKey(u.description.identifier))),c=w.filter(u=>!a.has(S.ExtensionIdentifier.toKey(u.description.identifier)));return new h(d,c)}constructor(w,s){this.added=w,this.removed=s}}e.ExtensionPointUserDelta=h;class i{constructor(w,s){this.name=w,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=h.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,T.onUnexpectedError)(w)}}}e.ExtensionPoint=i;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:n.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(30,null)},{label:"onUri",body:"onUri",description:n.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(35,null)},{label:"onRenderer",description:n.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(37,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(39,null)},{label:"*",description:n.localize(40,null),body:"*"}]}},badges:{type:"array",description:n.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(42,null)},href:{type:"string",description:n.localize(43,null)},description:{type:"string",description:n.localize(44,null)}}}},markdown:{type:"string",description:n.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(49,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(50,null)},{body:["workspace"],description:n.localize(51,null)},{body:["ui","workspace"],description:n.localize(52,null)},{body:["workspace","ui"],description:n.localize(53,null)},{body:[],description:n.localize(54,null)}]},capabilities:{description:n.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(58,null),n.localize(59,null),n.localize(60,null)]},description:{type:"string",markdownDescription:n.localize(61,null)}}},untrustedWorkspaces:{description:n.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(64,null),n.localize(65,null),n.localize(66,null)]},restrictedConfigurations:{description:n.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(68,null)}}}}},sponsor:{description:n.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(71,null),type:"string"},"vscode:uninstall":{description:n.localize(72,null),type:"string"}}},icon:{type:"string",description:n.localize(73,null)},l10n:{type:"string",description:n.localize(74,null)}}};class E{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const s=new i(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,s),w.activationEventsGenerator&&I.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,f.registerSchema(l,e.schema),s}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=E;const b={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(b.ExtensionsRegistry,new E),e.ExtensionsRegistry=R.Registry.as(b.ExtensionsRegistry),f.registerSchema(l,e.schema),f.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(De[191],Ce([1,0,142,9,23,190,41,5]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var k;(function(f){function v(h,i,o){if(!h)return;const l=T.isString(h.type)?h.type:void 0;if(!l||l.length===0){o.error(n.localize(3,null));return}const E=[];if(Array.isArray(h.required))for(const b of h.required)T.isString(b)&&E.push(b);return{extensionId:i.value,taskType:l,required:E,properties:h.properties?y.deepClone(h.properties):{},when:h.when?C.ContextKeyExpr.deserialize(h.when):void 0}}f.from=v})(k||(k={}));const O=N.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:n.localize(4,null),type:"array",items:S}});class I{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,h)=>{O.setHandler((i,o)=>{this.c=void 0;try{for(const l of o.removed){const E=l.value;for(const b of E)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const l of o.added){const E=l.value;for(const b of E){const p=k.from(b,l.description.identifier,l.collector);p&&(this.a[p.taskType]=p)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const h of this.all()){const i={type:"object",additionalProperties:!1};h.required.length>0&&(i.required=h.required.slice(0)),h.properties!==void 0?i.properties=y.deepClone(h.properties):i.properties=Object.create(null),i.properties.type={type:"string",enum:[h.taskType]},v.push(i)}this.c={oneOf:v}}return this.c}}e.TaskDefinitionRegistry=new I}),define(De[192],Ce([1,0,143,9,22,23,41,191]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function $(z){if(!z)return F.Strong;switch(z.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=$}(S=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var O;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(F){function $(z){switch(z.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=$}(O=e.RevealKind||(e.RevealKind={}));var I;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(I=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function $(z){switch(z.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=$}(I=e.RevealProblemKind||(e.RevealProblemKind={}));var f;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(f=e.PanelKind||(e.PanelKind={})),function(F){function $(z){switch(z.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=$}(f=e.PanelKind||(e.PanelKind={}));var v;(function(F){F.defaults={echo:!0,reveal:O.Always,revealProblems:I.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(v=e.PresentationOptions||(e.PresentationOptions={}));var h;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(h=e.RuntimeType||(e.RuntimeType={})),function(F){function $(V){switch(V.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=$;function z(V){switch(V){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=z}(h=e.RuntimeType||(e.RuntimeType={}));var i;(function(F){function $(z){return T.isString(z)?z:z.value}F.value=$})(i=e.CommandString||(e.CommandString={}));var o;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function $(V){return V===F.Clean._id||V===F.Build._id||V===F.Rebuild._id||V===F.Test._id}F.is=$;function z(V){if(V!==void 0)return T.isString(V)?$(V)?{_id:V,isDefault:!1}:void 0:V}F.from=z})(o=e.TaskGroup||(e.TaskGroup={}));var l;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var E;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function $(z){switch(z){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=$})(E=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(F){F.parallel="parallel",F.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var p;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(p=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:p.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class s{constructor($,z,V,X,Z,fe){this._label="",this._id=$,z&&(this._label=z),V&&(this.type=V),this.runOptions=X,this.configurationProperties=Z,this._source=fe}getDefinition($){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const $={folder:this.d(),id:this._id};return JSON.stringify($)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches($,z=!1){if($===void 0)return!1;if(T.isString($))return $===this._label||$===this.configurationProperties.identifier||z&&$===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===$._key}getQualifiedLabel(){const $=this.getWorkspaceFolder();return $?`${this._label} (${$.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages($){this.c===void 0&&(this.c=[]),$&&(this.c=this.c.concat($))}get taskLoadMessages(){return this.c}}e.CommonTask=s;class r extends s{constructor($,z,V,X,Z,fe,oe,le){super($,V,void 0,oe,le,z),this.command={},this._source=z,this.hasDefinedMatchers=fe,Z&&(this.command=Z)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition($=!1){if($&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case h.Shell:z="shell";break;case h.Process:z="process";break;case h.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is($){return $ instanceof r}getMapKey(){const $=this._source.config.workspaceFolder;return $?`${$.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===E.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let z=this.configurationProperties.identifier;this._source.kind!==E.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:z};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f($){return new r($._id,$._source,$._label,$.type,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.CustomTask=r;class a extends s{constructor($,z,V,X,Z,fe,oe){super($,V,X,fe,oe,z),this._source=z,this.configures=Z}static is($){return $ instanceof a}f($){return $}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===E.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let z=this.configurationProperties.identifier;this._source.kind!==E.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:z};return JSON.stringify(V)}}e.ConfiguringTask=a;class d extends s{constructor($,z,V,X,Z,fe,oe,le,ce){super($,V,X,le,ce,z),this.defines=Z,this.hasDefinedMatchers=oe,this.command=fe,this.icon=ce.icon,this.hide=ce.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is($){return $ instanceof d}getMapKey(){const $=this._source.workspaceFolder;return $?`${this._source.scope.toString()}|${$.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const $={type:"contributed",scope:this._source.scope,id:this._id};return $.folder=this.d(),JSON.stringify($)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f($){return new d($._id,$._source,$._label,$.type,$.defines,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.ContributedTask=d;class c extends s{constructor($,z,V,X,Z,fe){super($,V,X,Z,fe,z),this._source=z}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is($){return $ instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f($){return new c($._id,$._source,$._label,$.type,$.runOptions,$.configurationProperties)}}e.InMemoryTask=c;var u;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var t;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(t=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class m{constructor($){this.c=new Map;for(let z=0;z<$.length;z++)this.c.set($[z].uri.toString(),z)}compare($,z){const V=$.getWorkspaceFolder(),X=z.getWorkspaceFolder();if(V&&X){let Z=this.c.get(V.uri.toString());Z=Z===void 0?0:Z+1;let fe=this.c.get(X.uri.toString());return fe=fe===void 0?0:fe+1,Z===fe?$._label.localeCompare(z._label):Z-fe}else return!V&&X?-1:V&&!X?1:0}}e.TaskSorter=m;var g;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var A;(function(F){F.SingleRun="singleRun",F.Background="background"})(A=e.TaskRunType||(e.TaskRunType={}));var L;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var K;(function(F){function $(z,V,X,Z){if(V){const fe={kind:z,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:X,__task:V};return z==="start"?fe.resolvedVariables=Z:z==="processStarted"?fe.processId=Z:z==="processEnded"&&(fe.exitCode=Z),Object.freeze(fe)}else return Object.freeze({kind:"changed"})}F.create=$})(K=e.TaskEvent||(e.TaskEvent={}));var q;(function(F){function $(V){const X=Object.keys(V).sort();let Z="";for(const fe of X){let oe=V[fe];oe instanceof Object?oe=$(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),Z+=fe+","+oe+","}return Z}function z(V){const Z={_key:$(V),type:V.taskType};return Object.assign(Z,V),Z}F.create=z})(q=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var j;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(j=e.TaskSettingId||(e.TaskSettingId={}));var P;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(P=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var M;(function(F){function $(z,V){const X=R.TaskDefinitionRegistry.get(z.type);if(X===void 0){const le=N.deepClone(z);return delete le._key,q.create(le)}const Z=Object.create(null);Z.type=X.taskType;const fe=new Set;X.required.forEach(le=>fe.add(le));const oe=X.properties;for(const le of Object.keys(oe)){const ce=z[le];if(ce!=null)Z[le]=ce;else if(fe.has(le)){const me=oe[le];if(me.default!==void 0)Z[le]=N.deepClone(me.default);else switch(me.type){case"boolean":Z[le]=!1;break;case"number":case"integer":Z[le]=0;break;case"string":Z[le]="";break;default:V.error(n.localize(2,null,JSON.stringify(z,void 0,0),le));return}}}return q.create(Z)}F.createTaskIdentifier=$})(M=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[193],Ce([1,0,11]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,R)=>{this.b=C,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,n.onUnexpectedError)(C))}then(C,R){return this.j().then(C,R)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=T;class y extends T{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=y}),define(De[43],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++n.count}}e.ProxyIdentifier=n,n.count=0;const T=[];function y(R){const S=new n(R);return T[S.nid]=S,S}e.createProxyIdentifier=y;function N(R){return T[R].sid}e.getStringIdentifierForProxy=N;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(De[4],Ce([1,0,43]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(i){i[i.Default=0]="Default",i[i.InCenter=1]="InCenter",i[i.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",i[i.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(i){i[i.UnknownInput=0]="UnknownInput",i[i.TextInput=1]="TextInput",i[i.TextDiffInput=2]="TextDiffInput",i[i.TextMergeInput=3]="TextMergeInput",i[i.NotebookInput=4]="NotebookInput",i[i.NotebookDiffInput=5]="NotebookDiffInput",i[i.CustomEditorInput=6]="CustomEditorInput",i[i.WebviewEditorInput=7]="WebviewEditorInput",i[i.TerminalEditorInput=8]="TerminalEditorInput",i[i.InteractiveEditorInput=9]="InteractiveEditorInput"})(y=e.TabInputKind||(e.TabInputKind={}));var N;(function(i){i[i.TAB_OPEN=0]="TAB_OPEN",i[i.TAB_CLOSE=1]="TAB_CLOSE",i[i.TAB_UPDATE=2]="TAB_UPDATE",i[i.TAB_MOVE=3]="TAB_MOVE"})(N=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(i){i[i.Editable=0]="Editable",i[i.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(i){i[i.Int8Array=1]="Int8Array",i[i.Uint8Array=2]="Uint8Array",i[i.Uint8ClampedArray=3]="Uint8ClampedArray",i[i.Int16Array=4]="Int16Array",i[i.Uint16Array=5]="Uint16Array",i[i.Int32Array=6]="Int32Array",i[i.Uint32Array=7]="Uint32Array",i[i.Float32Array=8]="Float32Array",i[i.Float64Array=9]="Float64Array",i[i.BigInt64Array=10]="BigInt64Array",i[i.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(i){i[i.Text=1]="Text",i[i.Error=2]="Error",i[i.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(i){i[i.Default=0]="Default",i[i.InCenter=1]="InCenter",i[i.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",i[i.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(i){i[i.None=0]="None",i[i.Process=1]="Process",i[i.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(o){return o._id=I.a++,o}}e.IdObject=I,I.a=0;var f;(function(i){i.label="a",i.kind="b",i.detail="c",i.documentation="d",i.sortText="e",i.filterText="f",i.preselect="g",i.insertText="h",i.insertTextRules="i",i.range="j",i.commitCharacters="k",i.additionalTextEdits="l",i.kindModifier="m",i.commandIdent="n",i.commandId="o",i.commandArguments="p"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(i){i.defaultRanges="a",i.completions="b",i.isIncomplete="c",i.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(i){i[i.Workspace=0]="Workspace",i[i.TextDocument=1]="TextDocument"})(h=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(De[72],Ce([1,0,3,12,4,14]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,k){this.c=k,this.a=new Set,this.b=S.getProxy(y.MainContext.MainThreadTelemetry)}report(S,k,O){const I=this.d(S,k);this.a.has(I)||(this.a.add(I),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}d(S,k){return`${S}-${k.identifier.value}`}};C=Ve([je(0,N.IExtHostRpcService),je(1,T.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(R,S,k){}})}),define(De[194],Ce([1,0,5,4,6,26]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,k,O,I={}){const f=N.ExtensionIdentifier.toKey(S.identifier),v=this.f.get(f)||[],h=[...O].sort().join(" ");let i=v.find(o=>o.providerId===k&&o.scopes===h);if(i)return i.result;{const o=this.g(S,f,k,O,I);i={providerId:k,scopes:h,result:o},v.push(i),this.f.set(f,v);try{await o}finally{const l=v.findIndex(E=>E.providerId===k&&E.scopes===h);l>-1&&(v.splice(l),this.f.set(f,v))}return o}}async g(S,k,O,I,f={}){await this.a.$ensureProvider(O);const v=S.displayName||S.name;return this.a.$getSession(O,I,k,v,f)}async removeSession(S,k){const O=this.b.get(S);return O?O.provider.removeSession(k):this.a.$removeSession(S,k)}registerAuthenticationProvider(S,k,O,I){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:k,provider:O,options:I??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===S)||this.c.push({id:S,label:k});const f=O.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(S,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(S,k,I?.supportsMultipleAccounts??!1),new y.Disposable(()=>{f.dispose(),this.b.delete(S);const v=this.c.findIndex(h=>h.id===S);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const O=this.b.get(S);if(O)return Promise.resolve(O.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const O=this.b.get(S);if(O)return Promise.resolve(O.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const O=this.b.get(S);if(O)return Promise.resolve(O.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this.d.fire({provider:{id:S,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(De[195],Ce([1,0,4,14,8]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=class{constructor(R,S){this.a=R.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>S.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,S,k){const O=y.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};N=Ve([je(0,T.IExtHostRpcService)],N),e.ExtHostBulkEdits=N}),define(De[196],Ce([1,0,4]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(N){const C=N.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(R){return C.$writeText(R)}})}}e.ExtHostClipboard=T});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(De[38],Ce([1,0,9,6,8,23,4,16,12,80,53,250,2,7,3,14,97,24,43,45]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b){"use strict";var p,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(t,m){p.set(this,void 0),this.b=new Map,this.c=new Map,w.set(this,void 0),Ye(this,p,t.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=m,Ye(this,w,t.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new r(this,g=>{const A=this.c.get(g);return A?.result===d.Void?A:void 0},m),this.f=[{processArgument(g){return(0,k.revive)(g)}},{processArgument(g){return(0,N.cloneAndChange)(g,function(A){if(O.Range.isIRange(A))return y.Range.to(A);if(I.Position.isIPosition(A))return y.Position.to(A);if(O.Range.isIRange(A.range)&&f.URI.isUri(A.uri))return y.location.to(A);if(A instanceof l.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(t){this.f.push(t)}registerApiCommand(t){const m=this.registerCommand(!1,t.id,async(...g)=>{const A=t.args.map((K,q)=>{if(!K.validate(g[q]))throw new Error(`Invalid argument '${K.name}' when running '${t.id}', received: ${g[q]}`);return K.convert(g[q])}),L=await this.executeCommand(t.internalId,...A);return t.result.convert(L,g,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this.c.set(t.id,t),new T.Disposable(()=>{m.dispose(),this.c.delete(t.id)})}registerCommand(t,m,g,A,L,K){if(this.d.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this.b.has(m))throw new Error(`command '${m}' already exists`);return this.b.set(m,{callback:g,thisArg:A,description:L,extension:K}),t&&Re(this,p,"f").$registerCommand(m),new T.Disposable(()=>{this.b.delete(m)&&t&&Re(this,p,"f").$unregisterCommand(m)})}executeCommand(t,...m){return this.d.trace("ExtHostCommands#executeCommand",t),this.g(t,m,!0)}async g(t,m,g){if(this.b.has(t))return Re(this,p,"f").$fireCommandActivationEvent(t),this.h(t,m,!1);{let A=!1;const L=(0,N.cloneAndChange)(m,function(K){if(K instanceof T.Position)return y.Position.from(K);if(K instanceof T.Range)return y.Range.from(K);if(K instanceof T.Location)return y.location.from(K);if(T.NotebookRange.isNotebookRange(K))return y.NotebookRange.from(K);if(K instanceof ArrayBuffer)return A=!0,l.VSBuffer.wrap(new Uint8Array(K));if(K instanceof Uint8Array)return A=!0,l.VSBuffer.wrap(K);if(K instanceof l.VSBuffer)return A=!0,K;if(!Array.isArray(K))return K});try{const K=await Re(this,p,"f").$executeCommand(t,A?new E.SerializableObjectWithBuffers(L):L,g);return(0,k.revive)(K)}catch(K){if(K instanceof Error&&K.message==="$executeCommand:retry")return this.g(t,m,!1);throw K}}}async h(t,m,g){const A=this.b.get(t);if(!A)throw new Error("Unknown command");const{callback:L,thisArg:K,description:q}=A;if(q)for(let P=0;P<q.args.length;P++)try{(0,n.validateConstraint)(m[P],q.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${q.args[P].name}' - ${q.args[P].description}`)}const j=Date.now();try{return await L.apply(K,m)}catch(P){if(t===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...m);M&&(t=M.command)}throw this.d.error(P,t,A.extension?.identifier),g?new class extends Error{constructor(){super((0,b.toErrorMessage)(P)),this.id=t,this.source=A.extension?.displayName??A.extension?.name}}:P}finally{this.j(A,t,Date.now()-j)}}j(t,m,g){!t.extension||t.extension.isBuiltin||Re(this,w,"f").$publicLog2("Extension:ActionExecuted",{extensionId:t.extension.identifier.value,id:m,duration:g})}$executeContributedCommand(t,...m){return this.d.trace("ExtHostCommands#$executeContributedCommand",t),this.b.has(t)?(m=m.map(g=>this.f.reduce((A,L)=>L.processArgument(A),g)),this.h(t,m,!0)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this.d.trace("ExtHostCommands#getCommands",t),Re(this,p,"f").$getCommands().then(m=>(t&&(m=m.filter(g=>g[0]!=="_")),m))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(const[m,g]of this.b){const{description:A}=g;A&&(t[m]=A)}return Promise.resolve(t)}};p=new WeakMap,w=new WeakMap,s=Ve([je(0,i.IExtHostRpcService),je(1,S.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class r{constructor(t,m,g){this.d=t,this.f=m,this.g=g,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(t,m){if(!t)return;const g={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return g;const A=this.f(t.command);if(A)g.id=A.internalId,g.arguments=A.args.map((L,K)=>L.convert(t.arguments&&t.arguments[K]));else if((0,R.isNonEmptyArray)(t.arguments)){const L=`${t.command}/${++this.c}`;this.b.set(L,t),m.add((0,v.toDisposable)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),g.$ident=L,g.id=this.delegatingCommandId,g.arguments=[L],this.g.trace("CommandsConverter#CREATE",t.command,L)}return g}fromInternal(t){return typeof t.$ident=="string"?this.b.get(t.$ident):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this.b.get(t[0])}h(...t){const m=this.getActualCommand(...t);return this.g.trace("CommandsConverter#EXECUTE",t[0],m?m.command:"MISSING"),m?this.d.executeCommand(m.command,...m.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${t[0]}`)}}e.CommandsConverter=r;class a{constructor(t,m,g,A){this.name=t,this.description=m,this.validate=g,this.convert=A}optional(){return new a(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,m){return new a(t??this.name,m??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",u=>f.URI.isUri(u),u=>u),a.Position=new a("position","A position in a text document",u=>T.Position.isPosition(u),y.Position.from),a.Range=new a("range","A range in a text document",u=>T.Range.isRange(u),y.Range.from),a.Selection=new a("selection","A selection in a text document",u=>T.Selection.isSelection(u),y.Selection.from),a.Number=new a("number","",u=>typeof u=="number",u=>u),a.String=new a("string","",u=>typeof u=="string",u=>u),a.CallHierarchyItem=new a("item","A call hierarchy item",u=>u instanceof T.CallHierarchyItem,y.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",u=>u instanceof T.TypeHierarchyItem,y.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",u=>u instanceof o.TestItemImpl,y.TestItem.from);class d{constructor(t,m){this.description=t,this.convert=m}}e.ApiCommandResult=d,d.Void=new d("no result",u=>u);class c{constructor(t,m,g,A,L){this.id=t,this.internalId=m,this.description=g,this.args=A,this.result=L}}e.ApiCommand=c}),define(De[197],Ce([1,0,2,8,6,71,38,16,83,87,13]),function(te,e,n,T,y,N,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",v(T.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,o)=>{if((0,R.isFalsyOrEmpty)(i))return;class l extends y.SymbolInformation{static to(b){const p=new l(b.name,T.SymbolKind.to(b.kind),b.containerName||"",new y.Location(o[0],T.Range.to(b.range)));return p.detail=b.detail,p.range=p.location.range,p.selectionRange=T.Range.to(b.selectionRange),p.children=b.children?b.children.map(l.to):[],p}}return i.map(l.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new C.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(T.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(T.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(o=>y.Position.isPosition(o)),i=>i.map(T.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(o=>{let l;for(const E of o.reverse())l=new y.SelectionRange(T.Range.to(E),l);return l}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(T.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(T.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(T.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(T.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:T.Range.to(i.range),placeholder:i.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return T.WorkspaceEdit.to(i)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(T.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new y.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const o=(0,S.decodeSemanticTokensDto)(i);if(o.type==="full")return new y.SemanticTokens(o.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new y.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const o=(0,S.decodeSemanticTokensDto)(i);if(o.type==="full")return new y.SemanticTokens(o.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,o,l)=>{if(!i)return new y.CompletionList([]);const E=i.suggestions.map(b=>T.CompletionItem.to(b,l));return new y.CompletionList(E,i.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return T.SignatureHelp.to(i)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,o,l)=>v(E=>new y.CodeLens(T.Range.to(E.range),E.command&&l.fromInternal(E.command)))(i))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>y.Range.isRange(i),i=>y.Selection.isSelection(i)?T.Selection.from(i):T.Range.from(i)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,o,l)=>v(E=>{if(E._isSynthetic){if(!E.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(E.command)}else{const b=new y.CodeAction(E.title,E.kind?new y.CodeActionKind(E.kind):void 0);return E.edit&&(b.edit=T.WorkspaceEdit.to(E.edit)),E.command&&(b.command=l.fromInternal(E.command)),b.isPreferred=E.isPreferred,b}})(i))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(o=>new y.ColorInformation(T.Range.to(o.range),T.Color.to(o.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",i=>i instanceof y.Color,T.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:T.Range.from(i.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(T.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,o,l)=>i.map(T.InlayHint.to.bind(void 0,l)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(o=>T.NotebookExclusiveDocumentPattern.to(o))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(T.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",i=>n.URI.isUri(i)||typeof i=="string"&&(0,k.matchesSomeScheme)(i,O.Schemas.http,O.Schemas.https),i=>i),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[T.ViewColumn.from(i),void 0]:[T.ViewColumn.from(i.viewColumn),T.TextEditorOpenOptions.from(i)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[T.ViewColumn.from(i),void 0]:[T.ViewColumn.from(i.viewColumn),T.TextEditorOpenOptions.from(i)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[T.ViewColumn.from(i.viewColumn),T.TextEditorOpenOptions.from(i)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void)];class f{static register(o){I.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=f;function v(i){return o=>{if(Array.isArray(o))return o.map(i)}}function h(i){if(!Array.isArray(i))return;const o=[];for(const l of i)N.isLocationLink(l)?o.push(T.DefinitionLink.to(l)):o.push(T.location.to(l));return o}}),define(De[198],Ce([1,0,15,59,5,7,2,71,26,8,6,25,4]),function(te,e,n,T,y,N,C,R,S,k,O,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(h,i,o){const l=h.getProxy(f.MainContext.MainThreadComments);class E{constructor(){this.b=new Map,this.c=new Map,i.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const t=this.b.get(u.handle);return t?t.value:u}else if(u&&u.$mid===7){const t=this.b.get(u.commentControlHandle);if(!t)return u;const m=t.getCommentThread(u.commentThreadHandle);return m?m.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const t=this.b.get(u.thread.commentControlHandle);if(!t)return u;const m=t.getCommentThread(u.thread.commentThreadHandle);return m?u.$mid===8?m.value:{thread:m.value,text:u.text}:u}else if(u&&u.$mid===10){const t=this.b.get(u.thread.commentControlHandle);if(!t)return u;const m=t.getCommentThread(u.thread.commentThreadHandle);if(!m)return u;const g=u.commentUniqueId,A=m.getCommentByUniqueId(g);return A||u}else if(u&&u.$mid===11){const t=this.b.get(u.thread.commentControlHandle);if(!t)return u;const m=t.getCommentThread(u.thread.commentThreadHandle);if(!m)return u;const g=u.text,A=u.commentUniqueId,L=m.getCommentByUniqueId(A);return L?(typeof L.body=="string"?L.body=g:L.body.value=g,L):u}return u}})}createCommentController(u,t,m){const g=E.a++,A=new p(u,g,t,m);this.b.set(A.handle,A);const L=this.c.get(S.ExtensionIdentifier.toKey(u.identifier))||[];return L.push(A),this.c.set(S.ExtensionIdentifier.toKey(u.identifier),L),A.value}$createCommentThreadTemplate(u,t,m){const g=this.b.get(u);!g||g.$createCommentThreadTemplate(t,m)}async $updateCommentThreadTemplate(u,t,m){const g=this.b.get(u);!g||g.$updateCommentThreadTemplate(t,m)}$deleteCommentThread(u,t){this.b.get(u)?.$deleteCommentThread(t)}$provideCommentingRanges(u,t,m){const g=this.b.get(u);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const A=o.getDocument(C.URI.revive(t));return(0,n.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(A,m)).then(L=>L?L.map(K=>k.Range.from(K)):void 0)}$toggleReaction(u,t,m,g,A){const L=this.b.get(u);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const K=L.getCommentThread(t);if(K){const q=K.getCommentByUniqueId(g.uniqueIdInThread);if(L!==void 0&&q&&L.reactionHandler)return L.reactionHandler(q,r(A))}return Promise.resolve(void 0)})}dispose(){}}E.a=0;class b{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){u.isEqual(this.p)||(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(u){(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,t,m,g,A,L,K,q){this.m=t,this.n=m,this.o=g,this.p=A,this.q=L,this.extensionDescription=K,this.r=q,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new y.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.MutableDisposable,this.l.value=new N.DisposableStore,this.n===void 0&&(this.n=`${u}.${this.handle}`),l.$createCommentThread(t,this.handle,this.n,this.o,k.Range.from(this.p),K.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{l.$deleteCommentThread(t,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(P){j.range=P},get comments(){return j.comments},set comments(P){j.comments=P},get collapsibleState(){return j.collapsibleState},set collapsibleState(P){j.collapsibleState=P},get canReply(){return j.canReply},set canReply(P){j.canReply=P},get contextValue(){return j.contextValue},set contextValue(P){j.contextValue=P},get label(){return j.label},set label(P){j.label=P},get state(){return j.state},set state(P){j.state=P},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.DisposableStore);const u=m=>Object.prototype.hasOwnProperty.call(this.b,m),t={};u("range")&&(t.range=k.Range.from(this.p)),u("label")&&(t.label=this.label),u("contextValue")&&(t.contextValue=this.contextValue??null),u("comments")&&(t.comments=this.q.map(m=>w(this,m,this.k))),u("collapsibleState")&&(t.collapseState=a(this.g)),u("canReply")&&(t.canReply=this.canReply),u("state")&&(t.state=d(this.h)),u("isTemplate")&&(t.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,t)}getCommentByUniqueId(u){for(const t of this.k){const m=t[0],g=t[1];if(u===g)return m}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}b.a=0,Ve([(0,T.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,l.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,t,m,g){this.f=u,this.g=t,this.h=m,this.i=g,this.a=new Map,l.$registerCommentController(this.handle,m,g);const A=this;this.value=Object.freeze({id:A.id,label:A.label,get options(){return A.options},set options(L){A.options=L},get commentingRangeProvider(){return A.commentingRangeProvider},set commentingRangeProvider(L){A.commentingRangeProvider=L},get reactionHandler(){return A.reactionHandler},set reactionHandler(L){A.reactionHandler=L},createCommentThread(L,K,q){return A.createCommentThread(L,K,q).value},dispose:()=>{A.dispose()}}),this.e=[],this.e.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(u,t,m,g){if(typeof u=="string"){const A=new b(this.id,this.handle,u,t,m,g,this.f,!1);return this.a.set(A.handle,A),A}else{const A=new b(this.id,this.handle,void 0,u,t,m,this.f,!1);return this.a.set(A.handle,A),A}}$createCommentThreadTemplate(u,t){const m=new b(this.id,this.handle,void 0,C.URI.revive(u),k.Range.to(t),[],this.f,!0);return m.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(m.handle,m),m}$updateCommentThreadTemplate(u,t){const m=this.a.get(u);m&&(m.range=k.Range.to(t))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function w(c,u,t){let m=t.get(u);m||(m=++c.commentHandle,t.set(u,m));const g=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:m,body:typeof u.body=="string"?u.body:k.MarkdownString.from(u.body),userName:u.author.name,userIconPath:g,label:u.label,commentReactions:u.reactions?u.reactions.map(A=>s(A)):void 0,timestamp:u.timestamp?.toJSON()}}function s(c){return{label:c.label,iconPath:c.iconPath?k.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?C.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function a(c){if(c!==void 0)switch(c){case O.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function d(c){if(c!==void 0)switch(c){case O.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new E}e.createExtHostComments=v}),define(De[199],Ce([1,0,23,4,27,14]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(O,I){this.a=O.getProxy(T.MainContext.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,I){const f=this,v=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){f.e(O,I,v,arguments)}})}e(O,I,f,v){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:S(v,this.b)}),this.c&&this.f(O,f,v)}};C=Ve([je(0,N.IExtHostRpcService),je(1,y.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const R=1e5;function S(k,O){const I=[];if(k.length)for(let f=0;f<k.length;f++){let v=k[f];if(typeof v>"u")v="undefined";else if(v instanceof Error){const h=v;h.stack?v=h.stack:v=h.toString()}I.push(v)}if(O){const f=new Error().stack;f&&I.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,n.safeStringify)(I);return f.length>R?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(De[99],Ce([1,0,2,4,6,3,14,12,16,10,19,25]),function(te,e,n,T,y,N,C,R,S,k,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let f=class Ai{constructor(h,i){this.h=i,this.f=new Map,this.g=h.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,i){const o=Ai.c++;this.f.set(o,{provider:h,extensionDescription:i}),this.g.$registerDecorationProvider(o,i.identifier.value);const l=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(E=>{if(!E){this.g.$onDidChange(o,null);return}const b=(0,S.asArray)(E);if(b.length<=Ai.d){this.g.$onDidChange(o,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",i.identifier.value,b.length);const p=b.map(r=>({uri:r,rank:(0,k.count)(r.path,"/")})),w=(0,S.groupBy)(p,(r,a)=>r.rank-a.rank||(0,k.compare)(r.uri.path,a.uri.path)),s=[];e:for(const r of w){let a;for(const d of r){const c=(0,O.dirname)(d.uri.path);if(a!==c&&(a=c,s.push(d.uri)>=Ai.d))break e}}this.g.$onDidChange(o,s)});return new y.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(h,i,o){if(!this.f.has(h))return Object.create(null);const l=Object.create(null),{provider:E,extensionDescription:b}=this.f.get(h);return await Promise.all(i.map(async p=>{try{const{uri:w,id:s}=p,r=await Promise.resolve(E.provideFileDecoration(n.URI.revive(w),o));if(!r)return;try{y.FileDecoration.validate(r),r.badge&&typeof r.badge!="string"&&(0,I.checkProposedApiEnabled)(b,"codiconDecoration"),l[s]=[r.propagate,r.tooltip,r.badge,r.color]}catch(a){this.h.warn(`INVALID decoration from extension '${b}': ${a}`)}}catch(w){this.h.error(w)}})),l}};f.c=0,f.d=250,f=Ve([je(0,C.IExtHostRpcService),je(1,R.ILogService)],f),e.ExtHostDecorations=f,e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(De[200],Ce([1,0,132,86,2,4,6,8,5,12,28,37]),function(te,e,n,T,y,N,C,R,S,k,O,I){"use strict";var f,v,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class i{constructor(E,b,p,w,s,r,a){this.d=E,this.e=b,this.f=p,this.g=w,f.set(this,void 0),v.set(this,void 0),h.set(this,void 0),this.c=!1,Ye(this,h,new O.ResourceMap(d=>s.getComparisonKey(d)),"f"),Ye(this,f,r,"f"),Ye(this,v,a,"f")}dispose(){this.c||(Re(this,v,"f").fire([...Re(this,h,"f").keys()]),Re(this,f,"f")?.$clear(this.e),Re(this,h,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(E,b){if(!E){this.clear();return}this.h();let p=[];if(y.URI.isUri(E)){if(!b){this.delete(E);return}Re(this,h,"f").set(E,b.slice()),p=[E]}else if(Array.isArray(E)){p=[];let s;E=[...E].sort(i.j);for(const r of E){const[a,d]=r;if((!s||a.toString()!==s.toString())&&(s&&Re(this,h,"f").get(s).length===0&&Re(this,h,"f").delete(s),s=a,p.push(a),Re(this,h,"f").set(a,[])),d)Re(this,h,"f").get(a)?.push(...d);else{const c=Re(this,h,"f").get(a);c&&(c.length=0)}}}if(Re(this,v,"f").fire(p),!Re(this,f,"f"))return;const w=[];for(const s of p){let r=[];const a=Re(this,h,"f").get(s);if(a)if(a.length>this.f){r=[];const d=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const u of a)if(u.severity===d[c]&&r.push({...R.Diagnostic.from(u),modelVersionId:this.g(s)})===this.f)break e;r.push({severity:T.MarkerSeverity.Info,message:(0,n.localize)(0,null,a.length-this.f),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=a.map(d=>({...R.Diagnostic.from(d),modelVersionId:this.g(s)}));w.push([s,r])}Re(this,f,"f").$changeMany(this.e,w)}delete(E){this.h(),Re(this,v,"f").fire([E]),Re(this,h,"f").delete(E),Re(this,f,"f")?.$changeMany(this.e,[[E,void 0]])}clear(){this.h(),Re(this,v,"f").fire([...Re(this,h,"f").keys()]),Re(this,h,"f").clear(),Re(this,f,"f")?.$clear(this.e)}forEach(E,b){this.h();for(const[p,w]of this)E.call(b,p,w,this)}*[(f=new WeakMap,v=new WeakMap,h=new WeakMap,Symbol.iterator)](){this.h();for(const E of Re(this,h,"f").keys())yield[E,this.get(E)]}get(E){this.h();const b=Re(this,h,"f").get(E);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(E){return this.h(),Array.isArray(Re(this,h,"f").get(E))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(E,b){return E[0].toString()<b[0].toString()?-1:E[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=i;let o=class gi{static _mapper(E){const b=new O.ResourceMap;for(const p of E)b.set(p,p);return{uris:Object.freeze(Array.from(b.values()))}}constructor(E,b,p,w){this.h=b,this.j=p,this.k=w,this.f=new Map,this.g=new S.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,gi._mapper),this.e=E.getProxy(N.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(E,b){const{f:p,e:w,g:s,h:r,j:a,k:d}=this,c=new class{$changeMany(m,g){w.$changeMany(m,g),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",E.value,m,g.length===0?"CLEARING":g)}$clear(m){w.$clear(m),r.trace("[DiagnosticCollection] remove all (extension, owner)",E.value,m)}dispose(){w.dispose()}};let u;if(!b)b="_generated_diagnostic_collection_name_#"+gi.c++,u=b;else if(!p.has(b))u=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do u=b+gi.c++;while(p.has(u))}return new class extends i{constructor(){super(b,u,gi.d,m=>d.getDocument(m)?.version,a.extUri,c,s),p.set(u,this)}dispose(){super.dispose(),p.delete(u)}}}getDiagnostics(E){if(E)return this.l(E);{const b=new Map,p=[];for(const w of this.f.values())w.forEach((s,r)=>{let a=b.get(s.toString());typeof a>"u"&&(a=p.length,b.set(s.toString(),a),p.push([s,[]])),p[a][1]=p[a][1].concat(...r)});return p}}l(E){let b=[];for(const p of this.f.values())p.has(E)&&(b=b.concat(p.get(E)));return b}$acceptMarkersChange(E){if(!this.m){const b="_generated_mirror",p=new i(b,b,gi.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(b,p),this.m=p}for(const[b,p]of E)this.m.set(y.URI.revive(b),p.map(R.Diagnostic.to))}};o.c=0,o.d=1e3,o=Ve([je(1,k.ILogService),je(2,I.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(De[201],Ce([1,0,2,4]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(C){this.a=C.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(R=>R?R.map(S=>n.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(R=>R?n.URI.revive(R):void 0)}}e.ExtHostDialogs=y}),define(De[202],Ce([1,0,11,2,6,4,13,20,10]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,f,v){this.d=f,this.e=v,this.b=new Map,this.c=I.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,f){if(Object.keys(C.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const v=k.a++;this.b.set(v,f),this.c.$registerTextContentProvider(v,I);let h;return typeof f.onDidChange=="function"&&(h=f.onDidChange(i=>{if(i.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${i.scheme}' which will be IGNORED`);return}this.d.getDocument(i)&&this.$provideTextDocumentContent(v,i).then(o=>{if(!o&&typeof o!="string")return;const l=this.d.getDocument(i);if(!l)return;const E=(0,S.splitLines)(o);if(!l.equalLines(E))return this.c.$onVirtualDocumentChange(i,o)},n.onUnexpectedError)})),new y.Disposable(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(I,f){const v=this.b.get(I);return v?Promise.resolve(v.provideTextDocumentContent(T.URI.revive(f),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=k,k.a=0}),define(De[203],Ce([1,0,5,7,2,4,95,8,9,23,6]),function(te,e,n,T,y,N,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(v,h){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.DisposableStore,this.h=new Map,this.f=v.getProxy(N.MainContext.MainThreadDocuments),this.g=h,this.g.onDidRemoveDocuments(i=>{for(const o of i)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(i=>{for(const o of i)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const h=this.g.getDocument(v);if(h)return h}getDocument(v){const h=this.getDocumentData(v);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return h.document}ensureDocumentData(v){const h=this.g.getDocument(v);if(h)return Promise.resolve(h);let i=this.h.get(v.toString());return i||(i=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const l=y.URI.revive(o);return(0,S.assertIsDefined)(this.g.getDocument(l))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),i)),i}createDocumentData(v){return this.f.$tryCreateDocument(v).then(h=>y.URI.revive(h))}$acceptModelLanguageChanged(v,h){const i=y.URI.revive(v),o=this.g.getDocument(i);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(h),this.a.fire(o.document)}$acceptModelSaved(v){const h=y.URI.revive(v),i=this.g.getDocument(h);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(i.document)}$acceptDirtyStateChanged(v,h){const i=y.URI.revive(v),o=this.g.getDocument(i);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,h,i){const o=y.URI.revive(v),l=this.g.getDocument(o);if(!l)throw new Error("unknown document");l._acceptIsDirty(i),l.onEvents(h);let E;h.isUndoing?E=O.TextDocumentChangeReason.Undo:h.isRedoing&&(E=O.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:l.document,contentChanges:h.changes.map(b=>({range:R.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:E}))}setWordDefinitionFor(v,h){(0,C.setWordDefinitionFor)(v,h)}}e.ExtHostDocuments=I}),define(De[54],Ce([1,0,47,5,7,2,3,4,95,14,98,8,12,28,13,172,204]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(p){this.value=p,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let E=class{constructor(p,w){this.h=p,this.i=w,this.a=null,this.b=new Map,this.c=new v.ResourceMap,this.d=new T.Emitter,this.e=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const w=[],s=[],r=[];if(p.removedDocuments)for(const a of p.removedDocuments){const d=N.URI.revive(a),c=this.c.get(d);c?.unref()&&(this.c.delete(d),w.push(c.value))}if(p.addedDocuments)for(const a of p.addedDocuments){const d=N.URI.revive(a.uri);let c=this.c.get(d);if(c&&d.scheme!==h.Schemas.vscodeNotebookCell&&d.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);c||(c=new l(new S.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(d,c),s.push(c.value)),c.ref()}if(p.removedEditors)for(const a of p.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&r.push(d)}if(p.addedEditors)for(const a of p.addedEditors){const d=N.URI.revive(a.documentUri);n.ok(this.c.has(d),`document '${d}' does not exist`),n.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const c=this.c.get(d).value,u=new O.ExtHostTextEditor(a.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>c.document),a.selections.map(I.Selection.to),a.options,a.visibleRanges.map(t=>I.Range.to(t)),typeof a.editorPosition=="number"?I.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,u)}p.newActiveEditor!==void 0&&(n.ok(p.newActiveEditor===null||this.b.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this.a=p.newActiveEditor),(0,y.dispose)(w),(0,y.dispose)(r),p.removedDocuments&&this.e.fire(w),p.addedDocuments&&this.d.fire(s),(p.removedEditors||p.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),p.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(p){return this.c.get(p)?.value}allDocuments(){return i.Iterable.map(this.c.values(),p=>p.value)}getEditor(p){return this.b.get(p)}activeEditor(p){if(!this.a)return;const w=this.b.get(this.a);return p?w:w?.value}allEditors(){return[...this.b.values()]}};E=Ve([je(0,k.IExtHostRpcService),je(1,f.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[55],Ce([1,0,8,4,2,5,3,6,14,9,78]),function(te,e,n,T,y,N,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class I{constructor(o,l,E){this.e=E,this.d=l,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(y.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(y.URI.revive(this.b.input.base),y.URI.revive(this.b.input.input1),y.URI.revive(this.b.input.input2),y.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(y.URI.revive(this.b.input.uri),y.URI.revive(this.b.input.inputBoxUri));default:return}}}class f{constructor(o,l){this.c=[],this.d="",this.b=o,this.e=l;for(const E of o.tabs)E.isActive&&(this.d=E.id),this.c.push(new I(E,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return n.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(E=>E.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(E=>E.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const E=new I(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,E),o.tabDto.isActive&&(this.d=E.tabId),E}else if(o.kind===1){const E=this.c.splice(o.index,1)[0];if(!E)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return E.tabId===this.d&&(this.d=""),E}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const E=this.c.splice(o.oldIndex,1)[0];if(!E)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,E),E}const l=this.c.find(E=>E.tabId===o.tabDto.id);if(!l)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(o.tabDto),l}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new N.Emitter,this.c=new N.Emitter,this.e=[],this.a=o.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,l={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(E=>E.apiObject))},get activeTabGroup(){const E=o.d;return(0,k.assertIsDefined)(o.e.find(p=>p.groupId===E)?.apiObject)},close:async(E,b)=>{const p=Array.isArray(E)?E:[E];return p.length?h(p[0])?this.j(p,b):this.i(p,b):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(o){const l=new Set(this.e.map(a=>a.groupId)),E=new Set(o.map(a=>a.groupId)),b=(0,O.diffSets)(l,E),p=this.e.filter(a=>b.removed.includes(a.groupId)).map(a=>a.apiObject),w=[],s=[];this.e=o.map(a=>{const d=new f(a,()=>this.d);return b.added.includes(d.groupId)?w.push(d.apiObject):s.push(d.apiObject),d});const r=(0,k.assertIsDefined)(o.find(a=>a.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:w,closed:p,changed:s}))}$acceptTabGroupUpdate(o){const l=this.e.find(E=>E.groupId===o.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const l=this.e.find(b=>b.groupId===o.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const E=l.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[E.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[E.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[E.apiObject]}));return}}g(o){for(const l of this.e)for(const E of l.tabs)if(E.apiObject===o)return E}h(o){return this.e.find(l=>l.apiObject===o)}async i(o,l){const E=[];for(const b of o){const p=this.g(b);if(!p)throw new Error("Tab close: Invalid tab not found!");E.push(p.tabId)}return this.a.$closeTab(E,l)}async j(o,l){const E=[];for(const b of o){const p=this.h(b);if(!p)throw new Error("Group close: Invalid group not found!");E.push(p.groupId)}return this.a.$closeGroup(E,l)}};v=Ve([je(0,S.IExtHostRpcService)],v),e.ExtHostEditorTabs=v;function h(i){return i.tabs!==void 0}}),define(De[205],Ce([1,0,2,4,7,6,8,251,10,24,25]),function(te,e,n,T,y,N,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const i=this.a.indexOf(h);i>=0&&(this.a.splice(i,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),i=[];let o,l,E=14,b=14;for(const p of h){let w=o?(0,S.commonPrefixLength)(o,p):0;for(w===0?l=1:l=b;w<p.length;w++)w+1===p.length?(E=b,b=9):b+=1,i.push([l,p.toUpperCase().charCodeAt(w),b]),i.push([l,p.toLowerCase().charCodeAt(w),b]),l=b;o=p,b=E}i.push([9,58,10]),i.push([10,47,12]),this.b=new R.StateMachine(i)}}provideDocumentLinks(h){this.c();const i=[],o=R.LinkComputer.computeLinks({getLineContent(l){return h.lineAt(l-1).text},getLineCount(){return h.lineCount}},this.b);for(const l of o){const E=C.DocumentLink.to(l);E.target&&i.push(E)}return i}}class f{constructor(h,i){this.i=i,this.b=new I,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,i,o,l={}){if(this.d.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const E=this.h++;this.b.add(i),this.d.add(i),this.c.set(E,o);let b=2;l.isCaseSensitive&&(b+=1024),l.isReadonly&&(b+=2048),typeof o.copy=="function"&&(b+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,O.checkProposedApiEnabled)(h,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(E,i,b).catch(w=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${i}`),console.error(w)});const p=o.onDidChangeFile(w=>{const s=[];for(const r of w){const{uri:a,type:d}=r;if(a.scheme!==i)continue;let c;switch(d){case N.FileChangeType.Changed:c=0;break;case N.FileChangeType.Created:c=1;break;case N.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:a,type:c})}this.a.$onFileSystemChange(E,s)});return(0,y.toDisposable)(()=>{p.dispose(),this.b.delete(i),this.d.delete(i),this.c.delete(E),this.a.$unregisterProvider(E)})}static j(h){const{type:i,ctime:o,mtime:l,size:E,permissions:b}=h;return{type:i,ctime:o,mtime:l,size:E,permissions:b}}$stat(h,i){return Promise.resolve(this.k(h).stat(n.URI.revive(i))).then(o=>f.j(o))}$readdir(h,i){return Promise.resolve(this.k(h).readDirectory(n.URI.revive(i)))}$readFile(h,i){return Promise.resolve(this.k(h).readFile(n.URI.revive(i))).then(o=>k.VSBuffer.wrap(o))}$writeFile(h,i,o,l){return Promise.resolve(this.k(h).writeFile(n.URI.revive(i),o.buffer,l))}$delete(h,i,o){return Promise.resolve(this.k(h).delete(n.URI.revive(i),o))}$rename(h,i,o,l){return Promise.resolve(this.k(h).rename(n.URI.revive(i),n.URI.revive(o),l))}$copy(h,i,o,l){const E=this.k(h);if(!E.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(E.copy(n.URI.revive(i),n.URI.revive(o),l))}$mkdir(h,i){return Promise.resolve(this.k(h).createDirectory(n.URI.revive(i)))}$watch(h,i,o,l){const E=this.k(h).watch(n.URI.revive(o),l);this.f.set(i,E)}$unwatch(h,i){const o=this.f.get(i);o&&(o.dispose(),this.f.delete(i))}$open(h,i,o){const l=this.k(h);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(n.URI.revive(i),o))}$close(h,i){const o=this.k(h);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(i))}$read(h,i,o,l){const E=this.k(h);if(!E.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(l);return Promise.resolve(E.read(i,o,b.buffer,0,l)).then(p=>b.slice(0,p))}$write(h,i,o,l){const E=this.k(h);if(!E.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(E.write(i,o,l.buffer,0,l.byteLength))}k(h){const i=this.c.get(h);if(!i){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return i}}e.ExtHostFileSystem=f}),define(De[56],Ce([1,0,4,36,6,24,3,14,37,7]),function(te,e,n,T,y,N,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Jt{constructor(f,v){this.b=new Map,this.a=f.getProxy(n.MainContext.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(i){try{const o=h.b.get(i.scheme);if(!o)return await h.a.$stat(i);await h.a.$ensureActivation(i.scheme);const l=await o.stat(i);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(o){Jt.c(o)}},async readDirectory(i){try{const o=h.b.get(i.scheme);return o?(await h.a.$ensureActivation(i.scheme),(await o.readDirectory(i)).slice()):await h.a.$readdir(i)}catch(o){return Jt.c(o)}},async createDirectory(i){try{return await h.a.$mkdir(i)}catch(o){return Jt.c(o)}},async readFile(i){try{const o=h.b.get(i.scheme);return o?(await h.a.$ensureActivation(i.scheme),(await o.readFile(i)).slice()):(await h.a.$readFile(i)).buffer}catch(o){return Jt.c(o)}},async writeFile(i,o){try{return await h.a.$writeFile(i,N.VSBuffer.wrap(o))}catch(l){return Jt.c(l)}},async delete(i,o){try{const l=h.b.get(i.scheme);return l?(await h.a.$ensureActivation(i.scheme),await l.delete(i,{recursive:!1,...o})):await h.a.$delete(i,{recursive:!1,useTrash:!1,...o})}catch(l){return Jt.c(l)}},async rename(i,o,l){try{return await h.a.$rename(i,o,{overwrite:!1,...l})}catch(E){return Jt.c(E)}},async copy(i,o,l){try{return await h.a.$copy(i,o,{overwrite:!1,...l})}catch(E){return Jt.c(E)}},isWritableFileSystem(i){const o=v.getCapabilities(i);if(typeof o=="number")return!(o&2048)}})}static c(f){if(f instanceof y.FileSystemError)throw f;if(!(f instanceof Error))throw new y.FileSystemError(String(f));if(f.name==="ENOPRO")throw y.FileSystemError.Unavailable(f.message);switch(f.name){case T.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(f.message);default:throw new y.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,v){return this.b.set(f,v),(0,k.toDisposable)(()=>this.b.delete(f))}};O=Ve([je(0,R.IExtHostRpcService),je(1,S.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(De[206],Ce([1,0,5,35,2,4,8,6]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(I,f,v,h,i,o,l,E){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const b=this.h(I,v,i);this.g=0,o&&(this.g+=1),l&&(this.g+=2),E&&(this.g+=4);const p=(0,T.parse)(i),w=typeof i=="string",s=h(r=>{if(!o)for(const a of r.created){const d=y.URI.revive(a);p(d.fsPath)&&(!w||f.getWorkspaceFolder(d))&&this.a.fire(d)}if(!l)for(const a of r.changed){const d=y.URI.revive(a);p(d.fsPath)&&(!w||f.getWorkspaceFolder(d))&&this.b.fire(d)}if(!E)for(const a of r.deleted){const d=y.URI.revive(a);p(d.fsPath)&&(!w||f.getWorkspaceFolder(d))&&this.c.fire(d)}});this.d=R.Disposable.from(b,this.a,this.b,this.c,s)}h(I,f,v){const h=R.Disposable.from();if(typeof v=="string")return h;const i=I.getProxy(N.MainContext.MainThreadFileSystem);let o=!1;(v.pattern.includes(T.GLOBSTAR)||v.pattern.includes(T.GLOB_SPLIT))&&(o=!0);const l=Math.random();return i.$watch(f.identifier.value,l,v.baseUri,{recursive:o,excludes:[]}),R.Disposable.from({dispose:()=>i.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(I,f,v){this.j=I,this.k=f,this.l=v,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,f,v,h,i,o){return new S(this.j,I,f,this.a.event,C.GlobPattern.from(v),h,i,o)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,f){switch(I){case 2:this.b.fire(Object.freeze({files:f.map(v=>({oldUri:y.URI.revive(v.source),newUri:y.URI.revive(v.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(v=>y.URI.revive(v.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(v=>y.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,f){return(v,h,i)=>{const o=function(E){v.call(h,E)};return o.extension=I,f.event(o,void 0,i)}}async $onWillRunFileOperation(I,f,v,h){switch(I){case 2:return await this.n(this.g,{files:f.map(i=>({oldUri:y.URI.revive(i.source),newUri:y.URI.revive(i.target)}))},v,h);case 1:return await this.n(this.i,{files:f.map(i=>y.URI.revive(i.target))},v,h);case 0:case 3:return await this.n(this.h,{files:f.map(i=>y.URI.revive(i.target))},v,h)}}async n(I,f,v,h){const i=new Set,o=[];if(await I.fireAsync(f,h,async(E,b)=>{const p=Date.now(),w=await Promise.resolve(E);w instanceof R.WorkspaceEdit&&(o.push([b.extension,w]),i.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-p>v&&this.k.warn("SLOW file-participant",b.extension.identifier)}),h.isCancellationRequested||o.length===0)return;const l={edits:[]};for(const[,E]of o){const{edits:b}=C.WorkspaceEdit.from(E,{getTextDocumentVersion:p=>this.l.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(b)}return{edit:l,extensionNames:Array.from(i)}}}e.ExtHostFileSystemEventService=k}),define(De[207],Ce([1,0,2,38]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(C,R,S,k,O){this.a=R,this.b=S,this.c=k;const I=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new T.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new T.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new T.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new T.ApiCommandResult("Notebook and input URI",f=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const v=this.a.getEditorById(f.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri),notebookEditor:v.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(C,R,S,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=y}),define(De[208],Ce([1,0,7,4]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(C){this.b=0,this.a=C.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,C),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=y}),define(De[209],Ce([1,0,2,23,8,6,71,4,10,53,16,9,252,20,7,83,79,50,210,11,15,25]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(D,U){this.d=D,this.e=U}async provideDocumentSymbols(D,U){const H=this.d.getDocument(D),G=await this.e.provideDocumentSymbols(H,U);if(!(0,O.isFalsyOrEmpty)(G))return G[0]instanceof N.DocumentSymbol?G.map(y.DocumentSymbol.from):s.f(G)}static f(D){D=D.slice(0).sort((G,ee)=>{let de=G.location.range.start.compareTo(ee.location.range.start);return de===0&&(de=ee.location.range.end.compareTo(G.location.range.end)),de});const U=[],H=[];for(const G of D){const ee={name:G.name||"!!MISSING: name!!",kind:y.SymbolKind.from(G.kind),tags:G.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:y.Range.from(G.location.range),selectionRange:y.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(ee),U.push(ee);break}const de=H[H.length-1];if(k.Range.containsRange(de.range,ee.range)&&!k.Range.equalsRange(de.range,ee.range)){de.children?.push(ee),H.push(ee);break}H.pop()}}return U}}class r{constructor(D,U,H){this.g=D,this.h=U,this.j=H,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(D,U){const H=this.g.getDocument(D),G=await this.j.provideCodeLenses(H,U);if(!G||U.isCancellationRequested)return;const ee=this.e.add(G),de=new h.DisposableStore;this.f.set(ee,de);const ye={cacheId:ee,lenses:[]};for(let se=0;se<G.length;se++)ye.lenses.push({cacheId:[ee,se],range:y.Range.from(G[se].range),command:this.h.toInternal(G[se].command,de)});return ye}async resolveCodeLens(D,U){const H=D.cacheId&&this.e.get(...D.cacheId);if(!H)return;let G;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.j.resolveCodeLens(H,U),G||(G=H),U.isCancellationRequested)return;const ee=D.cacheId&&this.f.get(D.cacheId[0]);if(!!ee)return D.command=this.h.toInternal(G.command??r.d,ee),D}releaseCodeLenses(D){this.f.get(D)?.dispose(),this.f.delete(D),this.e.delete(D)}}r.d={command:"missing",title:"!!MISSING: command!!"};function a(J){return Array.isArray(J)?J.map(y.DefinitionLink.from):J?[y.DefinitionLink.from(J)]:[]}class d{constructor(D,U){this.d=D,this.e=U}async provideDefinition(D,U,H){const G=this.d.getDocument(D),ee=y.Position.to(U),de=await this.e.provideDefinition(G,ee,H);return a(de)}}class c{constructor(D,U){this.d=D,this.e=U}async provideDeclaration(D,U,H){const G=this.d.getDocument(D),ee=y.Position.to(U),de=await this.e.provideDeclaration(G,ee,H);return a(de)}}class u{constructor(D,U){this.d=D,this.e=U}async provideImplementation(D,U,H){const G=this.d.getDocument(D),ee=y.Position.to(U),de=await this.e.provideImplementation(G,ee,H);return a(de)}}class t{constructor(D,U){this.d=D,this.e=U}async provideTypeDefinition(D,U,H){const G=this.d.getDocument(D),ee=y.Position.to(U),de=await this.e.provideTypeDefinition(G,ee,H);return a(de)}}class m{constructor(D,U){this.d=D,this.e=U}async provideHover(D,U,H){const G=this.d.getDocument(D),ee=y.Position.to(U),de=await this.e.provideHover(G,ee,H);if(!(!de||(0,O.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=G.getWordRangeAtPosition(ee)),de.range||(de.range=new N.Range(ee,ee)),y.Hover.from(de)}}class g{constructor(D,U){this.d=D,this.e=U}async provideEvaluatableExpression(D,U,H){const G=this.d.getDocument(D),ee=y.Position.to(U),de=await this.e.provideEvaluatableExpression(G,ee,H);if(de)return y.EvaluatableExpression.from(de)}}class A{constructor(D,U){this.d=D,this.e=U}async provideInlineValues(D,U,H,G){const ee=this.d.getDocument(D),de=await this.e.provideInlineValues(ee,y.Range.to(U),y.InlineValueContext.to(H),G);if(Array.isArray(de))return de.map(ye=>y.InlineValue.from(ye))}}class L{constructor(D,U){this.d=D,this.e=U}async provideDocumentHighlights(D,U,H){const G=this.d.getDocument(D),ee=y.Position.to(U),de=await this.e.provideDocumentHighlights(G,ee,H);if(Array.isArray(de))return de.map(y.DocumentHighlight.from)}}class K{constructor(D,U){this.d=D,this.e=U}async provideLinkedEditingRanges(D,U,H){const G=this.d.getDocument(D),ee=y.Position.to(U),de=await this.e.provideLinkedEditingRanges(G,ee,H);if(de&&Array.isArray(de.ranges))return{ranges:(0,O.coalesce)(de.ranges.map(y.Range.from)),wordPattern:de.wordPattern}}}class q{constructor(D,U){this.d=D,this.e=U}async provideReferences(D,U,H,G){const ee=this.d.getDocument(D),de=y.Position.to(U),ye=await this.e.provideReferences(ee,de,H,G);if(Array.isArray(ye))return ye.map(y.location.from)}}class j{constructor(D,U,H,G,ee,de,ye){this.g=D,this.h=U,this.j=H,this.k=G,this.l=ee,this.m=de,this.n=ye,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(D,U,H,G){const ee=this.g.getDocument(D),de=f.Selection.isISelection(U)?y.Selection.to(U):y.Range.to(U),ye=[];for(const tt of this.j.getDiagnostics(D))if(de.intersection(tt.range)&&ye.push(tt)>j.d)break;const se={diagnostics:ye,only:H.only?new N.CodeActionKind(H.only):void 0,triggerKind:y.CodeActionTriggerKind.to(H.trigger)},ve=await this.k.provideCodeActions(ee,de,se,G);if(!(0,O.isNonEmptyArray)(ve)||G.isCancellationRequested)return;const be=this.e.add(ve),$e=new h.DisposableStore;this.f.set(be,$e);const He=[];for(let tt=0;tt<ve.length;tt++){const Ge=ve[tt];!Ge||(j.o(Ge)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Ge.title,command:this.h.toInternal(Ge,$e)})):(se.only&&(Ge.kind?se.only.contains(Ge.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${se.only.value} 'requested but returned code action is of kind '${Ge.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${se.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[be,tt],title:Ge.title,command:Ge.command&&this.h.toInternal(Ge.command,$e),diagnostics:Ge.diagnostics&&Ge.diagnostics.map(y.Diagnostic.from),edit:Ge.edit&&y.WorkspaceEdit.from(Ge.edit,void 0),kind:Ge.kind&&Ge.kind.value,isPreferred:Ge.isPreferred,disabled:Ge.disabled?.reason})))}return{cacheId:be,actions:He}}async resolveCodeAction(D,U){const[H,G]=D,ee=this.e.get(H,G);if(!ee||j.o(ee)||!this.k.resolveCodeAction)return;const de=await this.k.resolveCodeAction(ee,U)??ee;return de?.edit?y.WorkspaceEdit.from(de.edit,void 0):void 0}releaseCodeActions(D){this.f.get(D)?.dispose(),this.f.delete(D),this.e.delete(D)}static o(D){return typeof D.command=="string"&&typeof D.title=="string"}}j.d=1e3;class P{constructor(D,U,H,G){this.d=D,this.e=U,this.f=H,this.g=G}async prepareDocumentPaste(D,U,H,G){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(D),de=U.map(se=>y.Range.to(se)),ye=y.DataTransfer.toDataTransfer(H,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(ee,de,ye,G),y.DataTransfer.toDataTransferDTO(ye)}async providePasteEdits(D,U,H,G,ee){const de=this.e.getDocument(U),ye=H.map(be=>y.Range.to(be)),se=y.DataTransfer.toDataTransfer(G,async be=>(await this.d.$resolvePasteFileData(this.g,D,be)).buffer),ve=await this.f.provideDocumentPasteEdits(de,ye,se,ee);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?y.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class M{constructor(D,U){this.d=D,this.e=U}async provideDocumentFormattingEdits(D,U,H){const G=this.d.getDocument(D),ee=await this.e.provideDocumentFormattingEdits(G,U,H);if(Array.isArray(ee))return ee.map(y.TextEdit.from)}}class F{constructor(D,U){this.d=D,this.e=U}async provideDocumentRangeFormattingEdits(D,U,H,G){const ee=this.d.getDocument(D),de=y.Range.to(U),ye=await this.e.provideDocumentRangeFormattingEdits(ee,de,H,G);if(Array.isArray(ye))return ye.map(y.TextEdit.from)}}class ${constructor(D,U){this.d=D,this.e=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(D,U,H,G,ee){const de=this.d.getDocument(D),ye=y.Position.to(U),se=await this.e.provideOnTypeFormattingEdits(de,ye,H,G,ee);if(Array.isArray(se))return se.map(y.TextEdit.from)}}class z{constructor(D,U){this.e=D,this.f=U,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(D,U){const H=await this.e.provideWorkspaceSymbols(D,U);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const G=this.d.add(H),ee={cacheId:G,symbols:[]};for(let de=0;de<H.length;de++){const ye=H[de];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}ee.symbols.push({...y.WorkspaceSymbol.from(ye),cacheId:[G,de]})}return ee}async resolveWorkspaceSymbol(D,U){if(typeof this.e.resolveWorkspaceSymbol!="function"||!D.cacheId)return D;const H=this.d.get(...D.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,U);return G&&(0,T.mixin)(D,y.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(D){this.d.delete(D)}}class V{static supportsResolving(D){return typeof D.prepareRename=="function"}constructor(D,U,H){this.d=D,this.e=U,this.f=H}async provideRenameEdits(D,U,H,G){const ee=this.d.getDocument(D),de=y.Position.to(U);try{const ye=await this.e.provideRenameEdits(ee,de,H,G);return ye?y.WorkspaceEdit.from(ye):void 0}catch(ye){const se=V.g(ye);return se?{rejectReason:se,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(D,U,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(D),ee=y.Position.to(U);try{const de=await this.e.prepareRename(G,ee,H);let ye,se;if(N.Range.isRange(de)?(ye=de,se=G.getText(de)):(0,I.isObject)(de)&&(ye=de.range,se=de.placeholder),!ye||!se)return;if(ye.start.line>ee.line||ye.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(ye),text:se}}catch(de){const ye=V.g(de);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(de)}}static g(D){return typeof D=="string"?D:D instanceof Error&&typeof D.message=="string"?D.message:void 0}}class X{constructor(D,U){this.resultId=D,this.tokens=U}}class Z{constructor(D,U){this.f=D,this.g=U,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(D,U,H){const G=this.f.getDocument(D),ee=U!==0?this.d.get(U):null;let de=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,ee.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return ee&&this.d.delete(U),de?(de=Z.h(de),this.o(Z.n(ee,de),de)):null}async releaseDocumentSemanticColoring(D){this.d.delete(D)}static h(D){return Z.j(D)?Z.k(D)?D:new N.SemanticTokens(new Uint32Array(D.data),D.resultId):Z.l(D)?Z.m(D)?D:new N.SemanticTokensEdits(D.edits.map(U=>new N.SemanticTokensEdit(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),D.resultId):D}static j(D){return D&&!!D.data}static k(D){return D.data instanceof Uint32Array}static l(D){return D&&Array.isArray(D.edits)}static m(D){for(const U of D.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static n(D,U){if(!Z.j(U)||!D||!D.tokens)return U;const H=D.tokens,G=H.length,ee=U.data,de=ee.length;let ye=0;const se=Math.min(G,de);for(;ye<se&&H[ye]===ee[ye];)ye++;if(ye===G&&ye===de)return new N.SemanticTokensEdits([],U.resultId);let ve=0;const be=se-ye;for(;ve<be&&H[G-ve-1]===ee[de-ve-1];)ve++;return new N.SemanticTokensEdits([{start:ye,deleteCount:G-ye-ve,data:ee.subarray(ye,de-ve)}],U.resultId)}o(D,U){if(Z.j(D)){const H=this.e++;return this.d.set(H,new X(D.resultId,D.data)),(0,i.encodeSemanticTokensDto)({id:H,type:"full",data:D.data})}if(Z.l(D)){const H=this.e++;return Z.j(U)?this.d.set(H,new X(U.resultId,U.data)):this.d.set(H,new X(D.resultId)),(0,i.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(D.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class fe{constructor(D,U){this.d=D,this.e=U}async provideDocumentRangeSemanticTokens(D,U,H){const G=this.d.getDocument(D),ee=await this.e.provideDocumentRangeSemanticTokens(G,y.Range.to(U),H);return ee?this.f(ee):null}f(D){return(0,i.encodeSemanticTokensDto)({id:0,type:"full",data:D.data})}}class oe{static supportsResolving(D){return typeof D.resolveCompletionItem=="function"}constructor(D,U,H,G,ee){this.f=D,this.g=U,this.h=H,this.j=G,this.k=ee,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(D,U,H,G){const ee=this.f.getDocument(D),de=y.Position.to(U),ye=ee.getWordRangeAtPosition(de)||new N.Range(de,de),se=ye.with({end:de}),ve=new E.StopWatch(!0),be=await this.h.provideCompletionItems(ee,de,G,y.CompletionContext.to(H));if(!be||G.isCancellationRequested)return;const $e=Array.isArray(be)?new N.CompletionList(be):be,He=oe.supportsResolving(this.h)?this.d.add($e.items):this.d.add([]),tt=new h.DisposableStore;this.e.set(He,tt);const Ge=[],et={x:He,b:Ge,a:{replace:y.Range.from(ye),insert:y.Range.from(se)},c:$e.isIncomplete||void 0,d:ve.elapsed()};for(let it=0;it<$e.items.length;it++){const ct=$e.items[it],nt=this.l(ct,[He,it],se,ye);Ge.push(nt)}return et}async resolveCompletionItem(D,U){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...D);if(!H)return;const G=await this.h.resolveCompletionItem(H,U);if(!!G)return this.l(G,D)}releaseCompletionItems(D){this.e.get(D)?.dispose(),this.e.delete(D),this.d.delete(D)}l(D,U,H,G){const ee=this.e.get(U[0]);if(!ee)throw Error("DisposableStore is missing...");const de=this.g.toInternal(D.command,ee),ye={x:U,a:D.label,b:D.kind!==void 0?y.CompletionItemKind.from(D.kind):void 0,m:D.tags&&D.tags.map(y.CompletionItemTag.from),c:D.detail,d:typeof D.documentation>"u"?void 0:y.MarkdownString.fromStrict(D.documentation),e:D.sortText!==D.label?D.sortText:void 0,f:D.filterText!==D.label?D.filterText:void 0,g:D.preselect||void 0,i:D.keepWhitespace?1:0,k:D.commitCharacters?.join(""),l:D.additionalTextEdits&&D.additionalTextEdits.map(y.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};D.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=D.textEdit.newText):typeof D.insertText=="string"?ye.h=D.insertText:D.insertText instanceof N.SnippetString&&(ye.h=D.insertText.value,ye.i|=4);let se;return D.textEdit?se=D.textEdit.range:D.range&&(se=D.range),N.Range.isRange(se)?ye.j=y.Range.from(se):se&&(!H?.isEqual(se.inserting)||!G?.isEqual(se.replacing))&&(ye.j={insert:y.Range.from(se.inserting),replace:y.Range.from(se.replacing)}),ye}}class le{async provideInlineCompletions(D,U,H,G){}disposeCompletions(D){}handleDidShowCompletionItem(D,U){}}class ce extends le{constructor(D,U,H,G){super(),this.f=D,this.g=U,this.h=H,this.j=G,this.d=new me,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(D,U,H,G){const ee=this.g.getDocument(D),de=y.Position.to(U),ye=await this.h.provideInlineCompletionItems(ee,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:y.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!ye||G.isCancellationRequested)return;const se=Array.isArray(ye)?ye:ye.items,ve=this.e?Array.isArray(ye)?[]:ye.commands||[]:[];let be;return{pid:this.d.createReferenceId({dispose(){be?.dispose()},items:se}),items:se.map((He,tt)=>{let Ge;He.command&&(be||(be=new h.DisposableStore),Ge=this.j.toInternal(He.command,be));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?y.Range.from(He.range):void 0,command:Ge,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:ve.map(He=>(be||(be=new h.DisposableStore),this.j.toInternal(He,be)))}}disposeCompletions(D){this.d.disposeReferenceId(D)?.dispose()}handleDidShowCompletionItem(D,U){const H=this.d.get(D)?.items[U];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}}class me{constructor(){this.d=new Map,this.e=1}createReferenceId(D){const U=this.e++;return this.d.set(U,D),U}disposeReferenceId(D){const U=this.d.get(D);return this.d.delete(D),U}get(D){return this.d.get(D)}}class Y{constructor(D,U){this.e=D,this.f=U,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(D,U,H,G){const ee=this.e.getDocument(D),de=y.Position.to(U),ye=this.g(H),se=await this.f.provideSignatureHelp(ee,de,G,ye);if(se){const ve=this.d.add([se]);return{...y.SignatureHelp.from(se),id:ve}}}g(D){let U;if(D.activeSignatureHelp){const H=y.SignatureHelp.to(D.activeSignatureHelp),G=this.d.get(D.activeSignatureHelp.id,0);G?(U=G,U.activeSignature=H.activeSignature,U.activeParameter=H.activeParameter):U=H}return{...D,activeSignatureHelp:U}}releaseSignatureHelp(D){this.d.delete(D)}}class pe{constructor(D,U,H,G,ee){this.f=D,this.g=U,this.h=H,this.j=G,this.k=ee,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(D,U,H){const G=this.f.getDocument(D),ee=y.Range.to(U),de=await this.h.provideInlayHints(G,ee,H);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${U}`);return}if(H.isCancellationRequested)return;const ye=this.d.add(de);this.e.set(ye,new h.DisposableStore);const se={hints:[],cacheId:ye};for(let ve=0;ve<de.length;ve++)this.l(de[ve],ee)&&se.hints.push(this.m(de[ve],[ye,ve]));return this.j.trace(`[InlayHints] ${se.hints.length} inlay hints from '${this.k.identifier.value}' for ${U}`),se}async resolveInlayHint(D,U){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...D);if(!H)return;const G=await this.h.resolveInlayHint(H,U);if(!!G&&!!this.l(G))return this.m(G,D)}releaseHints(D){this.e.get(D)?.dispose(),this.e.delete(D),this.d.delete(D)}l(D,U){return D.label.length===0||Array.isArray(D.label)&&D.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",D),!1):!(U&&!U.contains(D.position))}m(D,U){const H=this.e.get(U[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:U,tooltip:y.MarkdownString.fromStrict(D.tooltip),position:y.Position.from(D.position),textEdits:D.textEdits&&D.textEdits.map(y.TextEdit.from),kind:D.kind&&y.InlayHintKind.from(D.kind),paddingLeft:D.paddingLeft,paddingRight:D.paddingRight};return typeof D.label=="string"?G.label=D.label:G.label=D.label.map(ee=>{const de={label:ee.value};return de.tooltip=y.MarkdownString.fromStrict(ee.tooltip),N.Location.isLocation(ee.location)&&(de.location=y.location.from(ee.location)),ee.command&&(de.command=this.g.toInternal(ee.command,H)),de}),G}}class we{constructor(D,U){this.e=D,this.f=U,this.d=new l.Cache("DocumentLink")}async provideLinks(D,U){const H=this.e.getDocument(D),G=await this.f.provideDocumentLinks(H,U);if(!(!Array.isArray(G)||G.length===0)&&!U.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(we.g).map(y.DocumentLink.from)};{const ee=this.d.add(G),de={links:[],cacheId:ee};for(let ye=0;ye<G.length;ye++){if(!we.g(G[ye]))continue;const se=y.DocumentLink.from(G[ye]);se.cacheId=[ee,ye],de.links.push(se)}return de}}}static g(D){return D.target&&D.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(D,U){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...D);if(!H)return;const G=await this.f.resolveDocumentLink(H,U);if(!(!G||!we.g(G)))return y.DocumentLink.from(G)}releaseLinks(D){this.d.delete(D)}}class Fe{constructor(D,U){this.d=D,this.e=U}async provideColors(D,U){const H=this.d.getDocument(D),G=await this.e.provideDocumentColors(H,U);return Array.isArray(G)?G.map(de=>({color:y.Color.from(de.color),range:y.Range.from(de.range)})):[]}async provideColorPresentations(D,U,H){const G=this.d.getDocument(D),ee=y.Range.to(U.range),de=y.Color.to(U.color),ye=await this.e.provideColorPresentations(de,{document:G,range:ee},H);if(!!Array.isArray(ye))return ye.map(y.ColorPresentation.from)}}class We{constructor(D,U){this.d=D,this.e=U}async provideFoldingRanges(D,U,H){const G=this.d.getDocument(D),ee=await this.e.provideFoldingRanges(G,U,H);if(!!Array.isArray(ee))return ee.map(y.FoldingRange.from)}}class Xe{constructor(D,U,H){this.d=D,this.e=U,this.f=H}async provideSelectionRanges(D,U,H){const G=this.d.getDocument(D),ee=U.map(y.Position.to),de=await this.e.provideSelectionRanges(G,ee,H);if(!(0,O.isNonEmptyArray)(de))return[];if(de.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let se=0;se<ee.length;se++){const ve=[];ye.push(ve);let be=ee[se],$e=de[se];for(;;){if(!$e.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(y.SelectionRange.from($e)),!$e.parent)break;be=$e.range,$e=$e.parent}}return ye}}class Pe{constructor(D,U){this.f=D,this.g=U,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(D,U,H){const G=this.f.getDocument(D),ee=y.Position.to(U),de=await this.g.prepareCallHierarchy(G,ee,H);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(se=>this.h(ye,se)):[this.h(ye,de)]}async provideCallsTo(D,U,H){const G=this.j(D,U);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(G,H);if(!!ee)return ee.map(de=>({from:this.h(D,de.from),fromRanges:de.fromRanges.map(ye=>y.Range.from(ye))}))}async provideCallsFrom(D,U,H){const G=this.j(D,U);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(!!ee)return ee.map(de=>({to:this.h(D,de.to),fromRanges:de.fromRanges.map(ye=>y.Range.from(ye))}))}releaseSession(D){this.e.delete(D)}h(D,U){const H=this.e.get(D),G=y.CallHierarchyItem.from(U,D,H.size.toString(36));return H.set(G._itemId,U),G}j(D,U){return this.e.get(D)?.get(U)}}class Ie{constructor(D,U){this.f=D,this.g=U,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(D,U,H){const G=this.f.getDocument(D),ee=y.Position.to(U),de=await this.g.prepareTypeHierarchy(G,ee,H);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(se=>this.h(ye,se)):[this.h(ye,de)]}async provideSupertypes(D,U,H){const G=this.j(D,U);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(G,H);if(!!ee)return ee.map(de=>this.h(D,de))}async provideSubtypes(D,U,H){const G=this.j(D,U);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(G,H);if(!!ee)return ee.map(de=>this.h(D,de))}releaseSession(D){this.e.delete(D)}h(D,U){const H=this.e.get(D),G=y.TypeHierarchyItem.from(U,D,H.size.toString(36));return H.set(G._itemId,U),G}j(D,U){return this.e.get(D)?.get(U)}}class ke{constructor(D,U,H,G){this.d=D,this.e=U,this.f=H,this.g=G}async provideDocumentOnDropEdits(D,U,H,G,ee){const de=this.e.getDocument(U),ye=y.Position.to(H),se=y.DataTransfer.toDataTransfer(G,async be=>(await this.d.$resolveDocumentOnDropFileData(this.g,D,be)).buffer),ve=await this.f.provideDocumentDropEdits(de,ye,se,ee);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?y.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class re{constructor(D,U){this.adapter=D,this.extension=U}}class ae{constructor(D,U,H,G,ee,de,ye,se){this.g=U,this.h=H,this.j=G,this.k=ee,this.l=de,this.m=ye,this.n=se,this.f=new Map,this.e=D.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(D){return y.DocumentSelector.from(D,this.g)}p(D){return new N.Disposable(()=>{this.f.delete(D),this.e.$unregister(D)})}q(){return ae.d++}async s(D,U,H,G,ee,de=!1){const ye=this.f.get(D);if(!ye||!(ye.adapter instanceof U))return G;const se=Date.now();de||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ve=H(ye.adapter,ye.extension);return Promise.resolve(ve).catch(be=>{(0,b.isCancellationError)(be)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(be),this.n.onExtensionError(ye.extension.identifier,be))}).finally(()=>{de||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-se}ms`)}),v.CancellationToken.isCancellationToken(ee)?(0,p.raceCancellationError)(ve,ee):ve}t(D,U){const H=this.q();return this.f.set(H,new re(D,U)),H}static u(D){return D.displayName||D.name}registerDocumentSymbolProvider(D,U,H,G){const ee=this.t(new s(this.h,H),D),de=G&&G.label||ae.u(D);return this.e.$registerDocumentSymbolProvider(ee,this.o(U),de),this.p(ee)}$provideDocumentSymbols(D,U,H){return this.s(D,s,G=>G.provideDocumentSymbols(n.URI.revive(U),H),void 0,H)}registerCodeLensProvider(D,U,H){const G=this.q(),ee=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new re(new r(this.h,this.j.converter,H),D)),this.e.$registerCodeLensSupport(G,this.o(U),ee);let de=this.p(G);if(ee!==void 0){const ye=H.onDidChangeCodeLenses(se=>this.e.$emitCodeLensEvent(ee));de=N.Disposable.from(de,ye)}return de}$provideCodeLenses(D,U,H){return this.s(D,r,G=>G.provideCodeLenses(n.URI.revive(U),H),void 0,H)}$resolveCodeLens(D,U,H){return this.s(D,r,G=>G.resolveCodeLens(U,H),void 0,void 0)}$releaseCodeLenses(D,U){this.s(D,r,H=>Promise.resolve(H.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(D,U,H){const G=this.t(new d(this.h,H),D);return this.e.$registerDefinitionSupport(G,this.o(U)),this.p(G)}$provideDefinition(D,U,H,G){return this.s(D,d,ee=>ee.provideDefinition(n.URI.revive(U),H,G),[],G)}registerDeclarationProvider(D,U,H){const G=this.t(new c(this.h,H),D);return this.e.$registerDeclarationSupport(G,this.o(U)),this.p(G)}$provideDeclaration(D,U,H,G){return this.s(D,c,ee=>ee.provideDeclaration(n.URI.revive(U),H,G),[],G)}registerImplementationProvider(D,U,H){const G=this.t(new u(this.h,H),D);return this.e.$registerImplementationSupport(G,this.o(U)),this.p(G)}$provideImplementation(D,U,H,G){return this.s(D,u,ee=>ee.provideImplementation(n.URI.revive(U),H,G),[],G)}registerTypeDefinitionProvider(D,U,H){const G=this.t(new t(this.h,H),D);return this.e.$registerTypeDefinitionSupport(G,this.o(U)),this.p(G)}$provideTypeDefinition(D,U,H,G){return this.s(D,t,ee=>ee.provideTypeDefinition(n.URI.revive(U),H,G),[],G)}registerHoverProvider(D,U,H,G){const ee=this.t(new m(this.h,H),D);return this.e.$registerHoverProvider(ee,this.o(U)),this.p(ee)}$provideHover(D,U,H,G){return this.s(D,m,ee=>ee.provideHover(n.URI.revive(U),H,G),void 0,G)}registerEvaluatableExpressionProvider(D,U,H,G){const ee=this.t(new g(this.h,H),D);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(U)),this.p(ee)}$provideEvaluatableExpression(D,U,H,G){return this.s(D,g,ee=>ee.provideEvaluatableExpression(n.URI.revive(U),H,G),void 0,G)}registerInlineValuesProvider(D,U,H,G){const ee=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new A(this.h,H),D);this.e.$registerInlineValuesProvider(de,this.o(U),ee);let ye=this.p(de);if(ee!==void 0){const se=H.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(ee));ye=N.Disposable.from(ye,se)}return ye}$provideInlineValues(D,U,H,G,ee){return this.s(D,A,de=>de.provideInlineValues(n.URI.revive(U),H,G,ee),void 0,ee)}registerDocumentHighlightProvider(D,U,H){const G=this.t(new L(this.h,H),D);return this.e.$registerDocumentHighlightProvider(G,this.o(U)),this.p(G)}$provideDocumentHighlights(D,U,H,G){return this.s(D,L,ee=>ee.provideDocumentHighlights(n.URI.revive(U),H,G),void 0,G)}registerLinkedEditingRangeProvider(D,U,H){const G=this.t(new K(this.h,H),D);return this.e.$registerLinkedEditingRangeProvider(G,this.o(U)),this.p(G)}$provideLinkedEditingRanges(D,U,H,G){return this.s(D,K,async ee=>{const de=await ee.provideLinkedEditingRanges(n.URI.revive(U),H,G);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?ae.w(de.wordPattern):void 0}},void 0,G)}registerReferenceProvider(D,U,H){const G=this.t(new q(this.h,H),D);return this.e.$registerReferenceSupport(G,this.o(U)),this.p(G)}$provideReferences(D,U,H,G,ee){return this.s(D,q,de=>de.provideReferences(n.URI.revive(U),H,G,ee),void 0,ee)}registerCodeActionProvider(D,U,H,G){const ee=new h.DisposableStore,de=this.t(new j(this.h,this.j.converter,this.k,H,this.l,D,this.m),D);return this.e.$registerQuickFixSupport(de,this.o(U),{providedKinds:G?.providedCodeActionKinds?.map(ye=>ye.value),documentation:G?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,ee)}))},ae.u(D),Boolean(H.resolveCodeAction)),ee.add(this.p(de)),ee}$provideCodeActions(D,U,H,G,ee){return this.s(D,j,de=>de.provideCodeActions(n.URI.revive(U),H,G,ee),void 0,ee)}$resolveCodeAction(D,U,H){return this.s(D,j,G=>G.resolveCodeAction(U,H),void 0,void 0)}$releaseCodeActions(D,U){this.s(D,j,H=>Promise.resolve(H.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(D,U,H){const G=this.t(new M(this.h,H),D);return this.e.$registerDocumentFormattingSupport(G,this.o(U),D.identifier,D.displayName||D.name),this.p(G)}$provideDocumentFormattingEdits(D,U,H,G){return this.s(D,M,ee=>ee.provideDocumentFormattingEdits(n.URI.revive(U),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(D,U,H){const G=this.t(new F(this.h,H),D);return this.e.$registerRangeFormattingSupport(G,this.o(U),D.identifier,D.displayName||D.name),this.p(G)}$provideDocumentRangeFormattingEdits(D,U,H,G,ee){return this.s(D,F,de=>de.provideDocumentRangeFormattingEdits(n.URI.revive(U),H,G,ee),void 0,ee)}registerOnTypeFormattingEditProvider(D,U,H,G){const ee=this.t(new $(this.h,H),D);return this.e.$registerOnTypeFormattingSupport(ee,this.o(U),G,D.identifier),this.p(ee)}$provideOnTypeFormattingEdits(D,U,H,G,ee,de){return this.s(D,$,ye=>ye.provideOnTypeFormattingEdits(n.URI.revive(U),H,G,ee,de),void 0,de)}registerWorkspaceSymbolProvider(D,U){const H=this.t(new z(U,this.l),D);return this.e.$registerNavigateTypeSupport(H,typeof U.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(D,U,H){return this.s(D,z,G=>G.provideWorkspaceSymbols(U,H),{symbols:[]},H)}$resolveWorkspaceSymbol(D,U,H){return this.s(D,z,G=>G.resolveWorkspaceSymbol(U,H),void 0,void 0)}$releaseWorkspaceSymbols(D,U){this.s(D,z,H=>H.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(D,U,H){const G=this.t(new V(this.h,H,this.l),D);return this.e.$registerRenameSupport(G,this.o(U),V.supportsResolving(H)),this.p(G)}$provideRenameEdits(D,U,H,G,ee){return this.s(D,V,de=>de.provideRenameEdits(n.URI.revive(U),H,G,ee),void 0,ee)}$resolveRenameLocation(D,U,H,G){return this.s(D,V,ee=>ee.resolveRenameLocation(n.URI.revive(U),H,G),void 0,G)}registerDocumentSemanticTokensProvider(D,U,H,G){const ee=this.t(new Z(this.h,H),D),de=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(U),G,de);let ye=this.p(ee);if(de){const se=H.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(de));ye=N.Disposable.from(ye,se)}return ye}$provideDocumentSemanticTokens(D,U,H,G){return this.s(D,Z,ee=>ee.provideDocumentSemanticTokens(n.URI.revive(U),H,G),null,G)}$releaseDocumentSemanticTokens(D,U){this.s(D,Z,H=>H.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(D,U,H,G){const ee=this.t(new fe(this.h,H),D);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(U),G),this.p(ee)}$provideDocumentRangeSemanticTokens(D,U,H,G){return this.s(D,fe,ee=>ee.provideDocumentRangeSemanticTokens(n.URI.revive(U),H,G),null,G)}registerCompletionItemProvider(D,U,H,G){const ee=this.t(new oe(this.h,this.j.converter,H,this.m,D),D);return this.e.$registerCompletionsProvider(ee,this.o(U),G,oe.supportsResolving(H),`${D.identifier.value}(${G.join("")})`),this.p(ee)}$provideCompletionItems(D,U,H,G,ee){return this.s(D,oe,de=>de.provideCompletionItems(n.URI.revive(U),H,G,ee),void 0,ee)}$resolveCompletionItem(D,U,H){return this.s(D,oe,G=>G.resolveCompletionItem(U,H),void 0,H)}$releaseCompletionItems(D,U){this.s(D,oe,H=>H.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(D,U,H){const G=new ce(D,this.h,H,this.j.converter),ee=this.t(G,D);return this.e.$registerInlineCompletionsSupport(ee,this.o(U),G.supportsHandleDidShowCompletionItem),this.p(ee)}$provideInlineCompletions(D,U,H,G,ee){return this.s(D,le,de=>de.provideInlineCompletions(n.URI.revive(U),H,G,ee),void 0,ee)}$handleInlineCompletionDidShow(D,U,H){this.s(D,le,async G=>{G.handleDidShowCompletionItem(U,H)},void 0,void 0)}$freeInlineCompletionsList(D,U){this.s(D,le,async H=>{H.disposeCompletions(U)},void 0,void 0)}registerSignatureHelpProvider(D,U,H,G){const ee=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,de=this.t(new Y(this.h,H),D);return this.e.$registerSignatureHelpProvider(de,this.o(U),ee),this.p(de)}$provideSignatureHelp(D,U,H,G,ee){return this.s(D,Y,de=>de.provideSignatureHelp(n.URI.revive(U),H,G,ee),void 0,ee)}$releaseSignatureHelp(D,U){this.s(D,Y,H=>H.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(D,U,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new pe(this.h,this.j.converter,H,this.l,D),D);this.e.$registerInlayHintsProvider(ee,this.o(U),typeof H.resolveInlayHint=="function",G,ae.u(D));let de=this.p(ee);if(G!==void 0){const ye=H.onDidChangeInlayHints(se=>this.e.$emitInlayHintsEvent(G));de=N.Disposable.from(de,ye)}return de}$provideInlayHints(D,U,H,G){return this.s(D,pe,ee=>ee.provideInlayHints(n.URI.revive(U),H,G),void 0,G)}$resolveInlayHint(D,U,H){return this.s(D,pe,G=>G.resolveInlayHint(U,H),void 0,H)}$releaseInlayHints(D,U){this.s(D,pe,H=>H.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(D,U,H){const G=this.t(new we(this.h,H),D);return this.e.$registerDocumentLinkProvider(G,this.o(U),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(D,U,H){return this.s(D,we,G=>G.provideLinks(n.URI.revive(U),H),void 0,H,U.scheme==="output")}$resolveDocumentLink(D,U,H){return this.s(D,we,G=>G.resolveLink(U,H),void 0,void 0,!0)}$releaseDocumentLinks(D,U){this.s(D,we,H=>H.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(D,U,H){const G=this.t(new Fe(this.h,H),D);return this.e.$registerDocumentColorProvider(G,this.o(U)),this.p(G)}$provideDocumentColors(D,U,H){return this.s(D,Fe,G=>G.provideColors(n.URI.revive(U),H),[],H)}$provideColorPresentations(D,U,H,G){return this.s(D,Fe,ee=>ee.provideColorPresentations(n.URI.revive(U),H,G),void 0,G)}registerFoldingRangeProvider(D,U,H){const G=this.q(),ee=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new re(new We(this.h,H),D)),this.e.$registerFoldingRangeProvider(G,this.o(U),D.identifier,ee);let de=this.p(G);if(ee!==void 0){const ye=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));de=N.Disposable.from(de,ye)}return de}$provideFoldingRanges(D,U,H,G){return this.s(D,We,ee=>ee.provideFoldingRanges(n.URI.revive(U),H,G),void 0,G)}registerSelectionRangeProvider(D,U,H){const G=this.t(new Xe(this.h,H,this.l),D);return this.e.$registerSelectionRangeProvider(G,this.o(U)),this.p(G)}$provideSelectionRanges(D,U,H,G){return this.s(D,Xe,ee=>ee.provideSelectionRanges(n.URI.revive(U),H,G),[],G)}registerCallHierarchyProvider(D,U,H){const G=this.t(new Pe(this.h,H),D);return this.e.$registerCallHierarchyProvider(G,this.o(U)),this.p(G)}$prepareCallHierarchy(D,U,H,G){return this.s(D,Pe,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(U),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(D,U,H,G){return this.s(D,Pe,ee=>ee.provideCallsTo(U,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(D,U,H,G){return this.s(D,Pe,ee=>ee.provideCallsFrom(U,H,G),void 0,G)}$releaseCallHierarchy(D,U){this.s(D,Pe,H=>Promise.resolve(H.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(D,U,H){const G=this.t(new Ie(this.h,H),D);return this.e.$registerTypeHierarchyProvider(G,this.o(U)),this.p(G)}$prepareTypeHierarchy(D,U,H,G){return this.s(D,Ie,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(U),H,G)),void 0,G)}$provideTypeHierarchySupertypes(D,U,H,G){return this.s(D,Ie,ee=>ee.provideSupertypes(U,H,G),void 0,G)}$provideTypeHierarchySubtypes(D,U,H,G){return this.s(D,Ie,ee=>ee.provideSubtypes(U,H,G),void 0,G)}$releaseTypeHierarchy(D,U){this.s(D,Ie,H=>Promise.resolve(H.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(D,U,H){const G=this.q();return this.f.set(G,new re(new ke(this.e,this.h,H,G),D)),this.e.$registerDocumentOnDropEditProvider(G,this.o(U)),this.p(G)}$provideDocumentOnDropEdits(D,U,H,G,ee,de){return this.s(D,ke,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(U,n.URI.revive(H),G,ee,de)),void 0,void 0)}registerDocumentPasteEditProvider(D,U,H,G){const ee=this.q();return this.f.set(ee,new re(new P(this.e,this.h,H,ee),D)),this.e.$registerPasteEditProvider(ee,this.o(U),!!H.prepareDocumentPaste,G.pasteMimeTypes),this.p(ee)}$prepareDocumentPaste(D,U,H,G,ee){return this.s(D,P,de=>de.prepareDocumentPaste(n.URI.revive(U),H,G,ee),void 0,ee)}$providePasteEdits(D,U,H,G,ee,de){return this.s(D,P,ye=>ye.providePasteEdits(U,n.URI.revive(H),G,ee,de),void 0,de)}static w(D){return{pattern:D.source,flags:(0,S.regExpFlags)(D)}}static y(D){return{decreaseIndentPattern:ae.w(D.decreaseIndentPattern),increaseIndentPattern:ae.w(D.increaseIndentPattern),indentNextLinePattern:D.indentNextLinePattern?ae.w(D.indentNextLinePattern):void 0,unIndentedLinePattern:D.unIndentedLinePattern?ae.w(D.unIndentedLinePattern):void 0}}static B(D){return{beforeText:ae.w(D.beforeText),afterText:D.afterText?ae.w(D.afterText):void 0,previousLineText:D.previousLineText?ae.w(D.previousLineText):void 0,action:D.action}}static C(D){return D.map(ae.B)}setLanguageConfiguration(D,U,H){const{wordPattern:G}=H;if(G&&(0,S.regExpLeadsToEndlessLoop)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(U,G):this.h.setWordDefinitionFor(U,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",D,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",D,"Do not use.");const ee=this.q(),de={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ae.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ae.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ae.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(ee,U,de),this.p(ee)}$setWordDefinitions(D){for(const U of D)this.h.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.ExtHostLanguageFeatures=ae,ae.d=0}),define(De[211],Ce([1,0,4,8,6,29,15,7]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(O,I,f,v){this.c=I,this.d=f,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,I){await this.a.$changeLanguage(O,I);const f=this.c.getDocumentData(O);if(!f)throw new Error(`document '${O.toString()}' NOT found`);return f.document}async tokenAtPosition(O,I){const f=O.version,v=T.Position.from(I),h=await this.a.$tokensAtPosition(O.uri,v),i={type:y.StandardTokenType.Other,range:O.getWordRangeAtPosition(I)??new y.Range(I.line,I.character,I.line,I.character)};if(!h)return i;const o={range:T.Range.to(h.range),type:T.TokenType.to(h.type)};return!o.range.contains(I)||f!==O.version?i:o}createLanguageStatusItem(O,I,f){const v=this.f++,h=this.a,i=this.g,o=`${O.identifier.value}/${I}`;if(i.has(o))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);i.add(o);const l={selector:f,id:I,name:O.displayName??O.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let E;const b=new R.DisposableStore,p=()=>{E?.dispose(),E=(0,C.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(v,{id:o,name:l.name??O.displayName??O.name,source:O.displayName??O.name,selector:T.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===y.LanguageStatusSeverity.Error?N.default.Error:l.severity===y.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:l.command&&this.d.toInternal(l.command,b),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},w={dispose(){b.dispose(),E?.dispose(),h.$removeLanguageStatus(v),i.delete(o)},get id(){return l.id},get name(){return l.name},set name(s){l.name=s,p()},get selector(){return l.selector},set selector(s){l.selector=s,p()},get text(){return l.text},set text(s){l.text=s,p()},get detail(){return l.detail},set detail(s){l.detail=s,p()},get severity(){return l.severity},set severity(s){l.severity=s,p()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(s){l.accessibilityInformation=s,p()},get command(){return l.command},set command(s){l.command=s,p()},get busy(){return l.busy},set busy(s){l.busy=s,p()}};return p(),w}}e.ExtHostLanguages=S}),define(De[73],Ce([1,0,21,10,2,3,12,4,27,14]),function(te,e,n,T,y,N,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(f,v,h){this.f=h,this.d=new Map,this.a=v.getProxy(R.MainContext.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(f,v){const{message:h,args:i,comment:o}=v;if(this.c)return(0,T.format2)(h,i??{});let l=h;o&&o.length>0&&(l+=`/${Array.isArray(o)?o.join():o}`);const E=this.d.get(f)?.contents[l];return E||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,T.format2)(E??h,i??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let v;const h=await this.g(f);if(!h){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const i=await this.a.$fetchBundleContents(h),o=JSON.parse(i);v=f.isBuiltin?o.contents?.bundle:o}catch(i){this.f.error(`Failed to load translations for ${f.identifier.value} from ${h}: ${i.message}`);return}v&&this.d.set(f.identifier.value,{contents:v,uri:h})}async g(f){if(f.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(f.identifier.value);return y.URI.revive(v)}return f.l10n?y.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=Ve([je(0,S.IExtHostInitDataService),je(1,k.IExtHostRpcService),je(2,C.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,N.createDecorator)("IExtHostLocalizationService")}),define(De[212],Ce([1,0,12,4,27,14,2,5,9]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends n.AbstractLoggerService{constructor(f,v){super(v.logLevel,R.Event.None),this.g=f.getProxy(T.MainContext.MainThreadLogger)}$setLevel(f,v){v?this.setLevel(C.URI.revive(v),f):(0,S.isUndefined)(f)||this.setLevel(f)}f(f,v,h){return new O(this.g,f,v,h)}};k=Ve([je(0,N.IExtHostRpcService),je(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class O extends n.AbstractMessageLogger{constructor(f,v,h,i){super(i?.always),this.l=f,this.m=v,this.j=!1,this.k=[],this.setLevel(h),this.l.$createLogger(v,i).then(()=>{this.p(this.k),this.j=!0})}f(f,v){const h=[[f,v]];this.j?this.p(h):this.k.push(...h)}p(f){this.l.$log(this.m,f)}}}),define(De[213],Ce([1,0,4,12,25]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(R){return R&&R.title}let C=class{constructor(S,k){this.b=k,this.a=S.getProxy(n.MainContext.MainThreadMessageService)}showMessage(S,k,O,I,f){const v={source:{identifier:S.identifier,label:S.displayName||S.name}};let h;typeof I=="string"||N(I)?h=[I,...f]:(v.modal=I?.modal,v.useCustom=I?.useCustom,v.detail=I?.detail,h=f),v.useCustom&&(0,y.checkProposedApiEnabled)(S,"resolvers");const i=[];for(let o=0;o<h.length;o++){const l=h[o];if(typeof l=="string")i.push({title:l,handle:o,isCloseAffordance:!1});else if(typeof l=="object"){const{title:E,isCloseAffordance:b}=l;i.push({title:E,isCloseAffordance:!!b,handle:o})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(k,O,v,i).then(o=>{if(typeof o=="number")return h[o]})}};C=Ve([je(1,T.ILogService)],C),e.ExtHostMessageService=C}),define(De[214],Ce([1,0,24,5,7,28,10,9,2,50,4,38,8,6,43,186,96]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,p,w,s){this.q=w,this.r=s,this.f=new Map,this.g=new N.ResourceMap,this.h=new Map,this.j=new T.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new T.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new T.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(O.MainContext.MainThreadNotebook),this.c=b.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const a=r.notebookEditor?.notebookUri,d=r.cell.handle,u=this.g.get(a)?.getCell(d);if(u)return u.apiCell}if(r&&r.$mid===14){const a=r.uri,d=this.g.get(a);if(d)return d.apiNotebook}return r}}),l.x(p)}getEditorById(b){const p=this.h.get(b);if(!p)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(b){for(const[p,w]of this.h)if(w.apiEditor===b)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,p){const w=this.g.get(b);if(!w&&!p)throw new Error(`NO notebook document for '${b}'`);return w}static s(b,p){if(!p)return;const w=p.filenamePattern.map(s=>f.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(p.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:p.displayName,filenamePattern:w,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,p,w){const s=l.a++,r=typeof w.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(s,w),this.b.$registerNotebookCellStatusBarItemProvider(s,r,p);let a;return r!==void 0&&(a=w.onDidChangeCellStatusBarItems(d=>this.b.$emitCellStatusBarEvent(r))),new v.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,r),a?.dispose()})}async createNotebookDocument(b){const p=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&f.NotebookData.from(b.content)});return S.URI.revive(p)}async openNotebookDocument(b){const p=this.g.get(b);if(p)return p.apiNotebook;const w=await this.c.$tryOpenNotebook(b),s=this.g.get(S.URI.revive(w));return(0,R.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(b,p){S.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let w;typeof p=="object"?w={position:f.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(f.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:w={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,w),r=s&&this.h.get(s)?.apiEditor;if(r)return r;throw s?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,p,w,s){const r=this.f.get(b),a=S.URI.revive(p),d=this.g.get(a);if(!d||!r)return;const c=d.getCellFromIndex(w);if(!c)return;const u=await r.provideCellStatusBarItems(c.apiCell,s);if(!u)return;const t=new y.DisposableStore,m=this.p.add([t]),A=(Array.isArray(u)?u:[u]).map(L=>f.NotebookStatusBarItem.from(L,this.i,t));return{cacheId:m,items:A}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,p,w,s,r){if((0,C.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,w),this.b.$registerNotebookSerializer(a,{id:b.identifier,location:b.extensionLocation},p,f.NotebookDocumentContentOptions.from(s),l.s(b,r)),(0,y.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(b,p,w){const s=this.u.get(b);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(p.buffer,w);return new h.SerializableObjectWithBuffers(f.NotebookData.from(r))}async $notebookToData(b,p,w){const s=this.u.get(b);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(f.NotebookData.to(p.value),w);return n.VSBuffer.wrap(r)}w(b,p,w){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const s=new o.ExtHostNotebookEditor(p,this.d,b,w.visibleRanges.map(f.NotebookRange.to),w.selections.map(f.NotebookRange.to),typeof w.viewColumn=="number"?f.ViewColumn.to(w.viewColumn):void 0);this.h.set(p,s)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const w of b.value.removedDocuments){const s=S.URI.revive(w),r=this.g.get(s);r&&(r.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(r.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===s.toString()&&this.h.delete(a.id)}if(b.value.addedDocuments){const w=[];for(const s of b.value.addedDocuments){const r=S.URI.revive(s.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const a=new i.ExtHostNotebookDocument(this.c,this.q,this.r,r,s);w.push(...s.cells.map(d=>i.ExtHostCell.asModelAddData(a.apiNotebook,d))),this.g.get(r)?.dispose(),this.g.set(r,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(a.apiNotebook)}}if(b.value.addedEditors)for(const w of b.value.addedEditors){if(this.h.has(w.id))return;const s=S.URI.revive(w.documentUri),r=this.g.get(s);r&&this.w(r,w.id,w)}const p=[];if(b.value.removedEditors)for(const w of b.value.removedEditors){const s=this.h.get(w);s&&(this.h.delete(w),this.k?.id===s.id&&(this.k=void 0),p.push(s))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const w=new Set;this.l.forEach(s=>w.add(s.id));for(const s of this.h.values()){const r=w.has(s.id);s._acceptVisibility(r)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const p=I.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new I.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new I.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>n.VSBuffer.wrap(r))],new I.ApiCommandResult("Notebook Data",r=>f.NotebookData.to(r.value))),s=new I.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new I.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new h.SerializableObjectWithBuffers(f.NotebookData.from(r)))],new I.ApiCommandResult("Bytes",r=>r.buffer));b.registerApiCommand(w),b.registerApiCommand(s)}}e.ExtHostNotebookController=l,l.a=0}),define(De[215],Ce([1,0,16,15,20,5,7,28,2,26,12,50,4,38,8,6,68,173,25,43]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let p=class{constructor(c,u,t,m,g){this.k=u,this.l=t,this.m=m,this.n=g,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new I.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(f.MainContext.MainThreadNotebookKernels);const A=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const K=this.l.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:K}}else if(L&&"notebookEditor"in L){const K=this.l.getIdByEditor(L.notebookEditor);if(K===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:K}}return L})],v.ApiCommandResult.Void);this.m.registerApiCommand(A)}createNotebookController(c,u,t,m,g,A){for(const le of this.h.values())if(le.controller.id===u&&k.ExtensionIdentifier.equals(c.identifier,le.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const L=this.i++,K=this;this.n.trace(`NotebookController[${L}], CREATED by ${c.identifier.value}, ${u}`);const q=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${c.identifier}'`);let j=!1;const P=new C.DisposableStore,M=new N.Emitter,F=new N.Emitter,$={id:a(c.identifier,u),notebookType:t,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:m||c.identifier.value,preloads:A?A.map(h.NotebookRendererScript.from):[]};let z=g??q,V;this.a.$addKernel(L,$).catch(le=>{console.log(le),j=!0});let X=0;const Z=()=>{if(j)return;const le=++X;Promise.resolve().then(()=>{le===X&&this.a.$updateKernel(L,$)})},fe=new R.ResourceMap,oe={get id(){return u},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return $.label},set label(le){$.label=le??c.displayName??c.name,Z()},get detail(){return $.detail??""},set detail(le){$.detail=le,Z()},get description(){return $.description??""},set description(le){$.description=le,Z()},get kind(){return(0,E.checkProposedApiEnabled)(c,"notebookControllerKind"),$.kind??""},set kind(le){(0,E.checkProposedApiEnabled)(c,"notebookControllerKind"),$.kind=le,Z()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(le){$.supportedLanguages=le,Z()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(le){$.supportsExecutionOrder=le,Z()},get rendererScripts(){return $.preloads?$.preloads.map(h.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(le){z=le??q},get interruptHandler(){return V},set interruptHandler(le){V=le,$.supportsInterrupt=Boolean(le),Z()},createNotebookCellExecution(le){if(j)throw new Error("notebook controller is DISPOSED");if(!fe.has(le.notebook.uri))throw K.n.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(fe.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return K._createNotebookCellExecution(le,a(c.identifier,this.id))},dispose:()=>{j||(this.n.trace(`NotebookController[${L}], DISPOSED`),j=!0,this.h.delete(L),P.dispose(),M.dispose(),F.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(le,ce){ce===i.NotebookControllerAffinity2.Hidden&&(0,E.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),K.a.$updateNotebookPriority(L,le.uri,ce)},onDidReceiveMessage:F.event,postMessage(le,ce){return(0,E.checkProposedApiEnabled)(c,"notebookMessaging"),K.a.$postMessage(L,ce&&K.l.getIdByEditor(ce),le)},asWebviewUri(le){return(0,E.checkProposedApiEnabled)(c,"notebookMessaging"),(0,o.asWebviewUri)(le,K.k.remote)}};return this.h.set(L,{extensionId:c.identifier,controller:oe,onDidReceiveMessage:F,onDidChangeSelection:M,associatedNotebooks:fe}),oe}getIdByController(c){for(const[u,t]of this.h)if(t.controller===c)return a(t.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,u){const t=this.d++,m=this;this.n.trace(`NotebookControllerDetectionTask[${t}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(t,u);const g={dispose:()=>{this.c.delete(t),m.a.$removeKernelDetectionTask(t)}};return this.c.set(t,g),g}registerKernelSourceActionProvider(c,u,t){const m=this.f++,g=this;return this.e.set(m,t),this.n.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(m,u),{dispose:()=>{this.e.delete(m),g.a.$removeKernelSourceActionProvider(m)}}}async $provideKernelSourceActions(c,u){const t=this.e.get(c);if(t){const m=new C.DisposableStore;return this.g.add([m]),(await t.provideNotebookKernelSourceActions(u)??[]).map(A=>h.NotebookKernelSourceAction.from(A,this.m.converter,m))}return[]}$acceptNotebookAssociation(c,u,t){const m=this.h.get(c);if(m){const g=this.l.getNotebookDocument(S.URI.revive(u));t?m.associatedNotebooks.set(g.uri,!0):m.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,g.uri.toString(),t),m.onDidChangeSelection.fire({selected:t,notebook:g.apiNotebook})}}async $executeCells(c,u,t){const m=this.h.get(c);if(!m)return;const g=this.l.getNotebookDocument(S.URI.revive(u)),A=[];for(const L of t){const K=g.getCell(L);K&&A.push(K.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,g.uri.toString(),A.length),await m.controller.executeHandler.call(m.controller,A,g.apiNotebook,m.controller)}catch(L){this.n.error(`NotebookController[${c}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(c,u,t){const m=this.h.get(c);if(!m)return;const g=this.l.getNotebookDocument(S.URI.revive(u));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,g.apiNotebook);else for(const A of t){const L=g.getCell(A);L&&this.b.get(L.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,u,t){const m=this.h.get(c);if(!m)return;const g=this.l.getEditorById(u);m.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:t}))}$cellExecutionChanged(c,u,t){const g=this.l.getNotebookDocument(S.URI.revive(c)).getCell(u);if(g){const A=t?h.NotebookCellExecutionState.to(t):i.NotebookCellExecutionState.Idle;A!==void 0&&this.j.fire({cell:g.apiCell,state:A})}}_createNotebookCellExecution(c,u){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const g=new s(u,m,this.a);this.b.set(m.uri,g);const A=g.onDidChangeState(()=>{g.state===w.Resolved&&(g.dispose(),A.dispose(),this.b.delete(m.uri))});return g.asApiObject()}};p=Ve([je(4,O.ILogService)],p),e.ExtHostNotebookKernels=p;var w;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(w||(w={}));class s extends C.Disposable{get state(){return this.f}constructor(c,u,t){super(),this.j=u,this.k=t,this.b=s.a++,this.c=new N.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new y.CancellationTokenSource),this.h=new r(10,m=>this.m(m)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const u=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(u))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let u=this.j;if(c&&(u=this.j.notebook.getCellFromApiCell(c)),!u)throw new Error("INVALID cell");return u.handle}s(c){return c.map(u=>{const t=i.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return t===u.items?h.NotebookCellOutput.from(u):h.NotebookCellOutput.from({items:t,id:u.id,metadata:u.metadata})})}async t(c,u,t){const m=this.r(u),g=this.s((0,n.asArray)(c));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:m,append:t,outputs:g})}async w(c,u,t){return c=i.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(c),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:c.map(h.NotebookCellOutputItem.from),outputId:u.id,append:t})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(t){c.i=t,c.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(t){if(c.f===w.Resolved||c.f===w.Started)throw new Error("Cannot call start again");c.f=w.Started,c.c.fire(),c.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,m){if(c.f===w.Resolved)throw new Error("Cannot call resolve twice");c.f=w.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new b.SerializableObjectWithBuffers({runEndTime:m,lastRunSuccess:t}))},clearOutput(t){return c.n(),c.t([],t,!1)},appendOutput(t,m){return c.n(),c.t(t,m,!0)},replaceOutput(t,m){return c.n(),c.t(t,m,!1)},appendOutputItems(t,m){return c.n(),c.w(t,m,!0)},replaceOutputItems(t,m){return c.n(),c.w(t,m,!1)}})}}s.a=0;class r{constructor(c,u){this.d=c,this.e=u,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new T.DeferredPromise,this.b=Date.now(),(0,T.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const u=this.a;return this.a=[],this.e(u).finally(()=>c.complete())}}function a(d,c){return`${d.value}/${c}`}e.createKernelId=a}),define(De[216],Ce([1,0,5,4,96]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class N{constructor(R,S){this.c=S,this.a=new Map,this.b=R.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,S,k){const O=this.c.getEditorById(R);this.a.get(S)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(R,S){if(!R.contributes?.notebookRenderer?.some(O=>O.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(O,I,f)=>this.d(S).event(O,I,f),postMessage:(O,I)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,I]=[I,O]);const f=I&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.b.$postMessage(f?.id,S,O)}}}d(R){let S=this.a.get(R);return S||(S=new n.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(R)}}),this.a.set(R,S),S)}}e.ExtHostNotebookRenderers=N}),define(De[217],Ce([1,0,7,2,25,4]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class C{constructor(S){this.b=new Map,this.a=S.getProxy(N.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,k,O){if((0,y.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.b.set(k,O),this.a.$registerProfileContentHandler(k,O.name,S.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(k),this.a.$unregisterProfileContentHandler(k)})}async $saveProfile(S,k,O,I){const f=this.b.get(S);if(!f)throw new Error(`Unknown handler with id: ${S}`);return f.saveProfile(k,O,I)}async $readProfile(S,k,O){const I=this.b.get(S);if(!I)throw new Error(`Unknown handler with id: ${S}`);return I.readProfile(T.URI.revive(k),O)}}e.ExtHostProfileContentHandlers=C}),define(De[218],Ce([1,0,20,5,7,4,2,6,11,16,29,64]),function(te,e,n,T,y,N,C,R,S,k,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(v,h,i){const o=v.getProxy(N.MainContext.MainThreadQuickOpen);class l{constructor(c,u){this.e=new Map,this.f=0,this.a=c,this.b=u}showQuickPick(c,u,t=n.CancellationToken.None){this.c=void 0;const m=Promise.resolve(c),g=++this.f,A=o.$show(g,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},t),L={},K=A.then(()=>L);return Promise.race([K,m]).then(q=>{if(q!==L)return m.then(j=>{const P=[];for(let M=0;M<j.length;M++){const F=j[M];typeof F=="string"?P.push({label:F,handle:M}):F.kind===R.QuickPickItemKind.Separator?P.push({type:"separator",label:F.label}):P.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:M})}return u&&typeof u.onDidSelectItem=="function"&&(this.c=M=>{u.onDidSelectItem(j[M])}),o.$setItems(g,P),A.then(M=>{if(typeof M=="number")return j[M];if(Array.isArray(M))return M.map(F=>j[F])})})}).then(void 0,q=>{if(!(0,S.isCancellationError)(q))return o.$setError(g,q),Promise.reject(q)})}$onItemSelected(c){this.c?.(c)}showInput(c,u=n.CancellationToken.None){return this.d=c?.validateInput,o.$input(c,typeof this.d=="function",u).then(void 0,t=>{if(!(0,S.isCancellationError)(t))return Promise.reject(t)})}async $validateInput(c){if(!this.d)return;const u=await this.d(c);if(!u||typeof u=="string")return u;let t;switch(u.severity){case R.InputBoxValidationSeverity.Info:t=O.default.Info;break;case R.InputBoxValidationSeverity.Warning:t=O.default.Warning;break;case R.InputBoxValidationSeverity.Error:t=O.default.Error;break;default:t=u.message?O.default.Error:O.default.Ignore;break}return{content:u.message,severity:t}}async showWorkspaceFolderPick(c,u=n.CancellationToken.None){const t=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!t)return;const m=await this.a.getWorkspaceFolders2();if(!!m)return m.find(g=>g.uri.toString()===t.uri.toString())}createQuickPick(c){const u=new r(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(c){const u=new a(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(c,u){this.e.get(c)?._fireDidChangeValue(u)}$onDidAccept(c){this.e.get(c)?._fireDidAccept()}$onDidChangeActive(c,u){const t=this.e.get(c);t instanceof r&&t._fireDidChangeActive(u)}$onDidChangeSelection(c,u){const t=this.e.get(c);t instanceof r&&t._fireDidChangeSelection(u)}$onDidTriggerButton(c,u){this.e.get(c)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(c,u,t){const m=this.e.get(c);m instanceof r&&m._fireDidTriggerItemButton(u,t)}$onDidHide(c){this.e.get(c)?._fireDidHide()}}class E{constructor(c,u){this.x=c,this.y=u,this._id=r.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.Emitter,this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(c){this.b=c,this.A({title:c})}get step(){return this.c}set step(c){this.c=c,this.A({step:c})}get totalSteps(){return this.d}set totalSteps(c){this.d=c,this.A({totalSteps:c})}get enabled(){return this.g}set enabled(c){this.g=c,this.A({enabled:c})}get busy(){return this.j}set busy(c){this.j=c,this.A({busy:c})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(c){this.k=c,this.A({ignoreFocusOut:c})}get value(){return this.l}set value(c){this.l=c,this.A({value:c})}get placeholder(){return this.m}set placeholder(c){this.m=c,this.A({placeholder:c})}get buttons(){return this.n}set buttons(c){this.n=c.slice(),this.o.clear(),c.forEach((u,t)=>{const m=u===R.QuickInputButtons.Back?-1:t;this.o.set(m,u)}),this.A({buttons:c.map((u,t)=>({...s(u),tooltip:u.tooltip,handle:u===R.QuickInputButtons.Back?-1:t}))})}show(){this.e=!0,this.f=!0,this.A({visible:!0})}hide(){this.e=!1,this.A({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(c){this.l=c,this.q.fire(c)}_fireDidTriggerButton(c){const u=this.o.get(c);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,y.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),o.$dispose(this._id))}A(c){if(!this.v){for(const u of Object.keys(c)){const t=c[u];this.u[u]=t===void 0?null:t}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.B()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.B()},0))}}B(){o.$createOrUpdate(this.u),this.u={id:this._id}}}E.a=1;function b(d){if(d instanceof R.ThemeIcon)return{id:d.id};const c=w(d),u=p(d);return{dark:typeof c=="string"?C.URI.file(c):c,light:typeof u=="string"?C.URI.file(u):u}}function p(d){return typeof d=="object"&&"light"in d?d.light:d}function w(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const c=b(d.iconPath);let u,t;return"id"in c?t=I.ThemeIcon.asClassName(c):u=c,{iconPath:u,iconClass:t}}class r extends E{constructor(c,u){super(c.identifier,u),this.C=[],this.D=new Map,this.E=new Map,this.F=!1,this.G=!0,this.H=!0,this.I=!0,this.J=!1,this.K=[],this.L=new T.Emitter,this.M=[],this.N=new T.Emitter,this.O=new T.Emitter,this.onDidChangeActive=this.L.event,this.onDidChangeSelection=this.N.event,this.onDidTriggerItemButton=this.O.event,this.w.push(this.L,this.N,this.O),this.A({type:"quickPick"})}get items(){return this.C}set items(c){this.C=c.slice(),this.D.clear(),this.E.clear(),c.forEach((t,m)=>{this.D.set(m,t),this.E.set(t,m)});const u=[];for(let t=0;t<c.length;t++){const m=c[t];m.kind===R.QuickPickItemKind.Separator?u.push({type:"separator",label:m.label}):u.push({handle:t,label:m.label,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons?.map((g,A)=>({...s(g),tooltip:g.tooltip,handle:A}))})}this.A({items:u})}get canSelectMany(){return this.F}set canSelectMany(c){this.F=c,this.A({canSelectMany:c})}get matchOnDescription(){return this.G}set matchOnDescription(c){this.G=c,this.A({matchOnDescription:c})}get matchOnDetail(){return this.H}set matchOnDetail(c){this.H=c,this.A({matchOnDetail:c})}get sortByLabel(){return this.I}set sortByLabel(c){this.I=c,this.A({sortByLabel:c})}get keepScrollPosition(){return this.J}set keepScrollPosition(c){this.J=c,this.A({keepScrollPosition:c})}get activeItems(){return this.K}set activeItems(c){this.K=c.filter(u=>this.E.has(u)),this.A({activeItems:this.K.map(u=>this.E.get(u))})}get selectedItems(){return this.M}set selectedItems(c){this.M=c.filter(u=>this.E.has(u)),this.A({selectedItems:this.M.map(u=>this.E.get(u))})}_fireDidChangeActive(c){const u=(0,k.coalesce)(c.map(t=>this.D.get(t)));this.K=u,this.L.fire(u)}_fireDidChangeSelection(c){const u=(0,k.coalesce)(c.map(t=>this.D.get(t)));this.M=u,this.N.fire(u)}_fireDidTriggerItemButton(c,u){const t=this.D.get(c);if(!t||!t.buttons||!t.buttons.length)return;const m=t.buttons[u];m&&this.O.fire({button:m,item:t})}}class a extends E{constructor(c,u){super(c.identifier,u),this.C=!1,this.A({type:"inputBox"})}get password(){return this.C}set password(c){this.C=c,this.A({password:c})}get prompt(){return this.D}set prompt(c){this.D=c,this.A({prompt:c})}get valueSelection(){return this.E}set valueSelection(c){this.E=c,this.A({valueSelection:c})}get validationMessage(){return this.F}set validationMessage(c){this.F=c,c?typeof c=="string"?this.A({validationMessage:c,severity:O.default.Error}):this.A({validationMessage:c.message,severity:c.severity??O.default.Error}):this.A({validationMessage:void 0,severity:O.default.Ignore})}}return new l(h,i)}e.createExtHostQuickOpen=f});var Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n};define(De[219],Ce([1,0,2,5,59,7,15,4,16,120,12,26,64,8,25]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(m){if(m)return typeof m.iconPath=="string"?n.URI.file(m.iconPath):n.URI.isUri(m.iconPath)||f.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function E(m,g){if(!m.iconPath&&!g.iconPath)return 0;if(m.iconPath){if(!g.iconPath)return 1}else return-1;const A=typeof m.iconPath=="string"?m.iconPath:n.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,L=typeof g.iconPath=="string"?g.iconPath:n.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,k.comparePaths)(A,L)}function b(m,g){let A=0;if(m.strikeThrough!==g.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==g.faded)return m.faded?1:-1;if(m.tooltip!==g.tooltip)return(m.tooltip||"").localeCompare(g.tooltip||"");if(A=E(m,g),A!==0)return A;if(m.light&&g.light)A=E(m.light,g.light);else{if(m.light)return 1;if(g.light)return-1}if(A!==0)return A;if(m.dark&&g.dark)A=E(m.dark,g.dark);else{if(m.dark)return 1;if(g.dark)return-1}return A}function p(m,g){if(m.command!==g.command)return m.command<g.command?-1:1;if(m.title!==g.title)return m.title<g.title?-1:1;if(m.tooltip!==g.tooltip){if(m.tooltip!==void 0&&g.tooltip!==void 0)return m.tooltip<g.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(m.arguments===g.arguments)return 0;if(m.arguments)if(g.arguments){if(m.arguments.length!==g.arguments.length)return m.arguments.length-g.arguments.length}else return 1;else return-1;for(let A=0;A<m.arguments.length;A++){const L=m.arguments[A],K=g.arguments[A];if(L!==K)return L<K?-1:1}return 0}function w(m,g){let A=(0,k.comparePaths)(m.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(A!==0)return A;if(m.command&&g.command)A=p(m.command,g.command);else{if(m.command)return 1;if(g.command)return-1}if(A!==0)return A;if(m.decorations&&g.decorations)A=b(m.decorations,g.decorations);else{if(m.decorations)return 1;if(g.decorations)return-1}return A}function s(m,g){for(let A=0;A<m.length;A++)if(m[A]!==g[A])return!1;return!0}function r(m,g){return m.command===g.command&&m.title===g.title&&m.tooltip===g.tooltip&&(m.arguments&&g.arguments?s(m.arguments,g.arguments):m.arguments===g.arguments)}function a(m,g){return(0,S.equals)(m,g,r)}class d{get value(){return this.d}set value(g){g=g??"",Re(this,i,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Re(this,i,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,h.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,h.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Re(this,i,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Re(this,i,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Re(this,i,"f").$setInputBoxVisibility(this.l,g))}constructor(g,A,L){this.k=g,this.l=L,i.set(this,void 0),this.d="",this.e=new T.Emitter,this.f="",this.h=!0,this.j=!0,Ye(this,i,A,"f")}showValidationMessage(g,A){(0,h.checkProposedApiEnabled)(this.k,"scmValidation"),Re(this,i,"f").$showValidationMessage(this.l,g,A)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=d,i=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,A,L,K,q){this.q=g,this.s=A,this.t=L,this.u=K,this.v=q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,A){const L=this.h.get(g);return L?(0,C.asPromise)(()=>this.s.executeCommand(L.command,...L.arguments||[],A)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(w),L=(0,S.sortedDiff)(this.o,g,w).map(j=>{const P=j.toInsert.map(M=>{const F=this.e++;this.g.set(F,M);const $=M.resourceUri;let z;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const pe=new N.DisposableStore;z=this.s.converter.toInternal(M.command,pe),this.j.set(F,pe)}else this.h.set(F,M.command);const V=l(M.decorations),X=M.decorations&&l(M.decorations.light)||V,Z=M.decorations&&l(M.decorations.dark)||V,fe=[X,Z],oe=M.decorations&&M.decorations.tooltip||"",le=M.decorations&&!!M.decorations.strikeThrough,ce=M.decorations&&!!M.decorations.faded,me=M.contextValue||"";return{rawResource:[F,$,fe,oe,le,ce,me,z],handle:F}});return{start:j.start,deleteCount:j.deleteCount,toInsert:P}}),K=L.map(({start:j,deleteCount:P,toInsert:M})=>[j,P,M.map(F=>F.rawResource)]),q=L.reverse();for(const{start:j,deleteCount:P,toInsert:M}of q){const F=M.map(z=>z.handle),$=this.n.splice(j,P,...F);for(const z of $)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=g,K}dispose(){this.l=!0,this.m.fire()}}c.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Re(this,o,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Re(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Re(this,o,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new N.DisposableStore,this.l=g;const A=this.v.converter.toInternal(g,this.k.value);Re(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:A})}get actionButton(){return(0,h.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,h.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new N.DisposableStore,this.n=g;const A=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(L=>L.map(K=>this.v.converter.toInternal(K,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Re(this,o,"f").$updateSourceControl(this.t,{actionButton:A??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&a(this.p,g))return;this.o.value=new N.DisposableStore,this.p=g;const A=(g||[]).map(L=>this.v.converter.toInternal(L,this.o.value));Re(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:A})}get selected(){return this.q}constructor(g,A,L,K,q,j){this.u=g,this.v=L,this.w=K,this.x=q,this.y=j,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new N.MutableDisposable,this.l=void 0,this.m=new N.MutableDisposable,this.o=new N.MutableDisposable,this.p=void 0,this.q=!1,this.s=new T.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.A=new Map,this.B=new Set,Ye(this,o,A,"f"),this.f=new d(g,Re(this,o,"f"),this.t),Re(this,o,"f").$registerSourceControl(this.t,K,q,j)}createResourceGroup(g,A){const L=new c(Re(this,o,"f"),this.v,this.t,g,A),K=T.Event.once(L.onDidDispose)(()=>this.A.delete(L));return this.A.set(L,K),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const g=[],A=[];for(const[L,K]of this.A){K.dispose();const q=L.onDidUpdateResourceStates(()=>{this.B.add(L),this.eventuallyUpdateResourceStates()});T.Event.once(L.onDidDispose)(()=>{this.B.delete(L),q.dispose(),this.e.delete(L.handle),Re(this,o,"f").$unregisterGroup(this.t,L.handle)}),g.push([L.handle,L.id,L.label,L.features]);const j=L._takeResourceStateSnapshot();j.length>0&&A.push([L.handle,j]),this.e.set(L.handle,L)}Re(this,o,"f").$registerGroups(this.t,g,A),this.A.clear()}eventuallyUpdateResourceStates(){const g=[];this.B.forEach(A=>{const L=A._takeResourceStateSnapshot();L.length!==0&&g.push([A.handle,L])}),g.length>0&&Re(this,o,"f").$spliceResourceStates(this.t,g),this.B.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Re(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,u.d=0,Ve([(0,y.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),Ve([(0,y.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let t=class tn{get onDidChangeActiveProvider(){return this.j.event}constructor(g,A,L){this.l=A,this.m=L,this.g=new Map,this.h=new Map,this.j=new T.Emitter,this.e=g.getProxy(R.MainContext.MainThreadSCM),this.f=g.getProxy(R.MainContext.MainThreadTelemetry),A.registerArgumentProcessor({processArgument:K=>{if(K&&K.$mid===3){const q=this.g.get(K.sourceControlHandle);if(!q)return K;const j=q.getResourceGroup(K.groupHandle);return j?j.getResourceState(K.handle):K}else if(K&&K.$mid===4){const q=this.g.get(K.sourceControlHandle);return q?q.getResourceGroup(K.groupHandle):K}else if(K&&K.$mid===5){const q=this.g.get(K.handle);return q||K}return K}})}createSourceControl(g,A,L,K){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,A,L,K),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const q=tn.d++,j=new u(g,this.e,this.l,A,L,K);this.g.set(q,j);const P=this.h.get(I.ExtensionIdentifier.toKey(g.identifier))||[];return P.push(j),this.h.set(I.ExtensionIdentifier.toKey(g.identifier),P),j}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const A=this.h.get(I.ExtensionIdentifier.toKey(g.identifier)),L=A&&A[A.length-1];return L&&L.inputBox}$provideOriginalResource(g,A,L){const K=n.URI.revive(A);this.m.trace("ExtHostSCM#$provideOriginalResource",g,K.toString());const q=this.g.get(g);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>q.quickDiffProvider.provideOriginalResource(K,L)).then(j=>j||null)}$onInputBoxValueChange(g,A){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const L=this.g.get(g);return L&&L.inputBox.$onInputBoxValueChange(A),Promise.resolve(void 0)}$executeResourceCommand(g,A,L,K){this.m.trace("ExtHostSCM#$executeResourceCommand",g,A,L);const q=this.g.get(g);if(!q)return Promise.resolve(void 0);const j=q.getResourceGroup(A);return j?j.$executeResourceCommand(L,K):Promise.resolve(void 0)}$validateInput(g,A,L){this.m.trace("ExtHostSCM#$validateInput",g);const K=this.g.get(g);return!K||!K.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>K.inputBox.validateInput(A,L)).then(q=>{if(!q)return Promise.resolve(void 0);const j=v.MarkdownString.fromStrict(q.message);return j?Promise.resolve([j,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};t.d=0,t=Ve([je(2,O.ILogService)],t),e.ExtHostSCM=t}),define(De[74],Ce([1,0,4,5,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(R){this.b=new T.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,S){return this.a.$getPassword(R,S)}store(R,S,k){return this.a.$setPassword(R,S,k)}delete(R,S){return this.a.$deletePassword(R,S)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(De[220],Ce([1,0,6,4,135,7,8,9]),function(te,e,n,T,y,N,C,R){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(h,i,o,l,E=n.StatusBarAlignment.Left,b){S.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new N.DisposableStore,Ye(this,S,h,"f"),Ye(this,k,i,"f"),this.c=O.a++,this.e=o,this.f=l,this.g=E,this.h=this.t(b)}t(h){if(!!(0,R.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(h){this.k=h,this.u()}set name(h){this.m=h,this.u()}set tooltip(h){this.l=h,this.u()}set color(h){this.n=h,this.u()}set backgroundColor(h){h&&!O.b.has(h.id)&&(h=void 0),this.o=h,this.u()}set command(h){this.q?.fromApi!==h&&(this.p.clear(),typeof h=="string"?this.q={fromApi:h,internal:Re(this,k,"f").toInternal({title:"",command:h},this.p)}:h?this.q={fromApi:h,internal:Re(this,k,"f").toInternal(h,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(h){this.s=h,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Re(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let h;this.e?this.f?h=`${this.e.identifier.value}.${this.f}`:h=this.e.identifier.value:h=this.f;let i;this.m?i=this.m:i=(0,y.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=O.b.get(this.o.id));const l=C.MarkdownString.fromStrict(this.l);Re(this,S,"f").$setEntry(this.c,h,i,this.k,l,this.q?.internal,o,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=O,S=new WeakMap,k=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(h){this.b=[],this.a=h.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,y.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(h){const i={message:h};return this.b.unshift(i),this.c(),new n.Disposable(()=>{const o=this.b.indexOf(i);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class f{constructor(h,i){this.a=h.getProxy(T.MainContext.MainThreadStatusBar),this.b=i,this.c=new I(this)}createStatusBarEntry(h,i,o,l){return new O(this.a,this.b,h,i,o,l)}setStatusBarMessage(h,i){const o=this.c.setMessage(h);let l;return typeof i=="number"?l=setTimeout(()=>o.dispose(),i):typeof i<"u"&&i.then(()=>o.dispose(),()=>o.dispose()),new n.Disposable(()=>{o.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=f}),define(De[75],Ce([1,0,4,5,3]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(R,S){this.c=S,this.b=new T.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,S){this.a.$registerExtensionStorageKeysToSync(R,S)}async initializeExtensionStorage(R,S,k){const O=await this.a.$initializeExtensionStorage(R,S);let I;return O&&(I=this.d(R,S,O)),I||k}setValue(R,S,k){return this.a.$setValue(R,S,k)}$acceptValue(R,S,k){const O=this.d(R,S,k);O&&this.b.fire({shared:R,key:S,value:O})}d(R,S,k){try{return JSON.parse(k)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${R}): ${O}`)}}}e.ExtHostStorage=N,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(De[76],Ce([1,0,3,27,12,56,2]),function(te,e,n,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let R=class{constructor(k,O,I){this.d=O,this.f=I,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(k){return C.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,O=await this.g(k);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(C.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this.c)return C.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return C.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=Ve([je(0,T.IExtHostInitDataService),je(1,y.ILogService),je(2,N.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(De[57],Ce([1,0,5,4,3,2,14,7,6,136,11,174,20,34,160,64,9,15,8]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class b{constructor(t,m,g,A){this.k=t,this._id=m,this.l=g,this.m=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(K=>this.f=K);const L=this;this.value={get name(){return L.m||""},get processId(){return L.b},get creationOptions(){return L.l},get exitStatus(){return L.h},get state(){return L.j},sendText(K,q=!0){L.o(),L.k.$sendText(L._id,K,q)},show(K){L.o(),L.k.$show(L._id,K)},hide(){L.o(),L.k.$hide(L._id)},dispose(){L.a||(L.a=!0,L.k.$dispose(L._id))},get dimensions(){if(!(L.d===void 0||L.g===void 0))return{columns:L.d,rows:L.g}}}}async create(t,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:t.name,shellPath:(0,o.withNullAsUndefined)(t.shellPath),shellArgs:(0,o.withNullAsUndefined)(t.shellArgs),cwd:(0,o.withNullAsUndefined)(t.cwd),env:(0,o.withNullAsUndefined)(t.env),icon:(0,o.withNullAsUndefined)(d(t.iconPath)),color:i.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,o.withNullAsUndefined)(t.message),strictEnv:(0,o.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(m?.useShellEnvironment),location:m?.location||this.n(t.location,m?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,m,g,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:i.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.n(t,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(t,m){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in t?{viewColumn:E.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus}:void 0:t}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(t){this.m=t}setExitStatus(t,m){this.h=Object.freeze({code:t,reason:m})}setDimensions(t,m){return t===this.d&&m===this.g||t===0||m===0?!1:(this.d=t,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(t){this.f?(this.f(t),this.f=void 0):this.b.then(m=>{m!==t&&(this.b=Promise.resolve(t))})}}e.ExtHostTerminal=b;class p{get onProcessReady(){return this.b.event}constructor(t){this.g=t,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(t){this.g.handleInput?.(t)}resize(t,m){this.g.setDimensions?.({columns:t,rows:m})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(t||void 0),t&&this.g.setDimensions?.(t),this.b.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let w=1,s=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(t=>t.value)}get onDidWriteTerminalData(){return this.J.event}constructor(t,m){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.C=new Map,this.D=new n.Emitter,this.onDidCloseTerminal=this.D.event,this.F=new n.Emitter,this.onDidOpenTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeActiveTerminal=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalDimensions=this.H.event,this.I=new n.Emitter,this.onDidChangeTerminalState=this.I.event,this.L=new n.Emitter,this.onDidChangeShell=this.L.event,this.a=m.getProxy(T.MainContext.MainThreadTerminalService),this.s=new h.TerminalDataBufferer(this.a.$sendProcessData),this.J=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(t),this.B({dispose:()=>{for(const[g,A]of this.g)A.shutdown(!0)}})}getDefaultShell(t){return(t?this.n:this.m)?.path||""}getDefaultShellArgs(t){return(t?this.n:this.m)?.args||[]}createExtensionTerminal(t,m){const g=new b(this.a,(0,v.generateUuid)(),t,t.name),A=new p(t.pty);return g.createExtensionTerminal(t.location,this.M(t,m).resolvedExtHostIdentifier,d(t.iconPath),c(t.color)).then(L=>{const K=this.N(L,A);this.h[L]=K}),this.f.push(g),g.value}M(t,m){if(m=m||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const g=t.location.parentTerminal;if(g){const A=this.f.find(L=>L.value===g);A&&(m.resolvedExtHostIdentifier=A._id)}}else t.location&&typeof t.location!="object"?m.location=t.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(t,m){if(!this.P(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const A=new p(m),L=this.N(t,A);this.h[t]=L}async $acceptActiveTerminalChanged(t){const m=this.b;if(t===null){this.b=void 0,m!==this.b&&this.G.fire(this.b);return}const g=this.P(t);g&&(this.b=g,m!==this.b&&this.G.fire(this.b.value))}async $acceptTerminalProcessData(t,m){const g=this.P(t);g&&this.J.fire({terminal:g.value,data:m})}async $acceptTerminalDimensions(t,m,g){const A=this.P(t);A&&A.setDimensions(m,g)&&this.H.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptTerminalMaximumDimensions(t,m,g){this.g.get(t)?.resize(m,g)}async $acceptTerminalTitleChange(t,m){const g=this.P(t);g&&(g.name=m)}async $acceptTerminalClosed(t,m,g){const A=this.R(this.f,t);if(A!==null){const L=this.f.splice(A,1)[0];L.setExitStatus(m,g),this.D.fire(L.value)}}$acceptTerminalOpened(t,m,g,A){if(m){const q=this.R(this.f,m);if(q!==null){this.f[q]._id=t,this.F.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const L={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:N.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},K=new b(this.a,t,L,g);this.f.push(K),this.F.fire(K.value),K.isOpen=!0}async $acceptTerminalProcessId(t,m){this.P(t)?._setProcessId(m)}async $startExtensionTerminal(t,m){const g=this.P(t);if(!g)return{message:(0,k.localize)(0,null,t)};g.isOpen||await new Promise(L=>{const K=this.onDidOpenTerminal(async q=>{q===g.value&&(K.dispose(),L())})});const A=this.g.get(t);A?A.startSendingEvents(m):this.j[t]={initialDimensions:m}}N(t,m){const g=new R.DisposableStore;g.add(m.onProcessReady(L=>this.a.$sendProcessReady(t,L.pid,L.cwd))),g.add(m.onDidChangeProperty(L=>this.a.$sendProcessProperty(t,L))),this.s.startBuffering(t,m.onProcessData),g.add(m.onProcessExit(L=>this.O(t,L))),this.g.set(t,m);const A=this.j[t];return A&&m instanceof p&&(m.startSendingEvents(A.initialDimensions),delete this.j[t]),g}$acceptProcessAckDataEvent(t,m){this.g.get(t)?.acknowledgeDataEvent(m)}$acceptProcessInput(t,m){this.g.get(t)?.input(m)}$acceptTerminalInteraction(t){const m=this.P(t);m?.setInteractedWith()&&this.I.fire(m.value)}$acceptProcessResize(t,m,g){try{this.g.get(t)?.resize(m,g)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(t,m){this.g.get(t)?.shutdown(m)}$acceptProcessRequestInitialCwd(t){this.g.get(t)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(t,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(t){this.g.get(t)?.getCwd().then(m=>this.a.$sendProcessProperty(t,{type:"cwd",value:m}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this.u.add(t),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(t),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(t,m,g){if(this.v.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.v.set(m,g),this.a.$registerProfileProvider(m,t.identifier.value),new S.Disposable(()=>{this.v.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(t,m,g){if(this.w.has(t))throw new Error(`Terminal quick fix provider "${t}" is already registered`);return this.w.set(t,g),this.a.$registerQuickFixProvider(t,m),new S.Disposable(()=>{this.w.delete(t),this.a.$unregisterQuickFixProvider(t)})}async $provideTerminalQuickFixes(t,m){const g=new f.CancellationTokenSource().token;if(g.isCancellationRequested)return;const A=this.w.get(t);if(!!A)return A.provideTerminalQuickFixes(m,g)}async $createContributedProfileTerminal(t,m){const g=new f.CancellationTokenSource().token;let A=await this.v.get(t)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,m);return}this.createTerminalFromOptions(A.options,m)}}async $provideLinks(t,m){const g=this.P(t);if(!g)return[];this.y.delete(t),this.C.get(t)?.dispose(!0);const L=new f.CancellationTokenSource;this.C.set(t,L);const K=[],q={terminal:g.value,line:m},j=[];for(const F of this.u)j.push(l.Promises.withAsyncBody(async $=>{L.token.onCancellationRequested(()=>$({provider:F,links:[]}));const z=await F.provideTerminalLinks(q,L.token)||[];L.token.isCancellationRequested||$({provider:F,links:z})}));const P=await Promise.all(j);if(L.token.isCancellationRequested)return[];const M=new Map;for(const F of P)F&&F.links.length>0&&K.push(...F.links.map($=>{const z={id:w++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return M.set(z.id,{provider:F.provider,link:$}),z}));return this.y.set(t,M),K}$activateLink(t,m){const g=this.y.get(t)?.get(m);!g||g.provider.handleTerminalLink(g.link)}O(t,m){this.s.stopBuffering(t),this.g.delete(t),delete this.j[t];const g=this.h[t];g&&(g.dispose(),delete this.h[t]),this.a.$sendProcessExit(t,m)}P(t){return this.Q(this.f,t)}Q(t,m){const g=this.R(t,m);return g!==null?t[g]:null}R(t,m){let g=null;return t.some((A,L)=>A._id===m?(g=L,!0):!1),g}getEnvironmentVariableCollection(t){let m=this.l.get(t.identifier.value);return m||(m=new r,this.U(t.identifier.value,m)),m}S(t,m){const g=(0,I.serializeEnvironmentVariableCollection)(m.map);this.a.$setEnvironmentVariableCollection(t,m.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(t){t.forEach(m=>{const g=m[0],A=new r(m[1]);this.U(g,A)})}$acceptDefaultProfile(t,m){const g=this.m;this.m=t,this.n=m,g?.path!==t.path&&this.L.fire(t.path)}U(t,m){this.l.set(t,m),m.onDidChangeCollection(()=>{this.S(t,m)})}};s=Ve([je(1,C.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class r{get persistent(){return this.a}set persistent(t){this.a=t,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(t){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(t)}get size(){return this.map.size}replace(t,m){this.d(t,{value:m,type:S.EnvironmentVariableMutatorType.Replace})}append(t,m){this.d(t,{value:m,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,m){this.d(t,{value:m,type:S.EnvironmentVariableMutatorType.Prepend})}d(t,m){const g=this.map.get(t);(!g||g.value!==m.value||g.type!==m.type)&&(this.map.set(t,m),this.b.fire())}get(t){return this.map.get(t)}forEach(t,m){this.map.forEach((g,A)=>t.call(m,A,g,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}e.EnvironmentVariableCollection=r;let a=class extends s{constructor(t){super(!1,t)}createTerminal(t,m,g){throw new O.NotSupportedError}createTerminalFromOptions(t,m){throw new O.NotSupportedError}};a=Ve([je(0,C.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function d(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function c(u){return i.ThemeColor.isThemeColor(u)?u:void 0}});var Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n};define(De[221],Ce([1,0,16,24,20,5,184,222,7,23,9,34,4,14,97,8,6,42,67,52]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b){"use strict";var p,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(q,j,P){this.j=P,this.c=new N.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=q.getProxy(f.MainContext.MainThreadTesting),this.h=new g(this.f),this.g=new a(this.f),j.registerArgumentProcessor({processArgument:M=>{if(M?.$mid!==15)return M;const F=M,$=F.tests[F.tests.length-1].item.extId;return this.d.get(l.TestId.root($))?.collection.tree.get($)?.actual??(0,h.toItemFromContext)(M)}})}createTestController(q,j,P){if(this.d.has(q))throw new Error(`Attempt to insert a duplicate controller with ID "${q}"`);const M=new S.DisposableStore,F=M.add(new h.ExtHostTestItemCollection(q,j,this.j));F.root.label=j;const $=new Map,z=this.f,V={items:F.root.children,get label(){return j},set label(Z){j=Z,F.root.label=Z,z.$updateController(q,{label:j})},get refreshHandler(){return P},set refreshHandler(Z){P=Z,z.$updateController(q,{canRefresh:!!Z})},get id(){return q},createRunProfile:(Z,fe,oe,le,ce)=>{let me=(0,R.hash)(Z);for(;$.has(me);)me++;return new A(this.f,$,q,me,Z,fe,oe,le,ce)},createTestItem(Z,fe,oe){return new h.TestItemImpl(q,Z,fe,oe)},createTestRun:(Z,fe,oe=!0)=>this.g.createTestRun(q,F,Z,fe,oe),set resolveHandler(Z){F.resolveHandler=Z},get resolveHandler(){return F.resolveHandler},dispose:()=>{M.dispose()}};z.$registerTestController(q,j,!!P),M.add((0,S.toDisposable)(()=>z.$unregisterTestController(q)));const X={controller:V,collection:F,profiles:$};return this.d.set(q,X),M.add((0,S.toDisposable)(()=>this.d.delete(q))),M.add(F.onDidGenerateDiff(Z=>z.$publishDiff(q,Z.map(b.TestsDiffOp.serialize)))),V}createTestObserver(){return this.h.checkout()}async runTests(q,j=y.CancellationToken.None){const P=d(q);if(!P)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.d.get(P.controllerId);if(!M)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:q.include?.map(F=>l.TestId.fromExtHostTestItem(F,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:L[P.kind],profileId:P.profileId,controllerId:P.controllerId}],exclude:q.exclude?.map(F=>F.id)},j)}$syncTests(){for(const{collection:q}of this.d.values())q.flushDiff();return Promise.resolve()}$provideFileCoverage(q,j,P){return(0,n.mapFind)(this.g.trackers,F=>F.id===q?F.getCoverage(j):void 0)?.provideFileCoverage(P)??Promise.resolve([])}$resolveFileCoverage(q,j,P,M){return(0,n.mapFind)(this.g.trackers,$=>$.id===q?$.getCoverage(j):void 0)?.resolveFileCoverage(P,M)??Promise.resolve([])}$configureRunProfile(q,j){this.d.get(q)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(q,j){await this.d.get(q)?.controller.refreshHandler?.(j)}$publishTestResults(q){this.results=Object.freeze(q.map(j=>(0,k.deepFreeze)(i.TestResults.to(j))).concat(this.results).sort((j,P)=>P.completedAt-j.completedAt).slice(0,32)),this.c.fire()}async $expandTest(q,j){const P=this.d.get(l.TestId.fromString(q).controllerId)?.collection;P&&(await P.expand(q,j<0?1/0:j),P.flushDiff())}$acceptDiff(q){this.h.applyDiff(q.map(b.TestsDiffOp.deserialize))}async $runControllerTests(q,j){return Promise.all(q.map(P=>this.runControllerTestRequest(P,j)))}async runControllerTestRequest(q,j){const P=this.d.get(q.controllerId);if(!P)return{};const{collection:M,profiles:F}=P,$=F.get(q.profileId);if(!$)return{};const z=q.testIds.map(fe=>M.tree.get(fe)).filter(O.isDefined),V=q.excludeExtIds.map(fe=>P.collection.tree.get(fe)).filter(O.isDefined).filter(fe=>z.some(oe=>oe.fullId.compare(fe.fullId)===2));if(!z.length)return{};const X=new o.TestRunRequest(z.some(fe=>fe.actual instanceof h.TestItemRootImpl)?void 0:z.map(fe=>fe.actual),V.map(fe=>fe.actual),$),Z=this.g.prepareForMainThreadTestRun(X,c.fromInternal(q,P.collection),j);try{return await $.runHandler(X,j),{}}catch(fe){return{error:String(fe)}}finally{Z.isRunning&&!j.isCancellationRequested&&await N.Event.toPromise(Z.onEnd),Z.dispose()}}$cancelExtensionTestRun(q){q===void 0?this.g.cancelAllRuns():this.g.cancelRunById(q)}};s=Ve([je(0,v.IExtHostRpcService)],s),e.ExtHostTesting=s;class r extends S.Disposable{get isRunning(){return this.c.size>0}get id(){return this.k.id}constructor(q,j,P){super(),this.k=q,this.l=j,this.c=new Map,this.f=new Set,this.h=this.B(new N.Emitter),this.j=!1,this.onEnd=this.h.event,this.g=this.B(new y.CancellationTokenSource(P)),this.B(this.g.token.onCancellationRequested(()=>{for(const{run:M}of this.c.values())M.end()}))}getCoverage(q){return this.c.get(q)?.coverage}createRun(q){const j=this.k.id,P=this.k.controllerId,M=(0,I.generateUuid)(),F=new u(this.l,j,M),$=Z=>(fe,...oe)=>{if(V){console.warn(`Setting the state of test "${fe.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(fe)||(this.m(fe),Z(fe,...oe))},z=(Z,fe)=>{const oe=fe instanceof Array?fe.map(i.TestMessage.from):[i.TestMessage.from(fe)];if(Z.uri&&Z.range){const le={range:i.Range.from(Z.range),uri:Z.uri};for(const ce of oe)ce.location=ce.location||le}this.l.$appendTestMessagesInRun(j,M,l.TestId.fromExtHostTestItem(Z,P).toString(),oe)};let V=!1;const X={isPersisted:this.k.isPersisted,token:this.g.token,name:q,get coverageProvider(){return F.coverageProvider},set coverageProvider(Z){F.coverageProvider=Z},enqueued:$(Z=>{this.l.$updateTestStateInRun(j,M,l.TestId.fromExtHostTestItem(Z,P).toString(),1)}),skipped:$(Z=>{this.l.$updateTestStateInRun(j,M,l.TestId.fromExtHostTestItem(Z,P).toString(),5)}),started:$(Z=>{this.l.$updateTestStateInRun(j,M,l.TestId.fromExtHostTestItem(Z,P).toString(),2)}),errored:$((Z,fe,oe)=>{z(Z,fe),this.l.$updateTestStateInRun(j,M,l.TestId.fromExtHostTestItem(Z,P).toString(),6,oe)}),failed:$((Z,fe,oe)=>{z(Z,fe),this.l.$updateTestStateInRun(j,M,l.TestId.fromExtHostTestItem(Z,P).toString(),4,oe)}),passed:$((Z,fe)=>{this.l.$updateTestStateInRun(j,M,l.TestId.fromExtHostTestItem(Z,this.k.controllerId).toString(),3,fe)}),appendOutput:(Z,fe,oe)=>{V||(oe&&(this.k.isIncluded(oe)?this.m(oe):oe=void 0),this.l.$appendOutputToRun(j,M,T.VSBuffer.fromString(Z),fe&&i.location.from(fe),oe&&l.TestId.fromExtHostTestItem(oe,P).toString()))},end:()=>{V||(V=!0,this.l.$finishedTestRunTask(j,M),this.c.delete(M),this.isRunning||this.dispose())}};return this.c.set(M,{run:X,coverage:F}),this.l.$startedTestRunTask(j,{id:M,name:q,running:!0}),X}dispose(){this.j||(this.j=!0,this.h.fire(),this.g.cancel(),super.dispose())}m(q){if(!(q instanceof h.TestItemImpl))throw new E.InvalidTestItemError(q.id);if(this.f.has(l.TestId.fromExtHostTestItem(q,this.k.controllerId).toString()))return;const j=[],P=this.k.colllection.root;for(;;){const M=i.TestItem.from(q);if(j.unshift(M),this.f.has(M.extId)||(this.f.add(M.extId),q===P))break;q=q.parent||P}this.l.$addTestsToRun(this.k.controllerId,this.k.id,j)}}class a{get trackers(){return this.c.values()}constructor(q){this.d=q,this.c=new Map}prepareForMainThreadTestRun(q,j,P){return this.f(q,j,P)}cancelRunById(q){for(const j of this.c.values())if(j.id===q){j.dispose();return}}cancelAllRuns(){for(const q of this.c.values())q.dispose()}createTestRun(q,j,P,M,F){const $=this.c.get(P);if($)return $.createRun(M);const z=c.fromPublic(q,j,P,F),V=d(P);this.d.$startedExtensionTestRun({controllerId:q,profile:V&&{group:L[V.kind],id:V.profileId},exclude:P.exclude?.map(Z=>l.TestId.fromExtHostTestItem(Z,j.root.id).toString())??[],id:z.id,include:P.include?.map(Z=>l.TestId.fromExtHostTestItem(Z,j.root.id).toString())??[j.root.id],persist:F});const X=this.f(P,z);return X.onEnd(()=>this.d.$finishedExtensionTestRun(z.id)),X.createRun(M)}f(q,j,P){const M=new r(j,this.d,P);return this.c.set(q,M),M.onEnd(()=>this.c.delete(q)),M}}e.TestRunCoordinator=a;const d=K=>{if(!!K.profile){if(!(K.profile instanceof A))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class c{static fromPublic(q,j,P,M){return new c(q,(0,I.generateUuid)(),P.include?.map(F=>l.TestId.fromExtHostTestItem(F,q).toString())??[q],P.exclude?.map(F=>l.TestId.fromExtHostTestItem(F,q).toString())??[],M,j)}static fromInternal(q,j){return new c(q.controllerId,q.runId,q.testIds,q.excludeExtIds,!0,j)}constructor(q,j,P,M,F,$){this.controllerId=q,this.id=j,this.isPersisted=F,this.colllection=$,this.c=P.map(z=>z+"\0"),this.d=M.map(z=>z+"\0")}isIncluded(q){const j=l.TestId.fromExtHostTestItem(q,this.controllerId).toString()+"\0";for(const P of this.d)if(j===P||j.startsWith(P))return!1;for(const P of this.c)if(j===P||j.startsWith(P))return!0;return!1}}e.TestRunDto=c;class u{set coverageProvider(q){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!q||(this.c=q,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(q,j,P){this.f=q,this.g=j,this.h=P}async provideFileCoverage(q){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(q))());try{return(await this.d)?.map(i.TestCoverage.fromFile)??[]}catch(j){throw this.d=void 0,j}}async resolveFileCoverage(q,j){const P=await this.d;let M=P?.[q];return!this.c||!P||!M?[]:(M.detailedCoverage||(M=P[q]=await this.c.resolveFileCoverage?.(M,j)??M),M.detailedCoverage?.map(i.TestCoverage.fromDetailed)??[])}}class t{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(q){this.h=q,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(q){this.c.add(q)}update(q){Object.assign(q.revived,i.TestItem.toPlain(q.item)),this.c.has(q)||this.d.add(q)}remove(q){if(this.c.has(q)){this.c.delete(q);return}this.d.delete(q);const j=l.TestId.parentId(q.item.extId);if(j&&this.g.has(j.toString())){this.g.add(q.item.extId);return}this.f.add(q)}getChangeEvent(){const{c:q,d:j,f:P}=this;return{get added(){return[...q].map(M=>M.revived)},get updated(){return[...j].map(M=>M.revived)},get removed(){return[...P].map(M=>M.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class m extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new N.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(q){return this.d.get(q)}getMirroredTestDataByReference(q){return this.d.get(q.id)}p(q,j){return{...q,revived:i.TestItem.toPlain(q.item),depth:j?j.depth+1:0,children:new Set}}o(){return new t(this.q)}}e.MirroredTestCollection=m;class g{constructor(q){this.d=q}checkout(){this.c||(this.c=this.f());const q=this.c;return q.observers++,{onDidChangeTest:q.tests.onDidChangeTests,get tests(){return[...q.tests.rootTests].map(j=>j.revived)},dispose:(0,C.once)(()=>{--q.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(q){return this.c?.tests.getMirroredTestDataByReference(q)}applyDiff(q){this.c?.tests.apply(q)}f(){const q=new m;return this.d.$subscribeToDiffs(),{observers:0,tests:q}}}class A{get label(){return this.d}set label(q){q!==this.d&&(this.d=q,Re(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:q}))}get isDefault(){return this.f}set isDefault(q){q!==this.f&&(this.f=q,Re(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:q}))}get tag(){return this._tag}set tag(q){q?.id!==this._tag?.id&&(this._tag=q,Re(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:q?i.TestTag.namespace(this.controllerId,q.id):null}))}get configureHandler(){return this.c}set configureHandler(q){q!==this.c&&(this.c=q,Re(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!q}))}constructor(q,j,P,M,F,$,z,V=!1,X=void 0){this.controllerId=P,this.profileId=M,this.d=F,this.kind=$,this.runHandler=z,this.f=V,this._tag=X,p.set(this,void 0),w.set(this,void 0),Ye(this,p,q,"f"),Ye(this,w,j,"f"),j.set(M,this);const Z=L[$];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Re(this,p,"f").$publishTestRunProfile({profileId:M,controllerId:P,tag:X?i.TestTag.namespace(this.controllerId,X.id):null,label:F,group:Z,isDefault:V,hasConfigurationHandler:!1})}dispose(){Re(this,w,"f")?.delete(this.profileId)&&(Ye(this,w,void 0,"f"),Re(this,p,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=A,p=new WeakMap,w=new WeakMap;const L={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(De[223],Ce([1,0,16,5,4,98,8,6]),function(te,e,n,T,y,N,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(O,I){this.i=I,this.a=new T.Emitter,this.b=new T.Emitter,this.c=new T.Emitter,this.d=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(y.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(f=>this.g.fire(f)),this.i.onDidChangeActiveTextEditor(f=>this.f.fire(f))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const I=this.i.allEditors();return O?I:I.map(f=>f.value)}async showTextDocument(O,I,f){let v;typeof I=="number"?v={position:C.ViewColumn.from(I),preserveFocus:f}:typeof I=="object"?v={position:C.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?C.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:v={preserveFocus:!1};const h=await this.h.$tryShowTextDocument(O.uri,v),i=h&&this.i.getEditor(h);if(i)return i.value;throw h?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,I){return new N.TextEditorDecorationType(this.h,O,I).value}$acceptEditorPropertiesChanged(O,I){const f=this.i.getEditor(O);if(!f)throw new Error("unknown text editor");if(I.options&&f._acceptOptions(I.options),I.selections){const v=I.selections.selections.map(C.Selection.to);f._acceptSelections(v)}if(I.visibleRanges){const v=n.coalesce(I.visibleRanges.map(C.Range.to));f._acceptVisibleRanges(v)}if(I.options&&this.b.fire({textEditor:f.value,options:{...I.options,lineNumbers:C.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const v=R.TextEditorSelectionChangeKind.fromValue(I.selections.source),h=I.selections.selections.map(C.Selection.to);this.a.fire({textEditor:f.value,selections:h,kind:v})}if(I.visibleRanges){const v=n.coalesce(I.visibleRanges.map(C.Range.to));this.c.fire({textEditor:f.value,visibleRanges:v})}}$acceptEditorPositionData(O){for(const I in O){const f=this.i.getEditor(I);if(!f)throw new Error("Unknown text editor");const v=C.ViewColumn.to(O[I]);f.value.viewColumn!==v&&(f._acceptViewColumn(v),this.d.fire({textEditor:f.value,viewColumn:v}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.ExtHostEditors=S}),define(De[224],Ce([1,0,2,3,4,7,6,8,9]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class k{constructor(f,v){this.b=new Map,this.c=new Map,this.a=f.getProxy(y.MainContext.MainThreadTimeline),v.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===12){const i=h.uri===void 0?void 0:n.URI.revive(h.uri);return this.c.get(h.source)?.get(O(i))?.get(h.handle)}return h}})}async $getTimeline(f,v,h,i){return this.b.get(f)?.provideTimeline(n.URI.revive(v),h,i)}registerTimelineProvider(f,v,h,i){const o=new N.DisposableStore,l=this.d(v.id,i,o).bind(this);let E;v.onDidChange&&(E=v.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:v.id}),this));const b=this.c;return this.f({...v,scheme:f,onDidChange:void 0,async provideTimeline(p,w,s){w?.resetCache&&(o.clear(),b.get(v.id)?.clear());const r=await v.provideTimeline(p,w,s);if(r==null)return;const a=l(p,w);return{...r,source:v.id,items:r.items.map(a)}},dispose(){for(const p of b.values())p.get(v.id)?.clear();E?.dispose(),o.dispose()}})}d(f,v,h){return(i,o)=>{let l;if(o?.cacheResults){let E=this.c.get(f);E===void 0&&(E=new Map,this.c.set(f,E));const b=O(i);l=E.get(b),l===void 0&&(l=new Map,E.set(b,l))}return E=>{const{iconPath:b,...p}=E,w=`${f}|${E.id??E.timestamp}`;l?.set(w,E);let s,r,a;E.iconPath&&(b instanceof C.ThemeIcon?a={id:b.id,color:b.color}:n.URI.isUri(b)?(s=b,r=b):{light:s,dark:r}=b);let d;return C.MarkdownString.isMarkdownString(p.tooltip)?d=R.MarkdownString.from(p.tooltip):(0,S.isString)(p.tooltip)?d=p.tooltip:C.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=R.MarkdownString.from(p.detail)):(0,S.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=p.detail),{...p,id:p.id??void 0,handle:w,source:f,command:E.command?v.toInternal(E.command,h):void 0,icon:s,iconDark:r,themeIcon:a,tooltip:d,accessibilityInformation:E.accessibilityInformation}}}}f(f){if(this.b.get(f.id))throw new Error(`Timeline Provider ${f.id} already exists.`);return this.a.$registerTimelineProvider({id:f.id,label:f.label,scheme:f.scheme}),this.b.set(f.id,f),(0,N.toDisposable)(()=>{for(const h of this.c.values())h.get(f.id)?.clear();this.b.delete(f.id),this.a.$unregisterTimelineProvider(f.id),f.dispose()})}}e.ExtHostTimeline=k;function O(I){return I?.toString()}}),define(De[225],Ce([1,0,7,13,2,4]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,O,I){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const f=I.schemes.find(v=>!C.a.has(v));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(k,O),this.b.$registerUriOpener(k,I.schemes,S,I.label),(0,n.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(S,k,O){const I=this.c.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const f=y.URI.revive(k);return I.canOpenExternalUri(f,O)}async $openUri(S,k,O){const I=this.c.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(y.URI.revive(k.resolvedUri),{sourceUri:y.URI.revive(k.sourceUri)},O)}}e.ExtHostUriOpeners=C,C.a=new Set([T.Schemas.http,T.Schemas.https])}),define(De[226],Ce([1,0,4,2,7,11,26]),function(te,e,n,T,y,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(k,O){if(this.c.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=R.a++;return this.c.add(C.ExtensionIdentifier.toKey(k)),this.d.set(I,O),this.b.$registerUriHandler(I,k),(0,y.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(k)),this.d.delete(I),this.b.$unregisterUriHandler(I)})}$handleExternalUri(k,O){const I=this.d.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(O))}catch(f){(0,N.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this.b.$createAppUri(k))}}e.ExtHostUrls=R,R.a=0});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(De[58],Ce([1,0,5,13,23,2,148,168,68,4]),function(te,e,n,T,y,N,C,R,S,k){"use strict";var O,I,f,v,h,i,o,l,E,b,p,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class r{constructor(L,K,q,j,P,M,F){O.set(this,void 0),I.set(this,void 0),f.set(this,void 0),v.set(this,void 0),h.set(this,void 0),i.set(this,void 0),o.set(this,""),l.set(this,void 0),E.set(this,!1),b.set(this,!1),p.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new n.Emitter),this._onDidDispose=Re(this,s,"f").event,Ye(this,O,L,"f"),Ye(this,I,K,"f"),Ye(this,l,q,"f"),Ye(this,v,j,"f"),Ye(this,h,P,"f"),Ye(this,i,M,"f"),Ye(this,p,a(M),"f"),Ye(this,w,d(M),"f"),Ye(this,f,F,"f")}dispose(){Ye(this,E,!0,"f"),Re(this,s,"f").fire(),Re(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return Ye(this,b,!0,"f"),(0,S.asWebviewUri)(L,Re(this,v,"f"))}get cspSource(){const L=Re(this,i,"f").extensionLocation;if(L.scheme===T.Schemas.https||L.scheme===T.Schemas.http){let K=L.toString();return K.endsWith("/")||(K+="/"),K+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Re(this,o,"f")}set html(L){this.a(),Re(this,o,"f")!==L&&(Ye(this,o,L,"f"),Re(this,w,"f")&&!Re(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(Ye(this,b,!0,"f"),Re(this,f,"f").report("Webview vscode-resource: uris",Re(this,i,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,I,"f").$setHtml(Re(this,O,"f"),this.b(L)))}get options(){return this.a(),Re(this,l,"f")}set options(L){this.a(),y.equals(Re(this,l,"f"),L)||Re(this,I,"f").$setOptions(Re(this,O,"f"),t(Re(this,i,"f"),Re(this,h,"f"),L)),Ye(this,l,L,"f")}async postMessage(L){if(Re(this,E,"f"))return!1;const K=(0,R.serializeWebviewMessage)(L,{serializeBuffersForPostMessage:Re(this,p,"f")});return Re(this,I,"f").$postMessage(Re(this,O,"f"),K.message,...K.buffers)}a(){if(Re(this,E,"f"))throw new Error("Webview is disposed")}b(L){if(!Re(this,w,"f"))return L;const K=Re(this,i,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,q=Re(this,i,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Re(this,i,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(j,P,M,F,$,z)=>{const V=N.URI.from({scheme:F||"file",path:decodeURIComponent($)}),X=(0,S.asWebviewUri)(V,{isRemote:K,authority:q}).toString();return`${P}${X}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(j,P,M,F,$,z)=>{const V=N.URI.from({scheme:F||"file",path:decodeURIComponent($)}),X=(0,S.asWebviewUri)(V,{isRemote:K,authority:q}).toString();return`${P}${X}${z}`})}}e.ExtHostWebview=r,O=new WeakMap,I=new WeakMap,f=new WeakMap,v=new WeakMap,h=new WeakMap,i=new WeakMap,o=new WeakMap,l=new WeakMap,E=new WeakMap,b=new WeakMap,p=new WeakMap,w=new WeakMap,s=new WeakMap;function a(A){try{const L=(0,C.normalizeVersion)((0,C.parseVersion)(A.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function d(A){try{const L=(0,C.normalizeVersion)((0,C.parseVersion)(A.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class c{constructor(L,K,q,j,P){this.c=K,this.d=q,this.e=j,this.f=P,this.b=new Map,this.a=L.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(L,K,q){const j=this.g(L);if(j){const{message:P}=(0,R.deserializeWebviewMessage)(K,q.value);j._onMessageEmitter.fire(P)}}$onMissingCsp(L,K){this.e.warn(`${K} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,K,q){const j=new r(L,this.a,m(K),this.c,this.d,q,this.f);return this.b.set(L,j),j._onDidDispose(()=>{this.b.delete(L)}),j}deleteWebview(L){this.b.delete(L)}g(L){return this.b.get(L)}}e.ExtHostWebviews=c;function u(A){return{id:A.identifier,location:A.extensionLocation}}e.toExtensionData=u;function t(A,L,K){return{enableCommandUris:K.enableCommandUris,enableScripts:K.enableScripts,enableForms:K.enableForms,portMapping:K.portMapping,localResourceRoots:K.localResourceRoots||g(A,L)}}e.serializeWebviewOptions=t;function m(A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,enableForms:A.enableForms,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots?.map(L=>N.URI.from(L))}}function g(A,L){return[...(L?.getWorkspaceFolders()||[]).map(K=>K.uri),A.extensionLocation]}}),define(De[227],Ce([1,0,20,222,7,13,22,2,8,58,50,4,6]),function(te,e,n,T,y,N,C,R,S,k,O,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class v{constructor(r,a){this.document=r,this.b=a,this.a=1,this.c=new O.Cache("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,a){await this.f(r).undo(),a||this.disposeBackup()}async redo(r,a){await this.f(r).redo(),a||this.disposeBackup()}disposeEdits(r){for(const a of r)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=w(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const a=this.c.get(r,0);if(!a)throw new Error("No edit found");return a}}class h{constructor(){this.a=new Map}get(r,a){return this.a.get(this.b(r,a))}add(r,a,d){const c=this.b(r,a.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${a.uri}`);const u=new v(a,d);return this.a.set(c,u),u}delete(r,a){const d=this.b(r,a.uri);this.a.delete(d)}b(r,a){return`${r}@@@${a}`}}var i;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(i||(i={}));class o{constructor(){this.a=new Map}addTextProvider(r,a,d){return this.b(0,r,a,d)}addCustomProvider(r,a,d){return this.b(1,r,a,d)}get(r){return this.a.get(r)}b(r,a,d,c){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:r,extension:d,provider:c}),new f.Disposable(()=>this.a.delete(a))}}class l{constructor(r,a,d,c,u){this.d=a,this.f=d,this.g=c,this.h=u,this.b=new o,this.c=new h,this.a=r.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,a,d,c){const u=new y.DisposableStore;return b(d)?(u.add(this.b.addTextProvider(a,r,d)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(r),a,c.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(r))):(u.add(this.b.addCustomProvider(a,r,d)),E(d)&&u.add(d.onDidChangeCustomDocument(t=>{const m=this.i(a,t.document.uri);if(p(t)){const g=m.addEdit(t);this.a.$onDidEdit(t.document.uri,a,g,t.label)}else this.a.$onContentChange(t.document.uri,a)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(r),a,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(r))),f.Disposable.from(u,new f.Disposable(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(r,a,d,c,u){const t=this.b.get(a);if(!t)throw new Error(`No provider found for '${a}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${a}'`);const m=R.URI.revive(r),g=await t.provider.openCustomDocument(m,{backupId:d,untitledDocumentData:c?.buffer},u);let A;return E(t.provider)&&this.f&&(A=this.f.workspaceValue(t.extension)??this.f.globalValue(t.extension)),this.c.add(a,g,A),{editable:E(t.provider)}}async $disposeCustomDocument(r,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const c=R.URI.revive(r),{document:u}=this.i(a,c);this.c.delete(a,u),u.dispose()}async $resolveWebviewEditor(r,a,d,c,u,t){const m=this.b.get(d);if(!m)throw new Error(`No provider found for '${d}'`);const g=S.ViewColumn.to(u),A=this.g.createNewWebview(a,c.contentOptions,m.extension),L=this.h.createNewWebviewPanel(a,d,c.title,g,c.options,A,!0),K=R.URI.revive(r);switch(m.type){case 1:{const{document:q}=this.i(d,K);return m.provider.resolveCustomEditor(q,L,t)}case 0:{const q=this.d.getDocument(K);return m.provider.resolveCustomTextEditor(q,L,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,a,d){this.i(a,r).disposeEdits(d)}async $onMoveCustomEditor(r,a,d){const c=this.b.get(d);if(!c)throw new Error(`No provider found for '${d}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const u=this.h.getWebviewPanel(r);if(!u)throw new Error("No webview found");const t=R.URI.revive(a),m=this.d.getDocument(t);await c.provider.moveCustomTextEditor(m,u,n.CancellationToken.None)}async $undo(r,a,d,c){return this.i(a,r).undo(d,c)}async $redo(r,a,d,c){return this.i(a,r).redo(d,c)}async $revert(r,a,d){const c=this.i(a,r);await this.j(a).revertCustomDocument(c.document,d),c.disposeBackup()}async $onSave(r,a,d){const c=this.i(a,r);await this.j(a).saveCustomDocument(c.document,d),c.disposeBackup()}async $onSaveAs(r,a,d,c){const u=this.i(a,r);return this.j(a).saveCustomDocumentAs(u.document,R.URI.revive(d),c)}async $backup(r,a,d){const c=this.i(a,r),t=await this.j(a).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},d);return c.updateBackup(t),t.id}i(r,a){const d=this.c.get(r,R.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(r){const d=this.b.get(r)?.provider;if(!d||!E(d))throw new Error("Custom document is not editable");return d}}e.ExtHostCustomEditors=l;function E(s){return!!s.onDidChangeCustomDocument}function b(s){return typeof s.resolveCustomTextEditor=="function"}function p(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function w(s){const r=s.scheme===N.Schemas.file||s.scheme===N.Schemas.untitled?s.fsPath:s.toString();return(0,T.hash)(r)+""}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(De[228],Ce([1,0,5,7,2,34,8,58,4,6]),function(te,e,n,T,y,N,C,R,S,k){"use strict";var O,I,f,v,h,i,o,l,E,b,p,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends T.Disposable{constructor(u,t,m,g){super(),O.set(this,void 0),I.set(this,void 0),f.set(this,void 0),v.set(this,void 0),h.set(this,void 0),i.set(this,void 0),o.set(this,void 0),l.set(this,void 0),E.set(this,!0),b.set(this,void 0),p.set(this,!1),w.set(this,this.B(new n.Emitter)),this.onDidDispose=Re(this,w,"f").event,s.set(this,this.B(new n.Emitter)),this.onDidChangeViewState=Re(this,s,"f").event,Ye(this,O,u,"f"),Ye(this,I,t,"f"),Ye(this,v,m,"f"),Ye(this,f,g.viewType,"f"),Ye(this,h,g.panelOptions,"f"),Ye(this,l,g.viewColumn,"f"),Ye(this,i,g.title,"f"),Ye(this,b,g.active,"f")}dispose(){Re(this,p,"f")||(Ye(this,p,!0,"f"),Re(this,w,"f").fire(),Re(this,I,"f").$disposeWebview(Re(this,O,"f")),Re(this,v,"f").dispose(),super.dispose())}get webview(){return this.c(),Re(this,v,"f")}get viewType(){return this.c(),Re(this,f,"f")}get title(){return this.c(),Re(this,i,"f")}set title(u){this.c(),Re(this,i,"f")!==u&&(Ye(this,i,u,"f"),Re(this,I,"f").$setTitle(Re(this,O,"f"),u))}get iconPath(){return this.c(),Re(this,o,"f")}set iconPath(u){this.c(),Re(this,o,"f")!==u&&(Ye(this,o,u,"f"),Re(this,I,"f").$setIconPath(Re(this,O,"f"),y.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Re(this,h,"f")}get viewColumn(){if(this.c(),!(typeof Re(this,l,"f")=="number"&&Re(this,l,"f")<0))return Re(this,l,"f")}get active(){return this.c(),Re(this,b,"f")}get visible(){return this.c(),Re(this,E,"f")}_updateViewState(u){Re(this,p,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Ye(this,b,u.active,"f"),Ye(this,E,u.visible,"f"),Ye(this,l,u.viewColumn,"f"),Re(this,s,"f").fire({webviewPanel:this}))}reveal(u,t){this.c(),Re(this,I,"f").$reveal(Re(this,O,"f"),{viewColumn:typeof u>"u"?void 0:C.ViewColumn.from(u),preserveFocus:!!t})}c(){if(Re(this,p,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,I=new WeakMap,f=new WeakMap,v=new WeakMap,h=new WeakMap,i=new WeakMap,o=new WeakMap,l=new WeakMap,E=new WeakMap,b=new WeakMap,p=new WeakMap,w=new WeakMap,s=new WeakMap;class a{static c(){return(0,N.generateUuid)()}constructor(u,t,m){this.g=t,this.h=m,this.e=new Map,this.f=new Map,this.d=u.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,t,m,g,A={}){const L=typeof g=="object"?g.viewColumn:g,K={viewColumn:C.ViewColumn.from(L),preserveFocus:typeof g=="object"&&!!g.preserveFocus},q=(0,R.shouldSerializeBuffersForPostMessage)(u),j=a.c();this.d.$createWebviewPanel((0,R.toExtensionData)(u),j,t,{title:m,panelOptions:d(A),webviewOptions:(0,R.serializeWebviewOptions)(u,this.h,A),serializeBuffersForPostMessage:q},K);const P=this.g.createNewWebview(j,A,u);return this.createNewWebviewPanel(j,t,m,L,A,P,!0)}$onDidChangeWebviewPanelViewStates(u){const t=Object.keys(u);t.sort((m,g)=>{const A=u[m],L=u[g];return A.active?1:L.active?-1:+A.visible-+L.visible});for(const m of t){const g=this.getWebviewPanel(m);if(!g)continue;const A=u[m];g._updateViewState({active:A.active,visible:A.visible,viewColumn:C.ViewColumn.to(A.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.e.delete(u),this.g.deleteWebview(u)}registerWebviewPanelSerializer(u,t,m){if(this.f.has(t))throw new Error(`Serializer for '${t}' already registered`);return this.f.set(t,{serializer:m,extension:u}),this.d.$registerSerializer(t,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(u)}),new k.Disposable(()=>{this.f.delete(t),this.d.$unregisterSerializer(t)})}async $deserializeWebviewPanel(u,t,m,g){const A=this.f.get(t);if(!A)throw new Error(`No serializer found for '${t}'`);const{serializer:L,extension:K}=A,q=this.g.createNewWebview(u,m.webviewOptions,K),j=this.createNewWebviewPanel(u,t,m.title,g,m.panelOptions,q,m.active);await L.deserializeWebviewPanel(j,m.state)}createNewWebviewPanel(u,t,m,g,A,L,K){const q=new r(u,this.d,L,{viewType:t,title:m,viewColumn:g,panelOptions:A,active:K});return this.e.set(u,q),q}getWebviewPanel(u){return this.e.get(u)}}e.ExtHostWebviewPanels=a;function d(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(De[229],Ce([1,0,5,7,58,8,4,6]),function(te,e,n,T,y,N,C,R){"use strict";var S,k,O,I,f,v,h,i,o,l,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends T.Disposable{constructor(s,r,a,d,c,u){super(),S.set(this,void 0),k.set(this,void 0),O.set(this,void 0),I.set(this,void 0),f.set(this,!1),v.set(this,void 0),h.set(this,void 0),i.set(this,void 0),o.set(this,void 0),l.set(this,this.B(new n.Emitter)),this.onDidChangeVisibility=Re(this,l,"f").event,E.set(this,this.B(new n.Emitter)),this.onDidDispose=Re(this,E,"f").event,Ye(this,O,a,"f"),Ye(this,h,d,"f"),Ye(this,S,s,"f"),Ye(this,k,r,"f"),Ye(this,I,c,"f"),Ye(this,v,u,"f")}dispose(){Re(this,f,"f")||(Ye(this,f,!0,"f"),Re(this,E,"f").fire(),Re(this,I,"f").dispose(),super.dispose())}get title(){return this.a(),Re(this,h,"f")}set title(s){this.a(),Re(this,h,"f")!==s&&(Ye(this,h,s,"f"),Re(this,k,"f").$setWebviewViewTitle(Re(this,S,"f"),s))}get description(){return this.a(),Re(this,i,"f")}set description(s){this.a(),Re(this,i,"f")!==s&&(Ye(this,i,s,"f"),Re(this,k,"f").$setWebviewViewDescription(Re(this,S,"f"),s))}get visible(){return Re(this,v,"f")}get webview(){return Re(this,I,"f")}get viewType(){return Re(this,O,"f")}_setVisible(s){s===Re(this,v,"f")||Re(this,f,"f")||(Ye(this,v,s,"f"),Re(this,l,"f").fire())}get badge(){return this.a(),Re(this,o,"f")}set badge(s){this.a(),!(s?.value===Re(this,o,"f")?.value&&s?.tooltip===Re(this,o,"f")?.tooltip)&&(Ye(this,o,N.ViewBadge.from(s),"f"),Re(this,k,"f").$setWebviewViewBadge(Re(this,S,"f"),s))}show(s){this.a(),Re(this,k,"f").$show(Re(this,S,"f"),!!s)}a(){if(Re(this,f,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,k=new WeakMap,O=new WeakMap,I=new WeakMap,f=new WeakMap,v=new WeakMap,h=new WeakMap,i=new WeakMap,o=new WeakMap,l=new WeakMap,E=new WeakMap;class p{constructor(s,r){this.d=r,this.b=new Map,this.c=new Map,this.a=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,r,a,d){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:a,extension:s}),this.a.$registerWebviewViewProvider((0,y.toExtensionData)(s),r,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(s)}),new R.Disposable(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(s,r,a,d,c){const u=this.b.get(r);if(!u)throw new Error(`No view provider found for '${r}'`);const{provider:t,extension:m}=u,g=this.d.createNewWebview(s,{},m),A=new b(s,this.a,r,a,g,!0);this.c.set(s,A),await t.resolveWebviewView(A,{state:d},c)}async $onDidChangeWebviewViewVisibility(s,r){this.e(s)._setVisible(r)}async $disposeWebviewView(s){const r=this.e(s);this.c.delete(s),r.dispose(),this.d.deleteWebview(s)}e(s){const r=this.c.get(s);if(!r)throw new Error("No webview found");return r}}e.ExtHostWebviewViews=p}),define(De[100],Ce([1,0,5,4,2,13,10,3,14]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class nn{get state(){return this.d}constructor(I){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=nn.a,this.b=I.getProxy(T.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}$onDidChangeWindowFocus(I){I!==this.d.focused&&(this.d={...this.d,focused:I},this.c.fire(this.d))}openUri(I,f){let v;if(typeof I=="string"){v=I;try{I=y.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,C.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this.b.$openUri(I,v,f)}async asExternalUri(I,f){if((0,C.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(I,f);return y.URI.from(v)}};k.a={focused:!0},k=Ve([je(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(De[230],Ce([1,0,199,27,14]),function(te,e,n,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let N=class extends n.AbstractExtHostConsoleForwarder{constructor(R,S){super(R,S)}f(R,S,k){S.apply(console,k)}};N=Ve([je(0,y.IExtHostRpcService),je(1,T.IExtHostInitDataService)],N),e.ExtHostConsoleForwarder=N}),define(De[231],Ce([1,0,15,24,20,11,5,7,121,193,43]),function(te,e,n,T,y,N,C,R,S,k,O){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(A,L){try{return JSON.stringify(A,L)}catch{return"null"}}const v="$$ref$$",h={[v]:-1};class i{constructor(L,K){this.jsonString=L,this.referencedBuffers=K}}function o(A,L=null,K=!1){const q=[];return{jsonString:(K?f:JSON.stringify)(A,(P,M)=>{if(typeof M>"u")return h;if(typeof M=="object"){if(M instanceof T.VSBuffer){const F=q.push(M)-1;return{[v]:F}}if(L)return L(P,M)}return M}),referencedBuffers:q}}e.stringifyJsonWithBufferRefs=o;function l(A,L,K){return JSON.parse(A,(q,j)=>{if(j){const P=j[v];if(typeof P=="number")return L[P];if(K&&j.$mid===1)return K.transformIncoming(j)}return j})}e.parseJsonAndRestoreBufferRefs=l;function E(A,L){return JSON.stringify(A,L)}function b(A){return A?(L,K)=>K&&K.$mid===1?A.transformOutgoing(K):K:null}var p;(function(A){A[A.LocalSide=0]="LocalSide",A[A.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(A){A[A.Responsive=0]="Responsive",A[A.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},r=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends R.Disposable{constructor(L,K=null,q=null){super(),this[I]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=K,this.g=q,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let j=0,P=O.ProxyIdentifier.count;j<P;j++)this.k[j]=null,this.l[j]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new n.RunOnceScheduler(()=>this.D(),1e3)),this.c.onMessage(j=>this.H(j))}dispose(){this.j=!0,Object.keys(this.s).forEach(L=>{this.s[L].resolveErr(N.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(L){this.u===0&&(this.v=Date.now()+d.a),this.u++,this.w.isScheduled()||this.w.schedule()}C(L){this.v=Date.now()+d.a,this.u--,this.u===0&&this.w.cancel(),this.F(0)}D(){this.u!==0&&(Date.now()>this.v?this.F(1):this.w.schedule())}F(L){this.t!==L&&(this.t=L,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(L){return this.g?(0,S.transformIncomingURIs)(L,this.g):L}getProxy(L){const{nid:K,sid:q}=L;return this.l[K]||(this.l[K]=this.G(K,q)),this.l[K]}G(L,K){const q={get:(j,P)=>(typeof P=="string"&&!j[P]&&P.charCodeAt(0)===36&&(j[P]=(...M)=>this.P(L,P,M)),P===a?K:j[P])};return new Proxy(Object.create(null),q)}set(L,K){return this.k[L.nid]=K,K}assertRegistered(L){for(let K=0,q=L.length;K<q;K++){const j=L[K];if(!this.k[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}H(L){if(this.j)return;const K=L.byteLength,q=c.read(L,0),j=q.readUInt8(),P=q.readUInt32();switch(j){case 1:case 2:{let{rpcId:M,method:F,args:$}=t.deserializeRequestJSONArgs(q);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.I(K,P,M,F,$,j===2);break}case 3:case 4:{let{rpcId:M,method:F,args:$}=t.deserializeRequestMixedArgs(q);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.I(K,P,M,F,$,j===4);break}case 5:{this.f?.logIncoming(K,P,0,"ack"),this.C(P);break}case 6:{this.J(K,P);break}case 7:{this.L(K,P,void 0);break}case 9:{let M=t.deserializeReplyOKJSON(q);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.L(K,P,M);break}case 10:{const M=t.deserializeReplyOKJSONWithBuffers(q,this.g);this.L(K,P,M);break}case 8:{const M=t.deserializeReplyOKVSBuffer(q);this.L(K,P,M);break}case 11:{let M=t.deserializeReplyErrError(q);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.M(K,P,M);break}case 12:{this.M(K,P,void 0);break}default:console.error("received unexpected message"),console.error(L)}}I(L,K,q,j,P,M){this.f?.logIncoming(L,K,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(q)}.${j}(`,P);const F=String(K);let $,z;if(M){const X=new y.CancellationTokenSource;P.push(X.token),$=this.N(q,j,P),z=()=>X.cancel()}else $=this.N(q,j,P),z=s;this.p[F]=z;const V=t.serializeAcknowledged(K);this.f?.logOutgoing(V.byteLength,K,1,"ack"),this.c.send(V),$.then(X=>{delete this.p[F];const Z=t.serializeReplyOK(K,X,this.h);this.f?.logOutgoing(Z.byteLength,K,1,"reply:",X),this.c.send(Z)},X=>{delete this.p[F];const Z=t.serializeReplyErr(K,X);this.f?.logOutgoing(Z.byteLength,K,1,"replyErr:",X),this.c.send(Z)})}J(L,K){this.f?.logIncoming(L,K,1,"receiveCancel");const q=String(K);this.p[q]?.()}L(L,K,q){this.f?.logIncoming(L,K,0,"receiveReply:",q);const j=String(K);if(!this.s.hasOwnProperty(j))return;const P=this.s[j];delete this.s[j],P.resolveOk(q)}M(L,K,q){this.f?.logIncoming(L,K,0,"receiveReplyErr:",q);const j=String(K);if(!this.s.hasOwnProperty(j))return;const P=this.s[j];delete this.s[j];let M;q&&(q.$isError?(M=new Error,M.name=q.name,M.message=q.message,M.stack=q.stack):M=q),P.resolveErr(M)}N(L,K,q){try{return Promise.resolve(this.O(L,K,q))}catch(j){return Promise.reject(j)}}O(L,K,q){const j=this.k[L];if(!j)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(L));const P=j[K];if(typeof P!="function")throw new Error("Unknown method "+K+" on actor "+(0,O.getStringIdentifierForProxy)(L));return P.apply(j,q)}P(L,K,q){if(this.j)return new k.CanceledLazyPromise;let j=null;if(q.length>0&&y.CancellationToken.isCancellationToken(q[q.length-1])&&(j=q.pop()),j&&j.isCancellationRequested)return Promise.reject(N.canceled());const P=t.serializeRequestArguments(q,this.h),M=++this.m,F=String(M),$=new k.LazyPromise;j&&j.onCancellationRequested(()=>{const V=t.serializeCancel(M);this.f?.logOutgoing(V.byteLength,M,0,"cancel"),this.c.send(t.serializeCancel(M))}),this.s[F]=$,this.y(M);const z=t.serializeRequest(M,L,K,P,!!j);return this.f?.logOutgoing(z.byteLength,M,0,`request: ${(0,O.getStringIdentifierForProxy)(L)}.${K}(`,q),this.c.send(z),$}}e.RPCProtocol=d,I=r,d.a=3*1e3;class c{static alloc(L,K,q){const j=new c(T.VSBuffer.alloc(q+1+4),0);return j.writeUInt8(L),j.writeUInt32(K),j}static read(L,K){return new c(L,K)}get buffer(){return this.a}constructor(L,K){this.a=L,this.b=K}static sizeUInt8(){return 1}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const q=this.a.slice(this.b,this.b+L).toString();return this.b+=L,q}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+L).toString();return this.b+=L,q}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+L);return this.b+=L,K}static sizeMixedArray(L){let K=0;K+=1;for(let q=0,j=L.length;q<j;q++){const P=L[q];switch(K+=1,P.type){case 1:K+=this.sizeLongString(P.value);break;case 2:K+=this.sizeVSBuffer(P.value);break;case 3:K+=this.sizeUInt32,K+=this.sizeLongString(P.value);for(let M=0;M<P.buffers.length;++M)K+=this.sizeVSBuffer(P.buffers[M]);break;case 4:break}}return K}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let K=0,q=L.length;K<q;K++){const j=L[K];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let P=0;P<j.buffers.length;++P)this.writeBuffer(j.buffers[P]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const K=new Array(L);for(let q=0;q<L;q++)switch(this.readUInt8()){case 1:K[q]=this.readLongString();break;case 2:K[q]=this.readVSBuffer();break;case 3:{const P=this.readUInt32(),M=this.readLongString(),F=[];for(let $=0;$<P;++$)F.push(this.readVSBuffer());K[q]=new O.SerializableObjectWithBuffers(l(M,F,null));break}case 4:K[q]=void 0;break}return K}}c.sizeUInt32=4;var u;(function(A){A[A.Simple=0]="Simple",A[A.Mixed=1]="Mixed"})(u||(u={}));class t{static a(L){for(let K=0,q=L.length;K<q;K++)if(L[K]instanceof T.VSBuffer||L[K]instanceof O.SerializableObjectWithBuffers||typeof L[K]>"u")return!0;return!1}static serializeRequestArguments(L,K){if(this.a(L)){const q=[];for(let j=0,P=L.length;j<P;j++){const M=L[j];if(M instanceof T.VSBuffer)q[j]={type:2,value:M};else if(typeof M>"u")q[j]={type:4};else if(M instanceof O.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:$}=o(M.value,K);q[j]={type:3,value:T.VSBuffer.fromString(F),buffers:$}}else q[j]={type:1,value:T.VSBuffer.fromString(E(M,K))}}return{type:1,args:q}}return{type:0,args:E(L,K)}}static serializeRequest(L,K,q,j,P){switch(j.type){case 0:return this.b(L,K,q,j.args,P);case 1:return this.c(L,K,q,j.args,P)}}static b(L,K,q,j,P){const M=T.VSBuffer.fromString(q),F=T.VSBuffer.fromString(j);let $=0;$+=c.sizeUInt8(),$+=c.sizeShortString(M),$+=c.sizeLongString(F);const z=c.alloc(P?2:1,L,$);return z.writeUInt8(K),z.writeShortString(M),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(L){const K=L.readUInt8(),q=L.readShortString(),j=L.readLongString();return{rpcId:K,method:q,args:JSON.parse(j)}}static c(L,K,q,j,P){const M=T.VSBuffer.fromString(q);let F=0;F+=c.sizeUInt8(),F+=c.sizeShortString(M),F+=c.sizeMixedArray(j);const $=c.alloc(P?4:3,L,F);return $.writeUInt8(K),$.writeShortString(M),$.writeMixedArray(j),$.buffer}static deserializeRequestMixedArgs(L){const K=L.readUInt8(),q=L.readShortString(),j=L.readMixedArray(),P=new Array(j.length);for(let M=0,F=j.length;M<F;M++){const $=j[M];typeof $=="string"?P[M]=JSON.parse($):P[M]=$}return{rpcId:K,method:q,args:P}}static serializeAcknowledged(L){return c.alloc(5,L,0).buffer}static serializeCancel(L){return c.alloc(6,L,0).buffer}static serializeReplyOK(L,K,q){if(typeof K>"u")return this.d(L);if(K instanceof T.VSBuffer)return this.e(L,K);if(K instanceof O.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:P}=o(K.value,q,!0);return this.g(L,j,P)}else return this.f(L,f(K,q))}static d(L){return c.alloc(7,L,0).buffer}static e(L,K){let q=0;q+=c.sizeVSBuffer(K);const j=c.alloc(8,L,q);return j.writeVSBuffer(K),j.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,K){const q=T.VSBuffer.fromString(K);let j=0;j+=c.sizeLongString(q);const P=c.alloc(9,L,j);return P.writeLongString(q),P.buffer}static g(L,K,q){const j=T.VSBuffer.fromString(K);let P=0;P+=c.sizeUInt32,P+=c.sizeLongString(j);for(const F of q)P+=c.sizeVSBuffer(F);const M=c.alloc(10,L,P);M.writeUInt32(q.length),M.writeLongString(j);for(const F of q)M.writeBuffer(F);return M.buffer}static deserializeReplyOKJSON(L){const K=L.readLongString();return JSON.parse(K)}static deserializeReplyOKJSONWithBuffers(L,K){const q=L.readUInt32(),j=L.readLongString(),P=[];for(let M=0;M<q;++M)P.push(L.readVSBuffer());return new O.SerializableObjectWithBuffers(l(j,P,K))}static serializeReplyErr(L,K){const q=K?f(N.transformErrorForSerialization(K),null):void 0;if(typeof q!="string")return this.h(L);const j=T.VSBuffer.fromString(q);let P=0;P+=c.sizeLongString(j);const M=c.alloc(11,L,P);return M.writeLongString(j),M.buffer}static deserializeReplyErrError(L){const K=L.readLongString();return JSON.parse(K)}static h(L){return c.alloc(12,L,0).buffer}}var m;(function(A){A[A.RequestJSONArgs=1]="RequestJSONArgs",A[A.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",A[A.RequestMixedArgs=3]="RequestMixedArgs",A[A.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",A[A.Acknowledged=5]="Acknowledged",A[A.Cancel=6]="Cancel",A[A.ReplyOKEmpty=7]="ReplyOKEmpty",A[A.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",A[A.ReplyOKJSON=9]="ReplyOKJSON",A[A.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",A[A.ReplyErrError=11]="ReplyErrError",A[A.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var g;(function(A){A[A.String=1]="String",A[A.VSBuffer=2]="VSBuffer",A[A.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",A[A.Undefined=4]="Undefined"})(g||(g={}))}),define(De[232],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(N){const C=R=>{self.removeEventListener("message",C);const S=R.data;Object.defineProperties(self,{postMessage:{value(k,O){S.postMessage(k,O)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};self.addEventListener("message",C)}.toString();class T extends EventTarget{constructor(N,C,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${n})('${C}'))`,k=new Blob([S],{type:"application/javascript"}),O=URL.createObjectURL(k),I=new MessageChannel,f=O,v={type:"_newWorker",id:f,port:I.port2,url:O,options:R};N(v,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{N({type:"_terminateWorker",id:f}),URL.revokeObjectURL(O),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(h){I.port1.onmessage=h}},onmessageerror:{get(){return I.port1.onmessageerror},set(h){I.port1.onmessageerror=h}}}),I.port1.addEventListener("messageerror",h=>{const i=new MessageEvent("messageerror",{data:h.data});this.dispatchEvent(i)}),I.port1.addEventListener("message",h=>{const i=new MessageEvent("message",{data:h.data});this.dispatchEvent(i)}),I.port1.start()}}e.NestedWorker=T}),define(De[233],Ce([1,0,5,30,41,3,36,11,15]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(h){this.a.has(h.id)||(this.a.set(h.id,h),this.b.fire(h.id))}getChannels(){const h=[];return this.a.forEach(i=>h.push(i)),h}getChannel(h){return this.a.get(h)}removeChannel(h){this.a.delete(h),this.c.fire(h)}}T.Registry.add(e.Extensions.OutputChannels,new O);function I(v,h,i,o,l){return(0,S.createCancelablePromise)(async E=>{await(0,C.whenProviderRegistered)(i,o);const b=T.Registry.as(e.Extensions.OutputChannels);try{await f(i,1,o,l,E),b.registerChannel({id:v,label:h,file:i,log:!0})}catch(p){(0,R.isCancellationError)(p)||l.error("Error while registering log channel",i.toString(),(0,R.getErrorMessage)(p))}})}e.registerLogChannel=I;async function f(v,h,i,o,l){if(!await i.exists(v)){if(l.isCancellationRequested)throw new R.CancellationError;if(h>10)throw new Error("Timed out while waiting for file to be created");o.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",v.toString()),await(0,S.timeout)(1e3,l),await f(v,h+1,i,o,l)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(De[101],Ce([1,0,4,3,14,26,12,233,56,27,37,115,24,9,36,5,7]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends C.AbstractMessageLogger{get disposed(){return this.k}constructor(w,s,r,a,d){super(),this.id=w,this.name=s,this.l=r,this.m=a,this.extension=d,this.j=0,this.k=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.j;this.l.flush(),this.m.$update(this.id,R.OutputChannelUpdateMode.Clear,w)}replace(w){const s=this.j;this.info(w),this.m.$update(this.id,R.OutputChannelUpdateMode.Replace,s),this.visible&&this.l.flush()}show(w,s){this.l.flush(),this.m.$reveal(this.id,!!(typeof w=="boolean"?w:s))}hide(){this.m.$close(this.id)}f(w,s){this.j+=f.VSBuffer.fromString(s).byteLength,(0,C.log)(this.l,w,s),this.visible&&(this.l.flush(),this.m.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.k||(this.m.$dispose(this.id),this.k=!0)}}class E extends l{appendLine(w){this.append(w)}}let b=class{constructor(w,s,r,a,d,c){this.i=s,this.j=r,this.k=a,this.l=d,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[s,r]of this.g)r.visible=s===this.h}createOutputChannel(w,s,r){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const a=typeof s=="object"&&s.log,d=(0,v.isString)(s)?s:void 0;if((0,v.isString)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const u=this.i.environment.extensionLogLevel?.find(([m])=>N.ExtensionIdentifier.equals(r.identifier,m))?.[1];u&&(c=(0,C.parseLogLevel)(u));const t=a?this.o(w,c,r):this.n(w,d,r);return t.then(m=>{this.g.set(m.id,m),m.visible=m.id===this.h}),a?this.r(w,c??this.m.getLevel(),t):this.q(w,t)}async n(w,s,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(d,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.a.$register(w,d,!1,s,r.identifier.value);return new l(u,w,c,this.a,r)}async o(w,s,r){const a=await this.p(r),d=this.k.extUri.joinPath(a,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(d,{name:w},s),u=await this.a.$register(w,d,!0,void 0,r.identifier.value);return new E(u,w,c,this.a,r)}p(w){let s=this.d.get(w.identifier.value);if(!s){const r=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(r)}catch(a){if((0,h.toFileSystemProviderErrorCode)(a)!==h.FileSystemProviderErrorCode.FileExists)throw a}return r})())}return s}q(w,s){let r=!1;const a=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return w},append(d){a(),s.then(c=>c.append(d))},appendLine(d){a(),s.then(c=>c.appendLine(d))},clear(){a(),s.then(d=>d.clear())},replace(d){a(),s.then(c=>c.replace(d))},show(d,c){a(),s.then(u=>u.show(d,c))},hide(){a(),s.then(d=>d.hide())},dispose(){r=!0,s.then(d=>d.dispose())}}}r(w,s,r){const a=new o.DisposableStore,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},c=a.add(new i.Emitter);return r.then(u=>{a.add(u),a.add(u.onDidChangeLogLevel(t=>{s=t,c.fire(t)}))}),{...this.q(w,r),get logLevel(){return s},onDidChangeLogLevel:c.event,trace(u,...t){d(),r.then(m=>m.trace(u,...t))},debug(u,...t){d(),r.then(m=>m.debug(u,...t))},info(u,...t){d(),r.then(m=>m.info(u,...t))},warn(u,...t){d(),r.then(m=>m.warn(u,...t))},error(u,...t){d(),r.then(m=>m.error(u,...t))},dispose(){a.dispose()}}}};b=Ve([je(0,y.IExtHostRpcService),je(1,k.IExtHostInitDataService),je(2,S.IExtHostConsumerFileSystem),je(3,O.IExtHostFileSystemInfo),je(4,C.ILoggerService),je(5,C.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(De[234],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(De[235],Ce([1,0,39,13,19,21,22,2,3,164,49,179,234]),function(te,e,n,T,y,N,C,R,S,k,O,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let v=class rn{constructor(i,o,l,E){this.d=i,this.e=o,this.f=l,this.g=E,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??i})()}hasValidBasename(i,o,l){return typeof o=="string"||typeof o>"u"?this.a.then(E=>this.h(i,E,o)):this.h(i,o,l)}h(i,o,l){return i.scheme===T.Schemas.file||i.scheme===T.Schemas.vscodeRemote?(0,n.isValidBasename)(l??(0,C.basename)(i),o===1):!0}get defaultUriScheme(){return rn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(i,o){if(i.remoteAuthority)return T.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(l)return l;const E=o.getWorkspace().folders[0];if(E)return E.uri.scheme;const b=o.getWorkspace().configuration;return b?b.scheme:T.Schemas.file}userHome(i){return i?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(i=>i===1?y.win32:y.posix)}async fileURI(i){let o="";if(await this.a===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const E=i.indexOf("/",2);E===-1?(o=i.substring(2),i="/"):(o=i.substring(2,E),i=i.substring(E)||"/")}return R.URI.from({scheme:T.Schemas.file,authority:o,path:i,query:"",fragment:""})}};v=Ve([je(1,f.IRemoteAgentService),je(2,I.IWorkbenchEnvironmentService),je(3,O.IWorkspaceContextService)],v),e.AbstractPathService=v}),define(De[102],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(C,R){this.line=C,this.character=R}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,R){return new n(0,0)}with(C){return new n(0,0)}}e.Position=n;class T{constructor(C,R,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(C,R),this.end=new n(S,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new T(0,0,0,0)}with(C){return new T(0,0,0,0)}}e.Range=T;var y;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[44],Ce([1,0,16,35,23,39,10,3,19,11,102,15]),function(te,e,n,T,y,N,C,R,S,k,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",v=" characters skipped \u27EB",h=(f.length+v.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var i;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(i=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function l(oe){return!!oe.preview}e.resultIsMatch=l;function E(oe){return!!oe.resource}e.isFileMatch=E;function b(oe){return!!oe.message}e.isProgressMessage=b;var p;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(le){this.resource=le,this.results=[]}}e.FileMatch=w;class s{constructor(le,ce,me){this.ranges=ce;const Y=Array.isArray(ce)?ce:[ce];if(me&&me.matchLines===1&&r(Y)){le=(0,C.getNLines)(le,me.matchLines);let pe="",we=0,Fe=0;const We=Math.floor(me.charsPerLine/5),Xe=[];for(const Pe of Y){const Ie=Math.max(Pe.startColumn-We,0),ke=Pe.startColumn+me.charsPerLine;if(Ie>Fe+We+h){const re=f+(Ie-Fe)+v;pe+=re+le.slice(Ie,ke),we+=Ie-(Fe+re.length)}else pe+=le.slice(Fe,ke);Xe.push(new d(0,Pe.startColumn-we,Pe.endColumn-we)),Fe=ke}this.preview={text:pe,matches:Array.isArray(this.ranges)?Xe:Xe[0]}}else{const pe=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:le,matches:(0,n.mapArrayOrNot)(ce,we=>new a(we.startLineNumber-pe,we.startColumn,we.endLineNumber-pe,we.endColumn))}}}}e.TextSearchMatch=s;function r(oe){const le=oe[0].startLineNumber;for(const ce of oe)if(ce.startLineNumber!==le||ce.endLineNumber!==le)return!1;return!0}class a{constructor(le,ce,me,Y){this.startLineNumber=le,this.startColumn=ce,this.endLineNumber=me,this.endColumn=Y}}e.SearchRange=a;class d extends a{constructor(le,ce,me){super(le,ce,le,me)}}e.OneLineRange=d;var c;(function(oe){oe.List="list",oe.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var u;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function t(oe,le=!0){const ce=oe&&oe.files&&oe.files.exclude,me=le&&oe&&oe.search&&oe.search.exclude;if(!ce&&!me)return;if(!ce||!me)return ce||me;let Y=Object.create(null);return Y=y.mixin(Y,y.deepClone(ce)),Y=y.mixin(Y,y.deepClone(me),!0),Y}e.getExcludes=t;function m(oe,le){return oe.excludePattern&&T.match(oe.excludePattern,le)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&T.match(oe.includePattern,le)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ce=>{const me=ce.folder.fsPath;if(N.isEqualOrParent(le,me)){const Y=S.relative(me,le);return!ce.includePattern||!!T.match(ce.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var g;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(le,ce){super(le),this.code=ce}}e.SearchError=A;function L(oe){const le=oe.message;if((0,k.isCancellationError)(oe))return new A(le,g.canceled);try{const ce=JSON.parse(le);return new A(ce.message,ce.code)}catch{return new A(le,g.other)}}e.deserializeSearchError=L;function K(oe){const le={message:oe.message,code:oe.code};return new Error(JSON.stringify(le))}e.serializeSearchError=K;function q(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=q;function j(oe){return oe.type==="success"}e.isSerializedSearchSuccess=j;function P(oe){return!!oe.path}e.isSerializedFileMatch=P;function M(oe,le){const ce=oe.searchPath?oe.searchPath:oe.relativePath;return(0,C.fuzzyContains)(ce,le)}e.isFilePatternMatch=M;class F{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function $(oe,le){const ce={...oe||{},...le||{}};return Object.keys(ce).filter(me=>{const Y=ce[me];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=$;class z{constructor(le,ce){this.c=null,this.a={...le.excludePattern||{},...ce.excludePattern||{}},this.b=T.parse(this.a);let me=le.includePattern;ce.includePattern&&(me?me={...me,...ce.includePattern}:me=ce.includePattern),me&&(this.c=T.parse(me))}matchesExcludesSync(le,ce,me){return!!(this.b&&this.b(le,ce,me))}includedInQuerySync(le,ce,me){return!(this.b&&this.b(le,ce,me)||this.c&&!this.c(le,ce,me))}includedInQuery(le,ce,me){const Y=this.b(le,ce,me),pe=()=>this.c?!!this.c(le,ce,me):!0;return(0,I.isThenable)(Y)?Y.then(we=>we?!1:pe()):pe()}hasSiblingExcludeClauses(){return V(this.a)}}e.QueryGlobTester=z;function V(oe){for(const le in oe)if(typeof oe[le]!="boolean")return!0;return!1}function X(oe){if(!oe)return;let le;return ce=>(le||(le=(oe()||Promise.resolve([])).then(me=>me?fe(me):{})),le.then(me=>!!me[ce]))}e.hasSiblingPromiseFn=X;function Z(oe){if(!oe)return;let le;return ce=>{if(!le){const me=oe();le=me?fe(me):{}}return!!le[ce]}}e.hasSiblingFn=Z;function fe(oe){const le={};for(const ce of oe)le[ce]=!0;return le}}),define(De[31],Ce([1,0,16,15,20,5,7,46,13,109,22,10,9,2,138,3,12,153,49,37,27,14,8,6,51,44,4]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b,p,w,s,r,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(j,P,M){return new O.ExtUri(F=>A(F,M)).isEqual(j,P)}function t(j,P,M){return u(j.uri,P.uri,M)?0:(0,I.compare)(j.uri.toString(),P.uri.toString())}function m(j,P,M){return j.index!==P.index?j.index<P.index?-1:1:u(j.uri,P.uri,M)?(0,I.compare)(j.name,P.name):(0,I.compare)(j.uri.toString(),P.uri.toString())}function g(j,P,M,F){const $=j.slice(0).sort((V,X)=>M(V,X,F)),z=P.slice(0).sort((V,X)=>M(V,X,F));return(0,n.delta)($,z,(V,X)=>M(V,X,F))}function A(j,P){const M=P.getCapabilities(j.scheme);return!(M&&M&1024)}class L extends E.Workspace{static toExtHostWorkspace(P,M,F,$){if(!P)return{workspace:null,added:[],removed:[]};const{id:z,name:V,folders:X,configuration:Z,transient:fe,isUntitled:oe}=P,le=[],ce=M;M?X.forEach((we,Fe)=>{const We=v.URI.revive(we.uri),Xe=L.e(F||M,We,$);Xe?(Xe.name=we.name,Xe.index=we.index,le.push(Xe)):le.push({uri:We,name:we.name,index:Fe})}):le.push(...X.map(({uri:we,name:Fe,index:We})=>({uri:v.URI.revive(we),name:Fe,index:We}))),le.sort((we,Fe)=>we.index<Fe.index?-1:1);const me=new L(z,V,le,!!fe,Z?v.URI.revive(Z):null,!!oe,we=>A(we,$)),{added:Y,removed:pe}=g(ce?ce.workspaceFolders:[],me.workspaceFolders,t,$);return{workspace:me,added:Y,removed:pe}}static e(P,M,F){for(let $=0;$<P.folders.length;$++){const z=P.workspaceFolders[$];if(u(z.uri,M,F))return z}}constructor(P,M,F,$,z,V,X){super(P,F.map(Z=>new E.WorkspaceFolder(Z)),$,z,X),this.s=M,this.t=V,this.o=[],this.q=R.TernarySearchTree.forUris(X),F.forEach(Z=>{this.o.push(Z),this.q.set(Z.uri,Z)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(P,M){return M&&this.q.get(P)&&(P=(0,O.dirname)(P)),this.q.findSubstr(P)}resolveWorkspaceFolder(P){return this.q.get(P)}}let K=class{constructor(P,M,F,$,z){this.c=new N.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new N.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=$,this.q=F,this.s=z,this.h=new k.Counter,this.j=new T.Barrier,this.n=P.getProxy(c.MainContext.MainThreadWorkspace),this.o=P.getProxy(c.MainContext.MainThreadMessageService);const V=M.workspace;this.k=V?new L(V.id,V.name,[],!!V.transient,V.configuration?v.URI.revive(V.configuration):null,!!V.isUntitled,X=>A(X,F)):void 0}$initializeWorkspace(P,M){this.u=M,this.$acceptWorkspaceData(P),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?v.URI.from({scheme:S.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(P,M,F,...$){const z=[];if(Array.isArray($)&&$.forEach(oe=>{v.URI.isUri(oe.uri)&&!z.some(le=>u(le.uri,oe.uri,this.q))&&z.push({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri)})}),this.l||[M,F].some(oe=>typeof oe!="number"||oe<0)||F===0&&z.length===0)return!1;const V=this.w?this.w.workspaceFolders:[];if(M+F>V.length)return!1;const X=V.slice(0);X.splice(M,F,...z.map(oe=>({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<X.length;oe++){const le=X[oe];if(X.some((ce,me)=>me!==oe&&u(le.uri,ce.uri,this.q)))return!1}X.forEach((oe,le)=>oe.index=le);const{added:Z,removed:fe}=g(V,X,m,this.q);if(Z.length===0&&fe.length===0)return!1;if(this.n){const oe=P.displayName||P.name;this.n.$updateWorkspaceFolders(oe,M,F,z).then(void 0,le=>{this.l=void 0;const ce={source:{identifier:P.identifier,label:P.displayName||P.name}};this.o.$showMessage(l.Severity.Error,(0,h.localize)(0,null,oe,le.toString()),ce,[])})}return this.x(X),!0}getWorkspaceFolder(P,M){if(!!this.w)return this.w.getWorkspaceFolder(P,M)}async getWorkspaceFolder2(P,M){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(P,M)}async resolveWorkspaceFolder(P){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(P)}getPath(){if(!this.w)return;const{folders:P}=this.w;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,M){let F,$="";if(typeof P=="string"?(F=v.URI.file(P),$=P):typeof P<"u"&&(F=P,$=P.fsPath),!F)return $;const z=this.getWorkspaceFolder(F,!0);if(!z)return $;typeof M>"u"&&this.w&&(M=this.w.folders.length>1);let V=(0,O.relativePath)(z.uri,F);return M&&z.name&&(V=`${z.name}/${V}`),V}x(P){this.w&&(this.l=L.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:P,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:M,added:F,removed:$}=L.toExtHostWorkspace(P,this.k,this.l,this.q);this.k=M||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:$}))}findFiles(P,M,F,$,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let V;if(M===null?V=!1:M&&(typeof M=="string"?V=M:V=M.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:Z}=q(s.GlobPattern.from(P));return this.n.$startFileSearch((0,f.withUndefinedAsNull)(X),(0,f.withUndefinedAsNull)(Z),(0,f.withUndefinedAsNull)(V),(0,f.withUndefinedAsNull)(F),z).then(fe=>Array.isArray(fe)?fe.map(oe=>v.URI.revive(oe)):[])}async findTextInFiles(P,M,F,$,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const V=this.h.getNext(),X=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:Z,folder:fe}=q(s.GlobPattern.from(M.include)),oe=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,le={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:X,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:Z,excludePattern:oe},ce=!1;if(this.t[V]=me=>{if(ce)return;const Y=v.URI.revive(me.resource);me.results.forEach(pe=>{(0,d.resultIsMatch)(pe)?F({uri:Y,preview:{text:pe.preview.text,matches:(0,n.mapArrayOrNot)(pe.preview.matches,we=>new r.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,n.mapArrayOrNot)(pe.ranges,we=>new r.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):F({uri:Y,text:pe.text,lineNumber:pe.lineNumber})})},z.isCancellationRequested)return{};try{const me=await this.n.$startTextSearch(P,(0,f.withUndefinedAsNull)(fe),le,V,z);return delete this.t[V],me||{}}catch(me){throw delete this.t[V],me}}$handleTextSearchResult(P,M){this.t[M]?.(P)}saveAll(P){return this.n.$saveAll(P)}resolveProxy(P){return this.n.$resolveProxy(P)}get trusted(){return this.u}requestWorkspaceTrust(P){return this.n.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(P,M){if(this.v.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this.v.set(P,M);const F=this.s.transformOutgoingScheme(P),$=this.y++;return this.n.$registerEditSessionIdentityProvider($,F),(0,C.toDisposable)(()=>{this.v.delete(P),this.n.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(P,M){this.g.info("Getting edit session identifier for workspaceFolder",P);const F=await this.resolveWorkspaceFolder(v.URI.revive(P));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const $=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!$),!$)return;const z=await $.provideEditSessionIdentity(F,M);if(this.g.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(P,M,F,$){this.g.info("Getting edit session identifier for workspaceFolder",P);const z=await this.resolveWorkspaceFolder(v.URI.revive(P));if(!z){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const V=this.v.get(z.uri.scheme);if(this.g.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!V),!V)return;const X=await V.provideEditSessionIdentityMatch?.(M,F,$);if(this.g.info("Provider returned edit session identifier match result: ",X),!!X)return X}};K=Ve([je(0,w.IExtHostRpcService),je(1,p.IExtHostInitDataService),je(2,b.IExtHostFileSystemInfo),je(3,o.ILogService),je(4,a.IURITransformerService)],K),e.ExtHostWorkspace=K,e.IExtHostWorkspace=(0,i.createDecorator)("IExtHostWorkspace");function q(j){let P,M;return j&&(typeof j=="string"?P=j:(P=j.pattern,M=v.URI.revive(j.baseUri))),{includePattern:P,folder:M}}}),define(De[32],Ce([1,0,23,5,31,4,6,156,89,9,15,3,14,12,2]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function i(r,a){if(a){const d=a.split(".");let c=r;for(let u=0;c&&u<d.length;u++)c=c[d[u]];return c}}function o(r){return r instanceof h.URI}function l(r){return r&&r.uri instanceof h.URI&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&r.uri instanceof h.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function p(r){if(o(r))return{resource:r};if(l(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(E(r))return{overrideIdentifier:r.languageId};if(b(r))return{resource:r.uri};if(r===null)return{resource:null}}let w=class{constructor(a,d,c){this.a=a.getProxy(N.MainContext.MainThreadConfiguration),this.c=d,this.b=c,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new s(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,d))}};w=Ve([je(0,f.IExtHostRpcService),je(1,y.IExtHostWorkspace),je(2,v.ILogService)],w),e.ExtHostConfiguration=w;class s{constructor(a,d,c,u){this.a=new T.Emitter,this.b=a,this.f=u,this.c=d,this.e=R.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,c))}getConfiguration(a,d,c){const u=p(d)||{},t=this.g(a?i(this.e.getValue(void 0,u,this.c.workspace),a):this.e.getValue(void 0,u,this.c.workspace));a&&this.h(a,u,c?.identifier);function m(A){if(A==null)return null;if(typeof A=="boolean")return A?2:5;switch(A){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(A){return typeof i(t,A)<"u"},get:(A,L)=>{this.h(a?`${a}.${A}`:A,u,c?.identifier);let K=i(t,A);if(typeof K>"u")K=L;else{let q;const j=(P,M)=>{let F;const $=()=>{q=q||(0,n.deepClone)(t),F=F||i(q,M)};return(0,k.isObject)(P)?new Proxy(P,{get:(z,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return $(),()=>F;if(q)return F=F||i(q,M),F[V];const X=z[V];return typeof V=="string"?j(X,`${M}.${V}`):X},set:(z,V,X)=>($(),F&&(F[V]=X),!0),deleteProperty:(z,V)=>($(),F&&delete F[V],!0),defineProperty:(z,V,X)=>($(),F&&Object.defineProperty(F,V,X),!0)}):P};K=j(K,A)}return K},update:(A,L,K,q)=>{A=a?`${a}.${A}`:A;const j=m(K);return L!==void 0?this.b.$updateConfigurationOption(j,A,L,u,q):this.b.$removeConfigurationOption(j,A,u,q)},inspect:A=>{A=a?`${a}.${A}`:A;const L=this.e.inspect(A,u,this.c.workspace);if(L)return{key:A,defaultValue:(0,n.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,n.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,n.deepClone)(L.workspace?.value),workspaceFolderValue:(0,n.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(L.default?.override),globalLanguageValue:(0,n.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,n.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(L.workspaceFolder?.override),languageIds:(0,n.deepClone)(L.overrideIdentifiers)}}};return typeof t=="object"&&(0,n.mixin)(g,t,!1),Object.freeze(g)}g(a){const d=c=>(0,k.isObject)(c)?new Proxy(c,{get:(u,t)=>d(u[t]),set:(u,t,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(t)}' of object`)},deleteProperty:(u,t)=>{throw new Error(`TypeError: Cannot delete read only property '${String(t)}' of object`)},defineProperty:(u,t)=>{throw new Error(`TypeError: Cannot define property '${String(t)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return d(a)}h(a,d,c){const u=S.OVERRIDE_PROPERTY_REGEX.test(a)?4:this.d.get(a),t=c?`[${c.value}] `:"";if(u===4){typeof d?.resource>"u"&&this.f.warn(`${t}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){d?.resource&&this.f.warn(`${t}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const c=new R.ConfigurationChangeEvent(a,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,t)=>c.affectsConfiguration(u,p(t))})}k(a){return a.reduce((d,c)=>(d.set(c[0],c[1]),d),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(De[103],Ce([1,0,2,15,5,4,6,31,54,32,20,57,14,27,3,13,21,12,72,192,11]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b,p){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(P){function M($){if($!=null)return $}P.from=M;function F($){if($!=null)return $}P.to=F})(s||(s={}));var r;(function(P){function M($){if($!=null)return $}P.from=M;function F($){if($!=null)return $}P.to=F})(r||(r={}));var a;(function(P){function M($){if($!=null)return $}P.from=M;function F($){if($!=null)return $}P.to=F})(a||(a={}));var d;(function(P){function M(z){if(z){const V=z;return V&&!!V.process}else return!1}P.is=M;function F(z){if(z==null)return;const V={process:z.process,args:z.args};return z.options&&(V.options=a.from(z.options)),V}P.from=F;function $(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}P.to=$})(d||(d={}));var c;(function(P){function M($){if($!=null)return $}P.from=M;function F($){if($!=null)return $}P.to=F})(c||(c={}));var u;(function(P){function M(z){if(z){const V=z;return V&&(!!V.commandLine||!!V.command)}else return!1}P.is=M;function F(z){if(z==null)return;const V={};return z.commandLine!==void 0?V.commandLine=z.commandLine:(V.command=z.command,V.args=z.args),z.options&&(V.options=c.from(z.options)),V}P.from=F;function $(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}P.to=$})(u||(u={}));var t;(function(P){function M(z){if(z){const V=z;return V&&V.customExecution==="customExecution"}else return!1}P.is=M;function F(z){return{customExecution:"customExecution"}}P.from=F;function $(z,V){return V.get(z)}P.to=$})(t=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(P){function M(F,$){let z;return F.scope!==void 0&&typeof F.scope!="number"?z=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===C.TaskScope.Workspace&&$&&$.workspaceFile?z=$.workspaceFile:z=b.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:z}}P.from=M})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(P){function M(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}P.from=M})(g||(g={}));var A;(function(P){function M(z,V){if(z==null)return[];const X=[];for(const Z of z){const fe=F(Z,V);fe&&X.push(fe)}return X}P.fromMany=M;function F(z,V){if(z==null)return;let X;z.execution instanceof C.ProcessExecution?X=d.from(z.execution):z.execution instanceof C.ShellExecution?X=u.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(X=t.from(z.execution));const Z=s.from(z.definition);let fe;return z.scope?typeof z.scope=="number"?fe=z.scope:fe=z.scope.uri:fe=C.TaskScope.Workspace,!Z||!fe?void 0:{_id:z._id,definition:Z,name:z.name,source:{extensionId:V.identifier.value,label:z.source,scope:fe},execution:X,isBackground:z.isBackground,group:g.from(z.group),presentationOptions:r.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}P.from=F;async function $(z,V,X){if(z==null)return;let Z;d.is(z.execution)?Z=d.to(z.execution):u.is(z.execution)?Z=u.to(z.execution):t.is(z.execution)&&(Z=t.to(z._id,X));const fe=s.to(z.definition);let oe;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?oe=z.source.scope:oe=await V.resolveWorkspaceFolder(n.URI.revive(z.source.scope)):oe=C.TaskScope.Workspace),!fe||!oe)return;const le=new C.Task(fe,oe,z.name,z.source.label,Z,z.problemMatchers);return z.isBackground!==void 0&&(le.isBackground=z.isBackground),z.group!==void 0&&(le.group=C.TaskGroup.from(z.group._id),le.group&&z.group.isDefault&&(le.group=new C.TaskGroup(le.group.id,le.group.label),z.group.isDefault===!0&&(le.group.isDefault=z.group.isDefault))),z.presentationOptions&&(le.presentationOptions=r.to(z.presentationOptions)),z._id&&(le._id=z._id),z.detail&&(le.detail=z.detail),le}P.to=$})(A=e.TaskDTO||(e.TaskDTO={}));var L;(function(P){function M($){return $}P.from=M;function F($){if(!!$)return Object.assign(Object.create(null),$)}P.to=F})(L||(L={}));class K{constructor(M,F,$){this._id=F,this.a=$,w.set(this,void 0),Ye(this,w,M,"f")}get task(){return this.a}terminate(){Re(this,w,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}w=new WeakMap;let q=class{constructor(M,F,$,z,V,X,Z,fe){this.q=new y.Emitter,this.r=new y.Emitter,this.s=new y.Emitter,this.t=new y.Emitter,this.a=M.getProxy(N.MainContext.MainThreadTask),this.b=$,this.c=z,this.d=V,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Z,this.g=fe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,F,$){if(!$)return new C.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:F,provider:$,extension:M}),this.a.$registerTaskProvider(z,F),new C.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(M,F){this.a.$registerTaskSystem(M,F)}fetchTasks(M){return this.a.$fetchTasks(L.from(M)).then(async F=>{const $=[];for(const z of F){const V=await A.to(z,this.b,this.m);V&&$.push(V)}return $})}get taskExecutions(){const M=[];return this.k.forEach(F=>M.push(F)),M}terminateTask(M){if(!(M instanceof K))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,F,$){const z=this.m.get(M.id);z&&(this.o.set(M.id,z),this.e.attachPtyToTerminal(F,await z.callback($))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const F=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.B(M),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const F=await this.y(M.id);this.s.fire({execution:F,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const F=await this.y(M.id);this.t.fire({execution:F,exitCode:M.exitCode})}$provideTasks(M,F){const $=this.j.get(M);if(!$)return Promise.reject(new Error("no handler found"));const z=[],V=(0,T.asPromise)(()=>$.provider.provideTasks(O.CancellationToken.None)).then(X=>this.u(F,z,$,X));return new Promise(X=>{V.then(Z=>{Promise.all(z).then(()=>{X(Z)})})})}async $resolveTask(M,F){const $=this.j.get(M);if(!$)return Promise.reject(new Error("no handler found"));if(F.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${$.type}].`);const z=await A.to(F,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const V=await $.provider.resolveTask(z,O.CancellationToken.None);if(!V)return;this.A(V,$);const X=A.from(V,$.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return t.is(X.execution)&&await this.x(X,V,!0),await this.v(X)}w(){return this.h++}async x(M,F,$){const z=await this.a.$createTaskId(M);!$&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,F.execution)),this.m.set(z,F.execution)}async y(M,F){if(typeof M=="string"){const V=this.l.get(M);if(!V)throw new p.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const $=this.l.get(M.id);if($)return $;const z=new Promise((V,X)=>{function Z(fe,oe,le){le?V(new K(fe,oe.id,le)):X("Unexpected: Task does not exist.")}F?Z(this,M,F):A.to(M.task,this.b,this.m).then(fe=>Z(this,M,fe))});return this.l.set(M.id,z),z.then(V=>(this.k.set(M.id,V),V),V=>Promise.reject(V))}A(M,F){M._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const $=this.n.values();let z=$.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=$.next()}};q=Ve([je(0,f.IExtHostRpcService),je(1,v.IExtHostInitDataService),je(2,R.IExtHostWorkspace),je(3,S.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,I.IExtHostTerminalService),je(6,l.ILogService),je(7,E.IExtHostApiDeprecationService)],q),e.ExtHostTaskBase=q;let j=class extends q{constructor(M,F,$,z,V,X,Z,fe){super(M,F,$,z,V,X,Z,fe),this.registerTaskSystem(i.Schemas.vscodeRemote,{scheme:i.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(M,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const $=A.from(F,M);if($===void 0)throw new Error("Task is not valid");if(t.is($.execution))await this.x($,F,!1);else throw new p.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution($),F);return this.a.$executeTask($).catch(V=>{throw new Error(V)}),z}u(M,F,$,z){const V=[];if(z)for(const X of z){this.A(X,$),(!X.definition||!M[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const Z=A.from(X,$.extension);Z&&t.is(Z.execution)?(V.push(Z),F.push(this.x(Z,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:$.extension}}async v(M){if(t.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,F,$){}};j=Ve([je(0,f.IExtHostRpcService),je(1,v.IExtHostInitDataService),je(2,R.IExtHostWorkspace),je(3,S.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,I.IExtHostTerminalService),je(6,l.ILogService),je(7,E.IExtHostApiDeprecationService)],j),e.WorkerExtHostTask=j,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(De[236],Ce([1,0,19,20,45,35,22,210,44]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(f,v,h){this.k=f,this.l=v,this.o=h,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&N.parse(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&N.parse(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const v=this.k.folderQueries||[];return new Promise((h,i)=>{const o=l=>{this.f++,f(l)};if(this.g)return h({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const E=l.toString(),b=n.basename(E);this.j&&this.j(E,b)||this.v(o,{base:l,basename:b})}),Promise.all(v.map(l=>this.p(l,o))).then(l=>{h({limitHit:this.e,stats:l[0]||void 0})},l=>{i(new Error((0,y.toErrorMessage)(l)))})})}async p(f,v){const h=new T.CancellationTokenSource,i=this.q(f),o=this.r(),l=new S.QueryGlobTester(this.k,f),E=!l.hasSiblingExcludeClauses();let b;try{this.h.add(h),b=R.StopWatch.create();const p=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},i,h.token),w=b.elapsed(),s=R.StopWatch.create();return this.g&&!this.e||(p&&p.forEach(r=>{const a=n.posix.relative(f.folder.path,r.path);if(E){const d=n.basename(r.path);this.v(v,{base:f.folder,relativePath:a,basename:d});return}this.s(o,f.folder,a,v)}),this.g&&!this.e)?null:(this.u(o,l,v),{providerTime:w,postProcessTime:s.elapsed()})}finally{h.dispose(),this.h.delete(h)}}q(f){const v=(0,S.resolvePatternsForProvider)(this.k.includePattern,f.includePattern),h=(0,S.resolvePatternsForProvider)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:h,includes:v,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},v,h,i){if(h===this.a){const l=n.basename(this.a);this.v(i,{base:v,relativePath:this.a,basename:l})}function o(l){const E=n.basename(l),b=n.dirname(l);let p=f[b];p||(p=f[b]=[],o(b)),p.push({base:v,relativePath:l,basename:E})}o(h)}u({rootEntries:f,pathToEntries:v},h,i){const o=this,l=this.a;function E(b){const p=(0,S.hasSiblingFn)(()=>b.map(w=>w.basename));for(let w=0,s=b.length;w<s;w++){const r=b[w],{relativePath:a,basename:d}=r;if(h.matchesExcludesSync(a,d,l!==d?p:void 0))continue;const c=v[a];if(c)E(c);else{if(a===l)continue;o.v(i,r)}if(o.e)break}}E(f)}v(f,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(v))}}class O{constructor(){this.b=new Map}fileSearch(f,v,h,i){const o=this.c(f.cacheKey),l=new k(f,v,o&&o.token);let E=0;const b=p=>{E+=p.length,h(p.map(w=>this.d(w)))};return this.e(l,O.a,b,i).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:p.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(!!f)return this.b.has(f)||this.b.set(f,new T.CancellationTokenSource),this.b.get(f)}d(f){return f.relativePath?{resource:C.joinPath(f.base,f.relativePath)}:{resource:f.base}}e(f,v,h,i){i.onCancellationRequested(()=>{f.cancel()});const o=E=>{E&&(l.push(E),v>0&&l.length>=v&&(h(l),l=[]))};let l=[];return f.search(o).then(E=>(l.length&&h(l),E),E=>(l.length&&h(l),Promise.reject(E)))}}e.FileSearchManager=O,O.a=512}),define(De[237],Ce([1,0,16,78,35,82,28,13,19,22,10,9,2,253,146,40,12,49,94,235,44]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(g,A,L,K,q){this.a=g,this.b=A,this.c=L,this.d=K,this.e=q}text(g,A,L={}){g=this.f(g,L);const K=this.a.getValue(),q=A&&A.some(P=>!this.a.getValue({resource:P}).search.useRipgrep);return{...this.h(A?.map(l.toWorkspaceFolder),L),type:2,contentPattern:g,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:K.search.usePCRE2||q||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(g,A){const L=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const K={...g,wordSeparators:L.editor.wordSeparators};return this.j(g,A)&&(K.isCaseSensitive=!0),this.k(g)&&(K.isMultiline=!0),K}file(g,A={}){return{...this.h(g,A),type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey}}g(g,A){return g?(g=Array.isArray(g)?g.map(c):c(g),A?this.parseSearchPaths(g):{pattern:r(...Array.isArray(g)?g:[g])}):{}}h(g=[],A={}){const L=this.g(A.includePattern,A.expandPatterns),K=this.g(A.excludePattern,A.expandPatterns),q=g.length>1,j=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(F=>this.q(F,A,K)):g.map(F=>this.r(F,A,K,q))).filter(F=>!!F),P={_reason:A._reason,folderQueries:j,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:K.pattern,includePattern:L.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const F=n.coalesce(n.flatten(this.c.groups.map(V=>V.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const $=F.filter(V=>(0,p.pathIncludedInQuery)(P,V.fsPath)),z=this.i($);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...P,...z}}const M=A.extraFileResources&&A.extraFileResources.filter(F=>(0,p.pathIncludedInQuery)(P,F.fsPath));return P.extraFileResources=M&&M.length?M:void 0,P}i(g){const A=[],L=new C.ResourceMap,K={};let q=!1;return g.forEach(j=>{if(j.scheme===R.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(j)){const M=this.b.getWorkspaceFolder(j)?.uri??j.with({path:S.dirname(j.fsPath)});let F=L.get(M);F||(q=!0,F={folder:M,includePattern:{}},A.push(F),L.set(M,F));const $=S.relative(M.fsPath,j.fsPath);(0,I.assertIsDefined)(F.includePattern)[$.replace(/\\/g,"/")]=!0}else j.fsPath&&(q=!0,K[j.fsPath]=!0)}),{folderQueries:A,includePattern:K,usingSearchPaths:!0,excludePattern:q?void 0:{"**/*":!0}}}j(g,A){if(A.isSmartCase){if(g.isRegExp){if(O.containsUppercaseCharacter(g.pattern,!0))return!0}else if(O.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,v.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const A=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),K=(Array.isArray(g)?g:a(g)).map(z=>{const V=this.e.resolvedUserHome;return V?(0,N.untildify)(z,V.scheme===R.Schemas.file?V.fsPath:V.path):z}),q=T.groupBy(K,z=>A(z)?"searchPaths":"exprSegments"),j=(q.exprSegments||[]).map(z=>O.rtrim(z,"/")).map(z=>O.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),d(z))),P={},M=this.m(q.searchPaths||[]);M&&M.length&&(P.searchPaths=M);const F=n.flatten(j),$=r(...F);return $&&(P.pattern=$),P}l(g,A){return A.disregardExcludeSettings?void 0:(0,p.getExcludes)(g,!A.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const A=n.flatten(g.map(K=>{let{pathPortion:q,globPortion:j}=s(K);j&&(j=u(j));const P=this.n(q);return n.flatten(P.map(M=>this.o(M,j)))})),L=new Map;return A.forEach(K=>{const q=K.searchPath.toString(),j=L.get(q);j?K.pattern&&(j.pattern=j.pattern||{},j.pattern[K.pattern]=!0):L.set(q,{searchPath:K.searchPath,pattern:K.pattern?r(K.pattern):void 0})}),Array.from(L.values())}n(g){if(S.isAbsolute(g)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==R.Schemas.file?[{searchPath:A[0].uri.with({path:g})}]:[{searchPath:f.URI.file(S.normalize(g))}]}if(this.b.getWorkbenchState()===2){const A=this.b.getWorkspace().folders[0].uri;if(g=c(g),g.startsWith("../")||g===".."){const K=S.posix.resolve(A.path,g);return[{searchPath:A.with({path:K})}]}const L=u(g);return[{searchPath:A,pattern:L}]}else{if(g==="./"||g===".\\")return[];{const A=g.replace(/^\.[\/\\]/,""),K=this.b.getWorkspace().folders.map(q=>{const j=A.match(new RegExp(`^${O.escapeRegExpCharacters(q.name)}(?:/(.*)|$)`));return j?{match:j,folder:q}:null}).filter(I.isDefined);if(K.length)return K.map(q=>{const j=q.match[1];return{searchPath:q.folder.uri,pattern:j&&u(j)}});{const q=g.match(/\.[\/\\](.+)[\/\\]?/),j=q?q[1]:g,P=h.localize(0,null,j);throw new Error(P)}}}}o(g,A){const L=g.pattern&&A?`${g.pattern}/${A}`:g.pattern||A,K=[{searchPath:g.searchPath,pattern:L}];return L&&!L.endsWith("**")&&K.push({searchPath:g.searchPath,pattern:L+"/**"}),K}q(g,A,L){const K=this.r((0,l.toWorkspaceFolder)(g.searchPath),A,L,!1);return K?{...K,includePattern:g.pattern}:null}r(g,A,L,K){let q;const j=f.URI.isUri(g)?g:g.uri;if(L.searchPaths){const z=L.searchPaths.filter(V=>(0,k.isEqual)(V.searchPath,j))[0];if(z&&!z.pattern)return null;z&&(q=z.pattern)}const P=this.a.getValue({resource:j}),F={...this.l(P,A)||{},...q||{}},$=f.URI.isUri(g)?(0,k.basename)(g):g.name;return{folder:j,folderName:K?$:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:P.files&&P.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!P.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!P.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!P.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!P.search.followSymlinks}}};w=Ve([je(0,i.IConfigurationService),je(1,l.IWorkspaceContextService),je(2,E.IEditorGroupsService),je(3,o.ILogService),je(4,b.IPathService)],w),e.QueryBuilder=w;function s(m){const g=m.match(/[\*\{\}\(\)\[\]\?]/);if(g){const A=g.index,L=m.substr(0,A).match(/[/|\\][^/\\]*$/);if(L){let K=m.substr(0,L.index);return K.match(/[/\\]/)||(K+="/"),{pathPortion:K,globPortion:m.substr((L.index||0)+1)}}}return{pathPortion:m}}function r(...m){return m.length?m.reduce((g,A)=>(g[A]=!0,g),Object.create(null)):void 0}function a(m){return y.splitGlobAware(m,",").map(g=>g.trim()).filter(g=>!!g.length)}function d(m){return[`**/${m}/**`,`**/${m}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function c(m){return m.replace(/\\/g,"/")}function u(m){return c(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function t(m,g){m=n.distinct(m,K=>K.toString());const A=[],L=g.getWorkspace();return m&&m.forEach(K=>{let q;if(g.getWorkbenchState()===2)q=(0,k.relativePath)(L.folders[0].uri,K),q&&q!=="."&&(q="./"+q);else{const j=g.getWorkspaceFolder(K);if(j){const P=j.name;if(L.folders.filter(F=>F.name===P).length===1){const F=(0,k.relativePath)(j.uri,K);F===""?q=`./${j.name}`:q=`./${j.name}/${F}`}else q=K.fsPath}}q&&A.push(q)}),A}e.resolveResourcesForSearchIncludes=t}),define(De[238],Ce([1,0,22,2,20,11,3,237,44,49]),function(te,e,n,T,y,N,C,R,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function I(i,o){const l=o.activationEvents;if(!l)return Promise.resolve(void 0);const E=[],b=[];for(const d of l)if(/^workspaceContains:/.test(d)){const c=d.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||i.forceUsingSearch?b.push(c):E.push(c)}if(E.length===0&&b.length===0)return Promise.resolve(void 0);let p;const w=new Promise((d,c)=>{p=d}),s=d=>p({activationEvent:d}),r=Promise.all(E.map(d=>f(i,d,s))).then(()=>{}),a=v(i,o.identifier,b,s);return Promise.all([r,a]).then(()=>{p(void 0)}),w}e.checkActivateWorkspaceContainsExtension=I;async function f(i,o,l){for(const E of i.folders)if(await i.exists(n.joinPath(T.URI.revive(E),o))){l(`workspaceContains:${o}`);return}}async function v(i,o,l,E){if(l.length===0)return Promise.resolve(void 0);const b=new y.CancellationTokenSource,p=i.checkExists(i.folders,l,b.token),w=setTimeout(async()=>{b.cancel(),i.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},O);let s=!1;try{s=await p}catch(r){N.isCancellationError(r)||N.onUnexpectedError(r)}b.dispose(),clearTimeout(w),s&&E(`workspaceContains:${l.join(",")}`)}function h(i,o,l,E){const b=i.get(C.IInstantiationService),p=i.get(S.ISearchService),s=b.createInstance(R.QueryBuilder).file(o.map(r=>(0,k.toWorkspaceFolder)(T.URI.revive(r))),{_reason:"checkExists",includePattern:l,exists:!0});return p.fileSearch(s,E).then(r=>!!r.limitHit,r=>N.isCancellationError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=h});var Ye=this&&this.__classPrivateFieldSet||function(te,e,n,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(te,n):y?y.value=n:e.set(te,n),n},Re=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(De[33],Ce([1,0,133,19,77,22,15,7,46,2,12,4,32,181,75,31,25,180,11,26,24,165,6,90,3,27,76,14,62,65,57,5,238,74,167,13,73]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b,p,w,s,r,a,d,c,u,t,m,g,A,L,K,q,j,P){"use strict";var M,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let z=class Ri extends R.Disposable{constructor(ce,me,Y,pe,we,Fe,We,Xe,Pe,Ie,ke){super(),this.a=this.B(new A.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=me,this.g=Y,this.f=We,this.j=pe,this.k=we,this.l=Fe,this.m=Pe,this.p=Ie,this.s=ke,this.t=this.g.getProxy(I.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(I.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(I.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.C=new C.Barrier,this.D=new C.Barrier,this.G=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const re=(0,o.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.F=new l.ExtensionDescriptionRegistry(Z(this.G,re)),this.H=new h.ExtHostStorage(this.g,this.l),this.I=new K.ExtHostSecretState(this.g),this.J=Xe,this.h=ce.createChild(new t.ServiceCollection([h.IExtHostStorage,this.H],[K.IExtHostSecretState,this.I]));let ae=[],J=[];this.f.remote.isRemote&&(ae=this.f.allExtensions.filter(U=>!U.main&&!U.browser).map(U=>U.identifier),J=this.f.allExtensions.filter(U=>!re.has(b.ExtensionIdentifier.toKey(U.identifier.value))).filter(U=>(U.main||U.browser)&&U.api==="none").map(U=>U.identifier));const D=(0,o.extensionIdentifiersArrayToSet)(J);this.L=this.B(new v.ExtensionsActivator(this.F,ae,J,{onExtensionActivationError:(U,H,G)=>{this.v.$onExtensionActivationError(U,E.transformErrorForSerialization(H),G)},actualActivateExtension:async(U,H)=>{if(D.has(b.ExtensionIdentifier.toKey(U)))return await this.v.$activateExtension(U,H),new v.HostExtension;const G=this.F.getExtensionDescription(U);return this.ab(G,H)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),y.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.mb()}catch(ce){E.onUnexpectedError(ce)}}async R(){this.J.onWillDeactivateAll();let ce=[];try{ce=this.F.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.Y(we))}catch{}await Promise.all(ce)}terminate(ce,me=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${ce}`),this.l.flush(),this.p.dispose(),this.L.dispose(),E.setUnexpectedErrorHandler(pe=>{this.l.error(pe)}),this.g.dispose();const Y=this.R();Promise.race([(0,C.timeout)(5e3),Y]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${me}`):this.l.info(`Extension host exiting with code ${me}`),this.l.flush(),this.l.dispose(),this.c.exit(me)})}isActivated(ce){return this.C.isOpen()?this.L.isActivated(ce):!1}async getExtension(ce){const me=await this.v.$getExtension(ce);let Y;if(me?.browserNlsBundleUris){Y={};for(const pe of Object.keys(me.browserNlsBundleUris))Y[pe]=k.URI.revive(me.browserNlsBundleUris[pe])}return me&&{...me,identifier:new b.ExtensionIdentifier(me.identifier.value),extensionLocation:k.URI.revive(me.extensionLocation),browserNlsBundleUris:Y}}S(ce,me){return this.L.activateByEvent(ce,me)}U(ce,me){return this.L.activateById(ce,me)}activateByIdWithErrors(ce,me){return this.U(ce,me).then(()=>{const Y=this.L.getActivatedExtension(ce);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this.C.wait().then(ce=>this.F)}getExtensionExports(ce){return this.C.isOpen()?this.L.getActivatedExtension(ce).exports:null}async W(ce){if(ce.scheme!==j.Schemas.file)return ce;const me=await this.c.realpath(ce.fsPath);return k.URI.file(me)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(ce=>new oe(ce))),this.M}async X(ce){const me=S.TernarySearchTree.forUris(Y=>N.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(ce.map(async Y=>{if(this.qb(Y)){const pe=await this.W(Y.extensionLocation);me.set(pe,Y)}})),me}Y(ce){let me=Promise.resolve(void 0);if(!this.C.isOpen()||!this.L.isActivated(ce))return me;const Y=this.L.getActivatedExtension(ce);if(!Y)return me;try{typeof Y.module.deactivate=="function"&&(me=Promise.resolve(Y.module.deactivate()).then(void 0,pe=>(this.l.error(pe),Promise.resolve(void 0))))}catch(pe){this.l.error(`An error occurred when deactivating the extension '${ce.value}':`),this.l.error(pe)}try{(0,R.dispose)(Y.subscriptions)}catch(pe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ce.value}':`),this.l.error(pe)}return me}async ab(ce,me){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ce.identifier):await this.v.$onWillActivateExtension(ce.identifier),this.cb(ce,me).then(Y=>{const pe=Y.activationTimes;return this.v.$onDidActivateExtension(ce.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,me),this.bb(ce,me,"success",pe),Y},Y=>{throw this.bb(ce,me,"failure"),Y})}bb(ce,me,Y,pe){const we=V(ce,me);this.u.$publicLog2("extensionActivationTimes",{...we,...pe||{},outcome:Y})}cb(ce,me){const Y=V(ce,me);this.u.$publicLog2("activatePlugin",Y);const pe=this.qb(ce);if(!pe)return Promise.resolve(new v.EmptyExtension(v.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ce.identifier.value}, startup: ${me.startup}, activationEvent: '${me.activationEvent}'${ce.identifier.value!==me.extensionId.value?`, root cause: ${me.extensionId.value}`:""}`),this.l.flush();const we=new v.ExtensionActivationTimesBuilder(me.startup);return Promise.all([this.rb(ce,(0,N.joinPath)(ce.extensionLocation,pe),we),this.db(ce)]).then(Fe=>(y.mark(`code/extHost/willActivateExtension/${ce.identifier.value}`),Ri.eb(this.l,ce.identifier,Fe[0],Fe[1],we))).then(Fe=>(y.mark(`code/extHost/didActivateExtension/${ce.identifier.value}`),Fe))}db(ce){const me=new w.ExtensionGlobalMemento(ce,this.H),Y=new w.ExtensionMemento(ce.identifier.value,!1,this.H),pe=new q.ExtensionSecrets(ce,this.I),we=ce.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Fe=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ce.identifier.value}`),Promise.all([me.whenReady,Y.whenReady,this.J.whenReady]).then(()=>{const We=this;let Xe,Pe;const Ie=(0,o.isProposedApiEnabled)(ce,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(ce.identifier)):void 0;return Object.freeze({globalState:me,workspaceState:Y,secrets:pe,subscriptions:[],get extensionUri(){return ce.extensionLocation},get extensionPath(){return ce.extensionLocation.fsPath},asAbsolutePath(ke){return T.join(ce.extensionLocation.fsPath,ke)},get storagePath(){return We.J.workspaceValue(ce)?.fsPath},get globalStoragePath(){return We.J.globalValue(ce).fsPath},get logPath(){return T.join(We.f.logsLocation.fsPath,ce.identifier.value)},get logUri(){return k.URI.joinPath(We.f.logsLocation,ce.identifier.value)},get storageUri(){return We.J.workspaceValue(ce)},get globalStorageUri(){return We.J.globalValue(ce)},get extensionMode(){return we},get extension(){return Xe===void 0&&(Xe=new X(We,ce.identifier,ce,Fe,!1)),Xe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(ce,"extensionRuntime"),We.extensionRuntime},get environmentVariableCollection(){return We.p.getEnvironmentVariableCollection(ce)},get messagePassingProtocol(){if(!Pe){if(!Ie)return;const ke=A.Event.buffer(A.Event.fromDOMEventEmitter(Ie,"message",re=>re.data));Ie.start(),Pe={onDidReceiveMessage:ke,postMessage:Ie.postMessage.bind(Ie)}}return Pe}})})}static eb(ce,me,Y,pe,we){return Y=Y||{activate:void 0,deactivate:void 0},this.fb(ce,me,Y,pe,we).then(Fe=>new v.ActivatedExtension(!1,null,we.build(),Y,Fe,pe.subscriptions))}static fb(ce,me,Y,pe,we){if(typeof Y.activate=="function")try{we.activateCallStart(),ce.trace(`ExtensionService#_callActivateOptional ${me.value}`);const Fe=typeof global=="object"?global:self,We=Y.activate.apply(Fe,[pe]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(We).then(Xe=>(we.activateResolveStop(),Xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(Y)}gb(ce,me){this.U(ce.identifier,{startup:!1,extensionId:ce.identifier,activationEvent:me}).then(void 0,Y=>{this.l.error(Y)})}hb(){this.v.$setPerformanceMarks(y.getMarks());for(const ce of this.F.getAllExtensionDescriptions())if(ce.activationEvents)for(const me of ce.activationEvents)me==="onStartupFinished"&&this.gb(ce,me)}ib(){const ce=this.S("*",!0).then(void 0,we=>{this.l.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.jb(we.added)));const me=this.j.workspace?this.j.workspace.folders:[],Y=this.jb(me),pe=Promise.all([ce,Y]).then(()=>{});return Promise.race([pe,(0,C.timeout)(1e4)]).then(()=>{this.hb()}),pe}jb(ce){return ce.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(me=>this.kb(ce,me))).then(()=>{})}async kb(ce,me){if(this.isActivated(me.identifier))return;const Y=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.l,folders:ce.map(Fe=>Fe.uri),forceUsingSearch:Y,exists:Fe=>this.c.exists(Fe.fsPath),checkExists:(Fe,We,Xe)=>this.t.$checkExists(Fe,We,Xe)},we=await(0,L.checkActivateWorkspaceContainsExtension)(pe,me);if(!!we)return this.U(me.identifier,{startup:!0,extensionId:me.identifier,activationEvent:we.activationEvent}).then(void 0,Fe=>this.l.error(Fe))}async $extensionTestsExecute(){await this.D.wait();try{return await this.lb()}catch(ce){throw console.error(ce),ce}}async lb(){const{extensionDevelopmentLocationURI:ce,extensionTestsLocationURI:me}=this.f.environment;if(!ce||!me)throw new Error(n.localize(0,null));const Y=await this.rb(null,me,new v.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(n.localize(1,null,me.toString()));return new Promise((pe,we)=>{const Fe=(Pe,Ie)=>{Pe?we(Pe):pe(typeof Ie=="number"&&Ie>0?1:0)},We=(0,N.originalFSPath)(me),Xe=Y.run(We,Fe);Xe&&Xe.then&&Xe.then(()=>{pe(0)}).catch(Pe=>{we(Pe instanceof Error&&Pe.stack?Pe.stack:String(Pe))})})}mb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.C.open()).then(()=>this.ib()).then(()=>{this.D.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ce,me){return this.N[ce]=me,(0,R.toDisposable)(()=>{delete this.N[ce]})}async nb(ce){const me=ce.indexOf("+");if(me===-1)throw new Error("Not an authority that can be resolved!");const Y=ce.substr(0,me);return await this.w.wait(),await this.S(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this.N[Y]}}async $resolveAuthority(ce,me){this.l.info(`$resolveAuthority invoked for authority (${fe(ce)})`);const{authorityPrefix:Y,resolver:pe}=await this.nb(ce);if(!pe)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(pe)),y.mark(`code/extHost/willResolveAuthority/${Y}`);const we=await pe.resolve(ce,{resolveAttempt:me});y.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const Fe={authority:ce,host:we.host,port:we.port,connectionToken:we.connectionToken},We={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:We,tunnelInformation:{environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures}}}}catch(we){if(y.mark(`code/extHost/didResolveAuthorityError/${Y}`),we instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}async $getCanonicalURI(ce,me){this.l.info(`$getCanonicalURI invoked for authority (${fe(ce)})`);const{resolver:Y}=await this.nb(ce);if(!Y)return null;const pe=k.URI.revive(me);if(typeof Y.getCanonicalURI>"u")return pe;const we=await(0,C.asPromise)(()=>Y.getCanonicalURI(pe));return we||pe}static ob(ce,me,Y){const pe=new l.ExtensionDescriptionRegistry(ce.getAllExtensionDescriptions());pe.deltaExtensions(Y.toAdd,Y.toRemove);const we=(0,o.extensionIdentifiersArrayToSet)(me.getAllExtensionDescriptions().map(We=>We.identifier));for(const We of Y.myToRemove)we.delete(b.ExtensionIdentifier.toKey(We));for(const We of Y.myToAdd)we.add(b.ExtensionIdentifier.toKey(We));const Fe=Z(pe,we);return{globalRegistry:pe,myExtensions:Fe}}$startExtensionHost(ce){ce.toAdd.forEach(pe=>pe.extensionLocation=k.URI.revive(pe.extensionLocation));const{globalRegistry:me,myExtensions:Y}=Ri.ob(this.G,this.F,ce);return this.G.set(me.getAllExtensionDescriptions()),this.F.set(Y),this.mb()}$activateByEvent(ce,me){return me===1?this.S(ce,!1):this.C.wait().then(Y=>this.S(ce,!1))}async $activate(ce,me){return await this.C.wait(),this.F.getExtensionDescription(ce)?(await this.U(ce,me),!0):!1}async $deltaExtensions(ce){ce.toAdd.forEach(Fe=>Fe.extensionLocation=k.URI.revive(Fe.extensionLocation));const{globalRegistry:me,myExtensions:Y}=Ri.ob(this.G,this.F,ce),pe=await this.X(Y);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.G.set(me.getAllExtensionDescriptions()),this.F.set(Y),Promise.resolve(void 0)}async $test_latency(ce){return ce}async $test_up(ce){return ce.byteLength}async $test_down(ce){const me=p.VSBuffer.alloc(ce),Y=Math.random()%256;for(let pe=0;pe<ce;pe++)me.writeUInt8(Y,pe);return me}async $updateRemoteConnectionData(ce){this.Q=ce,this.a.fire()}};z=Ve([je(0,a.IInstantiationService),je(1,e.IHostUtils),je(2,u.IExtHostRpcService),je(3,i.IExtHostWorkspace),je(4,f.IExtHostConfiguration),je(5,O.ILogService),je(6,d.IExtHostInitDataService),je(7,c.IExtensionStoragePaths),je(8,m.IExtHostTunnelService),je(9,g.IExtHostTerminalService),je(10,P.IExtHostLocalizationService)],z),e.AbstractExtHostExtensionService=z;function V(le,ce){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:ce.activationEvent,reasonId:ce.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class X{constructor(ce,me,Y,pe,we){M.set(this,void 0),F.set(this,void 0),$.set(this,void 0),Ye(this,M,ce,"f"),Ye(this,F,me,"f"),Ye(this,$,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=T.normalize((0,N.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=pe,this.isFromDifferentExtensionHost=we}get isActive(){return Re(this,M,"f").isActivated(Re(this,$,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Re(this,M,"f").getExtensionExports(Re(this,$,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Re(this,M,"f").activateByIdWithErrors(Re(this,$,"f"),{startup:!1,extensionId:Re(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=X,M=new WeakMap,F=new WeakMap,$=new WeakMap;function Z(le,ce){return le.getAllExtensionDescriptions().filter(me=>ce.has(b.ExtensionIdentifier.toKey(me.identifier)))}function fe(le){const ce=le.indexOf("+");return ce===-1?le:le.substring(0,ce)}class oe{constructor(ce){this.a=ce}setSearchTree(ce){this.a=ce}findSubstr(ce){return this.a.findSubstr(ce)}forEach(ce){return this.a.forEach(ce)}}e.ExtensionPaths=oe}),define(De[239],Ce([1,0,77,2,4,32,25,26,14,27,3,33,48,12,10]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let i=class{constructor(w,s,r,a,d,c,u){this.c=w,this.d=s,this.e=r,this.f=a,this.g=d,this.h=c,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new l(this.c,s,this.d,w,this.i)),this.register(this.e.createInstance(E,s)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,s,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const s of w.nodeModuleName)this.a.set(s,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(s=>w.alternativeModuleName(s))}};i=Ve([je(2,O.IInstantiationService),je(3,N.IExtHostConfiguration),je(4,I.IExtHostExtensionService),je(5,k.IExtHostInitDataService),je(6,v.ILogService)],i),e.RequireInterceptor=i;let o=class Zi{constructor(w){if(w.environment.appRoot&&Zi.a.size){const s=(0,h.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),r="[a-z0-9_.-]",a=`@${r}+\\/${r}+|${r}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const s=this.b.exec(this.c(w));if(!s)return;const[,r,a,d]=s,c=Zi.a.get(a);if(c!==void 0)return console.warn(`${a} as been renamed to ${c}, please update your imports`),r+c+d}c(w){return w.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=Ve([je(0,k.IExtHostInitDataService)],o);class l{constructor(w,s,r,a,d){this.c=w,this.d=s,this.e=r,this.f=a,this.g=d,this.nodeModuleName="vscode",this.a=new Map}load(w,s){const r=this.d.findSubstr(s);if(r){let a=this.a.get(R.ExtensionIdentifier.toKey(r.identifier));return a||(a=this.c(r,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(r.identifier),a)),a}if(!this.b){let a="";this.d.forEach((d,c)=>a+=`	${c} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${a}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let E=class{constructor(w,s,r){this.d=w,this.nodeModuleName="keytar",this.a=s.getProxy(y.MainContext.MainThreadTelemetry);const{environment:a}=r,d=s.getProxy(y.MainContext.MainThreadKeytar);if(a.appRoot){let c=a.appRoot.fsPath;f.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,u)=>d.$getPassword(c,u),setPassword:(c,u,t)=>d.$setPassword(c,u,t),deletePassword:(c,u)=>d.$deletePassword(c,u),findPassword:c=>d.$findPassword(c),findCredentials(c){return d.$findCredentials(c)}}}load(w,s){const r=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:r?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const s=w.length;if(s<=7||!this.b)return;const r=s-7;if((w.charAt(r)==="/"||w.charAt(r)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};E=Ve([je(1,S.IExtHostRpcService),je(2,k.IExtHostInitDataService)],E);let b=class{constructor(w,s,r){this.e=w,this.f=s,this.nodeModuleName=["open","opn"],this.d=r.getProxy(y.MainContext.MainThreadTelemetry);const a=r.getProxy(y.MainContext.MainThreadWindow);this.c=(d,c)=>{const u=T.URI.parse(d);return c?this.g(d,c):u.scheme==="http"||u.scheme==="https"?a.$openUri(u,d,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?a.$openUri(u,d,{}):this.g(d,c)}}load(w,s,r){const a=this.e.findSubstr(s);return a&&(this.a=a.identifier.value,this.h()),this.b=r(w),this.c}g(w,s){return this.i(),this.b(w,s)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=Ve([je(2,S.IExtHostRpcService)],b)}),define(De[104],Ce([1,0,204,7,19,48,3,54,55,33,6,31,177,32]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class h extends f.AbstractVariableResolverService{constructor(l,E,b,p,w,s,r){function a(){if(b){const d=b.activeEditor();if(d)return d.document.uri;const c=p.tabGroups.all.find(u=>u.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof O.TextDiffTabInput||c.input instanceof O.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof O.TextTabInput||c.input instanceof O.NotebookEditorTabInput||c.input instanceof O.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:d=>{const c=s.folders.filter(u=>u.name===d);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(d,c)=>w.getConfiguration(void 0,d).get(c),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return y.normalize(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(E){const d=a();if(d){const c=E.getWorkspaceFolder(d);if(c)return y.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(b){const d=b.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(b){const d=b.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>l.getExtension(d)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(N.env))}}let i=class extends T.Disposable{constructor(l,E,b,p,w){super(),this.b=l,this.c=E,this.g=b,this.h=p,this.i=w,this.a=new n.Lazy(async()=>{const s=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new h(this.b,this.c,this.g,this.i,s,a,this.j())})}getResolver(){return this.a.getValue()}j(){}};i=Ve([je(0,k.IExtHostExtensionService),je(1,I.IExtHostWorkspace),je(2,R.IExtHostDocumentsAndEditors),je(3,v.IExtHostConfiguration),je(4,S.IExtHostEditorTabs)],i),e.ExtHostVariableResolverProviderService=i}),define(De[105],Ce([1,0,15,5,9,2,3,4,55,33,14,6,31,169,171,32,104]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,d,c,u,t,m){this.E=d,this.F=c,this.G=u,this.H=t,this.I=m,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.Emitter,this.n=new T.Emitter,this.o=new T.Emitter,this.u=new T.Emitter,this.k=a.getProxy(R.MainContext.MainThreadDebugService),this.A=new T.Emitter({onWillAddFirstListener:()=>{this.U()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.F.getExtensionRegistry().then(g=>{g.onDidChange(A=>{this.J(g)}),this.J(g)})}asDebugSourceUri(a,d){const c=a;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let u=`debug:${encodeURIComponent(c.path||"")}`,t="?";return d&&(u+=`${t}session=${encodeURIComponent(d.id)}`,t="&"),u+=`${t}ref=${c.sourceReference}`,N.URI.parse(u)}else{if(c.path)return N.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(a){const d=[];for(const c of a.getAllExtensionDescriptions())if(c.contributes){const u=c.contributes.debuggers;if(u&&u.length>0)for(const t of u)(0,h.isDebuggerMainContribution)(t)&&d.push(t.type)}this.k.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){this.U();const a=[];return this.w.forEach(d=>a.push(d)),a}addBreakpoints(a){this.U();const d=a.filter(t=>{const m=t.id;return this.w.has(m)?!1:(this.w.set(m,t),!0)});this.V(d,[],[]);const c=[],u=new Map;for(const t of d)if(t instanceof I.SourceBreakpoint){let m=u.get(t.location.uri.toString());m||(m={type:"sourceMulti",uri:t.location.uri,lines:[]},u.set(t.location.uri.toString(),m),c.push(m)),m.lines.push({id:t.id,enabled:t.enabled,condition:t.condition,hitCondition:t.hitCondition,logMessage:t.logMessage,line:t.location.range.start.line,character:t.location.range.start.character})}else t instanceof I.FunctionBreakpoint&&c.push({type:"function",id:t.id,enabled:t.enabled,hitCondition:t.hitCondition,logMessage:t.logMessage,condition:t.condition,functionName:t.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(a){this.U();const d=a.filter(m=>this.w.delete(m.id));this.V([],d,[]);const c=d.filter(m=>m instanceof I.SourceBreakpoint).map(m=>m.id),u=d.filter(m=>m instanceof I.FunctionBreakpoint).map(m=>m.id),t=d.filter(m=>m instanceof I.DataBreakpoint).map(m=>m.id);return this.k.$unregisterBreakpoints(c,u,t)}startDebugging(a,d,c){return this.k.$startDebugging(a?a.uri:void 0,d,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,d,c){if(!d)return new I.Disposable(()=>{});const u=this.d++;return this.f.push({type:a,handle:u,provider:d}),this.k.$registerDebugConfigurationProvider(a,c,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,u),new I.Disposable(()=>{this.f=this.f.filter(t=>t.provider!==d),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(a,d,c){if(!c)return new I.Disposable(()=>{});if(!this.Q(a,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:d,handle:u,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(d,u),new I.Disposable(()=>{this.h=this.h.filter(t=>t.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(a,d){if(!d)return new I.Disposable(()=>{});const c=this.i++;return this.j.push({type:a,handle:c,factory:d}),new I.Disposable(()=>{this.j=this.j.filter(u=>u.factory!==d)})}async $runInTerminal(a,d){return Promise.resolve(void 0)}async $substituteVariables(a,d){let c;const u=await this.X(a);return u&&(c={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(c,d)}K(a,d){if(a.type==="implementation")return new w(a.implementation)}L(){}async $startDASession(a,d){const c=this,u=await this.W(d);return this.S(this.N(u.type),u).then(t=>{if(!t)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const m=this.M(t),g=this.K(m,u);if(!g)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const A=g;return this.B.set(a,A),this.R(u).then(L=>(L&&this.C.set(a,L),A.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const q=K,j={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const P=await this.D.sign(q.arguments.value);j.body={signature:P},A.sendResponse(j)}else throw new Error("no signer")}catch(P){j.success=!1,j.message=P.message,A.sendResponse(j)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(K),K=(0,h.convertToVSCPaths)(K,!0),c.k.$acceptDAMessage(a,K)}),A.onError(K=>{L&&L.onError&&L.onError(K),this.k.$acceptDAError(a,K.name,K.message,K.stack)}),A.onExit(K=>{L&&L.onExit&&L.onExit((0,y.withNullAsUndefined)(K),void 0),this.k.$acceptDAExit(a,(0,y.withNullAsUndefined)(K),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),A.startSession()))})}$sendDAMessage(a,d){d=(0,h.convertToDAPaths)(d,!1);const c=this.C.get(a);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(d),this.B.get(a)?.sendMessage(d)}$stopDASession(a){const d=this.C.get(a);this.C.delete(a),d&&d.onWillStopSession&&d.onWillStopSession();const c=this.B.get(a);return this.B.delete(a),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const d=[],c=[],u=[];if(a.added)for(const t of a.added){const m=t.id;if(m&&!this.w.has(m)){let g;if(t.type==="function")g=new I.FunctionBreakpoint(t.functionName,t.enabled,t.condition,t.hitCondition,t.logMessage);else if(t.type==="data")g=new I.DataBreakpoint(t.label,t.dataId,t.canPersist,t.enabled,t.hitCondition,t.condition,t.logMessage);else{const A=N.URI.revive(t.uri);g=new I.SourceBreakpoint(new I.Location(A,new I.Position(t.line,t.character)),t.enabled,t.condition,t.hitCondition,t.logMessage)}g._id=m,this.w.set(m,g),d.push(g)}}if(a.removed)for(const t of a.removed){const m=this.w.get(t);m&&(this.w.delete(t),c.push(m))}if(a.changed){for(const t of a.changed)if(t.id){const m=this.w.get(t.id);if(m){if(m instanceof I.FunctionBreakpoint&&t.type==="function"){const g=m;g.enabled=t.enabled,g.condition=t.condition,g.hitCondition=t.hitCondition,g.logMessage=t.logMessage,g.functionName=t.functionName}else if(m instanceof I.SourceBreakpoint&&t.type==="source"){const g=m;g.enabled=t.enabled,g.condition=t.condition,g.hitCondition=t.hitCondition,g.logMessage=t.logMessage,g.location=new I.Location(N.URI.revive(t.uri),new I.Position(t.line,t.character))}u.push(m)}}}this.V(d,c,u)}$provideDebugConfigurations(a,d,c){return(0,n.asPromise)(async()=>{const u=this.P(a);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const t=await this.X(d);return u.provideDebugConfigurations(t,c)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(a,d,c,u){return(0,n.asPromise)(async()=>{const t=this.P(a);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const m=await this.X(d);return t.resolveDebugConfiguration(m,c,u)})}$resolveDebugConfigurationWithSubstitutedVariables(a,d,c,u){return(0,n.asPromise)(async()=>{const t=this.P(a);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const m=await this.X(d);return t.resolveDebugConfigurationWithSubstitutedVariables(m,c,u)})}async $provideDebugAdapter(a,d){const c=this.O(a);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.W(d);return this.S(c,u).then(t=>{if(!t)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.M(t)})}async $acceptDebugSessionStarted(a){const d=await this.W(a);this.m.fire(d)}async $acceptDebugSessionTerminated(a){const d=await this.W(a);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.W(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,d){(await this.W(a))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(a,d){const u={session:await this.W(a),event:d.event,body:d.body};this.u.fire(u)}M(a){if(a instanceof I.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof I.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}N(a){const d=this.h.filter(c=>c.type===a);if(d.length>0)return d[0].factory}O(a){const d=this.h.filter(c=>c.handle===a);if(d.length>0)return d[0].factory}P(a){const d=this.f.filter(c=>c.handle===a);if(d.length>0)return d[0].provider}Q(a,d){if(a.contributes){const c=a.contributes.debuggers;if(c&&c.length>0){for(const u of c)if(u.label&&u.type&&u.type===d)return!0}}return!1}R(a){const c=a.configuration.type,u=this.j.filter(t=>t.type===c||t.type==="*").map(t=>(0,n.asPromise)(()=>t.factory.createDebugAdapterTracker(a)).then(m=>m,m=>null));return Promise.race([Promise.all(u).then(t=>{const m=t.filter(g=>!!g);if(m.length>0)return new p(m)}),new Promise(t=>setTimeout(()=>t(void 0),1e3))]).catch(t=>{})}async S(a,d){const c=d.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new I.DebugAdapterServer(c));if(a){const t=await this.F.getExtensionRegistry();return(0,n.asPromise)(()=>a.createDebugAdapterDescriptor(d,this.T(d,t))).then(m=>{if(m)return m})}const u=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,u))}T(a,d){}U(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}V(a,d,c){(a.length>0||d.length>0||c.length>0)&&this.A.fire(Object.freeze({added:a,removed:d,changed:c}))}async W(a){if(a)if(typeof a=="string"){const d=this.l.get(a);if(d)return d}else{let d=this.l.get(a.id);if(!d){const c=await this.X(a.folderUri),u=a.parent?this.l.get(a.parent):void 0;d=new E(this.k,a.id,a.type,a.name,c,a.configuration,u),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}X(a){if(a){const d=N.URI.revive(a);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};l=Ve([je(0,O.IExtHostRpcService),je(1,f.IExtHostWorkspace),je(2,k.IExtHostExtensionService),je(3,i.IExtHostConfiguration),je(4,S.IExtHostEditorTabs),je(5,o.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class E{constructor(a,d,c,u,t,m,g){this.d=a,this.f=d,this.g=c,this.h=u,this.i=t,this.j=m,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,d){return this.d.$customDebugAdapterRequest(this.f,a,d)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.ExtHostDebugSession=E;class b{constructor(a){this.value=Object.freeze({append(d){a.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=b;class p{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(d=>d.onError?d.onError(a):void 0)}onExit(a,d){this.d.forEach(c=>c.onExit?c.onExit(a,d):void 0)}}class w extends v.AbstractDebugAdapter{constructor(a){super(),this.h=a,a.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends l{constructor(a,d,c,u,t,m){super(a,d,c,u,t,m)}};s=Ve([je(0,O.IExtHostRpcService),je(1,f.IExtHostWorkspace),je(2,k.IExtHostExtensionService),je(3,i.IExtHostConfiguration),je(4,S.IExtHostEditorTabs),je(5,o.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(De[240],Ce([1,0,11,77,2,4,231,12,61,62,27,151,14,51,33,70]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(b){const p=b.get(R.ILogService),s=b.get(f.IExtHostRpcService).getProxy(N.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(r=>{p.error(r);const a=n.transformErrorForSerialization(r);s.$onUnexpectedError(a)})}static async installFullHandler(b){const p=b.get(R.ILogService),w=b.get(f.IExtHostRpcService),s=b.get(h.IExtHostExtensionService),r=b.get(i.IExtHostTelemetry),a=w.getProxy(N.MainContext.MainThreadExtensionService),d=w.getProxy(N.MainContext.MainThreadErrors),c=await s.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(t,m)=>{let g="",A,L;for(const K of m)g+=`
	at ${K.toString()}`,L=K.getFileName(),!A&&L&&(A=c.findSubstr(y.URI.file(L)));return u.set(t,A?.identifier),`${t.name||"Error"}: ${t.message||""}${g}`},n.setUnexpectedErrorHandler(t=>{p.error(t);const m=n.transformErrorForSerialization(t),g=u.get(t);if(!g){d.$onUnexpectedError(m);return}a.$onExtensionRuntimeError(g,m);const A=r.onExtensionError(g,t);p.trace("forwarded error to extension?",A,g)})}}Error.stackTraceLimit=100;class l{constructor(b,p,w,s,r){this.a=w,this.b=new C.RPCProtocol(b,null,s),p=l.e(p,this.b);const a=new k.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());a.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...p,messagePorts:r}),a.set(f.IExtHostRpcService,new f.ExtHostRpcService(this.b)),a.set(v.IURITransformerService,new v.URITransformerService(s)),a.set(h.IHostUtils,w);const d=new I.InstantiationService(a,!0);d.invokeFunction(o.installEarlyHandler),this.d=d.invokeFunction(c=>c.get(R.ILogService)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",p),this.c=d.invokeFunction(c=>c.get(h.IExtHostExtensionService)),this.c.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(b){const p=this.b.getProxy(N.MainContext.MainThreadExtensionService);return y.URI.revive(await p.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,p){b.allExtensions.forEach(s=>{s.extensionLocation=y.URI.revive(p.transformIncomingURIs(s.extensionLocation));const r={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(a=>r[a]=y.URI.revive(p.transformIncomingURIs(s.browserNlsBundleUris[a]))),s.browserNlsBundleUris=r)}),b.environment.appRoot=y.URI.revive(p.transformIncomingURIs(b.environment.appRoot));const w=b.environment.extensionDevelopmentLocationURI;return w&&(b.environment.extensionDevelopmentLocationURI=w.map(s=>y.URI.revive(p.transformIncomingURIs(s)))),b.environment.extensionTestsLocationURI=y.URI.revive(p.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=y.URI.revive(p.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=y.URI.revive(p.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=y.URI.revive(p.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=y.URI.revive(p.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=y.URI.revive(p.transformIncomingURIs(b.logsLocation)),b.logFile=y.URI.revive(p.transformIncomingURIs(b.logFile)),b.workspace=p.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=l}),define(De[241],Ce([1,0,16,15,20,45,13,19,22,2,44]),function(te,e,n,T,y,N,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(E,b,p,w){this.d=E,this.e=b,this.f=p,this.g=w,this.a=null,this.b=!1,this.c=0}search(E,b){const p=this.d.folderQueries||[],w=new y.CancellationTokenSource;return b.onCancellationRequested(()=>w.cancel()),new Promise((s,r)=>{this.a=new v(E);let a=!1;const d=(c,u)=>{if(!a&&!this.b){const t=this.h(c);i(c)&&typeof this.d.maxResults=="number"&&this.c+t>this.d.maxResults&&(this.b=!0,a=!0,w.cancel(),c=this.j(c,this.d.maxResults-this.c));const m=this.h(c);this.c+=m,(m>0||!i(c))&&this.a.add(c,u)}};Promise.all(p.map((c,u)=>this.k(c,t=>d(t,u),w.token))).then(c=>{w.dispose(),this.a.flush();const u=c.some(t=>!!t&&!!t.limitHit);s({limitHit:this.b||u,messages:(0,n.flatten)(c.map(t=>t?.message?Array.isArray(t.message)?t.message:[t.message]:[])),stats:{type:this.g}})},c=>{w.dispose();const u=(0,N.toErrorMessage)(c);r(new Error(u))})})}h(E){return i(E)?Array.isArray(E.ranges)?E.ranges.length:1:0}j(E,b){const p=Array.isArray(E.ranges)?E.ranges:[E.ranges],w=Array.isArray(E.preview.matches)?E.preview.matches:[E.preview.matches];return{ranges:p.slice(0,b),preview:{matches:w.slice(0,b),text:E.preview.text},uri:E.uri}}async k(E,b,p){const w=new O.QueryGlobTester(this.d,E),s=[],r={report:c=>{if(!this.l(c))return;const u=E.folder.scheme===C.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(c.uri))):void 0,t=S.relativePath(E.folder,c.uri);if(t){const m=w.includedInQuery(t,R.basename(t),u);(0,T.isThenable)(m)?s.push(m.then(g=>{g&&b(c)})):m&&b(c)}}},a=this.n(E),d=await this.e.provideTextSearchResults(f(this.d.contentPattern),a,r,p);return s.length&&await Promise.all(s),d}l(E){if(i(E)){if(Array.isArray(E.ranges)){if(!Array.isArray(E.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(E.preview.matches.length!==E.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(E.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(E){const b=(0,O.resolvePatternsForProvider)(this.d.includePattern,E.includePattern),p=(0,O.resolvePatternsForProvider)(this.d.excludePattern,E.excludePattern),w={folder:k.URI.from(E.folder),excludes:p,includes:b,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,encoding:E.fileEncoding&&this.f.toCanonicalName(E.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=I;function f(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class v{constructor(E){this.e=E,this.b=-1,this.d=null,this.a=new o(512,b=>this.g(b))}add(E,b){this.d&&(this.b!==b||!S.isEqual(this.c,E.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:E.uri,results:[]}),this.d.results.push(h(E))}f(){const E=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,E)}flush(){this.f(),this.a.flush()}g(E){this.e(E)}}e.TextSearchResultsCollector=v;function h(l){return i(l)?{preview:{matches:(0,n.mapArrayOrNot)(l.preview.matches,E=>({startLineNumber:E.start.line,startColumn:E.start.character,endLineNumber:E.end.line,endColumn:E.end.character})),text:l.preview.text},ranges:(0,n.mapArrayOrNot)(l.ranges,E=>({startLineNumber:E.start.line,startColumn:E.start.character,endLineNumber:E.end.line,endColumn:E.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function i(l){return!!l.preview}e.extensionResultIsMatch=i;class o{constructor(E,b){this.g=E,this.h=b,this.c=0,this.d=[],this.e=0}addItem(E,b){!E||this.j(E,b)}addItems(E,b){!E||this.k(E,b)}j(E,b){this.d.push(E),this.e+=b,this.l()}k(E,b){this.d=this.d.concat(E),this.e+=b,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=o,o.a=4e3,o.b=50}),define(De[106],Ce([1,0,7,4,3,236,14,51,12,2,241]),function(te,e,n,T,y,N,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let I=class{constructor(i,o,l){this.k=i,this.l=o,this.n=l,this.c=this.k.getProxy(T.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new N.FileSearchManager}o(i){return this.l.transformOutgoingScheme(i)}registerTextSearchProvider(i,o){if(this.g.has(i))throw new Error(`a text search provider for the scheme '${i}' is already registered`);this.g.add(i);const l=this.d++;return this.e.set(l,o),this.c.$registerTextSearchProvider(l,this.o(i)),(0,n.toDisposable)(()=>{this.g.delete(i),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(i,o){if(this.i.has(i))throw new Error(`a file search provider for the scheme '${i}' is already registered`);this.i.add(i);const l=this.d++;return this.h.set(l,o),this.c.$registerFileSearchProvider(l,this.o(i)),(0,n.toDisposable)(()=>{this.i.delete(i),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(i,o,l,E){const b=f(l),p=this.h.get(i);if(p)return this.j.fileSearch(b,p,w=>{this.c.$handleFileMatch(i,o,w.map(s=>s.resource))},E);throw new Error("unknown provider: "+i)}$clearCache(i){return this.j.clearCache(i),Promise.resolve(void 0)}$provideTextSearchResults(i,o,l,E){const b=this.e.get(i);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${i}`);const p=f(l);return this.q(p,b).search(s=>this.c.$handleTextMatch(i,o,s),E)}$enableExtensionHostSearch(){}q(i,o){return new O.TextSearchManager(i,o,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};I=Ve([je(0,C.IExtHostRpcService),je(1,R.IURITransformerService),je(2,S.ILogService)],I),e.ExtHostSearch=I;function f(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(v),extraFileResources:h.extraFileResources&&h.extraFileResources.map(i=>k.URI.revive(i))}}e.reviveQuery=f;function v(h){return{...h,folder:k.URI.revive(h.folder)}}}),define(De[242],Ce([1,0,61,101,31,99,32,38,54,57,103,105,106,75,65,72,100,56,37,74,70,55,212,12,182,104,73]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b,p,w,s,r,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,n.registerSingleton)(r.ILoggerService,s.ExtHostLoggerService,1),(0,n.registerSingleton)(r.ILogService,a.ExtHostLogService,1),(0,n.registerSingleton)(i.IExtHostApiDeprecationService,i.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,n.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,n.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,n.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations,0),(0,n.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,n.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,0),(0,n.registerSingleton)(v.IExtHostStorage,v.ExtHostStorage,0),(0,n.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,n.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService,0),(0,n.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,n.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,n.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,n.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry,0),(0,n.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,n.registerSingleton)(d.IExtHostVariableResolverProvider,d.ExtHostVariableResolverProviderService,0)}),define(De[243],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(y){if(y&&this.a.has(y)){const N=this.a.get(y);return this.a.delete(y),N}}addDragOperationTransfer(y,N){this.a.set(y,N)}getRenderedTreeElement(y){if(this.b.has(y))return this.b.get(y)}addRenderedTreeItemElement(y,N){this.b.set(y,N)}removeRenderedTreeItemElement(y){this.b.has(y)&&this.b.delete(y)}}e.TreeviewsService=n}),define(De[244],Ce([1,0,137,6,22,2,5,7,15,6,9,16,8,20,243,25]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(b,p){if((0,O.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let w;return Array.isArray(b.highlights)&&(w=b.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),w=w.length?w:void 0),{label:b.label,highlights:w}}}class l{constructor(p,w,s){this.d=p,this.e=w,this.f=s,this.a=new Map,this.b=new h.TreeviewsService;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:a=>r(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(d=>r(d)?this.i(d):d):a})}registerTreeDataProvider(p,w,s){const r=this.createTreeView(p,{treeDataProvider:w},s);return{dispose:()=>r.dispose()}}createTreeView(p,w,s){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=w.dragAndDropController?.dropMimeTypes??[],a=w.dragAndDropController?.dragMimeTypes??[],d=!!w.dragAndDropController?.handleDrag,c=!!w.dragAndDropController?.handleDrop,u=this.h(p,w,s),t=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:d,hasHandleDrop:c});return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,i.checkProposedApiEnabled)(s,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(m){u.message=m},get title(){return u.title},set title(m){u.title=m},get description(){return u.description},set description(m){u.description=m},get badge(){return u.badge},set badge(m){m!==void 0&&k.ViewBadge.isViewBadge(m)?u.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(u.badge=void 0)},reveal:(m,g)=>u.reveal(m,g),dispose:async()=>{await t,this.a.delete(p),u.dispose()}}}$getChildren(p,w){const s=this.a.get(p);return s?s.getChildren(w):Promise.reject(new Error((0,n.localize)(0,null,p)))}async $handleDrop(p,w,s,r,a,d,c,u){const t=this.a.get(p);if(!t)return Promise.reject(new Error((0,n.localize)(1,null,p)));const m=f.DataTransfer.toDataTransfer(s,async g=>(await this.d.$resolveDropFileData(p,w,g)).buffer);return c===p&&u&&await this.g(m,t,u,a,d),t.onDrop(m,r,a)}async g(p,w,s,r,a){const d=this.b.removeDragOperationTransfer(a);if(d)(await d)?.forEach((c,u)=>{c&&p.set(u,c)});else if(a&&w.handleDrag){const c=w.handleDrag(s,p,r);this.b.addDragOperationTransfer(a,c),await c}return p}async $handleDrag(p,w,s,r){const a=this.a.get(p);if(!a)return Promise.reject(new Error((0,n.localize)(2,null,p)));const d=await this.g(new T.DataTransfer,a,w,r,s);if(!!d)return f.DataTransfer.toDataTransferDTO(d)}async $hasResolve(p){const w=this.a.get(p);if(!w)throw new Error((0,n.localize)(3,null,p));return w.hasResolve}$resolve(p,w,s){const r=this.a.get(p);if(!r)throw new Error((0,n.localize)(4,null,p));return r.resolveTreeItem(w,s)}$setExpanded(p,w,s){const r=this.a.get(p);if(!r)throw new Error((0,n.localize)(5,null,p));r.setExpanded(w,s)}$setSelection(p,w){const s=this.a.get(p);if(!s)throw new Error((0,n.localize)(6,null,p));s.setSelection(w)}$setFocus(p,w){const s=this.a.get(p);if(!s)throw new Error((0,n.localize)(7,null,p));s.setFocus(w)}$setVisible(p,w){const s=this.a.get(p);if(!s)throw new Error((0,n.localize)(8,null,p));s.setVisible(w)}$changeCheckboxState(p,w){const s=this.a.get(p);if(!s)throw new Error((0,n.localize)(9,null,p));s.setCheckboxState(w)}h(p,w,s){const r=new E(p,w,this.d,this.e.converter,this.f,s);return this.a.set(p,r),r}i(p){const w=this.a.get(p.$treeViewId);return w&&"$treeItemHandle"in p?w.getExtensionElement(p.$treeItemHandle):w&&"$focusedTreeItem"in p&&p.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=l;class E extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,O.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,w,s,r,a,d){if(super(),this.D=p,this.F=s,this.G=r,this.H=a,this.I=d,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new v.CancellationTokenSource,d.contributes&&d.contributes.views)for(const t in d.contributes.views)for(const m of d.contributes.views[t])m.id===p&&(this.L=m.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(t=>this.w.fire({message:!1,element:t})));let c,u;this.B(C.Event.debounce(this.w.event,(t,m)=>(t||(t={message:!1,elements:[]}),m.element!==!1&&(c||(c=new Promise(g=>u=g),this.y=this.y.then(()=>c)),Array.isArray(m.element)?t.elements.push(...m.element):t.elements.push(m.element)),m.message&&(t.message=!0),t),200,!0)(({message:t,elements:m})=>{m.length&&(this.C=this.C.then(()=>{const g=u;return c=null,this.W(m).then(()=>g())})),t&&this.F.$setMessage(this.D,this.J)}))}async getChildren(p){const w=p?this.getExtensionElement(p):void 0;if(p&&!w)return this.H.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let s=this.R(p);return s||(s=await this.S(w)),s?s.map(r=>r.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,w){w=w||{select:!0,focus:!1};const s=(0,O.isUndefinedOrNull)(w.select)?!0:w.select,r=(0,O.isUndefinedOrNull)(w.focus)?!1:w.focus,a=(0,O.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.O(p)).then(d=>this.Q(p,d[d.length-1]).then(c=>this.F.$reveal(this.D,{item:c.item,parentChain:d.map(u=>u.item)},{select:s,focus:r,expand:a})),d=>this.H.error(d)):this.F.$reveal(this.D,void 0,{select:s,focus:r,expand:a})}get message(){return this.J}set message(p){this.J=p,this.w.fire({message:!0,element:!1})}get title(){return this.L}set title(p){this.L=p,this.F.$setTitle(this.D,p,this.M)}get description(){return this.M}set description(p){this.M=p,this.F.$setTitle(this.D,this.L,p)}get badge(){return this.N}set badge(p){this.N?.value===p?.value&&this.N?.tooltip===p?.tooltip||(this.N=f.ViewBadge.from(p),this.F.$setBadge(this.D,p))}setExpanded(p,w){const s=this.getExtensionElement(p);s&&(w?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(p){(0,I.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const w=(await Promise.all(p.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);w.forEach(s=>{s.treeItem.checkboxState=s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(s=>[s.extensionItem,s.newState])})}async handleDrag(p,w,s){const r=[];for(const a of p){const d=this.getExtensionElement(a);d&&r.push(d)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,w,s),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,w,s){const r=w?this.getExtensionElement(w):void 0;if(!(!r&&w||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,p,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,w){if(!this.f.resolveTreeItem)return;const s=this.i.get(p);if(s){const r=this.j.get(s);if(r){const a=await this.f.resolveTreeItem(r.extensionItem,s,w)??r.extensionItem;return this.fb(a),r.item.tooltip=this.cb(a.tooltip),r.item.command=this.db(r.disposableStore,a.command),r.item}}}O(p){return this.P(p).then(w=>w?this.O(w).then(s=>this.Q(w,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}P(p){const w=this.j.get(p);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(p))}Q(p,w){const s=this.j.get(p);return s?Promise.resolve(s):(0,S.asPromise)(()=>this.f.getTreeItem(p)).then(r=>this.ib(p,r,w,!0)).then(r=>this.getChildren(w?w.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const d=this.j.get(a);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}R(p){if(p){let w;if(typeof p=="string"){const s=this.getExtensionElement(p);w=s?this.j.get(s):void 0}else w=p;return w&&w.children||void 0}return this.h}async S(p){this.pb(p);const w=new v.CancellationTokenSource(this.U.token);try{const s=p?this.j.get(p):void 0,r=await this.f.getChildren(p);if(w.token.isCancellationRequested)return;const a=await Promise.all((0,I.coalesce)(r||[]).map(async d=>{const c=await this.f.getTreeItem(d);return c&&!w.token.isCancellationRequested?this.bb(d,c,s):null}));return w.token.isCancellationRequested?void 0:(0,I.coalesce)(a)}finally{w.dispose()}}W(p){if(p.some(s=>!s))return this.U.dispose(!0),this.U=new v.CancellationTokenSource,this.rb(),this.F.$refresh(this.D);{const s=this.X(p);if(s.length)return this.Y(s)}return Promise.resolve(void 0)}X(p){const w=new Set,s=p.map(a=>this.j.get(a));for(const a of s)if(a&&!w.has(a.item.handle)){let d=a;for(;d&&d.parent&&s.findIndex(c=>d&&d.parent&&c&&c.item.handle===d.parent.item.handle)===-1;){const c=this.i.get(d.parent.item.handle);d=c?this.j.get(c):void 0}d&&!d.parent&&w.add(a.item.handle)}const r=[];return w.forEach(a=>{const d=this.i.get(a);if(d){const c=this.j.get(d);c&&(!c.parent||!w.has(c.parent.item.handle))&&r.push(a)}}),r}Y(p){const w={};return Promise.all(p.map(s=>this.ab(s).then(r=>{r&&(w[s]=r.item)}))).then(()=>Object.keys(w).length?this.F.$refresh(this.D,w):void 0)}ab(p){const w=this.getExtensionElement(p);if(w){const s=this.j.get(w);if(s)return this.pb(w),(0,S.asPromise)(()=>this.f.getTreeItem(w)).then(r=>{if(r){const a=this.gb(w,r,s.parent);return this.nb(w,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}bb(p,w,s){const r=this.gb(p,w,s);if(w.id&&this.i.has(r.item.handle))throw new Error((0,n.localize)(10,null,w.id));return this.mb(p,r),this.ob(r,s),r}cb(p){return k.MarkdownString.isMarkdownString(p)?f.MarkdownString.from(p):p}db(p,w){return w?{...this.G.toInternal(w,p),originalId:w.command}:void 0}eb(p){if(!p.checkboxState)return;let w,s;return typeof p.checkboxState=="number"?w=p.checkboxState:(w=p.checkboxState.state,s=p.checkboxState.tooltip),{isChecked:w===k.TreeItemCheckboxState.Checked,tooltip:s}}fb(p){if(!k.TreeItem.isTreeItem(p,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}gb(p,w,s){this.fb(w);const r=new R.DisposableStore,a=this.ib(p,w,s),d=this.jb(w);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:o(w.label,this.I),description:w.description,resourceUri:w.resourceUri,tooltip:this.cb(w.tooltip),command:this.db(r,w.command),contextValue:w.contextValue,icon:d,iconDark:this.kb(w)||d,themeIcon:this.hb(w),collapsibleState:(0,O.isUndefinedOrNull)(w.collapsibleState)?k.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.eb(w)},extensionItem:w,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}hb(p){return p.iconPath instanceof k.ThemeIcon?p.iconPath:void 0}ib(p,{id:w,label:s,resourceUri:r},a,d){if(w)return`${E.b}/${w}`;const c=o(s,this.I),u=a?a.item.handle:E.a;let t=c?c.label:r?(0,y.basename)(r):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const m=this.j.has(p)?this.j.get(p).item.handle:void 0,g=this.R(a)||[];let A,L=0;do{if(A=`${u}/${L}:${t}`,d||!this.i.has(A)||m===A)break;L++}while(L<=g.length);return A}jb(p){if(p.iconPath&&!(p.iconPath instanceof k.ThemeIcon))return typeof p.iconPath=="string"||N.URI.isUri(p.iconPath)?this.lb(p.iconPath):this.lb(p.iconPath.light)}kb(p){if(p.iconPath&&!(p.iconPath instanceof k.ThemeIcon)&&p.iconPath.dark)return this.lb(p.iconPath.dark)}lb(p){return N.URI.isUri(p)?p:N.URI.file(p)}mb(p,w){this.i.set(w.item.handle,p),this.j.set(p,w)}nb(p,w,s,r){this.i.delete(w.item.handle),this.j.delete(p),w.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.mb(p,w);const a=this.R(r)||[],d=a.filter(c=>c.item.handle===s.item.handle)[0];d&&a.splice(a.indexOf(d),1,w)}ob(p,w){w?(w.children||(w.children=[]),w.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}pb(p){if(p){const w=this.j.get(p);if(w){if(w.children)for(const s of w.children){const r=this.i.get(s.item.handle);r&&this.qb(r)}w.children=void 0}}else this.rb()}qb(p){const w=this.j.get(p);if(w){if(w.children)for(const s of w.children){const r=this.i.get(s.item.handle);r&&this.qb(r)}this.j.delete(p),this.i.delete(w.item.handle),w.dispose()}}rb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.rb(),this.F.$disposeTree(this.D)}}E.a="0",E.b="1"}),define(De[245],Ce([1,0,20,11,5,29,2,124,254,113,122,36,4,69,197,196,38,198,32,200,201,202,185,203,54,33,205,206,209,211,213,101,188,218,219,220,75,57,223,244,8,6,91,226,58,100,31,175,208,63,99,103,105,106,12,51,14,27,214,183,65,72,194,224,76,56,229,227,228,195,37,221,225,74,55,70,215,102,216,13,87,187,166,207,7,25,170,73,163,217]),function(te,e,n,T,y,N,C,R,S,k,O,I,f,v,h,i,o,l,E,b,p,w,s,r,a,d,c,u,t,m,g,A,L,K,q,j,P,M,F,$,z,V,X,Z,fe,oe,le,ce,me,Y,pe,we,Fe,We,Xe,Pe,Ie,ke,re,ae,J,D,U,H,G,ee,de,ye,se,ve,be,$e,He,tt,Ge,et,it,ct,nt,Le,lt,_,Q,ue,Ue,Ne,_e,Je,ht,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function St(ut){const gt=ut.get(ke.IExtHostInitDataService),yt=ut.get(be.IExtHostFileSystemInfo),Ut=ut.get(ee.IExtHostConsumerFileSystem),At=ut.get(d.IExtHostExtensionService),pt=ut.get(le.IExtHostWorkspace),kt=ut.get(et.IExtHostTelemetry),Bt=ut.get(E.IExtHostConfiguration),Ft=ut.get(Pe.IURITransformerService),Ke=ut.get(Ie.IExtHostRpcService),zt=ut.get(P.IExtHostStorage),Rt=ut.get(G.IExtensionStoragePaths),Wt=ut.get(Xe.ILoggerService),ft=ut.get(Xe.ILogService),Mt=ut.get(J.IExtHostTunnelService),Se=ut.get(D.IExtHostApiDeprecationService),Te=ut.get(oe.IExtHostWindow),ge=ut.get(tt.IExtHostSecretState),x=ut.get(Ge.IExtHostEditorTabs);Ke.set(f.ExtHostContext.ExtHostFileSystemInfo,yt),Ke.set(f.ExtHostContext.ExtHostLogLevelServiceShape,Wt),Ke.set(f.ExtHostContext.ExtHostWorkspace,pt),Ke.set(f.ExtHostContext.ExtHostConfiguration,Bt),Ke.set(f.ExtHostContext.ExtHostExtensionService,At),Ke.set(f.ExtHostContext.ExtHostStorage,zt),Ke.set(f.ExtHostContext.ExtHostTunnelService,Mt),Ke.set(f.ExtHostContext.ExtHostWindow,Te),Ke.set(f.ExtHostContext.ExtHostSecretState,ge),Ke.set(f.ExtHostContext.ExtHostTelemetry,kt),Ke.set(f.ExtHostContext.ExtHostEditorTabs,x);const Ae=Ke.set(f.ExtHostContext.ExtHostDecorations,ut.get(pe.IExtHostDecorations)),Me=Ke.set(f.ExtHostContext.ExtHostDocumentsAndEditors,ut.get(a.IExtHostDocumentsAndEditors)),xe=Ke.set(f.ExtHostContext.ExtHostCommands,ut.get(o.IExtHostCommands)),ze=Ke.set(f.ExtHostContext.ExtHostTerminalService,ut.get(M.IExtHostTerminalService)),Ze=Ke.set(f.ExtHostContext.ExtHostDebugService,ut.get(Fe.IExtHostDebugService)),Ct=Ke.set(f.ExtHostContext.ExtHostSearch,ut.get(We.IExtHostSearch)),bt=Ke.set(f.ExtHostContext.ExtHostTask,ut.get(we.IExtHostTask)),Ot=Ke.set(f.ExtHostContext.ExtHostOutputService,ut.get(A.IExtHostOutputService)),mt=Ke.set(f.ExtHostContext.ExtHostLocalization,ut.get(Je.IExtHostLocalizationService)),Tt=Ke.set(f.ExtHostContext.ExtHostUrls,new Z.ExtHostUrls(Ke)),vt=Ke.set(f.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(Ke,Me)),Ht=Ke.set(f.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ke,Me,ft)),Nt=Ke.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(ft,vt,Ke.getProxy(f.MainContext.MainThreadBulkEdits))),Et=Ke.set(f.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(Ke,xe,Me,vt)),Zt=Ke.set(f.ExtHostContext.ExtHostNotebookDocuments,new Q.ExtHostNotebookDocuments(Et)),oi=Ke.set(f.ExtHostContext.ExtHostNotebookEditors,new _.ExtHostNotebookEditors(ft,Et)),ei=Ke.set(f.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ke,gt,Et,xe,ft)),pi=Ke.set(f.ExtHostContext.ExtHostNotebookRenderers,new nt.ExtHostNotebookRenderers(Ke,Et)),It=Ke.set(f.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ke,Me)),ai=Ke.set(f.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(Ke.getProxy(f.MainContext.MainThreadTreeViews),xe,ft)),Oi=Ke.set(f.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(Ke.getProxy(f.MainContext.MainThreadEditorInsets),It,gt.remote)),ti=Ke.set(f.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Ke,ft,yt,Me)),Vt=Ke.set(f.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(Ke,vt,xe.converter,Ft)),ot=Ke.set(f.ExtHostContext.ExtHostLanguageFeatures,new t.ExtHostLanguageFeatures(Ke,Ft,vt,xe,ti,ft,Se,kt)),vi=Ke.set(f.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ke,ot)),qt=Ke.set(f.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Ke,ft,Me)),_t=Ke.set(f.ExtHostContext.ExtHostQuickOpen,(0,K.createExtHostQuickOpen)(Ke,pt,xe)),ci=Ke.set(f.ExtHostContext.ExtHostSCM,new q.ExtHostSCM(Ke,xe,ft)),bi=Ke.set(f.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ke,xe,vt)),ui=Ke.set(f.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Ke.getProxy(f.MainContext.MainThreadProgress))),Ei=Ke.set(f.ExtHostContext.ExtHosLabelService,new me.ExtHostLabelService(Ke)),Ci=Ke.set(f.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ke)),ii=Ke.set(f.ExtHostContext.ExtHostAuthentication,new U.ExtHostAuthentication(Ke)),wi=Ke.set(f.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(Ke,xe)),ri=Ke.set(f.ExtHostContext.ExtHostWebviews,new fe.ExtHostWebviews(Ke,gt.remote,pt,ft,Se)),si=Ke.set(f.ExtHostContext.ExtHostWebviewPanels,new se.ExtHostWebviewPanels(Ke,ri,pt)),Fi=Ke.set(f.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Ke,vt,Rt,ri,si)),Si=Ke.set(f.ExtHostContext.ExtHostWebviewViews,new de.ExtHostWebviewViews(Ke,ri)),Qt=Ke.set(f.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(Ke,xe,Me)),Li=Ke.set(f.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ke)),Mi=Ke.set(f.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(Ke));Ke.set(f.ExtHostContext.ExtHostInteractive,new ue.ExtHostInteractive(Ke,Et,Me,xe,ft));const Ni=Object.values(f.ExtHostContext);Ke.assertRegistered(Ni);const Ui=new ve.ExtHostBulkEdits(Ke,Me),Bi=new i.ExtHostClipboard(Ke),yi=new g.ExtHostMessageService(Ke,ft),li=new p.ExtHostDialogs(Ke),di=new j.ExtHostStatusBar(Ke,xe.converter);return h.ExtHostApiCommands.register(xe),function(Be,Gt,ki){const dt=function(){let ne=!Be.isUnderDevelopment;function he(){ne||(ft.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(rt){if(Array.isArray(rt))rt.forEach(Oe);else if(typeof rt=="string")he();else{const Dt=rt;typeof Dt.scheme>"u"&&he(),typeof Dt.exclusive=="boolean"&&(0,Ne.checkProposedApiEnabled)(Be,"documentFiltersExclusive")}return rt}}(),$i={getSession(ne,he,Oe){return ii.getSession(Be,ne,he,Oe)},async hasSession(ne,he){return(0,Ne.checkProposedApiEnabled)(Be,"authSession"),!!await ii.getSession(Be,ne,he,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(ne,he,Oe,rt){return ii.registerAuthenticationProvider(ne,he,Oe,rt)}},zi={registerCommand(ne,he,Oe){return xe.registerCommand(!0,ne,he,Oe,void 0,Be)},registerTextEditorCommand(ne,he,Oe){return xe.registerCommand(!0,ne,(...rt)=>{const Dt=It.getActiveTextEditor();if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(Pt=>{he.apply(Oe,[Dt,Pt,...rt])}).then(Pt=>{Pt||ft.warn("Edits from command "+ne+" were not applied.")},Pt=>{ft.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Be)},registerDiffInformationCommand:(ne,he,Oe)=>((0,Ne.checkProposedApiEnabled)(Be,"diffCommand"),xe.registerCommand(!0,ne,async(...rt)=>{const Dt=Me.activeEditor(!0);if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await It.getDiffInformation(Dt.id);he.apply(Oe,[Pt,...rt])},void 0,void 0,Be)),executeCommand(ne,...he){return xe.executeCommand(ne,...he)},getCommands(ne=!1){return xe.getCommands(ne)}},Ti={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return Bi.value},get shell(){return ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ne.checkProposedApiEnabled)(Be,"envShellEvent"),ze.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Be,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Be,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,Ne.checkProposedApiEnabled)(Be,"telemetryLogger"),kt.instantiateLogger(Be,ne)},openExternal(ne,he){return Te.openUri(ne,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===gt.environment.appUriScheme)return Tt.createAppUri(ne);try{return await Te.asExternalUri(ne,{allowTunneling:!!gt.remote.authority})}catch(he){if((0,lt.matchesScheme)(ne,Le.Schemas.http)||(0,lt.matchesScheme)(ne,Le.Schemas.https))return ne;throw he}},get remoteName(){return(0,Y.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,Ne.checkProposedApiEnabled)(Be,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel}};gt.environment.extensionTestsLocationURI||Object.freeze(Ti);const Wi={createTestController(ne,he,Oe){return Qt.createTestController(ne,he,Oe)},createTestObserver(){return(0,Ne.checkProposedApiEnabled)(Be,"testObserver"),Qt.createTestObserver()},runTests(ne){return(0,Ne.checkProposedApiEnabled)(Be,"testObserver"),Qt.runTests(ne)},get onDidChangeTestResults(){return(0,Ne.checkProposedApiEnabled)(Be,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,Ne.checkProposedApiEnabled)(Be,"testObserver"),Qt.results}},ni=gt.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,Hi={getExtension(ne,he){(0,Ne.isProposedApiEnabled)(Be,"extensionsAny")||(he=!1);const Oe=Gt.mine.getExtensionDescription(ne);if(Oe)return new d.Extension(At,Be.identifier,Oe,ni,!1);if(he){const rt=Gt.all.getExtensionDescription(ne);if(rt)return new d.Extension(At,Be.identifier,rt,ni,!0)}},get all(){const ne=[];for(const he of Gt.mine.getAllExtensionDescriptions())ne.push(new d.Extension(At,Be.identifier,he,ni,!1));return ne},get allAcrossExtensionHosts(){(0,Ne.checkProposedApiEnabled)(Be,"extensionsAny");const ne=new Ne.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),he=[];for(const Oe of Gt.all.getAllExtensionDescriptions()){const rt=!ne.has(Oe.identifier);he.push(new d.Extension(At,Be.identifier,Oe,ni,rt))}return he},get onDidChange(){return(0,Ne.isProposedApiEnabled)(Be,"extensionsAny")?y.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},xt={createDiagnosticCollection(ne){return ti.createDiagnosticCollection(Be.identifier,ne)},get onDidChangeDiagnostics(){return ti.onDidChangeDiagnostics},getDiagnostics:ne=>ti.getDiagnostics(ne),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(ne,he){return Vt.changeLanguage(ne.uri,he)},match(ne,he){const Oe=vt.getDocumentData(he.uri)?.notebook;return(0,O.score)(z.LanguageSelector.from(ne),he.uri,he.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ne,he,Oe){return ot.registerCodeActionProvider(Be,dt(ne),he,Oe)},registerDocumentPasteEditProvider(ne,he,Oe){return(0,Ne.checkProposedApiEnabled)(Be,"documentPaste"),ot.registerDocumentPasteEditProvider(Be,dt(ne),he,Oe)},registerCodeLensProvider(ne,he){return ot.registerCodeLensProvider(Be,dt(ne),he)},registerDefinitionProvider(ne,he){return ot.registerDefinitionProvider(Be,dt(ne),he)},registerDeclarationProvider(ne,he){return ot.registerDeclarationProvider(Be,dt(ne),he)},registerImplementationProvider(ne,he){return ot.registerImplementationProvider(Be,dt(ne),he)},registerTypeDefinitionProvider(ne,he){return ot.registerTypeDefinitionProvider(Be,dt(ne),he)},registerHoverProvider(ne,he){return ot.registerHoverProvider(Be,dt(ne),he,Be.identifier)},registerEvaluatableExpressionProvider(ne,he){return ot.registerEvaluatableExpressionProvider(Be,dt(ne),he,Be.identifier)},registerInlineValuesProvider(ne,he){return ot.registerInlineValuesProvider(Be,dt(ne),he,Be.identifier)},registerDocumentHighlightProvider(ne,he){return ot.registerDocumentHighlightProvider(Be,dt(ne),he)},registerLinkedEditingRangeProvider(ne,he){return ot.registerLinkedEditingRangeProvider(Be,dt(ne),he)},registerReferenceProvider(ne,he){return ot.registerReferenceProvider(Be,dt(ne),he)},registerRenameProvider(ne,he){return ot.registerRenameProvider(Be,dt(ne),he)},registerDocumentSymbolProvider(ne,he,Oe){return ot.registerDocumentSymbolProvider(Be,dt(ne),he,Oe)},registerWorkspaceSymbolProvider(ne){return ot.registerWorkspaceSymbolProvider(Be,ne)},registerDocumentFormattingEditProvider(ne,he){return ot.registerDocumentFormattingEditProvider(Be,dt(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return ot.registerDocumentRangeFormattingEditProvider(Be,dt(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Oe,...rt){return ot.registerOnTypeFormattingEditProvider(Be,dt(ne),he,[Oe].concat(rt))},registerDocumentSemanticTokensProvider(ne,he,Oe){return ot.registerDocumentSemanticTokensProvider(Be,dt(ne),he,Oe)},registerDocumentRangeSemanticTokensProvider(ne,he,Oe){return ot.registerDocumentRangeSemanticTokensProvider(Be,dt(ne),he,Oe)},registerSignatureHelpProvider(ne,he,Oe,...rt){return typeof Oe=="object"?ot.registerSignatureHelpProvider(Be,dt(ne),he,Oe):ot.registerSignatureHelpProvider(Be,dt(ne),he,typeof Oe>"u"?[]:[Oe,...rt])},registerCompletionItemProvider(ne,he,...Oe){return ot.registerCompletionItemProvider(Be,dt(ne),he,Oe)},registerInlineCompletionItemProvider(ne,he){return he.handleDidShowCompletionItem&&(0,Ne.checkProposedApiEnabled)(Be,"inlineCompletionsAdditions"),ot.registerInlineCompletionsProvider(Be,dt(ne),he)},registerDocumentLinkProvider(ne,he){return ot.registerDocumentLinkProvider(Be,dt(ne),he)},registerColorProvider(ne,he){return ot.registerColorProvider(Be,dt(ne),he)},registerFoldingRangeProvider(ne,he){return ot.registerFoldingRangeProvider(Be,dt(ne),he)},registerSelectionRangeProvider(ne,he){return ot.registerSelectionRangeProvider(Be,ne,he)},registerCallHierarchyProvider(ne,he){return ot.registerCallHierarchyProvider(Be,ne,he)},registerTypeHierarchyProvider(ne,he){return ot.registerTypeHierarchyProvider(Be,ne,he)},setLanguageConfiguration:(ne,he)=>ot.setLanguageConfiguration(Be,ne,he),getTokenInformationAtPosition(ne,he){return(0,Ne.checkProposedApiEnabled)(Be,"tokenInformation"),Vt.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return ot.registerInlayHintsProvider(Be,ne,he)},createLanguageStatusItem(ne,he){return Vt.createLanguageStatusItem(Be,ne,he)},registerDocumentDropEditProvider(ne,he){return ot.registerDocumentOnDropEditProvider(Be,ne,he)}},hi={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return ze.activeTerminal},get terminals(){return ze.terminals},async showTextDocument(ne,he,Oe){const rt=await(C.URI.isUri(ne)?Promise.resolve(Pi.openTextDocument(ne)):Promise.resolve(ne));return It.showTextDocument(rt,he,Oe)},createTextEditorDecorationType(ne){return It.createTextEditorDecorationType(Be,ne)},onDidChangeActiveTextEditor(ne,he,Oe){return It.onDidChangeActiveTextEditor(ne,he,Oe)},onDidChangeVisibleTextEditors(ne,he,Oe){return It.onDidChangeVisibleTextEditors(ne,he,Oe)},onDidChangeTextEditorSelection(ne,he,Oe){return It.onDidChangeTextEditorSelection(ne,he,Oe)},onDidChangeTextEditorOptions(ne,he,Oe){return It.onDidChangeTextEditorOptions(ne,he,Oe)},onDidChangeTextEditorVisibleRanges(ne,he,Oe){return It.onDidChangeTextEditorVisibleRanges(ne,he,Oe)},onDidChangeTextEditorViewColumn(ne,he,Oe){return It.onDidChangeTextEditorViewColumn(ne,he,Oe)},onDidCloseTerminal(ne,he,Oe){return ze.onDidCloseTerminal(ne,he,Oe)},onDidOpenTerminal(ne,he,Oe){return ze.onDidOpenTerminal(ne,he,Oe)},onDidChangeActiveTerminal(ne,he,Oe){return ze.onDidChangeActiveTerminal(ne,he,Oe)},onDidChangeTerminalDimensions(ne,he,Oe){return(0,Ne.checkProposedApiEnabled)(Be,"terminalDimensions"),ze.onDidChangeTerminalDimensions(ne,he,Oe)},onDidChangeTerminalState(ne,he,Oe){return ze.onDidChangeTerminalState(ne,he,Oe)},onDidWriteTerminalData(ne,he,Oe){return(0,Ne.checkProposedApiEnabled)(Be,"terminalDataWriteEvent"),ze.onDidWriteTerminalData(ne,he,Oe)},get state(){return Te.state},onDidChangeWindowState(ne,he,Oe){return Te.onDidChangeWindowState(ne,he,Oe)},showInformationMessage(ne,...he){return yi.showMessage(Be,N.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return yi.showMessage(Be,N.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return yi.showMessage(Be,N.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Oe){return _t.showQuickPick(ne,he,Oe)},showWorkspaceFolderPick(ne){return _t.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return _t.showInput(ne,he)},showOpenDialog(ne){return li.showOpenDialog(ne)},showSaveDialog(ne){return li.showSaveDialog(ne)},createStatusBarItem(ne,he,Oe){let rt,Dt,Pt;return typeof ne=="string"?(rt=ne,Dt=he,Pt=Oe):(Dt=ne,Pt=he),di.createStatusBarEntry(Be,rt,Dt,Pt)},setStatusBarMessage(ne,he){return di.setStatusBarMessage(ne,he)},withScmProgress(ne){return Se.report("window.withScmProgress",Be,"Use 'withProgress' instead."),ui.withProgress(Be,{location:V.ProgressLocation.SourceControl},(he,Oe)=>ne({report(rt){}}))},withProgress(ne,he){return ui.withProgress(Be,ne,he)},createOutputChannel(ne,he){return Ot.createOutputChannel(ne,he,Be)},createWebviewPanel(ne,he,Oe,rt){return si.createWebviewPanel(Be,ne,he,Oe,rt)},createWebviewTextEditorInset(ne,he,Oe,rt){return(0,Ne.checkProposedApiEnabled)(Be,"editorInsets"),Oi.createWebviewEditorInset(ne,he,Oe,rt,Be)},createTerminal(ne,he,Oe){return typeof ne=="object"?"pty"in ne?ze.createExtensionTerminal(ne):ze.createTerminalFromOptions(ne):ze.createTerminal(ne,he,Oe)},registerTerminalLinkProvider(ne){return ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return ze.registerProfileProvider(Be,ne,he)},registerTerminalQuickFixProvider(ne,he){return(0,Ne.checkProposedApiEnabled)(Be,"terminalQuickFixProvider"),ze.registerTerminalQuickFixProvider(ne,Be.identifier.value,he)},registerTreeDataProvider(ne,he){return ai.registerTreeDataProvider(ne,he,Be)},createTreeView(ne,he){return ai.createTreeView(ne,he,Be)},registerWebviewPanelSerializer:(ne,he)=>si.registerWebviewPanelSerializer(Be,ne,he),registerCustomEditorProvider:(ne,he,Oe={})=>Fi.registerCustomEditorProvider(Be,ne,he,Oe),registerFileDecorationProvider(ne){return Ae.registerFileDecorationProvider(ne,Be)},registerUriHandler(ne){return Tt.registerUriHandler(Be.identifier,ne)},createQuickPick(){return _t.createQuickPick(Be)},createInputBox(){return _t.createInputBox(Be)},get activeColorTheme(){return Ci.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Oe){return Ci.onDidChangeActiveColorTheme(ne,he,Oe)},registerWebviewViewProvider(ne,he,Oe){return Si.registerWebviewViewProvider(Be,ne,he,Oe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Oe){return Et.onDidChangeActiveNotebookEditor(ne,he,Oe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Oe){return oi.onDidChangeNotebookEditorSelection(ne,he,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,he,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(ne,he,Oe)},showNotebookDocument(ne,he){return Et.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Oe){return(0,Ne.checkProposedApiEnabled)(Be,"externalUriOpener"),Li.registerExternalUriOpener(Be.identifier,ne,he,Oe)},registerProfileContentHandler(ne,he){return(0,Ne.checkProposedApiEnabled)(Be,"profileContentHandlers"),Mi.registrProfileContentHandler(Be,ne,he)},get tabGroups(){return x.tabGroups}},Pi={get rootPath(){return Se.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(ne){throw T.readonly()},getWorkspaceFolder(ne){return pt.getWorkspaceFolder(ne)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(ne){throw T.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(ne){throw T.readonly()},updateWorkspaceFolders:(ne,he,...Oe)=>pt.updateWorkspaceFolders(Be,ne,he||0,...Oe),onDidChangeWorkspaceFolders:function(ne,he,Oe){return pt.onDidChangeWorkspace(ne,he,Oe)},asRelativePath:(ne,he)=>pt.getRelativePath(ne,he),findFiles:(ne,he,Oe,rt)=>pt.findFiles(ne,he,Oe,Be.identifier,rt),findTextInFiles:(ne,he,Oe,rt)=>{(0,Ne.checkProposedApiEnabled)(Be,"findTextInFiles");let Dt,Pt;return typeof he=="object"?(Dt=he,Pt=Oe):(Dt={},Pt=he,rt=Oe),pt.findTextInFiles(ne,Dt||{},Pt,Be.identifier,rt)},saveAll:ne=>pt.saveAll(ne),applyEdit(ne,he){return Ui.applyWorkspaceEdit(ne,Be,he)},createFileSystemWatcher:(ne,he,Oe,rt)=>qt.createFileSystemWatcher(pt,Be,ne,he,Oe,rt),get textDocuments(){return vt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw T.readonly()},openTextDocument(ne){let he;const Oe=ne;if(typeof ne=="string")he=Promise.resolve(C.URI.file(ne));else if(C.URI.isUri(ne))he=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")he=vt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(rt=>vt.ensureDocumentData(rt).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,he,Oe)=>vt.onDidAddDocument(ne,he,Oe),onDidCloseTextDocument:(ne,he,Oe)=>vt.onDidRemoveDocument(ne,he,Oe),onDidChangeTextDocument:(ne,he,Oe)=>vt.onDidChangeDocument(ne,he,Oe),onDidSaveTextDocument:(ne,he,Oe)=>vt.onDidSaveDocument(ne,he,Oe),onWillSaveTextDocument:(ne,he,Oe)=>Nt.getOnWillSaveTextDocumentEvent(Be)(ne,he,Oe),get notebookDocuments(){return Et.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Oe;if(C.URI.isUri(ne))Oe=ne,await Et.openNotebookDocument(ne);else if(typeof ne=="string")Oe=C.URI.revive(await Et.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,he,Oe){return Zt.onDidSaveNotebookDocument(ne,he,Oe)},onDidChangeNotebookDocument(ne,he,Oe){return Zt.onDidChangeNotebookDocument(ne,he,Oe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Oe,rt){return Et.registerNotebookSerializer(Be,ne,he,Oe,(0,Ne.isProposedApiEnabled)(Be,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,he,Oe)=>ki.onDidChangeConfiguration(ne,he,Oe),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,ki.getConfiguration(ne,he,Be)},registerTextDocumentContentProvider(ne,he){return Ht.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(Se.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Be,ne,he)),registerFileSystemProvider(ne,he,Oe){return(0,Ue.combinedDisposable)(vi.registerFileSystemProvider(Be,ne,he,Oe),Ut.addFileSystemProvider(ne,he))},get fs(){return Ut.value},registerFileSearchProvider:(ne,he)=>((0,Ne.checkProposedApiEnabled)(Be,"fileSearchProvider"),Ct.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,Ne.checkProposedApiEnabled)(Be,"textSearchProvider"),Ct.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,Ne.checkProposedApiEnabled)(Be,"resolvers"),At.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,Ne.checkProposedApiEnabled)(Be,"resolvers"),Ei.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Oe)=>qt.onDidCreateFile(ne,he,Oe),onDidDeleteFiles:(ne,he,Oe)=>qt.onDidDeleteFile(ne,he,Oe),onDidRenameFiles:(ne,he,Oe)=>qt.onDidRenameFile(ne,he,Oe),onWillCreateFiles:(ne,he,Oe)=>qt.getOnWillCreateFileEvent(Be)(ne,he,Oe),onWillDeleteFiles:(ne,he,Oe)=>qt.getOnWillDeleteFileEvent(Be)(ne,he,Oe),onWillRenameFiles:(ne,he,Oe)=>qt.getOnWillRenameFileEvent(Be)(ne,he,Oe),openTunnel:ne=>((0,Ne.checkProposedApiEnabled)(Be,"tunnels"),Mt.openTunnel(Be,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ne.checkProposedApiEnabled)(Be,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(ne,he,Oe)=>((0,Ne.checkProposedApiEnabled)(Be,"tunnels"),Mt.onDidChangeTunnels(ne,he,Oe)),registerPortAttributesProvider:(ne,he)=>((0,Ne.checkProposedApiEnabled)(Be,"portsAttributes"),Mt.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,Ne.checkProposedApiEnabled)(Be,"timeline"),wi.registerTimelineProvider(ne,he,Be.identifier,xe.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:ne=>((0,Ne.checkProposedApiEnabled)(Be,"workspaceTrust"),pt.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Oe)=>pt.onDidGrantWorkspaceTrust(ne,he,Oe),registerEditSessionIdentityProvider:(ne,he)=>((0,Ne.checkProposedApiEnabled)(Be,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(ne,he))},$t={get inputBox(){return Se.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Be)},createSourceControl(ne,he,Oe){return ci.createSourceControl(Be,ne,he,Oe)}},fi={createCommentController(ne,he){return bi.createCommentController(Be,ne,he)}},ji={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,he,Oe){return Ze.onDidStartDebugSession(ne,he,Oe)},onDidTerminateDebugSession(ne,he,Oe){return Ze.onDidTerminateDebugSession(ne,he,Oe)},onDidChangeActiveDebugSession(ne,he,Oe){return Ze.onDidChangeActiveDebugSession(ne,he,Oe)},onDidReceiveDebugSessionCustomEvent(ne,he,Oe){return Ze.onDidReceiveDebugSessionCustomEvent(ne,he,Oe)},onDidChangeBreakpoints(ne,he,Oe){return Ze.onDidChangeBreakpoints(ne,he,Oe)},registerDebugConfigurationProvider(ne,he,Oe){return Ze.registerDebugConfigurationProvider(ne,he,Oe||_e.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return Ze.registerDebugAdapterDescriptorFactory(Be,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return Ze.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Ze.startDebugging(ne,he,{parentSession:Oe}):Ze.startDebugging(ne,he,Oe||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return Ze.asDebugSourceUri(ne,he)}},Vi={registerTaskProvider:(ne,he)=>bt.registerTaskProvider(Be,ne,he),fetchTasks:ne=>bt.fetchTasks(ne),executeTask:ne=>bt.executeTask(Be,ne),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(ne,he,Oe)=>bt.onDidStartTask(ne,he,Oe),onDidEndTask:(ne,he,Oe)=>bt.onDidEndTask(ne,he,Oe),onDidStartTaskProcess:(ne,he,Oe)=>bt.onDidStartTaskProcess(ne,he,Oe),onDidEndTaskProcess:(ne,he,Oe)=>bt.onDidEndTaskProcess(ne,he,Oe)},qi={createNotebookController(ne,he,Oe,rt,Dt){return ei.createNotebookController(Be,ne,he,Oe,rt,(0,Ne.isProposedApiEnabled)(Be,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>Et.registerNotebookCellStatusBarItemProvider(Be,ne,he),createRendererMessaging(ne){return pi.createRendererMessaging(Be,ne)},createNotebookControllerDetectionTask(ne){return(0,Ne.checkProposedApiEnabled)(Be,"notebookKernelSource"),ei.createNotebookControllerDetectionTask(Be,ne)},registerKernelSourceActionProvider(ne,he){return(0,Ne.checkProposedApiEnabled)(Be,"notebookKernelSource"),ei.registerKernelSourceActionProvider(Be,ne,he)},onDidChangeNotebookCellExecutionState(ne,he,Oe){return(0,Ne.checkProposedApiEnabled)(Be,"notebookCellExecutionState"),ei.onDidChangeNotebookCellExecutionState(ne,he,Oe)}},Ki={t(...ne){if(typeof ne[0]=="string"){const he=ne.shift(),Oe=!ne||typeof ne[0]!="object"?ne:ne[0];return mt.getMessage(Be.identifier.value,{message:he,args:Oe})}return mt.getMessage(Be.identifier.value,ne[0])},get bundle(){return mt.getBundle(Be.identifier.value)},get uri(){return mt.getBundleUri(Be.identifier.value)}};return{version:gt.version,authentication:$i,commands:zi,comments:fi,debug:ji,env:Ti,extensions:Hi,l10n:Ki,languages:xt,notebooks:qi,scm:$t,tasks:Vi,tests:Wi,window:hi,workspace:Pi,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:_e.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:k.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:v.UIKind,Uri:C.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:ct.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TrustedTelemetryValue:X.TrustedTelemetryValue,LogLevel:Xe.LogLevel,EditSessionIdentityMatch:ht.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=St}),define(De[246],Ce([1,0,245,33,2,239,6,15,230]),function(te,e,n,T,y,N,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends N.RequireInterceptor{j(){}getModule(v,h){for(const i of this.b){const o=i(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(S.ExtHostConsoleForwarder);const v=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,v,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(v){return v.browser}async rb(v,h,i){h=h.with({path:I(h.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const l=y.URI.revive(await this.v.$asBrowserUri(h)),E=await fetch(l.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),E.status!==200)throw new Error(E.statusText);const b=await E.text(),p=`${h.toString(!0)}#vscode-extension`,w=`${b}
//# sourceURL=${p}`;let s;try{s=new Function("module","exports","require",w)}catch(c){throw console.error(o?`Loading code for extension ${o} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${h.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}v&&await this.s.initializeLocalizedMessages(v);const r={},a={exports:r},d=c=>{const u=this.r.getModule(c,h);if(u===void 0)throw new Error(`Cannot load module '${c}'`);return u};try{return i.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),s(a,r,d),a.exports!==r?a.exports:r}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),i.codeLoadingStop()}}async $setRemoteEnvironment(v){}async vb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+v;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=O;function I(f,v){return f.endsWith(v)?f:f+v}}),define(De[247],Ce([1,0,61,33,76,246]),function(te,e,n,T,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(T.IExtHostExtensionService,N.ExtHostExtensionService,0),(0,n.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths,0)}),define(De[255],Ce([1,0,24,5,69,240,232,19,77,13,2,242,247]),function(te,e,n,T,y,N,C,R,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const I=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(s){return/^(file|vscode-remote):/i.test(s)}const h=fetch.bind(self);function i(s){self.fetch=async function(r,a){return r instanceof Request||v(String(r))&&(r=(await s(O.URI.parse(String(r)))).toString(!0)),h(r,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,a,d,c,u){(async()=>(v(a.toString())&&(a=(await s(O.URI.parse(a.toString()))).toString(!0)),super.open(r,a,d??!0,c,u)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(r,a){if(/^file:/i.test(r.toString()))r=k.FileAccess.uriToBrowserUri(O.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(g){function A(q){return typeof q=="string"||q instanceof URL?String(q).replace(/^file:\/\//i,"vscode-file://vscode-app"):q}const L=fetch.bind(self);self.fetch=function(q,j){return q instanceof Request?L(q,j):L(A(q),j)},self.XMLHttpRequest=class extends XMLHttpRequest{open(q,j,P,M,F){return super.open(q,A(j),P??!0,M,F)}};const K=importScripts.bind(self);self.importScripts=(...q)=>{K(...q.map(A))},K(g)}.toString()}('${r}'))`;a=a||{},a.name=a.name||R.basename(r.toString());const u=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(u);return new s(t,a)}}else self.Worker=class extends C.NestedWorker{constructor(s,r){super(f,s,{name:R.basename(s.toString()),...r})}};const o=new class{constructor(){this.pid=void 0}exit(s){I()}async exists(s){return!0}async realpath(s){return s}};class l{constructor(){const r=new MessageChannel,a=new T.Emitter;let d=!1;f(r.port2,[r.port2]),r.port1.onmessage=c=>{const{data:u}=c;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const t=n.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,y.isMessageOfType)(t,2)){d=!0,b("received terminate message from renderer");return}a.fire(t)},this.protocol={onMessage:a.event,send:c=>{if(!d){const u=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);r.port1.postMessage(u,[u])}}}}}function E(s){return new Promise(r=>{const a=s.onMessage(d=>{a.dispose();const c=JSON.parse(d.toString());s.send((0,y.createMessageOfType)(0)),r({protocol:s,initData:c})});s.send((0,y.createMessageOfType)(1))})}let b=s=>I();function p(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function w(){S.mark("code/extHost/willConnectToRenderer");const s=new l;return{onmessage(r){!p(r)||E(s.protocol).then(a=>{S.mark("code/extHost/didWaitForInitData");const d=new N.ExtensionHostMain(a.protocol,a.initData,o,null,r.data);i(c=>d.asBrowserUri(c)),b=c=>d.terminate(c)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2eca6d38dede985bf6180cca64d43c16a02e9a13/core/vs/workbench/api/worker/extensionHostWorker.js.map
